SystemOrganization addCategory: #'Chronos-SharedPool'!
SystemOrganization addCategory: #'Chronos-System'!
SystemOrganization addCategory: #'Chronos-Environment'!
SystemOrganization addCategory: #'Chronos-Foundation'!
SystemOrganization addCategory: #'Chronos-Timescales'!
SystemOrganization addCategory: #'Chronos-Calendars-Foundation'!
SystemOrganization addCategory: #'Chronos-Calendars-Regular'!
SystemOrganization addCategory: #'Chronos-Calendars-Irregular'!
SystemOrganization addCategory: #'Chronos-TimeZones-PolicyFactories-Annual'!
SystemOrganization addCategory: #'Chronos-TimeZones-PolicyFactories-Diachronic'!
SystemOrganization addCategory: #'Chronos-TimeZones-Policies-Annual'!
SystemOrganization addCategory: #'Chronos-TimeZones-Policies-Diachronic'!
SystemOrganization addCategory: #'Chronos-Timezones'!
SystemOrganization addCategory: #'Chronos-Duration'!
SystemOrganization addCategory: #'Chronos-DateTimeInterval'!
SystemOrganization addCategory: #'Chronos-Annual Dates'!
SystemOrganization addCategory: #'Chronos-Semantic Dates'!
SystemOrganization addCategory: #'Chronos-Localization'!
SystemOrganization addCategory: #'Chronos-Printing'!
SystemOrganization addCategory: #'Chronos-Parsing'!

SharedPool subclass: #Chronos
	instanceVariableNames: ''
	classVariableNames: 'DateAndTime Duration'
	poolDictionaries: ''
	category: 'Chronos-SharedPool'!

!Chronos class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 14:44'!
initialize
"
Chronos initialize
"
	DateAndTime :=Smalltalk at: #DateAndTime.
	Duration:=Smalltalk at: #Duration.! !

SharedPool subclass: #ChronosConstants
	instanceVariableNames: ''
	classVariableNames: 'ANSIDayOfWeekKeys AnsiStandardCalendar AnsiStandardCalendarClock April August CalendarDayDuration CalendarDurationFactory CivilDurationFactory CivilSecondDuration ClockDayDuration DateAndTimeFactory DateFactory DayOfMonthFactory DayOfYearFactory DaysPerWeek December DurationFactory February Friday Gregorian HourDuration HoursPerDay ISODayOfWeekKeys ISOFriday ISOMonday ISOMonthKeys ISOSaturday ISOSunday ISOThursday ISOTuesday ISOWednesday January Julian July June March May MeridianKeys MicrosecondsPerMillisecond MicrosecondsPerSecond MillisecondsPerSecond MinuteDuration MinutesPerDay MinutesPerHour Monday MonthDuration NanosecondDuration NanosecondsPerDay NanosecondsPerHour NanosecondsPerMicrosecond NanosecondsPerMillisecond NanosecondsPerMinute NanosecondsPerSecond November October Saturday SecondDuration SecondsPerDay SecondsPerHour SecondsPerMinute September SequenceFactory Sunday Thursday TimeOfDayFactory TimeperiodFactory Tuesday Wednesday WeekDuration WeekOfMonthDayOfWeekFactory YearDuration ZeroCalendarDuration ZeroDuration'
	poolDictionaries: ''
	category: 'Chronos-SharedPool'!

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:29'!
assignChronosDurationConstants
	CalendarDayDuration := CalendarDurationFactory days: 1.
	CivilSecondDuration := CivilDurationFactory seconds: 1.
	ClockDayDuration := DurationFactory days: 1.
	HourDuration := CivilDurationFactory hours: 1.
	MinuteDuration := CivilDurationFactory minutes: 1.
	MonthDuration := CalendarDurationFactory months: 1.
	NanosecondDuration := DurationFactory nanoseconds: 1.
	SecondDuration := DurationFactory seconds: 1.
	WeekDuration := CalendarDurationFactory weeks: 1.
	YearDuration := CalendarDurationFactory years: 1.
	ZeroDuration := DurationFactory zero.
	ZeroCalendarDuration := CalendarDurationFactory zero! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:29'!
assignChronosFactoryBindings
	CalendarDurationFactory := CalendarDuration.
	CivilDurationFactory := CivilDuration.
	DateAndTimeFactory := Timepoint.
	DateFactory := YearMonthDay.
	DayOfMonthFactory := DayOfMonth.
	DayOfYearFactory := DayOfYear.
	DurationFactory := ScientificDuration.
	SequenceFactory := OrderedCollection.
	TimeOfDayFactory := TimeOfDay.
	TimeperiodFactory := Timeperiod.
	WeekOfMonthDayOfWeekFactory := WeekOfMonthDayOfWeek! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:20'!
initialize 
	self initializeChronosTemporalRatioConstants.
	self initializeChronosDaysOfWeekConstants.
	self initializeChronosStandardMonthConstants.
	self initializeChronosFactoryBindings.
	self initializeChronosCalendarConstants.
	self initializeChronosDurationConstants.
	self initializeChronosConstants.
! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:07'!
initializeChronosCalendarConstants

	AnsiStandardCalendar := nil.
	AnsiStandardCalendarClock :=nil.
	Gregorian:=nil.
	Julian :=nil.
	! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:15'!
initializeChronosConstants

	MeridianKeys := #(#'ante-meridian' #'post-meridian')! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 11:57'!
initializeChronosDaysOfWeekConstants
	
	ANSIDayOfWeekKeys:=#(Sunday Monday Tuesday Wednesday Thursday Friday Saturday).
	Sunday:=1.
	Monday:=2.
	Tuesday :=3.
	Wednesday :=4.
	Thursday :=5.
	Friday :=6.
	Saturday :=7.
	ISODayOfWeekKeys:=#(Monday Tuesday Wednesday Thursday Friday Saturday Sunday).
	ISOSunday:=0.
	ISOMonday :=1.
	ISOTuesday :=2.
	ISOWednesday :=3.
	ISOThursday :=4.
	ISOFriday :=5.
	ISOSaturday :=6.! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:14'!
initializeChronosDurationConstants
CalendarDayDuration:= CivilSecondDuration :=ClockDayDuration:= HourDuration:= MinuteDuration :=MonthDuration :=NanosecondDuration:= SecondDuration:= WeekDuration:= YearDuration:= ZeroDuration:= ZeroCalendarDuration:=nil! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:14'!
initializeChronosFactoryBindings
	CalendarDurationFactory := CivilDurationFactory := DateAndTimeFactory := DateFactory := DayOfMonthFactory := DayOfYearFactory := DurationFactory := SequenceFactory := TimeOfDayFactory := TimeperiodFactory := WeekOfMonthDayOfWeekFactory := nil! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 11:59'!
initializeChronosStandardMonthConstants

	January:=1.
	February :=2.
	March :=3.
	April :=4.
	May :=5.
	June :=6.
	July:=7.
	August :=8.
	September :=9.
	October :=10.
	November :=11.
	December :=12.
	ISOMonthKeys :=#(January February March April May June July August September October November December).! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 11:54'!
initializeChronosTemporalRatioConstants

	DaysPerWeek :=7.
	HoursPerDay :=24.
	MicrosecondsPerMillisecond :=1000.
	MicrosecondsPerSecond :=1000000.
	MillisecondsPerSecond :=1000.
	MinutesPerDay :=1440.
	MinutesPerHour:=60.
	NanosecondsPerDay :=86400000000000.
	NanosecondsPerHour :=3600000000000.
	NanosecondsPerMicrosecond:=1000.
	NanosecondsPerMillisecond:=1000000.
	NanosecondsPerMinute:=60000000000.
	NanosecondsPerSecond:=1000000000.
	SecondsPerDay :=86400.
	SecondsPerHour :=3600.
	SecondsPerMinute:=60.
	
	
	
	! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:32'!
setAnsiStandardCalendar: aGregorianCalendar
	AnsiStandardCalendar := (aGregorianCalendar == nil ifFalse: [aGregorianCalendar assertIsGregorian])! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:33'!
setAnsiStandardCalendarClock: aGregorianCalendarClock

	aGregorianCalendarClock == nil ifFalse: [aGregorianCalendarClock calendar assertIsGregorian].
	
	AnsiStandardCalendarClock :=aGregorianCalendarClock ! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:31'!
setGregorian: aGregorianCalendar
	Gregorian :=(aGregorianCalendar == nil ifFalse: [aGregorianCalendar assertIsGregorian])! !

!ChronosConstants class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 3/9/2011 12:32'!
setJulian: aJulianCalendar

	Julian := (aJulianCalendar == nil ifFalse: [aJulianCalendar assertIsJulian])! !

!Number methodsFor: '*Chronos-converting' stamp: ''!
asTimezone
	"-28800 asTimezone"
	
	^ChronosTimezone at: self! !

!String methodsFor: '*Chronos-converting' stamp: ''!
asTimezone
	"Inspect it: {'Europe/Berlin' asTimezone}"
	
	^ChronosTimezone at: self! !

PassportObject subclass: #ChronosEnvironment
	instanceVariableNames: ''
	classVariableNames: 'Canonical InstallationCount NotAValue PlatformClass ProtectedGlobalVariables'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Environment'!

!ChronosEnvironment commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosEnvironment

	Concept:
		
		ChronosEnvironment is an abstract class. A concrete subclass of ChronosEnvironment provides namespace definition/initialization functionality whose implementation is necessarily specific to a particular Smalltalk platform/system (e.g., VisualWorks, Squeak, STX, Dolphin, GNU Smalltalk, etc.) The concrete ChronosEnvironment subclass specific to a particular Smalltalk system/environment is called the "platform class."

		The ChronosEnvironment platform class is responsible for defining certain namespaces (or "shared pool" Dictionaries,)  and for defining the bindings (entries, name-value associations) in those namespaces. Either the ChronosEnvironment platform class, or else its singleton instance, is responsible for initializing those bindings to appropriate values.  (Note: In the terminology of the orginal Smalltalk-80, a "binding" is an Association in a Dictionary, a "global binding" is an Association in the canonical instance of SystemDictionary, and a "shared pool binding" is an Association in a "shared pool dictionary" containing non-global variables shared among a set of classes that may or may not be in the same inheritance hierarchy).  

		The namespaces (or "shared pool" Dictionaries) that the ChronosEnvironment platform class is responsible for defining are as follows:

			Namespace name						Namespace purpose

			Chronos								Serves as the naming scope for the classes of the Chronos Date/Time Library, used 
													so as to avoid class-name collisions with other class libraries and/or applications.
													The Chronos namespace may or may not actually be defined, depending on whether
													or not the host Smalltalk system and tooling adequately support defining, browsing
													and editing classes in multiple, independent namespaces.
			ChronosTemporalRatioConstants			Defines constant ratios between temporal units (e.g., 'SecondsPerDay').
			ChronosDaysOfWeekConstants			Defines named constants for day-of-week ordinals (both ANSI Smalltalk and ISO 8601 values).
			ChronosStandardMonthConstants		Defines named constants for Gregorian/Julian month ordinals (must have ISO 8601 values).
			ChronosFactoryBindings					Defines aliases for certain Chronos classes where name collisions with other date/time 
													libraries would be especially likely.The Chronos codebase always uses the aliases 
													defined in ChronosFactoryBindings to refer to these particular classes. This strategy
													also facilitates using alternative implementations of the standard Chronos classes,
													should such be desired.
			ChronosCalendarConstants				Defines constants referring to the GregorianCalendar and JulianCalendar singletons, 
													and to the AnsiStandardCalendar singleton and its associated CalendarClock instance.
			ChronosDurationConstants				Defines constants for common Duration and CalendarDuration values.
			ChronosConstants						Defines all the Chronos constants in a single namespace.  Where possible, this should
													be implemented using namespace import (otherwise, the existing bindings (Associations) 
													defined in the 'home' namespace (Dictionary) should be added into ChronosConstants,
													so that the same binding (Association instance) exists in both the 'home' namespace 
													and also in ChronosConstants.)

		Additionally, the ChronosEnvironment singleton is responsible for defining the global names DateAndTime, Duration, Timezone, SystemClock and ScaledDecimal (as entries in the canonical global namespace of the host Smalltalk implementation--which is usually referenced using the global name 'Smalltalk.'  **** However, if any of these globals are members of the Set of 'protected global variables,' then they will NOT be defined in the global namespace if already present, nor will the values of their global bindings be changed by Chronos. The Set of 'protected global variables' can be retrieved by evaluating 'ChronosEnvironment platformClass protectedGlobalVariables', and its contents are established by the class method #setProtectedGlobalVariables (which should be sub-implemented as is appropriate for each Smalltalk environment/system.) **** 

		DateAndTime is the ANSI-standard name for a factory object (which doesn't have to be a class) responsible for instantiating objects that conform to what the ANSI Standard refers to as the <DateAndTime> protocol.  The Chronos class that implements both the ANSI <DateAndTime> protocol and the ANSI <DateAndTimeFactory> protocol is named Timepoint (partly because that name is less likely to conflict with any class name defined in some other Date/Time library.)

		Duration is the ANSI-standard name for a factory object (which doesn't have to be a class) responsible for instantiating objects that conform to what the ANSI Standard refers to as the <Duration> protocol.  The Chronos class that implements both the ANSI <Duration> protocol and the ANSI <DurationFactory> protocol is actually called ScientificDuration (because it implements temporal durations in a way that is compatible with scientific/technical use cases, as opposed to CalendarDuration, which implements temporal durations in a way that is compatible with civil/business use cases, and partly because that name is less likely to conflict with any class name defined in some other Date/Time library.)

		Timezone is an alias for the class ChronosTimezone. Timezone is a convenient and communicative name--but it may unfortunately already be taken by some class belonging to some other date/time library (VisualWorks has the class TimeZone in its standard library, which doesn't actually collide with Timezone, but it's a very near miss). Timezone (ChronosTimezone) and the VisualWorks TimeZone class are completely incompatible.  

		SystemClock is the current canonical ChronosSystemClock instance (which see.)

		ScaledDecimal is the name of the protocol specified and required by the ANSI-Smalltalk Standard for implementing scaled decimal values.  Unfortunately, the Standard fails to define the <ScaledDecimalFactory> protocol, and also fails to require that there be any particular "standard global" by which the factory object for creating instances of the <ScaledDecimal> protocol can be referenced.  Consequently, since Chronos needs to create scaled decimal values, if ScaledDecimal is not already defined as a global, Chronos will define ScaledDecimal as a global whose value is whatever native class implements scaled decimals (under the assumption that the existing global, if defined, in fact references the class that implements scaled decimals for the native Smalltalk environment.)  Note, however, that the instance creation protocol for scaled decimal values is not specified by the ANSI-Smalltalk Standard, and so Chronos uses the instance creation protocol defined by VisualWorks.  To port to other Smalltalk implementations, the recommended approach is to add VW compatibility methods to the ScaledDecimal class (if necessary.)

		Clients of Chronos (or of any other ANSI-compliant date/time library) who desire to create date/time instances in a way that conforms to the ANSI Smalltalk Standard should use the global name DateAndTime to refer to whatever factory object they wish to use to create ANSI-standard-compliant timepoints, using ANSI-standard instance creation protocol.  Clients of Chronos (or of any other ANSI-compliant date/time library) who desire to create duration instances in a way that conforms to the ANSI Smalltalk Standard should use the global name Duration to refer to whatever factory object they wish to use to create ANSI-standard-compliant time durations, using ANSI-standard instance creation protocol.  Changing the implementation class then becomes a matter of either reassigning the value of the names DateAndTime and/or Duration in the namespace used when the code was compiled, or else recompiling the code using a different namespace (or shared pool Dictionary.)

		To handle situations where there are multiple classes that implement the ANSI <DateAndTime>, <DateAndTimeFactory>, <Duration>  and <DurationFactory> protocols, it is suggested that all such classes should either be named something other than DateAndTime and Duration, or else they should all be resident in namespaces specific to the date/time library of which they are a part. In the case of Smalltalk systems that don't have good tool support for multiple namespaces wherein classes can natively reside,  shared-pool Dictionaries should be used to define DateAndTime and Duration as aliases. This strategy permits the clients of date/time libraries to decide for themselves, independently of other modules in the same image, and if necessary on a class-by-class basis, which date/time library they would like to use, and which classes will be referenced by the names DateAndTime and Duration. It also permits such decisions to be changed without actually modifying any source code.

		The Chronos codebase itself always uses the alias DateAndTimeFactory in order to create instances of Timepoint, and always uses the alias DurationFactory to create instances of ScientificDuration--unless 'self new', 'self class new' or 'self copy' can be used instead.  In addition to aiding in the avoidance of name collisions, this strategy also enables changing the behavior of the Chronos codebase, so that (when and as desired) it will uniformly use classes other than Timepoint and/or ScientificDuration as the canonical DateAndTime and Duration implementations--without needing to actually modify any Chronos source code.

		Finally, the ChronosEnvironment singleton is responsibible for purging any entries from the "Undeclared" namespace that may remain after Chronos has been "filed in to" (or otherwise installed in) an image, for specifying the concrete subclass of ChronosSystemFacade that should be instantiated during the installation of Chronos, and for performing the "post file-in/installation" initialization of the Chronos date/time library.

	Usage:

		The ChronosEnvironment singleton is intended solely for the private, internal usage of the Chronos date/time library.  Normally, it would only be used during the installation of Chronos.  However, it might also need to be used pursuant to significant modifications of the Chronos codebase that occur after Chronos has already been installed.  Also, anyone porting Chronos to a new environment may need to understand the intended usage of the ChronosEnvironment class and its singleton.

		The class ChronosEnvironment, and the concrete subclass specific to a particular environment into which Chronos will be installed, must be "loaded" or "filed in" before any other modules (or "packages") of the Chronos codebase.  On installation, the method ChronosEnvironment class>>initialize must be invoked.  Most Smalltalk implementations will automatically invoke the #initialize method of a class when it is first "filed in" (or otherwise installed from a persistent external source.) 

		In response to the message #initialize, the ChronosEnvironment class will perform the following operations:

			1) Determine the concrete subclass of ChronosEnvironment that is appropriate to the environment in which it finds itself ("set the platform class."). 

				The implementation strategy is as follows: 

				1. There is a completely different "ChronosEnvironment" module defined for each platform, which may contain one or more subclasses of ChronosEnvironment. If the module contains multiple subclasses of ChronosEnvironment, then each such subclass is implemented for some range of versions of that particular Smalltalk environment (e.g., VisualWorks 3.x, VisualWorks 5i.x, etc.)

				2. The procedure for setting the platform class begins when the message #setPlatformClass is sent to ChronosEnvironment (the class itself, not an instance.) The class method <ChronosEnvironment class>>setPlatformClass> simply sends the message #setPlatformClass to the first subclass of ChronosEnvironment that is enumerated by sending #do: to <ChronosEnvironment subclasses> (so all direct subclasses of ChronosEnvironment must subimplement #setPlatformClass as a class method.)  This strategy makes ChronosEnvironment itself depend only on the invariant that its direct subclasses are all platform/environment specific, but not depend in any way on the platform or environment on/in which it may find itself.  

				3. Any direct subclass of ChronosEnvironment must, in response to the message #setPlatformClass, select the appropriate "Chronos Environment" class (perhaps itself) as the platform class. The selection of the platform class must of course depend on which version of the platform/environment is detected.  The class selected as the platform class must then be set as the value of the class variable PlatformClass. 

				The strategy also avoids any necessity to install "foreign" subclasses of ChronosEnvironment, meant for other platforms, that would never be used (some of which would probably not even be compilable in some cases.) 

			2) Define the namespaces used by Chronos. 

				Namespace definition is the responsibility of the ChronosEnvironment class itself, and not the responsibility of its instance. The ChronosEnvironment platform class will define the Chronos namespaces when sent the message #defineChronosNamespaces.  See the Implementation section of the class comment for a discussion of namespace implementation on various platforms.

			3) Define (as constants, if possible) the bindings (key to value associations) that should reside in each of the Chronos namespaces (or in the global namespace.) 

				The initial phase of defining the Chronos constant bindings will be performed when the message #defineChronosSharedAndGlobalVariables is sent to the ChronosEnvironment platform class. During this phase of Chronos installation/initialization, the value of the bindings in the Chronos namespaces must in many cases be set to nil, because the code needed to instantiate the canonical value of the binding may either not yet be installed, or else may not yet be ready to be successfully invoked.  Assigning the canonical values to any Chronos constants that cannot be set during this initial phase of Chronos installation/initialization is deferred to a later step in the installation/initialization process, and is the responsibility of the singleton instance of the ChronosEnvironment platform class. 

				The reason that all the Chronos constant bindings are defined during this phase, even when the canonical value of the binding may not yet be instantiable, is to guarantee that, when the rest of the Chronos codebase is "filed in" (or otherwise installed,) the binding's name will be correctly resolved to an entry in the correct Chronos namespace, and will not be resolved as an entry in some non-Chronos namespace (not a problem in modern VisualWorks, but the goal here is maximum inter-Smalltalk portability.)

		Once the three steps listed above have been completed, the rest of the Chronos codebase may be "filed in" (or otherwise installed.)  

		After the Chronos codebase has been successfully filed in (or otherwise installed,) Chronos must still be properly initialized.  One way to initiate the final Chronos initialization procedure is to file in the class ChronosInstaller, which is provided in a separate module.  ChronosInstaller defines #initialize as a class method, which should automatically be invoked when the class is filed in.  ChronosInstaller class>>initialize delegates all responsibility for the final phase of Chronos initialization to the ChronosEnvironment platform class: the method's only statement is 'ChronosEnvirionment install.' The bottom line is that the message #install must be sent to the class ChronosEnvironment before Chronos will work as intended.  Ensuring that that happens can be done in whatever way is most appropriate in context. 

		In response to the #install message, ChronosEnvironment class sends the message #install to the singleton instance of the ChronosEnvironment platform class, which in response performs the following actions (in the order presented):

			1) Assigns the canonical values to the bindings in the ChronosFactoryBindings namepace (or shared pool Dictionary);
			2) Assigns the canonical values to the bindings in the ChronosCalendarConstants namepace (or shared pool Dictionary);
			3) Assigns the canonical values to the bindings in the ChronosDurationConstants namepace (or shared pool Dictionary);
			4) Assigns the canonical values to the global bindings for DateAndTime, Duration, Timezone and SystemClock (if and only if these variable names are not included in the 'protected variable names' Set--see the class method #setProtectedVariables);
			5) Removes any bindings (associations) from the Undeclared namespace (Dictionary) for which there are no active references in the system codebase.
			6) Installs the ChronosSystemFacade (by sending #installInitially to the ChronosSystemFacade singleton.)

	Motivation:

		The responsibility for defining global and/or "shared pool" bindings is assigned to a ChronosEnvironment instance for four reasons: 

			1) Chronos uses a large number of "shared pool" values.  No other class clearly owns the responsibility for constructing such "shared pools" (or namespaces, to use a more generic term.)  Nor is there any non-proprietary standard syntax or construct for defining and loading global and/or "shared pool" variables. 

			2) The code and/or syntax for defining global and/or "shared pool" bindings is not portable accross all Smalltalk implementations--a problem that is especially acute when one would like to use namespace-like functionality (where such is available) to avoid global name collisions, and when one would prefer that the name-to-value binding be immutable (if possible). By concentrating all system-specific code in the class hierarchies of ResourcePathFacade, ChronosSystemFacade, ChronosSystemClock and ChronosEnvironment, and by defining a standard API for the definition and initialization of the namespaces and globals needed by Chronos, ChronosEnvironment enhances the portability of the codebase of the Chronos date/time library, both with respect to different implementations/versions of Smalltalk and also with respect to the varying needs and preferences of applications (or code libraries) that use Chronos.

			3) Encapsulating the responsibility for both defining a global and/or "shared pool" binding, and initializing each binding to its appropriate value, enables and/or facilitates the requisite degree of control over the sequencing of the following procedural steps: the definition of the binding,  the loading of the code required to instantiate the value that should be assigned to the binding, and the initialization of the binding to its canonical value. 

			4) Ideally, porting Chronos to a new Smalltalk implementation (or in some cases, to a new version of a Smalltalk implementation) should require nothing more than writing a new subclass of a) ChronosEnvironment, b) ChronosSystemFacade, c) ResourcePathFacade and d) ChronosSystemClock. In reality, it will probably also be necessary to add (or reuse) inter-system compatibility methods in some classes of the host Smalltalk system's base library. Examples thereof might include methods such as #readStream and #writeStream in SequenceableCollection (or its equivalent(s)), and perhaps one or more utility methods in Stream. Finally, although the ANSI standard requires the existence of a class for scaled decimals, it very unfortunately does not specify the name of the class, nor the protocol for a scaled decimal factory.  Chronos assumes that the global that references the factory object for scaled decimal values is named ScaledDecimal, and that it conforms to the instance creation protocol defined by the VisualWorks FixedPoint class. If the native Smalltalk environment does not use the global name ScaledDecimal to reference the factory object for scaled decimal values, then the method ChronosEnvironemnt>>nativeScaledDecimalClass must be subimplemented by the subclass of ChronosEnvironment that will be used in that environment.  If the scaled decimal factory object's instance creation protocol does not conform to that of the VisualWorks FixedPoint class, then VW compatibility methods must be added.

		Modification of the Chronos codebase for the purpose of making Chronos work correctly on the Smalltalk platform to which it is being ported (other than as herein described,) is strongly not recommended. Instead, please notify the author of Chronos of the porting problem {send and e-mail to porting (at) chronos-st (dot) org} so that a general solution to the problem can be designed and incorporated into the mainline Chronos codebase. 

		See also: ChronosSystemFacade, ResourcePathFacade, ChronosSystemClock

	Implementation:

		Smalltalk-80, as defined by the "Blue Book" (Smalltalk-80: The Language and its Implementation; by Adele Goldberg and David Robson; Addison-Wesley 1983; ISBN 0-201-11371-6,) serves as the best "common denominator" among all extant implementations of Smalltalk. Consequently, the base class ChronosEnvironment itself is implemented so that it should work as-is for any Smalltalk-80 ("Blue Book") compliant implementation of Smalltalk (although the methods ChronosEnvironment class>>setPlatformClass, ChronosEnvironment class>>systemFacadeClass and ChronosEnvironment>>purgeUnusedBindingsFromUndeclaredNamespace must always be subimplmented.)  Subclasses of ChronosEnvironmnent intended for use on Smalltalk platforms that have richer namespace facilities are encouraged to make optimal use of whatever namespace functionality may be available for that particular Smalltalk system. Particularly, the classes of the Chronos codebase should, when possible, be defined in an independent namespace named 'Chronos.'

		Smalltalk-80 implements namespaces in three different ways: 1) The class SystemDictionary and its canonical instance, which is referenceable as the global binding "Smalltalk, " and which is used to store global values, especially classes; 2) "Class Pool" Dictionaries, which are used to define class variable bindings, and 3) "Shared Pool" Dictionaries, which are used to define non-global bindings to be shared among selected classess without regard to inheritance relationships.  Blue-Book Smalltalk-80 does not have sufficient system/tool support for defining the classes of the Chronos Date/Time Library in their own independent namespace.   However, "shared pool" Dictionaries will function quite adequately in the role of namespaces for the purpose of defining the constants and aliases used by Chronos.

		If not subclassed, or if the methods of ChronosEnvironment class that define the Chronos namespaces are not subimplemented, then ChronosEnvironment class will define a namespace as a "shared pool" Dictionary. Also, if the method ChronosEnvironment class>>defineChronosNamespace is not subimplemented, then ChronosEnvironment class will not attempt to define the namespace 'Chronos' for the purpose of defining the classes of the Chronos codebase in their own independent namespace. (The namespace 'Chronos' should be defined/used only if there is sufficient system/tool support for defining, browsing and editing classes in multiple, independent namespaces.) The default implementation provided by ChronosEnvironment itself is appropriate in cases where a) the host Smalltalk system supports "shared pool" Dictionaries, and b) there is insufficient system/tool support for any better implementation approach.

	Subclassing:

		Subclasses must subimplment the class methods ChronosEnvironment class>>setPlatformClass and ChronosEnvironment class>>systemFacadeClass, and also the instance method ChronosEnvironment>>purgeUnusedBindingsFromUndeclaredNamespace. The method comments fully specify the required behavior (as does this class comment in the text above.)

		Subclasses may need to subimplement the instance method #nativeScaledDecimalClass (as explained above.)

		The method ChronosEnvrionment>>defineVariable:in:withValue:constant:category:rebindIfPresent:onCollision: should be subimplemented if doing so would add value to the default implementation provided by ChronosEnvironment itself (which just uses #at:put: to add an entry to a namespace (or Dicitionary, as the case may be.)) For example, protocol and/or syntax may be available to make the binding constant (immutable,) and/or to classify the binding in a category (the latter has no effect on the behavior of Chronos, but when the system/tools provide support for organizing elements by category, it's best to avoid having elements show up in the 'As yet unspecified' category.)

		Subclasses specific to a Smalltalk system that provides robust support for multiple, independent namespaces (such that classes can be defined in multiple namespaces, with sufficient system/tool support for defining, browsing and editing such classes) are strongly encouraged to subimplement the following methods so that optimal use is made of the host Smalltalk system's namespace functionality (the method comments fully specify the required behavior):

			ChronosEnvironment class>>chronosNamespace			
			ChronosEnvironment class>>chronosNamespaceName		
			ChronosEnvironment class>>addImport:in:private:
			ChronosEnvironment class>>defineChronosCalendarConstantsNamespace
			ChronosEnvironment class>>defineChronosConstantsNamespace
			ChronosEnvironment class>>defineChronosConstantsNamespaceImports
			ChronosEnvironment class>>defineChronosDaysOfWeekConstantsNamespace
			ChronosEnvironment class>>defineChronosDurationConstantsNamespace
			ChronosEnvironment class>>defineChronosFactoryBindingsNamespace
			ChronosEnvironment class>>defineChronosNamespace
			ChronosEnvironment class>>defineChronosStandardMonthConstantsNamespace
			ChronosEnvironment class>>defineChronosTemporalRatioConstantsNamespace
			


		!

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Chronos'! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
canonical
	"Answer the canonical instance of the receiver--the one that is correct for the current Smalltalk environment."

	"ChronosEnvironment canonical"

	Canonical == nil ifTrue: [Canonical := self new].
	^Canonical! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
chronosNamespace
	"Answer the namespace that contains the classes of the Chronos codebase."

	^self globalNamespace! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
chronosNamespaceName
	"Answer the name of the namespace that contains the classes of the Chronos codebase."

	^EnvironmentFacade current globalNamespaceName! !

!ChronosEnvironment class methodsFor: 'shared/global variable bindings' stamp: ''!
defineChronosCalendarConstants
	| namespace | 
	namespace := self chronosNamespace at: #ChronosCalendarConstants.
	EnvironmentFacade current 
		defineVariable: #AnsiStandardCalendar
		in: namespace
		withValue: nil
		constant: true
		category: #public
		rebindIfPresent: false
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #AnsiStandardCalendarClock
		in: namespace
		withValue: nil
		constant: true
		category: #public
		rebindIfPresent: false
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Gregorian
		in: namespace
		withValue: nil
		constant: true
		category: #public
		rebindIfPresent: false
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Julian
		in: namespace
		withValue: nil
		constant: true
		category: #public
		rebindIfPresent: false
		onCollision: [].! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosCalendarConstantsNamespace
	"Define a namespace named ChronosCalendarConstants"

	EnvironmentFacade current 
		defineVariable: #ChronosCalendarConstants
		in: self chronosNamespace
		withValue: self newNamespace
		constant: true
		category: #'Chronos-Environment'
		rebindIfPresent: false
		onCollision: ["If already defined, then we'll just use it."]! !

!ChronosEnvironment class methodsFor: 'shared/global variable bindings' stamp: ''!
defineChronosConstants
	| namespace |
	namespace := self globalNamespace at: #ChronosConstants.
	EnvironmentFacade current 
		defineVariable: #MeridianKeys
		in: namespace
		withValue: #(#'ante-meridian' #'post-meridian')
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	self defineChronosConstantsNamespaceImports! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosConstantsNamespace
	"Define a namespace named ChronosConstants"

	EnvironmentFacade current 
		defineVariable: #ChronosConstants
		in: self globalNamespace
		withValue: self newNamespace
		constant: true
		category:  #'Chronos-Environment'
		rebindIfPresent: false
		onCollision: ["If already defined, then we'll just use it."]! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosConstantsNamespaceImports
	"Cause the #ChronosConstants namespace to 'import' from all the other Chronos namespaces that contain constants and/or aliases (i.e., all of the other Chronos namespaces except for the #Chronos namespace.) Ideally, this should be done by means of dynamic delegation from the #ChronosConstants namespace to the other namespaces.  However, if necessary, it may also be achieved by copying the bindings from the other namespaces into the #ChronosConstants namespace, or even by duplicating the key->value entries."

	| namespace | 
	namespace := self globalNamespace at: #ChronosConstants.
	EnvironmentFacade current
		addImport: (Array with: self chronosNamespaceName with: #ChronosTemporalRatioConstants)
		in: namespace private: false.
	EnvironmentFacade current
		addImport: (Array with: self chronosNamespaceName with: #ChronosDaysOfWeekConstants)
		in: namespace private: false.
	EnvironmentFacade current
		addImport: (Array with: self chronosNamespaceName with: #ChronosStandardMonthConstants)
		in: namespace private: false.
	EnvironmentFacade current
		addImport: (Array with: self chronosNamespaceName with: #ChronosFactoryBindings)
		in: namespace private: false.
	EnvironmentFacade current
		addImport: (Array with: self chronosNamespaceName with: #ChronosCalendarConstants)
		in: namespace private: false.
	EnvironmentFacade current 
		addImport: (Array with: self chronosNamespaceName with: #ChronosDurationConstants)
		in: namespace private: false.! !

!ChronosEnvironment class methodsFor: 'shared/global variable bindings' stamp: ''!
defineChronosDaysOfWeekConstants
	| namespace | 
	namespace := self chronosNamespace at: #ChronosDaysOfWeekConstants.

	"ANSI Smaltalk Values--must conform to ANSI Smalltalk Standard"

	EnvironmentFacade current 
		defineVariable: #ANSIDayOfWeekKeys
		in: namespace
		withValue: #(Sunday Monday Tuesday Wednesday Thursday Friday Saturday)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Friday
		in: namespace
		withValue: 6
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Monday
		in: namespace
		withValue: 2
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Saturday
		in: namespace
		withValue: 7
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Sunday
		in: namespace
		withValue: 1
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Thursday
		in: namespace
		withValue: 5
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Tuesday
		in: namespace
		withValue: 3
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #Wednesday
		in: namespace
		withValue: 4
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].

	"ISO 8601 Values--must conform to ISO 8601 international standard."

	EnvironmentFacade current 
		defineVariable: #ISODayOfWeekKeys
		in: namespace
		withValue: #(Monday Tuesday Wednesday Thursday Friday Saturday Sunday)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ISOFriday
		in: namespace
		withValue: 5
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ISOMonday
		in: namespace
		withValue: 1
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ISOSaturday
		in: namespace
		withValue: 6
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ISOSunday
		in: namespace
		withValue: 7
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ISOThursday
		in: namespace
		withValue: 4
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ISOTuesday
		in: namespace
		withValue: 2
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ISOWednesday
		in: namespace
		withValue: 3
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosDaysOfWeekConstantsNamespace
	"Define a namespace named ChronosDaysOfWeekConstants"

	EnvironmentFacade current 
		defineVariable: #ChronosDaysOfWeekConstants
		in: self chronosNamespace
		withValue: self newNamespace
		constant: true
		category: #'Chronos-Environment'
		rebindIfPresent: false
		onCollision: ["If already defined, then we'll just use it."]! !

!ChronosEnvironment class methodsFor: 'shared/global variable bindings' stamp: ''!
defineChronosDurationConstants
	| namespace | 
	namespace := self chronosNamespace at: #ChronosDurationConstants.
	#(CalendarDayDuration CivilSecondDuration ClockDayDuration HourDuration MinuteDuration MonthDuration NanosecondDuration SecondDuration WeekDuration YearDuration ZeroDuration ZeroCalendarDuration) do: 
		[:key | 
			EnvironmentFacade current 
				defineVariable: key
				in: namespace
				withValue: nil
				constant: true
				category: #public
				rebindIfPresent: false
				onCollision: []].! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosDurationConstantsNamespace
	"Define a namespace named ChronosDurationConstants"

	EnvironmentFacade current 
		defineVariable: #ChronosDurationConstants
		in: self chronosNamespace
		withValue: self newNamespace
		constant: true
		category: #'Chronos-Environment'
		rebindIfPresent: false
		onCollision: ["If already defined, then we'll just use it."]! !

!ChronosEnvironment class methodsFor: 'shared/global variable bindings' stamp: ''!
defineChronosFactoryBindings
	| namespace | 
	namespace := self chronosNamespace at: #ChronosFactoryBindings.
	#(CalendarDurationFactory CivilDurationFactory DateAndTimeFactory DateFactory DayOfMonthFactory DayOfYearFactory DurationFactory SequenceFactory TimeOfDayFactory TimeperiodFactory WeekOfMonthDayOfWeekFactory) do: 
		[:key | 
			EnvironmentFacade current 
				defineVariable: key
				in: namespace
				withValue: nil
				constant: true
				category: #public
				rebindIfPresent: false
				onCollision: []].! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosFactoryBindingsNamespace
	"Define a namespace named ChronosFactoryBindings"

	EnvironmentFacade current 
		defineVariable: #ChronosFactoryBindings
		in: self chronosNamespace
		withValue: self newNamespace
		constant: true
		category: #'Chronos-Environment'
		rebindIfPresent: false
		onCollision: ["If already defined, then we'll just use it."]! !

!ChronosEnvironment class methodsFor: 'shared/global variable bindings' stamp: ''!
defineChronosGlobalsAndAliases
	self standardChronosGlobalVariableNames do: [:key |
		EnvironmentFacade current 
			defineVariable: key
			in: self globalNamespace
			withValue: nil
			constant: true
			category: #'Chronos-Aliases'
			rebindIfPresent: false
			onCollision: []].! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosNamespace
	"Define a namespace named Chronos--if and only if the host Smalltalk implementation provides the necessary tools and facilities for defining, browsing and editing the classes of the Chronos Date/Time library in an indepedendent namespace named Chronos. Otherwise, do nothing.

	Subclasses implemented for Smalltalk platforms that do provide sufficient system/tool support for multiple, independent namepaces, in which classes can natively reside without becoming invisible to the programming tools, should subimplment this method to define a namespace named 'Chronos'"! !

!ChronosEnvironment class methodsFor: 'installation/setup' stamp: ''!
defineChronosNamespaces
	self defineChronosNamespace.
	self defineChronosTemporalRatioConstantsNamespace.
	self defineChronosDaysOfWeekConstantsNamespace.
	self defineChronosStandardMonthConstantsNamespace.
	self defineChronosFactoryBindingsNamespace.
	self defineChronosCalendarConstantsNamespace.
	self defineChronosDurationConstantsNamespace.
	self defineChronosConstantsNamespace.! !

!ChronosEnvironment class methodsFor: 'installation/setup' stamp: ''!
defineChronosSharedAndGlobalVariables
	self defineChronosTemporalRatioConstants.
	self defineChronosDaysOfWeekConstants.
	self defineChronosStandardMonthConstants.
	self defineChronosFactoryBindings.
	self defineChronosCalendarConstants.
	self defineChronosDurationConstants.
	self defineChronosConstants.
	self defineChronosGlobalsAndAliases! !

!ChronosEnvironment class methodsFor: 'shared/global variable bindings' stamp: ''!
defineChronosStandardMonthConstants
	| namespace | 
	namespace := self chronosNamespace at: #ChronosStandardMonthConstants.
	EnvironmentFacade current 
		defineVariable: #April
		in: namespace
		withValue: 4
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #August
		in: namespace
		withValue: 8
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #December
		in: namespace
		withValue: 12
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #February
		in: namespace
		withValue: 2
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ISOMonthKeys
		in: namespace
		withValue: #(January February March April May June July August September October November December)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #January
		in: namespace
		withValue: 1
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #July
		in: namespace
		withValue: 7
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #June
		in: namespace
		withValue: 6
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #March
		in: namespace
		withValue: 3
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #May
		in: namespace
		withValue: 5
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #November
		in: namespace
		withValue: 11
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #October
		in: namespace
		withValue: 10
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #September
		in: namespace
		withValue: 9
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosStandardMonthConstantsNamespace
	"Define a namespace named ChronosStandardMonthConstants"

	EnvironmentFacade current 
		defineVariable: #ChronosStandardMonthConstants
		in: self chronosNamespace
		withValue: self newNamespace
		constant: true
		category: #'Chronos-Environment'
		rebindIfPresent: false
		onCollision: ["If already defined, then we'll just use it."]! !

!ChronosEnvironment class methodsFor: 'shared/global variable bindings' stamp: ''!
defineChronosTemporalRatioConstants
	| namespace | 
	namespace := self chronosNamespace at: #ChronosTemporalRatioConstants.
	EnvironmentFacade current 
		defineVariable: #DaysPerWeek
		in: namespace
		withValue: 7
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #HoursPerDay
		in: namespace
		withValue: 24
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #MicrosecondsPerMillisecond
		in: namespace
		withValue: 1000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #MicrosecondsPerSecond
		in: namespace
		withValue: 1000000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #MillisecondsPerSecond
		in: namespace
		withValue: 1000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #MinutesPerDay
		in: namespace
		withValue: 1440
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #MinutesPerHour
		in: namespace
		withValue: 60
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #NanosecondsPerDay
		in: namespace
		withValue: 86400000000000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #NanosecondsPerHour
		in: namespace
		withValue: 3600000000000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #NanosecondsPerMicrosecond
		in: namespace
		withValue: 1000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #NanosecondsPerMillisecond
		in: namespace
		withValue: 1000000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #NanosecondsPerMinute
		in: namespace
		withValue: 60000000000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #NanosecondsPerSecond
		in: namespace
		withValue: 1000000000
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #SecondsPerDay
		in: namespace
		withValue: 86400
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #SecondsPerHour
		in: namespace
		withValue: 3600
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #SecondsPerMinute
		in: namespace
		withValue: 60
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
defineChronosTemporalRatioConstantsNamespace
	"Define a namespace named ChronosTemporalRatioConstants"

	EnvironmentFacade current 
		defineVariable: #ChronosTemporalRatioConstants
		in: self chronosNamespace
		withValue: self newNamespace
		constant: true
		category: #'Chronos-Environment'
		rebindIfPresent: false
		onCollision: ["If already defined, then we'll just use it."]! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
doInstallationInsteadOfReinstallation
	InstallationCount := -1! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
globalNamespace
	"Answer the namespace canonically (or most generally) used for the purpose of defining and accessing classes by the host Smalltalk implementation."

	^EnvironmentFacade current globalNamespace! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
globalNamespaceName
	"Answer the name of the namespace canonically (or most generally) used for the purpose of defining and accessing classes by the host Smalltalk implementation."

	^EnvironmentFacade current globalNamespaceName! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
incrementInstallationCount
	InstallationCount := self installationCount + 1! !

!ChronosEnvironment class methodsFor: 'class initialization' stamp: ''!
initialize
	"ChronosEnvironment initialize."

	NotAValue := Object new.
	Canonical := nil.
	PlatformClass := nil.
	ProtectedGlobalVariables := nil.
	self preInstall! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
installationCount
	InstallationCount == nil 
		ifTrue: [InstallationCount := 2].
	^InstallationCount! !

!ChronosEnvironment class methodsFor: 'instance creation' stamp: ''!
new
	^self platformClass basicNew initialize! !

!ChronosEnvironment class methodsFor: 'namespace operations' stamp: ''!
newNamespace
	^Dictionary new! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
platformClass
	PlatformClass == nil ifTrue: [self setPlatformClass].
	^PlatformClass == nil ifTrue: [self] ifFalse: [PlatformClass]! !

!ChronosEnvironment class methodsFor: 'installation/setup' stamp: ''!
preInstall
	(InstallationCount == nil or: [InstallationCount >= 0]) ifTrue: [InstallationCount := 2].
	self shouldSkipInstallation ifTrue: [^self].
	self platformClass defineChronosNamespaces.
	self platformClass defineChronosSharedAndGlobalVariables! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
protectedGlobalVariables
	ProtectedGlobalVariables == nil
		ifTrue: [self setProtectedGlobalVariables].
	^ProtectedGlobalVariables! !

!ChronosEnvironment class methodsFor: 'class initialization' stamp: ''!
release
	"The message #release must be sent to the current 'ChronosEnvironment platformClass' whenever Chronos is about to be removed from the system (image.)  It is the responsibility of subimplementors to ensure that this message is sent at the appropriate time."

	self standardChronosGlobalVariableNames do: 
			[:varName | 
			(self protectedGlobalVariables includes: varName) 
				ifFalse: [self globalNamespace removeKey: varName ifAbsent: []]].! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
setInstallationCount
	InstallationCount := 0! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
setPlatformClass
	"Set the concrete subclass of the reciever whose implmentation is specific to the current Smalltalk platform and usage context."

	"This version of the method assumes that any subclass of the receiver is competent to perform the function requested. If you're porting Chronos from one Smalltalk platform to another, this method must be subimplemented by all direct subclasses so that all (direct) subimplementations will correctly set the  PlatformClass to be the subclass of ChronosEnvironment appropriate for the particular version of the Smalltalk environment/platform into which Chronos finds itself being loaded when #setPlatformClass is sent to the receiver (or any direct subclass.)  The code to figure out which version of Squeak, or of Dolphin, or or VAST, or of ST/X (etc) on which the code is running is of course specific to each Smalltalk flavor.  Also, how many different versions of ChronosEnvironment may be needed in order to handle all the versions of a particular Smalltalk environment, and which specific subclass of ChronosEnvironment is optimal for each version, depends on the platform.  

	As the person doing the port, how far into the past you wish to provide support is up to you.  Support for previous (or future) versions can always be added later."

	self subclasses do: [:any | ^any setPlatformClass]! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
setProtectedGlobalVariables
	"Set <ProtectedGlobalVariables> to be a Set containing the names (as Symbols) of any variables (e.g., class names) in the host Smalltalk's global namespace whose values should not be changed by Chronos.  The only required entries are the names of any classes (or other global variable names) that canonically exist in the host Smalltalk's global namespace AND that Chronos would (re)define/initialize if permitted.  

	Note 1: Evaluate 'ChronosEnvironment platformClass standardChronosGlobalVariableNames' to get all global variable names whose values Chronos would like to define and set to new values unless the names of those variables are included in <ProtectedGlobalVariables>.

	Note 2: Versions of Squeak with Brent Pinkney's Chronology library installed should set the value of <ProtectedGlobalVariables> to 'Set with: #DateAndTime with: #Duration'."

	ProtectedGlobalVariables := Set with: #ScaledDecimal.! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
shouldDoInstallationInsteadOfReinstallation
	^self installationCount = -1! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
shouldSkipInstallation
	^ChronosEnvironment subclasses size = 0 or: 
			[(self globalNamespace at: #ChronosInstallationFlag ifAbsent: [true]) 
				= false]! !

!ChronosEnvironment class methodsFor: 'private' stamp: ''!
shouldSkipReinstallation
	^self installationCount = 2! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 14:36'!
standardChronosGlobalVariableNames
	"Answer a Collection of the names (as Symbols) of the global variables that Chronos would like to define and set to new values, if it is permitted to do so."

	^#(#DateAndTime #Duration #SystemClock #Timezone #ScaledDecimal)! !

!ChronosEnvironment class methodsFor: 'accessing' stamp: ''!
systemFacadeClass
	"Answer the concrete subclass of ChronosSystemFacade whose implementation is specific to the current Smalltalk platform and usage context."

	| pc |
	pc := self platformClass.
	^(pc == nil or: [pc == ChronosEnvironment])
		ifTrue: [self signal: Error message: 'Failure to resolve concrete ChronosSystemFacade subclass specifically implemented for use in this Smalltalk environment']
		ifFalse: [pc systemFacadeClass]! !

!ChronosEnvironment methodsFor: 'accessing' stamp: ''!
chronosNamespace
	^self class chronosNamespace! !

!ChronosEnvironment methodsFor: 'accessing' stamp: ''!
copyrightNotice
	^'NOTICE: All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2007 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html}).'! !

!ChronosEnvironment methodsFor: 'global variable bindings' stamp: ''!
defineChronosGlobalsAndAliases
	"ChronosEnvironment canonical defineChronosGlobalsAndAliases"

	self defineDateAndTimeInGlobalNamespace.
	self defineDurationInGlobalNamespace.
	self defineTimezoneInGlobalNamespace.! !

!ChronosEnvironment methodsFor: 'global variable bindings' stamp: ''!
defineDateAndTimeInGlobalNamespace
	"ChronosEnvironment canonical defineDateAndTimeInGlobalNamespace"

	EnvironmentFacade current
		defineVariable: #DateAndTime
		in: self globalNamespace
		withValue: Timepoint
		constant: true
		category: #'Chronos-Aliases'
		rebindIfPresent: self willRebindDateAndTimeIfAlreadyDefinedInGlobalNamespace
		onCollision: 
			[self reportToConsole: 'Unable to define DateAndTime as a global alias for Timepoint--entry with the same name already present in the global namespace.'. 
			EnvironmentFacade current
				defineVariable: #DateAndTime
				in: self chronosNamespace
				withValue: Timepoint
				constant: true
				category: #'Chronos-Aliases'
				rebindIfPresent: self chronosNamespace ~~ self globalNamespace
				onCollision: []]! !

!ChronosEnvironment methodsFor: 'global variable bindings' stamp: ''!
defineDurationInGlobalNamespace
	"ChronosEnvironment canonical defineDurationInGlobalNamespace"

	EnvironmentFacade current
		defineVariable: #Duration
		in: self globalNamespace
		withValue: ScientificDuration
		constant: true
		category: #'Chronos-Aliases'
		rebindIfPresent: self willRebindDurationIfAlreadyDefinedInGlobalNamespace
		onCollision: 
			[self reportToConsole: 'Unable to define Duration as a global alias for ScientificDuration--entry with the same name already present in the global namespace.'. 
			EnvironmentFacade current
				defineVariable: #Duration
				in: self chronosNamespace
				withValue: ScientificDuration
				constant: true
				category: #'Chronos-Aliases'
				rebindIfPresent: self chronosNamespace ~~ self globalNamespace
				onCollision: []].! !

!ChronosEnvironment methodsFor: 'global variable bindings' stamp: ''!
defineSystemClockInGlobalNamespace
	"ChronosEnvironment canonical defineSystemClockInGlobalNamespace"

	EnvironmentFacade current
		defineVariable: #SystemClock
		in: self globalNamespace
		withValue: ChronosSystemClock current
		constant: false
		category: #'Chronos-Globals'
		rebindIfPresent: self willRebindSystemClockIfAlreadyDefinedInGlobalNamespace
		onCollision: 
			[EnvironmentFacade current
				defineVariable: #SystemClock
				in: self chronosNamespace
				withValue: ChronosSystemClock current
				constant: true
				category: #'Chronos-Globals'
				rebindIfPresent: self chronosNamespace ~~ self globalNamespace
				onCollision: []].! !

!ChronosEnvironment methodsFor: 'global variable bindings' stamp: ''!
defineTimezoneInGlobalNamespace
	"ChronosEnvironment canonical defineTimezoneInGlobalNamespace"

	EnvironmentFacade current 
		defineVariable: #Timezone
		in: self globalNamespace
		withValue: ChronosTimezone
		constant: true
		category: #'Chronos-Aliases'
		rebindIfPresent: self willRebindTimezoneIfAlreadyDefinedInGlobalNamespace
		onCollision: 
			[self reportToConsole: 'Unable to define Timezone as a global alias for ChronosTimezone--entry with the same name already present in the global namespace.'. 
			EnvironmentFacade current
				defineVariable: #Timezone
				in: self chronosNamespace
				withValue: ChronosTimezone
				constant: true
				category: #'Chronos-Aliases'
				rebindIfPresent: self chronosNamespace ~~ self globalNamespace
				onCollision: []].! !

!ChronosEnvironment methodsFor: 'accessing' stamp: ''!
globalNamespace
	^EnvironmentFacade current globalNamespace! !

!ChronosEnvironment methodsFor: 'initialize-release' stamp: ''!
initialize
	"Be default, do nothing."! !

!ChronosEnvironment methodsFor: 'shared variables bindings' stamp: ''!
initializeCalendarConstants
	Calendar initializeCalendarConstants.! !

!ChronosEnvironment methodsFor: 'shared variables bindings' stamp: ''!
initializeChronosSharedVariables
	self initializeFactoryBindings.
	self initializeCalendarConstants.
	self initializeDurationConstants.! !

!ChronosEnvironment methodsFor: 'shared variables bindings' stamp: ''!
initializeDurationConstants
	"ChronosEnvironment canonical initializeDurationConstants"

	| namespace |
	ScientificDuration initializeClassVariables.
	CalendarDuration initializeClassVariables.
	namespace := self chronosNamespace at: #ChronosDurationConstants.
	EnvironmentFacade current 
		defineVariable: #CalendarDayDuration
		in: namespace
		withValue: (CalendarDurationFactory days: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current
		defineVariable: #ClockDayDuration
		in: namespace
		withValue: (DurationFactory days: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current
		defineVariable: #CivilSecondDuration
		in: namespace
		withValue: (CivilDurationFactory seconds: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #HourDuration
		in: namespace
		withValue: (CivilDurationFactory hours: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #MinuteDuration
		in: namespace
		withValue: (CivilDurationFactory minutes: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #MonthDuration
		in: namespace
		withValue: (CalendarDurationFactory months: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #NanosecondDuration
		in: namespace
		withValue: (DurationFactory nanoseconds: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #SecondDuration
		in: namespace
		withValue: (DurationFactory seconds: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #WeekDuration
		in: namespace
		withValue: (CalendarDurationFactory weeks: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #YearDuration
		in: namespace
		withValue: (CalendarDurationFactory years: 1)
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ZeroCalendarDuration
		in: namespace
		withValue: CalendarDurationFactory zero
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #ZeroDuration
		in: namespace
		withValue: DurationFactory zero
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment methodsFor: 'shared variables bindings' stamp: ''!
initializeFactoryBindings
	| namespace |
	namespace := self chronosNamespace at: #ChronosFactoryBindings.
	EnvironmentFacade current
		defineVariable: #CalendarDurationFactory
		in: namespace
		withValue: CalendarDuration
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #CivilDurationFactory
		in: namespace
		withValue: CivilDuration
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #DateAndTimeFactory
		in: namespace
		withValue: Timepoint
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #DateFactory
		in: namespace
		withValue: YearMonthDay
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #DayOfMonthFactory
		in: namespace
		withValue: DayOfMonth
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #DayOfYearFactory
		in: namespace
		withValue: DayOfYear
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #DurationFactory
		in: namespace
		withValue: ScientificDuration
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #SequenceFactory
		in: namespace
		withValue: OrderedCollection
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #TimeOfDayFactory
		in: namespace
		withValue: TimeOfDay
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #TimeperiodFactory
		in: namespace
		withValue: Timeperiod
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].
	EnvironmentFacade current 
		defineVariable: #WeekOfMonthDayOfWeekFactory
		in: namespace
		withValue: WeekOfMonthDayOfWeek
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment methodsFor: 'installation/setup' stamp: ''!
install
	"ChronosEnvironment canonical install"

	self class shouldSkipInstallation ifTrue: [^self].
	self class preInstall; setInstallationCount.
	ChronosSystemFacade current reportCommencementOfInitialChronosInstallation.
	self initializeChronosSharedVariables.
	self defineChronosGlobalsAndAliases.
	TemporalCoordinate defineRangeConstraints.
	ChronosLocale initializeDefaultLocaleInformation.
	EnvironmentFacade current purgeUnusedBindingsFromUndeclaredNamespace.
	self class incrementInstallationCount	.
	self installSystemFacade! !

!ChronosEnvironment methodsFor: 'installation/setup' stamp: ''!
installSystemFacade
	ChronosSystemFacade current shouldSkipInstallation
		ifTrue: [ChronosSystemFacade current reportInstallationSkipped]
		ifFalse: 
			[ChronosSystemFacade current instalIInitially.
			ChronosSystemFacade current reportInitialChronosInstallationAsSuccessful]! !

!ChronosEnvironment methodsFor: 'installation/setup' stamp: ''!
invalidateCalendarBindings
	"ChronosEnvironment canonical invalidateCalendarBindings"

	YearlyCalendar invalidateCalendarBindings.
	CalendarClock invalidateCalendarBindings.
	TemporalInterval invalidateCalendarBindings.
	DateSpec invalidateCalendarBindings! !

!ChronosEnvironment methodsFor: 'installation/setup' stamp: ''!
invalidateTimezones
	"ChronosEnvironment canonical invalidateTimezones"

	AnnuallyRecurringTZPolicyFactory initialize.
	TimeZonePolicyFactory initialize.
	ChronosTimezone invalidate.
	DateAndTimeFactory initialize.
	TimeZoneLocalizationPolicy initialize.! !

!ChronosEnvironment methodsFor: 'installation/setup' stamp: ''!
reinstall
	"Reinitialize Chronos, under the assumption that major changes have been made to the Chronos codebase. It would be wise to perform this operation after loading a new version of Chronos into an image in which a different version was already resident."
 
	"ChronosEnvironment canonical reinstall"

	self class shouldSkipInstallation ifTrue: [^self].
	self class shouldDoInstallationInsteadOfReinstallation ifTrue: [^self install].
	self class incrementInstallationCount	.
	self class shouldSkipReinstallation ifTrue: [^self].
	self reportToConsole: 'New version installed. Reinitializing Chronos...'.
	AnnualDate initialize.
	ComputedAnnualDate initializeAll.
	SemanticDatePolicy initialize.
	ChronosLocale 
		initialize; 
		initializeDefaultLocaleInformation.
	ChronosPrintPolicy initialize.
	ChronosParser initialize.
	Calendar invalidate.
	self initializeChronosSharedVariables.
	self defineChronosGlobalsAndAliases.
	self invalidateCalendarBindings.
	TemporalCoordinate defineRangeConstraints.	
	self  invalidateTimezones.
	ChronosSystemFacade current 
		showReportsWhile: [ChronosSystemFacade current install].
	EnvironmentFacade current purgeUnusedBindingsFromUndeclaredNamespace.
	[self
		reportToConsole: 'Reinitialized: ', (DateAndTimeFactory now % #rfc2822v);
		newLineToConsole] on: Error do: [:ex | ChronosSystemFacade current reportException: ex message: 'The following error occured during reinitialization: ']! !

!ChronosEnvironment methodsFor: 'shared variables bindings' stamp: ''!
setAnsiStandardCalendar: aGregorianCalendar

	EnvironmentFacade current 
		defineVariable: #AnsiStandardCalendar
		in:(self chronosNamespace at: #ChronosCalendarConstants)
		withValue: (aGregorianCalendar == nil ifFalse: [aGregorianCalendar assertIsGregorian])
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment methodsFor: 'shared variables bindings' stamp: ''!
setAnsiStandardCalendarClock: aGregorianCalendarClock

	aGregorianCalendarClock == nil ifFalse: [aGregorianCalendarClock calendar assertIsGregorian].
	EnvironmentFacade current 
		defineVariable: #AnsiStandardCalendarClock
		in:(self chronosNamespace at: #ChronosCalendarConstants)
		withValue: aGregorianCalendarClock
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment methodsFor: 'shared variables bindings' stamp: ''!
setGregorian: aGregorianCalendar

	EnvironmentFacade current 
		defineVariable: #Gregorian
		in:(self chronosNamespace at: #ChronosCalendarConstants)
		withValue: (aGregorianCalendar == nil ifFalse: [aGregorianCalendar assertIsGregorian])
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment methodsFor: 'shared variables bindings' stamp: ''!
setJulian: aJulianCalendar

	EnvironmentFacade current 
		defineVariable: #Julian
		in:(self chronosNamespace at: #ChronosCalendarConstants)
		withValue: (aJulianCalendar == nil ifFalse: [aJulianCalendar assertIsJulian])
		constant: true
		category: #public
		rebindIfPresent: true
		onCollision: [].! !

!ChronosEnvironment methodsFor: 'installation/setup' stamp: ''!
tzAdministrationalInstalled
	"The Chronos-Utilities module has been installed.  Take whatever action may be appropriate."

	EnvironmentFacade current purgeUnusedBindingsFromUndeclaredNamespace! !

!ChronosEnvironment methodsFor: 'testing' stamp: ''!
willRebindDateAndTimeIfAlreadyDefinedInGlobalNamespace
	"Answer whether or not the the value of the 'DateAndTime' global may be changed by Chronos if it's already defined in the global namespace."

	^(self class protectedGlobalVariables includes: #DateAndTime) not! !

!ChronosEnvironment methodsFor: 'testing' stamp: ''!
willRebindDurationIfAlreadyDefinedInGlobalNamespace
	"Answer whether or not the the value of the 'Duration' global may be changed by Chronos if it's already defined in the global namespace."

	^(self class protectedGlobalVariables includes: #Duration) not! !

!ChronosEnvironment methodsFor: 'testing' stamp: ''!
willRebindSystemClockIfAlreadyDefinedInGlobalNamespace
	"Answer whether or not the the value of the 'SystemClock' global may be changed by Chronos if it's already defined in the global namespace."

	^(self class protectedGlobalVariables includes: #SystemClock) not! !

!ChronosEnvironment methodsFor: 'testing' stamp: ''!
willRebindTimezoneIfAlreadyDefinedInGlobalNamespace
	"Answer whether or not the the value of the 'Timezone' global may be changed by Chronos if it's already defined in the global namespace."

	^(self class protectedGlobalVariables includes: #Timezone) not! !

UtilityFunction subclass: #ChronosFunction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ChronosFunction commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosFunction

	Concept: 

		ChronosFunction provides selected utliity functions, implemented as class methods

	Usage: 

		See individual class methods.

	Motivation: 

		The methods provided by ChronosFunction would best be implemented as methods in certain ANSI-standard classes. However, the Chronos implementation policy is to never modify classes of the base Smalltalk library. Adding methods is considered a modification.  

		One reason for the no-modification-of-base-library-class policy (which may very well not be applicable to other packages, applications or projects) is that Chronos is a widely-distributed utility package, and so may be used by many different applications (and by many other utility packages.)   The danger that methods added to base-library classes by Chronos might conflict in some way with methods added in the same inheritance hierarchy by other packages (of which Chronos could have no advance knowledge) is far from trivial or insignificant.

		Another reason for the no-modification-of-base-library-class policy (which may also very well not be applicable to other packages, applications or projects) is that Chronos is intended to be portable among all Smalltalk implementations (or as many as is practical.) Any modifications to classes in the base library of one Smalltalk implementation would complicate porting to other Smalltalk implementations (and could also cause problems when porting to different versions of the same Smalltalk implementation.)

		The functionality of some (or all) of the methods provided by ChronosFunction might possibly be provided (now or later) by methods in the standard class library of one or more Smalltalk implementations.  However, no such methods were provided in the standard class library of the Smalltalk implementation in which the original version of Chronos was written.  Worse, there is no standard that governs the name of any such methods, the arguments they expect, nor the class that must implement them.  Consequently, Chronos could not (and cannot) make use of any such methods.

	Implementation: Not Applicable

	Subclassing: Not Applicable

!

!ChronosFunction class methodsFor: 'date/time services' stamp: ''!
daysAndSecondsSinceStartOfDayFromSeconds: seconds into: block2
	"ChronosFunction daysAndSecondsSinceStartOfDayFromSeconds: Timepoint now secondsSinceEpch into: [:days :secondsSinceStartOfDay | Array with: days with: secondsSinceStartOfDay]"

	| secondsDiv128 |
	secondsDiv128 := seconds bitShift: -7. "Bit shifting is faster than LargeInteger math."
	^block2 
		value:  (secondsDiv128 // 675) "128 * 675 = 86400"
		value: ((seconds bitAnd: 127) + (secondsDiv128 \\ 675 bitShift: 7)) "seconds \\ 128 + (seconds // 128 \\ 675 * 128)"! !

!ChronosFunction class methodsFor: 'arithmetic services' stamp: ''!
divBy1000000000: numerator
	"[1000000 timesRepeat: [ChronosFunction divBy1000000000: 53694252136]] durationToRun"
	"[1000000 timesRepeat: [53694252136 // 1000000000]] durationToRun"
	"[1000000 timesRepeat: [ChronosFunction divBy1000000000: 33554431]] durationToRun"
	"[1000000 timesRepeat: [33554431 // 1000000000]] durationToRun"

	^(numerator bitShift: -9) // 1953125! !

!ChronosFunction class methodsFor: 'date/time services' stamp: 'PaulDeBruicker 3/9/2011 10:48'!
fromSeconds: secondsSinceStartOfTimeOfDayClock hourMinuteSecondDo: block3
	| seconds hour minute second |
	seconds := secondsSinceStartOfTimeOfDayClock.
	hour := seconds // (SecondsPerHour).
	seconds := seconds \\ (SecondsPerHour).
	minute := seconds // (SecondsPerMinute).
	second := seconds \\ (SecondsPerMinute).
	^block3 value: hour value: minute value: second! !

!ChronosFunction class methodsFor: 'date/time services' stamp: ''!
secondsFromDays: days
	"ChronosFunction secondsFromDays: YearMonthDay today daysSinceEpoch"

	^days * 675 bitShift: 7! !

!ChronosFunction class methodsFor: 'arithmetic services' stamp: ''!
times1000000: factor
	"[1000000 timesRepeat: [ChronosFunction times1000000: 53694252]] durationToRun"
	"[1000000 timesRepeat: [53694252 * 1000000]] durationToRun"
	"[1000000 timesRepeat: [ChronosFunction times1000000: 33554431]] durationToRun"
	"[1000000 timesRepeat: [33554431 * 1000000]] durationToRun"

	^(factor bitShift: 6) * 15625! !

!ChronosFunction class methodsFor: 'arithmetic services' stamp: ''!
times1000: factor
	"[1000000 timesRepeat: [ChronosFunction times1000: 53694252]] durationToRun"
	"[1000000 timesRepeat: [53694252 * 1000000]] durationToRun"
	"[1000000 timesRepeat: [ChronosFunction times1000: 33554431]] durationToRun"
	"[1000000 timesRepeat: [33554431 * 1000000]] durationToRun"

	^(factor bitShift: 3) * 125! !

!ChronosFunction class methodsFor: 'date/time services' stamp: ''!
twoDigitYearFromFullYear: fullYear
	"Answer the least two significant digits of the calendar year <fullYear> (which must be an Integer.)"

	^fullYear rem: 100! !

Immutable subclass: #ChronosObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ChronosObject commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosObject

	Concept:

		ChronosObject is an abstract class from which most of the classes in the Chronos Date/Time library inherit a small set of standard/foundational protocol/behavior.

	For details, see the method comments.

	!

ChronosObject subclass: #Calendar
	instanceVariableNames: 'clock yearNumberingPolicy secondsSinceJulianDayEpochUpToEpoch secondsSinceUnificationEpochUpToEpoch daysSinceStartOfWeekForEpochDay daysSinceStartOfISOWeekForEpochDay daysSinceStartOfANSIWeekForEpochDay minDaysPerYear maxDaysPerYear minMonthsPerYear maxMonthsPerYear minDaysPerMonth maxDaysPerMonth monthOrdinalRangeConstraint dayOfMonthOrdinalRangeConstraint dayOfYearOrdinalRangeConstraint daysSinceStartOfYearRangeConstraint monthOrdinalsByMonthKey monthKeysByMonthOrdinal monthNameKeysByMonthKey monthKeyByMonthNameKey monthOrdinalsAlwaysCorrespondToTheSameMonthKey doMonthKeysAlwaysCorrespondToTheSameMonthNameKey'
	classVariableNames: 'ClassRegistry InstanceRegistry'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

Calendar class
	instanceVariableNames: 'yearNumberingPolicy'!

!Calendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

Calendar

	Concept:

		Calendar is an abstract class. An instance of a concrete subclass of Calendar represents and implements a particular calendrical system (or "calendar," for short.) 

		A calendrical system, and therefore a Calendar instance:

			* Defines an epoch date;		 (see below for the definitions of terms such as 'epoch') 
			* Defines the number of days in a year--which may vary from year to year according to well-defined rules;
			* Defines the number of months in a year--which may vary from year to year according to well-defined rules (TAKE NOTE!!);
			* Defines the number of days in each month of the year--which may vary from month to month and from year to year according to well-defined rules;
			* Defines a mapping between each day-of-year ordinal and each month/day-of-month designation for a particular year--which may vary from year to year according to well-defined rules;
			* Defines an algorithm by which to convert a date (year-month-day designation) into a count of days since the epoch date;
			* Defines an algorithm by which to convert a count of the number of days since the epoch date into a year-month-day designation (i.e., a date.)

		Definitions of Terms

			A calendrical system is a system for counting time as a number of days, months and years from a "reference date."  The reference date of a calendrical system is the "zero point" from which years, months and days are counted. 'Epoch date' is the formal term for a calendrical system's reference date or "zero point"--it is usually referred to as just the "epoch" or "calendar epoch." The designation of a particular count of years, months and days from the epoch date used by a calendrical system is called a "date."  Typically (but not universally,) ordinal numbers are used to represent dates, so that a calendrical system's epoch date would be represented as 0001-01-01 (year=0001; month=01; day-of-month=01,) and would mean "zero years, zero months and zero days from the reference time of the calendar" (the ordinal number 1 corresponds to the cardinal number 0.)

			For example, the epoch date (zero-point, reference date) of the modern Julian Calendar is 1-January-0001 AD (which, given that January is the first month of the Julian year, means "first day-of-month" "first month ," "first year" since the Anno Domini Era, counting years, months and days according to the rules of the Julian Calendar.) The date 1-January-2000 in the Gregorian calendar designates a count of 1999 years, 0 months and 0 days from the epoch date of the Gregorian Calendar. [Note: The Gregorian calendar is the international de facto standard calendar for civil purposes--the calendar we all use every day; the Julian Calendar is the one that was used in European nations before the Gregorian Calendar was used.]
			
			The date on which a calendrical system comes into common or official use is called the inception date of the calendar. The epoch date of a calendar is almost always well before its inception date. A date that designates a time prior to a calendar's inception date is referred to as a "proleptic" date. "January 1, 1 AD" is a proleptic date for both the Gregorian and the modern Julian Calendars, since the epoch date of the modern Julian Calendar was first defined and used by Dionysius Exiguus in the Sixth Century AD, and the Gregorian Calendar was first defined and used in 1582 AD.  

			Here are the epoch dates of various calendars, along with their translation into dates in the Gregorian and Julian calendars (Note: As required by the ANSI Smalltalk standard, Gregorian dates in Chronos use "astronomical year numbering," which means that the year before the year 0001 AD is the year 0000 AD; however, Julian year numbers follow tradition, where there is no year zero, and the year prior to 0001 is -0001):

				yyyy-mm-dd [calendar]		    yyyy-mm-dd [Gregorian]	yyyy-mm-dd [Julian]

				0001-01-01 [Solarian] 		= -4236-12-23 [Gregorian] = -4236-01-26 [Julian]	
					Winter Solstice of the year in which the Egyptian Calendar was founded;
					4236 BC is the earliest recorded year in history (although -4236 is the 
					translation into Gregorian/Julian Calendar years of the of the actual 
					recorded date).

				0001-01-01 [Hebrew] 		= -3760-09-07 [Gregorian] = -3761-10-07 [Julian]	
					Date of the creation of the world, according to Jewish reckoning.

				0001-01-01 [Julian (Imperial)]	= -0753-12-24 [Gregorian] =  -0753-01-01 [Julian]
					First day of the Julian year considered to be the year in which the City of 
					Rome was founded.  In 46 B.C. Julius Caesar introduced the Imperial Julian
					Calendar, replacing the ancient Roman calendar. The Imperial Julian Calendar 
					set January 1 as New Year's Day, and added a leap day to the month of 
					February once every four years.  However, the Romans used many different
					epoch years at different times for different purposes. Whenever necessary in
					order to be completely clear, the Romans would use January 1 of the year 
					of the founding of Rome as the epoch date.  Imperial Julian Dates using that 
					epoch were said to be dates "Ab Urbe Condita" (A.U.C.), which is Latin for 
					"From the Founding of the City." 1 AUC [Imperial Julian] = 753 BC [Julian].

				0001-01-01 [Julian] 			=  0000-12-30 [Gregorian] =  0001-01-01 [Julian]	
					First day of the Imperial Julian year 754 AUC--which is the year either before which 
					(or perhaps in which--no one knows for sure) that Dionysius Exiguus reckoned 
					Christ was born. During the same peroid of time that the (supposed) year of Christ's 
					birth was beginning to be used as the epoch year (Sixth through the Ninth Centuries,) 
					the Church took a strong dislike to using January as the first month of the year.  
					Unfortunately, a variety of different days came to be used as New Year's Day (even 
					though January 1 was still used for historical--and sometimes civil--purposes as the 
					start of the year.) 1 AD [Julian] = 754 AUC [Imperial Julian]

				0001-01-01 [Gregorian] 		=  0001-01-01 [Gregorian] =  0001-01-03 [Julian]	
					The Gregorian epoch date was set two days after the Julian (Dionysian) epoch date 
					solely so that the date of the Vernal Equinox in the Gregorian Calendar (going forward 
					from 1582) would be on or about 21 March, the same date on or about which the 
					Vernal Equinox would occur when the official Church formula for computing the date 
					of Easter was formally adopted at the Council of Nicaea in 325 AD.

				0001-01-01 [Ethiopic] 		=  0008-08-27 [Gregorian] =  0008-08-29 [Julian]	
					First day of the year in the ancient Egyptian Calendar after which Christ
					was born by the reckoning of the Ethiopian Orthodox Christian Church.

				0001-01-01 [Indian] 			=  0079-03-22 [Gregorian] =  0079-03-24 [Julian]
					The vernal equinox of the first year of the Saka Era, marking the ascension to 
					the throne of King Salivahana.

				0001-01-01 [Coptic] 			=  0284-08-29 [Gregorian] =  0284-08-29 [Julian]
					First day of the year in the ancient Egyptian Calendar in which Diocletian 
					ascended to the office of Emperor of Rome. This year marks the beginning of
					what is generally known as the Diocletian Era, although Copts call it the Era 
					of Martyrs in memory of the many Christians tortured to death by Emperor 
					Diocletian. This year was widely used as the epoch year in Europe (along with 
					the leap year rule and month structure of the Imperial Julian Calendar) until 
					around the Ninth Century, when almost all Christians began to use the modern
					"Anno Domini" era--with the obvious exception of the Copts.

				0001-01-01 [Persian] 	=  0622-03-22 [Gregorian] =  0622-03-19 [Julian]
					Vernal Equinox of the year in which the "hijra" of Mohammed to Medina
					occurred ("hijra" means "flight from danger.") 

				0001-01-01 [Islamic (Fatimid)] =  0622-07-19 [Gregorian] =  0622-07-16 [Julian]
					Generally accepted date of the "hijra" of Mohammed to Medina ("hijra" means 
					"flight from danger.")  There are some who prefer a different date in the same
					year for this event.

				0001-01-01 [Bahai] 			=  1844-03-21 [Gregorian] =  1844-03-09 [Julian]
					Vernal Equinox of the year in which Siyyid Mrz 'Al-Muhammad was first recognized 
					as a Manifestation of God by Mull Husayn, and took the title "The Bb."  The Bb 
					was the forerunner to Baha' Ullah, the principal figure of the Bahai religion.

		Calendar Semantics

			Timescale

				The fundamental unit of time of any calendar system is the solar day.  Except for the issue of defining the moment that one day transitions to the next (midnight, sunrise, noon, sunset,) calendar systems are not concerned with the time of day. Calendars are responsible for converting a count days since their epoch date into a count of years, months and days (and vice-versa,) not for keeping time intra-day.  In other words, the 'time scale' of a calendrical system is always the solar day--a fundamental, universal and invariant fact about calendrical systems. Counting solar days is what calendars do, it's what they're for, it's their raison d'etre, its the justification for their existence. Consequently, issues such as 'daylight saving time' and 'leap seconds' are irrelevant to a calendrical system. Instances of Calendar, therefore, do not (and MUST not) make any adjustments to their calculations due to leap seconds, time zones or daylight saving time.  

				Calendar objects deal with nominal solar days. They know and care nothing about timezone offsets or atomic clock time. Such issues are properly the responsibility of moment-in-time, timezone and/or timescale objects. 

			Uniform Rule Invariance

				Instances of Calendar always uniformly (without any discontinuities) implement the rules of a calendrical system from the infinite past to the infinitue future. Consequently, for dates prior to the inception date of a calendrical system, a Calendar instance expects/generates proleptic (anachronistic) dates. Such dates, especially those also prior to the epoch date, may be culturally and/or religiously objectionable in some cases.  

				When necessary to avoid confusion, we will call any universally uniform, continuous calendrical system an "elemental calendrical system."

				Proleptic calendrical systems will generally cause historians to complain, because their principal usage for calendrical systems is to interpret dates found in historical documents and inscriptions. This use case gives them a different perspective on calendar semantics than an astronomer, physicist or mathematician would probably have, all of whom typically use calendrical systems as tools by which to measure time, and by which to denote measuresments of time.  Historians tend to view a "calendar" as a sequence of elemental calendrical systems that were used over time by a particular culture, because the dates they encounter and must deal with come from different time periods during which different elemental calendrical systems were in common use by "the same" culture. Although each such elemental calendrical system in the diachronic sequence defines a uniform, coherent and continuous system for reckoning, encoding and interpreting dates, the "composite calendar" formed by the diachronic sequence of different elemental calendrical systems does not. But it is quite natural to perceive each such elemental calendrical system in the diachronic sequence as a variation of "the same" calendar, partly because it is used by "the same" culture, and partly because it is usually quite similar to both its predecessor and its successor.

				In contrast, physicists, astronomers, mathematicians, the ISO 8601 standard for the representation of dates and times, the ANSI Smalltalk standard for DateAndTime behavior, and the Chronos Date/Time Library, all insist that a calendar, BY FORMAL DEFINITION, is a uniform, coherent and continuous system of counting the days since an epoch date as a number of years, months and days, and that any change to the rules by which such reckoning happens defines a new calendar. Consequently, Chronos holds that, by formal definition of "calendrical system," any changes to a) the epoch date, b) the number of days in a year; c) the number of months in a year; d) the number of days in any month; e) the mapping between day-of-year ordinals and month/day-of-month designations for any year; or f) the count of days from the epoch to a particular date designation, creates/defines a new calendrical system. 

				The fact is, a calendrical system is best understood as a uniform, coherent and continuous system of counting days since an epoch as a number of years, months and days, such that there can be no ambiguity as to the result of converting a date designation into a count of days since the epoch, nor any ambiguity about converting a count of days since the epoch into a date designation, nor any ambiguity about the epoch date itself. The reason is because the fundamental, primary and principal purpose of a calendrical system is to define a consistent, uniform, unambigous system for the measurement of time. 

				Applying the definition of calendrical system used by Chronos to a real case, we must conclude that, because their epoch dates differ, the Coptic and Ethiopic Calendars are different calendrical systems, even though they are otherwise identical.  That these two Calendars are in fact not the same is precisely what any Copt or Ethiopian will indignantly tell you, should you foolishly assert otherwise. And that's without even considering the fact that the Coptic start-of-day is sunset and the Ethiopic start-of-day is sunrise.

				The fundamental truth is this: A calendrical system is not just a cultural artifact, it's also a formally well-defined system for interpreting a count of days since an epoch date as a number of years, months and days, and also for interpreting a count of years, months and days as a count of days since an epoch date. Mathematically, the counting system is applicable to any count of days since the calendar's epoch date (positive or negative,) and to any count of years, months and days (positive or negative.)  

				A person who just wants to express or understand a count of time using the calendrical system with which he is familiar cares not at all whether using his preferred calendar to represent a date (that is, "to count time as a number of years, months and days, according to the rules of a calendar') would be either anachronistic or culturally out of context. For example, the fact that no one alive in what we call the year 46 BC would have labeled that year using any variation whatsoever of "negative 46" does not lessen the utility of the modern practice of labeling that year using a proleptic year ordinal (interestingly, even historians do this.)  For the same reason, when discussing events in China in the year 1000 AD, westerners (including western historians) prefer to use Julian dates, in spite of the fact that virtually no one in China at that time would have used Julian Calendar dates.  

				Consider the following quotes:

					"Did you know that nothing happened between 3 and 13 September 1752?" 
					(http://www.didyouknow.cd/calendar.htm)

					"September 1752 had only nineteen days " 
					(http://www.ancestry.com/learn/library/article.aspx?article=3358)

					"The year of 1752 began on March 25th and ended with December 31, 1752, 
					thus the earlier days of 1752 never existed, as the deleted days of September 2--13 
					also never existed. The year 1752 was a very short year; 72 days shorter, in fact." 
					(http://www.crowl.org/Lawrence/time/britgreg.html)  

				What these quotes are referring to is that the British Empire in the year 1752 transitioned from one calendrical system to another. In terms of the Medieval Julian Calendar (the one they transitioned from,) the year 1752 was a normal year, just like any other non-leap year in the Medieval Julian Calendar.  And 1752 was also a perfectly normal leap year in the Gregorian calendar (the one they transitioned to.)  Changing from one calendrical system to another as the official method of representing civil dates can present the appearance of abnormal years and months, but it is simply an illusion caused by changing the system of counting time, without understanding that any such change is a change of calendar, and hence a change to the system of measuring time and interpreting date designations (as opposed to a change in time itself.)  

				The same sort of seemingly-amazing comparisons could be formed by considering what the recorded heights of a child would look like, when a switch is made, in the middle of the record, from Imperial units to Metric System units, when the child is 7 years of age. Clearly, nothing unusual is actually happening to the child's height.  The child does not actually experience a sudden, astonishing spurt of amazing growth, just because his height up to age 7 is recorded in inches, but his height after age 7 is recorded in centimeters. For the same reasons, 1752 was a perfectly normal year in any and all calendrical systems.

				The point is that a calendar is not just a system by which dates are encoded at some point in time in some culture. A calendar also serves as a familiar/canonical measurement system by the members of a culture--which is why proleptic/anachronistic dates will be preferred by a member of a culture in cases where such a person just wants to understand (or have others understand) the meaning of a date in the past, as opposed to correctly interpreting what's written on a dusty document by a member of some historical culture. The fact that most people use dates in their native calendrical system as a canonical measure of time explains why they perceive the effects of transitioning from one calendrical system to another (e.g. Julian to Gregorian) as actually changing the length of years and/or months. Given this fact, there's nothing wrong with expressing dates using the calendrical system with which the audience is familiar, as opposed to the one that would have been natively used in the time and at the place to which the date refers. Nevertheless, many calendar programs and date/time libraries actually make proleptic dates illegal. One wonders whether the authors of such software also disapprove of using Metric System measurement units to measure, record and report the size of ancient artifacts, or to report the distances between ancient cities in Egypt?  To be consistent, they should also be in favor of requiring that  that Chinese history only be discussed in the Chinese language.  

				The bottom line is that a Chronos calendar object is intended to serve as a uniform, continuous system of counting time, and is not intended to be a complete and comprehensive service for interpreting dates from historical documents and inscriptions. However, a system or application for the interpretation of dates from historical sources could certainly be built using the foundation provided by the Chronos Date/Time Library.
			
				As a nod to the historians, one moral of this story is that when dealing with dates, one must take care to interpret them using the same calendrical system used by whoever generated/recorded/provided/specified the date. For the years 1582 in Catholic Europe and 1752 in the British Empire, this is no small problem (to use just two examples.) Nor would there be any way to define an always-correct rule to do such a thing based solely on the date itself, which is one reason for making this task the responsibility of an application, instead of the responsibility of a Calendar instance. Without an explicit specification of the calendrical system and culture, there is no reliable way to correctly interpret dates such as "02/03/784"--especially in the general case, without any context--which is exactly the situation in which a Date/Time Library such as Chronos finds itself.  Providing the necessary interpretive context is properly the responsibility of a particular application and its users.

				The Julian Calendar is actually a very good example of the many issues involved in the meaning of the term 'calendrical system.' See the class comments of ImperialJulianCalendar and JulianCalendar for an in-depth discution.

				The moral of the story is that dates and times are not simple--as the next sections will show even more emphatically.

		Types of Calendrical Systems

			There are fundamentally three different types of calendrical systems: Arithmetical, Astronomical and Observational.
	
			Arithmetical Calendars
		
				 Arithmetical Calendars are also known as Theoretical Calendars. An arithmetical calendar is one where:

					* There is a finite and relatively small number of "year types," where a "year type" a) defines a particular way of organizing the days of a year into months/days-of-the-month, and b) defines a deterministic mapping between day-of-year ordinals and month/day-of-month designations; and
					* There is an invariant, ever-repeating 'cycle of years' during which all the year types occur according to a mathematical pattern that repeats exactly every cycle. 
					* The formula for determining the "year type" can be computed as a function of the year number using integer math--and does not involve or require complex astronomical calculations of the relative motion of any celestial bodies.  The year-type formula functions as a 'sieve' that, for each year, assigns that year to a particular 'cycle of years,' and then assigns each year within the 'cycle of years' to a particular year type.

					The Gregorian Calendar (the de facto international standard civil calendar) is an arithmetical calendar, as are the Julian, Bahai, Coptic, Ethiopic, Fatimid (Arithmetical Islamic,) Hebrew, Indian (Civil,)  and Persian calendars. Most arithmetical calendars have only two year types: a "standard" year and a "leap" year.  The Hebrew Calendar, however, has six different year types: three with 352, 353 and 354 days per year respectively (all three of which have 12 months per year,) and three with 382, 383 and 384 days per year respectively (all three of which have 13 months per year.)

			Astronomical Calendars

				An astronomical calendar is one where:

					* There may be a very large number of "year types," where a "year type" a) defines a particular way of organizing the days of a year into months/days-of-the-month, and b) defines a deterministic mapping between day-of-year ordinals and month/day-of-month designations; and
					* There may NOT be an invariant, ever-repeating 'cycle of years' during which all the year types occur according to a mathematical pattern that repeats exactly every cycle--and if there is, the 'cycle of years' is relatively long. 
					* The formula for determining the "year type" requires complex astronomical calculations of the relative motion of two or more celestial bodies, and cannot be computed as a function of the year number using integer math.

				The difference between an Astronomical Calendar and an Arithmetical Calendar lies entirely in the semantics of the mathematics involved: astronomical calendars use calculations that directly model/simulate the motions of celestial bodies, and arithmetical calendars do not.

				The Chinese Calendar, the religious Islamic Calendar used by Saudi Arabia and many other Islamic countries in the region, the various modern Hindu Calendars, and the French Revolutionary Calendar are examples of astronomical calendars. The initial release of Chronos does not include any astronomical calendars.  An implementation of the Chinese Calendar is planned for Chronos Release 2.0, as is an implementation of the religious Islamic Calendar (which will use the same formulae and rules as does Saudi Arabia.) Those of you who would like to use Smalltalk to compute Chinese New Year or the official dates of the Hajj will have to wait for Chronos Release 2.0.  One or more of the many variations of the Hindu Luni-Solar Calendar may also eventually be implemented.

			Observational Calendars (also known as Pragmatic Calendars)

				An observational calendar system is one where the number of days in a month and/or in a year (and perhaps also the number of months in a year) is determined by "real time" observation of events that regularly occur and can be empirically observed. Of course, observational calendars usually have some rules that are purely arithmetical, and not observational (e.g., a fixed number of months in a year.) Similarly, some arithmetical/astronomical calendars may rely on observation to determine when one day ends and another begins, even though all the other calendrical rules are non-observational.

				All observational calendar systems in actual use require observations of astronomical events in order to determine when one month ends and another begins and/or when one year ends and another begins.  Examples of the sorts of astronomical events whose observation might be used to govern the counting of calendrical time units would be the beginning or ending of a particular phase of the moon (as defined by specific observational rules,) or the occurrence of an equinox or solstice (as defined by specific observational rules.)

				The difference between an observational calendar and an astronomical calendar is a matter of whether or not computational formulae **officially define** the moment of transition from month to month and/or year to year. In an observational calendar, direct real-time observation of real-world events is the official procedure for determining when one month or year ends and another begins, whereas in an astronomical calendar (or arithmetical calendar) the official procedure for determining when one month or year ends and another begins officially (legally) requires only the evaluation of mathematical fomulae.

				Since the observations required by the rules of an observational calendar may be prevented by weather conditions at the time the events actually first occur, and since weather conditions vary from place to place, and also since the observational rules may provide results that vary from one observer to another (even at the same location,)  dates a known number of days in the future cannot be deterministically computed in advance in the case of an observational calendar system (equally incomputable would be the number of days until a particular date in the future.)

				Also, the relationship between past dates and the number of days since the epoch of the calendar, although well-defined, cannot be computed by computational formula, but must instead by derived from an exhaustive record of the points in time at which the pertinent events were deemed to have occurred (information that will vary from location to location, since not all observers will have always agreed as to the timing of the events in question, often precisely because of the locational difference.)

				Calendars that are officially observational are often unofficially simulated using either arithmetical or astronomical computations.

				The religious Islamic Calendar was originally an observational calendar, and still is in some Muslim countries and communities, but in many Islamic countries (e.g, Saudi Arabia ) it is now an astronomical calendar.  There is also an arithmetical version of the Islamic Calendar, known as the Fatimid Calendar--which is the only version that Chronos Release 1.0 implements. Although the Fatimid Calendar is not widely used, nevertheless it is used by some Muslims--even for religious purposes (e.g., the Daudi Bohras [http://ismaili.net/mirrors/108_bohras/bohras.html])--and is also commonly used to interpret dates recorded in the past when the observational calendar was still in use (due to the ambiguities inherent in an observational calendar.)  The Fatimid Calendar agrees with its astronomical cousin more often than not, and would never be off by more than a day at any time within a few millennia of the present day.

				Given the nature of observational calendar systems, Chronos does not support them as such (although it may provide either arithmetical or astronomical simulations for some of them,) and there are no plans to ever directly implement any observational calendars. If such calendar systems are of interest to you, you are invited to implement them yourself.

		The class Calendar has the subclasses RegularCalendar and IrregularCalendar.  RegularCalendar assumes a high degree of regularity in the month strucure of the calendar--as would be typical of an arithmetical calendar.  A "regular calendar" is one with a manageably-small number of different "year types." IrregularCalendar is intended for calendrical systems having a large (perhaps infinite) number of different year types.  In many (but not all) cases, arithmetical calendars are RegularCalendars and astronomical calendars are IrregularCalendars.

		Calendrical systems--their epoch dates, their month structures, their start-of-year dates, their start-of-day times, and other issues are deeply ingrained in the members of each culture that uses a particular calendar.  Just imagine the average person's reaction to being required to use some calendrical system other than the one he or she grew up with.  Often, calendars touch on deeply held religious and/or cultural beliefs and conventions. Dates and times can be just as sensitive a subject as social or religious issues--because they in fact are social and religious issues.  Calendrical disputes have contributed to social unrest and popular revolutions. Caution is warranted.

	Usage:

		Calendar instances are canonically immutable; Calendar inherits (indirectly) from Immutable (which see.) Unlike most subclasses of Immutable, a Calendar instance fully initializes itself and makes itself immutable when instantiated by sending the message #new to its class--because a Calendar instance needs no external parameters to set its instance variables to their correct values.
		
		Calendar Registration/Semantic Keys

			Each concrete Calendar subclass defines a unique registration key that is used as a "well-known" semantic key to identify the calendrical system implemented by that class. The message #registrationKey may be sent to either a Calendar instance, or to its class, to retrieve its registration/semantic key. The well-known registration/semantic keys of the calendrical systems provided in Chronos Release 1.0 are #Bahai, #Coptic, #Ethiopic, #Gregorian, #Hebrew, #'Julian-Imperial', #Indian, #'Islamic-Fatimid', #Julian, #'Persian' and #Solarian.

		Calendar Singletons

			There is no reason to have more than one instance of any particular subclass of Calendar. Calendar class provides a framework so that a single instance of each concrete subclass can be used as a canonical singleton--but Calendar class does not require or enforce the singleton constraint  (Reason: to avoid making the development of new Calendars, or the redesign of existing ones, unnecessarily difficult.) So, although more than one instance of a Calendar is allowed to exist, the Chronos codebase assumes that there is only one canonical instance. Consequently, using a non-canonical instance of a Calendar class may produce undefined behavior in some cases. Recommendation: Don't use multiple instances of the same Calendar class simultaneously, other than for development, testing or experimental purposes.

			There are several ways to access the canonical instance of a Calendar class:

				* Send the message #at:ifAbsent: or #at: to Calendar class, with the registration/semantic key of the Calendar class as the argument of the #at: keyword ("Calendar at: #Hebrew");
				* Send the message #canonical to the Calendar class, or to any instance of the class ("EthiopicCalendar canonical");
				* Send the message #asCalendar to the Calendar class ("CopticCalendar asCalendar"; however, sending this message to an instance results in the instance itself, canonical or not);
				* Send the message #referencedBy: to Calendar class, with any of the following message arguments: a) the registration key of the desired concrete subclass of Calendar, b) the concrete Calendar subclass of the desired instance, c) an instance of the desired Calendar subclass--note that the same flexibility is generally available in the case of most Chronos methods that expect a "calendar" argument;
				* For the Gregorian calendar: Send the message #gregorian or #ansiStandard to Calendar class ("Calendar gregorian" or "Calendar ansiStandard"), or just use the constant Gregorian or the constant AnsiStandardCalendar (both or which should be defined in the ChronosCalendarConstants namespace or shared pool dictionary);
				* For the Julian calendar: Send the message #julian to Calendar class ("Calendar julian"), or just use the constant Julian (which should be defined in the ChronosCalendarConstants namespace or shared pool dictionary.)

		Year Numbering Policy

			Calendars use and provide a policy object for dealing with the year-numbering conventions of a calendrical system ("What's the number of the year immediately preceding the year 1?"; "Are years counted from 1 (ordinal numbering,) or from zero (cardinal numbering, as in the Hindu Calendars)?".)  The year-numbering policy object can be accessed by sending the message #yearNumberingPolicy to either the Calendar instance, or to its class. The policy object will be an instance of one of the subclasses of NumberingPolicy. The class comment of NumberingPolicy fully explains the usage of a Calendar's yearNumberingPolicy.

		Parsing Dates

			Date/Time parsing is provided by the class ChronosParser (which see.)  ChronosParser depends heavily upon both a Calendar instance and an instance of ChronosLocale in order to handle both differences between locales and between Calendars.

			A Calendar instance provides significant information useful for both parsing dates, and also for representing them to users.

		Year Types

			Calendrical systems define a set of 'year types,' where each year type defines a particular organization of the days of the year into months and days of the month, and hence a particular mapping between day-of-year ordinals and month/day-of-month designations for all years with the same year type. Most arithmetical calendars define only two year types ("standard" and "leap,") although the Hebrew Calendar defines six (it's the clear winner of the complexity competition for arithmetical calendar systems.) The number of year types in an astronomical calendar can be quite large (e.g. the Chinese and Hindu lunisolar Calendars)--although that does not have to be the case (e.g., the Persian Astronomical Calendar.)
			
			To determine the year type code of a particular year, send the message #typeCodeOfYear: to the Calendar instance, with the year as the argument ("Calendar gregorian typeCodeOfYear: 1900."; "Calendar julian typeCodeOfYear: 1900."; "Calendar gregorian typeCodeOfYear: 2000.")  The interpretation of the type code is unique to each Calendar: the same code value may have a totally different meaning to different calendars; for some Calendars, the type code of a year may be the year itself.  Generally, it is not possible to reliably infer directly from the year type code whether or not the year is a leap year (although that's quite straightforward for all arithmetical calendars other than the HebrewCalendar.) The canonical way to determine whether a year is a leap year will be revealed below.

			Many of the messages in the API of Calendar require the year type code (although many of them have alternates that take the year itself, compute the year type code for you, and then invoke the analogous message that takes a year type code instead of a year.) Since computing the year type code can be computationally quite expensive in some cases (the HebrewCalendar is the worst offender,) one should take advantage of any opportunities to compute the year type code once and reuse it for two or more subsequent message sends to a Calendar instance involving any dates in the same year.

		Month Ordinals; Numerical Month Designators

			Chronos requires that, for all calendars universally, the ordinal number of the month that contains the first day of the year must be 1 (in other words, the month ordinal must literally be an ordinal number that counts months since the start of the year, and so must be a number greater by one than the cardinal number of months since the month that begins a year.)  Consequently, the Chronos month ordinal for the month of Tishri in the Hebrew Calendar is 1, not 7 (this subject is fully discussed in the class comment of HebrewCalendar.)   

			Calendar provides the messages #monthOrdinalFromNumericMonthDesignator:forYearTypeCode: and #numericMonthDesignatorFromMonthOrdinal:forYearTypeCode: for the purpose of translation to/from canonical month ordinals and culturally-correct "numerical month designators." Be sure to use these messages appropriately when capturing dates from, or presenting dates to, the users of an application (a ChronosPrintPolicy can be used to print dates using month ordinals, numeric month designators, month names or month abbreviations.) Applications must provide their own date capture and/or date parsing mechanisms.

			Sending the message #month to a point-in-time object (a DateSpec, YearMonthDay, DateAndTimeSpec or DateAndTime/Timepoint,) provides the mathematically-correct month ordinal of the date (as required by the ANSI-Smalltalk standard.) Sending the message #numericMonthDesignator to a point-in-time object (a DateSpec, YearMonthDay, DateAndTimeSpec or DateAndTime/Timepoint,) provides the culturally-correct month ordinal.

		Month Keys; Month Name Keys

			Those only familiar with relatively simple and regular arithmetical calendars, such as the Gregorian Calendar, may be surprised to learn that some calendrical systems (e.g., the Hebrew, Chinese and Hindu lunisolar Calendars) have a variable number of months in a year--such calendrical systems have "leap months," in complete analogy with the familiar "leap day" that almost all calendrical systems use.  They may be even more surprised to discover that the leap months a) are often not inserted as the final month, and b) are not necessarily inserted in the same numerical sequence in different years.  Consequently, in such calendrical systems there is no invariant mapping between a month's ordinal number and the semantic identity of the month (e.g., it's name, what holidays or event annimversaries occur during the month, etc.)   For this reason, Chronos semantically identifies a month using a well-known "month key" (a Symbol.) for each month.

			Using month keys enables the date of Purm (for example) to be defined as the 14th day of the month whose month key is #Adar in the Hebrew calendar.  Otherwise, the date of Purim would have to be specified as the 14th day of "month 12" (monthOrdinal=6) in non-leap years, but as the 14th day of "month 13" (monthOrdinal=7) in leap years (a Hebrew leap year is one where a leap month is inserted.)

			The remaining issue is the name and abbreviation of a month.  The month ordinal should not be used as an index into a table of month names and abbreviations because not all calendars associate the same month name/abbreviation with the same month ordinal in all years. The month key should not be used as the name of a month because the key is a Symbol whose characters form an English word (or the English transliteration of a foreign word,) and not all users will want to see English month names (or ASCII representations of the names of months in a calendar.). 

			Also, the month key should not be used as a key into a Dictionary of month names/abbreviations, because the name/abbreviation of a month may vary as a function of the year type. For example, in the Hebrew Calendar,  the month whose monthKey is #Adar has the month ordinal 6 and the name "Adar" (English transliteration) in a non-leap year, but has the month ordinal 7 and name "Adar Sheni," "Adar Beth" or "Adar II" in leap years. For this reason, in addition to a month key for each month, Chronos also defines a month nameKey for each month (which for most calendrical systems, will always be identical to the monthKey, but in the Hebrew, Chinese and Hindu lunisolar calendars may differ from the monthKey for some months in some years.)  ChronosLocale (which see) provides a mapping between month nameKeys, month names, and month abbreviations.

		Queries about Years and Months

			Year Queries
				
				The method protocol 'API-queries-years' provides messages for querying a Calendar about its years.  See the individual methods and their comments for full details. Some examples:

					EthiopicCalendar canonical eraNameForYear: -5500
					Calendar gregorian maxDaysPerYear
					HebrewCalendar canonical daysInYear: 5765
			
			Month Queries

				The method protocol 'API-queries-months' provides messages for querying a Calendar about its months.  See the individual methods and their comments for full details. Some examples:

					Calendar julian daysInMonth: 2 inYear: 1900
					Calendar gregorian maximumDayOfYearOrdinalForMonth: 3 day: 1	
					HebrewCalendar canonical monthKeyForMonthAt: 7 inYear: 5765
					HebrewCalendar canonical 
						numericMonthDesignatorFromMonthOrdinal: (HebrewCalendar canonical monthOrdinalForMonthWithKey: #Adar inYear: 5766)
						inYear: 5766

		Date Validation

			The method protocol 'API-validation' provides messages useful for validating date designations:  

				Message									Usage example

				#dayOfMonthOrdinalRangeConstraint			Calendar gregorian dayOfMonthOrdinalRangeConstraint assertValid: 0
				#dayOfYearOrdinalRangeConstraint			Calendar gregorian dayOfYearOrdinalRangeConstraint isValid: 367
				#daysSinceStartOfYearRangeConstraint		Calendar gregorian daysSinceStartOfYearRangeConstraint minValidValue
				#monthOrdinalRangeConstraint				Calendar gregorian monthOrdinalRangeConstraint maxValidValue
				#assertValidDayOfYear:						Calendar gregorian assertValidDayOfYear: 367	
				#assertValidDaysSinceStartOfYear:			Calendar gregorian assertValidDaysSinceStartOfYear: -1
				#assertValidMonth:day:						Calendar gregorian assertValidMonth: 2 day: 30
				#validateYear:dayOfYear:ifInvalid:				Calendar julian validateYear: 0 dayOfYear: 366 ifInvalid: [:problem | problem]
				#validateYear:month:day:ifInvalid:				Calendar gregorian validateYear: 1900 month: 2 day: 29 ifInvalid: [:problems | problems]

		CalendarPeriods (YearlyCalendar, MonthlyCalendar, CalendarDay)

			Calendars use CalendarPeriod objects to represent the structure/organization of months within years, and days within months.  There are three subtypes of CalendarPeriod: YearlyCalendar, MonthlyCalendar and CalendarDay (all of which see.) There is a different YearlyCalendar instance for each type of year, each of which contains a MonthlyCalendar instance for each month that occurs in the type of year represented by its containing YearlyCalendar.  Each MonthlyCalendar contains a CalendarDay instance for each day of the month that occurs in that month, in the type of year represented by the root YearlyCalendar. So each CalendarDay is bound to a particular MonthlyCalendar, which is bound to a particular YearlyCalendar, which is bound to a particular type of year and to a particular Calendar instance.

			The CalendarPeriod objects used by Calendars are flyweight objects: only one instance will exist in memory representing the same calendar period for a given year type for a particular Calendar instance.  This means that there are four instances of CalendarDay that represent March 1--one for standard years in the Gregorian Calendar, one for standard years in the Julian Calendar, one for leap years in the Gregorian Calendar, and one for leap years in the Julian Calendar. 

			The method protocol 'API-CalendarPeriods' provides messages for accessing the CalendarPeriod flyweights.  For full details, see the individual methods and theif comments.  A few usage examples are provided below: 

				Message										Usage example

				#yearlyCalendarFor:								(Calendar at: #Hebrew) yearlyCalendarFor: 5765
				#calendarDayFromDayOfYearOrdinal:inYear: 		(Calendar gregorian calendarDayFromDayOfYearOrdinal: 60 inYear: 2004) isLeapDay
				#calendarDayFromMonth:day: inYear: year 		(Calendar gregorian calendarDayFromMonth: 12 day: 31 inYear: 2000) dayOfYear
				
		Date Deconstruction

			The method protocol 'API-Date Deconstruction' provides messages for converting a date designation into a count of days since the epoch. See the individual methods and their comments for complete details. Usage examples of the most important such messages are presented below:
		
				Message											Usage examples

				#daysUpToMonth:day:inYear:						Calendar gregorian daysUpToMonth: 1 day: 1 inYear: 2001.
																	Calendar gregorian daysUpToMonth: 9 day: 11 inYear: 2001.
																	Calendar gregorian daysUpToMonth: 12 day: 31 inYear: 2001.

				#daysSinceEpochUpToYear:							Calendar gregorian daysSinceEpochUpToYear: 2001. 

				#daysSinceEpochUpToMonth:day:inYear:			Calendar gregorian daysSinceEpochUpToMonth: 1 day: 1 inYear: 1.
																	Calendar gregorian daysSinceEpochUpToMonth: 1 day: 1 inYear: 1901.
																	Calendar gregorian daysSinceEpochUpToMonth: 7 day: 20 inYear: 1969.
																	Calendar gregorian daysSinceEpochUpToMonth: 9 day: 11 inYear: 2001.

			Note that adding 'Calendar gregorian daysSinceEpochUpToYear: 2001 [=730485]' to 'Calendar gregorian daysUpToMonth: 9 day: 11 inYear: 2001' [=253] gives the same result as 'Calendar gregorian daysSinceEpochUpToMonth: 9 day: 11 inYear: 2001' [=730738].

		Date Construction

			The method protocol 'API-Date Construction' provides messages for converting a count of days since the epoch (or months since the epoch) into a date designation. 

			Date designations are not simple numbers, which means that there are only two ways to provide the result of converting a count of days (or months) since the epoch into a date designation: either some sort of date object must be created and returned (even if it's just an Array instance,) or else the components of the date must be injected into a multi-argument block (more generally, a mult-argument message must be sent to a callback object.) Calendar instances use both strategies.

			The date objects returned by Calendar's date construction messages are instances of DateSpec (which see.) Performance testing proved that answering a DateSpec was significantly more efficient than answering an Array object. DateSpecs are designed to be extremely efficient to create, to have a small memory footprint, and to do nothing more than to serve as extremely efficient representations of a date designation. DateSpecs are not fully ANSI compliant, although they provide a subset of the protocol ANSI specifies for DateAndTime objects.  [Full compliance with the ANSI DateAndTime protocol is provided by instances of Timepoint.]  

			Calendar's date construction methods that inject the components of a date designation into a block require a two-argument block as their argument.  The first block argument is the year.  If the message is constructing a partial date from a count of months since the epoch, then the second block argument is the month ordinal. Otherwise, if the message is constructing a complete date designation from a count of days since the epoch, then the second argument is an instance of CalendarDay (see above, under "Calendar Periods.").  

			See the individual methods and their comments for complete details of each message. Usage examples of the most important date construction messages are presented below:

				Message											Usage examples

				#forDaysSinceEpoch:setYearAndCalendarDayInto: 	Calendar gregorian 
																		forDaysSinceEpoch: 0 
																		setYearAndCalendarDayInto: [:year :calendarDay | Array with: year with: calendarDay].
																	Calendar gregorian 
																		forDaysSinceEpoch: 730485
																		setYearAndCalendarDayInto: [:year :calendarDay | Array with: year with: calendarDay].
																	Calendar gregorian 
																		forDaysSinceEpoch: 730485 +  253
																		setYearAndCalendarDayInto: [:year :calendarDay | Array with: year with: calendarDay].

				#dateSpecFromDaysSinceEpoch:					Calendar gregorian dateSpecFromDaysSinceEpoch: 0
																	Calendar gregorian dateSpecFromDaysSinceEpoch: 730485
																	Calendar gregorian dateSpecFromDaysSinceEpoch: 730485 +  253

		Days of the Week

			Most calendar systems have seven days in a week. And those that don't aren't in active use (e.g., the French Revolutionary calendar.)  Chronos defines a week as 7 days.  Any other period of days, regardless of what a particular calendar system may call it, is by Chronos definition NOT a week.  There must be some invariants, and 7 days per week is so close to universal, that the benefits of this stance far outweigh the costs.

			The "first day of the week" is defined by culture, and not by a calendrical system. Nevertheless, the ANSI Smalltalk standard requires that the first day of the week must be Sunday--at least in the Gregorian Calendar. Unfortunately, the ISO 8601 international standard requires that the first day of the week must be Monday (also, at least in the Gregorian Calendar.) Actually, this conflict is an excellent example of the point that the first day of the week is a cultural issue (Americans versus Europeans,) since the difference of opinion involves the same calendrical system (Gregorian.) 

			Chronos provides support for both the ANSI and the ISO 8601 conventions for numbering the days of the week.  However, because Chronos must fully comply with the ANSI Smalltalk standard, methods that provide or expect day-of-week ordinals, in cases where the method selector doesn't clearly indicate whether the method provides or expects either ANSI or ISO values, will always provide or expect ANSI values for the Gregorian Calendar.  By default, the same holds for other calendars, unless they override the requisite day-of-week methods.

			Code that needs to refer to day-of-week ordinals is encouraged to use the day-of-week ordinal constants defined in the ChronosDaysOfWeekConstants namespace (or "shared pool dictionary.")  The constants whose values are ANSI (American) ordinals are Sunday, Monday, Tuesday, Wednesday, Thursday, Friday and Saturday.  The constants whose values are ISO 8601 ordinals are ISOMonday, ISOTuesday, ISOWednesday, ISOThursday, ISOFriday, ISOSaturday and ISOSunday.

			The names of the days of the week are also defined by culture/language, and not by a calendrical system.  Consequently, Chronos identifies days of the week by semantic keys (which are Symbols whose characters are the names in English of the days of the week.)   The ChronosDaysOfWeekConstants namespace defines both ANSIDayOfWeekKeys and ISODayOfWeekKeys, which are Arrays containing the semantic keys of the days of the week, such that the index of each key is the ordinal value as defined by either the ANSI or the ISO standards (e.g., 'ISODayOfWeekKeys indexOf: #Sunday' evaluates to the ISO 8601 ordinal number for Sunday.) Applications should use the day-of-week semantic keys to translate the day-of-week into a particular language--a task for which ChronosPrintPolicy and ChronosLocale provide the necessary infrastructure.

			The method protocol 'API-Day of week' provides various messages for dealing with days of the week.  See the individual methods and their comments for more information.

		Current Date & Time

			Each Calendar provides its own clock object (an instance of CalendarClock, which see) that provides the current time and date.  The clock can be accessed by sending the message #clock to any concrete subclass of Calendar (to either the class or the instance.)  

			Here a few examples of using the CalendarClock:

				Example											Comment

				Calendar gregorian clock now.						Current date&time in default timezone--in the Gregorian Calendar.
				Calendar julian clock now.							Current date&time in default timezone--in the Julian Calendar.
				EthiopicCalendar clock today.						Date&time at start-of-day in default timezone--in the Ethiopic Calendar (note: day starts at 6pm.)
				HebrewCalendar clock dateToday localePrintString.	Date today in default timezone--in the Hebrew Calendar (note: day starts at 6pm.)

		Julian Days
	
			The Julian day or Julian day number (JDN) is the number of days that have elapsed since 12 noon Greenwich Mean Time (UT or TT) on Monday, January 1, 4713 BC in the proleptic Julian calendar; or November 24, -4713 in the proleptic Gregorian calendar. The Julian day system was invented to provide astronomers with a single system of dates that could be used when working with different calendars, and to unify different historical chronologies.

			The Julian Date (JD) is the Julian day number plus the decimal fraction of the day that has elapsed since noon. Historical Julian Dates were recorded relative to GMT or Ephemeris Time, but the International Astronomical Union now recommends that Julian Dates be specified in Terrestrial Time, and that when necessary to specify Julian Dates using a different time scale, that the time scale used be indicated when required, such as JD(UT1). The fraction of the day is found by converting the number of hours, minutes, and seconds after noon into the equivalent decimal fraction.

			The term 'Julian date' is also used to refer to Julian calendar dates and to ordinal dates. An ordinal date is one that designates a day-of-year (and perhaps also a year.) The use of 'Julian date' to refer to the day-of-year is generally considered to be incorrect--the correct term is ordinal date.

			The method protocol 'API-Julian Days' provides messages for converting between Julian Day Numbers and a count of the number of days or seconds siince the epoch of a Calendar:

				Message											Usage example

				#julianDayOfEpoch									Calendar gregorian julianDayOfEpoch 
				#secondsSinceJulianDayEpochUpToEpoch			Calendar julian secondsSinceJulianDayEpochUpToEpoch
				#secondsFromMidnightToJulianDayStartOfDay		HebrewCalendar canonical secondsFromMidnightToJulianDayStartOfDay
				#secondsSinceStartOfDayAtStartOfJulianDay			IslamicFatimidCalendar canonical secondsSinceStartOfDayAtStartOfJulianDay
				#secondsSinceStartOfJulianDayAtStartOfDay			CopticCalendar canonical secondsSinceStartOfJulianDayAtStartOfDay
				#daysSinceEpochFromJulianDay:					Calendar gregorian daysSinceEpochFromJulianDay: Calendar gregorian julianDayOfEpoch
				#secondsSinceEpochFromJulianDay:				Calendar julian secondsSinceEpochFromJulianDay: Calendar julian julianDayOfEpoch
				#julianDayFromDaysSinceEpoch:					Calendar gregorian julianDayFromDaysSinceEpoch: 0
				#julianDayFromSecondsSinceEpoch:					Calendar julian julianDayFromSecondsSinceEpoch: 43200

		Inter-Calendar Date Conversion

			Dates are converted between calendrical systems by the following procedure:
		
				1. Deconstructing the source date into a count of the seconds since the epoch of the source date's calendar;
				2. Computing the count of seconds from the epoch of the target calendar up to the epoch of the source calendar (which may be a negative number);
				3. Adding the result of step 2 to the result of step 1, resulting in a count of seconds since the epoch of the target calendar, and then 
				4. Constructing a date in the target calendar from the count of seconds since its epoch that was computed in step 3.

			If you tried to execute the procedure given above, using just the Calendar protocol discussed so far in this text, you'd discover that "computing the count of seconds from the epoch of the target calendar up to the epoch of the source calendar" is more easily said than done.  It might, however, occur to you that the epoch dates of a number of calendrical systems is listed above (all as dates in the Gregorian Calendar,) and that evaluating '(Calendar gregorian daysSinceEpochUpToMonth: 3 day: 22 inYear: 622) - (Calendar gregorian daysSinceEpochUpToMonth: 9 day: 7 inYear: -3760)' would compute the number of days from the Hebrew epoch up to the Persian epoch (for example,) which works out to 1600323 days. And you'd be right: this works in principle, although it doesn't account for the fact that days in the Hebrew Calendar start at sundown (modernly at 6pm,) but days in both the Gregorian and Persian Calendars start at midnight.  

			The Chronos inter-calendar date conversion architecture works by a) requiring that concrete subclasses of Calendar must specify the initial moment of their epoch day as a count of seconds since the initial moment of Julian Day 0 (see discussion of Julian Days in previous section,)  and b) nominating a particular Calendar as the "unification calendar." During initialization of a Calendar instance, the instance computes the count of seconds since the initial moment of the epoch day of the unification calendar up to the initial moment of its own epoch day, and stores the result in an instance variable. The value is computed by sutracting a) the count of seconds since the initial moment of Julian Day 0 up to the initial moment of the epoch day of the unification calendar from  b) the count of seconds since the initial moment of Julian Day 0 up to its own epoch day. The computation is done using seconds, instead of days, because of the differences between calendrical systems regarding the time-of-day when one day ends and another begins. So each Calendar instance precomputes and caches the number of seconds required to convert a count of seconds since its epoch into a count of seconds since the epoch of the unification calendar (or to convert a count of seconds since the epoch of the unification calendar into a count of seconds since its own epoch.) Consequently, conversion either to or from a count of seconds since the initial moent of the epoch day of the unfication calendar and a count of seconds since the epoch day of any other calendar requires only a single addition or subtraction.

			To convert a date between two calendars, where neither is the unification calendar, requires an addition to convert the count of seconds since the epoch of the source date into a count of seconds since the epoch of the unification calendar, and then a subtraction to convert the count of seconds since the epoch of the unification calendar into a count of seconds since the epoch of the target calendar. If one of the calendars happens to be the unification calendar, then either the addition or subtraction will be omitted.

			Any implemented Calendar can be the unification calendar. The default unification calendar is the Gregorian Calendar--because that's the calendar most likely to be one of the calendars from or to which a date conversion operation will be performed. However, changing from one unification calendar to another is relatively trivial: It's simply a matter of changing the implementation of Calendar class>>unification, and then reinitializing all existing Calendar instances  Although this is not recommended for most situations, it is easy to do, and there might be special situations where it makes sense.

			In their book "Calendrical Calculations," Nachum Dershowitz and Edward Reingold define an inter-calendar conversion system that is essentially the same as the one that Chronos uses.  The only differences are that a) Dershowitz/Reingold define a system that is explicitlly and canonically based on the Gregorian Calendar; by contrast,  Chronos does not architecturally define any particular calendrical systrem as the canonical "unification calendar;" and b) Dershowitz/Reingold use ordinal numbers to count the days since the epoch of the Gregorian Calendar, whereas Chronos uses cardinal numbers.  In the Dershowitz/Reingold system 0001-01-01 Gregorian is day number 1 of the Gregorian epoch; by contrast, 0001-01-01 (regardless of calendar) is Chronos day 0 of the epoch of the calendar in question. 

			Dershowitz/Reingold call a date specified as the ordinal count of days since the epoch of the Gregorian Calendar a "Rata Die date". "Rata Die" is Latin for "Day of Calculation."  To convert a "Rata Die" (R.D.) date into a Chronos count of the days since the Gregorian epoch, subtract 1 day. To convert a Chronos count of the days since the Gregorian epoch into a "Rata Die" (R.D.) date, add 1 day.

			The method protocol 'API-unification' provides the fundamental date-conversion operations.  See the individual methods, and their comments, for complete details.

	Motivation:

		The Calendar class hierarchy separates the responsiblity of performing calendrical calculations from the responsibility of representing a particular date designation.  It also enables objects that represent date designations to use Calendar instances as Strategy objects, so that the same date and/or timepoint class can be used for dates in any calendrical system.

	Implementation:

		Instance Variables

			clock 										<CalendarClock>		Provides current date & time--see CalendarClock.
			yearNumberingPolicy 						<NumberingPolicy>		Provides policy for dealing with the year-numbering conventions 
																				of the calendrical system implemented by the instance ("What's 
																				the number of the year immediately preceding the year 1?"; "Are 
																				years counted from 1 (ordinal numbering,) or from zero (cardinal 
																				numbering, as in the Hindu Calendars)?".)
			secondsSinceUnificationEpochUpToEpoch 	<Integer>				Count of the number of seconds from the epoch of the unification
																				calendar up to the epoch date of the calendrical system 
																				implemented by the instance.
			secondsSinceJulianDayEpochUpToEpoch 	<Integer>				Count of the number of seconds from Julian Day Zero up to the
																				epoch date of the calendrical system implemented by the instance.
			minDaysPerYear 							<Integer>				Least number of days in any year of the calendrical system 
																				implemented by the instance.
			maxDaysPerYear 							<Integer>				Most number of days in any year of the calendrical system 
																				implemented by the instance.
			minMonthsPerYear 							<Integer>				Least number of months in any year of the calendrical system 
																				implemented by the instance.
			maxMonthsPerYear 							<Integer>				Most number of months in any year of the calendrical system 
																				implemented by the instance.
			minDaysPerMonth 							<Integer>				Least number of days in any month of any year of the calendrical 
																				system implemented by the instance.
			maxDaysPerMonth 							<Integer>				Most number of days in any month of any year of the calendrical 
																				system implemented by the instance.
			monthOrdinalRangeConstraint 				<RangeConstraint>		The range constraint for month ordinals for any year in the 
																				calendrical system implemented by the instance (the range may
																				include month ordinals that are not valid in some years.)
			dayOfMonthOrdinalRangeConstraint 			<RangeConstraint>		The range constraint for day-of-month ordinals for any month in any
																				year in the calendrical system implemented by the instance (the 
																				range may include day-of-month ordinals that are not valid fpr some
																				months and/or for some months in some years.)
			dayOfYearOrdinalRangeConstraint 			<RangeConstraint>		The range constraint for day-of-year ordinals for any year in the 
																				calendrical system implemented by the instance (the range may
																				include day-of-year ordinals that are not valid in some years.)
			daysSinceStartOfYearRangeConstraint 		<RangeConstraint>		The range constraint for day-of-year cardinals for any year in the 
																				calendrical system implemented by the instance (the range may
																				include day-of-year cardinals that are not valid in some years.)

	Subclassing:

		Concrete subclasses must subimplement the class method #registrationKey.

		The fundamental instance methods that must be subimplemented by a concrete subclasss are (see the method comment for the functional specification):

			Message Selector												Implementation notes

			#daysSinceEpochUpToYear:
			#forDaysSinceEpoch:setYearAndCalendarDayInto:				"Brute force" implementation is provided by Calendar, but it will be extremely slow.
			#forMonthsSinceEpoch:setYearAndMonthsSinceStartOfYearInto:	"Brute force" implementation is provided by Calendar, but it will be extremely slow.
			#typeCodeOfYear:
			#computeSecondsSinceJulianDayEpochUpToEpoch				Required for both intercalendar conversion and for Julian Day functionality

		The auxilliary instance methods that must be subimplemented by a concrete subclasss are (see the method comment for the functional specification)::

			Message Selector												

			#calendarDayFromDayOfYearOrdinalforYearTypeCode:
			#calendarDayFromMonth:day:forYearTypeCode:
			#daysInMonth:forYearTypeCode:
			#daysInYearForYearTypeCode:
			#daysUpToMonth:day:forYearTypeCode:
			#maximumDayOfYearOrdinalForMonth:day:
			#maximumDayOfYearOrdinalForMonthWithKey:day:
			#maximumDaysInMonth:
			#maximumDaysInMonthWithKey:
			#minimumDayOfYearOrdinalForMonth:day:
			#minimumDayOfYearOrdinalForMonthWithKey:day:
			#minimumDaysInMonth:
			#minimumDaysInMonthWithKey:
			#monthKeyForMonthAt:forYearTypeCode: 
			#monthOrdinalForMonthWithKey:forYearTypeCode: 
			#monthsInYearForYearTypeCode:
			#monthsSinceEpochUpToYear:
			#yearlyCalendarForYearTypeCode:
	
		Other instance methods may need to be subimplemented in those cases where the default implementation provided by Calendar is not correct.  Likely candidates would include:

			#ansiDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal:
			#canonicalDayOfWeekOrdinalFromANSIDayOfWeekOrdinal:
			#canonicalDayOfWeekOrdinalFromISODayOfWeekOrdinal:
			#computeDaysSinceStartOfWeekForEpochDay
			#eraNameForYear: 
			#isoDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal:
			#secondsSinceMidnightFromSecondsSinceStartOfDay:
			#secondsSinceStartOfDayFromSecondsSinceMidnight:
			#timeOfDayClockStartsAtStartOfDay
			
!

Calendar class
	instanceVariableNames: 'yearNumberingPolicy'!

!Calendar class methodsFor: 'queries' stamp: ''!
allRegisteredKeys
	"Answer the registrationKeys (semantic keys) for all implemented, resident Calendars."

	^self classRegistry keys! !

!Calendar class methodsFor: 'accessing' stamp: ''!
ansiStandard
	"Answer the Calendar that implements the calendrical system required for the implementation of DateAndTime objects, as specified by the ANSI Smalltalk standard. Specifically, answer the Calendar that implements the Gregorian Calendar using Astronomical Year Numbering (i.e., that uses an OrdinalNumberingPolicy as its yearNumberingPolicy.)"

	^self gregorian! !

!Calendar class methodsFor: 'converting' stamp: ''!
asCalendar
	"Answer the Calendar represented by the receiver.  If the receiver is a Calendar instance, answer the receiver.  If the receiver is a Calendar class, answer its canonical instance.  If the receiver is an indirect reference to a calendrical system, answer the canonical Calendar instance that implements that calendrical system."

	^self canonical! !

!Calendar class methodsFor: 'accessing' stamp: ''!
at: registrationKey
	"Answer the canonical Calendar instance whose registration key (semantic key) is <registrationKey>. If none, raise an Exception."

	^self at: registrationKey asSymbol ifAbsent: [self signalError: 'No Calendar found with key=', registrationKey printString]! !

!Calendar class methodsFor: 'accessing' stamp: ''!
at: registrationKey ifAbsent: missing
	"Answer the canonical Calendar instance whose registration key (semantic key) is <registrationKey>. If none, answer the result of evaluating the zero-argument block <missing>."

	| calendar |
	calendar := self instanceRegistry at: registrationKey ifAbsent: [0].
	(calendar == nil or: [calendar = 0]) ifFalse: [^calendar].
	^(self classRegistry at: registrationKey ifAbsent: [^missing value]) new register! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
basicDaysSinceEpochUpToYearVerifier
	^[:calendar :year | 
	| passes |
	passes := false.
	calendar 
		forDaysSinceEpoch: (calendar daysSinceEpochUpToYear: year)
		setYearAndCalendarDayInto: 
			[:computedYear :calendarDay | 
			passes := year = computedYear and: [calendarDay daysSinceStartOfYear = 0]].
	passes]! !

!Calendar class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self canonical! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
basicForDaysSinceEpochSetYearAndCalendarDayIntoVerifier
	^[:calendar :daysSinceEpoch | 
	| passes |
	passes := false.
	calendar 
		forDaysSinceEpoch: daysSinceEpoch
		setYearAndCalendarDayInto: 
			[:year :calendarDay | 
			passes := 
				(calendar 
					daysSinceEpochUpToMonth: calendarDay month
					day: calendarDay dayOfMonth
					inYear: year) = daysSinceEpoch.
			passes ifFalse: [nil halt]].
	passes]! !

!Calendar class methodsFor: 'class initialization' stamp: ''!
basicInvalidate

	self register.
	self allInstancesDo: [:instance | [instance invalidate] on: Error do: [:ex | self reportToConsole: ex description]].! !

!Calendar class methodsFor: 'class initialization' stamp: ''!
basicInvalidateClock
	"Ensure that the CalendarClock of all Calendar instances is the correct implmentation for the current system environment."

	self allInstancesDo: [:instance | instance invalidateClock].! !

!Calendar class methodsFor: 'accessing' stamp: ''!
canonical
	"Answer the canonical instance of the receiver."

	^self at: self registrationKey
		ifAbsent: 
			[(self registrationKey == nil or: [self isObsolete]) 
				ifFalse: 
					[self register.
					self canonical]]! !

!Calendar class methodsFor: 'private' stamp: ''!
classRegistry
	"Answer the registry used to associate the semantic key that identifies a particular calendrical system with the concrete subclass of Calendar that implements that calendrical system."

	ClassRegistry == nil ifTrue: [ClassRegistry := self newClassRegistry].
	^ClassRegistry! !

!Calendar class methodsFor: 'accessing' stamp: ''!
clock
	"Answer the CalendarClock associated with the canonical instance of the receiver."

	^self canonical clock! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToMonthDayInYearPassesVerification
	^self daysSinceEpochUpToMonthDayInYearVerifier value: self canonical! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToMonthDayInYearVerifier
	^[:calendar |
		(self daysSinceEpochUpToYearVerifier value: calendar)
			and: [self daysUpToMonthDayInYearVerifier value: calendar]]! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToYearPassesVerification
	^self daysSinceEpochUpToYearVerifier value: self canonical! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToYearVerifier
	"{Calendar daysSinceEpochUpToYearVerifier value: Calendar gregorian}"

	^[:calendar | 
	| passes |
	passes := true.
	self minVerificationYearCardinal to: self maxVerificationYearCardinal
		do: 
			[:cardinalYear | 
			| yearPasses |
			yearPasses := self basicDaysSinceEpochUpToYearVerifier value: calendar value: (self yearNumberingPolicy canonicalFromCardinal: cardinalYear).
			passes := passes and: [yearPasses]].
	passes].! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
daysUpToMonthDayInYearPassesVerification
	^self daysUpToMonthDayInYearVerifier value: self canonical! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
daysUpToMonthDayInYearVerifier
	"VERIFICATION:
		{Calendar daysUpToMonthDayInYearVerifier value: Calendar gregorian}"

	^[:calendar | 
	| exceptions |
	exceptions := OrderedCollection new.
	self minVerificationYearCardinal to: self maxVerificationYearCardinal
		do: 
			[:cardinalYear | 
			| canonicalYear daysUpToEndOfPrevMonth |
			canonicalYear := calendar yearNumberingPolicy canonicalFromCardinal: cardinalYear.
			daysUpToEndOfPrevMonth := 0.
			1 to: (calendar monthsInYear: canonicalYear)
				do: 
					[:monthOrdinal | 
					| daysInMonth |
					(calendar daysUpToMonth: monthOrdinal day: 1 inYear: canonicalYear) = daysUpToEndOfPrevMonth 
						ifFalse: [exceptions add: monthOrdinal -> #firstDayOfMonth].
					daysInMonth := calendar daysInMonth: monthOrdinal inYear: canonicalYear.
					(calendar daysUpToMonth: monthOrdinal day: daysInMonth inYear: canonicalYear) = (daysUpToEndOfPrevMonth + daysInMonth - 1) 
						ifFalse: [exceptions add: monthOrdinal -> #lastDayOfMonth].
					daysUpToEndOfPrevMonth := daysUpToEndOfPrevMonth + daysInMonth]].
	exceptions isEmpty]! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
forDaysSinceEpochSetYearAndCalendarDayIntoPassesVerification

	^self forDaysSinceEpochSetYearAndCalendarDayIntoVerifier value: self canonical! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
forDaysSinceEpochSetYearAndCalendarDayIntoVerifier
	^[:calendar | 
	| passes daysSinceEpoch daysInPrevYear |
	passes := true.
	daysSinceEpoch := nil.
	daysInPrevYear := 0.
	self minVerificationYearCardinal to: self maxVerificationYearCardinal
		do: 
			[:cardinalYear | 
			| canonicalYear |
			canonicalYear := self yearNumberingPolicy canonicalFromCardinal: cardinalYear.
			daysSinceEpoch := daysSinceEpoch == nil
				ifTrue: [calendar daysSinceEpochUpToYear: canonicalYear]
				ifFalse: [daysSinceEpoch + daysInPrevYear].
			daysInPrevYear := 0.
			1 to: (calendar monthsInYear: canonicalYear)
				do: 
					[:monthOrdinal | 
					| daysInMonth firstDayOfMonthPasses lastDayOfMonthPasses |
					
					firstDayOfMonthPasses := 
						self basicForDaysSinceEpochSetYearAndCalendarDayIntoVerifier 
							value: calendar value: daysSinceEpoch. "First day of month"
					daysInMonth := calendar daysInMonth: monthOrdinal inYear: canonicalYear.
					daysInPrevYear := daysInPrevYear + daysInMonth.
					daysSinceEpoch := daysSinceEpoch + daysInMonth.
					lastDayOfMonthPasses := 
						self basicForDaysSinceEpochSetYearAndCalendarDayIntoVerifier 
							value: calendar value: daysSinceEpoch - 1. "Last day of month"
					passes := passes and: [firstDayOfMonthPasses and: [lastDayOfMonthPasses]]]].
	passes].! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
fundamentalAlgorithmsPassVerification
	"{GregorianCalendar fundamentalAlgorithmsPassVerification}
	{JulianCalendar fundamentalAlgorithmsPassVerification}
	{ImperialJulianCalendar fundamentalAlgorithmsPassVerification}
	{DurationFactory toRun: [10 timesRepeat: [GregorianCalendar fundamentalAlgorithmsPassVerification]]}"

	^self daysSinceEpochUpToMonthDayInYearPassesVerification
		and: [self forDaysSinceEpochSetYearAndCalendarDayIntoPassesVerification]! !

!Calendar class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 10:32'!
gregorian
	"Answer the Calendar object that implements the Gregorian Calendar using Astronomical Year Numbering (i.e., that uses an OrdinalNumberingPolicy as its yearNumberingPolicy.)"

	(Gregorian == nil)
		ifTrue: 
			[^GregorianCalendar rebindCanonicalInstance].
	^Gregorian! !

!Calendar class methodsFor: 'class initialization' stamp: 'PaulDeBruicker 3/9/2011 10:42'!
initializeCalendarConstants
	"Calendar initializeCalendarConstants"

	InstanceRegistry := nil.
	(Gregorian == nil)
		ifFalse: [ Gregorian release ].
	(Julian == nil)
		ifFalse: [ Julian release ].
	ClassRegistry := nil.
	self registerAll.
	GregorianCalendar rebindCanonicalInstance.
	JulianCalendar rebindCanonicalInstance! !

!Calendar class methodsFor: 'private' stamp: ''!
instanceRegistry
	"Answer the registry used to associate the semantic key that identifies a particular calendrical system with the canonical instance of the subclass of Calendar that implements that calendrical system."

	InstanceRegistry == nil 
		ifTrue: [InstanceRegistry := self newInstanceRegistry].
	^InstanceRegistry! !

!Calendar class methodsFor: 'class initialization' stamp: ''!
invalidate

	self basicInvalidate.
	self subclasses do: [:each | each invalidate]! !

!Calendar class methodsFor: 'class initialization' stamp: ''!
invalidateClock
	"Ensure that the CalendarClock of all Calendar instances is the correct implmentation for the current system environment."

	self basicInvalidateClock.
	self subclasses do: [:each | each invalidateClock]! !

!Calendar class methodsFor: 'testing' stamp: ''!
isAbstract
	^self registrationKey == nil! !

!Calendar class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 10:40'!
julian
	"Answer the Calendar object that implements the Julian Calendar as first defined and used by Dionysius Exiguus."

	(Julian == nil)
		ifTrue: 
			[^JulianCalendar rebindCanonicalInstance].
	^Julian! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
maxVerificationYearCardinal
	^2500! !

!Calendar class methodsFor: 'functional verification' stamp: ''!
minVerificationYearCardinal
	^-2500! !

!Calendar class methodsFor: 'fundamental algorithms' stamp: ''!
monthsInYear: year 
	"Answer the number of months there are in the given <year>."

	^self canonical monthsInYear: year! !

!Calendar class methodsFor: 'fundamental algorithms' stamp: ''!
monthsInYearForYearTypeCode: yearTypeCode 
	"Answer the number of months there are per year, in a year whose typeCode is <yearTypeCode>."

	^self canonical monthsInYearForYearTypeCode: yearTypeCode! !

!Calendar class methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 10:43'!
newCardinalYearNumberingPolicy
	"Answer a new CardinalNumberingPolicy to be used as the the policy for interpreting year numbers in the calendrical system implemented by instances of the receiver. Using a CardinalNumberingPolicy as the year numbering policy of a calendar is precisely equivalent to what is sometimes called 'Elapsed Year Numbering' or 'Expired Year Numbering'--commonly used by the various Hindu Calendars."

	^(CardinalNumberingPolicy )
		semanticKey: #year
		zeroInvalidMessage: 'This error should not have occurred.'! !

!Calendar class methodsFor: 'private' stamp: ''!
newClassRegistry
	"Answer a new Dictionary-like object to be used as the registry by which a semantic key that identifies a particular calendrical system is associated with the concrete subclass of Calendar that implements that calendrical system."

	^EnvironmentFacade current newWeakDictionary! !

!Calendar class methodsFor: 'private' stamp: ''!
newDefaultYearNumberingPolicy
	"Answer a new NumberingPolicy to be used as the the policy for interpreting year numbers in the calendrical system implemented by instances of the receiver. NOTE: The ANSI Smalltalk standard REQUIRES the use of 'Astronomical Year Numbering' (i.e., an OrdinalNumberingPolicy) for dates in the Gregorian calendar. The ISO 8601 standard imposes the same requirement."

	^self newOrdinalYearNumberingPolicy! !

!Calendar class methodsFor: 'private' stamp: ''!
newInstanceRegistry
	"Answer a new Dictionary-like object to be used as the registry by which a semantic key that identifies a particular calendrical system is associated with the canonical instance of the concrete subclass of Calendar that implements that calendrical system."

	^EnvironmentFacade current newWeakDictionary! !

!Calendar class methodsFor: 'private' stamp: ''!
newOrdinalYearNumberingPolicy
	"Answer a new OrdinalNumberingPolicy to be used as the the policy for interpreting year numbers in the calendrical system implemented by instances of the receiver. Using an OrdinalNumberingPolicy as the year numbering policy of a calendar implements the year-numbering convention sometimes called 'Astronomical Year Numbering.' The ANSI Smalltalk standard REQUIRES the use of 'Astronomical Year Numbering' (i.e., an OrdinalNumberingPolicy) for dates in the Gregorian calendar. The ISO 8601 standard imposes the same requirement."

	^OrdinalNumberingPolicy 
		semanticKey: #year
		zeroInvalidMessage: 'This error should not have occurred'.! !

!Calendar class methodsFor: 'private' stamp: ''!
newZerolessOrdinalYearNumberingPolicy
	"Answer a new ZerolessOrdinalNumberingPolicy to be used as the the policy for interpreting year numbers in the calendrical system implemented by instances of the receiver. Using a ZerolessOrdinalNumberingPolicy as the year numbering policy of a calendar implements the convention traditionally used to number years in most calendrical systems, such as the Julian Calendar."

	^ZerolessOrdinalNumberingPolicy 
		semanticKey: #year
		zeroInvalidMessage: 'The year zero does not exist in the ', self name, ' calendar, which uses a zero-less (traditional, non-astronimical) year numbering system.'! !

!Calendar class methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 10:43'!
rebindCanonicalInstance
	self register.

	InstanceRegistry == nil 
		ifFalse: [InstanceRegistry removeKey: self registrationKey ifAbsent: [	]].
	
	^self at: self registrationKey! !

!Calendar class methodsFor: 'accessing' stamp: ''!
referencedBy: aCalendarOrCalendarRegistrationKey 
	"Anser the value referenced by <aCalendarOrCalendarRegistrationKey>. If the value is a key, answer the value bound to the key. Otherwise, answer aCalendarOrCalendarRegistrationKey itself."

	^aCalendarOrCalendarRegistrationKey == nil 
		ifTrue: [AnsiStandardCalendar]
		ifFalse: 
			[aCalendarOrCalendarRegistrationKey isString 
				ifTrue: [self at: aCalendarOrCalendarRegistrationKey]
				ifFalse: [aCalendarOrCalendarRegistrationKey asCalendar]]! !

!Calendar class methodsFor: 'class initialization' stamp: ''!
register
	| key |
	key := self registrationKey.
	(key == nil or: [self isAbstract]) 
		ifFalse: [self classRegistry at: key put: self].! !

!Calendar class methodsFor: 'class initialization' stamp: ''!
registerAll
	self register.
	self subclasses do: [:each | each registerAll]! !

!Calendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by instances of the receiver."

	^nil! !

!Calendar class methodsFor: 'class initialization' stamp: ''!
release
	self allInstancesDo: [:each | each release].
	ClassRegistry == nil 
		ifFalse: [ClassRegistry removeKey: self registrationKey ifAbsent: []]! !

!Calendar class methodsFor: 'fundamental algorithms' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^self canonical typeCodeOfYear: calendarYear! !

!Calendar class methodsFor: 'accessing' stamp: ''!
unification
	"Answer the 'unification calendar'--the Calendar used to unify the all the calendars implemented by concrete subclasses of Calendar, so that it is possible to interconvert dates between calendrical systems."

	^self gregorian! !

!Calendar class methodsFor: 'accessing' stamp: ''!
yearNumberingPolicy
	"Answer the instance of the concrete subclass of NumberingPolicy that implements the year-numbering policy of the calendrical system represented by instances of the receiver."

	yearNumberingPolicy == nil ifTrue: [yearNumberingPolicy := self newDefaultYearNumberingPolicy].
	^yearNumberingPolicy! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
ansiDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal: canonicalDayOfWeekOrdinal
	"Answer the ANSI day-of-week ordinal that corresponds to the canonical day-of-week ordinal <canonicalDayOfWeekOrdinal>."

	"{Calendar gregorian ansiDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal: 1}"
	"{Calendar gregorian ansiDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal: 7}"

	^canonicalDayOfWeekOrdinal! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
ansiDayOfWeekOrdinalFromDaysSinceEpoch: daysSinceEpoch
	"Answer the ordinal number of the day of the week of the day that is <daysSinceEpoch> days from the receiver's epoch. Use the ANSI Smalltalk numbering convention, where Sunday=1 and Saturday=7."

	^(self daysSinceStartOfANSIWeekFromDaysSinceEpoch: daysSinceEpoch) + 1! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
ansiDayOfWeekOrdinalFromISODayOfWeekOrdinal: isoDayOfWeekOrdinal
	"Answer the ANSI day-of-week ordinal that corresponds to the ISO 8601 day-of-week ordinal <isoDayOfWeekOrdinal>."

	"{Calendar gregorian ansiDayOfWeekOrdinalFromISODayOfWeekOrdinal: 1}"
	"{Calendar gregorian ansiDayOfWeekOrdinalFromISODayOfWeekOrdinal: 7}"

	^(isoDayOfWeekOrdinal \\ DaysPerWeek) + 1! !

!Calendar methodsFor: 'converting' stamp: ''!
asCalendar
	"Answer the Calendar represented by the receiver.  If the receiver is a Calendar instance, answer the receiver.  If the receiver is a Calendar class, answer its canonical instance.  If the receiver is an indirect reference to a calendrical system, answer the canonical Calendar instance that implements that calendrical system."

	^self! !

!Calendar methodsFor: 'API-validation' stamp: ''!
assertIsGregorian
	"If the calendrical system implemented by the receiver is not the Gregorian calendar, signal an Exception."

	self signalError:  'It is required that I must be a Gregorian Calendar.'! !

!Calendar methodsFor: 'API-validation' stamp: ''!
assertIsJulian
	"If the calendrical system implemented by the receiver is not the Julian calendar, signal an Exception."

	self signalError:  'It is required that I must be a Julian Calendar.'! !

!Calendar methodsFor: 'API-validation' stamp: ''!
assertValidDayOfYear: dayOfYear
	"If the <dayOfYear> parameter could not possibly be a valid value in the calendrical system implemented by the receiver, regardless of year, signal an Exception."

	dayOfYear < 1 ifTrue: [self signalInvalidArgument: #dayOfYear value: dayOfYear].
	dayOfYear > maxDaysPerYear ifTrue: [self signalInvalidArgument: #dayOfYear value: dayOfYear].! !

!Calendar methodsFor: 'API-validation' stamp: ''!
assertValidDaysSinceStartOfYear: daySinceStartOfYear
	"If the <daySinceStartOfYear> parameter could not possibly be a valid value in the calendrical system implemented by the receiver, regardless of year, signal an Exception."

	daySinceStartOfYear < 0 ifTrue: [self signalInvalidArgument: #daySinceStartOfYear value: daySinceStartOfYear].
	daySinceStartOfYear >= maxDaysPerYear ifTrue: [self signalInvalidArgument: #daySinceStartOfYear value: daySinceStartOfYear].! !

!Calendar methodsFor: 'API-validation' stamp: ''!
assertValidMonth: monthOrdinal day: dayOfMonth
	"If either or both the <monthOrdinal> and <dayOfMonth> parameters could not possibly be valid values in the calendrical system implemented by the receiver, regardless of year, signal an Exception."

	monthOrdinal < 1 ifTrue: [self signalInvalidArgument: #month value: monthOrdinal].
	monthOrdinal > maxMonthsPerYear ifTrue: [self signalInvalidArgument: #month value: monthOrdinal].

	dayOfMonth < 1 ifTrue: [self signalInvalidArgument: #dayOfMonth value: dayOfMonth].
	dayOfMonth > (self maximumDaysInMonth: monthOrdinal) ifTrue: [self signalInvalidArgument: #dayOfMonth value: dayOfMonth].! !

!Calendar methodsFor: 'private' stamp: ''!
basicNewCalendarClock
	"Answer a new CalendarClock for use by the receiver as its canonical CalendarClock."

	^ChronosSystemClock current newCalendarClock! !

!Calendar methodsFor: 'private' stamp: ''!
bindToClock
	"Perforn any necessary configuration or set up so that the receiver's <clock> can properly operate as the receiver's canonocal CalendarClock."

	"By default, do nothing"! !

!Calendar methodsFor: 'private' stamp: ''!
bindToSystem
	"Make the receiver and other sytem objects collaborate with each other, as required by the overall system architecture."

	self initializeReferenceTimes.
	self invalidateClock! !

!Calendar methodsFor: 'API-CalendarPeriods' stamp: ''!
calendarDayFromDayOfYearOrdinal: dayOfYearOrdinal forYearTypeCode: yearTypeCode 
	"Answer the CalendarDay (which see) that represents the day of the year whose ordinal number is <dayOfYearOrdinal>, for any year whose year type code is <yearTypeCode>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-CalendarPeriods' stamp: ''!
calendarDayFromDayOfYearOrdinal: dayOfYearOrdinal inYear: year
	"Answer the CalendarDay (which see) that represents the day of the year whose ordinal number is <dayOfYearOrdinal> in the year <year>."

	^self calendarDayFromDayOfYearOrdinal: dayOfYearOrdinal forYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'API-CalendarPeriods' stamp: ''!
calendarDayFromMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode
	"Answer the CalendarDay (which see) that represents the month of the year whose ordinal is <monthOrdinal>, and the day of the month whose ordinal number is <dayOfMonthOrdinal>, for any year whose year type code is <yearTypeCode>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-CalendarPeriods' stamp: ''!
calendarDayFromMonth: monthOrdinal day: dayOfMonthOrdinal inYear: year
	"Answer the CalendarDay (which see) that represents the month of the year whose ordinal is <monthOrdinal>, and the day of the month whose ordinal number is <dayOfMonthOrdinal> in the year <year>."

	^self calendarDayFromMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'converting' stamp: ''!
canonical
	"Answer the instance of the receiver's class that is the canonical instance."

	| value |
	value := self class canonical.
	^value == nil ifTrue: [self] ifFalse: [value]! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
canonicalDayOfWeekOrdinalFromANSIDayOfWeekOrdinal: ansiDayOfWeekOrdinal
	"Answer the canonical day-of-week ordinal that corresponds to the ANSI day-of-week ordinal <ansiDayOfWeekOrdinal>."

	"{Calendar gregorian canonicalDayOfWeekOrdinalFromANSIDayOfWeekOrdinal: 1}"
	"{Calendar gregorian canonicalDayOfWeekOrdinalFromANSIDayOfWeekOrdinal: 7}"

	^ansiDayOfWeekOrdinal! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
canonicalDayOfWeekOrdinalFromISODayOfWeekOrdinal: isoDayOfWeekOrdinal
	"Answer the canonical day-of-week ordinal that corresponds to the ISO 8601 day-of-week ordinal <isoDayOfWeekOrdinal>."

	"{Calendar gregorian canonicalDayOfWeekOrdinalFromISODayOfWeekOrdinal: 1}"
	"{Calendar gregorian canonicalDayOfWeekOrdinalFromISODayOfWeekOrdinal: 7}"

	^(isoDayOfWeekOrdinal \\ DaysPerWeek) + 1! !

!Calendar methodsFor: 'accessing' stamp: ''!
clock
	"Answer the CalendarClock associated with the receiver."

	^clock! !

!Calendar methodsFor: 'private' stamp: ''!
computeDaysSinceStartOfWeekForEpochDay
	"Answer the zero-based cardinal of the day of the week of the receiver's epoch day--without using the value of the <daysSinceStartOfWeekForEpochDay> instance variable"

	^daysSinceStartOfANSIWeekForEpochDay! !

!Calendar methodsFor: 'private' stamp: ''!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	"Example 'de novo' calculation for the Gregorian Calendar:

		 {| uDays uSeconds |
		uDays := Gregorian 
					daysSinceEpochUpToMonth: 11
					day: 24
					inYear: -4713.
		uSeconds := uDays * 86400.
		uSeconds negated - Gregorian secondsSinceStartOfDayAtStartOfJulianDay}"

	"Example 'de novo' calculation for the Hebrew Calendar:

		 {| uDays uSeconds |
		uDays := HebrewCalendar canonical
					daysSinceEpochUpToMonth: 4
					day: 20
					inYear: -952.
		uSeconds := uDays * 86400.
		uSeconds negated - HebrewCalendar canonical secondsSinceStartOfDayAtStartOfJulianDay}"


	self subclassResponsibility! !

!Calendar methodsFor: 'API-Date Construction' stamp: ''!
dateSpecFromDaysSinceEpoch: daysSinceEpoch 
	"Answer an instance of DateSpec that specifies a year/month/day that is daysSinceEpoch days since my Epoch."

	^self 
		forDaysSinceEpoch: daysSinceEpoch 
		setYearAndCalendarDayInto: DateSpec basicNew! !

!Calendar methodsFor: 'accessing' stamp: ''!
dayOfMonthOrdinalRangeConstraint
	"Answer the RangeConstraint that implements the range constraint for the valid values of dayOfMonth ordinals in the calendrical system represented by the receiver (taking all months and year-types into account.)"

	^dayOfMonthOrdinalRangeConstraint! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
dayOfWeekOrdinalFromDaysSinceEpoch: daysSinceEpoch
	"Answer the ordinal number of the day of the week of the day that is <daysSinceEpoch> days from the receiver's epoch. Use whatever numbering convention for days of the week that would be canonically used by the culture that is the principal user of the calendrical system implemented by the receiver.."

	^(self daysSinceStartOfWeekFromDaysSinceEpoch: daysSinceEpoch) + 1! !

!Calendar methodsFor: 'accessing' stamp: ''!
dayOfYearOrdinalRangeConstraint
	"Answer the RangeConstraint that implements the range constraint for the valid values of dayOfYear ordinals in the calendrical system represented by the receiver (taking all year-types into account.)"

	^dayOfYearOrdinalRangeConstraint! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
daysInMonth: monthOrdinal forYearTypeCode: yearTypeCode
	"Answer the number of days in the month whose ordinal is <monthOrdinal>, in a year whose typeCode is <yearTypeCode>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
daysInMonth: monthOrdinal inYear: year
	"Answer the number of days in the month whose ordinal is <monthOrdinal>, in the given <year>."

	^self daysInMonth: monthOrdinal forYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'API-queries-years' stamp: ''!
daysInYear: year
	"Answer the number of days in the given <year>."

	^self daysInYearForYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'API-queries-years' stamp: ''!
daysInYearForYearTypeCode: yearTypeCode
	"Answer the number of days per year there are in a year whose type is identified by the code <yearTypeCode>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-InterCalendar' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
daysSinceEpochFromForeignDaysSinceEpoch: foreignDaysSinceEpoch convertingFrom: aForeignCalendar 
	"Answer the number of days since the epoch of the receiver's calendar, converted from <foreignDaysSinceEpoch> days since the epoch of the Calendar <aForeignCalendar>."

	^(self 
		secondsSinceEpochFromForeignSecondsSinceEpoch: 
			(foreignDaysSinceEpoch * SecondsPerDay + (aForeignCalendar secondsSinceStartOfDayAtStartOfJulianDay))
		convertingFrom: aForeignCalendar) - (self secondsSinceStartOfDayAtStartOfJulianDay)  // SecondsPerDay! !

!Calendar methodsFor: 'API-Julian Days' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
daysSinceEpochFromJulianDay: julianDay
	"Answer the number of days since the epoch of the receiver's calendar that corresponds to the day whose Julian Astronomical Day Number is <julianDay>. Correspondence rule: The day in the receiver's count of days since the epoch that contains the starting moment of Julian Day J is the one that corresponds to Julian Day J.  Julian Days start at Noon--because astronomers work at night."

	^(self secondsSinceEpochFromJulianDay: julianDay) // SecondsPerDay! !

!Calendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear 
	"Answer the number of days since the receiver's epoch up to (but not including) the <dayOfMonthOrdinal>th day of the <monthOrdinal>th month of the given <calendarYear>.  By definition, the answer when <calendarYear> = 1 (assuming positve years are ordinal numbers,) <monthOrdinal> = 1 and <dayOfMonthOrdinal> = 1 must be zero."

	^(self daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear)
		+ (self daysSinceEpochUpToYear: calendarYear)! !

!Calendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: ordinalYearNumber 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
daysSinceStartOfANSIWeekForEpochDay
	"Answer the zero-based day-of-week index of the first day of the epoch (ANSI Smalltalk standard cardinal, where Sunday=0 and Saturday=6)."

	^daysSinceStartOfANSIWeekForEpochDay! !

!Calendar methodsFor: 'API-Day of week' stamp: 'PaulDeBruicker 3/9/2011 14:57'!
daysSinceStartOfANSIWeekFromDaysSinceEpoch: daysSinceEpoch
	"Answer the cardinal number of the day of the week of the day that is <daysSinceEpoch> days from the receiver's epoch. Use the ANSI Smalltalk numbering convention, where Sunday=0 and Saturday=6."

	^daysSinceEpoch + daysSinceStartOfANSIWeekForEpochDay \\ DaysPerWeek! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
daysSinceStartOfISOWeekForEpochDay
	"Answer the zero-based day-of-week index of the first day of the epoch (ISO 8601 standard cardinal, where Monday=0 and Sunday=6)."

	^daysSinceStartOfISOWeekForEpochDay! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
daysSinceStartOfISOWeekFromDaysSinceEpoch: daysSinceEpoch
	"Answer the cardinal number of the day of the week of the day that is <daysSinceEpoch> days from the receiver's epoch. Use the ISO 8601 numbering convention, where Monday=0 and Sunday=6."

	^daysSinceEpoch + daysSinceStartOfISOWeekForEpochDay \\ DaysPerWeek! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
daysSinceStartOfWeekForEpochDay
	"Answer the zero-based day-of-week index of the receiver's epoch day."

	^daysSinceStartOfWeekForEpochDay! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
daysSinceStartOfWeekFromDaysSinceEpoch: daysSinceEpoch
	"Answer the cardinal number of the day of the week of the day that is <daysSinceEpoch> days from the receiver's epoch"

	^daysSinceEpoch + daysSinceStartOfWeekForEpochDay \\ DaysPerWeek! !

!Calendar methodsFor: 'accessing' stamp: ''!
daysSinceStartOfYearRangeConstraint
	"Answer the RangeConstraint that implements the range constraint for the valid values of daysSinceStartOfYear (dayOfYear cardinal numbers) in the calendrical system represented by the receiver (taking all year-types into account.)"

	^daysSinceStartOfYearRangeConstraint! !

!Calendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	^self daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: (self typeCodeOfYear: calendarYear)! !

!Calendar methodsFor: 'accessing' stamp: ''!
defaultLocale
	"Answer the ChronosLocale to be used by default for printing (or parsing) dates in the calendrical system repersented by the receiver."

	^ChronosLocale default! !

!Calendar methodsFor: 'accessing' stamp: ''!
defaultTimeZone
	^ChronosTimezone default! !

!Calendar methodsFor: 'API-testing' stamp: ''!
doMonthKeysAlwaysCorrespondToTheSameMonthNameKey
	"If the mapping between month keys and month name keys is invariant for all years, answer true.  Otherwise, answer false."

	^doMonthKeysAlwaysCorrespondToTheSameMonthNameKey! !

!Calendar methodsFor: 'API-testing' stamp: ''!
doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey
	"If the mapping between month ordinals and month keys is invariant for all years, answer true.  Otherwise, answer false."

	^monthOrdinalsAlwaysCorrespondToTheSameMonthKey! !

!Calendar methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self registrationKey! !

!Calendar methodsFor: 'API-queries-years' stamp: ''!
eraNameForYear: calendarYear
	"Answer the abbreviation of the name of the era to which <calendarYear> belongs.  The name of an era identifies the epoch date of a calendrical system and/or the calendrical system itself (although it may do so ambiguously.) The era name may also identify whether or not the <calendarYear> occurs before or after the epoch date."

	^(yearNumberingPolicy cardinalFromCanonical: calendarYear) >= 0
		ifTrue: [self defaultLocale properNameAtSemanticKey: (self registrationKey, #'-era-postEpoch') asSymbol] 
		ifFalse: [self defaultLocale properNameAtSemanticKey: (self registrationKey, #'-era-preEpoch') asSymbol]! !

!Calendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearMonthDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	^self 
		startingWithYear: (yearNumberingPolicy canonicalFromCardinal: 0)
		addingDays: daysSinceEpoch
		setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2! !

!Calendar methodsFor: 'API-Date Construction' stamp: ''!
forMonthsSinceEpoch: monthsSinceEpoch setYearAndMonthsSinceStartOfYearInto: block2 
	"For a year and months-since-start-of-year that is monthsSinceEpoch months since my Epoch, send #value:value: to <block2>, with the year as the first argument and the months-since-start-of-year as the second argument."

	^self 
		startingWithYear: (yearNumberingPolicy canonicalFromCardinal: 0)
		addingMonths: monthsSinceEpoch
		setYearAndMonthsSinceStartOfYearInto: block2! !

!Calendar methodsFor: 'API-InterCalendar' stamp: ''!
forSecondsSinceEpoch: secondsSinceEpoch canonicalCalendarAndSecondsSinceEpochDo: block2 ifSameCalendar: block0
	"For a timepoint that is <secondsSinceEpoch> seconds since the initial moment of the epoch day of the receiver's calendar, determine whether the receiver is the canonical calendar used by the culture that would be, or would have been, the principal users of the receiver's calendar. If so, answer the result of evaluating ther zero-argument block <block0>.  Otherwise, answer the result of evaluating the two-argument block <block2>, where the first block argument is the Calendar instance that is canonical for that culture at that moment in time, and where the second block argument is the number of seconds since the initial moment of the epoch day of the calendrical system represented by the first block argument."

	^block0 value! !

!Calendar methodsFor: 'API-queries-years' stamp: ''!
fullYearFromTwoDigitYear: twoDigitYear
	"Answer the best guess regarding the full year, in the context of a) the calendar represented by the receiver, b) the current year in the calendar represented by the receiver. See #fullYearFromTwoDigitYear:backwardBias: for more information.

	Examples:

		Two-digitYear		CurrentYear		FullYear

		00					2000			2000
		50					2000			1950
		37					2004			1937
		37					2005                 2037

	VERIFICATION:
						Normal cases												Abnormal cases
		Print it: {Calendar gregorian fullYearFromTwoDigitYear: 0} 		Print it: {Calendar gregorian fullYearFromTwoDigitYear: 100} 
		Print it: {Calendar gregorian fullYearFromTwoDigitYear: 25}	Print it: {Calendar gregorian fullYearFromTwoDigitYear: -1250}
		Print it: {Calendar gregorian fullYearFromTwoDigitYear: 50}	Print it: {Calendar gregorian fullYearFromTwoDigitYear: -150}
		Print it: {Calendar gregorian fullYearFromTwoDigitYear: 75}	Print it: {Calendar gregorian fullYearFromTwoDigitYear: 2525}
		Print it: {Calendar gregorian fullYearFromTwoDigitYear: 1999}	Print it: {Calendar gregorian fullYearFromTwoDigitYear: 972}

						All two-digit years:
		Inspect it: {(0 to: 99) collect: [:twoDigitYear | twoDigitYear -> (Calendar gregorian fullYearFromTwoDigitYear: twoDigitYear)]}"

	^self fullYearFromTwoDigitYear: twoDigitYear backwardBias: 67! !

!Calendar methodsFor: 'API-queries-years' stamp: ''!
fullYearFromTwoDigitYear: twoDigitYear backwardBias: backwardBias 
	"Answer the best guess regarding the full year, in the context of a) the calendar represented by the receiver, b) the current year in the calendar represented by the receiver, and c) the given <backwardBias>.  The <backwardBias> is the number of years back from the receiver's current year for which the receiver will assume that the 2 least significant digits of such years correspond to those of the given <twoDigitYear>. If <twoDigitYear> has more than two (base 10) digits, then the value answered will be <twoDigitYear>.

	NOTE: The algorithm works for negative years, and for years within 100 years of the calendar's Epoch.

	A <backwardBias> of zero results in all two-digit years being mapped to either the current year, or to one of the following 99 years. A <backwardBias> of 99 results in all two-digit years being mapped to either the current year, or to one of the preceding 99 years. A <backwardBias> of 'self clock thisYear - 1901' maps all two-digit years to the 20th century (of the receiver's calendar, of course--and assuming that the year 2000 is considered the final year of the 20th century, as is canoncial in the Gregorian and Julian calendars.) 

	The industry-recommended standard backward bias is 67 (regardless of calendar.)

	Examples:

		Two-digitYear		BackwardBias	CurrentYear		FullYear

		00								     0			2000			2000
		50								   49			2000			2050
		50								   50			2000			1950
		37								   67			2004			1937
		37								   67			2005			2037
		00								 100			2000			1900
		50								 100			2000			1950
		00								-100			2000			2100
		50								-100			2000			2150
		00								 200			2000			1800
		50								 200			2000			1850
		00								-200			2000			2200
		50								-200			2000			2250

	VERIFICATION:
		Inspect it: {(0 to: 99) collect: [:twoDigitYear | twoDigitYear -> (Calendar gregorian fullYearFromTwoDigitYear: twoDigitYear  backwardBias: 67)]}
		Inspect it: {(0 to: 99) collect: [:twoDigitYear | twoDigitYear -> (Calendar gregorian fullYearFromTwoDigitYear: twoDigitYear  backwardBias: -33)]}
		Inspect it: {(0 to: 99) collect: [:twoDigitYear | twoDigitYear -> (Calendar gregorian fullYearFromTwoDigitYear: twoDigitYear  backwardBias: 167)]}
		Inspect it: {(0 to: 99) collect: [:twoDigitYear | twoDigitYear -> (Calendar gregorian fullYearFromTwoDigitYear: twoDigitYear  backwardBias: Calendar gregorian clock thisYear - 1901)]}"

	"{(-199 to: 199) collect: [:twoDigitYear | twoDigitYear -> (Calendar gregorian fullYearFromTwoDigitYear: twoDigitYear  backwardBias: 2067)]}"
	"{(-199 to: 199) collect: [:twoDigitYear | twoDigitYear -> (Calendar gregorian fullYearFromTwoDigitYear: twoDigitYear  backwardBias: 2167)]}"

	| thisYear pivotYear pivotYearMod100 yearDelta tdy |
	twoDigitYear abs >= 100 
		ifTrue: 
			["<twoDigitYear> is the full year."
			^twoDigitYear].
	thisYear := self clock thisYear.
	yearDelta := twoDigitYear - thisYear.
	yearDelta abs < 100 "Perhaps the calendar epoch is within 100 years of the current year."
		ifTrue: 
			["<twoDigitYear> is the full year."
			^twoDigitYear].
	pivotYear := yearNumberingPolicy ordinalFromCanonical: thisYear - backwardBias.
	yearDelta := twoDigitYear - pivotYear.
	(yearDelta abs < 100 or: [twoDigitYear ~= 0 and: [pivotYear sign ~= twoDigitYear sign]]) "Perhaps the pivot year is within 100 years of the specified year."
		ifTrue: 
			["<twoDigitYear> is the full year in the context of the <backwardBias>."
			^yearNumberingPolicy canonicalFromOrdinal: pivotYear + yearDelta].
	"<twoDigitYear> is intended to be some year within 100 years of the current year."	
	pivotYearMod100 := pivotYear \\ 100. "Handle negative years"
	tdy := twoDigitYear \\ 100. "Handle negative years"
	yearDelta := tdy - pivotYearMod100.
	^yearNumberingPolicy 
		canonicalFromOrdinal: 
			(tdy >= pivotYearMod100 
				ifTrue: [pivotYear + yearDelta]
				ifFalse: [pivotYear + yearDelta + 100])! !

!Calendar methodsFor: 'API-InterCalendar' stamp: ''!
gregorianDateSpecFromDaysSinceEpoch: daysSinceEpoch 
	"Answer an instance of DateSpec that specifies a Gregorian year/month/day that is daysSinceEpoch days since my Epoch."

	^Gregorian 
		dateSpecFromDaysSinceEpoch: 
			(Gregorian 
				daysSinceEpochFromForeignDaysSinceEpoch: daysSinceEpoch convertingFrom: self)! !

!Calendar methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize the receiver so that it becomes fully functional as a Calendar object that implements a particular calenrdical system. Fail if the receiver is not mutable."

	self assertMutability.
	yearNumberingPolicy := self newDefaultYearNumberingPolicy.
	self initializeIntraYearValues.
	self initializeRangeConstraints.
	self bindToSystem.
	self beImmutable.! !

!Calendar methodsFor: 'private' stamp: ''!
initializeIntraYearValues
	"Initialize the instance variables of the receiver that specify or describe the properties and organizational structure of days-of-the-year, months and days-of-the-month in the calendrical system of the receiver."

	self assertMutability.
	minDaysPerYear  := 0.
	maxDaysPerYear  := 0.
	minMonthsPerYear  := 0.
	maxMonthsPerYear := 0.
	maxDaysPerMonth := 0.
	minDaysPerMonth := 0.
	monthOrdinalsAlwaysCorrespondToTheSameMonthKey := self isMonthsPerYearInvariant. "Subclasses may need to override."
	doMonthKeysAlwaysCorrespondToTheSameMonthNameKey := self isMonthsPerYearInvariant.  "Subclasses may need to override."
	self initializeMonthSemantics.! !

!Calendar methodsFor: 'private' stamp: ''!
initializeMonthSemantics
	"Initialize the instance variables of the receiver that specify the mappings/associations between month ordinals, month keys and month name keys."

	monthOrdinalsByMonthKey := Dictionary new.
	monthKeysByMonthOrdinal := Dictionary new.
	monthNameKeysByMonthKey := Dictionary new.
	monthKeyByMonthNameKey := Dictionary new.! !

!Calendar methodsFor: 'private' stamp: ''!
initializeRangeConstraints
	"Initialize the instance variables of the receiver that constrain the numerical range of days-of-the-year, months and days-of-the-month in the calendrical system of the receiver."

	self assertMutability.
	monthOrdinalRangeConstraint := 
		RangeConstraint 
			semanticKey: #month
			minValidValue: 1
			maxValidValue: self maxMonthsPerYear.
	dayOfMonthOrdinalRangeConstraint  := 
		RangeConstraint 
			semanticKey: #dayOfMonth
			minValidValue: 1
			maxValidValue: self maxDaysPerMonth.
	dayOfYearOrdinalRangeConstraint  := 
		RangeConstraint 
			semanticKey: #dayOfYear
			minValidValue: 1
			maxValidValue: self maxDaysPerYear.
	daysSinceStartOfYearRangeConstraint := 
		RangeConstraint 
			semanticKey: #daysSinceStartOfYear
			minValidValue: 0
			maxValidValue: self maxDaysPerYear - 1.! !

!Calendar methodsFor: 'private' stamp: ''!
initializeReferenceTimes
	"Initialize the instance variables of the receiver that store values used to convert between calendrical systems, or that otherwise serve to provide temporal reference points for interpreting dates in the receiver's calendrical system in a calendar-neutral manner."

 	self setSecondsSinceJulianDayEpochUpToEpoch.
	self setSecondsSinceUnificationEpochUpToEpoch.
	self setDaysSinceStartOfWeekForEpochDay! !

!Calendar methodsFor: 'initialize-release' stamp: ''!
invalidate

	| originalLock |
	originalLock := lock.
	lock := nil.
	[self initialize] ensure: [lock := originalLock]! !

!Calendar methodsFor: 'initialize-release' stamp: ''!
invalidateClock
	"Ensure that the receiver's CalendarClock is the correct implmentation for the current system environment."

	clock := self newCalendarClock.
	self bindToClock.! !

!Calendar methodsFor: 'API-testing' stamp: ''!
isAnsiStandard
	"If the calendrical system implemented by the receiver conforms in all respects to the requirements of the ANSI Smalltalk standard with respect to the behavior of DateAndTime instances, answer true.  Otherwise, answer false.  Specifically: Answer true if and only if the receiver implements the proleptic Gregorian Calendar using astronomical (pure ordinal) year numbering."

	^false! !

!Calendar methodsFor: 'API-testing' stamp: ''!
isDaysPerMonthInvariant
	"If there are always the exact same number of days in all months of all years, answer true. Otherwise, answer false."

	^false! !

!Calendar methodsFor: 'API-testing' stamp: ''!
isDaysPerYearInvariant
	"If there are always the exact same number of days in all years, answer true. Otherwise, answer false."

	^false! !

!Calendar methodsFor: 'API-testing' stamp: ''!
isGregorian
	"If the receiver implements the Gregorian Calendar, answer true. Otherwise, answer false."

	^false! !

!Calendar methodsFor: 'API-testing' stamp: ''!
isJulian
	"If the receiver implements the Julian Calendar, answer true. Otherwise, answer false."

	^false! !

!Calendar methodsFor: 'API-testing' stamp: ''!
isMonthsPerYearInvariant
	"If there are always the exact same number of months in all years, answer true. Otherwise, answer false."

	^false! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
isoDayOfWeekOrdinalFromANSIDayOfWeekOrdinal: ansiDayOfWeekOrdinal
	"Answer the ISO 8601 day-of-week ordinal that corresponds to the ANSI day-of-week ordinal <ansiDayOfWeekOrdinal>."

	"{Calendar gregorian isoDayOfWeekOrdinalFromANSIDayOfWeekOrdinal: 1}"
	"{Calendar gregorian isoDayOfWeekOrdinalFromANSIDayOfWeekOrdinal: 7}"

	^(ansiDayOfWeekOrdinal - 2 \\ DaysPerWeek) + 1.! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
isoDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal: canonicalDayOfWeekOrdinal
	"Answer the ISO 8601 day-of-week ordinal that corresponds to the canonical day-of-week ordinal <canonicalDayOfWeekOrdinal>."

	"{Calendar gregorian isoDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal: 1}"
	"{Calendar gregorian isoDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal: 7}"

	^(canonicalDayOfWeekOrdinal - 2 \\ DaysPerWeek) + 1.! !

!Calendar methodsFor: 'API-Day of week' stamp: ''!
isoDayOfWeekOrdinalFromDaysSinceEpoch: daysSinceEpoch
	"Answer the ordinal number of the day of the week of the day that is <daysSinceEpoch> days from the receiver's epoch. Use the ISO 8601 numbering convention, where Monday=1 and Sunday=7."

	^(self daysSinceStartOfISOWeekFromDaysSinceEpoch: daysSinceEpoch) + 1! !

!Calendar methodsFor: 'API-Julian Days' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
julianDayFromDaysSinceEpoch: daysSinceEpoch
	"Answer the Julian Astronomical Day Number that corresponds to the day that is <daysSinceEpoch> days since the epoch of the receiver's calendar. Correspondence rule: The day in the receiver's count of days since the epoch that contains the starting moment of Julian Day J is the one that corresponds to Julian Day J.  Julian Days start at Noon--because astronomers work at night."

	^self julianDayFromSecondsSinceEpoch: ((daysSinceEpoch * SecondsPerDay) + self secondsSinceStartOfDayAtStartOfJulianDay)! !

!Calendar methodsFor: 'API-Julian Days' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
julianDayFromSecondsSinceEpoch: secondsSinceEpoch
	"Answer the Julian Astronomical Day Number that corresponds to the timepoint that is <secondsSinceEpoch> seconds since the initial moment of the epoch day of the receiver's calendar.  Julian Days start at Noon--because astronomers work at night.."

	^(self secondsSinceJulianDayEpochUpToEpoch + secondsSinceEpoch) // SecondsPerDay! !

!Calendar methodsFor: 'API-Julian Days' stamp: ''!
julianDayOfEpoch
	"Answer the Julian Astronomical Day Number that begins at Noon on the epoch day of the receiver's calendar."

	^self julianDayFromDaysSinceEpoch: 0! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
maxDaysPerMonth	
	"Answer the most number of days that occur in any month of any year."

	^maxDaysPerMonth! !

!Calendar methodsFor: 'API-queries-years' stamp: ''!
maxDaysPerYear
	"Answer the most number of days that may occur in a year."

	^maxDaysPerYear! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
maxMonthsPerYear
	"Answer the most number of months that occur in any year."

	^maxMonthsPerYear! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
maximumDayOfYearOrdinalForMonth: monthOrdinal day: dayOfMonthOrdinal
	"Answer the largest day-of-year ordinal corresponding to the intra-year date desgnation <monthOrdinal>/<dayOfMonthOrdinal>, for a year of any type."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
maximumDayOfYearOrdinalForMonthWithKey: monthKey day: dayOfMonthOrdinal
	"Answer the largest day-of-year ordinal corresponding to the intra-year date desgnation <monthKey>/<dayOfMonthOrdinal>, for a year of any type."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
maximumDaysInMonth: monthOrdinal
	"Answer the most number of days that may occur, for any year, in the month whose ordinal is <monthOrdinal>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
maximumDaysInMonthWithKey: monthKey
	"Answer the most number of days that may occur, for any year, in the month whose key is <monthKey>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the calendrical system represented by the receiver starts each day at local midnight."

	^(self secondsSinceMidnightFromSecondsSinceStartOfDay: 0) isZero! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
minDaysPerMonth	
	"Answer the least number of days that occur in any month of any year."

	^minDaysPerMonth! !

!Calendar methodsFor: 'API-queries-years' stamp: ''!
minDaysPerYear
	"Answer the least number of days that may occur in a year."

	^minDaysPerYear! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
minMonthsPerYear
	"Answer the least number of months that occur in any year."

	^minMonthsPerYear! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
minimumDayOfYearOrdinalForMonth: monthOrdinal day: dayOfMonthOrdinal
	"Answer the smallest day-of-year ordinal corresponding to the intra-year date desgnation <monthOrdinal>/<dayOfMonthOrdinal>, for a year of any type."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
minimumDayOfYearOrdinalForMonthWithKey: monthKey day: dayOfMonthOrdinal
	"Answer the smallest day-of-year ordinal corresponding to the intra-year date desgnation <monthKey>/<dayOfMonthOrdinal>, for a year of any type."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
minimumDaysInMonth: monthOrdinal
	"Answer the least number of days that may occur, for any year, in the month whose ordinal is <monthOrdinal>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
minimumDaysInMonthWithKey: monthKey
	"Answer the least number of days that may occur, for any year, in the month whose key is <monthKey>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthKeyAtMonthNameKey: monthNameKey
	monthKeyByMonthNameKey == nil ifTrue: [self bindToYearlyCalendars].
	^monthKeyByMonthNameKey at: monthNameKey! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthKeyForMonthAt: monthOrdinal forYearTypeCode: yearTypeCode
	"Answer the monthKey for the month whose ordinal is <monthOrdinal>, in a year whose type is identified by the code <yearTypeCode>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthKeyForMonthAt: monthOrdinal inYear: year
	"Answer the monthKey for the month whose ordinal is <monthOrdinal>, in the given <year>."

	^self monthKeyForMonthAt: monthOrdinal forYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'enumerating' stamp: ''!
monthKeysAndMonthNameKeysDo: block1 
	monthNameKeysByMonthKey == nil ifTrue: [self bindToYearlyCalendars].
	doMonthKeysAlwaysCorrespondToTheSameMonthNameKey 
		ifTrue: [monthNameKeysByMonthKey keysAndValuesDo: block1]
		ifFalse: 
			[monthNameKeysByMonthKey keysAndValuesDo: 
					[:monthKey :monthNameKeySet | 
					monthNameKeySet 
						do: [:monthNameKey | block1 value: monthKey value: monthNameKey]]]! !

!Calendar methodsFor: 'enumerating' stamp: ''!
monthKeysAndMonthOrdinalsDo: block1 
	monthOrdinalsByMonthKey == nil ifTrue: [self bindToYearlyCalendars].
	monthOrdinalsAlwaysCorrespondToTheSameMonthKey 
		ifTrue: [monthOrdinalsByMonthKey keysAndValuesDo: block1]
		ifFalse: 
			[monthOrdinalsByMonthKey keysAndValuesDo: 
					[:monthKey :monthOrdinalSet | 
					monthOrdinalSet 
						do: [:monthOrdinal | block1 value: monthKey value: monthOrdinal]]]! !

!Calendar methodsFor: 'enumerating' stamp: ''!
monthKeysDo: block1
	monthOrdinalsByMonthKey == nil ifTrue: [self bindToYearlyCalendars].
	monthOrdinalsByMonthKey keysDo: block1! !

!Calendar methodsFor: 'enumerating' stamp: ''!
monthNameKeysAndMonthKeysDo: block1 
	monthKeyByMonthNameKey == nil ifTrue: [self bindToYearlyCalendars].
	monthKeyByMonthNameKey keysAndValuesDo: block1! !

!Calendar methodsFor: 'enumerating' stamp: ''!
monthNameKeysDo: block1
	monthKeyByMonthNameKey == nil ifTrue: [self bindToYearlyCalendars].
	monthKeyByMonthNameKey keysDo: block1! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthOrdinalForMonthWithKey: monthKey forYearTypeCode: yearTypeCode
	"Answer the month ordinal for the month whose monthKey is <monthKey>, in a year whose type is identified by the code <yearTypeCode>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthOrdinalForMonthWithKey: monthKey inYear: year
	"Answer the month ordinal for the month whose monthKey is <monthKey>, in the given <year>."

	^self monthOrdinalForMonthWithKey: monthKey forYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthOrdinalFromNumericMonthDesignator: numericalMonthDesignator forYearTypeCode: yearTypeCode
	"Answer the month ordinal for the month identified by the culturally-correct numeric designator <numericalMonthDesignator>, for a year whose type is identified by the code <yearTypeCode>."

	^numericalMonthDesignator! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthOrdinalFromNumericMonthDesignator: numericalMonthDesignator inYear: year
	"Answer the month ordinal for the month whose culturally-correct numeric designator is <numericalMonthDesignator>, in the given <year>."

	^self monthOrdinalFromNumericMonthDesignator: numericalMonthDesignator forYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'accessing' stamp: ''!
monthOrdinalRangeConstraint
	"Answer the RangeConstraint that implements the range constraint for the valid values of month ordinals in the calendrical system represented by the receiver (taking all year-types into account.)"

	^monthOrdinalRangeConstraint! !

!Calendar methodsFor: 'enumerating' stamp: ''!
monthOrdinalsAndMonthKeysDo: block1 
	monthKeysByMonthOrdinal == nil ifTrue: [self bindToYearlyCalendars].
	monthOrdinalsAlwaysCorrespondToTheSameMonthKey 
		ifTrue: [monthKeysByMonthOrdinal keysAndValuesDo: block1]
		ifFalse: 
			[monthKeysByMonthOrdinal keysAndValuesDo: 
					[:monthOrdinal :monthKeySet | 
					monthKeySet 
						do: [:monthKey | block1 value: monthOrdinal value: monthKey]]]! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthsInYear: year
	"Answer the number of months there are in the given <year>."

	^self monthsInYearForYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
monthsInYearForYearTypeCode: yearTypeCode 
	"Answer the number of months there are per year, in a year whose typeCode is <yearTypeCode>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-Date Deconstruction' stamp: ''!
monthsSinceEpochUpToYear: calendarYear 
	"Answer the count of months since the Epoch day (start of day) up to (but NOT including) the first month of the specified year."

	^self subclassResponsibility! !

!Calendar methodsFor: 'accessing' stamp: ''!
name
	"Answer the name, for presentation purposes, of the calendrical system represented by the receiver."

	^self defaultLocale properNameAtSemanticKey: self registrationKey! !

!Calendar methodsFor: 'private' stamp: ''!
newCalendarClock
	"Answer a new CalendarClock usable by the receiver as its canonical CalendarClock."

	| newClock |
	newClock := self basicNewCalendarClock.
	^newClock
		setCalendar: self;
		beImmutable! !

!Calendar methodsFor: 'private' stamp: ''!
newDefaultYearNumberingPolicy
	"Answer a new NumberingPolicy to be used as the the policy for interpreting year numbers in the calendrical system implemented by instances of the receiver. NOTE: The ANSI Smalltalk standard REQUIRES the use of 'Astronomical Year Numbering' (i.e., an OrdinalNumberingPolicy) for dates in the Gregorian calendar. The ISO 8601 standard imposes the same requirement."

	^self class newDefaultYearNumberingPolicy! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
numericMonthDesignatorFromMonthOrdinal: monthOrdinal forYearTypeCode: yearTypeCode
	"Answer the culturally-correct numeric designator that identifies the month whose ordinal is <monthOrdinal>, for a year whose type is identified by the code <yearTypeCode>."

	^monthOrdinal! !

!Calendar methodsFor: 'API-queries-months' stamp: ''!
numericMonthDesignatorFromMonthOrdinal: monthOrdinal inYear: year
	"Answer the culturally-correct numeric designator that identifies the month whose ordinal is <monthOrdinal> in the given <year>."

	^self numericMonthDesignatorFromMonthOrdinal: monthOrdinal forYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'initialize-release' stamp: ''!
register
	"Register the receiver as the canonical instance of its class."

	| key old |
	key := self registrationKey.
	key == nil ifTrue: [^nil].
	old := self class instanceRegistry at: key ifAbsentPut: [self].
	old == self 
		ifFalse: 
			["The only obvious reason it should ever be necessary to register one Calendar instance in place of another is because their classes are different (and so have different behavior.)  However, the invariant that there is only one Calendar instance with a given key (where 'Calendar' is understood as a role/type, not a class) must be be maintained."

			self class instanceRegistry at: key put: self.
			ChronosEnvironment canonical invalidateCalendarBindings]! !

!Calendar methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^self class registrationKey! !

!Calendar methodsFor: 'initialize-release' stamp: ''!
release
	"Remove references to objects that may refer to the receiver. Answers self. 
	This message should be overidden by subclasses with any cycles, in which
	case the subclass should also include the expression super release."

	super release.
	InstanceRegistry == nil ifFalse: [InstanceRegistry removeKey: self registrationKey ifAbsent: []]! !

!Calendar methodsFor: 'API-Julian Days' stamp: ''!
secondsFromMidnightToJulianDayStartOfDay
	"Answer the number of seconds to be added to seconds-since-start-of-day, expressed relative to the canonical Julian Day start-of-day, to convert them into seconds-since-midnight (without respect to timezone translation.).

	Julian Day 0 starts at Noon 4713 BC-Jan-1 in the Julian Calendar."

	^"SecondsPerDay // 2" 43200! !

!Calendar methodsFor: 'API-InterCalendar' stamp: ''!
secondsSinceEpochFromForeignSecondsSinceEpoch: foreignSecondsSinceEpoch convertingFrom: aForeignCalendar
	"Answer the number of seconds since the initial moment of the epoch day of the receiver's calendar, converted from <foreignSecondsSinceEpoch> days since the initial moment of the epoch day of the Calendar <aForeignCalendar>. Do not include any adjustments for leap seconds, or any time-zone dependent adjustments."

	^self 
		secondsSinceEpochFromSecondsSinceUnificationEpoch: 
			(aForeignCalendar 
				secondsSinceUnificationEpochFromSecondsSinceEpoch: foreignSecondsSinceEpoch)! !

!Calendar methodsFor: 'API-Julian Days' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsSinceEpochFromJulianDay: julianDay
	"Answer the number of seconds since the initial moment of the epoch day of the receiver's calendar that corresponds to the initial moment of the day whose Julian Astronomical Day Number is <julianDay>. Julian Days start at Noon--because astronomers work at night."

	^(julianDay * SecondsPerDay) - self secondsSinceJulianDayEpochUpToEpoch! !

!Calendar methodsFor: 'API-unification' stamp: ''!
secondsSinceEpochFromSecondsSinceUnificationEpoch: secondsSinceUnificationEpoch
	"Answer the number of seconds since the initial moment of the epoch day of the receiver's calendar, converted from <secondsSinceUnificationEpoch> seconds from the initial moment of the epoch day of the unification calendar."

	^secondsSinceUnificationEpoch - secondsSinceUnificationEpochUpToEpoch! !

!Calendar methodsFor: 'API-Date Deconstruction' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsSinceEpochUpToYear: calendarYear 
	"Answer the count of seconds since the initial moment of the epoch day of the receiver's calendar up to the initial moment of the first day of the specified year. DO NOT include leap seconds, or any timezone-dependent adjustments."

	^(self daysSinceEpochUpToYear: calendarYear) * SecondsPerDay! !

!Calendar methodsFor: 'API-Julian Days' stamp: ''!
secondsSinceJulianDayEpochUpToEpoch
	"Answer the number of seconds since the initial moment (Noon) of Julian Day 0 (Monday, January 1, 4713 BC in the proleptic Julian calendar; or November 24, -4713 in the proleptic Gregorian calendar) up to the initial moment of the epoch day of the receiver's calendar."

	secondsSinceJulianDayEpochUpToEpoch == nil 
		ifTrue: 
			[EnvironmentFacade current makeMutable: self.
			secondsSinceJulianDayEpochUpToEpoch := self computeSecondsSinceJulianDayEpochUpToEpoch].
	^secondsSinceJulianDayEpochUpToEpoch! !

!Calendar methodsFor: 'API-unification' stamp: ''!
secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay
	"Answer the number of seconds-since-start-of-day relative to midnight represented by the argument, <secondsSinceStartOfDay>, where the argument is specified relative to the receiver's canonical start-of-day (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since midnight clock time that corresponds to the number of seconds since the receiver's canonical start-of-day clock time, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for calendar systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Hebrew calendar, the canonical start-of-day is 6pm."

	^secondsSinceStartOfDay! !

!Calendar methodsFor: 'API-Julian Days' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsSinceStartOfDayAtStartOfJulianDay
	"Answer the number of seconds to be added to the start-of-day of the receiver in order to derive the seconds-since-start-of-day of the next Julian Day.
	Julian Day 0 starts at Noon 4713 BC-Jan-1 in the Julian Calendar."

	| seconds |
	seconds := self secondsSinceStartOfDayFromSecondsSinceMidnight: self secondsFromMidnightToJulianDayStartOfDay.
	^(seconds > SecondsPerDay)
		ifTrue: [seconds - SecondsPerDay]
		ifFalse: [seconds]! !

!Calendar methodsFor: 'API-unification' stamp: ''!
secondsSinceStartOfDayFromSecondsSinceMidnight: secondsSinceMidnight
	"Answer the number of seconds-since-start-of-day relative to the receiver's canonical start-of-day represented by the argument, <secondsSinceMidnight>, where the argument is specified relative to midnight (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since the receiver's canonical start-of-day clock time that corresponds to the number of seconds since midnight, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for calendar systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Hebrew calendar, the canonical start-of-day is 6pm."

	^secondsSinceMidnight! !

!Calendar methodsFor: 'API-Julian Days' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsSinceStartOfJulianDayAtStartOfDay
	"Answer the number of seconds to be added to the start-of-day of a Julian Day in order to advance to the start-of-day of the receiver.
	Julian Day 0 starts at Noon 4713 BC-Jan-1 in the Julian Calendar."

	| seconds |
	seconds := self secondsSinceMidnightFromSecondsSinceStartOfDay: self secondsFromMidnightToJulianDayStartOfDay.
	^(seconds > SecondsPerDay)
		ifTrue: [seconds - SecondsPerDay]
		ifFalse: [seconds]! !

!Calendar methodsFor: 'API-unification' stamp: ''!
secondsSinceUnificationEpochFromSecondsSinceEpoch: secondsSinceEpoch
	"Answer the number of seconds from the initial moment of the epoch day of the unification calendar, converted from <secondsSinceEpoch> seconds since the initial moment of the epoch day of the receiver's calendar."

	^secondsSinceEpoch + secondsSinceUnificationEpochUpToEpoch! !

!Calendar methodsFor: 'API-InterCalendar' stamp: ''!
secondsSinceUnificationEpochUpToEpoch
	"Answer the number of seconds since the initial moment of the epoch day of the unification calendar up to the initial moment of the epoch day of the receiver's calendar."

	^secondsSinceUnificationEpochUpToEpoch! !

!Calendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 10:34'!
setDaysSinceStartOfWeekForEpochDay
	"Set the zero-based day-of-week index of the first day of the receiver's epoch.  Set this value for a) the receiver's canonical week, b) the ANSI Smalltalk week and c) the ISO 8601 standard week.  In ANSI Smalltalk, Sunday is the first day of the week.  ISO 8601 defines Monday as the first day of the week."

	self assertMutability.
	daysSinceStartOfISOWeekForEpochDay := self julianDayOfEpoch \\ (DaysPerWeek).
	daysSinceStartOfANSIWeekForEpochDay := daysSinceStartOfISOWeekForEpochDay + 1 \\ (DaysPerWeek).
	daysSinceStartOfWeekForEpochDay := self computeDaysSinceStartOfWeekForEpochDay! !

!Calendar methodsFor: 'private' stamp: ''!
setSecondsSinceJulianDayEpochUpToEpoch
	"Set the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	"Example 'de novo' calculation for the Gregorian Calendar:

		 {| uDays uSeconds |
		uDays := Gregorian 
					daysSinceEpochUpToMonth: 11
					day: 24
					inYear: -4713.
		uSeconds := uDays * SecondsPerDay + Gregorian secondsFromMidnightToJulianDayStartOfDay.
		(Gregorian secondsSinceEpochFromSecondsSinceUnificationEpoch: uSeconds) negated}"

	self assertMutability.
	secondsSinceJulianDayEpochUpToEpoch := self computeSecondsSinceJulianDayEpochUpToEpoch! !

!Calendar methodsFor: 'private' stamp: ''!
setSecondsSinceUnificationEpochUpToEpoch
	"Set the number of seconds since the initial moment of the epoch day of the unification calendar up to the initial moment of the epoch day of the receiver's calendrical system."

	self assertMutability.
	secondsSinceUnificationEpochUpToEpoch := self secondsSinceJulianDayEpochUpToEpoch - Calendar unification secondsSinceJulianDayEpochUpToEpoch! !

!Calendar methodsFor: 'API-Date Construction' stamp: ''!
startingWithYear: startYear addingDays: dayDelta setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2 
	"For a year and CalendarDay that is dayDelta days since the first day of the year <startYear>, send #value:value: to <yearMonthDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	| ordinalYear |
	^self isDaysPerYearInvariant
		ifTrue: 
			[| endingYear |
			ordinalYear := yearNumberingPolicy cardinalFromCanonical: startYear.
			endingYear := yearNumberingPolicy canonicalFromCardinal: (ordinalYear + (dayDelta // self maxDaysPerYear)).
			yearMonthDaySpecOrBlock2 
				value: endingYear
				value: (self calendarDayFromDayOfYearOrdinal: dayDelta \\ self maxDaysPerYear + 1 inYear: endingYear)]
		ifFalse: 
			["Default algorithm that will work, but is probably much slower than some alternative--except for a small number of days."
			| days daysInYear yearTypeCode canonicalYear |
			days := dayDelta.
			canonicalYear := startYear.
			ordinalYear := yearNumberingPolicy ordinalFromCanonical: canonicalYear.
			yearTypeCode := self typeCodeOfYear: canonicalYear.
			
			[days >= (daysInYear := self daysInYearForYearTypeCode: yearTypeCode)] 
					whileTrue: 
						[ordinalYear := ordinalYear + 1.
						canonicalYear := yearNumberingPolicy canonicalFromOrdinal: ordinalYear.
						yearTypeCode := self typeCodeOfYear: canonicalYear.
						days := days - daysInYear].
			[days < 0] whileTrue: 
					[ordinalYear := ordinalYear - 1.
					canonicalYear := yearNumberingPolicy canonicalFromOrdinal: ordinalYear.
					yearTypeCode := self typeCodeOfYear: canonicalYear.
					days := days + (daysInYear := self daysInYearForYearTypeCode: yearTypeCode)].
			yearMonthDaySpecOrBlock2 
				value: canonicalYear
				value: (self calendarDayFromDayOfYearOrdinal: days + 1 forYearTypeCode: yearTypeCode)]! !

!Calendar methodsFor: 'API-Date Construction' stamp: ''!
startingWithYear: startYear addingMonths: monthDelta setYearAndMonthsSinceStartOfYearInto: block2 
	"For a year and months-since-start-of-year that is monthDelta months since the first month of the year <startYear>, send #value:value: to <block2>, with the year as the first argument and the months-since-start-of-year as the second argument."

	| ordinalYear |
	^self isMonthsPerYearInvariant
		ifTrue: 
			[ordinalYear := yearNumberingPolicy cardinalFromCanonical: startYear.
			block2 
				value: (yearNumberingPolicy canonicalFromCardinal: (ordinalYear + (monthDelta // self maxMonthsPerYear)))
				value: monthDelta \\ self maxMonthsPerYear]
		ifFalse: 
			["Default algorithm that will work, but is probably much slower than some alternative--except for a small number of months."
			| months monthsInYear canonicalYear |
			months := monthDelta.
			canonicalYear := startYear.
			ordinalYear := yearNumberingPolicy ordinalFromCanonical: canonicalYear.
			
			[months >= (monthsInYear := self monthsInYear: canonicalYear)] 
					whileTrue: 
						[ordinalYear := ordinalYear + 1.
						canonicalYear := yearNumberingPolicy canonicalFromOrdinal: ordinalYear.
						months := months - monthsInYear].
			[months < 0] whileTrue: 
					[ordinalYear := ordinalYear - 1.
					canonicalYear := yearNumberingPolicy canonicalFromOrdinal: ordinalYear.
					months := months + (monthsInYear := self self monthsInYear: canonicalYear)].
			block2 
				value: canonicalYear 
				value: months]! !

!Calendar methodsFor: 'API-testing' stamp: ''!
timeOfDayClockStartsAtMidnight
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the calendrical system implemented by the receiver coincides with midnight.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^self midnightIsStartOfDay or: [self timeOfDayClockStartsAtStartOfDay not]! !

!Calendar methodsFor: 'API-testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the calendrical system implemented by the receiver coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^true! !

!Calendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^self subclassResponsibility! !

!Calendar methodsFor: 'API-unification' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
unificationDayNumberOfEpoch
	"Answer the number of days since the epoch of the unification calendar that corresponds to the initial moment of the epoch day of the receiver's calendar."

	^(self secondsSinceUnificationEpochFromSecondsSinceEpoch: 0) // SecondsPerDay! !

!Calendar methodsFor: 'API-validation' stamp: ''!
validateYear: y dayOfYear: d ifInvalid: block1
	"If, in the year <y>, either the day-of-year <d> is not valid (or the year <y> is not valid) in the calendrical system implemented by the receiver, answer the result of evaluating <block1> with a parameter that is a Symbol identifying the reason that <d> is not a valid day-of-year in the year <y> (or the reason that <y> is not a valid year)--the possible values of the Symbol are #yearZeroInvalid, #underflow and #overflow. If both <y> and <d> are valid, answer nil"

	"{Calendar gregorian validateYear: 2000 dayOfYear: 366 ifInvalid: [:evaluation | evaluation]}"
	"{Calendar gregorian validateYear: 1900 dayOfYear: 366 ifInvalid: [:evaluation | evaluation]}"
	"{Calendar gregorian validateYear: 0 dayOfYear: 0 ifInvalid: [:evaluation | evaluation]}"
	"{Calendar julian validateYear: 0 dayOfYear: 1 ifInvalid: [:evaluation | evaluation]}"

	| yearlyCalendar |
	d < 1 ifTrue: [^block1 value: #underflow].
	(yearNumberingPolicy satisfiesZeroConstraint: y) ifFalse: [^block1 value: #yearZeroInvalid].
	yearlyCalendar := self yearlyCalendarForYearTypeCode: (self typeCodeOfYear: y).
	d > yearlyCalendar daysPerYear 
		ifTrue: [^block1 value:  #overflow].
	^nil! !

!Calendar methodsFor: 'API-validation' stamp: ''!
validateYear: y month: m day: d ifInvalid: block1 
	"If the date designation whose year is <y>, whose month ordinal is <m> and whose day-of-month ordinal is <d> is not valid in the calendrical system implemented by the receiver, answer the result of evaluating <block1> with a Dictionary as the argument, where the keys and values of the Dictionary identify the reasons that the date designation is not valid. The keys of the Dictionary identify the date-field whose value is not valid (#year, #month, #dayOfMonth,) and the value at the key identifies the nature of the problem with that date field (#yearZeroInvalid, #underflow, #overflow.) If the date designation is valid in all respects, answer nil"

	"{Calendar gregorian validateYear: 2000 month: 2 day: 29 ifInvalid: [:evaluation | evaluation]}"
	"{Calendar gregorian validateYear: 1900 month: 2 day: 29 ifInvalid: [:evaluation | evaluation]}"
	"{Calendar gregorian validateYear: 2100 month: 0 day: -3 ifInvalid: [:evaluation | evaluation]}"
	"{Calendar gregorian validateYear: 2100 month: 13 day: -12 ifInvalid: [:evaluation | evaluation]}"
	"{Calendar julian validateYear: 0 month: 1 day: -12 ifInvalid: [:evaluation | evaluation]}"

	| evaluation evaluationRef yearlyCalendar monthlyCalendar |
	evaluation := nil.
	evaluationRef := 
			[evaluation == nil ifTrue: [evaluation := IdentityDictionary new].
			evaluation].
	d < 1 ifTrue: [evaluationRef value at: #dayOfMonth put: #underflow].
	m < 1 
		ifTrue: 
			[evaluationRef value at: #month put: #underflow.
			^block1 value: evaluation].
	(yearNumberingPolicy satisfiesZeroConstraint: y) 
		ifFalse: 
			[evaluationRef value at: #year put: #yearZeroInvalid.
			^block1 value: evaluation].
	yearlyCalendar := self yearlyCalendarForYearTypeCode: (self typeCodeOfYear: y).
	m > yearlyCalendar monthsPerYear 
		ifTrue: 
			[evaluationRef value at: #month put: #overflow.
			^block1 value: evaluation].
	monthlyCalendar := yearlyCalendar monthAt: m.
	d > monthlyCalendar daysPerMonth 
		ifTrue: [evaluationRef value at: #dayOfMonth put: #overflow].
	^evaluation == nil ifFalse: [block1 value: evaluation]! !

!Calendar methodsFor: 'API-testing' stamp: ''!
yearArithmeticPreferablyPreservesMonthOrdinal
	"Answer true if adding or subtracting an integer number of civil years to a date always results in a new date with the same month ordinal.  If the date's dayOfMonthOrdinal is greater than the number of days in the month identified by that ordinal in the new year, then the next month will be used. If there is no month with the same month ordinal in the new year, then the next month will be used when adding years, and the previous month when subtracting years.
	Answer false if adding or subtracting an integer number of civil years results in a new date with the same month key. If the date's dayOfMonthOrdinal is greater than the number of days in the month identified by that month key in the new year, then the next month will be used. If there is no month with the same month key in the new year, then the next month will be used when adding years, and the previous month when subtracting years."

	^true! !

!Calendar methodsFor: 'accessing' stamp: ''!
yearNumberingPolicy
	"Answer the instance of the concrete subclass of NumberingPolicy that implements the year-numbering policy of the calendrical system represented by the receiver."

	^yearNumberingPolicy! !

!Calendar methodsFor: 'API-CalendarPeriods' stamp: ''!
yearlyCalendarFor: year
	"Answer the YearlyCalendar (which see) that specifies the characteristics of the given <year>, including the year's organization into months and days of the month."

	^self yearlyCalendarForYearTypeCode: (self typeCodeOfYear: year)! !

!Calendar methodsFor: 'API-CalendarPeriods' stamp: ''!
yearlyCalendarForYearTypeCode: yearType
	"Answer the YearlyCalendar (which see) that specifies the characteristics of any year whose year type is identifiefied by the code <yearType>, including the year's organization into months and days of the month."

	^self subclassResponsibility! !

Calendar subclass: #IrregularCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!IrregularCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

IrregularCalendar

	Concept:

		IrregularCalendar is an abstract Calendar class whose subclasses implement "irregular" calendars.  An irregular calendar is one that does not have a reasonably small number of year types, and/or where the computation of the year type involves relatively complex math (typically astronomical calculations using real numbers.)  A year type defines a specific number of months in the year and a specific number of days in each month.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of AstronomicalCalendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		An irregular calendar is one where there is a rather large number of "year types," where a "year type" a) defines a particular way of organizing the days of a year into months and days-of-the-month, and b) defines a deterministic mapping between day-of-year ordinals and month/day-of-month designations.

		Typically, astronomical calendars are IrregularCalendars--but that's not always the case.

		IrregularCalendar is not yet implemented.
!

IrregularCalendar subclass: #ChineseCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!ChineseCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChineseCalendar

	Concept:

		ChineseCalendar implements the Chinese Calendar.  

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Chinese Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		ChineseCalendar is not yet implemented

		Epoch Date

		Leap Year Rule

		Month Structure

!

!ChineseCalendar class methodsFor: 'testing' stamp: ''!
isAbstract
	"Prevent registration, because I'm not implemented yet."

	^true! !

!ChineseCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Chinese! !

!IrregularCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^calendarYear "For the typical Astronomical Calendar, every year is its own type code, since there is no finite set of year types."! !

Calendar subclass: #RegularCalendar
	instanceVariableNames: 'yearlyCalendars'
	classVariableNames: 'StandardYearTypeCode'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

RegularCalendar class
	instanceVariableNames: 'monthlyCalendarSpecs'!

!RegularCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ArithmeticalCalendar

	Concept:

		RegularCalendar is an abstract Calendar class whose subclasses implement "regular" calendars.  A regular calendar is one that has a reasonably small number of year types.  A year type defines a specific number of months in the year and a specific number of days in each month.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of ArithmeticalCalendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		A regular calendar is one where there is a finite and relatively small number of "year types," where a "year type" a) defines a particular way of organizing the days of a year into months/days-of-the-month, and b) defines a deterministic mapping between day-of-year ordinals and month/day-of-month designations.
	 
		Typically, arithmetical calendars are RegularCalendars--although, at least theoretically, that does not have to be the case.

		The Gregorian Calendar (the de facto international standard civil calendar) is a regular calendar, as are the Julian, Bahai, Coptic, Ethiopic, Fatimid (Arithmetical Islamic,) Hebrew, Indian (Civil,)  and Persian calendars. Most regular calendars have only two year types: a "standard" year and a "leap" year.  The Hebrew Calendar, however, has six different year types: three with 352, 353 and 354 days per year respectively (all three of which have 12 months per year,) and three with 382, 383 and 384 days per year respectively (all three of which have 13 months per year.)

	Implementation:

		Instance Variables

			yearlyCalendars 											<Array of YearlyCalendar>
				Every year of an ArithmeticalCalendar is a year of a particular type.  Each year type differs from other year types by reason of some difference in one or more of the following: a) the number of months in the year, b) the number of days in one or more of the months, c) the semantic key of one or more of the months, d) the name key of one or more of the months, e) the numerical month designator of one or more of the months, f) the day-of-month ordinals of one or more months that are considered to be leap days, g) the mapping between day-of-year ordinals and month/day-of-month designations, or h) the number of days in the year. There are only a small, finite number of different year types defined by any ArithmeticalCalendar.  For each such year type, there is an integer code that is used to identify the corresponding year type.  The integer year type code corresponds to the index in the Array of YearlyCalendars (referenced by <yearlyCalendars>) of the instance of YearlyCalendar that specifies the month structure for a year of the type identified by that integer code.  See the class comment of YearlyCalendar for more information.

			doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey		<boolean> 
				True if the association between month ordinals and month keys is invariant for all year types--otherwise false.  Generally true for all calendrical systems that have the same number of months in all year types.  A month key is a well-known key that semantically (culturally) identifies the "same month," even in cases where its month ordinal differs in different year types (this happens in the Hebrew Calendar, among others.)  The value of this variable is computed from the information in <yearlyCalendars>, and set during initialization of the instance.

		Class Instance Variables

			monthlyCalendarSpecs										<Array of Array of MonthlyCalendarSpec>
				There must be one Array of MonthlyCalendarSpecs in the outer Array (the one referenced by <monthlyCalendarSpecs>) for each 'year type' of the calendrical system implemented by instances of (concrete subclasses of) ArithmeticalCalendar.  There must be a MonthlyCalendarSpec in the inner Array for each month for each year type.  The index in the outer Array of each inner Array of MonthlyCalendarSpecs is the integer code of the year type whose month structure is specified by the inner Array with that index. The index of each MonthlyCalendarSpec in its containing Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec. The value of <monthlyCalendarSpecs> is used to generate the value of the instance variable <yearlyCalendars> when an instance of (a concrete subclass of) ArithmeticalCalendar is instantiated/initialized. See the class comment of MonthlyCalendarSpec for more information.

				So: "monthlyCalendarSpecs at: 2" evaluates to an Array of MonthlyCalendarSpecs that specifies the month structure for the year type identified by the integer code 2; "(monthlyCalendarSpecs at: 1) at: 7" evaluates to a MonthlyCalendarSpec that specifies the properties of the seventh month of a year whose integer year type code is 1.

	Subclassing:

		The class method #setMonthlyCalendarSpecs must be subimplemented.  See the method comment for more information.
!

RegularCalendar class
	instanceVariableNames: 'monthlyCalendarSpecs'!

RegularCalendar subclass: #HebrewCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!HebrewCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

HebrewCalendar

	Concept:

		HebrewCalendar implements the Hebrew Calendar, which was and is the calendar of the Jewish people, and of the Jewish religion.  The Hebrew Calendar is, by far, the most complex arithmetical calendar ever devised.  Modernly, it is used more for religious than secular purposes, although it is one of the two official, civil calendars of the State of Israel--the other, of course, is the Gregorian Calendar. The Hebrew Calendar was given its current form (as an arithmetical, rule-based calendrical system) in the mid Fourth Century AD.  Originally, it was an observational calendar.  Consequently, using the current Hebrew Calendar (as herein implemented) for dates before the year 4120 [Hebrew] (the mid-Fourth Century AD) would be anachronistic (although it's useful as an approximation/estimate.)

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Hebrew Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The modern Hebrew Calendar is an arithmetical, luni-solar calendar. A luni-solar calendar is one that, although it attempts to match the (average) length of its years to that of mean solar years over some sufficiently long period of time, also attempts to align the day on which one month transitions to the next with the moment that the moon transitions from one phase to the next, so that each month begins within a day or so of the moment that the moon exits from or enters into a particular phase. In the case of arithmetical luni-solar calendars, the result is usually that New Year's day oscillates back and forth with a period of about 1 month around some "fixed point" with respect to the mean solar year. Also, the solar year "fixed point" itself is likely to shift through the solar year over sufficiently long periods of time.

		The Hebrew Calendar seeks to transition from one month to the next as a function of each New Moon. 
	
		Epoch Date

			The epoch date of the Hebrew Calendar, 0001-01-01 [Hebrew], corresponds to -3760-09-07 [Gregorian] (astronomical year numbering) and to -3761-10-07 [Julian] (traditional year numbering.)  Hebrew days begin at sunset. The Julian Date of the Hebrew epoch is 347,997.25 (6 pm,) so the actual initial moment of the Hebrew epoch corresponds to -3760-09-06T18:00:00 [Gregorian] and to -3761-10-06T18:00:00 [Julian]. 

			Jewish tradition considers the Hebrew Calendar epoch to be the date of the creation of the world, which is why the name of the Hebrew era is "Anno Mundi" (AM)--Latin for "In the Year of the World."

		Time-of-Day Clock

			Although Hebrew days begin at sunset, modernly the Jewish people label the hours of the day beginning at midnight.  So the zero-point of the time-of-day clock is midnight, although the initial moment of the day is 6 pm. 

			{HebrewCalendar clock today}
			{HebrewCalendar clock now}

		Year Numbering Policy

			The Hebrew Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Year Type Rules

			There are six different year types (which means six different month structures [see below], and six different numbers of days per year.)  The six year types result from a two-dimensional matrix, with one dimension representing a binary distinction between a standard year and a leap year, and the other dimension representing a trinary distinction between "regular," "deficient" and "complete" years:

												Year Type Matrix 
									Deficient		Regular		Complete
				Standard Year	  353[1]		  354[2]		  355[3]
				Leap Year		  383[4]		  384[5]		  385[6]
					(table cells show: days-per-year[Chronos year-type code])

			The Hebrew Calendar uses the 19-year metonic cycle to determine which years are leap years. Years 3, 6, 8, 11, 14, 17 and 19 of the cycle are leap years, the remaining years are standard years. Whether or not a Hebrew year is a leap year can be computed by the following predicate function:

				isLeapYear(hebrewYear) = (((7 * hebrewYear) + 1)  mod 19) < 7

			Now comes the really complicated part: how to determine whether a Hebrew year is "regular," "deficient" or "complete" (which we will refer to here as the "completeness" of the year, for lack of a better term, since the term "type" already refers to the combination of leap-year-status and "completeness.") 

			One does not first determine the completeness and leap-year-status of a year in order to determine its type (and hence the number of days in the year.) Instead, one must first determine the number of days in the year, after which the type of the year (and hence its completeness) become evident.  In other words, one first determines that a year has (for example) 353 days, from which it obviously follows that the year's Chronos year-type is 1, and that it is therefore a standard, deficient year.

			The number of days in a year is a function of when its first day occurs, and when the first day of the succeeding year occurs.  The approximate first day of a year is determined by the computed occurrence of the mean new moon (earth-lunar conjunction) that is associated with the beginning of the month of Tishri (the first month of the civil year.) The date so computed is subject to possible adjustment by a set of special rules called the Dehiyyah ("delays," "postponements.") First we will explain the formula for computing the occurence of the New Moon (Molad) of Tishri, then we will explain the application of the Dehiyyah rules for the purpose of precisely determining the beginning of a year, and then we will explain how to compute the length of a year.

			Computing the New Moon (Molad) of Tishri

				The Hebrew day was traditionally divided into 24 hours, and each hour was traditionally divided into 1080 parts (halaqim,) which means a day consists of 25,920 parts.  The duration of a part is 3 and a third seconds. The rule for computing the new moon of Tishri is expressed in terms of parts (halaqim.)

				The epochal new moon of Tishri (which occurred on 0001-01-01 Anno Mundi--year 1, month 1 day 1 of the Hebrew Calendar) is deemed by calendrical rule to have occurred at 11:11:20 pm on the epoch date of the Hebrew calendar--which is very late Sunday evening according to Julian/Gregorian reckoning, but is the 5th hour of Monday according to Hebrew reckoning (Hebrew days start at sunset, Julian/Gregorian days start at midnight.) A duration of 5 hours, 11 minutes and 20 seconds (since the start of the day at 6 pm) equates to 18,680 seconds, which is equivalent to 5 hours and 204 parts (halaqim,) or to 5,604 parts (exactly.) Because the epochal Molad of Tishri occurred on the second day of the week (Monday,) after 5 hours and 204 parts since the start of the day, it is called Molad Beharad--the appellation "Beharad" (BHRD--written Hebrew omits all vowels) being derived from the numerology of the Hebrew alphabet, where the letter Beth has the value 2 (second day of the week,) the letter Heh has the value 5 (fifth hour of the day), the letter Resh has the value 200 (parts since the hour,) and the letter Daleth has the value 4 (additional parts since the hour.) Molad Beharad is the base or pivotal occurrence of the new moon upon which all Hebrew calendrical calculations depend.

				The length of a mean lunar period (the average duration between new moons) is deemed (by the rules of the Hebrew Calendar) to be 29 days, 12 hours and 793 parts--which equates to 29 days, 12 hours, 17 minutes and 37 and 1/3 seconds, or to 2549857.333... seconds (using the UT1 timescale.) Since there are 25,920 parts in a day, and since 12 hours + 793 parts is 13,753 parts, the mean lunar period also equates to 29 + (13753/25920) days.

				To compute the duration of time since the Hebrew epoch of the Molad of Tishri for a given year, one simply computes the number of months since the Hebrew epoch up to that year, then multiplies that number of months by the Hebrew Calendar's canonical value for the mean lunar period--which is 29 + (13753/25920) mean solar days, as given above, and adds the result to the moment of occurrence of the Molad Beharad (the epochal new moon of Tishri.)

				The formula for computing the number of months since the Hebrew epoch upto the start of a given (Hebrew) year is expressed by the following function (derived from the 19-year metonic leap-year cycle used by the Hebrew Calendar):

					monthsSinceEpochUpToYear(hebrewYear) =  ((235 * hebrewYear) - 234) div 19

				So the number of (UT1) seconds since the Hebrew epoch of the Molad of Tishri for a given Hebrew year is computed by the following function:

						secondsSinceEpochOfMoladOfTishri(hebrewYear) = 
							(((235 * hebrewYear) - 234) // 19) 	"Number of months since the Hebrew epoch up to the given year"
							* ((29 + (13753/25920)) * 86400)		"times the duration in seconds of the lunar period (one Hebrew month)"
							+ 18680								"plus the number of seconds from the initial moment of the epoch up to the Molad Beharad"

						{Timepoint nominalSecondsSinceEpoch: (((235 * 5765) - 234) // 19) * (29 + (13753/25920)) * 86400 + 18680 calendar: #Hebrew}

			The Dehiyyah: Computing Rosh ha Shannah (New Year's Day) from the Molad of Tishri

				Given the Molad of Tishri for a given Hebrew year, it is necessary to apply the "postponement rules" (the Dehiyyah) to determine the actual date of the Hebrew New Year's Day ("Rosh ha Shannah.") There are four postponement rules, all of which must be satisfied by the actual first day of Tishri, with the effect that the first day of Tishri can be delayed by more than one day from the day on which the Molad of Tishri occurs:

				1. 'Dehiyyah Molad Zaqen' requires that the first day of Tishri (Rosh ha Shannah; New Year's Day) be delayed by one day whenever the candidate day occurs on or after the 18th hour of the Hebrew day (that's on or after 12 noon modern clock time.) 
				2. 'Dehiyyah Lo ADU Rosh' requires that the first day of Tishri be postponed to the following day whenever the candidate day occurs on a Sunday, Wednesday or Friday.  Rules 1 and 2 often both apply, resulting in a 2-day postponement of Rosh ha Shannah.
				3. 'Dehiyyah GaTaRaD' requires that Tishri 1 be postponed to Thursday whenever the candidate day for a 12-month year occurs on Tuesday at 9 hours and 204 parts or later. The effect is to disallow a year from having 356 days. This rule applies roughly once every 30 years.
				4. 'Dehiyyah BeTU'TeKaPoT' requires that Tishri 1 be postponed to Tuesday whenever the candidate day following a 13-month year is on Monday at 15 hours and 589 parts or later. The effect is to disallow a year from having 382 days.  This rule applies roughly once every 186 years.)

			Computing the Length of a Year

				To compute the length of a given <year>, one must compute the number of days since the Hebrew epoch up to the first day of <year>+ 1 and also up to the first day of <year>, and subtract the second value from the first.  There is no other way. 

				And so now you know part of the reason the Hebrew Calendar is so complex.  The other part of the reason is because of its month structure, which is explained below.

		Month Structure

																				D A Y S        P E R		M O N T H
				Month			Civil 		Religious			  		Standard Year					  	Leap Year
								Ordinal	Ordinal			Deficient Regular Complete		Deficient Regular Complete
	
				Tishri				1			7				30			30			30					30			30		30 
				Marheshvan		2			8				29			29			30					29			29		30
				Kislev				3			9				29			30			30					29			30		30
				Teveth				4			10				29			29			29					29			29		29
				Shevat			5			11				30			30			30					30			30		30
				[Adar Rishon		nil/6		nil/12			0			0			0					30			30		30]: Leap Month
				Adar (Sheni)		6/7			12/13			29			29			29					29			29 		29
				Nisan 				7/8			1				30			30			30					30			30		30
				Iyyar				8/9			2				29			29			29					29			29		29
				Sivan				9/10		3				30			30			30					30			30		30
				Tammuz			10/11		4				29			29			29					29			29		29
				Av					11/12		5				30			30			30					30			30		30
				Elul				12/13		6				29			29			29					29			29		29

				Days/year									353		354		355				383		384	385
				Chronos Year Type							  1		  	2		 	 3				 	4		 	 5		  6

			Months have either 29 or 30 days. Most months always have the same number of days every year, either 29 or 30.  The two exceptions are the months of Marheshvan (civil ordinal = 2) and Kislev (civil ordinal = 3.) In a "regular" year (which has 354 days in a standard year, but 384 days in a leap year,) the month of Marheshvan has 29 days and the month of Kislev has 30 days. In a "deficient" year (which has 353 days in a standard year, but 383 days in a leap year,) Marheshvan and Kislev both have 29 days.  In a "complete" year (which has 355 days in a standard year, but 385 day in a leap year,) Marheshvan and Kislev both have 30 days.

			In non-leap years, there are 12 months in a year.  However, in leap years, a 13th leap month is inserted (as month 6) after the fifth month (Shevat) and before the non-leap-year sixth month (Adar,) with the consequence that the month ordinals of the months following the inserted leap month are incremented by one in leap years. The name of the leap month is Adar Rishon ('First Adar.')  In leap years, the month of Adar is referred to as Adar Sheni ('Second Adar,') in order to disambiguate it from Adar Rishon.  The reason that Adar Sheni (instead of Adar Rishon) is considered to be the "same month" as non-leap-year Adar is because the holiday of Purim occurs on Adar 14 in non-leap years, but on Adar Sheni 14 in leap years--and those born in Adar in a non-leap year generally observe their (Jewish) birthday in Adar Sheni in a leap year.

			The semantic month-key of a month is the same as the month's (English) name, except for the months of Adar Rishon and Adar Sheni.  The month-key of Adar Rishon is #AdarL, and the month-key of Adar Sheni is #Adar (the same as that of Adar, since it is semantically the same month.)

			Tishri is the first month of the year.  Elul is the last.  However, the Jewish religion labels the months with a numerical designator such that the month of Nisan (which by mathematical definition is the 7th month of the year in a non-leap year) has the numerical label 1, to indicate that it is the first month of the year for religious purposes--in spite of the fact that New Year's Day (the day whose initial moment marks the transition from one year to the next) is nevertheless the first day of the month of Tishri (whose religious numerical designator is 7.) 

			However, Chronos requires that, for all calendars universally, the ordinal number of the month that contains the first day of the year must be 1 (in other words, the month ordinal must literally be an ordinal number that counts months since the start of the year, and so must be a number greater by one than the cardinal number of months since the month that begins a year.)  Consequently, the Chronos month ordinal for the month of Tishri in the Hebrew Calendar is 1, not 7.

			The Calendar API provides the messages #monthOrdinalFromNumericMonthDesignator:forYearTypeCode: and #numericMonthDesignatorFromMonthOrdinal:forYearTypeCode: for the purpose of translation to/from canonical month ordinals and culturally-correct "numerical month designators." Sending the message #month to a point-in-time object (a DateSpec, YearMonthDay, DateAndTimeSpec or DateAndTime/Timepoint,) provides the mathematically-correct month ordinal of the date (as required by the ANSI-Smalltalk standard.) Sending the message #numericMonthDesignator to a point-in-time object (a DateSpec, YearMonthDay, DateAndTimeSpec or DateAndTime/Timepoint,) provides the culturally-correct month number.  Be sure to use these messages appropriately when capturing dates from, or presenting dates to, the users of an application (a ChronosPrintPolicy can be used to print dates using month ordinals, numeric month designators, month names or month abbreviations.) Applications must provide their own date capture and/or date parsing mechanisms. 
!

!HebrewCalendar class methodsFor: 'fundamental algorithms-conversions' stamp: ''!
daysFromMolads: molads
	^molads * 765433 / 25920! !

!HebrewCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysSinceEpochUpToTishriMoladForYear: year
	"(HebrewCalendar daysSinceEpochUpToTishriMoladForYear: 2) floor"

	^((467 / 2160) + (self daysFromMolads: (((235 * year) - 234) // 19)))! !

!HebrewCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"HebrewCalendar initialize."

	self basicInitialize.! !

!HebrewCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
isLeapYear: year
	^((year * 7) + 1) \\ 19 < 7! !

!HebrewCalendar class methodsFor: 'fundamental algorithms-conversions' stamp: ''!
moladsFromDays: days
	^days * 25920 / 765433! !

!HebrewCalendar class methodsFor: 'fundamental algorithms-conversions' stamp: ''!
moladsFromSeconds: seconds
	^seconds * 3 / 7654330! !

!HebrewCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsFor353DayYear
	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Tishri daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Marheshvan daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Kislev daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Teveth daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shevat daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Adar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Nisan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Iyyar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sivan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tammuz daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Av daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Elul daysPerMonth: 29 leapDayOrdinals: #()).
	^specs contents! !

!HebrewCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsFor354DayYear
	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Tishri daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Marheshvan daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Kislev daysPerMonth: 30 leapDayOrdinals: #(30));
		nextPut: (MonthlyCalendarSpec newWithKey: #Teveth daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shevat daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Adar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Nisan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Iyyar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sivan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tammuz daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Av daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Elul daysPerMonth: 29 leapDayOrdinals: #()).
	^specs contents! !

!HebrewCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsFor355DayYear
	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Tishri daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Marheshvan daysPerMonth: 30 leapDayOrdinals: #(30));
		nextPut: (MonthlyCalendarSpec newWithKey: #Kislev daysPerMonth: 30 leapDayOrdinals: #(30));
		nextPut: (MonthlyCalendarSpec newWithKey: #Teveth daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shevat daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Adar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Nisan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Iyyar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sivan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tammuz daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Av daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Elul daysPerMonth: 29 leapDayOrdinals: #()).
	^specs contents! !

!HebrewCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsFor383DayYear
	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Tishri daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Marheshvan daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Kislev daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Teveth daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shevat daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey: #'Adar Rishon' nameKey: #'Adar Rishon' daysPerMonth: 30 occursEveryYear: false leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Adar nameKey: #'Adar Sheni' daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Nisan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Iyyar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sivan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tammuz daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Av daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Elul daysPerMonth: 29 leapDayOrdinals: #()).
	^specs contents! !

!HebrewCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsFor384DayYear
	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Tishri daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Marheshvan daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Kislev daysPerMonth: 30 leapDayOrdinals: #(30));
		nextPut: (MonthlyCalendarSpec newWithKey: #Teveth daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shevat daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey: #'Adar Rishon' daysPerMonth: 30 occursEveryYear: false leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Adar nameKey: #'Adar Sheni' daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Nisan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Iyyar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sivan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tammuz daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Av daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Elul daysPerMonth: 29 leapDayOrdinals: #()).
	^specs contents! !

!HebrewCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsFor385DayYear
	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Tishri daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Marheshvan daysPerMonth: 30 leapDayOrdinals: #(30));
		nextPut: (MonthlyCalendarSpec newWithKey: #Kislev daysPerMonth: 30 leapDayOrdinals: #(30));
		nextPut: (MonthlyCalendarSpec newWithKey: #Teveth daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shevat daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey: #'Adar Rishon' daysPerMonth: 30 occursEveryYear: false leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Adar nameKey: #'Adar Sheni' daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Nisan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Iyyar daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sivan daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tammuz daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Av daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Elul daysPerMonth: 29 leapDayOrdinals: #()).
	^specs contents! !

!HebrewCalendar class methodsFor: 'fundamental algorithms-conversions' stamp: ''!
partsFromSeconds: seconds
	^seconds * 3 / 10! !

!HebrewCalendar class methodsFor: 'fundamental algorithms-conversions' stamp: ''!
partsPerMolad
	^765433! !

!HebrewCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
partsSinceStartOfDayAtMoladBeharad
	^5604! !

!HebrewCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Hebrew! !

!HebrewCalendar class methodsFor: 'fundamental algorithms-conversions' stamp: ''!
secondsFromMolads: molads
	^molads * 7654330 / 3! !

!HebrewCalendar class methodsFor: 'fundamental algorithms-conversions' stamp: ''!
secondsFromParts: parts
	^parts * 10 / 3! !

!HebrewCalendar class methodsFor: 'fundamental algorithms-conversions' stamp: ''!
secondsPerMolad
	^7654330/3! !

!HebrewCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
secondsSinceStartOfDayAtMoladBeharad
	^18680! !

!HebrewCalendar class methodsFor: 'private' stamp: ''!
setMonthlyCalendarSpecs
	"Initialize the class instance variable monthlyCalendarSpecs, so that it contains an Array of Array of MonthlyCalendarSpecs.  There must be one Array of MonthlyCalendarSpecs in the outer Array (the one referenced by monthlyCalendarSpecs) for each 'year type' of the calendrical system implemented by instances of the receiver.  There must be a MonthlyCalendarSpec in the inner Array for each month for each year type.  See the class comments of ArithmeticalCalendar, Calendar and MonthlyCalendarSpec for more information."

	monthlyCalendarSpecs := Array new: 6.
	monthlyCalendarSpecs 
		at: 1 put: self newMonthlyCalendarSpecsFor353DayYear;	
		at: 2 put: self newMonthlyCalendarSpecsFor354DayYear;	
		at: 3 put: self newMonthlyCalendarSpecsFor355DayYear;	
		at: 4 put: self newMonthlyCalendarSpecsFor383DayYear;
		at: 5 put: self newMonthlyCalendarSpecsFor384DayYear;	
		at: 6 put: self newMonthlyCalendarSpecsFor385DayYear! !

!HebrewCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
yearTypeCodesDo: block1
	1 to: 6 do: [:ytc | block1 value: ytc]! !

!HebrewCalendar methodsFor: 'private' stamp: ''!
basicDaysSinceEpochUpToYear: year
	
	| molads basicDaysSinceEpoch ordinalDayNumber |

	molads := self monthsSinceEpochUpToYear: year.

	"'Dehiyyah Molad Zaqen' requires that the first day of Tishri (aka Rosh ha Shannah; New Year's Day) be delayed by one day whenever the Molad of Tishri (the computed occurrence of the new moon on or after which the month of Tishri should start) occurs on or after the 18th hour of the Hebrew day (that's on or after 12 noon modern clock time.) This rule is enforced by adding 6 hours (6480 parts) to the time for Molad Beharad (the new moon that marks the Epoch Day of the Hebrew Calendar, which is set by definition at 5604 parts since-start-of-day on Epoch Day, which corresponds to precisely -3760-09-06T23:11:20 Gregorian (using astronomical year numbering, as required by both ANSI and ISO standards))  The occurence of the value 12804 (6480 + 5604 = 12804) as an additive term in the expression in the statement that follows this comment implements the algorithmic enforcement of this rule."

	basicDaysSinceEpoch := 29 * molads + (((13753 * molads) + 12804) / 25920) floor.

	"'Dehiyyah Lo ADU Rosh' requires that the first day of Tishri be postponed to the following day whenever the Molad of Tishri occurs on a Sunday, Wednesday or Friday. This is implemented using the following logic:"

	ordinalDayNumber := basicDaysSinceEpoch + 1.
	^3 * ordinalDayNumber \\ 7 < 3
		ifTrue: 
			["The Molad occurs on Sunday, Wednesday or Friday, so the start-of-year is delayed by one day."
			ordinalDayNumber]
		ifFalse: 
			["The Molad occurs on Monday, Tuesday, Thursday or Saturday, so the start-of-year is not delayed by 'Dehiyyah Lo ADU Rosh'."
			basicDaysSinceEpoch]! !

!HebrewCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^347997 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!HebrewCalendar methodsFor: 'API-queries-years' stamp: ''!
daysInYear: year
	"Answer the number of days in the given <year>."

	"{(-10000 to: 10000) do: [:year | 
		| daysInYearA daysInYearB |
		daysInYearA := HebrewCalendar daysInYear: year.
		daysInYearB := (HebrewCalendar daysSinceEpochUpToYear: year + 1) - (HebrewCalendar daysSinceEpochUpToYear: year).
		daysInYearA = daysInYearB ifFalse: [year halt].
		year -> daysInYearA]}"

	"{HebrewCalendar daysInYear: 5765}"

	"^(self daysSinceEpochUpToYear: year + 1) - (self daysSinceEpochUpToYear: year)"

	| daysUpToYear0 daysUpToYear1 daysUpToYear2 daysUpToYear3 |
	daysUpToYear1 := self basicDaysSinceEpochUpToYear: year.
	daysUpToYear2 := self basicDaysSinceEpochUpToYear: year + 1.
	daysUpToYear3 := self basicDaysSinceEpochUpToYear: year + 2.
	(daysUpToYear3 - daysUpToYear2) = 356 
		ifTrue: [daysUpToYear2 := daysUpToYear2 + 2]
		ifFalse:
			[(daysUpToYear2 - daysUpToYear1) = 382 
				ifTrue: [daysUpToYear2 := daysUpToYear2 + 1]].

	(daysUpToYear2 - daysUpToYear1) = 356 
		ifTrue: [daysUpToYear1 := daysUpToYear1 + 2]
		ifFalse:
			[daysUpToYear0 := self basicDaysSinceEpochUpToYear:  year - 1.
			(daysUpToYear1 - daysUpToYear0) = 382 
				ifTrue: [daysUpToYear1 := daysUpToYear1 + 1]].
	^daysUpToYear2 - daysUpToYear1! !

!HebrewCalendar methodsFor: 'API-queries-years' stamp: ''!
daysInYearForYearTypeCode: yearTypeCode
	"Answer the number of days per year there are in a year whose type is identified by the code <yearTypeCode>."

	^yearTypeCode < 4
		ifTrue: [352 + yearTypeCode]
		ifFalse: [379 + yearTypeCode]! !

!HebrewCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: year 
	"Answer the number of days since the receiver's epoch up to (but not including) the <dayOfMonthOrdinal>th day of the <monthOrdinal>th month of the given <calendarYear>.  By definition, the answer when <calendarYear> = 1 (assuming positve years are ordinal numbers,) <monthOrdinal> = 1 and <dayOfMonthOrdinal> = 1 must be zero."

	| daysUpToYear0 daysUpToYear1 daysUpToYear2 daysUpToYear3 daysInYear yearTypeCode |
	daysUpToYear1 := self basicDaysSinceEpochUpToYear: year.
	daysUpToYear2 := self basicDaysSinceEpochUpToYear: year + 1.
	daysUpToYear3 := self basicDaysSinceEpochUpToYear: year + 2.
	(daysUpToYear3 - daysUpToYear2) = 356 
		ifTrue: [daysUpToYear2 := daysUpToYear2 + 2]
		ifFalse:
			[(daysUpToYear2 - daysUpToYear1) = 382 
				ifTrue: [daysUpToYear2 := daysUpToYear2 + 1]].

	(daysUpToYear2 - daysUpToYear1) = 356 
		ifTrue: [daysUpToYear1 := daysUpToYear1 + 2]
		ifFalse:
			[daysUpToYear0 := self basicDaysSinceEpochUpToYear:  year - 1.
			(daysUpToYear1 - daysUpToYear0) = 382 
				ifTrue: [daysUpToYear1 := daysUpToYear1 + 1]].

	daysInYear := daysUpToYear2 - daysUpToYear1.
	yearTypeCode := daysInYear < 356 ifTrue: [daysInYear - 352] ifFalse: [daysInYear - 379].
 	^daysUpToYear1+ ((yearlyCalendars at: yearTypeCode) daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal)! !

!HebrewCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"HebrewCalendar daysSinceEpochUpToYear: 5766"

	| daysUpToYear daysUpToNextYear daysUpToPrevYear |
	daysUpToYear := self basicDaysSinceEpochUpToYear: calendarYear.
	daysUpToNextYear := self basicDaysSinceEpochUpToYear: calendarYear + 1.
	(daysUpToNextYear - daysUpToYear) = 356 "'Dehiyyah GaTaRaD' requires that Tishri 1 be postponed to Thursday whenever the Molad of Tishri for a 12-month year is on Tuesday at 9 hours and 204 parts or later. The effect is to disallow a year from having 356 days--a fact that this implementation uses to simply and easily enforce the rule."
		ifTrue: [^daysUpToYear + 2].
	daysUpToPrevYear := self basicDaysSinceEpochUpToYear: calendarYear -1.
	^(daysUpToYear - daysUpToPrevYear) = 382 "'Dehiyyah BeTU'TeKaPoT' requires that Tishri 1 be postponed to Tuesday whenever the Molad of Tishri following a 13-month year is on Monday at 15 hours and 589 parts or later. The effect is to disallow a year from having 382 days--a fact that this implementation uses to simply and easily enforce the rule."
		ifTrue: [daysUpToYear + 1]
		ifFalse: [daysUpToYear]! !

!HebrewCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	"{(-10000 to: 10000) do: [:year | 
		HebrewCalendar canonical
			forDaysSinceEpoch: (HebrewCalendar canonical daysSinceEpochUpToYear: year) 
			setYearAndCalendarDayInto: [:y :calendarDay | (y = year and: [calendarDay dayOfYear = 1]) ifFalse: [year halt]. y->calendarDay]]}"

	"{HebrewCalendar canonical
			forDaysSinceEpoch: (HebrewCalendar canonical daysSinceEpochUpToYear: 5766)
			setYearAndCalendarDayInto: [:y :calendarDay | y->calendarDay]}"

	| year daysSinceStartOfYear daysSinceEpochAtStartOfYear daysSinceEpochAtStartOfYear1 daysUpToYear daysUpToNextYear daysUpToPrevYear |
	year := daysSinceEpoch * 98496 // 35975351 + 1. "Approximation based on average length of a calendar year--error range is from -1 to +1 years."

	"daysSinceEpochAtStartOfYear := self daysSinceEpochUpToYear: year."

	daysUpToYear := self basicDaysSinceEpochUpToYear: year.
	daysUpToNextYear := self basicDaysSinceEpochUpToYear: year + 1.
	(daysUpToNextYear - daysUpToYear) = 356 "'Dehiyyah GaTaRaD' requires that Tishri 1 be postponed to Thursday whenever the Molad of Tishri for a 12-month year is on Tuesday at 9 hours and 204 parts or later. The effect is to disallow a year from having 356 days--a fact that this implementation uses to simply and easily enforce the rule."
		ifTrue: [daysSinceEpochAtStartOfYear := daysUpToYear + 2]
		ifFalse: 
			[daysUpToPrevYear := self basicDaysSinceEpochUpToYear: year -1.
			(daysUpToYear - daysUpToPrevYear) = 382 "'Dehiyyah BeTU'TeKaPoT' requires that Tishri 1 be postponed to Tuesday whenever the Molad of Tishri following a 13-month year is on Monday at 15 hours and 589 parts or later. The effect is to disallow a year from having 382 days--a fact that this implementation uses to simply and easily enforce the rule."
				ifTrue: [daysSinceEpochAtStartOfYear := daysUpToYear + 1]
				ifFalse: [daysSinceEpochAtStartOfYear := daysUpToYear]].

	daysSinceStartOfYear := daysSinceEpoch - daysSinceEpochAtStartOfYear.
	daysSinceStartOfYear < 0 
		ifTrue: 
			["Approximation error: -1 years."
			year := year - 1.

			daysUpToNextYear := daysUpToYear.
			daysUpToYear := daysUpToPrevYear == nil ifTrue: [self basicDaysSinceEpochUpToYear: year] ifFalse: [daysUpToPrevYear].
			(daysUpToNextYear - daysUpToYear) = 356 "'Dehiyyah GaTaRaD' requires that Tishri 1 be postponed to Thursday whenever the Molad of Tishri for a 12-month year is on Tuesday at 9 hours and 204 parts or later. The effect is to disallow a year from having 356 days--a fact that this implementation uses to simply and easily enforce the rule."
				ifTrue: [daysSinceEpochAtStartOfYear := daysUpToYear + 2]
				ifFalse: 
					[daysUpToPrevYear := self basicDaysSinceEpochUpToYear: year -1.
					(daysUpToYear - daysUpToPrevYear) = 382 "'Dehiyyah BeTU'TeKaPoT' requires that Tishri 1 be postponed to Tuesday whenever the Molad of Tishri following a 13-month year is on Monday at 15 hours and 589 parts or later. The effect is to disallow a year from having 382 days--a fact that this implementation uses to simply and easily enforce the rule."
						ifTrue: [daysSinceEpochAtStartOfYear := daysUpToYear + 1]
						ifFalse: [daysSinceEpochAtStartOfYear := daysUpToYear]].

			daysSinceStartOfYear := daysSinceEpoch - daysSinceEpochAtStartOfYear "(self basicDaysSinceEpochUpToYear: year)"]
		ifFalse: 
			[daysSinceStartOfYear >= 353 "Minimum number of days in a year."
				ifTrue: 
					["daysSinceEpochAtStartOfYear1 := self daysSinceEpochUpToYear: year + 1."

					daysUpToPrevYear := daysUpToYear.
					daysUpToYear := daysUpToNextYear.
					daysUpToNextYear := self basicDaysSinceEpochUpToYear: year + 2.
					(daysUpToNextYear - daysUpToYear) = 356 "'Dehiyyah GaTaRaD' requires that Tishri 1 be postponed to Thursday whenever the Molad of Tishri for a 12-month year is on Tuesday at 9 hours and 204 parts or later. The effect is to disallow a year from having 356 days--a fact that this implementation uses to simply and easily enforce the rule."
						ifTrue: [daysSinceEpochAtStartOfYear1 := daysUpToYear + 2]
						ifFalse: 
							[(daysUpToYear - daysUpToPrevYear) = 382 "'Dehiyyah BeTU'TeKaPoT' requires that Tishri 1 be postponed to Tuesday whenever the Molad of Tishri following a 13-month year is on Monday at 15 hours and 589 parts or later. The effect is to disallow a year from having 382 days--a fact that this implementation uses to simply and easily enforce the rule."
								ifTrue: [daysSinceEpochAtStartOfYear1 := daysUpToYear + 1]
								ifFalse: [daysSinceEpochAtStartOfYear1 := daysUpToYear]].

					daysSinceEpochAtStartOfYear1 <= daysSinceEpoch 
						ifTrue: 
							["Approximation error: +1 years."
							year := year + 1.
							daysSinceStartOfYear := daysSinceEpoch - daysSinceEpochAtStartOfYear1]]].
	^yearMonthDaySpecOrBlock2 
		value: year 
		value: ((yearlyCalendars at: (self typeCodeOfYear: year)) basicDayAt: daysSinceStartOfYear + 1)! !

!HebrewCalendar methodsFor: 'API-testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the calendrical system represented by the receiver starts each day at local midnight."

	^false! !

!HebrewCalendar methodsFor: 'API-queries-months' stamp: ''!
monthOrdinalFromNumericMonthDesignator: numericalMonthDesignator forYearTypeCode: yearTypeCode
	"Answer the month ordinal for the month identified by the culturally-correct numeric designator <numericalMonthDesignator>, for a year whose type is identified by the code <yearTypeCode>."

	| monthOrdinal |
	monthOrdinal := numericalMonthDesignator - 6.
	^monthOrdinal < 1
		ifTrue: [monthOrdinal + (self monthsInYearForYearTypeCode: yearTypeCode)]
		ifFalse: [monthOrdinal]! !

!HebrewCalendar methodsFor: 'API-queries-months' stamp: ''!
monthsInYear: year
	"Answer the number of months there are in the given <year>."

	^((year * 7) + 1) \\ 19 < 7
		ifTrue: [13] ifFalse: [12]! !

!HebrewCalendar methodsFor: 'API-queries-months' stamp: ''!
monthsInYearForYearTypeCode: yearTypeCode 
	"Answer the number of months there are per year, in a year whose typeCode is <yearTypeCode>."

	^yearTypeCode < 4
		ifTrue: [12]
		ifFalse: [13]! !

!HebrewCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
monthsSinceEpochUpToYear: year 
	"Answer the count of months since the Epoch day (start of day) up to (but NOT including) the first month of the specified year."

	^((235 * year) - 234) // 19! !

!HebrewCalendar methodsFor: 'API-queries-months' stamp: ''!
numericMonthDesignatorFromMonthOrdinal: monthOrdinal forYearTypeCode: yearTypeCode
	"Answer the culturally-correct numeric designator that identifies the month whose ordinal is <monthOrdinal>, for a year whose type is identified by the code <yearTypeCode>."

	| designator monthsInYear |
	designator := monthOrdinal + 6.
	monthsInYear := self monthsInYearForYearTypeCode: yearTypeCode.
	^designator > monthsInYear 
		ifTrue: [designator - monthsInYear]
		ifFalse: [designator]! !

!HebrewCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay
	"Answer the number of seconds-since-start-of-day relative to midnight represented by the argument, <secondsSinceStartOfDay>, where the argument is specified relative to the receiver's canonical start-of-day (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since midnight clock time that corresponds to the number of seconds since the receiver's canonical start-of-day clock time, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for time systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Julian Day time system, the canonical start-of-day is Noon."

	^secondsSinceStartOfDay + 64800! !

!HebrewCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceStartOfDayFromSecondsSinceMidnight: secondsSinceMidnight
	"Answer the number of seconds-since-start-of-day relative to the receiver's canonical start-of-day represented by the argument, <secondsSinceMidnight>, where the argument is specified relative to midnight (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since the receiver's canonical start-of-day clock time that corresponds to the number of seconds since midnight, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for calendar systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Hebrew calendar, the canonical start-of-day is 6pm."

	^secondsSinceMidnight + 21600! !

!HebrewCalendar methodsFor: 'API-Date Construction' stamp: ''!
startingWithYear: startYear addingDays: dayDelta setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2 
	"For a year and CalendarDay that is dayDelta days since the first day of the year <startYear>, send #value:value: to <yearMonthDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	^self 
		forDaysSinceEpoch: (self daysSinceEpochUpToYear: startYear) + dayDelta
		setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2! !

!HebrewCalendar methodsFor: 'API-Date Construction' stamp: ''!
startingWithYear: startYear addingMonths: monthDelta setYearAndMonthsSinceStartOfYearInto: block2 
	"For a year and months-since-start-of-year that is monthDelta months since the first month of the year <startYear>, send #value:value: to <block2>, with the year as the first argument and the months-since-start-of-year as the second argument."

	"{HebrewCalendar canonical
		forMonthsSinceEpoch: (YearMonthDay year: 5000 month: 1 day: 1 calendar: #Hebrew) monthsSinceEpoch 
		setYearAndMonthsSinceStartOfYearInto: [:y :m | YearMonthDay year: y month: m + 1 day: 1 calendar: #Hebrew]}"

	| months monthsInYear year |
	months := monthDelta rem: 235.
	year := startYear + ((monthDelta quo: 235) * 19).
	[months >= (monthsInYear := self monthsInYear: year)] 
		whileTrue: 
			[year := year + 1.
			months := months - monthsInYear].
	[months < 0] whileTrue: 
			[year := year - 1.
			months := months + (monthsInYear := self monthsInYear: year)].
	^block2 value: year value: months! !

!HebrewCalendar methodsFor: 'API-testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the calendrical system implemented by the receiver coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^false! !

!HebrewCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	"{(-10000 to: 10000) do: [:year | 
		| typeCode isLeapYear |
		typeCode := HebrewCalendar canonical typeCodeOfYear: year.
		isLeapYear := HebrewCalendar isLeapYear: year.
		(isLeapYear and: [typeCode < 4]) ifTrue: [year halt].
		(typeCode < 1 or: [typeCode > 6]) ifTrue: [year halt]]}"

	"{HebrewCalendar typeCodeOfYear: 5765}"

	| daysInYear |
	daysInYear := self daysInYear: calendarYear.
	^daysInYear < 356 
		ifTrue: [daysInYear - 352]
		ifFalse: [daysInYear - 379]! !

RegularCalendar subclass: #MonthsPerYearInvariantCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!MonthsPerYearInvariantCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

MonthsPerYearInvariantCalendar	

	Concept:

		MonthsPerYearInvariantCalendar is an abstract Calendar class whose subclasses implement arithmetical calendars that have the same number of months in any and all years (most calendrical systems have this property.)  

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of ArithmetiicalCalendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

	Subclassing:

		The following class methods must be subimplemented by any concrete subclass (see the method comment for the method semantics):

			newMonthlyCalendarSpecsForStandardYear
			newMonthlyCalendarSpecsForLeapYear!

MonthsPerYearInvariantCalendar subclass: #BahaiCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!BahaiCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

BahaiCalendar

	Concept:

		BahaiCalendar implements the Bahai Calendar, the official calendar of the Bahai religion. Although the Bahai Calendar is at this time officially specified as an arithmetical calendar, the Bahais apparently intend at some future point to change their calendar from an arithmetical to an astronomical calendar, wherein leap years would be determined by astronomical calculations (as a function of the number of astronomically-computed days between vernal equinoxes.)

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Bahai Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Bahai Calendar (as implemented here) is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Bahai Calendar, 0001-01-01 [Bahai], corresponds to 1844-03-21 [Gregorian] and to 1844-03-09 [Julian].  Bahai days begin at sunset. The Julian Date of the Bahai epoch is 2,394,646.25 (6 pm,) so the actual initial moment of the Bahai epoch corresponds to 1844-03-20T18:00:00 [Gregorian] and to 1844-03-08T18:00:00 [Julian]. 

			The Bahai epoch is the Vernal Equinox of the year in which Siyyid Mrz 'Al-Muhammad was first recognized as a Manifestation of God by Mull Husayn, and took the title "The Bb."  The Bb was the forerunner to Baha' Ullah, the principal figure of the Bahai religion.

			The Bahai era is called just that: the "Bahai Era" (BE)--which is in English, obviously.

		Time-of-Day Clock

			Although Bahai days begin at sunset, Bahais label the hours of the day beginning at midnight.  So the zero-point of the the time-of-day clock is midnight, although the initial moment of the day is 6 pm. 

			{BahaiCalendar clock today}
			{BahaiCalendar clock now}

		Year Numbering Policy

			The  Bahai Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			A year is a leap year if its ordinal is evenly divisible by 400, or else if its ordinal is evenly divisible by 4 but not by 100.  Consequently, the year 400 is a leap year (evenly divisible by 400,) the year 300 is not a leap year (evenly divisible by 100, but not by 400,) the year 180 is a leap year (evenly divisible by 4, but not by 100,) and the year 166 is not a leap year (divisible neither by 4 nor by 400.)

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Bah						19/19
			2: Jall						19/19
			3: Jaml					19/19
			4: 'Azamat					19/19
			5: Nr						19/19
			6: Rahmat					19/19
			7: Kalimt					19/19
			8: Kaml					19/19
			9: Asm'					19/19
			10: 'Izzat					19/19
			11: Mashyyat				19/19
			12: 'Ilm						19/19
			13: Qudrat					19/19
			14: Qawl					19/19
			15: Mas'il					19/19
			16: Sharaf					19/19
			17: Sultn					19/19
			18: Mulk					19/19
			19: Ayym-i-H				4/5
			20: 'Al						19/19
		
			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)



!

!BahaiCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"BahaiCalendar initialize."

	self basicInitialize.! !

!BahaiCalendar class methodsFor: 'functional verification' stamp: ''!
minVerificationYearCardinal
	^0! !

!BahaiCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #'Bah' 						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Jall' 						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Jaml'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'''Azamat' 					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Nr'							daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Rahmat' 					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Kalimt' 					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Kaml'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Asm'''						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'''Izzat'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Mashyyat'					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'''Ilm'							daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Qudrat'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Qawl' 						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Mas''il' 					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Sharaf'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Sultn'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Mulk'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey: #'Ayym-i-H' 	daysPerMonth: 5 occursEveryYear: true leapDayOrdinals: #(5));
		nextPut: (MonthlyCalendarSpec newWithKey: #'''Al' 						daysPerMonth: 19 leapDayOrdinals: #()).
	^specs contents! !

!BahaiCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #'Bah' 						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Jall' 						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Jaml'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'''Azamat' 					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Nr'							daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Rahmat' 					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Kalimt' 					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Kaml'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Asm'''						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'''Izzat'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Mashyyat'					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'''Ilm'							daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Qudrat'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Qawl' 						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Mas''il' 					daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Sharaf'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Sultn'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Mulk'						daysPerMonth: 19 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey: #'Ayym-i-H' 	daysPerMonth: 5 occursEveryYear: true leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'''Al' 						daysPerMonth: 19 leapDayOrdinals: #()).
	^specs contents! !

!BahaiCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Bahai! !

!BahaiCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^2394646 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!BahaiCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"BahaiCalendar canonical daysSinceEpochUpToYear: 5"

	| cardinalYear |
	cardinalYear := calendarYear - 1.
	^ cardinalYear * 365 
		+ (cardinalYear // 4) 
		- (cardinalYear // 100) 
		+ (cardinalYear // 400)! !

!BahaiCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."
	"days-in-four-year-cycle=1461; days-in-century=36524; days-in-four-centuries=146097; days-in-20 centuries=730485 "

	| quadCentury century quadYear year days yearTypeCode |
	quadCentury := daysSinceEpoch // 146097.
	days := daysSinceEpoch \\ 146097.
	century := days // 36524.
	days := days \\ 36524.
	(days == 0 and: [century == 4]) 
		ifTrue: 
			["Handle the 36524th cardinal day--a leap day"
			century := century - 1.
			days := 36524].
	quadYear := days // 1461.
	days := days \\ 1461.
	year := days // 365.
	days := days \\ 365.
	(days == 0 and: [year == 4]) 
		ifTrue: 
			["Handle the 365th cardinal day--a leap day"
			year := year - 1.
			days := 365].
	yearTypeCode := 
		year == 3 "Last year in 4-year cycle"
			ifTrue: 
				[quadYear = 24 "last 4-year cycle in century"
					ifTrue: 
						[century = 3 "last century in 4-century cycle" 
							ifTrue: [2] ifFalse: [1]]
					ifFalse: [2]]
			ifFalse: [1].
	^yearMonthDaySpecOrBlock2
		value: (year + (quadCentury * 400) + (century * 100) + (quadYear * 4))  + 1
		value: ((yearlyCalendars at: yearTypeCode) basicDayAt: days + 1)! !

!BahaiCalendar methodsFor: 'API-testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the calendrical system represented by the receiver starts each day at local midnight."

	^false! !

!BahaiCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay
	"Answer the number of seconds-since-start-of-day relative to midnight represented by the argument, <secondsSinceStartOfDay>, where the argument is specified relative to the receiver's canonical start-of-day (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since midnight clock time that corresponds to the number of seconds since the receiver's canonical start-of-day clock time, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for time systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Julian Day time system, the canonical start-of-day is Noon."

	^secondsSinceStartOfDay + 64800! !

!BahaiCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceStartOfDayFromSecondsSinceMidnight: secondsSinceMidnight
	"Answer the number of seconds-since-start-of-day relative to the receiver's canonical start-of-day represented by the argument, <secondsSinceMidnight>, where the argument is specified relative to midnight (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since the receiver's canonical start-of-day clock time that corresponds to the number of seconds since midnight, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for calendar systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Hebrew calendar, the canonical start-of-day is 6pm."

	^secondsSinceMidnight + 21600! !

!BahaiCalendar methodsFor: 'API-testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the calendrical system implemented by the receiver coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^false! !

!BahaiCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^calendarYear \\ 4 == 0 
		ifTrue: [calendarYear \\ 100 == 0 
					ifTrue: [calendarYear \\ 400 == 0 
								ifTrue: [2] 
								ifFalse: [1]] 
					ifFalse: [2]]
		ifFalse: [1]! !

MonthsPerYearInvariantCalendar subclass: #CopticCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!CopticCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CopticCalendar

	Concept:

		CopticCalendar implements the Coptic Calendar.  The Copts are a Christian culture ethnically descended from the Pharonic Egyptians.  Their calendar is derived from the ancient Egyptian solar calendar, but unlike that calendar, uses leap years to more accurately reflect the length of the solar year.
		
		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Coptic Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Coptic Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Coptic Calendar, 0001-01-01 [Coptic], corresponds to 0284-08-29 [Gregorian and Julian].  Coptic days begin at sunset. The Julian Date of the Coptic epoch is 1,825,029.25 (6 pm,) so the actual initial moment of the Coptic epoch corresponds to 0284-08-28T18:00:00 [Gregorian and Julian]. 

			The Coptic epoch date is the first day of the year in the ancient Egyptian Calendar in which Diocletian ascended to the office of Emperor of Rome. This year marks the beginning of what is generally known as the Diocletian Era, although Copts call it the Era of Martyrs in memory of the many Christians tortured to death by Emperor Diocletian. This year was widely used as the epoch year in Europe (along with the leap year rule and month structure of the Imperial Julian Calendar) until around the Ninth Century, when almost all Christians began to use the modern "Anno Domini" era--with the obvious exception of the Copts.

			The Coptic era is called "Anno Martyrum" (AM)--which is Latin for "In the Year of the Martyrs."

		Time-of-Day Clock

			Although Coptic days begin at sunset, Copts label the hours of the day beginning at midnight.  So the zero-point of the the time-of-day clock is midnight, although the initial moment of the day is 6 pm. 

			{CopticCalendar clock today}
			{CopticCalendar clock now}

		Year Numbering Policy

			The Coptic Calendar uses "zeroless ordinal" year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year -1.

		Leap Year Rule

			A year is a leap year if dividing the year ordinal by 4 leaves a remainder of 3.

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Thoout					30/30
			2: Paope					30/30
			3: Athor						30/30
			4: Koiak					30/30
			5: Tobe						30/30
			6: Meshir					30/30
			7: Paremotep				30/30
			8: Parmoute					30/30
			9: Pashons					30/30
			10: Paone					30/30
			11: Epep					30/30
			12: Mesore					30/30
			13: Epagomene				5/6

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)



!

!CopticCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"CopticCalendar initialize."

	self basicInitialize.! !

!CopticCalendar class methodsFor: 'private' stamp: ''!
newDefaultYearNumberingPolicy
	"Answer a new NumberingPolicy to be used as the the policy for interpreting year numbers in the calendrical system implemented by instances of the receiver. NOTE: The ANSI Smalltalk standard REQUIRES the use of 'Astronomical Year Numbering' (i.e., an OrdinalNumberingPolicy) for dates in the Gregorian calendar. The ISO 8601 standard imposes the same requirement."

	^self newZerolessOrdinalYearNumberingPolicy! !

!CopticCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Thoout					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Paope 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Athor 						daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Koiak 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tobe	 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Meshir 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Paremotep 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Parmoute		 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Pashons 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Paone 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Epep 						daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Mesore 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey:  #Epagomene 	daysPerMonth: 6 occursEveryYear: true leapDayOrdinals: #(6)).
	^specs contents! !

!CopticCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Thoout					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Paope 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Athor 						daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Koiak 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tobe	 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Meshir 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Paremotep 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Parmoute		 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Pashons 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Paone 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Epep 						daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Mesore 					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey:  #Epagomene 	daysPerMonth: 5 occursEveryYear: true leapDayOrdinals: #()).
	^specs contents! !

!CopticCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Coptic! !

!CopticCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^1825029 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!CopticCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	| cardinalYear ordinalYear |
	cardinalYear := yearNumberingPolicy cardinalFromCanonical: calendarYear.
	ordinalYear := yearNumberingPolicy ordinalFromCanonical: calendarYear.
	^cardinalYear * 365 + (ordinalYear // 4) "NOT exactly the same as Julian rule, since Year 0003 is a Coptic leap year, but not a Julian leap year."! !

!CopticCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2 
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	"CopticCalendar canonical forDaysSinceEpoch: (7*365) negated setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"

	| quadYear year days yearTypeCode |
	quadYear := daysSinceEpoch // 1461.
	days := daysSinceEpoch \\ 1461.
	year := days // 365.
	days := days \\ 365.
	year >= 3 	"<year> and <days> are both CARDINAL numbers here"
		ifTrue: 
			[days = 0 
				ifTrue: 
					[year := year - 1.
					year = 2 
						ifTrue: 
							[days := 365.
							yearTypeCode := 2]
						ifFalse: 
							[days := 364.
							yearTypeCode := 1]]
				ifFalse: 
					[days := days - 1.
					yearTypeCode := 1]]
		ifFalse: [yearTypeCode := year = 2 ifTrue: [2] ifFalse: [1]].
	^yearMonthDaySpecOrBlock2 
		value: (yearNumberingPolicy canonicalFromCardinal: year + (quadYear * 4))
		value: ((yearlyCalendars at: yearTypeCode) basicDayAt: days + 1)! !

!CopticCalendar methodsFor: 'API-testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the calendrical system represented by the receiver starts each day at local midnight."

	^false! !

!CopticCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay
	"Answer the number of seconds-since-start-of-day relative to midnight represented by the argument, <secondsSinceStartOfDay>, where the argument is specified relative to the receiver's canonical start-of-day (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since midnight clock time that corresponds to the number of seconds since the receiver's canonical start-of-day clock time, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for time systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Julian Day time system, the canonical start-of-day is Noon."

	^secondsSinceStartOfDay + 64800! !

!CopticCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceStartOfDayFromSecondsSinceMidnight: secondsSinceMidnight
	"Answer the number of seconds-since-start-of-day relative to the receiver's canonical start-of-day represented by the argument, <secondsSinceMidnight>, where the argument is specified relative to midnight (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since the receiver's canonical start-of-day clock time that corresponds to the number of seconds since midnight, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for calendar systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Hebrew calendar, the canonical start-of-day is 6pm."

	^secondsSinceMidnight + 21600! !

!CopticCalendar methodsFor: 'API-testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the calendrical system implemented by the receiver coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^false! !

!CopticCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^calendarYear \\ 4 == 3
		ifTrue: [2]
		ifFalse: [1]! !

CopticCalendar subclass: #EthiopicCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!EthiopicCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

EthiopicCalendar

	Concept:

		EthiopicCalendar implements the Ethiopic Calendar.  The Ethiopic Calendar  is the principal calendar used in Ethiopia. The Ethiopic Calendar is derived from the ancient Egyptian solar calendar, but unlike that calendar, uses leap years to more accurately reflect the length of the solar year. It has the same leap year rule, month structure and New Year's Day as the Coptic Calendar, but has a different epoch year. Culturally, the usage of the Ethiopian Calendar in Ethiopia is strongly motivated by Ethiopia's main religions, the Coptic Church and the Ethiopian Orthodox Tewahido Church.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Ethiopic Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Ethiopic Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Ethiopic Calendar, 0001-01-01 [Ethiopic], corresponds to 0008-08-27 [Gregorian] and to 0008-08-29 [Julian].  Ethiopic days begin at sunrise. The Julian Date of the Ethiopic epoch is 1,724,220.75 (6 am,) so the actual initial moment of the Ethiopic epoch corresponds to 0008-08-27T06:00:00 [Gregorian] and to 0008-08-29T06:00:00 [Julian]. 
	
			The Ethiopic epoch date is the first day of the year in the ancient Egyptian Calendar after which Christ was born by the reckoning of the Ethiopian Orthodox Christian Church.

			Years on or after the epoch of the Ethiopic Calendar are said to be in the era "Zemene Haddis" (ZH)--which is Ethiopian for "Incarnation Era"  Alternatively, this era is also called "Amete Mihret" (AM)--which is Ethiopian for "years of mercy".  Chronos does not use "AM" in connection with the Ethiopic Calendar in order to avoid confusion with both "Anno Mundi" and "Anno Martyrum."  Years before the epoch are said to be in the era "Zemene Bluy" (ZB)--which is the Ethiopian equivalent of "Before Christ."

		Time-of-Day Clock

			Sunrise (6 am) is both the zero-point of the time-of-day clock and also the initial moment of the day. 

			{EthiopicCalendar clock today asGregorian}
			{EthiopicCalendar clock now}

		Year Numbering Policy

			The Ethiopic Calendar uses "zeroless ordinal" year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year -1.

		Leap Year Rule

			A year is a leap year if dividing the year ordinal by 4 leaves a remainder of 3.

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Maskaram				30/30
			2: Teqemt					30/30
			3: Khedar					30/30
			4: Takhsas					30/30
			5: Ter						30/30
			6: Yakatit					30/30
			7: Magabit					30/30
			8: Miyazya					30/30
			9: Genbot					30/30
			10: Sane					30/30
			11: Hamle					30/30
			12: Nahase					30/30
			13: Paguemen				5/6

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)


!

!EthiopicCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"EthiopicCalendar initialize."

	self basicInitialize.! !

!EthiopicCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Maskaram 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Teqemt 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Khedar 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Takhsas 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Ter	 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Yakatit 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Magabit	 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Miyazya	 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Genbot 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sane					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Hamle 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Nahase 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey: #Paguemen	daysPerMonth: 6 occursEveryYear: true leapDayOrdinals: #(6)).
	^specs contents! !

!EthiopicCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Maskaram 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Teqemt 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Khedar 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Takhsas 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Ter	 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Yakatit 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Magabit	 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Miyazya	 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Genbot 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sane					daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Hamle 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Nahase 				daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newIntercalaryWithKey: #Paguemen	daysPerMonth: 5 occursEveryYear: true leapDayOrdinals: #()).
	^specs contents! !

!EthiopicCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Ethiopic! !

!EthiopicCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^1724220 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!EthiopicCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay
	"Answer the number of seconds-since-start-of-day relative to midnight represented by the argument, <secondsSinceStartOfDay>, where the argument is specified relative to the receiver's canonical start-of-day (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since midnight clock time that corresponds to the number of seconds since the receiver's canonical start-of-day clock time, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for time systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Julian Day time system, the canonical start-of-day is Noon."

	^secondsSinceStartOfDay + 21600! !

!EthiopicCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceStartOfDayFromSecondsSinceMidnight: secondsSinceMidnight
	"Answer the number of seconds-since-start-of-day relative to the receiver's canonical start-of-day represented by the argument, <secondsSinceMidnight>, where the argument is specified relative to midnight (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since the receiver's canonical start-of-day clock time that corresponds to the number of seconds since midnight, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for calendar systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Hebrew calendar, the canonical start-of-day is 6pm."

	^secondsSinceMidnight + 64800! !

!EthiopicCalendar methodsFor: 'API-testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the calendrical system implemented by the receiver coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^true! !

MonthsPerYearInvariantCalendar subclass: #IndianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!IndianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

IndianCalendar

	Concept:

		IndianCalendar implements the Indian Civil Calendar, which is the official, civil calendar of India. A bewildering variety of calendars have been and continue to be used in the Indian subcontinent. In 1957 the Indian government's Calendar Reform Committee adopted the National Calendar of India for civil purposes and, in addition, defined guidelines to standardise computation of the religious calendar, which is based on astronomical observations. The civil calendar is used throughout India today for administrative purposes, but a variety of religious calendars remain in use.  Most Indians use the Gregorian Calendar for business purposes, and one of the variations of the religous calendar for the purposes of observing religious holidays, festivals and ceremonies.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Indian Civil Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Indian (Civil) Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Indian Civil Calendar, 0001-01-01 [Indian Civil], corresponds to 0079-03-22 [Gregorian] and to 0079-03-24 [Julian].  The Julian Date of the epoch of the Indian Civil Calendar is 1,749,994.50 (midnight.) 
	
			The epoch date of the Indian Civil Calendar is the vernal equinox of the first year of the Saka Era, marking the ascension to the throne of King Salivahana.

			The name of the era of the Indian Civil Calendar is "Anno Sakidae" (AS)--which is Latin for "In the Year of the Saka."

		Time-of-Day Clock

			Midnight is both the zero-point of the time-of-day clock and also the initial moment of the day. 

			{IndianCalendar clock today}
			{IndianCalendar clock now}

		Year Numbering Policy

			The Indian Civil Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			A year is a leap year if the number that results from adding 78 to the year ordinal is either a) evenly divisible by 400, or b) evenly divisible by 4 but not by 100.  

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Caitra					30/31
			2: Vaisakha					31/31
			3: Jyaistha					31/31
			4: Asadha					31/31
			5: Sravana					31/31
			6: Bhadra					31/31
			7: Asvina					30/30
			8: Kartika					30/30
			9: Agrahayana				30/30
			10: Pausa					30/30
			11: Magha					30/30
			12: Phalguna				30/30

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)

!

!IndianCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"IndianCalendar initialize."

	self basicInitialize.! !

!IndianCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Chaitra 			daysPerMonth: 31 leapDayOrdinals: #(31));
		nextPut: (MonthlyCalendarSpec newWithKey: #Vaisakha 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Jyaista 			daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Ashadha 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sravana 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Bhadrapada 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Asvina 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Kartika 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Margasira 		daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Pausha 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Magha			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Phalguna 		daysPerMonth: 30 leapDayOrdinals: #()).
	^specs contents! !

!IndianCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Chaitra 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Vaisakha 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Jyaista 			daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Ashadha 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Sravana 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Bhadrapada 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Asvina 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Kartika 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Margasira 		daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Pausha 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Magha			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Phalguna 		daysPerMonth: 30 leapDayOrdinals: #()).
	^specs contents! !

!IndianCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Indian! !

!IndianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^1749994 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!IndianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"IndianCalendar canonical daysSinceEpochUpToYear: 3"
	"IndianCalendar canonical daysSinceEpochUpToYear: 778"

	| cardinalYear |
	cardinalYear := calendarYear + 77.
	^ cardinalYear * 365 
		+ (cardinalYear // 4) 
		- (cardinalYear // 100) 
		+ (cardinalYear // 400)
		- 28489

	"(Gregorian daysSinceEpochUpToYear: ordinalYearNumber + 78) - (Gregorian daysSinceEpochUpToYear: 79)"! !

!IndianCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."
	"days-in-four-year-cycle=1461; days-in-century=36524; days-in-four-centuries=146097; days-in-20 centuries=730485 "
 
	"IndianCalendar canonical forDaysSinceEpoch: 283793  setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"IndianCalendar canonical forDaysSinceEpoch: 284158  setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"

	| quadCentury century quadYear year days yearTypeCode |
	days := daysSinceEpoch + 28489. "Adjusts for 79-year phase shift"
	quadCentury := days // 146097.
	days := days \\ 146097.
	century := days // 36524.
	days := days \\ 36524.
	(days == 0 and: [century == 4]) 
		ifTrue: 
			["Handle the 36524th cardinal day--a leap day"
			century := century - 1.
			days := 36524].
	quadYear := days // 1461.
	days := days \\ 1461.
	year := days // 365.
	days := days \\ 365.
	(days == 0 and: [year == 4]) 
		ifTrue: 
			["Handle the 365th cardinal day--a leap day"
			year := year - 1.
			days := 365].
	yearTypeCode := 
		year == 3 "Last year in 4-year cycle"
			ifTrue: 
				[quadYear = 24 "last 4-year cycle in century"
					ifTrue: 
						[century = 3 "last century in 4-century cycle" 
							ifTrue: [2] ifFalse: [1]]
					ifFalse: [2]]
			ifFalse: [1].
	^yearMonthDaySpecOrBlock2
		value: (year + (quadCentury * 400) + (century * 100) + (quadYear * 4))  - 77
		value: ((yearlyCalendars at: yearTypeCode) basicDayAt: days + 1)! !

!IndianCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	"IndianCalendar canonical typeCodeOfYear: 2"
	"IndianCalendar canonical typeCodeOfYear: 778"

	| year |
	year := calendarYear + 78.
	^year \\ 4 == 0 
		ifTrue: [year \\ 100 == 0 
					ifTrue: [year \\ 400 == 0 
								ifTrue: [2] 
								ifFalse: [1]] 
					ifFalse: [2]]
		ifFalse: [1]! !

MonthsPerYearInvariantCalendar subclass: #IslamicFatimidCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!IslamicFatimidCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

IslamicFatimidCalendar

	Concept:

		IslamicFatimidCalendar implements the Islamic Fatimid Calendar.  The Islamic Fatimid Calendar (also called the Tabular Islamic Calendar) is an arithmetical variation of the Astronomical Islamic Calendar (the one most Muslims use for religious purposes.) It has the same year numbers and months, but the months are determined by arithmetic rules rather than by observation or astronomical calculations. It was developed by early Muslim astronomers of the second Hijra century (the eighth century AD) to provide a predictable time base for calculating the positions of the moon, sun, and planets. Historians use it to convert an Islamic date into a Western calendar date when no other information (like the day of the week) is available. Some Muslims (e.g, the Daudi Bohras, the Isma'ilis) also use the arithmetical calendar for regligous purposes [reference: http://archive.mumineen.org/publications/oup/bohras.html].  All Muslims commonly use it to estimate future (and sometimes past) dates.

		Many authoritative reference works claim that almost all Muslims use an observation-based calendar. While that used to be true, it is no longer the case--at least not for legal/civil purposes. A substantial percentage of Muslims now use astronomical calculations to determine when each month will be deemed to have started and ended for civil/legal matters. Such is the case in Saudi Arabia and most of the Gulf countries. Although few Muslims currently use an astronomical version of the Islamic calendar for religious purposes, such use is beginning to be discussed and considered. [References: http://www.jas.org.jo/sau.html; http://www.phys.uu.nl/~vgent/islam/mecca/ummalqura.htm; http://www.amperspective.com/html/the_hijra_calender_2005.html; http://www.abc.net.au/science/news/space/SpaceRepublish_1352797.htm]

		Chronos may provide an implementation of the official Saudi astronomical Islamic Calendar in the future. If so, the calendar registration key will be #'Islamic-Saudi'.  The registration key #'Islamic-Astronomical' is reserved until there is some astronomical Islamic calendar which is widely accepted as the standard or canonical Islamic Calendar (which the Saudi version may become, but it's too soon to accord it such status at present.)

		For now, however, Chronos only provides the Fatimid (arithmetical) Islamic Calendar, for the following reasons: 1) Chronos will never support any purely observational calendars, 2) Chronos does not yet support any astronomical calendars, and 3) there is as yet no widely-accepted, standard/canonical astronomical Islamic calendar (although this may be in the process of changing.)

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Islamic Fatimid Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Islamic Fatimid Calendar is an arithmetical, lunar calendar. A lunar calendar is one that attempts to align the day on which one month transitions to the next with the moment that the moon transitions from one phase to the next, so that each month begins within a day or so of the moment that the moon exits from or enters into a particular phase. A lunar calendar makes no attempt to match the length of its years to the length of the solar year.

		The Islamic Calendar transitions from one month to the next as a function of each New Moon. 

		Epoch Date

			The epoch date of the Islamic Fatimid Calendar, 0001-01-01 [Islamic-Fatimid], corresponds to 0622-07-19 [Gregorian] and to 0622-07-16 [Julian].  Islamic days begin at sunset. The Julian Date of the Islamic epoch is 1,948,439.25 (6 pm,) so the actual initial moment of the Islamic epoch corresponds to 0622-07-18T18:00:00 [Gregorian] and to 0622-07-15T18:00:00 [Julian]. 

			The epoch date of the Islamic Calendar marks the generally accepted date of the "hijra" of Mohammed to Medina ("hijra" means "flight from danger.")  There are some who prefer a different date in the same year for this event, but the Islamic Calendar uses the generally-accepted date as its epoch.

			The Islamic era is called "Anno Hegirae" (AH,) which is Latin for "In the Year of the Hijra."

		Time-of-Day Clock

			Although Islamic days begin at sunset, Muslims modernly label the hours of the day beginning at midnight.  So the zero-point of the the time-of-day clock is midnight, although the initial moment of the day is 6 pm.

			{IslamicFatimidCalendar clock today}
			{IslamicFatimidCalendar clock now}

		Year Numbering Policy

			The Islamic Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule
	
			A year is a leap year if the following function evaluates to true: isIslamicLeapYear(calendarYear) => ((calendarYear * 11) + 14) \\ 30 < 11.

		Month Structure


			Month					Days In Month
								Standard Year/Leap Year					
			1: Muharram				30/30
			2: Safar						29/29
			3: Rabi1					30/30
			4: Rabi2					29/29
			5: Jumada1					30/30
			6: Jumada2					29/29
			7: Rajab					30/30
			8: Shaban					29/29
			9: Ramadan					30/30
			10: Shawwal				29/29
			11: Dhu al-Qa'ada			30/30
			12: Dhu al-Hijja				29/30

			Days In Year				354/355

			The semantic month-key of a month is the same as the month's (English) name (as given here.)

			
!

!IslamicFatimidCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"IslamicFatimidCalendar initialize."

	self basicInitialize.! !

!IslamicFatimidCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Muharram 		daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Safar 				daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Rabi1 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Rabi2 			daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Jumada1 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Jumada2 			daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Rajab 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shaban 			daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Ramadan 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shawwal 			daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Dhu al-Qa''ada'	daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Dhu al-Hijja' 		daysPerMonth: 30 leapDayOrdinals: #(30)).
	^specs contents! !

!IslamicFatimidCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Muharram 		daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Safar 				daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Rabi1 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Rabi2 			daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Jumada1 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Jumada2 			daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Rajab 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shaban 			daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Ramadan 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shawwal 			daysPerMonth: 29 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Dhu al-Qa''ada'	daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #'Dhu al-Hijja' 		daysPerMonth: 29 leapDayOrdinals: #()).
	^specs contents! !

!IslamicFatimidCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#'Islamic-Fatimid'! !

!IslamicFatimidCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^1948439 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!IslamicFatimidCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"IslamicCalendar canonical daysSinceEpochUpToYear: 4"

	^(calendarYear - 1) * 354 + ((11 * calendarYear + 3) // 30)! !

!IslamicFatimidCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2 
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	| year daysSinceEpochAtStartOfYear daysSinceStartOfYear |
	year := 30 * daysSinceEpoch + 10646 // 10631.
	daysSinceEpochAtStartOfYear := self daysSinceEpochUpToYear: year.
	daysSinceStartOfYear := daysSinceEpoch - daysSinceEpochAtStartOfYear.
	^yearMonthDaySpecOrBlock2 
		value: year
		value: ((yearlyCalendars at: (self typeCodeOfYear: year)) basicDayAt: daysSinceStartOfYear + 1)! !

!IslamicFatimidCalendar methodsFor: 'API-testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the calendrical system represented by the receiver starts each day at local midnight."

	^false! !

!IslamicFatimidCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay
	"Answer the number of seconds-since-start-of-day relative to midnight represented by the argument, <secondsSinceStartOfDay>, where the argument is specified relative to the receiver's canonical start-of-day (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since midnight clock time that corresponds to the number of seconds since the receiver's canonical start-of-day clock time, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for time systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Julian Day time system, the canonical start-of-day is Noon."

	^secondsSinceStartOfDay + 64800! !

!IslamicFatimidCalendar methodsFor: 'API-unification' stamp: ''!
secondsSinceStartOfDayFromSecondsSinceMidnight: secondsSinceMidnight
	"Answer the number of seconds-since-start-of-day relative to the receiver's canonical start-of-day represented by the argument, <secondsSinceMidnight>, where the argument is specified relative to midnight (without respect to timezone translation or leap seconds.)  In other words, answer the number of seconds since the receiver's canonical start-of-day clock time that corresponds to the number of seconds since midnight, assuming that daylight savings time is not in effect in either case, and that no leap seconds occur during the day.

	The translation enabled by the value this method returns is intended to account for calendar systems whose canoncial start-of-day is not midnight local time, but some other time of day.  For example, in the Hebrew calendar, the canonical start-of-day is 6pm."

	^secondsSinceMidnight + 21600! !

!IslamicFatimidCalendar methodsFor: 'API-testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the calendrical system implemented by the receiver coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^false! !

!IslamicFatimidCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^((calendarYear * 11) + 14) \\ 30 < 11
		ifTrue: [2] ifFalse: [1]! !

!MonthsPerYearInvariantCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	^self subclassResponsibility! !

!MonthsPerYearInvariantCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	^self subclassResponsibility! !

!MonthsPerYearInvariantCalendar class methodsFor: 'private' stamp: ''!
setMonthlyCalendarSpecs
	"Initialize the class instance variable monthlyCalendarSpecs, so that it contains an Array of Array of MonthlyCalendarSpecs.  There must be one Array of MonthlyCalendarSpecs in the outer Array (the one referenced by monthlyCalendarSpecs) for each 'year type' of the calendrical system implemented by instances of the receiver.  There must be a MonthlyCalendarSpec in the inner Array for each month for each year type.  See the class comments of ArithmeticalCalendar, Calendar and MonthlyCalendarSpec for more information."

	monthlyCalendarSpecs := Array new: 2.
	monthlyCalendarSpecs 
		at: 1 put: self newMonthlyCalendarSpecsForStandardYear;
		at: 2 put: self newMonthlyCalendarSpecsForLeapYear! !

!MonthsPerYearInvariantCalendar methodsFor: 'API-Date Construction' stamp: ''!
forMonthsSinceEpoch: monthsSinceEpoch setYearAndMonthsSinceStartOfYearInto: block2 
	"For a year and months-since-start-of-year that is monthsSinceEpoch months since my Epoch, send #value:value: to <block2>, with the year as the first argument and the months-since-start-of-year as the second argument."

	^block2 
		value: (yearNumberingPolicy canonicalFromCardinal: monthsSinceEpoch // self monthsPerYear)
		value: monthsSinceEpoch \\ self monthsPerYear! !

!MonthsPerYearInvariantCalendar methodsFor: 'API-testing' stamp: ''!
isMonthsPerYearInvariant
	"If there are always the exact same number of months in all years, answer true. Otherwise, answer false."

	^true! !

!MonthsPerYearInvariantCalendar methodsFor: 'API-queries-months' stamp: ''!
monthsInYear: year
	"Answer the number of months there are in the given <year>."

	^minMonthsPerYear! !

!MonthsPerYearInvariantCalendar methodsFor: 'API-queries-months' stamp: ''!
monthsInYearForYearTypeCode: yearTypeCode 
	"Answer the number of months there are per year, in a year whose typeCode is <yearTypeCode>."

	^minMonthsPerYear! !

!MonthsPerYearInvariantCalendar methodsFor: 'API-queries-months' stamp: ''!
monthsPerYear
	^minMonthsPerYear! !

!MonthsPerYearInvariantCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
monthsSinceEpochUpToYear: calendarYear 
	"Answer the count of months since the Epoch day (start of day) up to (but NOT including) the first month of the specified year."

	^(yearNumberingPolicy cardinalFromCanonical: calendarYear) 
		* self monthsPerYear! !

!MonthsPerYearInvariantCalendar methodsFor: 'API-Date Construction' stamp: ''!
startingWithYear: startYear addingMonths: monthDelta setYearAndMonthsSinceStartOfYearInto: block2 
	"For a year and months-since-start-of-year that is monthDelta months since the first month of the year <startYear>, send #value:value: to <block2>, with the year as the first argument and the months-since-start-of-year as the second argument."

	^block2 
		value: (yearNumberingPolicy 
				canonicalFromCardinal: (yearNumberingPolicy 
						cardinalFromCanonical: startYear) + (monthDelta // self monthsPerYear))
		value: monthDelta \\ self monthsPerYear! !

MonthsPerYearInvariantCalendar subclass: #PersianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!PersianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

PersianCalendar

	Concept:

		PersianCalendar implements the arithmetical version of the Persian Calendar.  There is also an astronomical version of the Persian Calendar, which some authorities claim is the one actually used in Iran, although other authorities claim otherwise.  Chronos does not currently provide implementations of any astronomical calendars. The astronomical version of the Persian Calendar will (eventually) be implemented by class named AstronomicalPersianCalendar, whose registration key will be #'Persian-Astronomical'.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Persian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Persian Calendar (as implemented here) is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.  

		Epoch Date

			The epoch date of the Persian Calendar, 0001-01-01 [Persian], corresponds to 0622-03-22 [Gregorian] and to 0622-03-19 [Julian].  The Julian Date of the epoch of the Persian Calendar is 1,948,320.50 (midnight.) 

			The epoch date of the Persian Calendar is the vernal equinox of the year in which the "hijra" of Mohammed to Medina occurred ("hijra" means "flight from danger.") 

			The era of the Persian Calendar is called "Anno Persico" or "Anno Persarum" (AP)--which is Latin for "In the Year of Persia/the Persians."

		Time-of-Day Clock

			Modernly, midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  However, such has not always been the case for all users of the Persian Calendar.

			{PersianCalendar clock today}
			{PersianCalendar clock now}

		Year Numbering Policy

			The Persian Calendar uses "zeroless ordinal" year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year -1.

		Leap Year Rule

			According to Birashk [A. Birashk, "A Comparative Calendar of the Iranian, Muslim Lunar, and Christian Eras for Three Thousand Years," Mazda Publishers (in association with Bibliotheca Persica,) Costa Mesa, CA, 1993], the arithmetical form of the Persian Calendar uses the following rather complicated leap year rules:

			There is a master cycle of 2820 years, during which 683 years are leap years. Each standard year contains 365 days, and each leap year contains 366 days, so the master 2820-year cycle contains 1,029,983 days [(2820 * 365) + 683 = 1,029,983].  Based on the current mean length of the tropical year and solar day, there are 1,029,983.00118 days in 2820 tropical years.  So, were it not for the fact that a) the length of the tropical year and the length of a mean solar day is slowly changing, and b) the length of the tropical year (which is defined by the duration between winter solstices) is not the same as the length of the spring equinoctial year (which is defined by the duration between vernal equinoxes,) it would be fair to say that the Persian arithmetical calendar deviates from the length of a year by only 101.952 minutes in 2820 years.  But for those (and other) caveats, the Persian arithmetical calendar would slip from perfect alignment with the tropical year by only one day every 39,829.68 years--which is astounding accuracy, in spite of the caveats. 

			Within each 2820-year cycle, there are 22 subcycles--the first 21 each contain 128 years, and the 22nd (final) subcycle contains 132 years [2820 = 21 * 128 + 132].

			Each 128-year subcycle contains one 29-year sub-subcycle (the first,) followed by three 33-year sub-subcycles [128 = 29 + (3 * 33)].

			Each 132-year subcycle contains one 29-year sub-subcycle (the first,) followed by two 33-year sub-subcycles, followed by one 37-year sub-subcycle [132 = 29 + (2 * 33) + 37].

			A year in a sub-subcycle (whether it contains 29, 33 or 37 years) is a leap year if the ordinal index of the year within the cycle satisfies the following two predicate tests: 1) it's greater than 1, and 2) the remainder after dividing it by 4 is 1 (so the first year in sub-subcyle is never a leap year; the first leap year is the fifth year in the sub-subcycle.) Thus, a 29-year sub-subcycle has 7 leap years, a 33-year sub-subcycle has 8 leap years, and a 37-year sub-subcycle has 9 leap years (Note: the last year of a sub-subcycle is always a leap year, since 29, 33 and 37 all result in a remainder of 1 when divided by 4) [21 * (7 + (3 * 8)) + (7 + (2 * 8) + 9) = 683].

			The base year of the 2820 cycle of years is NOT the Persian year zero or 1, however.  The base year of the 2820-year cycle of years is the Persian year 475 (which starts on 21 March 1096 [Gregorian] or 15 March 1096 [Julian].)  However, to facilitate the use of modular arithmetic, the Chronos implementation uses Persian year 474 as the zeroeth year of the 2820-year cycle.

			Algorithm of Predicate Function that answers true if a <persianYear> is a leap year (input arg=<persianYear>):

				1. If <persianYear> >= 1 then
					set <cardinalYear> to <persianYear> - 1;
				   else
					set <cardinalYear> to <persianYear>;
				   end
				2. Set <dividend> to <cardinalYear> - 473.
				3. Set <year> to (dividend mod 2820) + 474.
				4. Return (((<year> + 38) * 682) mod 2816) < 682

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Farvardin					31/31
			2: Ordibehesht				31/31
			3: Xordad					31/31
			4: Tir						31/31
			5: Mordad					31/31
			6: Shahrivar					31/31
			7: Mehr						30/30
			8: Aban						30/30
			9: Azar						30/30
			10: Dey						30/30
			11: Bahman					30/30
			12: Esfand					29/30

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)

			
	!

!PersianCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"PersianCalendar initialize."

	self basicInitialize.! !

!PersianCalendar class methodsFor: 'private' stamp: ''!
newDefaultYearNumberingPolicy
	"Answer a new NumberingPolicy to be used as the the policy for interpreting year numbers in the calendrical system implemented by instances of the receiver. NOTE: The ANSI Smalltalk standard REQUIRES the use of 'Astronomical Year Numbering' (i.e., an OrdinalNumberingPolicy) for dates in the Gregorian calendar. The ISO 8601 standard imposes the same requirement."

	^self newZerolessOrdinalYearNumberingPolicy! !

!PersianCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Farvardin 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Ordibehesht	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Khordad 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tir 			daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Mordad 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shahrivar 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Mehr 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Aban 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Azar 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Day 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Bahman 		daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Esfand 		daysPerMonth: 30 leapDayOrdinals: #(30)).
	^specs contents! !

!PersianCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Farvardin 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Ordibehesht	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Khordad 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Tir 			daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Mordad 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Shahrivar 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Mehr 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Aban 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Azar 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Day 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Bahman 		daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Esfand 		daysPerMonth: 29 leapDayOrdinals: #()).
	^specs contents! !

!PersianCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#'Persian'! !

!PersianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^1948320 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!PersianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"{PersianCalendar canonical daysSinceEpochUpToYear: 5}"
	"{PersianCalendar canonical daysSinceEpochUpToYear: 475} = 173125"
	"{(PersianCalendar canonical daysSinceEpochUpToYear: 2821)}  = 1029983"

	| cardinalYear dividend year |
	cardinalYear := yearNumberingPolicy cardinalFromCanonical: calendarYear.
	dividend := cardinalYear - 473.
	year := (dividend \\ 2820)  + 474.
	^(1029983 * (dividend // 2820)) + (365 * (year - 1)) + ((682 * year - 110) // 2816)! !

!PersianCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	"PersianCalendar canonical forDaysSinceEpoch: 1029983  setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"

	| cycles days year daysSinceEpochUpToYear daysSinceStartOfYear |
	days := daysSinceEpoch - 173125.
	cycles := days // 1029983.
	days := days \\ 1029983.
	days = 1029982 
		ifTrue: [year := 2820]
		ifFalse: [year := (2816 * days + 1031337) // 1028522].
	year := yearNumberingPolicy canonicalFromOrdinal: (2820 * cycles + 474 + year). " 2820 + 474 =  3294"
	daysSinceEpochUpToYear := self daysSinceEpochUpToYear: year.
	daysSinceStartOfYear :=  daysSinceEpoch - daysSinceEpochUpToYear.	
	^yearMonthDaySpecOrBlock2 
		value: year
		value: ((yearlyCalendars at: (self typeCodeOfYear: year)) basicDayAt: daysSinceStartOfYear + 1)! !

!PersianCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	"PersianCalendar canonical typeCodeOfYear: 475"
	"PersianCalendar canonical typeCodeOfYear: 479"
	"{(475 to: 3295) inject: 0 into: [:total :year | (PersianCalendar canonical typeCodeOfYear: year) = 2 ifTrue: [total + 1] ifFalse: [total]]} =  683"

	| cardinalYear dividend year |
	cardinalYear := yearNumberingPolicy cardinalFromCanonical: calendarYear.
	dividend := cardinalYear - 473.
	year := (dividend \\ 2820)  + 474.
	^((year + 38) * 682 \\ 2816) < 682
		ifTrue: [2] ifFalse: [1]! !

MonthsPerYearInvariantCalendar subclass: #RomanicCalendar
	instanceVariableNames: 'secondsFromEpochUpToGregorianStart'
	classVariableNames: 'LeapYearTypeCode'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!RomanicCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

RomanicCalendar

	Concept:

		RomanicCalendar is an abstract class whose concrete subclasses implement calendrical systems that use the same month structure as the Julian and Gregorian calendars--which ultimately derives from ancient, Imperial Rome. It also provides for specifying the canonical moment of transition to the offical, civil usage of the Gregorian Calendar (which is currently the de-facto civil calendar for most nations of the world.)

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Julian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: January					31/31
			2: February					28/29
			3: March					31/31
			4: April						30/30
			5: May						31/31
			6: June						30/30
			7: July						31/31
			8: August					31/31
			9: September				30/30
			10: October					31/31
			11: November				30/30
			12: December				31/31
			
			Days In Year				365/366

	Implementation: 

		Insance Variables

			secondsFromEpochUpToGregorianStart	<Integer>
				The number of seconds from the instance's epoch up to the canonical moment of official/legal transition to the Gregorian Calendar. The value of this variable is computed and set during initialization of the instance.

	Subclassing:

		The instance method #computeSecondsFromEpochUpToGregorianStart must be subimplemented by any concrete subclass.  See the method comment for the method semantics.
	!

RomanicCalendar subclass: #AbstractJulianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!AbstractJulianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

AbstractJulianCalendar

	Concept:

		AbstractJulianCalendar is an abstract class whose concrete subclasses implement a particular variation of the Julian Calendar.  

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Julian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		Some variation of the Julian Calendar was the official, civil calendar of the Western World from 45 BC until at least 1582 AD in Caltholic Europe, until 1752 AD in the British Empire, and until as late as the early 20th Century in a handful of locales (such as Russia.)

		However, there is no such thing as "the" Julian Calendar, because there are many different Julian Calendars.  In much the same way that England and the United States are two different countries separated by the same language (to quote Winston Churchill,) the various "Julian Calendars" are different calendrical systems falsely unified by the same name.  The various "Julian" Calendars differ from each other with respect to one or more of a) New Year's Day, b) the epoch year and c) the leap year rule. Historically, the "Julian Calendar" is a set of multiple, conflicting rules for counting time unified by nothing more than the same catchy name, the same set of months and the same leap year rule (and not even by that, in the case of the Roman Clerical Julian Calendar.).

		The Julian Calendar was invented by the Alexandrian astronomer Sosigenes at the request of Julius Caesar in 46 BC, who formulated the calendar based on the Roman Republican Calendar and the then best available estimate of the length of the tropical year.  Julius Caesar made it the civil calendar of the Roman Empire effective 1 January 45 BC [Julian].  There are two differences between the Imperial Julian Calendar (as used in ancient Rome) and the Modern Julian Calendar (used mainly by historians,) one "de jure" and one "de facto." 

		The "de jure" difference is that the ancient Romans did not use the year of Christ's birth as their epoch year.  

		The "de facto" difference is that the priests in charge of the calendar failed to correctly apply Caesar's leap year rule for the first 38 years of the calendar--requiring Emperor Augustus to order the omission of any leap days from 7 BC through 3 AD. For more information about the original Julian Calendar used in Imperial Rome, see the class ImperialJulianCalendar. For more information about the Modern Julian Calendar used by historians (and by some religions,) see the class JulianCalendar.

!

!AbstractJulianCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^((self yearNumberingPolicy ordinalFromCanonical: calendarYear) \\ 4 == 0)
		ifTrue: [2]
		ifFalse: [1]! !

!AbstractJulianCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	| quadYear year days yearTypeCode |
	quadYear := daysSinceEpoch // 1461.
	days := daysSinceEpoch \\ 1461.
	year := days // 365.
	days := days \\ 365.
	(year == 4 and: [days == 0])
		ifTrue: 
			[year := year - 1.
			days := 365].
	"<year> is a CARDINAL number here"
	yearTypeCode := 
		year == 3 "Last year in 4-year cycle"
			ifTrue: [2] 
			ifFalse: [1].
	^yearMonthDaySpecOrBlock2
		value: (yearNumberingPolicy  canonicalFromCardinal: year  + (quadYear * 4))  
		value: ((yearlyCalendars at: yearTypeCode) basicDayAt: days + 1)! !

!AbstractJulianCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^((yearNumberingPolicy ordinalFromCanonical: calendarYear) \\ 4 == 0)
		ifTrue: [2]
		ifFalse: [1]! !

AbstractJulianCalendar subclass: #ImperialJulianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!ImperialJulianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ImperialJulianCalendar 	

	Concept:

		ImperialJulianCalendar implements the original Julian Calendar as used in Imperial Rome.  

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Julian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Imperial Julian Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		See the class comment of AbstractJulianCalendar for information about the Julian Calendar common to all its variations. For more information about the Modern Julian Calendar used by historians (and by some religions,) see the class JulianCalendar.

		Epoch Date

			The pre-Imperial, Imperial and post-Imperial Romans counted time from various reference points that changed frequently. However, there was one "epoch year" that was canonically (albeit infrequently) used to unify all their various time counts: the year of the founding of the city of Rome. That era that was called "Ab Urbe Condita," Latin for "From the Founding of the City."  So the epoch date of the Imperial Julian Calendar is 1 January 1 Ab Urbe Condita (AUC,) which corresponds to 1 January 753 BC [Julian].

			 The Julian Date of the epoch of the Imperial Julian Calendar is 1,446,389.50 (midnight.) 

		Time-of-Day Clock

			For this implementation, midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  However, such has not always been the case for all users of the Imperial Julian Calendar.

			{ImperialJulianCalendar clock today}
			{ImperialJulianCalendar clock now}

		Year Numbering Policy

			The Imperial Julian Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			De jure, a year is a leap year if dividing its year ordinal by 4 results in a remainder of 1. The de facto situation is more complicated.

			The Roman priesthood in charge of the Roman calendar (the pontiffs) were mathematically challenged, and so failed to correctly follow the de jure rules for leap years specified by Caesar. The pontiffs mistakenly failed to insert a leap day in 45 BC (709 A.U.C.,) inserting it in 44 BC (710 AUC) instead. Then, from 44 BC to 8 BC (710 A.U.C. to 746 A.U.C.), they inserted a leap day every three years, instead of every 4 (Caesar's decree making his calendar the official civil calendar of the Roman Empire required a leap year every 4 years.) When the error was discovered, Emperor Augustus (Caesar's nephew) was obliged to omit the insertion of leap days between 7 BC and 3 AD (746 A.U.C. to 756 A.U.C.) In 4 AD (757 A.U.C.,) after the extra leap day intercalations had been corrected, itercalation of the leap day was resumed. 

			Which years were actually observed as leap years by the Roman pontiffs has long been a subject of some controversy. The years used by Chronos are based on a recently-published ancient document, as discussed in the following reference [http://www.nationmaster.com/encyclopedia/Julian-calendar]: 

			"In 1999, an Egyptian papyrus was published which gives an ephemeris table for 24 BC with both Roman and Egyptian dates. From this it can be shown that the most likely sequence was in fact 44, 41, 38, 35, 32, 29, 26, 23, 20, 17, 14, 11, 8 BC, AD 4, 8, 12 etc., very close to that proposed by Matzat. This sequence shows that the standard Julian leap year sequence began in AD 4, the twelfth year of the Augustan reform. Also, under this sequence the actual Roman year coincided with the proleptic Julian year between 32 and 26 BC. This suggests that one aim of the realignment portion of the Augustan reform was to ensure that key dates of his career, notably the fall of Alexandria on 1 August 30 BC, were unaffected by his correction. 

			Roman dates before 32 BC were typically a day or two before the day with the same Julian date, so 1 January in the Roman calendar of the first year of the Julian reform actually fell on 31 December 46 BC (Julian date). A curious effect of this is that Caesar's assassination on the Ides (15th day) of March in 44 BC fell on 14 March 44 BC in the Julian calendar."

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: January					31/31
			2: February					28/29
			3: March					31/31
			4: April						30/30
			5: May						31/31
			6: June						30/30
			7: July						31/31
			8: August					31/31
			9: September				30/30
			10: October					31/31
			11: November				30/30
			12: December				31/31
			
			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name.

		Motivation:

			Since no one has used the Roman Imperial Julian Calendar, nor its Clerical variation, for over a thousand years, the only "use case" for this ancient calendar is the interpretation of dates in ancient documents and inscriptions. Consequently, Chronos provides the class ImperialJulianCalendar that fully implements the "de facto" Imperial Julian Calendar, using the "Ab Urbe Condita" era, and duplicating the leap-year schedule used by the Roman pontiffs.  It makes sense to combine the "Ab Urbe Condita" epoch with the "de facto" leap year rules of the Roman pontiffs, because both actually go together historically (one might actually encounter such dates in an ancient document or inscription.)  Such is not the case for dates using the "Anno Domini" era and the "Julian" calendar.







!

!ImperialJulianCalendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToMonthDayInYearPassesVerification
	^self daysSinceEpochUpToMonthDayInYearVerifier value: self canonical! !

!ImperialJulianCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 1"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 2"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 3"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 4"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 5"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 708 = 258232" 
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 709 = 258597" 
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 710 = 258962" 
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 713 = 260058"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 754 = 275034"

	| estimate correction  |
	estimate := (calendarYear - 1) * 365.
	correction := (calendarYear < 710 or: [calendarYear > 753]) 
		ifTrue: [(calendarYear + 2) // 4]
		ifFalse:
			[calendarYear < 747
				ifTrue: [correction := 177 + ((calendarYear - 708) // 3)]
				ifFalse: [correction := 189]].
	^estimate + correction

	"Until 706: Every 4 years; 1 and 705 are leap years.
	706 - 709: No leap years (a five year gap--709 should have been a leap year, but wasn't).
	710 - 746: Every three years; 710 and 746 are leap years.
	747 - 756: No leap years.
	Since 757: Every 4 years; 757 is a leap year."! !

!ImperialJulianCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"ImperialJulianCalendar initialize"

	self basicInitialize.! !

!ImperialJulianCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#'Julian-Imperial'! !

!ImperialJulianCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
typeCodeOfYear: calendarYear 
	"Answer the year type code of the given <calendarYear>."

	^(calendarYear >= 757 or: [calendarYear < 709]) 
		ifTrue: [calendarYear \\ 4 == 1 ifTrue: [2] ifFalse: [1]]
		ifFalse: [calendarYear < 749 ifTrue: [calendarYear \\ 3 == 2 ifTrue: [2] ifFalse: [1]] ifFalse: [1]]

	"						
		Modern 			Imperial Roman		Imperial Roman
		Julian Year		Year AUC			Leap Status		
		753 BC			1					leap				{Julian typeCodeOfYear: -753}	{ImperialJulianCalendar canonical typeCodeOfYear: 1}
		752 BC			2					standard			{Julian typeCodeOfYear: -752}	{ImperialJulianCalendar canonical typeCodeOfYear: 2}
		751 BC			3					standard			{Julian typeCodeOfYear: -751}	{ImperialJulianCalendar canonical typeCodeOfYear: 3}
		750 BC			4					standard			{Julian typeCodeOfYear: -750}	{ImperialJulianCalendar canonical typeCodeOfYear: 4}
		749 BC			5					leap				{Julian typeCodeOfYear: -749}	{ImperialJulianCalendar canonical typeCodeOfYear: 5}

		45 BC			709					standard			{Julian typeCodeOfYear: -45}		{ImperialJulianCalendar canonical typeCodeOfYear: 709}
		44 BC			710					leap				{Julian typeCodeOfYear: -45}		{ImperialJulianCalendar canonical typeCodeOfYear: 710}
		42 BC			712					standard			{Julian typeCodeOfYear: -42}		{ImperialJulianCalendar canonical typeCodeOfYear: 712}
		41 BC			713					leap				{Julian typeCodeOfYear: -41}		{ImperialJulianCalendar canonical typeCodeOfYear: 713}
		38 BC			716					leap				{Julian typeCodeOfYear: -38}		{ImperialJulianCalendar canonical typeCodeOfYear: 716}
		35 BC			719					leap				{Julian typeCodeOfYear: -35}		{ImperialJulianCalendar canonical typeCodeOfYear: 719}
		32 BC			722 				leap				{Julian typeCodeOfYear: -32}		{ImperialJulianCalendar canonical typeCodeOfYear: 722}
		29 BC			725 				leap				{Julian typeCodeOfYear: -29}		{ImperialJulianCalendar canonical typeCodeOfYear: 725}
		26 BC			728					leap				{Julian typeCodeOfYear: -26}		{ImperialJulianCalendar canonical typeCodeOfYear: 728}
		23 BC			731					leap				{Julian typeCodeOfYear: -23}		{ImperialJulianCalendar canonical typeCodeOfYear: 730}
		20 BC			734					leap				{Julian typeCodeOfYear: -20}		{ImperialJulianCalendar canonical typeCodeOfYear: 731}
		17 BC			737					leap				{Julian typeCodeOfYear: -17}		{ImperialJulianCalendar canonical typeCodeOfYear: 737}
		14 BC			740					leap				{Julian typeCodeOfYear: -14}		{ImperialJulianCalendar canonical typeCodeOfYear: 740}
		11 BC			743					leap				{Julian typeCodeOfYear: -11}		{ImperialJulianCalendar canonical typeCodeOfYear: 743}
		8 BC			746					leap				{Julian typeCodeOfYear: -8}		{ImperialJulianCalendar canonical typeCodeOfYear: 746}

		5 BC			749					standard			{Julian typeCodeOfYear: -5}		{ImperialJulianCalendar canonical typeCodeOfYear: 749}
		2 BC			752					standard			{Julian typeCodeOfYear: -6}		{ImperialJulianCalendar canonical typeCodeOfYear: 752}
		1 BC			753					standard			{Julian typeCodeOfYear: -1}		{ImperialJulianCalendar canonical typeCodeOfYear: 753}
		1 AD			754					standard			{Julian typeCodeOfYear: 1}		{ImperialJulianCalendar canonical typeCodeOfYear: 754}
		4 AD			757					leap				{Julian typeCodeOfYear: 4}		{ImperialJulianCalendar canonical typeCodeOfYear: 757}
		8 AD			761					leap				{Julian typeCodeOfYear: 8}		{ImperialJulianCalendar canonical typeCodeOfYear: 761}

		"! !

!ImperialJulianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsFromEpochUpToGregorianStart

	^(self 
		daysSinceEpochUpToMonth: 10
		day: 5
		inYear: 2336) * SecondsPerDay! !

!ImperialJulianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^1446389 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!ImperialJulianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 1"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 2"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 3"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 4"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 5"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 708 = 258232" 
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 709 = 258597" 
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 710 = 258962" 
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 713 = 260058"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 754 = 275034"

	| estimate correction  |
	estimate := (calendarYear - 1) * 365.
	correction := (calendarYear < 710 or: [calendarYear > 753]) 
		ifTrue: [(calendarYear + 2) // 4]
		ifFalse:
			[calendarYear < 747
				ifTrue: [correction := 177 + ((calendarYear - 708) // 3)]
				ifFalse: [correction := 189]].
	^estimate + correction

	"Until 706: Every 4 years; 1 and 705 are leap years.
	706 - 709: No leap years (a five year gap--709 should have been a leap year, but wasn't).
	710 - 746: Every three years; 710 and 746 are leap years.
	747 - 756: No leap years.
	Since 757: Every 4 years; 757 is a leap year."! !

!ImperialJulianCalendar methodsFor: 'API-queries-years' stamp: ''!
eraNameForYear: calendarYear
	"Answer the abbreviation of the name of the era to which <calendarYear> belongs.  The name of an era identifies the epoch date of a calendrical system and/or the calendrical system itself (although it may do so ambiguously.) The era name may also identify whether or not the <calendarYear> occurs before or after the epoch date."

	^(yearNumberingPolicy cardinalFromCanonical: calendarYear) >= 0
		ifTrue: [self defaultLocale properNameAtSemanticKey: #'ImperialJulian-era-postEpoch'] 
		ifFalse: [self defaultLocale properNameAtSemanticKey: #'ImperialJulian-era-preEpoch']! !

!ImperialJulianCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2 
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	"ImperialJulianCalendar canonical forDaysSinceEpoch: 0 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 366 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 731 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch:1096 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 1461 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 1827 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"

	"ImperialJulianCalendar canonical forDaysSinceEpoch: 258232 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 258597 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 258962 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 260058 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 272479 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 273209 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 273574 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 275034 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"
	"ImperialJulianCalendar canonical forDaysSinceEpoch: 276129 setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"

	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 1"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 2"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 3"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 4"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 5"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 708 = 258232"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 709 = 258597"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 710 = 258962"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 713 = 260058"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 747 = 272479"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 749  = 273209"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 750 = 273574"

	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 754 = 275034"
	"ImperialJulianCalendar canonical daysSinceEpochUpToYear: 757 = 276129"

	"Until 706: Every 4 years; 1 and 705 are leap years.
	706 - 709: No leap years (a five year gap--709 should have been a leap year, but wasn't).
	710 - 746: Every three years; 710 and 746 are leap years.
	747 - 756: No leap years.
	Since 757: Every 4 years; 757 is a leap year."

	| year days yearTypeCode |
	^(daysSinceEpoch < 258597 "709 AUC" or: [daysSinceEpoch >= 275034 "754 AUC"]) 
		ifTrue: 
			[| quadYear |
			quadYear := daysSinceEpoch // 1461.
			days := daysSinceEpoch \\ 1461.
			days > 365 
				ifTrue: 
					[yearTypeCode := 1.
					days := days - 366.
					days > 364 
						ifTrue: 
							[days := days - 365.
							days > 364 
								ifTrue: 
									[days := days - 365.
									year := 3]
								ifFalse: [year := 2]]
						ifFalse: [year := 1]]
				ifFalse: 
					[yearTypeCode := 2.
					year := 0].	"<year> and <days> are both CARDINAL numbers here"
			yearMonthDaySpecOrBlock2 
				value: (yearNumberingPolicy canonicalFromCardinal: year + (quadYear * 4))
				value: ((yearlyCalendars at: yearTypeCode) basicDayAt: days + 1)]
		ifFalse: 
			[| daysSinceAdjustmentEpoch |
			daysSinceEpoch >= 272479 "747 AUC"
				ifTrue: 
					[daysSinceAdjustmentEpoch := daysSinceEpoch - 272479.
					yearMonthDaySpecOrBlock2 
						value: 747 + (daysSinceAdjustmentEpoch // 365)
						value: ((yearlyCalendars at: 1) basicDayAt: (daysSinceAdjustmentEpoch \\ 365) + 1)]
				ifFalse: 
					[daysSinceAdjustmentEpoch := daysSinceEpoch - 258597. "709 AUC"
					daysSinceAdjustmentEpoch < 365
						ifTrue: 
							[yearMonthDaySpecOrBlock2 
								value: 709
								value: ((yearlyCalendars at: 1) basicDayAt: daysSinceAdjustmentEpoch + 1)]
						ifFalse: 
							[| triadYear | 
							daysSinceAdjustmentEpoch := daysSinceAdjustmentEpoch - 365.
							triadYear := daysSinceAdjustmentEpoch // 1096.
							days := daysSinceAdjustmentEpoch \\ 1096.
							days > 365 
								ifTrue: 
									[yearTypeCode := 1.
									days := days - 366.
									days > 364 
										ifTrue: 
											[days := days - 365.
											year := 2]
										ifFalse: [year := 1]]
								ifFalse: 
									[yearTypeCode := 2.
									year := 0].	"<year> and <days> are both CARDINAL numbers here"
							yearMonthDaySpecOrBlock2 
								value: 710 + (year + (triadYear * 3))
								value: ((yearlyCalendars at: yearTypeCode) basicDayAt: days + 1)]]]! !

!ImperialJulianCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear 
	"Answer the year type code of the given <calendarYear>."

	^(calendarYear >= 757 or: [calendarYear < 709]) 
		ifTrue: [calendarYear \\ 4 == 1 ifTrue: [2] ifFalse: [1]]
		ifFalse: [calendarYear < 749 ifTrue: [calendarYear \\ 3 == 2 ifTrue: [2] ifFalse: [1]] ifFalse: [1]]

	"						
		Modern 			Imperial Roman		Imperial Roman
		Julian Year		Year AUC			Leap Status		
		753 BC			1					leap				{Julian typeCodeOfYear: -753}	{ImperialJulianCalendar canonical typeCodeOfYear: 1}
		752 BC			2					standard			{Julian typeCodeOfYear: -752}	{ImperialJulianCalendar canonical typeCodeOfYear: 2}
		751 BC			3					standard			{Julian typeCodeOfYear: -751}	{ImperialJulianCalendar canonical typeCodeOfYear: 3}
		750 BC			4					standard			{Julian typeCodeOfYear: -750}	{ImperialJulianCalendar canonical typeCodeOfYear: 4}
		749 BC			5					leap				{Julian typeCodeOfYear: -749}	{ImperialJulianCalendar canonical typeCodeOfYear: 5}

		45 BC			709					standard			{Julian typeCodeOfYear: -45}		{ImperialJulianCalendar canonical typeCodeOfYear: 709}
		44 BC			710					leap				{Julian typeCodeOfYear: -45}		{ImperialJulianCalendar canonical typeCodeOfYear: 710}
		42 BC			712					standard			{Julian typeCodeOfYear: -42}		{ImperialJulianCalendar canonical typeCodeOfYear: 712}
		41 BC			713					leap				{Julian typeCodeOfYear: -41}		{ImperialJulianCalendar canonical typeCodeOfYear: 713}
		38 BC			716					leap				{Julian typeCodeOfYear: -38}		{ImperialJulianCalendar canonical typeCodeOfYear: 716}
		35 BC			719					leap				{Julian typeCodeOfYear: -35}		{ImperialJulianCalendar canonical typeCodeOfYear: 719}
		32 BC			722 				leap				{Julian typeCodeOfYear: -32}		{ImperialJulianCalendar canonical typeCodeOfYear: 722}
		29 BC			725 				leap				{Julian typeCodeOfYear: -29}		{ImperialJulianCalendar canonical typeCodeOfYear: 725}
		26 BC			728					leap				{Julian typeCodeOfYear: -26}		{ImperialJulianCalendar canonical typeCodeOfYear: 728}
		23 BC			731					leap				{Julian typeCodeOfYear: -23}		{ImperialJulianCalendar canonical typeCodeOfYear: 730}
		20 BC			734					leap				{Julian typeCodeOfYear: -20}		{ImperialJulianCalendar canonical typeCodeOfYear: 731}
		17 BC			737					leap				{Julian typeCodeOfYear: -17}		{ImperialJulianCalendar canonical typeCodeOfYear: 737}
		14 BC			740					leap				{Julian typeCodeOfYear: -14}		{ImperialJulianCalendar canonical typeCodeOfYear: 740}
		11 BC			743					leap				{Julian typeCodeOfYear: -11}		{ImperialJulianCalendar canonical typeCodeOfYear: 743}
		8 BC			746					leap				{Julian typeCodeOfYear: -8}		{ImperialJulianCalendar canonical typeCodeOfYear: 746}

		5 BC			749					standard			{Julian typeCodeOfYear: -5}		{ImperialJulianCalendar canonical typeCodeOfYear: 749}
		2 BC			752					standard			{Julian typeCodeOfYear: -6}		{ImperialJulianCalendar canonical typeCodeOfYear: 752}
		1 BC			753					standard			{Julian typeCodeOfYear: -1}		{ImperialJulianCalendar canonical typeCodeOfYear: 753}
		1 AD			754					standard			{Julian typeCodeOfYear: 1}		{ImperialJulianCalendar canonical typeCodeOfYear: 754}
		4 AD			757					leap				{Julian typeCodeOfYear: 4}		{ImperialJulianCalendar canonical typeCodeOfYear: 757}
		8 AD			761					leap				{Julian typeCodeOfYear: 8}		{ImperialJulianCalendar canonical typeCodeOfYear: 761}

		"! !

AbstractJulianCalendar subclass: #JulianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!JulianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

JulianCalendar

	Concept:

		JulianCalendar implements the Modern Julian Calendar, as modernly used to designate dates prior to the adoption of the Gregorian Calendar (which happened at different times in different legal jurisdictions.)  

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Julian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Julian Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		See the class comment of AbstractJulianCalendar for information about the Julian Calendar common to all its variations.

		Epoch Date

			The epoch date of the Modern Julian Calendar as used by historians is 1 January 1 AD (1 January 754 AUC,) which is the first day of the year according to the civil calendar in use in Rome of the year in which or after which (no one knows for sure) that the Catholic Church reckoned that Christ was born. This year is the beginning of the Anno Domini era ("Anno Domini" is Latin for "In the year of the Lord.") Years prior to the year 1 Anno Domini are referred to as being in the era "Before Christ" (BC)--which is in English instead of Latin simply because the era was so named (originally) by the Venerable Bede, in his 'Ecclesiastical History of the English Nation,' which was published (in Old English) in the Eighth Century AD. 

			 The Julian Date of the epoch of the Modern Julian Calendar is 1,721,423.50 (midnight.) 

			The idea of using the year of Christ's birth as the epoch year of the Julian Calendar was first proposed by the Monk Dionysius Exiguus in 525 AD.  At the time, a variety of epoch years were in common use, with the year when Diocletian ascended to the office of Emperor of Rome being the most widely used. Although the Imperial and post-Imperial Romans counted time from various reference points that changed frequently, there was one "epoch date" that was canonically (albeit infrequently) used to unify all their various time counts: the date of the founding of the city of Rome (an era that was called "Ab Urbe Condita," Latin for "From the Founding of the City.") Dionysius explicity specified the year that would be the year 1 of the Anno Domini Era as the year 754 A.U.C. ("Ab Urbe Condita.")  

			There is much contention as to the actual year of Christ's birth, although it is almost certain that Christ was not in fact born in either 753 or 754 AUC (1 BC or 1 AD.)  However, it may be that Dionysius chose 754 AUC as the epoch year for mathematical reasons, and not because he believed that Christ was actually born in either 1 BC or 1 AD.
  
			Dionysius Exiguus' proposal to use the time of Christ's birth as the basis for the epoch of the Julian Calendar was not immediately adopted. In fact, it would be several centuries before the Christian/Anno Domini Era came to be the commonly used basis for counting years. But by that time, other changes in calendrical practices had taken place.

			New Year's Day as decreed by Julius Caesar was January 1.  But in medieval Europe, because the celebrations accompanying the new year were considered pagan and unchristian, the Council of Tours in 755 AD abolished January 1 as the beginning of the year. Over time, the result was that New Year's Day (the day on and after which the year ordinal would be incremented by one in date designations) came to be observed on any of December 25, March 1, March 25, the Feast of the Annunciation, or even Easter--and which of those days would have been deemed New Year's Day would depend, of course, on time and place. 

			The epoch date of the Modern Julian Calendar is 1 January 754 AUC. This epoch date is used by historians in order to establish a unified, canonical "Julian Calendar" for modern use when representing ancient and medieval dates. Note, however, that this epoch date makes the Modern Julian Calendar anachronistic (proleptic,) because its New Year's Day was last widely used officially (in connection with the Julian Calendar) in the Eighth Century, and its epoch year didn't become canonical until the Ninth Century. The Modern Julian Calendar as used by historians, with New Year's Day on January 1 and with 754 AUC as the epoch year, was never the official civil calendar of the Western World.

		Time-of-Day Clock

			Modernly, midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  However, such has not always been the case for all users of the Julian Calendar.

			{JulianCalendar clock today}
			{JulianCalendar clock now}

		Year Numbering Policy

			The Julian Calendar uses "zeroless ordinal" year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year -1.

		Leap Year Rule

			A year is a leap year if its ordinal is evenly divisible by 4.

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: January					31/31
			2: February					28/29
			3: March					31/31
			4: April						30/30
			5: May						31/31
			6: June						30/30
			7: July						31/31
			8: August					31/31
			9: September				30/30
			10: October					31/31
			11: November				30/30
			12: December				31/31

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name.

	Usage:

		The Chronos namespace (shared pool) defines the global variable Julian, which aliases the canonical instance of JulianCalendar.  "JulianCalendar canonical" and "Julian" should be the same object.

	!

!JulianCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."
	"VERIFICATION (should evaluate to true): {JulianCalendar daysSinceEpochUpToYearVerifier value: self}"

	| cardinalYear |
	cardinalYear := self yearNumberingPolicy cardinalFromCanonical: calendarYear.
	^cardinalYear * 365 + (cardinalYear // 4)! !

!JulianCalendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToYearVerifier
	"JulianCalendar daysSinceEpochUpToYearVerifier value: Calendar julian"
	^[:calendar | 
	((((calendar daysSinceEpochUpToYear: 1) = 0)
			and: [((calendar daysSinceEpochUpToYear: -1) = -366)
				and: [((calendar daysSinceEpochUpToYear: 4) = 1095)
					and: [((calendar daysSinceEpochUpToYear: -4) = -1461)
						and: [(calendar daysSinceEpochUpToYear: 5) = 1461]]]])
		and: [((calendar daysSinceEpochUpToYear: 101) = 36525)
				and: [((calendar daysSinceEpochUpToYear: 100) = 36159)
					and: [((calendar daysSinceEpochUpToYear: 104) = 37620)
						and: [((calendar daysSinceEpochUpToYear: 97) = 35064)
							and: [(calendar daysSinceEpochUpToYear: 105 ) = 37986]]]]])
		and: [((calendar daysSinceEpochUpToYear: -100) = -36525)
				and: [((calendar daysSinceEpochUpToYear: -101) = -36891)
					and: [((calendar daysSinceEpochUpToYear: -97) = -35430)
						and: [((calendar daysSinceEpochUpToYear: -104) = -37986)
							and: [(calendar daysSinceEpochUpToYear: -96 ) = -35064]]]]]]! !

!JulianCalendar class methodsFor: 'functional verification' stamp: ''!
daysUpToMonthDayInYearVerifier
	"JulianCalendar daysUpToMonthDayInYearVerifier value: Calendar julian"
	^[:calendar |
		((((((calendar daysUpToMonth: 2 day: 29 inYear: 2000) = 59)
		and: [(calendar daysUpToMonth: 3 day: 1 inYear: 2000) = 60])
		and: [(calendar daysUpToMonth: 3 day: 1 inYear: 1900) = 60])
		and: [(calendar daysUpToMonth: 12 day: 31 inYear: 1900) = 365])
		and: [(calendar daysUpToMonth: 12 day: 31 inYear: 2000) = 365])
		and: [super daysUpToMonthDayInYearVerifier value: calendar canonical]]! !

!JulianCalendar class methodsFor: 'functional verification' stamp: ''!
forDaysSinceEpochSetYearAndCalendarDayIntoVerifier
	"JulianCalendar forDaysSinceEpochSetYearAndCalendarDayIntoVerifier value: Calendar julian"

	^[:calendar | 
	| passes |
	passes := true.
	(calendar forDaysSinceEpoch: 577737
		setYearAndCalendarDayInto: 
			[:year :calendarDay | 
			passes := passes 
						and: [year = 1582 and: [calendarDay month = 10 and: [calendarDay dayOfMonth = 5]]]]) 
			and: 
				[calendar forDaysSinceEpoch: -1721424
					setYearAndCalendarDayInto: 
						[:year :calendarDay | 
						passes := passes 
									and: [year = -4713 and: [calendarDay month = 1 and: [calendarDay dayOfMonth = 1]]]]].
		passes and: [super forDaysSinceEpochSetYearAndCalendarDayIntoVerifier value: calendar]]! !

!JulianCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"JulianCalendar initialize"

	self basicInitialize.! !

!JulianCalendar class methodsFor: 'private' stamp: ''!
leapDayCorrectionForYear: year month: month 
        
        ^month > 2 
                ifTrue: [((self yearNumberingPolicy ordinalFromCanonical: year) \\ 4 = 0) ifTrue: [1] ifFalse: [2]] 
                ifFalse: [0]! !

!JulianCalendar class methodsFor: 'private' stamp: ''!
newDefaultYearNumberingPolicy
	"Answer a new NumberingPolicy to be used as the the policy for interpreting year numbers in the calendrical system implemented by instances of the receiver. NOTE: The ANSI Smalltalk standard REQUIRES the use of 'Astronomical Year Numbering' (i.e., an OrdinalNumberingPolicy) for dates in the Gregorian calendar. The ISO 8601 standard imposes the same requirement."

	^self newZerolessOrdinalYearNumberingPolicy! !

!JulianCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Julian! !

!JulianCalendar class methodsFor: 'private' stamp: ''!
shouldIgnorePostLoad
	^true! !

!JulianCalendar methodsFor: 'API-validation' stamp: ''!
assertIsJulian
	"If the calendrical system implemented by the receiver is not the Julian calendar, signal an Exception."

	"Yup, that's me--so do nothing."! !

!JulianCalendar methodsFor: 'private' stamp: ''!
bindToSystem
	"Make the receiver and other sytem objects collaborate with each other, as required by the overall system architecture."

	Julian == nil ifTrue: [self register].
	super bindToSystem! !

!JulianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsFromEpochUpToGregorianStart

	^(self 
		daysSinceEpochUpToMonth: 10
		day: 5
		inYear: 1582) * SecondsPerDay! !

!JulianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^(1721423 * SecondsPerDay) +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!JulianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToMonth: monthOrdinal day: dayOfMonthOrdinal  inYear: calendarYear
	"Answer the number of days since the receiver's epoch up to (but not including) the <dayOfMonthOrdinal>th day of the <monthOrdinal>th month of the given <calendarYear>.  By definition, the answer when <calendarYear> = 1 (assuming positve years are ordinal numbers,) <monthOrdinal> = 1 and <dayOfMonthOrdinal> = 1 must be zero."

	^self class daysSinceEpochUpToMonth: monthOrdinal day: dayOfMonthOrdinal  inYear: calendarYear! !

!JulianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	^self class daysSinceEpochUpToYear: calendarYear! !

!JulianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	^self class daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode! !

!JulianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear 
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	^self class daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear! !

!JulianCalendar methodsFor: 'testing' stamp: ''!
isJulian
	"If the receiver implements the Julian Calendar, answer true. Otherwise, answer false."

	^true! !

!JulianCalendar methodsFor: 'initialize-release' stamp: ''!
register
	super register.
	ChronosEnvironment canonical setJulian: self! !

!JulianCalendar methodsFor: 'initialize-release' stamp: ''!
release
	super release.
	self == Julian ifTrue: [ChronosEnvironment canonical setJulian: nil]! !

RomanicCalendar subclass: #GregorianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!GregorianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

GregorianCalendar

	Concept:

		GregorianCalendar implements the Gregorian Calendar. The Gregorian Calendar is the official, civil calendar of most (but not all) nations of the world.  It uses the same month structure and epoch year as the Julian Calendar, but uses a leap year rule that (compared to the Julian Calendar) more accurately keeps the mean length of the Gregorian calendar year the same as the mean length of the solar year. 

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Gregorian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Gregorian Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		The Gregorian Calendar became the official, civil calendar of most of the Catholic countries of Europe (replacing the Julian Calendar) by the decree of Pope Gregory on October 15, 1582 AD [Gregorian], which corresponds to October 5, 1582 AD [Julian]. The British Empire switched from the Julian Calendar to the Gregorian Calendar on 14 September 1752 AD [Gregorian], which corresponds to 3 September 1752 AD [Julian]. Other European countries switched at other times. Some European countries did not switch from the Julian to the Gregorian Calendar until the early 20th Century.

		Epoch Date

			The epoch date of the Gregorian Calendar is, of course, 1 January 1 AD [Gregorian], which corresponds to 3 January 1 AD [Julian]. The Gregorian epoch date was set two days after the Julian (Dionysian) epoch date solely so that the date of the Vernal Equinox in the Gregorian Calendar (going forward from 1582) would be on or about 21 March, the same date on or about which the Vernal Equinox would have occurred when the official Church formula for computing the date of Easter was formally adopted at the Council of Nicaea in 325 AD.  [Note: Fixing the date of Easter was the sole motivation behind the Catholic Church's decision to adopt the Gregorian Calendar].

			 The Julian Date of the epoch of the Gregorian Calendar is 1,721,425.50 (midnight.) 

			Year 1 of the Gregorian Calendar is the first year of the Anno Domini era ("Anno Domini" is Latin for "In the year of the Lord.") Years prior to the year 1 Anno Domini are referred to as being in the era "Before Christ" (BC)--which is in English instead of Latin simply because the era was so named (originally) by the Venerable Bede, in his 'Ecclesiastical History of the English Nation,' which was published (in Old English) in the Eighth Century AD. 

			For information about a) the epoch year shared by both the Gregorian and Julian Calendars, and b) the Anno Domini Era (which begins in that year,) see the class comment of JulianCalendar.

		Time-of-Day Clock

			Modernly, midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  However, such has not always been the case for all users of the Gregorian Calendar.

			{GregorianCalendar clock today}
			{GregorianCalendar clock now}

		Year Numbering Policy

			The Gregian Calendar uses ordinal year numbering (as required by the ANSI Smalltalk standard.)  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			A year is a leap year if its ordinal is evenly divisible by 400, or else if its ordinal is evenly divisible by 4 but not by 100.  Consequently, the year 2000 is a leap year (evenly divisible by 400,) the year 1900 is not a leap year (evenly divisible by 100, but not by 400,) the year 2008 is a leap year (evenly divisible by 4, but not by 100,) and the year 2010 is not a leap year (divisible neither by 4 nor by 400.)

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: January					31/31
			2: February					28/29
			3: March					31/31
			4: April						30/30
			5: May						31/31
			6: June						30/30
			7: July						31/31
			8: August					31/31
			9: September				30/30
			10: October					31/31
			11: November				30/30
			12: December				31/31

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name.

	Usage:

		In the case of class APIs where some messages provide for specifying a Calendar, but other variations of semantically "the same" message omit any "calendar:" parameter, the Gregorian Calendar is the implied (default) Calendar that will be used.  The reaons for this behavior are that 1) the Gregorian Calendar is the de facto international standard calendar--many people never use any other calendar, and are at best only vaguely aware that other calendars even exist, and 2) in some cases, the message-variants that omit the "calendar:" parameter are required by the ANSI-Smalltalk standard to function as though the Gregorian Calendar were the implied parameter (e.g., the DateAndTimeFactory protocol defined by the ANSI-Smalltalk standard.)

		The Chronos namespace (shared pool) defines the global variable Gregorian, which aliases the canonical instance of GregorianCalendar.  "GregorianCalendar canonical" and "Gregorian" should be the same object.
!

!GregorianCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"VERIFICATION (should evaluate to true): {GregorianCalendar daysSinceEpochUpToYearVerifier value: self}"
	| cardinalYear |
	cardinalYear := calendarYear - 1.
	^ cardinalYear * 365 
		+ (cardinalYear // 4) 
		- (cardinalYear // 100) 
		+ (cardinalYear // 400)! !

!GregorianCalendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToYearVerifier
	"GregorianCalendar daysSinceEpochUpToYearVerifier value: Calendar gregorian"
	^[:calendar | 
	((((((calendar daysSinceEpochUpToYear: 1) = 0)
			and: [((calendar daysSinceEpochUpToYear: 0) = -366)
				and: [((calendar daysSinceEpochUpToYear: 4) = 1095)
					and: [((GregorianCalendar daysSinceEpochUpToYear: -3) = -1461)
						and: [(calendar daysSinceEpochUpToYear: 5) = 1461]]]])
		and: [((calendar daysSinceEpochUpToYear: 101) = 36524)
				and: [((calendar daysSinceEpochUpToYear: 100) = 36159)
					and: [((calendar daysSinceEpochUpToYear: 104) = 37619)
						and: [((calendar daysSinceEpochUpToYear: 97) = 35064)
							and: [(calendar daysSinceEpochUpToYear: 105) = 37985]]]]])
		and: [((calendar daysSinceEpochUpToYear: -99 ) = -36525)
				and: [((calendar daysSinceEpochUpToYear: -100) = -36890)
					and: [((calendar daysSinceEpochUpToYear: -96) = -35430)
						and: [((calendar daysSinceEpochUpToYear: -103) = -37985)
							and: [(calendar daysSinceEpochUpToYear: -95) = -35064]]]]])
		and: [((calendar daysSinceEpochUpToYear: 401) = 146097)
				and: [((calendar daysSinceEpochUpToYear: 400) = 145731)
					and: [((calendar daysSinceEpochUpToYear: 404) = 147192)
						and: [((calendar daysSinceEpochUpToYear: 397) = 144636)
							and: [(calendar daysSinceEpochUpToYear: 405) = 147558]]]]])
		and: [((calendar daysSinceEpochUpToYear: -399 ) = -146097)
				and: [((calendar daysSinceEpochUpToYear: -400) =  -146463)
					and: [((calendar daysSinceEpochUpToYear: -396) = -145002)
						and: [((calendar daysSinceEpochUpToYear: -403) =  -147558)
							and: [(calendar daysSinceEpochUpToYear: -395) =  -144636]]]]]]! !

!GregorianCalendar class methodsFor: 'functional verification' stamp: ''!
daysUpToMonthDayInYearVerifier
	"GregorianCalendar daysUpToMonthDayInYearVerifier value: Calendar gregorian"
	^[:calendar |
		((((((calendar daysUpToMonth: 2 day: 29 inYear: 2000) = 59)
		and: [(calendar daysUpToMonth: 3 day: 1 inYear: 2000) = 60])
		and: [(calendar daysUpToMonth: 3 day: 1 inYear: 1900) = 59])
		and: [(calendar daysUpToMonth: 12 day: 31 inYear: 1900) = 364])
		and: [(calendar daysUpToMonth: 12 day: 31 inYear: 2000) = 365])
		and: [super daysUpToMonthDayInYearVerifier value: calendar canonical]]! !

!GregorianCalendar class methodsFor: 'functional verification' stamp: ''!
forDaysSinceEpochSetYearAndCalendarDayIntoVerifier
	"GregorianCalendar forDaysSinceEpochSetYearAndCalendarDayIntoVerifier value: Calendar gregorian"

	^[:calendar | 
	| passes |
	passes := true.
	(calendar forDaysSinceEpoch: 577735
		setYearAndCalendarDayInto: 
			[:year :calendarDay | 
			passes := passes 
						and: [year = 1582 and: [calendarDay month = 10 and: [calendarDay dayOfMonth = 15]]]]) 
			and: 
				[calendar forDaysSinceEpoch: -1721426
					setYearAndCalendarDayInto: 
						[:year :calendarDay | 
						passes := passes 
									and: [year = -4713 and: [calendarDay month = 11 and: [calendarDay dayOfMonth = 24]]]]].
		passes and: [super forDaysSinceEpochSetYearAndCalendarDayIntoVerifier value: calendar]]! !

!GregorianCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"GregorianCalendar initialize"

	self basicInitialize.! !

!GregorianCalendar class methodsFor: 'private' stamp: ''!
leapDayCorrectionForYear: year month: month 
        
        ^month > 2 
                ifTrue: [(year \\ 4 = 0 and: [year \\ 100 ~= 0 or: [year \\ 400 = 0]]) ifTrue: [1] ifFalse: [2]] 
                ifFalse: [0]! !

!GregorianCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Gregorian! !

!GregorianCalendar class methodsFor: 'private' stamp: ''!
shouldIgnorePostLoad
	^true! !

!GregorianCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^calendarYear \\ 4 == 0 
		ifTrue: [calendarYear \\ 100 == 0 
					ifTrue: [calendarYear \\ 400 == 0 
								ifTrue: [2] 
								ifFalse: [1]] 
					ifFalse: [2]]
		ifFalse: [1]! !

!GregorianCalendar methodsFor: 'API-validation' stamp: ''!
assertIsGregorian
	"If the calendrical system implemented by the receiver is not the Gregorian calendar, signal an Exception."

	"Yup, that's me--so do nothing."! !

!GregorianCalendar methodsFor: 'private' stamp: ''!
basicNewCalendarClock
	"Answer a new CalendarClock for use by the receiver as its canonical CalendarClock."

	^ChronosSystemClock current newGregorianCalendarClock! !

!GregorianCalendar methodsFor: 'private' stamp: ''!
bindToClock
	"Perforn any necessary configuration or set up so that the receiver's <clock> can properly operate as the receiver's canonocal CalendarClock."

	super bindToClock.
	ChronosEnvironment canonical setAnsiStandardCalendarClock: self clock! !

!GregorianCalendar methodsFor: 'private' stamp: ''!
bindToSystem
	"Make the receiver and other sytem objects collaborate with each other, as required by the overall system architecture."

	Gregorian == nil ifTrue: [self register].
	super bindToSystem! !

!GregorianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsFromEpochUpToGregorianStart

	^(self 
		daysSinceEpochUpToMonth: 10
		day: 15
		inYear: 1582)  * SecondsPerDay! !

!GregorianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^(1721425 * SecondsPerDay) +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!GregorianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToMonth: monthOrdinal day: dayOfMonthOrdinal  inYear: calendarYear
	"Answer the number of days since the receiver's epoch up to (but not including) the <dayOfMonthOrdinal>th day of the <monthOrdinal>th month of the given <calendarYear>.  By definition, the answer when <calendarYear> = 1 (assuming positve years are ordinal numbers,) <monthOrdinal> = 1 and <dayOfMonthOrdinal> = 1 must be zero."

	^self class daysSinceEpochUpToMonth: monthOrdinal day: dayOfMonthOrdinal  inYear: calendarYear! !

!GregorianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	^self class daysSinceEpochUpToYear: calendarYear! !

!GregorianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	^self class daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode! !

!GregorianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear 
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	^self class daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear! !

!GregorianCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."
	"days-in-four-year-cycle=1461; days-in-century=36524; days-in-four-centuries=146097; days-in-20 centuries=730485 "

	| quadCentury century quadYear year days yearTypeCode |
	quadCentury := daysSinceEpoch // 146097.
	days := daysSinceEpoch \\ 146097.
	century := days // 36524.
	days := days \\ 36524.
	(days == 0 and: [century == 4]) 
		ifTrue: 
			["Handle the 36524th cardinal day--a leap day"
			century := century - 1.
			days := 36524].
	quadYear := days // 1461.
	days := days \\ 1461.
	year := days // 365.
	days := days \\ 365.
	(days == 0 and: [year == 4]) 
		ifTrue: 
			["Handle the 365th cardinal day--a leap day"
			year := year - 1.
			days := 365].
	yearTypeCode := 
		year == 3 "Last year in 4-year cycle"
			ifTrue: 
				[quadYear = 24 "last 4-year cycle in century"
					ifTrue: 
						[century = 3 "last century in 4-century cycle" 
							ifTrue: [2] ifFalse: [1]]
					ifFalse: [2]]
			ifFalse: [1].
	^yearMonthDaySpecOrBlock2
		value: (year + (quadCentury * 400) + (century * 100) + (quadYear * 4))  + 1
		value: ((yearlyCalendars at: yearTypeCode) basicDayAt: days + 1)! !

!GregorianCalendar methodsFor: 'API-InterCalendar' stamp: ''!
gregorianDateSpecFromDaysSinceEpoch: daysSinceEpoch 	
	"Answer an instance of DateSpec that specifies a Gregorian year/month/day that is daysSinceEpoch days since my Epoch."

	^self dateSpecFromDaysSinceEpoch: daysSinceEpoch! !

!GregorianCalendar methodsFor: 'API-testing' stamp: ''!
isAnsiStandard
	"If the calendrical system implemented by the receiver conforms in all respects to the requirements of the ANSI Smalltalk standard with respect to the behavior of DateAndTime instances, answer true.  Otherwise, answer false.  Specifically: Answer true if and only if the receiver implements the proleptic Gregorian Calendar using astronomical (pure ordinal) year numbering."

	^true! !

!GregorianCalendar methodsFor: 'API-testing' stamp: ''!
isGregorian
	"If the receiver implements the Gregorian Calendar, answer true. Otherwise, answer false."

	^true! !

!GregorianCalendar methodsFor: 'initialize-release' stamp: ''!
register
	super register.
	ChronosEnvironment canonical
		setGregorian: self;
		setAnsiStandardCalendar: self! !

!GregorianCalendar methodsFor: 'initialize-release' stamp: ''!
release
	super release.
	self == Gregorian 
		ifTrue: 
			[(ChronosEnvironment canonical)
				setGregorian: nil;
				setAnsiStandardCalendar: nil;
				setAnsiStandardCalendarClock: nil]! !

!GregorianCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^calendarYear \\ 4 == 0 
		ifTrue: [calendarYear \\ 100 == 0 
					ifTrue: [calendarYear \\ 400 == 0 
								ifTrue: [2] 
								ifFalse: [1]] 
					ifFalse: [2]]
		ifFalse: [1]! !

!RomanicCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysInMonth: month forYearTypeCode: yearTypeCode 
 	"Answer the number of days in the month whose ordinal is <monthOrdinal>, in a year whose typeCode is <yearTypeCode>."

        ^(#((31 28 31 30 31 30 31 31 30 31 30 31) 
           (31 29 31 30 31 30 31 31 30 31 30 31)) at: yearTypeCode) at: month! !

!RomanicCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysInMonth: month inYear: year
       ^self daysInMonth: month forYearTypeCode: (self typeCodeOfYear: year)! !

!RomanicCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysSinceEpochUpToMonth: monthOrdinal day: dayOfMonthOrdinal  inYear: calendarYear
	"Answer the number of days since the receiver's epoch up to (but not including) the <dayOfMonthOrdinal>th day of the <monthOrdinal>th month of the given <calendarYear>.  By definition, the answer when <calendarYear> = 1 (assuming positve years are ordinal numbers,) <monthOrdinal> = 1 and <dayOfMonthOrdinal> = 1 must be zero."

	"VERIFICATION (should evaluate to true):
		Gregorian: 		{GregorianCalendar daysSinceEpochUpToMonthDayInYearVerifier value: GregorianCalendar}
		Julian: 			{JulianCalendar daysSinceEpochUpToMonthDayInYearVerifier value: JulianCalendar}
		Equivalence:	{(((JulianCalendar daysSinceEpochUpToMonth: 10 day: 5 inYear: 1582) 
							- (GregorianCalendar daysSinceEpochUpToMonth: 10 day: 15 inYear: 1582))
								= (JulianCalendar daysSinceEpochUpToMonth: 1 day: 3 inYear: 1))
						and: [((GregorianCalendar daysSinceEpochUpToMonth: 10 day: 15 inYear: 1582) 
							- (JulianCalendar daysSinceEpochUpToMonth: 10 day: 5 inYear: 1582))
								= (GregorianCalendar daysSinceEpochUpToMonth: 12 day: 30 inYear: 0)]}"

	^(self 
		daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear)
		+ (self daysSinceEpochUpToYear: calendarYear)! !

!RomanicCalendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToMonthDayInYearPassesVerification
	^self daysSinceEpochUpToMonthDayInYearVerifier value: self! !

!RomanicCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysSinceEpochUpToYear: ordinalYearNumber 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	^self subclassResponsibility! !

!RomanicCalendar class methodsFor: 'functional verification' stamp: ''!
daysSinceEpochUpToYearPassesVerification
	^self daysSinceEpochUpToYearVerifier value: self! !

!RomanicCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	^dayOfMonthOrdinal - 1 
		+ (30 * (monthOrdinal - 1)) 
		+ ((monthOrdinal // 8 + monthOrdinal) // 2) 
		- (monthOrdinal > 2 ifTrue: [yearTypeCode - 1] ifFalse: [0])! !

!RomanicCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal inYear: calendarYear 
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	"VERIFICATION-Gregorian (should evaluate to true):
		{GregorianCalendar daysUpToMonthDayInYearVerifier value: GregorianCalendar}"

	"VERIFICATION-Julian (should evaluate to true):
		{JulianCalendar daysUpToMonthDayInYearVerifier value: JulianCalendar}"

	^dayOfMonthOrdinal - 1 
		+ (30 * (monthOrdinal - 1)) 
		+ ((monthOrdinal // 8 + monthOrdinal) // 2) 
		- (self leapDayCorrectionForYear: calendarYear month: monthOrdinal)! !

!RomanicCalendar class methodsFor: 'functional verification' stamp: ''!
daysUpToMonthDayInYearPassesVerification
	^self daysUpToMonthDayInYearVerifier value: self! !

!RomanicCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"RomanicCalendar initialize"

	LeapYearTypeCode := 2.
	self basicInitialize.! !

!RomanicCalendar class methodsFor: 'private' stamp: ''!
leapDayCorrectionForYear: year month: month 
        
        ^month > 2 
                ifTrue: [(self typeCodeOfYear: year) - 1] 
                ifFalse: [0]! !

!RomanicCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #January 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #February 		daysPerMonth: 29 leapDayOrdinals: #(29));
		nextPut: (MonthlyCalendarSpec newWithKey: #March 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #April 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #May 			daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #June 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #July 			daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #August 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #September 	daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #October 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #November 	daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #December 	daysPerMonth: 31 leapDayOrdinals: #()).
	^specs contents! !

!RomanicCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #January 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #February 		daysPerMonth: 28 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #March 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #April 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #May 			daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #June 			daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #July 			daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #August 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #September 	daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #October 		daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #November 	daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #December 	daysPerMonth: 31 leapDayOrdinals: #()).
	^specs contents! !

!RomanicCalendar methodsFor: 'private' stamp: ''!
computeSecondsFromEpochUpToGregorianStart
	"Compute and answer the number of seconds from the receiver's epoch up to the canonical moment of official/legal transition to the Gregorian Calendar."

	^self subclassResponsibility! !

!RomanicCalendar methodsFor: 'API-queries-months' stamp: ''!
daysInMonth: monthOrdinal forYearTypeCode: yearTypeCode
	"Answer the number of days in the month whose ordinal is <monthOrdinal>, in a year whose typeCode is <yearTypeCode>."

	^self class daysInMonth: monthOrdinal forYearTypeCode: yearTypeCode! !

!RomanicCalendar methodsFor: 'API-queries-months' stamp: ''!
daysInMonth: month inYear: year
       ^self class daysInMonth: month inYear: year! !

!RomanicCalendar methodsFor: 'API-queries-years' stamp: ''!
daysInYearForYearTypeCode: yearTypeCode
	"Answer the number of days per year there are in a year whose type is identified by the code <yearTypeCode>."

	^yearTypeCode + 364! !

!RomanicCalendar methodsFor: 'API-queries-years' stamp: ''!
eraNameForYear: calendarYear
	"Answer the abbreviation of the name of the era to which <calendarYear> belongs.  The name of an era identifies the epoch date of a calendrical system and/or the calendrical system itself (although it may do so ambiguously.) The era name may also identify whether or not the <calendarYear> occurs before or after the epoch date."

	^(yearNumberingPolicy cardinalFromCanonical: calendarYear) >= 0
		ifTrue: [self defaultLocale properNameAtSemanticKey: #'Christian-era-postEpoch'] 
		ifFalse: [self defaultLocale properNameAtSemanticKey: #'Christian-era-preEpoch']! !

!RomanicCalendar methodsFor: 'API-InterCalendar' stamp: ''!
forSecondsSinceEpoch: secondsSinceEpoch canonicalCalendarAndSecondsSinceEpochDo: block2 ifSameCalendar: block0 
	"For a timepoint that is <secondsSinceEpoch> seconds since the initial moment of the epoch day of the receiver's calendar, determine whether the receiver is the canonical calendar used by the culture that would be, or would have been, the principal users of the receiver's calendar. If so, answer the result of evaluating ther zero-argument block <block0>.  Otherwise, answer the result of evaluating the two-argument block <block2>, where the first block argument is the Calendar instance that is canonical for that culture at that moment in time, and where the second block argument is the number of seconds since the initial moment of the epoch day of the calendrical system represented by the first block argument."

	^secondsSinceEpoch >= secondsFromEpochUpToGregorianStart 
		ifTrue: 
			[self isGregorian 
				ifTrue: [block0 value]
				ifFalse: 
					[block2 
						value: Gregorian
						value: (Gregorian
								secondsSinceEpochFromForeignSecondsSinceEpoch: secondsSinceEpoch
								convertingFrom: self)]]
		ifFalse: 
			[self isJulian 
				ifTrue: [block0 value]
				ifFalse: 
					[block2 
						value: Julian
						value: (Julian
								secondsSinceEpochFromForeignSecondsSinceEpoch: secondsSinceEpoch
								convertingFrom: self)]]! !

!RomanicCalendar methodsFor: 'private' stamp: ''!
initializeReferenceTimes
	"Initialize the instance variables of the receiver that store values used to convert between calendrical systems, or that otherwise serve to provide temporal reference points for interpreting dates in the receiver's calendrical system in a calendar-neutral manner."

	super initializeReferenceTimes.
	secondsFromEpochUpToGregorianStart := self computeSecondsFromEpochUpToGregorianStart! !

!RomanicCalendar methodsFor: 'API-testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the calendrical system represented by the receiver starts each day at local midnight."

	^true! !

!RomanicCalendar methodsFor: 'API-InterCalendar' stamp: ''!
secondsFromEpochUpToGregorianStart
	^secondsFromEpochUpToGregorianStart! !

MonthsPerYearInvariantCalendar subclass: #SolarianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!SolarianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

SolarianCalendar

	Concept:

		SolarianCalendar implements the Solarian Calendar.  The SolarianCalendar is an invention of the author of Chronos.  It was designed to ensure that, as far as possible, the solstices and equinoxes should occur on either the first of a month, or else on the last day of the previous month.  The formal, official specification of the Solarian calendrical system has not yet been finalized.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Solarian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Solarian Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Solarian Calendar, 0001-01-01 [Solarian], corresponds to 4236-12-23 [Gregorian] (astronomical year numbering) and to -4236-01-26 [Julian] (traditional year numbering.)  The Julian Date of the epoch of the Solarian Calendar is 174,249.50 (midnight.) 

			The epoch date of the Solarian Calendar is the Winter Solstice of the year in which the ancient Egyptian Calendar was founded, which corresponds to 4236 BC. This is the earliest recorded year in history.

			The name of the Solarian Calendar's era is "Solarian Year" (SY)--which is in English, obviously.

		Time-of-Day Clock

			Midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  

			{SolarianCalendar clock today}
			{SolarianCalendar clock now}

		Year Numbering Policy

			The Solarian Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			There is a master cycle of 2820 years, during which 683 years are leap years. Each standard year contains 365 days, and each leap year contains 366 days, so the master 2820-year cycle contains 1,029,983 days [(2820 * 365) + 683 = 1,029,983].  Based on the current mean length of the tropical year and solar day, there are 1,029,983.00118 days in 2820 tropical years.  So, were it not for the fact that a) the length of the tropical year and the length of a mean solar day is slowly changing, and b) the length of the tropical year (which is defined by the duration between winter solstices) is not the same as the length of the spring equinoctial year (which is defined by the duration between vernal equinoxes,) it would be fair to say that the Solarian calendar deviates from the length of a year by only 101.952 minutes in 2820 years.  But for those (and other) caveats, the Solarian calendar would slip from perfect alignment with the tropical year by only one day every 39,829.68 years--which is astounding accuracy, in spite of the caveats. 

			Within each 2820-year cycle, there are 22 subcycles--the first 21 each contain 128 years, and the 22nd (final) subcycle contains 132 years [2820 = 21 * 128 + 132].

			Each 128-year subcycle contains one 29-year sub-subcycle (the first,) followed by three 33-year sub-subcycles [128 = 29 + (3 * 33)].

			Each 132-year subcycle contains one 29-year sub-subcycle (the first,) followed by two 33-year sub-subcycles, followed by one 37-year sub-subcycle [132 = 29 + (2 * 33) + 37].

			A year in a sub-subcycle (whether it contains 29, 33 or 37 years) is a leap year if the ordinal index of the year within the cycle satisfies the following two predicate tests: 1) it's greater than 1, and 2) the remainder after dividing it by 4 is 1 (so the first year in sub-subcyle is never a leap year; the first leap year is the fifth year in the sub-subcycle.) Thus, a 29-year sub-subcycle has 7 leap years, a 33-year sub-subcycle has 8 leap years, and a 37-year sub-subcycle has 9 leap years (Note: the last year of a sub-subcycle is always a leap year, since 29, 33 and 37 all result in a remainder of 1 when divided by 4) [21 * (7 + (3 * 8)) + (7 + (2 * 8) + 9) = 683].

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Month1					28/28
			2: Month2					30/31
			3: Month3					31/31
			4: Month4					31/31
			5: Month5					31/31
			6: Month6					31/31
			7: Month7					31/31
			8: Month8					31/31
			9: Month9					31/31
			10: Month10				31/31
			11: Month11				31/31
			12: Month12				28/28

			Days In Year				365/366

			The names of the months are acutually unspecified.  It is the responsiblity of each culture/language group to devise or evolve month names that are appropriate to their language and culture. The semantic month-key of a month is the English word #Month followed by one or more digits that identify the month ordinal.


			
	
!

!SolarianCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	"SolarianCalendar initialize."

	self basicInitialize.! !

!SolarianCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForLeapYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a leap (non-standard) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a leap year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Month1	daysPerMonth: 28 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month2	daysPerMonth: 31 leapDayOrdinals: #(31));
		nextPut: (MonthlyCalendarSpec newWithKey: #Month3 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month4 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month5	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month6 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month7	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month8	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month9	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month10 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month11	 daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month12	 daysPerMonth: 28 leapDayOrdinals: #()).
	^specs contents! !

!SolarianCalendar class methodsFor: 'private' stamp: ''!
newMonthlyCalendarSpecsForStandardYear
	"Construct and answer an Array of MonthlyCalendarSpecs specifying the month structure of a standard (non-leap) year in the calendrical system implemented by instances of the receiver. There must be a MonthlyCalendarSpec in the Array for each month of a standard year.  The index of each MonthlyCalendarSpec in the Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec."

	| specs |
	specs := Array new writeStream.
	specs 
		nextPut: (MonthlyCalendarSpec newWithKey: #Month1	daysPerMonth: 28 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month2	daysPerMonth: 30 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month3 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month4 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month5	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month6 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month7	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month8	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month9	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month10 	daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month11	 daysPerMonth: 31 leapDayOrdinals: #());
		nextPut: (MonthlyCalendarSpec newWithKey: #Month12	 daysPerMonth: 28 leapDayOrdinals: #()).
	^specs contents! !

!SolarianCalendar class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Answer the well-known semantic key that uniquely identifies the calendrical system implemented by the receiver."

	^#Solarian! !

!SolarianCalendar methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's calendrical system."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^174249 * SecondsPerDay +  self secondsSinceStartOfJulianDayAtStartOfDay! !

!SolarianCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysSinceEpochUpToYear: calendarYear 
	"Answer the count of days since the Epoch day (start of day) up to (but NOT including) the first day of the specified year."

	"{SolarianCalendar canonical daysSinceEpochUpToYear: 5}"
	"{SolarianCalendar canonical daysSinceEpochUpToYear: 475} = 173125"
	"{(SolarianCalendar canonical daysSinceEpochUpToYear: 2821)}  = 1029983"

	| cardinalYear dividend year |
	cardinalYear := yearNumberingPolicy cardinalFromCanonical: calendarYear.
	dividend := cardinalYear - 473.
	year := (dividend \\ 2820)  + 474.
	^(1029983 * (dividend // 2820)) + (365 * (year - 1)) + ((682 * year - 110) // 2816)! !

!SolarianCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearAndCalendarDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	"SolarianCalendar canonical 
		forDaysSinceEpoch: 1029983
		setYearAndCalendarDayInto: [:year :cd | Array with: year with: cd with: cd yearTypeCode]"

	| cycles days year daysSinceEpochUpToYear daysSinceStartOfYear |
	days := daysSinceEpoch - 173125.
	cycles := days // 1029983.
	days := days \\ 1029983.
	days = 1029982 
		ifTrue: [year := 2820]
		ifFalse: [year := (2816 * days + 1031337) // 1028522].
	year := yearNumberingPolicy canonicalFromOrdinal: (2820 * cycles + 474 + year). " 2820 + 474 =  3294"
	daysSinceEpochUpToYear := self daysSinceEpochUpToYear: year.
	daysSinceStartOfYear :=  daysSinceEpoch - daysSinceEpochUpToYear.	
	^yearMonthDaySpecOrBlock2 
		value: year
		value: ((yearlyCalendars at: (self typeCodeOfYear: year)) basicDayAt: daysSinceStartOfYear + 1)! !

!SolarianCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	"SolarianCalendar canonical typeCodeOfYear: 0"
	"SolarianCalendar canonical typeCodeOfYear: 1"
	"SolarianCalendar canonical typeCodeOfYear: 475"
	"SolarianCalendar canonical typeCodeOfYear: 479"
	"{(1 to: 2820) inject: 0 into: [:total :year | (SolarianCalendar canonical typeCodeOfYear: year) = 2 ifTrue: [total + 1] ifFalse: [total]]} =  683"

	| cardinalYear dividend year |
	cardinalYear := yearNumberingPolicy cardinalFromCanonical: calendarYear.
	dividend := cardinalYear - 473.
	year := (dividend \\ 2820)  + 474.
	^((year + 38) * 682 \\ 2816) < 682
		ifTrue: [2] ifFalse: [1]! !

!RegularCalendar class methodsFor: 'class initialization' stamp: ''!
basicInitialize
	monthlyCalendarSpecs := nil! !

!RegularCalendar class methodsFor: 'class initialization' stamp: ''!
initialize
	StandardYearTypeCode := 1.
	self basicInitialize! !

!RegularCalendar class methodsFor: 'private' stamp: ''!
monthlyCalendarSpecs
	monthlyCalendarSpecs == nil ifTrue: [self setMonthlyCalendarSpecs].
	^monthlyCalendarSpecs! !

!RegularCalendar class methodsFor: 'private' stamp: ''!
setMonthlyCalendarSpecs
	"Initialize the class instance variable monthlyCalendarSpecs, so that it contains an Array of Array of MonthlyCalendarSpecs.  There must be one Array of MonthlyCalendarSpecs in the outer Array (the one referenced by monthlyCalendarSpecs) for each 'year type' of the calendrical system implemented by instances of the receiver.  There must be a MonthlyCalendarSpec in the inner Array for each month for each year type.  See the class comments of ArithmeticalCalendar, Calendar and MonthlyCalendarSpec for more information."

	^self subclassResponsibility! !

!RegularCalendar class methodsFor: 'private' stamp: ''!
specificationOfMonthsForYearTypeCode: yearTypeCode
	^self monthlyCalendarSpecs at: yearTypeCode! !

!RegularCalendar class methodsFor: 'accessing' stamp: ''!
standardYearTypeCode
	^StandardYearTypeCode! !

!RegularCalendar class methodsFor: 'fundamental algorithms' stamp: ''!
yearTypeCodesDo: block1
	block1 value: StandardYearTypeCode.
	block1 value: 2.! !

!RegularCalendar methodsFor: 'private' stamp: ''!
bindToYearlyCalendars
	self initializeMonthSemantics.
	maxDaysPerYear := 0.
	maxMonthsPerYear := 0.
	maxDaysPerMonth := 0.
	yearlyCalendars do: [:yearlyCalendar |
		maxDaysPerYear := maxDaysPerYear max: yearlyCalendar daysPerYear.
		maxMonthsPerYear := maxMonthsPerYear max: yearlyCalendar monthsPerYear.
		yearlyCalendar 
			monthsDo: [:monthlyCalendar | 
				maxDaysPerMonth := maxDaysPerMonth max: monthlyCalendar daysPerMonth.
				(monthOrdinalsByMonthKey at: monthlyCalendar monthKey ifAbsentPut: [Set new]) add: monthlyCalendar monthOrdinal.
				(monthKeysByMonthOrdinal at: monthlyCalendar monthOrdinal ifAbsentPut: [Set new]) add: monthlyCalendar monthKey.
				(monthNameKeysByMonthKey at: monthlyCalendar monthKey ifAbsentPut: [Set new]) add: monthlyCalendar nameKey.
				monthKeyByMonthNameKey at: monthlyCalendar nameKey put: monthlyCalendar monthKey]].
	monthOrdinalsAlwaysCorrespondToTheSameMonthKey := ChronosFunction allElementsOf: monthOrdinalsByMonthKey satisfy: [:monthOrdinalsSet | monthOrdinalsSet size = 1].
	monthOrdinalsAlwaysCorrespondToTheSameMonthKey
		ifTrue: 
			[| map |
			map := Dictionary new.
			monthOrdinalsByMonthKey keysAndValuesDo: [:monthKey :monthOrdinalSet | monthOrdinalSet do: [:monthOrdinal | map at: monthKey put: monthOrdinal]].
			monthOrdinalsByMonthKey := map.
			map := Dictionary new.
			monthKeysByMonthOrdinal keysAndValuesDo: [:monthOrdinal :monthKeySet | monthKeySet do: [:monthKey | map at: monthOrdinal put: monthKey]].
			monthKeysByMonthOrdinal := map].
	doMonthKeysAlwaysCorrespondToTheSameMonthNameKey := ChronosFunction allElementsOf: monthNameKeysByMonthKey satisfy: [:monthNameKeySet | monthNameKeySet size = 1].
	doMonthKeysAlwaysCorrespondToTheSameMonthNameKey
		ifTrue: 
			[| map |
			map := Dictionary new.
			monthNameKeysByMonthKey keysAndValuesDo: [:monthKey :monthNameKeySet | monthNameKeySet do: [:monthNameKey | map at: monthKey put: monthNameKey]].
			monthNameKeysByMonthKey := map].

	minDaysPerYear := maxDaysPerYear.
	minDaysPerMonth := maxDaysPerMonth.
	minMonthsPerYear := maxMonthsPerYear.
	yearlyCalendars do: [:yearlyCalendar |
		minDaysPerYear := minDaysPerYear min: yearlyCalendar daysPerYear.
		minMonthsPerYear := minMonthsPerYear min: yearlyCalendar monthsPerYear.
		yearlyCalendar monthsDo: [:monthlyCalendar | minDaysPerMonth := minDaysPerMonth min: monthlyCalendar daysPerMonth]].! !

!RegularCalendar methodsFor: 'API-CalendarPeriods' stamp: ''!
calendarDayFromDayOfYearOrdinal: dayOfYearOrdinal forYearTypeCode: yearTypeCode 
	"Answer the CalendarDay (which see) that represents the day of the year whose ordinal number is <dayOfYearOrdinal>, for any year whose year type code is <yearTypeCode>."

	^(yearlyCalendars at: yearTypeCode) basicDayAt: dayOfYearOrdinal! !

!RegularCalendar methodsFor: 'API-CalendarPeriods' stamp: ''!
calendarDayFromMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode
	"Answer the CalendarDay (which see) that represents the month of the year whose ordinal is <monthOrdinal>, and the day of the month whose ordinal number is <dayOfMonthOrdinal>, for any year whose year type code is <yearTypeCode>."

	^(yearlyCalendars at: yearTypeCode) monthAt: monthOrdinal dayAt: dayOfMonthOrdinal! !

!RegularCalendar methodsFor: 'private' stamp: ''!
computeArrayOfYearlyCalendars
	| list |
	list := SortedCollection sortBlock: [:a :b | a yearTypeCode < b yearTypeCode].
	self yearTypeCodesDo: [:yearTypeCode | list add: (self computeCalendarForYearTypeCode: yearTypeCode)].
	^list asArray! !

!RegularCalendar methodsFor: 'private' stamp: ''!
computeCalendarForYearTypeCode: yearTypeCode
	^StaticYearlyCalendar 
		calendar: self
		typeCode: yearTypeCode 
		specificationOfMonths: (self class specificationOfMonthsForYearTypeCode: yearTypeCode)! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
daysInMonth: monthOrdinal forYearTypeCode: yearTypeCode
	"Answer the number of days in the month whose ordinal is <monthOrdinal>, in a year whose typeCode is <yearTypeCode>."

	^((yearlyCalendars at: yearTypeCode) monthAt: monthOrdinal) daysPerMonth! !

!RegularCalendar methodsFor: 'API-queries-years' stamp: ''!
daysInYearForYearTypeCode: yearTypeCode
	"Answer the number of days per year there are in a year whose type is identified by the code <yearTypeCode>."

	^(yearlyCalendars at: yearTypeCode) daysPerYear! !

!RegularCalendar methodsFor: 'API-Date Deconstruction' stamp: ''!
daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal forYearTypeCode: yearTypeCode
	"Answer the number of days from the start of the year up to the given month/day. 
	For example, the number of days from January 1 up to January 1 is 0 (assuming January 1 is the first day of the year.)"

	^(yearlyCalendars at: yearTypeCode) daysUpToMonth: monthOrdinal day: dayOfMonthOrdinal! !

!RegularCalendar methodsFor: 'API-Date Construction' stamp: ''!
forDaysSinceEpoch: daysSinceEpoch setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2 
	"For a year and CalendarDay that is daysSinceEpoch days since my Epoch, send #value:value: to <yearMonthDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	^self subclassResponsibility! !

!RegularCalendar methodsFor: 'private' stamp: ''!
initializeIntraYearValues
	"Initialize the instance variables of the receiver that specify or describe the properties and organizational structure of days-of-the-year, months and days-of-the-month in the calendrical system of the receiver."

	super initializeIntraYearValues.
	self setYearlyCalendars: self computeArrayOfYearlyCalendars.! !

!RegularCalendar methodsFor: 'API-testing' stamp: ''!
isDaysPerMonthInvariant
	"If there are always the exact same number of days in all months of all years, answer true. Otherwise, answer false."

	^minDaysPerMonth = maxDaysPerMonth! !

!RegularCalendar methodsFor: 'API-testing' stamp: ''!
isDaysPerYearInvariant
	"If there are always the exact same number of days in all years, answer true. Otherwise, answer false."

	^minDaysPerYear = maxDaysPerYear! !

!RegularCalendar methodsFor: 'API-testing' stamp: ''!
isMonthsPerYearInvariant
	"If there are always the exact same number of months in all years, answer true. Otherwise, answer false."

	^minMonthsPerYear = maxMonthsPerYear! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
maximumDayOfYearOrdinalForMonth: monthOrdinal day: dayOfMonthOrdinal 
	"Answer the largest day-of-year ordinal corresponding to the intra-year date desgnation <monthOrdinal>/<dayOfMonthOrdinal>, for a year of any type."

	^yearlyCalendars inject: 1
		into: 
			[:max :yearlyCalendar | 
			| dayOfYearOrdinal |
			dayOfYearOrdinal := dayOfMonthOrdinal = 1 
						ifTrue: [(yearlyCalendar daysUpToMonth: monthOrdinal) + 1]
						ifFalse: 
							[yearlyCalendar dayOfYearOrdinalForMonth: monthOrdinal
								day: dayOfMonthOrdinal].
			dayOfYearOrdinal == nil ifTrue: [max] ifFalse: [dayOfYearOrdinal max: max]]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
maximumDayOfYearOrdinalForMonthWithKey: monthKey day: dayOfMonthOrdinal
	"Answer the largest day-of-year ordinal corresponding to the intra-year date desgnation <monthKey>/<dayOfMonthOrdinal>, for a year of any type."

	^yearlyCalendars 
		inject: 1 
		into: [:max :yearlyCalendar | 
			| dayOfYearOrdinal |
			dayOfYearOrdinal := dayOfMonthOrdinal = 1
					ifTrue: [(yearlyCalendar daysUpToMonthWithKey: monthKey ifAbsent: [max - 1]) + 1]
					ifFalse: [(yearlyCalendar daysUpToMonthWithKey: monthKey day: dayOfMonthOrdinal ifAbsent: [max - 1]) + 1].
			dayOfYearOrdinal == nil
				ifTrue: [max]
				ifFalse: 
					[dayOfYearOrdinal max: max]]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
maximumDaysInMonth: monthOrdinal 
	"Answer the most number of days that may occur, for any year, in the month whose ordinal is <monthOrdinal>."

	^yearlyCalendars inject: self minDaysPerMonth
		into: [:max :yearlyCalendar | (yearlyCalendar daysInMonthAt: monthOrdinal) max: max]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
maximumDaysInMonthWithKey: monthKey
	"Answer the most number of days that may occur, for any year, in the month whose key is <monthKey>."

	^yearlyCalendars inject: self minDaysPerMonth
		into: [:max :yearlyCalendar | (yearlyCalendar daysInMonthWithKey: monthKey ifAbsent: [max]) max: max ]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
minimumDayOfYearOrdinalForMonth: monthOrdinal day: dayOfMonthOrdinal 
	"Answer the smallest day-of-year ordinal corresponding to the intra-year date desgnation <monthOrdinal>/<dayOfMonthOrdinal>, for a year of any type."

	^yearlyCalendars inject: self maxDaysPerYear
		into: 
			[:min :yearlyCalendar | 
			| dayOfYearOrdinal |
			dayOfYearOrdinal := 
					dayOfMonthOrdinal = 1 
						ifTrue: [(yearlyCalendar daysUpToMonth: monthOrdinal) + 1]
						ifFalse: 
							[yearlyCalendar dayOfYearOrdinalForMonth: monthOrdinal
								day: dayOfMonthOrdinal].
			dayOfYearOrdinal == nil ifTrue: [min] ifFalse: [dayOfYearOrdinal min: min]]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
minimumDayOfYearOrdinalForMonthWithKey: monthKey day: dayOfMonthOrdinal
	"Answer the smallest day-of-year ordinal corresponding to the intra-year date desgnation <monthKey>/<dayOfMonthOrdinal>, for a year of any type."

	^yearlyCalendars 
		inject: self maxDaysPerYear 
		into: [:min :yearlyCalendar | 
			| dayOfYearOrdinal |
			dayOfYearOrdinal := dayOfMonthOrdinal = 1
					ifTrue: [(yearlyCalendar daysUpToMonthWithKey: monthKey ifAbsent: [min - 1]) + 1]
					ifFalse: [(yearlyCalendar daysUpToMonthWithKey: monthKey day: dayOfMonthOrdinal ifAbsent: [min - 1]) + 1].
			dayOfYearOrdinal == nil
				ifTrue: [min]
				ifFalse: 
					[dayOfYearOrdinal min: min]]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
minimumDaysInMonth: monthOrdinal
	"Answer the least number of days that may occur, for any year, in the month whose ordinal is <monthOrdinal>."

	^yearlyCalendars inject: self maxDaysPerMonth
		into: [:min :yearlyCalendar | (yearlyCalendar daysInMonthAt: monthOrdinal) min: min ]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
minimumDaysInMonthWithKey: monthKey
	"Answer the least number of days that may occur, for any year, in the month whose key is <monthKey>."

	^yearlyCalendars inject: self minDaysPerMonth
		into: [:min :yearlyCalendar | (yearlyCalendar daysInMonthWithKey: monthKey ifAbsent: [min]) min: min ]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
monthKeyForMonthAt: monthOrdinal forYearTypeCode: yearTypeCode
	"Answer the monthKey for the month whose ordinal is <monthOrdinal>, in a year whose type is identified by the code <yearTypeCode>."

	^((yearlyCalendars at: yearTypeCode) monthAt: monthOrdinal) monthKey! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
monthOrdinalForMonthWithKey: monthKey forYearTypeCode: yearTypeCode 
	"Answer the month ordinal for the month whose monthKey is <monthKey>, in a year whose type is identified by the code <yearTypeCode>."

	^(yearlyCalendars at: yearTypeCode) 
		monthOrdinalForMonthWithKey: monthKey
		ifAbsent: 
			[^self 
				signalError: 'The ' , self name 
						, ' calendar has no month whose monthKey is ' , monthKey printString]! !

!RegularCalendar methodsFor: 'API-queries-months' stamp: ''!
monthsInYearForYearTypeCode: yearTypeCode
	"Answer the number of months there are per year, in a year whose typeCode is <yearTypeCode>."

	^(yearlyCalendars at: yearTypeCode) monthsPerYear! !

!RegularCalendar methodsFor: 'initialize-release' stamp: ''!
setYearlyCalendars: anArrayOfYearlyCalendars
	self assertMutability.
	yearlyCalendars := anArrayOfYearlyCalendars.
	self bindToYearlyCalendars! !

!RegularCalendar methodsFor: 'API-Date Construction' stamp: ''!
startingWithYear: startYear addingDays: dayDelta setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2 
	"For a year and CalendarDay that is dayDelta days since the first day of the year <startYear>, send #value:value: to <yearMonthDaySpecOrBlock2>, with the year as the first argument and the CalendarDay as the second argument."

	^dayDelta < 2922
		ifTrue: 
			[super 
				startingWithYear: startYear
				addingDays: dayDelta
				setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2]
		ifFalse: 
			[self 
				forDaysSinceEpoch: (self daysSinceEpochUpToYear: startYear) + dayDelta
				setYearAndCalendarDayInto: yearMonthDaySpecOrBlock2]! !

!RegularCalendar methodsFor: 'API-queries-years' stamp: ''!
typeCodeOfYear: calendarYear
	"Answer the year type code of the given <calendarYear>."

	^StandardYearTypeCode! !

!RegularCalendar methodsFor: 'enumerating' stamp: ''!
yearTypeCodesDo: block1
	^self class yearTypeCodesDo: block1! !

!RegularCalendar methodsFor: 'API-CalendarPeriods' stamp: ''!
yearlyCalendarForYearTypeCode: yearTypeCode
	"Answer the YearlyCalendar (which see) that specifies the characteristics of any year whose year type is identifiefied by the code <yearType>, including the year's organization into months and days of the month."

	^yearlyCalendars at: yearTypeCode! !

ChronosObject subclass: #CalendarClock
	instanceVariableNames: 'systemClock calendar secondsFromCalendarEpochUpToSystemClockEpoch secondsFromGregorianEpochUpToSystemClockEpoch'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!CalendarClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CalendarClock

	Concept:

		CalendarClock is an abstract class.  An instance of a concrete subclass of CalendarClock functions as a clock that reports the current date and/or time with respect to a particular calendrical system.  The current date and/or time may be represented by "date," "time-of-day" or "point-in-time" values.  In the case of "point-in-time" values, a CalendarClock instance generates values that conform to the ANSI-Smalltalk "DateAndTime" protocol. By default, a "date" value will be an instance of YearMonthDay, a "time-of-day" value will be an instance of TimeOfDay, and a "point-in-time" value will be an instance of Timepoint (which will be aliased by the global DateAndTime, unless that name is normally assigned to some non-Chronos class.) A CalendarClock is also responsible for converting Chronos date and time objects from and to those that are native to the host Smalltalk environment.

		The two standard concrete subclasses of CalendarClock--UTCalendarClock and LocalTimeCalendarClock--are specialized for dealing with the two fundamentally-different possible operational paradigms of different system clocks: those that report time relative to the UT timezone and those that report time relative to the local timezone. See the classes UTCalendarClock and LocalTimeCalendarClock for more information.

		So conceptually, a CalendarClock is responsible for a) encapsulating a ChronosSystemClock (which see,) regardless of whether it reports time relative to the UT timezone or relative to the local timezone, regardless of its resolution (seconds, milliseconds, microseconds, nanoseconds...,) and regardless of its epoch (the moment-in-time represented by a zero ticks of the system clock, b) converting the current time reported by the encapsulated system clock (as a number of ticks since the system clock epoch, relative to either the UT or local timezone) into a number of seconds and nanoseconds since the epoch of the Calendar to which it is bound, c) converting the number of seconds/nanoseconds since the epoch of its Calendar into a "time-of-day," "date," or "point-in-time" value (as implemented by an appropritate class in the Chronos Date/Time library,) and d) (in collaboration with the SystemClock) converting Chronos time objects to and from their analogs provided by the native/host Smalltalk environment (if any.)

		See the class comment of ChronosSystemClock for more information, including a glossary of clock terminology.

	Usage:

		As is the case with most Chronos classes, CalendarClock instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		Each Chronos Calendar (which see) provides its own CalendarClock flyweight object, which can be accessed by sending the message #clock to either the Calendar instance, or to its class. Each CalendarClock is bound to a particular Chronos Calendar. The time values provided by a CalendarClock specify the current date and time according to the rules of the calendrical sytem implemented by the Calendar to which the CalendarClock is bound.  For example, to access the current date and/or time in terms of the Hebrew Calendar, a CalendarClock bound to the Hebrew Calendar must be used. The following expressions evaluate to the current date and time according to various Calendars:
			
			GregorianCalendar clock now. 
			PersianCalendar clock now. 
			EthiopicCalendar clock now. 	
				"Note: The time-of-day clock for the Ethiopic Calendar starts at 6 am (sunrise.)"

		The Chronos namespace (shared pool) defines the global variable AnsiStandardCalendarClock, which aliases the CalendarClock that is bound to the GregorianCalendar.  "GregorianCalendar clock" and "AnsiStandardCalendarClock" should be the same object--as should "CalendarClock default."

		The messages for accessing the current date and/or time can be categorized as follows:

													Temporal Locality/Relativity Semantics
			Type-of-return-value	Default Timezone				Specified Timezone				UT Timezone					Nominal Time
			
			TimeOfDay			#timeOfDayNow					#timeOfDayNowIn:				#utTimeOfDayNow				N/A
			TimeOfDay			#timeOfDayNowToTheSecond	#timeOfDayNowToTheSecondIn:	N/A								N/A
			YearMonthDay		#dateToday						#dateTodayIn:					N/A								N/A
			DateAndTime 		#today							#todayIn:						#utToday						#nominalToday			
			DateAndTime		#now							#nowIn:							#utNow							#nominalNow
			DateAndTime		#nowToTheSecond				#nowToTheSecondIn:			N/A								#nominalNowToTheSecond
			
		The difference between #now and #nowIn: (for example) is that #now provides the current time relative to the current default time zone, whereas #nowIn: provides the current time relative to the time zone provided as the message argument (each answers an object that probably represents a different local time.)

		The difference between #now and #utNow (for example) is that #now provides the current time relative to the current default time zone, whereas #utNow provides the current time relative to the UT time zone (each answers an object that probably represents a different local time.)

		The difference betweeen #now/#utNow/#nowIn: and #nominalNow (for example) is that #now/#utNow/#nowIn: provide answers that represent time values that are bound to a particular time zone using UT-invariant semantics (which means it represents a well-defined point-in-time relative to the international reference UT timezone,) whereas #nominalNow provides an answer that represents time using nominal-time invariant semantics (which means it represents a particular nominal time without specifying a fixed relation or mapping to any absolute temporal coordinate system.)  See the class comments of Timepoint, ChronosTimezone and NominalTimeInvariantTZ for more information about the differences between "UT-invariant semantics" and "nominal time semantics."

		The difference between #dateToday and #today (for example) is that #dateToday provides an answer that is only a "date" value, and not a "point-in-time" value, whereas #today provides a "point-in-time" value that represents the first moment of the day.
		
		The messages for getting the current time that provide DateAndTime and TimeOfDay values have variants that only provide the current time to the second, and omit any fractions of a second that the system clock may provide.  Such messages provide one way to suppress the print out of fractional seconds (using a ConfigurableChronosPrintPolicy configured to #hideSubsecondFraction is the other.)  They also provide a significant performance advantage for those situations where time-to-the second is good enough.

		It should also be noted that "time-of-day" and "date" values always have nominal time semantics in Chronos--they aren't bound (specific) to any particular time zone. The same is true of "Blue Book"/ST-80 "Date" and "Time" objects (and also of  VisualWorks "Timestamp" objects.) Once created, time-valued objects that aren't bound to a specific time zone have no deterministic, precise mapping or relation to any absolute timescale.  For example, A VisualWorks Timestamp created on a computer running in Bangalore can easily be transported over a network (or in a notebook computer travelling by airplane) to New York, but absent contextual information that the object itself does not encapsulate, there is no way to deterministically convert it to local time in New York. Such is the nature of nominal time values: they specify the designation of a time value, but fail to specify how to map the designated time to any absolute reference scale--a property that is desirable in some situations, and highly undesirable in others.

		Timepoint class and ChronosTimezone both provide a similar API for retrieving the current date and/or time.

	Motivation:

		Since the Chronos Date/Time library is intended to be portable among a wide variety of different Smalltalk implementations, it is necessary to be able to deal with the operational paradigm of whatever system clock happens to be available in a particular case. In many cases, the Smalltalk VM provides its own virtual system clock, encapsulating whatever may be available from the operating system kernel. In such cases, the VM's virtual system clock is probably the only one that's easily-accessible--which mean that it's operational paradigm is the one that must be dealt with, like it or not. Specific cases that exemplify the problem: The VisualWorks VM's virtual system clock reports time relative to the UT timezone (which the VW documentation refers to a "UTC (GMT)"--the first of which is a timescale that--unlike the VW system clock--uses leap seconds, and the second of which is no longer formally/officially defined,) but the Squeak VM's virtual system clock reports time relative to the local timezone. In neither case would it be trivial to use a system clock other than the virtual one provided by the VM.

		Chronos' solution to the problem of the differences between system clock operational paradigms is to provide two distinct layers of encapsulation over whatever "system clock" may be available in a particular Smalltalk execution environment: the ChronosSystemClock class, that encapsulates the protocol for accessing the platform system clock's current tick value (and also provides the meta information necessary to interpret the meaning of the system clock's tick count,) and the CalendarClock class, that encapsulates the mechanisms by which the ChronosSystemClock's meta information is used to convert its tick count into Chronos date/time objects representing temporal values according to a particular calendrical system.

	Implementation:

		Instance Variables

			systemClock 											<ChronosSystemClock>
				The ChronosSystemClock encapsulated by the instance, from which the current time is obtained as a count of ticks since the epoch of the system clock, and from which the meta-information is obtained needed in order to interpret the meaning of the count of clock ticks (see ChronosSystemClock for more information.)
			calendar 												<Calendar>
				The Calnedar that implements the calendrical system that the instance will use to represent the date and/or time values it generates.
			secondsFromCalendarEpochUpToSystemClockEpoch 	<Integer>
				The number of seconds from the epoch of the instance's <calendar> up to the epoch of its <systemClock>.
			secondsFromGregorianEpochUpToSystemClockEpoch	<Integer> 
				The number of seconds from the epoch of the Gregorian Calendar up to the epoch of the instance's <systemClock>.

	Subclassing:

		Concrete subclasses must subimplement the following instance methods:

			#basicDateTodayIn:
			#basicTodayIn:
			#nowIn:includeNanoseconds:
			#timeOfDayNowIn:includeNanoseconds:
			#utNow
			#utTimeOfDayNow
			#utToday!

!CalendarClock class methodsFor: 'accessing' stamp: ''!
ansiStandard
	"Answer the CalendarClock bound to the ANSI-Smalltalk Standard Calendar (Gregorian.)"

	^AnsiStandardCalendarClock! !

!CalendarClock class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^(Calendar referencedBy: (literalArray at: 2)) clock! !

!CalendarClock class methodsFor: 'accessing' stamp: ''!
default
	"Answer the default CalendarClock."

	^AnsiStandardCalendarClock! !

!CalendarClock class methodsFor: 'private' stamp: ''!
implementationClassForSystemClock: aSystemClock
	^(aSystemClock isRelativeToUT 
		ifTrue: [UTCalendarClock]
		ifFalse: [LocalTimeCalendarClock])! !

!CalendarClock class methodsFor: 'initialize-release' stamp: ''!
invalidateCalendarBindings
	"CalendarClock invalidateCalendarBindings"

	self allInstancesDo: [:calendrical | calendrical invalidateCalendar].
	self subclasses do: [:class | class invalidateCalendarBindings]! !

!CalendarClock class methodsFor: 'instance creation' stamp: ''!
systemClock: aSystemClock
	"Answer a new (mutable) instance of the receiver that encapsulates the given <systemClock> (which must be an instance of a concrete subclass of ChronosSystemClock.)"

	^(self implementationClassForSystemClock: aSystemClock) new
		setSystemClock: aSystemClock! !

!CalendarClock methodsFor: 'private' stamp: ''!
basicTodayIn: aTimezone
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the timezone implemented by <aTimezone> (which must be an instance of a concrete subclass of ChronosTimezone,) and with invariant-to-UT semantics." 

	^self subclassResponsibility! !

!CalendarClock methodsFor: 'calendar binding' stamp: ''!
bindToCalendar
	"Set the instance variables <secondsFromCalendarEpochUpToSystemClockEpoch> and <ticksFromCalendarEpochUpToSystemClockEpoch> to values valid for the receiver's calendar, computed de novo.
	POSTCONDITION: The instance variables <secondsFromCalendarEpochUpToSystemClockEpoch> and <ticksFromCalendarEpochUpToSystemClockEpoch> should contain the number of seconds and ticks (respectively) from the Epoch date/time of the receiver's calendar (i.e., Year 1, Month 1, Day1 in a calendar that uses ordinal numbering) up to the Epoch date/time of the internal system clock encapsulated by the receiver (i.e., where clock ticks = 0)."

	"NOTE: The method #chronosDateAndTimeFromNativeCalendricalCoordinate: will not work correctly unless and until the instance variable <secondsFromCalendarEpochUpToSystemClockEpoch> has been set to a valid value--consequently, that method cannot be used to compute the values for which this method is responsible."

	calendar == nil ifTrue: [^nil].
	secondsFromGregorianEpochUpToSystemClockEpoch := systemClock secondsFromGregorianEpochUpToSystemClockEpoch.
	secondsFromCalendarEpochUpToSystemClockEpoch := 
			calendar isGregorian 
				ifTrue: [secondsFromGregorianEpochUpToSystemClockEpoch]
				ifFalse: 
					[calendar 
						secondsSinceEpochFromForeignSecondsSinceEpoch: secondsFromGregorianEpochUpToSystemClockEpoch
						convertingFrom: Calendar gregorian].! !

!CalendarClock methodsFor: 'accessing' stamp: ''!
calendar
	^calendar! !

!CalendarClock methodsFor: 'API-converting' stamp: ''!
chronosDateAndTimeFromNativeCalendricalCoordinate: aNativeTimestampOrDate
	"Answer a Chronos DateAndTime that semantically corresponds as closely as possible to <aNativeTimestampOrDate>.
	PRECONDITION: The receiver must already have been bound to its calendar; 
		specificially, the instance variable <secondsFromCalendarEpochUpToSystemClockEpoch> must contain a valid value."

	^ChronosSystemFacade current chronosDateAndTimeFromNativeCalendricalCoordinate: aNativeTimestampOrDate calendarClock: self! !

!CalendarClock methodsFor: 'API-converting' stamp: ''!
chronosDateFromNativeCalendricalCoordinate: aNativeTimestampOrDate
	"Answer a Chronos YearMonthDay that semantically corresponds as closely as possible to <aNativeTimestampOrDate>.
	PRECONDITION: The receiver must already have been bound to its calendar; 
		specificially, the instance variable <secondsFromCalendarEpochUpToSystemClockEpoch> must contain a valid value."

	^ChronosSystemFacade current chronosDateFromNativeCalendricalCoordinate: aNativeTimestampOrDate calendarClock: self! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
dateToday
	"Answer a date value representing today's date, in the receiver's calendar, and relative to the current default timezone."

	"{Calendar gregorian clock dateToday}"

	"{Calendar julian clock dateToday}"

	^(self mutableDateTodayIn: ChronosTimezone default) beImmutable! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
dateTodayIn: aTimezoneOrTimezoneReference 
	"Answer a date value representing today's date, in the receiver's calendar, and relative to the timezone specified by the value of <aTimezoneOrTimezoneReference>."

	"{Calendar gregorian clock dateTodayIn: (Duration hours: 10) asTimezone}"

	"{Calendar julian clock dateTodayIn: (Duration hours: 10) asTimezone}"

	^(self mutableDateTodayIn: (ChronosTimezone referencedBy: aTimezoneOrTimezoneReference)) 
		beImmutable! !

!CalendarClock methodsFor: 'accessing' stamp: ''!
daysFromCalendarEpochUpToSystemClockEpoch
	"Answer the number of days (mean solar) from the epoch of the receiver's calendar up to (but not including) the epoch of the receiver's systemClock."

	^(secondsFromCalendarEpochUpToSystemClockEpoch bitShift: -7) // 675! !

!CalendarClock methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self calendar registrationKey! !

!CalendarClock methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:16'!
epoch
	"Answer a DateAndTime that represents the epoch of the receiver's systemClock, and that designates the date and time of the sytemClock's epoch using the calendrical system implemented by the receiver's calendar."

	^systemClock isRelativeToUT 
		ifTrue: 
			[(DateAndTimeFactory )
				utSecondsSinceEpoch: self secondsFromCalendarEpochUpToSystemClockEpoch
				timeZone: ChronosTimezone universal
				calendar: calendar]
		ifFalse: 
			[(DateAndTimeFactory )
				secondsSinceEpoch: self secondsFromCalendarEpochUpToSystemClockEpoch
				calendar: calendar]! !

!CalendarClock methodsFor: 'accessing' stamp: ''!
gregorianEpoch
	"Answer a DateAndTime that represents the epoch of the receiver's systemClock, and that designates the date and time of the sytemClock's epoch using the Gregorian Calendar."

	^systemClock epoch! !

!CalendarClock methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	secondsFromCalendarEpochUpToSystemClockEpoch := 0.
	secondsFromGregorianEpochUpToSystemClockEpoch := 0! !

!CalendarClock methodsFor: 'initialize-release' stamp: ''!
invalidateCalendar
	calendar := calendar == nil ifFalse: [Calendar at: calendar registrationKey ifAbsent: [calendar]]! !

!CalendarClock methodsFor: 'private-UT operations' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
mutableDateAndTimeAtStartOfDayFromUTSecondsSinceSystemClockEpoch: utSecondsSinceSystemClockEpoch timeZone: aTimeZone 
	"Answer a Timepoint (bound to the specified <calendar>) whose local time in the time zone defined by the receiver, and as defined by the time-of-day clock of the specified <calendar>, is the first moment of the day (as defined by the specified <calendar>) that starts less than one day prior to the moment in time that is <utSecondsSinceGregorianEpoch> seconds since the Gregorian epoch (relative to Universal Time) and <utSecondsSinceCalendarEpoch> seconds since the epoch of the specified <calendar> (relative to Universal Time)."

	"{HebrewCalendar clock
		mutableDateAndTimeAtStartOfDayFromUTSecondsSinceSystemClockEpoch: SystemClock secondsNowSinceSystemClockEpoch
		timeZone: Timezone default}"
	"{AnsiStandardCalendarClock
		mutableDateAndTimeAtStartOfDayFromUTSecondsSinceSystemClockEpoch: SystemClock secondsNowSinceSystemClockEpoch 
		timeZone: Timezone default}"
	
	| timeZone utSecondsSinceGregorianEpoch secondsDiv128 secondsMod128 gregorianDaysSinceEpoch utcSecondsSinceStartOfDay offsetSecondsFromUT localTZ annualPolicy gregorianYMD today secondsSinceStartOfDay dayDelta |

	utSecondsSinceGregorianEpoch := utSecondsSinceSystemClockEpoch + secondsFromGregorianEpochUpToSystemClockEpoch.
	secondsDiv128 := utSecondsSinceGregorianEpoch bitShift: -7. "Bit shifting is faster than LargeInteger math."
	gregorianDaysSinceEpoch := secondsDiv128 // 675. "128 * 675 = 86400"
	secondsMod128 := utSecondsSinceGregorianEpoch bitAnd: 127.
	utcSecondsSinceStartOfDay := secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7). "seconds \\ 128 + (seconds // 128 \\ 675 * 128)"
	timeZone := aTimeZone.
	localTZ := aTimeZone asNonProxy.
	localTZ isStatic 
		ifTrue: [offsetSecondsFromUT := localTZ offsetSecondsFromUT]
		ifFalse: 
			[gregorianYMD := Gregorian dateSpecFromDaysSinceEpoch: gregorianDaysSinceEpoch.
			annualPolicy := 
				localTZ
					annualPolicyForUTYear: gregorianYMD year
					dayOfYear: gregorianYMD dayOfYearOrdinal
					secondsSinceStartOfDayFunction: [:offsetSeconds | utcSecondsSinceStartOfDay].
			offsetSecondsFromUT := annualPolicy offsetSecondsFromUT.
			aTimeZone isProxy ifFalse: [timeZone := annualPolicy]].
	today := (DateAndTimeFactory basicNew)
				basicSetCalendar: calendar;
				setNanosecondsSinceSecond: 0.
	calendar isGregorian 
		ifTrue: 
			[secondsSinceStartOfDay := utcSecondsSinceStartOfDay + offsetSecondsFromUT.
			offsetSecondsFromUT abs >= SecondsPerDay 
				ifTrue: 
					[dayDelta := secondsSinceStartOfDay // SecondsPerDay.
					secondsSinceStartOfDay := secondsSinceStartOfDay \\ SecondsPerDay]
				ifFalse: 
					[secondsSinceStartOfDay < 0 
						ifTrue: 
							[dayDelta := -1.
							secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]
						ifFalse: 
							[secondsSinceStartOfDay >= SecondsPerDay 
								ifTrue: 
									[dayDelta := 1.
									secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]
								ifFalse: [dayDelta := 0]]].
			gregorianYMD == nil 
				ifTrue: 
					[aTimeZone isInvariantToNominalTime 
						ifTrue: 
							[today
								basicSetSecondsSinceStartOfDay: 0;
								basicSetDaysSinceEpoch: gregorianDaysSinceEpoch + dayDelta]
						ifFalse: 
							[utcSecondsSinceStartOfDay := utcSecondsSinceStartOfDay - secondsSinceStartOfDay.
							utcSecondsSinceStartOfDay < 0 
								ifTrue: 
									[utcSecondsSinceStartOfDay := SecondsPerDay + utcSecondsSinceStartOfDay.
									gregorianDaysSinceEpoch := gregorianDaysSinceEpoch - 1].
							today
								basicSetSecondsSinceStartOfDay: utcSecondsSinceStartOfDay;
								basicSetDaysSinceEpoch: gregorianDaysSinceEpoch;
								basicSetTimeZone: timeZone]]
				ifFalse: 
					[gregorianYMD 
						addingDays: dayDelta
						setYearAndCalendarDayInto: 
							[:year :calendarDay | 
							aTimeZone isInvariantToNominalTime 
								ifTrue: 
									[today
										basicSetSecondsSinceStartOfDay: 0;
										setYear: year
											calendarDay: calendarDay
											daysSinceEpoch: gregorianDaysSinceEpoch + dayDelta]
								ifFalse: 
									[utcSecondsSinceStartOfDay := utcSecondsSinceStartOfDay - secondsSinceStartOfDay.
									utcSecondsSinceStartOfDay < 0 
										ifTrue: 
											[utcSecondsSinceStartOfDay := SecondsPerDay + utcSecondsSinceStartOfDay.
											gregorianDaysSinceEpoch := gregorianDaysSinceEpoch - 1].
									today
										basicSetSecondsSinceStartOfDay: utcSecondsSinceStartOfDay;
										setYear: year
											calendarDay: calendarDay
											daysSinceEpoch: gregorianDaysSinceEpoch;
										basicSetTimeZone: timeZone]]]]
		ifFalse: 
			[| utSecondsSinceCalendarEpoch daysSinceEpoch |
			utSecondsSinceCalendarEpoch := utSecondsSinceSystemClockEpoch + secondsFromCalendarEpochUpToSystemClockEpoch.
			utSecondsSinceCalendarEpoch := 
				aTimeZone isInvariantToNominalTime 
					ifTrue: [utSecondsSinceCalendarEpoch + offsetSecondsFromUT]
					ifFalse: [utSecondsSinceCalendarEpoch].
			secondsDiv128 := utSecondsSinceCalendarEpoch bitShift: -7. "Bit shifting is faster than LargeInteger math."
			daysSinceEpoch := secondsDiv128 // 675. "128 * 675 = 86400"
			aTimeZone isInvariantToNominalTime 
				ifTrue: [secondsSinceStartOfDay := 0]
				ifFalse:
					[secondsMod128 := utSecondsSinceCalendarEpoch bitAnd: 127.
					utcSecondsSinceStartOfDay := secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7). "seconds \\ 128 + (seconds // 128 \\ 675 * 128)"

					secondsSinceStartOfDay := utcSecondsSinceStartOfDay + offsetSecondsFromUT.
					offsetSecondsFromUT abs >= SecondsPerDay 
						ifTrue: [secondsSinceStartOfDay := secondsSinceStartOfDay \\ SecondsPerDay]
						ifFalse: 
							[secondsSinceStartOfDay < 0 
								ifTrue: [secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]
								ifFalse: 
									[secondsSinceStartOfDay >= SecondsPerDay 
										ifTrue: [secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]]].

					secondsSinceStartOfDay := utcSecondsSinceStartOfDay - secondsSinceStartOfDay.
					secondsSinceStartOfDay < 0 
						ifTrue: 
							[secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay.
							daysSinceEpoch := daysSinceEpoch - 1].
					today basicSetTimeZone: timeZone].

			today
				basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
				basicSetDaysSinceEpoch: daysSinceEpoch].
	^today! !

!CalendarClock methodsFor: 'private-UT operations' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
mutableDateAndTimeFromUTSecondsSinceGregorianEpoch: utSecondsSinceGregorianEpoch nanoseconds: nanosecondsSinceSecond timeZone: aTimeZone
	"Answer a Timepoint (bound to the Gregorian Calendar) whose local time in the time zone defined by the receiver is <utSecondsSinceGregorianEpoch> seconds since the Gregorian epoch (relative to Universal Time) and <nanosecondsSinceSecond> nanoseconds since the start of the specified second."

	"{AnsiStandardCalendarClock
		mutableDateAndTimeFromUTSecondsSinceGregorianEpoch: 63240832637 
		nanoseconds: 0
		timeZone: (ChronosTimezone at: #'America/Los_Angeles') }"
	"{AnsiStandardCalendarClock
		mutableDateAndTimeFromUTSecondsSinceGregorianEpoch: 63240832637 
		nanoseconds: 0
		timeZone: (ChronosTimezone at: #'Australia/Adelaide')}"

	| dateAndTime |
	dateAndTime := 
		(DateAndTimeFactory basicNew)
			basicSetCalendar: Gregorian;
			setNanosecondsSinceSecond: nanosecondsSinceSecond.
	aTimeZone isInvariantToUT 
		ifTrue: 
			[dateAndTime
				basicSetTimeZone: aTimeZone root;
				basicSetSecondsSinceEpoch: utSecondsSinceGregorianEpoch]
		ifFalse: 
			[| secondsDiv128 secondsMod128 gregorianDaysSinceEpoch gregorianYMD utcSecondsSinceStartOfDay secondsSinceStartOfDay localTZ offsetSecondsFromUT dayDelta timeZone |
			secondsDiv128 := utSecondsSinceGregorianEpoch bitShift: -7. "Bit shifting is faster than LargeInteger math."
			gregorianDaysSinceEpoch := secondsDiv128 // 675. "128 * 675 = 86400"
			secondsMod128 := utSecondsSinceGregorianEpoch bitAnd: 127.
			utcSecondsSinceStartOfDay := secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7). "seconds \\ 128 + (seconds // 128 \\ 675 * 128)"
			localTZ := aTimeZone asNonProxy.
			localTZ isStatic 
				ifTrue: 
					[timeZone := localTZ binding.
					offsetSecondsFromUT := timeZone offsetSecondsFromUT]
				ifFalse: 
					[gregorianYMD := Gregorian dateSpecFromDaysSinceEpoch: gregorianDaysSinceEpoch.
					timeZone := 
						localTZ 
							bindingForUTYear: gregorianYMD year
							dayOfYear: gregorianYMD dayOfYearOrdinal
							secondsSinceStartOfDayFunction: [:offsetSeconds | utcSecondsSinceStartOfDay].
					offsetSecondsFromUT := timeZone offsetSecondsFromUT].
			secondsSinceStartOfDay := utcSecondsSinceStartOfDay + offsetSecondsFromUT.
			offsetSecondsFromUT abs >= SecondsPerDay 
				ifTrue: 
					[dayDelta := secondsSinceStartOfDay // SecondsPerDay.
					secondsSinceStartOfDay := secondsSinceStartOfDay \\ SecondsPerDay]
				ifFalse: 
					[secondsSinceStartOfDay < 0 
						ifTrue: 
							[dayDelta := -1.
							secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]
						ifFalse: 
							[secondsSinceStartOfDay >= SecondsPerDay 
								ifTrue: 
									[dayDelta := 1.
									secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]
								ifFalse: [dayDelta := 0]]].
			gregorianDaysSinceEpoch := gregorianDaysSinceEpoch + dayDelta.
			gregorianYMD == nil 
				ifTrue: 
					[dateAndTime
						basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
						basicSetDaysSinceEpoch: gregorianDaysSinceEpoch]
				ifFalse: 
					[dateAndTime
						basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay.
					dayDelta = 0
						ifTrue: [dateAndTime setYear: gregorianYMD year calendarDay: gregorianYMD calendarDay daysSinceEpoch: gregorianDaysSinceEpoch]
						ifFalse: 
							[gregorianYMD 
								addingDays: dayDelta 
								setYearAndCalendarDayInto: 
									[:year :calendarDay | 
										dateAndTime
											setYear: year
											calendarDay: calendarDay
											daysSinceEpoch: gregorianDaysSinceEpoch]]]].
	^dateAndTime! !

!CalendarClock methodsFor: 'private-UT operations' stamp: ''!
mutableDateAndTimeFromUTSecondsSinceSystemClockEpoch: utSecondsSinceSystemClockEpoch nanoseconds: nanosecondsSinceSecond timeZone: aTimeZone
	"Answer a Timepoint (bound to the specified <calendar>) whose local time in the time zone defined by the receiver, and as defined by the time-of-day clock of the specified <calendar>, is <utSecondsSinceGregorianEpoch> seconds since the Gregorian epoch (relative to Universal Time), <utSecondsSinceCalendarEpoch> seconds since the epoch of the specified <calendar> (relative to Universal Time), and <nanosecondsSinceSecond> nanoseconds since the start of the specified second."

	"{(Gregorian clock
		mutableDateAndTimeFromUTSecondsSinceSystemClockEpoch: SystemClock secondsNowSinceSystemClockEpoch 
		nanoseconds: 0 
		timeZone: ChronosTimezone nominal) canonicalize}"
	"{Julian clock
		mutableDateAndTimeFromUTSecondsSinceSystemClockEpoch: SystemClock secondsNowSinceSystemClockEpoch 
		nanoseconds: 0 
		timeZone: (ChronosTimezone at: #'America/Los_Angeles')}"
	"{Calendar julian clock
		mutableDateAndTimeFromUTSecondsSinceSystemClockEpoch: SystemClock secondsNowSinceSystemClockEpoch 
		nanoseconds: 0 
		timeZone: (ChronosTimezone at: #'Australia/Adelaide')}"

	| utSecondsSinceGregorianEpoch utSecondsSinceCalendarEpoch dateAndTime |
	utSecondsSinceGregorianEpoch := utSecondsSinceSystemClockEpoch + secondsFromGregorianEpochUpToSystemClockEpoch.
	calendar isGregorian ifTrue: [^self mutableDateAndTimeFromUTSecondsSinceGregorianEpoch: utSecondsSinceGregorianEpoch nanoseconds: nanosecondsSinceSecond timeZone: aTimeZone].
	utSecondsSinceCalendarEpoch := utSecondsSinceSystemClockEpoch + secondsFromCalendarEpochUpToSystemClockEpoch.
	dateAndTime := 
		DateAndTimeFactory basicNew
			basicSetCalendar: calendar;
			setNanosecondsSinceSecond: nanosecondsSinceSecond.
	aTimeZone isInvariantToUT
		ifTrue: 
			[dateAndTime 
				basicSetTimeZone: aTimeZone root;
				basicSetSecondsSinceEpoch: utSecondsSinceCalendarEpoch]
		ifFalse: 
			[| secondsDiv128 secondsMod128 gregorianDaysSinceEpoch gregorianYMD utcSecondsSinceStartOfDay localTZ offsetSecondsFromUT timeZone |	
			secondsDiv128 := utSecondsSinceGregorianEpoch bitShift: -7. "Bit shifting is faster than LargeInteger math."
			gregorianDaysSinceEpoch := secondsDiv128 // 675. "128 * 675 = 86400"
			secondsMod128 := utSecondsSinceGregorianEpoch bitAnd: 127.
			utcSecondsSinceStartOfDay := secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7). "seconds \\ 128 + (seconds // 128 \\ 675 * 128)"
			localTZ := aTimeZone asNonProxy.
			localTZ isStatic
				ifTrue: 
					[timeZone := localTZ binding.
					offsetSecondsFromUT := timeZone offsetSecondsFromUT]
				ifFalse:
					[gregorianYMD := Gregorian dateSpecFromDaysSinceEpoch: gregorianDaysSinceEpoch.
					timeZone := 
						localTZ 
							bindingForUTYear: gregorianYMD year
							dayOfYear: gregorianYMD dayOfYearOrdinal
							secondsSinceStartOfDayFunction: [:offsetSeconds | utcSecondsSinceStartOfDay].
					offsetSecondsFromUT := timeZone offsetSecondsFromUT].
			dateAndTime
				basicSetSecondsSinceEpoch: utSecondsSinceCalendarEpoch + offsetSecondsFromUT].
	^dateAndTime! !

!CalendarClock methodsFor: 'private-UT operations' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
mutableDateFromUTSecondsSinceSystemClockEpoch: utSecondsSinceSystemClockEpoch timeZone: aTimezone 
	"Answer a YearMonthDay (bound to the specified <calendar>) whose local time in the time zone defined by the receiver is the day that starts (as defined by the specified <calendar>) less than one day prior to the moment in time that is <utSecondsSinceGregorianEpoch> seconds since the Gregorian epoch (relative to Universal Time) and <utSecondsSinceCalendarEpoch> seconds since the epoch of the specified <calendar> (relative to Universal Time)."

	"{HebrewCalendar clock
		mutableDateFromUTSecondsSinceSystemClockEpoch: SystemClock secondsNowSinceSystemClockEpoch
		timeZone: ChronosTimezone default}"
	"{Gregorian clock
		mutableDateFromUTSecondsSinceSystemClockEpoch: SystemClock secondsNowSinceSystemClockEpoch 
		timeZone: ChronosTimezone default}"

	| utSecondsSinceGregorianEpoch secondsDiv128 secondsMod128 timeZone gregorianDaysSinceEpoch gregorianYMD secondsSinceStartOfDay offsetSecondsFromUT dayDelta |
	utSecondsSinceGregorianEpoch := utSecondsSinceSystemClockEpoch + secondsFromGregorianEpochUpToSystemClockEpoch.
	secondsDiv128 := utSecondsSinceGregorianEpoch bitShift: -7.	"Bit shifting is faster than LargeInteger math."
	gregorianDaysSinceEpoch := secondsDiv128 // 675.	"128 * 675 = 86400"
	secondsMod128 := utSecondsSinceGregorianEpoch bitAnd: 127.
	secondsSinceStartOfDay := secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7).	"seconds \\ 128 + (seconds // 128 \\ 675 * 128)"
	aTimezone isStatic 
		ifTrue: [offsetSecondsFromUT := aTimezone offsetSecondsFromUT]
		ifFalse: 
			[gregorianYMD := 
				Gregorian 
					dateSpecFromDaysSinceEpoch: gregorianDaysSinceEpoch.
			timeZone := 
				aTimezone 
					bindingForUTYear: gregorianYMD year
					dayOfYear: gregorianYMD dayOfYearOrdinal
					secondsSinceStartOfDayFunction: [:offsetSeconds | secondsSinceStartOfDay].
			offsetSecondsFromUT := timeZone offsetSecondsFromUT].
	^calendar isGregorian 
		ifTrue: 
			[secondsSinceStartOfDay := secondsSinceStartOfDay + offsetSecondsFromUT.
			offsetSecondsFromUT abs >= SecondsPerDay 
				ifTrue: [dayDelta := secondsSinceStartOfDay // SecondsPerDay]
				ifFalse: 
					[secondsSinceStartOfDay < 0 
						ifTrue: [dayDelta := -1]
						ifFalse: 
							[secondsSinceStartOfDay >= SecondsPerDay 
								ifTrue: [dayDelta := 1]
								ifFalse: [dayDelta := 0]]].
			gregorianYMD == nil 
				ifTrue: 
					[(DateFactory basicNew)
						basicSetCalendar: calendar;
						basicSetDaysSinceEpoch: gregorianDaysSinceEpoch + dayDelta]
				ifFalse: 
					[| date |
					date := DateFactory basicNew.
					date basicSetCalendar: calendar.
					gregorianYMD addingDays: dayDelta setYearAndCalendarDayInto: date]]
		ifFalse: 
			[(DateFactory basicNew)
				basicSetCalendar: calendar;
				basicSetSecondsSinceEpoch: utSecondsSinceSystemClockEpoch + secondsFromCalendarEpochUpToSystemClockEpoch + offsetSecondsFromUT]! !

!CalendarClock methodsFor: 'private' stamp: ''!
mutableDateTodayIn: aTimezone
	"Answer a date value representing today's date, in the receiver's calendar, and relative to the timezone implemented by <aTimezone> (which must be an instance of a concrete subclass of ChronosTimezone.)"

	^self subclassResponsibility! !

!CalendarClock methodsFor: 'private-UT operations' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
mutableTimeOfDayFromUTSecondsSinceGregorianEpoch: utSecondsSinceGregorianEpoch nanoseconds: nanosecondsSinceSecond timeZone: aTimezone
	"Answer a TimeOfDay whose local time in the time zone defined by the receiver, and as defined by the time-of-day clock of the specified <calendar>, is <utSecondsSinceGregorianEpoch> seconds since the Gregorian epoch (relative to Universal Time), <utSecondsSinceCalendarEpoch> seconds since the epoch of the specified <calendar> (relative to Universal Time), and <nanosecondsSinceSecond> nanoseconds since the start of the specified second."

	"{Calendar gregorian clock
		mutableTimeOfDayFromUTSecondsSinceGregorianEpoch: Calendar gregorian clock now utSecondsSinceEpoch 
		nanoseconds: 0 timeZone: ChronosTimezone default}" 
	"{Calendar gregorian clock
		mutableTimeOfDayFromUTSecondsSinceGregorianEpoch: Calendar gregorian clock utNow secondsSinceEpoch 
		nanoseconds: 0 timeZone: (ChronosTimezone at: #'America/Los_Angeles')}"
	"{Calendar gregorian clock
		mutableTimeOfDayFromUTSecondsSinceGregorianEpoch: Calendar gregorian clock utNow secondsSinceEpoch  
		nanoseconds: 0 timeZone: (ChronosTimezone at: #'Australia/Adelaide')}"
	"{EthiopicCalendar clock
		mutableTimeOfDayFromUTSecondsSinceGregorianEpoch: Calendar gregorian clock now utSecondsSinceEpoch 
		nanoseconds: 0 timeZone: ChronosTimezone default}" 
	"The Ethiopian clock time T00:00:00 corresponds to ISO 8601 T06:00:00 (6 am) Gregorian Calendar. It's a cultural difference in both the zero-point for labelling the hours of the day and in the time-of-day at which one day ends and the next begins. It is not a difference of timezone offset."

	| timeOfDay secondsDiv128 secondsMod128 gregorianDaysSinceEpoch utcSecondsSinceStartOfDay offsetSecondsFromUT gregorianYMD timeZone secondsSinceStartOfDay |
	timeOfDay := 
		(TimeOfDayFactory basicNew)
			setNanosecondsSinceSecond: nanosecondsSinceSecond.
	secondsDiv128 := utSecondsSinceGregorianEpoch bitShift: -7. "Bit shifting is faster than LargeInteger math."
	gregorianDaysSinceEpoch := secondsDiv128 // 675. "128 * 675 = 86400"
	secondsMod128 := utSecondsSinceGregorianEpoch bitAnd: 127.
	utcSecondsSinceStartOfDay := secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7). "seconds \\ 128 + (seconds // 128 \\ 675 * 128)"
	aTimezone isStatic 
		ifTrue: [offsetSecondsFromUT := aTimezone offsetSecondsFromUT]
		ifFalse: 
			[gregorianYMD := Gregorian dateSpecFromDaysSinceEpoch: gregorianDaysSinceEpoch.
			timeZone := 
				aTimezone asNonProxy
					bindingForUTYear: gregorianYMD year
					dayOfYear: gregorianYMD dayOfYearOrdinal
					secondsSinceStartOfDayFunction: [:offsetSeconds | utcSecondsSinceStartOfDay].
			offsetSecondsFromUT := timeZone offsetSecondsFromUT].
	secondsSinceStartOfDay := utcSecondsSinceStartOfDay + offsetSecondsFromUT.
	calendar timeOfDayClockStartsAtMidnight
		ifFalse: [secondsSinceStartOfDay := calendar secondsSinceStartOfDayFromSecondsSinceMidnight:  secondsSinceStartOfDay].
	offsetSecondsFromUT abs >= SecondsPerDay 
		ifTrue: [secondsSinceStartOfDay := secondsSinceStartOfDay \\ SecondsPerDay]
		ifFalse: 
			[secondsSinceStartOfDay < 0 
				ifTrue: [secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]
				ifFalse: 
					[secondsSinceStartOfDay >= SecondsPerDay 
						ifTrue: 
							[secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]]].
	^timeOfDay 
		setSecondsSinceStartOfDay: secondsSinceStartOfDay! !

!CalendarClock methodsFor: 'API-converting' stamp: ''!
nativeCalendricalCoordinateFromChronosDate: aChronosDate
	"Answer the native 'Date' analog (or 'Timestamp' analog, if no Date analog is available) that semantically corresponds as closely as possible to <aChronosDate>.
	PRECONDITION: The receiver must already have been bound to its calendar; 
		specificially, the instance variable <secondsFromCalendarEpochUpToSystemClockEpoch> must contain a valid value."

	^ChronosSystemFacade current nativeCalendricalCoordinateFromChronosDate: aChronosDate! !

!CalendarClock methodsFor: 'API-converting' stamp: ''!
nativeCalendricalCoordinateFromChronosDateAndTime: aChronosDateAndTime
	"Answer the native 'Timestamp' analog (or 'Date' analog, if no Timestamp analog is available) that semantically corresponds as closely as possible to <aChronosDateAndTime>.
	PRECONDITION: The receiver must already have been bound to its calendar; 
		specificially, the instance variable <secondsFromCalendarEpochUpToSystemClockEpoch> must contain a valid value."

	^ChronosSystemFacade current nativeCalendricalCoordinateFromChronosDateAndTime: aChronosDateAndTime! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
nominalNow
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the current default timezone, and with invariant-to-nominal-time semantics."

	"{Calendar gregorian clock nominalNow}"
	"{Calendar julian clock nominalNow}"

	^self nominalNow: true! !

!CalendarClock methodsFor: 'private' stamp: ''!
nominalNow: includeNanoseconds 
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the current default timezone, and with invariant-to-nominal-time semantics. If <includeNanoseconds> is true, include the number of nanoseconds-since-the-second in the answered DateAndTime; otherwise, have the answered DateAndTime specify zero nanoseconds-since-the-second (so that the current date and time is reported only to the latest second.)"

	"{Calendar gregorian clock nominalNow: true}"
	"{Calendar julian clock nominalNow: false}"

	^self nowIn: DateAndTimeFactory nominalTZ includeNanoseconds: includeNanoseconds! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
nominalNowToTheSecond
	"Answer a DateAndTime (a point-in-time value) representing the current date and time to the second, in the receiver's calendar, relative to the current default timezone, and with invariant-to-nominal-time semantics."

	"{Calendar gregorian clock nominalNowToTheSecond}"
	"{Calendar julian clock nominalNowToTheSecond}"

	^self nominalNow: false! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
nominalToday
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the current default timezone, and with invariant-to-nominal-time semantics."

	^self basicTodayIn: ChronosTimezone nominal! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
now
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the current default timezone, and with invariant-to-UT semantics."

	"{Calendar gregorian clock now}"
	"{Calendar julian clock now}"

	^self nowIn: ChronosTimezone default includeNanoseconds: true! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
nowIn: aTimezoneOrTimezoneReference 
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the  timezone specified by the value of <aTimezoneOrTimezoneReference>, and with invariant-to-UT semantics."

	"{Calendar gregorian clock nowIn: #'Pacific/Honolulu'}"
	"{Calendar julian clock nowIn: #'Pacific/Honolulu'}"

	^self nowIn: (ChronosTimezone referencedBy: aTimezoneOrTimezoneReference) includeNanoseconds: true! !

!CalendarClock methodsFor: 'private' stamp: ''!
nowIn: aTimezoneOrTimezoneReference includeNanoseconds: includeNanoseconds 
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the  timezone specified by the value of <aTimezoneOrTimezoneReference>, and with invariant-to-UT semantics. If <includeNanoseconds> is true, include the number of nanoseconds-since-the-second in the answered DateAndTime; otherwise, have the answered DateAndTime specify zero nanoseconds-since-the-second (so that the current date and time is reported only to the latest second.)"

	^self subclassResponsibility! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
nowToTheSecond
	"Answer a DateAndTime (a point-in-time value) representing the current date and time to the second, in the receiver's calendar, relative to the current default timezone, and with invariant-to-UT semantics."

	"{Calendar gregorian clock nowToTheSecond}"
	"{Calendar julian clock nowToTheSecond}"

	^self nowIn: ChronosTimezone default includeNanoseconds: false! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
nowToTheSecondIn: aTimezoneOrTimezoneReference
	"Answer a DateAndTime (a point-in-time value) representing the current date and time to the second, in the receiver's calendar, relative to the  timezone specified by the value of <aTimezoneOrTimezoneReference>, and with invariant-to-UT semantics."

	"{Calendar gregorian cock nowToTheSecondIn: #'Pacific/Honolulu'}"
	"{Calendar julian clock nowToTheSecondIn: #'Pacific/Honolulu'}"

	^self nowIn: (ChronosTimezone referencedBy: aTimezoneOrTimezoneReference) includeNanoseconds: false! !

!CalendarClock methodsFor: 'accessing' stamp: ''!
precision
	"Answer a Duration whose value indicates the precision of the receiver's systemClock.  The precision of a clock is the average time interval between updates to the clock's tick count.  The 'tick size' of a clock is the minimum time interval that notationally can be represented by the clock's time counter (the clock's 'tick size' is also called the 'clock resolution.')"

	^systemClock precision! !

!CalendarClock methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	stream
		nextPut: $(;
		nextPutAll: 'tick resolution = ';
		nextPutAll: systemClock tickResolutionName;
		nextPutAll: ' | ';
		nextPutAll: 'Calendar = ';
		nextPutAll: calendar name;
		nextPutAll: ' | ';
		nextPutAll: 'Clock Epoch = ';
		nextPutAll: (self epoch printStringUsing: ChronosPrintPolicy verbose).
	calendar isGregorian
		ifFalse: 
			[stream
				nextPutAll: ' / ';
				nextPutAll: (self gregorianEpoch printStringUsing: ChronosPrintPolicy verbose)].
	stream nextPut: $)! !

!CalendarClock methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the resolution of the receiver's systemClock.  The resolution of a clock is the minimum temporal extent that notationally can be represented by the clock's time counter."

	^systemClock resolutionQuantum! !

!CalendarClock methodsFor: 'accessing' stamp: ''!
secondsFromCalendarEpochUpToSystemClockEpoch
	"Answer the number of seconds (UT1) from the epoch of the receiver's calendar up to (but not including) the epoch of the receiver's systemClock."

	^secondsFromCalendarEpochUpToSystemClockEpoch! !

!CalendarClock methodsFor: 'initialize-release' stamp: ''!
setCalendar: aCalendar
	self assertMutability.
	calendar := aCalendar.
	self bindToCalendar.! !

!CalendarClock methodsFor: 'initialize-release' stamp: ''!
setSystemClock: aSystemClock
	self assertMutability.
	systemClock := aSystemClock.! !

!CalendarClock methodsFor: 'accessing' stamp: ''!
systemClock
	^systemClock! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
thisDayOfMonth
	"Answer the day of the month of today's date, in the receiver's calendar, and relative to the current default timezone."

	^self dateToday dayOfMonth! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
thisDayOfYear
	"Answer the day of the year ordinal of today's date, in the receiver's calendar, and relative to the current default timezone."

	^self dateToday dayOfYear! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
thisMonth
	"Answer the ordinal of today's month, in the receiver's calendar, and relative to the current default timezone."

	^self dateToday month! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
thisYear
	"Answer the current year, in the receiver's calendar, and relative to the current default timezone."

	^self dateToday year! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
timeOfDayNow
	"Answer a time-of-day value representing the current time-of-day, in the receiver's calendar, and relative to the current default timezone."

	"{Calendar gregorian clock timeOfDayNow}"
	"{Calendar julian clock timeOfDayNow}"

	^self timeOfDayNowIn: ChronosTimezone default includeNanoseconds: true! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
timeOfDayNowIn: aTimezoneOrTimezoneReference 
	"Answer a time-of-day value representing the current time-of-day, in the receiver's calendar, and relative to the timezone specified by the value of <aTimezoneOrTimezoneReference>."

	"{Calendar gregorian clock timeOfDayNowIn: #'Pacific/Honolulu'}"
	"{Calendar julian clock timeOfDayNowIn: #'Pacific/Honolulu'}"

	^self timeOfDayNowIn: (ChronosTimezone referencedBy: aTimezoneOrTimezoneReference) includeNanoseconds: true! !

!CalendarClock methodsFor: 'private' stamp: ''!
timeOfDayNowIn: aTimezoneOrTimezoneReference includeNanoseconds: includeNanoseconds 
	"Answer a time-of-day value representing the current time-of-day, in the receiver's calendar, and relative to the timezone specified by the value of <aTimezoneOrTimezoneReference>. If <includeNanoseconds> is true, include the number of nanoseconds-since-the-second in the answered time-of-day value; otherwise, have the answered time-of-day value specify zero nanoseconds-since-the-second (so that the current date and time is reported only to the latest second.)"

	^self subclassResponsibility! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
timeOfDayNowToTheSecond
	"Answer a time-of-day value representing the current time-of-day to the second, in the receiver's calendar, and relative to the current default timezone."

	"{Calendar gregorian clock timeOfDayNowToTheSecond}"
	"{Calendar julian clock timeOfDayNowToTheSecond}"

	^self timeOfDayNowIn: ChronosTimezone default includeNanoseconds: false! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
timeOfDayNowToTheSecondIn: aTimezoneOrTimezoneReference
	"Answer a time-of-day value representing the current time-of-day to the second, in the receiver's calendar, and relative to the timezone specified by the value of <aTimezoneOrTimezoneReference>."

	"{Calendar gregorian clock timeOfDayNowToTheSecondIn: #'Pacific/Honolulu'}"
	"{Calendar julian clock timeOfDayNowToTheSecondIn: #'Pacific/Honolulu'}"

	^self timeOfDayNowIn: (ChronosTimezone referencedBy: aTimezoneOrTimezoneReference) includeNanoseconds: false! !

!CalendarClock methodsFor: 'accessing' stamp: ''!
timescale
	"Answer the Timescale used by the receiver."

	^self notYetImplemented! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
today
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the current default timezone, and with invariant-to-UT semantics."

	"{Gregorian clock today}"

	^self basicTodayIn: ChronosTimezone default! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
todayIn: aTimezoneOrTimezoneReference
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the  timezone specified by the value of <aTimezoneOrTimezoneReference>, and with invariant-to-UT semantics." 

	"{Calendar gregorian clock todayIn: #'Pacific/Honolulu'}"
	"{Calendar julian clock todayIn: #'Pacific/Honolulu'}"

	^self basicTodayIn: (ChronosTimezone referencedBy: aTimezoneOrTimezoneReference)! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utNow
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the UT timezone, and with invariant-to-UT semantics."

	"{Calendar gregorian clock utNow}"
	"{Calendar julian clock utNow}"

	^self subclassResponsibility! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utTimeOfDayNow
	"Answer a time-of-day value representing the current time-of-day, in the receiver's calendar, and relative to the UT timezone."

	"{Calendar gregorian clock utTimeOfDayNow}"
	"{Calendar julian clock utTimeOfDayNow}"

	^self subclassResponsibility! !

!CalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utToday
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the UT timezone, and with invariant-to-UT semantics."

	"{Calendar gregorian clock utToday}"
	"{Calendar julian clock utToday}"

	^self subclassResponsibility! !

CalendarClock subclass: #LocalTimeCalendarClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!LocalTimeCalendarClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

LocalTimeCalendarClock

	Concept:
		
		A LocalTimeCalendarClock is CalendarClock (which see) specialized for encapsulating a ChronosSystemClock that reports time relative to the current default timezone.
!

!LocalTimeCalendarClock methodsFor: 'private' stamp: ''!
basicTodayIn: aTimezone
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the timezone implemented by <aTimezone> (which must be an instance of a concrete subclass of ChronosTimezone,) and with invariant-to-UT semantics." 

	| ticksNow now |
	ticksNow := systemClock ticksNowSinceSystemClockEpoch.
	now :=
		self class dateAndTimeFactory basicNew
			basicSetCalendar: calendar;
			basicSetTimeZone: ChronosTimezone system;
			setNanosecondsSinceSecond: 0;
			basicSetSecondsSinceEpoch: 
				(systemClock secondsFromTicks: ticksNow) + secondsFromCalendarEpochUpToSystemClockEpoch.
	^now 
		canonicalizeFromLocalTime;
		convertToTimeZone: aTimezone;
		addSeconds: now secondsSinceStartOfDay negated;
		beImmutable! !

!LocalTimeCalendarClock methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:28'!
mutableDateTodayIn: aTimezone
	"Answer a date value representing today's date, in the receiver's calendar, and relative to the timezone implemented by <aTimezone> (which must be an instance of a concrete subclass of ChronosTimezone.)"

	^(DateFactory) basicNew
		initializeFrom: (self nowIn: aTimezone includeNanoseconds: false)! !

!LocalTimeCalendarClock methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 10:46'!
nowIn: aTimeZone includeNanoseconds: includeNanoseconds 
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the  timezone specified by the value of <aTimezoneOrTimezoneReference>, and with invariant-to-UT semantics. If <includeNanoseconds> is true, include the number of nanoseconds-since-the-second in the answered DateAndTime; otherwise, have the answered DateAndTime specify zero nanoseconds-since-the-second (so that the current date and time is reported only to the latest second.)"

	| ticksNow now nanosecondsSinceSecond |
	ticksNow := systemClock ticksNowSinceSystemClockEpoch.
	nanosecondsSinceSecond := includeNanoseconds 
				ifTrue: [systemClock nanosecondsSinceSecondFromTicks: ticksNow]
				ifFalse: [0].
	^(aTimeZone isInvariantToNominalTime and: [aTimeZone asNonProxy isSystem])
		ifTrue:
			[self class dateAndTimeFactory 
				nominalSecondsSinceEpoch: 
					(systemClock secondsFromTicks: ticksNow) 
					+ secondsFromCalendarEpochUpToSystemClockEpoch
				nanoseconds: nanosecondsSinceSecond
				calendar: calendar]
		ifFalse:
			[now :=
				(DateAndTimeFactory) basicNew
					basicSetCalendar: calendar;
					basicSetTimeZone: ChronosTimezone system;
					setNanosecondsSinceSecond: nanosecondsSinceSecond;
					basicSetSecondsSinceEpoch: 
						(systemClock secondsFromTicks: ticksNow) + secondsFromCalendarEpochUpToSystemClockEpoch.
			now 
				canonicalizeFromLocalTime;
				convertToTimeZone: aTimeZone;
				beImmutable]! !

!LocalTimeCalendarClock methodsFor: 'private' stamp: ''!
timeOfDayNowIn: aTimezone includeNanoseconds: includeNanoseconds 
	"Answer a time-of-day value representing the current time-of-day, in the receiver's calendar, and relative to the timezone specified by the value of <aTimezoneOrTimezoneReference>. If <includeNanoseconds> is true, include the number of nanoseconds-since-the-second in the answered time-of-day value; otherwise, have the answered time-of-day value specify zero nanoseconds-since-the-second (so that the current date and time is reported only to the latest second.)"

	^(self nowIn: aTimezone includeNanoseconds: includeNanoseconds) timeOfDay! !

!LocalTimeCalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utNow
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the UT timezone, and with invariant-to-UT semantics."

	"{Calendar gregorian clock utNow}"
	"{Calendar julian clock utNow}"

	^self nowIn: ChronosTimezone universal includeNanoseconds: true! !

!LocalTimeCalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utTimeOfDayNow
	"Answer a time-of-day value representing the current time-of-day, in the receiver's calendar, and relative to the UT timezone."

	"{Calendar gregorian clock utTimeOfDayNow}"
	"{Calendar julian clock utTimeOfDayNow}"

	^self timeOfDayNowIn: ChronosTimezone universal includeNanoseconds: true! !

!LocalTimeCalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utToday
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the UT timezone, and with invariant-to-UT semantics."

	"{Calendar gregorian clock utToday}"
	"{Calendar julian clock utToday}"

	^self basicTodayIn: ChronosTimezone universal! !

CalendarClock subclass: #UTCalendarClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!UTCalendarClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UTCalendarClock

	Concept:

		A UTCalendarClock is CalendarClock (which see) specialized for encapsulating a ChronosSystemClock that reports time relative to the UT timezone.

!

!UTCalendarClock methodsFor: 'private' stamp: ''!
basicTodayIn: aTimezone
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the timezone implemented by <aTimezone> (which must be an instance of a concrete subclass of ChronosTimezone,) and with invariant-to-UT semantics." 

	^(self
		mutableDateAndTimeAtStartOfDayFromUTSecondsSinceSystemClockEpoch: systemClock secondsNowSinceSystemClockEpoch
		timeZone: aTimezone) beImmutable! !

!UTCalendarClock methodsFor: 'private' stamp: ''!
mutableDateTodayIn: aTimezone 
	"Answer a date value representing today's date, in the receiver's calendar, and relative to the timezone implemented by <aTimezone> (which must be an instance of a concrete subclass of ChronosTimezone.)"

	^self 
		mutableDateFromUTSecondsSinceSystemClockEpoch: systemClock secondsNowSinceSystemClockEpoch
		timeZone: aTimezone! !

!UTCalendarClock methodsFor: 'private' stamp: ''!
nowIn: aTimezone includeNanoseconds: includeNanoseconds 
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the  timezone specified by the value of <aTimezoneOrTimezoneReference>, and with invariant-to-UT semantics. If <includeNanoseconds> is true, include the number of nanoseconds-since-the-second in the answered DateAndTime; otherwise, have the answered DateAndTime specify zero nanoseconds-since-the-second (so that the current date and time is reported only to the latest second.)"

	| ticksNow secondsNow nanosecondsSinceSecond |
	ticksNow := systemClock ticksNowSinceSystemClockEpoch.
	nanosecondsSinceSecond := includeNanoseconds 
				ifTrue: [systemClock nanosecondsSinceSecondFromTicks: ticksNow]
				ifFalse: [0].
	secondsNow := systemClock secondsFromTicks: ticksNow.
	^(calendar isGregorian 
		ifTrue: 
			[self 
				mutableDateAndTimeFromUTSecondsSinceGregorianEpoch: secondsNow + secondsFromGregorianEpochUpToSystemClockEpoch
				nanoseconds: nanosecondsSinceSecond
				timeZone: aTimezone]
		ifFalse: 
			[self 
				mutableDateAndTimeFromUTSecondsSinceSystemClockEpoch: secondsNow
				nanoseconds: nanosecondsSinceSecond
				timeZone: aTimezone]) 
			beImmutable! !

!UTCalendarClock methodsFor: 'private' stamp: ''!
timeOfDayNowIn: aTimezone includeNanoseconds: includeNanoseconds 
	"Answer a time-of-day value representing the current time-of-day, in the receiver's calendar, and relative to the timezone specified by the value of <aTimezoneOrTimezoneReference>. If <includeNanoseconds> is true, include the number of nanoseconds-since-the-second in the answered time-of-day value; otherwise, have the answered time-of-day value specify zero nanoseconds-since-the-second (so that the current date and time is reported only to the latest second.)"

	"{Calendar gregorian clock timeOfDayNowIn: #'Pacific/Honolulu'}"
	"{Calendar julian clock timeOfDayNowIn: #'Pacific/Honolulu'}"

	| ticksNow gregorianSecondsNow nanosecondsSinceSecond |
	ticksNow := systemClock ticksNowSinceSystemClockEpoch.
	nanosecondsSinceSecond := 
		includeNanoseconds 
			ifTrue: [systemClock nanosecondsSinceSecondFromTicks: ticksNow]
			ifFalse: [0].
	gregorianSecondsNow := (systemClock secondsFromTicks: ticksNow) + secondsFromGregorianEpochUpToSystemClockEpoch.
	^(self 
		mutableTimeOfDayFromUTSecondsSinceGregorianEpoch: gregorianSecondsNow 
		nanoseconds: nanosecondsSinceSecond 
		timeZone: aTimezone) beImmutable! !

!UTCalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utNow
	"Answer a DateAndTime (a point-in-time value) representing the current date and time, in the receiver's calendar, relative to the UT timezone, and with invariant-to-UT semantics."

	"{Calendar gregorian clock utNow}"
	"{Calendar julian clock utNow}"

	| ticksNow |
	ticksNow := systemClock ticksNowSinceSystemClockEpoch.
	^DateAndTimeFactory basicNew
		basicSetCalendar: calendar;
		basicSetTimeZone: ChronosTimezone universal;
		setNanosecondsSinceSecond: (systemClock nanosecondsSinceSecondFromTicks: ticksNow);
		basicSetSecondsSinceEpoch: (systemClock secondsFromTicks: ticksNow) + secondsFromCalendarEpochUpToSystemClockEpoch;
		canonicalizeFromUT;
		beImmutable! !

!UTCalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utTimeOfDayNow
	"Answer a time-of-day value representing the current time-of-day, in the receiver's calendar, and relative to the UT timezone."

	"{Calendar gregorian clock utTimeOfDayNow}"
	"{Calendar julian clock utTimeOfDayNow}"

	| ticksNow |
	ticksNow := systemClock ticksNowSinceSystemClockEpoch.
	^TimeOfDayFactory basicNew
		setNanosecondsSinceSecond: (systemClock nanosecondsSinceSecondFromTicks: ticksNow);
		setSecondsSinceStartOfDay: ((systemClock secondsFromTicks: ticksNow)) "\\ SecondsPerDay";
		beImmutable! !

!UTCalendarClock methodsFor: 'API-Current Dates & Times' stamp: ''!
utToday
	"Answer a DateAndTime (a point-in-time value) representing the first moment of today's date, in the receiver's calendar, relative to the UT timezone, and with invariant-to-UT semantics."

	"{Calendar gregorian clock utToday}"
	"{Calendar julian clock utToday}"

	| seconds secondsDiv128 daysSinceEpoch |
	seconds := (systemClock secondsFromTicks: systemClock ticksNowSinceSystemClockEpoch) + secondsFromCalendarEpochUpToSystemClockEpoch.
	secondsDiv128 := seconds bitShift: -7. "Bit shifting is faster than LargeInteger math."
	daysSinceEpoch := secondsDiv128 // 675. "128 * 675 = 86400"
	^DateAndTimeFactory basicNew
		basicSetCalendar: calendar;
		basicSetTimeZone: ChronosTimezone universal;
		setNanosecondsSinceSecond: 0;
		basicSetSecondsSinceStartOfDay: 0;
		basicSetDaysSinceEpoch: daysSinceEpoch;
		canonicalizeFromUT;
		beImmutable! !

!ChronosObject class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Chronos'! !

!ChronosObject class methodsFor: 'accessing' stamp: ''!
calendarDurationFactory
	^CalendarDurationFactory! !

!ChronosObject class methodsFor: 'accessing' stamp: ''!
civilDurationFactory
	^CivilDurationFactory! !

!ChronosObject class methodsFor: 'accessing' stamp: ''!
dateAndTimeFactory
	^DateAndTimeFactory! !

!ChronosObject class methodsFor: 'accessing' stamp: ''!
dateFactory
	^DateFactory! !

!ChronosObject class methodsFor: 'accessing' stamp: ''!
durationFactory
	^DurationFactory! !

!ChronosObject class methodsFor: 'accessing' stamp: ''!
timeOfDayFactory
	^TimeOfDayFactory! !

!ChronosObject class methodsFor: 'accessing' stamp: ''!
timeperiodFactory
	^TimeperiodFactory! !

!ChronosObject methodsFor: 'converting' stamp: ''!
asChronosValue
	"Answer the translation of the receiver into an object that is an instance of whichever class in the Chronos Date/Time Library would be most appropriate for the instantiation of an object equal and/or analogous to the receiver ."

	^self! !

!ChronosObject methodsFor: 'printing' stamp: ''!
basicPrintOn: stream
	"Print the receiver on <stream> using the implementation of #printOn: inherited from the superclass of ChronosObject ."

	super printOn: stream! !

!ChronosObject methodsFor: 'testing' stamp: ''!
isCalendricalCoordinate
	^false! !

!ChronosObject methodsFor: 'testing' stamp: ''!
isDurational
	^false! !

!ChronosObject methodsFor: 'private-comparing' stamp: ''!
isEqualToCalendarDuration: aCalendarDuration
	^false! !

!ChronosObject methodsFor: 'private-comparing' stamp: ''!
isEqualToCivilDuration: aCivilDuration 
	^false! !

!ChronosObject methodsFor: 'private-comparing' stamp: ''!
isEqualToInfiniteDuration: anInfiniteDuration
	^false! !

!ChronosObject methodsFor: 'private-comparing' stamp: ''!
isEqualToTimezone: aTimezone 
	^false! !

!ChronosObject methodsFor: 'testing' stamp: ''!
isTemporalCoordinate
	^false! !

!ChronosObject methodsFor: 'testing' stamp: ''!
isTimezone
	^false! !

!ChronosObject methodsFor: 'parameter validation' stamp: ''!
signalInvalidArgument: key value: value
	"Signal an Error to the effect that <value> is not a valid argument value for the parameter <key>."

	self signalError: 'The value ', value printString, ' for the ', key printString, ' parameter is not valid.'! !

!ChronosObject methodsFor: 'printing' stamp: ''!
storeOn: stream 
	"{Compiler evaluate: Timepoint now storeString}"
	"{Compiler evaluate: (CalendarDuration years: 4 months: 3 days: 15) storeString}"
	"{Compiler evaluate: Timeperiod today storeString}"
	"{Compiler evaluate: ChronosPrintPolicy universal storeString}"
	"{Compiler evaluate: ChronosLocale unitedStates storeString}"
	"{Compiler evaluate: TimeZoneLocalizationPolicy unitedStates storeString}"
	"{Compiler evaluate: SemanticDatePolicy default storeString}"
	"{Compiler evaluate: 
		(VariableOffsetTimezone
			key: #nonGlobalKey name: #SouthernHemisphereNormalOrder
			initialOffset: (Duration hours: 10) withAbbreviation: #WADT 
				until: (WeekOfMonthDayOfWeek month: 4 week: 0 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #nominal
			thenOffset: (Duration hours: 9)  withAbbreviation: #WAST  
				until: (WeekOfMonthDayOfWeek month: 9 week: 1 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #nominal)
					nowToTheSecond storeString}"

	stream 
		store: self literalArrayEncoding;
		nextPutAll: ' decodeAsLiteralArray.'! !

ChronosObject subclass: #ChronosPrintable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ChronosPrintable commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosPrintable

	Concept:

		ChronosPrintable is an abstract class that establishes a framework for instances (of a concrete subclass) to delegate to a ChronosPrintPolicy (which see) the responsibility for printing themselves on a Stream.  See the individual method comments for more information.

		ChronosPrintable also provides/implements Immutable behvavior/protocol and ChronosObject behavior/protocol (by inheritance.)

	Subclassing:

		Concrete subclasses must subimplement the instance method #printOn:using:




!

ChronosPrintable subclass: #CalendarPeriod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!CalendarPeriod commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CalendarPeriod

	Concept:
		
		CalendarPeriod is an abstract class, whose concrete subclasses specify the properties of a particular calendrical period, such as a year, a month of the year or a day of the year. The properties (e.g, month structure) of a year of a particular type are specified by an instance of YearlyCalendar. Each different type of year (e.g., standard year, leap year) requires a different YearlyCalendar instance. Each YearlyCalendar contains some number of MonthlyCalendar objects that specify the properties of the months in a year of a particular type.  Each MonthlyCalendar instance contains some number of CalendarDay objects that specify the properties of the days of a particular month in a year of a particular type. 

		For most calendrical systems, there should be only one instance of a CalendarPeriod object for each calendrical period for each type of year for each Calendar (the instances should be flyweights.) However, for calendrical systems where there are an exceedingly large number of different year types (e.g, the Chinese Calendar,) the "flyweight invariant" may not hold. 

		See the class comments of Calendar, YearlyCalendar, CalendarYearPart, MonthlyCalendar and CalendarDay for more information.

	Usage:

		As is the case with most Chronos classes, CalendarPeriod instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Subclassing:

		Concrete subclasses must subimplement the following instance methods (see the comment of each method for the required semantics):

			#yearlyCalendar

!

!CalendarPeriod class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!CalendarPeriod methodsFor: 'accessing' stamp: ''!
calendar
	"Answer the instance of Calendar that implements the calendrical system of the calendar period whose properties are specified by the receiver."

	^self yearlyCalendar calendar! !

!CalendarPeriod methodsFor: 'accessing' stamp: ''!
calendarRegistrationKey
	^self calendar registrationKey! !

!CalendarPeriod methodsFor: 'converting' stamp: ''!
canonical
	^self subclassResponsibility! !

!CalendarPeriod methodsFor: 'accessing' stamp: ''!
daysPerYear
	"Answer the number of days per in a year whose type is the same as the year type of the calendar period whose properties are specified by the receiver."

	^self yearlyCalendar daysPerYear! !

!CalendarPeriod methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self calendarRegistrationKey;
		nextPut: self yearTypeCode literalArrayEncoding! !

!CalendarPeriod methodsFor: 'accessing' stamp: ''!
firstMonth
	"Answer the MonthlyCalendar instance that specifies the properties of the first month of the receiver's year."

	^self yearlyCalendar firstMonth! !

!CalendarPeriod methodsFor: 'accessing' stamp: ''!
lastMonth
	"Answer the MonthlyCalendar instance that specifies the properties of the last month of the receiver's year."

	^self yearlyCalendar lastMonth! !

!CalendarPeriod methodsFor: 'printing' stamp: ''!
printOn: stream
	self basicPrintOn: stream! !

!CalendarPeriod methodsFor: 'accessing' stamp: ''!
yearTypeCode
	"Answer the year type code of the receiver's year type."

	^self yearlyCalendar yearTypeCode! !

!CalendarPeriod methodsFor: 'accessing' stamp: ''!
yearlyCalendar
	"Answer the YearlyCalendar instance that specifies the properties of the receiver's year type (if the receiver is itself a YearlyCalendar, answer the receiver.)"

	^self subclassResponsibility! !

CalendarPeriod subclass: #CalendarYearPart
	instanceVariableNames: 'containingPeriod monthOrdinal isLeap'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!CalendarYearPart commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CalendarYearPart

	Concept:

		CalendarYearPart is an abstract class, whose concrete subclasses specify the properties of a calendrical period that forms a part of a year, such as a month of the year or a day of the month. The properties of a month of the year (for a year of a particular type) are specified by an instance of MonthlyCalendar. Each MonthlyCalendar instance must be contained by an instance YearlyCalendar. The properties of a day of the month are specified by an instance CalendarDay. 

		For most calendrical systems, there should be only one instance of a CalendarYearPart object for each calendrical period for each type of year for each Calendar (the instances should be flyweights.) However, for calendrical systems where there are an exceedingly large number of different year types (e.g, the Chinese Calendar,) the "flyweight invariant" may not hold. 

		See the class comments of Calendar, CalendarPeriod, YearlyCalendar, MonthlyCalendar and CalendarDay for more information.

	Usage:

		As is the case with most Chronos classes, CalendarYearPart instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			containingPeriod	<MonthlyCalendar | YearlyCalendar> 
				The CalendarPeriod that contains the instance, and for which the instance represents one of its subperiods.  If the instance is a MonthlyCalendar, then its <containingPeriod> is a YearlyCalendar.  If the instance is a CalendarDay, then its <containingPeriod> is a MonthlyCalendar.
			monthOrdinal		<Integer>
				The ordinal number of the instance's month.
			isLeap				<Boolean> 
				Flag that signals whether the instance is a leap period of its year.  If the instance is a MonthlyCalendar, then the flag indicates whether it represents a leap month of its year.  If the instance is a CalendarDay, then the flag indicates whether it represents a leap day of the year (either because it's any day in a leap month, or because it's a leap day in a non-leap month.)

	Subclassing:

		Concrete subclasses must subimplement the following instance methods (see the comment of each method for the required semantics):

			#monthlyCalendar!

CalendarYearPart subclass: #CalendarDay
	instanceVariableNames: 'dayOfMonthOrdinal dayOfYearOrdinal isLeapDayInMonth'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!CalendarDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CalendarDay

	Concept:

		CalendarDay is an abstract class; an instance of one of its concrete subclasses represents/specifies the properties of a particular day as it occurs within a particular type of year (e.g., a standard year, a leap year) of a particular calendrical system (e.g., the Gregorian, Hebrew, or Persian calendar.)  It does NOT represent/specify an actual occurrence of a specific day or date in any specific year. In other words, a CalendarDay would specify/represent (for example) the properties of February 29 as it occurs in any leap year of the Gregorian Calendar, but would not specify/represent any specific occurrence of February 29 in a specific Gregorian year. 

		Specifically, in the context of a particular calendrical system and type of year, a CalendarDay specifies the following properties of a particular day of a particular month: the day-of-year ordinal, the month ordinal, the day-of-month ordinal, and whether the day is a leap day of the year and/or is a day in a leap month. Also, via a reference to the MonthlyCalendar object that specifies the properties of its month, and via a reference to the YearlyCalendar object that specifies the properties of the type of year in which it occurs, a CalendarDay also provides information about the month and year that contain it.

		A CalendarDay also provides date arithmetic and comparison operations.

		The two concrete subclasses of CalendarDay are StaticCalendarDay and DynamicCalendarDay.  StaticCalendarDay must be used in collaboration with a StaticMonthlyCalendar.  DynamicCalendarDay must be used in collaboration with a DynamicMonthlyCalendar.

	Usage:

		As is the case with most Chronos classes, CalendarDay instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Motivation:

	Implementation:

		Instance Variables
		
			dayOfMonthOrdinal	<Integer>
				The ordinal number of the day of the month represented by the instance.
			dayOfYearOrdinal	<Integer>
				The ordinal number of the day of the year represented by the instance.
			isLeapDayInMonth	<Boolean>
				Flag that signals whether the day represented by the instance is a leap day of its month.  The days of a leap month may or may not also be leap days of the month (although they will always be leap days of the year.)

	Subclassing:

		Concrete subclasses must subimplement the following instance methods (see the comment of each method for the required semantics):

			#addingDays:
			#subtractingDays:!

!CalendarDay class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^((Calendar referencedBy: (literalArray at: 2)) canonical
		yearlyCalendarForYearTypeCode: (literalArray at: 3) decodeAsLiteralArray)
			dayAt: (literalArray at: 4)! !

!CalendarDay methodsFor: 'comparing' stamp: ''!
= aCalendarDay
	^(self compareTo: aCalendarDay) = 0! !

!CalendarDay methodsFor: 'arithmetic' stamp: ''!
addingDays: count
	"Answer the CalendarDay in the receiver's year type whose day-of-year ordinal is computed by adding <count> to the receiver's day-of-year ordinal. If the resulting day-of-year ordinal is not valid, answer nil."

	^self subclassResponsibility! !

!CalendarDay methodsFor: 'converting' stamp: ''!
canonical
	^self yearlyCalendar canonical dayAt: self dayOfYearOrdinal! !

!CalendarDay methodsFor: 'comparing' stamp: ''!
compareTo: otherCalendarDay
	"Compare the value of the receiver to that of <otherCalendarDay>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <otherCalendarDay> are the same.)"

	self == otherCalendarDay ifTrue: [^0].
	^[otherCalendarDay compareToCalendarDay: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == otherCalendarDay and: [ex message selector == #compareToCalendarDay:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!CalendarDay methodsFor: 'private-comparing' stamp: ''!
compareToCalendarDay: otherCalendarDay
	
	| diff |
	diff := otherCalendarDay monthOrdinal - monthOrdinal.
	diff = 0 ifFalse: [^diff].
	^otherCalendarDay dayOfMonthOrdinal - dayOfMonthOrdinal! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
dayOfMonth
	^dayOfMonthOrdinal! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
dayOfMonthOrdinal
	^dayOfMonthOrdinal! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
dayOfYear
	^dayOfYearOrdinal! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
dayOfYearOrdinal
	^dayOfYearOrdinal! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
daysPerMonth
	"Answer the number of days in the receiver's month."

	^containingPeriod daysPerMonth! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
daysSinceStartOfMonth
	"Answer the number of days since the first day of the receiver's month up to (but not including) the day represented by the receiver. The answer is the CARDINAL number of the day of the month represented by the receiver."

	^dayOfMonthOrdinal - 1! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
daysSinceStartOfYear
	"Answer the number of days since the first day of the receiver's year up to (but not including) the day represented by the receiver. The answer is the CARDINAL number of the day of the year represented by the receiver."

	^dayOfYearOrdinal - 1! !

!CalendarDay methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self dayOfYearOrdinal! !

!CalendarDay methodsFor: 'comparing' stamp: ''!
hash
	^(monthOrdinal + dayOfMonthOrdinal) hash! !

!CalendarDay methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	dayOfMonthOrdinal := 1.
	dayOfYearOrdinal := 1.
	isLeapDayInMonth := false.! !

!CalendarDay methodsFor: 'testing' stamp: ''!
isFirstDayOfMonth
	^dayOfMonthOrdinal = 1! !

!CalendarDay methodsFor: 'testing' stamp: ''!
isFirstDayOfYear
	^dayOfYearOrdinal = 1! !

!CalendarDay methodsFor: 'testing' stamp: ''!
isInIntercalaryMonth
	"Answer whether the receiver's month is an intercalary month. An intercalary month is one that either a) does not occur every year, and/or b) does not have nearly the same number of days as the majority of months in the year."

	^containingPeriod isIntercalaryMonth! !

!CalendarDay methodsFor: 'testing' stamp: ''!
isInLeapMonth
	"Answer whether the receiver's month is a leap month."

	^containingPeriod isLeapMonth! !

!CalendarDay methodsFor: 'testing' stamp: ''!
isLastDayOfMonth
	^dayOfMonthOrdinal = self daysPerMonth! !

!CalendarDay methodsFor: 'testing' stamp: ''!
isLastDayOfYear
	^dayOfYearOrdinal = self daysPerYear! !

!CalendarDay methodsFor: 'testing' stamp: ''!
isLeapDay
	"Answer whether the day represented by the receiver is a leap day of its year. This will be true for all days in a leap month."

	^isLeap! !

!CalendarDay methodsFor: 'testing' stamp: ''!
isLeapDayInMonth
	"Answer whether the day represented by the receiver is a leap day of its month. This may or may not be true for days in a leap month."

	^isLeapDayInMonth! !

!CalendarDay methodsFor: 'accessing-multivalued' stamp: ''!
monthDayDo: block2
	"Evaluate <block2> with the month ordinal and day-of-month ordinal of the day represented by the receiver as the first and second arguments (respectively.)"

	^block2 value: monthOrdinal value: dayOfMonthOrdinal! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
monthlyCalendar
	"Answer the MonthlyCalendar instance that specifies the properties the receiver's month (if the receiver is itself a MonthlyCalendar, answer the receiver.)"

	^containingPeriod! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
numericMonthDesignator
	"Answer the culturally-correct numerical label for the receiver's month (usually, this is the ordinal number of the month in the sequence of months since the month that begins a year, but such is not the case in all cultures.)"

	^self calendar 
		numericMonthDesignatorFromMonthOrdinal: self monthOrdinal
		forYearTypeCode: self yearTypeCode! !

!CalendarDay methodsFor: 'printing' stamp: ''!
printOn: stream indent: depth
	stream
		tab: depth;
		nextPut: ${;
		nextPutAll: self monthName;
		space;
		print: self dayOfMonthOrdinal.
	self isLeapDay
		ifTrue: [stream nextPutAll: ' (leap day)'].
	stream nextPut: $}! !

!CalendarDay methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printCalendarDay: self on: stream! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^CalendarDayDuration! !

!CalendarDay methodsFor: 'initialize-release' stamp: ''!
setMonthlyCalendar: aMonthlyCalendar
	self assertMutability.
	containingPeriod := aMonthlyCalendar.
	monthOrdinal := containingPeriod monthOrdinal.
	isLeapDayInMonth := containingPeriod hasLeapDayAt: dayOfMonthOrdinal.
	isLeap := isLeapDayInMonth or: [self isInLeapMonth].! !

!CalendarDay methodsFor: 'arithmetic' stamp: ''!
startingWithYear: year addingDays: dayDelta setYearAndCalendarDayInto: block2OrYearMonthDaySpec 
	"PRECONDITION: The year type of <year> must be the same as that of the receiver's year."

	"For the day that is <dayDelta> days after the day represented by the receiver, send #value:value: to <block2OrYearMonthDaySpec> with the year of said day as the first argument, and the CalendarDay that represents said day as the second argument."

	| calendarDay |
	calendarDay := self addingDays: dayDelta.
	^calendarDay == nil 
		ifTrue: 
			[self calendar 
				startingWithYear: year
				addingDays: dayOfYearOrdinal - 1 + dayDelta
				setYearAndCalendarDayInto: block2OrYearMonthDaySpec]
		ifFalse: [block2OrYearMonthDaySpec value: year value: calendarDay]! !

!CalendarDay methodsFor: 'arithmetic' stamp: ''!
subtractingDays: count
	"Answer the CalendarDay in the receiver's year type whose day-of-year ordinal is computed by subtracting <count> from the receiver's day-of-year ordinal. If the resulting day-of-year ordinal is not valid, answer nil."

	^self subclassResponsibility! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
weekOfMonthOrdinal
	"Answer the ordinal number of the week of the month in which the day represented by the receiver occurs.  The first seven days of the month are the first week of the month."

	^self weeksSinceStartOfMonth + 1! !

!CalendarDay methodsFor: 'accessing' stamp: ''!
weeksSinceStartOfMonth
	"Answer the CARDINAL number of the week of the month in which the day represented by the receiver occurs.  The first seven days of the month are in the week whose CARDINAL number is zero."

	^self daysSinceStartOfMonth // DaysPerWeek! !

!CalendarDay methodsFor: 'accessing-multivalued' stamp: ''!
yearMonthDayDo: block3
	"Evaluate <block3> with the calendar year number, month ordinal and day-of-month ordinal of the day represented by the receiver as the first, second and third arguments (respectively.) If the receiver is not bound to a particular year, use nil as the value of the year."

	^block3 
		value: nil
		value: monthOrdinal
		value: dayOfMonthOrdinal! !

CalendarDay subclass: #DynamicCalendarDay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!DynamicCalendarDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

DynamicCalendarDay

	Concept:

		A DynamicCalendarDay is a CalendarDay (which see) that is specialized for collaboration with a DynamicMonthlyCalendar (also which see.)

	Usage:

		As is the case with most Chronos classes, DynamicCalendarDay instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Motivation:

		DynamicCalendarDay, in collaboration with DynamicMonthlyCalendar and DynamicYearlyCalendar, avoids the utilization of too much memory in the case of calendrical systems that have too many different year types to reasonably use the flyweight pattern for representing the month structure of each type of year.

	Implementation:
!

!DynamicCalendarDay class methodsFor: 'instance creation' stamp: ''!
newInMonth: monthlyCalendar dayOfMonthOrdinal: dayOfMonth dayOfYearOrdinal: dayOfYear
	"Answer an instance of the receiver initalized as a CalendarDay of the month represented by <monthlyCalendar> (an instance of MonthlyCalendar,) with <dayOfMonth> as the its day-of-month ordinal and with <dayOfYear> as its day-of-year ordinal."

	^self new
		setDayOfMonthOrdinal: dayOfMonth dayOfYearOrdinal: dayOfYear;
		setMonthlyCalendar: monthlyCalendar;
		beImmutable;
		yourself! !

!DynamicCalendarDay methodsFor: 'arithmetic' stamp: ''!
addingDays: count
	"Answer the CalendarDay in the receiver's year type whose day-of-year ordinal is computed by adding <count> to the receiver's day-of-year ordinal. If the resulting day-of-year ordinal is not valid, answer nil."

	^count > 0
		ifTrue: [containingPeriod nextDayInYearAfter: self count: count - 1]		
		ifFalse: 
			[count < 0
				ifTrue: [self subtractingDays: count negated]
				ifFalse: [self]]! !

!DynamicCalendarDay methodsFor: 'initialize-release' stamp: ''!
setDayOfMonthOrdinal: dayOfMonth dayOfYearOrdinal: dayOfYear
	"Initialize the receiver as a CalendarDay representing the <dayOfMonth> day of a month, and the <dayOfYear>th day of the year. Fail if the receiver is not mutable."

	self assertMutability.
	dayOfMonthOrdinal := dayOfMonth.
	dayOfYearOrdinal := dayOfYear.! !

!DynamicCalendarDay methodsFor: 'arithmetic' stamp: ''!
subtractingDays: count
	"Answer the CalendarDay in the receiver's year type whose day-of-year ordinal is computed by subtracting <count> from the receiver's day-of-year ordinal. If the resulting day-of-year ordinal is not valid, answer nil."

	^count > 0
		ifTrue: [containingPeriod prevDayInYearBefore: self count: count - 1]		
		ifFalse: 
			[count < 0
				ifTrue: [self addingDays: count negated]
				ifFalse: [self]]! !

CalendarDay subclass: #StaticCalendarDay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!StaticCalendarDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

StaticCalendarDay

	Concept:

		A StaticCalendarDay is a CalendarDay (which see) that is specialized for collaboration with a StaticMonthlyCalendar (also which see.)

	Usage:

		As is the case with most Chronos classes, StaticCalendarDay instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:
!

!StaticCalendarDay class methodsFor: 'instance creation' stamp: ''!
firstDayOfMonth: aMonthlyCalendar
	"Answer an instance of the receiver initialized as the first day of the month represented by <aMonthlyCalendar> (an instance of MonthlyCalendar.)"

	^self new
		setMonthlyCalendar: aMonthlyCalendar! !

!StaticCalendarDay methodsFor: 'arithmetic' stamp: ''!
addingDays: count
	"Answer the CalendarDay in the receiver's year type whose day-of-year ordinal is computed by adding <count> to the receiver's day-of-year ordinal. If the resulting day-of-year ordinal is not valid, answer nil."

	^count = 0
		ifTrue: [self]
		ifFalse: [self yearlyCalendar dayAt: dayOfYearOrdinal + count]! !

!StaticCalendarDay methodsFor: 'private' stamp: ''!
advanceToNextDayOfMonth
	self assertMutability.
	dayOfMonthOrdinal := dayOfMonthOrdinal + 1.
	dayOfYearOrdinal := dayOfYearOrdinal + 1.
	isLeapDayInMonth := containingPeriod hasLeapDayAt: dayOfMonthOrdinal.
	isLeap := isLeapDayInMonth or: [self isInLeapMonth].! !

!StaticCalendarDay methodsFor: 'private' stamp: ''!
advanceToNextDayOfNextMonth
	self assertMutability.
	containingPeriod := containingPeriod nextInYear.
	monthOrdinal := containingPeriod monthOrdinal.
	dayOfMonthOrdinal := 1.
	dayOfYearOrdinal := dayOfYearOrdinal + 1.
	isLeapDayInMonth := containingPeriod hasLeapDayAt: dayOfMonthOrdinal.
	isLeap := isLeapDayInMonth or: [self isInLeapMonth].! !

!StaticCalendarDay methodsFor: 'private' stamp: ''!
newForNextDayOfMonth
	| nextInYear |
	self assertMutability.
	nextInYear := self copy.
	nextInYear advanceToNextDayOfMonth.
	self beImmutable.
	^nextInYear! !

!StaticCalendarDay methodsFor: 'private' stamp: ''!
newForNextDayOfNextMonth
	| nextInYear |
	self assertMutability.
	nextInYear := self copy.
	nextInYear 	advanceToNextDayOfNextMonth.
	self beImmutable.
	^nextInYear! !

!StaticCalendarDay methodsFor: 'arithmetic' stamp: ''!
subtractingDays: count
	"Answer the CalendarDay in the receiver's year type whose day-of-year ordinal is computed by subtracting <count> from the receiver's day-of-year ordinal. If the resulting day-of-year ordinal is not valid, answer nil."

	^count = 0
		ifTrue: [self]
		ifFalse: [self yearlyCalendar dayAt: dayOfYearOrdinal - count]! !

!CalendarYearPart methodsFor: 'printing' stamp: ''!
basicPrintOn: stream
	self printOn: stream indent: 0! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
daysUpToMonthSinceStartOfYear
	"For the type of year of the receiver, answer the number of days from the first day of the year up to (but not including) the first day of the receiver's month."

	^self monthlyCalendar daysUpToMonthSinceStartOfYear! !

!CalendarYearPart methodsFor: 'accessing-multivalued' stamp: ''!
eitherMonthOrdinalDo: block1a orMonthkeyDo: block1b
	"If the receiver's month ordinal is unambigously specified, evaluate <block1a> with the receiver's month ordinal. Otherwise, evaluate <block1b> with the semantic key that identifies the receiver's month."

	^block1a value: self monthOrdinal! !

!CalendarYearPart methodsFor: 'accessing-multivalued' stamp: ''!
eitherYearMonthDayDo: block3a orYearMonthkeyDayDo: block3b
	"If the receiver's month ordinal is unambigously specified, evaluate <block3a> with the receiver's year, its month ordinal and its day-of-month ordinal as the arguments. Otherwise, evaluate <block3b> with the receiver's year,  the semantic key that identifies the receiver's month and its day-of-month ordinal as the arguments."

	^self yearMonthDayDo: block3a! !

!CalendarYearPart methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthAbbreviationIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the abbreviation of the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^self monthlyCalendar 
		forLocale: aChronosLocale
		monthAbbreviationIfResolvable: resolvable
		ifNot: notResolvable! !

!CalendarYearPart methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthNameIfResolvable: resolvable ifNot: notResolvable 
	"Evaluate <resolvable> with the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKkey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^self monthlyCalendar 
		forLocale: aChronosLocale
		monthNameIfResolvable: resolvable
		ifNot: notResolvable! !

!CalendarYearPart methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	self assertMutability.
	monthOrdinal := 1.
	isLeap := false! !

!CalendarYearPart methodsFor: 'initialize-release' stamp: ''!
invalidateCalendar
	containingPeriod := containingPeriod == nil ifFalse: [containingPeriod canonical]! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
leapDayCountInYear
	"For the type of year of the receiver, answer the number of leap days in the year."

	^self yearlyCalendar leapDayCount! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
month
	"Answer the ordinal of the receiver's month."

	^monthOrdinal! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
monthAbbreviation
	"Answer the abbreviation of the receiver's month name according to the current default ChronosLocale."

	^self monthlyCalendar abbreviation! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
monthKey
	"Answer the semantic key that identifies the receiver's month."

	^self monthlyCalendar monthKey! !

!CalendarYearPart methodsFor: 'queries' stamp: ''!
monthKeyIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the key that semantically identifies the receiver's month as the sole argument. However, if the month's semantic key is not unambiguously resolvable, answer the result of evaluationg <notResolvable>. Answer the result of the evaluated block."

	^resolvable value: self monthKey! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
monthName
	"Answer the name of the receiver's month according to the current default ChronosLocale."

	^self monthlyCalendar name! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
monthOrdinal
	"Answer the ordinal of the receiver's month."

	^monthOrdinal! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
monthlyCalendar
	"Answer the MonthlyCalendar instance that specifies the properties the receiver's month (if the receiver is itself a MonthlyCalendar, answer the receiver.)"

	^self subclassResponsibility! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
monthsPerYear
	"For the type of year of the receiver, answer the number of months in the year."

	^self yearlyCalendar monthsPerYear! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
monthsSinceStartOfYear
	"For the type of year of the receiver, answer the number of months from the first month of the year up to (but not including) the receiver's month (the answer must be the cardinal number of the receiver's month.)"

	^self monthlyCalendar monthsSinceStartOfYear! !

!CalendarYearPart methodsFor: 'testing' stamp: ''!
occursEveryYear
	"Answer whether the calendar period represented by the receiver occurs in each and every type of year of the receiver's calendrical system."

	^isLeap not! !

!CalendarYearPart methodsFor: 'testing' stamp: ''!
yearHasLeapDays
	"Answer whether the receiver's year has any leap days."

	^self yearlyCalendar hasLeapDays! !

!CalendarYearPart methodsFor: 'accessing' stamp: ''!
yearlyCalendar
	"Answer the YearlyCalendar instance that specifies the properties of the receiver's year type (if the receiver is itself a YearlyCalendar, answer the receiver.)"

	^containingPeriod yearlyCalendar! !

CalendarYearPart subclass: #MonthlyCalendar
	instanceVariableNames: 'key nameKey isIntercalary leapDayOrdinals daysUpToMonthSinceStartOfYear'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!MonthlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

MonthlyCalendar

	Concept:

		MonthlyCalendar is an abstract class; an instance of one of its concrete subclasses represents/specifies the properties of a particular month as it occurs within a particular type of year (e.g., a standard year, a leap year) of a particular calendrical system (e.g., the Gregorian, Hebrew, or Persian calendar.)  It does NOT represent/specify an actual occurrence of a month in any specific year. In other words, a MonthlyCalendar would specify/represent (for example) the properties of the month of February as it occurs in any leap year of the Gregorian Calendar, but would not specify/represent any specific occurrence of February in a specific Gregorian year.

		Specifically, a MonthlyCalendar specifies the YearlyCalendar that encapsulates it (and hence also the Calendar that implements the calendrical system for which it represents the properties/characteristics of a particular month in a particular type of year); the month ordinal of the month it represents; the "month key" that semantically identifies the month (because "the same" month may have a different ordinal in different year types); the "name key" that semantically identifies the name of the month (because the "same month" may have a different name in different year types, and also because the "same month" probably has a different name in different languages and/or cultures); whether or not the month is an intercalary or leap month; what the month's leap days are (if any); the number of days from the beginning of the year up to the first day of the month; and the properties of each day of the month (by means of an encapsulated instance of CalendarDay--one for each day of the month.)

		The two concrete subclasses of MonthlyCalendar are StaticMonthlyCalendar and DynamicMonthlyCalendar. A StaticMonthlyCalendar is preinitialized to encapsulate a flyweight instance of StaticCalendarDay for each day in the month it represents.  In contrast, a DynamicMonthlyCalendar generates a new instance of DynamicCalendarDay every time one is needed. StaticMonthlyCalendar must be used in collaboration with StaticYearlyCalendar and StaticCalendarDay. DynamicMonthlyCalendar must be used in collaboration with DynamicYearlyCalendar and DynamicCalendarDay.

	Usage:

		As is the case with most Chronos classes, MonthlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			key 								<Symbol>
				The key that semantically identifies the month represented by the instance.
			nameKey 							<Symbol | nil>
				The key that semantically identifies the name of the month represented by the instance (because what is semantically the "same month" may go by different names in different years--for example, "Adar" and "Adar Sheni" in the Hebrew Calendar.)  If the <nameKey> is nil, then the instance's "name key" is identical to its <key>.
			isIntercalary 						<Boolean>
				Flag that signals whether or not the month represented by the instance is an intercalary month. An intercalary month is one that either a) does not occur every year (it's a "leap month,") and/or b) does not have nearly the same number of days as the majority of months in the year.
			leapDayOrdinals 					<Collection of Integer>
				Collection of the day-of-month ordinals of the days of the month represented by the instance that are leaps days (days that are inserted into the month in some years but not in others--note that a leap day does NOT have to be the last day of a month.)
			daysUpToMonthSinceStartOfYear	<Integer>
				The number of days from the first day of the instance's year up to (but not including) the first day of the month represented by the instance.

	Subclassing:

		Concrete subclasses must subimplement the following instance methods (see the comment of each method for the required semantics):

			#basicDayAt:
			#calendarDayClass
			#dayAt:
			#daysPerMonth
			#setDaysPerMonth:
!

MonthlyCalendar subclass: #DynamicMonthlyCalendar
	instanceVariableNames: 'daysPerMonth'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!DynamicMonthlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

DynamicMonthlyCalendar

	Concept:

		A DynamicMonthlyCalendar is a MonthlyCalendar (which see) that generates a new instance of DynamicCalendarDay every time one is needed.  DynamicMonthlyCalendar must be used in collaboration with DynamicYearlyCalendar and DynamicCalendarDay.

	Usage:

		As is the case with most Chronos classes, DynamicMonthlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Motivation:

		DynamicMonthlyCalendar, in collaboration with DynamicCalendarDay and DynamicYearlyCalendar, avoids the utilization of too much memory in the case of calendrical systems that have too many different year types to reasonably use the flyweight pattern for representing the month structure of each type of year.

	Implementation:

		Instance Variables

			daysPerMonth	<Integer> The number of days in the month represented by the instance.
!

!DynamicMonthlyCalendar class methodsFor: 'instance creation' stamp: ''!
monthInYear: aYearlyCalendar monthOrdinal: monthOrdinal daysUpToMonthSinceStartOfYear: daysUpToMonthSinceStartOfYear specification: aCalendarMonthSpecification
	^self new 
		setYearlyCalendar: aYearlyCalendar 
		monthOrdinal: monthOrdinal
		daysUpToMonthSinceStartOfYear: daysUpToMonthSinceStartOfYear 
		specification: aCalendarMonthSpecification! !

!DynamicMonthlyCalendar class methodsFor: 'instance creation' stamp: ''!
monthInYear: aYearlyCalendar monthOrdinal: monthOrdinal specification: aCalendarMonthSpecification
	^self new 
		setYearlyCalendar: aYearlyCalendar 
		monthOrdinal: monthOrdinal
		specification: aCalendarMonthSpecification! !

!DynamicMonthlyCalendar methodsFor: 'accessing' stamp: ''!
basicDayAt: dayOfMonthOrdinal
	"Answer the CalendarDay with the given <dayOfMonthOrdinal>.  Fail if the <dayOfMonthOrdinal> is invalid."

	^self newCalendarDay: dayOfMonthOrdinal! !

!DynamicMonthlyCalendar methodsFor: 'private' stamp: ''!
calendarDayClass
	"Answer the concrete subclass of CalendarDays that should be used to instantiate CalendarDays to represent the days of the receiver's month."

	^DynamicCalendarDay! !

!DynamicMonthlyCalendar methodsFor: 'accessing' stamp: ''!
dayAt: dayOfMonthOrdinal
	"Answer the CalendarDay with the given <dayOfMonthOrdinal>.  Answer nil if the <dayOfMonthOrdinal> is invalid."

	(dayOfMonthOrdinal > daysPerMonth or: [dayOfMonthOrdinal < 1])
		ifTrue: [^nil].
	^self newCalendarDay: dayOfMonthOrdinal! !

!DynamicMonthlyCalendar methodsFor: 'accessing' stamp: ''!
daysPerMonth
	"For the type of year of the receiver, answer the number of days in the month whose properties are specified by the receiver."

	^daysPerMonth! !

!DynamicMonthlyCalendar methodsFor: 'private' stamp: ''!
newCalendarDay: dayOfMonth
	^self calendarDayClass
		newInMonth: self 
		dayOfMonthOrdinal: dayOfMonth 
		dayOfYearOrdinal: dayOfMonth + daysUpToMonthSinceStartOfYear! !

!DynamicMonthlyCalendar methodsFor: 'private' stamp: ''!
nextDayInYearAfter: aCalendarDay count: count
	| nextDayOfMonth |
	nextDayOfMonth := aCalendarDay dayOfMonthOrdinal + count.
	^nextDayOfMonth > daysPerMonth
		ifTrue: [containingPeriod dayAt: aCalendarDay dayOfYearOrdinal + count]
		ifFalse: 
			[nextDayOfMonth < 1
				ifTrue: [self signalError: 'Invalid operation']
				ifFalse: [self newCalendarDay: nextDayOfMonth]]! !

!DynamicMonthlyCalendar methodsFor: 'private' stamp: ''!
prevDayInYearBefore: aCalendarDay count: count
	| prevDayOfMonth |
	prevDayOfMonth := aCalendarDay dayOfMonthOrdinal - count.
	^prevDayOfMonth < 1 
		ifTrue: [containingPeriod dayAt: aCalendarDay dayOfYearOrdinal - count]
		ifFalse: 
			[prevDayOfMonth > daysPerMonth
				ifTrue: [self signalError: 'Invalid operation']
				ifFalse: [self  newCalendarDay: prevDayOfMonth]]! !

!DynamicMonthlyCalendar methodsFor: 'private' stamp: ''!
setDaysPerMonth: daysInMonth
	"Initialize the receiver so that it represents a month with <daysPerMonth> days. Fail if the receiver is immutable."

	self assertMutability.
	daysPerMonth := daysInMonth! !

!DynamicMonthlyCalendar methodsFor: 'initialize-release' stamp: ''!
setYearlyCalendar: aYearlyCalendar monthOrdinal: monthIndex daysUpToMonthSinceStartOfYear: daysUpToMonth specification: aMonthlyCalendarSpecification
	"Initialize the receiver as the <monthIndex>th month of <aYearlyCalendar> (an instance of YearlyCalendar,) so that the receiver specifies the same properties for the month it represents as are specifed by <aMonthlyCalendarSpecification> (an instance of MonthlyCalendarSpec,) and so that the receiver specifies that there are <daysUpToMonth> days from the first day of the year up to (but not including) the first day of the month represented by the receiver."

	self assertMutability.
	monthOrdinal := monthIndex.
	daysUpToMonthSinceStartOfYear := daysUpToMonth.
	super setYearlyCalendar: aYearlyCalendar specification: aMonthlyCalendarSpecification! !

!DynamicMonthlyCalendar methodsFor: 'initialize-release' stamp: ''!
setYearlyCalendar: aYearlyCalendar specification: aMonthlyCalendarSpecification
	self shouldNotImplement! !

!MonthlyCalendar class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^((Calendar referencedBy: (literalArray at: 2)) canonical
		yearlyCalendarForYearTypeCode: (literalArray at: 3) decodeAsLiteralArray)
			monthAt: (literalArray at: 4)! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
abbreviation
	"Answer the abbreviation of the receiver's month name according to the current default ChronosLocale."

	^self forLocale: ChronosLocale default monthAbbreviationIfResolvable: [:name | name] ifNot: [self nameKey]! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
basicDayAt: index
	"Answer the CalendarDay with the given <dayOfMonthOrdinal>.  Fail if the <dayOfMonthOrdinal> is invalid."

	^self subclassResponsibility! !

!MonthlyCalendar methodsFor: 'private' stamp: ''!
calendarDayClass
	"Answer the concrete subclass of CalendarDays that should be used to instantiate CalendarDays to represent the days of the receiver's month."

	^self subclassResponsibility! !

!MonthlyCalendar methodsFor: 'converting' stamp: ''!
canonical
	^self yearlyCalendar canonical monthAt: self monthOrdinal! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
dayAt: dayOfMonthOrdinal
	"Answer the CalendarDay with the given <dayOfMonthOrdinal>.  Answer nil if the <dayOfMonthOrdinal> is invalid."

	^self subclassResponsibility! !

!MonthlyCalendar methodsFor: 'enumerating' stamp: ''!
dayOfMonthOrdinalsDo: block1
	"For each day of the receiver's month, evaluate <block1> with the day-of-month ordinal (in ascending sequence) of the day as the argument."

	1 to: self daysPerMonth do: [:index | block1 value: index]! !

!MonthlyCalendar methodsFor: 'enumerating' stamp: ''!
daysDo: block1
	"For each day of the receiver's month, evaluate <block1> with the receiver's CalendarDay representing that day as the argument."

	1 to: self daysPerMonth do: [:dayOfMonth | block1 value: (self basicDayAt: dayOfMonth)]! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
daysPerMonth
	"For the type of year of the receiver, answer the number of days in the month whose properties are specified by the receiver."

	^self subclassResponsibility! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
daysUpToMonthSinceStartOfYear
	"For the type of year of the receiver, answer the number of days from the first day of the year up to (but not including) the first day of the receiver's month."

	^daysUpToMonthSinceStartOfYear! !

!MonthlyCalendar methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self monthOrdinal! !

!MonthlyCalendar methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthAbbreviationIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the abbreviation of the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^resolvable value: ((ChronosLocale referencedBy: aChronosLocale) abbreviationAtSemanticKey: self nameKey)! !

!MonthlyCalendar methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthNameIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKkey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^resolvable value: ((ChronosLocale referencedBy: aChronosLocale) properNameAtSemanticKey: self nameKey)! !

!MonthlyCalendar methodsFor: 'testing' stamp: ''!
hasLeapDayAt: dayOfMonthOrdinal
	"Answer whether the day of the receiver's month with the given <dayOfMonthOrdinal> is a leap day."

	^leapDayOrdinals includes: dayOfMonthOrdinal! !

!MonthlyCalendar methodsFor: 'testing' stamp: ''!
hasLeapDays
	"Answer whether there are any leap days in the receiver's month."

	^leapDayOrdinals size > 0! !

!MonthlyCalendar methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	isIntercalary = false.
	daysUpToMonthSinceStartOfYear := 0.
	leapDayOrdinals := #()! !

!MonthlyCalendar methodsFor: 'testing' stamp: ''!
isIntercalaryMonth
	"Answer whether the receiver's month is an intercalary month. An intercalary month is one that either a) does not occur every year, and/or b) does not have nearly the same number of days as the majority of months in the year."

	^isIntercalary! !

!MonthlyCalendar methodsFor: 'testing' stamp: ''!
isLeapMonth
	"Answer true if the month represented by the receiver does not occur in every type of year."

	^isLeap! !

!MonthlyCalendar methodsFor: 'testing' stamp: ''!
isStandardMonth
	"Answer whether the receiver's month is a 'normal' month. A normal month is one that a) occurs every year, and b) has about the same number of days as the majority of months in the year."

	^isIntercalary not! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
lastDay
	"Answer the CalendarDay that specifies the properties of the last day of the month specified by the receiver."

	^self basicDayAt: self daysPerMonth! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
leapDayCount
	"For the type of year of the receiver, answer the number of leap days in the month whose properties are specified by the receiver."

	^leapDayOrdinals size! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
leapDayOrdinals
	^leapDayOrdinals! !

!MonthlyCalendar methodsFor: 'enumerating' stamp: ''!
leapDayOrdinalsDo: block1
	"For each leap day in the receiver's month, evaluate <block1> with the day-of-month ordinal (in ascending sequence) of the day as the argument."

	leapDayOrdinals do: block1! !

!MonthlyCalendar methodsFor: 'enumerating' stamp: ''!
leapDaysDo: block1
	"For each leap day in the receiver's month, evaluate <block1> with the receiver's CalendarDay representing that day as the argument."

	self leapDayOrdinalsDo: [:index | block1 value: (self basicDayAt: index)]! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
month
	"For the type of year of the receiver, answer the ordinal of the receiver's month."

	^monthOrdinal! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
monthAbbreviation
	"Answer the abbreviation of the receiver's month name according to the current default ChronosLocale."

	^self abbreviation! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
monthKey
	"Answer the semantic key that identifies the receiver's month."

	^key! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
monthName
	"Answer the name of the receiver's month according to the current default ChronosLocale."

	^self name! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
monthOrdinal
	"Answer the ordinal of the receiver's month."

	^monthOrdinal! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
monthlyCalendar
	"Answer the MonthlyCalendar instance that specifies the properties the receiver's month (if the receiver is itself a MonthlyCalendar, answer the receiver.)"

	^self! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
monthsSinceStartOfYear
	"For the type of year of the receiver, answer the number of months from the first month of the year up to (but not including) the receiver's month (the answer must be the cardinal number of the receiver's month.)"

	^monthOrdinal - 1! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
name
	"Answer the receiver's name according to the current default ChronosLocale."

	^self forLocale: ChronosLocale default monthNameIfResolvable: [:name | name] ifNot: [self nameKey]! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
nameKey
	^nameKey == nil
		ifTrue: [key]
		ifFalse: [nameKey]! !

!MonthlyCalendar methodsFor: 'printing' stamp: ''!
printCalendarDaysOn: stream indent: depth
	self daysDo: [:day |
		stream cr.
		day printOn: stream indent: depth + 1]! !

!MonthlyCalendar methodsFor: 'printing' stamp: ''!
printOn: stream indent: depth
	stream 
		tab: depth;
		nextPut: ${;
		nextPutAll: self class name;
		nextPutAll: ' monthKey=';
		print: self monthKey;
		tab;
		nextPutAll: ' name=';
		nextPutAll: self name;
		crtab;
		tab: depth;
		nextPutAll: ' ordinal=';
		print: self monthOrdinal;
		tab;
		nextPutAll: ' yearTypeCode=';
		print: self yearTypeCode;
		tab;
		nextPutAll: ' daysPerMonth=';
		print: self daysPerMonth;
		tab;
		nextPutAll: ' intercalaryMonth=';
		print: isIntercalary;
		tab;
		nextPutAll: ' leapMonth=';
		print: isLeap;
		tab;
		nextPutAll: ' leapDayOrdinals: ';
		print: self leapDayOrdinals;
		nextPut: $}! !

!MonthlyCalendar methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printMonthlyCalendar: self on: stream! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^MonthDuration! !

!MonthlyCalendar methodsFor: 'private' stamp: ''!
setDaysPerMonth: daysPerMonth
	"Initialize the receiver so that it represents a month with <daysPerMonth> days. Fail if the receiver is immutable."

	^self subclassResponsibility! !

!MonthlyCalendar methodsFor: 'initialize-release' stamp: ''!
setYearlyCalendar: aYearlyCalendar specification: aMonthlyCalendarSpecification
	"Initialize the receiver as one of the months of <aYearlyCalendar> (an instance of YearlyCalendar,) so that the receiver specifies the same properties for the month it represents as are specifed by <aMonthlyCalendarSpecification> (an instance of MonthlyCalendarSpec.)"

	self assertMutability.
	containingPeriod := aYearlyCalendar.
	key := aMonthlyCalendarSpecification monthKey.
	nameKey := aMonthlyCalendarSpecification nameKey.
	isLeap := aMonthlyCalendarSpecification isLeapMonth.
	isIntercalary := isLeap or: [aMonthlyCalendarSpecification isIntercalaryMonth].
	leapDayOrdinals := aMonthlyCalendarSpecification leapDayOrdinals.
	self setDaysPerMonth: aMonthlyCalendarSpecification daysPerMonth! !

!MonthlyCalendar methodsFor: 'accessing' stamp: ''!
yearlyCalendar
	"Answer the YearlyCalendar instance that specifies the properties of the receiver's year type (if the receiver is itself a YearlyCalendar, answer the receiver.)"

	^containingPeriod! !

MonthlyCalendar subclass: #StaticMonthlyCalendar
	instanceVariableNames: 'prevInYear nextInYear days'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!StaticMonthlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

StaticMonthlyCalendar

	Concept:

		A StaticMonthlyCalendar is a MonthlyCalendar (which see) that is preinitialized to encapsulate a flyweight instance of StaticCalendarDay for each day in the month it represents.  StaticMonthlyCalendar must be used in collaboration with StaticYearlyCalendar and StaticCalendarDay.

	Usage:

		As is the case with most Chronos classes, StaticMonthlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			prevInYear 	<StaticMonthlyCalendar | nil>
				The StaticMonthlyCalendar that represents the month of the instance's year type that immediately precedes the month represented by the instance (if any).
			nextInYear 	<StaticMonthlyCalendar | nil>
				The StaticMonthlyCalendar that represents the month of the instance's year type that immediately follows the month represented by the instance (if any).
			days 		<Array of StaticCalendarDay>
				The StaticCalendarDay at the <D>th index in the array specifies the properties of the <D>th day of the month represented by the instance.
!

!StaticMonthlyCalendar class methodsFor: 'instance creation' stamp: ''!
firstMonthInYear: aYearlyCalendar specification: aCalendarMonthSpecification
	^self new 
		setYearlyCalendar: aYearlyCalendar 
		specification: aCalendarMonthSpecification! !

!StaticMonthlyCalendar methodsFor: 'private' stamp: ''!
advanceToNextMonth: aMonthlyCalendarSpecification after: prev
	self assertMutability.
	key := aMonthlyCalendarSpecification monthKey.
	nameKey := aMonthlyCalendarSpecification nameKey.
	nextInYear := nil.
	prevInYear := prev.
	monthOrdinal := monthOrdinal + 1.
	isLeap := aMonthlyCalendarSpecification isLeapMonth.
	isIntercalary := isLeap or: [aMonthlyCalendarSpecification isIntercalaryMonth].
	daysUpToMonthSinceStartOfYear := daysUpToMonthSinceStartOfYear + prev daysPerMonth.
	leapDayOrdinals := aMonthlyCalendarSpecification leapDayOrdinals.
	self setDaysPerMonth: aMonthlyCalendarSpecification daysPerMonth! !

!StaticMonthlyCalendar methodsFor: 'accessing' stamp: ''!
basicDayAt: dayOfMonthOrdinal
	"Answer the CalendarDay with the given <dayOfMonthOrdinal>.  Fail if the <dayOfMonthOrdinal> is invalid."

	^days at: dayOfMonthOrdinal! !

!StaticMonthlyCalendar methodsFor: 'private' stamp: ''!
calendarDayClass
	"Answer the concrete subclass of CalendarDays that should be used to instantiate CalendarDays to represent the days of the receiver's month."

	^StaticCalendarDay! !

!StaticMonthlyCalendar methodsFor: 'accessing' stamp: ''!
dayAt: dayOfMonthOrdinal
	"Answer the CalendarDay with the given <dayOfMonthOrdinal>.  Answer nil if the <dayOfMonthOrdinal> is invalid."

	^(dayOfMonthOrdinal > days size or: [dayOfMonthOrdinal < 1])
		ifFalse: [days at: dayOfMonthOrdinal]! !

!StaticMonthlyCalendar methodsFor: 'enumerating' stamp: ''!
daysDo: block1
	"For each day of the receiver's month, evaluate <block1> with the receiver's CalendarDay representing that day."

	^days do: block1! !

!StaticMonthlyCalendar methodsFor: 'accessing' stamp: ''!
daysPerMonth
	"For the type of year of the receiver, answer the number of days in the month whose properties are specified by the receiver."

	^days size! !

!StaticMonthlyCalendar methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	days := #().! !

!StaticMonthlyCalendar methodsFor: 'accessing' stamp: ''!
lastDay
	"Answer the CalendarDay that specifies the properties of the last day of the month specified by the receiver."

	^days last! !

!StaticMonthlyCalendar methodsFor: 'private' stamp: ''!
newFirstDayOfMonth
	^self calendarDayClass firstDayOfMonth: self! !

!StaticMonthlyCalendar methodsFor: 'private' stamp: ''!
newForNextMonth: aCalendarMonthSepcification
	self assertMutability.
	nextInYear := self copy.
	nextInYear advanceToNextMonth: aCalendarMonthSepcification after: self.
	self beImmutable.
	^nextInYear! !

!StaticMonthlyCalendar methodsFor: 'private' stamp: ''!
nextInYear
	^nextInYear! !

!StaticMonthlyCalendar methodsFor: 'private' stamp: ''!
setDaysPerMonth: daysPerMonth
	"Initialize the receiver so that it represents a month with <daysPerMonth> days. Fail if the receiver is immutable."

	| d |
	self assertMutability.
	days := Array new: daysPerMonth.
	d := prevInYear == nil 
		ifTrue: [self newFirstDayOfMonth] 
		ifFalse: [prevInYear lastDay newForNextDayOfNextMonth].
	days at: 1 put: d.
	2 to: days size do: [:i | days at: i put: (d := d newForNextDayOfMonth)].! !

CalendarPeriod subclass: #YearlyCalendar
	instanceVariableNames: 'calendar typeCode intercalaryMonthCount leapMonthOrdinals leapDayOrdinals daysPerYear daysPerStandardYear hasNoLeapDays'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!YearlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

YearlyCalendar

	Concept:

		YearlyCalendar is an abstract class; an instance of one of its concrete subclasses represents/specifies the properties of a calendar year (of a particular type) of a particular calendrical system (e.g., the Gregorian, Hebrew, or Persian calendar.)  It does NOT represent/specify an actual occurrence of a specific year. In other words, a YearlyCalendar would specify/represent (for example) the properties of any leap year of the Gregorian Calendar, but would not specify/represent any specific Gregorian year.

		Specifically, a YearlyCalendar specifies the calendrical system for which it represents a type of year; the Chronos 'year type code' of the type of year it specifies; the number of months per year; the number of leap and intercalary months in the year; which months of the year are leap or intercalary months; the number of days per year; the number of leap days in the year; which days of the year are leap days; and the number of days in each month.  A YearlyCalendar encapsulates, and provides access to, instances of MonthlyCalendar and CalendarDay that specify the properties of each month and day of the type of year specified by the instance.

		Most calendrical systems have more than one type of year.  Instances of Calendar use a different instance of YearlyCalendar to represent/specify the properties/characteristics of each type of year that occurs in the calendrical system implemented by the Calendar instance.  

		StaticYearlyCalendar and DynamicYearlyCalendar are the two concrete subclasses of YearlyCalendar.  If there is a relatively small number of different year types that can occur in a calendrical system, a Calendar that implements that calendrical system instantiates a single instance of StaticYearlyCalendar for each such year type. Since there is usually only one instance of Calendar per calendrical system, StaticYearlyCalendars (and also StaticMonthlyCalendars and StaticCalendarDays) usually conform to the flyweight constraint (there's only one instance in the image per year type.)  However, if there is a relatively large (or infinite) number of distinct year types in a calendrical system, then a Calendar that implements that calendrical system instead may use instances of DynamicYearlyCalendar, DynamicMonthlyCalendar and DynamicCalendarDay, which will not conform to the flyweight constraint (so as to avoid using up excessive amounts of memory.)

		A StaticYearlyCalendar is preinitialized to encapsulate a flyweight instance of StaticMonthlyCalendar for each month in the type of year it represents, and to encapsulate a flyweight StaticCalendarDay for each day of the type of year it represents.  Similarly, a StaticMonthlyCalendar is preinitialized to encapsulate a flyweight instance of StaticCalendarDay for each day in the month it represents.  In contrast, a DynamicYearlyCalendar generates a new DynamicMontlyCalendar instance or a new DynamicCalendarDay instance every time it needs one or the other.  And a DynamicMonthlyCalendar generates a new instance of DynamicCalendarDay every time one is needed.

	Usage:

		As is the case with most Chronos classes, YearlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			calendar 				<Calendar>
				The Calendar object that implements the calendrical system for which the instance specifies the properties of a year of a particular type.
			typeCode 				<Object>
				The object that uniquely identifies the type of the year whose properties are specified by the instance (usually, but not necessarily, this is an integer code.)
			intercalaryMonthCount 	<Integer>
				The number of intercalary months in a year of the type whose properties are specified by the instance (an intercalary month is one whose purpose is to contain any days that need to be added to the year--in addition to those that are contained by normal months--so that the total number of days in all the months of the year, and the total number of days in the year, will be the same. Intercalary months that occur every year usually have a number of days in the month that substantially differs from the number of days in a "standard" month.)
			leapMonthOrdinals 		<Array of Integer>
				Contains the month ordinal of each month that is a leap month in the type of year whose properties are specified by the instance.  A leap month is any month that doesn't occur in every type of year.  All leap months are also intercalary months, although not all intercalary months are leap months.
			leapDayOrdinals  		<Array of Integer>
				Contains the day-of-year ordinal of each day of the type of year whose properties are specified by the instance that is a leap day.  A leap day is any day of any month that doesn't occur in every type of year--including all the days of any leap month.
			daysPerYear 			<Integer>
				The number of days in a year of the type whose properties are specified by the instance.
			daysPerStandardYear 	<Integer>
				The number of days in a "standard" year for the calendrical system of the instance (as specified by the value of the 'calendar' instance variable.) A "standard year" is the type of year with the fewest leap days.
			hasNoLeapDays 		<Boolean>
				Flag that indicates whether there are any leap days in the type of year whose properties are specified by the instance.

	Subclassing:

		Concrete subclasses must subimplement the following instance methods (see the comment of each method for the required semantics):

			#basicDayAt:
			#basicMonthAt:dayAt:
			#dayAt:
			#dayAt:monthDayDo:
			#daysInMonthAt:
			#daysInMonthWithKey:ifAbsent:
			#daysUpToMonth:
			#daysUpToMonthWithKey:ifAbsent:
			#monthAt:
			#monthlyCalendarClass
			#monthOrdinalForMonthWithKey:ifAbsent:
			#monthsPerYear
			#setMonthsInYear:
!

YearlyCalendar subclass: #DynamicYearlyCalendar
	instanceVariableNames: 'monthSpecs daysUpToMonthSinceStartOfYear'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!DynamicYearlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

DynamicYearlyCalendar

	Concept:

		A DynamicYearlyCalendar is a YearlyCalendar (which see) that generates a new DynamicMontlyCalendar instance or a new DynamicCalendarDay instance every time it needs one or the other.

	Usage:

		As is the case with most Chronos classes, DynamicYearlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Motivation:

		DynamicYearlyCalendar, in collaboration with DynamicCalendarDay and DynamicMonthlyCalendar, avoids the utilization of too much memory in the case of calendrical systems that have too many different year types to reasonably use the flyweight pattern for representing the month structure of each type of year.

	Implementation:

		Instance Variables

			monthSpecs 						<Array of MonthlyCalendarSpec>
				The MonthlyCalendarSpec at the <M>th index in the array specifies the properties of the <M>th month of the year represented by the instance.
			daysUpToMonthSinceStartOfYear 	<Array of Integer>
				The integer value at the <M>th index in the array specifies the number of days from the first day of the year up to (but not including) the first day of the <M>th month of the year represented by the instance.
!

!DynamicYearlyCalendar methodsFor: 'accessing' stamp: ''!
basicDayAt: dayOfYearOrdinal 
	"Answer the CalendarDay with the given <dayOfYearOrdinal>.  Fail if the <dayOfYearOrdinal> is invalid."

	^self dayAt: dayOfYearOrdinal monthDayDo: 
		[:month :dayOfMonth | self basicMonthAt: month dayAt: dayOfMonth]! !

!DynamicYearlyCalendar methodsFor: 'accessing' stamp: ''!
basicMonthAt: monthOrdinal dayAt: day
	"Answer the CalendarDay with the given <monthOrdinal> and <day>-of-month ordinal.  Fail if either the <monthOrdinal> or the the <day>-of-month ordinal are invalid."

	^(self newMonthlyCalendarAt: monthOrdinal) basicDayAt: day! !

!DynamicYearlyCalendar methodsFor: 'accessing' stamp: ''!
dayAt: dayOfYearOrdinal
	"Answer the CalendarDay with the given <dayOfYearOrdinal>.  Answer nil if the <dayOfYearOrdinal> is invalid."

	^self dayAt: dayOfYearOrdinal monthDayDo: 
		[:month :dayOfMonth | self monthAt: month dayAt: dayOfMonth]! !

!DynamicYearlyCalendar methodsFor: 'queries' stamp: ''!
dayAt: dayOfYearOrdinal monthDayDo: block2
	"For the day of the receiver's year type with the given <dayOfYearOrdinal>, evaluate <block2> with the day's month ordinal and day-of-month ordinal as the first and second arguments (respectively.)"

	dayOfYearOrdinal > daysPerYear ifTrue: [^nil].
	dayOfYearOrdinal < 1 ifTrue: [^nil].
	daysUpToMonthSinceStartOfYear size to: 1 by: -1 do: 
		[:monthOrdinal |
			| daysUpToMonth |
			daysUpToMonth := daysUpToMonthSinceStartOfYear at: monthOrdinal.
			dayOfYearOrdinal > daysUpToMonth
				ifTrue: [^block2 value: monthOrdinal value: (dayOfYearOrdinal - daysUpToMonth)]]! !

!DynamicYearlyCalendar methodsFor: 'queries' stamp: ''!
daysInMonthAt: monthOrdinal
	"Answer the number of days in the month of the receiver's year type with the given <monthOrdinal>."

	^(monthSpecs at: monthOrdinal) daysPerMonth! !

!DynamicYearlyCalendar methodsFor: 'queries' stamp: ''!
daysInMonthWithKey: monthKey ifAbsent: block0
	"Answer the number of days in the month of the receiver's year type with the given <monthKey> (semantic identifier.) If there is no month with the given <monthKey> in the receiver's year, answer the result of evaluating <block0>."

	^(self monthWithKey: monthKey ifAbsent: [^block0 value]) daysPerMonth! !

!DynamicYearlyCalendar methodsFor: 'queries' stamp: ''!
daysUpToMonth: month
	"Anwer the number of days from the first day of the year up to (but not including) the first day of the month (in the receiver's year type) with the given <month> ordinal. The answer should be the CARDINAL day-of-year number of the first day of the month."

	^(daysUpToMonthSinceStartOfYear at: month)! !

!DynamicYearlyCalendar methodsFor: 'queries' stamp: ''!
daysUpToMonthWithKey: monthKey ifAbsent: block0
	"Anwer the number of days from the first day of the year up to (but not including) the first day of the month (in the receiver's year type) with the given <monthKey> (semantic identifier.) The answer should be the CARDINAL day-of-year number of the first day of the month. If the receiver's year type has no month with the given <monthKey>, answer the result of evaluating <block0>."

	| month | 
	month := self monthWithKey: monthKey ifAbsent: [^block0 value].
	^self daysUpToMonth: month monthOrdinal! !

!DynamicYearlyCalendar methodsFor: 'accessing' stamp: ''!
firstMonth
	"Answer the MonthlyCalendar instance that specifies the properties of the first month of the receiver's year."

	^self newMonthlyCalendarAt: 1! !

!DynamicYearlyCalendar methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.	
	monthSpecs := #().
	daysUpToMonthSinceStartOfYear := #().! !

!DynamicYearlyCalendar methodsFor: 'accessing' stamp: ''!
lastMonth
	"Answer the MonthlyCalendar instance that specifies the properties of the last month of the receiver's year."

	^self newMonthlyCalendarAt: self monthsPerYear! !

!DynamicYearlyCalendar methodsFor: 'accessing' stamp: ''!
monthAt: monthOrdinal
	"Answer the MonthlyCalendar for the month with the given <monthOrdinal>. Answer nil if the <monthOrdinal> is invalid."

	^(monthOrdinal > self monthsPerYear or: [monthOrdinal < 1])
		ifFalse: [self newMonthlyCalendarAt: monthOrdinal]! !

!DynamicYearlyCalendar methodsFor: 'queries' stamp: ''!
monthOrdinalForMonthWithKey: monthKey ifAbsent: block0
	"Answer the month ordinal of the month with the given <monthKey> (semantic identifier) in the receiver's year type. If the receiver's year type has no month with the given <monthKey>, answer the result of evaluating <block0>."
 
	^(self monthWithKey: monthKey ifAbsent: [^block0 value]) monthOrdinal! !

!DynamicYearlyCalendar methodsFor: 'private' stamp: ''!
monthWithKey: monthKey ifAbsent: block0
	^monthSpecs detect: [:each | each monthKey == monthKey] ifNone: block0! !

!DynamicYearlyCalendar methodsFor: 'private' stamp: ''!
monthlyCalendarClass
	"Answer the concrete subclass of MonthlyCalendar that should be used to instantiate MonthlyCalendars to represent the months of the receiver's year."

	^DynamicMonthlyCalendar! !

!DynamicYearlyCalendar methodsFor: 'accessing' stamp: ''!
monthsPerYear
	"Answer the number of months in the type of year whose properties are specified by the receiver."

	^monthSpecs size! !

!DynamicYearlyCalendar methodsFor: 'private' stamp: ''!
newMonthlyCalendarAt: monthOrdinal
	^self monthlyCalendarClass
		monthInYear: self 
		monthOrdinal: monthOrdinal 
		daysUpToMonthSinceStartOfYear: (daysUpToMonthSinceStartOfYear at: monthOrdinal)
		specification: (monthSpecs at: monthOrdinal)! !

!DynamicYearlyCalendar methodsFor: 'private' stamp: ''!
setMonthsInYear: specificationOfMonths
	"Initialize the receiver so that its month structure is as specified by <specificationOfMonths>--which is an Array of MonthlyCalendarSpecs, such that the entry in the Array whose index is M specifies the properties of the month whose month ordinal is also M. Fail if the receiver is immutable."

	| leapMonthStream leapDaySet  |
	self assertMutability.
	monthSpecs := specificationOfMonths.
	daysUpToMonthSinceStartOfYear := Array new: monthSpecs size.
	daysPerYear := 0.
	intercalaryMonthCount := 0.
	leapMonthOrdinals := Array new.
	leapMonthStream := leapMonthOrdinals writeStream.
	leapDaySet := Set new.
	1 to: monthSpecs size do: [:monthOrdinal | 
		| month daysPerMonth |
		daysUpToMonthSinceStartOfYear at: monthOrdinal put: daysPerYear.
		month := monthSpecs at: monthOrdinal.
		daysPerMonth := month daysPerMonth.
		month isIntercalaryMonth 
			ifTrue: 
				[intercalaryMonthCount := intercalaryMonthCount + 1.
				month isLeapMonth 
					ifTrue: 
						[leapMonthStream nextPut: monthOrdinal.
						month dayOfMonthOrdinalsDo: [:dayOfMonth | leapDaySet add: dayOfMonth + daysPerYear]]].
		month leapDayOrdinalsDo: [:leapDayOrdinal | leapDaySet add: (leapDayOrdinal + daysPerYear)].
		daysPerYear := daysPerYear + daysPerMonth].
	leapMonthOrdinals := leapMonthStream contents.
	leapDayOrdinals := leapDaySet asArray.! !

YearlyCalendar subclass: #StaticYearlyCalendar
	instanceVariableNames: 'months days'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!StaticYearlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

StaticYearlyCalendar

	Concept:

		A StaticYearlyCalendar is a YearlyCalendar (which see) that is preinitialized to encapsulate a flyweight instance of StaticMonthlyCalendar for each month in the type of year it represents, and to encapsulate a flyweight StaticCalendarDay for each day of the type of year it represents.  

	Usage:

		As is the case with most Chronos classes, StaticYearlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			months <Array of StaticMonthlyCalendar>
				The StaticMonthlyCalendar at the <M>th index in the array specifies the properties of the <M>th month of the year represented by the instance.
			days 	<Array of StaticCalendarDay>
				The StaticCalendarDay at the <D>th index in the array specifies the properties of the <D>th day of the year represented by the instance.
!

!StaticYearlyCalendar methodsFor: 'accessing' stamp: ''!
basicDayAt: dayOfYearOrdinal 
	"Answer the CalendarDay with the given <dayOfYearOrdinal>.  Fail if the <dayOfYearOrdinal> is invalid."

	^days at: dayOfYearOrdinal! !

!StaticYearlyCalendar methodsFor: 'accessing' stamp: ''!
basicMonthAt: monthOrdinal dayAt: day
	"Answer the CalendarDay with the given <monthOrdinal> and <day>-of-month ordinal.  Fail if either the <monthOrdinal> or the the <day>-of-month ordinal are invalid."

	^(months at: monthOrdinal) basicDayAt: day! !

!StaticYearlyCalendar methodsFor: 'accessing' stamp: ''!
dayAt: dayOfYearOrdinal 
	"Answer the CalendarDay with the given <dayOfYearOrdinal>.  Answer nil if the <dayOfYearOrdinal> is invalid."

	^dayOfYearOrdinal > 0 
		ifTrue: 
			[dayOfYearOrdinal > daysPerYear
				ifFalse: [days at: dayOfYearOrdinal]]! !

!StaticYearlyCalendar methodsFor: 'queries' stamp: ''!
dayAt: dayOfYearOrdinal monthDayDo: block2
	"For the day of the receiver's year type with the given <dayOfYearOrdinal>, evaluate <block2> with the day's month ordinal and day-of-month ordinal as the first and second arguments (respectively.)"

	^(days at: dayOfYearOrdinal) monthDayDo: block2! !

!StaticYearlyCalendar methodsFor: 'enumerating' stamp: ''!
daysDo: block1
	"For each CalendarDay of the receiver's year type, evaluate <block1> with that CalendarDay as the argument."

	^days do: block1! !

!StaticYearlyCalendar methodsFor: 'queries' stamp: ''!
daysInMonthAt: monthOrdinal
	"Answer the number of days in the month of the receiver's year type with the given <monthOrdinal>."

	^(self monthAt: monthOrdinal) daysPerMonth! !

!StaticYearlyCalendar methodsFor: 'queries' stamp: ''!
daysInMonthWithKey: monthKey ifAbsent: block0
	"Answer the number of days in the month of the receiver's year type with the given <monthKey> (semantic identifier.) If there is no month with the given <monthKey> in the receiver's year, answer the result of evaluating <block0>."

	^(self monthWithKey: monthKey ifAbsent: [^block0 value]) daysPerMonth! !

!StaticYearlyCalendar methodsFor: 'queries' stamp: ''!
daysUpToMonth: month
	"Anwer the number of days from the first day of the year up to (but not including) the first day of the month (in the receiver's year type) with the given <month> ordinal. The answer should be the CARDINAL day-of-year number of the first day of the month."

	^(months at: month) daysUpToMonthSinceStartOfYear! !

!StaticYearlyCalendar methodsFor: 'queries' stamp: ''!
daysUpToMonthWithKey: monthKey ifAbsent: block0
	"Anwer the number of days from the first day of the year up to (but not including) the first day of the month (in the receiver's year type) with the given <monthKey> (semantic identifier.) The answer should be the CARDINAL day-of-year number of the first day of the month. If the receiver's year type has no month with the given <monthKey>, answer the result of evaluating <block0>."

	^(self monthWithKey: monthKey ifAbsent: [^block0 value]) daysUpToMonthSinceStartOfYear! !

!StaticYearlyCalendar methodsFor: 'accessing' stamp: ''!
firstMonth
	"Answer the MonthlyCalendar instance that specifies the properties of the first month of the receiver's year."

	^months first! !

!StaticYearlyCalendar methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	months := #().
	days := #().! !

!StaticYearlyCalendar methodsFor: 'accessing' stamp: ''!
lastMonth
	"Answer the MonthlyCalendar instance that specifies the properties of the last month of the receiver's year."

	^months last! !

!StaticYearlyCalendar methodsFor: 'accessing' stamp: ''!
monthAt: monthOrdinal
	"Answer the MonthlyCalendar for the month with the given <monthOrdinal>. Answer nil if the <monthOrdinal> is invalid."

	^monthOrdinal > 0
		ifTrue: [monthOrdinal > months size
			 		ifFalse: [months at: monthOrdinal]]! !

!StaticYearlyCalendar methodsFor: 'queries' stamp: ''!
monthOrdinalForMonthWithKey: monthKey ifAbsent: block0
	"Answer the month ordinal of the month with the given <monthKey> (semantic identifier) in the receiver's year type. If the receiver's year type has no month with the given <monthKey>, answer the result of evaluating <block0>."
 
	^(self monthWithKey: monthKey ifAbsent: [^block0 value]) monthOrdinal! !

!StaticYearlyCalendar methodsFor: 'private' stamp: ''!
monthWithKey: monthKey ifAbsent: block0
	^months detect: [:each | each monthKey == monthKey] ifNone: block0! !

!StaticYearlyCalendar methodsFor: 'private' stamp: ''!
monthlyCalendarClass
	"Answer the concrete subclass of MonthlyCalendar that should be used to instantiate MonthlyCalendars to represent the months of the receiver's year."

	^StaticMonthlyCalendar! !

!StaticYearlyCalendar methodsFor: 'enumerating' stamp: ''!
monthsDo: block1
	"For each month in the receiver's year type, evaluate <block1> with the MonthlyCalendar of said month as the argument."

	^months do: block1! !

!StaticYearlyCalendar methodsFor: 'accessing' stamp: ''!
monthsPerYear
	"Answer the number of months in the type of year whose properties are specified by the receiver."

	^months size! !

!StaticYearlyCalendar methodsFor: 'private' stamp: ''!
newMonthlyCalendar: aMonthlyCalendarSpecification
	^self 
		monthlyCalendarClass firstMonthInYear: self 
		specification: aMonthlyCalendarSpecification! !

!StaticYearlyCalendar methodsFor: 'private' stamp: ''!
setMonthsInYear: specificationOfMonths
	"Initialize the receiver so that its month structure is as specified by <specificationOfMonths>--which is an Array of MonthlyCalendarSpecs, such that the entry in the Array whose index is M specifies the properties of the month whose month ordinal is also M. Fail if the receiver is immutable."

	| monthSpec calendarMonth leapMonthStream daysStream leapDaySet |
	self assertMutability.
	months := Array new: specificationOfMonths size.
	monthSpec := specificationOfMonths at: 1.
	calendarMonth := self newMonthlyCalendar: monthSpec.
	months at: 1 put: calendarMonth.
	daysPerYear := calendarMonth daysPerMonth.
	2 to: months size do: [:i | 
		monthSpec := specificationOfMonths at: i.
		months at: i put: (calendarMonth := calendarMonth newForNextMonth: monthSpec).
		daysPerYear := daysPerYear + calendarMonth daysPerMonth].
	calendarMonth lastDay beImmutable.
	calendarMonth beImmutable.
	leapMonthOrdinals := Array new.
	leapMonthStream := leapMonthOrdinals writeStream.
	daysStream := (Array new: daysPerYear) writeStream.
	leapDaySet := Set new.
	intercalaryMonthCount := 0.
	self monthsDo: [:month | 
		month isIntercalaryMonth 
			ifTrue: 
				[intercalaryMonthCount := intercalaryMonthCount + 1.
				month isLeapMonth 
					ifTrue: [leapMonthStream nextPut: month monthOrdinal]].
		month daysDo: [:day | 
			daysStream nextPut: day.
			day isLeapDay ifTrue: [leapDaySet add: day dayOfYearOrdinal]]].
	days := daysStream contents.
	leapMonthOrdinals := leapMonthStream contents.
	leapDayOrdinals := leapDaySet asSortedCollection asArray.! !

!YearlyCalendar class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^(Calendar referencedBy: (literalArray at: 2)) canonical
		yearlyCalendarForYearTypeCode: (literalArray at: 3) decodeAsLiteralArray! !

!YearlyCalendar class methodsFor: 'instance creation' stamp: ''!
calendar: aCalendar typeCode: yearType specificationOfMonths: specificationOfMonths
	"Create, initialize and answer an immutable instance of the receiver whose Calendar is <aCalendar>, whose year type code is <yearType>, and whose month structure is specified by <specificationOfMonths>--which is an Array of MonthlyCalendarSpecs, such that the entry in the Array whose index is M specifies the properties of the month whose month ordinal is also M."

	^self new 
		setCalendar: aCalendar;
		setTypeCode: yearType specificationOfMonths: specificationOfMonths;
		beImmutable! !

!YearlyCalendar class methodsFor: 'class initialization' stamp: ''!
invalidateCalendarBindings
	"YearlyCalendar invalidateCalendarBindings"

	self allInstancesDo: [:calendrical | calendrical invalidateCalendar].
	self subclasses do: [:class | class invalidateCalendarBindings]! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
basicDayAt: dayOfYearOrdinal 
	"Answer the CalendarDay with the given <dayOfYearOrdinal>.  Fail if the <dayOfYearOrdinal> is invalid."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
basicMonthAt: monthOrdinal dayAt: day
	"Answer the CalendarDay with the given <monthOrdinal> and <day>-of-month ordinal.  Fail if either the <monthOrdinal> or the the <day>-of-month ordinal are invalid."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'printing' stamp: ''!
basicPrintOn: stream

	self basicPrintOn: stream showMonths: true! !

!YearlyCalendar methodsFor: 'printing' stamp: ''!
basicPrintOn: stream showMonths: shouldShowMonths

	stream nextPut: ${.
	stream 
		nextPutAll: self class name;
		nextPutAll: ' typeCode=';
		print: self yearTypeCode;
		tab;
		nextPutAll: ' monthsPerYear=';
		print: self monthsPerYear;
		tab;
		nextPutAll: ' daysPerYear=';
		print: self daysPerYear;
		tab;
		nextPutAll: ' leapMonthOrdinals=';
		print: self leapMonthOrdinals;
		tab;
		nextPutAll: ' leapDayOrdinals=';
		print: self leapDayOrdinals.	
	shouldShowMonths ifTrue: [self printMonthsOn: stream indent: 1].
	stream nextPut: $}! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
calendar
	"Answer the instance of Calendar that implements the calendrical system of the calendar period whose properties are specified by the receiver."

	^calendar! !

!YearlyCalendar methodsFor: 'converting' stamp: ''!
canonical
	self invalidateCalendar.
	^calendar yearlyCalendarForYearTypeCode: self yearTypeCode! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
dayAt: dayOfYearOrdinal
	"Answer the CalendarDay with the given <dayOfYearOrdinal>.  Answer nil if the <dayOfYearOrdinal> is invalid."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
dayAt: dayOfYearOrdinal monthDayDo: block2
	"For the day of the receiver's year type with the given <dayOfYearOrdinal>, evaluate <block2> with the day's month ordinal and day-of-month ordinal as the first and second arguments (respectively.)"

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
dayOfYearOrdinalForMonth: month day: day
	"Answer the day-of-year ordinal for the day in the receiver's year type with the given <month> ordinal and <day>-of-month ordinal."

	^(self daysUpToMonth: month day: day) + 1! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
dayOfYearOrdinalForMonthWithKey: monthKey day: day
	"Answer the day-of-year ordinal for the day in the receiver's year type with the given <monthKey> (semantic identifier) and <day>-of-month ordinal."

	^(self daysUpToMonthWithKey: monthKey day: day) + 1! !

!YearlyCalendar methodsFor: 'enumerating' stamp: ''!
daysDo: block1
	"For each CalendarDay of the receiver's year type, evaluate <block1> with that CalendarDay as the argument."

	self monthsDo:[:month | month daysDo: block1]! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
daysInMonthAt: monthOrdinal
	"Answer the number of days in the month of the receiver's year type with the given <monthOrdinal>."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
daysInMonthWithKey: monthKey ifAbsent: block0
	"Answer the number of days in the month of the receiver's year type with the given <monthKey> (semantic identifier.) If there is no month with the given <monthKey> in the receiver's year, answer the result of evaluating <block0>."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
daysPerStandardYear
	^daysPerStandardYear! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
daysPerYear
	"Answer the number of days per in a year whose type is the same as the year type of the calendar period whose properties are specified by the receiver."

	^daysPerYear! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
daysUpToMonth: month
	"Anwer the number of days from the first day of the year up to (but not including) the first day of the month (in the receiver's year type) with the given <month> ordinal. The answer should be the CARDINAL day-of-year number of the first day of the month."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
daysUpToMonth: month day: day
	"Anwer the number of days from the first day of the year up to (but not including) the day (in the receiver's year type) with the given <month> ordinal and <day>-of-month ordinal. The answer should be the CARDINAL day-of-year number of the day with the given month/day designation."

	^(self daysUpToMonth: month) + day - 1! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
daysUpToMonthWithKey: monthKey day: dayOfMonth ifAbsent: block0
	"Anwer the number of days from the first day of the year up to (but not including) the day (in the receiver's year type) with given <monthKey> (semantic identifier) and <day>-of-month ordinal. The answer should be the CARDINAL day-of-year number of the day with the given month/day designation."

	^(self daysUpToMonthWithKey: monthKey ifAbsent: [^block0 value]) + dayOfMonth - 1! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
daysUpToMonthWithKey: monthKey ifAbsent: block0
	"Anwer the number of days from the first day of the year up to (but not including) the first day of the month (in the receiver's year type) with the given <monthKey> (semantic identifier.) The answer should be the CARDINAL day-of-year number of the first day of the month. If the receiver's year type has no month with the given <monthKey>, answer the result of evaluating <block0>."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'testing' stamp: ''!
hasIntercalaryMonths
	^intercalaryMonthCount > 0! !

!YearlyCalendar methodsFor: 'testing' stamp: ''!
hasLeapDayAt: dayOfYearOrdinal
	^leapDayOrdinals includes: dayOfYearOrdinal! !

!YearlyCalendar methodsFor: 'testing' stamp: ''!
hasLeapDays
	^hasNoLeapDays not! !

!YearlyCalendar methodsFor: 'testing' stamp: ''!
hasLeapMonths
	^leapMonthOrdinals size > 0! !

!YearlyCalendar methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	self assertMutability.
	typeCode := 0.
	daysPerYear := 0.
	daysPerStandardYear := 0.
	hasNoLeapDays := true.
	intercalaryMonthCount := 0.
	leapMonthOrdinals := #().
	leapDayOrdinals := #().! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
intercalaryMonthCount
	^intercalaryMonthCount! !

!YearlyCalendar methodsFor: 'initialize-release' stamp: ''!
invalidateCalendar
	calendar := calendar == nil ifFalse: [Calendar at: calendar registrationKey ifAbsent: [calendar]]! !

!YearlyCalendar methodsFor: 'testing' stamp: ''!
isStandardYear
	^hasNoLeapDays! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
leapDayCount
	"Answer the number of leap days in the type of year whose properties are specified by the receiver."

	^leapDayOrdinals size! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
leapDayOrdinals
	^leapDayOrdinals! !

!YearlyCalendar methodsFor: 'enumerating' stamp: ''!
leapDayOrdinalsDo: block1
	"For each day-of-year ordinal of a leap day in the receiver's year type, evaluate <block1> with said day-of-year ordinal as the argument."

	leapDayOrdinals do: block1! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
leapMonthCount
	"Answer the number of leap months in the type of year whose properties are specified by the receiver."

	^leapMonthOrdinals size! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
leapMonthOrdinals
	^leapMonthOrdinals! !

!YearlyCalendar methodsFor: 'enumerating' stamp: ''!
leapMonthOrdinalsDo: block1
	"For each month ordinal of a leap day in the receiver's year type, evaluate <block1> with said month ordinal as the argument."

	leapMonthOrdinals do: block1! !

!YearlyCalendar methodsFor: 'enumerating' stamp: ''!
leapMonthsDo: block1
	"For each leap month in the receiver's year type, evaluate <block1> with the MonthlyCalendar of said month as the argument."

	self leapMonthOrdinalsDo: [:index | block1 value: (self monthAt:index)]! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
monthAt: monthOrdinal
	"Answer the MonthlyCalendar for the month with the given <monthOrdinal>. Answer nil if the <monthOrdinal> is invalid."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
monthAt: monthOrdinal dayAt: day
	"Answer the CalendarDay with the given <monthOrdinal> and <day>-of-month ordinal.  Answer nil if either the <monthOrdinal> or the the <day>-of-month ordinal are invalid."

	| month |
	month := self monthAt: monthOrdinal.
	^month == nil
		ifFalse: [month dayAt: day]! !

!YearlyCalendar methodsFor: 'queries' stamp: ''!
monthOrdinalForMonthWithKey: monthKey ifAbsent: block0
	"Answer the month ordinal of the month with the given <monthKey> (semantic identifier) in the receiver's year type. If the receiver's year type has no month with the given <monthKey>, answer the result of evaluating <block0>."
 
	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'private' stamp: ''!
monthlyCalendarClass
	"Answer the concrete subclass of MonthlyCalendar that should be used to instantiate MonthlyCalendars to represent the months of the receiver's year."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'enumerating' stamp: ''!
monthsDo: block1
	"For each month in the receiver's year type, evaluate <block1> with the MonthlyCalendar of said month as the argument."

	1 to: self monthsPerYear do: [:monthOrdinal | block1 value: (self monthAt: monthOrdinal)]! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
monthsPerYear
	"Answer the number of months in the type of year whose properties are specified by the receiver."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'printing' stamp: ''!
printMonthsOn: stream indent: depth

	self monthsDo: [:month |
		stream cr.
		month printOn: stream indent: depth]! !

!YearlyCalendar methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printYearlyCalendar: self on: stream! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^YearDuration! !

!YearlyCalendar methodsFor: 'initialize-release' stamp: ''!
setCalendar: aCalendar
	"Initialize the receiver so that it's Calendar is <aCalendar>. Fail if the receiver is not mutable"

	self assertMutability.
	calendar := aCalendar! !

!YearlyCalendar methodsFor: 'private' stamp: ''!
setMonthsInYear: specificationOfMonths
	"Initialize the receiver so that its month structure is as specified by <specificationOfMonths>--which is an Array of MonthlyCalendarSpecs, such that the entry in the Array whose index is M specifies the properties of the month whose month ordinal is also M. Fail if the receiver is immutable."

	^self subclassResponsibility! !

!YearlyCalendar methodsFor: 'initialize-release' stamp: ''!
setTypeCode: aYearTypeCode specificationOfMonths: specificationOfMonths
	"Initialize the receiver so that its year type code is <yearType>, and so that its month structure is as specified by <specificationOfMonths>--which is an Array of MonthlyCalendarSpecs, such that the entry in the Array whose index is M specifies the properties of the month whose month ordinal is also M. Fail if the receiver is immutable."

	self assertMutability.
	typeCode := aYearTypeCode.
	self setMonthsInYear: specificationOfMonths.
	daysPerStandardYear := daysPerYear - self leapDayCount.
	hasNoLeapDays := daysPerYear = daysPerStandardYear.! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
yearTypeCode
	"Answer the year type code of the receiver's year type."

	^typeCode! !

!YearlyCalendar methodsFor: 'accessing' stamp: ''!
yearlyCalendar
	"Answer the YearlyCalendar instance that specifies the properties of the receiver's year type (if the receiver is itself a YearlyCalendar, answer the receiver.)"

	^self! !

!ChronosPrintable class methodsFor: 'accessing' stamp: ''!
defaultParser
	^ChronosParser iso8601! !

!ChronosPrintable class methodsFor: 'instance creation' stamp: ''!
readFrom: stream
	"Create an object based on the contents of <stream>, as interpreted by the receiver's default parser."

	"YearMonthDay readFrom: '1776-07-04' readStream"
	"TimeOfDay readFrom: 'T17:30:00.5' readStream"
	"Timepoint readFrom: '1776-07-04' readStream"

	^self readFrom: stream using: self defaultParser! !

!ChronosPrintable class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^self subclassResponsibility! !

!ChronosPrintable class methodsFor: 'instance creation' stamp: ''!
readFromString: aString
	"Create an object based on the contents of aString, as interpreted by the receiver's default parser."

	"YearMonthDay readFromString: '1776-07-04'"
	"TimeOfDay readFromString: 'T17:30:00.5'"
	"Timepoint readFromString: '1776-07-04'"

	^self readFromString: aString using: self defaultParser! !

!ChronosPrintable class methodsFor: 'instance creation' stamp: ''!
readFromString: aString using: aChronosParser
	"Create an object based on the contents of aString, as interpreted by <aChronosParser>."

	^self readFrom: aString readStream using: aChronosParser! !

!ChronosPrintable methodsFor: 'printing' stamp: ''!
% aChronosPrintPolicyOrSpec
	^self printStringUsing: aChronosPrintPolicyOrSpec! !

!ChronosPrintable methodsFor: 'converting' stamp: ''!
asString
	^self printString! !

!ChronosPrintable methodsFor: 'accessing' stamp: ''!
defaultLocale
	"Answer the default ChronosLocale for the receiver."

	^ChronosLocale default! !

!ChronosPrintable methodsFor: 'accessing' stamp: ''!
defaultPrintPolicy
	"Answer the default ChronosPrintPolicy for the receiver."

	^ChronosPrintPolicy ansiStandard! !

!ChronosPrintable methodsFor: 'printing' stamp: ''!
localePrintString
	"Answer the printString of the receiver as generated by the temporal print policy of the default ChronosLocale."
	"Timepoint now localePrintString"

	^self printStringUsing: self defaultLocale temporalPrintPolicy! !

!ChronosPrintable methodsFor: 'printing' stamp: ''!
longPrintString
	^self printStringUsing: (self defaultLocale temporalPrintPolicy 
				apply: #(#showDayOfWeekName 
						#useMonthName 
						#showTimeOfDay 
						#showTimeZoneOffset 
						#timeZoneSeparator: $  
						#timeZoneElementSeparator: nil 
						#showNamesOfDurationElements 
						#showNamesOfCalendarDurationElements))! !

!ChronosPrintable methodsFor: 'printing' stamp: ''!
printOn: stream
	self printOn: stream using: self defaultPrintPolicy! !

!ChronosPrintable methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	^self subclassResponsibility! !

!ChronosPrintable methodsFor: 'printing' stamp: ''!
printStringForLocale: aLocale
	"Answer the printString of the receiver as generated by the temporal print policy of the ChronosLocale specified by <aLocale>."
	"Timepoint now printStringForLocale: #'de_DE'"
	"Timepoint now printStringForLocale: #'fr_FR'"
	"Timepoint now printStringForLocale: #'en_UK'"
	"Timepoint now printStringForLocale: #'en_US'"
	"Timepoint now printStringForLocale: #'es_ES'"

	^self printStringUsing: (ChronosLocale referencedBy: aLocale) temporalPrintPolicy! !

!ChronosPrintable methodsFor: 'printing' stamp: ''!
printStringUsing: aChronosPrintPolicy
	"Answer the printString of the receiver as generated by <aChronosPrintPolicy>."

	| stream |
	stream := (String new: 30) writeStream.
	self printOn: stream using: aChronosPrintPolicy.
	^stream contents! !

!ChronosPrintable methodsFor: 'printing' stamp: ''!
shortPrintString
	"Timepoint now shortPrintString"

	^self printStringUsing: (self defaultLocale temporalPrintPolicy 
				apply: #(#hideDayOfWeek 
						#useMonthAbbreviation 
						#showTimeOfDay 
						#hideSubsecondFraction 
						#showTimeZoneOffset 
						#timeZoneSeparator: $  
						#timeZoneElementSeparator: nil 
						#hideNamesOfDurationElements 
						#durationDayHourSeparator: ' T ' 
						#durationElementSeparator: $: 
						#durationPadChar: $0 
						#hideNamesOfCalendarDurationElements 
						#showZeroValuedDurationElements 
						#hideZeroValuedCalendarDurationElements))! !

!ChronosPrintable methodsFor: 'converting' stamp: ''!
withDefaultPrintPolicy: defaultChronosPrintPolicyOrSpec 
	^ChronosPrintableDecorator on: self
		defaultPrintPolicy: defaultChronosPrintPolicyOrSpec! !

ChronosPrintable subclass: #ChronosPrintableDecorator
	instanceVariableNames: 'delegate defaultPolicy'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ChronosPrintableDecorator class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray
	" *** This method was defined by Chronos.ChronosObject class as a subclass responsibility.
	Replace its body with a proper implementation. *** "

	self error: 'Subclass responsibility stub not reimplemented'! !

!ChronosPrintableDecorator class methodsFor: 'instance creation' stamp: ''!
on: aChronosPrintable defaultPrintPolicy: aChronosPrintPolicyOrSpec 
	"(ChronosPrintableDecorator on: Timepoint now defaultPrintPolicy: #rfc2822) printString"
	"(Timepoint now withDefaultPrintPolicy: #(useTimeBeforeDateOrder dateAndTimeSeparator: $ hideSubsecondFraction timeZoneSeparator: $ )) printString."
	"(ChronosPrintableDecorator on: Timepoint now defaultPrintPolicy: #verbose) fractionalDaysSinceEpoch"

	^(self new)
		setDefaultPolicy: aChronosPrintPolicyOrSpec;
		setDelegate: aChronosPrintable;
		beImmutable! !

!ChronosPrintableDecorator methodsFor: 'accessing' stamp: ''!
defaultPrintPolicy
	"Answer the default ChronosPrintPolicy for the receiver."

	^defaultPolicy == nil 
		ifTrue: [super defaultPrintPolicy]
		ifFalse: [defaultPolicy]! !

!ChronosPrintableDecorator methodsFor: 'accessing' stamp: ''!
delegate
	^delegate! !

!ChronosPrintableDecorator methodsFor: 'error handling' stamp: ''!
doesNotUnderstand: aMessage 
	"Decorator pattern."
	"{| decoratedTimepoint |
	decoratedTimepoint := ChronosPrintableDecorator on: Timepoint now defaultPrintPolicy: #verbose.
	Array
		with: decoratedTimepoint printString
		with: decoratedTimepoint fractionalDaysSinceEpoch}"

	^delegate perform: aMessage selector withArguments: aMessage arguments! !

!ChronosPrintableDecorator methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	delegate printOn: stream using: aChronosPrintPolicy! !

!ChronosPrintableDecorator methodsFor: 'initialize-release' stamp: ''!
setDefaultPolicy: aChronosPrintPolicyOrSpec
	self assertMutability.
	defaultPolicy := (ChronosPrintPolicy referencedBy: aChronosPrintPolicyOrSpec)! !

!ChronosPrintableDecorator methodsFor: 'initialize-release' stamp: ''!
setDelegate: aChronosPrintable
	self assertMutability.
	delegate := aChronosPrintable.! !

ChronosPrintable subclass: #Durational
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!Durational commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

Durational

	Concept:

		Durational is an abstract class. An instance of a concrete subclass of Durational represents a duration of time. A duration of time differs from a "date" or "point-in-time" value in the same way that a "distance" value differs from a "position" value. A "position" value specifies an absolute location by specifying the distance between the location and some absolute reference point (.e.g, "93 million miles from the Sun.")  Similarly, a "point-in-time" value specifies an absolute point in time by specifying the duration since (or until) a particular point-in-time and some absolute reference time (e.g., "5765 years since the creation of the world.") A durational value specifies/designates a temporal extent ("how long,") without specifying when the temporal extent begins or ends.

		Chronos implemements two different types of durational ("temporal extent") values: "scientific" durations and "calendar" durations. Scientific durations are implemented by the concrete subclass ScientificDuration. Calendar durations are implemented by the concrete subclasses CalendarDuration and CivilDuration. The semantics of a ScientificDuration and of a CalendarDuration/CivilDuration differ as follows: A ScientificDuration conceptually represents a scalar value--a number of seconds (optionally including fractions of a second.) A CalendarDuration or CivilDuration conceptually represents a vector, where the elements of the vector represent years, months, days, hours, minutes and seconds (optionally including fractions of a second.) The days specified by a CalendarDuration or CivilDuration represent a number of calendar days, based on the civil (business) definition of a day.  The days of a ScientificDuration always represent 86400 seconds uniformly and invariantly. The days of a CalendarDuration or CivilDuration may have more or less than 86400 seconds, due to timezone offset changes and/or leap seconds.

		See ScientificDuration, CalendarDuration and CivilDuration for more information.

	Usage:

		Instances of Durational can be used as arithmetic operands with each other, and with instances of TemporalCoordinate (whose concrete subclasses include Timepoint, YearMonthDay and TimeOfDay--all of which see.) TemporalCoordinates can compute the temporal extent between any two instances, providing the result as a Durational instance. A Timeperiod specifies the temporal extent of the temporal inteveral it represents using a Durational instance. A ChronosTimezone uses a ScientificDuration to represent its offset from UTC.

		Key methods of Durational, CalendarDuration, CivilDuration and ScientificDuration have "do its" in their comments that provide usage examples.

		Many of the methods of Durational and ScientificDuration implement message signatures as specified and required by the ANSI-Smalltalk Standard.  As is true throughout the Chronos codebase, many of the others are implemented by analogy to those required by ANSI Smalltalk (i.e., in the same style and/or spirit--both in terms of naming conventions and semantics.)

		As is the case with most Chronos classes, Durational instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		Note that the instance creation messages (class messages) #days: and #seconds: (and many of the variations thereof) will correctly handle either integer or non-integer numeric arguments.

	Motivation:

		Firstly, the ANSI-Smalltalk Standard requires that durational values be supported as a type distinct from that of point-in-time values.

		Secondly, although in some contexts/situations it is both necessary and proper to represent a duration of time using a "raw" numeric value, it is usually superior to encapsulate a durational value in an object that knows the semantics and behavior of the represented temporal extent.  This avoids the possibility that raw numeric values will be misinterpreted as a number of seconds when they actually represent a number of days, hours or tenths of a microsecond.  Even better, it enables such values to collaborate with other objects with greater semantic precision, and in ways that can be made much more specific to the functional intent of the value.  It is much easier to define and understand the meaning of adding a durational value to a point-in-time value, than it would be to define or understand the meaning of adding a raw number (a number of what?).

		Thirdly, although point-in-time values represent a count of some number of years, months, days, hours, minutes and seconds (possibly including fractions of a second,) they are unsuitable for use as durational values for the following reasons:

			1. Although one can interpret point-in-time values as though they also represented a temporal extent defined by the duration of time form the epoch of their calendar up to the point-in-time they designate, doing so causes such values to have two distinct (and sometimes irreconcilable) meanings. For example, if points-in-time and durations are all considered one and the same semantically, then what is the meaning of subtracting one such value from another?  Should the result of subtracting <a> from <b> be the duration of time between the points-in-time <a> and <b>, or the point-in-time that results from subtracting the durational value of <b> from the point-in-time value of <a>?  The two cases are not at all equivalent, thanks to the non-uniform and context-dependent way that the rules of most calendrical systems count seconds into days, days into months, and days/months into years.

			2. Does a point-in-time value represent the number of seconds since its epoch, or the number of years, months, days and seconds?  In other words, is it a "scientific" duration, or a "calendar" duration? If one adds the number of seconds since the calendar epoch represented by the point-in-time <alpha> to the point-in-time <beta>, it is unlikely that the number of years, months, days and seconds by which the result <gamma> will differ from <beta> will be the same as the number of years, months, days and seconds since the epoch represented by <alpha>. Conversely, if one adds the number of years, months, days and seconds represented by the point-in-time <alpha> to the point-in-time <beta>, it is unlikely that the number of seconds by which the result <gamma> will differ from <beta> will be the same as the number of seconds since the epoch represented by <alpha>. Such contradictions and semantic undecidability are inherent to interpreting point-in-time values as simultaneously moments in time and also durations of time (temporal extents.)

			3. Points-in-time are bound to a particular calendar, and so cannot represent temporal extents independently of any particular calendrical system.

			4. Because calendrical/civil time/business semantics are not appropriate for all durational values, there must be at least one type of duration that does not count minutes, hours or days separately/independently of seconds, nor count years/months at all. But point-in-time values must do every one of those things.

		Durational defines and implements, to the extent possible, the behavior and state that is common to both ScientificDurations, CalendarDurations and CivilDurations.

	Implementation:

		Instance Variables

			NONE

	Subclassing:

		Concrete subclasses must subimplement the following instance methods:

			#addedToCalendricalCoordinate:
			#addedToDuration:
			#asCalendarSeconds
			#calendarDays
			#calendarDaysAreZero
			#calendarPeriodsAreZero
			#days
			#isZero
			#resolutionQuantum
			#setDays:
			#subsecondsAreZero
			#subtractedFromCalendricalCoordinate:
			#subtractedFromDuration:

		Concrete subclasses must subimplment the following class methods:

			#zero

!

Durational subclass: #CalendarDuration
	instanceVariableNames: 'years months days'
	classVariableNames: 'Zero'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!CalendarDuration commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CalendarDuration

	Concept:

		A CalendarDuration is a "temporal extent" or "duration of time" specified in terms of calendrical periods--years, months and days. A CalendarDuration differs both in its semantics and interface from an ANSI-Smalltalk Duration in important ways. Semantically, a CalendarDuration represents "civil," "legal," business" or "calendrical" time, as opposed to "scientific," "metric system" or "atomic" time (which is implemented by the other subclass of Durational, ScientificDuration.)  Also see CalendarDuration's subclass CivilDuration, which adds support for hours, minutes, seconds and nanoseconds.

		Conceptually and mathematically, a CalendarDuration represents a duration vector with three elements: years, months and days. The number of years, months and days represented by a CalendarDuration are each independent of each other, and (unlike seconds and nanoseconds, for example) cannot be deterministically/universally translated from one to the other.  

		Changing the number of days represented by a CalendarDuration will have no effect on its extent in months or years (and vice versa,) because each component is a separate and independent vector element.  CalendarDurations are so implemented because conversions among years, months and days are not uniform. Generally, there is no way to determine how many days make a month, nor how many months make a year, because a) Durational instances are agnostic with respect to any particular calendrical system,  b) months and years usually have more than one size in days, and c) years in some calendrical systems have more than one size in months (e.g, Hebrew, Chinese, Hindu.)

		CalendarDuration semantics defines the duration of a day based on its civil or business interpretation, by which 'one day' means whatever number of hours, minutes or seconds are required to go from a particular civil time-of-day on day 0 to the same civil time-of-day on day 1.  Due to such things as leap seconds and Daylight Saving Time (also known as "Summer Time" in most places outside North America,) such "civil" or "calendar" days may have more or less than 86400 seconds (as the second is currently defined by SI, the international metric system.)

		For more in depth conceptual discussion, see the class comment of Durational (the superclass.)

	Usage:

		Instances of CalendarDuration can be used as arithmetic operands with each other, and with instances of TemporalCoordinate (whose concrete subclasses include Timepoint, YearMonthDay and TimeOfDay--all of which see.) TemporalCoordinates can compute the temporal extent between any two instances, providing the result as a Durational instance. A Timeperiod specifies the temporal extent of the temporal inteveral it represents using a Durational instance. 

		Key methods of Durational, CalendarDuration, CivilDuration and ScientificDuration have "do its" in their comments that provide usage examples.

		Many of the methods of Durational and ScientificDuration (and some methods of CalendarDuration and CivilDuration) implement message signatures as specified and required by the ANSI-Smalltalk Standard.  As is true throughout the Chronos codebase, many of the others are implemented and/or named by analogy to those required by ANSI Smalltalk (i.e., in the same style and/or spirit--both in terms of naming conventions and semantics.)

		As is the case with most Chronos classes, instances of CalendarDuration will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		Note that the instance creation messages (class messages) #days: and #seconds: (and many of the variations thereof) will correctly handle either integer or non-integer numeric arguments. 

		CalendarDuration has instance creation methods that will instantiate instances of CivilDuration in cases where the semantics of the message require the representation of some non-zero number of hours, minutes or seconds.

	Motivation:

		The ANSI-Smalltalk standard requires that durational values be supported as a type distinct from that of point-in-time values.

		Secondly, although in some contexts/situations it is both necessary and proper to represent a duration of time using a "raw" numeric value, it is usually superior to encapsulate a durational value in an object that knows the semantics and behavior of the represented temporal extent.  This avoids the possibility that raw numeric values will be misinterpreted as a number of seconds when they actually represent a number of days, hours or tenths of a microsecond.  Even better, it enables such values to collaborate with other objects with greater semantic precision, and in ways that can be made much more specific to the functional intent of the value.  It is much easier to define and understand the meaning of adding a durational value to a point-in-time value, than it would be to define or understand the meaning of adding a raw number (a number of what?).

		Thirdly, the scientific/technical view of durations, as implemented by ScientificDuration, is not appropriate for most legal, business and religious use cases. Generally, outside of scientific/technical use, the ability to specifiy some combination of an invariant number of years, months and days--without regard to the number of seconds that may happen to elapse--is absolutely necessary. 

	Implementation:

		Conceptually, a CalendarDuration represents a temporal extent as a vector whose elements represent a number of 1) years, 2) months and 3) days. Physically, it uses a different instance variable for each element of the vector. 

		Although the number of seconds/nanoseconds specified collectively by the instance variables 'seconds' and 'nanosecondsSinceSecond' are independent of the number of years, months or days represented by an instance, when an instance is in canonical form, the absolute value of the "seconds" element of its duration vector must not be greater than the number of seconds in a UT1 (mean solar) day (86400.) Therefore, when an instance canonicalizes itself, if the absolute number of seconds in the "seconds" element of its duration vector is greater than or equal 86400, it converts the overflow into days.

		Instance Variables

			days 		<Integer>
				The number of days in the duration vector that represents the instance's temporal extent--this value is independent of the number of years, months or seconds represented by the instance.
			months		<Integer> 
				The number of months in the duration vector that represents the instance's temporal extent--this value is independent of the number of years, days or seconds represented by the instance.
			years		<Integer> 
				The number of years in the duration vector that represents the instance's temporal extent--this value is independent of the number of months, days or seconds represented by the instance.

		Class Variables

			Zero		<CalendarDuration>
				A constant CalendarDuration that represents a temporal extent of zero.  Accessed by sending the message #zero to the class. The global ZeroCalendarDuration (defined in the namespace ChronosDurationConstants) serves as an alias of 'CalendarDuration zero'.!

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
days: d hours: h minutes: m seconds: s
	"Answer an immutable durational value representing a temporal extent of <d> days, <h> hours, <m> minutes and <s> seconds."
	"Specified and required by the ANSI-Smalltalk Standard."


	^self civilDurationFactory days: d hours: h minutes: m seconds: s! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
days: d hours: h minutes: m seconds: s nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <d> days, <h> hours, <m> minutes, <s> seconds and <n> nanoseconds."

	"{Timepoint now + (ScientificDuration days: 182 hours: 24 minutes: 10 seconds: -59 nanoseconds: -1)}"
	"{Timepoint now + (CivilDuration days: 182 hours: 24 minutes: 10 seconds: -59 nanoseconds: -1)}"

	^self civilDurationFactory days: d hours: h minutes: m seconds: s nanoseconds: n! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
hours: h 
	"Answer an immutable durational value representing a temporal extent of <h> hours."

	^self civilDurationFactory hours: h! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
hours: h minutes: m seconds: s
	"Answer an immutable durational value representing a temporal extent of <h> hours, <m> minutes and <s> seconds."

	^self civilDurationFactory hours: h minutes: m seconds: s! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
hours: h minutes: m seconds: s nanoseconds: n 
	"Answer an immutable durational value representing a temporal extent of <h> hours, <m> minutes, <s> seconds and <n> nanoseconds."

	^self civilDurationFactory 
		hours: h
		minutes: m
		seconds: s
		nanoseconds: n! !

!CalendarDuration class methodsFor: 'class initialization' stamp: ''!
initializeClassVariables
	"CalendarDuration initializeClassVariables"

	Zero := self new beImmutable! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
microseconds: microseconds
	"Answer an immutable durational value representing a temporal extent of <microseconds> microseconds."

	^self civilDurationFactory microseconds: microseconds! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
milliseconds: milliseconds
	"Answer an immutable durational value representing a temporal extent of <milliseconds> milliseconds."

	^self civilDurationFactory milliseconds: milliseconds! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
minutes: m
	"Answer an immutable durational value representing a temporal extent of <m> minutes."


	^self civilDurationFactory minutes: m! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
months: m
	"Answer an immutable CalendarDuration representing a temporal extent of <m> months."

	"{Timepoint now + (CalendarDuration months: 360)}"
	"{Timepoint now - (CalendarDuration months: -360)}"

	^self years: 0 months: m! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <n> nanoseconds."

	^self civilDurationFactory nanoseconds: n! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
quarters: q
	"Answer an immutable CalendarDuration representing a temporal extent of <q> quarters."

	"{Timepoint now + (CalendarDuration quarters: 120)}"
	"{Timepoint now - (CalendarDuration quarters: -120)}"

	^self years: 0 months: q * 3! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^(ChronosParser referencedBy: aChronosParser) nextCalendarDurationFrom: stream usingFactory: self! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
seconds: s
	"Answer an immutable durational value representing a temporal extent of <s> seconds."
	"Specified and required by the ANSI-Smalltalk Standard."

	^self civilDurationFactory seconds: s! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
seconds: s nanoseconds: n 
	"Answer an immutable durational value representing a temporal extent of <s> seconds and <n> nanoseconds."

	^self civilDurationFactory seconds: s nanoseconds: n! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
years: y
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years."

	"{Timepoint now + (CalendarDuration years: 30)}"
	"{Timepoint now - (CalendarDuration years: -30)}"

	^self years: y months: 0! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
years: y months: m
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years and <m> months."

	"{Timepoint now + (CalendarDuration years: 1 months: -6)}"
	"{Timepoint now + (CalendarDuration years: -2 months: 18)}"

	^self years: y months: m days: 0! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
years: y months: m days: d
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years, <m> months and <d> days."

	"{Timepoint now + (CalendarDuration years: 1 months: -6 days: 1/2)}"
	"{Timepoint now + (CalendarDuration years: -2 months: 18 days: 1/2)}"

	^self new
		setYears: y months: m;
		setDays: d;
		beImmutable! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
years: y months: months days: d hours: h minutes: minutes seconds: s
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years, <months> months, <d> days, <h> hours <minutes> minutes and <s> seconds."

	"{Timepoint now + (CivilDuration years: 1 months: 1 days: 1 hours: 1 minutes: 1 seconds: 1)}"
	"{Timepoint now + (CivilDuration years: 1 months: -1 days: 1 hours: -1 minutes: 1 seconds: -1)}"

	^self civilDurationFactory years: y months: months days: d hours: h minutes: minutes seconds: s! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
years: y months: months days: d hours: h minutes: minutes seconds: s nanoseconds: n 
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years, <months> months, <d> days, <h> hours <minutes> minutes, <s> seconds and <n> nanoseconds."

	"{Timepoint now + (CivilDuration years: 1 months: 1 days: 1 hours: 1 minutes: 1 seconds: 1 nanoseconds: 1000000001)}"
	"{Timepoint now + (CivilDuration years: -1 months: 1 days: -1 hours: 1 minutes: -1 seconds: 1 nanoseconds: -1000000001)}"

	^self civilDurationFactory 
		years: y
		months: months
		days: d
		hours: h
		minutes: minutes
		seconds: s
		nanoseconds: n! !

!CalendarDuration class methodsFor: 'instance creation' stamp: ''!
years: y months: months days: d seconds: s nanoseconds: n
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years, <months> months, <d> days, <s> seconds and <n> nanoseconds."

	"{Timepoint now + (CivilDuration years: -1 months: 6 days: 6 seconds: 6 nanoseconds: 1000000001)}"
	"{Timepoint now + (CivilDuration years: 1 months: -6 days: 6 seconds: -6 nanoseconds: 1000000001)}"

	^self civilDurationFactory years: y months: months days: d seconds: s nanoseconds: n! !

!CalendarDuration class methodsFor: 'accessing' stamp: ''!
zero
	"Answer a CalendarDuration that represents a temporal extent of zero."

	"CalendarDuration zero"

	^Zero! !

!CalendarDuration methodsFor: 'arithmetic' stamp: ''!
* aNumber
	"{(CalendarDuration years: 1 months: 1 days:1) * 4}"

	aNumber = 1 ifTrue: [^self].
	^self copy
		setYears: years * aNumber months: months * aNumber;
		setDays: days * aNumber;
		beImmutable! !

!CalendarDuration methodsFor: 'arithmetic' stamp: ''!
+ aDurationOrTemporalCoordinate

	"{((CalendarDuration years: 1 months: -3 days: 5) + (CalendarDuration days: 7))}"
	"{(CalendarDuration days: 7) - YearMonthDay today}"

	^aDurationOrTemporalCoordinate addedToCalendarDuration: self! !

!CalendarDuration methodsFor: 'arithmetic' stamp: ''!
- aDurationOrTemporalCoordinate
	"{((CalendarDuration years: 1 months: -3 days: 5) - (CalendarDuration years: 2 months: -7 days: 7))}"
	"{(CalendarDuration days: 7) - YearMonthDay today}"

	^aDurationOrTemporalCoordinate subtractedFromCalendarDuration: self! !

!CalendarDuration methodsFor: 'arithmetic' stamp: ''!
/ aNumber
	"{(CalendarDuration years: 4 months: 8 days:16) / 4}"

	aNumber = 1 ifTrue: [^self].
	^self copy 
		setYears: years // aNumber months: months // aNumber;
		setDays: days // aNumber;
		beImmutable! !

!CalendarDuration methodsFor: 'comparing' stamp: ''!
= aMagnitude 
	"Answer whether the receiver is equal to the argument."

	self == aMagnitude ifTrue: [^true].
	^[aMagnitude isEqualToCalendarDuration: self]
		on: MessageNotUnderstood
		do: [:ex | 
			(ex receiver == aMagnitude and: [ex message selector == #isEqualToCalendarDuration:])
				ifTrue: [ex return: false]
				ifFalse: [ex pass]]! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
addDays: addedDays
	self assertMutability.
	days := days + addedDays.! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
addMonths: addedMonths
	self assertMutability.
	months := months + addedMonths.! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
addYears: addedYears
	self assertMutability.
	years := years + addedYears.! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
addYears: addedYears months: addedMonths
	self assertMutability.
	years := years + addedYears.
	months := months + addedMonths.! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
addYears: addedYears months: addedMonths days: addedDays
	self assertMutability.
	years := years + addedYears.
	months := months + addedMonths.
	days := days + addedDays.! !

!CalendarDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToCalendarDuration: aCalendarDuration 
	^aCalendarDuration 
		addingYears: years
		months: months
		days: days! !

!CalendarDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToCivilDuration: aCivilDuration 
	^aCivilDuration 
		addingYears: years
		months: months
		days: days! !

!CalendarDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToDuration: aDuration 
	^aDuration isZero 
		ifTrue: [self]
		ifFalse: 
			[(self asSubDayMutable)
				addSeconds: aDuration asSeconds nanoseconds: aDuration nanosecondsSinceSecond;
				beImmutable]! !

!CalendarDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToTemporalInterval: aTemporalInterval
	^aTemporalInterval 
		addingYears: years
		months: months
		days: days! !

!CalendarDuration methodsFor: 'converting' stamp: ''!
asCalendarDuration
	^self! !

!CalendarDuration methodsFor: 'private' stamp: ''!
asCivilSubDayMutable
	^self class civilDurationFactory new
		setYears: years months: months;
		setDays: days! !

!CalendarDuration methodsFor: 'private' stamp: ''!
asSubDayMutable
	^self class civilDurationFactory new
		setYears: years months: months;
		setDays: days! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
beAbsolute
	"Make the receiver's temporal extent be the absolute value of its current temporal extent. Fail if the receiver is immutable."

	super beAbsolute.
	years := years abs.
	months := months abs.
	days := days abs.! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
beNegated
	"Make the receiver's temporal extent be the additive inverse ('negated value') of its current temporal extent. Fail if the receiver is immutable."

	super beNegated.
	years := years negated.
	months := months negated.
	days := days negated.! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
beToYear: toYear month: toMonth day: toDay fromYear: fromYear month: fromMonth day: fromDay calendar: calendar
	"Make the receiver represent a calendrical duration vector that specifies the number of years, months and days between two points-in-time (both designated in terms of the specified <calendar>,) such that the calendrical duration vector is in 'normal form.'  The two points-in-time are the 'to-moment' and the 'from-moment.'  The 'to-moment' is specified by the parameters <toYear>, <toMonth>, and <toDay> (a day of the <toMonth>).   The 'from-moment' is specified by the parameters <fromYear>, <fromMonth> and <fromDay> (a day of the <fromMonth>). As a result of the execution of this method, the receiver must represent the temporal extent since the 'from-moment' up to the 'to-moment,' assuming that there are always 86400 seconds in a day.

	The constraints that a calendrical duration vector must satisfy in order to be in normal form are as follows:
	
		1. If the number of years of the duration vector are positive, then the number of months must be positive or zero. If the number of years of the duration vector are negative, then the number of months must be negative or zero. This constraint does not apply when the number of years are zero.
		2. If either the number of years and/or of the number of months of the duration vector are positive, then the number of days must be positive or zero. If either the number of years and/or of the number of months of the duration vector are negative, then the number of days must be negative or zero. This constraint does not apply when the number of years and months are both zero.

	NOTE: The message semantics are non-commutative."

	"{CalendarDuration new
		beToYear: 2004 month: 2 day: 29
		fromYear: 2004 month: 4 day: 1
		calendar: Gregorian}  P-1M-1D"

	"{CalendarDuration new
		beToYear: 2004 month: 4 day: 1
		fromYear: 2004 month: 2 day: 29
		calendar: Gregorian }  P1M3D"

	"{CalendarDuration new
		beToYear: 2004 month: 3 day: 15
		fromYear: 2004 month: 2 day: 16
		calendar: Gregorian}  P28D"

	"{CalendarDuration new
		beToYear: 2004 month: 4 day: 15
		fromYear: 2004 month: 2 day: 16
		calendar: Gregorian}  P1M30D"

	"{CalendarDuration new
		beToYear: 2005 month: 3 day: 15
		fromYear: 2004 month: 3 day: 16
		calendar: Gregorian}  P11M27D"

	"{CalendarDuration new
		beToYear: 2005 month: 3 day: 6
		fromYear: 1905 month: 3 day: 16
		calendar: Gregorian}  P99Y11M18D"

	"{CalendarDuration new
		beToYear: 2005 month: 1 day: 1
		fromYear: 2004 month: 11 day: 30
		calendar: Gregorian}  P1M2D"

	"{CalendarDuration new
		beToYear: 2004 month: 12 day: 1
		fromYear: 1999 month: 8 day: 20
		calendar: Gregorian}  P5Y3M11D"

	"{CalendarDuration new
		beToYear: 2004 month: 8 day: 20
		fromYear: 1999 month: 12 day: 1
		calendar: Gregorian}  P4Y8M19D"

	| yearNumberingPolicy year month monthsInYear daysInMonth |
	yearNumberingPolicy := calendar yearNumberingPolicy.
	self
		setYears: (yearNumberingPolicy ordinalFromCanonical: toYear) - (yearNumberingPolicy ordinalFromCanonical: fromYear) months: toMonth - fromMonth;
		setDays: toDay - fromDay.
	monthsInYear := nil.
	years > 0 
		ifTrue: 
			[months >= 0 
				ifFalse: 
					[years := years - 1.
					months := months + (monthsInYear := calendar monthsInYear: fromYear)].
			days >= 0 
				ifFalse: 
					[months := months - 1.
					months < 0 
						ifTrue: 
							[years := years - 1.
							monthsInYear == nil 
								ifTrue: [monthsInYear := calendar monthsInYear: fromYear].
							months := monthsInYear + months].
					year := toYear.
					month := toMonth - 1.
					month < 1 
						ifTrue: 
							[year := year - 1.
							monthsInYear == nil 
								ifTrue: [monthsInYear := calendar monthsInYear: fromYear].
							month := monthsInYear].
					daysInMonth := calendar daysInMonth: month inYear: year.
					fromDay > daysInMonth ifTrue: [daysInMonth := calendar daysInMonth: toMonth inYear: toYear].
					days := days + daysInMonth]]
		ifFalse: 
			[years < 0 
				ifTrue: 
					[months <= 0 
						ifFalse: 
							[years := years + 1.
							months := months - (monthsInYear := calendar monthsInYear: toYear)].
					days <= 0 
						ifFalse: 
							[months := months + 1.
							months > -1 
								ifTrue: 
									[years := years + 1.
									monthsInYear == nil 
										ifTrue: [monthsInYear := calendar monthsInYear: toYear].
									months := months - monthsInYear].
							year := toYear.
							month := toMonth.
							month < 1 
								ifTrue: 
									[year := year + 1.
									monthsInYear == nil 
										ifTrue: [monthsInYear := calendar monthsInYear: toYear].
									month := monthsInYear].
							days := days - (calendar daysInMonth: month inYear: year)]]
				ifFalse: 
					[months > 0 
						ifTrue: 
							[days >= 0 
								ifFalse: 
									[months := months - 1.
									year := toYear.
									month := toMonth - 1.
									month < 1 
										ifTrue: 
											[year := year - 1.
											month := calendar monthsInYear: fromYear].
									daysInMonth := calendar daysInMonth: month inYear: year.
									fromDay > daysInMonth ifTrue: [daysInMonth := calendar daysInMonth: toMonth inYear: toYear].
									days := days + daysInMonth]]
						ifFalse: 
							[months < 0 
								ifTrue: 
									[days <= 0 
										ifFalse: 
											[months := months + 1.
											days := days - (calendar daysInMonth: toMonth inYear: toYear)]]]]]! !

!CalendarDuration methodsFor: 'testing' stamp: ''!
calendarPeriodsAreZero
	"Answer whether the components of the receiver's duration vector that represent calendrical periods (years, months, days) all have the value zero."

	^days = 0 and: [months = 0 and: [years = 0]]! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	self assertMutability.
	days == nil ifTrue: [days := 0].
	months == nil ifTrue: [months := 0].
	years == nil ifTrue: [years := 0].! !

!CalendarDuration methodsFor: 'accessing' stamp: ''!
days
	"Answer the integer number of days (truncated towards zero) represented by the receiver, independent of the number of years, months or seconds it may represent."
	"Specified and required by the ANSI-Smalltalk Standard."

	^days! !

!CalendarDuration methodsFor: 'printing' stamp: ''!
defaultPrintPolicy
	^ChronosPrintPolicy iso8601! !

!CalendarDuration methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: years;
		nextPut: months;
		nextPut: days! !

!CalendarDuration methodsFor: 'comparing' stamp: ''!
hash
	^(months + years + days) hash! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	days := 0.
	months := 0.
	years := 0! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self
		setYears: (literalArray at: 2) asNumber months: (literalArray at: 3) asNumber;
		setDays: (literalArray at: 4) asNumber! !

!CalendarDuration methodsFor: 'testing' stamp: ''!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^days = 1 and: [months = 0 and: [years = 0]]! !

!CalendarDuration methodsFor: 'private-comparing' stamp: ''!
isEqualToCalendarDuration: aCalendarDuration
	^years = aCalendarDuration years and: [months = aCalendarDuration months and: [days = aCalendarDuration days]]! !

!CalendarDuration methodsFor: 'private-comparing' stamp: ''!
isEqualToCivilDuration: aCivilDuration 
	^aCivilDuration nonCalendarPeriodsAreZero 
		and: [self isEqualToCalendarDuration: aCivilDuration]! !

!CalendarDuration methodsFor: 'testing' stamp: ''!
isMonthDuration
	"Answer whether the receiver's temporal extent is one month."

	^months = 1 and: [days = 0 and: [years = 0]]! !

!CalendarDuration methodsFor: 'testing' stamp: ''!
isYearDuration
	"Answer whether the receiver's temporal extent is one year."

	^years = 1 and: [days = 0 and: [months = 0]]! !

!CalendarDuration methodsFor: 'testing' stamp: ''!
isZero
	"Answer the whether the receiver represents a zero-length temporal extent."

	^self nonCalendarPeriodsAreZero and: [self calendarPeriodsAreZero]! !

!CalendarDuration methodsFor: 'accessing' stamp: ''!
months
	"Answer the integer number of months (truncated towards zero) represented by the receiver, independent of the number of years or seconds it may represent."

	^months! !

!CalendarDuration methodsFor: 'testing' stamp: ''!
negative
	"Answer whether the receiver represents a temporal extent whose magnitude is negative."
	"Specified and required by the ANSI-Smalltalk Standard."

	self yearsAndMonthsMustBeZeroOrNegative.
	^days negative and: [self nonCalendarPeriodsNegative]! !

!CalendarDuration methodsFor: 'testing' stamp: ''!
positive
	"Answer whether the receiver represents a temporal extent whose magnitude is positive (or zero.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	self yearsAndMonthsMustBeZeroOrPositive.
	^days positive and: [self nonCalendarPeriodsPositive]! !

!CalendarDuration methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."
	"If <aChronosPrintPolicy> == ChronosPrintPolicy default (or ChronosPrintPolicy ansiStandard or ChronosPrintPolicy iso8601,) then the receiver's printString will be formatted as required by the ISO 8601 Standard."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printCivilDuration: self on: stream! !

!CalendarDuration methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^CalendarDayDuration! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
setDays: d 
	"Set the component of the receiver's duration vector that represents its temporal extent in days to the value <d>. Fail if the receiver is not mutable."

	self assertMutability.
	days := d! !

!CalendarDuration methodsFor: 'initialize-release' stamp: ''!
setYears: y months: m
	"Set the component of the receiver's duration vector that represents its temporal extent in years to the value <y>, and set the component of the receiver's duration vector that represents its temporal extent in months to the value <m>. Fail if the receiver is not mutable."

	self assertMutability.
	months := m.
	years := y! !

!CalendarDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCalendarDuration: aCalendarDuration 
	^aCalendarDuration 
		subtractingYears: years
		months: months
		days: days! !

!CalendarDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aCivilDuration 
	^aCivilDuration 
		subtractingYears: years
		months: months
		days: days! !

!CalendarDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromDuration: aDuration 
	^aDuration isZero 
		ifTrue: [self negated]
		ifFalse: 
			[aDuration nonCalendarPeriodsAreZero 
				ifTrue: 
					[self class 
						years: years negated
						months: months negated
						days: days negated]
				ifFalse: 
					[self class 
						years: years negated
						months: months negated
						days: days negated
						seconds: aDuration asSeconds
						nanoseconds: aDuration nanosecondsSinceSecond]]! !

!CalendarDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromTemporalInterval: aTemporalInterval 
	^aTemporalInterval
		subtractingYears: years
		months: months
		days: days! !

!CalendarDuration methodsFor: 'accessing' stamp: ''!
years
	"Answer the integer number of years (truncated towards zero) represented by the receiver, independent of the number of months or seconds it may represent."

	^years! !

CalendarDuration subclass: #CivilDuration
	instanceVariableNames: 'hours minutes seconds nanosecondsSinceSecond'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!CivilDuration commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CivilDuration

	Concept:

		A CivilDuration is a "temporal extent" or "duration of time" specified in terms of both calendrical periods--years, months and days--and also in terms of hours, minutes and seconds (including fractions of a second.) A CivilDuration differs both in its semantics and interface from an ANSI-Smalltalk Duration in important ways. Semantically, a CivilDuration represents "civil," "legal," business" or "calendrical" time, as opposed to "scientific," "metric system" or "atomic" time (which is implemented by ScientificDuration.)  

		Also see CivilDuration's superclass CalendarDuration, which provides the implementation of the "years, months, days" portion of a CivilDuration's behavior.

		Conceptually and mathematically, a CivilDuration represents a duration vector with seven elements: years, months, days, hours, minutes, seconds and nanoseconds. The number of years, months and days are each independent of each other, and (unlike seconds and nanoseconds, for example) cannot be deterministically/universally translated from one to the other.  In contrast, nanoseconds and seconds are interconvertible by a factor of 1,000,000,000, seconds and minutes are interconvertible by a factor of 60, minutes and hours are interconvertible by a factor of 60, and hours and days are interconvertible by a factor of 24.  Although CivilDuration itself converts between seconds and minutes, seconds and hours and seconds and days using invariant conversion factors, other Chronos objects may use either different conversion factors, and/or may convert seconds into minutes, hours and days using occasional 'leap seconds' (and in the future, perhaps also leap minutes or leap hours.)

		CivilDuration semantics defines the duration of days, hours, minutes and seconds based on their civil, legal or business semantics, by which 'one day' means whatever number of seconds are required to go from a particular civil time-of-day on day 0 to the same civil time-of-day on day 1, 'one hour' is the temporal extent between T23:00:00 and T24:00:00 (regardless of any leap seconds or leap minutes,) 'one minute' is the temporal extent between T23:59:00 and T24:00:00 (regardless of any leap seconds,) and 'one second' is the temporal extent between T23:59:59 and T24:00:00 (also regardless of any leap seconds.)  Due to such things as leap seconds such "civil" or "calendar" time extents may have more or less than the regular number of SI (metric system) seconds (as measured by an atomic clock.) There may be more or less than 24 metric system ("scientific") hours in a day, due to Daylight Saving Time transitions (Daylight Saving Time is known as "Summer Time" in most places outside North America,)

		For more in depth conceptual discussion, see the class comments of CalendarDuration and Durational (the superclasses.)

	Usage:

		Instances of CivilDuration can be used as arithmetic operands with each other, and with instances of TemporalCoordinate (whose concrete subclasses include Timepoint, YearMonthDay and TimeOfDay--all of which see.) TemporalCoordinates can compute the temporal extent between any two instances, providing the result as a Durational instance. A Timeperiod specifies the temporal extent of the temporal inteveral it represents using a Durational instance. 

	Implementation:

		Conceptually, a CivilDuration represents a temporal extent as a vector whose elements represent a number of 1) years, 2) months, 3) days, 4) hours, 5) minutes and 6) seconds (including fractions of a second.) Physically, it uses a different instance variable for each element of the vector--except for the "seconds" element, where it uses two instance variables--one for the integer number of seconds, and one for the integer number of nanoseconds. Two instance variables are used for this purpose: 'seconds' and 'nanosecondsSinceSecond.' 

		Although the number of seconds/nanoseconds specified collectively by the instance variables 'seconds' and 'nanosecondsSinceSecond' are independent of the number of years, months, days, hours and minutes represented by an instance, when an instance is in canonical form, the absolute value of the "nanoseconds" element in its duration vector must not be greater than or equal to 1,000,000,000, and the "seconds" element of its duration vector must not be greater than or equal to the number of seconds in a mean solar minute (i.e., must be less than 60.) Similarly, the number of minutes must be less than 60 and the number of hours must be less than 24. Therefore, when an instance canonicalizes itself, if any such vector element has a value greater than is canonical (or less,) the overflow (or underflow) is propagated upward, which may result in adding to or subtracting from the number of days (or hours, or minutes, etc.)

		Instance Variables

			hours 		<Integer>
				The number of hours in the duration vector that represents the instance's temporal extent. When the instance is in canonical form, the value of <hours> must be positive or zero if the value of <days> is positive, and must be negative or zero if the value of <days> is negative--and the absolute value of <hours> must be less than the number of hours in a day (HoursPerDay = 24)
			minutes		<Integer> 
				The number of minutes in the duration vector that represents the instance's temporal extent. When the instance is in canonical form, the value of <minutes> must be positive or zero if the value of <hours> is positive, and must be negative or zero if the value of <hours> is negative--and the absolute value of <minutes> must be less than the number of minutes in an hour (MinutesPerHour = 60)
			seconds 					<Integer>
				The integer part of the "seconds" element of the instance's duration vector. When the instance is in canonical form, the value of <seconds> must be positive or zero if the value of <minutes> is positive, and must be negative or zero if the value of <minutes> is negative--and the absolute value of <seconds> must be less than the number of seconds in a minute (SecondsPerMinute = 60)
			nanosecondsSinceSecond	<Integer>
				Represents, as an integer number of nanoseconds, the fractional part of the "seconds" element of the instance's duration vector. When the instance is in canonical form, the value of <nanosecondsSinceSecond> must be positive or zero if the value of <seconds> is positive, and must be negative or zero if the value of <seconds> is negative--and the absolute value of <nanosecondsSinceSecond> must be less than the number of nanoseconds in a second (NanosecondsPerSecond = 1,000,000,000.)

		!

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
days: d hours: h minutes: m seconds: s
	"Answer an immutable durational value representing a temporal extent of <d> days, <h> hours, <m> minutes and <s> seconds."
	"Specified and required by the ANSI-Smalltalk Standard."

	"{Timepoint now + (ScientificDuration days: 182 hours: 24 minutes: 10 seconds: -59)}"
	"{Timepoint now + (CivilDuration days: 182 hours: 24 minutes: 10 seconds: -59)}"

	^self new
		setDays: d hours: h minutes: m seconds: s;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
days: d hours: h minutes: m seconds: s nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <d> days, <h> hours, <m> minutes, <s> seconds and <n> nanoseconds."

	"{Timepoint now + (ScientificDuration days: 182 hours: 24 minutes: 10 seconds: -59 nanoseconds: -1)}"
	"{Timepoint now + (CivilDuration days: 182 hours: 24 minutes: 10 seconds: -59 nanoseconds: -1)}"

	^self new
		setDays: d hours: h minutes: m seconds: s nanoseconds: n;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
hours: h
	"Answer an immutable durational value representing a temporal extent of <h> hours."

	"{(CivilDuration hours: -8) asTimezone}"

	^self new
		setHours: h;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
hours: h minutes: m seconds: s
	"Answer an immutable durational value representing a temporal extent of <h> hours, <m> minutes and <s> seconds."

	"{CivilDuration hours: 1.5 minutes: 1.5 seconds: 1.5}"

	^self new
		setHours: h minutes: m seconds: s;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
hours: h minutes: m seconds: s nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <h> hours, <m> minutes, <s> seconds and <n> nanoseconds."

	"{CivilDuration hours: 1.5 minutes: 1.5 seconds: 1.5}"

	^self new
		setHours: h minutes: m seconds: s nanoseconds: n;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
microseconds: microseconds
	"Answer an immutable durational value representing a temporal extent of <microseconds> microseconds."

	"{CivilDuration microseconds: 1.5}"
	"{(CivilDuration microseconds: (AnsiStandardCalendarClock now microsecondsSinceEpoch)) asDateAndTime}"

	^microseconds isInteger
		ifTrue: [self nanoseconds: ((microseconds * 125) bitShift: 3)]
		ifFalse: [self seconds: microseconds / MicrosecondsPerSecond]! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
milliseconds: milliseconds
	"Answer an immutable durational value representing a temporal extent of <milliseconds> milliseconds."

	"{CivilDuration milliseconds: 1.5}"
	"{(CivilDuration milliseconds: (AnsiStandardCalendarClock now millisecondsSinceEpoch)) asDateAndTime}"

	^milliseconds isInteger
		ifTrue: [self nanoseconds: ((milliseconds * 15625) bitShift: 6)]
		ifFalse: [self seconds: milliseconds / MillisecondsPerSecond]! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
minutes: m
	"Answer an immutable durational value representing a temporal extent of <m> minutes."

	"{CivilDuration minutes: 1.5}"

	^self new
		setMinutes: m;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <n> nanoseconds."

	"{CivilDuration nanoseconds: -1000000001}"
	"{CivilDuration seconds: -1 nanoseconds: 1}"
	"{(CivilDuration nanoseconds: (AnsiStandardCalendarClock now nanosecondsSinceEpoch))}"

	^self new
		setNanoseconds: n;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^(ChronosParser referencedBy: aChronosParser) nextCivilDurationFrom: stream usingFactory: self! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
seconds: s
	"Answer an immutable durational value representing a temporal extent of <s> seconds."
	"Specified and required by the ANSI-Smalltalk Standard."

	"{CivilDuration seconds: SecondsPerDay negated + 1}"
	"{(CivilDuration seconds: (AnsiStandardCalendarClock now fractionalSecondsSinceEpoch))}"

	^self new
		setSeconds: s;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
seconds: s nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <s> seconds and <n> nanoseconds."

	"{CivilDuration seconds: 1 nanoseconds: 1}"
	"{CivilDuration seconds: 1 nanoseconds: -1}"
	"{CivilDuration seconds: -1 nanoseconds: 1}"
	"{CivilDuration seconds: -1 nanoseconds: -1}"

	^self new
		setSeconds: s nanoseconds: n;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
years: y months: months days: d hours: h minutes: minutes seconds: s
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years, <months> months, <d> days, <h> hours <minutes> minutes and <s> seconds."

	"{Timepoint now + (CivilDuration years: 1 months: 1 days: 1 hours: 1 minutes: 1 seconds: 1)}"
	"{Timepoint now + (CivilDuration years: 1 months: -1 days: 1 hours: -1 minutes: 1 seconds: -1)}"

	^self new
		setYears: y months: months;
		setDays: d hours: h minutes: minutes seconds: s;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
years: y months: months days: d hours: h minutes: minutes seconds: s nanoseconds: n
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years, <months> months, <d> days, <h> hours <minutes> minutes, <s> seconds and <n> nanoseconds."

	"{Timepoint now + (CivilDuration years: 1 months: 1 days: 1 hours: 1 minutes: 1 seconds: 1 nanoseconds: 1000000001)}"
	"{Timepoint now + (CivilDuration years: -1 months: 1 days: -1 hours: 1 minutes: -1 seconds: 1 nanoseconds: -1000000001)}"

	^self new
		setYears: y months: months;
		setDays: d hours: h minutes: minutes seconds: s nanoseconds: n;
		beImmutable! !

!CivilDuration class methodsFor: 'instance creation' stamp: ''!
years: y months: months days: d seconds: s nanoseconds: n
	"Answer an immutable CalendarDuration representing a temporal extent of <y> years, <months> months, <d> days, <s> seconds and <n> nanoseconds."

	"{Timepoint now + (CivilDuration years: -1 months: 6 days: 6 seconds: 6 nanoseconds: 1000000001)}"
	"{Timepoint now + (CivilDuration years: 1 months: -6 days: 6 seconds: -6 nanoseconds: 1000000001)}"

	^self new
		setYears: y months: months;
		setDays: d seconds: s nanoseconds: n;
		beImmutable! !

!CivilDuration methodsFor: 'arithmetic' stamp: ''!
* aNumber
	"{(CivilDuration years: 1 months: 1 days:1 hours: 7 minutes: 16 seconds: 16) * 4}"

	aNumber = 1 ifTrue: [^self].
	^self copy
		setYears: years * aNumber months: months * aNumber;
		setDays: days * aNumber hours: hours * aNumber minutes: minutes * aNumber seconds: seconds * aNumber nanoseconds: nanosecondsSinceSecond * aNumber;
		beImmutable! !

!CivilDuration methodsFor: 'arithmetic' stamp: ''!
+ aDurationOrTemporalCoordinate

	"{((CivialDuration years: 1 months: -3 days: 5) + (CivialDuration days: 7 hours: 4 minutes: 0 seconds: 52))}"
	"{(CivialDuration days: 7 hours: 4 minutes: 0 seconds: 52) - YearMonthDay today}"

	^aDurationOrTemporalCoordinate addedToCivilDuration: self! !

!CivilDuration methodsFor: 'arithmetic' stamp: ''!
- aDurationOrTemporalCoordinate
	"{((CivilDuration years: 1 months: -3 days: 5) - (CivilDuration years: 2 months: -7 days: 7 hours: 4 minutes: 0 seconds: 52))}"
	"{(CivilDuration days: 7 hours: 4 minutes: 0 seconds: 52) - YearMonthDay today}"

	^aDurationOrTemporalCoordinate subtractedFromCivilDuration: self! !

!CivilDuration methodsFor: 'arithmetic' stamp: ''!
/ aNumber
	"{(CivilDuration years: 4 months: 8 days:16) / 4}"

	aNumber = 1 ifTrue: [^self].
	^self copy 
		setYears: years // aNumber months: months // aNumber;
		setFractionalSeconds: self asFractionalSeconds / aNumber;
		beImmutable! !

!CivilDuration methodsFor: 'comparing' stamp: ''!
= aMagnitude 
	"Answer whether the receiver is equal to the argument."

	self == aMagnitude ifTrue: [^true].
	^[aMagnitude isEqualToCivilDuration: self]
		on: MessageNotUnderstood
		do: [:ex | 
			(ex receiver == aMagnitude and: [ex message selector == #isEqualToCivilDuration:])
				ifTrue: [ex return: false]
				ifFalse: [ex pass]]! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours
	self assertMutability.
	hours := hours + addedHours.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes
	self assertMutability.
	minutes := minutes + addedMinutes.
	hours := hours + addedHours.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes seconds: addedSeconds
	self assertMutability.
	seconds := seconds + addedSeconds.
	minutes := minutes + addedMinutes.
	hours := hours + addedHours.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds
	self assertMutability.
	nanosecondsSinceSecond := nanosecondsSinceSecond + addedNanoseconds.
	seconds := seconds + addedSeconds.
	minutes := minutes + addedMinutes.
	hours := hours + addedHours.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
addMinutes: addedMinutes
	self assertMutability.
	minutes := minutes + addedMinutes.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
addSeconds: addedSeconds
	self assertMutability.
	seconds := seconds + addedSeconds.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
addSeconds: addedSeconds nanoseconds: addedNanoseconds
	self assertMutability.
	nanosecondsSinceSecond := nanosecondsSinceSecond + addedNanoseconds rounded.
	seconds := seconds + addedSeconds.! !

!CivilDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToCalendarDuration: aCalendarDuration 
	^self nonCalendarPeriodsAreZero 
		ifTrue: 
			[aCalendarDuration 
				addingYears: years
				months: months
				days: days]
		ifFalse: 
			[aCalendarDuration 
				addingYears: years
				months: months
				days: days
				hours: hours
				minutes: minutes
				seconds: seconds
				nanoseconds: nanosecondsSinceSecond]! !

!CivilDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToCivilDuration: aCivilDuration 
	^aCivilDuration 
		addingYears: years
		months: months
		days: days
		hours: hours
		minutes: minutes
		seconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!CivilDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToDuration: aDuration 
	^self calendarPeriodsAreZero 
		ifTrue: [aDuration addingHours: hours minutes: minutes seconds: seconds nanoseconds: nanosecondsSinceSecond]
		ifFalse: 
			[self class 
				years: years
				months: months
				days: days
				seconds: aDuration asSeconds + seconds
				nanoseconds: aDuration nanosecondsSinceSecond + nanosecondsSinceSecond]! !

!CivilDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToTemporalInterval: aTemporalInterval 
	^aTemporalInterval 
		addingYears: years
		months: months
		days: days
		hours: hours
		minutes: minutes
		seconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!CivilDuration methodsFor: 'converting' stamp: ''!
asCalendarDuration
	^self class calendarDurationFactory  
		years: years
		months: months
		days: self asDays! !

!CivilDuration methodsFor: 'converting' stamp: ''!
asCivilDuration
	^self! !

!CivilDuration methodsFor: 'private' stamp: ''!
asCivilSubDayMutable
	^self copy! !

!CivilDuration methodsFor: 'converting' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
asFractionalDays
	"Answer the number of days (including any fractional part) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	self yearsAndMonthsMustBeZero.
	^ScaledDecimal 
		numerator: self asNanoseconds 
		denominator: SecondsPerDay * NanosecondsPerSecond 
		scale: 9! !

!CivilDuration methodsFor: 'converting' stamp: ''!
asNanoseconds
	"Answer the integer number of nanoseconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.).."

	^nanosecondsSinceSecond + super asNanoseconds! !

!CivilDuration methodsFor: 'converting' stamp: ''!
asSeconds
	"Answer the integer number of seconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	^super asSeconds + self secondsSinceStartOfDay! !

!CivilDuration methodsFor: 'private' stamp: ''!
asSubDayMutable
	^self copy! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
beAbsolute
	"Make the receiver's temporal extent be the absolute value of its current temporal extent. Fail if the receiver is immutable."

	super beAbsolute.
	hours := hours abs.
	minutes := minutes abs.
	seconds := seconds abs.
	nanosecondsSinceSecond := nanosecondsSinceSecond abs.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
beNegated
	"Make the receiver's temporal extent be the additive inverse ('negated value') of its current temporal extent. Fail if the receiver is immutable."

	super beNegated.
	hours := hours negated.
	minutes := minutes negated.
	seconds := seconds negated.
	nanosecondsSinceSecond := nanosecondsSinceSecond negated.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
beToYear: toYear month: toMonth day: toDay second: toSecond nanosecond: toNanosecond fromYear: fromYear month: fromMonth day: fromDay second: fromSecond nanosecond: fromNanosecond calendar: calendar 
	"Make the receiver represent a civil duration vector that specifies the number of years, months, days and seconds (including any fractional seconds) between two points-in-time (both designated in terms of the specified <calendar>,) such that the civil duration vector is in 'normal form.'  The two points-in-time are the 'to-moment' and the 'from-moment.'  The 'to-moment' is specified by the parameters <toYear>, <toMonth>, <toDay> (a day of the <toMonth>) and <toSecond> (a second of the day) and <toNanosecond>.   The 'from-moment' is specified by the parameters <fromYear>, <fromMonth>, <fromDay> (a day of the <fromMonth>) and <fromSecond> (a second of the day) and <fromNanosecond>. As a result of the execution of this method, the receiver must represent the temporal extent since the 'from-moment' up to the 'to-moment,' assuming that there are always 86400 seconds in a day.

	The constraints that a civil duration vector must satisfy in order to be in normal form are as follows:
	
		1. If the number of years of the duration vector are positive, then the number of months must be positive or zero. If the number of years of the duration vector are negative, then the number of months must be negative or zero. This constraint does not apply when the number of years are zero.
		2. If either the number of years and/or of the number of months of the duration vector are positive, then the number of days must be positive or zero. If either the number of years and/or of the number of months of the duration vector are negative, then the number of days must be negative or zero. This constraint does not apply when the number of years and months are both zero.
		3. If any of a) the number of years, b) the number of months, or c) the number of days of the duration vector are positive, then the number of seconds/nanoseconds must be positive or zero. If any of a) the number of years, b) the number of months, or c) the number of days of the duration vector are negative, then the number of seconds/nanoseconds must be negative or zero.  This constraint does not apply when the number of years, months and days are all zero.

	NOTE: The message semantics are non-commutative."

	"{CivilDuration new
		beToYear: 2004 month: 2 day: 29 second: 0 nanosecond: 0
		fromYear: 2004 month: 4 day: 1 second: 0 nanosecond: 0
		calendar: Gregorian}  P-1M-1D"

	"{CivilDuration new
		beToYear: 2004 month: 4 day: 1  second: 0 nanosecond: 0
		fromYear: 2004 month: 2 day: 29 second: 0 nanosecond: 0
		calendar: Gregorian }  P1M3D"

	"{CivilDuration new
		beToYear: 2004 month: 3 day: 15  second: 0 nanosecond: 0
		fromYear: 2004 month: 2 day: 16 second: 0 nanosecond: 0
		calendar: Gregorian}  P28D"

	"{CivilDuration new
		beToYear: 2004 month: 4 day: 15  second: 0 nanosecond: 0
		fromYear: 2004 month: 2 day: 16 second: 0 nanosecond: 0
		calendar: Gregorian}  P1M30D"

	"{CivilDuration new
		beToYear: 2005 month: 3 day: 15  second: 0 nanosecond: 0
		fromYear: 2004 month: 3 day: 16 second: 0 nanosecond: 0
		calendar: Gregorian}  P11M27D"

	"{CivilDuration new
		beToYear: 2005 month: 3 day: 6  second: 0 nanosecond: 0
		fromYear: 1905 month: 3 day: 16 second: 0 nanosecond: 0
		calendar: Gregorian}  P99Y11M18D"

	"{CivilDuration new
		beToYear: 2005 month: 1 day: 1  second: 0 nanosecond: 0
		fromYear: 2004 month: 11 day: 30 second: 0 nanosecond: 0
		calendar: Gregorian}  P1M2D"

	"{CivilDuration new
		beToYear: 2004 month: 12 day: 1  second: 0 nanosecond: 0
		fromYear: 1999 month: 8 day: 20 second: 0 nanosecond: 0
		calendar: Gregorian}  P5Y3M11D"

	"{CivilDuration new
		beToYear: 2004 month: 8 day: 20  second: 0 nanosecond: 0
		fromYear: 1999 month: 12 day: 1 second: 0 nanosecond: 0
		calendar: Gregorian}  P4Y8M19D"

	self 
		beToYear: toYear
		month: toMonth
		day: toDay
		fromYear: fromYear
		month: fromMonth
		day: fromDay
		calendar: calendar.
	self setSeconds: toSecond - fromSecond nanoseconds: toNanosecond - fromNanosecond.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	super canonicalize.	
	nanosecondsSinceSecond == nil ifTrue: [nanosecondsSinceSecond := 0].
	seconds == nil ifTrue: [seconds := 0].
	minutes == nil ifTrue: [minutes := 0].
	hours == nil ifTrue: [hours := 0].
	days isInteger
		ifFalse: 
			[| int fractionalPart |
			int := days truncated.
			fractionalPart := days - int.
			days := int.
			hours := hours + (fractionalPart * HoursPerDay)].
	hours isInteger
		ifFalse:
			[| int fractionalPart |
			int := hours truncated.
			fractionalPart := hours - int.
			hours := int.
			minutes := minutes + (fractionalPart * MinutesPerHour)].
	minutes isInteger
		ifFalse:
			[| int fractionalPart |
			int := minutes truncated.
			fractionalPart := minutes - int.
			minutes := int.
			seconds := seconds + (fractionalPart * SecondsPerMinute)].
	seconds isInteger
		ifFalse:
			[| int fractionalPart |
			int := seconds truncated.
			fractionalPart := seconds - int.
			seconds := int.
			nanosecondsSinceSecond := nanosecondsSinceSecond + (fractionalPart * NanosecondsPerSecond) truncated].
	self canonicalizeNanosecondsSinceSecondMagnitude.
	self canonicalizeHoursSinceDayPolarity.! !

!CivilDuration methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 10:15'!
canonicalizeHoursSinceDayMagnitude
	"The receiver is about to made immutable.  Therefore, if the absolute value of hours is greater than or equal to the number of hours in an day, propagate its excess magnitude upward. Fail if the receiver is not mutable."

	self assertMutability.
	(hours abs >= HoursPerDay)
		ifTrue: 
			[days := days +  (hours quo: HoursPerDay).
			hours := hours rem: HoursPerDay].! !

!CivilDuration methodsFor: 'private' stamp: ''!
canonicalizeHoursSinceDayPolarity
	self canonicalizeHoursSinceDayPolarity: (days = 0 ifTrue: [months = 0 ifTrue: [years] ifFalse: [months]] ifFalse: [days])! !

!CivilDuration methodsFor: 'private' stamp: ''!
canonicalizeHoursSinceDayPolarity: polarity
	polarity > 0 
		ifTrue: 
			[hours < 0 
				ifTrue: 
					[days := days - 1.
					hours := hours + HoursPerDay.
					self canonicalizeMinutesSinceHourPolarity: (hours = 0 ifTrue: [polarity] ifFalse: [hours])]
				ifFalse: 
					[self canonicalizeMinutesSinceHourPolarity: 
						(hours = 0 
							ifTrue: [polarity]
							ifFalse: [hours])]]
		ifFalse: 
			[polarity < 0 
				ifTrue: 
					[hours > 0 
						ifTrue: 
							[days := days + 1.
							hours := hours - HoursPerDay.
							self canonicalizeMinutesSinceHourPolarity: (hours = 0 ifTrue: [polarity] ifFalse: [hours])]
						ifFalse: 
							[self canonicalizeMinutesSinceHourPolarity: 
								(hours = 0 
									ifTrue: [polarity]
									ifFalse: [hours])]]
				ifFalse: [self canonicalizeMinutesSinceHourPolarity: (hours = 0 ifTrue: [polarity] ifFalse: [hours])]]! !

!CivilDuration methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 10:15'!
canonicalizeMinutesSinceHourMagnitude
	"The receiver is about to made immutable.  Therefore, if the absolute value of minutes is greater than or equal to the number of minutes in an hour, propagate its excess magnitude upward. Fail if the receiver is not mutable."

	self assertMutability.
	(minutes abs >= MinutesPerHour )
		ifTrue: 
			[hours := hours + (minutes quo: MinutesPerHour).
			minutes := minutes rem: MinutesPerHour].
	self canonicalizeHoursSinceDayMagnitude! !

!CivilDuration methodsFor: 'private' stamp: ''!
canonicalizeMinutesSinceHourPolarity: polarity 
	polarity > 0 
		ifTrue: 
			[minutes < 0 
				ifTrue: 
					[hours := hours - 1.
					minutes := minutes + MinutesPerHour.
					self canonicalizeSecondsSinceMinutePolarity: minutes]
				ifFalse: 
					[self canonicalizeSecondsSinceMinutePolarity: 
						(minutes = 0 
							ifTrue: [hours = 0 ifTrue: [days] ifFalse: [hours]]
							ifFalse: [minutes])]]
		ifFalse: 
			[polarity < 0 
				ifTrue: 
					[minutes > 0 
						ifTrue: 
							[hours := hours + 1.
							minutes := minutes - MinutesPerHour.
							self canonicalizeSecondsSinceMinutePolarity: minutes]
						ifFalse: 
							[self canonicalizeSecondsSinceMinutePolarity: 
								(minutes = 0 
									ifTrue: [hours = 0 ifTrue: [days] ifFalse: [hours]]
									ifFalse: [minutes])]]
				ifFalse: [self canonicalizeSecondsSinceMinutePolarity: minutes]]! !

!CivilDuration methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 10:16'!
canonicalizeNanosecondsSinceSecondMagnitude
	"The receiver is about to made immutable.  Therefore, if the absolute value of nanosecondsSinceSecond is greater than or equal to the number of nanoseconds in a second, propagate its excess magnitude upward. Fail if the receiver is not mutable."

	self assertMutability.
	(nanosecondsSinceSecond abs >= NanosecondsPerSecond)
		ifTrue: 
			[seconds := seconds + ((nanosecondsSinceSecond bitShift: -9) quo: 1953125).
			nanosecondsSinceSecond := nanosecondsSinceSecond rem: NanosecondsPerSecond].
	self canonicalizeSecondsSinceMinuteMagnitude! !

!CivilDuration methodsFor: 'private' stamp: ''!
canonicalizeNanosecondsSinceSecondPolarity: polarity 
	polarity > 0 
		ifTrue: 
			[nanosecondsSinceSecond < 0 
				ifTrue: 
					[seconds := seconds - 1.
					nanosecondsSinceSecond := nanosecondsSinceSecond + NanosecondsPerSecond]]
		ifFalse: 
			[polarity < 0 
				ifTrue: 
					[nanosecondsSinceSecond > 0 
						ifTrue: 
							[seconds := seconds + 1.
							nanosecondsSinceSecond := nanosecondsSinceSecond - NanosecondsPerSecond]]]! !

!CivilDuration methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 10:16'!
canonicalizeSecondsSinceMinuteMagnitude
	"The receiver is about to made immutable.  Therefore, if the absolute value of seconds is greater than or equal to the number of seconds in a minute, propagate its excess magnitude upward. Fail if the receiver is not mutable."

	self assertMutability.
	(seconds abs >= SecondsPerMinute )
		ifTrue: 
			[minutes := minutes + (seconds quo: SecondsPerMinute).
			seconds := seconds rem: SecondsPerMinute].
	self canonicalizeMinutesSinceHourMagnitude! !

!CivilDuration methodsFor: 'private' stamp: ''!
canonicalizeSecondsSinceMinutePolarity: polarity 
	polarity > 0 
		ifTrue: 
			[seconds < 0 
				ifTrue: 
					[minutes := minutes - 1.
					seconds := seconds + SecondsPerMinute.
					self canonicalizeNanosecondsSinceSecondPolarity: seconds]
				ifFalse: 
					[self canonicalizeNanosecondsSinceSecondPolarity: 
						(seconds = 0 
							ifTrue: 
								[minutes = 0 
									ifTrue: [hours = 0 ifTrue: [days] ifFalse: [hours]]
									ifFalse: [minutes]]
							ifFalse: [seconds])]]
		ifFalse: 
			[polarity < 0 
				ifTrue: 
					[seconds > 0 
						ifTrue: 
							[minutes := minutes + 1.
							seconds := seconds - SecondsPerMinute.
							self canonicalizeNanosecondsSinceSecondPolarity: seconds]
						ifFalse: 
							[self canonicalizeNanosecondsSinceSecondPolarity: 
								(seconds = 0 
									ifTrue: 
										[minutes = 0 
											ifTrue: [hours = 0 ifTrue: [days] ifFalse: [hours]]
											ifFalse: [minutes]]
									ifFalse: [seconds])]]
				ifFalse: [self canonicalizeNanosecondsSinceSecondPolarity: seconds]]! !

!CivilDuration methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: hours;
		nextPut: minutes;
		nextPut: seconds;
		nextPut: nanosecondsSinceSecond! !

!CivilDuration methodsFor: 'comparing' stamp: ''!
hash
	^super hash + (hours + minutes + seconds + nanosecondsSinceSecond) hash! !

!CivilDuration methodsFor: 'accessing' stamp: ''!
hours
	"Answer the integer number of hours-since-the-day (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in hours after subtracting from its temporal extent the integer number of days (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^hours! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	hours := 0.
	minutes := 0.
	seconds := 0.
	nanosecondsSinceSecond := 0! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self 
		setHours: (literalArray at: 5) asNumber
		minutes: (literalArray at: 6) asNumber
		seconds: (literalArray at: 7) asNumber
		nanoseconds: (literalArray at: 8) asNumber! !

!CivilDuration methodsFor: 'testing' stamp: ''!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^self nonCalendarPeriodsAreZero and: [super isDayDuration]! !

!CivilDuration methodsFor: 'private-comparing' stamp: ''!
isEqualToCalendarDuration: aCalendarDuration
	^self nonCalendarPeriodsAreZero and: [super isEqualToCalendarDuration: aCalendarDuration]! !

!CivilDuration methodsFor: 'private-comparing' stamp: ''!
isEqualToCivilDuration: aCivilDuration 
	(super isEqualToCalendarDuration: aCivilDuration) ifFalse: [^false].
	^hours = aCivilDuration hours and: 
			[minutes = aCivilDuration minutes and: 
					[seconds = aCivilDuration seconds 
						and: [nanosecondsSinceSecond = aCivilDuration nanosecondsSinceSecond]]]! !

!CivilDuration methodsFor: 'testing' stamp: ''!
isHourDuration
	"Answer whether the receiver's temporal extent is one hour."

	^hours = 1 and: [self calendarPeriodsAreZero and: [minutes = 0 and: [seconds = 0 and: [self subsecondsAreZero]]]]! !

!CivilDuration methodsFor: 'testing' stamp: ''!
isMinuteDuration
	"Answer whether the receiver's temporal extent is one minute."

	^minutes = 1 and: [self calendarPeriodsAreZero and: [hours = 0 and: [seconds = 0 and: [self subsecondsAreZero]]]]! !

!CivilDuration methodsFor: 'testing' stamp: ''!
isMonthDuration
	"Answer whether the receiver's temporal extent is one month."

	^self nonCalendarPeriodsAreZero and: [super isMonthDuration]! !

!CivilDuration methodsFor: 'testing' stamp: ''!
isNanosecondDuration
	"Answer whether the receiver's temporal extent is one nanosecond."

	^nanosecondsSinceSecond = 1 and: [self calendarPeriodsAreZero]! !

!CivilDuration methodsFor: 'testing' stamp: ''!
isSecondDuration
	"Answer whether the receiver's temporal extent is one second."

	^seconds = 1 and: [self calendarPeriodsAreZero and: [hours = 0 and: [minutes = 0 and: [self subsecondsAreZero]]]]! !

!CivilDuration methodsFor: 'testing' stamp: ''!
isYearDuration
	"Answer whether the receiver's temporal extent is one year."

	^self nonCalendarPeriodsAreZero and: [super isYearDuration]! !

!CivilDuration methodsFor: 'accessing' stamp: ''!
minutes
	"Answer the integer number of minutes-since-the-hour (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in minutes after subtracting from its temporal extent integer number of hours (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^minutes! !

!CivilDuration methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond
	"Answer the integer number of nanoseconds-since-the-second (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in nanoseconds after subtracting from its temporal extent the integer number of seconds (truncated towards zero) represented by the receiver.)"

	^nanosecondsSinceSecond! !

!CivilDuration methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsAreZero
	"Answer whether the non-calendrical temporal extent (hours/minutes/seconds/nanoseconds) of the receiver is zero."

	^hours isZero and: [minutes isZero and: [seconds isZero and: [nanosecondsSinceSecond isZero]]]! !

!CivilDuration methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsPositive
	"Answer whether the non-calendrical temporal extent (hours/minutes/seconds/nanoseconds) of the receiver is positive."

	hours > 0 ifTrue: [^true].
	hours < 0 ifTrue: [^false].
	minutes > 0 ifTrue: [^true].
	minutes < 0 ifTrue: [^false].
	seconds > 0 ifTrue: [^true].
	seconds < 0 ifTrue: [^false].
	^nanosecondsSinceSecond positive! !

!CivilDuration methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^NanosecondDuration! !

!CivilDuration methodsFor: 'accessing' stamp: ''!
seconds
	"Answer the integer number of seconds-since-the-minute (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in seconds after subtracting from its temporal extent the integer number of minutes (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^seconds! !

!CivilDuration methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	"Answer the integer number of seconds-since-the-day (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in seconds after subtracting from its temporal extent the integer number of days (truncated towards zero) represented by the receiver.) Assume an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	^(hours * SecondsPerHour) + (minutes * SecondsPerMinute) + seconds! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setDays: d hours: h minutes: m seconds: s
	"Set the component of the receiver's duration vector that represents its temporal extent in days to the value <d>, and set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <h> hours, <m> minutes and <s> seconds to the value (<h> * 3600) + (<m> * 60) + <s> (and if both days and sub-days are represented by the same vector component, set the value of that component to the sum of the specified day and sub-day extents.) Fail if the receiver is not mutable."

	self assertMutability.
	days := d.
	hours := h.
	minutes := m.
	seconds := s.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setDays: d hours: h minutes: m seconds: s nanoseconds: n
	"Set the component of the receiver's duration vector that represents its temporal extent in days to the value <d>, and set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <h> hours, <m> minutes and <s> seconds to the value (<h> * 3600) + (<m> * 60) + <s>, and set the component of the receiver's duration vector that represents its temporal extent in nanoseconds to the value <n> (and if both days and sub-days are represented by the same vector component, set the value of that component to the sum of the specified day and sub-day extents.) Fail if the receiver is not mutable."

	self assertMutability.
	days := d.
	hours := h.
	minutes := m.
	seconds := s.
	nanosecondsSinceSecond := n rounded! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setDays: d seconds: s nanoseconds: n
	"Set the component of the receiver's duration vector that represents its temporal extent in days to the value <d>, set the component of the receiver's duration vector that represents its temporal extent in seconds to the value <s>, and set the component of the receiver's duration vector that represents its temporal extent in nanoseconds to the value <n>. Fail if the receiver is not mutable."

	self assertMutability.
	days := d.
	seconds := s.
	nanosecondsSinceSecond := n rounded! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setHours: h
	"Set the component of the receiver's duration vector that represents its temporal extent in hours to the value <h>. Fail if the receiver is not mutable."

	self assertMutability.
	hours := h! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setHours: h minutes: m seconds: s 
	"Set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <h> hours, <m> minutes and <s> seconds. Fail if the receiver is not mutable."

	self assertMutability.
	hours := h.
	minutes := m.
	seconds := s.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setHours: h minutes: m seconds: s nanoseconds: n
	"Set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <h> hours, <m> minutes and <s> seconds. Fail if the receiver is not mutable."

	self assertMutability.
	hours := h.
	minutes := m.
	seconds := s.
	nanosecondsSinceSecond := n rounded! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setMinutes: m
	"Set the component of the receiver's duration vector that represents its temporal extent in minutes to the value <m>. Fail if the receiver is not mutable."

	self assertMutability.
	minutes := m! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setNanoseconds: n
	"Set the component of the receiver's duration vector that represents its temporal extent in nanoseconds to the value <n>. Fail if the receiver is not mutable."

	self assertMutability.
	nanosecondsSinceSecond := n rounded! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setSeconds: s
	"Set the component of the receiver's duration vector that represents its temporal extent in seconds to the value <s>. Fail if the receiver is not mutable."

	self assertMutability.
	seconds := s.! !

!CivilDuration methodsFor: 'initialize-release' stamp: ''!
setSeconds: s nanoseconds: n
	"Set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <s> seconds and <n> nanoseconds. Fail if the receiver is not mutable."

	self assertMutability.
	seconds := s.
	nanosecondsSinceSecond := n rounded! !

!CivilDuration methodsFor: 'testing' stamp: ''!
subsecondsAreZero
	"Answer whether the sub-second temporal extent (seconds/nanoseconds) of the receiver is zero."

	^nanosecondsSinceSecond = 0! !

!CivilDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCalendarDuration: aCalendarDuration 
	^self nonCalendarPeriodsAreZero 
		ifTrue: 
			[aCalendarDuration 
				subtractingYears: years
				months: months
				days: days]
		ifFalse: 
			[aCalendarDuration 
				subtractingYears: years
				months: months
				days: days
				hours: hours
				minutes: minutes
				seconds: seconds
				nanoseconds: nanosecondsSinceSecond]! !

!CivilDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aCivilDuration 
	^aCivilDuration 
		subtractingYears: years
		months: months
		days: days
		hours: hours
		minutes: minutes
		seconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!CivilDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromDuration: aDuration 
	^self calendarPeriodsAreZero 
		ifTrue: [aDuration subtractingHours: hours minutes: minutes seconds: seconds nanoseconds: nanosecondsSinceSecond]
		ifFalse: 
			[self class 
				years: years negated
				months: months negated
				days: days negated
				seconds: aDuration asSeconds - seconds
				nanoseconds: aDuration nanosecondsSinceSecond - nanosecondsSinceSecond]! !

!CivilDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromTemporalInterval: aTemporalInterval 
	^aTemporalInterval 
		subtractingYears: years
		months: months
		days: days
		hours: hours
		minutes: minutes
		seconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

Durational subclass: #ComparableDuration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!ComparableDuration methodsFor: 'comparing' stamp: ''!
< aMagnitude 
	"Answer whether the receiver is less than the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison < 0]! !

!ComparableDuration methodsFor: 'comparing' stamp: ''!
<= aMagnitude 
	"Answer whether the receiver is less than or equal to the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	^(self > aMagnitude) not! !

!ComparableDuration methodsFor: 'comparing' stamp: ''!
> aMagnitude 
	"Answer whether the receiver is greater than the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison > 0]! !

!ComparableDuration methodsFor: 'comparing' stamp: ''!
>= aMagnitude 
	"Answer whether the receiver is greater than or equal to the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	^(self < aMagnitude) not! !

!ComparableDuration methodsFor: 'comparing' stamp: ''!
between: min and: max 
	"Answer whether the receiver is less than or equal to the argument, max,
	and greater than or equal to the argument, min."

	^self >= min and: [self <= max]! !

!ComparableDuration methodsFor: 'private-comparing' stamp: ''!
compareToInfiniteDuration: anInfiniteDuration
	^anInfiniteDuration negative
		ifTrue: [-1]
		ifFalse: [1]! !

!ComparableDuration methodsFor: 'comparing' stamp: ''!
max: aMagnitude 
	"Answer the receiver or the argument, whichever has the greater magnitude."

	self > aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!ComparableDuration methodsFor: 'comparing' stamp: ''!
min: aMagnitude 
	"Answer the receiver or the argument, whichever has the lesser magnitude."

	self < aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

ComparableDuration subclass: #InfiniteDuration
	instanceVariableNames: 'extent'
	classVariableNames: 'Backward Forward Negative Positive'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!InfiniteDuration class methodsFor: 'class initialization' stamp: ''!
initialize
	Positive := nil.
	Negative := nil! !

!InfiniteDuration class methodsFor: 'constants' stamp: ''!
negative
	Negative == nil 
		ifTrue: 
			[Negative := 
				(self basicNew)
						beNegative;
						beImmutable].
	^Negative! !

!InfiniteDuration class methodsFor: 'instance creation' stamp: ''!
new
	^self shouldNotImplement! !

!InfiniteDuration class methodsFor: 'instance creation' stamp: ''!
polarity: polarity
	^polarity
		ifTrue: [self positive]
		ifFalse: [self negative]! !

!InfiniteDuration class methodsFor: 'constants' stamp: ''!
positive
	Positive == nil 
		ifTrue: 
			[Positive := 
				(self basicNew)
						bePositive;
						beImmutable].
	^Positive! !

!InfiniteDuration class methodsFor: 'unit test' stamp: ''!
testDoIts
	"InfiniteDuration positive = InfiniteDuration positive
	InfiniteDuration positive = InfiniteDuration negative

	InfiniteDuration negative = InfiniteDuration positive
	InfiniteDuration negative = InfiniteDuration negative

	InfiniteDuration negative = Duration zero
	InfiniteDuration negative = Duration zero

	Duration zero = InfiniteDuration negative
	Duration zero = InfiniteDuration negative

	InfiniteDuration positive > InfiniteDuration positive
	InfiniteDuration positive > InfiniteDuration negative

	InfiniteDuration negative > InfiniteDuration positive
	InfiniteDuration negative > InfiniteDuration negative

	InfiniteDuration positive > Duration zero
	InfiniteDuration negative > Duration zero

	Duration zero > InfiniteDuration positive
	Duration zero > InfiniteDuration negative

	Duration zero + InfiniteDuration positive
	Duration zero + InfiniteDuration negative

	Duration zero - InfiniteDuration positive
	Duration zero - InfiniteDuration negative

	InfiniteDuration positive + Duration zero
	InfiniteDuration negative + Duration zero

	InfiniteDuration positive - Duration zero
	InfiniteDuration negative - Duration zero"! !

!InfiniteDuration class methodsFor: 'constants' stamp: ''!
zero
	self shouldNotImplement! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
* aNumber
	"Specified and required by the ANSI-Smalltalk Standard."

	^aNumber negative 
		ifTrue: [self negated]
		ifFalse: [self]! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
+ aDurationOrTemporalCoordinate
	"Specified and required by the ANSI-Smalltalk Standard."

	^aDurationOrTemporalCoordinate addedToInfiniteDuration: self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
- aDurationOrTemporalCoordinate
	"Specified and required by the ANSI-Smalltalk Standard."

	^aDurationOrTemporalCoordinate subtractedFromInfiniteDuration: self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
/ aDurationOrNumber 
	"Specified and required by the ANSI-Smalltalk Standard."

	^aDurationOrNumber negative ifTrue: [self negated] ifFalse: [self]! !

!InfiniteDuration methodsFor: 'comparing' stamp: ''!
= aMagnitude 
	"Answer whether the receiver is equal to the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	self == aMagnitude ifTrue: [^true].
	^[aMagnitude isEqualToInfiniteDuration: self]
		on: MessageNotUnderstood
		do: [:ex | 
			(ex receiver == aMagnitude and: [ex message selector == #isEqualToInfiniteDuration:])
				ifTrue: [ex return: false]
				ifFalse: [ex pass]]! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
abs
	^extent negative ifTrue: [InfiniteDuration positive] ifFalse: [self]! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addDays: addedDays
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes seconds: addedSeconds
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addMinutes: addedMinutes
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addMonths: addedMonths
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addSeconds: addedSeconds
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addSeconds: addedSeconds nanoseconds: addedNanoseconds
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addYears: addedYears
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addYears: addedYears months: addedMonths
	"Do nothing"! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
addYears: addedYears months: addedMonths days: addedDays
	"Do nothing"! !

!InfiniteDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToCalendarDuration: aCalendarDuration
	^self! !

!InfiniteDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToCivilDuration: aCivilDuration
	^self! !

!InfiniteDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToDuration: aDuration
	^self! !

!InfiniteDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToTemporalInterval: aTemporalInterval 
	^InfiniteTimepoint polarity: self positive! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingDays: addedDays
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingHours: addedHours
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingHours: addedHours minutes: addedMinutes
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingHours: addedHours minutes: addedMinutes seconds: addedSeconds
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingHours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds 
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingMinutes: addedMinutes
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingMonths: addedMonths
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingSeconds: addedSeconds 
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingSeconds: addedSeconds nanoseconds: addedNanoseconds 
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths days: addedDays
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths days: addedDays hours: addedHours minutes: addedMinutes seconds: addedSeconds
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths days: addedDays hours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths days: addedDays seconds: addedSeconds nanoseconds: addedNanoseconds
	^self! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asCalendarDuration
	^self! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asCivilDuration
	^self! !

!InfiniteDuration methodsFor: 'private' stamp: ''!
asCivilSubDayMutable
	^self shouldNotImplement! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asDays
	"Answer the integer number of days (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)"

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asFractionalDays
	"Answer the number of days (including any fractional part) represented by the receiver's temporal extent."

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asFractionalSeconds
	"Answer the number of seconds (including any fractional part) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asHours
	"Answer the integer number of hours (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asMicroseconds
	"Answer the integer number of microseconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asMilliseconds
	"Answer the integer number of milliseconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asMinutes
	"Answer the integer number of minutes (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asNanoseconds
	"Answer the integer number of nanoseconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asSeconds
	"Answer the integer number of seconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	^extent! !

!InfiniteDuration methodsFor: 'private' stamp: ''!
asSubDayMutable
	^self shouldNotImplement! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
asWeeks
	"Answer the integer number of weeks (truncated towards zero, 1 week = 7 days) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)"

	^extent! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
beNegative
	self assertMutability.
	extent := PassportInfinity negative! !

!InfiniteDuration methodsFor: 'initialize-release' stamp: ''!
bePositive
	self assertMutability.
	extent := PassportInfinity positive! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
calendarPeriodsAreZero
	^false! !

!InfiniteDuration methodsFor: 'comparing' stamp: ''!
compareTo: aDuration
	"Compare the value of the receiver to that of <aDuration>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aDuration> are the same.)"

	self == aDuration ifTrue: [^0].
	^[^aDuration compareToInfiniteDuration: self]	
		on: MessageNotUnderstood
		do: [:ex | (ex receiver == aDuration and: [#compareToInfiniteDuration: == ex message selector]) 
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!InfiniteDuration methodsFor: 'private-comparing' stamp: ''!
compareToDuration: aDuration
	^extent negative
		ifTrue: [1]
		ifFalse: [-1]! !

!InfiniteDuration methodsFor: 'private-comparing' stamp: ''!
compareToInfiniteDuration: anInfiniteDuration
	^anInfiniteDuration negative
		ifTrue: [self negative ifTrue: [0] ifFalse: [-1]]
		ifFalse: [self negative ifTrue: [1] ifFalse: [0]]! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
days
	"Answer the integer number of days (truncated towards zero) represented by the receiver, independent of the number of years, months or seconds it may represent."
	"Specified and required by the ANSI-Smalltalk Standard."

	^extent! !

!InfiniteDuration methodsFor: 'comparing' stamp: ''!
hash
	^extent hash! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
hours
	"Answer the integer number of hours-since-the-day (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in hours after subtracting from its temporal extent the integer number of days (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^extent! !

!InfiniteDuration methodsFor: 'private-comparing' stamp: ''!
isEqualToInfiniteDuration: anInfiniteDuration
	^anInfiniteDuration negative == self negative! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
isInfinite
	^true! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
isZero
	^false! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
microsecondsSinceSecond
	"Answer the integer number of microseconds-since-the-second (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in microseconds after subtracting from its temporal extent the integer number of seconds (truncated towards zero) represented by the receiver.)"

	^extent! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
millisecondsSinceSecond
	"Answer the integer number of milliseconds-since-the-second (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in milliseconds after subtracting from its temporal extent the integer number of seconds (truncated towards zero) represented by the receiver.)"

	^extent! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
minutes
	"Answer the integer number of minutes-since-the-hour (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in minutes after subtracting from its temporal extent integer number of hours (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^extent! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
months
	"Answer the integer number of months (truncated towards zero) represented by the receiver, independent of the number of years or seconds it may represent."

	^extent! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond
	"Answer the integer number of nanoseconds-since-the-second (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in nanoseconds after subtracting from its temporal extent the integer number of seconds (truncated towards zero) represented by the receiver.)"

	^extent! !

!InfiniteDuration methodsFor: 'converting' stamp: ''!
negated
	^InfiniteDuration polarity: extent negative! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
negative
	"Answer whether the receiver represents a temporal extent whose magnitude is negative."
	"Specified and required by the ANSI-Smalltalk Standard."

	^extent negative! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsAreZero
	"Answer whether the non-calendrical temporal extent (hours/minutes/seconds/nanoseconds) of the receiver is zero."

	^false! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsNegative
	"Answer whether the non-calendrical temporal extent (seconds/nanoseconds) of the receiver is negative."

	^extent negative! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsPositive
	"Answer whether the non-calendrical temporal extent (hours/minutes/seconds/nanoseconds) of the receiver is positive."

	^extent positive! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
positive
	"Answer whether the receiver represents a temporal extent whose magnitude is positive (or zero.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^extent positive! !

!InfiniteDuration methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy 
	aChronosPrintPolicy printInfiniteDuration: self on: stream! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	^extent negative ifTrue: [InfiniteDuration positive] ifFalse: [self]! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
seconds
	"Answer the integer number of seconds-since-the-minute (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in seconds after subtracting from its temporal extent the integer number of minutes (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^extent! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	"Answer the integer number of seconds-since-the-day (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in seconds after subtracting from its temporal extent the integer number of days (truncated towards zero) represented by the receiver.) Assume an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	^extent! !

!InfiniteDuration methodsFor: 'testing' stamp: ''!
subsecondsAreZero
	^false! !

!InfiniteDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCalendarDuration: aCalendarDuration
	^self negated! !

!InfiniteDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aCivilDuration
	^self negated! !

!InfiniteDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromDuration: aDuration
	^self negated! !

!InfiniteDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromTemporalInterval: aTemporalInterval 
	^InfiniteTimepoint polarity: self negative! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingDays: subtractedDays
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingHours: subtractedHours
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingHours: subtractedHours minutes: subtractedMinutes
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingHours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingHours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds nanoseconds: subtractedNanoseconds 
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingMinutes: subtractedMinutes
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingMonths: subtractedMonths
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: subtractedSeconds
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: subtractedSeconds nanoseconds: subtractedNanoseconds 
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths days: subtractedDays
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedYears> years, <addedMonths> months, <addedDays> days, <addedSeconds> seconds and <addedNanoseconds> nanoseconds less than that of the receiver's." 
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths days: subtractedDays hours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths days: subtractedDays hours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds nanoseconds: subtractedNanoseconds
	^self! !

!InfiniteDuration methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths days: subtractedDays seconds: subtractedSeconds nanoseconds: subtractedNanoseconds
	^self! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
weeks
	"Answer the integer number of weeks (truncated towards zero) represented by the receiver, solely as a function of the number of days it represents, and independent of the number of months and/or years it may represent."

	^extent! !

!InfiniteDuration methodsFor: 'accessing' stamp: ''!
years
	"Answer the integer number of years (truncated towards zero) represented by the receiver, independent of the number of months or seconds it may represent."

	^extent! !

ComparableDuration subclass: #ScientificDuration
	instanceVariableNames: 'seconds nanosecondsSinceSecond'
	classVariableNames: 'Zero'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!ScientificDuration commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ScientificDuration [Aliased by the global Duration, unless that conflicts with a native global of the host Smalltalk environment]

	Concept:

		ScientificDuration implements the protocol <Duration> (and ScientificDuration class implements the protocol <DurationFactory>) as defined and specified by the ANSI-Smalltalk Standard. As required by the Standard, the global Duration is defined as an alias for ScientficDuration (unless there is already a global by that name defined in the standard environment of the host Smalltalk system in which this copy of the Chronos Date/Time library happens to be installed.)

		A ScientificDuration (or an ANSI-Smalltalk Duration) is a "temporal extent" or "duration of time" that represents a scalar number of seconds (including fractions of a second.) It is one of the two different types of Durational (the superclass) provided by Chronos. The other type of Durational provided by Chronos is implemented by the classes CalendarDuration and CivilDuration (which see.)

		For more in depth conceptual discussion, see the class comment of Durational (the superclass.)

	Usage:

		Instances of ScientificDuration can be used as arithmetic operands with each other, and with instances of TemporalCoordinate (whose concrete subclasses include Timepoint, YearMonthDay and TimeOfDay--all of which see.) TemporalCoordinates can compute the temporal extent between any two instances, providing the result as a Durational instance. A Timeperiod specifies the temporal extent of the temporal inteveral it represents using a Durational instance. A ChronosTimezone uses a ScientificDuration to represent its offset from Universal Time.

		Key methods of Durational, CalendarDuration, CivilDuration and ScientificDuration have "do its" in their comments that provide usage examples.

		Many of the methods of Durational and ScientificDuration implement message signatures as specified and required by the ANSI-Smalltalk Standard.  As is true throughout the Chronos codebase, many of the others are implemented as an analogy to those required by ANSI Smalltalk (i.e., in the same style and/or spirit--both in terms of naming conventions and semantics.)

		As is the case with most Chronos classes, instances of ScientificDuration will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		Note that the instance creation messages (class messages) #days: and #seconds: (and many of the variations thereof) will correctly handle either integer or non-integer numeric arguments.

	Motivation:

		The ANSI-Smalltalk standard requires that durational values be supported as a type distinct from that of point-in-time values.

		Secondly, although in some contexts/situations it is both necessary and proper to represent a duration of time using a "raw" numeric value, it is usually superior to encapsulate a durational value in an object that knows the semantics and behavior of the represented temporal extent.  This avoids the possibility that raw numeric values will be misinterpreted as a number of seconds when they actually represent a number of days, hours or tenths of a microsecond.  Even better, it enables such values to collaborate with other objects with greater semantic precision, and in ways that can be made much more specific to the functional intent of the value.  It is much easier to define and understand the meaning of adding a durational value to a point-in-time value, than it would be to define or understand the meaning of adding a raw number (a number of what?).

		Thirdly, because calendrical/civil time/business semantics are not appropriate for all durational values, there must be a type of duration that does not count days separately/independently of seconds, nor count years/months at all. Scientific and technical use cases require temporal extents that have a well-defined physical meaning, and that function as scalar values in a monotonic, uniform and gauge-invariant manner.  ScientificDuration is implemented to meet such needs.

	Implementation:

		The implementation represents a temporal extent as a count of seconds and nanoseconds, converting seconds to nanoseconds and nanoseconds to seconds as necessary.  The reason for this architecture is to hopefully minimize the usage of LargeIntegers, and also because an integer number of seconds is so commonly and generally needed, that it makes sense to store the durational information as a number of integer seconds. The instance variables (and many of the methods) used for this purpose are inherited from Durational (which see.)

		Instance Variables

			seconds 					<Integer>
				The integer part of the "seconds" element of the instance's duration vector. 

			nanosecondsSinceSecond	<Integer>
				Represents, as an integer number of nanoseconds, the fractional part of the "seconds" element of the instance's duration vector. When the instance is in canonical form, the value of <nanosecondsSinceSecond> must be positive or zero if the value of <seconds> is positive, and must be negative or zero if the value of <seconds> is negative--and the absolute value of <nanosecondsSinceSecond> must be less than the number of nanoseconds in a second (NanosecondsPerSecond = 1,000,000,000.)


		Class Variables

			Zero		<ScientificDuration>
				A constant ScientificDuration that represents a temporal extent of zero.  Accessed by sending the message #zero to the class (as specified and required by the ANSI-Smalltalk Standard.)  The global ZeroDuration (defined in the namespace ChronosDurationConstants) serves as an alias of 'ScientificDuration zero'.




!

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
days: d hours: h minutes: m seconds: s
	"Answer an immutable durational value representing a temporal extent of <d> days, <h> hours, <m> minutes and <s> seconds."
	"Specified and required by the ANSI-Smalltalk Standard."

	"{Timepoint now + (ScientificDuration days: 182 hours: 24 minutes: 10 seconds: -59)}"
	"{Timepoint now + (CalendarDuration days: 182 hours: 24 minutes: 10 seconds: -59)}"

	^self new
		setDays: d hours: h minutes: m seconds: s;
		beImmutable! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
days: d hours: h minutes: m seconds: s nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <d> days, <h> hours, <m> minutes, <s> seconds and <n> nanoseconds."

	"{Timepoint now + (ScientificDuration days: 182 hours: 24 minutes: 10 seconds: -59 nanoseconds: -1)}"
	"{Timepoint now + (CivilDuration days: 182 hours: 24 minutes: 10 seconds: -59 nanoseconds: -1)}"

	^self new
		setDays: d hours: h minutes: m seconds: s nanoseconds: n;
		beImmutable! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
hours: h
	"Answer an immutable durational value representing a temporal extent of <h> hours."

	"{(ScientificDuration hours: -8) asTimezone}"

	^self new
		setHours: h;
		beImmutable! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
hours: h minutes: m seconds: s
	"Answer an immutable durational value representing a temporal extent of <h> hours, <m> minutes and <s> seconds."

	"{ScientificDuration hours: 1.5 minutes: 1.5 seconds: 1.5}"

	^self new
		setHours: h minutes: m seconds: s;
		beImmutable! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
hours: h minutes: m seconds: s nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <h> hours, <m> minutes and <s> seconds."

	"{ScientificDuration hours: 1.5 minutes: 1.5 seconds: 1.5 nanoseconds: 1}"

	^self new
		setHours: h minutes: m seconds: s nanoseconds: n;
		beImmutable! !

!ScientificDuration class methodsFor: 'class initialization' stamp: ''!
initializeClassVariables
	"ScientificDuration initializeClassVariables"

	Zero := self new beImmutable! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
microseconds: microseconds
	"Answer an immutable durational value representing a temporal extent of <microseconds> microseconds."

	"{ScientificDuration microseconds: 1.5}"
	"{(ScientificDuration microseconds: (AnsiStandardCalendarClock now microsecondsSinceEpoch)) asDateAndTime}"

	^microseconds isInteger
		ifTrue: [self nanoseconds: ((microseconds * 125) bitShift: 3)]
		ifFalse: [self seconds: microseconds / MicrosecondsPerSecond]! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
milliseconds: milliseconds
	"Answer an immutable durational value representing a temporal extent of <milliseconds> milliseconds."

	"{ScientificDuration milliseconds: 1.5}"
	"{(ScientificDuration milliseconds: (AnsiStandardCalendarClock now millisecondsSinceEpoch)) asDateAndTime}"

	^milliseconds isInteger
		ifTrue: [self nanoseconds: ((milliseconds * 15625) bitShift: 6)]
		ifFalse: [self seconds: milliseconds / MillisecondsPerSecond]! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
minutes: m
	"Answer an immutable durational value representing a temporal extent of <m> minutes."

	"{ScientificDuration minutes: 1.5}"

	^self new
		setMinutes: m;
		beImmutable! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <n> nanoseconds."

	"{ScientificDuration nanoseconds: -1000000001}"
	"{ScientificDuration seconds: -1 nanoseconds: 1}"
	"{(ScientificDuration nanoseconds: (AnsiStandardCalendarClock now nanosecondsSinceEpoch)) asDateAndTime}"

	^self new
		setNanoseconds: n;
		beImmutable! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^(ChronosParser referencedBy: aChronosParser) nextDurationFrom: stream usingFactory: self! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
seconds: s
	"Answer an immutable durational value representing a temporal extent of <s> seconds."
	"Specified and required by the ANSI-Smalltalk Standard."

	"{ScientificDuration seconds: SecondsPerDay negated + 1}"
	"{(ScientificDuration seconds: (AnsiStandardCalendarClock now fractionalSecondsSinceEpoch)) asDateAndTime}"

	^self new
		setSeconds: s;
		beImmutable! !

!ScientificDuration class methodsFor: 'instance creation' stamp: ''!
seconds: s nanoseconds: n
	"Answer an immutable durational value representing a temporal extent of <s> seconds and <n> nanoseconds."

	"{ScientificDuration seconds: 1 nanoseconds: 1}"
	"{ScientificDuration seconds: 1 nanoseconds: -1}"
	"{ScientificDuration seconds: -1 nanoseconds: 1}"
	"{ScientificDuration seconds: -1 nanoseconds: -1}"

	^self new
		setSeconds: s nanoseconds: n;
		beImmutable! !

!ScientificDuration class methodsFor: 'accessing' stamp: ''!
zero
	"Answer a ScientificDuration that represents a temporal extent of zero."
	"Specified and required by the ANSI-Smalltalk Standard."

	"ScientificDuration zero"

	^Zero! !

!ScientificDuration methodsFor: 'arithmetic' stamp: ''!
* aNumber
	"Specified and required by the ANSI-Smalltalk Standard."
	"{(ScientificDuration hours: 6) * 4}"

	aNumber = 1 ifTrue: [^self].
	^self copy 
		setSeconds: seconds * aNumber nanoseconds: nanosecondsSinceSecond * aNumber;
		beImmutable! !

!ScientificDuration methodsFor: 'arithmetic' stamp: ''!
+ aDurationOrTemporalCoordinate
	"Specified and required by the ANSI-Smalltalk Standard."
	"{((ScientificDuration days: 5) + (ScientificDuration days: 7 hours: 4 minutes: 0 seconds: 52))}"
	"{(ScientificDuration days: 7 hours: 4 minutes: 0 seconds: 52) - YearMonthDay today}"

	^aDurationOrTemporalCoordinate addedToDuration: self! !

!ScientificDuration methodsFor: 'arithmetic' stamp: ''!
- aDurationOrTemporalCoordinate
	"Specified and required by the ANSI-Smalltalk Standard."
	"{((ScientificDuration days: 5) - (ScientificDuration days: 7 hours: 4 minutes: 0 seconds: 52))}"
	"{(ScientificDuration days: 7 hours: 4 minutes: 0 seconds: 52) - YearMonthDay today}"

	^aDurationOrTemporalCoordinate subtractedFromDuration: self! !

!ScientificDuration methodsFor: 'arithmetic' stamp: ''!
/ aDurationOrNumber 
	"Specified and required by the ANSI-Smalltalk Standard."
	"{((Duration days: 4/3) addingSeconds: 0 nanoseconds: 4) / 4}"
	"{(Duration days: 4/3) / (Duration days: 2/3)}"

	^aDurationOrNumber respondsToArithmetic 
		ifTrue: 
			[aDurationOrNumber = 1 ifTrue: [^self].
			(self copy)
				setSeconds: self asFractionalSeconds / aDurationOrNumber;
				beImmutable]
		ifFalse: 
			[(self copy)
				setSeconds: self asFractionalSeconds / aDurationOrNumber asFractionalSeconds;
				beImmutable]! !

!ScientificDuration methodsFor: 'comparing' stamp: ''!
= aMagnitude 
	"Answer whether the receiver is equal to the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	self == aMagnitude ifTrue: [^true].
	^[aMagnitude isEqualToDuration: self]
		on: MessageNotUnderstood
		do: [:ex | 
			(ex receiver == aMagnitude and: [ex message selector == #isEqualToDuration:])
				ifTrue: [ex return: false]
				ifFalse: [ex pass]]! !

!ScientificDuration methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
addDays: addedDays
	addedDays isInteger 
		ifTrue: [self addSeconds: (addedDays * 675 bitShift: 7)]
		ifFalse: [self addSeconds: (addedDays * SecondsPerDay)].! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours
	self addSeconds: addedHours * SecondsPerHour! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes
	self assertMutability.
	seconds := seconds + (addedHours * SecondsPerHour) + (addedMinutes * SecondsPerMinute)! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes seconds: addedSeconds
	self assertMutability.
	seconds := seconds + addedSeconds + (addedHours * SecondsPerHour) + (addedMinutes * SecondsPerMinute)! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds
	self assertMutability.
	nanosecondsSinceSecond := nanosecondsSinceSecond + addedNanoseconds.
	seconds := seconds + addedSeconds + (addedHours * SecondsPerHour) + (addedMinutes * SecondsPerMinute)! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
addMinutes: addedMinutes
	self addSeconds: addedMinutes * SecondsPerMinute! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
addSeconds: addedSeconds
	self assertMutability.
	seconds := seconds + addedSeconds.! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
addSeconds: addedSeconds nanoseconds: addedNanoseconds
	self assertMutability.
	nanosecondsSinceSecond := nanosecondsSinceSecond + addedNanoseconds.
	seconds := seconds + addedSeconds.! !

!ScientificDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToCalendarDuration: aCalendarDuration
	^aCalendarDuration
		addingSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToCivilDuration: aCivilDuration
	^aCivilDuration
		addingSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToDuration: aDuration
	^aDuration  
		addingSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'private-arithmetic' stamp: ''!
addedToTemporalInterval: aTemporalInterval 
	^aTemporalInterval 
		addingSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asCalendarDuration
	^self class calendarDurationFactory  days: self asDays! !

!ScientificDuration methodsFor: 'private' stamp: ''!
asCalendricalMutable
	^self class civilDurationFactory new 
		setSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'private' stamp: ''!
asCivilSubDayMutable
	^self class civilDurationFactory new 
		setSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asDate
	"Answer a date-valued CalendricalCoordinate (bound to the Gregorian Calendar) that represents the same number of days since the epoch of the Gregorian calendar as is represented by the receiver's temporal extent in days.  A date-valued CalendricalCoordinate is one that specifies a date without specifying a particular time-of-day nor a particular timezone (i.e., it has nominal time semantics, and its quantum of resolution is 1 calendar day.)"

	"{(Duration days: YearMonthDay today daysSinceEpoch) asDate}"

	^DateFactory daysSinceEpoch: self asDays! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asDateAndTime
	"Answer a a DateAndTime value (bound to the current default timezone and the Gregorian Calendar) that represents the same number of seconds and nanoseconds since the epoch of the Gregorian calendar as is represented by the receiver's temporal extent.  A DateAndTime value is a CalendricalCoordinate that specifies a point-in-time, with a quantum of resolution no larger than one second, with behavior/semantics that is invariant to UT, and that conforms to the ANSI-Smalltalk <DateAndTime> protocol. See the class comment of Timepoint for further clarification."

	"{(Duration days: Timepoint now fractionalDaysSinceEpoch) asDateAndTime}"

	^self asDateAndTimeIn: ChronosTimezone default! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asDateAndTimeIn: timeZone
	"Answer a Gregorian point-in-time value (bound to the specified <timeZone>) that represents the same number of seconds and nanoseconds since the epoch of the Gregorian calendar as is represented by the receiver's temporal extent."

	"{(Duration days: (Timezone at: 'Asia/Calcutta') now fractionalDaysSinceEpoch) asDateAndTimeIn: 'Asia/Calcutta'}"

	^self class dateAndTimeFactory
		secondsSinceEpoch: seconds
		nanoseconds: nanosecondsSinceSecond
		timeZone: timeZone! !

!ScientificDuration methodsFor: 'converting' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
asDays
	"Answer the integer number of days (truncated towards zero) represented by the receiver's temporal extent."

	"{(Duration days: 365) asSeconds}"

	^seconds quo: SecondsPerDay! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asDelay
	"Answer a Delay whose delay duration is the same as the temporal extent represented by the receiver."

	"{(Duration seconds: 3) asDelay wait}"

	^ChronosSystemFacade current newDelayFromDuration: self! !

!ScientificDuration methodsFor: 'converting' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
asFractionalDays
	"Answer the number of days (including any fractional part) represented by the receiver's temporal extent."

	"{(Duration seconds: 123456789) asFractionalDays}"
	"{(DateAndTimeFactory utcNow - (DateAndTimeFactory utcDaysSinceEpoch: 0 timeZone: Timezone utc)) asFractionalDays}"

	^ScaledDecimal 
		numerator: self asNanoseconds 
		denominator: SecondsPerDay * NanosecondsPerSecond 
		scale: 9! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asFractionalSeconds
	"Answer the number of seconds (including any fractional part) represented by the receiver's temporal extent."

	"{(Duration seconds: 1 nanoseconds: 500000000) asFractionalSeconds}"

	"{DateAndTimeFactory secondsSinceEpoch: (ScientificDuration days: (DateAndTimeFactory now fractionalDaysSinceEpoch))  asFractionalSeconds}"

	"{(DateAndTimeFactory utcNow - (DateAndTimeFactory utcDaysSinceEpoch: 0 timeZone: Timezone utc)) asFractionalSeconds}"

	^ScaledDecimal 
		numerator: self asNanoseconds
		denominator: NanosecondsPerSecond
		scale: 9! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asHours
	"Answer the integer number of hours (truncated towards zero) represented by the receiver's temporal extent."

	"{(Duration days: 2/3) asHours}"

	^seconds quo: SecondsPerHour! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asMicroseconds
	"Answer the integer number of microseconds (truncated towards zero) represented by the receiver's temporal extent."

	"{(Duration toRun: [100000 timesRepeat: [Timepoint now]]) asMicroseconds}"

	^((nanosecondsSinceSecond bitShift: -3) // 125) + ((seconds bitShift: 6) * 15625)! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asMilliseconds
	"Answer the integer number of milliseconds (truncated towards zero) represented by the receiver's temporal extent."

	"{(Duration toRun: [100000 timesRepeat: [Timepoint now]]) asMilliseconds}"

	^((nanosecondsSinceSecond bitShift: -6) // 15625) + ((seconds * 125)  bitShift: 3)! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asMinutes
	"Answer the integer number of minutes (truncated towards zero) represented by the receiver's temporal extent."

	"{(Duration days: 1/6) asMinutes}"

	^seconds quo: SecondsPerMinute! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asNanoseconds
	"Answer the integer number of nanoseconds (truncated towards zero) represented by the receiver's temporal extent."

	^nanosecondsSinceSecond + (seconds * NanosecondsPerSecond)! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asNominalDateAndTime
	"Answer a nominal-time-invariant DateAndTime value (bound to the Gregorian Calendar) that represents the same number of seconds and nanoseconds since the epoch of the Gregorian calendar as is represented by the receiver's temporal extent.  A nominal-time-invariant DateAndTime value is a CalendricalCoordinate that nominally specifies a point-in-time without reference to any particular timezone, and has a quantum of resolution no larger than one second. A nominal-time-invariant DateAndTime value conforms to the ANSI-Smalltalk <DateAndTime> protocol EXCEPT that its behavior/semantics is invariant to nominal time, as opposed to being UT invariant.  See the class comment of Timepoint for further clarification."

	"{(Duration days: Timepoint now fractionalDaysSinceEpoch) asNominalDateAndTime}"

	^self asDateAndTimeIn: ChronosTimezone nominal! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asSeconds
	"Answer the integer number of seconds (truncated towards zero) represented by the receiver's temporal extent."
	"Specified and required by the ANSI-Smalltalk Standard."

	"{(Duration hours: -5) asSeconds}"

	^seconds! !

!ScientificDuration methodsFor: 'private' stamp: ''!
asSubDayMutable
	^self copy! !

!ScientificDuration methodsFor: 'converting' stamp: ''!
asTimezone
	"Answer a ChronosTimezone whose offset-from-UT has the same temporal extent as that of the receiver."

	"{(Duration hours: -8) asTimezone}"

	^ChronosTimezone offset: self! !

!ScientificDuration methodsFor: 'converting' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
asWeeks
	"Answer the integer number of weeks (truncated towards zero, 1 week = 7 days) represented by the receiver's temporal extent."

	"{(DateAndTimeFactory utcNow - (DateAndTimeFactory utcDaysSinceEpoch: 0 timeZone: Timezone utc)) asWeeks}"

	^seconds quo: (DaysPerWeek * SecondsPerDay)! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
beAbsolute
	"Make the receiver's temporal extent be the absolute value of its current temporal extent. Fail if the receiver is immutable."

	self assertMutability.
	seconds := seconds abs.
	nanosecondsSinceSecond := nanosecondsSinceSecond abs.! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
beNegated
	"Make the receiver's temporal extent be the additive inverse ('negated value') of its current temporal extent. Fail if the receiver is immutable."

	self assertMutability.
	seconds := seconds negated.
	nanosecondsSinceSecond := nanosecondsSinceSecond negated.! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
calendarPeriodsAreZero
	"Answer whether the components of the receiver's duration vector that represent calendrical periods (years, months, days) all have the value zero."

	^true! !

!ScientificDuration methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 10:36'!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	self assertMutability.
	nanosecondsSinceSecond == nil ifTrue: [nanosecondsSinceSecond := 0].
	seconds == nil 
		ifTrue: [seconds := 0]
		ifFalse:
			[seconds isInteger
				ifFalse:
					[| int fractionalPart |
					int := seconds truncated.
					fractionalPart := seconds - int.
					seconds := int.
					nanosecondsSinceSecond := nanosecondsSinceSecond + (fractionalPart * NanosecondsPerSecond) rounded]].
	(nanosecondsSinceSecond abs >= NanosecondsPerSecond)
		ifTrue: 
			[seconds := seconds + ((nanosecondsSinceSecond bitShift: -9) quo: 1953125).
			nanosecondsSinceSecond := nanosecondsSinceSecond rem: NanosecondsPerSecond].
	seconds > 0
		ifTrue: 
			[nanosecondsSinceSecond < 0
				ifTrue: 
					[seconds := seconds - 1.
					nanosecondsSinceSecond := nanosecondsSinceSecond + NanosecondsPerSecond]]
		ifFalse: 
			[seconds < 0
				ifTrue: 
					[nanosecondsSinceSecond > 0
						ifTrue: 
							[seconds := seconds + 1.
							nanosecondsSinceSecond := nanosecondsSinceSecond - NanosecondsPerSecond]]]! !

!ScientificDuration methodsFor: 'comparing' stamp: ''!
compareTo: aDuration
	"Compare the value of the receiver to that of <aDuration>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aDuration> are the same.)"

	self == aDuration ifTrue: [^0].
	^[^aDuration compareToDuration: self]	
		on: MessageNotUnderstood
		do: [:ex | (ex receiver == aDuration and: [#compareToDuration: == ex message selector]) 
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!ScientificDuration methodsFor: 'private-comparing' stamp: ''!
compareToDuration: aDuration

	| diff |
	diff := aDuration asSeconds - seconds.
	diff = 0 ifFalse: [^diff].
	^aDuration nanosecondsSinceSecond - nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
days
	"Answer the integer number of days (truncated towards zero) represented by the receiver, independent of the number of months and/or years it may represent."
	"Specified and required by the ANSI-Smalltalk Standard."

	^seconds quo: SecondsPerDay! !

!ScientificDuration methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: seconds;
		nextPut: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'comparing' stamp: ''!
hash
	^(nanosecondsSinceSecond + seconds) hash! !

!ScientificDuration methodsFor: 'accessing' stamp: ''!
hours
	"Answer the integer number of hours-since-the-day (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in hours after subtracting from its temporal extent the integer number of days (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^(seconds quo: SecondsPerHour) rem: HoursPerDay! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	seconds := 0.
	nanosecondsSinceSecond := 0.! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self setSeconds: (literalArray at: 2) asNumber nanoseconds: (literalArray at: 3) asNumber! !

!ScientificDuration methodsFor: 'testing' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^self subsecondsAreZero and: [seconds = SecondsPerDay]! !

!ScientificDuration methodsFor: 'private-comparing' stamp: ''!
isEqualToDuration: aDuration 
	^seconds = aDuration asSeconds 
		and: [nanosecondsSinceSecond = aDuration nanosecondsSinceSecond]! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
isHourDuration
	"Answer whether the receiver's temporal extent is one hour."

	^self subsecondsAreZero and: [seconds = SecondsPerHour]! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
isMinuteDuration
	"Answer whether the receiver's temporal extent is one minute."

	^self subsecondsAreZero and: [seconds = SecondsPerMinute]! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
isNanosecondDuration
	"Answer whether the receiver's temporal extent is one nanosecond."

	^nanosecondsSinceSecond = 1 and: [seconds = 0]! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
isSecondDuration
	"Answer whether the receiver's temporal extent is one second."

	^self subsecondsAreZero and: [seconds = 1]! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
isZero
	"Answer the whether the receiver represents a zero-length temporal extent."

	^self == Zero or: [self nonCalendarPeriodsAreZero]! !

!ScientificDuration methodsFor: 'accessing' stamp: ''!
minutes
	"Answer the integer number of minutes-since-the-hour (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in minutes after subtracting from its temporal extent integer number of hours (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^(seconds quo: SecondsPerMinute) rem: MinutesPerHour! !

!ScientificDuration methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond
	"Answer the integer number of nanoseconds-since-the-second (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in nanoseconds after subtracting from its temporal extent the integer number of seconds (truncated towards zero) represented by the receiver.)"

	^nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsAreZero
	"Answer whether the non-calendrical temporal extent (hours/minutes/seconds/nanoseconds) of the receiver is zero."

	^seconds isZero and: [nanosecondsSinceSecond isZero]! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsPositive
	"Answer whether the non-calendrical temporal extent (hours/minutes/seconds/nanoseconds) of the receiver is positive."

	seconds > 0 ifTrue: [^true].
	seconds < 0 ifTrue: [^false].
	^nanosecondsSinceSecond positive! !

!ScientificDuration methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."
	"If <aChronosPrintPolicy> == ChronosPrintPolicy default (or ChronosPrintPolicy ansiStandard,) then the receiver's printString will be formatted as required by the ANSI-Smalltalk Standard.
	If <aChronosPrintPolicy> == ChronosPrintPolicy  iso8601, then the receiver's printString will be formatted as required by the ISO 8601 Standard."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printDuration: self on: stream! !

!ScientificDuration methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^NanosecondDuration! !

!ScientificDuration methodsFor: 'accessing' stamp: ''!
seconds
	"Answer the integer number of seconds-since-the-minute (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in seconds after subtracting from its temporal extent the integer number of minutes (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^seconds rem: SecondsPerMinute! !

!ScientificDuration methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsSinceStartOfDay
	"Answer the integer number of seconds-since-the-day (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in seconds after subtracting from its temporal extent the integer number of days (truncated towards zero) represented by the receiver.) Assume an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	^seconds rem: SecondsPerDay! !

!ScientificDuration methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
setDays: d
	"Set the durational value of the receiver to a temporal extent of <d> days. Fail if the receiver is not mutable."

	d isInteger 
		ifTrue: [self setSeconds: (d * 675 bitShift: 7)]  
		ifFalse: [self setSeconds: d * SecondsPerDay].! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setDays: d hours: h minutes: m seconds: s
	"Set the component of the receiver's duration vector that represents its temporal extent in days to the value <d>, and set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <h> hours, <m> minutes and <s> seconds to the value (<h> * 3600) + (<m> * 60) + <s> (and if both days and sub-days are represented by the same vector component, set the value of that component to the sum of the specified day and sub-day extents.) Fail if the receiver is not mutable."

	self 
		setDays: d 
		seconds: (h * SecondsPerHour) + (m * SecondsPerMinute) + s! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setDays: d hours: h minutes: m seconds: s nanoseconds: n
	"Set the component of the receiver's duration vector that represents its temporal extent in days to the value <d>, and set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <h> hours, <m> minutes and <s> seconds to the value (<h> * 3600) + (<m> * 60) + <s>, and set the component of the receiver's duration vector that represents its temporal extent in nanoseconds to the value <n> (and if both days and sub-days are represented by the same vector component, set the value of that component to the sum of the specified day and sub-day extents.) Fail if the receiver is not mutable."

	self 
		setDays: d 
		seconds: (h * SecondsPerHour) + (m * SecondsPerMinute) + s 
		nanoseconds: n! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setDays: d seconds: s
	"Set the durational value of the receiver to a temporal extent of <d> days and <s> seconds. Fail if the receiver is not mutable."

	self setSeconds: (d * 675 bitShift: 7) + s! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setDays: d seconds: s nanoseconds: n
	"Set the durational value of the receiver to a temporal extent of <d> days, <s> seconds and <n> nanoseconds. Fail if the receiver is not mutable."

	self setSeconds: (d * 675 bitShift: 7) + s  nanoseconds: n! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setHours: h
	"Set the component of the receiver's duration vector that represents its temporal extent in hours to the value <h>. Fail if the receiver is not mutable."

	self setSeconds: h * SecondsPerHour! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setHours: h minutes: m seconds: s 
	"Set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <h> hours, <m> minutes and <s> seconds. Fail if the receiver is not mutable."

	self setSeconds: h * SecondsPerHour + (m * SecondsPerMinute) + s! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setHours: h minutes: m seconds: s nanoseconds: n
	"Set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <h> hours, <m> minutes and <s> seconds. Fail if the receiver is not mutable."

	self assertMutability.
	seconds := (h * SecondsPerHour) + (m * SecondsPerMinute) + s.
	nanosecondsSinceSecond := n! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setMinutes: m
	"Set the component of the receiver's duration vector that represents its temporal extent in minutes to the value <m>. Fail if the receiver is not mutable."

	self setSeconds: m * SecondsPerMinute! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setNanoseconds: n
	"Set the component of the receiver's duration vector that represents its temporal extent in nanoseconds to the value <n>. Fail if the receiver is not mutable."

	self assertMutability.
	nanosecondsSinceSecond := n rounded.! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setSeconds: s 
	"Set the component of the receiver's duration vector that represents its temporal extent in seconds to the value <s>. Fail if the receiver is not mutable."

	"s isInteger ifFalse: [^self setFractionalSeconds: s]."
	self assertMutability.
	seconds := s.! !

!ScientificDuration methodsFor: 'initialize-release' stamp: ''!
setSeconds: s nanoseconds: n
	"Set the component of the receiver's duration vector that represents its non-calendrical temporal extent to <s> seconds and <n> nanoseconds. Fail if the receiver is not mutable."

	self assertMutability.
	nanosecondsSinceSecond := n rounded.
	seconds := s.! !

!ScientificDuration methodsFor: 'testing' stamp: ''!
subsecondsAreZero
	"Answer whether the sub-second temporal extent (seconds/nanoseconds) of the receiver is zero."

	^nanosecondsSinceSecond = 0! !

!ScientificDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCalendarDuration: aCalendarDuration
	^aCalendarDuration
		subtractingSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aCivilDuration
	^aCivilDuration
		subtractingSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromDuration: aDuration
	^aDuration
		subtractingSeconds: seconds 
		nanoseconds: nanosecondsSinceSecond! !

!ScientificDuration methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromTemporalInterval: aTemporalInterval 
	^aTemporalInterval 
		subtractingSeconds: seconds
		nanoseconds: nanosecondsSinceSecond! !

!Durational class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!Durational class methodsFor: 'instance creation' stamp: ''!
days: d
	"Answer an immutable durational value representing a temporal extent of <d> days."

	"{ScientificDuration days: 3/4}"
	"{(ScientificDuration days: (AnsiStandardCalendarClock now fractionalDaysSinceEpoch)) asDateAndTime}"

	^self new
		setDays: d;
		beImmutable! !

!Durational class methodsFor: 'deprecated' stamp: ''!
quantum
	"Answer a Durational value that specifies the quantum of temporal resolution of instances of the receiver (i.e., the minimum amount by which the temporal extent represented by an instance may differ from that of any other.)"

	^NanosecondDuration! !

!Durational class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^(ChronosParser referencedBy: aChronosParser) nextDurationalFrom: stream! !

!Durational class methodsFor: 'utilities' stamp: ''!
toRun: timedBlock
	"Evaluate the zero-argument block <timedBlock>. Answer a Durational value that represents the duration (extent) of time required for the execution."

	^self nanoseconds: (ChronosSystemClock current nanosecondsToRun: timedBlock)

	"Date/Time Benchmarks:"

	"{Duration toRun: [1000000 timesRepeat: [Gregorian clock now]]}"
	"{Duration toRun: [1000000 timesRepeat: [Timestamp now]]}"

	"{Duration toRun: [1000000 timesRepeat: [Gregorian clock dateToday]]}"
	"{Duration toRun: [1000000 timesRepeat: [Date today]]}"

	"{Duration toRun: [1000000 timesRepeat: [Gregorian clock utTimeOfDayNow]]}"
	"{Duration toRun: [1000000 timesRepeat: [Gregorian clock timeOfDayNowToTheSecond]]}"
	"{Duration toRun: [1000000 timesRepeat: [Time now]]}"

	"1969-07-20T10:17:40 UTC is the official time of the Apollo-11 lunar landing."

	"{Duration toRun: [1000000 timesRepeat: [DateSpec year: 1969 month: 7 day: 20]]}"
	"{Duration toRun: [1000000 timesRepeat: [Date newDay: 20 monthNumber: 7 year: 1969]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateFactory year: 1969 month: 7 day: 20]]}"  

	"{Duration toRun: [1000000 timesRepeat: [DateSpec daysSinceEpoch: 718997]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateFactory daysSinceEpoch:  718997]]}" 
	"{Duration toRun: [1000000 timesRepeat: [Date fromDays: 25037]]}" 

	"{Duration toRun: [1000000 timesRepeat: [Timestamp new year: 1969; month: 7; day: 20; hour: 5; minute: 17; second: 40; millisecond: 0]]}"
	"{Duration toRun: [1000000 timesRepeat: 
		[(DateAndTimeSpec basicNew) 
			setYear: 1969 monthOrdinal: 7 dayOfMonthOrdinal: 20 calendar: Gregorian;  
			setHour: 5 minute: 17 second: 40; 
			setNanosecondsSinceSecond: 0]]}"
	"{Duration toRun: [1000000 timesRepeat: [Timestamp fromDate: (Date newDay: 20 monthNumber: 7 year: 1969) andTime: (Time fromSeconds: 19060)]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory fromNative: (Timestamp new year: 1969; month: 7; day: 20; hour: 5; minute: 17; second: 40; millisecond: 0)]]}"
	"{Duration toRun: [1000000 timesRepeat: [(DateAndTimeSpec year: 1969 month: 7 day: 20 hour: 5 minute: 17 second: 40 nanosecond: 0) asNative]]}"
	"{Duration toRun: [1000000 timesRepeat: [(DateAndTimeSpec year: 1969 month: 7 day: 20 seconds: 19060 nanoseconds: 0) asNative]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeSpec year: 1969 month: 7 day: 20 hour: 5 minute: 17 second: 40 nanosecond: 0]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeSpec year: 1969 month: 7 day: 20 seconds: 19060 nanoseconds: 0]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory nominalYear: 1969 day: 201 seconds: 19060 nanoseconds: 0]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory nominalYear: 1969 month: 7 day: 20 seconds: 19060 nanoseconds: 0]]}"
	"{| ut |	
	ut := Timezone universal.
	Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory utYear: 1969 month: 7 day: 20 seconds: 37060 nanoseconds: 0 timeZone: ut]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory utYear: 1969 month: 7 day: 20 seconds: 37060 nanoseconds: 0]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory year: 1969 month: 7 day: 20 seconds: 11860 nanoseconds: 0]]}"
	"{| tz |
	tz := ChronosTimezone at: 'America/Chicago'.
	Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory year: 1969 month: 7 day: 20  seconds: 19060 nanoseconds: 0 timeZone: tz]]}"

	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeSpec secondsSinceEpoch: 62121359860]]}" 
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory nominalSecondsSinceEpoch: 62121359860]]}"
	"{Duration toRun: [1000000 timesRepeat: [DateAndTimeFactory utSecondsSinceEpoch: 62121377860]]}"
	"{Duration toRun: [1000000 timesRepeat: [Timestamp fromSeconds: 2163215860]]}" 

	"{Duration toRun: [100000 timesRepeat: [Gregorian clock dateToday localePrintString]]}"
	"{Duration toRun: [100000 timesRepeat: [Date today printString]]}"
	"{Duration toRun: [100000 timesRepeat: [Gregorian clock timeOfDayNowToTheSecond localePrintString]]}"
	"{Duration toRun: [100000 timesRepeat: [Time  now printString]]}"
	"{Duration toRun: [100000 timesRepeat: [Gregorian clock now localePrintString]]}"
	"{Duration toRun: [100000 timesRepeat: [Timestamp now printString]]}"

	"{| date |
	date := Gregorian clock dateToday.
	Duration toRun: [1000000 timesRepeat: [date daysSinceEpoch]]}"

	"{| dateAndTime |
	dateAndTime := Gregorian clock now.
	Duration toRun: [1000000 timesRepeat: [dateAndTime secondsSinceEpoch]]}"

	"{| date |
	date := Gregorian clock dateToday.
	Duration toRun: [1000000 timesRepeat: [date year; month; day]]}"

	"{| dateAndTime |
	dateAndTime := Gregorian clock now.
	Duration toRun: [1000000 timesRepeat: [dateAndTime year; month; day]]}"! !

!Durational class methodsFor: 'instance creation' stamp: ''!
weeks: w
	"Answer an immutable durational value representing a temporal extent of <w> weeks."

	"{ScientificDuration weeks: 1.5}"
	"{CalendarDuration weeks: 1.5}"

	^self new
		setWeeks: w;
		beImmutable! !

!Durational class methodsFor: 'accessing' stamp: ''!
zero
	"Answer a Durational value that represent a temporal extent of zero."
	"Specified and required by the ANSI-Smalltalk Standard."

	^self subclassResponsibility! !

!Durational methodsFor: 'converting' stamp: ''!
abs
	"Answer a new (immutable) value of the receiver's type whose temporal extent is the absolute value of that of the receiver's." 
	"Specified and required by the ANSI-Smalltalk Standard."

	^self copy
		beAbsolute;
		beImmutable! !

!Durational methodsFor: 'private-arithmetic' stamp: ''!
addedToInfiniteDuration: anInfiniteDuration
	^anInfiniteDuration! !

!Durational methodsFor: 'private-arithmetic' stamp: ''!
addedToTimePeriod: aTimeperiod
	^aTimeperiod asTimeperiodStartingAt: aTimeperiod start + self! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingDays: addedDays
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedDays> days greater than that of the receiver's." 

	addedDays = 0 ifTrue: [^self].
	^(self copy)
		addDays: addedDays;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingHours: addedHours
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedHours> hours greater than that of the receiver's." 

	addedHours = 0 ifTrue: [^self].
	^(self asSubDayMutable)
		addHours: addedHours;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingHours: addedHours minutes: addedMinutes

	addedMinutes = 0 ifTrue: [^self addingHours: addedHours] .
	^(self asSubDayMutable)
		addHours: addedHours minutes: addedMinutes;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingHours: addedHours minutes: addedMinutes seconds: addedSeconds

	addedSeconds = 0 ifTrue: [^addedMinutes = 0 ifTrue: [self addingHours: addedHours] ifFalse: [self addingHours: addedHours minutes: addedMinutes]].
	^(self asSubDayMutable)
		addHours: addedHours minutes: addedMinutes seconds: addedSeconds;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingHours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds 

	^(self asSubDayMutable)
		addHours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingMinutes: addedMinutes
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedMinutes> minutes greater than that of the receiver's." 

	addedMinutes = 0 ifTrue: [^self].
	^(self asSubDayMutable)
		addMinutes: addedMinutes;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingMonths: addedMonths
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedMonths> months greater than that of the receiver's." 

	addedMonths = 0 ifTrue: [^self].
	^(self asCalendricalMutable)
		addMonths: addedMonths;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingSeconds: addedSeconds 
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedSeconds> seconds greater than that of the receiver's."

	addedSeconds = 0 ifTrue: [^self].
	^(self asSubDayMutable)
		addSeconds: addedSeconds;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingSeconds: addedSeconds nanoseconds: addedNanoseconds 
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedSeconds> seconds and <addedNanoseconds> nanoseconds greater than that of the receiver's." 

	addedNanoseconds = 0 ifTrue: [^self addingSeconds: addedSeconds].
	^(self asSubDayMutable)
		addSeconds: addedSeconds nanoseconds: addedNanoseconds;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedYears> years greater than that of the receiver's." 

	addedYears = 0 ifTrue: [^self].
	^(self asCalendricalMutable)
		addYears: addedYears;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedYears> years and <addedMonths> months greater than that of the receiver's." 

	addedMonths = 0 ifTrue: [^self addingYears: addedYears].
	^self asCalendricalMutable
		addYears: addedYears months: addedMonths;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths days: addedDays
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedYears> years, <addedMonths> months, <addedDays> days, <addedSeconds> seconds and <addedNanoseconds> nanoseconds greater than that of the receiver's." 

	addedDays = 0 ifTrue: [^addedMonths = 0 ifTrue: [self addingYears: addedYears] ifFalse: [self addingYears: addedYears months: addedMonths]].
	^self asCalendricalMutable
		addYears: addedYears months: addedMonths days: addedDays;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths days: addedDays hours: addedHours minutes: addedMinutes seconds: addedSeconds

	^(self asCivilSubDayMutable)
		addYears: addedYears months: addedMonths days: addedDays;
		addHours: addedHours minutes: addedMinutes seconds: addedSeconds;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths days: addedDays hours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds

	^(self asCivilSubDayMutable)
		addYears: addedYears months: addedMonths days: addedDays;
		addHours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
addingYears: addedYears months: addedMonths days: addedDays seconds: addedSeconds nanoseconds: addedNanoseconds
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedYears> years, <addedMonths> months, <addedDays> days, <addedSeconds> seconds and <addedNanoseconds> nanoseconds greater than that of the receiver's." 

	^(self asCivilSubDayMutable)
		addYears: addedYears months: addedMonths days: addedDays;
		addSeconds: addedSeconds nanoseconds: addedNanoseconds;
		beImmutable! !

!Durational methodsFor: 'converting' stamp: ''!
asCalendarDuration
	^self asCalendricalMutable beImmutable! !

!Durational methodsFor: 'private' stamp: ''!
asCalendricalMutable
	^self copy! !

!Durational methodsFor: 'converting' stamp: ''!
asCivilDuration
	^self asSubDayMutable beImmutable! !

!Durational methodsFor: 'private' stamp: ''!
asCivilSubDayMutable
	^self subclassResponsibility! !

!Durational methodsFor: 'converting' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
asDays
	"Answer the integer number of days (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)"

	self yearsAndMonthsMustBeZero.
	^self days + (self secondsSinceStartOfDay quo: SecondsPerDay)! !

!Durational methodsFor: 'converting' stamp: ''!
asFractionalDays
	"Answer the number of days (including any fractional part) represented by the receiver's temporal extent."

	^self asDays! !

!Durational methodsFor: 'converting' stamp: ''!
asFractionalSeconds
	"Answer the number of seconds (including any fractional part) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	^ScaledDecimal 
		numerator: self asNanoseconds
		denominator: NanosecondsPerSecond
		scale: 9! !

!Durational methodsFor: 'converting' stamp: ''!
asHours
	"Answer the integer number of hours (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	^self asSeconds quo: SecondsPerHour! !

!Durational methodsFor: 'converting' stamp: ''!
asMicroseconds
	"Answer the integer number of microseconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	self yearsAndMonthsMustBeZero.
	^((self nanosecondsSinceSecond bitShift: -3) // 125) + ((self asSeconds bitShift: 6) * 15625)! !

!Durational methodsFor: 'converting' stamp: ''!
asMilliseconds
	"Answer the integer number of milliseconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	self yearsAndMonthsMustBeZero.
	^((self nanosecondsSinceSecond bitShift: -6) // 15625) + ((self asSeconds * 125)  bitShift: 3)! !

!Durational methodsFor: 'converting' stamp: ''!
asMinutes
	"Answer the integer number of minutes (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	^self asSeconds quo: SecondsPerMinute! !

!Durational methodsFor: 'converting' stamp: ''!
asNanoseconds
	"Answer the integer number of nanoseconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)."

	^self asSeconds * NanosecondsPerSecond! !

!Durational methodsFor: 'converting' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
asSeconds
	"Answer the integer number of seconds (truncated towards zero) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	self yearsAndMonthsMustBeZero.
	^self days * SecondsPerDay! !

!Durational methodsFor: 'private' stamp: ''!
asSubDayMutable
	^self subclassResponsibility! !

!Durational methodsFor: 'converting' stamp: ''!
asTimeperiodStartingAt: startPoint
	"Answer a Timeperiod whose starting value is <initialMoment> (a CalendricalCoordinate) and whose duration is the receiver."

	^startPoint withDuration: self! !

!Durational methodsFor: 'converting' stamp: ''!
asTimezone
	"(CivilDuration hours: -8) asTimezone"

	self yearsAndMonthsMustBeZero.
	^ChronosTimezone offset: (DurationFactory days: self days hours: self hours minutes: self minutes seconds: self seconds nanoseconds: self nanosecondsSinceSecond)! !

!Durational methodsFor: 'converting' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
asWeeks
	"Answer the integer number of weeks (truncated towards zero, 1 week = 7 days) represented by the receiver's temporal extent, independent of the number of years and/or months it may represent, and assuming an invariant number of seconds in each time period (days, hours, minutes.)"

	^self asDays quo: (DaysPerWeek * SecondsPerDay)! !

!Durational methodsFor: 'testing' stamp: ''!
calendarPeriodsAreZero
	"Answer whether the components of the receiver's duration vector that represent calendrical periods (years, months, days) all have the value zero."

	^self subclassResponsibility! !

!Durational methodsFor: 'private-comparing' stamp: ''!
compareToInfiniteDuration: anInfiniteDuration
	^anInfiniteDuration negative
		ifTrue: [-1]
		ifFalse: [1]! !

!Durational methodsFor: 'accessing' stamp: ''!
comparisonClassIdentifier	
	"Answer a value that identifies the group of comparable values to which the receiver belongs.  It must be valid to use #== to compare two identifiers for equality."

	^#Durational! !

!Durational methodsFor: 'accessing' stamp: ''!
days
	"Answer the integer number of days (truncated towards zero) represented by the receiver, independent of the number of months and/or years it may represent."
	"Specified and required by the ANSI-Smalltalk Standard."

	^0! !

!Durational methodsFor: 'accessing' stamp: ''!
duration
	"Answer a Duration whose value represents the receiver's temporal extent."

	^self! !

!Durational methodsFor: 'accessing' stamp: ''!
hours
	"Answer the integer number of hours-since-the-day (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in hours after subtracting from its temporal extent the integer number of days (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^0! !

!Durational methodsFor: 'testing' stamp: ''!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^false! !

!Durational methodsFor: 'testing' stamp: ''!
isDurational
	^true! !

!Durational methodsFor: 'testing' stamp: ''!
isHourDuration
	"Answer whether the receiver's temporal extent is one hour."

	^false! !

!Durational methodsFor: 'testing' stamp: ''!
isInfinite
	^false! !

!Durational methodsFor: 'testing' stamp: ''!
isMinimumResolutionQuantum
	"Answer whether the receiver's temporal extent is the receiver's minimum resolution quantum."

	^self isNanosecondDuration! !

!Durational methodsFor: 'testing' stamp: ''!
isMinuteDuration
	"Answer whether the receiver's temporal extent is one minute."

	^false! !

!Durational methodsFor: 'testing' stamp: ''!
isMonthDuration
	"Answer whether the receiver's temporal extent is one month."

	^false! !

!Durational methodsFor: 'testing' stamp: ''!
isNanosecondDuration
	"Answer whether the receiver's temporal extent is one nanosecond."

	^false! !

!Durational methodsFor: 'testing' stamp: ''!
isSecondDuration
	"Answer whether the receiver's temporal extent is one second."

	^false! !

!Durational methodsFor: 'testing' stamp: ''!
isYearDuration
	"Answer whether the receiver's temporal extent is one year."

	^false! !

!Durational methodsFor: 'testing' stamp: ''!
isZero
	"Answer the whether the receiver represents a zero-length temporal extent."

	^self subclassResponsibility! !

!Durational methodsFor: 'accessing' stamp: ''!
microsecondsSinceSecond
	"Answer the integer number of microseconds-since-the-second (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in microseconds after subtracting from its temporal extent the integer number of seconds (truncated towards zero) represented by the receiver.)"

	^(self nanosecondsSinceSecond bitShift: -3) // 125! !

!Durational methodsFor: 'accessing' stamp: ''!
millisecondsSinceSecond
	"Answer the integer number of milliseconds-since-the-second (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in milliseconds after subtracting from its temporal extent the integer number of seconds (truncated towards zero) represented by the receiver.)"

	^(self nanosecondsSinceSecond bitShift: -6) // 15625! !

!Durational methodsFor: 'accessing' stamp: ''!
minutes
	"Answer the integer number of minutes-since-the-hour (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in minutes after subtracting from its temporal extent integer number of hours (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^0! !

!Durational methodsFor: 'accessing' stamp: ''!
months
	"Answer the integer number of months (truncated towards zero) represented by the receiver, independent of the number of years or seconds it may represent."

	^0! !

!Durational methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond
	"Answer the integer number of nanoseconds-since-the-second (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in nanoseconds after subtracting from its temporal extent the integer number of seconds (truncated towards zero) represented by the receiver.)"

	^0! !

!Durational methodsFor: 'converting' stamp: ''!
negated
	"Answer a new (immutable) value of the receiver's type whose temporal extent is the negation (additive inverse) of that of the receiver's." 
	"Specified and required by the ANSI-Smalltalk Standard."

	^self copy
		beNegated;
		beImmutable! !

!Durational methodsFor: 'testing' stamp: ''!
negative
	"Answer whether the receiver represents a temporal extent whose magnitude is negative."
	"Specified and required by the ANSI-Smalltalk Standard."

	^self nonCalendarPeriodsNegative! !

!Durational methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsAreZero
	"Answer whether the non-calendrical temporal extent (hours/minutes/seconds/nanoseconds) of the receiver is zero."

	^true! !

!Durational methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsNegative
	"Answer whether the non-calendrical temporal extent (seconds/nanoseconds) of the receiver is negative."

	^self nonCalendarPeriodsPositive not! !

!Durational methodsFor: 'testing' stamp: ''!
nonCalendarPeriodsPositive
	"Answer whether the non-calendrical temporal extent (hours/minutes/seconds/nanoseconds) of the receiver is positive."

	^true! !

!Durational methodsFor: 'testing' stamp: ''!
positive
	"Answer whether the receiver represents a temporal extent whose magnitude is positive (or zero.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^self nonCalendarPeriodsPositive! !

!Durational methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^self subclassResponsibility! !

!Durational methodsFor: 'accessing' stamp: ''!
seconds
	"Answer the integer number of seconds-since-the-minute (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in seconds after subtracting from its temporal extent the integer number of minutes (truncated towards zero) represented by the receiver.)"
	"Specified and required by the ANSI-Smalltalk Standard."

	^0! !

!Durational methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	"Answer the integer number of seconds-since-the-day (truncated towards zero) represented by the receiver (i.e., the truncation-towards-zero of the remainder in seconds after subtracting from its temporal extent the integer number of days (truncated towards zero) represented by the receiver.) Assume an invariant number of seconds in each higher-order time period (days, hours, minutes.)"

	^0! !

!Durational methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 10:36'!
setWeeks: w
	"Set the component of the receiver's duration vector that represents its temporal extent in days to the value <w> * 7. Fail if the receiver is not mutable."

	self setDays: (w * (DaysPerWeek))! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count calendarDaysDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> calendar days (which may or may not contain exactly 86400 seconds) to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class calendarDurationFactory  days: count) do: block1! !

!Durational methodsFor: 'enumerating' stamp: ''!
startingFrom: start every: period collect: mapper
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding the given durational <period> to the preceding point-in-time in the sequence, do the following: 1) evaluate <mapper> with each successive point-in-time (in the monotonic sequence as specified) as the argument, and 2) add the result of each evaluation to a sequential collection. When all the moments (in the monotonic sequence as specified) have been evaluated, answer the sequential collection. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	"EXAMPLE: Compute the formatted printString of the first day of each quarter for the next year (where the first quarter starts today):
		{(CalendarDuration years: 1) 
			startingFrom: DateFactory today 
			every: (CalendarDuration months: 3) 
			collect: [:date | date printStringUsing: #verbose]}"

	| list |
	list := SequenceFactory new.
	self startingFrom: start every: period do: [:time |
		list add: (mapper value: time).
	].
	^list! !

!Durational methodsFor: 'enumerating' stamp: ''!
startingFrom: start every: period contains: predicate
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding the given durational <period> to the preceding point-in-time in the sequence, 1) apply <predicate> as a predicate test, with each successive point-in-time (in the monotonic sequence as specified) as the argument, and 2) if any such point-in-time in the mononotic sequence satisfies the predicate test, answer true.  Otherwise, answer false. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	"EXAMPLE: Compute whether a weekly recurring event, starting from today, would coincide with any US Federal Holidays over the next year:
		{(CalendarDuration years: 1) 
			startingFrom: DateFactory today 
			every: (CalendarDuration weeks: 1) 
			contains: [:date | date isUSFederalHoliday]}"

	self startingFrom: start every: period
		do: [:time | (predicate value: time) ifTrue: [^true]].
	^false! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count daysDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> days to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class days: count) do: block1! !

!Durational methodsFor: 'enumerating' stamp: ''!
startingFrom: start every: period detect: predicate ifNone: unsatisfiedAction
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding the given durational <period> to the preceding point-in-time in the sequence, 1) apply <predicate> as a predicate test, with each successive point-in-time (in the monotonic sequence as specified) as the argument, and 2) if any such point-in-time in the mononotic sequence satisfies the predicate test, answer that point-in-time value.  Otherwise, answer the result of evaluating <unsatisfiedAction>. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	"EXAMPLE: For a weekly recurring event, starting from today, compute the first day where the event would coincide with any US Federal Holiday over the next year (if any--and if not, try using some day other than today):
		{(CalendarDuration years: 1) 
			startingFrom: DateFactory today 
			every: (CalendarDuration weeks: 1) 
			detect: [:date | date isUSFederalHoliday]
			ifNone: ['No collisions with any holidays']}"

	self startingFrom: start every: period
		do: [:time | (predicate value: time) ifTrue: [^time]].
	^unsatisfiedAction value! !

!Durational methodsFor: 'enumerating' stamp: ''!
startingFrom: start every: durationStep do: block1 
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding the given durational <period> to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	"EXAMPLE: Show the date of each day for a week, starting with today:
		{Transcript cr.
		(CalendarDuration weeks: 1) 
			startingFrom: DateFactory today 
			every: (CalendarDuration days: 1) 
			do: [:date | Transcript cr; show: (date printStringUsing: #verbose)]}"

	start to: self + start every: durationStep do: block1! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count hoursDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> hours to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class hours: count) do: block1! !

!Durational methodsFor: 'enumerating' stamp: ''!
startingFrom: start every: period inject: initialValue into: mapper 
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding the given durational <period> to the preceding point-in-time in the sequence, evaluate <mapper> with the following arugments (labelled `a` and `b,` with `a` being the first and `b` the second argument): a) the given <initialValue> in the case of the first evaluation, but otherwise the value resulting from the previous evaluation of <mapper>, and b) each successive point-in-time (in the monotonic sequence as specified.) Answer the value resulting from the last evaluation of <mapper>--unless there were no such evaluations, in which case answer <initialValue>. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	"EXAMPLE: Count the number of weekend days for the next year, starting with today:
		{(CalendarDuration years: 1) 
			startingFrom: DateFactory today 
			every: (CalendarDuration days: 1) 
			inject: 0 
			into: [:result :date | 
				date isWeekendDay 
					ifTrue: [result + 1] 
					ifFalse: [result]]}"

	| value |
	value := initialValue.
	self startingFrom: start every: period
		do: [:time | value := mapper value: value value: time].
	^value! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count minutesDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> minutes to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class minutes: count) do: block1! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count monthsDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> months to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class calendarDurationFactory  months: count) do: block1! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count nonCalendarDaysDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> calendar days (each of which must contain exactly 86400 seconds) to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class durationFactory days: count) do: block1! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count quartersDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> quarters to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class calendarDurationFactory  quarters: count) do: block1! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count secondsDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> seconds to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class seconds: count) do: block1! !

!Durational methodsFor: 'enumerating' stamp: ''!
startingFrom: start every: period select: selector 
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding the given durational <period> to the preceding point-in-time in the sequence, do the following: 1) apply <selector> as a predicate test, with each successive point-in-time (in the monotonic sequence as specified) as the argument, and 2) for each point-in-time in the mononotic sequence for which the aforesaid evaluation results in the value true, add the evaluated argument to a sequential collection. When all the moments (in the monotonic sequence as specified) have been evaluated, answer the sequential collection (containing all--and only--those moments in the specified monotonic sequence that satisfied the predicate test represented by <selector>.) (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	"EXAMPLE: For a weekly recurring event, starting from today, compute all the days over the next year where the event would coincide with any US Federal Holiday (if any--and if not, try using some day other than today):
		{(CalendarDuration years: 1) 
			startingFrom: DateFactory today 
			every: (CalendarDuration weeks: 1) 
			select: [:date | date isUSFederalHoliday]}"

	| list |
	list := SequenceFactory new.
	self startingFrom: start every: period
		do: [:time | (selector value: time) ifTrue: [list add: time]].
	^list! !

!Durational methodsFor: 'enumerating' stamp: ''!
startingFrom: start every: period select: selector thenCollect: mapper 
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding the given durational <period> to the preceding point-in-time in the sequence, do the following: 1) apply <selector> as a predicate test, with each successive point-in-time (in the monotonic sequence as specified) as the argument, and 2) for each point-in-time in the mononotic sequence for which the aforesaid evaluation results in the value true, add to a sequential collection the result of evaluating <mapper> with that point-in-time as the argument. When all the moments (in the monotonic sequence as specified) have been evaluated, and all the ones that satisfied the predicate test (as implemented by <selector>) have been added to a sequential collenction, answer the sequential collection. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	"EXAMPLE: For a weekly recurring event, starting from today, for each day over the next year where the event would coincide with any US Federal Holiday, compute the day's date and it's associated holiday (if any--and if not, try using some day other than today):
		{(CalendarDuration years: 1) 
			startingFrom: DateFactory today 
			every: (CalendarDuration weeks: 1) 
			select: [:date | date isUSFederalHoliday]
			thenCollect: [:holiday | 
				holiday->(holiday annualDateSemanticKeyFrom: SemanticDatePolicy unitedStates ifNone: [])]}"

	| list |
	list := SequenceFactory new.
	self startingFrom: start every: period
		do: [:time | (selector value: time) ifTrue: [list add: (mapper value: time)]].
	^list! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count weeksDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> weeks to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class weeks: count) do: block1! !

!Durational methodsFor: 'enumerating-common durations' stamp: ''!
startingFrom: start every: count yearsDo: block1
	"For every point-in-time in a monotonic sequence of moments contained by the left-closed, right-open interval `[<start>, <start> + self)`, such that the initial moment is the point-in-time specified by <start>, and such that each succeeding moment is the point-in-time computed by adding <count> years to the preceding point-in-time in the sequence, evaluate <block1> with each successive point-in-time (in the monotonic sequence as specified) as the argument. (Note: a closed interval is one that contains its end-points.  An open interval is one that does not contain its endpoints.  A left-closed, right-open interval contains its left endpoint, but not its right endpoint.)"

	self startingFrom: start every: (self class calendarDurationFactory  years: 1) do: block1! !

!Durational methodsFor: 'testing' stamp: ''!
subsecondsAreNonZero
	"Answer whether the sub-second temporal extent (seconds/nanoseconds) of the receiver is non-zero."

	^self subsecondsAreZero not! !

!Durational methodsFor: 'testing' stamp: ''!
subsecondsAreZero
	"Answer whether the sub-second temporal extent (seconds/nanoseconds) of the receiver is zero."

	^true! !

!Durational methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfiniteDuration: anInfiniteDuration
	^anInfiniteDuration! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingDays: subtractedDays
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <subtractedDays> days less than that of the receiver's." 

	subtractedDays = 0 ifTrue: [^self].
	^(self asCalendricalMutable)
		addDays: subtractedDays negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingHours: subtractedHours
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <subtractedHours> hours less than that of the receiver's." 

	subtractedHours = 0 ifTrue: [^self].
	^(self asSubDayMutable)
		addHours: subtractedHours negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingHours: subtractedHours minutes: subtractedMinutes

	subtractedMinutes = 0 ifTrue: [^self subtractingHours: subtractedHours] .
	^(self asSubDayMutable)
		addHours: subtractedHours negated minutes: subtractedMinutes negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingHours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds

	subtractedSeconds = 0 ifTrue: [^subtractedMinutes = 0 ifTrue: [self subtractingHours: subtractedHours] ifFalse: [self subtractingHours: subtractedHours minutes: subtractedMinutes]].
	^(self asSubDayMutable)
		addHours: subtractedHours negated minutes: subtractedMinutes negated seconds: subtractedSeconds negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingHours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds nanoseconds: subtractedNanoseconds 

	^(self asSubDayMutable)
		addHours: subtractedHours negated minutes: subtractedMinutes negated seconds: subtractedSeconds negated nanoseconds: subtractedNanoseconds negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingMinutes: subtractedMinutes
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <subtractedMinutes> minutes less than that of the receiver's." 

	subtractedMinutes = 0 ifTrue: [^self].
	^(self asSubDayMutable)
		addMinutes: subtractedMinutes negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingMonths: subtractedMonths
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedMonths> months less than that of the receiver's." 

	subtractedMonths = 0 ifTrue: [^self].
	^(self asCalendricalMutable)
		addMonths: subtractedMonths negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: subtractedSeconds
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <subtractedSeconds> seconds less than that of the receiver's." 

	subtractedSeconds = 0 ifTrue: [^self].
	^(self asSubDayMutable)
		addSeconds: subtractedSeconds negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: subtractedSeconds nanoseconds: subtractedNanoseconds 
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <subtractedSeconds> seconds and <subtractedNanoseconds> nanoseconds less than that of the receiver's."

	subtractedNanoseconds = 0 ifTrue: [^self addingSeconds: subtractedSeconds negated].
	^(self asSubDayMutable)
		addSeconds: subtractedSeconds negated nanoseconds: subtractedNanoseconds negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <subtractedYears> years less than that of the receiver's." 

	subtractedYears = 0 ifTrue: [^self].
	^(self asCalendricalMutable)
		addYears: subtractedYears negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <subtractedYears> years and <subtractedMonths> months greater than that of the receiver's." 

	subtractedMonths = 0 ifTrue: [^self subtractingYears: subtractedYears].
	^self asCalendricalMutable
		addYears: subtractedYears negated months: subtractedMonths negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths days: subtractedDays
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedYears> years, <addedMonths> months, <addedDays> days, <addedSeconds> seconds and <addedNanoseconds> nanoseconds less than that of the receiver's." 

	subtractedDays = 0 ifTrue: [^subtractedMonths = 0 ifTrue: [self subtractingYears: subtractedYears] ifFalse: [self subtractingYears: subtractedYears months: subtractedMonths]].
	^self asCalendricalMutable
		addYears: subtractedYears negated months: subtractedMonths negated days: subtractedDays negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths days: subtractedDays hours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds

	^(self asCivilSubDayMutable)
		addYears: subtractedYears negated months: subtractedMonths negated days: subtractedDays negated;
		addHours: subtractedHours negated minutes: subtractedMinutes negated seconds: subtractedSeconds negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths days: subtractedDays hours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds nanoseconds: subtractedNanoseconds

	^(self asCivilSubDayMutable)
		addYears: subtractedYears negated months: subtractedMonths negated days: subtractedDays negated;
		addHours: subtractedHours negated minutes: subtractedMinutes negated seconds: subtractedSeconds negated nanoseconds: subtractedNanoseconds negated;
		beImmutable! !

!Durational methodsFor: 'arithmetic' stamp: ''!
subtractingYears: subtractedYears months: subtractedMonths days: subtractedDays seconds: subtractedSeconds nanoseconds: subtractedNanoseconds
	"Answer a new (immutable) value of the receiver's type whose temporal extent is <addedYears> years, <addedMonths> months, <addedDays> days, <addedSeconds> seconds and <addedNanoseconds> nanoseconds less than that of the receiver's." 

	^(self asCivilSubDayMutable)
		addYears: subtractedYears negated months: subtractedMonths negated days: subtractedDays negated;
		addSeconds: subtractedSeconds negated nanoseconds: subtractedNanoseconds negated;
		beImmutable! !

!Durational methodsFor: 'accessing' stamp: ''!
weeks
	"Answer the integer number of weeks (truncated towards zero) represented by the receiver, solely as a function of the number of days it represents, and independent of the number of months and/or years it may represent."

	^self asDays quo: DaysPerWeek! !

!Durational methodsFor: 'accessing' stamp: ''!
years
	"Answer the integer number of years (truncated towards zero) represented by the receiver, independent of the number of months or seconds it may represent."

	^0! !

!Durational methodsFor: 'private' stamp: ''!
yearsAndMonthsMustBeZero
	(self months isZero and: [self years isZero]) ifFalse: [self signalError: 'Illegal operation: Both years and months must be zero'].! !

!Durational methodsFor: 'private' stamp: ''!
yearsAndMonthsMustBeZeroOrNegative
	(self months <= 0 and: [self years <= 0]) ifFalse: [self signalError: 'Illegal operation: Both years and months must be less than or equal to zero'].! !

!Durational methodsFor: 'private' stamp: ''!
yearsAndMonthsMustBeZeroOrPositive
	(self months >= 0 and: [self years >= 0]) ifFalse: [self signalError: 'Illegal operation: Both years and months must be greater than or equal to zero'].! !

ChronosPrintable subclass: #TemporalInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!TemporalInterval commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

TemporalInterval

	Concept:

		TemporalInterval is an abstract class. An instance of a concrete subclass of TemporalInterval represesents a temporal interval--specifically, a left-closed, right-open interval of time.  A temporal interval is a temporal extent that starts at a particular point-in-time. A left-closed, right-open interval is one that includes its left endpoint (its starting point,) but does not include its right endpoint (its ending point, or limit value.) The left endpoint of a TemporalInterval is the initial moment contained by the interval. The right endpoint/limit value is that point-in-time computed by adding the TemporalInterval's temporal extent to its starting point-in-time. Since a TemporalInterval represents an interval that includes its starting point-in-time, but does not include its ending point, a TemporalInterval representing the interval that started at the most recent local midnight, and whose temporal extent is one calendrical/civil day, asymptotically spans up to but does not include the next day's midnight.

		A TemporalInterval also represents a value associated with or related to a particular Calendar (which see.) TemporalInterval provides protocol for accessing the Calendar to which a TemporalInterval is associated, and for accessing properties of the associated Calendar (e.g, does the associated Calendar have an invariant number of months per year?)

		TemporalInterval also provides/implements "Magnitude" behavior/protocol (comparison operators,) Immutable behvavior/protocol and ChronosObject behavior/protocol.

		A TemporalInterval has the attributes #resolutionQuantum and #duration. The #resolutionQuantum of a TemporalInterval is the minimum non-zero interval of time by which one instance of a concrete subclass of Calendrical can differ from that of another instance of the same class. The #duration of a TemporalInterval is the interval of time spanned by the instance. Although the #resolutionQuantum and the #duration will often be the same, there are cases where they differ (see, for example, Timeperiod). The #resolutionQuantum and the #duration attributes are both represented by instances of Durational (e.g., a ScientificDuration or a CalendarDuration.)

	Usage:

		The starting point of a TemporalInterval can be accessed by sending the message #start to a Timeperiod instance.

		The temporal extent of a TemporalInterval is represented by an instance of Durational (which see,) and can be accessed by sending the message #duration to a TemporalInterval instance. The temporal extent may be negative--in which case the TemporalInterval's endpoint (limit value) is temporally prior to its starting point.  Also, the temporal extent may be either a simple scalar number of seconds, or a vector specifying some number of years, months, days, hours, minutes and seconds. 

		The end-point or "limit value" of a TemporalInterval is computed by adding its temporal extent (duration) to its starting point.  It can be accessed by sending the message #limit to an instance.  The end-point/limit is not included by the TemporalInterval.

		The granularity of a TemporalInterval is defined to be the quantum of resolution of its starting point-in-time (accessible by sending the message #granularity to a Timeperiod instance.)  The quantum of resolution of a date value is one calendar day.  The quantum of resolution of a DateAndTime value is the same as that of a Duration value--currently implemented to be one nanosecond. 

		In the case of a TemporalInterval with a positive duration, its "closed extent" is (conceptually) the temporal extent (duration) of the **fully-closed** interval that contains every point-in-time that is greater than or equal to the TemporalInterval's earliest point-in-time, and less than its latest point-in-time. In the case of a TemporalInterval with a negative duration, its "closed extent" is (conceptually) the temporal extent (duration) of the **fully-closed** interval that contains every point-in-time that is less than or equal to the TemporalInterval's latest point-in-time, and greater than its earliest point-in-time. Physically, its "closed extent" is defined to be the temporal extent (duration) computed by subtracting the TemporalInterval's granularity from its temporal exent (i.e., "aTimeperiod duration - aTimeperiod granularity.") It can be accessed by sending the message #closedExtent to a TemporalInterval instance.

		The first element of a Timeperiod is its starting point-in-time. It can be accessed by sending the message #first to a Timeperiod instance (to provide a small degree of polymorphism with SequenceableCollections/Intervals.)  The last element of a Timeperiod is the point-in-time computed by adding the Timeperiod's closed extent to its starting point-in-time ("aTimeperiod start + aTimeperiod closedExtent." The last element of a Timeperiod can be accessed by sending the message #last to an instance. 
		
		The quantum of resolution of the last element may or may not be the same as that of the first element, depending upon the nature of the Durational value that represents the TemporalInterval's closed extent (if it's either a non-zero ScientificDuration, or a CalendarDuration where the "seconds" element of its duration vector is non-zero, then the TemporalInterval's last element will have a 1-nanosecond quantum of resolution.)  For example, "(Timeperiod dayStartingAt: Timepoint today) last" evaluates to the final nanosecond of the current day, but "(Timeperiod quarterStartingAt: YearMonthDay today) last" evaluates to the last date of the quarter that started on today's date. The last day of the quarter, since it's a date value, conceptually includes all the points-in-time of that date, because the quantum of resolution of a Chronos date value is 1 calendar day, and a Chronos point-in-time value implicitly represents a left-closed, right-open interval, whose starting point (left endpoint) is the moment nominally designated by the value, and whose (open) temporal extent is the value's quantum of resolution.

		TemporalInterval introduces the API message #compareTo:, which is used to compute the relative ordering between two values (less than, equal to or greater than.)  See the method comment of #compareTo: for specific details.
	
	Implementation:

		Unlike class Magnitude, Calendrical implements all the other comparison methods using #compareTo:.

	Subclassing:

		Subclasses that store an instance of Calendar must subimplment the #invalidateCalendar method.

		Concrete subclasses must subimplement the following instance methods:
		
			#compareTo:
			#initializeFromLiteralArray:		(also see the class method #basicDecodeFromLiteralArray:)
			#literalArrayEncoding
		
!

TemporalInterval subclass: #InfiniteTimepoint
	instanceVariableNames: 'isNegative'
	classVariableNames: 'Future Past'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!InfiniteTimepoint class methodsFor: 'constants' stamp: ''!
future
	Future == nil 
		ifTrue: 
			[Future := 
				(self basicNew)
					bePositive;
					beImmutable].
	^Future! !

!InfiniteTimepoint class methodsFor: 'instance creation' stamp: ''!
new
	^self shouldNotImplement! !

!InfiniteTimepoint class methodsFor: 'constants' stamp: ''!
past
	Past == nil 
		ifTrue: 
			[Past := 
				(self basicNew)
					beNegative;
					beImmutable].
	^Past! !

!InfiniteTimepoint class methodsFor: 'instance creation' stamp: 'PaulDeBruicker 3/9/2011 15:11'!
polarity: polarity 
	^polarity ifTrue: [self perform: #future] ifFalse: [self past]! !

!InfiniteTimepoint class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	^self notYetImplemented! !

!InfiniteTimepoint class methodsFor: 'unit test' stamp: ''!
testDoIts
	"InfiniteTimepoint future = InfiniteTimepoint future
	InfiniteTimepoint future < InfiniteTimepoint future
	InfiniteTimepoint future > InfiniteTimepoint future

	InfiniteTimepoint future = InfiniteTimepoint past
	InfiniteTimepoint future < InfiniteTimepoint past
	InfiniteTimepoint future > InfiniteTimepoint past

	InfiniteTimepoint past = InfiniteTimepoint future
	InfiniteTimepoint past < InfiniteTimepoint future
	InfiniteTimepoint past > InfiniteTimepoint future

	InfiniteTimepoint past = InfiniteTimepoint past
	InfiniteTimepoint past < InfiniteTimepoint past
	InfiniteTimepoint past > InfiniteTimepoint past

	InfiniteTimepoint future = Timepoint now
	InfiniteTimepoint future < Timepoint now
	InfiniteTimepoint future > Timepoint now

	InfiniteTimepoint past = Timepoint now
	InfiniteTimepoint past < Timepoint now
	InfiniteTimepoint past > Timepoint now

	(YearMonthDay today withDuration: InfiniteDuration positive) includes: YearMonthDay tomorrow
	(YearMonthDay today withDuration: InfiniteDuration positive) includes: YearMonthDay yesterday
	(YearMonthDay today withDuration: InfiniteDuration negative) includes: YearMonthDay tomorrow
	(YearMonthDay today withDuration: InfiniteDuration negative) includes: YearMonthDay yesterday

	YearMonthDay today + InfiniteDuration positive
	YearMonthDay today + InfiniteDuration negative
	YearMonthDay today - InfiniteDuration positive
	YearMonthDay today - InfiniteDuration negative

	InfiniteDuration positive +YearMonthDay today
	InfiniteDuration negative +YearMonthDay today
	InfiniteDuration positive -YearMonthDay today
	InfiniteDuration negative -YearMonthDay today

	YearMonthDay today + InfiniteTimepoint future
	YearMonthDay today + InfiniteTimepoint past 
	YearMonthDay today - InfiniteTimepoint future
	YearMonthDay today - InfiniteTimepoint past

	InfiniteTimepoint future + YearMonthDay today
	InfiniteTimepoint past + YearMonthDay today
	InfiniteTimepoint future - YearMonthDay today
	InfiniteTimepoint past - YearMonthDay today"! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
- aDurationOrTemporalInterval
	"Specified and required by the ANSI-Smalltalk Standard."

	^aDurationOrTemporalInterval subtractedFromInfiniteTimepoint: self! !

!InfiniteTimepoint methodsFor: 'private-arithmetic' stamp: ''!
addedToCalendarDuration: aDuration
	^aDuration + (InfiniteDuration polarity: isNegative not)! !

!InfiniteTimepoint methodsFor: 'private-arithmetic' stamp: ''!
addedToCivilDuration: aDuration
	^aDuration + (InfiniteDuration polarity: isNegative not)! !

!InfiniteTimepoint methodsFor: 'private-arithmetic' stamp: ''!
addedToDuration: aDuration
	^aDuration + (InfiniteDuration polarity: isNegative not)! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingDays: dayDelta
	"Answer a new CalendricalCoordinate which is the given number of civil days after the date represented by the receiver, preserving the same civil time-of-day."

	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingHours: hours
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes seconds: seconds
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingMinutes: minutes
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingMonths: months
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingSeconds: seconds
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingSeconds: seconds nanoseconds: nanoseconds 
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingYears: years
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds 
	^self! !

!InfiniteTimepoint methodsFor: 'initialize-release' stamp: ''!
beNegative
	self assertMutability.
	isNegative := true! !

!InfiniteTimepoint methodsFor: 'initialize-release' stamp: ''!
bePositive
	self assertMutability.
	isNegative := false! !

!InfiniteTimepoint methodsFor: 'comparing' stamp: ''!
compareTo: aTemporalInterval
	"Compare the value of the receiver to that of <aTemporalInterval>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aTemporalInterval ifTrue: [^0].
	^[aTemporalInterval compareToInfiniteTimepoint: self] 
			on: MessageNotUnderstood 
			do: [:ex | 
				((ex receiver == aTemporalInterval) and: [#compareToInfiniteTimepoint: == ex message selector])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!InfiniteTimepoint methodsFor: 'private-comparing' stamp: ''!
compareToInfiniteTimepoint: anInfiniteTimepoint
	^anInfiniteTimepoint isInfinitePast
		ifTrue: [isNegative ifTrue: [0] ifFalse: [-1]]
		ifFalse: [isNegative ifTrue: [1] ifFalse: [0]]! !

!InfiniteTimepoint methodsFor: 'private-comparing' stamp: ''!
compareToTemporalCoordinate: aTemporalCoordinate
	^isNegative
		ifTrue: [1]
		ifFalse: [-1]! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
daysSince: aTemporalCoordinate
	^PassportInfinity polarity: isNegative not! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
daysUntil: aTemporalCoordinate
	^PassportInfinity polarity: isNegative! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
durationSince: aTemporalCoordinate
	^InfiniteDuration polarity: isNegative not! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
durationUntil: aTemporalCoordinate
	^InfiniteDuration polarity: isNegative! !

!InfiniteTimepoint methodsFor: 'comparing' stamp: ''!
hash
	^isNegative hash! !

!InfiniteTimepoint methodsFor: 'testing' stamp: ''!
isInfinite
	^true! !

!InfiniteTimepoint methodsFor: 'testing' stamp: ''!
isInfiniteFuture
	^isNegative not! !

!InfiniteTimepoint methodsFor: 'testing' stamp: ''!
isInfinitePast
	^isNegative! !

!InfiniteTimepoint methodsFor: 'converting' stamp: ''!
negated
	^self class polarity: isNegative! !

!InfiniteTimepoint methodsFor: 'INTER-period-stream protocol' stamp: ''!
next
	^self! !

!InfiniteTimepoint methodsFor: 'INTER-period-stream protocol' stamp: ''!
prev
	^self! !

!InfiniteTimepoint methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy 
	aChronosPrintPolicy printInfiniteTimepoint: self on: stream! !

!InfiniteTimepoint methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	^InfiniteDuration polarity:self isInfiniteFuture! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
scientificDurationSince: aTemporalCoordinate
	^self durationSince: aTemporalCoordinate! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
scientificDurationUntil: aTemporalCoordinate
	^self durationUntil: aTemporalCoordinate! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
secondsSince: aTemporal
	^PassportInfinity polarity: isNegative not! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
secondsUntil: aTemporal
	^PassportInfinity polarity: isNegative! !

!InfiniteTimepoint methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCalendarDuration: aDuration
	^aDuration - (InfiniteDuration polarity: isNegative)! !

!InfiniteTimepoint methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aDuration
	^aDuration - (InfiniteDuration polarity: isNegative)! !

!InfiniteTimepoint methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromDuration: aDuration
	^aDuration - (InfiniteDuration polarity: isNegative)! !

!InfiniteTimepoint methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromTemporalInterval: aTemporalInterval
	^InfiniteDuration polarity: isNegative! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingDays: days
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes seconds: seconds
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingMinutes: minutes
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingMonths: months
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: seconds
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: seconds nanoseconds: nanoseconds
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	^self! !

!InfiniteTimepoint methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds
	^self! !

TemporalInterval subclass: #TemporalCoordinate
	instanceVariableNames: ''
	classVariableNames: 'HoursSinceStartOfDayRangeConstraint MinutesSinceHourRangeConstraint NanosecondsSinceSecondRangeConstraint SecondsSinceMinuteRangeConstraint SecondsSinceStartOfDayRangeConstraint'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!TemporalCoordinate commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

TemporalCoordinate subclass: #CalendricalCoordinate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!CalendricalCoordinate commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

CalendricalCoordinate subclass: #AbstractDate
	instanceVariableNames: 'calendar'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
atFirstDayOfMonth
	"{YearMonthDay atFirstDayOfMonth}"

	^self today atFirstDayOfMonth! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
atFirstDayOfWeek
	"{YearMonthDay atFirstDayOfWeek}"

	^self today atFirstDayOfWeek! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
atFirstDayOfYear
	"{YearMonthDay atFirstDayOfYear}"

	^self today atFirstDayOfYear! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
atLastDayOfMonth
	"{YearMonthDay atLastDayOfMonth}"

	^self today atLastDayOfMonth! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
atLastDayOfWeek
	"{YearMonthDay atLastDayOfWeek}"

	^self today atLastDayOfWeek! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
atLastDayOfYear
	"{YearMonthDay atLastDayOfYear}"

	^self today atLastDayOfYear! !

!AbstractDate class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days
	^self basicNew
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days calendar: calendar
	^self basicNew
		setCalendar: calendar;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'accessing' stamp: ''!
defaultParser
	^ChronosParser ansiStandard! !

!AbstractDate class methodsFor: 'instance creation' stamp: ''!
fromNative: aNativeTimestampOrDate
	^self 
		fromNative: aNativeTimestampOrDate 
		as: AnsiStandardCalendar! !

!AbstractDate class methodsFor: 'instance creation' stamp: ''!
fromNative: aNativeCalendricalCoordinate as: calendar
	^(Calendar referencedBy: calendar) clock 
		chronosDateFromNativeCalendricalCoordinate: aNativeCalendricalCoordinate! !

!AbstractDate class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal 
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"YearMonthDay isoYear: 2006 week: 1 dayOfWeek: ISOMonday"
	"DateAndTime isoYear: 2006 week: 1 dayOfWeek: ISOMonday"

	"{(YearMonthDay year: 2003 month: 12 day: 28)
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (YearMonthDay isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"
	"{(YearMonthDay year: 2003 month: 12 day: 29) 
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (YearMonthDay isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"
	"{(YearMonthDay year: 2005 month: 1 day: 2) 
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (YearMonthDay isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"
	"{(YearMonthDay year: 2010 month: 1 day: 3) 
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (YearMonthDay isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"
	"{(YearMonthDay year: 2010 month: 1 day: 4) 
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (YearMonthDay isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"

	^self basicNew
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay
	"DateAndTime julianDay: YearMonthDay today julianDay"

	^self basicNew
		setJulianDay: julianDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setJulianDay: julianDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDayNumber: julianDay
	"For compatibility with other Date/Time libraries."

	^self basicNew
		setJulianDayNumber: julianDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^(ChronosParser referencedBy: aChronosParser) nextDateFrom: stream usingFactory: self! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: 'PaulDeBruicker 3/9/2011 11:28'!
today
	^(AnsiStandardCalendarClock) dateToday! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
todayAs: aCalendarOrCalendarReference
	^(Calendar referencedBy: aCalendarOrCalendarReference) clock dateToday

	"{DateFactory todayAs: Gregorian}"
	"{DateFactory todayAs: #Gregorian}" 		"{DateFactory todayAs: GregorianCalendar}" 
	"{DateFactory todayAs: Julian}" 	
	"{DateFactory todayAs: #Julian}" 			"{DateFactory todayAs: JulianCalendar}"		
	"{DateFactory todayAs: #Bahai}" 			"{DateFactory todayAs: BahaiCalendar}"
	"{DateFactory todayAs: #Coptic}" 			"{DateFactory todayAs: CopticCalendar}"
	"{DateFactory todayAs: #Ethiopic}" 			"{DateFactory todayAs: EthiopicCalendar}"
	"{DateFactory todayAs: #Hebrew}" 			"{DateFactory todayAs: HebrewCalendar}"
	"{DateFactory todayAs: #Indian}" 			"{DateFactory todayAs: IndianCalendar}"
	"{DateFactory todayAs: #'Islamic-Fatimid'}" 	"{DateFactory todayAs: IslamicFatimidCalendar}"
	"{DateFactory todayAs: #Persian}" 			"{DateFactory todayAs: PersianCalendar}"
	"{DateFactory todayAs: #Solarian}" 			"{DateFactory todayAs: SolarianCalendar}"! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
todayIn: aTimezone
	^AnsiStandardCalendarClock dateTodayIn: aTimezone! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
todayIn: aTimezone as: aCalendarOrCalendarReference
	^(Calendar referencedBy: aCalendarOrCalendarReference) clock dateTodayIn: aTimezone! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
tomorrow
	^self today tomorrow! !

!AbstractDate class methodsFor: 'instance creation-local time' stamp: ''!
year: year calendarDay: aCalendarDay
	^self basicNew
		basicSetYear: year calendarDay: aCalendarDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear
	^self basicNew
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth
	^self basicNew
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth calendar: calendar
	"{(DateFactory year: 5766 month: 1 day: 1 calendar: HebrewCalendar) as: GregorianCalendar}"
	"{(DateFactory year: 5766 month: 1 day: 1 calendar: HebrewCalendar canonical) as: Calendar gregorian}"
	"{(DateFactory year: 5766 month: 1 day: 1 calendar: #Hebrew) as: #Gregorian}"
	"{(DateFactory year: 5766 month: 1 day: 1 calendar: #Hebrew) as: Gregorian}"

	^self basicNew
		setCalendar: calendar;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!AbstractDate class methodsFor: 'instance creation-local time-current' stamp: ''!
yesterday
	^self today yesterday! !

!AbstractDate methodsFor: 'converting' stamp: ''!
<< aChronosTimezone 
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but convert the date and time-of-day as though the receiver represented a date and time in the current default time zone (i.e,. preserve date and time-of-day in Universal Time as though the receiver represented a date and time in the current default time zone.)
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is the same as that of the receiver (i.e,, preserve local date and local time-of-day, don't preserve date or time-of-day in Universal Time.)"

	"YearMonthDay today << 10 hours"
	"YearMonthDay today << #nominal"
	"YearMonthDay today << 'Australia/Adelaide'"
	"YearMonthDay today << #default"
	"YearMonthDay today << #system"

	| timeZone dateAndTime |
	timeZone := ChronosTimezone referencedBy: aChronosTimezone.
	timeZone isInvariantToNominalTime ifTrue: [^self].
	timeZone isDefault 
		ifTrue: 
			[dateAndTime := 
				self isMutable 
					ifTrue: [self asMutableDateAndTimeInvariantToUT]
					ifFalse: [self asDateAndTime]]
		ifFalse: 
			[dateAndTime := self asMutableDateAndTime.
			dateAndTime
				deproxifyTimeZone;
				convertToTimeZone: timeZone;
				beImmutable].
	^self duration asTimeperiodStartingAt: dateAndTime! !

!AbstractDate methodsFor: 'converting' stamp: ''!
>> aChronosTimezone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."

	"YearMonthDay today >> 10 hours"
	"YearMonthDay today >> #nominal"
	"YearMonthDay today >> 'Australia/Adelaide'"
	"YearMonthDay today >> #default"
	"YearMonthDay today >> #system"
	"{YearMonthDay today >> 'America/Phoenix'}"
	"{YearMonthDay today >> 'Asia/Calcutta'}"

	| timeZone |
	timeZone := ChronosTimezone referencedBy: aChronosTimezone.
	timeZone isInvariantToNominalTime ifTrue: [^self].
	^self duration asTimeperiodStartingAt: (self asDateAndTimeIn: timeZone)! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
addMonths: months 
	"Add the given number of civil months to the date represented by the receiver, preserving the same civil time-of-day.   The new dayOfMonth will be the same as it had been, unless it would be invalid.  For example, if the orignal date was March 31, the new dayOfMonth will also be 31, unless the new month has less than 31 days. In such a case, the receiver's new dayOfMonth will be the last day of the receiver's new month.

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal."

	months = 0 ifTrue: [^self].
	self basicAddMonths: months days: 0! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
addYears: years 
	"Add the given number of civil years to the date represented by the receiver, preserving the same civil time-of-day.  The civil intra-year date in the new year will be the same as in the old year, unless it would be invalid.   For example, if the orignal date is March 1 in a Gregorian/Julian leap year, the date in the new year will remain March 1 after adding the specified years.  However, if the original date is February 29 and the new year is not a leap year, then the new date will be Feb 28.   

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal.  If intercalary months may occur at times other than the end of the year, the Calendar system's cultural tradition will be respected regarding the semantics of 'same civil date N years later (or earlier.)'  The implementation assumes that the only issue in that respect is whether or not 'same month' is defined by the monthOrdinal or by the monthKey (by definition of a Chronos monthKey, months with the same monthKey are semantically the same month, regardless of possibly having different monthOrdinals in different years--which does happen in some Calendars!!.)"

	| remainingDays |
	years = 0 ifTrue: [^self].
	remainingDays := (self basicAddYears: years) truncated.
	remainingDays = 0 ifFalse: [self basicAddDays: remainingDays]! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
addYears: years months: months days: days 
	"Add the given number of civil years, months and days, and the given number of scientific seconds and nanoseconds, to the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years, M civil months and D civil days away from another date' will be respected..

	See the specifications/comments for #addYears:, #addMonths:and #addDays for more detailed/precise semantics."

	(days = 0 and: [months = 0 and: [years = 0]]) 
		ifFalse: 
			[| daysToAdd |
			years = 0 
				ifTrue: [daysToAdd := days truncated]
				ifFalse: [daysToAdd := (days + (self basicAddYears: years)) truncated].
			months = 0
				ifTrue: [daysToAdd = 0 ifFalse: [self basicAddDays: daysToAdd]]
				ifFalse: [self basicAddMonths: months days: daysToAdd]].! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
addYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 

	self addYears: years months: months days: days.
	self addHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
addYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds 
	"Add the given number of civil years, months and days, and the given number of scientific seconds and nanoseconds, to the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years, M civil months and D civil days away from another date' will be respected.  The scientific semantics of a timepoint S seconds and N nanoseconds from another will be respected (UT).

	See the specifications/comments for #addYears:, #addMonths:, #addDays: and #addSeconds:nanoseconds: for more detailed/precise semantics."

	self addYears: years months: months days: days.
	self addSeconds: seconds nanoseconds: nanoseconds! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
annualDateSemanticKeyFrom: aSemanticDatePolicy satisfies: predicate 
	aSemanticDatePolicy 
		forEachSemanticAnnualEventOccurringOn: self
		do: [:semanticKey :date | (predicate value: semanticKey) ifTrue: [^true]].
	^false! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
annualDateSemanticKeySatisfies: predicate
	^self annualDateSemanticKeyFrom: SemanticDatePolicy default satisfies: predicate! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
annualDateSemanticKeysFrom: aSemanticDatePolicy ifNone: ifNone 
	"In the United States (in all time zones except for Pacific/Guam,) 
	Unix's `2038 bug` will strike in the eveving of Martin Luther King Day
	(assuming no time zone changes, no new territories added to
	the US inventory, and no changes to the rule for determining the
	date on which Martin Luther King Day occurs):

		{((Timepoint utYear: 1970 day: 1 timeZone: 'America/New_York') + (Duration seconds: 2 ** 31 - 1)) 
			annualDateSemanticKeysFrom: SemanticDatePolicy unitedStates ifNone: []}"

	| set |
	set := Set new.
	aSemanticDatePolicy 
		forEachSemanticAnnualEventOccurringOn: self
		do: [:semanticKey :date | set add: semanticKey].
	^set isEmpty ifTrue: [ifNone value] ifFalse: [set]! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
annualDateSemanticKeysIfNone: ifNone
	^self annualDateSemanticKeysFrom: SemanticDatePolicy default ifNone: ifNone! !

!AbstractDate methodsFor: 'private' stamp: ''!
asMutableDate
	^self copy! !

!AbstractDate methodsFor: 'private' stamp: ''!
asMutableDateAndTime
	^self yearAndCalendarDayDo: 
			[:year :calendarDay | 
			(self class dateAndTimeFactory basicNew)
				basicSetCalendar: self calendar;
				basicSetYear: year calendarDay: calendarDay;
				canonicalize]! !

!AbstractDate methodsFor: 'private' stamp: ''!
asMutableDateAndTimeInvariantToUT
	^self yearAndCalendarDayDo: 
			[:year :calendarDay | 
			(self class dateAndTimeFactory basicNew)
				basicSetCalendar: self calendar;
				basicSetYear: year calendarDay: calendarDay;
				canonicalizeFromLocalTime]! !

!AbstractDate methodsFor: 'private' stamp: ''!
asMutableTimeOfDay
	^self asMutableDateAndTime! !

!AbstractDate methodsFor: 'converting' stamp: ''!
asNative
	"Answer the native system's 'Date' analog (or 'Timestamp' analog, if no Date analog is available) that semantically corresponds as closely as possible to the receiver."

	"{Julian clock dateToday asNative}"

	^self clock nativeCalendricalCoordinateFromChronosDate: self! !

!AbstractDate methodsFor: 'converting' stamp: ''!
asSpec
	^self dateSpec! !

!AbstractDate methodsFor: 'private-arithmetic' stamp: ''!
basicAddDays: dayDelta 
	"Add the given number of civil days to the date represented by the receiver, preserving the same civil time-of-day."

	dayDelta = 0 ifTrue: [^self].
	self setDaysSinceEpoch: self daysSinceEpoch + dayDelta! !

!AbstractDate methodsFor: 'private-arithmetic' stamp: ''!
basicAddMonths: months days: days 
	"Add the given number of civil months and days to the date represented by the receiver.   Any of the <months>, or the <days>, or both, may be fractional numbers--however, only an integer number of months and days will be added. Fractional months will be converted to an integer number of days, plus some fraction of a day. Fractional days will be converted to an integer number of days, plus some fraction of a day. Answer any fraction of a day not added (which will be the sum of the day fractions left over from both <months> and <days>, if any.)

	If <days> is zero: The new dayOfMonth will be the same as it had been, unless it would be invalid.  For example, if the orignal date was March 31, the new dayOfMonth will also be 31, unless the new month has less than 31 days.  In such a case, the receiver's new dayOfMonth will be the last day of the receiver's new month.

	If <days> is non-zero: The recevier's new date will the same as it would have been, had this method been invoked with <days = 0>, followed by performing <self addDays: days>.  See the comment/specification of the method #addDays.  In other words, this method introduces no new semantics, but is simply for improved performance.

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal."

	| dayFraction |
	self yearAndCalendarDayDo: 
			[:localYear :localCalendarDay | 
			| monthsToAdd monthFraction  daysToAdd |
			months isInteger
				ifTrue: 
					[monthsToAdd := months.
					monthFraction := 0]
				ifFalse: 
					[monthsToAdd := months truncated.
					monthFraction := months - monthsToAdd].
			self calendar 
				startingWithYear: localYear
				addingMonths: localCalendarDay monthsSinceStartOfYear + monthsToAdd
				setYearAndMonthsSinceStartOfYearInto: 
					[:newYear :newMonthsSinceStartOfYear | 
					| newMonth daysInMonth dayOfMonth newYearTypeCode yearTypeCodeIsTheSame newCalendarDay |
					newMonth := newMonthsSinceStartOfYear + 1.
					dayOfMonth := localCalendarDay dayOfMonth.
					newYear = localYear 
						ifTrue: 
							[yearTypeCodeIsTheSame := true.
							newYearTypeCode := localCalendarDay yearTypeCode.
							daysInMonth := localCalendarDay yearlyCalendar daysInMonthAt: newMonth]
						ifFalse: 
							[newYearTypeCode := self calendar typeCodeOfYear: newYear.
							daysInMonth := 
								newYearTypeCode = localCalendarDay yearTypeCode 
									ifTrue: 
										[yearTypeCodeIsTheSame := true.
										localCalendarDay yearlyCalendar daysInMonthAt: newMonth]
									ifFalse: 
										[yearTypeCodeIsTheSame := false.
										self calendar daysInMonth: newMonth forYearTypeCode: newYearTypeCode]].
					dayOfMonth > daysInMonth ifTrue: [dayOfMonth := daysInMonth].
					newCalendarDay := 
						yearTypeCodeIsTheSame 
							ifTrue: [localCalendarDay yearlyCalendar basicMonthAt: newMonth dayAt: dayOfMonth]
							ifFalse: 
								[self calendar 
									calendarDayFromMonth: newMonth
									day: dayOfMonth
									forYearTypeCode: newYearTypeCode].
					days isInteger
						ifTrue: 
							[daysToAdd := days.
							dayFraction := 0]
						ifFalse: 
							[daysToAdd := days truncated.
							dayFraction := days - daysToAdd].
					monthFraction = 0
						ifFalse: 
							[| delta iDelta |
							delta := monthFraction * daysInMonth.
							iDelta := delta truncated.
							daysToAdd := daysToAdd + iDelta.
							dayFraction := (delta - iDelta) + dayFraction.
							dayFraction >= 1
								ifTrue:
									[daysToAdd := daysToAdd + 1.
									dayFraction := dayFraction - 1]
								ifFalse:
									[dayFraction >= -1
										ifTrue: 
											[daysToAdd := daysToAdd - 1.
											dayFraction := dayFraction + 1]]].
					daysToAdd = 0
						ifTrue: 
							[self 
								setYear: newYear 
								calendarDay: newCalendarDay]
						ifFalse: 
							[newCalendarDay 
								startingWithYear: newYear 
								addingDays: daysToAdd 
								setYearAndCalendarDayInto: [:y :cd | self setYear: y calendarDay: cd]]]].
	^dayFraction! !

!AbstractDate methodsFor: 'private-arithmetic' stamp: ''!
basicAddYears: years 
	"Add the given number of civil years to the date represented by the receiver.  The civil intra-year date in the new year will be the same as in the old year, unless it would be invalid.  For example, if the orignal date is March 1 in a Gregorian/Julian leap year, the date in the new year will remain March 1 after adding the specified years.  However, if the original date is February 29 and the new year is not a leap year, then the new date will be Feb 28.  

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal.  If intercalary months may occur at times other than the end of the year, the Calendar system's cultural tradition will be respected regarding the semantics of 'same civil date N years later (or earlier.)'  The implementation assumes that the only issue in that respect is whether or not 'same month' is defined by the monthOrdinal or by the monthKey (by definition of a Chronos monthKey, months with the same monthKey are semantically the same month, regardless of possibly having different monthOrdinals in different years--which does happen in some Calendars!!.)

	The <years> parameter may be a fractional number, in which case it will be converted to an integer value with a fractional remainder.  The fractional remainder (which may be zero) will be multiplied by the number of days in the year which resulted from adding the integer number of years, and that value will be answered by the method."

	| intYears yearFraction |
	self assertMutability.
	years isInteger 
		ifTrue: 
			[intYears := years.
			yearFraction := 0]
		ifFalse:
			[intYears := years truncated.
			yearFraction := years - intYears].
	self yearAndCalendarDayDo: 
		[:localYear :localCalendarDay | 
		| yearNumberingPolicy newYear newYearTypeCode newCalendarDay |
		yearNumberingPolicy := self calendar yearNumberingPolicy.
		newYear := yearNumberingPolicy canonicalFromOrdinal: (yearNumberingPolicy ordinalFromCanonical: localYear) + intYears.
		newYearTypeCode := self calendar typeCodeOfYear: newYear.
		newYearTypeCode = localCalendarDay yearTypeCode 
			ifTrue: [newCalendarDay := localCalendarDay]
			ifFalse: 
				["When the yearTypeCode differs, the calendarDay MUST be replaced by one that is bound to the correct yearTypeCode.  There is also the possibility that the old calendarDay's monthOrdinal and/or dayOfMonthOrdinal will no longer be valid."
				| monthOrdinal daysInMonth |
				monthOrdinal := 
					self calendar yearArithmeticPreferablyPreservesMonthOrdinal 
						ifTrue: [localCalendarDay monthOrdinal	"Usual case."]
						ifFalse: [self calendar monthOrdinalForMonthWithKey: localCalendarDay monthKey forYearTypeCode: newYearTypeCode].
				self calendar isMonthsPerYearInvariant 
					ifFalse: 
						["Most calendars have an invariant number months in a year.  The one we're dealing with here, unfortunately, can have a different number of months in different years."
						| monthsInYear |
						monthOrdinal > (monthsInYear := self calendar monthsInYearForYearTypeCode: newYearTypeCode) 
								ifTrue: 
									["The monthOrdinal is not valid for a year of this type.  Use the monthOrdinal of the last month of the year."
									monthOrdinal := monthsInYear	"Collapses ALL the intercalary months, if more than one in the old year--which can happen!!"]].
					newCalendarDay := 
						localCalendarDay dayOfMonthOrdinal > (daysInMonth := self calendar daysInMonth: monthOrdinal forYearTypeCode: newYearTypeCode) 
							ifTrue: 
								["The dayOfMonth is not valid for this month in a year of this type. Use the last dayOfMonth."
								self calendar 
									calendarDayFromMonth: monthOrdinal
									day: daysInMonth
									forYearTypeCode: newYearTypeCode]
							ifFalse: 
								[self calendar 
									calendarDayFromMonth: monthOrdinal
									day: localCalendarDay dayOfMonthOrdinal
									forYearTypeCode: newYearTypeCode]].
		self 
			setYear: newYear 
			calendarDay: newCalendarDay].
	^yearFraction = 0
		ifTrue: [0]
		ifFalse: [yearFraction * self daysInYear]! !

!AbstractDate methodsFor: 'private-initialize-release' stamp: ''!
basicSetCalendar: aCalendar
	self assertMutability.
	calendar := aCalendar! !

!AbstractDate methodsFor: 'private-initialize-release' stamp: ''!
basicSetDaysSinceEpoch: daysSinceEpoch 
	self calendar 
		forDaysSinceEpoch: daysSinceEpoch truncated
		setYearAndCalendarDayInto: self! !

!AbstractDate methodsFor: 'private-initialize-release' stamp: ''!
basicSetSecondsSinceEpoch: seconds 
	self basicSetDaysSinceEpoch: (seconds truncated bitShift: -7) // 675 	"128 * 675 = 86400"	"Bit shifting is faster than LargeInteger math."! !

!AbstractDate methodsFor: 'private-initialize-release' stamp: ''!
basicSetYear: aYear calendarDay: aCalendarDay 
	self value: aYear value: aCalendarDay.! !

!AbstractDate methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:30'!
calendar
	"Answer the Calendar that implements the calendrical system associated with the receiver."

	calendar == nil ifTrue: [calendar := (AnsiStandardCalendar)].
	^calendar! !

!AbstractDate methodsFor: 'accessing' stamp: ''!
comparisonClassIdentifier	
	"Answer a value that identifies the group of comparable values to which the receiver belongs.  It must be valid to use #== to compare two identifiers for equality."

	^#DateAndTime! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
convertToCalendar: otherCalendar 
	"Make the receiver represent a calendrical coordinate whose Calendar is <otherCalendar>, but which represents the same absolute temporal value (e.g., the same day in history) as does the receiver."

	| originalCalendar daysSinceEpoch |
	originalCalendar := self calendar.
	originalCalendar == otherCalendar ifTrue: [^self].
	daysSinceEpoch := self daysSinceEpoch.
	self
		basicSetCalendar: otherCalendar;
		setDaysSinceEpoch: 
			(otherCalendar 
				daysSinceEpochFromForeignDaysSinceEpoch: daysSinceEpoch
				convertingFrom: originalCalendar)! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
dayOfWeekSemanticKeyFrom: aSemanticDatePolicy ifNone: ifNone
	aSemanticDatePolicy forEachSemanticWeeklyEventOccurringOnTheDayOfWeekOf: self do: [:semanticKey :date | ^semanticKey].
	^ifNone value! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
dayOfWeekSemanticKeyFrom: aSemanticDatePolicy satisfies: predicate
	^predicate value: (self dayOfWeekSemanticKeyFrom: aSemanticDatePolicy ifNone: [^false])! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
dayOfWeekSemanticKeyIfNone: ifNone
	^self dayOfWeekSemanticKeyFrom: SemanticDatePolicy default ifNone: ifNone! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
dayOfWeekSemanticKeySatisfies: predicate
	^self dayOfWeekSemanticKeyFrom: SemanticDatePolicy default satisfies: predicate! !

!AbstractDate methodsFor: 'private-arithmetic' stamp: ''!
durationSinceDate: aDate
	^self calendarDurationSince: aDate! !

!AbstractDate methodsFor: 'private-arithmetic' stamp: ''!
durationUntilDate: aDate
	^self calendarDurationUntil: aDate! !

!AbstractDate methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self calendarRegistrationKey! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	self assertMutability.
	calendar := AnsiStandardCalendar! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
initializeFrom: aCalendricalCoordinate 
	self
		basicSetCalendar: aCalendricalCoordinate calendar;
		basicSetDaysSinceEpoch: aCalendricalCoordinate daysSinceEpoch! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self setCalendar: (literalArray at: 2) asSymbol! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
invalidateCalendar
	calendar := calendar == nil ifFalse: [Calendar at: calendar registrationKey ifAbsent: [calendar]]! !

!AbstractDate methodsFor: 'testing' stamp: ''!
isAtStartOfDay
	^true! !

!AbstractDate methodsFor: 'testing' stamp: ''!
isAtStartOfHour
	^true! !

!AbstractDate methodsFor: 'testing' stamp: ''!
isAtStartOfMinute
	^true! !

!AbstractDate methodsFor: 'testing' stamp: ''!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^true! !

!AbstractDate methodsFor: 'semantic keys-examples' stamp: ''!
isNYSETradingHoliday
	"YearMonthDay today isNYSETradingHoliday"
	"(YearMonthDay year: 2004 month: December day: 31) isNYSETradingHoliday" "Friday before New Year's Day--a trading day!!"
	"(YearMonthDay year: 2005 month: March day: 25) isNYSETradingHoliday" "Good Friday"
	"(YearMonthDay year: 2004 month: June day: 11) isNYSETradingHoliday" "Funeral of Ronald Reagan"
	"(YearMonthDay year: 2001 month: September day: 14) isNYSETradingHoliday" "World Trade Center Event"
	"(YearMonthDay year: 1969 month: July day: 21) isNYSETradingHoliday" "Monday after the first Lunar Landing"
	"(YearMonthDay year: 1952 month: November day: 8) isNYSETradingHoliday" "A Saturday--but a trading day!!"
	"(YearMonthDay year: 1933 month: March day: 13) isNYSETradingHoliday" "A Monday--but FDR had all the banks and stock exchanges closed (Great Depression)!!"
	"| count |
	count := 0.
	(YearMonthDay year: 2000 month: January day: 14) 
		through: YearMonthDay today 
		every: 1 
		daysDo: [:date | date isNYSETradingHoliday ifFalse: [count := count + 1]].
	count" "Count of trading days from 2000-01-14 through today."

	^(self 
		semanticKeyFrom: SemanticDatePolicy nyse
		detect: 
			[:semanticKey | 
			semanticKey == #weekend 
				ifTrue: 
					[(self year between: 1873 and: 1952) "Open for a 2-hour trading session on Saturdays from 1873 to 1952!!"
						ifTrue: [self dayOfWeek = Sunday]
						ifFalse: [true]]
				ifFalse: [true]]
		ifNone: []) notNil! !

!AbstractDate methodsFor: 'semantic keys-examples' stamp: ''!
isUSFederalHoliday
	"(YearMonthDay year: 2004 month: 12 day: 31) isUSFederalHoliday"

	^self annualDateSemanticKeyFrom: SemanticDatePolicy unitedStates
		satisfies: 
			[:semanticKey | 
			SemanticDatePolicy usFederalHolidaySemanticKeys includes: semanticKey]! !

!AbstractDate methodsFor: 'semantic keys-examples' stamp: ''!
isWeekendDay
	"(YearMonthDay year: 2006 month: 01 day: 01) isWeekendDay"

	^self dayOfWeekSemanticKeySatisfies: [:semanticKey | semanticKey == #weekend]! !

!AbstractDate methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."
	"If <aChronosPrintPolicy> == ChronosPrintPolicy default (or ChronosPrintPolicy ansiStandard or ChronosPrintPolicy iso8601,) AND if the receiver does not represent a partial date (such as an AnnualDate,) then the receiver's printString will be formatted as required by the ISO 8601 Standard."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printDate: self on: stream! !

!AbstractDate methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^CalendarDayDuration! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
semanticKeyDetect: predicate ifNone: ifNone 
	^self 
		semanticKeyFrom: SemanticDatePolicy default
		detect: predicate
		ifNone: ifNone! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
semanticKeyFrom: aSemanticDatePolicy detect: predicate ifNone: ifNone 
	^aSemanticDatePolicy 
		semanticKeysFor: self
		detect: predicate
		ifNone: ifNone! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
semanticKeys

	"(YearMonthDay year: 2006 month: 1 day: 1) semanticKeys"
	"(YearMonthDay year: 2006 month: 1 day: 2) semanticKeys"
	"(YearMonthDay year: 2005 month: 12 day: 25) semanticKeys"
	"(YearMonthDay year: 2005 month: 12 day: 26) semanticKeys"	

	| set |
	set := Set new.
	self semanticKeysDo: [:semanticKey | set add: semanticKey].
	^set! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
semanticKeysDo: block1 
	^self semanticKeysFrom: SemanticDatePolicy default do: block1! !

!AbstractDate methodsFor: 'semantic keys' stamp: ''!
semanticKeysFrom: aSemanticDatePolicy do: block1
	aSemanticDatePolicy semanticKeysFor: self do: block1! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setCalendar: aCalendar 
	self assertMutability.
	calendar := Calendar referencedBy: aCalendar.! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setDaysSinceEpoch: daysSinceEpoch 
	self basicSetDaysSinceEpoch: daysSinceEpoch! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"
	"{(DateAndTime year: 2003 month: 12 day: 28)
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (DateAndTime isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"
	"{(DateAndTime year: 2003 month: 12 day: 29) 
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (DateAndTime isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"
	"{(DateAndTime year: 2005 month: 1 day: 2) 
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (DateAndTime isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"
	"{(DateAndTime year: 2010 month: 1 day: 3) 
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (DateAndTime isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"
	"{(DateAndTime year: 2010 month: 1 day: 4) 
		isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | 
			(Array with: isoYear with: isoWeek with: isoDayOfWeek) -> (DateAndTime isoYear: isoYear week: isoWeek dayOfWeek: isoDayOfWeek)]}"

	| daysSinceEpochUpToYear daysSinceEpochOfFourthDayOfYear dayOfWeekCardinalOfFourthDayOfYear daysSinceEpochOfFirstDayOfISO8601Year daysSinceEpoch |
	daysSinceEpochUpToYear := Gregorian daysSinceEpochUpToYear: isoYear.
	daysSinceEpochOfFourthDayOfYear := daysSinceEpochUpToYear + 3.
	dayOfWeekCardinalOfFourthDayOfYear := Gregorian daysSinceStartOfISOWeekFromDaysSinceEpoch: daysSinceEpochOfFourthDayOfYear.
	daysSinceEpochOfFirstDayOfISO8601Year := daysSinceEpochOfFourthDayOfYear - dayOfWeekCardinalOfFourthDayOfYear.
	daysSinceEpoch := daysSinceEpochOfFirstDayOfISO8601Year + ((isoWeekOrdinal - 1) * 7) + (isoDayOfWeekOrdinal - 1).
	Gregorian 
		forDaysSinceEpoch: daysSinceEpoch 
		setYearAndCalendarDayInto: self! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setJulianDay: julianDay 
	self basicSetDaysSinceEpoch: (self calendar daysSinceEpochFromJulianDay: julianDay)! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds 
	self setJulianDay: julianDay! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setJulianDayNumber: julianDayNumber
	self basicSetDaysSinceEpoch: (self calendar daysSinceEpochFromJulianDay: julianDayNumber)! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setNanosecondsSinceEpoch: nanoseconds
	self setSecondsSinceEpoch: (nanoseconds bitShift: -9) // 1953125! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setSecondsSinceEpoch: seconds 
	self basicSetSecondsSinceEpoch: seconds.! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setYear: aYear calendarDay: aCalendarDay 
	self basicSetYear: aYear calendarDay: aCalendarDay.! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setYear: y dayOfYearOrdinal: dayOfYearOrdinal
	| cd |
	cd := (self calendar yearlyCalendarFor: y) dayAt: dayOfYearOrdinal.
	cd == nil ifTrue: [self signalError: 'Invalid ordinal date: year=', y printString, ' dayOfYearOrdinal=', dayOfYearOrdinal printString].
	self basicSetYear: y calendarDay: cd! !

!AbstractDate methodsFor: 'initialize-release' stamp: ''!
setYear: y monthOrdinal: m dayOfMonthOrdinal: d
	"{DateFactory year: 1969 month: 7 day: 20}"
	"{DateFactory year: 1969 month: 2 day: 29}"
	"{DateFactory year: 2001 month: 13 day: 0}"

	| cd |
	cd := self calendar calendarDayFromMonth: m day: d inYear: y.
	cd == nil
		ifTrue:
			[| errorMessage |
			errorMessage := String new writeStream.
			errorMessage nextPutAll: 'Invalid date designation:'; cr.
			self calendar validateYear: y month: m day: d ifInvalid: [:problems | 
				problems keysAndValuesDo: [:parameter :problem | 
					errorMessage
						tab;
						nextPutAll: parameter;
						nextPutAll: ' => ';
						nextPutAll: problem;
						cr]].
			self signalError: errorMessage contents].
	self basicSetYear: y calendarDay: cd.! !

!AbstractDate methodsFor: 'private' stamp: ''!
value: aYear value: aCalendarDay 
	^self subclassResponsibility! !

AbstractDate subclass: #AnnualDate
	instanceVariableNames: ''
	classVariableNames: 'Registry'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!AnnualDate commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:

!

!AnnualDate class methodsFor: 'accessing' stamp: ''!
at: selfDesribingKey 
	"Answers a flyweight instance of an AnnualDate as specified by <selfDesribingKey>.  If no AnnualDate with the same value is currently registered as a flyweight, a new one will be created and registered."

	| key value |
	key := selfDesribingKey asSymbol.
	value := self registry at: key ifAbsentPut: [self decodeFrom: selfDesribingKey readStream].
	value == nil 
		ifTrue: 
			[value := self decodeFrom: selfDesribingKey readStream.
			self registry at: key put: value].
	^value! !

!AnnualDate class methodsFor: 'accessing' stamp: ''!
at: selfDescribingKey ifAbsent: block0
	"Answers a flyweight instance of an AnnualDate as specified by <selfDesribingKey>.  If no AnnualDate with the same value is currently registered as a flyweight, the result of evaluating <block0> will be returned."

	| value |
	value := self registry at: selfDescribingKey asSymbol ifAbsent: [^block0 value].
	^value == nil	
		ifTrue: [block0 value]
		ifFalse: [value]! !

!AnnualDate class methodsFor: 'instance creation' stamp: ''!
decodeFrom: stream
	"{AnnualDate decodeFrom: (WeekOfMonthDayOfWeek month: October week: 0 dayOfWeek: Sunday) encodedString readStream}"
	"{AnnualDate decodeFrom: GregorianEaster canonical encodedString readStream}"
	
	ChronosFunction skipSeparators: stream.
	(stream peekFor: $()
		ifFalse: [^self signalError: 'Invalid encoding format--must begin with `(`'].
	^self decodeFromLiteralArray: (ChronosFunction componentsFromString: (ChronosFunction nextFrom: stream until: [:ch | ch = $)]) separator: $|)! !

!AnnualDate class methodsFor: 'instance creation' stamp: ''!
gregorianNewYear
	^self newYearsDayInCalendar: Gregorian! !

!AnnualDate class methodsFor: 'class initialization' stamp: ''!
initialize
	"AnnualDate initialize."

	Registry := nil! !

!AnnualDate class methodsFor: 'instance creation' stamp: ''!
newYearsDayInCalendar: calendar
	^DayOfYearFactory  
		ordinal: 1
		calendar: calendar! !

!AnnualDate class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"
	"Parser support not yet implemented."

	^self decodeFrom: stream! !

!AnnualDate class methodsFor: 'accessing' stamp: ''!
referencedBy: aChronosObjectOrChronosObjectLiteralString
	"Anser the value referenced by <aChronosObjectOrChronosObjectLiteralString>. If the value is a key, answer the value bound to the key. If the value is a literal representation of a value encoded as a String, answer the result of decoding the value encoded by the String.  Otherwise, answer the value of <aChronosObjectOrChronosObjectLiteralString> itself."

	aChronosObjectOrChronosObjectLiteralString isString ifFalse: [^aChronosObjectOrChronosObjectLiteralString].
	^self at: aChronosObjectOrChronosObjectLiteralString! !

!AnnualDate class methodsFor: 'private' stamp: ''!
registry
	Registry == nil ifTrue: [Registry := EnvironmentFacade current newWeakDictionary].
	^Registry! !

!AnnualDate class methodsFor: 'examples' stamp: ''!
showDateOfEasterForNextTenYears
	"AnnualDate showDateOfEasterForNextTenYears"

	| year |
	year := GregorianCalendar clock thisYear.
	Transcript cr.
	10 timesRepeat:
		[Transcript cr; show: (GregorianEaster canonical inYear: year) localePrintString.
		year := year + 1].! !

!AnnualDate class methodsFor: 'examples' stamp: ''!
showSelectedJewishHolidaysForThisYearAndNextYear
	"AnnualDate showSelectedJewishHolidaysForThisYearAndNextYear"

	| year roshHoshannah yomKippur khanukkah purim pesach list printSpec |
	year := HebrewCalendar clock thisYear.
	roshHoshannah := 	DayOfMonth monthKey: #Tishri 	day: 1   calendar: #Hebrew.
	yomKippur := 		DayOfMonth monthKey: #Tishri 	day: 10 calendar: #Hebrew.
	khanukkah :=		DayOfMonth monthKey: #Kislev 	day: 25 calendar: #Hebrew.
	purim := 				DayOfMonth monthKey: #Adar 	day: 14 calendar: #Hebrew.
	pesach :=			DayOfMonth monthKey: #Nisan 	day: 15 calendar: #Hebrew.
	list := OrderedCollection new.
	printSpec := #(showDayOfWeekAbbreviation useMonthName dateSeparator: $ datePadChar: nil).
	2 timesRepeat: [
		| hDate |
		hDate := roshHoshannah inYear: year. 
		list add: (Array 
					with: #'Rosh Hoshannah' 
					with: hDate % printSpec 
					with: hDate asGregorian % printSpec).
		hDate := yomKippur inYear: year. 
		list add: (Array
					with: #'Yom Kippur' 
					with: hDate % printSpec 
					with: hDate asGregorian % printSpec).
		hDate := khanukkah inYear: year. 
		list add: (Array 
					with: #'Khanukkah' 
					with: hDate % printSpec 
					with: hDate asGregorian % printSpec).
		hDate := purim inYear: year. 
		list add: (Array 
					with: #'Purim' 
					with: hDate % printSpec 
					with: hDate asGregorian % printSpec).
		hDate := pesach inYear: year. 
		list add: (Array 
					with: #'Pesach' 
					with: hDate % printSpec 
					with: hDate asGregorian % printSpec).
		year := year + 1].
	Transcript cr.
	list do: 
		[:array | 
			Transcript 
				cr; show: (array at: 1); show: ':';  
				cr; tab; show: (array at: 2); 
				cr; tab; show: (array at: 3); 
				show: ' (starting sundown of the day before)']! !

!AnnualDate methodsFor: 'queries' stamp: ''!
ansiDayOfWeekOrdinalInYear: year
	^(self daysSinceStartOfANSIWeekInYear: year) + 1! !

!AnnualDate methodsFor: 'converting' stamp: ''!
asDate
	"Answer the conversion of the receiver into a date-valued CalendricalCoordinate that represents the same date as does the receiver.  If the receiver is already a date-valued CalendricalCoordinate, answer the receiver.  A date-valued CalendricalCoordinate is one that specifies a date without specifying a particular time-of-day nor a particular timezone (i.e., it has nominal time semantics, and its quantum of resolution is 1 calendar day.)"

	^self asMutableDate beImmutable! !

!AnnualDate methodsFor: 'converting' stamp: ''!
asDateAndTimeInUTYear: year timeZone: timeZone
	"GregorianEaster canonical asDateAndTimeInUTYear: 2005 timeZone: 3 hours"

	^self 
		forYear: year 
		monthDayDo: [:month :day | 
			self class dateAndTimeFactory
				utYear: year
				month: month
				day: day
				timeZone: timeZone
				calendar: self calendar]! !

!AnnualDate methodsFor: 'converting' stamp: ''!
asDateAndTimeInYear: year
	"GregorianEaster canonical asDateAndTimeInYear: 2005"

	^self 
		forYear: year 
		monthDayDo: [:month :day | 
			self class dateAndTimeFactory
				year: year
				month: month
				day: day
				calendar: self calendar]! !

!AnnualDate methodsFor: 'converting' stamp: ''!
asDateAndTimeInYear: year timeZone: timeZone
	"GregorianEaster canonical asDateAndTimeInYear: 2005 timeZone: 3 hours"

	^self 
		forYear: year 
		monthDayDo: [:month :day | 
			self class dateAndTimeFactory
				year: year
				month: month
				day: day
				timeZone: timeZone
				calendar: self calendar]! !

!AnnualDate methodsFor: 'converting' stamp: ''!
asDateAndTimeSpecInYear: year
	"GregorianEaster canonical asDateAndTimeSpecInYear: 2005"

	| thisYear |
	thisYear := self year.
	^(DateAndTimeSpec new)
		setYear: thisYear calendarDay: (self calendarDayInYear: thisYear)! !

!AnnualDate methodsFor: 'converting' stamp: ''!
asDateInYear: year
	"GregorianEaster canonical asDateInYear: 2005"

	^(self class dateFactory basicNew)
		basicSetCalendar: self calendar;
		setYear: year calendarDay: (self calendarDayInYear: year)! !

!AnnualDate methodsFor: 'converting' stamp: ''!
asDateSpecInYear: year
	"GregorianEaster canonical asDateSpecInYear: 2005"

	^(DateSpec basicNew)
		setYear: year calendarDay: (self calendarDayInYear: year)! !

!AnnualDate methodsFor: 'converting' stamp: ''!
asFlyweight
	^self class registry at: self selfDescribingKey ifAbsentPut: [self]! !

!AnnualDate methodsFor: 'private' stamp: ''!
asMutableDate
	| thisYear |
	thisYear := self year.
	^(self class dateFactory basicNew)
		basicSetCalendar: self calendar;
		setYear: thisYear calendarDay: (self calendarDayInYear: thisYear)! !

!AnnualDate methodsFor: 'private' stamp: ''!
asMutableDateAndTime
	| thisYear |
	thisYear := self year.
	^(self class dateAndTimeFactory basicNew)
		basicSetCalendar: self calendar;
		basicSetYear: thisYear calendarDay: (self calendarDayInYear: thisYear);
		canonicalize! !

!AnnualDate methodsFor: 'private' stamp: ''!
asMutableDateAndTimeInvariantToUT
	| thisYear |
	thisYear := self year.
	^(self class dateAndTimeFactory basicNew)
		basicSetCalendar: self calendar;
		basicSetYear: thisYear calendarDay: (self calendarDayInYear: thisYear);
		canonicalizeFromLocalTime! !

!AnnualDate methodsFor: 'private' stamp: ''!
basicComputeDaysSinceEpoch
	^self daysSinceEpochInYear: self year! !

!AnnualDate methodsFor: 'accessing' stamp: ''!
calendarDay
	^self calendarDayInYear: self year! !

!AnnualDate methodsFor: 'queries' stamp: ''!
calendarDayInYear: year 
	^self subclassResponsibility! !

!AnnualDate methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToAnnualDate: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == aCalendrical and: [ex message selector == #compareToAnnualDate:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!AnnualDate methodsFor: 'private-comparing' stamp: ''!
compareToCalendricalCoordinate: aCalendricalCoordinate
	^self compareToDate: aCalendricalCoordinate! !

!AnnualDate methodsFor: 'private-comparing' stamp: ''!
compareToDate: aDate
	| leftComparand leftComparandDayOfYear delta |
	leftComparand := 
		aDate calendar == self calendar
			ifTrue: [aDate]
			ifFalse: [aDate as: self calendar].
	leftComparandDayOfYear := leftComparand dayOfYear.
	delta := leftComparandDayOfYear - self maxDayOfYearOrdinal.
	delta > 0 ifTrue: [^delta].
	delta := leftComparandDayOfYear - self minDayOfYearOrdinal.
	delta < 0 ifTrue: [^delta].
	^leftComparandDayOfYear - (self dayOfYearOrdinalInYear: leftComparand year)! !

!AnnualDate methodsFor: 'private-comparing' stamp: ''!
compareToDateAndTime: aDateAndTime
	^self compareToDate: aDateAndTime! !

!AnnualDate methodsFor: 'private-comparing' stamp: ''!
compareToDayOfMonth: aDayOfMonth
	| diff |
	aDayOfMonth == self ifTrue: [^0].
	aDayOfMonth calendar = self calendar ifFalse: [^nil].
	diff := aDayOfMonth minDayOfYearOrdinal - self minDayOfYearOrdinal.
	diff = 0 ifFalse: [^diff].
	^aDayOfMonth maxMinDayOfYearDelta - self maxMinDayOfYearDelta! !

!AnnualDate methodsFor: 'private-comparing' stamp: ''!
compareToDayOfYear: aDayOfYear
	| diff |
	aDayOfYear == self ifTrue: [^0].
	aDayOfYear calendar = self calendar ifFalse: [^nil].
	diff := aDayOfYear minDayOfYearOrdinal - self minDayOfYearOrdinal.
	diff = 0 ifFalse: [^diff].
	^aDayOfYear maxMinDayOfYearDelta - self maxMinDayOfYearDelta! !

!AnnualDate methodsFor: 'private-comparing' stamp: ''!
compareToMonth: aMonth
	| diff |
	aMonth == self ifTrue: [^0].
	aMonth calendar = self calendar ifFalse: [^nil].
	diff := aMonth minDayOfYearOrdinal - self minDayOfYearOrdinal.
	diff = 0 ifFalse: [^diff].
	^aMonth maxMinDayOfYearDelta - self maxMinDayOfYearDelta! !

!AnnualDate methodsFor: 'private-comparing' stamp: ''!
compareToWeekOfMonthDayOfWeek:  aWeekOfMonthDayOfWeek
	| diff |
	aWeekOfMonthDayOfWeek == self ifTrue: [^0].
	aWeekOfMonthDayOfWeek calendar == self calendar ifFalse: [^nil].
	diff := aWeekOfMonthDayOfWeek minDayOfYearOrdinal - self minDayOfYearOrdinal.
	diff = 0 ifFalse: [^diff].
	^aWeekOfMonthDayOfWeek maxMinDayOfYearDelta - self maxMinDayOfYearDelta! !

!AnnualDate methodsFor: 'private-comparing' stamp: ''!
compareToYearMonthDaySpec: aYMDSpec

	^(self calendarDayInYear: aYMDSpec year) compareTo: aYMDSpec calendarDay! !

!AnnualDate methodsFor: 'converting' stamp: ''!
dateSpec
	| year |
	year := self year.
	^DateSpec year: year calendarDay: (self calendarDayInYear: year)! !

!AnnualDate methodsFor: 'queries' stamp: ''!
dayOfMonthOrdinalInYear: year
	^(self calendarDayInYear: year) dayOfMonthOrdinal! !

!AnnualDate methodsFor: 'queries' stamp: ''!
dayOfYearOrdinalInYear: year
	^(self calendarDayInYear: year) dayOfYearOrdinal! !

!AnnualDate methodsFor: 'queries' stamp: ''!
daysInMonthInYear: year
	^(self calendarDayInYear: year) daysPerMonth! !

!AnnualDate methodsFor: 'queries' stamp: ''!
daysSinceEpochInYear: year
	^(self calendar daysSinceEpochUpToYear: year) + (self daysSinceStartOfYearInYear: year)! !

!AnnualDate methodsFor: 'queries' stamp: ''!
daysSinceStartOfANSIWeekInYear: year
	^self calendar 
		daysSinceStartOfANSIWeekFromDaysSinceEpoch: (self daysSinceEpochInYear: year)! !

!AnnualDate methodsFor: 'queries' stamp: ''!
daysSinceStartOfISOWeekInYear: year
	^self calendar 
		daysSinceStartOfISOWeekFromDaysSinceEpoch: (self daysSinceEpochInYear: year)! !

!AnnualDate methodsFor: 'queries' stamp: ''!
daysSinceStartOfMonthInYear: year
	^(self calendarDayInYear: year) daysSinceStartOfMonth! !

!AnnualDate methodsFor: 'queries' stamp: ''!
daysSinceStartOfYearInYear: year
	^(self calendarDayInYear: year) daysSinceStartOfYear! !

!AnnualDate methodsFor: 'queries' stamp: ''!
daysSinceUnificationEpochInYear: year
	^(self daysSinceEpochInYear: year) + self calendar unificationDayNumberOfEpoch! !

!AnnualDate methodsFor: 'queries' stamp: ''!
daysUpToMonthSinceStartOfYearInYear: year
	^(self calendarDayInYear: year) daysSinceStartOfMonth! !

!AnnualDate methodsFor: 'printing' stamp: ''!
encodeOn: stream 
	| literalArray encodeAspect |
	literalArray := self literalArrayEncoding.
	encodeAspect := [:value | 
		value isString 
			ifTrue: [stream nextPutAll: value]
			ifFalse: [stream print: value]].
	literalArray at: 1 put: self class name.
	stream nextPut: $(.
	1 to: literalArray size - 1 do: 
			[:index | 
			encodeAspect value: (literalArray at: index).
			stream nextPut: $|].
	encodeAspect value: literalArray last.	
	stream nextPut: $).! !

!AnnualDate methodsFor: 'printing' stamp: ''!
encodedString
	| stream |
	stream := (String new: 320) writeStream.
	self encodeOn: stream.
	^stream contents! !

!AnnualDate methodsFor: 'queries' stamp: ''!
forYear: year monthDayDo: block2
	^(self calendarDayInYear: year) monthDayDo: block2! !

!AnnualDate methodsFor: 'accessing' stamp: ''!
identifiers
	| identifiers |
	identifiers := (Array new: 1) writeStream.
	self identifiersDo: [:key :value | identifiers nextPut: key->value].
	^identifiers contents! !

!AnnualDate methodsFor: 'accessing' stamp: ''!
identifiersDo: block2
	block2 value: #className value: self class name.
	block2 value: #calendar value: self calendarRegistrationKey! !

!AnnualDate methodsFor: 'queries' stamp: ''!
inYear: year 
	^(self class dateFactory basicNew)
		basicSetCalendar: self calendar;
		setYear: year calendarDay: (self calendarDayInYear: year)! !

!AnnualDate methodsFor: 'testing' stamp: ''!
isDayOfMonthInvariant
	^false! !

!AnnualDate methodsFor: 'testing' stamp: ''!
isDayOfWeekInvariant
	^false! !

!AnnualDate methodsFor: 'testing' stamp: ''!
isDayOfYearInvariant
	^false! !

!AnnualDate methodsFor: 'testing' stamp: ''!
isMonthKeyInvariant
	^false! !

!AnnualDate methodsFor: 'testing' stamp: ''!
isMonthOrdinalInvariant
	^false! !

!AnnualDate methodsFor: 'testing' stamp: ''!
isWeekOfMonthInvariant
	^false! !

!AnnualDate methodsFor: 'queries' stamp: ''!
isoDayOfWeekOrdinalInYear: year
	^(self daysSinceStartOfISOWeekInYear: year) + 1! !

!AnnualDate methodsFor: 'queries' stamp: ''!
julianDayInYear: year
	^self calendar 
		julianDayFromDaysSinceEpoch: (self daysSinceEpochInYear: year)! !

!AnnualDate methodsFor: 'deprecated' stamp: ''!
lastYear
	^self inYear: self year - 1! !

!AnnualDate methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinal
	^self calendar maxDaysPerYear! !

!AnnualDate methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinalForYearOfType: yearTypeCode
	^(self calendar yearlyCalendarForYearTypeCode: yearTypeCode) daysPerYear! !

!AnnualDate methodsFor: 'accessing' stamp: ''!
maxMinDayOfYearDelta
	^self maxDayOfYearOrdinal - self minDayOfYearOrdinal! !

!AnnualDate methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinal
	^1! !

!AnnualDate methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinalForYearOfType: yearTypeCode
	^1! !

!AnnualDate methodsFor: 'queries' stamp: ''!
monthKeyInYear: year
	^(self calendarDayInYear: year) monthKey! !

!AnnualDate methodsFor: 'queries' stamp: ''!
monthOrdinalInYear: year 
	^(self calendarDayInYear: year) monthOrdinal! !

!AnnualDate methodsFor: 'queries' stamp: ''!
monthsSinceStartOfYearInYear: year
	^(self calendarDayInYear: year) monthsSinceStartOfYear! !

!AnnualDate methodsFor: 'queries' stamp: ''!
nextYear
	^self inYear: self year + 1! !

!AnnualDate methodsFor: 'queries' stamp: ''!
numericMonthDesignatorInYear: year 
	^(self calendarDayInYear: year) numericMonthDesignator! !

!AnnualDate methodsFor: 'queries' stamp: ''!
prevYear
	^self inYear: self year - 1! !

!AnnualDate methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printAnnualDate: self on: stream! !

!AnnualDate methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processAnnualDate: self! !

!AnnualDate methodsFor: 'private' stamp: ''!
resolveMonthKeyFromMonthOrdinal: monthOrdinal forYearTypeCode: yearTypeCode
	^self calendar monthKeyForMonthAt: monthOrdinal forYearTypeCode: yearTypeCode! !

!AnnualDate methodsFor: 'private' stamp: ''!
resolveMonthOrdinalFromMonthKey: monthKey forYearTypeCode: yearTypeCode
	^self calendar monthOrdinalForMonthWithKey: monthKey forYearTypeCode: yearTypeCode! !

!AnnualDate methodsFor: 'queries' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsSinceEpochInYear: year
	^(self daysSinceEpochInYear: year) * SecondsPerDay! !

!AnnualDate methodsFor: 'accessing' stamp: ''!
selfDescribingKey
	^self encodedString asSymbol! !

!AnnualDate methodsFor: 'accessing' stamp: ''!
semanticKey
	^self class name! !

!AnnualDate methodsFor: 'queries' stamp: ''!
startingAt: firstYear forYears: years 
	^years >= 0 
		ifTrue: 
			[| list |
			list := SequenceFactory new: years.
			0 to: years - 1 do: [:i | list add: (self inYear: firstYear + i)].
			list]
		ifFalse: [self startingAt: firstYear + years + 1 forYears: years negated]! !

!AnnualDate methodsFor: 'converting' stamp: ''!
thisYear
	^self inYear: self year! !

!AnnualDate methodsFor: 'accessing' stamp: ''!
year
	^self clock thisYear! !

!AnnualDate methodsFor: 'accessing-multivalued' stamp: ''!
yearAndCalendarDayDo: block2
	| year |
	year := self year. 
	^block2 value: year value: (self calendarDayInYear: year)! !

AnnualDate subclass: #CalendricalAnnualDate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!CalendricalAnnualDate commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!CalendricalAnnualDate class methodsFor: 'instance creation-local time' stamp: ''!
today
	^self basicNew
		initializeFrom: AnsiStandardCalendarClock today;
		beImmutable! !

!CalendricalAnnualDate class methodsFor: 'instance creation-local time' stamp: ''!
todayAs: aCalendar
	^self basicNew
		initializeFrom: ((Calendar referencedBy: aCalendar) clock today);
		beImmutable! !

!CalendricalAnnualDate class methodsFor: 'instance creation-local time' stamp: ''!
todayIn: aTimezone
	^self basicNew
		initializeFrom: (AnsiStandardCalendarClock todayIn: aTimezone);
		beImmutable! !

!CalendricalAnnualDate class methodsFor: 'instance creation-local time' stamp: ''!
todayIn: aTimezone as: aCalendar
	^self basicNew
		initializeFrom: ((Calendar referencedBy: aCalendar) clock todayIn: aTimezone);
		beImmutable! !

!CalendricalAnnualDate methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinalForYearOfType: yearTypeCode
	^self maxDayOfYearOrdinalForYearOfType: yearTypeCode! !

!CalendricalAnnualDate methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processCalendricalAnnualDate: self! !

CalendricalAnnualDate subclass: #DayOfYear
	instanceVariableNames: 'dayOfYearOrdinal'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!DayOfYear commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!DayOfYear class methodsFor: 'examples' stamp: ''!
firstDayOfYear: year inCalendar: calendar
	"{(DayOfYear firstDayOfYear: 2004 inCalendar: Calendar julian) asGregorian}"
	"Note: Don't use this method for real work.  It's only an example.  The right way to do this is to either create and reuse a cached set of DayOfYear instances to do computations of this nature, or else to create an instance of DateAndTime using 'DateAndTime year: year month: 1 day: 1 calendar: calendar'].  The DayOfYear instance would be the preferred solution when there are a finite set of dayOfYear ordinals whose full date must be repeatedly computed for various years (e.g., holidays.)  The DateAndTime (a.k.a. Timepoint) instance would be the preferred solution when the full date is known in advance, or when neither the dayOfYearOrdinal nor the month/dayOfMonth are knowable in advance."

	^(DayOfYearFactory ordinal: 1 calendar: calendar) inYear: year! !

!DayOfYear class methodsFor: 'constants' stamp: ''!
lastDayOfYear
	^0! !

!DayOfYear class methodsFor: 'examples' stamp: ''!
lastDayOfYear: year inCalendar: calendar
	"{(DayOfYear lastDayOfYear: 2004 inCalendar: Calendar julian) asGregorian}"
	"Note: Don't use this method for real work.  It's only an example.  The right way to do this is to either create and reuse a cached set of DayOfYear instances to do computations of this nature, or else to create an instance of DateAndTime using 'DateAndTime year: year month: 12 day: 31 calendar: calendar' (or whatever the lastMonth/lastDayOfMonth ordinals are for the calendar in question--an issue which highlights one reason why you might want to use a DayOfYear instance instead of a DateAndTime.)  The DayOfYear instance would be the preferred solution when there are a finite set of dayrOfYear ordinals whose full date must be repeatedly computed for various years (e.g., holidays.)  The DateAndTime (a.k.a. Timepoint) instance would be the preferred solution when the full date is known in advance, or when neither the dayOfYearOrdinal nor the month/dayOfMonth are knowable in advance."

	^(DayOfYearFactory ordinal: DayOfYearFactory lastDayOfYear calendar: calendar) inYear: year! !

!DayOfYear class methodsFor: 'instance creation' stamp: ''!
ordinal: dayOfYearOrdinal
	^self new
		setDayOfYearOrdinal: dayOfYearOrdinal;
		beImmutable! !

!DayOfYear class methodsFor: 'instance creation' stamp: ''!
ordinal: dayOfYearOrdinal calendar: aCalendar
	^self new
		setCalendar: aCalendar;
		setDayOfYearOrdinal: dayOfYearOrdinal;
		beImmutable! !

!DayOfYear methodsFor: 'queries' stamp: ''!
calendarDayInYear: year 
	^self calendar 
		calendarDayFromDayOfYearOrdinal: (self dayOfYearOrdinalInYear: year)
		inYear: year! !

!DayOfYear methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToDayOfYear: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == aCalendrical and: [ex message selector == #compareToDayOfYear:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!DayOfYear methodsFor: 'private-comparing' stamp: ''!
compareToDayOfYear: aDayOfYear
	aDayOfYear == self ifTrue: [^0].
	aDayOfYear calendar = self calendar ifFalse: [^nil].
	^aDayOfYear minDayOfYearOrdinal - self minDayOfYearOrdinal! !

!DayOfYear methodsFor: 'accessing' stamp: ''!
dayOfYearOrdinal
	^dayOfYearOrdinal! !

!DayOfYear methodsFor: 'queries' stamp: ''!
dayOfYearOrdinalInYear: year 
	^dayOfYearOrdinal > 0 
		ifTrue: [dayOfYearOrdinal]
		ifFalse: [(self calendar daysInYear: year) + dayOfYearOrdinal]! !

!DayOfYear methodsFor: 'accessing' stamp: ''!
daysSinceStartOfYear
	"Answer the number of days since the first day of the receiver's year up to (but not including) the day represented by the receiver. The answer is the CARDINAL number of the day of the year represented by the receiver."

	^self dayOfYearOrdinal - 1! !

!DayOfYear methodsFor: 'queries' stamp: ''!
daysSinceStartOfYearInYear: year
	^(self dayOfYearOrdinalInYear: year) - 1! !

!DayOfYear methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self dayOfYearOrdinal! !

!DayOfYear methodsFor: 'comparing' stamp: ''!
hash
	^dayOfYearOrdinal hash! !

!DayOfYear methodsFor: 'accessing' stamp: ''!
identifiersDo: block2
	super identifiersDo: block2.
	block2 value: #dayOfYearOrdinal value: self dayOfYearOrdinal! !

!DayOfYear methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.	
	dayOfYearOrdinal := 1.! !

!DayOfYear methodsFor: 'initialize-release' stamp: ''!
initializeFrom: aCalendricalCoordinate
	self 
		basicSetCalendar: aCalendricalCoordinate calendar;
		setDayOfYearOrdinal: aCalendricalCoordinate dayOfYearOrdinal! !

!DayOfYear methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self setDayOfYearOrdinal: (literalArray at: 3) asNumber! !

!DayOfYear methodsFor: 'testing' stamp: ''!
isDayOfYearInvariant
	^dayOfYearOrdinal > 0! !

!DayOfYear methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinal
	^dayOfYearOrdinal > 0 
		ifTrue: [dayOfYearOrdinal]
		ifFalse: [self calendar maxDaysPerYear + dayOfYearOrdinal]! !

!DayOfYear methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinalForYearOfType: yearTypeCode
	^self maxDayOfYearOrdinal! !

!DayOfYear methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinal
	^dayOfYearOrdinal > 0 
		ifTrue: [dayOfYearOrdinal]
		ifFalse: [self calendar minDaysPerYear + dayOfYearOrdinal]! !

!DayOfYear methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printDayOfYear: self on: stream! !

!DayOfYear methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processDayOfYear: self! !

!DayOfYear methodsFor: 'initialize-release' stamp: ''!
setDayOfYearOrdinal: anOrdinal
	self assertMutability.
	dayOfYearOrdinal := anOrdinal! !

!DayOfYear methodsFor: 'private' stamp: ''!
value: aYear value: aCalendarDay
	self setDayOfYearOrdinal: aCalendarDay dayOfYear! !

CalendricalAnnualDate subclass: #MonthOfYear
	instanceVariableNames: 'monthKey monthOrdinal minDayOfYearOrdinal maxDayOfYearOrdinal'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!MonthOfYear commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

MonthOfYear subclass: #DayOfMonth
	instanceVariableNames: 'dayOfMonthOrdinal'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!DayOfMonth commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!DayOfMonth class methodsFor: 'constants' stamp: ''!
lastDayOfMonth
	^0! !

!DayOfMonth class methodsFor: 'examples' stamp: ''!
lastDayOfMonth: month inYear: year
	"DayOfMonth lastDayOfMonth: 2 inYear: 2004"
	"Note: Don't use this method for real work.  It's only an example.  The right way to do this is to create and reuse a cached set of DayOfMonth instances to do computations of this nature. AnnualDates (such as DayOfMonth, DayOfYear and WeekOfMonthDayOfWeek) are the preferred solution when there are a finite set of incomplete date specifications (e.g, {month, dayOfMonth}, {dayOfYear}, {month, weekOfMonth, dayOfWeek}) whose full date must be repeatedly computed for various years (e.g., holidays.)  A DateAndTime (a.k.a. Timepoint) or YearMonthDay (a.k.a, 'Date') instance would be the preferred solution when the full date is known in advance, or when most or all of the date elements cannot be known in advance."

	^(DayOfMonthFactory month: month day: DayOfMonthFactory lastDayOfMonth) inYear: year! !

!DayOfMonth class methodsFor: 'instance creation' stamp: ''!
month: month day: day
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <dayOfMonth> <= 0, then it is interpreted as <dayOfMonth> days from the last day of the month."
	^self new
		setMonthOrdinal: month;
		setDayOfMonthOrdinal: day;
		beImmutable;
		yourself! !

!DayOfMonth class methodsFor: 'instance creation' stamp: ''!
month: month day: day calendar: calendar
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <dayOfMonth> <= 0, then it is interpreted as <dayOfMonth> days from the last day of the month."
	^self new
		setCalendar: calendar;
		setMonthOrdinal: month;
		setDayOfMonthOrdinal: day;
		beImmutable;
		yourself! !

!DayOfMonth class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey day: day
	"If <dayOfMonth> <= 0, then it is interpreted as <dayOfMonth> days from the last day of the month."
	^self new
		setMonthKey: monthKey;
		setDayOfMonthOrdinal: day;
		beImmutable;
		yourself! !

!DayOfMonth class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey day: day calendar: calendar
	"If <dayOfMonth> <= 0, then it is interpreted as <dayOfMonth> days from the last day of the month."
	^self new
		setCalendar: calendar;
		setMonthKey: monthKey;
		setDayOfMonthOrdinal: day;
		beImmutable;
		yourself! !

!DayOfMonth methodsFor: 'converting' stamp: ''!
asDayOfMonth
	^self! !

!DayOfMonth methodsFor: 'queries' stamp: ''!
calendarDayInYear: year 
	| yearTypeCode mOrdinal |
	yearTypeCode := self calendar typeCodeOfYear: year.
	mOrdinal := self monthOrdinalForYearTypeCode: yearTypeCode.
	^self calendar 
		calendarDayFromMonth: mOrdinal
		day: (dayOfMonthOrdinal > 0 
				ifTrue: [dayOfMonthOrdinal]
				ifFalse: 
					[(self calendar daysInMonth: mOrdinal forYearTypeCode: yearTypeCode) + dayOfMonthOrdinal])
		forYearTypeCode: yearTypeCode! !

!DayOfMonth methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToDayOfMonth: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == aCalendrical and: [ex message selector == #compareToDayOfMonth:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!DayOfMonth methodsFor: 'private-comparing' stamp: ''!
compareToDayOfMonth: aDayOfMonth
	aDayOfMonth == self ifTrue: [^0].
	aDayOfMonth calendar = self calendar ifFalse: [^nil].
	^aDayOfMonth minDayOfYearOrdinal - self minDayOfYearOrdinal! !

!DayOfMonth methodsFor: 'private' stamp: ''!
computeMaxDayOfYearOrdinal
	^self maximumDayOfYearOrdinalOfDayOfMonth: 
		(dayOfMonthOrdinal > 0 
			ifTrue: [dayOfMonthOrdinal]
			ifFalse: [self maximumDaysPerMonth + dayOfMonthOrdinal])! !

!DayOfMonth methodsFor: 'private' stamp: ''!
computeMinDayOfYearOrdinal
	^self minimumDayOfYearOrdinalOfDayOfMonth: 
		(dayOfMonthOrdinal > 0 
			ifTrue: [dayOfMonthOrdinal]
			ifFalse: [self minimumDaysPerMonth + dayOfMonthOrdinal])! !

!DayOfMonth methodsFor: 'accessing' stamp: ''!
dayOfMonth
	^dayOfMonthOrdinal! !

!DayOfMonth methodsFor: 'accessing' stamp: ''!
dayOfMonthOrdinal
	^dayOfMonthOrdinal! !

!DayOfMonth methodsFor: 'queries' stamp: ''!
dayOfMonthOrdinalInYear: year 
	^dayOfMonthOrdinal > 0 
		ifTrue: [dayOfMonthOrdinal]
		ifFalse: [(self daysInMonthInYear: year) + dayOfMonthOrdinal]! !

!DayOfMonth methodsFor: 'accessing' stamp: ''!
daysSinceStartOfMonth
	"Answer the number of days since the first day of the receiver's month up to (but not including) the day represented by the receiver. The answer is the CARDINAL number of the day of the month represented by the receiver."

	^dayOfMonthOrdinal - 1! !

!DayOfMonth methodsFor: 'queries' stamp: ''!
daysSinceStartOfMonthInYear: year
	^(self dayOfMonthOrdinalInYear: year) - 1! !

!DayOfMonth methodsFor: 'queries' stamp: ''!
eitherYearMonthDayDo: block3a orYearMonthkeyDayDo: block3b
	"If the receiver's month ordinal is unambigously specified, evaluate <block3a> with the receiver's year, its month ordinal and its day-of-month ordinal as the arguments. Otherwise, evaluate <block3b> with the receiver's year,  the semantic key that identifies the receiver's month and its day-of-month ordinal as the arguments."

	^self isMonthOrdinalResolvable
		ifTrue: [block3a value: nil value: self monthOrdinal value: self dayOfMonthOrdinal]
		ifFalse: [block3b value: nil value: self monthKey value: self dayOfMonthOrdinal]! !

!DayOfMonth methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream nextPut:  self dayOfMonthOrdinal! !

!DayOfMonth methodsFor: 'queries' stamp: ''!
forYear: year monthDayDo: block2 
	^block2 
		value: (self monthOrdinalForYearTypeCode: (self calendar typeCodeOfYear: year))
		value: (self dayOfMonthOrdinalInYear: year)! !

!DayOfMonth methodsFor: 'comparing' stamp: ''!
hash
	^(super hash + dayOfMonthOrdinal) hash! !

!DayOfMonth methodsFor: 'accessing' stamp: ''!
identifiersDo: block2
	super identifiersDo: block2.
	block2 value: #dayOfMonthOrdinal value: self dayOfMonthOrdinal.! !

!DayOfMonth methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.	
	dayOfMonthOrdinal := 1.! !

!DayOfMonth methodsFor: 'initialize-release' stamp: ''!
initializeFrom: aCalendricalCoordinate
	self 
		basicSetCalendar: aCalendricalCoordinate calendar;
		setMonthOrdinal: aCalendricalCoordinate monthOrdinal;
		setDayOfMonthOrdinal: aCalendricalCoordinate dayOfMonthOrdinal! !

!DayOfMonth methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self setDayOfMonthOrdinal: (literalArray at: 4) asNumber! !

!DayOfMonth methodsFor: 'testing' stamp: ''!
isDayOfMonthInvariant
	^dayOfMonthOrdinal > 0! !

!DayOfMonth methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinalForYearOfType: yearTypeCode 
	^self eitherMonthOrdinalDo: 
			[:month | 
			(self calendar 
				calendarDayFromMonth: month
				day: self dayOfMonth
				forYearTypeCode: yearTypeCode) dayOfYear]
		orMonthkeyDo: 
			[:month | 
			(self calendar 
				calendarDayFromMonth: (self resolveMonthOrdinalFromMonthKey: month forYearTypeCode: yearTypeCode)
				day: self dayOfMonth
				forYearTypeCode: yearTypeCode) dayOfYear]! !

!DayOfMonth methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printDayOfMonth: self on: stream! !

!DayOfMonth methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processDayOfMonth: self! !

!DayOfMonth methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^CalendarDayDuration! !

!DayOfMonth methodsFor: 'initialize-release' stamp: ''!
setDayOfMonthOrdinal: dayOfMonth
	"If <dayOfMonth> <= 0, then it is interpreted as <dayOfMonth> days from the last day of the month."
	self assertMutability.
	dayOfMonthOrdinal := dayOfMonth! !

!DayOfMonth methodsFor: 'private' stamp: ''!
value: aYear value: aCalendarDay 
	self
		setMonthOrdinal: aCalendarDay month;
		setDayOfMonthOrdinal: aCalendarDay dayOfMonth! !

!MonthOfYear class methodsFor: 'constants' stamp: ''!
lastMonthOfYear
	^0! !

!MonthOfYear methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	super canonicalize.
	self canonicalizeMonthOrdinal.
	maxDayOfYearOrdinal := self computeMaxDayOfYearOrdinal.
	minDayOfYearOrdinal := self computeMinDayOfYearOrdinal! !

!MonthOfYear methodsFor: 'private' stamp: ''!
canonicalizeMonthOrdinal
	monthOrdinal == nil ifTrue: [^self].
	self calendar isMonthsPerYearInvariant ifFalse: [^self].
	monthOrdinal <= 0
		ifTrue: [monthOrdinal := monthOrdinal + self calendar maxMonthsPerYear]! !

!MonthOfYear methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToMonth: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == aCalendrical and: [ex message selector == #compareToMonth:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!MonthOfYear methodsFor: 'private' stamp: ''!
computeMaxDayOfYearOrdinal 
	^self maximumDayOfYearOrdinalOfDayOfMonth: self maximumDaysPerMonth! !

!MonthOfYear methodsFor: 'private' stamp: ''!
computeMinDayOfYearOrdinal 
	^self minimumDayOfYearOrdinalOfDayOfMonth: 1! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
dayOfYearOrdinalOfDayOfMonth: dayOfMonthOrdinal inYearOfType: yearTypeCode 
	| month daysUpToMonth |
	month := 
		self 
			eitherMonthOrdinalDo: 
				[:mOrdinal | 
				mOrdinal > 0 
					ifTrue: [mOrdinal]
					ifFalse: [(self calendar monthsInYearForYearTypeCode: yearTypeCode) + mOrdinal]]
			orMonthkeyDo: 
				[:mKey | 
				self resolveMonthOrdinalFromMonthKey: mKey forYearTypeCode: yearTypeCode].
	daysUpToMonth := (self calendar yearlyCalendarForYearTypeCode: yearTypeCode) 
				daysUpToMonth: month.
	^(dayOfMonthOrdinal > 0 
		ifTrue: [daysUpToMonth]
		ifFalse: [daysUpToMonth + (self calendar daysInMonth: month forYearTypeCode: yearTypeCode)]) + dayOfMonthOrdinal! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
daysInMonthInYear: year 
	^self eitherMonthOrdinalDo: 
			[:mOrdinal | 
			| yearTypeCode |
			yearTypeCode := self calendar typeCodeOfYear: year.
			self calendar 
				daysInMonth: 
					(mOrdinal > 0 
						ifTrue: [mOrdinal]
						ifFalse: [(self calendar monthsInYearForYearTypeCode: yearTypeCode) + mOrdinal])
				forYearTypeCode:yearTypeCode]
		orMonthkeyDo: 
			[:mKey | 
			(self calendar yearlyCalendarFor: year) daysInMonthWithKey: mKey ifAbsent: []]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
eitherMonthOrdinalDo: block1a orMonthkeyDo: block1b
	"If the receiver's month ordinal is unambigously specified, evaluate <block1a> with the receiver's month ordinal. Otherwise, evaluate <block1b> with the semantic key that identifies the receiver's month."

	^self isMonthOrdinalResolvable
		ifTrue: [block1a value: self monthOrdinal]
		ifFalse: [block1b value: self monthKey]! !

!MonthOfYear methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream nextPut: 
		(monthKey == nil 
			ifTrue: [self monthOrdinal]
			ifFalse: [self monthKey])! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthAbbreviationIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the abbreviation of the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^self 
		monthKeyIfResolvable: [:mKey | resolvable value: ((ChronosLocale referencedBy: aChronosLocale) abbreviationAtSemanticKey: mKey)] 
		ifNot: notResolvable! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthNameIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKkey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^self 
		monthKeyIfResolvable: [:mKey | resolvable value: ((ChronosLocale referencedBy: aChronosLocale) properNameAtSemanticKey: mKey)]
		ifNot: notResolvable! !

!MonthOfYear methodsFor: 'comparing' stamp: ''!
hash
	^((monthOrdinal == nil ifTrue: [monthKey] ifFalse: [monthOrdinal])) hash! !

!MonthOfYear methodsFor: 'accessing' stamp: ''!
identifiersDo: block2
	super identifiersDo: block2.
	monthKey == nil 
		ifTrue: [block2 value: #monthOrdinal value: self monthOrdinal]
		ifFalse: [block2 value: #monthKey value: self monthKey].! !

!MonthOfYear methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	monthOrdinal := 1.
	monthKey := nil! !

!MonthOfYear methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	| month |
	super initializeFromLiteralArray: literalArray.
	month := literalArray at: 3.
	month isString 
		ifTrue: 
			[month first isDigit 
				ifTrue: [self setMonthOrdinal: month asNumber]
				ifFalse: [self setMonthKey: month]]
		ifFalse: [self setMonthOrdinal: month]! !

!MonthOfYear methodsFor: 'testing' stamp: ''!
isMonthKeyInvariant
	^monthKey == nil
		ifTrue: [self calendar doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey]
		ifFalse: [true]! !

!MonthOfYear methodsFor: 'testing' stamp: ''!
isMonthKeyResolvable
	^monthKey notNil or: [self calendar doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey]! !

!MonthOfYear methodsFor: 'testing' stamp: ''!
isMonthOrdinalInvariant
	^monthOrdinal == nil
		ifTrue: [self calendar doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey]
		ifFalse: [monthOrdinal > 0]! !

!MonthOfYear methodsFor: 'testing' stamp: ''!
isMonthOrdinalResolvable
	^monthOrdinal notNil or: [self calendar doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinal 
	maxDayOfYearOrdinal == nil ifTrue: [maxDayOfYearOrdinal := self computeMaxDayOfYearOrdinal].
	^maxDayOfYearOrdinal! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
maximumDayOfYearOrdinalOfDayOfMonth: dayOfMonthOrdinal
	^(self 
		eitherMonthOrdinalDo: 
			[:mOrdinal | 
			self calendar 
				maximumDayOfYearOrdinalForMonth: 
					(mOrdinal > 0 
						ifTrue: [mOrdinal]
						ifFalse: [self calendar maxMonthsPerYear + mOrdinal])
				day: dayOfMonthOrdinal]
		orMonthkeyDo: 
			[:mKey | 
			self calendar 
				maximumDayOfYearOrdinalForMonthWithKey: mKey 
				day: dayOfMonthOrdinal])! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
maximumDaysPerMonth
	^self eitherMonthOrdinalDo: 
			[:mOrdinal | 
			mOrdinal > 0 
				ifTrue: [self calendar maximumDaysInMonth: mOrdinal]
				ifFalse: 
					[(self calendar minMonthsPerYear to: self calendar maxMonthsPerYear) inject: 0
						into: [:max :monthsPerYear | max max: (self calendar maximumDaysInMonth: mOrdinal + monthsPerYear)]]]
		orMonthkeyDo: [:mKey | self calendar maximumDaysInMonthWithKey: mKey]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinal 
	minDayOfYearOrdinal == nil ifTrue: [minDayOfYearOrdinal := self computeMinDayOfYearOrdinal].
	^minDayOfYearOrdinal! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
minimumDayOfYearOrdinalOfDayOfMonth: dayOfMonthOrdinal
	^(self 
		eitherMonthOrdinalDo: 
			[:mOrdinal | 
			self calendar 
				minimumDayOfYearOrdinalForMonth: 
					(mOrdinal > 0 
						ifTrue: [mOrdinal]
						ifFalse: [mOrdinal + self calendar minMonthsPerYear])
				day: dayOfMonthOrdinal]
		orMonthkeyDo: 
			[:mKey | 
			self calendar 
				minimumDayOfYearOrdinalForMonthWithKey: mKey 
				day: dayOfMonthOrdinal])! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
minimumDaysPerMonth
	^self eitherMonthOrdinalDo: 
			[:mOrdinal | 
			mOrdinal > 0 
				ifTrue: [self calendar minimumDaysInMonth: mOrdinal]
				ifFalse: 
					[(self calendar minMonthsPerYear to: self calendar maxMonthsPerYear) 
						inject: self calendar maxDaysPerMonth
						into: [:min :monthsPerYear | min min: (self calendar minimumDaysInMonth: mOrdinal + monthsPerYear )]]]
		orMonthkeyDo: [:mKey | self calendar minimumDaysInMonthWithKey: mKey]! !

!MonthOfYear methodsFor: 'accessing' stamp: ''!
month
	^self monthOrdinal! !

!MonthOfYear methodsFor: 'accessing' stamp: ''!
monthKey
	^(monthKey == nil and: [self calendar doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey])
		ifTrue: 
			[| mKey |
			mKey := self resolveMonthKeyFromMonthOrdinalForYearTypeCode: RegularCalendar standardYearTypeCode.
			self isMonthKeyInvariant
				ifTrue: [monthKey := mKey].
			mKey]
		ifFalse: [monthKey]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
monthKeyIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the key that semantically identifies the receiver's month as the sole argument. However, if the month's semantic key is not unambiguously resolvable, answer the result of evaluationg <notResolvable>. Answer the result of the evaluated block."

	^self isMonthKeyResolvable
		ifTrue: [resolvable value: self monthKey]
		ifFalse: [notResolvable value]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
monthKeyInYear: year
	^monthKey == nil
		ifTrue: 
			[| mKey |
			mKey := self resolveMonthKeyFromMonthOrdinalForYearTypeCode: (self calendar typeCodeOfYear: year).
			self isMonthKeyInvariant
				ifTrue: [monthKey := mKey].
			mKey]
		ifFalse: [monthKey]! !

!MonthOfYear methodsFor: 'accessing' stamp: ''!
monthOrdinal
	^(monthOrdinal == nil and: [self calendar doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey])
		ifTrue: 
			[| mOrdinal |
			mOrdinal := self resolveMonthOrdinalFromMonthKeyForYearTypeCode: RegularCalendar standardYearTypeCode.
			self isMonthOrdinalInvariant ifTrue: [monthOrdinal := mOrdinal].
			mOrdinal]
		ifFalse: [monthOrdinal]! !

!MonthOfYear methodsFor: 'private' stamp: ''!
monthOrdinalForYearTypeCode: yearTypeCode 
	^monthOrdinal == nil 
		ifTrue: 
			[| mOrdinal |
			mOrdinal := self 
						resolveMonthOrdinalFromMonthKeyForYearTypeCode: yearTypeCode.
			self isMonthOrdinalInvariant ifTrue: [monthOrdinal := mOrdinal].
			mOrdinal]
		ifFalse: 
			[monthOrdinal > 0 
				ifTrue: [monthOrdinal]
				ifFalse: [(self calendar monthsInYearForYearTypeCode: yearTypeCode) + monthOrdinal]]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
monthOrdinalIfResolvable: resolvable ifNot: notResolvable
	^self isMonthOrdinalResolvable
		ifTrue: [resolvable value: self monthOrdinal]
		ifFalse: [notResolvable value]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
monthOrdinalInYear: year 
	^monthOrdinal == nil 
		ifTrue: [self monthOrdinalForYearTypeCode: (self calendar typeCodeOfYear: year)]
		ifFalse: 
			[monthOrdinal > 0 
				ifTrue: [monthOrdinal]
				ifFalse: [(self calendar monthsInYear: year) + monthOrdinal]]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
monthsSinceStartOfYearInYear: year 
	^monthOrdinal == nil 
		ifTrue: [super monthsSinceStartOfYearInYear: year]
		ifFalse: [(self monthOrdinalInYear: year) - 1]! !

!MonthOfYear methodsFor: 'queries' stamp: ''!
numericMonthDesignatorInYear: year 
	| ytc |
	ytc := self calendar typeCodeOfYear: year.
	^self calendar numericMonthDesignatorFromMonthOrdinal: ((self monthOrdinalForYearTypeCode: ytc))
		forYearTypeCode: ytc! !

!MonthOfYear methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processMonthOfYear: self! !

!MonthOfYear methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^MonthDuration! !

!MonthOfYear methodsFor: 'private' stamp: ''!
resolveMonthKeyFromMonthOrdinalForYearTypeCode: yearTypeCode 
	^self 
		resolveMonthKeyFromMonthOrdinal: 
			(monthOrdinal > 0 
				ifTrue: [monthOrdinal]
				ifFalse: [(self calendar monthsInYearForYearTypeCode: yearTypeCode) + monthOrdinal])
		forYearTypeCode: yearTypeCode! !

!MonthOfYear methodsFor: 'private' stamp: ''!
resolveMonthOrdinalFromMonthKeyForYearTypeCode: yearTypeCode
	^self resolveMonthOrdinalFromMonthKey: monthKey forYearTypeCode: yearTypeCode! !

!MonthOfYear methodsFor: 'initialize-release' stamp: ''!
setMonthKey: aMonthKey
	"A <aMonthKey> is a Symbol that specifies the name of a month, regardless of the monthOrdinal that may pertain in different years (some calendrical systems assign a different monthOrdinal to months with the same name in different years.)"

	self assertMutability.
	monthKey := aMonthKey asSymbol.
	monthOrdinal := nil! !

!MonthOfYear methodsFor: 'initialize-release' stamp: ''!
setMonthOrdinal: month
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year.  
	Note: In some calendrical systems, months with the same ordinal may have different names (and semantics) in different years."

	self assertMutability.
	monthOrdinal := month.
	monthKey := nil! !

MonthOfYear subclass: #WeekOfMonthDayOfWeek
	instanceVariableNames: 'dayOfWeekOrdinal minDayOfMonthCardinal maxDayOfMonthCardinal daysOffset'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!WeekOfMonthDayOfWeek commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!WeekOfMonthDayOfWeek class methodsFor: 'constants' stamp: ''!
lastDayOfWeek
	^0! !

!WeekOfMonthDayOfWeek class methodsFor: 'constants' stamp: ''!
lastWeekOfMonth
	^0! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
month: monthOrdinal minDayOfMonth: minDayOfMonth dayOfWeek: dayOfWeekOrdinal
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <minDayOfMonth:> <= 0, then it is interpreted as <minDayOfMonth:> days from the last day of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	^self new
		setMonthOrdinal: monthOrdinal;
		setMinDayOfMonthOrdinal: minDayOfMonth dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
month: monthOrdinal minDayOfMonth: minDayOfMonth dayOfWeek: dayOfWeekOrdinal calendar: calendar
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <minDayOfMonth:> <= 0, then it is interpreted as <minDayOfMonth:> days from the last day of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	^self new
		setCalendar: calendar;
		setMonthOrdinal: monthOrdinal;
		setMinDayOfMonthOrdinal: minDayOfMonth dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
month: monthOrdinal minDayOfMonth: minDayOfMonth dayOfWeek: dayOfWeekOrdinal offset: days
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <minDayOfMonth:> <= 0, then it is interpreted as <minDayOfMonth:> days from the last day of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	^self basicNew
		setOffset: days;
		setMonthOrdinal: monthOrdinal;
		setMinDayOfMonthOrdinal: minDayOfMonth dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
month: monthOrdinal minDayOfMonth: minDayOfMonth dayOfWeek: dayOfWeekOrdinal offset: days calendar: calendar
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <minDayOfMonth:> <= 0, then it is interpreted as <minDayOfMonth:> days from the last day of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	^self basicNew
		setCalendar: calendar;
		setOffset: days;
		setMonthOrdinal: monthOrdinal;
		setMinDayOfMonthOrdinal: minDayOfMonth dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
month: monthOrdinal week: weekOfMonthOrdinal dayOfWeek: dayOfWeekOrdinal
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."
	^self new
		setMonthOrdinal: monthOrdinal;
		setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
month: monthOrdinal week: weekOfMonthOrdinal dayOfWeek: dayOfWeekOrdinal calendar: calendar
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."
	^self new
		setCalendar: calendar;
		setMonthOrdinal: monthOrdinal;
		setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
month: monthOrdinal week: weekOfMonthOrdinal dayOfWeek: dayOfWeekOrdinal offset: daysOffset
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."
	^self new
		setMonthOrdinal: monthOrdinal;
		setOffset: daysOffset;
		setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
month: monthOrdinal week: weekOfMonthOrdinal dayOfWeek: dayOfWeekOrdinal offset: days calendar: calendar
	"If <monthOrdinal> <= 0, then it is interpreted as <monthOrdinal> months from the last month of the year."
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."
	^self basicNew
		setCalendar: calendar;
		setOffset: days;
		setMonthOrdinal: monthOrdinal;
		setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey minDayOfMonth: minDayOfMonth dayOfWeek: dayOfWeekOrdinal
	"If <minDayOfMonth:> <= 0, then it is interpreted as <minDayOfMonth:> days from the last day of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	^self new
		setMonthKey: monthKey;
		setMinDayOfMonthOrdinal: minDayOfMonth dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey minDayOfMonth: minDayOfMonth dayOfWeek: dayOfWeekOrdinal calendar: calendar
	"If <minDayOfMonth:> <= 0, then it is interpreted as <minDayOfMonth:> days from the last day of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	^self new
		setCalendar: calendar;
		setMonthKey: monthKey;
		setMinDayOfMonthOrdinal: minDayOfMonth dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey minDayOfMonth: minDayOfMonth dayOfWeek: dayOfWeekOrdinal offset: days
	"If <minDayOfMonth:> <= 0, then it is interpreted as <minDayOfMonth:> days from the last day of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	^self new
		setOffset: days;
		setMonthKey: monthKey;
		setMinDayOfMonthOrdinal: minDayOfMonth dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey minDayOfMonth: minDayOfMonth dayOfWeek: dayOfWeekOrdinal offset: days calendar: calendar
	"If <minDayOfMonth:> <= 0, then it is interpreted as <minDayOfMonth:> days from the last day of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	^self basicNew
		setCalendar: calendar;
		setOffset: days;
		setMonthKey: monthKey;
		setMinDayOfMonthOrdinal: minDayOfMonth dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey week: weekOfMonthOrdinal dayOfWeek: dayOfWeekOrdinal
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."
	^self new
		setMonthKey: monthKey;
		setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey week: weekOfMonthOrdinal dayOfWeek: dayOfWeekOrdinal calendar: calendar
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."
	^self new
		setCalendar: calendar;
		setMonthKey: monthKey;
		setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey week: weekOfMonthOrdinal dayOfWeek: dayOfWeekOrdinal offset: days
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."
	^self new
		setOffset: days;
		setMonthKey: monthKey;
		setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek class methodsFor: 'instance creation' stamp: ''!
monthKey: monthKey week: weekOfMonthOrdinal dayOfWeek: dayOfWeekOrdinal offset: days calendar: calendar
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."
	^self basicNew
		setCalendar: calendar;
		setOffset: days;
		setMonthKey: monthKey;
		setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: dayOfWeekOrdinal;
		beImmutable;
		yourself! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
ansiDayOfWeekOrdinal
	^self calendar 
		ansiDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal: dayOfWeekOrdinal! !

!WeekOfMonthDayOfWeek methodsFor: 'converting' stamp: ''!
asWeekOfMonthDayOfWeek
	^self! !

!WeekOfMonthDayOfWeek methodsFor: 'queries' stamp: ''!
calendarDayInYear: year 
	"Fundamental algorithm for determining the starting and ending days of Daylight Savings Time, and of course also for many Holidays, such as Thanksgiving."

	| daysUpToYear yearTypeCode yearlyCalendar monthNumber daysUpToMonth cardinalEpochDayNumberOfFirstDayOfMonth dayOfMonth  cd |
	daysUpToYear := self calendar daysSinceEpochUpToYear: year.
	yearTypeCode := self calendar typeCodeOfYear: year.
	yearlyCalendar := self calendar yearlyCalendarForYearTypeCode: yearTypeCode.
	monthNumber := self monthOrdinalForYearTypeCode: yearTypeCode.
	daysUpToMonth := yearlyCalendar daysUpToMonth: monthNumber.
	cardinalEpochDayNumberOfFirstDayOfMonth := daysUpToYear + daysUpToMonth.
	minDayOfMonthCardinal < 0 
		ifTrue: 
			[| daysInMonth cardinalEpochDayNumberOfFirstDayOfNextMonth maxDayOfWeekOrdinal  delta |
			daysInMonth := yearlyCalendar daysInMonthAt: monthNumber.
			cardinalEpochDayNumberOfFirstDayOfNextMonth := cardinalEpochDayNumberOfFirstDayOfMonth + daysInMonth.
			maxDayOfWeekOrdinal := self calendar dayOfWeekOrdinalFromDaysSinceEpoch: cardinalEpochDayNumberOfFirstDayOfNextMonth + maxDayOfMonthCardinal.
			delta := maxDayOfWeekOrdinal - dayOfWeekOrdinal.
			delta < 0 ifTrue: [delta := DaysPerWeek + delta].
			dayOfMonth := daysInMonth - delta]
		ifFalse: 
			[| minDayOfWeekOrdinal delta |
			minDayOfWeekOrdinal := self calendar dayOfWeekOrdinalFromDaysSinceEpoch: cardinalEpochDayNumberOfFirstDayOfMonth + minDayOfMonthCardinal.
			delta := dayOfWeekOrdinal - minDayOfWeekOrdinal.
			delta < 0 ifTrue: [delta := DaysPerWeek + delta].
			dayOfMonth := minDayOfMonthCardinal + 1 + delta].
	cd := yearlyCalendar dayAt: daysUpToMonth + dayOfMonth + daysOffset. 
	^cd == nil 
		ifTrue: [(self calendar dateSpecFromDaysSinceEpoch: cardinalEpochDayNumberOfFirstDayOfMonth + daysOffset + dayOfMonth - 1) calendarDay]
		ifFalse: [cd]! !

!WeekOfMonthDayOfWeek methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	super canonicalize.
	dayOfWeekOrdinal := ((dayOfWeekOrdinal - 1) \\ DaysPerWeek) + 1.! !

!WeekOfMonthDayOfWeek methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToWeekOfMonthDayOfWeek: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == aCalendrical and: [ex message selector == #compareToWeekOfMonthDayOfWeek:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!WeekOfMonthDayOfWeek methodsFor: 'private' stamp: ''!
computeMaxDayOfYearOrdinal
	"maxDayOfYearOrdinal is used for comparisons, but not for computing the calendarDay in a given year--so it's OK to add in the daysOffset."

	^(minDayOfMonthCardinal >= 0 
		ifTrue: [self maximumDayOfYearOrdinalOfDayOfMonth: maxDayOfMonthCardinal + 1]
		ifFalse: [self maximumDayOfYearOrdinalOfDayOfMonth: self maximumDaysPerMonth + maxDayOfMonthCardinal + 1]) + daysOffset! !

!WeekOfMonthDayOfWeek methodsFor: 'private' stamp: ''!
computeMinDayOfYearOrdinal 
	"minDayOfYearOrdinal is used for comparisons, but not for computing the calendarDay in a given year--so it's OK to add in the daysOffset."

	^(minDayOfMonthCardinal >= 0 
		ifTrue: [self minimumDayOfYearOrdinalOfDayOfMonth: minDayOfMonthCardinal + 1]
		ifFalse: [self minimumDayOfYearOrdinalOfDayOfMonth: self minimumDaysPerMonth + minDayOfMonthCardinal + 1]) + daysOffset! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
dayOfWeek
	^dayOfWeekOrdinal! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
dayOfWeekKey
	^ANSIDayOfWeekKeys at: dayOfWeekOrdinal! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
daysOffset
	"Needed for 'Day after Thanksgiving' (for example)"

	^daysOffset! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
daysOffset: daysAsInteger
	^self isMutable 
		ifTrue: [self setDaysOffset: daysAsInteger]
		ifFalse: 
			[(self copy)
				setDaysOffset: daysAsInteger;
				beImmutable]! !

!WeekOfMonthDayOfWeek methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut:  self minDayOfMonthOrdinal;
		nextPut: self dayOfWeek;
		nextPut: self daysOffset! !

!WeekOfMonthDayOfWeek methodsFor: 'comparing' stamp: ''!
hash
	^(super hash + minDayOfMonthCardinal + dayOfWeekOrdinal) hash! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
identifiersDo: block2
	super identifiersDo: block2.
	block2 value: #minDayOfMonthOrdinal value: self minDayOfMonthOrdinal.
	block2 value: #dayOfWeek value: self dayOfWeek.
	block2 value: #daysOffset value: daysOffset! !

!WeekOfMonthDayOfWeek methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.	
	minDayOfMonthCardinal := 0.
	maxDayOfMonthCardinal := 6.
	dayOfWeekOrdinal := 1.
	daysOffset := 0 "days"! !

!WeekOfMonthDayOfWeek methodsFor: 'initialize-release' stamp: ''!
initializeFrom: aCalendricalCoordinate 
	self
		basicSetCalendar: aCalendricalCoordinate calendar;
		setMonthOrdinal: aCalendricalCoordinate monthOrdinal;
		setWeekOfMonthOrdinal: aCalendricalCoordinate weekOfMonthOrdinal dayOfWeekOrdinal: aCalendricalCoordinate dayOfWeek;
		setDaysOffset: 0! !

!WeekOfMonthDayOfWeek methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self 
		setMinDayOfMonthOrdinal: (literalArray at: 4) asNumber
		dayOfWeekOrdinal: (literalArray at: 5) asNumber;
		setDaysOffset: (literalArray at: 6) asNumber! !

!WeekOfMonthDayOfWeek methodsFor: 'testing' stamp: ''!
isDayOfWeekInvariant
	^true! !

!WeekOfMonthDayOfWeek methodsFor: 'testing' stamp: ''!
isWeekOfMonthInvariant
	^true! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
isoDayOfWeekOrdinal
	^self calendar 
		isoDayOfWeekOrdinalFromCanonicalDayOfWeekOrdinal: dayOfWeekOrdinal! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
maxDayOfMonthOrdinal
	^maxDayOfMonthCardinal + 1! !

!WeekOfMonthDayOfWeek methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinalForYearOfType: yearTypeCode 
	^self dayOfYearOrdinalOfDayOfMonth: maxDayOfMonthCardinal + 1 inYearOfType: yearTypeCode! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
minDayOfMonthOrdinal
	^minDayOfMonthCardinal + 1! !

!WeekOfMonthDayOfWeek methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinalForYearOfType: yearTypeCode
	^self dayOfYearOrdinalOfDayOfMonth: minDayOfMonthCardinal + 1 inYearOfType: yearTypeCode! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
offset
	^self class durationFactory days: self daysOffset! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
offset: aDuration
	^self copy
		setOffset: aDuration;
		beImmutable! !

!WeekOfMonthDayOfWeek methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printWeekOfMonthDayOfWeek: self on: stream! !

!WeekOfMonthDayOfWeek methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processWeekOfMonthDayOfWeek: self! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^CalendarDayDuration! !

!WeekOfMonthDayOfWeek methodsFor: 'initialize-release' stamp: ''!
setDaysOffset: days
	self assertMutability.
	daysOffset := days == nil ifTrue: [0] ifFalse: [days]! !

!WeekOfMonthDayOfWeek methodsFor: 'initialize-release' stamp: ''!
setMinDayOfMonthOrdinal: minDayOfMonthOrdinal dayOfWeekOrdinal: d
	"If <minDayOfMonthOrdinal> is greater than 0, then it is interpreted as <minDayOfMonthOrdinal - 1> days from the first day of the month.
	If <minDayOfMonthOrdinal> <= 0, then it is interpreted as <minDayOfMonthOrdinal> days from the last day of the month."

	self assertMutability.
	dayOfWeekOrdinal := d.
	minDayOfMonthCardinal := minDayOfMonthOrdinal - 1.
	maxDayOfMonthCardinal := minDayOfMonthCardinal + DaysPerWeek - 1! !

!WeekOfMonthDayOfWeek methodsFor: 'initialize-release' stamp: ''!
setOffset: aDurationWhoseYearsMonthsAndSubdaysWillBeIgnoredOrElseDaysAsInteger
	"Set my offset in days.  I accept either integers or Durations--solely to avoid having too many instance creation messages, one each for integer offsets and Duration offsets."

	self setDaysOffset: 
			(aDurationWhoseYearsMonthsAndSubdaysWillBeIgnoredOrElseDaysAsInteger respondsToArithmetic
				ifTrue: [aDurationWhoseYearsMonthsAndSubdaysWillBeIgnoredOrElseDaysAsInteger]
				ifFalse: [aDurationWhoseYearsMonthsAndSubdaysWillBeIgnoredOrElseDaysAsInteger days])! !

!WeekOfMonthDayOfWeek methodsFor: 'initialize-release' stamp: ''!
setWeekOfMonthOrdinal: weekOfMonthOrdinal dayOfWeekOrdinal: d
	"If <weekOfMonthOrdinal> <= 0, then it is interpreted as <weekOfMonthOrdinal> weeks from the last week of the month.
	If <dayOfWeekOrdinal> <= 0, then it is interpreted as <dayOfWeekOrdinal> days from the last day of the week."

	self setMinDayOfMonthOrdinal: weekOfMonthOrdinal - 1 * DaysPerWeek + 1 dayOfWeekOrdinal: d! !

!WeekOfMonthDayOfWeek methodsFor: 'private' stamp: ''!
value: aYear value: aCalendarDay
	| date |
	date := YearMonthDay year: aYear calendarDay: aCalendarDay.
	self 
		setMonthOrdinal: date month;
		setWeekOfMonthOrdinal: date weekOfMonthOrdinal dayOfWeekOrdinal: date dayOfWeek! !

!WeekOfMonthDayOfWeek methodsFor: 'accessing' stamp: ''!
weeksSinceStartOfMonth
	"Answer the CARDINAL number of the week of the month in which the day represented by the receiver occurs.  The first seven days of the month are in the week whose CARDINAL number is zero."

	^minDayOfMonthCardinal // DaysPerWeek! !

AnnualDate subclass: #ComputedAnnualDate
	instanceVariableNames: 'daysOffset'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

ComputedAnnualDate class
	instanceVariableNames: 'canonical'!

!ComputedAnnualDate commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

ComputedAnnualDate class
	instanceVariableNames: 'canonical'!

!ComputedAnnualDate class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^literalArray size < 3 
		ifTrue: [self canonical]
		ifFalse: 
			[(self new)
				initializeFromLiteralArray: literalArray;
				beImmutable]! !

!ComputedAnnualDate class methodsFor: 'accessing' stamp: ''!
canonical
	"Answer the canonical instance of the receiver."

	canonical == nil 
		ifTrue: [canonical := self new].
	^canonical! !

!ComputedAnnualDate class methodsFor: 'instance creation' stamp: ''!
daysOffset: daysOffset 
	"Good Friday: {(GregorianEaster daysOffset: -2) inYear: 2006}"
	"Easter: {GregorianEaster canonical inYear: 2006}"

	^(self new)
		setDaysOffset: daysOffset;
		beImmutable! !

!ComputedAnnualDate class methodsFor: 'class initialization' stamp: ''!
initialize
	canonical := nil! !

!ComputedAnnualDate class methodsFor: 'class initialization' stamp: ''!
initializeAll
	self initialize.
	self subclasses do: [:each | each initializeAll]! !

!ComputedAnnualDate class methodsFor: 'class initialization' stamp: ''!
invalidateCalendarBindings
	"ComputedAnnualDate invalidateCalendarBindings"

	self initialize.
	super invalidateCalendarBindings! !

!ComputedAnnualDate methodsFor: 'accessing' stamp: ''!
comparisonClassIdentifier	
	"Answer a value that identifies the group of comparable values to which the receiver belongs.  The value might be a Smalltalk class, or might be a Symbol, or might be something else."

	^self semanticKey! !

!ComputedAnnualDate methodsFor: 'accessing' stamp: ''!
daysOffset
	"Needed for 'Good Friday' (for example)."

	daysOffset == nil ifTrue: [daysOffset := 0].
	^daysOffset! !

!ComputedAnnualDate methodsFor: 'accessing' stamp: ''!
daysOffset: daysAsInteger 
	^self isMutable 
		ifTrue: [self setDaysOffset: daysAsInteger]
		ifFalse: 
			[(self copy)
				setDaysOffset: daysAsInteger;
				beImmutable]! !

!ComputedAnnualDate methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	stream
		nextPut: self globalNameOfClass;
		nextPut: self semanticKey.
	self daysOffset = 0 ifFalse: [stream nextPut: self daysOffset]! !

!ComputedAnnualDate methodsFor: 'comparing' stamp: ''!
hash
	^self semanticKey hash! !

!ComputedAnnualDate methodsFor: 'accessing' stamp: ''!
identifiersDo: block2
	block2 value: #semanticKey value: self semanticKey.
	block2 value: #daysOffset value: self daysOffset! !

!ComputedAnnualDate methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	daysOffset := 0! !

!ComputedAnnualDate methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	literalArray size >= 3 
		ifTrue: [self setDaysOffset: (literalArray at: 3) asNumber]! !

!ComputedAnnualDate methodsFor: 'testing' stamp: ''!
isComputed
	^true! !

!ComputedAnnualDate methodsFor: 'accessing' stamp: ''!
name
	^self nameInLocale: self defaultLocale! !

!ComputedAnnualDate methodsFor: 'accessing' stamp: ''!
nameInLocale: aChronosLocale
	^(ChronosLocale referencedBy: aChronosLocale) properNameAtSemanticKey: self semanticKey! !

!ComputedAnnualDate methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processComputedAnnualDate: self! !

!ComputedAnnualDate methodsFor: 'accessing' stamp: ''!
selfDescribingKey
	^self semanticKey! !

!ComputedAnnualDate methodsFor: 'accessing' stamp: ''!
semanticKey
	^self globalNameOfClass! !

!ComputedAnnualDate methodsFor: 'initialize-release' stamp: ''!
setDaysOffset: days
	self assertMutability.
	daysOffset := days == nil ifTrue: [0] ifFalse: [days]! !

!ComputedAnnualDate methodsFor: 'private' stamp: ''!
value: aYear value: aCalendarDay
	self shouldNotImplement! !

ComputedAnnualDate subclass: #GregorianEaster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!GregorianEaster commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!GregorianEaster methodsFor: 'private-initialize-release' stamp: ''!
basicSetCalendar: aCalendar
	self shouldNotImplement! !

!GregorianEaster methodsFor: 'queries' stamp: ''!
calendarDayInYear: year 
	"Mathematically valid for any year--HOWEVER, no one used the Easter rule that this algorithm implements before 1583, and after 4099 at the latest, it is highly likely that the rule will have been changed."
	"{GregorianEaster canonical inYear: 2006}"

	| modulus19 century yearInCentury cycleIndex centuryInCycle leapYearsThisCentury yearsSinceLastLeapYear lunarCorrection paschalFullMoon pfmAdjustment daysFromPFMToEasterSunday daysSinceMarch22 month day calendarDay |
	modulus19 := year \\ 19.
	century := year // 100.
	yearInCentury := year \\ 100.
	cycleIndex := century // 4.
	centuryInCycle := century \\ 4.
	leapYearsThisCentury := yearInCentury // 4.
	yearsSinceLastLeapYear := yearInCentury \\ 4.
	lunarCorrection := 8 * century + 13 // 25. "8 days per 2500 years."
	paschalFullMoon := 19 * modulus19 + century - cycleIndex - lunarCorrection + 15 \\ 30.
	pfmAdjustment := modulus19 + (11 * paschalFullMoon) // 319.
	daysFromPFMToEasterSunday := (2 * centuryInCycle) + (2 * leapYearsThisCentury) - yearsSinceLastLeapYear  - paschalFullMoon + pfmAdjustment + 32 \\ 7.
	daysSinceMarch22 := paschalFullMoon - pfmAdjustment + daysFromPFMToEasterSunday.
	month :=  daysSinceMarch22 + 90 // 25.
	day := daysSinceMarch22 + 19 + month \\ 32.
	calendarDay := 
		self calendar 
			calendarDayFromMonth: month
			day: day
			inYear: year.
	^self daysOffset = 0
		ifTrue: [calendarDay]
		ifFalse: 
			[calendarDay 
				startingWithYear: year
				addingDays: daysOffset
				setYearAndCalendarDayInto: [:y :cd | cd]]! !

!GregorianEaster methodsFor: 'testing' stamp: ''!
isDayOfWeekInvariant
	^true! !

!GregorianEaster methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinal

	^116 + self daysOffset! !

!GregorianEaster methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinalForYearOfType: yearTypeCode
	^(yearTypeCode = 1 ifTrue: [115] ifFalse: [116]) + self daysOffset! !

!GregorianEaster methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinal

	^80 + self daysOffset! !

!GregorianEaster methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinalForYearOfType: yearTypeCode
	^(yearTypeCode = 1 ifTrue: [80] ifFalse: [81]) + self daysOffset! !

!GregorianEaster methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processGregorianEaster: self! !

!GregorianEaster methodsFor: 'initialize-release' stamp: ''!
setCalendar: aCalendar 
	self shouldNotImplement! !

ComputedAnnualDate subclass: #JulianEaster
	instanceVariableNames: ''
	classVariableNames: 'PaschalMoonTable'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!JulianEaster commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!JulianEaster class methodsFor: 'accessing' stamp: ''!
paschalMoonTable
	PaschalMoonTable == nil
		ifTrue: 
			[PaschalMoonTable := Array new: 19.
			PaschalMoonTable 
				at: 1 put: (DayOfMonth month: 4 day: 5 calendar: Julian);
				at: 2 put: (DayOfMonth month: 3 day: 25 calendar: Julian);	
				at: 3 put: (DayOfMonth month: 4 day: 13 calendar: Julian);
				at: 4 put: (DayOfMonth month: 4 day: 2 calendar: Julian);
				at: 5 put: (DayOfMonth month: 3 day: 22 calendar: Julian);
				at: 6 put: (DayOfMonth month: 4 day: 10 calendar: Julian);	
				at: 7 put: (DayOfMonth month: 3 day: 30 calendar: Julian);
				at: 8 put: (DayOfMonth month: 4 day: 18 calendar: Julian);
				at: 9 put: (DayOfMonth month: 4 day: 7 calendar: Julian);
				at: 10 put: (DayOfMonth month: 3 day: 27 calendar: Julian);	
				at: 11 put: (DayOfMonth month: 4 day: 15 calendar: Julian);
				at: 12 put: (DayOfMonth month: 4 day: 4 calendar: Julian);
				at: 13 put: (DayOfMonth month: 3 day: 24 calendar: Julian);
				at: 14 put: (DayOfMonth month: 4 day: 12 calendar: Julian);	
				at: 15 put: (DayOfMonth month: 4 day: 1 calendar: Julian);
				at: 16 put: (DayOfMonth month: 3 day: 21 calendar: Julian);
				at: 17 put: (DayOfMonth month: 4 day: 9 calendar: Julian);	
				at: 18 put: (DayOfMonth month: 3 day: 20 calendar: Julian);
				at: 19 put: (DayOfMonth month: 4 day: 17 calendar: Julian)].
	^PaschalMoonTable! !

!JulianEaster methodsFor: 'private-initialize-release' stamp: ''!
basicSetCalendar: aCalendar
	self shouldNotImplement! !

!JulianEaster methodsFor: 'queries' stamp: ''!
calendarDayInYear: year 
	"{JulianEaster canonical inYear: 2006}"

	| modulus19 isoDayOfWeekCardinal daysSinceEpochUpToYear dayOfMonthOfPaschalMoon calendarDay daysSinceEpoch |
	modulus19 := year \\ 19.
	dayOfMonthOfPaschalMoon := self class paschalMoonTable at: modulus19 + 1.
	calendarDay := dayOfMonthOfPaschalMoon calendarDayInYear: year.
	daysSinceEpochUpToYear := self calendar daysSinceEpochUpToYear: year.
	daysSinceEpoch := daysSinceEpochUpToYear + calendarDay daysSinceStartOfYear.
	isoDayOfWeekCardinal := self calendar daysSinceStartOfISOWeekFromDaysSinceEpoch: daysSinceEpoch.
	calendarDay := calendarDay addingDays: 6 - isoDayOfWeekCardinal.	"Add zero days if the calendarDay is a Sunday, otherwise add the number of days necessary to advance to the next Sunday"
	^self daysOffset = 0 
		ifTrue: [calendarDay]
		ifFalse: 
			[calendarDay 
				startingWithYear: year
				addingDays: daysOffset
				setYearAndCalendarDayInto: [:y :cd | cd]]! !

!JulianEaster methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	calendar := Julian! !

!JulianEaster methodsFor: 'testing' stamp: ''!
isDayOfWeekInvariant
	^true! !

!JulianEaster methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinal
	"(DayOfMonth month: 4 day: 25 calendar: Julian) maxDayOfYearOrdinal"

	^116 + self daysOffset! !

!JulianEaster methodsFor: 'queries' stamp: ''!
maxDayOfYearOrdinalForYearOfType: yearTypeCode
	^(yearTypeCode = 1 ifTrue: [115] ifFalse: [116]) + self daysOffset! !

!JulianEaster methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinal
	"(DayOfMonth month: 3 day: 22 calendar: Julian) minDayOfYearOrdinal"

	^80 + self daysOffset! !

!JulianEaster methodsFor: 'queries' stamp: ''!
minDayOfYearOrdinalForYearOfType: yearTypeCode
	^(yearTypeCode = 1 ifTrue: [80] ifFalse: [81]) + self daysOffset! !

!JulianEaster methodsFor: 'processing' stamp: ''!
processBy: annualDateProcessor
	annualDateProcessor processJulianEaster: self! !

!JulianEaster methodsFor: 'initialize-release' stamp: ''!
setCalendar: aCalendar 
	self shouldNotImplement! !

AbstractDate subclass: #YearMonthDay
	instanceVariableNames: 'year calendarDay'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!YearMonthDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

YearMonthDay subclass: #Timepoint
	instanceVariableNames: 'daysSinceEpoch secondsSinceStartOfDay nanosecondsSinceSecond timeZone'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

Timepoint class
	instanceVariableNames: 'universalTZ nominalTZ utcTZ'!

!Timepoint commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

Timepoint [Aliased by the global DateAndTime, unless that conflicts with a native global of the host Smalltalk environment]

	Concept:

		## NOMINAL TIME INVARIANCE vs. UNIVERSAL TIME INVARIANCE {this section is strongly recommended for all Chronos users}
		
		## UNIVERSAL TIME (UTC,) COORDINATED UNIVERSAL TIME (UTC) and LEAP SECONDS {if you don't care about timescales and/or leap seconds, you may skip this section}

			The formal name of the standard international reference zero-offset timezone is Universal Time (UT, although it is colloquially referred to as GMT more often than not--even by techies.) The formal name of the standard international reference timescale is Coordinated Universal Time (UTC.) However, UT and UTC are technically not the same thing at all: UT is a timezone; UTC is a timescale.  

			Universal Time, and any other timezone, can be used with any terrestrial timescale that uses Greenwhich Mean Time (directly or indirectly) to establish the zero-point of the time-of-day clock.  Were such not the case, it would be impossible for any country that didn't use the UTC timescale to define its timezones as offsets from Universal Time--and not all countries use the UTC timescale as the basis for their civil time-of-day, even though they all define their timezones as offsets from Universal Time. Universal Time is simply the timezone whose offset from the specific timescale of one's choice (UT0, UT1, UTC, etc) is an invariant 0.0 seconds.

			UTC is also quite commonly used as a synonum for UT, even though the former is technically a timescale and the latter is technically a timezone. In addition to the use of GMT as a synonym for UT, this can create no small amount of confusion and/or bogosity.  For example, many date/time libraries use the term UTC to mean the timezone UT.  They cannot possibly be literally referring to the UTC timescale, since they do not support leap seconds.  The same is true of international standards such as POSIX and the ANSI Smalltalk Standard.

			For example, the ANSI-Smalltalk standard says the following with respect to the behavior of the <DateAndTime> protocol:

				"This protocol describes the behavior that is common to date time objects. Date time objects represent individual points in Coordinated Universal Time (UTC) as represented in an implementation defined local time. The exact properties of local times are unspecified. Local times may differ in their offset from UTC. A given local time may have different offsets from UTC at different points in time. All dates and times in the UTC local time are in the Gregorian calendar. Date times prior to the adoption of the Gregorian calendar are given in the retrospective astronomical Gregorian calendar. The year 1 B.C. is astronomical Gregorian year 0. The year 2 B.C. is astronomical Gregorian year-1. The year 1 A.D. is astronomical Gregorian year 1. The offset of the UTC local time is zero."

			Given the precisely-specified requirements, the lack of any mention of leap seconds stands out. The X3J20 committee's specification does bother to define UTC as the timezone whose local time offset is zero. But why say that much, while saying nothing about leap seconds? 

			If the X3J20 committe intended "Coordinated Universal Time (UTC) " to be a reference to UTC as a timescale, including its use of leap seconds, then why did they take such care in the specification of the semantics of <DateAndTime> values, without any explicit requirement to handle leap seconds?  To be consistent with the level of detail on other matters, had the committee intended to require the proper handling of leap seconds, they should have a) said so explicity, b) specified the moment of insertion of the 10 "floating" leap seconds from 1955 to 1972 whose moments of insertion are not specified anywhere by any international standard, and c) specified how leap seconds in the future, and before 1955, should be dealt with (Ignore them? Estimate them? Provide for dynamic leap second notification? Leave such questions as implementation defined--which they usually **explicitly** do for other issues?).

			Consider also the ANSI-Smalltalk Standard's documentation of the message DateAndTime>>second, which says the following: "Answer a <number> greater than or equal to 0 and strictly less than 60 representing the second of the minute of the local time of the receiver."  This statement actually forbids leap seconds, since a leap second would have the cardinal value 60, which is not legal (the cardinal number of seconds must be "strictly less than 60.")

			Finally, there is the fact that earlier draft versions of the Standard did explicitly require the correct handling of leap seconds.  The statements in the X3J20 specification that required leap second handling were deliberately removed from the later (and final) versions of the standard, because the members of the X3J20 committee decided that mandatory support for leap seconds would be too great a burden (that information comes from public statements made by members of the X3J20 committee, including a written statement by Douglas Surber, who was the principal author of the section of the standard that deals with date and time protocols.)  So, although the ANSI Smalltalk standard states that <DateAndTime> values are coordinate points in UTC, it is beyond reasonable doubt that "UTC" is being (incorrectly) used in this case as a synonym for Universal Time, without reference to a specific timescale.  Such (mis)usage of the term "UTC" is quite common, even in contexts where one might rightly expect a high level of rigour and precision in the use of technical terms.

			Similarly, the VisualWorks documentation says the following with respect to the operation of the VisualWorks system clock primitive (which returns the number of clock ticks since 1901-01-01T00:00:00+00:00 as a count of microseconds):  "With the arrival of the object engine's microsecond clock, which provides the time in UTC (GMT) for all platforms, all users must now set the TimeZone."  However, it is easy to prove either that the implementation is broken, or that the author of this statement meant the timezone UT, not the timescale UTC. Without even considering the actual behavior of the VW system clock, the parenthetical "GMT" in this statement strongly suggests the latter interpretation.

			To the best of the author's knowledge, the "vanilla" version (as delivered in the default image) of all date/time libraries that claim to be compliant with the ANSI-Smalltalk Standard do not handle leap seconds, and use the UT1 timescale.  However, David T. Lewis has implemented an optional module for Squeak (available from SqueakMap) that enhances Brent Pinkney's ANSI-compliant Chronology Date/Time library (currently the native date/time library of Squeak) so that it supports leap seconds.

			The fact is, few computer operating systems natively support leap seconds.  Windows does not.  MacOS and MacOS-X do not.  POSIX-compliant systems are forbidden from doing so. The fact that POSIX systems emit timestamp strings that use "UTC" to indicate the UT timezone just adds to the general confusion.  POSIX is far from the only offender in this regard (e.g, Java.).  It would be easier to list the systems that do use the term UTC correctly--or that actually correctly implement leap seconds.

			The bottom line is this: any system which expects sub-second timing precision needs to be very carefully designed, taking into account all of the sources of delay and error. In more plain language, what the *&%#$!! are you thinking if you expect to use the system clock in your computer for precision timing? Few computer clocks are accurate to anywhere near one second every year--and that's the level of accuracy needed before the distinction between UT1 and UTC begins to have any relevance whatsoever.  Nevertheless, some use cases actually do require that degree of accuracy, and some applications have to correctly handle very precise UTC timestamps--perhaps generated by special (and expensive) clocks other than those installed on the motherboard of a laptop or desktop personal computer, or else generated by local clocks that are disciplined by means of the Network Time Protocol (which periodically synchronizes local clocks with atomic clocks over a network, and measures and corrects for the inaccuracies of the local clocks, greatly enhancing the effective accuracy of the local clocks.) For this reason, full support for leap seconds is planned for a future release of the Chronos Date/Time library.

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

Timepoint class
	instanceVariableNames: 'universalTZ nominalTZ utcTZ'!

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days seconds: seconds
	^self basicNew
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days seconds: seconds nanoseconds: n
	^self basicNew
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days seconds: seconds nanoseconds: n calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days seconds: seconds nanoseconds: n timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days seconds: seconds nanoseconds: n timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days seconds: seconds timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
daysSinceEpoch: days timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'accessing' stamp: ''!
defaultParser
	^ChronosParser iso8601! !

!Timepoint class methodsFor: 'instance creation' stamp: ''!
fromNative: aNativeCalendricalCoordinate as: calendar
	^(Calendar referencedBy: calendar) clock 
		chronosDateAndTimeFromNativeCalendricalCoordinate: aNativeCalendricalCoordinate! !

!Timepoint class methodsFor: 'examples' stamp: ''!
inAllTimeZonesAndCalendars: aDateAndTime
	"INSPECT IT: 
		{Timepoint 
			inAllTimeZonesAndCalendars: 
				(Timepoint 
					year: 2001 
					month: September 
					day: 11 
					hour: 8
					minute: 42
					second: 26
					timeZone: #'America/New_York')}"
	"INSPECT IT: 
		{Timepoint 
			inAllTimeZonesAndCalendars: 
				(Timepoint 
					year: 1941 
					month: December 
					day: 7 
					hour: 7
					minute: 55
					second: 0
					timeZone: #'Pacific/Honolulu')}"

	| inAllTimezones map allCalendars printPolicy |
	allCalendars := Calendar allRegisteredKeys asSortedCollection: [:a :b | a == #Gregorian ifTrue: [true] ifFalse: [b == #Gregorian ifTrue: [false] ifFalse: [a < b]]].
	inAllTimezones := aDateAndTime inAll: ChronosTimezone allCanonicalKeys asArray.
	printPolicy := ChronosPrintPolicy rfc2822 apply: #(showEraNameAfterDate dateAndTimeSeparator: ' @ ' use12HourFormat hourPadChar: nil showTimeZoneAbbreviation).
	map := Dictionary new.
	inAllTimezones do: 
		[:timepoint | 
			| stream timeZone |
			timeZone := timepoint timeZone.
			stream := String new writeStream.
			timeZone specifiesGeographicCoordinates
				ifTrue: 
					[stream
						nextPutAll: 'Geographic coordinates: ';
						print: timeZone geographicCoordinates;
						cr].
			stream 
				nextPutAll: 'Julian Date: '.
			ChronosFunction
				printFractional: timepoint utJulianDate asDecimalOn: stream decimalPoint: $. precision: 9.
			stream cr.
			(timepoint asAll: allCalendars) 
				do: [:each | 
					each printOn: stream using: printPolicy.
					stream 
						nextPutAll: ' ['.
					ChronosFunction
						printFractional: each fractionalDaysSinceEpoch asDecimalOn: stream decimalPoint: $. precision: 3.
					stream
						nextPutAll: ' days since ';
						nextPutAll: each calendar name;
						nextPutAll: ' Epoch]';
						cr].
			map 
				at: '[', timepoint timeZone zuluNotation, '] ', timeZone identityString
				put: stream contents].
	^map! !

!Timepoint class methodsFor: 'class initialization' stamp: ''!
initialize
	"Timepoint initialize"

	universalTZ := nil.
	nominalTZ := nil.! !

!Timepoint class methodsFor: 'class initialization' stamp: ''!
invalidateTimezones
	"DateAndTimeFactory invalidateTimezones"

	self allInstancesDo: [:each | [each invalidateTimezone] on: Error do: [:ex | ex return]]! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoNominalYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoNominalYear: 2006 week: 1 dayOfWeek: ISOMonday"

	^self 
		isoYear: isoYear
		week: isoWeekOrdinal
		dayOfWeek: isoDayOfWeekOrdinal
		timeZone: ChronosTimezone nominal! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoNominalYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoNominalYear: 2006 week: 1 dayOfWeek: ISOMonday"

	^self basicNew
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		setHour: hour minute: minute second: second;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoNominalYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoNominalYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30 nanosecond: 500000000 "

	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoUTYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoUTYear: 2006 week: 1 dayOfWeek: ISOMonday"

	^self basicNew
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoUTYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoUTYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30"

	^self basicNew
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		setHour: hour minute: minute second: second;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoUTYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoUTYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30 nanosecond: 500000000"

	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoUTYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond timeZone: timeZone
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoUTYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30 nanosecond: 500000000 timeZone: #UT"

	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoUTYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second timeZone: timeZone
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoUTYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30 timeZone: #UT"

	^self basicNew
		setTimeZone: timeZone;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		setHour: hour minute: minute second: second;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoUTYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal timeZone: timeZone
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoUTYear: 2006 week: 1 dayOfWeek: ISOMonday timeZone: #UT"

	^self basicNew
		setTimeZone: timeZone;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30"

	^self basicNew
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30 nanosecond: 500000000"

	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond timeZone: timeZone
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30 nanosecond: 500000000 timeZone: 'Asia/Rangoon'"

	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second timeZone: timeZone
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoYear: 2006 week: 1 dayOfWeek: ISOMonday hour: 12 minute: 30 second: 30 timeZone: 'Asia/Rangoon'"

	^self basicNew
		setTimeZone: timeZone;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-ISO 8601' stamp: ''!
isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal timeZone: timeZone
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"

	"Timepoint isoYear: 2006 week: 1 dayOfWeek: ISOMonday timeZone: 'Asia/Rangoon'"

	^self basicNew
		setTimeZone: timeZone;
		setIsoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay seconds: seconds
	^self basicNew
		setJulianDay: julianDay seconds: seconds nanoseconds: 0;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay seconds: seconds nanoseconds: nanoseconds
	^self basicNew
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay seconds: seconds nanoseconds: nanoseconds calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay seconds: seconds nanoseconds: nanoseconds timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay seconds: seconds nanoseconds: nanoseconds timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay timeZone: timeZone
	"{(DateAndTimeFactory 
		julianDay: 2452163.862800926d
		timeZone: 'America/New_York') localePrintString}"

	^self basicNew
		setTimeZone: timeZone;
		setJulianDay: julianDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDay: julianDay timeZone: timeZone calendar: aCalendar
	^self basicNew
		setCalendar: aCalendar;
		setTimeZone: timeZone;
		setJulianDay: julianDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-Julian Days' stamp: ''!
julianDayNumber: julianDay timeZone: timeZone
	"Should be true: {(Timepoint julianDayNumber: 2400001 timeZone: #UT) = (Timepoint julianDayNumber: 2400000.5 timeZone: #UT)}"
	"Should be true: {(Timepoint julianDayNumber: 2400001 timeZone: #UT) > (Timepoint julianDayNumber: 2400000 timeZone: #UT)}"


	^self basicNew
		setTimeZone: timeZone;
		setJulianDayNumber: julianDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
nanosecondsSinceEpoch: n
	^self basicNew
		setNanosecondsSinceEpoch: n;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
nanosecondsSinceEpoch: n calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceEpoch: n;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
nanosecondsSinceEpoch: n timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceEpoch: n;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
nanosecondsSinceEpoch: n timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceEpoch: n;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalDaysSinceEpoch: days 
	^self basicNew
		basicSetDaysSinceEpoch: days;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalDaysSinceEpoch: days calendar: calendar 
	^self basicNew
		setCalendar: calendar;
		basicSetDaysSinceEpoch: days;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalDaysSinceEpoch: days seconds: seconds 
	^self basicNew
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalDaysSinceEpoch: days seconds: seconds nanoseconds: n 
	^self basicNew
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalDaysSinceEpoch: days seconds: seconds nanoseconds: n calendar: calendar 
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-Julian Days' stamp: ''!
nominalJulianDay: julianDay 
	^self basicNew
		setJulianDay: julianDay;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-Julian Days' stamp: ''!
nominalJulianDay: julianDay calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setJulianDay: julianDay;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-Julian Days' stamp: ''!
nominalJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds 
	^self basicNew
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-Julian Days' stamp: ''!
nominalJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds calendar: calendar 
	^self basicNew
		setCalendar: calendar;
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalNanosecondsSinceEpoch: n
	^self basicNew
		setNanosecondsSinceEpoch: n;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalNanosecondsSinceEpoch: n calendar: calendar 
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceEpoch: n;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-current' stamp: ''!
nominalNow	
	"DateAndTime nominalNow"

	^AnsiStandardCalendarClock nominalNow! !

!Timepoint class methodsFor: 'instance creation-nominal time-current' stamp: ''!
nominalNowAs: calendar
	^(Calendar referencedBy: calendar) clock nominalNow! !

!Timepoint class methodsFor: 'instance creation-nominal time-current' stamp: ''!
nominalNowToTheSecond
	^AnsiStandardCalendarClock nominalNowToTheSecond! !

!Timepoint class methodsFor: 'instance creation-nominal time-current' stamp: ''!
nominalNowToTheSecondAs: calendar
	^(Calendar referencedBy: calendar) clock nominalNowToTheSecond! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalSecondsSinceEpoch: s 
	^self basicNew
		basicSetSecondsSinceEpoch: s;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalSecondsSinceEpoch: s calendar: calendar 
	^self basicNew
		setCalendar: calendar;
		basicSetSecondsSinceEpoch: s;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalSecondsSinceEpoch: s nanoseconds: n 
	^self basicNew
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-since epoch' stamp: ''!
nominalSecondsSinceEpoch: s nanoseconds: n calendar: calendar 
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		beImmutable! !

!Timepoint class methodsFor: 'private' stamp: ''!
nominalTZ
	nominalTZ == nil ifTrue: [nominalTZ := ChronosTimezone nominal].
	^nominalTZ! !

!Timepoint class methodsFor: 'instance creation-nominal time-current' stamp: ''!
nominalToday
	^AnsiStandardCalendarClock nominalToday! !

!Timepoint class methodsFor: 'instance creation-nominal time-current' stamp: ''!
nominalTodayAs: calendar
	^(Calendar referencedBy: calendar) clock nominalToday! !

!Timepoint class methodsFor: 'instance creation-nominal time-current' stamp: ''!
nominalTodayAt: aTimeOfDay 
	"Timepoint nominalTodayAt: TimeOfDay now"

	^aTimeOfDay asMutableDateAndTime beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time-current' stamp: ''!
nominalTodayIn: aTimezone
	^AnsiStandardCalendarClock nominalTodayIn: aTimezone! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year day: dayOfYear 
	"DateAndTimeFactory nominalYear: 2000 day: 1"

	^self basicNew
		setYear: year dayOfYearOrdinal: dayOfYear;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year day: dayOfYear calendar: calendar
	^self basicNew
		basicSetCalendar: calendar;
		setYear: year dayOfYearOrdinal: dayOfYear;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year day: dayOfYear hour: hour minute: minute second: second 
	^self basicNew
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond
	^self basicNew
		setYear: year dayOfYearOrdinal: dayOfYear;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond calendar: calendar 
	^self basicNew
		basicSetCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year month: month day: dayOfMonth 
	^self basicNew
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year month: month day: dayOfMonth calendar: calendar 
	^self basicNew
		basicSetCalendar: calendar;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year month: month day: dayOfMonth hour: hour minute: minute second: second 
	^self basicNew
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year month: month day: dayOfMonth hour: hour minute: minute second: second calendar: calendar
	^self basicNew
		basicSetCalendar: calendar;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond
	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond calendar: calendar 
	^self basicNew
		basicSetCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond
	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-nominal time' stamp: ''!
nominalYear: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond calendar: calendar 
	^self basicNew
		basicSetCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: 'PaulDeBruicker 3/9/2011 10:46'!
now	
	"Specified and required by the ANSI-Smalltalk Standard."

	^(AnsiStandardCalendarClock) now! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowAs: aCalendarOrCalendarReference
	^(Calendar referencedBy: aCalendarOrCalendarReference) clock now

	"{DateAndTimeFactory todayAs: Gregorian}"
	"{DateAndTimeFactory nowAs: #Gregorian}" 			"{DateAndTimeFactory nowAs: GregorianCalendar}" 
	"{DateAndTimeFactory nowAs: Julian}" 	
	"{DateAndTimeFactory nowAs: #Julian}" 				"{DateAndTimeFactory nowAs: JulianCalendar}"		
	"{DateAndTimeFactory nowAs: #Bahai}" 				"{DateAndTimeFactory nowAs: BahaiCalendar}"
	"{DateAndTimeFactory nowAs: #Coptic}" 				"{DateAndTimeFactory nowAs: CopticCalendar}"
	"{DateAndTimeFactory nowAs: #Ethiopic}" 			"{DateAndTimeFactory nowAs: EthiopicCalendar}"
	"{DateAndTimeFactory nowAs: #Hebrew}" 			"{DateAndTimeFactory nowAs: HebrewCalendar}"
	"{DateAndTimeFactory nowAs: #Indian}" 				"{DateAndTimeFactory nowAs: IndianCalendar}"
	"{DateAndTimeFactory nowAs: #'Islamic-Fatimid'}" 	"{DateAndTimeFactory nowAs: IslamicFatimidCalendar}"
	"{DateAndTimeFactory nowAs: #Persian}" 			"{DateAndTimeFactory nowAs: PersianCalendar}"
	"{DateAndTimeFactory nowAs: #Solarian}" 			"{DateAndTimeFactory nowAs: SolarianCalendar}"! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowIn: aTimezone
	^AnsiStandardCalendarClock nowIn: aTimezone	

	"{DateAndTimeFactory nowIn: #UTC}"
	"{DateAndTimeFactory nowIn: 'Pacific/Auckland'}"
	"{DateAndTimeFactory nowIn: 'Australia/Sydney'}"
	"{DateAndTimeFactory nowIn: 'Asia/Tokyo'}"
	"{DateAndTimeFactory nowIn: 'Asia/Hong_Kong'}"
	"{DateAndTimeFactory nowIn: 'Europe/Moscow'}"
	"{DateAndTimeFactory nowIn: 'Asia/Jerusalem'}"
	"{DateAndTimeFactory nowIn: 'Europe/Amsterdam'}"
	"{DateAndTimeFactory nowIn: 'Europe/London'}"
	"{DateAndTimeFactory nowIn: 'America/Sao_Paulo'}"
	"{DateAndTimeFactory nowIn: 'America/Argentina/Buenos_Aires'}"
	"{DateAndTimeFactory nowIn: 'America/New_York'}"
	"{DateAndTimeFactory nowIn: 'America/Chicago'}"
	"{DateAndTimeFactory nowIn: 'America/Denver'}"
	"{DateAndTimeFactory nowIn: 'America/Los_Angeles'}"
	"{DateAndTimeFactory nowIn: 'Pacific/Honolulu'}"! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowIn: aTimezone as: aCalendar
	"{DateAndTimeFactory nowIn: #'America/Chicago' as: #Gregorian}"
	"{(DateAndTimeFactory nowIn: ChronosTimezone alwaysDefault as: Julian) printStringUsing: ChronosPrintPolicy verbose}"

	^(Calendar referencedBy: aCalendar) clock nowIn: aTimezone! !

!Timepoint class methodsFor: 'examples' stamp: ''!
nowInAll: aCollectionOfTimeZones
	"Timepoint nowInAll: Timepoint commonWorldTimezones"

	^self utNow inAll: aCollectionOfTimeZones.! !

!Timepoint class methodsFor: 'examples' stamp: ''!
nowInAllCalendars
	"Timepoint nowInAllCalendars"
	"{Transcript cr.
	Timepoint nowInAllCalendars do: 
		[:each | Transcript cr; show: (each printStringUsing: #universal)]}"

	^self now inAllCalendars! !

!Timepoint class methodsFor: 'examples' stamp: ''!
nowInAllTimeZones
	"INSPECT IT: {Timepoint nowInAllTimeZones}"

	^self utNow inAllTimeZones! !

!Timepoint class methodsFor: 'examples' stamp: ''!
nowInAllTimeZonesAndCalendars
	"INSPECT IT: {Timepoint nowInAllTimeZonesAndCalendars}"

	^self utNow inAllTimeZonesAndCalendars! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowToTheHour
	"{Timepoint nowToTheHour}"

	| now |
	now := self nowToTheSecond.
	^now subtractingHours: 0 minutes: now minute seconds: now second! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowToTheMinute
	"{Timepoint nowToTheMinute}"

	| now |
	now := self nowToTheSecond.
	^now subtractingSeconds: now second! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowToTheSecond	
	^AnsiStandardCalendarClock nowToTheSecond! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowToTheSecondAs: aCalendarOrCalendarReference
	^(Calendar referencedBy: aCalendarOrCalendarReference) clock nowToTheSecond! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowToTheSecondIn: aTimezone
	^AnsiStandardCalendarClock nowToTheSecondIn: aTimezone! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
nowToTheSecondIn: aTimezone as: aCalendar
	"{DateAndTimeFactory nowToTheSecondIn: #'America/Chicago' as: #Gregorian}"
	"{(DateAndTimeFactory nowToTheSecondIn: ChronosTimezone alwaysDefault as: Julian) printStringUsing: ChronosPrintPolicy verbose}"

	^(Calendar referencedBy: aCalendar) clock nowToTheSecondIn: aTimezone! !

!Timepoint class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^(ChronosParser referencedBy: aChronosParser) nextDateAndTimeFrom: stream usingFactory: self! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
secondsSinceEpoch: seconds
	^self basicNew
		basicSetSecondsSinceEpoch: seconds;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
secondsSinceEpoch: s calendar: calendar
	^self basicNew
		setCalendar: calendar;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
secondsSinceEpoch: s nanoseconds: n
	^self basicNew
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
secondsSinceEpoch: s nanoseconds: n calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
secondsSinceEpoch: s nanoseconds: n timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
secondsSinceEpoch: s nanoseconds: n timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
secondsSinceEpoch: s timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-since epoch' stamp: ''!
secondsSinceEpoch: s timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
today
	^AnsiStandardCalendarClock today! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
todayAs: aCalendarOrCalendarReference
	^(Calendar referencedBy: aCalendarOrCalendarReference) clock today

	"{DateAndTimeFactory todayAs: Gregorian}"
	"{DateAndTimeFactory todayAs: #Gregorian}" 		"{DateAndTimeFactory todayAs: GregorianCalendar}" 	
	"{DateAndTimeFactory todayAs: Julian}" 
	"{DateAndTimeFactory todayAs: #Julian}" 			"{DateAndTimeFactory todayAs: JulianCalendar}"			
	"{DateAndTimeFactory todayAs: #Bahai}" 			"{DateAndTimeFactory todayAs: BahaiCalendar}"
	"{DateAndTimeFactory todayAs: #Coptic}" 			"{DateAndTimeFactory todayAs: CopticCalendar}"
	"{DateAndTimeFactory todayAs: #Ethiopic}" 			"{DateAndTimeFactory todayAs: EthiopicCalendar}"
	"{DateAndTimeFactory todayAs: #Hebrew}" 			"{DateAndTimeFactory todayAs: HebrewCalendar}"
	"{DateAndTimeFactory todayAs: #Indian}" 			"{DateAndTimeFactory todayAs: IndianCalendar}"
	"{DateAndTimeFactory todayAs: #'Islamic-Fatimid'}" 	"{DateAndTimeFactory todayAs: IslamicFatimidCalendar}"
	"{DateAndTimeFactory todayAs: #Persian}" 			"{DateAndTimeFactory todayAs: PersianCalendar}"
	"{DateAndTimeFactory todayAs: #Solarian}" 			"{DateAndTimeFactory todayAs: SolarianCalendar}"! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
todayAt: aTimeOfDay 
	"Timepoint todayAt: TimeOfDay now"

	^aTimeOfDay in: ChronosTimezone default! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
todayAt: aTimeOfDay in: timeZone
	"Timepoint todayAt: TimeOfDay now in: (Duration hours: 5.5)"

	^aTimeOfDay in: timeZone! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
todayIn: aTimezone
	^AnsiStandardCalendarClock todayIn: aTimezone

	"{DateAndTimeFactory todayIn: #UTC}"
	"{DateAndTimeFactory todayIn: 'Pacific/Auckland'}"
	"{DateAndTimeFactory todayIn: 'Australia/Sydney'}"
	"{DateAndTimeFactory todayIn: 'Asia/Tokyo'}"
	"{DateAndTimeFactory todayIn: 'Asia/Hong_Kong'}"
	"{DateAndTimeFactory todayIn: 'Europe/Moscow'}"
	"{DateAndTimeFactory todayIn: 'Asia/Jerusalem'}"
	"{DateAndTimeFactory todayIn: 'Europe/Amsterdam'}"
	"{DateAndTimeFactory todayIn: 'Europe/London'}"
	"{DateAndTimeFactory todayIn: 'America/Sao_Paulo'}"
	"{DateAndTimeFactory todayIn: 'America/Argentina/Buenos_Aires'}"
	"{DateAndTimeFactory todayIn: 'America/New_York'}"
	"{DateAndTimeFactory todayIn: 'America/Chicago'}"
	"{DateAndTimeFactory todayIn: 'America/Denver'}"
	"{DateAndTimeFactory todayIn: 'America/Los_Angeles'}"
	"{DateAndTimeFactory todayIn: 'Pacific/Honolulu'}"! !

!Timepoint class methodsFor: 'instance creation-local time-current' stamp: ''!
todayIn: aTimezone as: aCalendarOrCalendarReference
	^(Calendar referencedBy: aCalendarOrCalendarReference) clock todayIn: aTimezone! !

!Timepoint class methodsFor: 'private' stamp: ''!
universalTZ
	universalTZ == nil ifTrue: [universalTZ := ChronosTimezone universal].
	^universalTZ! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utDaysSinceEpoch: days
	"{DateAndTime utDaysSinceEpoch: 730118.5}"

	^self basicNew
		basicSetDaysSinceEpoch: days;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utDaysSinceEpoch: days seconds: seconds
	^self basicNew
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utDaysSinceEpoch: days seconds: seconds nanoseconds: n
	^self basicNew
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utDaysSinceEpoch: days seconds: seconds nanoseconds: n calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utDaysSinceEpoch: days seconds: seconds nanoseconds: n timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utDaysSinceEpoch: days seconds: seconds nanoseconds: n timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceStartOfDay: seconds;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utDaysSinceEpoch: days timeZone: timeZone
	"{DateAndTime utDaysSinceEpoch: 730118.5 timeZone: Timezone universal}"
	"{DateAndTime utDaysSinceEpoch: 730118.5 timeZone: 'America/Chicago'}"

	^self basicNew
		setTimeZone: timeZone;
		basicSetDaysSinceEpoch: days;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay
	"{((DateAndTimeFactory utJulianDay: 2452164.0294675923d) 
		in: 'America/New_York') localePrintString}"

	^self basicNew
		setJulianDay: julianDay;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setJulianDay: julianDay;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay seconds: seconds
	^self basicNew
		setJulianDay: julianDay seconds: seconds nanoseconds: 0;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds
	^self basicNew
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay seconds: seconds timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setJulianDay: julianDay seconds: seconds nanoseconds: 0;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay seconds: seconds timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setJulianDay: julianDay seconds: seconds nanoseconds: 0;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay timeZone: timeZone
	"{(DateAndTimeFactory 
		utcJulianDay: 2452164.0294675923d
		timeZone: 'America/New_York') localePrintString}"

	^self basicNew
		setTimeZone: timeZone;
		setJulianDay: julianDay;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDay: julianDay timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setJulianDay: julianDay;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDayNumber: julianDay
	"Timepoint utJulianDayNumber: 2400001"

	^self basicNew
		setJulianDayNumber: julianDay;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-Julian Days' stamp: ''!
utJulianDayNumber: julianDay timeZone: timeZone
	"Timepoint utJulianDayNumber: 2400001 timeZone: #UT"

	^self basicNew
		setTimeZone: timeZone;
		setJulianDayNumber: julianDay;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utNanosecondsSinceEpoch: n
	^self basicNew
		setNanosecondsSinceEpoch: n;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utNanosecondsSinceEpoch: n calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceEpoch: n;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utNanosecondsSinceEpoch: n timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceEpoch: n;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utNanosecondsSinceEpoch: n timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceEpoch: n;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-current' stamp: ''!
utNow
	^AnsiStandardCalendarClock utNow! !

!Timepoint class methodsFor: 'instance creation-UT-current' stamp: ''!
utNowAs: aCalendarOrCalendarReference
	^(Calendar referencedBy: aCalendarOrCalendarReference) clock utNow! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utSecondsSinceEpoch: s
	^self basicNew
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utSecondsSinceEpoch: s calendar: calendar
	^self basicNew
		setCalendar: calendar;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utSecondsSinceEpoch: s nanoseconds: n
	^self basicNew
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utSecondsSinceEpoch: s nanoseconds: n calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utSecondsSinceEpoch: s nanoseconds: n timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utSecondsSinceEpoch: s nanoseconds: n timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: n;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utSecondsSinceEpoch: s timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-since epoch' stamp: ''!
utSecondsSinceEpoch: s timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		basicSetSecondsSinceEpoch: s;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT-current' stamp: ''!
utToday
	^AnsiStandardCalendarClock utToday! !

!Timepoint class methodsFor: 'instance creation-UT-current' stamp: ''!
utTodayAs: aCalendarOrCalendarReference
	^(Calendar referencedBy: aCalendarOrCalendarReference) clock utToday! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear
	^self basicNew
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear hour: hour minute: minute second: second
	^self basicNew
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear hour: hour minute: minute second: second timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear hour: hour minute: minute second: second timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond
	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year day: dayOfYear timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth
	^self basicNew
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth hour: hour minute: minute second: second
	^self basicNew
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond
	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth hour: hour minute: minute second: second timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth hour: hour minute: minute second: second timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond
	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-UT' stamp: ''!
utYear: year month: month day: dayOfMonth timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromUT;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear hour: hour minute: minute second: second
	"Specified and required by the ANSI-Smalltalk Standard."

	^self basicNew
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear hour: hour minute: minute second: second calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear hour: hour minute: minute second: second offset: aDuration
	"Specified and required by the ANSI-Smalltalk Standard."

	^self basicNew
		setOffset: aDuration;
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear hour: hour minute: minute second: second offset: aDuration calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setOffset: aDuration;
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear hour: hour minute: minute second: second timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear hour: hour minute: minute second: second timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setYear: year dayOfYearOrdinal: dayOfYear;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond
	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year day: dayOfYear timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setYear: year dayOfYearOrdinal: dayOfYear;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second
	"Specified and required by the ANSI-Smalltalk Standard."

	^self basicNew
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second calendar: aCalendar
	^self basicNew
		setCalendar: aCalendar;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond
	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second offset: aDuration
	"Specified and required by the ANSI-Smalltalk Standard."

	^self basicNew
		setOffset: aDuration;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		setHour: hour minute: minute second: second;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond
	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsSinceStartOfDay;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth timeZone: timeZone
	^self basicNew
		setTimeZone: timeZone;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint class methodsFor: 'instance creation-local time' stamp: ''!
year: year month: month day: dayOfMonth timeZone: timeZone calendar: calendar
	^self basicNew
		setCalendar: calendar;
		setTimeZone: timeZone;
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth;
		canonicalizeFromLocalTime;
		beImmutable! !

!Timepoint methodsFor: 'converting' stamp: ''!
<< aChronosTimezone 
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but convert the date and time-of-day as though the receiver represented a date and time in the current default time zone (i.e,. preserve date and time-of-day in Universal Time as though the receiver represented a date and time in the current default time zone.)
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is the same as that of the receiver (i.e,, preserve local date and local time-of-day, don't preserve date or time-of-day in Universal Time.)"

	"Timepoint now << 10 hours"
	"Timepoint now << 'Australia/Adelaide'"
	"Timepoint now << #nominal"
	"(Timepoint nowIn: 'Pacific/Kiritimati') << #nominal"
	"(Timepoint nowIn: 'Pacific/Kiritimati') << #default"
	"(Timepoint nowIn: 'Pacific/Kiritimati') << #system"
	"Timepoint nominalNow << 10 hours"
	"Timepoint nominalNow << 'Australia/Adelaide'"

	^(self isInvariantToUT 
		ifTrue: 
			[(self asMutableDateAndTime)
				convertToTimeZone: ChronosTimezone nominal;
				convertToTimeZone: (ChronosTimezone referencedBy: aChronosTimezone)]
		ifFalse: 
			[(self asMutableDateAndTime)
				deproxifyTimeZone;
				convertToTimeZone: (ChronosTimezone referencedBy: aChronosTimezone)]) beImmutable! !

!Timepoint methodsFor: 'converting' stamp: ''!
>> aChronosTimezone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."

	"{DateAndTimeFactory now >> 'Asia/Calcutta'}"
	"{DateAndTimeFactory nominalNow >> 'Asia/Calcutta'}"
	"{DateAndTimeFactory now >> ChronosTimezone nominal}"

	| newTimeZone |
	newTimeZone := (ChronosTimezone referencedBy:  aChronosTimezone) root.
	newTimeZone == timeZone root ifTrue: [^self isMutable ifTrue: [self copy] ifFalse: [self]].
	^self copy 
		convertToTimeZone: newTimeZone;
		beImmutable! !

!Timepoint methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 10:53'!
addHours: hours 

	^self addSeconds: hours * SecondsPerHour! !

!Timepoint methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:07'!
addHours: hours minutes: minutes
	^self addSeconds: hours * SecondsPerHour + (minutes * SecondsPerMinute)! !

!Timepoint methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:07'!
addHours: hours minutes: minutes seconds: seconds 
	^self addSeconds: hours * SecondsPerHour + (minutes * SecondsPerMinute) + seconds! !

!Timepoint methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:07'!
addHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	^self 
		addSeconds: hours * SecondsPerHour + (minutes * SecondsPerMinute) + seconds
		nanoseconds: nanoseconds! !

!Timepoint methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:07'!
addMinutes: minutes 
	^self addSeconds: minutes * SecondsPerMinute! !

!Timepoint methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:07'!
addMonths: months 
	"Add the given number of civil months to the date represented by the receiver, preserving the same civil time-of-day.   The new dayOfMonth will be the same as it had been, unless it would be invalid.  For example, if the orignal date was March 31, the new dayOfMonth will also be 31, unless the new month has less than 31 days. In such a case, the receiver's new dayOfMonth will be the last day of the receiver's new month.

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal."

	| dayFraction |
	months = 0 ifTrue: [^self].
	timeZone isProxyOrStatic
		ifTrue: [dayFraction := self basicAddMonths: months days: 0]
		ifFalse: [self preservingCivilTimeOfDayDo: [dayFraction := self basicAddMonths: months days: 0]].
	dayFraction = 0 ifFalse: [^self addSeconds: dayFraction * self secondsInDay]! !

!Timepoint methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:06'!
addSeconds: seconds
	"Add the given number of scientific seconds to the timepoint represented by the receiver. The scientific semantics of a timepoint S seconds from another will be respected (UT)."

	seconds = 0 ifTrue: [^self].
	self isImmutable ifTrue: [^self addingSeconds: seconds].
	^self addSeconds: seconds nanoseconds: 0! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
addSeconds: seconds nanoseconds: nanoseconds 
	"Add the given number of scientific seconds and nanoseconds to the timepoint represented by the receiver. The scientific semantics of a timepoint S seconds and N nanoseconds from another will be respected (UT)."

	| nanoSecondsToAdd secondsToAdd |
	self assertMutability.
	nanoSecondsToAdd := seconds isInteger
		ifTrue: 
			[secondsToAdd := seconds.
			nanoseconds rounded]
		ifFalse:
			[secondsToAdd := seconds truncated.
			((seconds - secondsToAdd) * NanosecondsPerSecond) rounded + nanoseconds rounded].
	nanoSecondsToAdd = 0
		ifFalse:
			[nanosecondsSinceSecond := nanosecondsSinceSecond + nanoSecondsToAdd.
			(nanosecondsSinceSecond < 0 
				or: [nanosecondsSinceSecond >= NanosecondsPerSecond]) 
					ifTrue: 
						[secondsToAdd := secondsToAdd +  ((nanosecondsSinceSecond bitShift: -9) // 1953125).
						nanosecondsSinceSecond := nanosecondsSinceSecond \\ NanosecondsPerSecond]].
	secondsToAdd = 0
		ifFalse:
			[timeZone isProxy ifFalse: [self ensureDaysSinceEpochIsSet].
			secondsSinceStartOfDay := secondsSinceStartOfDay + secondsToAdd.
			self changedSecondsSinceStartOfDay]! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
addYears: years 
	"Add the given number of civil years to the date represented by the receiver, preserving the same civil time-of-day.  The civil intra-year date in the new year will be the same as in the old year, unless it would be invalid.   For example, if the orignal date is March 1 in a Gregorian/Julian leap year, the date in the new year will remain March 1 after adding the specified years.  However, if the original date is February 29 and the new year is not a leap year, then the new date will be Feb 28.   

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal.  If intercalary months may occur at times other than the end of the year, the Calendar system's cultural tradition will be respected regarding the semantics of 'same civil date N years later (or earlier.)'  The implementation assumes that the only issue in that respect is whether or not 'same month' is defined by the monthOrdinal or by the monthKey (by definition of a Chronos monthKey, months with the same monthKey are semantically the same month, regardless of possibly having different monthOrdinals in different years--which does happen in some Calendars!!.)"

	| remainingDays |
	years = 0 ifTrue: [^self].
	timeZone isProxyOrStatic
		ifTrue: [remainingDays := (self basicAddYears: years)]
		ifFalse: [self preservingCivilTimeOfDayDo: [remainingDays := (self basicAddYears: years)]].
	remainingDays = 0 ifFalse: [self basicAddDays: remainingDays]! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
addYears: years months: months days: days 
	"Add the given number of civil years, months and days, and the given number of scientific seconds and nanoseconds, to the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years, M civil months and D civil days away from another date' will be respected..

	See the specifications/comments for #addYears:, #addMonths:and #addDays for more detailed/precise semantics."

	(days = 0 and: [months = 0 and: [years = 0]]) 
		ifFalse: 
			[| dayFraction daysToAdd |
			years = 0 
				ifTrue: [daysToAdd := days]
				ifFalse: [daysToAdd := days + (self basicAddYears: years)].
			daysToAdd isInteger
				ifTrue: [dayFraction := 0]
				ifFalse: 
					[| int |
					int := daysToAdd truncated.
					dayFraction := daysToAdd - int.
					daysToAdd := int].
			months = 0
				ifTrue:
					[timeZone isProxyOrStatic 
						ifTrue: [daysToAdd = 0 ifFalse: [self proxyTimeZoneAddDays: daysToAdd]]
						ifFalse:
							[self preservingCivilTimeOfDayDo: 
								[daysToAdd = 0 ifFalse: [self nonProxyTimeZoneAddDays: daysToAdd]]]]
				ifFalse: 
					[timeZone isProxyOrStatic 
						ifTrue: [dayFraction := self basicAddMonths: months days: daysToAdd + dayFraction]
						ifFalse:
							[self preservingCivilTimeOfDayDo: 
								[dayFraction := self basicAddMonths: months days: daysToAdd + dayFraction]]].
			dayFraction = 0 ifFalse: [self addSeconds: dayFraction * self secondsInDay]].! !

!Timepoint methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
alignCalendarDayWithLocalSecondsSinceStartOfDay: localSecondsSinceStartOfDay
	"PRECONDITION: Neither <year> nor <calendarDay> are nil."

	| offsetSecondsFromUTC |
	timeZone isProxy
		ifFalse: 
			[offsetSecondsFromUTC := localSecondsSinceStartOfDay - secondsSinceStartOfDay.
			offsetSecondsFromUTC abs >= self secondsInDay 
				ifTrue: [super basicAddDays: localSecondsSinceStartOfDay // SecondsPerDay]
				ifFalse: 
					["Avoid division for the common case."
					localSecondsSinceStartOfDay < 0 
						ifTrue: [super basicAddDays: -1]
						ifFalse:
							[localSecondsSinceStartOfDay >= self secondsInDay
								ifTrue: [super basicAddDays: 1]]]]! !

!Timepoint methodsFor: 'converting' stamp: ''!
asBoundToStaticTimeZone
	"(Timezone at: 'Australia/Adelaide') now asBoundToStaticTimeZone"

	^timeZone isStatic 
		ifFalse: 
			[(self copy)
				convertToTimeZone: self timeZone asStatic;
				beImmutable]! !

!Timepoint methodsFor: 'converting' stamp: ''!
asBoundToTimeZone
	^timeZone isProxy 
		ifTrue: 
			[(self copy)
				deproxifyTimeZone;
				beImmutable]
		ifFalse: [self]! !

!Timepoint methodsFor: 'converting' stamp: ''!
asDate
	"Answer the conversion of the receiver into a date-valued CalendricalCoordinate that represents the same date as does the receiver.  If the receiver is already a date-valued CalendricalCoordinate, answer the receiver.  A date-valued CalendricalCoordinate is one that specifies a date without specifying a particular time-of-day nor a particular timezone (i.e., it has nominal time semantics, and its quantum of resolution is 1 calendar day.)"

	^self class dateFactory 
		year: self year
		month: self month
		day: self dayOfMonth
		calendar: self calendar! !

!Timepoint methodsFor: 'converting' stamp: ''!
asDateAndTime
	"Answer the conversion of the receiver into a DateAndTime value that represents the same point-in-time as does the receiver.  If the receiver is already a DateAndTime value, answer the receiver.  A DateAndTime value is a CalendricalCoordinate that specifies a point-in-time, with a quantum of resolution no larger than one second, with behavior/semantics that is invariant to UT, and that conforms to the ANSI-Smalltalk <DateAndTime> protocol. See the class comment of Timepoint for further clarification."

	^self asInvariantToUT! !

!Timepoint methodsFor: 'converting' stamp: ''!
asDateAndTimeIn: aChronosTimezone
	^self >> aChronosTimezone! !

!Timepoint methodsFor: 'converting' stamp: ''!
asInvariantToNominalTime
	"Answer a value equivalent to that of the receiver in all respects, except that its semantics/behavior is invariant to nominal time.  If the receiver is already nominal-time invariant, answer the receiver. See the class comment of Timepoint for further clarification."

	"Timepoint now asInvariantToNominalTime"

	^timeZone isInvariantToUT 
		ifTrue: 
			[(self copy)
				convertToTimeZone: self class nominalTZ;
				beImmutable]
		ifFalse: [self]! !

!Timepoint methodsFor: 'converting' stamp: ''!
asInvariantToUT
	"Answer a value equivalent to that of the receiver in all respects, except that it has UT-invariant behavior/semantics.  If the receiver is already invariant-to-UT, answer the receiver. See the class comment of Timepoint for further clarification."

	^timeZone isInvariantToUT
		ifTrue: [self]
		ifFalse: [self in: ChronosTimezone default]! !

!Timepoint methodsFor: 'converting' stamp: ''!
asLocal
	"Specified and required by the ANSI-Smalltalk Standard."

	^self >> ChronosTimezone default! !

!Timepoint methodsFor: 'private' stamp: ''!
asMutableDateAndTime
	^self copy! !

!Timepoint methodsFor: 'private' stamp: ''!
asMutableDateAndTimeInvariantToUT
	^timeZone isInvariantToUT 
		ifTrue: [self copy]
		ifFalse: [self copy deproxifyTimeZone]! !

!Timepoint methodsFor: 'private' stamp: ''!
asMutableTimeOfDay
	^self copy! !

!Timepoint methodsFor: 'converting' stamp: ''!
asNative
	"Answer the native system's 'Timestamp' analog (or 'Date' analog, if no Timestamp analog is available) that semantically corresponds as closely as possible to the receiver."

	"{Julian clock now asNative}"

	^self clock nativeCalendricalCoordinateFromChronosDateAndTime: self! !

!Timepoint methodsFor: 'converting' stamp: ''!
asNominalDateAndTime
	"Answer the conversion of the receiver into a nominal-time-invariant DateAndTime value that represents the same local point-in-time as does the receiver.  If the receiver is already a nominal-time-invariant DateAndTime value, answer the receiver.  A nominal-time-invariant DateAndTime value is a CalendricalCoordinate that nominally specifies a point-in-time without reference to any particular timezone, and has a quantum of resolution no larger than one second. A nominal-time-invariant DateAndTime value conforms to the ANSI-Smalltalk <DateAndTime> protocol EXCEPT that its behavior/semantics is invariant to nominal time, as opposed to being UT invariant. See the class comment of Timepoint for further clarification."

	^self asInvariantToNominalTime! !

!Timepoint methodsFor: 'converting' stamp: ''!
asSpec
	^self dateAndTimeSpec! !

!Timepoint methodsFor: 'converting' stamp: ''!
asUT

	^self localTimeIsUniversal 
		ifTrue: [self asBoundToTimeZone]
		ifFalse: 
			[timeZone isInvariantToNominalTime
				ifTrue: 
					[self copy
						basicSetTimeZone: self class universalTZ;
						beImmutable]
				ifFalse: [self in: self class universalTZ]]! !

!Timepoint methodsFor: 'queries' stamp: ''!
atStartOfDay
	^self
		subtractingSeconds: self secondsSinceStartOfDay
		nanoseconds: self nanosecondsSinceSecond! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
basicAddDays: dayDelta 
	"Add the given number of civil days to the date represented by the receiver, preserving the same civil time-of-day."

	| daysToAdd dayFraction |
	dayDelta = 0 ifTrue: [^self].
	dayDelta isInteger
		ifTrue: 
			[daysToAdd := dayDelta.
			dayFraction := 0]
		ifFalse:
			[daysToAdd := dayDelta truncated.
			dayFraction := dayDelta - daysToAdd].
	timeZone isProxyOrStatic 
		ifTrue: [self proxyTimeZoneAddDays: daysToAdd]
		ifFalse: [self preservingCivilTimeOfDayDo: [self nonProxyTimeZoneAddDays: daysToAdd]].
	dayFraction = 0 ifFalse: [self addSeconds: dayFraction * self secondsInDay]! !

!Timepoint methodsFor: 'private-initialize-release' stamp: ''!
basicAddSecondsSinceStartOfDay: seconds

	self assertMutability.
	secondsSinceStartOfDay :=  secondsSinceStartOfDay + seconds! !

!Timepoint methodsFor: 'private' stamp: ''!
basicDaysSinceEpoch
	self ensureDaysSinceEpochIsSet.
	^daysSinceEpoch! !

!Timepoint methodsFor: 'private-time zone operations' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
basicGregorianYearAndDayOfYearAndSecondsSinceStartOfDayFunctionDo: block3
	"PRECONDIITION: The receiver's internal state has been set to a valid UTC, local or nominal timepoint. 
	The sender is responsible for knowing whether the internal state represents a UTC, local or nominal time--this method just provides the raw data from the receiver's internal state, without any timezone translation. If nil, the instance variables <daysSinceEpoch>, <year> and <calendarDay> may be set to values computed from non-nil instance variables, but only when a) the receiver is invariant to nominal time, or b) the receiver's offset seconds from UTC is 0."

	^self calendar isGregorian 
		ifTrue: 
			[year == nil 
				ifTrue: [self setYearAndCalendarDayFromDaysSinceEpoch: daysSinceEpoch].
			block3 
				value: year
				value: calendarDay dayOfYearOrdinal
				value: [:offsetSecondsFromUT | secondsSinceStartOfDay]]
		ifFalse: 
			[| dayCount ymd |
			daysSinceEpoch == nil 
				ifTrue: 
					[dayCount := self basicComputeDaysSinceEpoch.
					(timeZone isProxy or: [timeZone isUniversalTime]) 
						ifTrue: [daysSinceEpoch := dayCount]]
				ifFalse: [dayCount := daysSinceEpoch].
			ymd := Gregorian 
						dateSpecFromDaysSinceEpoch: 
							(Gregorian 
								secondsSinceEpochFromForeignSecondsSinceEpoch: dayCount * SecondsPerDay + secondsSinceStartOfDay
								convertingFrom: self calendar) // SecondsPerDay.
			block3 
				value: ymd year
				value: ymd dayOfYearOrdinal
				value: 
					[:offsetSecondsFromUT | 
					(self calendar 
						secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay) 
							\\ self secondsInDay]]! !

!Timepoint methodsFor: 'private' stamp: ''!
basicNanosecondsSinceSecond
	^nanosecondsSinceSecond! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondSinceUT: aTemporal
	^self isInvariantToUT
		ifTrue: [self utNanosecondsSinceSecond - aTemporal utNanosecondsSinceSecond]
		ifFalse: [self nanosecondsSinceSecond - aTemporal nanosecondsSinceSecond]! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondUntilUT: aTemporal 
	^self isInvariantToUT
		ifTrue: [aTemporal utNanosecondsSinceSecond - self utNanosecondsSinceSecond]
		ifFalse: [aTemporal nanosecondsSinceSecond - self nanosecondsSinceSecond]! !

!Timepoint methodsFor: 'private' stamp: ''!
basicNanosecondsSinceStartOfDay
	^secondsSinceStartOfDay * NanosecondsPerSecond + nanosecondsSinceSecond! !

!Timepoint methodsFor: 'private' stamp: ''!
basicSecondsSinceStartOfDay
	^secondsSinceStartOfDay! !

!Timepoint methodsFor: 'private-initialize-release' stamp: ''!
basicSetDaysSinceEpoch: days 
	self assertMutability.
	days isInteger 
		ifTrue: [daysSinceEpoch := days]
		ifFalse: 
			[daysSinceEpoch := days truncated.
			self basicSetSecondsSinceStartOfDay: (days - daysSinceEpoch) * self secondsInDay]! !

!Timepoint methodsFor: 'private-initialize-release' stamp: ''!
basicSetSecondsSinceEpoch: secondsSinceEpoch 

	| seconds secondsDiv128 secondsMod128 |
	self assertMutability.
	secondsSinceEpoch isInteger 
		ifTrue: [seconds := secondsSinceEpoch]
		ifFalse: 
			[seconds := secondsSinceEpoch truncated.
			self setNanosecondsSinceSecond: (secondsSinceEpoch - seconds) * NanosecondsPerSecond].
	secondsDiv128 := seconds bitShift: -7.	"Bit shifting is faster than LargeInteger math."
	daysSinceEpoch := secondsDiv128 // 675.	"128 * 675 = 86400"
	secondsMod128 := seconds bitAnd: 127.
	secondsSinceStartOfDay := secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7)	"seconds \\ 128 + (seconds // 128 \\ 675 * 128)"! !

!Timepoint methodsFor: 'private-initialize-release' stamp: ''!
basicSetSecondsSinceStartOfDay: s 
	| seconds |
	self assertMutability.
	s isInteger 
		ifTrue: [seconds := s]
		ifFalse: 
			[seconds := s truncated.
			self setNanosecondsSinceSecond: (s - seconds) * NanosecondsPerSecond].
	secondsSinceStartOfDay := seconds! !

!Timepoint methodsFor: 'private-initialize-release' stamp: ''!
basicSetTimeZone: aTimeZone
	self assertMutability.
	timeZone := aTimeZone! !

!Timepoint methodsFor: 'private-time zone operations' stamp: ''!
basicTimeZone
	^timeZone! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
beImmutable
	"Make the receiver immutable.  Idempotent.  Must answer the receiver."

	timeZone == nil ifTrue: [self canonicalize].
	lock := #immutable! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
beInvariantToNominalTime
	self convertToTimeZone: ChronosTimezone nominal! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
beInvariantToUT
	self isInvariantToUT
		ifFalse: [self convertToTimeZone: ChronosTimezone default]! !

!Timepoint methodsFor: 'accessing' stamp: ''!
calendarDay
	timeZone isProxyAndInvariantToUT 
		ifTrue: 
			[| localDaysSinceEpoch |
			localDaysSinceEpoch := self daysSinceEpoch.
			daysSinceEpoch = localDaysSinceEpoch 
				ifFalse: 
					[^self calendar 
						forDaysSinceEpoch: localDaysSinceEpoch
						setYearAndCalendarDayInto: [:y :cd | cd]]].
	calendarDay == nil ifTrue: [self setYearAndCalendarDay].
	^calendarDay! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	timeZone == nil ifTrue: [timeZone := self class nominalTZ].
	nanosecondsSinceSecond == nil ifTrue: [nanosecondsSinceSecond := 0].	
	secondsSinceStartOfDay == nil ifTrue: [secondsSinceStartOfDay := 0].! !

!Timepoint methodsFor: 'private-time zone operations' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
canonicalizeFromLocal: offsetSecondsFromUTC nanoseconds: nanoseconds 
	"The receiver's internal state has been set to a timepoint relative to local time in the receiver's current timezone.  If necessary, change the receiver's internal state so that it canonically represents that same local time in the receiver's timezone. The agruments <offsetSecondsFromUTC> and <nanoseconds> are the number of seconds and nanoseconds (respectively) to add to a UTC time in order to derive the same local time in the receiver's timezone.  The value of <nanoseconds> MUST be less than NanosecondsPerSecond."

	timeZone isInvariantToUT "When the receiver is invariant to nominal time, all time fields are supposed to be set to their local-time values. If that's already the case, then no action is necessary."
		ifTrue: 
			["When the receiver is invariant to UT, the <daysSinceEpoch> and <secondsSinceStartOfDay> instance variables are supposed to be set to their UT values."
			| netNanoseconds netOffsetSecondsFromUTC |
			self assertMutability.
			nanoseconds = 0 
				ifTrue: [netOffsetSecondsFromUTC := offsetSecondsFromUTC]
				ifFalse: 
					[netNanoseconds := nanosecondsSinceSecond - nanoseconds.
					netNanoseconds < 0 
						ifTrue: 
							[nanosecondsSinceSecond := netNanoseconds + NanosecondsPerSecond.
							netOffsetSecondsFromUTC := offsetSecondsFromUTC + 1]
						ifFalse: 
							[netNanoseconds >= NanosecondsPerSecond 
								ifTrue: 
									[nanosecondsSinceSecond := netNanoseconds - NanosecondsPerSecond .
									netOffsetSecondsFromUTC := offsetSecondsFromUTC - 1]
								ifFalse: 
									[nanosecondsSinceSecond := netNanoseconds.
									netOffsetSecondsFromUTC := offsetSecondsFromUTC]]].
			netOffsetSecondsFromUTC = 0 ifTrue: [^self].	"Subsecond time adjustements cannot, by themselves, change the year or day."
			secondsSinceStartOfDay := secondsSinceStartOfDay - netOffsetSecondsFromUTC.
			(secondsSinceStartOfDay < 0 or: [secondsSinceStartOfDay >= self secondsInDay]) 
				ifTrue: 
					[| dayDelta |
					daysSinceEpoch == nil 
						ifFalse: 
							[daysSinceEpoch := daysSinceEpoch + (dayDelta := secondsSinceStartOfDay // SecondsPerDay)].
					(timeZone isProxy and: [calendarDay notNil]) "When the receiver is invariant to UT but the timezone is a proxy, the <year> and <calendarDay> instance variables are are supposed to to be set to their UT values."
						ifTrue: 
							[dayDelta == nil 
								ifTrue: [dayDelta := secondsSinceStartOfDay // SecondsPerDay].
							dayDelta = 0 ifFalse: [super basicAddDays: dayDelta]].
					secondsSinceStartOfDay := secondsSinceStartOfDay \\ self secondsInDay]]! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
canonicalizeFromLocalTime
	"The receiver's internal state has been set to a timepoint relative to local time in the receiver's current timezone.  If necessary, change the receiver's internal state so that it canonically represents that same local time in the receiver's timezone."

	secondsSinceStartOfDay == nil ifTrue: [secondsSinceStartOfDay := 0].
	nanosecondsSinceSecond == nil ifTrue: [nanosecondsSinceSecond := 0].
	timeZone == nil ifTrue: [timeZone := self calendar defaultTimeZone].
	timeZone isInvariantToUT 
		ifTrue: 
			[| annualPolicy boundTZ |
			timeZone isBound 
				ifTrue: [boundTZ := timeZone binding]
				ifFalse: 
					[annualPolicy := 
						self basicGregorianYearAndDayOfYearAndSecondsSinceStartOfDayFunctionDo: 
								[:y :dayOfYear :sssodFunction | 
									timeZone 
										annualPolicyForLocalYear: y
										dayOfYear: dayOfYear
										secondsSinceStartOfDayFunction: sssodFunction].
					timeZone isProxy ifFalse: [timeZone := annualPolicy].
					boundTZ := annualPolicy binding].
			boundTZ canonicalizeFromLocal: self]! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
canonicalizeFromUT
	"The receiver's internal state has been set to a timepoint relative to UT.  If necessary, change the receiver's internal state so that it canonically represents that same UT time in the receiver's timezone."

	| boundTZ |
	secondsSinceStartOfDay == nil ifTrue: [secondsSinceStartOfDay := 0].
	nanosecondsSinceSecond == nil ifTrue: [nanosecondsSinceSecond := 0].
	timeZone == nil ifTrue: [timeZone := self calendar defaultTimeZone].
	timeZone isProxy
		ifTrue: [timeZone isInvariantToUT ifTrue: [^self]]
		ifFalse: [year == nil ifTrue: [^self]].
	timeZone isBound
		ifTrue: [boundTZ := timeZone binding]
		ifFalse:
			[| annualPolicy |
			annualPolicy := 
				self basicGregorianYearAndDayOfYearAndSecondsSinceStartOfDayFunctionDo: 
						[:y :dayOfYear :sssodFunction | 
							timeZone 
								bindingForUTYear: y
								dayOfYear: dayOfYear
								secondsSinceStartOfDayFunction: sssodFunction].
			timeZone isProxy ifFalse: [timeZone := annualPolicy].
			boundTZ := annualPolicy binding].
	boundTZ canonicalizeFromUT: self! !

!Timepoint methodsFor: 'private-time zone operations' stamp: ''!
canonicalizeFromUT: offsetSecondsFromUT nanoseconds: nanoseconds 
	"The receiver's internal state has been set to a timepoint relative to UT.  If necessary, change the receiver's internal state so that it canonically represents that same UT time in the receiver's timezone.  The agruments <offsetSecondsFromUT> and <nanoseconds> are the number of seconds and nanoseconds (respectively) to add to a UT time in order to derive the same local time in the receiver's timezone.  The value of <nanoseconds> MUST be less than NanosecondsPerSecond."

	| netNanoseconds netOffsetSecondsFromUT dayDelta |
	self assertMutability.
	timeZone isInvariantToNominalTime 
		ifTrue: 
			["When the receiver is invariant to nominal time, all time fields are supposed to be set to their local-time values."
			nanoseconds = 0 
				ifTrue: [netOffsetSecondsFromUT := offsetSecondsFromUT]
				ifFalse: 
					[netNanoseconds := nanosecondsSinceSecond + nanoseconds.
					netNanoseconds < 0 
						ifTrue: 
							[nanosecondsSinceSecond := netNanoseconds + NanosecondsPerSecond.
							netOffsetSecondsFromUT := offsetSecondsFromUT + 1]
						ifFalse: 
							[netNanoseconds >= NanosecondsPerSecond 
								ifTrue: 
									[nanosecondsSinceSecond := netNanoseconds - NanosecondsPerSecond.
									netOffsetSecondsFromUT := offsetSecondsFromUT + 1]
								ifFalse: 
									[nanosecondsSinceSecond := netNanoseconds.
									netOffsetSecondsFromUT := offsetSecondsFromUT]]].
			netOffsetSecondsFromUT = 0 ifTrue: [^self].	"The local year and day are already correct, since there is less than one second of net offset from UT."
			secondsSinceStartOfDay := secondsSinceStartOfDay + netOffsetSecondsFromUT.
			(secondsSinceStartOfDay < 0 or: [secondsSinceStartOfDay >= self secondsInDay]) 
				ifTrue: 
					[| secondsDiv128 secondsMod128 |
					secondsDiv128 := secondsSinceStartOfDay bitShift: -7.	"Bit shifting is faster than LargeInteger math."
					dayDelta := secondsDiv128 // 675.	"128 * 675 = 86400"
					self proxyTimeZoneAddDays: dayDelta.
					secondsMod128 := secondsSinceStartOfDay bitAnd: 127.
					secondsSinceStartOfDay := 
						secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7)	"seconds \\ 128 + (seconds // 128 \\ 675 * 128)"]]
		ifFalse: 
			["When the receiver is invariant to UT, the <daysSinceEpoch> and <secondsSinceStartOfDay> instance variables are supposed to be set to their UT values."
			year == nil ifTrue: [^self]. "The <year> and <calendarDay> are not specified, so there is no need to set them until their values are actually needed."
			timeZone isProxy ifTrue: [^self]. "When the receiver is invariant to UT but the timezone is a proxy, the <year> and <calendarDay> instance variables are are supposed to to be set to their UT values--which is already the case."
			"When the receiver is invariant to UT and the timezone is NOT a proxy, the <year> and <calendar> instance variables are supposed to be set to their local-time values."
			nanoseconds = 0 
			ifTrue: [netOffsetSecondsFromUT := offsetSecondsFromUT]
			ifFalse: 
				[netNanoseconds := nanosecondsSinceSecond + nanoseconds.
				netNanoseconds < 0 
					ifTrue: [netOffsetSecondsFromUT := offsetSecondsFromUT - 1]
					ifFalse: 
						[netNanoseconds >= NanosecondsPerSecond 
							ifTrue: [netOffsetSecondsFromUT := offsetSecondsFromUT + 1]
							ifFalse: [netOffsetSecondsFromUT := offsetSecondsFromUT]]].
		netOffsetSecondsFromUT = 0 ifTrue: [^self ]. "The local <year> and <calendarDay> are already correct, since there is less than one second of net offset from UT."
		self 
				alignCalendarDayWithLocalSecondsSinceStartOfDay: secondsSinceStartOfDay + netOffsetSecondsFromUT]! !

!Timepoint methodsFor: 'private' stamp: ''!
changedSecondsSinceStartOfDay
	(secondsSinceStartOfDay < 0 or: [secondsSinceStartOfDay >= self secondsInDay]) 
		ifTrue: 
			[| secondsDiv128 secondsMod128 dayDelta |
			self assertMutability.

			secondsDiv128 := secondsSinceStartOfDay bitShift: -7.
			dayDelta := secondsDiv128 // 675. 
			secondsMod128 := secondsSinceStartOfDay bitAnd: 127.
			secondsSinceStartOfDay := secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7).

			timeZone isProxyOrStatic 
				ifTrue: [self proxyTimeZoneAddDays: dayDelta]
				ifFalse: 
					[daysSinceEpoch := self basicDaysSinceEpoch + dayDelta.
					self 
						unbindTimeZone;
						invalidateYearAndCalendarDay]]
		ifFalse: 
			[timeZone isProxy ifTrue: [^self].
			self 
				unbindTimeZone;
				invalidateYearAndCalendarDay]! !

!Timepoint methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToDateAndTime: self] 
			on: MessageNotUnderstood 
			do: [:ex | 
				((ex receiver == aCalendrical) and: [#compareToDateAndTime: == ex message selector])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!Timepoint methodsFor: 'private-comparing' stamp: ''!
compareToDate: aDate
	^(aDate compareToDateAndTime: self) negated! !

!Timepoint methodsFor: 'private-comparing' stamp: ''!
compareToDateAndTime: aDateAndTime

	| diff |
	diff := aDateAndTime basicSecondsSince: self.
	diff = 0 ifFalse: [^diff].
	^(timeZone isInvariantToUT and: [aDateAndTime isInvariantToUT])
		ifTrue: [aDateAndTime utNanosecondsSinceSecond - self utNanosecondsSinceSecond]
		ifFalse: [aDateAndTime nanosecondsSinceSecond - self nanosecondsSinceSecond]! !

!Timepoint methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeDaysSinceEpoch
	^timeZone isProxy
		ifTrue: [self basicComputeDaysSinceEpoch]
		ifFalse: 
			[| tz offsetSecondsFromUTC localSeconds days secondsInDay |
			days := self basicComputeDaysSinceEpoch.
			tz := self timeZone.
			tz offsetIsZero ifTrue: [^days].
			localSeconds := tz 
								netSecondsAfterAddingOffsetFromUTToSeconds: secondsSinceStartOfDay
								nanosecondsSinceSecond: nanosecondsSinceSecond.
			offsetSecondsFromUTC := localSeconds - secondsSinceStartOfDay.
			offsetSecondsFromUTC abs >= (secondsInDay := self secondsInDay) 
				ifTrue: 
					[days := days - (localSeconds // SecondsPerDay).
					localSeconds := localSeconds \\ secondsInDay]
				ifFalse: 
					["Avoid division for the common case."
					localSeconds < 0 
						ifTrue: 
							[localSeconds := localSeconds + secondsInDay.
							days := days + 1]
						ifFalse: 
							[localSeconds >= secondsInDay 
								ifTrue: 
									[localSeconds := localSeconds - secondsInDay.
									days := days - 1]]].
			days]! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
convertToCalendar: otherCalendar 
	"Make the receiver represent a calendrical coordinate whose Calendar is <otherCalendar>, but which represents the same absolute temporal value (e.g., the same day in history) as does the receiver."

	| originalCalendar secondsSinceEpoch |
	originalCalendar := self calendar.
	originalCalendar == otherCalendar ifTrue: [^self].
	secondsSinceEpoch := 
		self isInvariantToNominalTime 
			ifTrue: [self secondsSinceEpoch]
			ifFalse: [self utSecondsSinceEpoch].
	self
		basicSetCalendar: otherCalendar;
		setSecondsSinceEpoch: 
			(otherCalendar 
				secondsSinceEpochFromForeignSecondsSinceEpoch: secondsSinceEpoch
				convertingFrom: originalCalendar)! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
convertToTimeZone: aTimeZone 
	| newTimeZone |
	timeZone == nil 
		ifTrue: [timeZone := self class nominalTZ].
	newTimeZone := aTimeZone root.
	timeZone root == newTimeZone ifTrue: [^self].
	self assertMutability.
	timeZone isInvariantToUT 
		ifTrue: 
			[newTimeZone isInvariantToUT 
				ifTrue: 
					[newTimeZone isProxy 
						ifTrue: [timeZone isProxy ifFalse: [self invalidateYearAndCalendarDay]]
						ifFalse: [self invalidateYearAndCalendarDay].
					self basicSetTimeZone: newTimeZone]
				ifFalse: 
					[timeZone isProxy 
						ifTrue: 
							[self basicSetTimeZone: newTimeZone.
							self canonicalizeFromUT]
						ifFalse: 
							[secondsSinceStartOfDay := self secondsSinceStartOfDay.
							self invalidateDaysSinceEpoch.
							self basicSetTimeZone: newTimeZone]]]
		ifFalse: 
			[self basicSetTimeZone: newTimeZone.
			self canonicalizeFromLocalTime]! !

!Timepoint methodsFor: 'converting' stamp: ''!
dateSpec
	^(year == nil or: [timeZone isProxyAndInvariantToUT])
		ifTrue: [self calendar dateSpecFromDaysSinceEpoch: self daysSinceEpoch]
		ifFalse: [super dateSpec]! !

!Timepoint methodsFor: 'arithmetic' stamp: ''!
daysSince: aCalendricalCoordinate
	^aCalendricalCoordinate daysUntilDateAndTime: self! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
daysSinceDate: aDate
	| dayDelta |
	dayDelta := super daysSinceDate: aDate.
	dayDelta >= 0 ifTrue: [^dayDelta].
	^self isAtStartOfDay ifTrue: [dayDelta] ifFalse: [dayDelta + 1]! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
daysSinceDateAndTime: aDateAndTime 
	"(Timepoint year: 2006 month: 4 day: 4 timeZone: 'America/New_York') 
		daysSinceDateAndTime: (Timepoint year: 2006 month: 4 day: 1 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 1 timeZone: 'America/New_York') 
		daysSinceDateAndTime: (Timepoint year: 2006 month: 4 day: 4 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 4 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York') 
		daysSinceDateAndTime: (Timepoint year: 2006 month: 4 day: 1 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 1 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York') 
		daysSinceDateAndTime: (Timepoint year: 2006 month: 4 day: 4 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 4 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York') 
		daysSinceDateAndTime: (Timepoint year: 2006 month: 4 day: 1 hour: 1 minute: 0 second: 1 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 1 hour: 1 minute: 0 second: 1 timeZone: 'America/New_York') 
		daysSinceDateAndTime: (Timepoint year: 2006 month: 4 day: 4 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York')"

	^self rootTimeZone = aDateAndTime rootTimeZone
		ifTrue: 
			[| dayDelta subdayDelta |
			dayDelta := super daysSinceDate: aDateAndTime.
			subdayDelta := self secondsSinceStartOfDay - aDateAndTime secondsSinceStartOfDay.
			subdayDelta = 0 ifTrue: [subdayDelta := self nanosecondsSinceSecond - aDateAndTime nanosecondsSinceSecond].
			dayDelta >= 0 
				ifTrue: [subdayDelta >= 0 ifTrue: [dayDelta] ifFalse: [dayDelta - 1]]
				ifFalse: [subdayDelta <= 0 ifTrue: [dayDelta] ifFalse: [dayDelta + 1]]]
		ifFalse: [(self - aDateAndTime) asDays]! !

!Timepoint methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
daysSinceEpoch
	| tz offsetSecondsFromUTC localSeconds days secondsInDay |
	timeZone isInvariantToNominalTime ifTrue: [^self basicDaysSinceEpoch].
	tz := self timeZone.
	tz offsetIsZero ifTrue: [^self basicDaysSinceEpoch].
	localSeconds := 
		tz 
			netSecondsAfterAddingOffsetFromUTToSeconds: secondsSinceStartOfDay
			nanosecondsSinceSecond: nanosecondsSinceSecond.
	offsetSecondsFromUTC := localSeconds - secondsSinceStartOfDay.
	timeZone isProxy ifTrue: [self ensureDaysSinceEpochIsSet].
	daysSinceEpoch == nil 
		ifTrue: 
			[daysSinceEpoch := days := self basicComputeDaysSinceEpoch.
			offsetSecondsFromUTC abs >= (secondsInDay := self secondsInDay)  
				ifTrue: 
					[daysSinceEpoch := daysSinceEpoch - (localSeconds // SecondsPerDay).
					localSeconds := localSeconds \\ secondsInDay]
				ifFalse: 
					["Avoid division for the common case."

					localSeconds < 0 
						ifTrue: 
							[localSeconds := localSeconds + secondsInDay.
							daysSinceEpoch := daysSinceEpoch + 1]
						ifFalse: 
							[localSeconds >= secondsInDay 
								ifTrue: 
									[localSeconds := localSeconds - secondsInDay.
									daysSinceEpoch := daysSinceEpoch - 1]]]]
		ifFalse: 
			[days := daysSinceEpoch.
			offsetSecondsFromUTC abs >= (secondsInDay := self secondsInDay) 
				ifTrue: 
					[days := days + (localSeconds // SecondsPerDay).
					localSeconds := localSeconds \\ secondsInDay]
				ifFalse: 
					["Avoid division for the common case."

					localSeconds < 0 
						ifTrue: 
							[localSeconds := localSeconds + secondsInDay.
							days := days - 1]
						ifFalse: 
							[localSeconds >= secondsInDay 
								ifTrue: 
									[localSeconds := localSeconds - secondsInDay.
									days := days + 1]]]].
	^days! !

!Timepoint methodsFor: 'arithmetic' stamp: ''!
daysUntil: aCalendricalCoordinate
	^aCalendricalCoordinate daysSinceDateAndTime: self! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
daysUntilDate: aDate 
	| dayDelta |
	dayDelta := super daysUntilDate: aDate.
	dayDelta <= 0 ifTrue: [^dayDelta].
	^self isAtStartOfDay ifTrue: [dayDelta] ifFalse: [dayDelta - 1]! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
daysUntilDateAndTime: aDateAndTime
	"(Timepoint year: 2006 month: 4 day: 1 timeZone: 'America/New_York') 
		daysUntilDateAndTime: (Timepoint year: 2006 month: 4 day: 4 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 4 timeZone: 'America/New_York') 
		daysUntilDateAndTime: (Timepoint year: 2006 month: 4 day: 1 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 1 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York') 
		daysUntilDateAndTime: (Timepoint year: 2006 month: 4 day: 4 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 4 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York') 
		daysUntilDateAndTime: (Timepoint year: 2006 month: 4 day: 1 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 1 hour: 1 minute: 0 second: 1 timeZone: 'America/New_York') 
		daysUntilDateAndTime: (Timepoint year: 2006 month: 4 day: 4 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York')"
	"(Timepoint year: 2006 month: 4 day: 4 hour: 1 minute: 0 second: 0 timeZone: 'America/New_York') 
		daysUntilDateAndTime: (Timepoint year: 2006 month: 4 day: 1 hour: 1 minute: 0 second: 1 timeZone: 'America/New_York')"

	^self rootTimeZone = aDateAndTime rootTimeZone
		ifTrue: 
			[| dayDelta subdayDelta |
			dayDelta := super daysUntilDate: aDateAndTime.
			subdayDelta := aDateAndTime secondsSinceStartOfDay -  self secondsSinceStartOfDay.
			subdayDelta = 0 ifTrue: [subdayDelta := aDateAndTime nanosecondsSinceSecond - self nanosecondsSinceSecond].
			dayDelta >= 0 
				ifTrue: [subdayDelta >= 0 ifTrue: [dayDelta] ifFalse: [dayDelta - 1]]
				ifFalse: [subdayDelta <= 0 ifTrue: [dayDelta] ifFalse: [dayDelta + 1]]]
		ifFalse: [(aDateAndTime - self) asDays]! !

!Timepoint methodsFor: 'private-time zone operations' stamp: ''!
deproxifyTimeZone
	| wasInvariantToUT |
	timeZone isProxy ifFalse: [^self].
	self assertMutability.
	wasInvariantToUT := timeZone isInvariantToUT.
	timeZone := timeZone asNonProxy.
	wasInvariantToUT 
		ifTrue: [self canonicalizeFromUT]
		ifFalse: [self canonicalizeFromLocalTime]! !

!Timepoint methodsFor: 'arithmetic' stamp: ''!
durationSince: aTemporalCoordinate
	^aTemporalCoordinate durationUntilDateAndTime: self! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
durationSinceDate: aDate
	^self civilDurationSince: aDate! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
durationSinceDateAndTime: aDateAndTime
	^self scientificDurationSince: aDateAndTime! !

!Timepoint methodsFor: 'arithmetic' stamp: ''!
durationUntil: aTemporalCoordinate
	^aTemporalCoordinate durationSinceDateAndTime: self! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
durationUntilDate: aDate
	^self civilDurationUntil: aDate! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
durationUntilDateAndTime: aDateAndTime
	^self scientificDurationUntil: aDateAndTime! !

!Timepoint methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	| unboundTz |
	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self basicSecondsSinceStartOfDay;
		nextPut: self basicNanosecondsSinceSecond.
	unboundTz := timeZone asUnbound.
	stream nextPut: 
		(unboundTz keyIsGlobal 
			ifTrue: [unboundTz key]
			ifFalse: [unboundTz literalArrayEncoding]).! !

!Timepoint methodsFor: 'private' stamp: ''!
ensureDaysSinceEpochIsSet
	daysSinceEpoch = nil 
		ifTrue: [daysSinceEpoch := self computeDaysSinceEpoch]! !

!Timepoint methodsFor: 'private' stamp: ''!
ensureYearAndCalendarDayAreSet
	year == nil ifTrue: [self setYearAndCalendarDay].! !

!Timepoint methodsFor: 'private-time zone operations' stamp: ''!
gregorianLocalYearAndDayOfYearAndSecondsSinceStartOfDayFunctionDo: block3 
	"PRECONDITIONS: Either A) the receiver is invariant to nominal time and the <secondsSinceStartOfDay> instance variable is set to represent local time, or B) the <year> and <calendarDay> instance variables are set to represent local time and the <secondsSinceStartOfDay> instance variable is set to represent UTC time [CONSEQUENTLY, the receiver's timeZone must not be a ProxyTZ unless it is the NominalTimeInvariantTZ.]."

	| ymd |
	^self isGregorian 
		ifTrue: 
			[block3 
				value: self year
				value: self dayOfYearOrdinal
				value: 
					(self isInvariantToUT 
						ifTrue: [[:offsetSecondsFromUT | secondsSinceStartOfDay + offsetSecondsFromUT]]
						ifFalse: [[:offsetSecondsFromUT | secondsSinceStartOfDay]])]
		ifFalse: 
			[| localDaysSinceEpoch |
			localDaysSinceEpoch := 
				self isInvariantToNominalTime 
					ifTrue: [self daysSinceEpoch]
					ifFalse: [self basicComputeDaysSinceEpoch].
			ymd := self calendar gregorianDateSpecFromDaysSinceEpoch: localDaysSinceEpoch.
			block3 
				value: ymd year
				value: ymd dayOfYearOrdinal
				value: (self isInvariantToUT 
						ifTrue: 
							[[:offsetSecondsFromUT | 
							((self calendar 
								secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay) 
									+ offsetSecondsFromUT) \\ self secondsInDay]]
						ifFalse: 
							[[:offsetSecondsFromUT | 
							(self calendar 
								secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay) 
									\\ self secondsInDay]])]! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	daysSinceEpoch := 0.
	secondsSinceStartOfDay := 0.
	nanosecondsSinceSecond := 0.
	timeZone := self class nominalTZ! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
initializeFrom: aCalendricalCoordinate
	self
		basicSetCalendar: aCalendricalCoordinate calendar;
		setTimeZone: aCalendricalCoordinate basicTimeZone;
		setNanosecondsSinceSecond: aCalendricalCoordinate basicNanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: aCalendricalCoordinate basicSecondsSinceStartOfDay;
		basicSetDaysSinceEpoch: aCalendricalCoordinate basicDaysSinceEpoch! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self 
		setTimeZone:  (literalArray at: 6) decodeAsLiteralArray;
		setNanosecondsSinceSecond: (literalArray at: 5) asNumber;
		basicSetSecondsSinceStartOfDay: (literalArray at: 4) asNumber! !

!Timepoint methodsFor: 'private' stamp: ''!
invalidateDaysSinceEpoch	
	self ensureYearAndCalendarDayAreSet.
	daysSinceEpoch := nil.! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
invalidateTimezone
	"Ensure that the receiver's internal state is consistent with respect to the current ruleset of the canonical instance of its timezone."

	timeZone == nil 
		ifTrue: 
			[timeZone := self class nominalTZ.
			self invalidateDaysSinceEpoch]
		ifFalse: 
			[timeZone isProxyOrStatic ifFalse: [self invalidateYearAndCalendarDay].
			timeZone := timeZone canonical]! !

!Timepoint methodsFor: 'private' stamp: ''!
invalidateYearAndCalendarDay	
	self ensureDaysSinceEpochIsSet.
	year := nil.
	calendarDay := nil.! !

!Timepoint methodsFor: 'testing' stamp: ''!
isAtStartOfDay
	^self nanosecondsSinceSecond = 0 and: [self secondsSinceStartOfDay = 0]! !

!Timepoint methodsFor: 'testing' stamp: ''!
isAtStartOfHour
	self subsecondsAreZero ifFalse: [^false].
	^(self secondsSinceStartOfDay \\ SecondsPerHour) = 0! !

!Timepoint methodsFor: 'testing' stamp: ''!
isAtStartOfMinute
	self subsecondsAreZero ifFalse: [^false].
	^(self secondsSinceStartOfDay \\ SecondsPerMinute) = 0! !

!Timepoint methodsFor: 'testing' stamp: ''!
isBoundToTimeZone
	^timeZone isProxy not! !

!Timepoint methodsFor: 'testing' stamp: ''!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^false! !

!Timepoint methodsFor: 'testing' stamp: ''!
isInvariantToNominalTime
	"Answer true if the receiver always represents an invariant nominal local time ('3 pm local time') in whatever Timezone to which it may be bound. Otherwise, answer false."

	^timeZone isInvariantToNominalTime! !

!Timepoint methodsFor: 'testing' stamp: ''!
isInvariantToUT
	"Answer true if the receiver always represents an invariant nominal UT time ('3 pm UT') in whatever Timezone to which it may be bound. Otherwise, answer false."

	^timeZone isInvariantToUT! !

!Timepoint methodsFor: 'testing' stamp: ''!
isNanosecondDuration
	"Answer whether the receiver's temporal extent is one nanosecond."

	^true! !

!Timepoint methodsFor: 'accessing' stamp: ''!
julianDay
	"Answers the Julian Day Number of the Julian Day in which the the point-in-time represented by the receiver occurs (local time.) However, if the receiver's interval spans across the transition from one Julian Day to the next, then the Julian Day Number of the first Julian Day that starts at Noon within the interval of time represented by the receiver is answered (also local time.)"

	^self calendar julianDayFromSecondsSinceEpoch: self secondsSinceEpoch! !

!Timepoint methodsFor: 'testing' stamp: ''!
localTimeIsUniversal
	^timeZone isUniversalTime! !

!Timepoint methodsFor: 'accessing' stamp: ''!
microsecondsSinceEpoch
	"{(Duration microseconds: (AnsiStandardCalendarClock now microsecondsSinceEpoch)) asDateAndTime}"

	^(self daysSinceEpoch * 675 bitShift: 7) * MicrosecondsPerSecond + self microsecondsSinceStartOfDay! !

!Timepoint methodsFor: 'accessing' stamp: ''!
millisecondsSinceEpoch
	"{(Duration milliseconds: (AnsiStandardCalendarClock now millisecondsSinceEpoch)) asDateAndTime}"

	^(self daysSinceEpoch * 675 bitShift: 7) * MillisecondsPerSecond + self millisecondsSinceStartOfDay! !

!Timepoint methodsFor: 'accessing' stamp: ''!
nanosecondsSinceEpoch
	"{(Duration nanoseconds: (AnsiStandardCalendarClock now nanosecondsSinceEpoch)) asDateAndTime}"

	^(self daysSinceEpoch * 675 bitShift: 7) * NanosecondsPerSecond + self nanosecondsSinceStartOfDay! !

!Timepoint methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond
	^timeZone isInvariantToUT 
		ifTrue: 
			[| tz |
			tz := self timeZone.
			tz hasSubsecondOffset 
				ifTrue: [(nanosecondsSinceSecond + tz offsetFromUT nanosecondsSinceSecond) \\ NanosecondsPerSecond]
				ifFalse: [nanosecondsSinceSecond]]
		ifFalse: [nanosecondsSinceSecond]! !

!Timepoint methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:24'!
nanosecondsSinceStartOfDay
	^timeZone isInvariantToUT 
		ifTrue: 
			[| tz |
			tz := self timeZone.
			tz hasSubsecondOffset 
				ifTrue: 
					[((self class durationFactory  
						seconds: secondsSinceStartOfDay
						nanoseconds: nanosecondsSinceSecond) + tz offsetFromUT) asNanoseconds \\ (NanosecondsPerDay)]
				ifFalse: [(secondsSinceStartOfDay + tz offsetSecondsFromUT) \\ self secondsInDay * (NanosecondsPerSecond) + nanosecondsSinceSecond]]
		ifFalse: [self basicNanosecondsSinceStartOfDay]! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
nonProxyTimeZoneAddDays: days 
	"Add the given number of civil days to the date represented by the receiver, preserving the same civil time-of-day.  The implementation is specific to the case where the receiver's time zone is a proxy time zone."

	self invalidateDaysSinceEpoch.
	super basicAddDays: days.
	self unbindTimeZone! !

!Timepoint methodsFor: 'private-time zone operations' stamp: ''!
offsetSecondsFromUT
	^nanosecondsSinceSecond = 0 
		ifTrue: [self timeZone offsetSecondsFromUT]
		ifFalse: 
			[self timeZone 
				netSecondsAfterAddingOffsetFromUTToSeconds: 0
				nanosecondsSinceSecond: nanosecondsSinceSecond]! !

!Timepoint methodsFor: 'private' stamp: ''!
preservingCivilTimeOfDayDo: civilTimeOfDayPreservingAction 
	| oldOffsetSecondsFromUTC delta |
	oldOffsetSecondsFromUTC := self offsetSecondsFromUT.
	civilTimeOfDayPreservingAction value.
	delta := oldOffsetSecondsFromUTC - self offsetSecondsFromUT.
	delta = 0 ifFalse: [secondsSinceStartOfDay := secondsSinceStartOfDay + delta]! !

!Timepoint methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."
	"If <aChronosPrintPolicy> == ChronosPrintPolicy default (or ChronosPrintPolicy ansiStandard or ChronosPrintPolicy iso8601,) AND if the receiver is bound to a specific timezone, then the receiver's printString will be formatted as required by both the ANSI-Smalltalk and the ISO 8601 Standards. If the receiver is not bound to a specific timezone, then the receiver's printString will be formatted as required by both the ANSI-Smalltalk and the ISO 8601 Standards except for the omission of any timezone information."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printDateAndTime: self on: stream! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
proxyTimeZoneAddDays: days 
	"Add the given number of civil days to the date represented by the receiver, preserving the same civil time-of-day.  The implementation is specific to the case where the receiver's time zone is a proxy."

	daysSinceEpoch == nil
		ifTrue: [super basicAddDays: days]
		ifFalse: 
			[daysSinceEpoch := daysSinceEpoch + days.
			self invalidateYearAndCalendarDay].! !

!Timepoint methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^NanosecondDuration! !

!Timepoint methodsFor: 'accessing' stamp: ''!
secondsSinceEpoch
	^self isInvariantToUT
		ifTrue: 
			[self timeZone 
				netSecondsAfterAddingOffsetFromUTToSeconds: self basicSecondsSinceEpoch
				nanosecondsSinceSecond: nanosecondsSinceSecond]		
		ifFalse: [self basicSecondsSinceEpoch]! !

!Timepoint methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	^self isInvariantToUT 
		ifTrue: 
			[(self timeZone 
				netSecondsAfterAddingOffsetFromUTToSeconds: secondsSinceStartOfDay
				nanosecondsSinceSecond: nanosecondsSinceSecond) \\ self secondsInDay]
		ifFalse: [secondsSinceStartOfDay]! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setDaysSinceEpoch: days
	self basicSetDaysSinceEpoch: days.
	self invalidateYearAndCalendarDay.
	self unbindTimeZone! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setHour: hour minute: minute second: second 
	self 
		validateHour: hour
		minute: minute
		second: second.
	self calendar timeOfDayClockStartsAtStartOfDay 
		ifTrue: [self setSecondsSinceStartOfDay: hour * SecondsPerHour + (minute * SecondsPerMinute) + second]
		ifFalse: [self setSecondsSinceMidnight: hour * SecondsPerHour + (minute * SecondsPerMinute) + second]! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setJulianDay: julianDay 
	self setSecondsSinceEpoch: (self calendar secondsSinceEpochFromJulianDay: julianDay)! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setJulianDay: julianDay seconds: seconds nanoseconds: nanoseconds 
	self 
		setNanosecondsSinceSecond: nanoseconds;
		setSecondsSinceEpoch: (self calendar secondsSinceEpochFromJulianDay: julianDay) + seconds! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setNanosecondsSinceEpoch: nanoseconds
	| n |
	n := nanoseconds rounded.
	self 
		setNanosecondsSinceSecond: n \\ NanosecondsPerSecond;
		setSecondsSinceEpoch: (n bitShift: -9) // 1953125! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setNanosecondsSinceSecond: n
	self assertMutability.
	"NanosecondsSinceSecondRangeConstraint assertValid: n."
	nanosecondsSinceSecond := n truncated! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setOffset: aDuration
	self convertToTimeZone: aDuration asTimezone! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setSecondsSinceEpoch: seconds 
	self 
		basicSetSecondsSinceEpoch: seconds;
		invalidateYearAndCalendarDay;
		unbindTimeZone! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setSecondsSinceMidnight: s 
	| seconds |
	self calendar midnightIsStartOfDay 
		ifTrue: [self setSecondsSinceStartOfDay: s]
		ifFalse: 
			[s isInteger
				ifTrue: [seconds := s]
				ifFalse:
					[seconds := s truncated.
					self setNanosecondsSinceSecond: (s - seconds) * NanosecondsPerSecond].
			self setSecondsSinceStartOfDay: 
					(self calendar secondsSinceStartOfDayFromSecondsSinceMidnight: seconds) \\ self secondsInDay].! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setSecondsSinceStartOfDay: s
	secondsSinceStartOfDay = s ifTrue: [^self].
	self basicSetSecondsSinceStartOfDay: s.
	self unbindTimeZone! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setTimeOfDay: aTimeOfDay 
	self
		setNanosecondsSinceSecond: aTimeOfDay nanosecondsSinceSecond;
		setHour: aTimeOfDay hour
			minute: aTimeOfDay minute
			second: aTimeOfDay second! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setTimeZone: aTimeZone 
	self assertMutability.
	timeZone := ChronosTimezone referencedBy: aTimeZone.! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setYear: aYear calendarDay: aCalendarDay 
	self basicSetYear: aYear calendarDay: aCalendarDay.
	self invalidateDaysSinceEpoch.
	self unbindTimeZone! !

!Timepoint methodsFor: 'initialize-release' stamp: ''!
setYear: aYear calendarDay: aCalendarDay daysSinceEpoch: days
	self basicSetYear: aYear calendarDay: aCalendarDay.
	daysSinceEpoch := days.
	self unbindTimeZone! !

!Timepoint methodsFor: 'private' stamp: ''!
setYearAndCalendarDay
	| savedLock |
	savedLock := lock.
	lock := nil.
	timeZone isInvariantToUT 
		ifTrue: 
			[timeZone isProxyOrStatic ifFalse: [timeZone isBound ifFalse: [self timeZone]]. 
			"If the receiver's timeZone is not a proxy, then retrieving the receiver's (bound) timeZone will usually result in the <year> and <calendarDay> being opportunistically set as a side effect.  Consequently, explicitly requesting the bound timeZone right at this point in the logic, then checking whether the year is set, makes it possible to avoid unecessarily doing the computation twice in such cases.   In the case of UT time invariant Timepoints, the timeZone must be bound in any case in order to compute the local year and calendarDay from the <daysSinceEpoch> and <secondsSinceStartOfDay> instance variables, which are both specified as UT values."
			year == nil 
				ifTrue: 
					[self setYearAndCalendarDayFromDaysSinceEpoch: 
						(timeZone isProxyAndInvariantToUT 
							ifTrue: [self utDaysSinceEpoch]
							ifFalse: [self daysSinceEpoch])]]
		ifFalse: [self setYearAndCalendarDayFromDaysSinceEpoch: self basicDaysSinceEpoch].
	lock := savedLock! !

!Timepoint methodsFor: 'private' stamp: ''!
setYearAndCalendarDayFromDaysSinceEpoch: days
	self calendar
		forDaysSinceEpoch: days 
		setYearAndCalendarDayInto: self.! !

!Timepoint methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aDuration
	^aDuration 
		subtractingYears: self yearsSinceEpoch
		months: self monthsSinceStartOfYear
		days: self daysSinceStartOfMonth
		hours: self hour
		minutes: self minute
		seconds: self second
		nanoseconds: self nanosecondsSinceSecond! !

!Timepoint methodsFor: 'accessing' stamp: ''!
timeZone
	"Answer the bound Timezone that has the correct offsetFromUT for the date and time represented by the receiver.  If the receiver's timeZone is not a proxy, the receiver's timeZone instance variable will be opportunistically set as a side effect. Also, the receiver's year and calendarDay instance variables **MAY OR MAY NOT** be opportunistically set as a side effect."

	"This method has a greater impact on the performace of Timepoints than any other method in the inheritance hierarchy.  This is where the rubber meets the road."

	| policy |
	timeZone isBound ifTrue: [^timeZone binding].
	(timeZone isInvariantToUT and: [year == nil or: [timeZone isProxy]]) 
		ifTrue: 
			[self isGregorian 
				ifTrue: 
					[| savedLock boundTZ |
					savedLock := lock.
					lock := nil.
					year == nil ifTrue: [self setYearAndCalendarDayFromDaysSinceEpoch: self basicDaysSinceEpoch].
					policy := 
						timeZone
							annualPolicyForUTYear: year
							dayOfYear: calendarDay dayOfYearOrdinal
							secondsSinceStartOfDayFunction: [:offsetSeconds | secondsSinceStartOfDay].
					boundTZ := policy binding.
					timeZone isProxy 
						ifFalse: 
							[timeZone := policy.
							self 
								alignCalendarDayWithLocalSecondsSinceStartOfDay: 
									(boundTZ
										netSecondsAfterAddingOffsetFromUTToSeconds: secondsSinceStartOfDay
										nanosecondsSinceSecond: nanosecondsSinceSecond)].
					lock := savedLock.
					^boundTZ]
				ifFalse: 
					[| ymd |
					ymd := self calendar gregorianDateSpecFromDaysSinceEpoch: daysSinceEpoch.
					policy := 
						timeZone
							annualPolicyForUTYear: ymd year
							dayOfYear: ymd dayOfYearOrdinal
							secondsSinceStartOfDayFunction: 
								[:offsetSeconds | 
								"Handle calendars whose start-of-day is not midnight."
								(self calendar 
									secondsSinceMidnightFromSecondsSinceStartOfDay: secondsSinceStartOfDay) 
										\\ self secondsInDay].
					timeZone isProxy ifFalse: [timeZone := policy].
					^policy binding]]
		ifFalse: 
			[policy := self gregorianLocalYearAndDayOfYearAndSecondsSinceStartOfDayFunctionDo: 
								[:y :dayOfYear :sssodFunction | 
									timeZone
										annualPolicyForLocalYear: y
										dayOfYear: dayOfYear
										secondsSinceStartOfDayFunction: sssodFunction].
			timeZone isProxy ifFalse: [timeZone := policy].
			^policy binding]! !

!Timepoint methodsFor: 'private-time zone operations' stamp: ''!
unbindTimeZone
	timeZone == nil ifFalse: [timeZone := timeZone asUnbound]! !

!Timepoint methodsFor: 'converting' stamp: ''!
utDateSpec
	^timeZone isProxy
		ifTrue: 
			[self ensureYearAndCalendarDayAreSet.
			DateSpec year: year calendarDay: calendarDay]
		ifFalse: [super utDateSpec]! !

!Timepoint methodsFor: 'accessing-UT' stamp: ''!
utJulianDay
	"Answers the Julian Day Number of the Julian Day in which the the point-in-time represented by the receiver occurs (Universal Time.) However, if the receiver's interval spans across the transition from one Julian Day to the next, then the Julian Day Number of the first Julian Day that starts at Noon within the interval of time represented by the receiver is answered (also Universal Time.)"

	^self calendar julianDayFromSecondsSinceEpoch: self utSecondsSinceEpoch! !

!Timepoint methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceEpoch
	^(self utDaysSinceEpoch * 675 bitShift: 7) * NanosecondsPerSecond + self utNanosecondsSinceStartOfDay! !

!Timepoint methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceSecond
	^nanosecondsSinceSecond! !

!Timepoint methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceStartOfDay
	^self basicNanosecondsSinceStartOfDay! !

!Timepoint methodsFor: 'accessing-UT' stamp: ''!
utSecondsSinceEpoch
	^self basicSecondsSinceEpoch! !

!Timepoint methodsFor: 'accessing-UT' stamp: ''!
utSecondsSinceStartOfDay
	^secondsSinceStartOfDay! !

!Timepoint methodsFor: 'accessing' stamp: ''!
year
	"Specified and required by the ANSI-Smalltalk Standard."

	timeZone isProxyAndInvariantToUT 
		ifTrue: 
			[| localDaysSinceEpoch |
			localDaysSinceEpoch := self daysSinceEpoch.
			daysSinceEpoch = localDaysSinceEpoch 
				ifFalse: 
					[^self calendar 
						forDaysSinceEpoch: localDaysSinceEpoch
						setYearAndCalendarDayInto: [:y :cd | y]]].
	year == nil ifTrue: [self setYearAndCalendarDay].
	^year! !

!Timepoint methodsFor: 'accessing-multivalued' stamp: ''!
yearAndCalendarDayDo: block2 
	^timeZone isProxyAndInvariantToUT 
		ifTrue: 
			[self calendar 
				forDaysSinceEpoch: self daysSinceEpoch
				setYearAndCalendarDayInto: block2]
		ifFalse: 
			[year == nil ifTrue: [self setYearAndCalendarDay].
			block2 value: year value: calendarDay]! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
allUSFederalHolidaysFromTodayForAYear
	"YearMonthDay allUSFederalHolidaysFromTodayForAYear"

	| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy unitedStates 
		observedAnnualEventOccurenceDatesFrom: YearMonthDay today
		through: YearMonthDay yesterday + (CalendarDuration years: 1)
		do: [:semanticKey :date :observanceType | 
				(SemanticDatePolicy usFederalHolidaySemanticKeys includes: semanticKey)
					ifTrue: [list add: date->(Array with: semanticKey with: observanceType)]].
	^list! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
calendarDurationSinceFirstMoonLandingUntilToday
	"YearMonthDay calendarDurationSinceFirstMoonLandingUntilToday"

	^(YearMonthDay year: 1969 month: July day: 20) calendarDurationUntil: YearMonthDay today! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
countOfNYSETradingDaysSince1Jan2000ThroughToday
	"YearMonthDay countOfNYSETradingDaysSince1Jan2000ThroughToday"

	^SemanticDatePolicy 
		nyseTradingDayCountFrom: (YearMonthDay year: 2000 day: 1)
		through: YearMonthDay today! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
countOfUSFederalBusinessDaysFromTodayForNextThreeYears
	"YearMonthDay countOfUSFederalBusinessDaysFromTodayForNextThreeYears"

	^SemanticDatePolicy 
		usFederalBusinessDayCountFrom: YearMonthDay today
		through: YearMonthDay yesterday + (CalendarDuration years: 3)! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
daysSInceFirstMoonLandingUntilToday
	"YearMonthDay daysSInceFirstMoonLandingUntilToday"

	^(YearMonthDay year: 1969 month: July day: 20) daysUntil: YearMonthDay today! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
showAllCalendarEpochDates
	"YearMonthDay showAllCalendarEpochDates"

	Calendar allRegisteredKeys 
		do: [:toCalendar | YearMonthDay showAllCalendarEpochDatesAs: toCalendar]! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
showAllCalendarEpochDatesAs: toCalendar 
	"YearMonthDay showAllCalendarEpochDatesAs: #Gregorian"
	"YearMonthDay showAllCalendarEpochDatesAs: #Julian"
	"YearMonthDay showAllCalendarEpochDatesAs: #'Julian-Imperial'"
	"YearMonthDay showAllCalendarEpochDatesAs: #Hebrew"
	"YearMonthDay showAllCalendarEpochDatesAs: #Solarian"

	| list stream pp |
	list := SortedCollection new.
	Calendar allRegisteredKeys 
		do: [:key | list add: (self daysSinceEpoch: 0 calendar: key)].
	pp := ConfigurableChronosPrintPolicy 
				applying: #(#showStandardCalendarName #useNumericMonthDesignator).
	Transcript cr.
	list do: 
			[:each | 
			Transcript
				cr;
				show: (each printStringUsing: pp);
				show: ' = ';
				tab;
				show: ((each as: toCalendar) printStringUsing: pp);
				show: ' = ';
				tab.
			stream := String new writeStream.
			ChronosFunction
				printFractional: each julianDate
				asDecimalOn: stream
				decimalPoint: $. 
				precision: 2.
			stream nextPutAll: ' [Julian Date]'.
			Transcript show: stream contents]! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
todayAsAll: calendarArray
	"YearMonthDay todayAsAll: Calendar allRegisteredKeys asArray"

	^calendarArray collect: [:calendar | self todayAs: calendar]! !

!YearMonthDay class methodsFor: 'examples' stamp: ''!
todayInAllCalendars
	"YearMonthDay todayInAllCalendars"

	^self todayAsAll: (Calendar allRegisteredKeys asSortedCollection: [:a :b | a == #Gregorian ifTrue: [true] ifFalse: [b == #Gregorian ifTrue: [false] ifFalse: [a < b]]])! !

!YearMonthDay methodsFor: 'private-arithmetic' stamp: ''!
basicAddDays: dayDelta 
	"Add the given number of civil days to the date represented by the receiver, preserving the same civil time-of-day."

	dayDelta = 0 ifTrue: [^self].
	calendarDay 
		startingWithYear: year
		addingDays: dayDelta
		setYearAndCalendarDayInto: self! !

!YearMonthDay methodsFor: 'private' stamp: ''!
basicDaysSinceEpochUpToYear
	^calendar daysSinceEpochUpToYear: year! !

!YearMonthDay methodsFor: 'private' stamp: ''!
basicDaysSinceStartOfYear
	^calendarDay daysSinceStartOfYear! !

!YearMonthDay methodsFor: 'private-initialize-release' stamp: ''!
basicSetYear: aYear calendarDay: aCalendarDay 
	self assertMutability.
	year := aYear.
	calendarDay := aCalendarDay.! !

!YearMonthDay methodsFor: 'initialize-release' stamp: ''!
beImmutable
	"Make the receiver immutable.  Idempotent.  Must answer the receiver."

	lock := #immutable! !

!YearMonthDay methodsFor: 'accessing' stamp: ''!
calendarDay
	^calendarDay! !

!YearMonthDay methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	year == nil ifTrue: [year := 1].
	calendarDay == nil 
		ifTrue: 
			[calendarDay := self calendar calendarDayFromDayOfYearOrdinal: 1 inYear: year]! !

!YearMonthDay methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToDate: self] 
			on: MessageNotUnderstood 
			do: [:ex | 
				((ex receiver == aCalendrical) and: [#compareToDate: == ex message selector])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!YearMonthDay methodsFor: 'converting' stamp: ''!
dateSpec
	^DateSpec year: year calendarDay: calendarDay! !

!YearMonthDay methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self basicDaysSinceEpoch! !

!YearMonthDay methodsFor: 'initialize-release' stamp: ''!
initializeFrom: aCalendricalCoordinate 
	self 
		basicSetCalendar: aCalendricalCoordinate calendar;
		basicSetYear: aCalendricalCoordinate year calendarDay: aCalendricalCoordinate calendarDay! !

!YearMonthDay methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self basicSetDaysSinceEpoch: (literalArray at: 3) asNumber! !

!YearMonthDay methodsFor: 'initialize-release' stamp: ''!
invalidateCalendar
	super invalidateCalendar.
	calendarDay := calendarDay == nil ifFalse: [calendarDay canonical]! !

!YearMonthDay methodsFor: 'private-initialize-release' stamp: ''!
value: aYear value: aCalendarDay
	self assertMutability.
	year := aYear.
	calendarDay := aCalendarDay.! !

!YearMonthDay methodsFor: 'accessing' stamp: ''!
year
	"Specified and required by the ANSI-Smalltalk Standard."

	^year! !

!YearMonthDay methodsFor: 'accessing-multivalued' stamp: ''!
yearAndCalendarDayDo: block2 
	^block2 value: year value: calendarDay! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
@ timeOfDay
	"(YearMonthDay year: 2006 month: 1 day: 31) @ (TimeOfDay hour: 12 minute: 0 second: 0)"
	"GregorianEaster canonical @ TimeOfDay now"

	^self yearAndCalendarDayDo: 
			[:year :calendarDay | 
			(self class dateAndTimeFactory basicNew)
				setCalendar: self calendar;
				basicSetTimeZone: self basicTimeZone;
				basicSetYear: year calendarDay: calendarDay;
				setTimeOfDay: timeOfDay;
				canonicalizeFromLocalTime;
				beImmutable]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
ansiDayOfWeekOrdinal
	^self calendar ansiDayOfWeekOrdinalFromDaysSinceEpoch: self daysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
asCalendarDurationSinceEpoch
	^self class calendarDurationFactory 
		years: self yearsSinceEpoch
		months: self monthsSinceStartOfYear 
		days: self daysSinceStartOfMonth! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
asCalendricalCoordinate
	"Answer the conversion of the receiver into its equivalent value implemented as a CalendricalCoordinate.  If the receiver is already a CalendricalCoordinate, answer the receiver."

	^self! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
asCivilDurationSinceEpoch
	^self class civilDurationFactory 
		years: self yearsSinceEpoch
		months: self monthsSinceStartOfYear 
		days: self daysSinceStartOfMonth
		seconds: self secondsSinceStartOfDay 
		nanoseconds: self nanosecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
asDate
	"Answer the conversion of the receiver into a date-valued CalendricalCoordinate that represents the same date as does the receiver.  If the receiver is already a date-valued CalendricalCoordinate, answer the receiver.  A date-valued CalendricalCoordinate is one that specifies a date without specifying a particular time-of-day nor a particular timezone (i.e., it has nominal time semantics, and its quantum of resolution is 1 calendar day.)"

	^self! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
asDayOfMonth
	^self yearMonthDayDo: 
		[:y :month :day | DayOfMonthFactory month: month day: day calendar: self calendar]! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
asDurationSinceEpoch
	^self class durationFactory
		seconds: self secondsSinceEpoch
		nanoseconds: self nanosecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
asNative
	"Answer the native system's 'Date' analog (or 'Timestamp' analog, if no Date analog is available) that semantically corresponds as closely as possible to the receiver."

	"{Julian clock dateToday asNative}"

	^self clock nativeCalendricalCoordinateFromChronosDate: self! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
asWeekOfMonthDayOfWeek
	^self 
		monthAndWeekOfMonthAndDayOfWeekDo: 
			[:month :weekOfMonth :dayOfWeek |
				WeekOfMonthDayOfWeekFactory 
					month: month
					week: weekOfMonth 
					dayOfWeek: dayOfWeek]! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atFirstDayOfMonth
	"{YearMonthDay today atFirstDayOfMonth}"

	^self withDayOfMonth: 1! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atFirstDayOfWeek
	"{YearMonthDay today atFirstDayOfWeek}"

	| dayOfWeek |
	^(dayOfWeek := self dayOfWeek) > Sunday 
		ifTrue: [self subtractingDays: dayOfWeek - Sunday]
		ifFalse: [self]! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atFirstDayOfYear
	"{YearMonthDay today atFirstDayOfYear}"

	^self withDayOfYear: 1! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atLastDayOfMonth
	"{YearMonthDay today  atLastDayOfMonth}"

	^self withDayOfMonth: DayOfMonthFactory lastDayOfMonth! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atLastDayOfWeek
	"{YearMonthDay today atLastDayOfWeek}"

	| dayOfWeek |
	^(dayOfWeek := self dayOfWeek) < Saturday 
		ifTrue: [self addingDays: Saturday - dayOfWeek]
		ifFalse: [self]! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atLastDayOfYear
	"{YearMonthDay today atLastDayOfYear}"

	^self withDayOfYear: DayOfYearFactory lastDayOfYear! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atStartOfDay
	^self! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atTimeOfDay: aTimeOfDay
	"YearMonthDay today atTimeOfDay: TimeOfDay now"
	"Timepoint today atTimeOfDay: TimeOfDay now"
	"GregorianEaster canonical atTimeOfDay: (TimeOfDay hour: 12 minute: 0 second: 0)"

	^self @ aTimeOfDay! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
atTimeOfDay: aTimeOfDay in: timeZone
	"YearMonthDay today atTimeOfDay: TimeOfDay now in: 'Europe/Moscow'"
	"Timepoint today atTimeOfDay: TimeOfDay now in: 'America/Denver'"
	"GregorianEaster canonical atTimeOfDay: (TimeOfDay hour: 12 minute: 0 second: 0)in: 'Asia/Tashkent'"

	^self yearAndCalendarDayDo: 
			[:year :calendarDay | 
			(self class dateAndTimeFactory basicNew)
				setCalendar: self calendar;
				setTimeZone: timeZone;
				basicSetYear: year calendarDay: calendarDay;
				setTimeOfDay: aTimeOfDay;
				canonicalizeFromLocalTime;
				beImmutable]! !

!CalendricalCoordinate methodsFor: 'private' stamp: ''!
basicComputeDaysSinceEpoch
	^self basicDaysSinceEpochUpToYear + self basicDaysSinceStartOfYear! !

!CalendricalCoordinate methodsFor: 'private' stamp: ''!
basicDaysSinceEpoch
	^self basicComputeDaysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'private' stamp: ''!
basicDaysSinceEpochUpToYear
	^self calendar daysSinceEpochUpToYear: self year! !

!CalendricalCoordinate methodsFor: 'private' stamp: ''!
basicDaysSinceStartOfYear
	^self calendarDay daysSinceStartOfYear! !

!CalendricalCoordinate methodsFor: 'private' stamp: ''!
basicDaysSinceUnificationEpoch
	^self basicDaysSinceEpoch + self calendar unificationDayNumberOfEpoch! !

!CalendricalCoordinate methodsFor: 'private' stamp: ''!
basicEnsureYearAndCalendarDayAreSet
	"By default, do nothing"! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSince: aTemporal
	^self isInvariantToUT
		ifTrue: [aTemporal basicSecondsSinceEpochUntilUT: self]		
		ifFalse: [aTemporal basicSecondsSinceEpochUntilNominal: self]! !

!CalendricalCoordinate methodsFor: 'private' stamp: ''!
basicSecondsSinceEpoch
	^(ChronosFunction secondsFromDays: self basicDaysSinceEpoch) + self basicSecondsSinceStartOfDay! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochSinceNominal: aDateAndTimeInvariantToNominalTime
	^self calendar == aDateAndTimeInvariantToNominalTime calendar
		ifTrue: [self secondsSinceEpoch - aDateAndTimeInvariantToNominalTime secondsSinceEpoch]
		ifFalse: [self secondsSinceUnificationEpoch - aDateAndTimeInvariantToNominalTime secondsSinceUnificationEpoch]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochSinceUT: aDateAndTimeInvariantToUT 
	^self calendar == aDateAndTimeInvariantToUT calendar 
		ifTrue: 
			[self isInvariantToUT 
				ifTrue: [self utSecondsSinceEpoch - aDateAndTimeInvariantToUT utSecondsSinceEpoch]
				ifFalse: [self secondsSinceEpoch - aDateAndTimeInvariantToUT secondsSinceEpoch]]
		ifFalse: 
			[self isInvariantToUT 
				ifTrue: [self utSecondsSinceUnificationEpoch - aDateAndTimeInvariantToUT utSecondsSinceUnificationEpoch]
				ifFalse: [self secondsSinceUnificationEpoch - aDateAndTimeInvariantToUT secondsSinceUnificationEpoch]]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochUntilNominal: aDateAndTimeInvariantToNominalTime 
	^self calendar == aDateAndTimeInvariantToNominalTime calendar 
		ifTrue: [aDateAndTimeInvariantToNominalTime secondsSinceEpoch - self secondsSinceEpoch]
		ifFalse: [aDateAndTimeInvariantToNominalTime secondsSinceUnificationEpoch - self secondsSinceUnificationEpoch]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochUntilUT: aDateAndTimeInvariantToUT 
	^self isInvariantToUT 
		ifTrue: 
			[self calendar == aDateAndTimeInvariantToUT calendar 
				ifTrue: [aDateAndTimeInvariantToUT utSecondsSinceEpoch - self utSecondsSinceEpoch]
				ifFalse: [aDateAndTimeInvariantToUT utSecondsSinceUnificationEpoch - self utSecondsSinceUnificationEpoch]]
		ifFalse: 
			[self calendar == aDateAndTimeInvariantToUT calendar 
				ifTrue: [aDateAndTimeInvariantToUT secondsSinceEpoch - self secondsSinceEpoch]
				ifFalse: [aDateAndTimeInvariantToUT secondsSinceUnificationEpoch - self secondsSinceUnificationEpoch]]! !

!CalendricalCoordinate methodsFor: 'private' stamp: ''!
basicSecondsSinceUnificationEpoch
	^self calendar secondsSinceUnificationEpochFromSecondsSinceEpoch: self basicSecondsSinceEpoch! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsUntil: aTemporal
	^self isInvariantToUT
		ifTrue: [aTemporal basicSecondsSinceEpochSinceUT: self]		
		ifFalse: [aTemporal basicSecondsSinceEpochSinceNominal: self]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
calendarDay
	^self dateSpec calendarDay! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
calendarDurationNominalSinceNominal: aDateAndTimeInvariantToNominalTime
	| comparand |
	comparand := 
		aDateAndTimeInvariantToNominalTime calendar == self calendar
			ifTrue: [aDateAndTimeInvariantToNominalTime]
			ifFalse: [aDateAndTimeInvariantToNominalTime as: self calendar].
	^self class calendarDurationFactory  new
		beToYear: self year 
		month: self month 
		day: self dayOfMonth 
		fromYear: comparand year
		month: comparand month
		day: comparand dayOfMonth
		calendar: self calendar! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
calendarDurationSince: aDateAndTime 
	"REQUIRED INVARIANT: (alpha calendarDurationSince: beta) = (beta calendarDurationUntil: alpha)"
	"{(Timepoint nominalYear: 1582 month: 10 day: 15) 
		calendarDurationSince: (Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0)} [Gregorian since Gegorian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: 1582 month: 10 day: 15) 
		calendarDurationSince: (Timepoint nominalYear: -4713 month: 1 day: 1 hour: 12 minute: 0 second: 0 nanosecond: 0 calendar: Calendar julian)} [Gregorian since Julian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: -4713 month: 1 day: 1 hour: 12 minute: 0 second: 0 nanosecond: 0 calendar: Calendar julian) 
		calendarDurationUntil: (Timepoint nominalYear: 1582 month: 10 day: 15)} [Julian until Gregorian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: 1582 month: 10 day: 5 calendar: Calendar julian) 
		calendarDurationSince: (Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0)} [Julian since Gregorian]
			= 6294 Years 9 Months +3:12:00:00 (Julian) [note: Julian yearNumberingPolicy is zeroless-ordinal, as is traditional]"
	"{(Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0) 
		calendarDurationUntil: (Timepoint nominalYear: 1582 month: 10 day: 5 calendar: Calendar julian)} [Gregorian until Julian] 
			= 6294 Years 9 Months +3:12:00:00 (Julian) [note: Julian yearNumberingPolicy is zeroless-ordinal, as is traditional]"

	^self isInvariantToUT
		ifTrue: [aDateAndTime calendarDurationUntilUT: self]		
		ifFalse: [aDateAndTime calendarDurationUntilNominal: self]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
calendarDurationSinceNominal: aDateAndTimeInvariantToNominalTime 
	^self isInvariantToUT 
		ifTrue: [self calendarDurationUTSinceUT: (aDateAndTimeInvariantToNominalTime in: self basicTimeZone)]
		ifFalse: [self calendarDurationNominalSinceNominal: aDateAndTimeInvariantToNominalTime]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
calendarDurationSinceUT: aDateAndTimeInvariantToUT
	^self isInvariantToUT
		ifTrue: [self calendarDurationUTSinceUT: aDateAndTimeInvariantToUT]
		ifFalse: [(self in: aDateAndTimeInvariantToUT basicTimeZone) calendarDurationNominalSinceNominal: aDateAndTimeInvariantToUT]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
calendarDurationUTSinceUT: aDateAndTimeInvariantToUT
	| comparand thisDateSpec thatDateSpec |
	comparand := 
		self calendar == aDateAndTimeInvariantToUT calendar
			ifTrue: [aDateAndTimeInvariantToUT]
			ifFalse: [aDateAndTimeInvariantToUT as: self calendar].
	thisDateSpec := self utDateSpec.
	thatDateSpec := comparand utDateSpec.
	^self class calendarDurationFactory  new
		beToYear: thisDateSpec year 
		month: thisDateSpec month 
		day: thisDateSpec dayOfMonth 
		fromYear: thatDateSpec year
		month: thatDateSpec month
		day: thatDateSpec dayOfMonth
		calendar: self calendar! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
calendarDurationUntil: aDateAndTime 
	"REQUIRED INVARIANT: (alpha calendarDurationSince: beta) = (beta calendarDurationUntil: alpha)"

	"REQUIRED INVARIANT: (alpha calendarDurationSince: beta) = (beta calendarDurationUntil: alpha)"
	"{(Timepoint nominalYear: 1582 month: 10 day: 15) 
		calendarDurationSince: (Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0)} [Gregorian since Gegorian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: 1582 month: 10 day: 15) 
		calendarDurationSince: (Timepoint nominalYear: -4713 month: 1 day: 1 hour: 12 minute: 0 second: 0 nanosecond: 0 calendar: Calendar julian)} [Gregorian since Julian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: -4713 month: 1 day: 1 hour: 12 minute: 0 second: 0 nanosecond: 0 calendar: Calendar julian) 
		calendarDurationUntil: (Timepoint nominalYear: 1582 month: 10 day: 15)} [Julian until Gregorian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: 1582 month: 10 day: 5 calendar: Calendar julian) 
		calendarDurationSince: (Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0)} [Julian since Gregorian]
			= 6294 Years 9 Months +3:12:00:00 (Julian) [note: Julian yearNumberingPolicy is zeroless-ordinal, as is traditional]"
	"{(Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0) 
		calendarDurationUntil: (Timepoint nominalYear: 1582 month: 10 day: 5 calendar: Calendar julian)} [Gregorian until Julian] 
			= 6294 Years 9 Months +3:12:00:00 (Julian) [note: Julian yearNumberingPolicy is zeroless-ordinal, as is traditional]"

	^self isInvariantToUT
		ifTrue: [aDateAndTime calendarDurationSinceUT: self]		
		ifFalse: [aDateAndTime calendarDurationSinceNominal: self]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
calendarDurationUntilNominal: aDateAndTimeInvariantToNominalTime
	^self isInvariantToUT
		ifTrue: [aDateAndTimeInvariantToNominalTime calendarDurationUTSinceUT: self]
		ifFalse: [aDateAndTimeInvariantToNominalTime calendarDurationNominalSinceNominal: self]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
calendarDurationUntilUT: aDateAndTimeInvariantToUT
	^self isInvariantToUT
		ifTrue: [aDateAndTimeInvariantToUT calendarDurationUTSinceUT: (self in: aDateAndTimeInvariantToUT basicTimeZone)]
		ifFalse: [aDateAndTimeInvariantToUT calendarDurationNominalSinceNominal: self]! !

!CalendricalCoordinate methodsFor: 'initialize-release' stamp: ''!
canonicalizeFromLocalTime
	"By default, do nothing."! !

!CalendricalCoordinate methodsFor: 'initialize-release' stamp: ''!
canonicalizeFromUT
	"By default, do nothing."! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
centuryPeriod
	"YearMonthDay today centuryPeriod"
	"DateAndTimeFactory now centuryPeriod"

	^self class timeperiodFactory 
		from: (self start subtractingYears: (self year \\ 100) - 1 months: 0 days: self dayOfYear - 1) 
		duration: (self class calendarDurationFactory years: 100)! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
civilDurationNominalSinceNominal: aDateAndTimeInvariantToNominalTime
	| comparand |
	comparand := 
		aDateAndTimeInvariantToNominalTime calendar == self calendar
			ifTrue: [aDateAndTimeInvariantToNominalTime]
			ifFalse: [aDateAndTimeInvariantToNominalTime as: self calendar].
	^self class civilDurationFactory new
		beToYear: self year 
		month: self month 
		day: self dayOfMonth 
		second: self secondsSinceStartOfDay
		nanosecond: self nanosecondsSinceSecond
		fromYear: comparand year
		month: comparand month
		day: comparand dayOfMonth
		second: comparand secondsSinceStartOfDay
		nanosecond: comparand nanosecondsSinceSecond
		calendar: self calendar! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
civilDurationSince: aDateAndTime 
	"REQUIRED INVARIANT: (alpha civilDurationSince: beta) = (beta civilDurationUntil: alpha)"
	"{(Timepoint nominalYear: 1582 month: 10 day: 15) 
		civilDurationSince: (Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0)} [Gregorian since Gegorian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: 1582 month: 10 day: 15) 
		civilDurationSince: (Timepoint nominalYear: -4713 month: 1 day: 1 hour: 12 minute: 0 second: 0 nanosecond: 0 calendar: Calendar julian)} [Gregorian since Julian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: -4713 month: 1 day: 1 hour: 12 minute: 0 second: 0 nanosecond: 0 calendar: Calendar julian) 
		civilDurationUntil: (Timepoint nominalYear: 1582 month: 10 day: 15)} [Julian until Gregorian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: 1582 month: 10 day: 5 calendar: Calendar julian) 
		civilDurationSince: (Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0)} [Julian since Gregorian]
			= 6294 Years 9 Months +3:12:00:00 (Julian) [note: Julian yearNumberingPolicy is zeroless-ordinal, as is traditional]"
	"{(Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0) 
		civilDurationUntil: (Timepoint nominalYear: 1582 month: 10 day: 5 calendar: Calendar julian)} [Gregorian until Julian] 
			= 6294 Years 9 Months +3:12:00:00 (Julian) [note: Julian yearNumberingPolicy is zeroless-ordinal, as is traditional]"

	^self isInvariantToUT
		ifTrue: [aDateAndTime civilDurationUntilUT: self]		
		ifFalse: [aDateAndTime civilDurationUntilNominal: self]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
civilDurationSinceNominal: aDateAndTimeInvariantToNominalTime 
	^self isInvariantToUT 
		ifTrue: [self civilDurationUTSinceUT: (aDateAndTimeInvariantToNominalTime in: self basicTimeZone)]
		ifFalse: [self civilDurationNominalSinceNominal: aDateAndTimeInvariantToNominalTime]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
civilDurationSinceUT: aDateAndTimeInvariantToUT
	^self isInvariantToUT
		ifTrue: [self civilDurationUTSinceUT: aDateAndTimeInvariantToUT]
		ifFalse: [(self in: aDateAndTimeInvariantToUT basicTimeZone) civilDurationNominalSinceNominal: aDateAndTimeInvariantToUT]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
civilDurationUTSinceUT: aDateAndTimeInvariantToUT
	| comparand thisDateSpec thatDateSpec |
	comparand := 
		self calendar == aDateAndTimeInvariantToUT calendar
			ifTrue: [aDateAndTimeInvariantToUT]
			ifFalse: [aDateAndTimeInvariantToUT as: self calendar].
	thisDateSpec := self utDateSpec.
	thatDateSpec := comparand utDateSpec.
	^self class civilDurationFactory new
		beToYear: thisDateSpec year 
		month: thisDateSpec month 
		day: thisDateSpec dayOfMonth 
		second: self utSecondsSinceStartOfDay
		nanosecond: self utNanosecondsSinceSecond
		fromYear: thatDateSpec year
		month: thatDateSpec month
		day: thatDateSpec dayOfMonth
		second: comparand utSecondsSinceStartOfDay
		nanosecond: comparand utNanosecondsSinceSecond
		calendar: self calendar! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
civilDurationUntil: aDateAndTime 
	"REQUIRED INVARIANT: (alpha calendarDurationSince: beta) = (beta calendarDurationUntil: alpha)"

	"REQUIRED INVARIANT: (alpha civilDurationSince: beta) = (beta civilDurationUntil: alpha)"
	"{(Timepoint nominalYear: 1582 month: 10 day: 15) 
		civilDurationSince: (Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0)} [Gregorian since Gegorian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: 1582 month: 10 day: 15) 
		civilDurationSince: (Timepoint nominalYear: -4713 month: 1 day: 1 hour: 12 minute: 0 second: 0 nanosecond: 0 calendar: Calendar julian)} [Gregorian since Julian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: -4713 month: 1 day: 1 hour: 12 minute: 0 second: 0 nanosecond: 0 calendar: Calendar julian) 
		civilDurationUntil: (Timepoint nominalYear: 1582 month: 10 day: 15)} [Julian until Gregorian]
			= 6294 Years 10 Months +20:12:00:00 (Gregorian) [note: Gregorian yearNumberingPolicy is ordinal/astronomical (as required by ANSI)]"
	"{(Timepoint nominalYear: 1582 month: 10 day: 5 calendar: Calendar julian) 
		civilDurationSince: (Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0)} [Julian since Gregorian]
			= 6294 Years 9 Months +3:12:00:00 (Julian) [note: Julian yearNumberingPolicy is zeroless-ordinal, as is traditional]"
	"{(Timepoint nominalYear: -4713 month: 11 day: 24 hour: 12 minute: 0 second: 0 nanosecond: 0) 
		civilDurationUntil: (Timepoint nominalYear: 1582 month: 10 day: 5 calendar: Calendar julian)} [Gregorian until Julian] 
			= 6294 Years 9 Months +3:12:00:00 (Julian) [note: Julian yearNumberingPolicy is zeroless-ordinal, as is traditional]"

	^self isInvariantToUT
		ifTrue: [aDateAndTime civilDurationSinceUT: self]		
		ifFalse: [aDateAndTime civilDurationSinceNominal: self]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
civilDurationUntilNominal: aDateAndTimeInvariantToNominalTime
	^self isInvariantToUT
		ifTrue: [aDateAndTimeInvariantToNominalTime civilDurationUTSinceUT: self]
		ifFalse: [aDateAndTimeInvariantToNominalTime civilDurationNominalSinceNominal: self]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
civilDurationUntilUT: aDateAndTimeInvariantToUT
	^self isInvariantToUT
		ifTrue: [aDateAndTimeInvariantToUT civilDurationUTSinceUT: (self in: aDateAndTimeInvariantToUT basicTimeZone)]
		ifFalse: [aDateAndTimeInvariantToUT civilDurationNominalSinceNominal: self]! !

!CalendricalCoordinate methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToCalendricalCoordinate: self] 
			on: MessageNotUnderstood 
			do: [:ex | 
				((ex receiver == aCalendrical) and: [#compareToCalendricalCoordinate: == ex message selector])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!CalendricalCoordinate methodsFor: 'private-comparing' stamp: ''!
compareToAnnualDate: anAnnualDate
	^(anAnnualDate compareToDate: self) negated! !

!CalendricalCoordinate methodsFor: 'private-comparing' stamp: ''!
compareToDate: aDate
	^self calendar == aDate calendar
		ifTrue: [aDate daysSinceEpoch - self daysSinceEpoch]
		ifFalse: [aDate daysSinceUnificationEpoch - self daysSinceUnificationEpoch]! !

!CalendricalCoordinate methodsFor: 'private-comparing' stamp: ''!
compareToDayOfMonth: aDayOfMonth
	^(aDayOfMonth compareToDate: self) negated! !

!CalendricalCoordinate methodsFor: 'private-comparing' stamp: ''!
compareToDayOfYear: aDayOfYear
	^(aDayOfYear compareToDate: self) negated! !

!CalendricalCoordinate methodsFor: 'private-comparing' stamp: ''!
compareToWeekOfMonthDayOfWeek: aWeekOfMonthDayOfWeek
	^(aWeekOfMonthDayOfWeek compareToDate: self) negated! !

!CalendricalCoordinate methodsFor: 'private-comparing' stamp: ''!
compareToYearMonthDaySpec: aYMDSpec

	| diff |
	diff := aYMDSpec year - self year.
	diff = 0 ifFalse: [^diff].
	^aYMDSpec calendarDay compareTo: self calendarDay! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
dateAndTimeSpec
	^self yearAndCalendarDayDo: 
			[:year :calendarDay | 
			DateAndTimeSpec 
				year: year
				calendarDay: calendarDay
				seconds: self secondsSinceStartOfDay
				nanoseconds: self nanosecondsSinceSecond]! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
dateSpec
	^self calendar dateSpecFromDaysSinceEpoch: self daysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayOfMonth
	"Specified and required by the ANSI-Smalltalk Standard."

	^self calendarDay dayOfMonth! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayOfMonthOrdinal
	^self calendarDay dayOfMonthOrdinal! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayOfWeek
	"Specified and required by the ANSI-Smalltalk Standard."

	^self calendar dayOfWeekOrdinalFromDaysSinceEpoch: self daysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayOfWeekAbbreviation
	"Specified and required by the ANSI-Smalltalk Standard."

	^ChronosLocale default abbreviationAtSemanticKey: self dayOfWeekKey! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayOfWeekKey
	^ANSIDayOfWeekKeys at: self ansiDayOfWeekOrdinal! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayOfWeekName
	"Specified and required by the ANSI-Smalltalk Standard."

	^ChronosLocale default properNameAtSemanticKey: self dayOfWeekKey! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayOfYear
	^self calendarDay dayOfYearOrdinal! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayOfYearOrdinal
	^self calendarDay dayOfYearOrdinal! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
dayPeriod
	"YearMonthDay today dayPeriod"
	"DateAndTimeFactory now dayPeriod"

	^self class timeperiodFactory  
		from: self start 
		duration: CalendarDayDuration! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
daysInMonth
	^self calendarDay daysPerMonth! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
daysInYear
	^self calendarDay daysPerYear! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
daysSince: aCalendricalCoordinate
	^aCalendricalCoordinate daysUntilDate: self! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
daysSinceDate: aDate
	^aDate calendar == self calendar 
		ifTrue: [self daysSinceEpoch - aDate daysSinceEpoch]
		ifFalse: [self daysSinceUnificationEpoch - aDate daysSinceUnificationEpoch]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
daysSinceDateAndTime: aDateAndTime 
	| dayDelta |
	dayDelta := 
		aDateAndTime calendar == self calendar 
			ifTrue: [self daysSinceEpoch - aDateAndTime daysSinceEpoch]
			ifFalse: [self daysSinceUnificationEpoch - aDateAndTime daysSinceUnificationEpoch].
	dayDelta <= 0 ifTrue: [^dayDelta].
	^aDateAndTime isAtStartOfDay ifTrue: [dayDelta] ifFalse: [dayDelta - 1]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
daysSinceEpoch
	^self basicComputeDaysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
daysSinceEpochUpToYear
	^self daysSinceEpoch - self daysSinceStartOfYear! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
daysSinceStartOfANSIWeek
	^self calendar daysSinceStartOfANSIWeekFromDaysSinceEpoch: self daysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
daysSinceStartOfISOWeek
	^self calendar daysSinceStartOfISOWeekFromDaysSinceEpoch: self daysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
daysSinceStartOfMonth
	"Answer the number of days since the first day of the receiver's month up to (but not including) the day represented by the receiver. The answer is the CARDINAL number of the day of the month represented by the receiver."

	^self calendarDay daysSinceStartOfMonth! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
daysSinceStartOfYear
	"Answer the number of days since the first day of the receiver's year up to (but not including) the day represented by the receiver. The answer is the CARDINAL number of the day of the year represented by the receiver."

	^self calendarDay daysSinceStartOfYear! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
daysSinceUnificationEpoch
	^self daysSinceEpoch + self calendar unificationDayNumberOfEpoch! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
daysUntil: aCalendricalCoordinate
	^aCalendricalCoordinate daysSinceDate: self! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
daysUntilDate: aDate 
	^aDate calendar == self calendar 
		ifTrue: [aDate daysSinceEpoch - self daysSinceEpoch]
		ifFalse: [aDate daysSinceUnificationEpoch - self daysSinceUnificationEpoch]! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
daysUntilDateAndTime: aDateAndTime 
	| dayDelta |
	dayDelta := 
		aDateAndTime calendar == self calendar 
			ifTrue: [aDateAndTime daysSinceEpoch - self daysSinceEpoch]
			ifFalse: [aDateAndTime daysSinceUnificationEpoch - self daysSinceUnificationEpoch].
	dayDelta >= 0 ifTrue: [^dayDelta].
	^aDateAndTime isAtStartOfDay ifTrue: [dayDelta] ifFalse: [dayDelta + 1]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
decade
	"YearMonthDay today decade"
	"DateAndTimeFactory now decade"

	^self class timeperiodFactory  
		from: (self start subtractingYears: (self year \\ 10) - 1 months: 0 days: self dayOfYear - 1) 
		duration: (self class calendarDurationFactory years: 10)! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
durationSince: aTemporalCoordinate
	^aTemporalCoordinate durationUntilDate: self! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationSinceDateAndTime: aDateAndTime
	^self civilDurationSince: aDateAndTime! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationSinceTimeOfDay: aTimeOfDay
	^self civilDurationSince: aTimeOfDay! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
durationUntil: aTemporalCoordinate
	^aTemporalCoordinate durationSinceDate: self! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationUntilDateAndTime: aDateAndTime
	^self civilDurationUntil: aDateAndTime! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationUntilTimeOfDay: aTimeOfDay
	^self civilDurationUntil: aTimeOfDay! !

!CalendricalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
eitherMonthOrdinalDo: block1a orMonthkeyDo: block1b
	"If the receiver's month ordinal is unambigously specified, evaluate <block1a> with the receiver's month ordinal. Otherwise, evaluate <block1b> with the semantic key that identifies the receiver's month."

	^block1a value: self monthOrdinal! !

!CalendricalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
eitherYearMonthDayDo: block3a orYearMonthkeyDayDo: block3b
	"If the receiver's month ordinal is unambigously specified, evaluate <block3a> with the receiver's year, its month ordinal and its day-of-month ordinal as the arguments. Otherwise, evaluate <block3b> with the receiver's year,  the semantic key that identifies the receiver's month and its day-of-month ordinal as the arguments."

	^self yearMonthDayDo: block3a! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
eraName
	^self calendar eraNameForYear: self year! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthAbbreviationIfResolvable: resolvable ifNot: notResolvable 
	"Evaluate <resolvable> with the abbreviation of the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^self calendarDay forLocale: aChronosLocale monthAbbreviationIfResolvable: resolvable ifNot: notResolvable! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthNameIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKkey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^self calendarDay forLocale: aChronosLocale monthNameIfResolvable: resolvable ifNot: notResolvable! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
fractionalDaysSinceEpoch
	"{(Duration days: (AnsiStandardCalendarClock now fractionalDaysSinceEpoch)) asDateAndTime}"
	"{[:tp |
		Array
			with: tp
			with: (DateAndTimeFactory secondsSinceEpoch: tp fractionalSecondsSinceEpoch)
			with: (DateAndTimeFactory daysSinceEpoch: tp fractionalDaysSinceEpoch) 
			with: (DateAndTimeFactory julianDay: tp julianDate)] value: DateAndTimeFactory now}"

	^self daysSinceEpoch + self fractionalTimeOfDay! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
fractionalSecondsSinceEpoch
	"{(Duration seconds: (AnsiStandardCalendarClock now fractionalSecondsSinceEpoch)) asDateAndTime}"
	"{[:tp |
		Array
			with: tp
			with: (DateAndTimeFactory secondsSinceEpoch: tp fractionalSecondsSinceEpoch)
			with: (DateAndTimeFactory daysSinceEpoch: tp fractionalDaysSinceEpoch) 
			with: (DateAndTimeFactory julianDay: tp julianDate)] value: DateAndTimeFactory now}"

	^ScaledDecimal 
		numerator: self nanosecondsSinceEpoch
		denominator: NanosecondsPerSecond 
		scale: 9! !

!CalendricalCoordinate methodsFor: 'private-time zone operations' stamp: ''!
gregorianLocalYearAndDayOfYearAndSecondsSinceStartOfDayFunctionDo: block3
	^self isGregorian 
		ifTrue: 
			[block3 
				value: self year
				value: self dayOfYearOrdinal
				value: [:offsetSecondsFromUTC | self secondsSinceStartOfDay]]
		ifFalse: 
			[| ymd |
			ymd := self calendar 
						gregorianDateSpecFromDaysSinceEpoch: self daysSinceEpoch.
			block3 
				value: ymd year
				value: ymd dayOfYearOrdinal
				value: 
					[:offsetSecondsFromUTC | 
					(self calendar secondsSinceMidnightFromSecondsSinceStartOfDay: self secondsSinceStartOfDay) 
						\\ self secondsInDay]]! !

!CalendricalCoordinate methodsFor: 'comparing' stamp: ''!
hash
	^self basicDaysSinceUnificationEpoch hash! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
inCanonicalCalendar
	^self calendar 
		forSecondsSinceEpoch: self secondsSinceEpoch
		canonicalCalendarAndSecondsSinceEpochDo: 
			[:canonicalCalendar :seconds | 
			| copy |
			copy := self copy.
			copy
				basicSetCalendar: canonicalCalendar;
				setSecondsSinceEpoch: seconds.
			copy isInvariantToUT ifTrue: [copy canonicalizeFromLocalTime].
			copy beImmutable]
		ifSameCalendar: [self]! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
inYear: aYear 
	"YearMonthDay today inYear: 1950"
	"(YearMonthDay year: 1 month: 7 day: 3 calendar: Julian) inYear: -1"
	"(YearMonthDay year: 2000 month: 2 day: 29)  inYear: 1999"

	aYear = self year ifTrue: [^self].
	^self addingYears: (self calendar yearNumberingPolicy ordinalFromCanonical: aYear) - self yearOrdinal! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isAtStartOfMonth
	^self isFirstDayOfMonth and: [self isAtStartOfDay]! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isAtStartOfYear
	^self isFirstDayOfYear and: [self isAtStartOfDay]! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isCalendricalCoordinate
	^true! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isFirstDayOfMonth
	^self calendarDay isFirstDayOfMonth! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isFirstDayOfYear
	^self calendarDay isFirstDayOfYear! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isLastDayOfMonth
	^self calendarDay isLastDayOfMonth! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isLastDayOfYear
	^self calendarDay isLastDayOfYear! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isLeapYear
	"Specified and required by the ANSI-Smalltalk Standard."

	^self calendarDay yearHasLeapDays! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isMonthKeyResolvable
	^true! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
isMonthOrdinalResolvable
	^true! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
isoDayOfWeekOrdinal
	^self calendar isoDayOfWeekOrdinalFromDaysSinceEpoch: self daysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
isoYearWeekDayOfWeekDo: block3
	"According to IS0 8601 specification (i.e., ISO week ordinal 1 starts on Monday of the week containing the 4th day of the year according to the Gregorian calendar--which may be in the previous Gregorian year.)"
	"{(DateAndTime year: 2003 month: 12 day: 28) isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | Array with: isoYear with: isoWeek with: isoDayOfWeek]} #(2003 52 7)"
	"{(DateAndTime year: 2003 month: 12 day: 29) isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | Array with: isoYear with: isoWeek with: isoDayOfWeek]} #(2004 1 1)"
	"{(DateAndTime year: 2004 month: 12 day: 31) isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | Array with: isoYear with: isoWeek with: isoDayOfWeek]} #(2004 53 5)"
	"{(DateAndTime year: 2005 month: 1 day: 2) isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | Array with: isoYear with: isoWeek with: isoDayOfWeek]} #(2004 53 7)"
	"{(DateAndTime year: 2005 month: 1 day: 3) isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | Array with: isoYear with: isoWeek with: isoDayOfWeek]} #(2005 1 1)"
	"{(DateAndTime year: 2010 month: 1 day: 3) isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | Array with: isoYear with: isoWeek with: isoDayOfWeek]} #(2009 53 7)"
	"{(DateAndTime year: 2010 month: 1 day: 4) isoYearWeekDayOfWeekDo: [:isoYear :isoWeek :isoDayOfWeek | Array with: isoYear with: isoWeek with: isoDayOfWeek]} #(2010 1 1)"

	|  dse daysSinceEpochUpToYear daysSinceEpochOfFourthDayOfYear dayOfWeekCardinalOfFourthDayOfYear daysSinceEpochOfFirstDayOfISO8601Year isoDayOfYearCardinal isoDayOfWeek isoWeek isoYear |
	self isGregorian ifFalse: [^self asGregorian isoYearWeekDayOfWeekDo: block3].
	dse := self daysSinceEpoch.
	daysSinceEpochUpToYear :=  dse - self daysSinceStartOfYear.
	daysSinceEpochOfFourthDayOfYear := daysSinceEpochUpToYear + 3.
	dayOfWeekCardinalOfFourthDayOfYear := daysSinceEpochOfFourthDayOfYear \\ 7. "Results in ISO value because the Gregorian Epoch day is a Monday."
	daysSinceEpochOfFirstDayOfISO8601Year := daysSinceEpochOfFourthDayOfYear - dayOfWeekCardinalOfFourthDayOfYear.
	isoDayOfYearCardinal := dse - daysSinceEpochOfFirstDayOfISO8601Year.
	isoDayOfWeek := (isoDayOfYearCardinal \\ 7) + 1.
	isoWeek := (isoDayOfYearCardinal // 7) + 1.
	isoWeek < 1 
		ifTrue: 
			[isoYear := self year - 1.
			isoWeek := 53] 
		ifFalse: 
			[(isoWeek > 52 
				and: 
					[| thursdayDelta |
					"Next thursday is in the same week as I am BUT ALSO in the next year"
					thursdayDelta := ISOThursday - isoDayOfWeek.
					thursdayDelta > 0 
						ifTrue: ["Same week--check whether next Thursday is next year:" 
								("<dayOfYearOrdinal>" dse - daysSinceEpochUpToYear + 1) + thursdayDelta > self daysInYear] 
						ifFalse: ["Not the same week, so: " false]])
				ifTrue: 
					[isoYear := self year + 1.
					isoWeek := 1] 
				ifFalse: [isoYear := self year]].
	^block3 
		value: isoYear
		value: isoWeek
		value: isoDayOfWeek! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:24'!
julianDate
	"{[:tp |
		Array
			with: tp
			with: (DateAndTimeFactory secondsSinceEpoch: tp fractionalSecondsSinceEpoch)
			with: (DateAndTimeFactory daysSinceEpoch: tp fractionalDaysSinceEpoch) 
			with: (DateAndTimeFactory julianDay: tp julianDate)] value: DateAndTimeFactory now}"

	^ScaledDecimal
		numerator: (self nanosecondsSinceEpoch + (self calendar secondsSinceJulianDayEpochUpToEpoch * NanosecondsPerSecond))
		denominator: (NanosecondsPerDay)
		scale: 9! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
julianDay
	"Answers the Julian Day Number of the Julian Day in which the the point-in-time represented by the receiver occurs (local time.) However, if the receiver's interval spans across the transition from one Julian Day to the next, then the Julian Day Number of the first Julian Day that starts at Noon within the interval of time represented by the receiver is answered (also local time.)"

	^self calendar julianDayFromDaysSinceEpoch: self daysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
julianDayNumber
	"Answers the Julian Day Number of the Julian Day that starts at Noon on the date represented by the receiver (local time.)"

	^self calendar julianDayFromDaysSinceEpoch: self daysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
microsecondsSinceEpoch
	"{(Duration microseconds: (AnsiStandardCalendarClock dateToday microsecondsSinceEpoch)) asDateAndTime}"

	^self secondsSinceEpoch * MicrosecondsPerSecond + self microsecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the receiver's calendrical system starts each day at local midnight."

	^self calendar midnightIsStartOfDay! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
milleniumPeriod
	"YearMonthDay today milleniumPeriod"
	"DateAndTimeFactory now milleniumPeriod"

	^self class timeperiodFactory  
		from: (self start subtractingYears: (self year \\ 1000) - 1 months: 0 days: self dayOfYear - 1) 
		duration: (self class calendarDurationFactory years: 1000)! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
millisecondsSinceEpoch
	"{(Duration milliseconds: (AnsiStandardCalendarClock dateToday millisecondsSinceEpoch)) asDateAndTime}"

	^self secondsSinceEpoch * MillisecondsPerSecond + self millisecond! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
month
	"Specified and required by the ANSI-Smalltalk Standard."

	^self calendarDay month! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
monthAbbreviation
	"Specified and required by the ANSI-Smalltalk Standard."

	^self 
		forLocale: ChronosLocale default
		monthAbbreviationIfResolvable: [:name | name]
		ifNot: [self calendarDay monthAbbreviation]! !

!CalendricalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
monthAndWeekOfMonthAndDayOfWeekDo: block3
	^block3 
		value: self month 
		value: (self dayOfMonth - 1 // DaysPerWeek) + 1 
		value: self dayOfWeek! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
monthKey
	^self calendarDay monthKey! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
monthKeyIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the key that semantically identifies the receiver's month as the sole argument. However, if the month's semantic key is not unambiguously resolvable, answer the result of evaluationg <notResolvable>. Answer the result of the evaluated block."

	^resolvable value: self monthKey! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
monthName
	"Specified and required by the ANSI-Smalltalk Standard."

	^self 
		forLocale: ChronosLocale default
		monthNameIfResolvable: [:name | name]
		ifNot: [self calendarDay monthName]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
monthOrdinal
	^self calendarDay monthOrdinal! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
monthPeriod
	"YearMonthDay today monthPeriod"
	"YearMonthDay today monthPeriod last"
	"YearMonthDay today monthPeriod addingMonths: 6"
	"DateAndTimeFactory now monthPeriod"

	^self class timeperiodFactory  
		from: (self start subtractingDays: self dayOfMonth - 1)
		duration: MonthDuration! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
monthlyCalendar
	"YearMonthDay today monthlyCalendar lastDay"

	^self calendarDay monthlyCalendar! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
monthsInYear
	^self calendarDay monthsPerYear! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
monthsSince: aCalendricalCoordinate 
	| civilDuration |
	civilDuration := self civilDurationSince: aCalendricalCoordinate.
	civilDuration years = 0 ifTrue: [^civilDuration months].
	^self calendar isMonthsPerYearInvariant 
		ifTrue: [civilDuration years * self calendar monthsPerYear + civilDuration months]
		ifFalse: 
			[(self calendar monthsSinceEpochUpToYear: self year) 
				- (self calendar monthsSinceEpochUpToYear: aCalendricalCoordinate year) 
					+ civilDuration months]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
monthsSinceEpoch
	^(self calendar monthsSinceEpochUpToYear: self year) 
		+ self monthsSinceStartOfYear! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
monthsSinceStartOfYear
	^self calendarDay monthsSinceStartOfYear! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
monthsUntil: aCalendricalCoordinate 
	| civilDuration |
	civilDuration := self civilDurationUntil: aCalendricalCoordinate.
	civilDuration years = 0 ifTrue: [^civilDuration months].
	^self calendar isMonthsPerYearInvariant 
		ifTrue: [civilDuration years * self calendar monthsPerYear + civilDuration months]
		ifFalse: 
			[(self calendar monthsSinceEpochUpToYear: aCalendricalCoordinate year) 
				- (self calendar monthsSinceEpochUpToYear: self year) + civilDuration months]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
nanosecondsSinceEpoch
	"{(Duration nanoseconds: (AnsiStandardCalendarClock dateToday nanosecondsSinceEpoch)) asDateAndTime}"

	^self secondsSinceEpoch * NanosecondsPerSecond + self nanosecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
nanosecondsSinceUnificationEpoch
	^self secondsSinceUnificationEpoch * NanosecondsPerSecond + self nanosecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
numericMonthDesignator
	"Answer the culturally-correct numerical label for the receiver's month (usually, this is the ordinal number of the month in the sequence of months since the month that begins a year, but such is not the case in all cultures.)"

	^self calendar 
		numericMonthDesignatorFromMonthOrdinal: self monthOrdinal
		forYearTypeCode: self yearTypeCode! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
quartersSince: aCalendricalCoordinate 
	^(self monthsSince: aCalendricalCoordinate) quo: 3! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
quartersUntil: aCalendricalCoordinate 
	^(self monthsUntil: aCalendricalCoordinate) quo: 3! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
secondsSinceEpoch
	^(self daysSinceEpoch * 675 bitShift: 7) + self secondsSinceStartOfDay
	"86400 = 128 * 675"! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
secondsSinceMidnight
	^self calendar midnightIsStartOfDay 
		ifTrue: [self secondsSinceStartOfDay]
		ifFalse: 
			[(self calendar 
				secondsSinceMidnightFromSecondsSinceStartOfDay: self secondsSinceStartOfDay) 
					\\ self secondsInDay]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
secondsSinceUnificationEpoch
	^self calendar secondsSinceUnificationEpochFromSecondsSinceEpoch: self secondsSinceEpoch! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCalendarDuration: aDuration 
	^aDuration 
		subtractingYears: self yearsSinceEpoch
		months: self monthsSinceStartOfYear
		days: self daysSinceStartOfMonth! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aDuration
	^aDuration 
		subtractingYears: self yearsSinceEpoch
		months: self monthsSinceStartOfYear
		days: self daysSinceStartOfMonth! !

!CalendricalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromDuration: aDuration
	^aDuration
		subtractingSeconds: self secondsSinceEpoch
		nanoseconds: self nanosecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
timeOfDayClockStartsAtMidnight
	"Answer true if the zero-point of the time-of-day clock coincides with midnight"

	^self calendar timeOfDayClockStartsAtMidnight! !

!CalendricalCoordinate methodsFor: 'testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the receiver's calendrical system coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^self calendar timeOfDayClockStartsAtStartOfDay! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
timeZone
	"Answer the bound Timezone that has the correct offsetFromUT for the date and time represented by the receiver."
 	| timeZone |
	timeZone := self basicTimeZone.
	^timeZone isBound
		ifTrue: [timeZone binding]
		ifFalse: 
			[self gregorianLocalYearAndDayOfYearAndSecondsSinceStartOfDayFunctionDo: 
					[:y :dayOfYear :sssodFunction | 
					timeZone 
						bindingForLocalYear: y
						dayOfYear: dayOfYear
						secondsSinceStartOfDayFunction: sssodFunction]]! !

!CalendricalCoordinate methodsFor: 'converting' stamp: ''!
utDateSpec
	^self localTimeIsUniversal 
		ifTrue: [self dateSpec]
		ifFalse: [self calendar dateSpecFromDaysSinceEpoch: self utDaysSinceEpoch ]! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utDaysSinceEpoch
	^self basicDaysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utFractionalDaysSinceEpoch
	"{(Duration days: (AnsiStandardCalendarClock now utFractionalDaysSinceEpoch)) asDateAndTimeIn: Timezone universal}"
	"{[:tp |
		Array
			with: tp
			with: (DateAndTimeFactory utSecondsSinceEpoch: tp utcFractionalSecondsSinceEpoch)
			with: (DateAndTimeFactory utDaysSinceEpoch tp utcFractionalDaysSinceEpoch) 
			with: (DateAndTimeFactory utJulianDay: tp utcJulianDate)] value: DateAndTimeFactory now}"

	^self utDaysSinceEpoch + self utFractionalTimeOfDay! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utFractionalSecondsSinceEpoch 
	"{(Duration seconds: (AnsiStandardCalendarClock now utFractionalSecondsSinceEpoch)) asDateAndTimeIn: Timezone universal}"
	"{[:tp |
		Array
			with: tp
			with: (DateAndTimeFactory utcSecondsSinceEpoch: tp utFractionalSecondsSinceEpoch)
			with: (DateAndTimeFactory utcDaysSinceEpoch: tp utFractionalDaysSinceEpoch) 
			with: (DateAndTimeFactory utcJulianDay: tp utJulianDate)] value: DateAndTimeFactory now}"

	^ScaledDecimal 
		numerator: self utNanosecondsSinceEpoch
		denominator: NanosecondsPerSecond 
		scale: 9! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: 'PaulDeBruicker 3/9/2011 11:24'!
utJulianDate
	"{DateAndTimeFactory utJulianDay: DateAndTimeFactory now utJulianDate}"

	^ScaledDecimal
		numerator: (self utNanosecondsSinceEpoch + (self calendar secondsSinceJulianDayEpochUpToEpoch * NanosecondsPerSecond))
		denominator: (NanosecondsPerDay)
		scale: 9! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utJulianDay
	"Answers the Julian Day Number of the Julian Day in which the the point-in-time represented by the receiver occurs (Universal Time.) However, if the receiver's interval spans across the transition from one Julian Day to the next, then the Julian Day Number of the first Julian Day that starts at Noon within the interval of time represented by the receiver is answered (also Universal Time.)"

	^self calendar julianDayFromDaysSinceEpoch: self utDaysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utJulianDayNumber
	"Answers the Julian Day Number of the Julian Day that starts at Noon on the date represented by the receiver (Universal Time.)"

	^self calendar julianDayFromDaysSinceEpoch: self utDaysSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utMicrosecondsSinceEpoch
	^(self utNanosecondsSinceEpoch bitShift: -3) // 125! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utMillisecondsSinceEpoch
	^(self utNanosecondsSinceEpoch bitShift: -6) // 15625! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceEpoch
	^self utSecondsSinceEpoch * NanosecondsPerSecond + self utNanosecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceUnificationEpoch
	^self utSecondsSinceUnificationEpoch * NanosecondsPerSecond + self utNanosecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utSecondsSinceEpoch
	^self timeZone 
		netSecondsAfterSubtractingOffsetFromUTFromSeconds: self basicSecondsSinceEpoch
		nanosecondsSinceSecond: self basicNanosecondsSinceSecond! !

!CalendricalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utSecondsSinceUnificationEpoch
	^self calendar secondsSinceUnificationEpochFromSecondsSinceEpoch: self utSecondsSinceEpoch! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
weekOfMonthOrdinal
	"Answer the ordinal number of the week of the month in which the day represented by the receiver occurs.  The first seven days of the month are the first week of the month."

	^self weeksSinceStartOfMonth + 1! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
weekOfYearOrdinal
	"NOT ISO 8601"

	^self weeksSinceStartOfYear + 1! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
weeksSince: aCalendricalCoordinate
	^(self daysSince: aCalendricalCoordinate) quo: DaysPerWeek! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
weeksSinceStartOfMonth
	"Answer the CARDINAL number of the week of the month in which the day represented by the receiver occurs.  The first seven days of the month are in the week whose CARDINAL number is zero."

	^self daysSinceStartOfMonth // DaysPerWeek! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
weeksSinceStartOfYear
	"NOT ISO 8601"

	^self daysSinceStartOfYear // DaysPerWeek! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
weeksUntil: aCalendricalCoordinate 
	^(self daysUntil: aCalendricalCoordinate) quo: DaysPerWeek! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
withDayOfMonth: dayOfMonthOrdinal
	"YearMonthDay today withDayOfMonth: 7"
	"(YearMonthDay year: 1 month: 7 day: 30 calendar: Julian) withDayOfMonth: 1"
	"(YearMonthDay year: 2000 month: 2 day: 1) withDayOfMonth: 0"

	| myDayOfMonth |
	myDayOfMonth := self dayOfMonth.
	myDayOfMonth = dayOfMonthOrdinal ifTrue: [^self].
	^self addingDays: 
		(dayOfMonthOrdinal > 0 
			ifTrue: [dayOfMonthOrdinal - myDayOfMonth]
			ifFalse: [(self daysInMonth + dayOfMonthOrdinal) - myDayOfMonth])! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
withDayOfYear: dayOfYear 
	"YearMonthDay today withDayOfYear: 182"
	"(YearMonthDay year: 1 month: 7 day: 3 calendar: Julian) withDayOfYear: 1"
	"(YearMonthDay year: 2000 month: 2 day: 29) withDayOfYear: -1"

	| myDayOfYear |
	myDayOfYear := self dayOfYear.
	myDayOfYear = dayOfYear ifTrue: [^self].
	^self addingDays: 
		(dayOfYear > 0 
			ifTrue: [dayOfYear - myDayOfYear]
			ifFalse: [(self daysInYear + dayOfYear) - myDayOfYear])! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
withMonth: monthOrdinal
	"YearMonthDay today withMonth: 7"
	"(YearMonthDay year: 1 month: 7 day: 3 calendar: Julian) withMonth: 1"
	"(YearMonthDay year: 2000 month: 2 day: 29) withMonth: -1"

	| myMonth |
	myMonth := self month.
	myMonth = monthOrdinal ifTrue: [^self].
	^self addingMonths: 
		(monthOrdinal > 0 
			ifTrue: [monthOrdinal - myMonth]
			ifFalse: [(self monthsInYear + monthOrdinal) - myMonth])! !

!CalendricalCoordinate methodsFor: 'queries' stamp: ''!
withMonth: monthOrdinal day: dayOfMonthOrdinal
	"YearMonthDay today withMonth: 7 day: 31"
	"(YearMonthDay year: 1 month: 7 day: 3 calendar: Julian) withMonth: 1 day: 1"
	"(YearMonthDay year: 2000 month: 2 day: 29) withMonth: -1 day: 0"

	| calendarDay month dayOfMonth monthlyCalendar |
	calendarDay := self calendarDay.
	month := calendarDay monthOrdinal.
	dayOfMonth := calendarDay dayOfMonthOrdinal.
	month := (monthOrdinal > 0 
					ifTrue: [monthOrdinal]
					ifFalse: [calendarDay monthsPerYear + monthOrdinal]).
	monthlyCalendar := calendarDay yearlyCalendar monthAt: month.
	dayOfMonth := (dayOfMonthOrdinal > 0 
							ifTrue: [dayOfMonthOrdinal]
							ifFalse: [monthlyCalendar daysPerMonth + dayOfMonthOrdinal]).
	^self withDayOfYear: (monthlyCalendar dayAt: dayOfMonth) dayOfYear! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
year
	"Specified and required by the ANSI-Smalltalk Standard."

	^self yearMonthDayDo: [:year :month :dayOfMonth | year]! !

!CalendricalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
yearAndCalendarDayDo: block2 
	^self calendar 
		forDaysSinceEpoch: self daysSinceEpoch
		setYearAndCalendarDayInto: block2! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
yearCardinal
	^self calendar yearNumberingPolicy cardinalFromCanonical: self year! !

!CalendricalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
yearMonthDayDo: block3 
	"Evaluate <block3> with the calendar year number, month ordinal and day-of-month ordinal of the day represented by the receiver as the first, second and third arguments (respectively.) If the receiver is not bound to a particular year, use nil as the value of the year."

	^self yearAndCalendarDayDo: 
			[:year :calendarDay | 
			block3 
				value: year
				value: calendarDay monthOrdinal
				value: calendarDay dayOfMonthOrdinal]! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
yearOrdinal
	^self calendar yearNumberingPolicy ordinalFromCanonical: self year! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
yearPeriod
	"YearMonthDay today yearPeriod"
	"DateAndTimeFactory now yearPeriod"

	^self class timeperiodFactory  
		from: (self start subtractingDays: self dayOfYear - 1) 
		duration: YearDuration! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
yearTypeCode
	^self calendarDay yearTypeCode! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
yearlyCalendar
	"YearMonthDay today yearlyCalendar"

	^self calendarDay yearlyCalendar! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
yearsSince: aCalendricalCoordinate
	^(self calendarDurationSince: aCalendricalCoordinate) years! !

!CalendricalCoordinate methodsFor: 'accessing' stamp: ''!
yearsSinceEpoch
	^self yearCardinal! !

!CalendricalCoordinate methodsFor: 'arithmetic' stamp: ''!
yearsUntil: aCalendricalCoordinate
	^(self calendarDurationUntil: aCalendricalCoordinate) years! !

CalendricalCoordinate subclass: #Timeperiod
	instanceVariableNames: 'start duration'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!Timeperiod commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

Timeperiod

	Concept:

		A Timeperiod is a TemporalInterval (which see) whose duration may be specified to be any durational value.

	Usage:

		The starting point of a Timeperiod may be any TemporalCoordinate (which see,) and can be accessed by sending the message #start to a Timeperiod instance. The Calendar associated with a Timeperiod is the same as the Calendar of its starting point.

		A Timeperiod can be used for the following purposes:

			1. To determine whether a point-in-time occurs during a particular temporal interval (e.g., "Timeperiod today includes: Gregorian clock now.")
			2. To determine whether one temporal interval intersects, contains or is adjacent to another (e.g., "Timeperiod today isAdjacentTo: YearMonthDay today tomorrow asTimeperiod.") 
			3. To compute the union or intersection of two temporal intervals (e.g., "Timeperiod currentYear * (Timeperiod yearStartingAt: YearMonthDay today).").
			4. To compute the temporal interval that results from adding/subtracting a temporal extent to/from a temporal interval's starting point-in-time--preserving the interval's exent (e.g., "(Timeperiod dayStartingAt: Gregorian clock now) + (CalendarDuration months: 6)").
			5. To compute and/or enumerate over a sequence of smaller temporal intervals contained by a larger temporal interval (e.g., "(Timeperiod yearStartingAt: YearMonthDay today) quartersDo: [:eachQuarter | Transcript cr; show: eachQuarter printString].")
			6. To compute and/or enumerate over a succession of temporal intervals, each starting at the endpoint of its predecessor, and having the same temporal extent (e.g., "(Timeperiod from: TimeOfDay now duration: HourDuration) next: 24.")

		See the individual method comments for more details.

	Implementation:

		Instance Variables

			start 		<TemporalCoordinate>
				The starting point-in-time ("left endpoint") of the temporal interval represented by the instance--this moment is included in the interval.
			duration 	<Durational>
				The temporal extent of the temporal interval represented by the instance.  The point-in-time computed by adding the <duration> to the <start> is the "right endpoint" or "limit" of the instance's temporal interval--and is NOT included in the interval (although all points-in-time asymptotically approaching the limit value "from the left" (from the <start> value) are included.) The <duration> may be either a scalar number of seconds (as implemented by ScientificDuration) or a vector specifying some number of years, months, days and seconds (as implemented by CalendarDuration.) The <duration> may be either positive or negative.

!

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
currentHour
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is the initial moment of the current hour (a DateAndTime instance bound to current default timezone and the Gregorian Calendar) and whose open temporal extent is one hour. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod currentHour}"

	^self hourStartingAt: self dateAndTimeFactory nowToTheHour! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
currentMinute
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is the initial moment of the current minute (a DateAndTime instance bound to current default timezone and the Gregorian Calendar) and whose open temporal extent is one minute. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod currentMinute}"

	^self minuteStartingAt: self dateAndTimeFactory nowToTheMinute! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
currentMonth
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is the first day of the current month (a YearMonthDay instance bound to the Gregorian Calendar) and whose open temporal extent is one month. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod currentMonth}"

	^self monthStartingAt: self dateFactory atFirstDayOfMonth! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
currentSecond
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is the initial moment of the current second (a DateAndTime instance bound to current default timezone and the Gregorian Calendar) and whose open temporal extent is one second. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod currentSecond}"

	^self secondStartingAt: self dateAndTimeFactory nowToTheSecond! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
currentWeek 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is the first day of the current week (a YearMonthDay instance bound to the Gregorian Calendar) and whose open temporal extent is one week (7 days.) The first day of the week is considered to be Sunday. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod currentWeek}"

	^self weekStartingAt: self dateFactory atFirstDayOfWeek! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
currentYear
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is the first day of the current year (a YearMonthDay instance bound to the Gregorian Calendar) and whose open temporal extent is one year. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod currentYear}"
	"{(Timeperiod currentYear quarterPeriods at: 4) last}"

	^self yearStartingAt: self dateFactory atFirstDayOfYear! !

!Timeperiod class methodsFor: 'instance creation-common periods' stamp: ''!
dayStartingAt: initialMoment 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is one calendar day. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod dayStartingAt: Gregorian clock now}"

	^self from: initialMoment duration: CalendarDayDuration! !

!Timeperiod class methodsFor: 'instance creation' stamp: ''!
duration: temporalExtent through: finalMoment
	"Answer a new Timeperiod that represents a closed temporal interval whose starting point-in-time is <finalMoment - temporalExtent + finalMoment resolutionQuantum> (where <finalMoment> is a TemporalCoordinate) and whose open temporal extent is <temporalExtent> (a Durational instance.) A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod
		duration: (CalendarDuration years: 100) 
		to: (YearMonthDay year: 2001 day: 1)}"
	"{(Timeperiod
		duration: (ScientificDuration hours: 2) 
		to: (Timepoint year: 2005 month: 4 day: 3 hour: 4 minute: 0 second: 0)) hourPeriods}"

	^self new
		setStart: finalMoment - temporalExtent + finalMoment resolutionQuantum duration: temporalExtent;
		beImmutable! !

!Timeperiod class methodsFor: 'instance creation' stamp: ''!
duration: temporalExtent to: limitMoment
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <limitMoment - temporalExtent> (where <last> is a TemporalCoordinate) and whose open temporal extent is <temporalExtent> (a Durational instance.) A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod
		duration: (CalendarDuration years: 100) 
		to: (YearMonthDay year: 1901 day: 1)}"
	"{(Timeperiod
		duration: (ScientificDuration hours: 2) 
		to: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 0 second: 0)) hourPeriods}"

	^self new
		setStart: limitMoment - temporalExtent duration: temporalExtent;
		beImmutable! !

!Timeperiod class methodsFor: 'instance creation' stamp: ''!
endpoint: endpoint1 endpoint: endpoint2
	"{Timeperiod 
		endpoint: (YearMonthDay year: 1901 day: 1)
		endpoint: (YearMonthDay year: 2001 day: 1)}"
	"{Timeperiod 
		endpoint: (YearMonthDay year: 2001 day: 1)
		endpoint: (YearMonthDay year: 1901 day: 1)}"

	^endpoint1 <= endpoint2
		ifTrue: [self from: endpoint1 to: endpoint2]
		ifFalse: [self from: endpoint2 to: endpoint1]! !

!Timeperiod class methodsFor: 'instance creation' stamp: ''!
from: initialMoment duration: temporalExtent
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is <temporalExtent> (a Durational instance.) A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod 
		from: (YearMonthDay year: 1901 day: 1)
		duration: (CalendarDuration years: 100)}"
	"{(Timeperiod 
		from: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 0 second: 0)
		duration: (ScientificDuration hours: 2)) hourPeriods}"

	^self new
		setStart: initialMoment duration: temporalExtent;
		beImmutable! !

!Timeperiod class methodsFor: 'instance creation' stamp: ''!
from: initialMoment through: finalMoment
	"Answer a new Timeperiod that represents a closed temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose right end-point (its final value) is <finalMoment>. A closed temporal interval includes both its initial moment (left end-point) and also its right end-point. The temporal extent of the answered instance will be the ScientificDuration computed by subtracting the <initialMoment> from the <limitMoment>, and then adding the resolution quantum of <finalMoment>."

	"{Timeperiod 
		from: (YearMonthDay year: 1901 day: 1)
		through: (YearMonthDay year: 2000 day: 366)}"
	"{Timeperiod 
		from: (YearMonthDay year: 2001 day: 1)
		through: (YearMonthDay year: 1901 day: 1)}"

	^self from: initialMoment to: finalMoment + finalMoment resolutionQuantum! !

!Timeperiod class methodsFor: 'instance creation' stamp: ''!
from: initialMoment to: limitMoment
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose right end-point (its limit value) is <limitMoment>. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point. The temporal extent of the answered instance will be the ScientificDuration computed by subtracting the <initialMoment> from the <limitMoment>."

	"{Timeperiod 
		from: (YearMonthDay year: 1901 day: 1)
		to: (YearMonthDay year: 2001 day: 1)}"
	"{Timeperiod 
		from: (YearMonthDay year: 2001 day: 1)
		to: (YearMonthDay year: 1901 day: 1)}"

	^self new
		setStart: initialMoment limit: limitMoment;
		beImmutable! !

!Timeperiod class methodsFor: 'instance creation-common periods' stamp: ''!
hourStartingAt: initialMoment 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is one hour. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod hourStartingAt: Gregorian clock now}"

	^self from: initialMoment duration: HourDuration! !

!Timeperiod class methodsFor: 'instance creation-common periods' stamp: ''!
minuteStartingAt: initialMoment 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is one minute. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod minuteStartingAt: Gregorian clock now}"

	^self from: initialMoment duration: MinuteDuration! !

!Timeperiod class methodsFor: 'instance creation-common periods' stamp: ''!
monthStartingAt: initialMoment 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is one month. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod monthStartingAt: YearMonthDay today}"

	^self from: initialMoment duration: MonthDuration! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
nowIn: aChronosTimezoneOrTimezoneReference as: aCalendarOrCalendarReference duration: aDurational 
	"{Timeperiod nowIn: 'Pacific/Kiritimati' as: #Julian duration: MinuteDuration}"
	"{Timeperiod nowIn: #system as: #Gregorian duration: CalendarDayDuration}"
	"{Timeperiod nowIn: #nominal as: #Gregorian duration: CivilSecondDuration}"
	"{Timeperiod nowIn: 'Asia/Jerusalem' as: #Hebrew duration: WeekDuration}"
	"{Timeperiod nowIn: 'Asia/Calcutta' as: #Indian duration: (ScientificDuration milliseconds: 1)}"
	"{Timeperiod nowIn: 'Asia/Tehran' as: #Persian duration: HourDuration}"

	^self 
		from: 
			(self dateAndTimeFactory 
				nowIn: aChronosTimezoneOrTimezoneReference
				as: aCalendarOrCalendarReference)
		duration: aDurational! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
nowIn: aChronosTimezoneOrTimezoneReference duration: aDurational 
	"{Timeperiod nowIn: 'Pacific/Kiritimati' duration: MinuteDuration}"
	"{Timeperiod nowIn: #system duration: CalendarDayDuration}"
	"{Timeperiod nowIn: #nominal duration: CivilSecondDuration}"
	"{Timeperiod nowIn: 'Asia/Jerusalem' duration: WeekDuration}"
	"{Timeperiod nowIn: 'Asia/Calcutta' duration: (ScientificDuration milliseconds: 1)}"
	"{Timeperiod nowIn: 'Asia/Tehran' duration: HourDuration}"

	^self nowIn: aChronosTimezoneOrTimezoneReference as: AnsiStandardCalendar duration: aDurational! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
nowWithDuration: aDurational 
	"{Timeperiod nowWithDuration: MinuteDuration}"
	"{Timeperiod nowWithDuration: CalendarDayDuration}"
	"{Timeperiod nowWithDuration: CivilSecondDuration}"
	"{Timeperiod nowWithDuration: WeekDuration}"
	"{Timeperiod nowWithDuration: (ScientificDuration milliseconds: 1)}"
	"{Timeperiod nowWithDuration: HourDuration}"

	^self nowIn: ChronosTimezone default duration: aDurational! !

!Timeperiod class methodsFor: 'instance creation-common periods' stamp: ''!
quarterStartingAt: initialMoment 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is one quarter (three months.) A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod quarterStartingAt: YearMonthDay today}"

	^self from: initialMoment duration: MonthDuration * 3! !

!Timeperiod class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^(ChronosParser referencedBy: aChronosParser) nextTimeperiodFrom: stream usingFactory: self! !

!Timeperiod class methodsFor: 'instance creation-common periods' stamp: ''!
secondStartingAt: initialMoment 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is one second. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"Timeperiod secondStartingAt: Gregorian clock now"

	^self from: initialMoment duration: CivilSecondDuration! !

!Timeperiod class methodsFor: 'deprecated' stamp: ''!
startingAt: initialMoment duration: temporalExtent
	"Deprecated. See #from:duration:"

	^self from: initialMoment duration: temporalExtent! !

!Timeperiod class methodsFor: 'deprecated' stamp: ''!
startingAt: initialMoment upTo: limitMoment
	"Deprecated. See #from:to:"

	^self from: initialMoment to: limitMoment! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
today 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is today (a YearMonthDay instance bound to the Gregorian Calendar) and whose open temporal extent is one day. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod today}"
	"{Timeperiod today next: 30}"

	^self dayStartingAt: self dateFactory today! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
todayAs: aCalendarOrCalendarReference
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is today (a YearMonthDay instance bound to the calendar implemented or referenced by <aCalendarOrCalendarReference>) and whose open temporal extent is one day. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod todayAs: #Hebrew}"

	^self dayStartingAt: (self dateFactory todayAs: aCalendarOrCalendarReference)! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
todayIn: aTimeZoneOrTimeZoneReference
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is today in the timezone referenced by <aTimeZoneOrTimeZoneReference> (the starting point-in-time will be a YearMonthDay instance bound to the Gregorian Calendar) and whose open temporal extent is one day. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod todayIn: 'Asia/Calcutta'}"
	"{Timeperiod todayIn: #default}"
	"{Timeperiod todayIn: #nominal}"

	| tz |
	tz := ChronosTimezone referencedBy: aTimeZoneOrTimeZoneReference.
	^self dayStartingAt: ((tz isInvariantToNominalTime ifTrue: [self dateFactory] ifFalse: [self dateAndTimeFactory]) todayIn: tz)! !

!Timeperiod class methodsFor: 'instance creation-current periods' stamp: ''!
todayIn: aTimeZoneOrTimeZoneReference as: aCalendarOrCalendarReference
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is today in the timezone referenced by <aTimeZoneOrTimeZoneReference> (the starting point-in-time will be a YearMonthDay instance bound to the calendar implemented or referenced by <aCalendarOrCalendarReference>) and whose open temporal extent is one day. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod todayIn: 'Asia/Calcutta' as: #Indian}"
	"{Timeperiod todayIn: #default as: #Indian}"
	"{Timeperiod todayIn: #nominal as: #Indian}"

	| tz |
	tz := ChronosTimezone referencedBy: aTimeZoneOrTimeZoneReference.
	^self dayStartingAt: ((tz isInvariantToNominalTime ifTrue: [self dateFactory] ifFalse: [self dateAndTimeFactory]) todayIn: tz as: aCalendarOrCalendarReference)! !

!Timeperiod class methodsFor: 'instance creation-common periods' stamp: ''!
weekStartingAt: initialMoment 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is one week (7 calendar days.) A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod weekStartingAt: YearMonthDay today}"

	^self from: initialMoment duration: WeekDuration! !

!Timeperiod class methodsFor: 'instance creation-common periods' stamp: ''!
yearStartingAt: initialMoment 
	"Answer a new Timeperiod that represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is one year. A left-closed, right-open temporal interval includes its initial moment (left end-point) but does not include its right end-point (defined as the moment computed by adding the temporal extent to the initial moment.)"

	"{Timeperiod yearStartingAt: YearMonthDay today}"

	^self from: initialMoment duration: YearDuration! !

!Timeperiod methodsFor: 'converting' stamp: ''!
<< timeZone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but convert the date and time-of-day as though the receiver represented a date and time in the current default time zone (i.e,. preserve date and time-of-day in Universal Time as though the receiver represented a date and time in the current default time zone.)
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is the same as that of the receiver (i.e,, preserve local date and local time-of-day, don't preserve date or time-of-day in Universal Time.)"

	| newStart |
	newStart := start << timeZone.
	start == newStart ifTrue: [^self].
	^(self copy)
		setStart: newStart;
		beImmutable! !

!Timeperiod methodsFor: 'converting' stamp: ''!
>> aChronosTimezone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."
	| newStart |
	newStart := start >> aChronosTimezone.
	start == newStart ifTrue: [^self].
	^(self copy)
		setStart: newStart;
		beImmutable! !

!Timeperiod methodsFor: 'queries' stamp: ''!
@ timeOfDay
	"{Timeperiod currentMonth @ (TimeOfDay hour: 12 minute: 0 second: 0)}"

	| newStart |
	newStart := start  @ timeOfDay.
	start == newStart ifTrue: [^self].
	^(self copy)
		setStart: newStart;
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingDays: days
	days = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^(self copy)
		setStart: (self start addingDays: days);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingHours: hours
	hours = 0 ifTrue: [^self isMutable ifTrue: [self asMutableTimeOfDay] ifFalse: [self]].
	^(self copy)
		setStart: (self start addingHours: hours);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes
	minutes = 0 ifTrue: [^self addingHours: hours].
	^(self copy)
		setStart: (self start addingHours: hours minutes: minutes);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes seconds: seconds
	seconds = 0 ifTrue: [^self addingHours: hours minutes: minutes].
	^(self copy)
		setStart: (self start addingHours: hours minutes: minutes seconds: seconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	nanoseconds = 0 ifTrue: [^self addingHours: hours minutes: minutes seconds: seconds].
	^(self copy)
		setStart: (self start addingHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingMinutes: minutes
	minutes = 0 ifTrue: [^self isMutable ifTrue: [self asMutableTimeOfDay] ifFalse: [self]].
	^(self copy)
		setStart: (self start addingMinutes: minutes);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingMonths: months
	months = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^(self copy)
		setStart: (self start addingMonths: months);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingSeconds: seconds
	seconds = 0 ifTrue: [^self isMutable ifTrue: [self asMutableTimeOfDay] ifFalse: [self]].
	^(self copy)
		setStart: (self start addingSeconds: seconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingSeconds: seconds nanoseconds: nanoseconds 
	nanoseconds = 0 ifTrue: [^self addingSeconds: seconds].
	^(self copy)
		setStart: (self start addingSeconds: seconds nanoseconds: nanoseconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingYears: years
	years = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^(self copy)
		setStart: (self start addingYears: years);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months
	months = 0 ifTrue: [^self addingYears: years].
	^(self copy)
		setStart: (self start addingYears: years months: months);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days
	days = 0 ifTrue: [^self addingYears: years months: months].
	^(self copy)
		setStart: (self start addingYears: years months: months days: days);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	^(self copy)
		setStart: (self start addingYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds 
	^(self copy)
		setStart: (self start addingYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds);
		beImmutable! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asCalendarDurationSinceEpoch
	^start asCalendarDurationSinceEpoch! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asCivilDurationSinceEpoch
	^start asCivilDurationSinceEpoch! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asDate
	"Answer the conversion of the receiver into a date-valued CalendricalCoordinate that represents the same date as does the receiver.  If the receiver is already a date-valued CalendricalCoordinate, answer the receiver.  A date-valued CalendricalCoordinate is one that specifies a date without specifying a particular time-of-day nor a particular timezone (i.e., it has nominal time semantics, and its quantum of resolution is 1 calendar day.)"

	^start asDate! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asDateAndTime
	"Answer the conversion of the receiver into a DateAndTime value that represents the same point-in-time as does the receiver.  If the receiver is already a DateAndTime value, answer the receiver.  A DateAndTime value is a CalendricalCoordinate that specifies a point-in-time, with a quantum of resolution no larger than one second, with behavior/semantics that is invariant to UT, and that conforms to the ANSI-Smalltalk <DateAndTime> protocol. See the class comment of Timepoint for further clarification."

	^start asDateAndTime! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asDateAndTimeIn: aChronosTimezone
	"Timepoint now asDateAndTimeIn: 'Pacific/Kiritimati'"
	"TimeOfDay now asDateAndTimeIn: 'Pacific/Kiritimati'"
	"YearMonthDay today asDateAndTimeIn: 'Pacific/Kiritimati'"
	"GregorianEaster canonical asDateAndTimeIn: 'Pacific/Kiritimati'"
	"(Timeperiod hourStartingAt: Timepoint now) asDateAndTimeIn: 'Pacific/Kiritimati'"

	^start asDateAndTimeIn: aChronosTimezone! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asDays
	"Answer the number of days spanned by the receiver."

	"{(Timeperiod 
		startingAt: (YearMonthDay year: 2004 month: 10 day: 30)
		duration: (CalendarDuration days: 4)) asDays}"

	^start daysUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asHours
	"Answer the number of hours spanned by the receiver."

	"The following examples illustrate both the results of sending the #hours message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 timeZone: 'America/Vancouver')
		duration: (ScientificDuration hours: 4)) asHours}"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 timeZone: 'America/Vancouver')
		duration: (ScientificDuration hours: 2)) asHours}"

	^start hoursUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asInvariantToNominalTime
	"Answer a value equivalent to that of the receiver in all respects, except that its semantics/behavior is invariant to nominal time.  If the receiver is already nominal-time invariant, answer the receiver. See the class comment of Timepoint for further clarification."

	| newStart |
	newStart := start asInvariantToNominalTime.
	start == newStart ifTrue: [^self].
	^(self copy)
		setStart: newStart;
		beImmutable! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asInvariantToUT
	"Answer a value equivalent to that of the receiver in all respects, except that it has UT-invariant behavior/semantics.  If the receiver is already invariant-to-UT, answer the receiver. See the class comment of Timepoint for further clarification."

	| newStart |
	newStart := start asInvariantToUT.
	start == newStart ifTrue: [^self].
	^(self copy)
		setStart: newStart;
		beImmutable! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asLocal
	| newStart |
	newStart := start asLocal.
	start == newStart ifTrue: [^self].
	^(self copy)
		setStart: newStart;
		beImmutable! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asMicroseconds
	"Answer the number of microseconds spanned by the receiver."

	"The following examples illustrate both the results of sending the #seconds message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"

	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 hour: 1 minute: 59 second: 55 timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) asMicroseconds}"

	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 59 second: 55  timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) asMicroseconds}"

	^start microsecondsUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asMilliseconds
	"Answer the number of milliseconds spanned by the receiver."

	"The following examples illustrate both the results of sending the #seconds message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"

	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 hour: 1 minute: 59 second: 55 timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) asMilliseconds}"

	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 59 second: 55  timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) asMilliseconds}"

	^start millisecondsUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asMinutes
	"Answer the number of minutes spanned by the receiver."

	"The following examples illustrate both the results of sending the #minutes message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 hour: 1 minute: 50 second: 0 timeZone: 'America/Vancouver')
		duration: (ScientificDuration minutes: 20)) asMinutes}"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 55 second: 0  timeZone: 'America/Vancouver')
		duration: (ScientificDuration minutes: 10)) asMinutes}"

	^start minutesUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asMonths
	"Answer the number of months spanned by the receiver."

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration years: 1)) asMonths}"

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration years: 1 months: -2 days: 15)) asMonths}"

	"{(Timeperiod 
		startingAt: HebrewCalendar clock dateToday
		duration: (CalendarDuration years: 2 months: -2 days: 15)) asMonths}"

	^start monthsUntil: self limit! !

!Timeperiod methodsFor: 'private' stamp: ''!
asMutableDate
	^start asMutableDate! !

!Timeperiod methodsFor: 'private' stamp: ''!
asMutableDateAndTime
	^start asMutableDateAndTime! !

!Timeperiod methodsFor: 'private' stamp: ''!
asMutableDateAndTimeInvariantToUT
	^start asMutableDateAndTimeInvariantToUT! !

!Timeperiod methodsFor: 'private' stamp: ''!
asMutableTimeOfDay
	^start asMutableTimeOfDay! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asNanoseconds
	"Answer the number of nanoseconds spanned by the receiver."

	"The following examples illustrate both the results of sending the #seconds message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"

	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 hour: 1 minute: 59 second: 55 timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) asNanoseconds}"

	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 59 second: 55  timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) asNanoseconds}"

	^start nanosecondsUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asNominalDateAndTime
	"Answer the conversion of the receiver into a nominal-time-invariant DateAndTime value that represents the same local point-in-time as does the receiver.  If the receiver is already a nominal-time-invariant DateAndTime value, answer the receiver.  A nominal-time-invariant DateAndTime value is a CalendricalCoordinate that nominally specifies a point-in-time without reference to any particular timezone, and has a quantum of resolution no larger than one second. A nominal-time-invariant DateAndTime value conforms to the ANSI-Smalltalk <DateAndTime> protocol EXCEPT that its behavior/semantics is invariant to nominal time, as opposed to being UT invariant. See the class comment of Timepoint for further clarification."

	^start asNominalDateAndTime! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asQuarters
	"Answer the number of quarters spanned by the receiver."

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration years: 1)) asQuarters}"

	^start quartersUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asSeconds
	"Answer the number of seconds spanned by the receiver."

	"The following examples illustrate both the results of sending the #seconds message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"

	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 hour: 1 minute: 59 second: 55 timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) asSeconds}"

	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 59 second: 55  timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) asSeconds}"

	^start secondsUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asTimeperiodStartingAt: initialMoment
	"Answer a Timeperiod whose starting value is <initialMoment> (a CalendricalCoordinate) and whose duration is the receiver's temporal extent."

	^(self copy)
		setStart: initialMoment;
		beImmutable! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asUT
	
	^self in: ChronosTimezone universal! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asUTC
	"Specified and required by the ANSI-Smalltalk Standard."

	^self asUT! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asWeeks
	"Answer the number of weeks spanned by the receiver."

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration months: 1)) asWeeks}"

	^start weeksUntil: self limit! !

!Timeperiod methodsFor: 'converting' stamp: ''!
asYears
	"Answer the number of years spanned by the receiver."

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration years: 4)) asYears}"

	^start yearsUntil: self limit! !

!Timeperiod methodsFor: 'queries' stamp: ''!
atStartOfDay
	| atStartOfDay |
	atStartOfDay := start atStartOfDay.
	start == atStartOfDay ifTrue: [^self].
	^(self copy)
		setStart: atStartOfDay;
		beImmutable! !

!Timeperiod methodsFor: 'queries' stamp: ''!
atTimeOfDay: aTimeOfDay
	"Timeperiod today atTimeOfDay: TimeOfDay now"

	| newStart |
	newStart := start atTimeOfDay: aTimeOfDay.
	start == newStart ifTrue: [^self].
	^(self copy)
		setStart: newStart;
		beImmutable! !

!Timeperiod methodsFor: 'queries' stamp: ''!
atTimeOfDay: aTimeOfDay in: timeZone
	"Timeperiod today atTimeOfDay: TimeOfDay now in: 'Pacific/Honolulu'"

	| newStart |
	newStart := start atTimeOfDay: aTimeOfDay in: timeZone.
	start == newStart ifTrue: [^self].
	^(self copy)
		setStart: newStart;
		beImmutable! !

!Timeperiod methodsFor: 'private' stamp: ''!
basicDaysSinceEpoch
	^start basicDaysSinceEpoch! !

!Timeperiod methodsFor: 'private-time zone operations' stamp: ''!
basicTimeZone
	^start basicTimeZone! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
calendar
	"Answer the Calendar that implements the calendrical system associated with the receiver."

	^start calendar! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
calendarDay
	^start calendarDay! !

!Timeperiod methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	start == nil ifTrue: [start := self defaultStart].	
	duration == nil ifTrue: [duration := self defaultDuration].! !

!Timeperiod methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToTimeperiod: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == aCalendrical and: [ex message selector == #compareToTimeperiod:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!Timeperiod methodsFor: 'private-comparing' stamp: ''!
compareToCalendricalCoordinate: aCalendricalCoordinate

	^self compareToTemporalCoordinate: aCalendricalCoordinate! !

!Timeperiod methodsFor: 'private-comparing' stamp: ''!
compareToDate: aDate

	^self compareToTemporalCoordinate: aDate! !

!Timeperiod methodsFor: 'private-comparing' stamp: ''!
compareToDateAndTime: aDateAndTime

	^self compareToTemporalCoordinate: aDateAndTime! !

!Timeperiod methodsFor: 'private-comparing' stamp: ''!
compareToTemporalCoordinate: aTemporalCoordinate
	|  nextStart |
	nextStart := self limit.
	^nextStart >= start 
		ifTrue: 
			[aTemporalCoordinate < start 
				ifTrue: [-1]
				ifFalse: [aTemporalCoordinate >= nextStart ifTrue: [1] ifFalse: [0]]]
		ifFalse: 
			[aTemporalCoordinate > start 
				ifTrue: [1]
				ifFalse: [aTemporalCoordinate <= nextStart ifTrue: [-1] ifFalse: [0]]]! !

!Timeperiod methodsFor: 'private-comparing' stamp: ''!
compareToTimeperiod: aTimeperiod 
	| diff thisStart thisNextStart thatStart thatNextStart |
	thisStart := self start.
	thisNextStart := self limit.
	thatStart := aTimeperiod start.
	thatNextStart := aTimeperiod limit.
	^thisNextStart >= thisStart 
		ifTrue: 
			[thatNextStart >= thatStart 
				ifTrue: 
					[diff := thatStart compareTo: thisStart.
					diff = 0 ifFalse: [^diff].
					thatNextStart compareTo: thisNextStart]
				ifFalse: 
					[diff := thatNextStart + thatNextStart resolutionQuantum compareTo: thisStart.
					diff = 0 ifFalse: [^diff].
					thatStart compareTo: thisNextStart - thisNextStart resolutionQuantum]]
		ifFalse: 
			[thatNextStart >= thatStart 
				ifTrue: 
					[diff := thatStart compareTo: thisNextStart + thisNextStart resolutionQuantum.
					diff = 0 ifFalse: [^diff].
					thatNextStart - thatNextStart resolutionQuantum compareTo: thisStart]
				ifFalse: 
					[diff := thatNextStart compareTo: thisNextStart.
					diff = 0 ifFalse: [^diff].
					thatStart compareTo: thisStart]]! !

!Timeperiod methodsFor: 'converting' stamp: ''!
dateSpec
	^start dateSpec! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
daysSince: aCalendricalCoordinate
	^start daysSince: aCalendricalCoordinate! !

!Timeperiod methodsFor: 'private-arithmetic' stamp: ''!
daysSinceDate: aDate
	^start daysSinceDate: aDate! !

!Timeperiod methodsFor: 'private-arithmetic' stamp: ''!
daysSinceDateAndTime: aDateAndTime
	^start daysSinceDateAndTime: aDateAndTime! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
daysSinceEpoch
	^start daysSinceEpoch! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
daysUntil: aCalendricalCoordinate
	^start daysUntil: aCalendricalCoordinate! !

!Timeperiod methodsFor: 'private-arithmetic' stamp: ''!
daysUntilDate: aDate
	^start daysUntilDate: aDate! !

!Timeperiod methodsFor: 'private-arithmetic' stamp: ''!
daysUntilDateAndTime: aDateAndTime
	^start daysUntilDateAndTime: aDateAndTime! !

!Timeperiod methodsFor: 'private' stamp: ''!
defaultDuration
	^ZeroDuration! !

!Timeperiod methodsFor: 'printing' stamp: ''!
defaultPrintPolicy
	^ChronosPrintPolicy iso8601! !

!Timeperiod methodsFor: 'private' stamp: ''!
defaultStart
	^self class dateAndTimeFactory nominalNow! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
duration
	"Answer a Duration whose value represents the receiver's temporal extent."

	^duration! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
durationSince: aCalendricalCoordinate
	^start durationSince: aCalendricalCoordinate! !

!Timeperiod methodsFor: 'private-arithmetic' stamp: ''!
durationSinceDateAndTime: aDateAndTime
	^start durationSinceDateAndTime: aDateAndTime! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
durationUntil: aCalendricalCoordinate
	^start durationUntil: aCalendricalCoordinate! !

!Timeperiod methodsFor: 'private-arithmetic' stamp: ''!
durationUntilDateAndTime: aDateAndTime
	^start durationUntilDateAndTime: aDateAndTime! !

!Timeperiod methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self start literalArrayEncoding;
		nextPut: self duration literalArrayEncoding! !

!Timeperiod methodsFor: 'converting' stamp: ''!
inCanonicalCalendar

	| canonical |
	canonical := start inCanonicalCalendar.
	start == canonical ifTrue: [^self].
	^(self copy)
		setStart: canonical;
		beImmutable! !

!Timeperiod methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self 
		setStart: (literalArray at: 2) decodeAsLiteralArray
		duration: (literalArray at: 3) decodeAsLiteralArray! !

!Timeperiod methodsFor: 'initialize-release' stamp: ''!
invalidateCalendar
	start invalidateCalendar! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isAtStartOfDay
	^start isAtStartOfDay! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isAtStartOfHour
	^start isAtStartOfHour! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isAtStartOfMinute
	^start isAtStartOfMinute! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isBoundToTimeZone
	^start isBoundToTimeZone! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^self duration isDayDuration! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isHourDuration
	"Answer whether the receiver's temporal extent is one hour."

	^self duration isHourDuration! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isInvariantToNominalTime
	"Answer true if the receiver always represents an invariant nominal local time ('3 pm local time') in whatever Timezone to which it may be bound. Otherwise, answer false."

	^start isInvariantToNominalTime! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isInvariantToUT
	"Answer true if the receiver always represents an invariant nominal UT time ('3 pm UT') in whatever Timezone to which it may be bound. Otherwise, answer false."

	^start isInvariantToUT! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isMinuteDuration
	"Answer whether the receiver's temporal extent is one minute."

	^self duration isMinuteDuration! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isMonthDuration
	"Answer whether the receiver's temporal extent is one month."

	^self duration isMonthDuration! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isNanosecondDuration
	"Answer whether the receiver's temporal extent is one nanosecond."

	^self duration isNanosecondDuration! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isSecondDuration
	"Answer whether the receiver's temporal extent is one second."

	^self duration isSecondDuration! !

!Timeperiod methodsFor: 'testing' stamp: ''!
isYearDuration
	"Answer whether the receiver's temporal extent is one year."

	^self duration isYearDuration! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
julianDay
	"Answers the Julian Day Number of the Julian Day in which the the point-in-time represented by the receiver occurs (local time.) However, if the receiver's interval spans across the transition from one Julian Day to the next, then the Julian Day Number of the first Julian Day that starts at Noon within the interval of time represented by the receiver is answered (also local time.)"

	^start julianDay! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond
	^start nanosecondsSinceSecond! !

!Timeperiod methodsFor: 'INTER-period-stream protocol' stamp: ''!
next
	"Answer a Timeperiod whose starting point-in-time is the receiver's limit value (end-point,) and whose temporal extent (duration) is the same as the receiver's.  See the class comment for the definition of these terms."

	"{Timeperiod currentHour next}"
	"{Timeperiod today next}"
	"{Timeperiod currentWeek next}"
	"{Timeperiod currentMonth next}"
	"{Timeperiod currentYear next}"

	^self class from: self limit duration: self duration! !

!Timeperiod methodsFor: 'INTER-period-stream protocol' stamp: ''!
prev
	"Answer a Timeperiod whose starting point-in-time is computed by subtracting the receiver's temporal extent (duration) from its starting point-in-time, and whose temporal extent (duration) is the same as the receiver's.  See the class comment for the definition of these terms."

	"{Timeperiod currentHour prev}"
	"{Timeperiod today prev}"
	"{Timeperiod currentWeek prev}"
	"{Timeperiod currentMonth prev}"
	"{Timeperiod currentYear prev}"

	^self class from: self start - self duration duration: self duration! !

!Timeperiod methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."
	"If <aChronosPrintPolicy> == ChronosPrintPolicy default (or ChronosPrintPolicy ansiStandard or ChronosPrintPolicy iso8601,) then the receiver's printString will be formatted as required by the ISO 8601 Standard."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printTimeperiod: self on: stream! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^NanosecondDuration! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	^start secondsSinceStartOfDay! !

!Timeperiod methodsFor: 'initialize-release' stamp: ''!
setDuration: temporalExtent 
	"Initialize the receiver so that it represents a right-closed, left-open temporal interval whose starting point-in-time is its current starting point-in-time and whose open temporal extent is <temporalExtent> (a Durational instance.) Fail if the receiver is not mutable."

	self assertMutability.
	duration := temporalExtent! !

!Timeperiod methodsFor: 'initialize-release' stamp: ''!
setLimit: limitMoment
	"Initialize the receiver so that it represents a right-closed, left-open temporal interval whose starting point-in-time is its current starting point-in-time and whose right end-point (its limit value) is <limitMoment>. Set the temporal extent of the receiver (its 'duration') to be a temporal extent  computed by subtracting the receiver's initial moment (it's starting point-in-time) from the specified <limitMoment>. Fail if the receiver is not mutable."
 
	self assertMutability.
	duration := limitMoment durationSince: self start! !

!Timeperiod methodsFor: 'initialize-release' stamp: ''!
setStart: aStart
	"Initialize the receiver so that it represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is its current temporal extent (its 'duration.') Fail if the receiver is not mutable."

	self assertMutability.
	start := aStart.! !

!Timeperiod methodsFor: 'initialize-release' stamp: ''!
setStart: initialMoment duration: temporalExtent 
	"Initialize the receiver so that it represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose open temporal extent is <temporalExtent> (a Durational instance.) Fail if the receiver is not mutable."

	self assertMutability.
	start := initialMoment.
	duration := temporalExtent! !

!Timeperiod methodsFor: 'initialize-release' stamp: ''!
setStart: initialMoment limit: limitMoment
	"Initialize the receiver so that it represents a right-closed, left-open temporal interval whose starting point-in-time is <initialMoment> (a TemporalCoordinate, such as a YearMonthDay, TimeOfDay or Timepoint instance) and whose right end-point (its limit value) is <limitMoment>. Set the temporal extent of the receiver (its `duration`) to be a temporal extent computed by subtracting the <initialMoment> from the <limitMoment>. Fail if the receiver is not mutable."

	self assertMutability.
	start := initialMoment.
	duration :=  limitMoment durationSince: initialMoment! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
start
	"Answer the point-in-time value that is the initial moment of the receiver's temporal interval (which is included in the interval.)"

	^start! !

!Timeperiod methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aDuration
	^start subtractedFromCivilDuration: aDuration! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingDays: days
	days = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^(self copy)
		setStart: (self start subtractingDays: days);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours
	hours = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDateAndTime] ifFalse: [self]].
	^(self copy)
		setStart: (self start subtractingHours: hours);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes
	minutes = 0 ifTrue: [^self subtractingHours: hours].
	^(self copy)
		setStart: (self start subtractingHours: hours minutes: minutes);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes seconds: seconds
	seconds = 0 ifTrue: [^self subtractingHours: hours minutes: minutes].
	^(self copy)
		setStart: (self start subtractingHours: hours minutes: minutes seconds: seconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	nanoseconds = 0 ifTrue: [^self subtractingHours: hours minutes: minutes seconds: seconds].
	^(self copy)
		setStart: (self start subtractingHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingMinutes: minutes
	minutes = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDateAndTime] ifFalse: [self]].
	^(self copy)
		setStart: (self start subtractingMinutes: minutes);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingMonths: months
	months = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^(self copy)
		setStart: (self start subtractingMonths: months);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: seconds
	seconds = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDateAndTime] ifFalse: [self]].
	^(self copy)
		setStart: (self start subtractingSeconds: seconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: seconds nanoseconds: nanoseconds
	nanoseconds = 0 ifTrue: [^self subtractingSeconds: seconds].
	^(self copy)
		setStart: (self start subtractingSeconds: seconds nanoseconds: nanoseconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years
	years = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^(self copy)
		setStart: (self start subtractingYears: years);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months
	months = 0 ifTrue: [^self subtractingYears: years].
	^(self copy)
		setStart: (self start subtractingYears: years months: months);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days
	days = 0 ifTrue: [^self subtractingYears: years months: months].
	^(self copy)
		setStart: (self start subtractingYears: years months: months days: days);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	days = 0 ifTrue: [^self subtractingYears: years months: months].
	^(self copy)
		setStart: (self start subtractingYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds);
		beImmutable! !

!Timeperiod methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds
	^(self copy)
		setStart: (self start subtractingYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds);
		beImmutable! !

!Timeperiod methodsFor: 'converting' stamp: ''!
through: finalMoment 
	"Answer a Timeperiod whose starting point-in-time is the receiver and whose temporal extent is the duration computed by subtracting the receiver from <finalMoment> (a TemporalCoordinate) and then adding the resolution quantum of <finalMoment>. The result is a Timeperiod representing the closed interval [self, finalMoment]."

	^(self copy)
		setLimit: finalMoment + finalMoment resolutionQuantum;
		beImmutable! !

!Timeperiod methodsFor: 'accessing' stamp: ''!
timeZone
	"Answer the bound Timezone that has the correct offsetFromUT for the date and time represented by the receiver."
 	
	^start timeZone! !

!Timeperiod methodsFor: 'converting' stamp: ''!
to: limitValue
	"Answer a Timeperiod whose starting point-in-time is the same as the receiver's and whose temporal extent is the duration computed by subtracting the receiver's starting point-in-time from <limitValue> (a CalendricalCoordinate.)"

	^(self copy)
		setLimit: limitValue;
		beImmutable! !

!Timeperiod methodsFor: 'deprecated' stamp: ''!
upTo: limitValue
	"Deprecated. See #to:"

	^self to: limitValue! !

!Timeperiod methodsFor: 'accessing-UT' stamp: ''!
utDaysSinceEpoch
	^start utDaysSinceEpoch! !

!Timeperiod methodsFor: 'accessing-UT' stamp: ''!
utJulianDay
	"Answers the Julian Day Number of the Julian Day in which the the point-in-time represented by the receiver occurs (Universal Time.) However, if the receiver's interval spans across the transition from one Julian Day to the next, then the Julian Day Number of the first Julian Day that starts at Noon within the interval of time represented by the receiver is answered (also Universal Time.)"

	^start utJulianDay! !

!Timeperiod methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceEpoch
	^start utNanosecondsSinceEpoch! !

!Timeperiod methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceSecond
	^start utNanosecondsSinceSecond! !

!Timeperiod methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceStartOfDay
	^start utNanosecondsSinceStartOfDay! !

!Timeperiod methodsFor: 'accessing-UT' stamp: ''!
utSecondsSinceStartOfDay
	^start utSecondsSinceStartOfDay! !

!Timeperiod methodsFor: 'converting' stamp: ''!
withDuration: aDuration
	"Answer a Timeperiod whose starting point-in-time is the same as the receiver's and whose temporal extent is <aDuration> (a Durational instance.)"

	^(self copy)
		setDuration: aDuration;
		beImmutable! !

!Timeperiod methodsFor: 'accessing-multivalued' stamp: ''!
yearAndCalendarDayDo: block2 
	^start yearAndCalendarDayDo: block2! !

!Timeperiod methodsFor: 'accessing-multivalued' stamp: ''!
yearMonthDayDo: block3 
	"Evaluate <block3> with the calendar year number, month ordinal and day-of-month ordinal of the day represented by the receiver as the first, second and third arguments (respectively.) If the receiver is not bound to a particular year, use nil as the value of the year."

	^start yearMonthDayDo: block3! !

!TemporalCoordinate class methodsFor: 'accessing' stamp: ''!
clockPrecision
	"Answer a Duration whose value indicates the precision of the current ChronosSystemClock.  The precision of a clock is the average time interval between updates to the clock's tick count.  The 'tick size' of a clock is the minimum time interval that notationally can be represented by the clock's time counter (the clock's 'tick size' is also called the 'clock resolution.')"

	"This method is required by the ANSI Smalltalk standard (which omits any mention of the clock's resolution, which is at least as important an issue as the clock's precision, especially because a) it establishes a hard limit to precision, and b) on any given platform, it is much less likely to change over time as the hardware and system software of that platform evolves.)"

	"{TemporalCoordinate clockPrecision}"

	^AnsiStandardCalendarClock precision! !

!TemporalCoordinate class methodsFor: 'class initialization' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
defineRangeConstraints
	"TemporalCoordinate defineRangeConstraints."

	NanosecondsSinceSecondRangeConstraint := 
		RangeConstraint 
			semanticKey: #nanosecondsSinceSecond
			minValidValue: 0
			maxValidValue: (NanosecondsPerSecond) - 1.
	SecondsSinceStartOfDayRangeConstraint := 
		RangeConstraint 
			semanticKey: #secondsSinceStartOfDay
			minValidValue: 0
			maxValidValue: SecondsPerDay.
	SecondsSinceMinuteRangeConstraint := 
		RangeConstraint 
			semanticKey: #second
			minValidValue: 0
			maxValidValue: (SecondsPerMinute). "Leap seconds"
	MinutesSinceHourRangeConstraint := 
		RangeConstraint 
			semanticKey: #minute
			minValidValue: 0
			maxValidValue: (MinutesPerHour) - 1.
	HoursSinceStartOfDayRangeConstraint :=
		RangeConstraint 
			semanticKey: #hour
			minValidValue: 0
			maxValidValue: (HoursPerDay) - 1.! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
<< aChronosTimezone 
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but convert the date and time-of-day as though the receiver represented a date and time in the current default time zone (i.e,. preserve date and time-of-day in Universal Time as though the receiver represented a date and time in the current default time zone.)
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is the same as that of the receiver (i.e,, preserve local date and local time-of-day, don't preserve date or time-of-day in Universal Time.)"

	^self subclassResponsibility! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
>> aChronosTimezone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."

	^self subclassResponsibility! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
\ calendar
	"Answer the result of converting the receiver into a calendrical coordinate whose Calendar is <otherCalendar>, but which represents the same absolute temporal value (e.g., the same day in history)."

	"YearMonthDay today \ #Hebrew"

	^self as: calendar! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingDays: dayDelta
	"Answer a new CalendricalCoordinate which is the given number of civil days after the date represented by the receiver, preserving the same civil time-of-day."

	dayDelta = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^(self asMutableDate) 
		basicAddDays: dayDelta;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingHours: hours
	hours = 0 ifTrue: [^self isMutable ifTrue: [self asMutableTimeOfDay] ifFalse: [self]].
	^(self asMutableTimeOfDay)
		addHours: hours;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes
	minutes = 0 ifTrue: [^self addingHours: hours].
	^(self asMutableTimeOfDay)
		addHours: hours minutes: minutes;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes seconds: seconds
	seconds = 0 ifTrue: [^self addingHours: hours minutes: minutes].
	^(self asMutableTimeOfDay)
		addHours: hours minutes: minutes seconds: seconds;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	nanoseconds = 0 ifTrue: [^self addingHours: hours minutes: minutes seconds: seconds].
	^(self asMutableTimeOfDay)
		addHours: hours
		minutes: minutes
		seconds: seconds
		nanoseconds: nanoseconds;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingMinutes: minutes
	minutes = 0 ifTrue: [^self isMutable ifTrue: [self asMutableTimeOfDay] ifFalse: [self]].
	^(self asMutableTimeOfDay)
		addMinutes: minutes;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingMonths: months
	"Answer a CalendricalCoordinate which is the given number of civil months after the date represented by the receiver, preserving the same civil time-of-day.   The dayOfMonth in the new CalendricalCoordinate will be the same as in the receiver, unless it would be invalid.  For example, if the orignal date is March 31, the dayOfMonth in the answered CalendricalCoordinate will also be 31, unless the month of the answered DateAndTime has less than 31 days.  In such a case, the answered CalendricalCoordinate's dayOfMonth will be the last day of its month.

	If <months> is negative, then the semantics are not quite as described above, but will conform to the specification for #subtracingMonths:, with <months> negated.

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal."

	months = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^self asMutableDate 
		addMonths: months;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingSeconds: seconds
	"Answer a CalendricalCoordinate which is the given number of scientific seconds after the timepoint represented by the receiver. The scientific semantics of a timepoint S seconds from another will be respected (UTC)."

	seconds = 0 ifTrue: [^self isMutable ifTrue: [self asMutableTimeOfDay] ifFalse: [self]].
	^(self asMutableTimeOfDay)
		addSeconds: seconds;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingSeconds: seconds nanoseconds: nanoseconds 
	"Answer a CalendricalCoordinate which is the given number of scientific seconds and nanoseconds after the timepoint represented by the receiver. The scientific semantics of a timepoint S seconds and N nanoseconds from another will be respected (UTC)."

	nanoseconds = 0 ifTrue: [^self addingSeconds: seconds].
	^(self asMutableTimeOfDay)
		addSeconds: seconds nanoseconds: nanoseconds;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingYears: years
	"Answer a new CalendricalCoordinate whose date is the given number of civil years after the date represented by the receiver, and which has the same civil time-of-day.  The civil intra-year date of the answered CalendricalCoordinate will be the same as that of the receiver, unless it would be invalid.  For example, if the orignal date is March 1 in a Gregorian/Julian leap year, the date in the new year will remain March 1 after adding the specified years.  However, if the original date is February 29 and the new year is not a leap year, then the new date will be Feb 28.  

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal.  If intercalary months may occur at times other than the end of the year, the Calendar system's cultural tradition will be respected regarding the semantics of 'same civil date N years later (or earlier.)'  The implementation assumes that the only issue in that respect is whether or not 'same month' is defined by the monthOrdinal or by the monthKey (by definition of a Chronos monthKey, months with the same monthKey are semantically the same month, regardless of possibly having different monthOrdinals in different years--which does happen in some Calendars!!.)"

	years = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^self asMutableDate 
		addYears: years;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months
	"Answer a new CalendricalCoordinate which is the given number of civil years and months after the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years and M civil months away from another date' will be respected.

	See the specifications/comments for #addingYears: abd #addingMonths:for more detailed/precise semantics."

	months = 0 ifTrue: [^self addingYears: years].
	^self asMutableDate
		addYears: years months: months days: 0;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days
	"Answer a new CalendricalCoordinate which is the given number of civil years, months and days after the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years, M civil months and D civil days away from another date' will be respected.

	See the specifications/comments for #addingYears:, #addingMonths: and #addingDays: for more detailed/precise semantics."

	days = 0 ifTrue: [^self addingYears: years months: months].
	^self asMutableDate
		addYears: years months: months days: days;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	^(self asMutableDateAndTime)
		addYears: years
		months: months 
		days: days
		hours: hours
		minutes: minutes
		seconds: seconds
		nanoseconds: nanoseconds;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
addingYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds 
	"Answer a new CalendricalCoordinate which is the given number of civil years, months, days, seconds and nanoseconds after the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years, M civil months and D civil days away from another date' will be respected. The scientific semantics of a timepoint S seconds and N nanoseconds from another will be respected (UTC).

	See the specifications/comments for #addingYears:, #addingMonths:, #addingDays: and #addingSeconds:nanoseconds: for more detailed/precise semantics."

	^(seconds = 0 and: [nanoseconds = 0]) 
		ifTrue: 
			[(self asMutableDate)
				addYears: years
					months: months
					days: days;
				beImmutable]
		ifFalse: 
			[(self asMutableDateAndTime)
				addYears: years
					months: months
					days: days;
				addSeconds: seconds nanoseconds: nanoseconds;
				beImmutable]! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
as: otherCalendar 
	"Answer the result of converting the receiver into a calendrical coordinate whose Calendar is <otherCalendar>, but which represents the same absolute temporal value (e.g., the same day in history)."

	| newCalendar |
	newCalendar := Calendar referencedBy: otherCalendar.
	self calendar == newCalendar ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^(self asMutableDate)
		convertToCalendar: newCalendar;
		beImmutable! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asAll: anCollectionOfCalendars
	"NOTE: If <anCollectionOfCalendars> is a Set, the result will be a Set with only one member, because Calendrical instances compare as equal to all others that represent the same moment in time."

	^anCollectionOfCalendars asArray collect: [:aCalendar | self as: aCalendar]! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asBoundToStaticTimeZone
	"YearMonthDay today asBoundToStaticTimeZone"

	^self asDateAndTime asBoundToStaticTimeZone! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asBoundToTimeZone
	^self asDateAndTime! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asCalendricalCoordinate
	"Answer the conversion of the receiver into its equivalent value implemented as a CalendricalCoordinate.  If the receiver is already a CalendricalCoordinate, answer the receiver."

	^self subclassResponsibility! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asDate
	"Answer the conversion of the receiver into a date-valued CalendricalCoordinate that represents the same date as does the receiver.  If the receiver is already a date-valued CalendricalCoordinate, answer the receiver.  A date-valued CalendricalCoordinate is one that specifies a date without specifying a particular time-of-day nor a particular timezone (i.e., it has nominal time semantics, and its quantum of resolution is 1 calendar day.)"

	^self asMutableDate beImmutable! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asDateAndTime
	"Answer the conversion of the receiver into a DateAndTime value that represents the same point-in-time as does the receiver.  If the receiver is already a DateAndTime value, answer the receiver.  A DateAndTime value is a CalendricalCoordinate that specifies a point-in-time, with a quantum of resolution no larger than one second, with behavior/semantics that is invariant to UT, and that conforms to the ANSI-Smalltalk <DateAndTime> protocol. See the class comment of Timepoint for further clarification."

	"Timepoint now asDateAndTime"
	"TimeOfDay now asDateAndTime"
	"YearMonthDay today asDateAndTime"
	"GregorianEaster canonical asDateAndTime"
	"(Timeperiod hourStartingAt: Timepoint now) asDateAndTime"

	^self asMutableDateAndTimeInvariantToUT beImmutable! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asDateAndTimeIn: aChronosTimezone
	"Timepoint now asDateAndTimeIn: 'Pacific/Kiritimati'"
	"TimeOfDay now asDateAndTimeIn: 'Pacific/Kiritimati'"
	"YearMonthDay today asDateAndTimeIn: 'Pacific/Kiritimati'"
	"GregorianEaster canonical asDateAndTimeIn: 'Pacific/Kiritimati'"
	"(Timeperiod hourStartingAt: Timepoint now) asDateAndTimeIn: 'Pacific/Kiritimati'"

	| timeZone |
	timeZone := ChronosTimezone referencedBy: aChronosTimezone.
	^(self asMutableDateAndTime)
		basicSetTimeZone: timeZone;
		canonicalizeFromLocalTime;
		beImmutable! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asDurationSinceStartOfDay
	^self class durationFactory
		seconds: self secondsSinceStartOfDay
		nanoseconds: self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asGregorian
	^self as: Gregorian! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asInvariantToNominalTime
	"Answer a value equivalent to that of the receiver in all respects, except that its semantics/behavior is invariant to nominal time.  If the receiver is already nominal-time invariant, answer the receiver. See the class comment of Timepoint for further clarification."

	^self! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asInvariantToUT
	"Answer a value equivalent to that of the receiver in all respects, except that it has UT-invariant behavior/semantics.  If the receiver is already invariant-to-UT, answer the receiver. See the class comment of Timepoint for further clarification."

	^self asDateAndTime! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asJulian
	^self as: Julian! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asLocal
	"Specified and required by the ANSI-Smalltalk Standard."

	^self >> ChronosTimezone default! !

!TemporalCoordinate methodsFor: 'private' stamp: ''!
asMutableDate
	^self subclassResponsibility! !

!TemporalCoordinate methodsFor: 'private' stamp: ''!
asMutableDateAndTime
	^self subclassResponsibility! !

!TemporalCoordinate methodsFor: 'private' stamp: ''!
asMutableDateAndTimeInvariantToUT
	^self subclassResponsibility! !

!TemporalCoordinate methodsFor: 'private' stamp: ''!
asMutableTimeOfDay
	^self copy! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asNominalDateAndTime
	"Answer the conversion of the receiver into a nominal-time-invariant DateAndTime value that represents the same local point-in-time as does the receiver.  If the receiver is already a nominal-time-invariant DateAndTime value, answer the receiver.  A nominal-time-invariant DateAndTime value is a CalendricalCoordinate that nominally specifies a point-in-time without reference to any particular timezone, and has a quantum of resolution no larger than one second. A nominal-time-invariant DateAndTime value conforms to the ANSI-Smalltalk <DateAndTime> protocol EXCEPT that its behavior/semantics is invariant to nominal time, as opposed to being UT invariant. See the class comment of Timepoint for further clarification."

	^self asMutableDateAndTime beImmutable! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asTemporalCoordinate
	"Answer the conversion of the receiver into its equivalent value implemented as a TemporalCoordinate.  If the receiver is already a TemporalCoordinate, answer the receiver."

	^self! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asTimeperiod
	"Answer a Timeperiod whose starting point-in-time is the receiver, and whose temporal extent is the receiver's duration."

	^self withDuration: self duration! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asUT
	
	^self in: ChronosTimezone universal! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
asUTC
	"Specified and required by the ANSI-Smalltalk Standard."

	^self asUT! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
atStartOfDay
	^self subclassResponsibility! !

!TemporalCoordinate methodsFor: 'private' stamp: ''!
basicNanosecondsSinceSecond
	^0! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondSince: aTemporal
	^self isInvariantToUT
		ifTrue: [aTemporal basicNanosecondsSinceSecondUntilUT: self]
		ifFalse: [aTemporal basicNanosecondsSinceSecondUntilNominal: self]! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondSinceNominal: aTemporal
	^self nanosecondsSinceSecond - aTemporal nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondSinceUT: aTemporal
	^self nanosecondsSinceSecond - aTemporal nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondUntil: aTemporal 
	^self isInvariantToUT
		ifTrue: [aTemporal basicNanosecondsSinceSecondSinceUT: self]
		ifFalse: [aTemporal basicNanosecondsSinceSecondSinceNominal: self]! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondUntilNominal: aTemporal 
	^aTemporal nanosecondsSinceSecond - self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondUntilUT: aTemporal 
	^aTemporal nanosecondsSinceSecond - self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'private' stamp: ''!
basicNanosecondsSinceStartOfDay
	^self basicSecondsSinceStartOfDay * NanosecondsPerSecond + self basicNanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSince: aTemporal
	^aTemporal basicSecondsSinceStartOfDayUntil: self! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochSinceNominal: aDateAndTimeInvariantToNominalTime
	^self secondsSinceStartOfDay - aDateAndTimeInvariantToNominalTime secondsSinceStartOfDay! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochSinceUT: aDateAndTimeInvariantToUT
	^self secondsSinceStartOfDay - aDateAndTimeInvariantToUT secondsSinceStartOfDay! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochUntilNominal: aDateAndTimeInvariantToNominalTime
	^aDateAndTimeInvariantToNominalTime secondsSinceStartOfDay - self secondsSinceStartOfDay! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochUntilUT: aDateAndTimeInvariantToUT
	^aDateAndTimeInvariantToUT secondsSinceStartOfDay - self secondsSinceStartOfDay! !

!TemporalCoordinate methodsFor: 'private' stamp: ''!
basicSecondsSinceStartOfDay
	^0! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceStartOfDaySince: aTimeOfDay
	^self secondsSinceStartOfDay - aTimeOfDay secondsSinceStartOfDay! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceStartOfDayUntil: aTimeOfDay
	^aTimeOfDay secondsSinceStartOfDay - self secondsSinceStartOfDay! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsUntil: aTemporal
	^aTemporal basicSecondsSinceStartOfDaySince: self! !

!TemporalCoordinate methodsFor: 'private-time zone operations' stamp: ''!
basicTimeZone
	^ChronosTimezone nominal! !

!TemporalCoordinate methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[^aCalendrical compareToTemporalCoordinate: self] 
			on: MessageNotUnderstood 
			do: [:ex | 
				((ex receiver == aCalendrical) and: [#compareToTemporalCoordinate: == ex message selector])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
comparisonClassIdentifier	
	"Answer a value that identifies the group of comparable values to which the receiver belongs.  It must be valid to use #== to compare two identifiers for equality."

	^#TimeOfDay! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
daysSince: aTemporalCoordinate
	^0! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
daysUntil: aTemporalCoordinate
	^0! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
durationSince: aTemporalCoordinate
	^aTemporalCoordinate durationUntilTimeOfDay: self! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationSinceDate: aDate
	^self civilDurationSince: aDate! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationSinceDateAndTime: aDateAndTime
	^self scientificDurationSince: aDateAndTime! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationSinceTimeOfDay: aTimeOfDay
	^self scientificDurationSince: aTimeOfDay! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
durationUntil: aTemporalCoordinate
	^aTemporalCoordinate durationSinceTimeOfDay: self! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationUntilDate: aDate
	^self civilDurationUntil: aDate! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationUntilDateAndTime: aDateAndTime
	^self scientificDurationUntil: aDateAndTime! !

!TemporalCoordinate methodsFor: 'private-arithmetic' stamp: ''!
durationUntilTimeOfDay: aTimeOfDay
	^self scientificDurationUntil: aTimeOfDay! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
fractionalSecondsSinceMidnight
	^ScaledDecimal 
		numerator: self nanosecondsSinceMidnight
		denominator: NanosecondsPerSecond 
		scale: 9! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
fractionalSecondsSinceStartOfDay
	^ScaledDecimal 
		numerator: self nanosecondsSinceStartOfDay 
		denominator: NanosecondsPerSecond 
		scale: 9! !

!TemporalCoordinate methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:24'!
fractionalTimeOfDay
	^ScaledDecimal
		numerator: self nanosecondsSinceStartOfDay
		denominator: (NanosecondsPerDay)
		scale: 9! !

!TemporalCoordinate methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:24'!
fractionalTimeOfDaySinceMidnight
	^ScaledDecimal
		numerator: self nanosecondsSinceMidnight
		denominator: (NanosecondsPerDay)
		scale: 9! !

!TemporalCoordinate methodsFor: 'comparing' stamp: ''!
hash
	^(self secondsSinceStartOfDay + self nanosecondsSinceSecond) hash! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
hour
	"Specified and required by the ANSI-Smalltalk Standard."

	^self secondsSinceStartOfTimeOfDayClock // SecondsPerHour! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
hour12
	"Specified and required by the ANSI-Smalltalk Standard."

	| hour |
	hour := self hoursSinceMidnight \\ 12.
	^hour = 0
		ifTrue: [12]
		ifFalse: [hour]! !

!TemporalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
hour12MinuteSecondDo: block3 
	^self hourMinuteSecondDo: block3 hour24Format: false! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
hour24
	"Specified and required by the ANSI-Smalltalk Standard."

	^self hoursSinceMidnight! !

!TemporalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
hour24MinuteSecondDo: block3 
	^self hourMinuteSecondDo: block3 hour24Format: true! !

!TemporalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
hourMinuteSecondDo: block3 
	^self hourMinuteSecondDo: block3 hour24Format: true! !

!TemporalCoordinate methodsFor: 'accessing-multivalued' stamp: ''!
hourMinuteSecondDo: block3 hour24Format: hour24
	^ChronosFunction 
		fromSeconds: 
			(hour24 
				ifTrue: [self secondsSinceStartOfTimeOfDayClock]
				ifFalse: [self secondsSinceMidnight])
		hourMinuteSecondDo:  block3! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
hoursSinceMidnight
	^self secondsSinceMidnight // SecondsPerHour! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
hoursSinceStartOfDay 
	^self secondsSinceStartOfDay // SecondsPerHour! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
in: aChronosTimezone 
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."

	"{YearMonthDay today in: 'America/Phoenix'}"
	"{DateAndTimeFactory now in: 'Asia/Calcutta'}"
	"{DateAndTimeFactory nominalNow in: 'Asia/Calcutta'}"
	"{DateAndTimeFactory now in: ChronosTimezone nominal}"

	^self >> aChronosTimezone! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
inAll: aCollectionOfTimeZones
	"NOTE: If <aCollectionOfTimeZones> is a Set, the result will be a Set with only one member, because all DateAndTime instances compare as equal to all others that represent the same moment in time."

	^aCollectionOfTimeZones  collect: [:tz | self >> tz]! !

!TemporalCoordinate methodsFor: 'examples' stamp: ''!
inAllCalendars
	"YearMonthDay today inAllCalendars"

	| allCalendars |
	allCalendars := Calendar allRegisteredKeys asSortedCollection: [:a :b | a == #Gregorian ifTrue: [true] ifFalse: [b == #Gregorian ifTrue: [false] ifFalse: [a < b]]].
	^self asAll: allCalendars! !

!TemporalCoordinate methodsFor: 'examples' stamp: ''!
inAllTimeZones
	"INSPECT IT: 
		{(Timepoint 
			year: 2001 
			month: September 
			day: 11 
			hour: 8
			minute: 42
			second: 26
			timeZone: #'America/New_York') inAllTimeZones}"
	"INSPECT IT: 
		{(Timepoint 
			year: 1941 
			month: December 
			day: 7 
			hour: 7
			minute: 55
			second: 0
			timeZone: #'Pacific/Honolulu')  inAllTimeZones}"


	| inAllTimezones map |
	inAllTimezones := self inAll: ChronosTimezone allRegisteredKeys asArray.
	map := Dictionary new.
	inAllTimezones do: 
		[:timepoint | 
			map 
				at: '[', timepoint timeZone zuluNotation, '] ', timepoint timeZone identityString 
				put: timepoint localePrintString].
	^map! !

!TemporalCoordinate methodsFor: 'examples' stamp: ''!
inAllTimeZonesAndCalendars
	"INSPECT IT: 
		{(Timepoint 
			year: 2001 
			month: September 
			day: 11 
			hour: 8
			minute: 42
			second: 26
			timeZone: #'America/New_York') inAllTimeZonesAndCalendars}"
	"INSPECT IT: 
		{(Timepoint 
			year: 1941 
			month: December 
			day: 7 
			hour: 7
			minute: 55
			second: 0
			timeZone: #'Pacific/Honolulu') inAllTimeZonesAndCalendars}"

	| inAllTimezones map allCalendars printPolicy |
	allCalendars := Calendar allRegisteredKeys asSortedCollection: [:a :b | a == #Gregorian ifTrue: [true] ifFalse: [b == #Gregorian ifTrue: [false] ifFalse: [a < b]]].
	inAllTimezones := self inAll: ChronosTimezone allCanonicalKeys asArray.
	printPolicy := ChronosPrintPolicy rfc2822 apply: #(showEraNameAfterDate dateAndTimeSeparator: ' @ ' use12HourFormat hourPadChar: nil showTimeZoneAbbreviation).
	map := Dictionary new.
	inAllTimezones do: 
		[:timepoint | 
			| stream timezone |
			timezone := timepoint timeZone.
			stream := String new writeStream.
			timezone specifiesGeographicCoordinates
				ifTrue: 
					[stream
						nextPutAll: 'Geographic coordinates: ';
						print: timezone geographicCoordinates;
						cr].
			stream nextPutAll: 'Julian Date: '.
			ChronosFunction
				printFractional: timepoint utJulianDate asDecimalOn: stream decimalPoint: $. precision: 9.
			stream nextPutAll: ' (Universal Time)'; cr.
			(timepoint asAll: allCalendars) 
				do: [:each | 
					each printOn: stream using: printPolicy.
					stream 
						nextPutAll: ' ['.
					ChronosFunction
						printFractional: each fractionalDaysSinceEpoch asDecimalOn: stream decimalPoint: $. precision: 3.
					stream
						nextPutAll: ' days since ';
						nextPutAll: each calendar name;
						nextPutAll: ' Epoch]';
						cr].
			map 
				at: '[', timezone zuluNotation, '] ', timezone identityString
				put: stream contents].
	^map! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
isAtStartOfDay
	self subsecondsAreZero ifFalse: [^false].
	self hourMinuteSecondDo: [:hour :minute :second | (second = 0 and: [minute = 0 and: [hour = 0]]) ifFalse: [^false]].
	^true! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
isAtStartOfHour
	self subsecondsAreZero ifFalse: [^false].
	self hourMinuteSecondDo: [:hour :minute :second | (second = 0 and: [minute = 0]) ifFalse: [^false]].
	^true! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
isAtStartOfMinute
	^self subsecondsAreZero and: [self second = 0]! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
isBoundToTimeZone
	^false! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
isInvariantToNominalTime
	"Answer true if the receiver always represents an invariant nominal local time ('3 pm local time') in whatever Timezone to which it may be bound. Otherwise, answer false."

	^true! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
isInvariantToUT
	"Answer true if the receiver always represents an invariant nominal UT time ('3 pm UT') in whatever Timezone to which it may be bound. Otherwise, answer false."
	^self isInvariantToNominalTime not! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
isTemporalCoordinate
	^true! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
localTimeIsUniversal
	^self basicTimeZone isUniversalTime! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
meridianAbbreviation
	"Specified and required by the ANSI-Smalltalk Standard."

	^ChronosLocale default 
		properNameAtSemanticKey: (MeridianKeys at: (self hour // 12) + 1)! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
microsecondsSinceSecond
	^(self nanosecondsSinceSecond bitShift: -3) // 125! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
microsecondsSinceStartOfDay
	^self nanosecondsSinceStartOfDay // NanosecondsPerMicrosecond! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
millisecond
	^(self nanosecondsSinceSecond bitShift: -6) // 15625! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
millisecondsSinceStartOfDay
	^self nanosecondsSinceStartOfDay // NanosecondsPerMillisecond! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
minute
	"Specified and required by the ANSI-Smalltalk Standard."

	^self minutesSinceStartOfTimeOfDayClock \\ MinutesPerHour! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
minutesSinceMidnight
	^self secondsSinceMidnight // SecondsPerMinute! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
minutesSinceStartOfDay 
	^self secondsSinceStartOfDay // SecondsPerMinute! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
minutesSinceStartOfTimeOfDayClock
	^self secondsSinceStartOfTimeOfDayClock // SecondsPerMinute! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
nanosecondsSinceMidnight
	^self secondsSinceMidnight * NanosecondsPerSecond + self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond
	^0! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
nanosecondsSinceStartOfDay
	^self secondsSinceStartOfDay * NanosecondsPerSecond + self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'INTER-period-stream protocol' stamp: ''!
next
	"Answer a Timeperiod whose starting point-in-time is the receiver's limit value (end-point,) and whose temporal extent (duration) is the same as the receiver's.  See the class comment for the definition of these terms."

	^self + self resolutionQuantum! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
offset
	"Specified and required by the ANSI-Smalltalk Standard."

	^self timeZone offsetFromUT! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
offset: aDuration
	"Specified and required by the ANSI-Smalltalk Standard."

	^self in: aDuration asTimezone! !

!TemporalCoordinate methodsFor: 'private-time zone operations' stamp: ''!
offsetSecondsFromUT
	^self timeZone 
		netSecondsAfterAddingOffsetFromUTToSeconds: 0
		nanosecondsSinceSecond: self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
on: aCalendricalCoordinate 
	"TimeOfDay now on: YearMonthDay today"
	"TimeOfDay now on: Timepoint today"
	"(TimeOfDay hour: 17 minute: 30 second: 0) on: (YearMonthDay year: 2006 month: June day: 14)"
	"(TimeOfDay hour: 17 minute: 30 second: 0) on: (Timepoint year: 2006 month: June day: 14)"
	"(TimeOfDay hour: 9 minute: 20 second: 0) on: GregorianEaster canonical"

	^aCalendricalCoordinate @ self! !

!TemporalCoordinate methodsFor: 'converting' stamp: ''!
on: aCalendricalCoordinate in: timeZone 
	"TimeOfDay now on: YearMonthDay today in: 'Australia/Adelaide'"
	"TimeOfDay now on: Timepoint today in: 'America/Vancouver'"
	"(TimeOfDay hour: 17 minute: 30 second: 0) on: (YearMonthDay year: 2006 month: June day: 14) in: 'Europe/Berlin'"
	"(TimeOfDay hour: 17 minute: 30 second: 0) on: (Timepoint year: 2006 month: June day: 14) in: 'Pacific/Auckland'"
	"(TimeOfDay hour: 9 minute: 20 second: 0) on: GregorianEaster canonical in: 'Asia/Rangoon'"

	^aCalendricalCoordinate atTimeOfDay: self in: timeZone! !

!TemporalCoordinate methodsFor: 'INTER-period-stream protocol' stamp: ''!
prev
	"Answer a Timeperiod whose starting point-in-time is computed by subtracting the receiver's temporal extent (duration) from its starting point-in-time, and whose temporal extent (duration) is the same as the receiver's.  See the class comment for the definition of these terms."

	"{Timeperiod currentHour prev}"
	"{Timeperiod today prev}"
	"{Timeperiod currentWeek prev}"
	"{Timeperiod currentMonth prev}"
	"{Timeperiod currentYear prev}"

	^self - self resolutionQuantum! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
rootTimeZone
	^self basicTimeZone root! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
scientificDurationSince: aTemporalCoordinate
	^self class durationFactory
		seconds: (self basicSecondsSince: aTemporalCoordinate)
		nanoseconds: self nanosecondsSinceSecond - aTemporalCoordinate nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
scientificDurationUntil: aTemporalCoordinate
	^self class durationFactory
		seconds: (self basicSecondsUntil: aTemporalCoordinate)
		nanoseconds: aTemporalCoordinate nanosecondsSinceSecond - self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
second
	"Specified and required by the ANSI-Smalltalk Standard."

	^self secondsSinceStartOfTimeOfDayClock \\ SecondsPerMinute! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
secondsSince: aTemporal
	| seconds |
	seconds := self basicSecondsSince: aTemporal.
	^(self basicNanosecondsSinceSecondSince: aTemporal) >= 0 
		ifTrue: [seconds]
		ifFalse: [seconds - 1]! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
secondsSinceMidnight
	^self secondsSinceStartOfDay! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	^0! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfTimeOfDayClock
	^self timeOfDayClockStartsAtStartOfDay 
		ifTrue: [self secondsSinceStartOfDay]
		ifFalse: [self secondsSinceMidnight]! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
secondsUntil: aTemporal
	| seconds |
	seconds := self basicSecondsUntil: aTemporal.
	^(self basicNanosecondsSinceSecondUntil: aTemporal ) >= 0 
		ifTrue: [seconds]
		ifFalse: [seconds - 1]! !

!TemporalCoordinate methodsFor: 'examples' stamp: ''!
showInAllCalendars
	"(DateAndTimeFactory utYear: 1969 month: 7 day: 20 seconds: 37060 nanoseconds: 0) showInAllCalendars"
	"HebrewCalendar clock now showInAllCalendars"

	| printPolicy policySpec |
	Transcript cr.
	self inAllCalendars do: [:each | Transcript cr; show: (each printStringUsing: #universal)].
	policySpec := #(#standardCalendarRegistrationKey: nil #useOrdinalDate #dateAndTimeSeparator: ' @ ' timeOfDayPrefix: nil hourPadChar: nil #use12HourFormat #hideSubsecondFraction #timeZoneSeparator: $  #timeZoneElementSeparator: nil) copy.
	policySpec at: 2 put: self calendarRegistrationKey.
	printPolicy := ChronosPrintPolicy applying: policySpec.
	Transcript
		cr;
		show: (self printStringUsing: printPolicy);
		show: ' [';
		show: self calendar name;
		show: '-ordinal date]'.
	printPolicy := printPolicy apply: #(#useISOWeekOfYearDayOfWeek).
	Transcript
		cr;
		show: (self printStringUsing: printPolicy);
		show: ' [ISO]'.
	printPolicy := printPolicy apply: #(#showDateAsJulianDay).
	Transcript
		cr;
		show: (self printStringUsing: printPolicy);
		show: ' [Julian Day]'.
	Transcript
		cr;
		show: (self - ChronosSystemClock st80Epoch) printString;
		show: ' days:hh:mm:ss.s.. since 1901-01-01T00:00:00Z (ST80 epoch)'.
	Transcript
		cr;
		show: (self secondsSince: ChronosSystemClock unixEpoch) printString;
		show: ' seconds since 1970-01-01T00:00:00Z (Unix epoch)'.
	Transcript
		cr;
		show: ((self nanosecondsSince: ChronosSystemClock msWindowsNTEpoch) // 100) printString;
		show: ' 100-nanosecond ticks since 1601-01-01T00:00:00Z (MS WIndows epoch)'.
	SemanticDatePolicy default semanticKeysFor: self do: [:semanticKey | 
		Transcript cr; tab; show: semanticKey.
		semanticKey == #weekend 
			ifTrue: [Transcript show: ' ('; show: self dayOfWeekName; show: ')']].
	Transcript cr! !

!TemporalCoordinate methodsFor: 'examples' stamp: ''!
showInCommonWorldTimezones
	"Timepoint now showInCommonWorldTimezones"

	| printPolicy |
	printPolicy := ChronosPrintPolicy rfc2822v.
	Transcript cr.
	(self inAll: ChronosTimezone commonWorldTimezones) do: 
		[:each | 
			Transcript 
				cr; 
				show: (each printStringUsing: printPolicy)]! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
subsecondsAreZero
	^self nanosecondsSinceSecond = 0! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingDays: days
	"Answer a new CalendricalCoordinate which is the given number of civil days before the date represented by the receiver, preserving the same civil time-of-day."

	^self addingDays: days negated! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours
	hours = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDateAndTime] ifFalse: [self]].
	^(self asMutableDateAndTime)
		addHours: hours negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes
	minutes = 0 ifTrue: [^self subtractingHours: hours].
	^(self asMutableTimeOfDay)
		addHours: hours negated minutes: minutes negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes seconds: seconds
	seconds = 0 ifTrue: [^self subtractingHours: hours minutes: minutes].
	^(self asMutableDateAndTime)
		addHours: hours negated minutes: minutes negated seconds: seconds negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingHours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	nanoseconds = 0 ifTrue: [^self subtractingHours: hours minutes: minutes seconds: seconds].
	^(self asMutableDateAndTime)
		addHours: hours negated
		minutes: minutes negated
		seconds: seconds negated
		nanoseconds: nanoseconds negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingMinutes: minutes
	minutes = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDateAndTime] ifFalse: [self]].
	^(self asMutableDateAndTime)
		addMinutes: minutes negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingMonths: months
	"Answer a CalendricalCoordinate which is the given number of civil months before the date represented by the receiver, preserving the same civil time-of-day.   The dayOfMonth in the new CalendricalCoordinate will be the same as in the receiver, unless it would be invalid.  For example, if the orignal date is March 31, the dayOfMonth in the answered CalendricalCoordinate will also be 31, unless the month of the answered DateAndTime has less than 31 days.  In that case,  the dayOfMonth of the answered CalendricalCoordinate will be the last day of its month.

	If <months> is negative, then the semantics are not quite as described above, but will conform to the specification for #addingMonths:, with <months> negated.

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal."

	months = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^self asMutableDate 
		addMonths: months negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: seconds
	"Answer a TemporalCoordinate which is the given number of scientific seconds before the timepoint represented by the receiver. The scientific semantics of a timepoint S seconds from another will be respected (UTC)."

	seconds = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDateAndTime] ifFalse: [self]].
	^(self asMutableDateAndTime)
		addSeconds: seconds negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingSeconds: seconds nanoseconds: nanoseconds
	"Answer a TemporalCoordinate which is the given number of scientific seconds and nanoseconds before the timepoint represented by the receiver. The scientific semantics of a timepoint S seconds and N nanoseconds from another will be respected (UTC)."

	nanoseconds = 0 ifTrue: [^self subtractingSeconds: seconds].
	^(self asMutableDateAndTime)
		addSeconds: seconds negated nanoseconds: nanoseconds negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years
	"Answer a new CalendricalCoordinate whose date is the given number of civil years before the date represented by the receiver, and which has the same civil time-of-day.  The civil intra-year date of the answered CalendricalCoordinate will be the same as that of the receiver, unless it would be invalid.  For example, if the orignal date is March 1 in a Gregorian/Julian leap year, the date in the new year will remain March 1 after subtracting the specified years.  However, if the original date is February 29 and the new year is not a leap year, then the new date will be Feb 28. 

	In the case of Calendar systems with intercalary months, analogous rules apply to the monthOrdinal.  If intercalary months may occur at times other than the end of the year, the Calendar system's cultural tradition will be respected regarding the semantics of 'same civil date N years later (or earlier.)'  The implementation assumes that the only issue in that respect is whether or not 'same month' is defined by the monthOrdinal or by the monthKey (by definition of a Chronos monthKey, months with the same monthKey are semantically the same month, regardless of possibly having different monthOrdinals in different years--which does happen in some Calendars!!.)"

	years = 0 ifTrue: [^self isMutable ifTrue: [self asMutableDate] ifFalse: [self]].
	^self asMutableDate 
		addYears: years negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months
	"Answer a new CalendricalCoordinate which is the given number of civil years and months before the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years and M civil months away from another date' will be respected.

	See the specifications/comments for #addingYears: and #addingMonths: for more detailed/precise semantics."

	months = 0 ifTrue: [^self subtractingYears: years].
	^self asMutableDate
		addYears: years negated 
		months: months negated 
		days: 0;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days
	"Answer a new CalendricalCoordinate which is the given number of civil years, months and days before the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years, M civil months and D civil days away from another date' will be respected.

	See the specifications/comments for #addingYears:, #addingMonths: and #addingDays: for more detailed/precise semantics."

	days = 0 ifTrue: [^self subtractingYears: years months: months].
	^self asMutableDate
		addYears: years negated 
		months: months negated 
		days: days negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days hours: hours minutes: minutes seconds: seconds nanoseconds: nanoseconds 
	^(self asMutableDateAndTime)
		addYears: years negated
		months: months negated
		days: days negated
		hours: hours negated
		minutes: minutes negated
		seconds: seconds negated
		nanoseconds: nanoseconds negated;
		beImmutable! !

!TemporalCoordinate methodsFor: 'arithmetic' stamp: ''!
subtractingYears: years months: months days: days seconds: seconds nanoseconds: nanoseconds
	"Answer a new CalendricalCoordinate which is the given number of civil years, months, days, seconds and nanoseconds before the date represented by the receiver.  The traditions/conventions of the receiver's calendar with respect to the semantics of 'a date Y civil years, M civil months and D civil days away from another date' will be respected. The scientific semantics of a timepoint S seconds and N nanoseconds from another will be respected (UTC).

	See the specifications/comments for #subtractingYears:, #subtractingMonths:, #subtractingDays: and #subtractingSeconds:nanoseconds: for more detailed/precise semantics."

	^(seconds = 0 and: [nanoseconds = 0]) 
		ifTrue: 
			[(self asMutableDate)
				addYears: years negated
					months: months negated
					days: days negated;
				beImmutable]
		ifFalse: 
			[(self asMutableDateAndTime)
				addYears: years negated
					months: months negated
					days: days negated;
				addSeconds: seconds negated nanoseconds: nanoseconds negated;
				beImmutable]! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
timeOfDay
	^self class timeOfDayFactory
		secondsSinceStartOfDay: self secondsSinceStartOfTimeOfDayClock
		nanoseconds: self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
timeOfDaySinceMidnight
	^self class timeOfDayFactory
		secondsSinceStartOfDay: self secondsSinceMidnight 
		nanoseconds: self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
timeOfDaySinceStartOfDay
	^self class timeOfDayFactory
		secondsSinceStartOfDay: self secondsSinceStartOfDay
		nanoseconds: self nanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
timeZone
	"Answer the bound Timezone that has the correct offsetFromUT for the date and time represented by the receiver."

 	^self basicTimeZone! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
timeZoneAbbreviation
	"Specified and required by the ANSI-Smalltalk Standard."

	^self timeZone abbreviation! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
timeZoneIsDynamic
	^self basicTimeZone isDynamic! !

!TemporalCoordinate methodsFor: 'testing' stamp: ''!
timeZoneIsStatic
	^self basicTimeZone isStatic! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
timeZoneKey
	^self basicTimeZone key! !

!TemporalCoordinate methodsFor: 'accessing' stamp: ''!
timeZoneName
	"Specified and required by the ANSI-Smalltalk Standard."

	^self timeZone name! !

!TemporalCoordinate methodsFor: 'private-time zone operations' stamp: ''!
unbindTimeZone
	"By default, do nothing"! !

!TemporalCoordinate methodsFor: 'deprecated' stamp: ''!
upTo: limitValue 
	"Deprecated. See #to:"

	^self to: limitValue! !

!TemporalCoordinate methodsFor: 'accessing-UT' stamp: 'PaulDeBruicker 3/9/2011 11:24'!
utFractionalTimeOfDay
	^ScaledDecimal
		numerator: self utNanosecondsSinceStartOfDay
		denominator: (NanosecondsPerDay)
		scale: 9! !

!TemporalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceSecond
	^0! !

!TemporalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utNanosecondsSinceStartOfDay
	^self utSecondsSinceStartOfDay * NanosecondsPerSecond + self utNanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'accessing-UT' stamp: ''!
utSecondsSinceStartOfDay
	^self timeZone 
		netSecondsAfterSubtractingOffsetFromUTFromSeconds: self basicSecondsSinceStartOfDay
		nanosecondsSinceSecond: self basicNanosecondsSinceSecond! !

!TemporalCoordinate methodsFor: 'parameter validation' stamp: ''!
validateHour: hour minute: minute second: second
	HoursSinceStartOfDayRangeConstraint assertValid: hour.
	MinutesSinceHourRangeConstraint assertValid: minute.
	SecondsSinceMinuteRangeConstraint assertValid: second.
	hour = 24 
		ifTrue: 
			[(second = 0 and: [minute = 0]) 
				ifFalse: 
					[self signalInvalidArgument: #hour:minute:second:
						value: (Array with: hour with: minute with: second)]].! !

TemporalCoordinate subclass: #TimeOfDay
	instanceVariableNames: 'hour minute second nanosecondsSinceSecond'
	classVariableNames: 'StartOfDay'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!TimeOfDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
hour: hour minute: minute second: second
	"{TimeOfDay hour: 13 minute: 44 second: 15}"

	^self basicNew
		setHour: hour minute: minute second: second;
		beImmutable! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond
	"{TimeOfDay hour: 13 minute: 44 second: 15 nanosecond: 418000000}"

	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second;
		beImmutable! !

!TimeOfDay class methodsFor: 'class initialization' stamp: ''!
initialize
	"TimeOfDay initialize" 

	StartOfDay := nil.! !

!TimeOfDay class methodsFor: 'private' stamp: ''!
initializeStartOfDay
	StartOfDay := self secondsSinceStartOfDay: 0 nanoseconds: 0! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
nanosecondsSinceStartOfDay: nanosecondsSinceStartOfDay
	"{TimeOfDay nanosecondsSinceStartOfDay: 86399999999999}"

	^self basicNew
		setNanosecondsSinceStartOfDay: nanosecondsSinceStartOfDay;
		beImmutable! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
now	
	"{TimeOfDay now}"

	^AnsiStandardCalendarClock timeOfDayNow! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
nowIn: aTimezone
	"{TimeOfDay nowIn: 'Asia/Calcutta'}"

	^AnsiStandardCalendarClock timeOfDayNowIn: aTimezone! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
nowToTheSecond
	"{TimeOfDay nowToTheSecond}"

	^AnsiStandardCalendarClock timeOfDayNowToTheSecond! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
nowToTheSecondIn: aTimezone
	"{TimeOfDay nowToTheSecondIn: 'Asia/Calcutta'}"

	^AnsiStandardCalendarClock timeOfDayNowToTheSecondIn: aTimezone! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
readFrom: stream using: aChronosParser
	"Create an object based on the contents of <stream>, as interpreted by <aChronosParser>"

	^(ChronosParser referencedBy: aChronosParser) nextTimeOfDayFrom: stream usingFactory: self! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
secondsSinceStartOfDay: secondsSinceStartOfDay
	"{TimeOfDay secondsSinceStartOfDay: 86399}"
	"{TimeOfDay secondsSinceStartOfDay: 86400}"
	"{TimeOfDay secondsSinceStartOfDay: 86401}"

	^self basicNew
		setSecondsSinceStartOfDay: secondsSinceStartOfDay;
		beImmutable! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
secondsSinceStartOfDay: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond
	"{TimeOfDay secondsSinceStartOfDay: 86399 nanoseconds: 999999999}"

	^self basicNew
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setSecondsSinceStartOfDay: secondsSinceStartOfDay;
		beImmutable! !

!TimeOfDay class methodsFor: 'accessing' stamp: ''!
startOfDay
	"{TimeOfDay startOfDay}"

	StartOfDay == nil ifTrue: [self initializeStartOfDay].
	^StartOfDay! !

!TimeOfDay class methodsFor: 'instance creation' stamp: ''!
utNow	
	"{TimeOfDay utNow}"

	^AnsiStandardCalendarClock utTimeOfDayNow! !

!TimeOfDay methodsFor: 'converting' stamp: ''!
<< aChronosTimezone 
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but convert the date and time-of-day as though the receiver represented a date and time in the current default time zone (i.e,. preserve date and time-of-day in Universal Time as though the receiver represented a date and time in the current default time zone.)
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is the same as that of the receiver (i.e,, preserve local date and local time-of-day, don't preserve date or time-of-day in Universal Time.)"

	"TimeOfDay now << 10 hours"
	"TimeOfDay now << 'Australia/Adelaide'"
	"TimeOfDay now << #nominal"
	"WeekOfMonthDayOfWeek today << 'Pacific/Kiritimati'"
	"(Timepoint nowIn: 'Pacific/Kiritimati') << #nominal"
	"(Timepoint nowIn: 'Pacific/Kiritimati') << #default"
	"(Timepoint nowIn: 'Pacific/Kiritimati') << #system"
	"Timepoint nominalNow << 10 hours"
	"Timepoint nominalNow << 'Australia/Adelaide'"

	| timeZone |
	timeZone := ChronosTimezone referencedBy: aChronosTimezone.
	timeZone isDefault ifTrue: [^self isMutable ifTrue: [self asMutableDateAndTimeInvariantToUT] ifFalse: [self asDateAndTime]].
	^((self asMutableDateAndTime)
		deproxifyTimeZone;
		convertToTimeZone: timeZone)
			beImmutable! !

!TimeOfDay methodsFor: 'converting' stamp: ''!
>> aChronosTimezone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."

	"TimeOfDay now >> 10 hours"
	"TimeOfDay now >> 'Australia/Adelaide'"

	| newTimeZone |
	newTimeZone := ChronosTimezone referencedBy: aChronosTimezone.
	newTimeZone isDefault ifTrue: [^self isMutable ifTrue: [self asMutableDateAndTimeInvariantToUT] ifFalse: [self asDateAndTime]].
	^(self asMutableDateAndTime)
		basicSetTimeZone: newTimeZone;
		canonicalizeFromLocalTime;
		beImmutable! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours
	self assertMutability.
	hour := hour + addedHours.
	hour isInteger
		ifFalse:
			[| h |
			h := hour.
			hour := hour truncated.
			self addMinutes: (h - hour) * MinutesPerHour].
	(hour < 0 or: [hour >= HoursPerDay])
		ifTrue: [hour := hour \\ HoursPerDay]! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes
	self 
		addMinutes: addedMinutes;
		addHours: addedHours! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes seconds: addedSeconds
	self 
		addSeconds: addedSeconds;
		addMinutes: addedMinutes;
		addHours: addedHours! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
addHours: addedHours minutes: addedMinutes seconds: addedSeconds nanoseconds: addedNanoseconds
	self 
		addSeconds: addedSeconds nanoseconds: addedNanoseconds;
		addMinutes: addedMinutes;
		addHours: addedHours! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
addMinutes: addedMinutes
	self assertMutability.
	minute := minute + addedMinutes.
	minute isInteger
		ifFalse:
			[| m |
			m := minute.
			minute := minute truncated.
			self addSeconds: (m - minute) * SecondsPerMinute].
	(minute < 0 or: [minute >= MinutesPerHour])
		ifTrue: 
			[self addHours: minute // MinutesPerHour.
			minute := minute \\ MinutesPerHour]! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
addSeconds: seconds
	"Add the given number of seconds to the time-of-day represented by the receiver."

	seconds isInteger
		ifTrue: 
			[self assertMutability.
			second := second + seconds]
		ifFalse:
			[| s |
			s := seconds truncated.
			self addSeconds: s nanoseconds: (s - seconds) * NanosecondsPerSecond].
	(second < 0 or: [second >= MinutesPerHour])
		ifTrue: 
			[self addMinutes: second // MinutesPerHour.
			second := second \\ MinutesPerHour]! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
addSeconds: seconds nanoseconds: nanoseconds 
	"Add the given number of seconds and nanoseconds to the time-of-day represented by the receiver."

	| nanoSecondsToAdd secondsToAdd |
	nanoseconds = 0 ifTrue: [^self addSeconds:  seconds].
	self assertMutability.
	nanoSecondsToAdd := seconds isInteger
		ifTrue: 
			[secondsToAdd := seconds.
			nanoseconds rounded]
		ifFalse:
			[secondsToAdd := seconds truncated.
			((seconds - secondsToAdd) * NanosecondsPerSecond) rounded + nanoseconds rounded].
	nanosecondsSinceSecond := nanosecondsSinceSecond + nanoSecondsToAdd.
	(nanosecondsSinceSecond < 0 
		or: [nanosecondsSinceSecond >= NanosecondsPerSecond]) 
			ifTrue: 
				[secondsToAdd := secondsToAdd +  ((nanosecondsSinceSecond bitShift: -9) // 1953125).
				nanosecondsSinceSecond := nanosecondsSinceSecond \\ NanosecondsPerSecond].
	secondsToAdd = 0
		ifFalse:
			[second := second + secondsToAdd.
			(second < 0 or: [second >= SecondsPerMinute])
				ifTrue: 
					[self addMinutes: second // SecondsPerMinute.
					second := second \\ SecondsPerMinute]]! !

!TimeOfDay methodsFor: 'converting' stamp: ''!
asCalendricalCoordinate
	"Answer the conversion of the receiver into its equivalent value implemented as a CalendricalCoordinate.  If the receiver is already a CalendricalCoordinate, answer the receiver."

	^self asNominalDateAndTime! !

!TimeOfDay methodsFor: 'private' stamp: ''!
asMutableDate
	 ^self asMutableDateAndTime! !

!TimeOfDay methodsFor: 'private' stamp: ''!
asMutableDateAndTime
	 | today |
	today := AnsiStandardCalendarClock mutableDateTodayIn: ChronosTimezone default.
	^(self class dateAndTimeFactory basicNew)
		basicSetCalendar: AnsiStandardCalendar;
		basicSetTimeZone: DateAndTimeFactory nominalTZ;
		setYear: today year calendarDay: today calendarDay;
		setTimeOfDay: self! !

!TimeOfDay methodsFor: 'private' stamp: ''!
asMutableDateAndTimeInvariantToUT
	 | today |
	today := AnsiStandardCalendarClock mutableDateTodayIn: ChronosTimezone default.
	^(self class dateAndTimeFactory basicNew)
		basicSetYear: today year calendarDay: today calendarDay;
		setTimeOfDay: self;
		canonicalizeFromLocalTime! !

!TimeOfDay methodsFor: 'converting' stamp: ''!
asNative
	"Answer the native 'TimeOfDay' analog that semantically corresponds as closely as possible to the receiver."

	"{TimeOfDay now asNative}"

	^ChronosSystemFacade current nativeTimeOfDayFromChronosTimeOfDay: self! !

!TimeOfDay methodsFor: 'converting' stamp: ''!
asSpec
	^self! !

!TimeOfDay methodsFor: 'converting' stamp: ''!
atStartOfDay
	^self class startOfDay! !

!TimeOfDay methodsFor: 'private' stamp: ''!
basicNanosecondsSinceSecond
	^nanosecondsSinceSecond! !

!TimeOfDay methodsFor: 'private' stamp: ''!
basicSecondsSinceStartOfDay
	^(hour * SecondsPerHour) + (minute * SecondsPerMinute) + second! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	hour == nil
		ifTrue: [hour := 0].
	minute == nil
		ifTrue: [minute := 0].
	second == nil
		ifTrue: [second := 0].
	nanosecondsSinceSecond == nil
		ifTrue: [nanosecondsSinceSecond := 0].! !

!TimeOfDay methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self hour;
		nextPut: self minute;
		nextPut: self second;
		nextPut: self nanosecondsSinceSecond! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
hour
	^hour! !

!TimeOfDay methodsFor: 'accessing-multivalued' stamp: ''!
hourMinuteSecondDo: block3 
	^block3
		value: hour
		value: minute
		value: second! !

!TimeOfDay methodsFor: 'accessing-multivalued' stamp: ''!
hourMinuteSecondDo: block3 hour24Format: hour24
	^block3
		value: (hour24 ifTrue: [hour] ifFalse: [self hour12])
		value: minute
		value: second! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
hoursSinceMidnight
	^hour! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
hoursSinceStartOfDay 
	^hour! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	hour := 0.
	minute := 0.
	second := 0.	
	nanosecondsSinceSecond := 0.! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
initializeFrom: aTemporalCoordinate 
	self setNanosecondsSinceSecond: aTemporalCoordinate nanosecondsSinceSecond.	
	aTemporalCoordinate hourMinuteSecondDo: [:h :m :s | self setHour: h minute: m second: s].! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self 
		setNanosecondsSinceSecond: (literalArray at: 5) asNumber;
		setHour: (literalArray at: 2) asNumber minute: (literalArray at: 3) asNumber second: (literalArray at: 4) asNumber! !

!TimeOfDay methodsFor: 'testing' stamp: ''!
isNanosecondDuration
	"Answer whether the receiver's temporal extent is one nanosecond."

	^true! !

!TimeOfDay methodsFor: 'testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the receiver's calendrical system starts each day at local midnight."

	^true! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
minute
	^minute! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
minutesSinceMidnight
	^self minutesSinceStartOfDay! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
minutesSinceStartOfDay 
	^hour * MinutesPerHour + minute! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
minutesSinceStartOfTimeOfDayClock
	^self minutesSinceStartOfDay! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond
	^nanosecondsSinceSecond! !

!TimeOfDay methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printTimeOfDay: self on: stream! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^NanosecondDuration! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
second
	^second! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	^(hour * SecondsPerHour) + (minute * SecondsPerMinute) + second! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
setHour: h minute: m second: s 
	self validateHour: h minute: m second: s.
	self assertMutability.
	s isInteger
		ifTrue: [second := s]
		ifFalse:
			[second := s truncated.
			self setNanosecondsSinceSecond: (s - second) * NanosecondsPerSecond]	.
	minute := m truncated.
	hour := h truncated.
	m isInteger ifFalse: [self addSeconds: (m - minute) * SecondsPerMinute nanoseconds: 0].
	h isInteger ifFalse: [self addMinutes: (h - hour) * MinutesPerHour].! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
setNanosecondsSinceSecond: n
	self assertMutability.
	nanosecondsSinceSecond := n truncated! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
setNanosecondsSinceStartOfDay: nanosecondsSinceStartOfDay
	| nanoseconds |
	nanoseconds := nanosecondsSinceStartOfDay rounded.
	self 
		setNanosecondsSinceSecond: (nanoseconds \\ NanosecondsPerSecond);
		setSecondsSinceStartOfDay: (ChronosFunction divBy1000000000: nanoseconds)! !

!TimeOfDay methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
setSecondsSinceStartOfDay: secondsSinceStartOfDay 
	| seconds |
	secondsSinceStartOfDay isInteger
		ifTrue: [seconds := secondsSinceStartOfDay] 
		ifFalse: 
			[seconds := secondsSinceStartOfDay truncated.
			self setNanosecondsSinceSecond: (secondsSinceStartOfDay - seconds) * NanosecondsPerSecond].
	self assertMutability.
	seconds := seconds abs <= SecondsPerDay 
				ifTrue: 
					[secondsSinceStartOfDay positive 
						ifTrue: [seconds]
						ifFalse: [SecondsPerDay + seconds]]
				ifFalse: [seconds \\ SecondsPerDay].
	hour := seconds // SecondsPerHour.
	seconds := seconds \\ SecondsPerHour.
	minute := seconds // SecondsPerMinute.
	second := seconds \\ SecondsPerMinute.
	(hour == 24 and: [minute == 0 and: [second == 0]]) 
		ifTrue: 
			[hour := 23.
			minute := 59.
			second := 60]! !

!TimeOfDay methodsFor: 'initialize-release' stamp: ''!
subtractHours: subtractedHours minutes: subtractedMinutes seconds: subtractedSeconds nanoseconds: subtractedNanoseconds
	self assertMutability.
	nanosecondsSinceSecond := nanosecondsSinceSecond - subtractedNanoseconds.
	second := second - subtractedSeconds.
	minute := minute - subtractedMinutes.
	hour := hour - subtractedHours.! !

!TimeOfDay methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromDuration: aDuration
	^aDuration
		subtractingHours: self hour
		minutes: self minute
		seconds: self second
		nanoseconds: self nanosecondsSinceSecond! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
timeOfDay
	^self! !

!TimeOfDay methodsFor: 'testing' stamp: ''!
timeOfDayClockStartsAtMidnight
	"Answer true if the zero-point of the time-of-day clock coincides with midnight"

	^true! !

!TimeOfDay methodsFor: 'testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the receiver's calendrical system coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^true! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
timeOfDaySinceMidnight

	^self! !

!TimeOfDay methodsFor: 'accessing' stamp: ''!
timeOfDaySinceStartOfDay

	^self! !

!TemporalInterval class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!TemporalInterval class methodsFor: 'class initialization' stamp: ''!
invalidateCalendarBindings
	"Calendrical invalidateCalendarBindings"

	self allInstancesDo: [:calendrical | calendrical invalidateCalendar].
	self subclasses do: [:class | class invalidateCalendarBindings]! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
* aTemporalInterval 
	"Answer the intersection of the receiver with <aTemporalInterval>.  Answer nil if there is no intersection."

	"{(Timeperiod dayStartingAt: (Timepoint todayIn: 'Asia/Calcutta')) * (Timeperiod dayStartingAt: (Timepoint todayIn: 'America/Los_Angeles'))}"
	"{Timeperiod currentMonth * (Timeperiod monthStartingAt: YearMonthDay today)}"
	"{Timeperiod currentMonth * (Timeperiod monthStartingAt: (YearMonthDay today addingMonths: 1))}"
	"{Timeperiod currentMonth * (Timeperiod from: YearMonthDay today duration: (CivilDuration months: -1))}"
	"{Timeperiod currentMonth * (Timeperiod from: (YearMonthDay today subtractingMonths: 1) duration: (CivilDuration months: -1))}"
	"{(Timeperiod from: YearMonthDay today duration: (CivilDuration months: -1)) * Timeperiod currentMonth}"
	"{(Timeperiod from: (YearMonthDay today subtractingMonths: 1) duration: (CivilDuration months: -1)) * Timeperiod currentMonth}"
	"{Timeperiod currentMonth * (Timeperiod monthStartingAt: (YearMonthDay today subtractingMonths: 1))}"
	"{Timeperiod currentMonth * (YearMonthDay atLastDayOfMonth @ (TimeOfDay hour: 12 minute: 0 second: 0))}"

	| thisStart thisLimit thatStart thatLimit iStart iLimit |
	(self duration isZero or: [aTemporalInterval duration isZero]) ifTrue: [^nil].
	thisStart := self start.
	thisLimit := self limit.
	thatStart := aTemporalInterval start.
	thatLimit := aTemporalInterval limit.
	thisLimit > thisStart 
		ifTrue: 
			[thatLimit > thatStart 
				ifTrue: 
					[iStart := thisStart max: thatStart.
					iLimit := thisLimit min: thatLimit]
				ifFalse: 
					[iStart := thisStart max: thatLimit + thatLimit resolutionQuantum.
					iLimit := thisLimit min: thatStart + thatStart resolutionQuantum]]
		ifFalse: 
			[thatLimit > thatStart 
				ifTrue: 
					[iStart := thisLimit + thisLimit resolutionQuantum max: thatStart.
					iLimit := thisStart + thisStart resolutionQuantum min: thatLimit]
				ifFalse: 
					[iStart := thisStart min: thatStart.
					iLimit := thisLimit max: thatLimit]].
	^iLimit > iStart ifTrue: [iStart to: iLimit]! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
+ aDurationOrTemporalInterval
	"Specified and required by the ANSI-Smalltalk Standard."

	"{Timeperiod today + Timeperiod currentMonth}"
	"{(Timeperiod 
		from: (YearMonthDay today subtractingDays: 10)
		duration: (CalendarDuration days: 1)) + Timeperiod today}"
	"{Timeperiod today + (CalendarDuration days: 1)}"

	^aDurationOrTemporalInterval addedToTemporalInterval: self! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
- aDurationOrTemporalInterval
	"Specified and required by the ANSI-Smalltalk Standard."

	"{Timeperiod today - (ScientificDuration days: 1)}"

	^aDurationOrTemporalInterval subtractedFromTemporalInterval: self! !

!TemporalInterval methodsFor: 'converting' stamp: ''!
/ aTemporalCoordinateOrADurational
	"YearMonthDay today / 1 days"
	"(YearMonthDay year: 2006 day: 1) / (YearMonthDay year: 2007 month: 7 day: 1)"

	^aTemporalCoordinateOrADurational asTimeperiodStartingAt: self start! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
< aMagnitude 
	"Answer whether the receiver is less than the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison < 0]! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
<= aMagnitude 
	"Answer whether the receiver is less than or equal to the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	^(self > aMagnitude) not! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
= aMagnitude 
	"Answer whether the receiver is equal to the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	self == aMagnitude ifTrue: [^true].
	^(self compareTo: aMagnitude) = 0! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
> aMagnitude 
	"Answer whether the receiver is greater than the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison > 0]! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
>= aMagnitude 
	"Answer whether the receiver is greater than or equal to the argument."
	"Specified and required by the ANSI-Smalltalk Standard."

	^(self < aMagnitude) not! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
addedToCalendarDuration: aDuration
	^aDuration addedToTemporalInterval: self! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
addedToCivilDuration: aDuration
	^aDuration addedToTemporalInterval: self! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
addedToDuration: aDuration 
	^aDuration addedToTemporalInterval: self! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
addedToInfiniteDuration: anInfiniteDuration
	^InfiniteTimepoint polarity: anInfiniteDuration positive! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
addedToTemporalInterval: aTemporalInterval
	| thisStart thisNextStart thatStart thatNextStart |
	thisStart := self start.
	thisNextStart := self limit.
	thatStart := aTemporalInterval start.
	thatNextStart := aTemporalInterval limit.
	^thisNextStart >= thisStart 
		ifTrue: 
			[thatNextStart >= thatStart 
				ifTrue: [(thisStart min: thatStart) to: (thisNextStart max: thatNextStart)]
				ifFalse: 
					[(thisStart min: thatNextStart + thatNextStart resolutionQuantum) 
						to: (thisNextStart max: thatStart + thatStart resolutionQuantum)]]
		ifFalse: 
			[thatNextStart >= thatStart 
				ifTrue: 
					[(thisNextStart + thisNextStart resolutionQuantum min: thatStart) 
						to: (thisStart + thisStart resolutionQuantum max: thatNextStart)]
				ifFalse: [(thisStart max: thatStart) to: (thisNextStart min: thatNextStart)]]! !

!TemporalInterval methodsFor: 'converting' stamp: ''!
asTimeperiod
	"Answer a Timeperiod whose starting point-in-time is the receiver, and whose temporal extent is the receiver's duration."

	^self! !

!TemporalInterval methodsFor: 'converting' stamp: ''!
asTimeperiodStartingAt: startPoint
	^startPoint to: self start! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
between: min and: max 
	"Answer whether the receiver is less than or equal to the argument, max,
	and greater than or equal to the argument, min."

	^self >= min and: [self <= max]! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
calendar
	"Answer the Calendar that implements the calendrical system associated with the receiver."

	^Calendar ansiStandard! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
calendarRegistrationKey
	^self calendar registrationKey! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
clock
	^self calendar clock! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
closedExtent
	"Answer the `closed extent` of the receiver. Conceptually, the closed extent of a Timeperiod is the temporal extent (duration) of the **fully-closed** temporal interval that contains every representable point-in-time contained by the Timeperiod. Physically, it is defined to be the temporal extent (duration) computed by subtracting the Timeperiod's granularity from its temporal exent (i.e., {aTimeperiod duration - aTimeperiod granularity}.) See the comment of the receiver's #granularity method (and also the class comment.)"

	"{Timeperiod currentWeek closedExtent}"
	"{Timeperiod currentHour closedExtent}"

	^self duration - self granularity! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
compareTo: aTemporalInterval
	"Compare the value of the receiver to that of <aTemporalInterval>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aTemporalInterval> are the same.)"

	^self subclassResponsibility! !

!TemporalInterval methodsFor: 'private-comparing' stamp: ''!
compareToCalendricalCoordinate: aCalendricalCoordinate

	^self compareToTemporalCoordinate: aCalendricalCoordinate! !

!TemporalInterval methodsFor: 'private-comparing' stamp: ''!
compareToDate: aDate

	^self compareToTemporalCoordinate: aDate! !

!TemporalInterval methodsFor: 'private-comparing' stamp: ''!
compareToDateAndTime: aDateAndTime

	^self compareToTemporalCoordinate: aDateAndTime! !

!TemporalInterval methodsFor: 'private-comparing' stamp: ''!
compareToInfiniteTimepoint: anInfiniteTimepoint
	^anInfiniteTimepoint isInfinitePast
		ifTrue: [-1]
		ifFalse: [1]! !

!TemporalInterval methodsFor: 'private-comparing' stamp: ''!
compareToTemporalCoordinate: aTemporalCoordinate

	| diff |
	diff := aTemporalCoordinate basicSecondsSince: self.
	diff = 0 ifFalse: [^diff].
	^aTemporalCoordinate nanosecondsSinceSecond - self nanosecondsSinceSecond! !

!TemporalInterval methodsFor: 'private-comparing' stamp: ''!
compareToTimeperiod: aTimeperiod 
	^(aTimeperiod compareToTemporalCoordinate: self) negated! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
comparisonClassIdentifier	
	"Answer a value that identifies the group of comparable values to which the receiver belongs.  It must be valid to use #== to compare two identifiers for equality."

	^#TemporalInterval! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
contains: aTemporalInterval 
	"Answer whether the temporal interval represented by the receiver fully encloses the temporal interval represented by <aTemporalInterval>. If so, then the union of the two temporal intervals will be the same as the receiver's temporal interval."

	"{Timeperiod currentMonth contains: YearMonthDay today}"
	"{Timeperiod currentWeek contains: YearMonthDay today}"
	"{Timeperiod today contains: YearMonthDay today}"
	"{Timeperiod today contains: Timepoint today}"
	"{Timeperiod today contains: Timepoint tomorrow}"
	"{Timeperiod today contains: (Timeperiod dayStartingAt: Timepoint now)}"
	"{Timeperiod currentMonth contains: (Timeperiod monthStartingAt: YearMonthDay today)}"
	"{Timeperiod currentMonth contains: (Timeperiod monthStartingAt: (YearMonthDay today addingMonths: 1))}"
	"{Timeperiod currentMonth contains: (Timeperiod from: YearMonthDay today duration: (CivilDuration months: -1))}"
	"{Timeperiod currentMonth contains: (Timeperiod from: (YearMonthDay today subtractingMonths: 1) duration: (CivilDuration months: -1))}"
	"{(Timeperiod from: YearMonthDay today duration: (CivilDuration months: -1)) contains: Timeperiod currentMonth}"
	"{(Timeperiod from: (YearMonthDay today subtractingMonths: 1) duration: (CivilDuration months: -1)) contains: Timeperiod currentMonth}"
	"{Timeperiod currentMonth contains: (Timeperiod monthStartingAt: (YearMonthDay today subtractingMonths: 1))}"
	"{Timeperiod currentMonth contains: YearMonthDay atLastDayOfMonth @ (TimeOfDay hour: 12 minute: 0 second: 0)}"

	| myStart nextStart thatStart thatNextStart |
	self duration isZero ifTrue: [^false].
	nextStart := self limit.
	thatStart := aTemporalInterval start.
	thatNextStart := aTemporalInterval limit.
	myStart := self start.
	^nextStart > myStart 
		ifTrue: 
			[thatNextStart > thatStart 
				ifTrue: [thatStart >= myStart and: [thatNextStart <= nextStart]]
				ifFalse: [thatStart < nextStart and: [aTemporalInterval last >= myStart]]]
		ifFalse: 
			[thatNextStart > thatStart 
				ifTrue: [thatStart > nextStart and: [aTemporalInterval last <= myStart]]
				ifFalse: [thatStart <= myStart and: [thatNextStart >= nextStart]]]! !

!TemporalInterval methodsFor: 'accessing-subintervals' stamp: ''!
dayPeriods
	"Answer a SequenceableCollection containing a Timeperiod representing each of the days contained by the receiver."

	"{(Timeperiod 
		startingAt: (YearMonthDay year: 2004 month: 10 day: 30)
		duration: (CalendarDuration days: 4)) dayPeriods}"

	| sequence | 
	sequence := SequenceFactory new.
	self daysDo: [:each | sequence add: each].
	^sequence! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
daysDo: block1
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent 1-day interval (a civil/calendar day, with a positive temporal exent) whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentWeek daysDo: [:interval | Transcript cr; show: interval printString]}"

	self every: 1 daysDo: block1! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
daysInMonth: monthOrdinal
	^self calendar daysInMonth: monthOrdinal forYearTypeCode: self yearTypeCode! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
duration
	"Answer a Duration whose value represents the receiver's temporal extent."

	^self resolutionQuantum! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
earliest
	"Compare the first and last element of the receiver (see the class comment,) and answer whichever one temporally precedes the other. If neither one precedes the other, answer either the receiver's first or last element."

	^self first min: self last! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
earliestAndLatestDo: block2
	"Evaluate <block2> with 'self earliest' as the first argument and with 'self latest' as the second argument."

	| first last |
	first := self first.
	last := self last.
	^last >= first 
		ifTrue: [block2 value: first value: last]
		ifFalse: [block2 value: last value: first]! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating' stamp: ''!
every: period collect: block1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the one whose starting point-in-time is the same as that of the receiver, with each having <period> (a Durational instance) as its temporal extent, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, and ending with the last such Timeperiod whose starting point-in-time is included by the temporal interval represented by the receiver, evaluate <block1> with each such Timeperiod in the sequence so defined as the argument, add the resulting value to a SequenceableCollection, and (when all the Timeperiods have been added to the SequenceableCollection as previously specified) answer the SequenceableCollection."

	"{Timeperiod currentYear every: (CalendarDuration months: 1) collect: [:interval | interval last]}"

	| list |
	list := SequenceFactory new.
	self 
		every: period 
		do: [:timePeriod | list add: (block1 value: timePeriod)].
	^list! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating' stamp: ''!
every: period contains: block1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the one whose starting point-in-time is the same as that of the receiver, with each having <period> (a Durational instance) as its temporal extent, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, and ending with the last such Timeperiod whose starting point-in-time is included by the temporal interval represented by the receiver, evaluate <block1> with each such Timeperiod in the sequence so defined as the argument, and if the result is the value true, then immediately return with the value true as the answered value. Otherwise, if none of the Timeperiods in the sequence (as defined) resulted in the value true when <block1> wa evaluated (as specified,) then answer false."

	"Is the last day of any month in the current year a leap day?
	{Timeperiod currentYear 
		every: (CalendarDuration months: 1) 
		contains: [:interval | interval last calendarDay occursEveryYear not]}"
	"Do any months in the current year have both their first and last days occurring on the weekend?
	{Timeperiod currentYear
		every: (CalendarDuration months: 1) 
		contains: [:interval | interval first isWeekendDay and: [interval last isWeekendDay]]}"

	self 
		every: period
		do: [:timePeriod | (block1 value: timePeriod) ifTrue: [^true]].
	^false! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
every: count daysDo: block1 
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent <count>-day interval whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentMonth every: 7 daysDo: [:interval | Transcript cr; show: interval printString]}"

	self every: (count = 1 ifTrue: [CalendarDayDuration] ifFalse: [self class calendarDurationFactory  days: count]) do: block1! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating' stamp: ''!
every: period detect: block1 ifNone: unsatisfiedAction 
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the one whose starting point-in-time is the same as that of the receiver, with each having <period> (a Durational instance) as its temporal extent, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, and ending with the last such Timeperiod whose starting point-in-time is included by the temporal interval represented by the receiver, evaluate <block1> with each such Timeperiod in the sequence so defined as the argument, and if the result is the value true, then immediately return with that Timeperiod as the answerd value. Otherwise, if none of the Timeperiods in the sequence (as defined) resulted in the value true when <block1> wa evaluated (as specified,) then answer the result of evaluating <unsatisfiedAction>."

	"Find the first month in the current year that has its first day occurring on the weekend (if any):
	{Timeperiod currentYear
		every: (CalendarDuration months: 1) 
		detect: [:interval | interval first isWeekendDay]
		ifNone: ['No such months this year']}"

	self 
		every: period
		do: [:timePeriod | (block1 value: timePeriod) ifTrue: [^timePeriod]].
	^unsatisfiedAction value! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating' stamp: ''!
every: period do: block1 
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the one whose starting point-in-time is the same as that of the receiver, with each having <period> (a Durational instance) as its temporal extent, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, and ending with the last such Timeperiod whose starting point-in-time is included by the temporal interval represented by the receiver, evaluate <block1> with each such Timeperiod in the sequence (as specified) as the argument."

	"{Timeperiod today every: (Duration hours: 7) do: [:interval | Transcript cr; show: interval printString]}"

	| start limit |
	start := self start.
	limit := start + (self duration - period).
	start through: limit every: period do: [:tp | block1 value: (self class timeperiodFactory from: tp duration: period)].! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
every: count hoursDo: block1 
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent <count>-hour interval whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod today every: 8 hoursDo: [:interval | Transcript cr; show: interval printString]}"

	self every: (count = 1 ifTrue: [HourDuration] ifFalse: [self class civilDurationFactory hours: count]) do: block1! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating' stamp: ''!
every: period inject: initialValue into: mapper 
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the one whose starting point-in-time is the same as that of the receiver, with each having <period> (a Durational instance) as its temporal extent, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, and ending with the last such Timeperiod whose starting point-in-time is included by the temporal interval represented by the receiver, evaluate <mapper> with the following arugments (labelled `a` and `b,` with `a` being the first and `b` the second argument): a) the given <initialValue> in the case of the first evaluation, but otherwise the value resulting from the previous evaluation of <mapper>, and b) each successive Timeperiod in the sequence (as specified.) Answer the value resulting from the last evaluation of <mapper>--unless there were no such evaluations, in which case answer <initialValue>. "

	"EXAMPLE: Count the number of weekend days occurring this year:
		{Timeperiod currentYear
			every: (CalendarDuration days: 1)
			inject: 0
			into: [:count :dayInterval | dayInterval start isWeekendDay ifTrue: [count + 1] ifFalse: [count]]}"

	"EXAMPLE: Count the number of US Federal Holidays occurring in the next year (starting with today):
		{(Timeperiod yearStartingAt: YearMonthDay today)
			every: (CalendarDuration days: 1)
			inject: 0
			into: [:count :dayInterval | dayInterval start isUSFederalHoliday ifTrue: [count + 1] ifFalse: [count]]}"

	"EXAMPLE: Count the number of leap years in the next 400 years:
		{(Timeperiod from: YearMonthDay today duration: (CalendarDuration years: 400))
			every: (CalendarDuration years: 1)
			inject: 0
			into: [:count :yearInterval | yearInterval start isLeapYear ifTrue: [count + 1] ifFalse: [count]]}"

	| value |
	value := initialValue.
	self 
		every: period
		do: [:timePeriod | value := mapper value: value value: timePeriod].
	^value! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
every: count minutesDo: block1 
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent <count>-minute interval whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod today every: 144 minutesDo: [:interval | Transcript cr; show: interval printString]}"

	self every: (count = 1 ifTrue: [MinuteDuration] ifFalse: [self class civilDurationFactory minutes: count]) do: block1! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
every: count monthsDo: block1 
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent <count>-month interval whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentYear every: 4 monthsDo: [:interval | Transcript cr; show: interval printString]}"

	self every: (count = 1 ifTrue: [MonthDuration] ifFalse: [self class calendarDurationFactory  months: count]) do: block1! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
every: count quartersDo: block1 
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent <count>-quarter (3 month) interval whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentYear every: 2 quartersDo: [:interval | Transcript cr; show: interval printString]}"

	self every: count * 3 monthsDo: block1! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
every: count secondsDo: block1 
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent <count>-second interval whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod today every: 864 secondsDo: [:interval | Transcript cr; show: interval printString]}"

	self every: (count = 1 ifTrue: [SecondDuration] ifFalse: [self class durationFactory  seconds: count]) do: block1! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating' stamp: ''!
every: period select: block1 
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the one whose starting point-in-time is the same as that of the receiver, with each having <period> (a Durational instance) as its temporal extent, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, and ending with the last such Timeperiod whose starting point-in-time is included by the temporal interval represented by the receiver, evaluate <block1> with each such Timeperiod in the sequence so defined as the argument, and if the result is the value true, then add the that Timeperiod to a SequenceableCollection, and (when all the Timeperiods have been evaluated by <block1> as previously specified) answer the SequenceableCollection."

	"{Timeperiod currentYear every: (CalendarDuration months: 1) select: [:interval | interval start isWeekendDay]}"
	"Compute all the years from 1950 to 2049 where both the first and the last days of the year are weekend days:
	{(Timeperiod 
		from: (YearMonthDay year: 1950 day: 1)
		duration: (CalendarDuration years: 100))
			every: (CalendarDuration years: 1) 
			select: [:interval | interval first isWeekendDay and: [interval last isWeekendDay]]}"

	| list |
	list := SequenceFactory new.
	self 
		every: period
		do: [:timePeriod | (block1 value: timePeriod) ifTrue: [list add: timePeriod]].
	^list! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating' stamp: ''!
every: period select: selector thenCollect: mapper 
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the one whose starting point-in-time is the same as that of the receiver, with each having <period> (a Durational instance) as its temporal extent, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, and ending with the last such Timeperiod whose starting point-in-time is included by the temporal interval represented by the receiver, evaluate <selector> with each such Timeperiod in the sequence so defined as the argument, and if the result is the value true, then add the result of evaluating <mapper> with that Timeperiod as the argument to a SequenceableCollection, and (when all the Timeperiods have been evaluated by <selector> as previously specified) answer the SequenceableCollection."

	"{Timeperiod currentYear every: (CalendarDuration months: 1) select: [:interval | interval start isWeekendDay] thenCollect: [:interval | interval start monthName]}"
	"Compute all the years from 1950 to 2049 where both the first and the last days of the year are weekend days:
	{(Timeperiod 
		from: (YearMonthDay year: 1950 day: 1)
		duration: (CalendarDuration years: 100))
			every: (CalendarDuration years: 1) 
			select: [:interval | interval first isWeekendDay and: [interval last isWeekendDay]]
			thenCollect: [:interval | interval start year]}"

	| list |
	list := SequenceFactory new.
	self 
		every: period
		do: [:timePeriod | (selector value: timePeriod) ifTrue: [list add: (mapper value: timePeriod)]].
	^list! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
every: count weeksDo: block1 
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent <count>-week interval whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentYear every: 4 weeksDo: [:interval | Transcript cr; show: interval printString]}"

	self every: (count = 1 ifTrue: [WeekDuration] ifFalse: [self class calendarDurationFactory  weeks: count]) do: block1! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
every: count yearsDo: block1 
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent <count>-year interval whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{(Timeperiod 
		from: (YearMonthDay year: 2001 month: 1 day: 20) 
		duration: (CalendarDuration years: 64)) every: 4 yearsDo: [:interval | Transcript cr; show: interval printString]}"

	self every: (count = 1 ifTrue: [YearDuration] ifFalse: [self class calendarDurationFactory  years: count]) do: block1! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
first
	"Answer the first element of the receiver, which is defined to be its starting point-in-time."

	^self start! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
granularity
	"Answer the receiver's granularity, which is defined to be the quantum of resolution of its starting point-in-time (the quantum of resolution of any Chronos point-in-time value is accessible by sending it the message #resolutionQuantum.)  The quantum of resolution of a date value is one calendar day.  The quantum of resolution of a DateAndTime value is the same as that of a Duration value--currently implemented to be one nanosecond. The granularity of Timeperiod contributes to the definition of its closed extent (see the comment of the #closedExtent method, and also the class comment.)"

	^self start resolutionQuantum! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
hash
	^self subclassResponsibility! !

!TemporalInterval methodsFor: 'accessing-subintervals' stamp: ''!
hourPeriods
	"Answer a SequenceableCollection containing a Timeperiod representing each of the hours contained by the receiver."

	"The following examples illustrate both the results of sending the #hours message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 timeZone: 'America/Vancouver')
		duration: (ScientificDuration hours: 4)) hourPeriods}"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 timeZone: 'America/Vancouver')
		duration: (ScientificDuration hours: 2)) hourPeriods}"

	| sequence | 
	sequence := SequenceFactory new.
	self hoursDo: [:each | sequence add: each].
	^sequence! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
hoursDo: block1
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent 1-hour interval (with a positive temporal exent) whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod today hoursDo: [:interval | Transcript cr; show: interval printString]}"

	self every: 1 hoursDo: block1! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
hoursSince: aTemporalCoordinate
	^(self - aTemporalCoordinate) asHours! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
hoursUntil: aTemporalCoordinate
	^(aTemporalCoordinate - self) asHours! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
includes: aTemporalInterval 
	"Answer whether the temporal interval represented by the receiver intersects with the point-in-time represented by <aTemporalInterval>."

	"{Timeperiod currentMonth includes: YearMonthDay atLastDayOfMonth + (HourDuration * 12)}"

	^self intersects: aTemporalInterval! !

!TemporalInterval methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	^self subclassResponsibility! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
intersects: aTemporalInterval
	"Answer whether the temporal interval represented by the receiver has any overlap with the temporal interval represented by <aTemporalInterval>. If so, then the intersection of the two temporal intervals will a non-empty temporal interval."

	"{Timeperiod currentMonth intersects: (Timeperiod monthStartingAt: YearMonthDay today)}"
	"{Timeperiod currentMonth intersects: (Timeperiod monthStartingAt: (YearMonthDay today addingMonths: 1))}"
	"{Timeperiod currentMonth intersects: (Timeperiod from: YearMonthDay today duration: (CivilDuration months: -1))}"
	"{Timeperiod currentMonth intersects: (Timeperiod from: (YearMonthDay today subtractingMonths: 1) duration: (CivilDuration months: -1))}"
	"{(Timeperiod from: YearMonthDay today duration: (CivilDuration months: -1)) intersects: Timeperiod currentMonth}"
	"{(Timeperiod from: (YearMonthDay today subtractingMonths: 1) duration: (CivilDuration months: -1)) intersects: Timeperiod currentMonth}"
	"{Timeperiod currentMonth intersects: (Timeperiod monthStartingAt: (YearMonthDay today subtractingMonths: 1))}"
	"{Timeperiod currentMonth intersects: YearMonthDay atLastDayOfMonth @ (TimeOfDay hour: 12 minute: 0 second: 0)}"

	| thisStart thisLimit thatStart thatLimit |
	(self duration isZero or: [aTemporalInterval duration isZero]) ifTrue: [^false].
	
	thisStart := self start.
	thisLimit := self limit.
	thatStart := aTemporalInterval start.
	thatLimit := aTemporalInterval limit.
	^thisLimit >= thisStart
		ifTrue:  
			[thatLimit > thatStart
				ifTrue: [(thatStart >= thisLimit or: [thatLimit <= thisStart]) not]
				ifFalse: [(thatLimit >= thisLimit or: [thatStart < thisStart]) not]]
		ifFalse:
			[thatLimit >= thatStart
				ifTrue: [(thatLimit <= thisLimit or: [thatStart > thisStart]) not]
				ifFalse: [(thatStart <= thisLimit or: [thatLimit >= thisStart]) not]]


	"thisStart := self start.
	thisLimit := self last.
	thisLimit > thisStart
		ifTrue:
			[thisEarliest := thisStart.
			thisLatest := thisLimit]
		ifFalse:
			[thisEarliest := thisLimit.
			thisLatest := thisStart].
	thatStart := aTemporalInterval start.
	thatLimit := aTemporalInterval last.
	thatLimit > thatStart
		ifTrue:
			[thatEarliest := thatStart.
			thatLatest := thatLimit]
		ifFalse:
			[thatEarliest := thatLimit.
			thatLatest := thatStart].
	^(thatEarliest >= thisLatest or: [thatLatest < thisEarliest]) not"! !

!TemporalInterval methodsFor: 'initialize-release' stamp: ''!
invalidateCalendar
	"Be default, do nothing."! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isAdjacentTo: aTimeperiod 
	"Answer whether the temporal interval represented by the receiver is adjacent to the temporal interval represented by <aTimeperiod>. To be adjacent, one Timeperiod's starting point-in-time must equal the other Timeperiod's limit value (see the class comment for definitions of these terms.)"

	| thisStart thisNextStart thatStart thatNextStart |
	thisStart := self start.
	thisNextStart := self limit.
	thatStart := aTimeperiod start.
	thatNextStart := aTimeperiod limit.
	^thisNextStart >= thisStart 
		ifTrue: 
			[thatNextStart >= thatStart 
				ifTrue: [thisNextStart = thatStart or: [thisStart = thatNextStart]]
				ifFalse: [thisNextStart  = (thatStart + thisNextStart resolutionQuantum) or: [thisStart = (thatNextStart + thisStart resolutionQuantum)]]]
		ifFalse: 
			[thatNextStart >= thatStart 
				ifTrue: [(thisNextStart + thatStart resolutionQuantum) = thatStart or: [(thisStart + thatNextStart resolutionQuantum) = thatNextStart]]
				ifFalse: [thisNextStart = thatStart or: [thisStart = thatNextStart]]]! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isGregorian
	^self calendar isGregorian! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isHourDuration
	"Answer whether the receiver's temporal extent is one hour."

	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isInfinite
	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isInfiniteFuture
	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isInfinitePast
	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isJulian
	^self calendar isJulian! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isMinuteDuration
	"Answer whether the receiver's temporal extent is one minute."

	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isMonthDuration
	"Answer whether the receiver's temporal extent is one month."

	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isMonthsPerYearInvariant
	^self calendar isMonthsPerYearInvariant! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isNanosecondDuration
	"Answer whether the receiver's temporal extent is one nanosecond."

	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isSecondDuration
	"Answer whether the receiver's temporal extent is one second."

	^false! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
isYearDuration
	"Answer whether the receiver's temporal extent is one year."

	^false! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
last
	"Answer the last element of the receiver, which is defined to be the point-in-time computed by adding the receiver's closed extent to its starting point-in-time ({self start + self closedExtent.} Also see the class comment."


	"{(Timeperiod 
		startingAt: (YearMonthDay year: 1901 day: 1)
		duration: (CalendarDuration years: 100)) last}"

	^self start + self closedExtent! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
latest
	"Compare the first and last element of the receiver (see the class comment,) and answer whichever one temporally follows the other. If neither one temporally follows the other, answer either the receiver's first or last element."

	^self first max: self last! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
limit
	"Answer the end-point or `limit value` of the receiver, which is defined to be the point-in-time computed by adding the temporal extent (duration) of a Timeperiod to its starting point. The end-point/limit is not included in the Timeperiod's temporal interval (although the points-in-time that asymptotically approach the limit from its starting point-in-time are all included in a Timeperiod's temporal interval.)"

	^self start + self duration! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
max: aMagnitude 
	"Answer the receiver or the argument, whichever has the greater magnitude."

	self > aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
microsecondsSince: aTemporal
	^(self - aTemporal) asMicroseconds! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
microsecondsUntil: aTemporal
	^(aTemporal - self) asMicroseconds! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the receiver's calendrical system starts each day at local midnight."

	^self calendar midnightIsStartOfDay! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
millisecondsSince: aTemporal
	^(self - aTemporal) asMilliseconds! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
millisecondsUntil: aTemporal
	^(aTemporal - self) asMilliseconds! !

!TemporalInterval methodsFor: 'comparing' stamp: ''!
min: aMagnitude 
	"Answer the receiver or the argument, whichever has the lesser magnitude."

	self < aMagnitude
		ifTrue: [^self]
		ifFalse: [^aMagnitude]! !

!TemporalInterval methodsFor: 'accessing-subintervals' stamp: ''!
minutePeriods
	"Answer a SequenceableCollection containing a Timeperiod representing each of the minutes contained by the receiver."

	"The following examples illustrate both the results of sending the #minutes message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 hour: 1 minute: 50 second: 0 timeZone: 'America/Vancouver')
		duration: (ScientificDuration minutes: 20)) minutePeriods}"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 55 second: 0  timeZone: 'America/Vancouver')
		duration: (ScientificDuration minutes: 10)) minutePeriods}"

	| sequence | 
	sequence := SequenceFactory new.
	self minutesDo: [:each | sequence add: each].
	^sequence! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
minutesDo: block1
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent 1-minute interval (with a positive temporal exent) whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentHour minutesDo: [:interval | Transcript cr; show: interval printString]}"

	self every: 1 minutesDo: block1! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
minutesSince: aTemporalCoordinate
	^(self - aTemporalCoordinate) asMinutes! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
minutesUntil: aTemporalCoordinate
	^(aTemporalCoordinate - self) asMinutes! !

!TemporalInterval methodsFor: 'accessing-subintervals' stamp: ''!
monthPeriods
	"Answer a SequenceableCollection containing a Timeperiod representing each of the months contained by the receiver."

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration years: 1)) monthPeriods}"

	| sequence | 
	sequence := SequenceFactory new.
	self monthsDo: [:each | sequence add: each].
	^sequence! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
monthsDo: block1
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent 1-month interval (with a positive temporal exent) whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentYear monthsDo: [:interval | Transcript cr; show: interval printString]}"

	self every: 1 monthsDo: block1! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
nanoosecondsUntil: aTemporal
	^(aTemporal - self) asNanoseconds! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
nanosecondsSince: aTemporal
	^(self - aTemporal) asNanoseconds! !

!TemporalInterval methodsFor: 'arithmetic' stamp: ''!
nanosecondsUntil: aTemporal
	^(aTemporal - self) asNanoseconds! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
next
	"Answer a Timeperiod whose starting point-in-time is the receiver's limit value (end-point,) and whose temporal extent (duration) is the same as the receiver's.  See the class comment for the definition of these terms."

	^self subclassResponsibility! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
next: count
	"Answer a SequenceableCollection that contains a sequence of <count> adjacent Timeperiods, computed as follows: 

		The first Timeperiod in the sequence is computed by sending the message #next to the receiver, which results in a Timeperiod whose starting point-in-time is the receiver's limit value (end-point,) and whose temporal extent (duration) is the same as the receiver's.  Each successive Timeperiod in the sequence is computed by sending the message #next to the result of the previous send (of the message #next.) Consequently, each Timeperiod in the sequence has the same temporal extent (duration) as the receiver, and each one's starting point-in-time is the same as the limit value of its predecessor in the sequence.

	See the class comment for the definitions of the terminology used."

	"{Timeperiod currentHour next: 10}"
	"{Timeperiod today next: 10}"
	"{Timeperiod currentWeek next: 10}"
	"{Timeperiod currentMonth next: 10}"
	"{Timeperiod currentYear next: 10}"

	| list t |
	count <= 0 ifTrue: [^#()].
	list := SequenceFactory new: count.
	t := self next.
	1 to: count - 1 do: [:i |
		list add: t.
		t := t next].
	list add: t.
	^list! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
next: count collect: mapper
	"With a sequence of Timeperiods computed as defined by the method Timeperiond>>next:, evaluate <mapper> with each such Timeperiod as the argument, add the result to a SequenceableCollection, and answer said SequenceableCollection."

	"{Timeperiod currentHour  next: 10 collect: [:aTimeperiod | aTimeperiod last]}"
	"{Timeperiod today next: 10 collect: [:aTimeperiod | aTimeperiod asCalendricalCoordinate]}"
	"{Timeperiod currentWeek next: 10 collect: [:aTimeperiod | aTimeperiod last]}"
	"{Timeperiod currentMonth next: 10 collect: [:aTimeperiod | aTimeperiod last]}"
	"{Timeperiod currentYear next: 10 collect: [:aTimeperiod | aTimeperiod last]}"

	| list t |
	count <= 0 ifTrue: [^#()].
	list := SequenceFactory new: count.
	t := self next.
	1 to: count - 1 do: [:i |
		list add: (mapper value: t).
		t := t next].
	list add: (mapper value: t).
	^list! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
nextDayOfWeek: dayOfWeek 
	"YearMonthDay today nextDayOfWeek: Saturday"
	"YearMonthDay today nextDayOfWeek: #Monday"
	"YearMonthDay yesterday nextDayOfWeek: Wednesday"
	"YearMonthDay yesterday nextDayOfWeek: #Wednesday"
	"YearMonthDay tomorrow nextDayOfWeek: Sunday"
	"YearMonthDay tomorrow nextDayOfWeek: #Sunday"

	| ansiDayOfWeekOrdinal |
	ansiDayOfWeekOrdinal := 
		dayOfWeek isInteger 
			ifTrue: [dayOfWeek]
			ifFalse: [ANSIDayOfWeekKeys indexOf: dayOfWeek].
	^self addingDays: (ansiDayOfWeekOrdinal - self ansiDayOfWeekOrdinal \\ DaysPerWeek)! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
nextDo: block1 until: predicate1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the receiver, all of which have the same temporal extent as the receiver, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, do the following:

		1. Make the element of the sequence (as defined above) that is the immediate successor to the receiver the subject Timeperiod.
		2. Evaluate <predicate1> with the subject Timeperiod as the argument.  If the result is the value false, proceed to the next step, otherwise stop and return control to the sender.
		3. Evaluate <block1> with the subject Timeperiod as the argument.
		4. Make the successor Timeperiod in the sequence (as defined above) the subject Timeperiod, then go to step 2. 

	See the class comment for the definitions of the terminology used."

	"Compute a schedule of payment due-dates (each on the last day of the month) until the principal amount of a loan is paid off (assuming no interest is charged):
	{| dueDates principal payment |
	dueDates := OrderedCollection new.
	principal := 30000.
	payment := 1000.
	Timeperiod currentMonth 
		nextDo: [:aTimeperiod | dueDates add: aTimeperiod last. principal := principal - payment] 
		until:[:aTimeperiod | principal <= 0].
	dueDates}"

	| t |
	t := self next.
	[predicate1 value: t]
		whileFalse: 
			[block1 value: t.
			t := t next].! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
nextDo: block1 while: predicate1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the receiver, all of which have the same temporal extent as the receiver, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, do the following:

		1. Make the element of the sequence (as defined above) that is the immediate successor to the receiver the subject Timeperiod.
		2. Evaluate <predicate1> with the subject Timeperiod as the argument.  If the result is the value true, proceed to the next step, otherwise stop and return control to the sender.
		3. Evaluate <block1> with the subject Timeperiod as the argument.
		4. Make the next Timeperiod in the sequence (as defined above) the subject Timeperiod, then go to step 2. 

	See the class comment for the definitions of the terminology used."

	"Compute a schedule of payment due-dates (each on the last day of the month) until the principal amount of a loan is paid off (assuming no interest is charged):
	{| dueDates principal payment |
	dueDates := OrderedCollection new.
	principal := 30000.
	payment := 1000.
	Timeperiod currentMonth 
		nextDo: [:aTimeperiod | dueDates add: aTimeperiod last. principal := principal - payment] 
		while:[:aTimeperiod | principal > 0].
	dueDates}"

	| t |
	t := self next.
	[predicate1 value: t]
		whileTrue: 
			[block1 value: t.
			t := t next].! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
nextMonth
	^self addingMonths: 1! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
nextUntil: predicate1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the receiver, all of which have the same temporal extent as the receiver, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, do the following:

		1. Create an initially-empty SequenceableCollection.
		2. Make the element of the sequence (as defined above) that is the immediate successor to the receiver the subject Timeperiod.
		3. Evaluate <predicate1> with the subject Timeperiod as the argument.  If the result is the value false, proceed to the next step, otherwise stop and return the SequenceableCollection created in step 1.
		4. Add the subject Timeperiod as the last element of the SequenceableCollection created in step 1.
		5. Make the successor Timeperiod in the sequence (as defined above) the subject Timeperiod, then go to step 3. 

	See the class comment for the definitions of the terminology used."

	"{Timeperiod currentMonth 
		nextUntil:[:aTimeperiod | aTimeperiod last dayOfMonth < 30]}"

	| list |
	list := SequenceFactory new: 15.
	self nextDo: [:t | list add: t] until: predicate1.
	^list! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
nextWeek
	^self addingDays: DaysPerWeek! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
nextWhile: predicate1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the receiver, all of which have the same temporal extent as the receiver, and where the starting point-in-time of each successor Timeperiod in the sequence is the same as the limit value of its predecessor, do the following:

		1. Create an initially-empty SequenceableCollection.
		2. Make the element of the sequence (as defined above) that is the immediate successor to the receiver the subject Timeperiod.
		3. Evaluate <predicate1> with the subject Timeperiod as the argument.  If the result is the value true, proceed to the next step, otherwise stop and return the SequenceableCollection created in step 1.
		4. Add the subject Timeperiod as the last element of the SequenceableCollection created in step 1.
		5. Make the successor Timeperiod in the sequence (as defined above) the subject Timeperiod, then go to step 3. 

	See the class comment for the definitions of the terminology used."

	"{Timeperiod currentMonth 
		nextWhile:[:aTimeperiod | aTimeperiod last dayOfMonth > 29]}"

	| list |
	list := SequenceFactory new: 15.
	self nextDo: [:t | list add: t] while: predicate1.
	^list! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
nextYear
	^self addingYears: 1! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
prev
	"Answer a Timeperiod whose starting point-in-time is computed by subtracting the receiver's temporal extent (duration) from its starting point-in-time, and whose temporal extent (duration) is the same as the receiver's.  See the class comment for the definition of these terms."

	^self subclassResponsibility! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
prev: count
	"Answer a SequenceableCollection that contains a sequence of <count> adjacent Timeperiods, computed as follows: 

		The first Timeperiod in the sequence is computed by sending the message #prev to the receiver, which results in a Timeperiod whose starting point-in-time is computed by subtracting the receiver's temporal extent (duration) from its starting point-in-time, and whose temporal extent (duration) is the same as the receiver's.  Each successive Timeperiod in the sequence is computed by sending the message #prev to the result of the previous send (of the message #prev.) Consequently, each Timeperiod in the sequence has the same temporal extent (duration) as the receiver, and each one's starting point-in-time is the same as the limit value of its successor in the sequence.

	See the class comment for the definitions of the terminology used."

	"{Timeperiod currentHour prev: 10}"
	"{Timeperiod today prev: 10}"
	"{Timeperiod currentWeek prev: 10}"
	"{Timeperiod currentMonth prev: 10}"
	"{Timeperiod currentYear prev: 10}"

	| list t |
	count <= 0 ifTrue: [^#()].
	list := SequenceFactory new: count.
	t := self prev.
	1 to: count - 1 do: [:i |
		list add: t.
		t := t prev].
	list add: t.
	^list! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
prev: count collect: mapper
	"With a sequence of Timeperiods computed as defined by the method Timeperiod>>prev:, evaluate <mapper> with each such Timeperiod as the argument, add the result to a SequenceableCollection, and answer said SequenceableCollection."

	"{Timeperiod currentHour  prev: 10 collect: [:aTimeperiod | aTimeperiod last]}"
	"{Timeperiod today prev: 10 collect: [:aTimeperiod | aTimeperiod asCalendricalCoordinate]}"
	"{Timeperiod currentWeek prev: 10 collect: [:aTimeperiod | aTimeperiod last]}"
	"{Timeperiod currentMonth prev: 10 collect: [:aTimeperiod | aTimeperiod last]}"
	"{Timeperiod currentYear prev: 10 collect: [:aTimeperiod | aTimeperiod last]}"

	| list t |
	count <= 0 ifTrue: [^#()].
	list := SequenceFactory new: count.
	t := self prev.
	1 to: count - 1 do: [:i |
		list add: (mapper value: t).
		t := t prev].
	list add: (mapper value: t).
	^list! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
prevDayOfWeek: dayOfWeek 
	"YearMonthDay today prevDayOfWeek: Saturday"
	"YearMonthDay today prevDayOfWeek: #Monday"
	"YearMonthDay yesterday prevDayOfWeek: Wednesday"
	"YearMonthDay yesterday prevDayOfWeek: #Wednesday"
	"YearMonthDay tomorrow prevDayOfWeek: Sunday"
	"YearMonthDay tomorrow prevDayOfWeek: #Sunday"

	| ansiDayOfWeekOrdinal |
	ansiDayOfWeekOrdinal := 
		dayOfWeek isInteger 
			ifTrue: [dayOfWeek]
			ifFalse: [ANSIDayOfWeekKeys indexOf: dayOfWeek ifAbsent: [self signalError: 'Invalid day-of-week key: ', dayOfWeek printString]].
	^self subtractingDays: (self ansiDayOfWeekOrdinal - ansiDayOfWeekOrdinal  \\ DaysPerWeek)! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
prevDo: block1 until: predicate1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the receiver, all of which have the same temporal extent as the receiver, and where the limit value of each successor Timeperiod in the sequence is the same as the starting point-in-time of its predecessor, do the following:

		1. Make the element of the sequence (as defined above) that is the immediate successor to the receiver the subject Timeperiod.
		2. Evaluate <predicate1> with the subject Timeperiod as the argument.  If the result is the value false, proceed to the next step, otherwise stop and return control to the sender.
		3. Evaluate <block1> with the subject Timeperiod as the argument.
		4. Make the successor Timeperiod in the sequence (as defined above) the subject Timeperiod, then go to step 2. 

	See the class comment for the definitions of the terminology used."

	"Compute a schedule of payment due-dates (each on the last day of the month) until the principal amount of a loan is paid off (assuming no interest is charged):
	{| dueDates principal payment |
	dueDates := OrderedCollection new.
	principal := 30000.
	payment := 1000.
	Timeperiod currentMonth 
		prevDo: [:aTimeperiod | dueDates add: aTimeperiod last. principal := principal - payment] 
		until:[:aTimeperiod | principal <= 0].
	dueDates}"

	| t |
	t := self prev.
	[predicate1 value: t]
		whileFalse: 
			[block1 value: t.
			t := t prev].! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
prevDo: block1 while: predicate1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the receiver, all of which have the same temporal extent as the receiver, and where the limit value of each successor Timeperiod in the sequence is the same as the starting point-in-time of its predecessor, do the following:

		1. Make the element of the sequence (as defined above) that is the immediate successor to the receiver the subject Timeperiod.
		2. Evaluate <predicate1> with the subject Timeperiod as the argument.  If the result is the value true, proceed to the next step, otherwise stop and return control to the sender.
		3. Evaluate <block1> with the subject Timeperiod as the argument.
		4. Make the successor Timeperiod in the sequence (as defined above) the subject Timeperiod, then go to step 2. 

	See the class comment for the definitions of the terminology used."

	"Compute a schedule of payment due-dates (each on the last day of the month) until the principal amount of a loan is paid off (assuming no interest is charged):
	{| dueDates principal payment |
	dueDates := OrderedCollection new.
	principal := 30000.
	payment := 1000.
	Timeperiod currentMonth 
		prevDo: [:aTimeperiod | dueDates add: aTimeperiod last. principal := principal - payment] 
		while:[:aTimeperiod | principal > 0].
	dueDates}"

	| t |
	t := self prev.
	[predicate1 value: t]
		whileTrue: 
			[block1 value: t.
			t := t prev].! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
prevMonth
	^self subtractingMonths: 1! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
prevUntil: predicate1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the receiver, all of which have the same temporal extent as the receiver, and where the limit value of each successor Timeperiod in the sequence is the same as the starting point-in-time of its predecessor, do the following:

		1. Create an initially-empty SequenceableCollection.
		2. Make the element of the sequence (as defined above) that is the immediate successor to the receiver the subject Timeperiod.
		3. Evaluate <predicate1> with the subject Timeperiod as the argument.  If the result is the value false, proceed to the next step, otherwise stop and return the SequenceableCollection created in step 1.
		4. Add the subject Timeperiod as the last element of the SequenceableCollection created in step 1.
		5. Make the successor Timeperiod in the sequence (as defined above) the subject Timeperiod, then go to step 3. 

	See the class comment for the definitions of the terminology used."

	"{Timeperiod currentMonth 
		prevUntil:[:aTimeperiod | aTimeperiod last dayOfMonth < 30]}"

	| list |
	list := SequenceFactory new: 15.
	self prevDo: [:t | list add: t] until: predicate1.
	^list! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
prevWeek
	^self subtractingDays: DaysPerWeek! !

!TemporalInterval methodsFor: 'INTER-period-stream protocol' stamp: ''!
prevWhile: predicate1
	"For each Timeperiod in an adjacent sequence of Timeperiods, starting with the receiver, all of which have the same temporal extent as the receiver, and where the limit value of each successor Timeperiod in the sequence is the same as the starting point-in-time of its predecessor, do the following:

		1. Create an initially-empty SequenceableCollection.
		2. Make the element of the sequence (as defined above) that is the immediate successor to the receiver the subject Timeperiod.
		3. Evaluate <predicate1> with the subject Timeperiod as the argument.  If the result is the value true, proceed to the next step, otherwise stop and return the SequenceableCollection created in step 1.
		4. Add the subject Timeperiod as the last element of the SequenceableCollection created in step 1.
		5. Make the successor Timeperiod in the sequence (as defined above) the subject Timeperiod, then go to step 3. 

	See the class comment for the definitions of the terminology used."

	"{Timeperiod currentMonth 
		prevWhile:[:aTimeperiod | aTimeperiod last dayOfMonth > 29]}"

	| list |
	list := SequenceFactory new: 15.
	self prevDo: [:t | list add: t] while: predicate1.
	^list! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
prevYear
	^self subtractingYears: 1! !

!TemporalInterval methodsFor: 'accessing-subintervals' stamp: ''!
quarterPeriods
	"Answer a SequenceableCollection containing a Timeperiod representing each of the quartes contained by the receiver."

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration years: 1)) quarterPeriods}"

	| sequence | 
	sequence := SequenceFactory new.
	self quartersDo: [:each | sequence add: each].
	^sequence! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
quartersDo: block1
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent 1-quarter (3 month) interval (with a positive temporal exent) whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentYear quartersDo: [:interval | Transcript cr; show: interval printString]}"

	self every: 1 quartersDo: block1! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^self subclassResponsibility! !

!TemporalInterval methodsFor: 'accessing-subintervals' stamp: ''!
secondPeriods
	"Answer a SequenceableCollection containing a Timeperiod representing each of the seconds contained by the receiver."

	"The following examples illustrate both the results of sending the #seconds message, and also the effects of the transition to and from Daylight Saving Time/Summer Time:"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2004 month: 10 day: 31 hour: 1 minute: 59 second: 55 timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) secondPeriods}"
	"{(Timeperiod 
		startingAt: (Timepoint year: 2005 month: 4 day: 3 hour: 1 minute: 59 second: 55  timeZone: 'America/Vancouver')
		duration: (ScientificDuration seconds: 10)) secondPeriods}"

	| sequence | 
	sequence := SequenceFactory new.
	self secondsDo: [:each | sequence add: each].
	^sequence! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
secondsDo: block1
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent 1-second interval (with a positive temporal exent) whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentMinute secondsDo: [:interval | Transcript cr; show: interval printString]}"

	self every: 1 secondsDo: block1! !

!TemporalInterval methodsFor: 'queries' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsInDay
	^SecondsPerDay! !

!TemporalInterval methodsFor: 'accessing' stamp: ''!
start
	"Answer the point-in-time value that is the initial moment of the receiver's temporal interval (which is included in the interval.)"

	^self! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCalendarDuration: aDuration 
	^aDuration 
		subtractingHours: self hour
		minutes: self minute
		seconds: self second
		nanoseconds: self nanosecondsSinceSecond! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromCivilDuration: aDuration
	^aDuration
		subtractingHours: self hour
		minutes: self minute
		seconds: self second
		nanoseconds: self nanosecondsSinceSecond! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromDuration: aDuration
	^self subclassResponsibility! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfiniteDuration: anInfiniteDuration
	^anInfiniteDuration! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromInfiniteTimepoint: anInfiniteTimepoint
	^InfiniteDuration polarity: anInfiniteTimepoint isInfiniteFuture! !

!TemporalInterval methodsFor: 'private-arithmetic' stamp: ''!
subtractedFromTemporalInterval: aTemporalInterval
	^self class durationFactory 
		seconds: (aTemporalInterval basicSecondsSince: self)
		nanoseconds: aTemporalInterval nanosecondsSinceSecond - self nanosecondsSinceSecond! !

!TemporalInterval methodsFor: 'converting' stamp: ''!
through: finalMoment 
	"Answer a Timeperiod whose starting point-in-time is the receiver and whose temporal extent is the duration computed by subtracting the receiver from <finalMoment> (a TemporalCoordinate) and then adding the resolution quantum of <finalMoment>. The result is a Timeperiod representing the closed interval [self, finalMoment]."

	^self class timeperiodFactory  
		from: self start
		through: finalMoment! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: count daysDo: block1 
	"Closed interval"
	"(YearMonthDay daysSinceEpoch: 732000) through: (YearMonthDay daysSinceEpoch: 732030) every: 1 daysDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: 
			(count = 1 
				ifTrue: [CalendarDayDuration]
				ifFalse: [CalendarDuration days: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: durationStep do: block1 
	"Closed interval"
	"{Transcript cr. YearMonthDay today yesterday through: YearMonthDay today tomorrow every: (CalendarDuration days: 1) do: [:eachDay | Transcript cr; show: eachDay printString]}"
	"{Transcript cr. YearMonthDay today tomorrow through: YearMonthDay today yesterday every: (CalendarDuration days: -1) do: [:eachDay | Transcript cr; show: eachDay printString]}"
	"{Transcript cr. YearMonthDay today through: YearMonthDay today every: (CalendarDuration days: 1) do: [:eachDay | Transcript cr; show: eachDay printString]}"
	"{Transcript cr. YearMonthDay today through: YearMonthDay today every: (CalendarDuration days: -1) do: [:eachDay | Transcript cr; show: eachDay printString]}"

	| induction |
	durationStep isZero ifTrue: [^self].
	induction := self + durationStep.
	end >= self 
		ifTrue: 
			[induction < self ifTrue: [^induction].
			block1 value: self.
			[induction <= end] whileTrue: 
					[block1 value: induction.
					induction := induction + durationStep]]
		ifFalse: 
			[induction > self ifTrue: [^induction].
			block1 value: self.
			[induction >= end] whileTrue: 
					[block1 value: induction.
					induction := induction + durationStep]].
	^induction! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: count hoursDo: block1 
	"Closed interval"
	"(DateAndTime daysSinceEpoch: 733000) through: (DateAndTime daysSinceEpoch: 733000.9) every: 1 hoursDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: 
			(count = 1 
				ifTrue: [HourDuration]
				ifFalse: [self class civilDurationFactory  hours: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: count minutesDo: block1 
	"Closed interval"
	"(DateAndTime daysSinceEpoch: 733000) through: (DateAndTime daysSinceEpoch: 733000.03d) every: 1 minutesDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: 
			(count = 1 
				ifTrue: [MinuteDuration]
				ifFalse: [self class civilDurationFactory  minutes: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: count monthsDo: block1 
	"Closed interval"
	"(YearMonthDay daysSinceEpoch: 732000) through: (YearMonthDay daysSinceEpoch: 732300) every: 1 monthsDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: 
			(count = 1 
				ifTrue: [MonthDuration]
				ifFalse: [self class calendarDurationFactory  months: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: count quartersDo: block1 
	"Closed interval"
	"(YearMonthDay daysSinceEpoch: 732000) through: (YearMonthDay daysSinceEpoch: 733000) every: 1 quartersDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: (self class calendarDurationFactory  quarters: count)
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: count secondsDo: block1 
	"Closed interval"
	"(DateAndTime daysSinceEpoch: 733000) through: (DateAndTime daysSinceEpoch: 733000.001d) every: 1 secondsDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: 
			(count = 1 
				ifTrue: [SecondDuration]
				ifFalse: [self class durationFactory  seconds: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: count weeksDo: block1 
	"Closed interval"
	"(YearMonthDay daysSinceEpoch: 732000) through: (YearMonthDay daysSinceEpoch: 732030) every: 1 weeksDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: 
			(count = 1 
				ifTrue: [WeekDuration]
				ifFalse: [self class calendarDurationFactory  weeks: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
through: end every: count yearsDo: block1 
	"Closed interval"
	"(YearMonthDay daysSinceEpoch: 730000) through: (YearMonthDay daysSinceEpoch: 735000) every: 1 yearsDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: 
			(count = 1 
				ifTrue: [YearDuration]
				ifFalse: [self class calendarDurationFactory  years: count])
		do: block1! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
timeOfDayClockStartsAtMidnight
	"Answer true if the zero-point of the time-of-day clock coincides with midnight"

	^self calendar timeOfDayClockStartsAtMidnight! !

!TemporalInterval methodsFor: 'testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the receiver's calendrical system coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^self calendar timeOfDayClockStartsAtStartOfDay! !

!TemporalInterval methodsFor: 'converting' stamp: ''!
to: limitValue 
	"Answer a Timeperiod whose starting point-in-time is the receiver and whose temporal extent is the duration computed by subtracting the receiver from <limitValue> (a TemporalCoordinate.) The result is a Timeperiod representing the left closed, right open interval [self, limitValue)."

	^self class timeperiodFactory  
		from: self start
		to: limitValue! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: count daysDo: block1 
	"Left closed, right open interval"
	"(YearMonthDay daysSinceEpoch: 732000) to: (YearMonthDay daysSinceEpoch: 732030) every: 1 daysDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		to: end
		every: 
			(count = 1 
				ifTrue: [CalendarDayDuration]
				ifFalse: [CalendarDuration days: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: durationStep do: block1 
	"Left closed, right open interval"
	"{Transcript cr. YearMonthDay today yesterday to: YearMonthDay today tomorrow every: (CalendarDuration days: 1) do: [:eachDay | Transcript cr; show: eachDay printString]}"
	"{Transcript cr. YearMonthDay today  tomorrow to: YearMonthDay today yesterday every: (CalendarDuration days: -1) do: [:eachDay | Transcript cr; show: eachDay printString]}"
	"{Transcript cr. YearMonthDay today  to: YearMonthDay today every: (CalendarDuration days: 1) do: [:eachDay | Transcript cr; show: eachDay printString]}"
	"{Transcript cr. YearMonthDay today  to: YearMonthDay today tomorrow every: (CalendarDuration days: 1) do: [:eachDay | Transcript cr; show: eachDay printString]}"
	"{Transcript cr. YearMonthDay today tomorrow  to: YearMonthDay today every: (CalendarDuration days: -1) do: [:eachDay | Transcript cr; show: eachDay printString]}"
	"{Transcript cr. YearMonthDay today  to: YearMonthDay today every: (CalendarDuration days: 1) do: [:eachDay | Transcript cr; show: eachDay printString]}"

	| induction |
	durationStep isZero ifTrue: [^self].
	end > self 
		ifTrue: 
			[induction := self + durationStep.
			induction < self ifTrue: [^induction].
			block1 value: self.
			[induction < end] whileTrue: 
					[block1 value: induction.
					induction := induction + durationStep]]
		ifFalse: 
			[end < self
				ifTrue: 
					[induction := self + durationStep.
					induction > self ifTrue: [^induction].
					block1 value: self.
					[induction > end] whileTrue: 
							[block1 value: induction.
							induction := induction + durationStep]]
				ifFalse: [induction := self]].
	^induction! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: count hoursDo: block1 
	"Left closed, right open interval"
	"(DateAndTime daysSinceEpoch: 733000) to: (DateAndTime daysSinceEpoch: 733000.9) every: 1 hoursDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		to: end
		every: 
			(count = 1 
				ifTrue: [HourDuration]
				ifFalse: [self class durationFactory  hours: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: count minutesDo: block1 
	"Left closed, right open interval"
	"(DateAndTime daysSinceEpoch: 733000) to: (DateAndTime daysSinceEpoch: 733000.03d) every: 1 minutesDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		to: end
		every: 
			(count = 1 
				ifTrue: [MinuteDuration]
				ifFalse: [self class durationFactory  minutes: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: count monthsDo: block1 
	"Left closed, right open interval"
	"(YearMonthDay daysSinceEpoch: 732000) to: (YearMonthDay daysSinceEpoch: 732300) every: 1 monthsDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		to: end
		every: 
			(count = 1 
				ifTrue: [MonthDuration]
				ifFalse: [self class calendarDurationFactory  months: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: count quartersDo: block1 
	"Left closed, right open interval"
	"(YearMonthDay daysSinceEpoch: 732000) through: (YearMonthDay daysSinceEpoch: 733000) every: 1 quartersDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		through: end
		every: (self class calendarDurationFactory  quarters: count)
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: count secondsDo: block1 
	"Left closed, right open interval"
	"(DateAndTime daysSinceEpoch: 733000) to: (DateAndTime daysSinceEpoch: 733000.001d) every: 1 secondsDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		to: end
		every: 
			(count = 1 
				ifTrue: [SecondDuration]
				ifFalse: [self class durationFactory  seconds: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: count weeksDo: block1 
	"Left closed, right open interval"
	"(YearMonthDay daysSinceEpoch: 732000) to: (YearMonthDay daysSinceEpoch: 732030) every: 1 weeksDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		to: end
		every: 
			(count = 1 
				ifTrue: [WeekDuration]
				ifFalse: [self class calendarDurationFactory  weeks: count])
		do: block1! !

!TemporalInterval methodsFor: 'INTER-period-enumerating' stamp: ''!
to: end every: count yearsDo: block1 
	"Left closed, right open interval"
	"(YearMonthDay daysSinceEpoch: 730000) to: (YearMonthDay daysSinceEpoch: 735000) every: 1 yearsDo: [:date | Transcript cr; show: date printString]"

	count = 0 ifTrue: [^self].
	^self 
		to: end
		every: 
			(count = 1 
				ifTrue: [YearDuration]
				ifFalse: [self class calendarDurationFactory  years: count])
		do: block1! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
tomorrow
	^self addingDays: 1! !

!TemporalInterval methodsFor: 'accessing-subintervals' stamp: ''!
weekPeriods
	"Answer a SequenceableCollection containing a Timeperiod representing each of the 7-day weeks contained by the receiver."

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration months: 1)) weekPeriods}"

	| sequence | 
	sequence := SequenceFactory new.
	self weeksDo: [:each | sequence add: each].
	^sequence! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
weeksDo: block1
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent 1-week (7 civil/calendar days) interval (with a positive temporal exent) whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{Timeperiod currentMonth weeksDo: [:interval | Transcript cr; show: interval printString]}"

	self every: 1 weeksDo: block1! !

!TemporalInterval methodsFor: 'converting' stamp: ''!
withDuration: aDuration 
	"Answer a Timeperiod whose starting point-in-time is the receiver and whose temporal extent is <aDuration> (a Durational instance.)"

	^self class timeperiodFactory  from: self start duration: aDuration! !

!TemporalInterval methodsFor: 'accessing-subintervals' stamp: ''!
yearPeriods
	"Answer a SequenceableCollection containing a Timeperiod representing each of the years contained by the receiver."

	"{(Timeperiod 
		startingAt: YearMonthDay today
		duration: (CalendarDuration years: 4)) yearPeriods}"

	| sequence | 
	sequence := SequenceFactory new.
	self yearsDo: [:each | sequence add: each].
	^sequence! !

!TemporalInterval methodsFor: 'INTRA-period-enumerating-common durations' stamp: ''!
yearsDo: block1
	"Evaluate <block1> with each Timeperiod in sequence that represents an adjacent 1-year interval (with a positive temporal exent) whose starting point-in-time occurs during the temporal interval represented by the receiver. The first interval's starting point-in-time must be the same as that of the receiver, and each subsequent interval's starting point-in-time must be the same moment as the limit (end-point) of its predecessor."

	"{(Timeperiod 
		from: YearMonthDay today
		duration: (CalendarDuration years: 10)) yearsDo: [:interval | Transcript cr; show: interval printString]}"

	self every: 1 yearsDo: block1! !

!TemporalInterval methodsFor: 'queries' stamp: ''!
yesterday
	^self subtractingDays: 1! !

ChronosObject subclass: #ChronosTimezone
	instanceVariableNames: ''
	classVariableNames: 'AlwaysDefault AlwaysSystem BindingRegistry Default Nominal OffsetRegistry System Universal'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!ChronosTimezone commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosTimezone [Aliased by the global Timezone]

	Concept:

		ChronosTimezone is an abstract class; an instance of one of its concrete subclasses represents/implements a particular timezone. A timezone defines the civil/legal time-of-day for a particular locality (some legal jurisdiction, from as small as a city to as large as a nation-state.) Local time-of-day in a timezone is defined as some number of seconds of offset (positive or negative) from the local time-of-day in the international standard reference timezone.  For a timezone whose offset from the international reference timezone is negative 5 hours, the local time in that timezone would be 6 am when the local time of day in the international reference timezone is 11 am.  For more information on the origin and conceptual evolution of timezones, see the HISTORY section below.

		Universal Time (abbreviated UT) has been the official name of the international standard zero-offset reference timezone since 1928.   This reference timezone was originally called Greenwich Mean Time (abbreviated GMT.)  Common usage is to use either GMT or UTC as the name of the international zero-offset reference timezone, in spite of the fact that neither is the formally correct name (the name GMT has been superceded by UT, and UTC is technically the abbreviation of a timescale, not a timezone.)  

		Other than in comments such as this one, Chronos does not use the term "GMT." With but one exception, Chronos always uses either "Universal Time" or "UT" to refer to the international reference zero-offset timezone. Other than the name of the message #asUTC (whose name and semantics are mandated by the ANSI-Smalltalk Standard,) Chronos uses "UTC" solely as the abbreviation of the timescale "Coordinated Universal Time." The UTC timescale defines a second as an SI (metric system) second (which defines the temporal extent of one second in terms of the vibrational frequency of a particular type of atom under specific conditions,) and requires that a leap second occasionally be added to or removed from the number of seconds in a day in order to keep the UTC time-of-day to within 0.9 seconds of the UT1 time-of-day (in UT1, each day is a mean solar day of exactly 86400 seconds.) For more information on this subject, see the section on TIMESCALES presented below.

		Chronos supports both "simple" timezones whose UT-offset is some invariant number of seconds, and also "complex" timezones whose UT-offset varies over time.  Variable-offset timezones may not only use different UT-offsets within a year, but may also use different rules in different years to determine the moments of transition to or from Daylight Saving Time.  See the "INVARIANT-OFFSETS AND VARIABLE-OFFSETS FROM UNIVERSAL TIME" section immediately below for more details.

		Timezones are far from as simple as you probably imagine.  However, those who don't require sub-second time accuracy, and who don't care about points-in-time that occur all that far in the future or the past, may need to know nothing more than a) how to catalog all available pre-defined ChronosTimezones, b) how to instantiate a point-in-time value whose local time will be defined by a particular ChronosTimezone, and c) how to set the default ChronosTimezone to whatever the local timezone happens to be.  That information is provided in the "Usage:" section (far) below.  Everyone else is strongly encouraged to read the entire "Concept:" section of this class comment.

		## INVARIANT-OFFSETS AND VARIABLE-OFFSETS FROM UNIVERSAL TIME

			Chronos supports both "simple" timezones whose offset from UT never varies (from the infinite past into the infinite future) and also "real world" timezones whose offsets from UT may vary over time (diachronic offset rules.)  The simple, invariant-offset timezones are implemented by BasicTimezone.  The "real world," variable-offset timezones are implemented by VariableOffsetTimezone (both of which see.)

			BasicTimezone provides an invariant offset from UT (no DST rules,) an invariant name (optional) and an invariant abbreviation (optional.)  It is provided for two reasons: 1) simplicity/performance, and 2) compatibility with the way the ANSI-Smalltalk Standard defines the timezone behavior of instances of DateAndTime. The ANSI Standard makes the (generally false) assumption that a timezone can be specified as a Duration.  Although using an invariant Duration (offset) to define a timezone can work quite well under certain conditions, it is a very poor model of the way timezones usually work in practice.

			Generally, people don't conceptualize a timezone as a fixed offset from universal time.  They conceptualize a timezone as the local time at a particular location.  When you have an appointment to meet someone for some purpose at 1pm, the meaning of "1pm" is defined by the a) the location of the meeting, and 2) the legal definition of the time of day at that location at that moment in time.  Both the location and the moment in time are required in order to determine the offset from UT that will be in effect at a given location at a given time. For example, consider the following questions: If there is an event scheduled to occur (or that did occur) at "1pm" in Lihue, Hawaii (on the island of Kauai,) what is the offset from UT? What would be the date and time 100 hours later? 

			Even though Daylight Saving Time is not observed in Hawaii, the answer nevertheless depends on the date--and perhaps even on the time-of-day.  Before 1947-06-08T02:00:00 HST, the offset from UT would be -10:30 (hours:mintues,) on or after that moment it would be -10:00.  So an event that occurred at 1947-06-07T13:00:00 HST would correspond to 1947-06-07T23:30:00 Universal Time--and 100 hours later would be 1947-06-11T17:30:00 HST (1947-06-12T03:30:00 UT)--5:30pm local time, 3:30am UT.

			Consider also this: Hawaii could decide to start observing Daylight Saving Time at some point in the future--or the US Congress could decide that for them.  Consequently, it is not at all a guaranteed fact that the local time in Hawaii of some point-in-time in the future will have an offset from UT of -10 hours. So using "-10 hours" as the invariant offset of points-in-time for events in Hawaii will not only be wrong for moments prior to 1947-06-08T02:00:00 HST, it may also be wrong for moments in the future.  

			The preceding examples demonstrate why Chronos supports not only timezones whose offsets from UT may vary "intra-year" (which is typical of the way Daylight Saving Time works,) it also supports timezones whose "standard time" offset, abbreviation or DST transition rules may vary from one year to the next.  By specifying Hawaii's local timezone as "'Pacific/Honolulu'" instead of as "Duration hours: -10", not only will one get the correct UT-offset in effect now, one will also get the correct offsets in effect prior to June 1947, as well as whatever the correct offset may be in the future.

			See VariableOffsetTimezone for more details.

		## HISTORY {information that may be helpful for those who aren't already rather knowledgeable about timezones and how the time-of-day is determined)}

			"Standard Time"

				Before the introduction of timezones, every municipality set its clock by the local position of the sun (usually "mean solar time" in the case of cultures that were using relatively accurate mechanical clocks, or else "apparent solar time" otherwise. Local solar time (whether mean or apparent) served well until the introduction of the train, when it became possible to travel fast enough to require almost constant re-setting of clocks. Timezones were invented to solve this problem by setting all clocks in a region to the same time--which was originally called "standard time" (although modernly, "standard time" means something slightly different.) 

				"Standard time" (in its original meaning) divides the world into a number of "time zones", each one covering, in theory at least, 15 degrees (one hour of solar time.) All clocks within each of these zones are (theoretically) set to the same time as the others, but so as to differ by one hour from those in the neighbouring zones. The local time at the Royal Greenwich Observatory in Greenwich, England was chosen as the international reference timezone at the 1884 International Meridian Conference, leading to the now almost-universal practice of defining local (civil/legal, but perhaps not religious) time-of-day as some number of seconds of offset from that of the Universal Time (UT) timezone. Greenwich, England was chosen because by 1884 two-thirds of all charts and maps already used it as their prime meridian.

				In actual practice, the amount of offset from the international reference timezone that defines local time in a region is a political matter. The offset in actual use is far from being a simple function of the local longitude. And some timezones have (or have had) fractional-hour offsets, instead of the integer-hour ideal.

				The first time zone in the world was established by British railways on December 1, 1847Greenwich Mean Time (GMT) being hand carried on chronometers. About August 23, 1852, time signals were first transmitted by telegraph from the Royal Greenwich Observatory. Even though 98% of Great Britain's public clocks were using GMT by 1855, it was not made Britain's legal time until August 2, 1880.

				On November 2, 1868 New Zealand officially adopted a standard time to be observed nationally, and was perhaps the first country to do so. It was based on the longitude 172 30' East of Greenwich, that is 11 hours 30 minutes ahead of Greenwich Mean Time. This standard was known as New Zealand Mean Time. 

				In the United States and Canada, standard time zones were introduced on November 18, 1883, by American and Canadian railroads. Newspapers referred to that day as "the Day of Two Noons." There was no legislative enactment or ruling: the railroads simply adopted a five zone system and assumed the public would follow. The American Railway Association, an organization of railroad managers, had noticed growing scientific interest in standardizing time. The ARA devised their own system, which had irregular zone boundaries which followed then-existing boundaries of different (railroad) lines, partly in order to head off government action which might have been inconvenient to their operations. Most people simply accepted the new time, but a number of cities and counties refused to accept "railroad time", which, after all, had not been made law. In, for example, the expiration of a contract--what does "midnight" mean? In one Iowa Supreme Court case, the owner of a saloon argued that he operated by local (sun) time, not "railroad time," and so he had not violated laws about closing time. Standard time remained a local matter until 1918, when it was made US Federal law as part of the introduction of daylight saving time (to save fuel for World War 1.)

			"Daylight Saving Time" (also known as "Summer Time")

				Daylight Saving Time is the practice of temporarily adjusting a timezone's offset to a different value--usually by adding 1 hour to the offset, and usually only during local summer (note that summer in the Southern Hemisphere happens during winter in the Northern Hemisphere.) The effect is that local time advances by one hour while Daylight Saving Time is in effect, so that what was local noon (for example) becomes 1 pm. Daylight Saving Time has been used in the United States and in many European countries since World War I. 

				During World War I, in an effort to conserve fuel needed to produce electric power, Germany and Austria initiated Daylight Saving Time as of 11 pm (local standard time) on the 30th of April, 1916, by advancing the hands of the local clocks by one hour. The following October, Daylight Saving Time was terminated, and the hour-hand of the local clocks was set back by one hour. This 1916 action was immediately followed by other countries in Europe, Belgium, Denmark, France, Italy, Luxembourg, Netherlands, Norway, Portugal, Sweden, and Turkey. Tasmania, and Manitoba.and Britian began "saving daylight" 3 weeks later, on 21 May 1916. In 1917, Australia, Newfoundland and Nova Scotia also began the practice. 

				Daylight Saving Time was not formally adopted in the United States until 1918. 'An Act to preserve daylight and provide standard time for the United States' was enacted on 19 March 1918. It both established standard time zones and set summer DST to begin on 31 March 1918. Daylight Saving Time was observed for seven months in 1918 and 1919. After the War ended, the law, however, proved so unpopular (mostly because people rose earlier and went to bed earlier than we do today) that the law was later repealed in 1919 over President Wilson's veto. It became a local option, and was continued in a few states (Massachusetts, Rhode Island) and some cities (New York, Philadelphia, Chicago, and others).

				During World War II, President Roosevelt instituted year-round Daylight Saving Time, called 'War Time' (e.g., "Eastern War Time" or "EWT,' "Pacific War Time" or "PWT.") "War Time" was in effect from 2 February 1942 to 14 August 1945, when its name was changed to "Peace Time" (but the offset wasn't changed back to "standard time" until 30 September 1945.).  

				From 1945 to 1966, there was no federal law about Daylight Saving Time. So states and localities were free to choose whether to observe Daylight Saving Time or not, and could choose when it began and ended. This, however, caused confusion--especially for the broadcasting industry, and for railways, airlines, and bus companies. Because of the different local customs and laws, radio and TV stations and the transportation companies had to publish new schedules every time a state or town began or ended Daylight Saving Time.

				Since the introduction of Daylight Saving Time, the term "standard time" has been redefined; it now refers to the local time defined by a time zone when Daylight Saving Time is not in effect (originally, it meant the canonical time to which all clocks in a time zone were set--a better term for that concept nowadays would be simply 'local time.')

		## TIMESCALES {important technical information for those interested in the precise meaning of certain terms, such as GMT, UT1, UTC, timezone and timescale--others may skip this section}

			To unambigously specify a well-defined moment in time in the terrestrial reference frame (especially with accuracy to the second or better,) a temporal coordinate must not only specify an extent of time since an epoch (the zero-point of the coordinate system used to designate a point-in-time value,) it must also specify both a timescale and a timezone.  

			A timescale specifies the moment that serves as the origin point for the coordinate system used to designate temporal coordinates (the timescale's epoch,)  and also specifies the size of the time units used to count or measure extents of time since (or until) the epoch (zero point) of the timescale.  It also defines the zero-point of the time-of-day clock.

			Timezones specify a number of seconds by which temporal coordinates (point-in-time values) are translated with respect to the epoch of their timescale, and so define translated timescales.  Timezones always maintain gauge-invariance--they only involve addition of a well-defined number of seconds (which may be negative,) never any gauge-changing multiplications or divisions which would change the size (gauge) of any time units.  Conversely, a timescale may define different gauges (time unit sizes) that apply during different intervals within the coordinate system defined by the timescale--in fact, the sizes of a timescale's time units may be defined by complex functions, so that they differ continuously (e.g., apparent solar time.).

			The timescale of a Chronos point-in-time value (a conceputal value) is defined partly by its Calendar (which see,) and partly by a Timescale instance (once that gets implemented, which it currently is not--and until it is, the only supported timescale is UT1.) The Calendar of a Chronos point-in-time value defines the size of its day, month and year time units (a Calendar's day is a mean solar day,) and also defines the epoch of its timescale to the nearest day. The Timescale of a Chronos point-in-time value (an object--once it is implemented, which it currently is not) defines the size of one second, the number of seconds in a day (which may or may not differ from day to day, depending on the Timescale,) and defines the reference coordinate system by means of which the time-of-day of a point-in-time value may be unambigously specified in the terrestrial reference frame.

			Universal Time (UT,) and any other timezone, can be used with any terrestrial timescale that uses Greenwhich Mean Time (directly or indirectly) to establish the zero-point of the time-of-day clock.  Were such not the case, it would be impossible for any country that didn't use the UTC timescale to define its timezones as offsets from Universal Time--and not all countries use the UTC timescale as the basis for their civil time-of-day, even though they all define their timezones as offsets from Universal Time. Universal Time is simply the timezone whose offset from the specific timescale of one's choice (UT0, UT1, UTC, etc) is an invariant 0.0 seconds.

			Unfortunately, the names of specific timezones and/or timescales ("GMT," "UT," "UTC,") tend to be used to refer either to a timezone, or to a timescale, which leads to much confusion and bogosity.  To help clarify matters, and also to establish the technically correct meanings (which are often different than colloquial usage,) the following history and explanation of timescales should prove helpful:

			In 1884, at the International Meridian Conference, GMT was officially adopted as the international reference timezone and timescale. At the time, no conscious distinction was made between a timezone and a timescale--because everyone at the conference was using mean solar time as the timescale of their timezones, viewed a timescale based on apparent solar time as a barbarous anachronism, had never heard of or imagined atomic clocks, and so saw no need to think about timezones and timescales separately.

			In 1928, the International Astronomical Union (IAU) changed the official name of the international zero-offset reference timezone from Greenwich Mean Time (GMT) to Universal Time (UT) for English speakers, Temps Universel (TU) for French speakers, and Welt Zeit (WZ) for German speakers.  However, the habit of using the name of the international reference timescale as a synonym for the international reference timezone (or vice versa) was very strongly entrenched--due to the fact that the initial definition of GMT meant both or either--and so GMT continued to be used as the name for both the timezone and the timescale--a habit that continues to this day. 

			In 1956, the timescales UT0 (mean solar,) UT1 (UT0 corrected for polar motion) and UT2 (UT1 corrected for predictable seasonal variations) were defined by the International Astronomical Union (IAU), with UT1 simply being a new name for the GMT timescale as it was defined in 1956 (GMT had originally used a less-rigourously-defined version of what is now called UT0.) In 1960, the Confrence Gnrale des Poids et Mesures (CGPM,  "General Conference of Weights and Measures") adopted the names and definitions of these timescales as international standards. Here we finally see recognition of the need to think (and speak) about timescales separately from timezones. The fact that atomic clocks had been in operation since 1949 may have had something to do with this.

			Also in 1956, the International Committee for Weights and Measures, under the authority given it by the Tenth General Conference on Weights and Measures in 1954, defined the second in terms of the period of revolution of the Earth around the Sun for a particular epoch, because by then it had become recognized that the Earth's rotation on its own axis was not sufficiently uniform as a standard of time. The Earth's motion was described in Newcomb's Tables of the Sun, which provides a formula for the motion of the Sun at the epoch 1900 based on astronomical observations made during the eighteenth and nineteenth centuries (also known as the "Equation of Time.") The second thus defined is the fraction 1/31,556,925.9747 of the tropical year for 1900 January 0 at 12 hours ephemeris time. This definition was ratified by the Eleventh General Conference on Weights and Measures in 1960. Reference to the year 1900 does not mean that this is the epoch of a mean solar day of 86,400 seconds. Rather, it is the epoch of the tropical year of 31,556,925.9747 seconds of ephemeris time. Ephemeris Time (ET) was defined as the measure of time that brings the observed positions of the celestial bodies into accord with the Newtonian dynamical theory of motion. Consequently, for the first time, the second became (by official definition) an extent of time of invariant size. However, seconds with invariant size and days containing an invariant 86400 seconds are not at all consistent with keeping time according to the sun--because the Earth's rotational speed is not a constant.  But this problem was not addressed in 1956. [Measuring time is so simple!! Why is this lengthy class comment necessary?!!]

			In 1959, the first atomic time scale was constructed by the USNO and was extrapolated back to 1956. It was named A.1. It was set equal to the UT2 point-in-time of the USNO as of 1958-01-01. In 1961 the BIH constructed a time scale named AM using radio broadcasts based on three atomic clocks. This was renamed A3, more clocks were added from 1967 through 1969, new statistical algorithms were employed, and the name became TA. This series of time scales has been extrapolated back into 1955 using broadcast time signals based on the original cesium clock at NPL. In 1971 the BIH atomic time scale became TAI (Temps Atomique International.) By the mid 1970s it was evident that the scale unit of TAI was not equal to the SI second at sea level. On 1977-01-01 the frequency of TAI was reduced by one part in 1012, and the frequency of TAI has been steered since that time. Starting 1977-01-01 the un-steered combination of atomic clocks which had formerly been TAI has been known by the new name EAL. By 1995 it was evident that blackbody radiation was affecting the frequency of cesium clocks, and that the true SI second should be measured at 0 Kelvin. Over the interval from 1995 to 1998 the length of the TAI second was decreased by about 2 parts in 1014 until it corresponded as closely as possible to cesium atoms at absolute zero. [Measuring time is so simple!! Why is this lengthy class comment necessary?!!]

			In 1965, the Bureau International de l'Heure (BIH) developed a UT-like time scale from its atomic time scale, A3, and called it "UTC."  In 1967, at the IAU's 13th General Assembly, the Commissions on Ephemerides and Time Scales approved the name "Coordinated Universal Time" (UTC) for this new timescale.

			In 1967 the Thirteenth General Conference on Weights and Measures defined the second of atomic time in the International System of Units (SI) as the duration of 9,192,631,770 periods of the radiation corresponding to the transition between the two hyperfine levels of the ground state of the caesium-133 atom. The ground state is defined at zero magnetic field. The definition of the second was later refined at the 1997 meeting of the BIPM to append the statement "This definition refers to a caesium atom at rest at a temperature of 0 K." The second thus defined is equivalent to the ephemeris second, although its (now invariant) size became even more precisely and universally defined (measurement of the Earth's motion were no longer necessary.) But the conflict between the number of invariantly-sized seconds in a day and the definition of the day as invariantly 86400 seconds was not addressed in 1967.

			In 1971 the Confrence Gnrale des Poids et Mesures (General Conference of Weights and Measures) officially recognized the Atomic Time Scale and endorsed the BIH (now BIPM) time scale as the International Atomic Time Scale, TAI. Since the first of January 1972, most countries in the world have distributed the Atomic Time Scale. TAI is generated from data from hundreds of atomic clocks kept by laboratories around the world. Timing centers from many countries regularly contribute data to BIPM. The Consultative Committee on Radiocommunications of the International Telecommunications Union developed a scale for broadcast time signals based on TAI.  This new scale was named Coordinated Universal Time (UTC). It was defined by saying that at the beginning of 1 January 1972, UTC would be exactly 10 seconds behind TAI--but the points-in-time at which any of these 10 leap seconds should be inserted have never been specified. 

			In 1975 the Confrence Gnrale des Poids et Mesures endorsed UTC and recommended that civil clock time be based on it. Today, the UTC timescale is the official basis for civil time in most (but not all) nations of the world. 

			In order for UTC to match the Earth's rotation, some compensation for the irregularities in that rotation must be made, because there are not an invariant 86400 SI (atomic clock) seconds in a solar day.  Without corrections, the sun at noon would gradually drift from being overhead.  Prior to 1972, broadcast time services had kept in step with the Earth's rotation by subtly varying the frequency they broadcast.   For UTC, the frequency was to be held constant. Corrections are made only by adding or subtracting a whole number of seconds, to prevent UTC from differing by more than 0.7 (initially,) but now 0.9, seconds from TAI. The Bureau Internationale des Heures announces when a leap second is to be added or subtracted from UTC.  Since the Earth's rotation is slowing, it is usually necessary to add a second. The change is usually made at the last moment of June or December, but may also be made at the end of March or September. Unless the definition of either the SI second or of the UTC timescale is changed, leap seconds will eventually have to be added with ever greater frequency--at the end of any month, then at the end of any day (by about the year 52,000 Gregorian,) and in the far distant future more than one per day.

			As currently specified, the UTC timescale defines the day as having either 86399, 86400 or 864001 SI seconds, and is equivalent to UT1 ("GMT") to within a tolerance of +/- 0.9 SI seconds.  Which days have which number of SI seconds is decided by the International Earth Rotation and Reference Systems Service, who publish advance notice whenever their astronomical observations and calculations show that it is necessary to add or remove a leap second. In a very real sense,  with respect to the number of seconds in a day, this makes the UTC timescale an observational one.  In contrast, UT1 (mean solar time) is observational with respect to the temporal extent of days and seconds, but not with respect to the number of seconds in a day.

	Usage:

		## TIMEZONE KEYS

			In most cases, ChronosTimezones are uniquely identified by a well-known globally-defined key. The key of a ChronosTimezone whose offset is an invariant number of seconds from UT is simply the number of (possibly fractional) seconds in its offset (unless it's the time zone for Universal Time--see below.)   They key of a ChronosTimezone whose offset varies over time is a Symbol.  And the keys of a few other `special` time zones are also Symbols, as will be explained below. As delivered by the author, all persistently-stored, globally-well-known variable-offset time zones (and their keys) are as defined by the Olson Timezone Database (the same one used by UNIX.) The Olson time zone keys usually (but not always) have the form <continent>/<city> or <ocean>/<city>, such as 'Europe/London', 'Asia/Calcutta' or 'Pacific/Auckland'. However, clients of Chronos are allowed to define their own variable-offset time zones having any desired key--which do not have to be globally well known, and do not have to be persistently stored in the Chronos time-zones repository. 
		
			The time zone key #system is used by Chronos whenever it constructs a variable-offset timezone as an analog or emulation of the base system's local timezone. The key #system may not even be unique within an image, let alone globally.  Variable-offset time zones created by Chronos to emulate or model the local time zone of the host system are not persistently stored in Chronos' external time-zones repository.

			The canonical key of the timezone whose proper name is Universal Time is #'Universal Time'.  However, a variety of aliases are supported: #Universal, #UT, #UTC, #GMT, #Z and #Zulu. 

			To retrieve the keys of all the time zones resident in Chronos' repository of pre-defined time zones, inspect the result of evaluating 'ChronosTimezone allRegisteredKeys' (if there are none, then the Chronos time-zones repository is missing.)

			To see the current time in all the time zones resident in Chronos' repository of pre-defined time zones, (showing the key, current offset, and current abbreviation for each time zone,) inspect the result of evaluating 'Timepoint nowInAllTimeZones' (if there are no entries, then the Chronos time-zones repository is missing.)

		## TIMEZONE LOOKUP/RETRIEVAL BY (CANONICAL CHRONOS) KEY

			To retrieve a ChronosTimezone with a given Chronos timezone key, evaluate 'ChronosTimezone at: <key>', where <key> is either the number of seconds of offset from UT (a Number) or is one of the Symbols contained in the Set returned as a result of evaluating 'ChronosTimezone allRegisteredKeys.'  In place of the Symbol, one may instead use the equivalent String value.  

			The class message ChronosTimezone class>>referencedBy: can be used to convert the value passed as its argument into a ChronosTimezone in cases where the value might be a) a String, b) a Symbol, c) a Number, d) a Duration instance or e) a ChronosTimezone instance {"ChronosTimezone referencedBy: 0". "ChronosTimezone referencedBy: 'Europe/London'"}.

			The Universal timezone can be accessed by sending either #universal or #ut as messages to ChronosTimezone {Timezone universal}.

			Examples:

				Timezone universal.								"Timezone for Universal Time. 'ChronosTimezone ut' can also be used."
				Timezone referencedBy: Duration zero.			"Equivalent to 'ChronosTimezone universal'--but not identical"
				Timezone at: -25200.								"-7 hours--never any DST."
				Timezone at: 19800.								"+5.5 hours--never any DST."
				Timezone at: 0.9d.								"+0.9 seconds--never any DST."
				Timezone at: 'America/Vancouver'.				"Pacific Time with DST rules as observed (past, present, future) in Western Canada"
				Timezone at: #'America/Tijuana'.					"Pacific Time with DST rules as observed (past, present, future) in North Western Mexico"
				Timezone at: 'America/Los_Angeles'.				"Pacific Time with DST rules as observed (past, present, future) in the Western US"
				Timezone at: #'America/Phoenix'.					"US Mountain Time in Arizona--No DST since 1969"
				Timezone at: 'America/Denver'.					"US Mountain Time"
				Timezone at: #'America/Chicago'.					"US Central Time"
				Timezone at: 'America/Indiana/Indianapolis'.		"US Eastern Time in most of Indiana--No DST since 1971"
				Timezone at: #'America/New_York'.				"US Eastern Time with DST rules as observed in much of the US East Coast"

		## VARIABLE-OFFSET TIMEZONE LOOKUP/RETRIEVAL BY ABBREVIATION OR OFFSET

			The familiar timezone abbreviations are not unique on a world-wide basis.  However, a ChronosLocale provides a TimeZoneLocalizationPolicy that maps timezone abbreviations and offsets to a Chronos timezone, as is appropriate to a particular locale (e.g., the TimeZoneLocalizationPolicy provided by <ChronosLocale at: 'en_US'> maps the timezone abbreviation 'EST' to 'America/New_York', whereas the TimeZoneLocalizationPolicy provided by <ChronosLocale at: 'en_AU'> maps 'EST' to a timezone in Eastern Australia.) 

			A TimeZoneLocalizationPolicy will generally map a timezone offset or abbreviation to a timezone whose standard time offset from UTC is probably correct, and whose DST offset is probably correct, but whose rules for transitioning to and/or from DST may be wrong (perhaps currently, perhaps in the past, perhaps in the future).  A pertinent example: the DST transition rules for 'America/New_York' and 'America/Detroit' have not always been the same, even though both have the abbreviation "EST" and have the same standard time and DST offsets.  When using a TimeZoneLocalizationPolicy to map an abbreviation or an offset to a well-defined timezone, one can (in fact, must) specify a boolean preference for either a timezone that does, or does not, observe daylight saving time (also known as "summer time" in many parts of the world):

			TimeZoneLocalizationPolicy unitedStates 
				defaultTimeZoneKeyForStandardTimeOffsetSecondsFromUT: (Duration hours: -5) asSeconds
				dstPreferred: false
				ifAbsent: [].

			(Timezone atAbbreviation: #AST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #AST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #EST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #EST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #EST inLocale: (ChronosLocale at: 'en_AU') dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #EST inLocale: (ChronosLocale at: 'en_AU') dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #CST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #MST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #MST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #PST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #PST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #AKST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name 
			(Timezone atAbbreviation: #HAST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #HAST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name

			See ChronosLocale and TimezoneLocalizationPolicy for more information.

		## LOCAL TIME: THE DEFAULT TIMEZONE & THE SYSTEM TIMEZONE

			Chronos supports two separate definitions of "local time." There is local time according to the host operating system, and local time as defined by clients of Chronos. Although it would normally be the case that a Chronos client would want to have the same local time as the operating system on which it runs, there are situations where that is not so.  For example, a stock-trading application might need to define it's local time to be 'America/New_York', even though the user's computer resides in 'Australia/Perth'.  Or perhaps an application hosted on a web server in 'Asia/Calcutta' wants to let each logged-in user define his or her own local time to be any timezone defined in Chronos' timezone repository. To support such use cases, Chronos defines a system timezone and a default timezone.

			In order for Chronos to permit its view of "local time" to differ from that of the host system, it is absolutely necessary for Chronos to nevertheless know which timezone the host system is using to define local time. The reason is simply because the system clock on some systems keeps and reports time relative to the system's local timezone; and when that is the case, it is necessary to know the system timezone in order to know the meaning of times reported by the system clock.  Also, should one's Smalltalk environment need to interoperate or collaborate with the host system, or with some foreign component or application hosted on the same system, it may be necessary to either provide dates and/or times encoded as local time as defined by the host system, or to accept and correctly interpret such values (believe it or not, using UT-relative time values as the standard for data interchange is far from a universal practice.) 

			The default timezone is the one that is used by default whenever no timezone is explicitly specified. It serves as the 'implementation-defined local time' as required by the ANSI-Smalltalk Standard.  The default timezone is the one that will be used when the ANSI-Standard message #asLocal is sent to a DateAndTime value, or when the current DateAndTime is retrieved by evaluating 'DateAndTime now'.

			The default timezone is accessible by sending the message #default to ChronosTimezone {ChronosTimezone default}. A ChronosTimezone will be set as the current default timezone when sent the message #beDefault {(ChronosTimezone at: 'America/New_York') beDefault}. Setting the default timezone has no affect at all on which timezone is the system timezone.

			The system timezone is intended to be as congruent as possible to whatever timezone the host operating system uses to define local time. The statement says "intended" because it may not be possible to discover which timezone the host system is using to define local time, and also because the actual binding between Chronos and the host system is the responsibility of whoever ports Chronos to a particular platform. The statement says "as congruent as possible" because it may not be possible for Chronos to provide a timezone implemented so that it behaves in all respects identically to the timezone implementation used by the host system:  The ChronosSystemFacade provides an API by which a Chronos client can choose the strategy that will be used to synchronize Chronos' system timezone with the timezone used by the base/host system.  [For more information on the different system-timezone-binding strategies see ChronosSystemFacade.  The default behavior is as follows: If and only if the TZ environment variable of the current user specifies a valid Olson timezone key, the Chronos system timezone is set to the Olson timezone with that key whenever the image is restarted after a snopshot.]

			The system timezone is accessible by sending the message #system to ChronosTimezone {ChronosTimezone system}.  A ChronosTimezone will be set as the current system timezone when sent the message #beSystem {(ChronosTimezone at: 'America/Chicago') beSystem}.  Setting the Chronos system timezone in this manner may or may not change which timezone the host system uses to define local time, and it may or may not change which timezone is the Chronos default timezone.  

			When no timezone has been explicitly set as the default, Chronos makes the system timezone serve as the virtual default timezone--which means that <Timezone default> will evaluate to <Timezone system>, and that changing which timezone is the system timezone automatically changes which timezone is the default.  This is the situation immediately after Chronos has been installed.  However, once any timezone (other than the current system timezone) has been explicity set as the default, changing the system timezone will not affect which timezone serves as Chronos' default timezone.  To resynchronize the default and system timezones, so that changing the system timezone also changes the default, set the system timezone to be the default: <Timezone system beDefault>.

			The effect on the host operating system of changing the Chronos system timezone is a function of the implementation of the ChronosSystemFacade [As currently implemented for VisualWorks, there is no effect on the host operating system when the Chronos system timezone is changed from within Chronos, although the native VW default TimeZone will be redefined.]  Chronos clients are encouraged to change the implementation of ChronosSystemFacade  so that it meets their specific needs (subclassing is the recommended approach.).

		## ACCESSING THE CURRENT DATE/TIME IN A SPECIFIC TIMEZONE

			There are a variety of messages that can be sent to any ChronosTimezone to retrieve the current date and/or time (such that the local time of the retrieved points-in-time will be as defined by the referenced timezone):

												Message Signature		
			Type-of-return-value		Gregorain Calendar					Specified Calendar		
			
			TimeOfDay				#timeOfDayNow						#timeOfDayNowAs:		
			TimeOfDay				#timeOfDayNowToTheSecond		#timeOfDayNowToTheSecondAs:		
			YearMonthDay			#dateToday							#dateTodayAs:			
			DateAndTime 			#today								#todayAs:							
			DateAndTime			#now								#nowAs:					
			DateAndTime			#nowToTheSecond					#nowToTheSecondAs:	
			
			Examples (with explanations of semantics):

				Expression												Semantics

				Timezone default timeOfDayNow.							"Current time-of-day in the default timezone"
				Timezone system timeOfDayNowToTheSecond. 			"Current time-of-day (to the second) in the system timezone"
				Timezone universal dateToday.							"Current date in the Universal timezone"
				(Timezone at: 'Asia/Calcutta') today.						"DateAndTime in India as of the initial moment of today's date"
				(Timezone at: 'Australia/Sydney') now.						"DateAndTime at this moment in Sydney, Australia"
				Timezone default nowAs: #Hebrew.						"(Local) DateAndTime at this moment according to the Hebrew Calendar"
				Timezone default nowToTheSecondAs: #Ethiopic.			"(Local) DateAndTime at this moment (to the second) according to the Ethiopic Calendar" 
					(The Ethiopic Calendar's time-of-day clock starts at 6am)

			Timepoint class and CalendarClock both provide a similar API for retrieving the current date and/or time.

		## INSTANTIATION OF DATE/TIME VALUES WHOSE LOCAL TIME IS DEFINED BY A SPECIFIC TIMEZONE

			The ANSI-Smalltalk standard defines a few DateAndTime creation messages where the final message argument is a Duration whose value specifies the timezone that will define local time for the DateAndTime instance created as a result of sending the message--these ANSI-required multi-keyword messages all have the keyword "offset:" as the final message keyword.  

			Chronos provides a variety of DateAndTime (and date and time-of-day) factory methods that accept a "timeZone:" argument, the value of which can be any of a) a ChronosTimezone instance, b) a Duration instance, or c) the key of any Chronos timezone (a Symbol, a String or a Number.)  

			Examples (see the class methods of Timepoint and its superclasses for the complete factory-method API):

				Timepoint 	utYear: 1969 month: 7 day: 20 hour: 10 minute: 17 second: 40 timeZone: #'America/Chicago'.
				Timepoint 	   year: 1969 month: 7 day: 20 hour:   5 minute: 17 second: 40 offset: (Duration hours: -5).  
				Timepoint 	   year: 1969 month: 7 day: 20 hour:   5 minute: 17 second: 40 timeZone: 'America/Chicago'.
				Timepoint 	   year: 1969 month: 7 day: 20 seconds: 19060 nanoseconds: 677411800 timeZone: (ChronosTimezone at: #'America/Chicago'). 
				Timepoint daysSinceEpoch:  718997.220601852d timeZone: (Duration seconds: -18000).
				Timepoint julianDay: 2440422.720601852d timeZone: -18000.

			Note that the first example specifies the time using the Universal Time date and time (the specified time is the official point-in-time when Apollo 11 landed on the Moon,) even though the Timepoint created uses US Central Time as its local time.
				
		## PROXY TIMEZONES {"always default", "always system" and "nominal time"}
	
			A "proxy" timezone is one that serves as an indirect reference to some other timezone.  Chronos defines three standard "proxy" timezones: <Timezone alwaysSystem>, <Timezone alwaysDefault> and <Timezone nominal>. Proxy timezones are useful for cases where it is desirable that the local time of a point-in-time value dynamically change to reflect whatever timezone is currently set as the local timezone.  

			The precise semantics of the three standard proxy timezones are defined as follows:

				<Timezone alwaysDefault>	
					Dynamically refers by proxy to whatever Timezone is currently set as <Timezone default>. A Timepoint with this timezone always represents the same time UT, but its local time is dynamically determined by whatever Timezone is set as the current default timezone--in other words, its UT time is invariant, but its local time varies dynamically as a function of any change to whichever timezone == Timezone default. The key of the "always default" time zone is #alwaysDefault.

				<Timezone alwaysSystem>	
					Dynamically refers by proxy to whatever Timezone is currently set as <Timezone system>. A Timepoint with this timezone always represents the same time UT, but its local time is dynamically determined by whatever Timezone is set as the current system timezone--in other words, its UT time is invariant, but its local time varies dynamically as a function of any change to whichever timezone == Timezone system. The key of the "always system" time zone is #alwaysSystem.

				<Timezone nominal>		
					Refers to no timezone at all (or to any timezone)--used as the "timezone" of Timepoints that will/should be invariant to nominal time.  A point-in-time that is invariant to nominal time represents the same LOCAL time in any and all timezones, and so compares as equal to any other point-in-time whose local (or nominal) time matches the time it nominally designates. Timepoints with any other timezone are invariant to UT, which means that their value relative to other UT-invariant Timepoints is determined by the UT point-in-time they represent, and not by their local time (UT-invariance is the semantics required of points-in-time that conform to the ANSI-Smalltalk <DateAndTime> protocol.) However, for compatibility with UT-invariant Timepoints, Timepoints whose timezone is <Timezone nominal> also behave to some extent as though their timezone were <Timezone default>. So, nominal-time invariant Timepoints always represent THE SAME LOCAL TIME in any and all time zones--in other words, their LOCAL TIME ("nominal time") is INVARIANT, but the UT time they represent varies as a function of the value of 'Timezone default.'    The key of the `nominal time` time zone is #nominal.

		## RETRIEVING TIMEZONE OFFSETS FROM UT (UNIVERSAL TIME) (and also other related information) 

			[Definition: A timezone's offset from UT is the value that is added to the UT point-in-time in order to derive the local point-in-time in that timezone, and is also the value that is subtracted from the local point-in-time in order to derive the UT point-in-time. It is also common to refer to a time zone offset as a number of "hours east," "minutes east" or "seconds east" of UT, and to refer to its additive inverse as a number of "hours west," "minutes west" or "seconds west" of UT. POSIX time-zone rule literals are specified using "hours:minutes:seconds" **west** (not east) of UT--so the POSIX rule literal "EST5" means 'timezone whose standard-time abbreviation is EST and whose standard-time offset (west from/behind) UT is 5 hours (which corresponds to an offset that is -5 hours east (or ahead) of UT.)']

			The API for retrieving the offset of a ChronosTimezone varies depending on whether the ChronosTimezone instance is "bound" or "unbound" (the same is true of a timezone's abbreviation, but not of its key or name.) A "bound" Chronos time zone is one whose single, specific offset-abbreviation tuple is or can be "bound to" (properly associated with) a specific point-in-time.  An "unbound" Chronos time zone is one that does NOT specify a single, specific offset and abbreviation that can be "bound to" (properly associated with) a specific point-in-time. 

			Chronos time zones are also classified as either "static" or "dynamic." A "static" Chronos time zone is one whose offset-abbreviation tuple is not subject to retroactive changes--for a static time zone, the binding of a point-in-time value to the offset-abbreviation tuple of its time zone is permanent for all time. A "dynamic" Chronos time zone is one whose offset-abbreviation tuple (or tuples) is subject to retroactive changes--for a dynamic time zone, the binding of a point-in-time value to the offset-abbreviation tuple currently specified by its time zone is not necessarily permanent. 

		 	The following table presents the ontology of Chronos time zone types, and the names of the core classes that provide concrete implementations of each of the 3 types:

											Static					Dynamic

						Bound				UniversalTime			StandardTime
											BasicTimezone			NonStandardTime
								

						Unbound			<non-sensical>			VariableOffsetTimezone

			When sent the message #isBound, a "bound" ChronosTimezone will answer true, and an "unbound" ChronosTimezone will answer false. When sent the message #isStatic, a static Chronos time zone will answer true, and a dynamic Chronos time zone will answer false.

			BasicTimezone instances are "bound, static" timezones, because they have exactly one offset and one abbreviation for all time, from the infinite past to the infinite future--and the binding to the offset/abbreviation tuple is not subject to future revision, it's "static" or "constant." Instances of VariableOffsetTimezone are  "unbound, dynamic" time zones, because their offset and abbreviation can vary over time (even if their present offset and/or abbreviation have always been the same from the infinite past, either or both the offset and the abbreviation are still subject to change in the future--and even the past/current offsets and abbreviations are subject to being changed dynamically.) 

			++ BOUND TIMEZONE API ++
	
				Message							Semantics

				#offsetFromUT						Answers a Duration representing the timezone's offset. 
				#offsetSecondsFromUT				Answers the integer number of seconds of the timezone's 
														offset (ignores any subsecond fraction.)
				#stdTimeOffsetFromUT				Answers a Duration representing the timezone's offset from 
														UT for "standard time" (when DST is not in effect.) 
				#stdTimeOffsetSecondsFromUT		Answers the integer number of seconds of the timezone's 
														offset from UT for "standard time" (when DST is not in effect; 
														ignores any subsecond fraction.)
				#offsetDelta							Answers a Duration representing the difference between the 
														timezone's effective offset and its "standard time" offset.
				#offsetDeltaSeconds					Answers the integer number of seconds of the difference 
														between the timezone's effective offset and its "standard time" 
														offset (ignores any subsecond fraction.)
				#commonAbbreviation				Answers the timezone's commonly-used abbreviation.

				Note: Bound timezones also respond correctly to the API for unbound timezones; the reverse is NOT true.

			++ UNBOUND TIMEZONE  API ++ 

				In order to retrieve the offset and/or abbreviation that is correct for the location of an unbound ChronosTimezone (i.e., an instance of VariableOffsetTimezone) at a particular point-in-time one must use the unbound ChronosTimezone API to resolve a "bound" ChronosTimezone with the correct offset and abbreviation, and retrieve the offset and/or abbreviation from the "bound" timezone so obtained.

				The search parameters needed to resolve a bound timezone are the year, day-of-year and seconds-since-start-of-day. They can be specified either as UT values or as local time ("wall clock") values.  The message signatures for resolving a bound timezone are as follows:

					#bindingForLocalYear:dayOfYear:secondsSinceStartOfDayFunction:		"Uses local-time search parameters"
					#bindingForUTYear:dayOfYear:secondsSinceStartOfDayFunction:		"Uses Universal Time search parameters"

				The final parameter value (following "secondsSinceStartOfDayFunction:") is a one-argument block.  If the seconds-since-start-of-day value is needed to find the bound timezone, this block will be invoked (as a 'call-back') with an argument whose value is the offset from UT in seconds for a particular bound timezone (representing a particular set of zone properties in effect during a particular period of time.)  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary (the answered seconds-since-start-of-day should be in Universal Time if the message #bindingForUTYear:dayOfYear:secondsSinceStartOfDayFunction: was sent, but in local ("wall clock") time if the message #bindingForLocalYear:dayOfYear:secondsSinceStartOfDayFunction: was sent.)  The reason for the callback block is that, during some years, a timezone may have more than one 'standard time' offset from UT, and because the offset transition rules for the same timezone for the same year can be specified as UT values for the first transition, local "wall clock" time for the second transition, but as local standard time for the third transition (yes, all that stuff actually happens--timezones are NOT simple!!)

				See VariableOffsetTimezone for more detailed information.

				Examples: 

					((Timezone at: 'America/Los_Angeles')
						bindingForLocalYear: 1968
						dayOfYear: 119 "Sunday, April 28"
						secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | 7199 "1:59:59 am local time"]) offsetFromUT

					((Timezone at: 'America/Los_Angeles')
						bindingForLocalYear: 1968
						dayOfYear: 119 "Sunday, April 28"
						secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | 7200 "2:00:00 am local time"]) offsetFromUT

					((Timezone at: 'Europe/London')
						bindingForLocalYear: 2005
						dayOfYear: 86 "Sunday, March 27"
						secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | 3599 "12:59:59 am local time"]) offsetFromUT

					((Timezone at: 'Europe/London')
						bindingForLocalYear: 2005
						dayOfYear: 86 "Sunday, March 27"
						secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | 3600 "1:00:00 am local time"]) offsetFromUT

					And finally, to contrast and compare Chronos with the functionality and performance of the VW Timestamp and TimeZone--which, to be fair, were introduced long before most languages supported any equivalent functionality (although the Standard C Library provided both more and less functionality):
					
					[| now |
					now := Timepoint nominalNow.
					1000000 timesRepeat:
						[(Timezone system
							bindingForLocalYear: now year
							dayOfYear: now dayOfYear
							secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | now secondsSinceStartOfDay]) 
										offsetSecondsFromUT + now secondsSinceEpoch]] durationToRun.

					[| now | "Will only run in VisualWorks"
					now := Timestamp now.
					1000000 timesRepeat:
						[TimeZone default convertLocalSecondsToGMT: now asSeconds]] durationToRun.
						"Design/implementation from the late 1980's--which, although ancient, is not old enough to have made it into the Squeak branch of ST80."

					[| now |
					now := Timepoint now.
					1000000 timesRepeat:
						[now utSecondsSinceEpoch]] durationToRun.

	Implementation:

		Instance Variables

			name				<StringOrSymbol | nil> 	The name of the timezone represented by instance--value may be nil.

		Class Variables

			AlwaysDefault	<AlwaysDefaultTZ> 		Canonical instance of AlwaysDefaultTZ (which see.)
			AlwaysSystem	<AlwaysSystemTZ> 	Canonical instance of AlwaysSystemTZ (which see.)
			BindingRegistry	<IdentityDictionary> 	Cache of instances of either StandardTime or NonStandardTime that are created when instances of VariableOffsetTimezone are deserialized by means of TimeZonePolicySpecs.  The cache is used to ensure that instances of VariableOffsetTimezone that are being deserialized from the time zone repository use only a single instance of StandardTime (or NonStandardTime) with the same offset and abbreviation (this is done solely to minimize memory usage--it is not an invariant required for correct operation.) The cache is cleared once the deserialization process is complete.
			Default			<ChronosTimezone | nil>	
				Specifies the current default timezone that establishes what Chronos considers to be local time--if nil, then the default timezone (that establishes local time in the context of Chronos) is the current system timezone.
			Nominal			<NominalTime> 			Canonical instance of NominalTime (which see.)
			OffsetRegistry	<WeakDictionary; offsetSecondsFromUT->(Duration seconds: offsetSecondsFromUT)>			
				Cache of Durations that serve as offsets-from-UT--the purpose is to ensure that instances of VariableOffsetTimezone that are being deserialized from the time zone repository use only a single Duration instance throughout their object graphs for a given number of offset-seconds-from-UT (this is done solely to minimize memory usage--it is not an invariant required for correct operation.) The cache is cleared once the deserialization process is complete.
			System			<ChronosTimezone>		
				Specifies the current system timezone--intended to correspond to whatever timezone defines/establishes local time in the context of the host system. Should always be the same object as the value of the <systemTimeZone> instance variable of 'ChronosSystemFacade current.'
			Universal			<UniversalTime> 	Canonical instance of UniversalTime (which see.)

	Subclassing:

		Concrete subclasses must subimplement the following instance methods:

			#defaultOffsetPolicy
			#isBound
			#key
			#processBy:


!

ChronosTimezone subclass: #BoundTimezone
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!BoundTimezone commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

BoundTimezone

	Concept:

		BoundTimezone is an abstract class that provides inheritable behavior appropriate for implementing "bound, static" time zones. A "bound" Chronos time zone is one whose single, specific offset-abbreviation tuple is or can be "bound to" (properly associated with) a specific point-in-time.  An "unbound" Chronos time zone is one that does NOT specify a single, specific offset and abbreviation that can be "bound to" (properly associated with) a specific point-in-time. A "static" Chronos time zone is one whose offset-abbreviation tuple is not subject to retroactive changes--for a static time zone, the binding of a point-in-time value to the offset-abbreviation tuple of its time zone is permanent for all time. A "dynamic" Chronos time zone is one whose offset-abbreviation tuple (or tuples) is subject to retroactive changes--for a dynamic time zone, the binding of a point-in-time value to the offset-abbreviation tuple currently specified by its time zone is not necessarily permanent.

		A "bound, static" timezone is a "bound timezone" whose offset and abbreviation are invariant in two different senses: All points-in-time within the domain of a "bound, static" time zone, from the infinite past to the infinite future, have the same offset and abbreviation; and the offset/abbreviation tuple specified by a "bound, static" timezone will always be immutably, invariantly the same--no "ex post facto" rule changes are allowed.

		However, the API (as opposed to some of the method implementations) of BoundTimezone is also appropriate for a type of time zone which Chronos refers to as a "bound, dynamic" time zone, which is a time zone whose specific offset and abbreviation are correct for (or "bound to") a specific point-in-time according to the currently-specified ruleset of an "unbound, dynamic" (variable-offset) timezone.

		The offset and abbreviation of a "bound, dynamic" timezone may vary dynamically in two different senses:

			1. The "bound, dynamic" time zone that is correct for (or "bound to") a specific point-in-time value at a particular location may be different from the "bound, dynamic" time zone (the offset and abbreviation tuple) that is correct for ("bound to") an infinitesimally different point-in-time value at the exact same location. In other words, adding even a nanosecond (or any non-zero duration, regardless of size) to a point-in-time value may require that the point-in-time value that results from such an addition be "bound to" a different "bound, dynamic" timezone (offset/abbreviation tuple) than the one to which the original point-in-time value was bound--even at the exact same location.

			2. The time zone ruleset that specifies the correct bound time zones (offset/abbreviation tuples) for all point-in-time values within some specified area or locale may change, requiring that an offset/abbreviation tuple different than the one previously required by the former rules be "bound to" some range (or set of ranges) of the point-in-time values at all locations within the time-zone's territory.  For example, the law that determines the date or dates of transition to and/or from Daylight Saving Time may change, so that future transitions to and/or from Daylight Saving Time happen on different dates than would have been the case previously (or, a new/changed law may eliminate Daylight Saving Time altogether, or initiate Daylight Saving Time in a time zone where it had not been previously observed at all, or even just change the standard-time offset of the time zone.) Usually, such changes would only affect point-in-time values in the future, but such changes can also happen to times in the past (e.g,, due to a correction of wrong time zone rules, or due to further elaboration of incomplete rules.)

		Although BoundTimezone itself implements "bound, static" time zones, subclasses may instead implement "bound, dynamic" time zones, using the same API (or an extension thereof.)

	Usage:

		An BoundTimezone conforms to both the Chronos "BOUND TIMEZONE API" and "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		See either the individual method comments, or ChronosTimezone, for any further information.

	Subclassing:

		Concrete subclasses must subimplement the instance method #offsetFromUT, and will probably need to also subimplement the method #commonAbbreviation (see the method comments for the required behaviors.)
!

BoundTimezone subclass: #BasicTimezone
	instanceVariableNames: 'offsetFromUT name commonAbbreviation'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!BasicTimezone commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

BasicTimezone

	Concept:

		BasicTimezone concretely implements a Chronos "bound, static" time zone, as specified and explained by the comment of the superclass BoundTimezone. BasicTimezone provides an invariant offset from UT (no DST rules,) an invariant name (optional) and an invariant abbreviation (optional.)  

		See also: ChronosTimezone, UniversalTime.

	Usage:

		A BasicTimezone conforms to both the Chronos "BOUND TIMEZONE API" and "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		A BasicTimezone (unnamed and with no abbreviation) is what will be created and set as a Timepoint's timezone whenever the ANSI-Smalltalk 'offset:' protocol is used to specify the timezone of a Timepoint.  There is no other choice, since it is generally impossible to uniquely and deterministically map an offset to an Olson timezone without any other contextual information.  It is more common than not for different Olson timezones (which differ because they have different DST rules and/or different abbreviations) to have the same offset as other Olson timezones (there are less than 50 distinct time zone offsets around the world (some have fractional-hour offsets,) but as of 2005 there are 409 different Olson timezone rulesets--so do the math.)	

	Motivation:

		BasicTimezone serves two purposes: 1) It's very fast and memory efficient; and 2) it's necessary in order to reconcile the API required by real-world Timezones (such as those specified in the Olson Timezone Database) with the rather quaint notion of 'timezone offset' specified by the ANSI-Smalltalk standard for DateAndTime.

		Since ANSI-Smalltalk timezone offsets are instances of Duration (Note: ScientificDuration is the actual name of the Chronos class that implements the ANSI-Smalltalk Duration protocol,) a BasicTimezone represents a timezone offset by encapsulating a Duration instance. There are no limitations on the Duration that defines the offset of a BasicTimezone--all values will work fully and correctly--from 1 nanosecond to gigayears.  	

	Implementation:

		Instance Variables

			offsetFromUT 			<ScientificDuration> 	The instance's offset from UT.
			commonAbbreviation	<Symbol | nil> 			The instance`s time zone abbreviation.
!

!BasicTimezone class methodsFor: 'instance creation' stamp: ''!
offset: aDuration
	"Answer a BasicTimezone whose offset from UT is <aDuration>."

	"{BasicTimezone offset: (Duration hours: -7)}"

	^self new
		setOffsetFromUT: aDuration;
		beImmutable! !

!BasicTimezone class methodsFor: 'instance creation' stamp: ''!
offset: aDuration commonAbbreviation: aSymbol
	"Answer a BasicTimezone whose offset from UT is <aDuration> and whose common abbreviation is <aSymbol>."

	"{BasicTimezone
		offset: (Duration hours: -7)
		commonAbbreviation: #MST}"

	^self new
		setOffsetFromUT: aDuration commonAbbreviation: aSymbol;
		beImmutable! !

!BasicTimezone class methodsFor: 'instance creation' stamp: ''!
offset: aDuration name: aStringOrSymbol commonAbbreviation: aSymbol
	"Answer a BasicTimezone whose offset from UT is <aDuration>, whose name is <aStringOrSymbol> and whose common abbreviation is <aSymbol>."

	"{BasicTimezone
		offset: (Duration hours: -7)
		name: 'US Mountain Time (Arizona)'
		commonAbbreviation: #MST}"

	^self new
		setName: aStringOrSymbol;
		setOffsetFromUT: aDuration commonAbbreviation: aSymbol;
		beImmutable! !

!BasicTimezone methodsFor: 'initialize-release' stamp: ''!
beUniversal
	"Make the receiver have the properties of the Universal Time zone. Fail if the receiver is not mutable."

	self assertMutability.
	offsetFromUT := ZeroDuration.! !

!BasicTimezone methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromLocal: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time in the local time defined by the receiver, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use Universal Time coordinates instead of local time coordinates.)"

	^aDateAndTime canonicalizeFromLocal: self offsetSecondsFromUT nanoseconds: offsetFromUT nanosecondsSinceSecond! !

!BasicTimezone methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromUT: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time using Universal Time coordinates, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use coordinates in the local time defined by the receiver instead of using Universal Time coordinates.)"

	^aDateAndTime canonicalizeFromUT: self offsetSecondsFromUT nanoseconds: offsetFromUT nanosecondsSinceSecond! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
commonAbbreviation
	"Answer the common abbreviation for the timezone represented by the receiver."

	^commonAbbreviation == nil 
		ifTrue: 
			[self isUniversalTime 
				ifTrue: [ChronosTimezone universal commonAbbreviation]
				ifFalse: [super commonAbbreviation]]
		ifFalse: [commonAbbreviation]! !

!BasicTimezone methodsFor: 'private' stamp: ''!
defaultNameIfNone: noneBlock
	^self isUniversalTime 
		ifTrue: [ChronosTimezone universal nameIfNone: noneBlock]
		ifFalse: [noneBlock value]! !

!BasicTimezone methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: name;
		nextPut: self offsetFromUT literalArrayEncoding; 
		nextPut: self commonAbbreviation! !

!BasicTimezone methodsFor: 'testing' stamp: ''!
hasSubsecondOffset
	"Answer whether the receiver has fractional seconds of offset."

	^offsetFromUT subsecondsAreNonZero! !

!BasicTimezone methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	self beUniversal! !

!BasicTimezone methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self setName: (literalArray at: 3).
	self setOffsetFromUT: (literalArray at: 4) decodeAsLiteralArray commonAbbreviation: (literalArray at: 5)! !

!BasicTimezone methodsFor: 'testing' stamp: ''!
isUniversalTime
	"Anwser whether the receiver has all the properties and behaviors of the international reference zero-offset time zone."

	^offsetFromUT isZero! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
key
	"Answer the key that identifies the receiver."

	^self isUniversalTime 
		ifTrue: [ChronosTimezone universal key]
		ifFalse: 
			[self hasSubsecondOffset 
				ifTrue: [self offsetFromUT asFractionalSeconds]
				ifFalse: [self offsetSecondsFromUT]]! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
nameIfNone: noneBlock
	"Answer the name of the receiver."

	^name == nil 
		ifTrue: 
			[self isUniversalTime 
				ifTrue: [ChronosTimezone universal nameIfNone: noneBlock]
				ifFalse: [self defaultNameIfNone: noneBlock]]
		ifFalse: [name]! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
netSecondsAfterAddingOffsetFromUTToSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from adding the receiver's offset from UT to the specified number of <seconds> and <nanosecondsSinceSecond>."

	^offsetFromUT subsecondsAreZero
		ifTrue: [seconds + offsetFromUT asSeconds]
		ifFalse: [(offsetFromUT addingSeconds: seconds nanoseconds: nanosecondsSinceSecond) asSeconds]! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
netSecondsAfterSubtractingOffsetFromUTFromSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from subtracting the receiver's offset from UT from the specified number of <seconds> and <nanosecondsSinceSecond>."

	^offsetFromUT subsecondsAreZero
		ifTrue: [seconds - offsetFromUT asSeconds]
		ifFalse: [(offsetFromUT negated addingSeconds: seconds nanoseconds: nanosecondsSinceSecond) asSeconds]! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
offsetFromUT
	"Answer a Duration that specifies the receiver's offset from Universal Time (which is defined as the amount of time to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the local time defined by the receiver.)"

	^offsetFromUT! !

!BasicTimezone methodsFor: 'testing' stamp: ''!
offsetIsZero
	"Anwser whether the receiver's offset from UT is zero."

	^offsetFromUT isZero! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
offsetSecondsFromUT
	"Answer the receiver's offset from Universal Time in seconds (which is defined as the number of seconds to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the local time defined by the receiver.)"

	^offsetFromUT asSeconds! !

!BasicTimezone methodsFor: 'printing' stamp: ''!
printKeyOn: stream
	stream print: self key! !

!BasicTimezone methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processBasicTimezone: self! !

!BasicTimezone methodsFor: 'initialize-release' stamp: ''!
setName: aStringOrSymbol
	"Set the name of the receiver to <aStringOrSymbol>. Fail if the receiver is not mutable."

	self assertMutability.
	name := aStringOrSymbol == nil ifFalse: [aStringOrSymbol asString]! !

!BasicTimezone methodsFor: 'initialize-release' stamp: ''!
setOffsetFromUT: aDuration 
	"Set the receiver's offset from UT to be <aDuration>. Fail if the receiver is not mutable."

	self assertMutability.
	offsetFromUT := aDuration! !

!BasicTimezone methodsFor: 'initialize-release' stamp: ''!
setOffsetFromUT: aDuration commonAbbreviation: aSymbol
	"Set the receiver's offset from UT to be <aDuration>, and set the receiver's common abbreviation to be <aSymbol>. Fail if the receiver is not mutable."

	self assertMutability.
	offsetFromUT := aDuration.
	commonAbbreviation := aSymbol! !

!BasicTimezone methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation
	^commonAbbreviation ~~ nil! !

!BasicTimezone methodsFor: 'testing' stamp: ''!
specifiesName
	^name ~~ nil! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
stdTimeOffsetFromUT
	"Answer a Duration that specifies the receiver's offset from Universal Time when `standard time` is in effect (which is defined as the amount of time to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the `standard time' defined by the receiver.)"

	^offsetFromUT! !

!BasicTimezone methodsFor: 'accessing' stamp: ''!
stdTimeOffsetSecondsFromUT
	"Answer the receiver's offset from Universal Time in seconds when `standard time` is in effect (which is defined as the number of seconds to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the `standard time' defined by the receiver.)"

	^offsetFromUT asSeconds! !

BasicTimezone subclass: #StandardTime
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!StandardTime commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

StandardTime

	Concept:

		StandardTime implements "bound, dynamic" time zones, as described in the superclass BoundTimezone.  A StandardTime represents the (offset, abbreviation) tuple that defines local "standard time" during some range (or ranges) ot point-in-time values within the territorial domain of a time zone.  For example, the StandardTime instance whose key is #'Pacific/Honolulu', whose offset from UT is -10 hours, and whose abbreviation is #HST functions as the "bound, dynamic" time-zone for all point-in-time values in Hawaii from 1947-06-08T02:00:00 HST up until the time that his comment was written (2005,) and for for some presently-unknown span of time into the future (i.e., until either the State of Hawaii decides to change one or both of those values yet again--or perhaps to begin observing Daylight Saving Time.)

	Usage:

		A StandardTime conforms to both the Chronos "BOUND TIMEZONE API" and "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		==>> Note that `bound, dynamic` time zones (such as instances of StandardTime or NonStandardTime) are not allowed to have offsets from UT that have fractional seconds. <==

		See either the individual method comments, or the superclasses BasicTimezone, BoundTimezonie or ChronosTimezone, or the collaborating class VaraibleOffsetTimezone, for any further information.

	Implementation:

		Instance Variables

			key			<Symbol>	The key that identifies the time zone represented by the instance. If and only if it's the key of an Olson time zone (or it it's otherwise a universally well-known key,) it must be universally unique. Unless it's the special value #system, it must be unique within an image (or within an OS process, if the Smalltalk environment is not image based.)


	!

StandardTime subclass: #NonStandardTime
	instanceVariableNames: 'stdTimeOffsetFromUT'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!NonStandardTime commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

NonStandardTime	

	Concept:

		NonStandardTime implements "bound, dynamic" time zones, as described in the superclass BoundTimezone.  A NonStandardTime represents the (offset, abbreviation) tuple that defines local "daylight saving time" (also called "summer time" in much of the world, and generically referred to as "non-standard time" by Chronos) during some range (or ranges) ot point-in-time values within the territorial domain of a time zone.  For example, the NonStandardTime instance whose key is #'America/Phoenix', whose offset from UT is -6 hours, and whose abbreviation is #MDT functions as the "bound, dynamic" time-zone for all point-in-time values in Arizona from 1967-04-02T03:00:00 MDT up until 1967-10-29T01:00:00 MST (Arizona has occasionally observed DST for brief perionds.)

	Usage:

		A NonStandardTime conforms to both the Chronos "BOUND TIMEZONE API" and "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		See StandardTime, BasicTimezone, BoundTimezone, ChronosTimezone and VariableOffsetTimezone for more informaiton.

	Implementation:

		Instance Variables

			stdTimeOffsetFromUT	<ScientificDuration> 	The offset from UT that would be in effect during "standard time" in the territorial domain of the time zone whose non-standard time properties are represented by the instance..!

!NonStandardTime methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream nextPut: self stdTimeOffsetFromUT literalArrayEncoding! !

!NonStandardTime methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	stdTimeOffsetFromUT := (literalArray at: 6) decodeAsLiteralArray! !

!NonStandardTime methodsFor: 'testing' stamp: ''!
isStandardTime
	"Answer whether or not the offset from UT specified by the receiver defines the `standard time` of the time zone represented by the receiver (as opposed to `daylight saving time`, `summer time`, `war time`, 'three-year-long-year-round energy-saving-during-a-crisis time', etc)."

	^false! !

!NonStandardTime methodsFor: 'accessing' stamp: ''!
offsetDelta
	"Answer a Duration that specifies the amount of time to be added to the receiver's standard-time offset from UT in order to compute the receiver's offset from UT when Daylight Saving Time (Summer Time) is in effect."

	^self offsetFromUT - self stdTimeOffsetFromUT! !

!NonStandardTime methodsFor: 'accessing' stamp: ''!
offsetDeltaSeconds
	"Answer the number of seconds to be added to the receiver's standard-time offset from UT in order to compute the receiver's offset from UT when Daylight Saving Time (Summer Time) is in effect."

	^self offsetSecondsFromUT - self stdTimeOffsetSecondsFromUT! !

!NonStandardTime methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processNonStandardTime: self! !

!NonStandardTime methodsFor: 'initialize-release' stamp: ''!
setKey: aTZKey offsetSeconds: offsetSecondsFromUT stdTimeOffsetSeconds: stdTimeOffsetSeconds commonAbbreviation: aSymbol
	"Set the receiver's time zone key to be <aTZKey>; 
	set the receiver's offset from UT to be the specified number of <offsetSecondsFromUT>;. 
	set the receiver's offset from UT during standard time (when DST is not in effect) to be the specified number of <stdTimeOffsetSeconds>;. 
	set the receiver's common abbreviation to be <aSymbol>.
	Fail if the receiver is not mutable."

	self setKey: aTZKey offsetSeconds: offsetSecondsFromUT commonAbbreviation: aSymbol.
	stdTimeOffsetFromUT := (self class offsetFromSeconds: stdTimeOffsetSeconds)! !

!NonStandardTime methodsFor: 'accessing' stamp: ''!
stdTimeOffsetFromUT
	"Answer a Duration that specifies the receiver's offset from Universal Time when `standard time` is in effect (which is defined as the amount of time to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the `standard time' defined by the receiver.)"

	^stdTimeOffsetFromUT! !

!NonStandardTime methodsFor: 'accessing' stamp: ''!
stdTimeOffsetSecondsFromUT
	"Answer the receiver's offset from Universal Time in seconds when `standard time` is in effect (which is defined as the number of seconds to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the `standard time' defined by the receiver.)"

	^stdTimeOffsetFromUT asSeconds! !

!NonStandardTime methodsFor: 'accessing' stamp: ''!
timeType
	^#nonstandard! !

!StandardTime methodsFor: 'accessing' stamp: ''!
abbreviation
	"Answer the abbreviation for the timezone represented by the receiver--according to the default locale if possible."

	^ChronosLocale default abbreviationAtSemanticKey: self key ifAbsent: [self commonAbbreviation]! !

!StandardTime methodsFor: 'accessing' stamp: ''!
aliasingKeys
	^self root aliasingKeys! !

!StandardTime methodsFor: 'converting' stamp: ''!
asStatic
	^ChronosTimezone 
		offset: self offsetFromUT
		name: self name
		commonAbbreviation: commonAbbreviation! !

!StandardTime methodsFor: 'converting' stamp: ''!
asUnbound
	"Answer the unbound time zone that specifies the full diachronic ruleset of the time zone represented by the receiver."

	^self root! !

!StandardTime methodsFor: 'initialize-release' stamp: ''!
beDefault
	"Set the receiver's root timezone as the default time zone. If the receiver's root timezone is the system time zone, cause the default time zone to virtually shadow the system time zone, so that whenever the system time zone is set to a different value, the default time zone is also set to the same new value."

	self canonical beDefault! !

!StandardTime methodsFor: 'initialize-release' stamp: ''!
beSystem
	"Set the receiver's root timezone as the system time zone. This operation may or may not affect the host Smalltalk environment and/or the host operating system. See the class of the current ChronosSystemFacade singleton to determine the behavior in the current environment and platform."

	self canonical beSystem! !

!StandardTime methodsFor: 'queries' stamp: ''!
bindingForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in the local time defined by the receiver.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in local (`wall clock`) time as defined by the receiver."

	^self root 
		bindingForLocalYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!StandardTime methodsFor: 'queries' stamp: ''!
bindingForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in Universal Time.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in Universal Time."

	^self root  
		bindingForUTYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!StandardTime methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's root time zone."

	^self root canonical! !

!StandardTime methodsFor: 'accessing' stamp: ''!
canonicalKey
	^self root canonicalKey! !

!StandardTime methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromLocal: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time in the local time defined by the receiver, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use Universal Time coordinates instead of local time coordinates.)"

	^aDateAndTime canonicalizeFromLocal: self offsetSecondsFromUT nanoseconds: 0! !

!StandardTime methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromUT: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time using Universal Time coordinates, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use coordinates in the local time defined by the receiver instead of using Universal Time coordinates.)"

	^aDateAndTime canonicalizeFromUT: self offsetSecondsFromUT nanoseconds: 0! !

!StandardTime methodsFor: 'accessing' stamp: ''!
defaultAnnualPolicy
	"Answer the AnnuallyRecurringTZPolicy that specifies the time zone rules that are in effect during the current year."

	^self root defaultAnnualPolicy! !

!StandardTime methodsFor: 'private' stamp: ''!
defaultName
	^self defaultNameIfNone: [self key]! !

!StandardTime methodsFor: 'private' stamp: ''!
defaultNameIfNone: noneBlock
	^name == nil
		ifTrue: [self root nameIfNone: noneBlock] 
 		ifFalse: [name]! !

!StandardTime methodsFor: 'accessing' stamp: ''!
geographicCoordinates
	^self root geographicCoordinates! !

!StandardTime methodsFor: 'testing' stamp: ''!
hasSubsecondOffset
	"Answer whether the receiver has fractional seconds of offset."

	^false! !

!StandardTime methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	key := (literalArray at: 2) asSymbol.! !

!StandardTime methodsFor: 'private-comparing' stamp: ''!
isEqualToTimezone: aTimezone 
	self class == aTimezone class ifFalse: [^false].
	^self key == aTimezone key and: [self offsetFromUT = aTimezone offsetFromUT]! !

!StandardTime methodsFor: 'testing' stamp: ''!
isProxyOrStatic
	"Answer whether the receiver is either a proxy time zone or a static time zone."

	^false! !

!StandardTime methodsFor: 'testing' stamp: ''!
isStandardTime
	"Answer whether or not the offset from UT specified by the receiver defines the `standard time` of the time zone represented by the receiver (as opposed to `daylight saving time`, `summer time`, `war time`, 'three-year-long-year-round energy-saving-during-a-crisis time', etc)."

	^true! !

!StandardTime methodsFor: 'testing' stamp: ''!
isStatic
	"Answer whether or not the timezone policy (key, offset, name and abbreviation) of the timezone represented by the receiver is invariant, constant and never subject to change or revision.  If the receiver's timezone policy is dynamically redefinable, answer false."

	^false! !

!StandardTime methodsFor: 'testing' stamp: ''!
isUniversalTime
	"Anwser whether the receiver has all the properties and behaviors of the international reference zero-offset time zone.
	[Note: Universal Time is intrinsically static--unlike the receiver."

	^false! !

!StandardTime methodsFor: 'accessing' stamp: ''!
key
	"Answer the key that identifies the receiver."

	^key! !

!StandardTime methodsFor: 'private' stamp: ''!
keyIsAlias
	^self root keyIsAlias! !

!StandardTime methodsFor: 'testing' stamp: ''!
keyIsGlobal
	"Answer whether the receiver's identifying key is a globally well-known value."

	^key ~~ #system 
		and: [TimeZonePolicyFactory timezoneKeyIsGloballyDefined: key]! !

!StandardTime methodsFor: 'private' stamp: ''!
literalArrayEncodingOfKey
	^key! !

!StandardTime methodsFor: 'accessing' stamp: ''!
name
	^self nameIfNone: [self key]! !

!StandardTime methodsFor: 'accessing' stamp: ''!
nameIfNone: noneBlock
	^self root nameIfNone: [self defaultNameIfNone: noneBlock]! !

!StandardTime methodsFor: 'accessing' stamp: ''!
namespaceKey
	^#dynamic! !

!StandardTime methodsFor: 'collaboration-dateAndTime' stamp: ''!
netSecondsAfterAddingOffsetFromUTToSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from adding the receiver's offset from UT to the specified number of <seconds> and <nanosecondsSinceSecond>."

	"Note: Chronos `bound, dynamic` time zones, such as instances of StandardTime or NonStandardTime, are not allowed to have offsets from UT that have fractional seconds."

	^seconds + offsetFromUT asSeconds! !

!StandardTime methodsFor: 'collaboration-dateAndTime' stamp: ''!
netSecondsAfterSubtractingOffsetFromUTFromSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from subtracting the receiver's offset from UT from the specified number of <seconds> and <nanosecondsSinceSecond>."

	"Note: Chronos `bound, dynamic` time zones, such as instances of StandardTime or NonStandardTime, are not allowed to have offsets from UT that have fractional seconds."

	^seconds - offsetFromUT asSeconds! !

!StandardTime methodsFor: 'accessing' stamp: ''!
policy
	"Answer the TimeZonePolicy that specifies the ruleset of the time zone represented by the instance.  The ruleset of a time zone specifies for all time values, from the infinite past to the infinite future, the (possibly varying) time zone offsets and abbreviations that apply to points-in-time within the territorial domain of the time zone. Note, however, that the `policy` (time zone ruleset) can be changed retroactively--and this is rather likely to happen for times in the future (but can also happen to times in the past.)"

	^self root policy! !

!StandardTime methodsFor: 'printing' stamp: ''!
printKeyOn: stream
	stream nextPutAll: self key! !

!StandardTime methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processStandardTime: self! !

!StandardTime methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
release 
	| registrationKey subRegistry |
	super release.
	key == nil ifTrue: [^self].
	registrationKey := self class bindingRegistryKeyForTimeZoneKey: key commonAbbreviation: self commonAbbreviation.
	subRegistry := self class offsetRegistry at: registrationKey ifAbsent: [^self].
	^subRegistry removeKey: (self offsetDeltaSeconds * SecondsPerDay) + self offsetSecondsFromUT ifAbsent: [^self]! !

!StandardTime methodsFor: 'accessing' stamp: ''!
root
	^self class at: key! !

!StandardTime methodsFor: 'initialize-release' stamp: ''!
setKey: aTZKey offsetSeconds: seconds commonAbbreviation: aSymbol
	"Set the receiver's time zone key to be <aTZKey>; 
	set the receiver's offset from UT to be the specified number of <seconds>;. 
	set the receiver's common abbreviation to be <aSymbol>.
	Fail if the receiver is not mutable."

	self setOffsetFromUT: (self class offsetFromSeconds: seconds) commonAbbreviation: aSymbol.
	key := aTZKey.! !

!StandardTime methodsFor: 'testing' stamp: ''!
specifiesAbbreviation
	^self specifiesCommonAbbreviation or: [(ChronosLocale default abbreviationAtSemanticKey: self key ifAbsent: [nil]) ~~ nil]! !

!StandardTime methodsFor: 'testing' stamp: ''!
specifiesGeographicCoordinates
	^self root specifiesGeographicCoordinates! !

!StandardTime methodsFor: 'testing' stamp: ''!
specifiesName
	^super specifiesName or: [self root specifiesName]! !

!StandardTime methodsFor: 'accessing' stamp: ''!
timeType
	^#standard! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
abbreviation
	"Answer the abbreviation for the timezone represented by the receiver--according to the default locale if possible."

	^self commonAbbreviation! !

!BoundTimezone methodsFor: 'converting' stamp: ''!
asStatic
	^self! !

!BoundTimezone methodsFor: 'queries' stamp: ''!
binding
	"Answer the bound timezone referenced by the receiver.  If there is none, answer nil."

	^self! !

!BoundTimezone methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromLocal: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time in the local time defined by the receiver, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use Universal Time coordinates instead of local time coordinates.)"

	^aDateAndTime canonicalizeFromLocal: self offsetSecondsFromUT nanoseconds: 0! !

!BoundTimezone methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromUT: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time using Universal Time coordinates, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use coordinates in the local time defined by the receiver instead of using Universal Time coordinates.)"

	^aDateAndTime canonicalizeFromUT: self offsetSecondsFromUT nanoseconds: 0! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
commonAbbreviation
	"Answer the common abbreviation for the timezone represented by the receiver."

	^self name! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
defaultAnnualPolicy
	"Answer the AnnuallyRecurringTZPolicy that specifies the time zone rules that are in effect during the current year."

	^UntilEndOfYearTimeZoneTransition 
		for: self
		offsetSeconds: self offsetSecondsFromUT
		stdTimeOffsetSeconds: self stdTimeOffsetSecondsFromUT
		commonAbbreviation: self commonAbbreviation! !

!BoundTimezone methodsFor: 'testing' stamp: ''!
isBound
	"Answer whether the receiver is a bound time zone. A bound time zone is one that defines a single offset/abbreviation tuple, and that conforms to the `BOUND TIMEZONE API` (as defined in the class comment of ChronosTimezone.)"

	^true! !

!BoundTimezone methodsFor: 'testing' stamp: ''!
isProxyOrStatic
	"Answer whether the receiver is either a proxy time zone or a static time zone."

	^true! !

!BoundTimezone methodsFor: 'testing' stamp: ''!
isStandardTime
	"Answer whether or not the offset from UT specified by the receiver defines the `standard time` of the time zone represented by the receiver (as opposed to `daylight saving time`, `summer time`, `war time`, 'three-year-long-year-round energy-saving-during-a-crisis time', etc)."

	^self offsetFromUT = self stdTimeOffsetFromUT! !

!BoundTimezone methodsFor: 'testing' stamp: ''!
isStatic
	"Answer whether or not the timezone policy (key, offset, name and abbreviation) of the timezone represented by the receiver is invariant, constant and never subject to change or revision.  If the receiver's timezone policy is dynamically redefinable, answer false."

	^true! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
namespaceKey
	^#static! !

!BoundTimezone methodsFor: 'collaboration-dateAndTime' stamp: ''!
netSecondsAfterAddingOffsetFromUTToSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from adding the receiver's offset from UT to the specified number of <seconds> and <nanosecondsSinceSecond>."

	^seconds + self offsetSecondsFromUT! !

!BoundTimezone methodsFor: 'collaboration-dateAndTime' stamp: ''!
netSecondsAfterSubtractingOffsetFromUTFromSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from subtracting the receiver's offset from UT from the specified number of <seconds> and <nanosecondsSinceSecond>."

	^seconds - self offsetFromUT asSeconds! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
offsetDelta
	"Answer a Duration that specifies the amount of time to be added to the receiver's standard-time offset from UT in order to compute the receiver's offset from UT when Daylight Saving Time (Summer Time) is in effect."

	^ZeroDuration! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
offsetDeltaSeconds
	"Answer the number of seconds to be added to the receiver's standard-time offset from UT in order to compute the receiver's offset from UT when Daylight Saving Time (Summer Time) is in effect."

	^0! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
offsetFromUT
	"Answer a Duration that specifies the receiver's offset from Universal Time (which is defined as the amount of time to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the local time defined by the receiver.)"

	^self subclassResponsibility! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
offsetSecondsFromUT
	"Answer the receiver's offset from Universal Time in seconds (which is defined as the number of seconds to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the local time defined by the receiver.)"

	^self offsetFromUT asSeconds! !

!BoundTimezone methodsFor: 'printing' stamp: ''!
offsetString
	"Answer a String that describes the receiver's offset from UT in ANSI format."

	"(Duration hours: -7) asTimezone offsetString"

	| stream |
	stream := (String new: 10) writeStream.
	self printOffsetOn: stream.
	^stream contents! !

!BoundTimezone methodsFor: 'printing' stamp: ''!
printOffsetOn: stream
	ChronosPrintPolicy ansiStandard printTimeZoneOffset: self offsetFromUT on: stream.! !

!BoundTimezone methodsFor: 'printing' stamp: ''!
printZuluNotationOn: stream

	stream nextPut: $Z.
	self printOffsetOn: stream.! !

!BoundTimezone methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processBoundTimezone: self! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
stdTimeOffsetFromUT
	"Answer a Duration that specifies the receiver's offset from Universal Time when `standard time` is in effect (which is defined as the amount of time to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the `standard time' defined by the receiver.)"

	^self offsetFromUT! !

!BoundTimezone methodsFor: 'accessing' stamp: ''!
stdTimeOffsetSecondsFromUT
	"Answer the receiver's offset from Universal Time in seconds when `standard time` is in effect (which is defined as the number of seconds to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the `standard time' defined by the receiver.)"

	^self stdTimeOffsetFromUT asSeconds! !

!BoundTimezone methodsFor: 'printing' stamp: ''!
zuluNotation
	"Answer a String that describes the receiver's offset from UT in `Zulu Notation.`"

	"(Duration hours: -7) asTimezone zuluNotation"

	| stream |
	stream := (String new: 10) writeStream.
	self printZuluNotationOn: stream.
	^stream contents! !

BoundTimezone subclass: #UniversalTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!UniversalTime commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UniversalTime

	Concept:

		UniversalTime implements the international reference zero-offset time zone whose formal name is Universal Time, and whose formally-correct abbreviation is UT.  However, this time zone is quite commonly referred to by a variety of other names and abbreviations--some of which are more widely used than the formally-correct ones.  Such names/abbreviations include Greenwich Mean Time (which is technically a timescale, not a time zone,) GMT (which is the abbreviation for Greenwich Mean Time,) Coordinated Universal Time (which is also technically a timescale, not a time zone,) UTC (which is the abbreviation for Coordinated Universal Time,) Zulu and Z (and there are others, especially in languages other than English.) [Briefly: A time zone is an offset or translation from a timescale or from some other time zone; a timescale defines an absolute temporal coordinate system by specifying an epoch (the zero-point of the timescale) and the temporal extent (size, duration) of the units used to measure the passage of time relative to the epoch. What those who use 'UTC' as the abbreviation of a timezone ought to (metaphorically) mean by such usage (although they typically don't) is 'the international reference timezone whose offset from the UTC timescale is zero.' The moral of the story is to be aware that "UTC" is quite often (incorrectly) used to mean 'the international reference timezone whose offset from the Greenwich Mean Time timescale is zero')--and, although the difference between the incorrect and correct meaning of UTC is never more than 0.9 seconds, that may be quite a large discrepancy in some technical/scientific contexts.]

		An instance of UniversalTime is a Chronos "bound, static" time zone, as specified and explained by the comment of the superclass BoundTimezone..

		See the class comments of BoundTimezone, ChronosTimezone and Timescale (once it's implemented, which it currently is not) for more information.

	Usage:

		The canonical instance of UniversalTime can be accessed by sending the (class) messages #universal or #ut to ChronosTimezone (e.g., 'ChronosTimezone universal',) or by using any of the following timezone keys to look up a time zone by its key: #Universal, #'Universal Time', #UT, #UTC, #GMT, #Zulu or #Z (e.g., 'ChronosTimezone at: #GMT.') The canonical key of the Universal time zone is #Universal.

!

!UniversalTime class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self universal! !

!UniversalTime methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's class whose value is equivalent to that of the receiver's."

	^ChronosTimezone universal! !

!UniversalTime methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromLocal: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time in the local time defined by the receiver, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use Universal Time coordinates instead of local time coordinates.)"

	"No action necessary"! !

!UniversalTime methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromUT: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time using Universal Time coordinates, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use coordinates in the local time defined by the receiver instead of using Universal Time coordinates.)"

	"No action necessary"! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
commonAbbreviation
	"Answer the common abbreviation for the timezone represented by the receiver."

	^#UT! !

!UniversalTime methodsFor: 'private' stamp: ''!
defaultNameIfNone: noneBlock
	^'Universal Time'! !

!UniversalTime methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	self beImmutable! !

!UniversalTime methodsFor: 'testing' stamp: ''!
isUniversalTime
	"Anwser whether the receiver has all the properties and behaviors of the international reference zero-offset time zone."

	^true! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
key
	"Answer the key that identifies the receiver."

	^#Universal! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
nameIfNone: noneBlock
	^ChronosLocale default properNameAtSemanticKey: self key ifAbsent: [self defaultNameIfNone: noneBlock]! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
netSecondsAfterAddingOffsetFromUTToSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from adding the receiver's offset from UT to the specified number of <seconds> and <nanosecondsSinceSecond>."

	^seconds! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
netSecondsAfterSubtractingOffsetFromUTFromSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from subtracting the receiver's offset from UT from the specified number of <seconds> and <nanosecondsSinceSecond>."

	^seconds negated! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
offsetFromUT
	"Answer a Duration that specifies the receiver's offset from Universal Time (which is defined as the amount of time to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the local time defined by the receiver.)"

	^ZeroDuration! !

!UniversalTime methodsFor: 'testing' stamp: ''!
offsetIsZero
	"Anwser whether the receiver's offset from UT is zero."

	^true! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
offsetSecondsFromUT
	"Answer the receiver's offset from Universal Time in seconds (which is defined as the number of seconds to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the local time defined by the receiver.)"

	^0! !

!UniversalTime methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation
	^true! !

!UniversalTime methodsFor: 'testing' stamp: ''!
specifiesName
	^true! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
stdTimeOffsetFromUT
	"Answer a Duration that specifies the receiver's offset from Universal Time when `standard time` is in effect (which is defined as the amount of time to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the `standard time' defined by the receiver.)"

	^ZeroDuration! !

!UniversalTime methodsFor: 'accessing' stamp: ''!
stdTimeOffsetSecondsFromUT
	"Answer the receiver's offset from Universal Time in seconds when `standard time` is in effect (which is defined as the number of seconds to be added to a temporal coordinate specified in Universal Time in order to derive the equivalent temporal coordinate specified in the `standard time' defined by the receiver.)"

	^0! !

!ChronosTimezone class methodsFor: 'queries' stamp: ''!
allAliasedKeys
	"Answer a Set of the canonical keys that have aliases (alternative keys) for all the time zones persistently stored in the Chronos time-zones repository (to which this execution environment is attached.)"

	^TimeZonePolicyFactory allAliasedKeys! !

!ChronosTimezone class methodsFor: 'queries' stamp: ''!
allAliasingKeys
	"Answer a Set of the aliasing (non-canonical) keys of all the time zones persistently stored in the Chronos time-zones repository (to which this execution environment is attached.)"

	^TimeZonePolicyFactory allAliasingKeys! !

!ChronosTimezone class methodsFor: 'queries' stamp: ''!
allCanonicalKeys
	"Answer a Set of the canonical (non-aliasing) keys of all the time zones persistently stored in the Chronos time-zones repository (to which this execution environment is attached.)"

	^TimeZonePolicyFactory allCanonicalKeys! !

!ChronosTimezone class methodsFor: 'queries' stamp: ''!
allRegisteredKeys
	"Answer a Set of the keys of all the time zones persistently stored in the Chronos time-zones repository (to which this execution environment is attached.)"

	^TimeZonePolicyFactory allRegisteredKeys! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
alwaysDefault
	"Answer the `always default` time zone."

	"Timezone alwaysDefault"

	AlwaysDefault == nil ifTrue: [AlwaysDefault := self newAlwaysDefault].
	^AlwaysDefault! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
alwaysSystem
	"Answer the `always system` time zone."

	"Timezone alwaysSystem"

	AlwaysSystem == nil ifTrue: [AlwaysSystem := self newAlwaysSystem].
	^AlwaysSystem! !

!ChronosTimezone class methodsFor: 'validation' stamp: ''!
assertValidityOfTimezoneKey: aTimeZoneKey
	"Assert that <aTimeZoneKey> is a valid Chronos time zone key (in the context of the current execution environment.) If it is, do nothing. If it is not, raise an Exception."

	aTimeZoneKey respondsToArithmetic
		ifFalse: 
			[VariableOffsetTimezone assertValidityOfTimezoneKey: aTimeZoneKey]! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
at: aChronosTimeZoneKey 
	"Answer the time zone whose key is <aChronosTimeZoneKey>.  If there is no time zone with the specified key, signal an exception."

	"Timezone at: 3600"
	"Timezone at: 'Asia/Rangoon'"
	"Timezone at: 'America/Los_Angeles'"
	"Timezone at: 'Europe/Berlin'"
	"Timezone allRegisteredKeys"

	^aChronosTimeZoneKey respondsToArithmetic 
		ifTrue: [(DurationFactory seconds: aChronosTimeZoneKey) asTimezone]
		ifFalse: [VariableOffsetTimezone at: aChronosTimeZoneKey]! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
at: aTimeZoneKey ifAbsent: absentAction
	"Answer the time zone whose key is <aChronosTimeZoneKey>.  If there is no time zone with the specified key, answer the result of evaluating <absentAction>."

	"Timezone at: 'Asia/Shanghai' ifAbsent: []"
	"Timezone at: 'America/New_York' ifAbsent: []"
	"Timezone at: 'Europe/Prague' ifAbsent: []"
	"Timezone at: 'Luna/Tycho' ifAbsent: []"
	"Timezone allRegisteredKeys"

	^aTimeZoneKey respondsToArithmetic 
		ifTrue: [(DurationFactory seconds: aTimeZoneKey) asTimezone]
		ifFalse: [VariableOffsetTimezone at: aTimeZoneKey ifAbsent: absentAction]! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
atAbbreviation: commonTzAbbreviation dstPreferred: dstPreferred ifAbsent: absentAction 
	"Answer the Olson time zone mapped to the time zone abbreviation <commonTzAbbreviation> by the current default TimeZoneLocalizationPolicy, with a preference for a time zone that observes DST if <dstPreferred> is true, but otherwise with a preference for a time zone that does not observe DST. A time zone whose DST behavior matches the specified preference may or may not be availlable; if it is not, then one will be answered with whatever DST behavior is available for <commonTzAbbreviation>.  If the default TimeZoneLocalizationPolicy defines no  mapping for <commonTzAbbreviation> (or if the mapping specifies a non-existent Olson time zone,) answer the result of evaluating <absentAction>."

	"Timezone atAbbreviation: #HOVT dstPreferred: true ifAbsent: []"
	"Timezone atAbbreviation: #MST dstPreferred: false ifAbsent: []"
	"Timezone atAbbreviation: #MST dstPreferred: true ifAbsent: []"

	^self 
		atAbbreviation: commonTzAbbreviation
		usingLocalizationPolicy: TimeZoneLocalizationPolicy default
		dstPreferred: dstPreferred
		ifAbsent: absentAction! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
atAbbreviation: commonTzAbbreviation inLocale: aChronosLocale dstPreferred: dstPreferred ifAbsent: absentAction 
	"Answer the Olson time zone mapped to the time zone abbreviation <commonTzAbbreviation> by <aChronosLocale>'s TimeZoneLocalizationPolicy, with a preference for a time zone that observes DST if <dstPreferred> is true, but otherwise with a preference for a time zone that does not observe DST. A time zone whose DST behavior matches the specified preference may or may not be availlable; if it is not, then one will be answered with whatever DST behavior is available for <commonTzAbbreviation>.  If <aChronosLocale>'s TimeZoneLocalizationPolicy defines no  mapping for <commonTzAbbreviation> (or if the mapping specifies a non-existent Olson time zone,) answer the result of evaluating <absentAction>."

	"Timezone atAbbreviation: #EST inLocale: #en_AU dstPreferred: true ifAbsent: []"
	"Timezone atAbbreviation: #EST inLocale: #en_US dstPreferred: false ifAbsent: []"
	"Timezone atAbbreviation: #EST inLocale: #en_US dstPreferred: true ifAbsent: []"
	"Timezone atAbbreviation: #PST inLocale: #en_CA dstPreferred: true ifAbsent: []"

	^self 
		atAbbreviation: commonTzAbbreviation
		usingLocalizationPolicy: (ChronosLocale referencedBy: aChronosLocale) timeZoneLocalizationPolicy
		dstPreferred: dstPreferred
		ifAbsent: absentAction! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
atAbbreviation: commonTzAbbreviation usingLocalizationPolicy: aTimeZoneLocalizationPolicy dstPreferred: dstPreferred ifAbsent: absentAction 
	"Answer the Olson time zone mapped to the time zone abbreviation <commonTzAbbreviation> by <aTimeZoneLocalizationPolicy>, with a preference for a time zone that observes DST if <dstPreferred> is true, but otherwise with a preference for a time zone that does not observe DST. A time zone whose DST behavior matches the specified preference may or may not be availlable; if it is not, then one will be answered with whatever DST behavior is available for <commonTzAbbreviation>.  If <aTimeZoneLocalizationPolicy> defines no  mapping for <commonTzAbbreviation> (or if the mapping specifies a non-existent Olson time zone,) answer the result of evaluating <absentAction>."

	"Timezone atAbbreviation: #CET 		usingLocalizationPolicy: TimeZoneLocalizationPolicy root 			dstPreferred: true 	ifAbsent: []"
	"Timezone atAbbreviation: #EET 		usingLocalizationPolicy: TimeZoneLocalizationPolicy root 			dstPreferred: true 	ifAbsent: []"
	"Timezone atAbbreviation: #HAST 	usingLocalizationPolicy: TimeZoneLocalizationPolicy unitedStates dstPreferred: true 	ifAbsent: []"
	"Timezone atAbbreviation: #HAST 	usingLocalizationPolicy: TimeZoneLocalizationPolicy unitedStates dstPreferred: false 	ifAbsent: []"
	"Timezone atAbbreviation: #CST 		usingLocalizationPolicy: TimeZoneLocalizationPolicy root			dstPreferred: true 	ifAbsent: []"
	"Timezone atAbbreviation: #CST 		usingLocalizationPolicy: TimeZoneLocalizationPolicy unitedStates dstPreferred: true 	ifAbsent: []"

	^self 
		at: ((TimeZoneLocalizationPolicy referencedBy: aTimeZoneLocalizationPolicy) 
				defaultTimeZoneKeyWithCommonAbbreviation: commonTzAbbreviation asSymbol
				dstPreferred: dstPreferred
				ifAbsent: [^absentAction value])
		ifAbsent: absentAction! !

!ChronosTimezone class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!ChronosTimezone class methodsFor: 'private-bound, dynamic time zones' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
bindingForKey: timeZoneKey offsetSecondsFromUT: offsetSeconds stdTimeOffsetSecondsFromUT: stdTimeOffsetSeconds commonAbbreviation: abbreviation 
	"Answer a `bound, dynamic` ChronosTimezone whose time zone key is <timeZoneKey>, whose offset (in seconds) from UT is <offsetSeconds>, whose offset (in seconds) from UT when `standard time` is in effect is <stdTimeOffsetSeconds> and whose common abbreviation is <abbreviation>. The `root time zone` of <anAnnuallyRecurringTZPolicy> ('anAnnuallyRecurringTZPolicy root') is the ChronosTimezone that a) defines the instance's key (identity,) and b) defines the full diachronic ruleset of the time zone for which the instance defines but a single atomic component."

	| registrationKey subRegistry offsetDeltaSeconds binding bindingKey |
	registrationKey := self bindingRegistryKeyForTimeZoneKey: timeZoneKey
				commonAbbreviation: abbreviation.
	subRegistry := self bindingRegistry at: registrationKey
				ifAbsentPut: [EnvironmentFacade current newWeakDictionary].
	offsetDeltaSeconds := offsetSeconds - stdTimeOffsetSeconds.
	binding := subRegistry at: (bindingKey := offsetDeltaSeconds * SecondsPerDay + offsetSeconds) ifAbsent: [0].
	(binding == nil or: [binding = 0])
		ifTrue:
			[subRegistry 
				at: bindingKey
				put: (binding := 
							self 
								newBindingForKey: timeZoneKey
								offsetSecondsFromUT: offsetSeconds
								stdTimeOffsetSecondsFromUT: stdTimeOffsetSeconds
								commonAbbreviation: abbreviation)].
	^binding! !

!ChronosTimezone class methodsFor: 'private-bound, dynamic time zones' stamp: ''!
bindingRegistry
	BindingRegistry == nil ifTrue: [BindingRegistry := IdentityDictionary new].
	^BindingRegistry! !

!ChronosTimezone class methodsFor: 'private-bound, dynamic time zones' stamp: ''!
bindingRegistryKeyForTimeZoneKey: aTimeZoneKey commonAbbreviation: abbreviation
	| stream |
	stream := (String new: 37) writeStream.
	stream
		nextPutAll: (aTimeZoneKey isString ifTrue: [aTimeZoneKey] ifFalse: [aTimeZoneKey printString]);
		nextPut: $:;
		nextPutAll: abbreviation.
	^stream contents asSymbol! !

!ChronosTimezone class methodsFor: 'queries' stamp: ''!
canonicalKeyAt: aKey ifNone: ifNone
	^TimeZonePolicyFactory canonicalKeyAt: aKey ifNone: ifNone! !

!ChronosTimezone class methodsFor: 'examples' stamp: ''!
commonWorldTimezones
	"ChronosTimezone commonWorldTimezones"

	^#('Pacific/Auckland' 'Australia/Sydney' 'Asia/Tokyo' 'Australia/Perth' 'Asia/Hong_Kong' 'Asia/Calcutta' 'Europe/Moscow' 
	'Asia/Jerusalem' 'Europe/Amsterdam' 'Europe/London' UT 'America/Sao_Paulo' 'America/Argentina/Buenos_Aires'
	'America/New_York' 'America/Chicago' 'America/Denver' 'America/Los_Angeles' 'Pacific/Honolulu') 
		collect: [:tzKey | self at: tzKey]! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
default
	"Answer the Chronos `default time zone` that implements the `implementation-defined local time` as specified and required by the ANSI-Smalltalk Standard.  The Chronos default time zone will be identical to the Chronos system time zone, unless the default time zone is explicitly (programmatically) set to a different value."

	"Timezone default"

	Default == nil ifTrue: [^self system].
	^Default! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
gmt
	"Answer the time zone that defines Universal Time--the international reference zero-offset time zone."

	"Timezone gmt"

	^self universal! !

!ChronosTimezone class methodsFor: 'class initialization' stamp: ''!
initialize
	"ChronosTimezone initialize" 

	Universal := nil.
	Nominal := nil.
	AlwaysSystem := nil.
	AlwaysDefault := nil.
	self invalidateSystemTimezone.
	self invalidateDefaultTimezone.! !

!ChronosTimezone class methodsFor: 'class initialization' stamp: ''!
invalidate
	"ChronosTimezone invalidate" 

	self initialize.
	VariableOffsetTimezone invalidate.! !

!ChronosTimezone class methodsFor: 'class initialization' stamp: ''!
invalidateBoundDynamicFlyweights
	"Discard any cached `bound, dynamic` time zone instances from the registry (does not affect operational correctness.)"

	BindingRegistry := nil! !

!ChronosTimezone class methodsFor: 'class initialization' stamp: ''!
invalidateDefaultTimezone
	"Reset the receiver's reference to the default time zone (idempotent.)"
	"Timezone invalidateDefaultTimezone"

	Default == nil 
		ifFalse: 
			[Default
				invalidatePolicy;
				register]! !

!ChronosTimezone class methodsFor: 'class initialization' stamp: ''!
invalidateOffsetFlyweights
	"Discard any cached offsets from the registry (does not affect operational correctness.)"

	OffsetRegistry := nil! !

!ChronosTimezone class methodsFor: 'class initialization' stamp: ''!
invalidateSystemTimezone
	"Reset the receiver's reference to the system time zone (idempotent.)"

	"Timezone invalidateSystemTimezone"

	System := nil! !

!ChronosTimezone class methodsFor: 'instance creation' stamp: ''!
key: aKey name: aStringOrSymbol initialOffset: offset1FromUT withAbbreviation: abbreviation1 until: annualTransitionDate1 at: timeOfDay1 relativity: relativity1 thenOffset: offset2FromUT withAbbreviation: abbreviation2 until: annualTransitionDate2 at: timeOfDay2 relativity: relativity2 
	"Answer a new `unbound, dynamic` ChronosTimezone with one inter-year ruleset consisting of two intra-year offset/abbreviation transitions that repeat annually. The answered instance's single inter-year ruleset with two intra-year annual transitions will apply every year, from the infinite past to the infinite future. The answered instance will have the specfied <key> and <name> (Symbols or Strings; the keys #alwaysSystem, #alwaysDefault and #nominal are not allowed.) The name may nil, in which case the answered instance's name will be its key.

	From the beginning of the year until the first offset/abbreviation transition, the answered instance's offset from UT will be <offset1FromUT> (a Duration) and its abbreviation will be <abbreviation1> (a Symbol.)  The first transtion will occur on <annualTransitionDate1> (an AnnualDate) at <timeOfDay1> (a TimeOfDay).  If <relativity1> == #nominal, then the specified date and time of the first transition reflect local `wall clock` time as defined by the answered instance.   If <relativity1> == #standard, then the specified date and time of the first transition reflect local `standard time` as defined by the answered instance (i.e., without DST.)  If <relativity1> == #universal, then the specified date and time reflect the Universal Time when the first transition occurs.

	From the first offset/abbreviation transition until the second offset/abbreviation transition,  the answered instance's offset from UT will be <offset2FromUT> (a Duration) and its abbreviation will be <abbreviation2> (a Symbol.)  The second transtion will occur on <annualTransitionDate2> (an AnnualDate) at <timeOfDay2> (a TimeOfDay).  If <relativity2> == #nominal, then the specified date and time of the second transition reflect local `wall clock` time as defined by the answered instance.   If <relativity2> == #standard, then the specified date and time of the second transition reflect local `standard time`  as defined by the answered instance (i.e., without DST.)  If <relativity2> == #universal, then the specified date and time reflect the Universal Time when the second transition occurs.

	After the second offset/abbreviation transition and until the end of the year,  the answered instance's offset from UT will again be <offset1FromUT> (a Duration) and its abbreviation will again be <abbreviation2> (a Symbol.) 

	HOWEVER, the parameters may be supplied in inverted order: If <annualTransitionDate1> occurs later in the year than <annualTransitionDate2>, then the role of <offset1FromUT> is swapped with that of <offset2FromUT>, the role of <abbreviation1> is swapped with that of <abbreviation2>, the role of <annualTransitionDate1> is swapped with that of <annualTransitionDate2>, the role of <timeOfDay1> is swapped with that of <timeOfDay2> and the role of <relativity1> is swapped with that of <relativity2>"

	"{(Timezone
		key: #myOwnPrivateTimeZone name: #NorthernHemispereInvertedOrder
		initialOffset: (Duration hours: -7) withAbbreviation: #WDT 
			until: (WeekOfMonthDayOfWeek month: 11 week: 0 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #nominal
		thenOffset: (Duration hours: -8)  withAbbreviation: #WST  
			until: (WeekOfMonthDayOfWeek month: 3 week: 1 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #standard) 
				nowToTheSecond printStringUsing: #verbose}"

	"{(Timezone
		key: #someonElsesPrivateTimeZone name: #SouthernHemisphereNormalOrder
		initialOffset: (Duration hours: 10) withAbbreviation: #WADT 
			until: (WeekOfMonthDayOfWeek month: 4 week: 0 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #universal
		thenOffset: (Duration hours: 9)  withAbbreviation: #WAST  
			until: (WeekOfMonthDayOfWeek month: 9 week: 1 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #universal)
				nowToTheSecond literalArrayEncoding decodeAsLiteralArray printStringUsing: #verbose}"

	^VariableOffsetTimezone 
		key: aKey
		name: aStringOrSymbol
		initialOffset: offset1FromUT
		withAbbreviation: abbreviation1
		until: annualTransitionDate1
		at: timeOfDay1
		relativity: relativity1
		thenOffset: offset2FromUT
		withAbbreviation: abbreviation2
		until: annualTransitionDate2
		at: timeOfDay2
		relativity: relativity2! !

!ChronosTimezone class methodsFor: 'private' stamp: ''!
newAlwaysDefault
	^AlwaysDefaultTZ
		new beImmutable! !

!ChronosTimezone class methodsFor: 'private' stamp: ''!
newAlwaysSystem
	^AlwaysSystemTZ
		new beImmutable! !

!ChronosTimezone class methodsFor: 'private-bound, dynamic time zones' stamp: ''!
newBindingForKey: aTimeZoneKey offsetSecondsFromUT: offsetSeconds stdTimeOffsetSecondsFromUT: stdTimOffsetSeconds commonAbbreviation: abbreviation 
	"Answer a new `bound, dynamic` ChronosTimezone whose time zone key is <aTimeZoneKey>, whose offset (in seconds) from UT is <offsetSeconds>, whose offset (in seconds) from UT when `standard time` is in effect is <stdTimeOffsetSeconds> and whose common abbreviation is <abbreviation>. The `root time zone` of <anAnnuallyRecurringTZPolicy> ('anAnnuallyRecurringTZPolicy root') is the ChronosTimezone that a) defines the instance's key (identity,) and b) defines the full diachronic ruleset of the time zone for which the instance defines but a single atomic component."

	^offsetSeconds = stdTimOffsetSeconds 
		ifTrue: 
			[StandardTime new
				setKey: aTimeZoneKey
					offsetSeconds: offsetSeconds
					commonAbbreviation: abbreviation;
				beImmutable]
		ifFalse: 
			[NonStandardTime new
				setKey: aTimeZoneKey
					offsetSeconds: offsetSeconds
					stdTimeOffsetSeconds: stdTimOffsetSeconds
					commonAbbreviation: abbreviation;
				beImmutable]! !

!ChronosTimezone class methodsFor: 'private' stamp: ''!
newNominalTimeInvariantTZ
	^NominalTime new! !

!ChronosTimezone class methodsFor: 'private' stamp: ''!
newUniversalTime
	^UniversalTime 
		new beImmutable! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
nominal
	"Answer the time zone that defines/specifies nominal time invariance."

	"Timezone nominal"

	Nominal == nil ifTrue: [Nominal := self newNominalTimeInvariantTZ].
	^Nominal! !

!ChronosTimezone class methodsFor: 'instance creation' stamp: ''!
offset: aDuration
	"Answer a `bound, static` ChronosTimezone whose offset from UT is <aDuration>."

	"{Timezone ofset: (Duration hours: -7)}"

	^BasicTimezone offset: aDuration! !

!ChronosTimezone class methodsFor: 'instance creation' stamp: ''!
offset: aDuration commonAbbreviation: aSymbol
	"Answer a `bound, static` ChronosTimezone whose offset from UT is <aDuration> and whose common abbreviation is <aSymbol>."

	"{Timezone
		offset: (Duration hours: -7)
		commonAbbreviation: #MST}"

	^BasicTimezone
		offset: aDuration 
		commonAbbreviation: aSymbol! !

!ChronosTimezone class methodsFor: 'instance creation' stamp: ''!
offset: aDuration name: aStringOrSymbol commonAbbreviation: aSymbol 
	"Answer a `bound, static` ChronosTimezone whose offset from UT is <aDuration>, whose name is <aStringOrSymbol> and whose common abbreviation is <aSymbol>."

	"{Timezone
		offset: (Duration hours: -7)
		name: 'US Mountain Time (Arizona)'
		commonAbbreviation: #MST}"

	^BasicTimezone 
		offset: aDuration
		name: aStringOrSymbol
		commonAbbreviation: aSymbol! !

!ChronosTimezone class methodsFor: 'private' stamp: ''!
offsetFromSeconds: seconds
	| offset |
	offset := self offsetRegistry at: seconds ifAbsent: [0].
	(offset == nil or: [offset = 0])
		ifTrue: [self offsetRegistry at: seconds put: (offset := (seconds = 0 ifTrue: [ZeroDuration] ifFalse: [DurationFactory seconds: seconds]))].
	^offset
	

	"^seconds = 0 ifTrue: [ZeroDuration] ifFalse: [DurationFactory seconds: seconds]"! !

!ChronosTimezone class methodsFor: 'private' stamp: ''!
offsetRegistry
	OffsetRegistry == nil ifTrue: [OffsetRegistry := EnvironmentFacade current newWeakDictionary].
	^OffsetRegistry! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
referencedBy: aTimeZoneOrTimeZoneKey 
	"Anser the value referenced by <aChronosObjectOrChronosObjectLiteralString>. If the value is a key, answer the value bound to the key. If the value is a literal representation of a value encoded as a String, answer the result of decoding the value encoded by the String.  Otherwise, answer aChronosObjectOrChronosObjectLiteralString itself."

	^aTimeZoneOrTimeZoneKey == nil 
		ifTrue: [self default]
		ifFalse: 
			[(aTimeZoneOrTimeZoneKey isString or: [aTimeZoneOrTimeZoneKey respondsToArithmetic])
				ifTrue: [self at: aTimeZoneOrTimeZoneKey]
				ifFalse: [aTimeZoneOrTimeZoneKey asTimezone root]]! !

!ChronosTimezone class methodsFor: 'private' stamp: ''!
resolveSystem
	^ChronosSystemFacade current systemTimeZone! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
system
	"Answer the Chronos `system time zone` that is intended to match the behavior of the host system's local time zone as cloesely as possible.  The Chronos system time zone will be identical to the Chronos default time zone, unless the Chronos default time zone is explicitly (programmatically) set to a different value.

	The Chronos system time zone may be explicitly (programatically) set to any Chronos time zone, regardless of the time zone used by the host system to define local time.  Doing so may or may not also change the host system's local time zone, depending on the specific implementation of the current ChronosSystemFacade singleton.  Also, when an image is restarted, the current ChronosSystemFacade singleton may reset the Chronos system time zone to match the host system's local time zone (as best it can,) but how and whether that happens depends upon both its current system-time-zone-binding strategy (which is programatically settable) and its specific implementation (which varies from one environment/platform to another.)"

	"Timezone system"

	System == nil 
		ifTrue: 
			[System := self resolveSystem.
			System register].
	^System! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
universal
	"Answer the time zone that defines Universal Time--the international reference zero-offset time zone."

	"Timezone universal"

	Universal == nil ifTrue: [Universal := self newUniversalTime].
	^Universal! !

!ChronosTimezone class methodsFor: 'accessing' stamp: ''!
ut
	"Answer the time zone that defines Universal Time--the international reference zero-offset time zone."

	"Timezone ut"

	^self universal! !

!ChronosTimezone methodsFor: 'comparing' stamp: ''!
= aMagnitude 
	"Answer whether the receiver is equal to the argument."

	self == aMagnitude ifTrue: [^true].
	^[aMagnitude isEqualToTimezone: self]
		on: MessageNotUnderstood
		do: [:ex | 
			(ex receiver == aMagnitude and: [ex message selector == #isEqualToTimezone:])
				ifTrue: [ex return: false]
				ifFalse: [ex pass]]! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
aliasingKeys
	^Set new! !

!ChronosTimezone methodsFor: 'queries' stamp: ''!
annualPolicyForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in local time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct annual policy, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UTC for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day in local time (without any need to consider standard versus daylight saving time.)"

	^self defaultAnnualPolicy! !

!ChronosTimezone methodsFor: 'queries' stamp: ''!
annualPolicyForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in Universal Time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct annual policy, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UT for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day as UT (without any need to consider standard versus daylight saving time.)"

	^self defaultAnnualPolicy! !

!ChronosTimezone methodsFor: 'converting' stamp: ''!
asNative
	"Answer the conversion of the receiver into whatever object/value would canonically be used by the host Smalltalk implementation to name/identify a time zone as equivalent to the receiver as is possible. If there is no such value, or if Chronos is the native date/time library of the host environment, answer the receiver."

	^ChronosSystemFacade current nativeTimeZoneFromChronosTimeZone: self! !

!ChronosTimezone methodsFor: 'converting' stamp: ''!
asNonProxy
	"Answer the time zone to which the receiver indirectly refers by proxy.  If the receiver is not a proxy for a time zone other than itself, answer the receiver."

	^self! !

!ChronosTimezone methodsFor: 'converting' stamp: ''!
asTimezone
	"Answer the conversion of the receiver into a time zone it either references or describes. If the receiver is itself a time zone, answer the receiver."

	^self! !

!ChronosTimezone methodsFor: 'converting' stamp: ''!
asUnbound
	"Answer the unbound time zone that specifies the full diachronic ruleset of the time zone represented by the receiver."

	^self! !

!ChronosTimezone methodsFor: 'initialize-release' stamp: ''!
beDefault
	"Set the receiver as the default time zone. If the receiver is the system time zone, cause the default time zone to virtually shadow the system time zone, so that whenever the system time zone is set to a different value, the default time zone is also set to the same new value."

	self == System ifTrue: [Default := nil] ifFalse: [Default := self canonical]! !

!ChronosTimezone methodsFor: 'initialize-release' stamp: ''!
beSystem
	"Set the receiver as the system time zone. This operation may or may not affect the host Smalltalk environment and/or the host operating system. See the class of the current ChronosSystemFacade singleton to determine the behavior in the current environment and platform."

	ChronosSystemFacade current 
		systemTimeZone: self! !

!ChronosTimezone methodsFor: 'queries' stamp: ''!
binding
	"Answer the bound timezone referenced by the receiver.  If there is none, answer nil."

	^nil! !

!ChronosTimezone methodsFor: 'queries' stamp: ''!
bindingForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in the local time defined by the receiver.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in local (`wall clock`) time as defined by the receiver."

	^self! !

!ChronosTimezone methodsFor: 'queries' stamp: ''!
bindingForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in Universal Time.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in Universal Time."

	^self! !

!ChronosTimezone methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's class whose value is equivalent to that of the receiver's."

	^self! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
canonicalKey
	^self key! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
comparisonClassIdentifier	
	"Answer a value that identifies the group of comparable values to which the receiver belongs.  The value might be a Smalltalk class, or might be a Symbol, or might be something else."

	^#timezone! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
dateToday
	"Answer the YearMonthDay (bound to the Gregorian Calendar) that designates today's date in the local time defined by the receiver."

	"Timezone default dateToday"

	^(AnsiStandardCalendarClock mutableDateTodayIn: self) beImmutable! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
dateTodayAs: calendarOrCalendarReference
	"Answer the YearMonthDay (bound to the specified <calendarOrCalendarReference>) that designates today's date in the local time defined by the receiver."

	"Timezone default dateTodayAs: #Persian"

	^((Calendar referencedBy: calendarOrCalendarReference) clock mutableDateTodayIn: self) beImmutable! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
defaultAnnualPolicy
	"Answer the AnnuallyRecurringTZPolicy that specifies the time zone rules that are in effect during the current year."

	^self subclassResponsibility! !

!ChronosTimezone methodsFor: 'private' stamp: ''!
defaultName
	^self defaultNameIfNone: [self zuluNotation]! !

!ChronosTimezone methodsFor: 'private' stamp: ''!
defaultNameIfNone: noneBlock
	^self subclassResponsibility! !

!ChronosTimezone methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream nextPut: self literalArrayEncodingOfKey! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
hasSubsecondOffset
	"Answer whether the receiver has fractional seconds of offset."

	^false! !

!ChronosTimezone methodsFor: 'comparing' stamp: ''!
hash
	"Answer a SmallInteger that is equal to the hash value of 
	any object that is equal to (=) the receiver. 
	When two objects are not =, their hash values may or may not be the same.
	The hash value may change based on the receiver's contents."

	^self key hash! !

!ChronosTimezone methodsFor: 'printing' stamp: ''!
identityString
	"Timezone default identityString"

	| stream |
	stream := WriteStream on: (String new: 16).
	self isStatic 
		ifTrue: [self printZuluNotationOn: stream]
		ifFalse: [self printKeyOn: stream].
	self specifiesName 
		ifTrue: 
			[stream
				nextPutAll: ' | ';
				nextPutAll: self name].
	^stream contents! !

!ChronosTimezone methodsFor: 'initialize-release' stamp: ''!
invalidatePolicy 
	"By default, do nothing"! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isAlwaysDefault
	"Answer whether the receiver is the `always default` time zone."

	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isAlwaysSystem
	"Answer whether the receiver is the `always system` time zone."

	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isBound
	"Answer whether the receiver is a bound time zone. A bound time zone is one that defines a single offset/abbreviation tuple, and that conforms to the `BOUND TIMEZONE API` (as defined in the class comment.)"

	^self subclassResponsibility! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isDefault
	"Answer whether the receiver is the default time zone."

	^self == self class default! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isDynamic
	"Answer whether or not the timezone policy (key, offset, name and abbreviation) of the timezone represented by the receiver is subject to retroactive revision."

	^self isStatic not! !

!ChronosTimezone methodsFor: 'private-comparing' stamp: ''!
isEqualToTimezone: aTimezone 
	^self key = aTimezone key! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isInvariantToNominalTime
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to nominal time."

	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isInvariantToUT
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to Universal Time."

	^true! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isProxy
	"Answer whether the receiver operates as an indirect reference to some other time zone."

	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isProxyAndInvariantToUT
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to Universal Time, and whether the receiver operates as an indirect reference to some other time zone (if both are true, answer true, otherwise answer false.)"

	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isProxyOrStatic
	"Answer whether the receiver is either a proxy time zone or a static time zone."

	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isStatic
	"Answer whether or not the timezone policy (key, offset, name and abbreviation) of the timezone represented by the receiver is invariant, constant and never subject to change or revision.  If the receiver's timezone policy is dynamically redefinable, answer false."

	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isSystem
	"Answer whether the receiver is the system time zone."

	^self == self class system! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isTimezone
	^true! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
isUniversalTime
	"Anwser whether the receiver has all the properties and behaviors of the international reference zero-offset time zone."

	^false! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
key
	"Answer the key that identifies the receiver."

	^self subclassResponsibility! !

!ChronosTimezone methodsFor: 'private' stamp: ''!
keyIsAlias
	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
keyIsGlobal
	"Answer whether the receiver's identifying key is a globally well-known value."

	^true! !

!ChronosTimezone methodsFor: 'private' stamp: ''!
literalArrayEncodingOfKey
	^self key! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
name
	"Answer the name of the receiver."

	^self nameIfNone: [self zuluNotation]! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
nameIfNone: noneBlock
	"Answer the name of the receiver."

	^self defaultNameIfNone: noneBlock! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
namespaceIfNone: block0
	^self keyIsGlobal ifTrue: [self class] ifFalse: [block0 value]! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
namespaceKey
	^self subclassResponsibility! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
now
	"Answer the Timepoint (bound to the Gregorian Calendar) that designates the current date and time in the local time defined by the receiver."

	"Timezone default now"

	^AnsiStandardCalendarClock nowIn: self! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
nowAs: calendarOrCalendarReference
	"Answer the Timepoint (bound to the specified <calendarOrCalendarReference>) that designates the current date and time in the local time defined by the receiver."

	"Timezone default nowAs: #Persian"

	^(Calendar referencedBy: calendarOrCalendarReference) clock nowIn: self! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
nowToTheSecond
	"Answer the Timepoint (bound to the Gregorian Calendar) that designates the current date and time at the start of the current second in the local time defined by the receiver."

	"Timezone default nowToTheSecond"

	^AnsiStandardCalendarClock nowToTheSecondIn: self! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
nowToTheSecondAs: calendarOrCalendarReference 
	"Answer the Timepoint (bound to the specified <calendarOrCalendarReference>) that designates the current date and time at the start of the current second in the local time defined by the receiver."

	"Timezone default nowToTheSecondAs: #Hebrew"

	^(Calendar referencedBy: calendarOrCalendarReference) clock 
		nowToTheSecondIn: self! !

!ChronosTimezone methodsFor: 'printing' stamp: ''!
printIdentificationOn: stream
	stream
		crtab;
		nextPutAll: 'key='.
	self printKeyOn: stream.	
	self specifiesName 
		ifTrue: 
			[stream
				crtab;
				nextPutAll: 'name=';
				nextPutAll: self name]! !

!ChronosTimezone methodsFor: 'printing' stamp: ''!
printKeyOn: stream
	stream nextPutAll: self key! !

!ChronosTimezone methodsFor: 'printing' stamp: ''!
printOn: stream
	stream nextPut: ${.
	self printTypeOn: stream.
	self printIdentificationOn: stream.
	self printPolicyOn: stream.
	stream nextPut: $}! !

!ChronosTimezone methodsFor: 'printing' stamp: ''!
printPolicyOn: stream 
	self specifiesAbbreviation 
		ifTrue: 
			[stream
				crtab;
				nextPutAll: 'abbreviation=';
				nextPutAll: self abbreviation].
	stream
		crtab;
		nextPutAll: 'offsetFromUT='.
	self printOffsetOn: stream.! !

!ChronosTimezone methodsFor: 'printing' stamp: ''!
printTypeOn: stream
	stream nextPutAll: self class name! !

!ChronosTimezone methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	^self subclassResponsibility! !

!ChronosTimezone methodsFor: 'initialize-release' stamp: ''!
register
	"By default, do nothing"! !

!ChronosTimezone methodsFor: 'converting' stamp: ''!
renamedTo: newName
	"Answer an immutable copy of the receiver whose name will be <newName>."

	^self copy
		setName: newName;
		beImmutable! !

!ChronosTimezone methodsFor: 'accessing' stamp: ''!
root

	^self! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
specifiesAbbreviation
	^self specifiesCommonAbbreviation! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation
	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
specifiesGeographicCoordinates
	^false! !

!ChronosTimezone methodsFor: 'testing' stamp: ''!
specifiesName
	^false! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
timeOfDayNow
	"Answer the TimeOfDay that designates the current time-of-day according to the Gregorian Calendar in the local time defined by the receiver."

	"Timezone default timeOfDayNow"

	^AnsiStandardCalendarClock timeOfDayNowIn: self! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
timeOfDayNowAs: calendarOrCalendarReference
	"Answer the TimeOfDay that designates the current time-of-day according to the specified <calendarOrCalendarReference> in the local time defined by the receiver."

	"Timezone default timeOfDayNowAs: #Ethiopic" "(The time-of-day clock of the Ethiopic Calendar starts at sunrise--6am.)"

	^(Calendar referencedBy: calendarOrCalendarReference) clock timeOfDayNowIn: self! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
timeOfDayNowToTheSecond
	"Answer the TimeOfDay that designates the current time-of-day at the start of the current second according to the Gregorian Calendar in the local time defined by the receiver."

	"Timezone default timeOfDayNowToTheSecond"

	^AnsiStandardCalendarClock timeOfDayNowToTheSecondIn: self! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
timeOfDayNowToTheSecondAs: aCalendarOrCalendarReference
	"Answer the TimeOfDay that designates the current time-of-day at the start of the current second according to the specified <calendarOrCalendarReference> in the local time defined by the receiver."

	"Timezone default timeOfDayNowToTheSecondAs: #Ethiopic" "(The time-of-day clock of the Ethiopic Calendar starts at sunrise--6am.)"

	^(Calendar referencedBy: aCalendarOrCalendarReference) clock timeOfDayNowToTheSecondIn: self! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
today
	"Answer the Timepoint (bound to the Gregorian Calendar) that designates the first moment of today's date in the local time defined by the receiver."

	"Timezone default today"

	^AnsiStandardCalendarClock basicTodayIn: self! !

!ChronosTimezone methodsFor: 'date/time-current time' stamp: ''!
todayAs: calendarOrCalendarReference
	"Answer the Timepoint (bound to the specified <calendarOrCalendarReference>) that designates the first moment of today's date (as defined by the specified <calendarOrCalendarReference>) in the local time defined by the receiver."

	"Timezone default todayAs: Julian"

	^(Calendar referencedBy: calendarOrCalendarReference) clock basicTodayIn: self! !

ChronosTimezone subclass: #ProxyTZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!ProxyTZ commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ProxyTZ

	Concept:

		ProxyTZ is an abstract class that provides inheritable behavior appropriate for implementing "proxy" time zones. A "proxy" timezone is one that serves as an indirect reference to some other timezone. Proxy timezones are useful for cases where it is desirable that the local time of a point-in-time value dynamically change to reflect whatever timezone is currently set as the local timezone.  

		Chronos defines three standard "proxy" timezones: <Timezone alwaysSystem>, <Timezone alwaysDefault> and <Timezone nominal>.

		For further information, see AlwaysDefaultTZ, AlwaysSystemTZ, NominalTime and ChronosTimezone.

	Usage:

		A ProxyTZ conforms to both the Chronos "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

	Subclassing:

		Concrete subclasses must sumplimplement the instance method #delegate
!

ProxyTZ subclass: #AlwaysDefaultTZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!AlwaysDefaultTZ commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

AlwaysDefaultTZ

	Concept:

		The canonical instance of AlwaysDefaultTZ (accessible by sending the class message #alwaysDefault to ChronosTimezone) refers by proxy to whatever Timezone is currently set as <Timezone default>. A Timepoint with this timezone always represents the same time UT, but its local time is dynamically determined by whatever Timezone is set as the current default timezone--in other words, its UT time is invariant, but its local time varies dynamically as a function of any change to whichever timezone == Timezone default.

		See ProxyTZ and ChronosTimezone for further information.

	Usage:

		An AlwaysDefaultTZ conforms to the Chronos "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		The key of the "always default" time zone is #alwaysDefault.

	Motivation:

		The "always default" time zone enables the presentation of point-in-time values as local to whatever time zone is currently set as the default.


!

!AlwaysDefaultTZ class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self alwaysDefault! !

!AlwaysDefaultTZ class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Anser the canonical key that uniquely identifies the receiver's canonical instance."

	^#alwaysDefault! !

!AlwaysDefaultTZ methodsFor: 'converting' stamp: ''!
asNonProxy
	"Answer the time zone to which the receiver indirectly refers by proxy.  If the receiver is not a proxy for a time zone other than itself, answer the receiver."

	^ChronosTimezone default! !

!AlwaysDefaultTZ methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's class whose value is equivalent to that of the receiver's."

	^ChronosTimezone alwaysDefault! !

!AlwaysDefaultTZ methodsFor: 'private' stamp: ''!
defaultNameIfNone: noneblock
	^'Dynamic Local Time (User)'! !

!AlwaysDefaultTZ methodsFor: 'testing' stamp: ''!
isAlwaysDefault
	"Answer whether the receiver is the `always default` time zone."

	^true! !

!AlwaysDefaultTZ methodsFor: 'testing' stamp: ''!
isDefault
	"Answer whether the receiver is the default time zone."

	^true! !

!AlwaysDefaultTZ methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processAlwaysDefaultTZ: self! !

ProxyTZ subclass: #AlwaysSystemTZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!AlwaysSystemTZ commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

AlwaysSystemTZ

	Concept:

		The canonical instance of AlwaysSystemTZ (accessible by sending the class message #alwaysSystem to ChronosTimezone) refers by proxy to whatever Timezone is currently set as <Timezone system>. A Timepoint with this timezone always represents the same time UT, but its local time is dynamically determined by whatever Timezone is set as the current system timezone--in other words, its UT time is invariant, but its local time varies dynamically as a function of any change to whichever timezone == Timezone system.

		See ProxyTZ and ChronosTimezone for further information.

	Usage:

		An AlwaysSystemTZ conforms to the Chronos "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		The key of the "always system" time zone is #alwaysSystem.

	Motivation:

		The "always system" time zone enables the presentation of point-in-time values as local to whatever time zone is currently set as the system time zone.
!

!AlwaysSystemTZ class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self alwaysSystem! !

!AlwaysSystemTZ class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Anser the canonical key that uniquely identifies the receiver's canonical instance."

	^#alwaysSystem! !

!AlwaysSystemTZ methodsFor: 'converting' stamp: ''!
asNonProxy
	"Answer the time zone to which the receiver indirectly refers by proxy.  If the receiver is not a proxy for a time zone other than itself, answer the receiver."

	^ChronosTimezone system! !

!AlwaysSystemTZ methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's class whose value is equivalent to that of the receiver's."

	^ChronosTimezone alwaysSystem! !

!AlwaysSystemTZ methodsFor: 'private' stamp: ''!
defaultNameIfNone: noneblock
	^'Dynamic Local Time (System)'! !

!AlwaysSystemTZ methodsFor: 'testing' stamp: ''!
isAlwaysSystem
	"Answer whether the receiver is the `always system` time zone."

	^true! !

!AlwaysSystemTZ methodsFor: 'testing' stamp: ''!
isSystem
	"Answer whether the receiver is the system time zone."

	^true! !

!AlwaysSystemTZ methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processAlwaysSystemTZ: self! !

ProxyTZ subclass: #NominalTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!NominalTime commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

NominalTime

	Concept:

		The canonical instance of NominalTime is accessible by sending the class message #nominal to ChronosTimezone ("Timezone nominal.")
				
		An instance of NominalTime implements nominal time. A point-in-time value bound to a NominalTime instance has "nominal-time-invariant" semantics. A point-in-time value with nominal-time-invariant semantics invariantly represents the same local (nominal) time in any time zone, and is therefore said to be "invariant to nominal time." In a sense, <Timezone nominal> refers to no timezone at all --or to any timezone of your choice.

		A point-in-time that is invariant to nominal time represents the same LOCAL time in any and all timezones, and so compares as equal to any other point-in-time whose local (or nominal) time matches the time it nominally designates. Timepoints with any other timezone are invariant to UT, which means that their value relative to other UT-invariant Timepoints is determined by the UT point-in-time they represent, and not by their local time (UT-invariance is the semantics required of points-in-time that conform to the ANSI-Smalltalk <DateAndTime> protocol.) However, for compatibility with UT-invariant Timepoints, Timepoints whose timezone is <Timezone nominal> also behave to some extent as though their timezone were <Timezone default>. So, nominal-time invariant Timepoints always represent THE SAME LOCAL TIME in any and all time zones--in other words, their LOCAL TIME ("nominal time") is INVARIANT, but the UT time they represent varies as a function of the value of 'Timezone default.' 

		Instances of the ST-80 "Date" and "Time" classes, and also instances of the VisualWorks "Timestamp" class, have "nominal-time-invariant" semantics.  Instances of Chronos' DateSpec, DateAndTimeSpec, YearMonthDay and TimeOfDay classes are also invariant to nominal time.

	Usage:

		A NominalTime conforms to the Chronos "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		The key of the "nominal time" time zone is #nominal.

	Motivation:

		The minor motivation for implementing nominal time invariance is for compatibility with date and time values provided by other date/time libraries that also have nominal-time-invariant behavior (an ST80 Date or Time, or a VisualWorks Timestamp, for example.)

		The major motivation for implementing nominal time invariance is so that point-in-time values with nominal-time-invariance can be instantiated that specify the point-in-time of an event that occurs at the same local time in all time zones (or in some set of time zones.) Examples would be the initial moment of New Year's Day, the time that a regularly-scheduled television show begins, a schedule of the first and last momements of a company's regular shift at all locations nationally for the next year, or the moment of insertion of a "rolling" leap second.

		One should take care to use point-in-time values whose time-invariance semantics are correct for the situation at hand.  Getting this wrong is a significant source of bogosity in computer code that deals with time. 

		Consider the following examples:

			1. "Misusing Universal Time Invariance: Christmas Day does NOT include Christmas Day for all time zones (if only you had a dollar for every bug analogous to this one...)"

				| christmasDay |
				christmasDay := 
					Timeperiod 
						startingAt: (Timepoint year: 2005 month: 12 day: 25 hour: 0 minute: 0 second: 0 offset: (Duration hours: -5) " <-- The arrow points to the problem") 
						duration: (Duration days: 1).
				Array
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 21 minute: 0 second: 0 offset: (Duration hours: -8))))
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 12 minute: 0 second: 0 offset: (Duration hours: 0))))
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 0 minute: 0 second: 0 offset: (Duration hours: 10))))

			2. "Correctly Using Nominal-Time-Invariance: Christmas Day DOES include Christmas Day for all time zones (I don't have any dollars for you, but I do have a simple fix for the problem demonstrated above)"

				| christmasDay |
				christmasDay := 
					Timeperiod 
						startingAt: (Timepoint year: 2005 month: 12 day: 25 hour: 0 minute: 0 second: 0 timeZone: Timezone nominal " <-- The arrow points to the solution") 
						duration: (Duration days: 1).
				Array
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 21 minute: 0 second: 0 offset: (Duration hours: -12))))
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 0 minute: 0 second: 0 offset: (Duration hours: 0))))
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 21 minute: 0 second: 0 offset: (Duration hours: 12))))

				

!

!NominalTime class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self nominal! !

!NominalTime class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Anser the canonical key that uniquely identifies the receiver's canonical instance."

	^#nominal! !

!NominalTime methodsFor: 'comparing' stamp: ''!
= aMagnitude 
	"Answer whether the receiver is equal to the argument."

	self == aMagnitude ifTrue: [^true].
	^[aMagnitude isTimezone]
		on: MessageNotUnderstood
		do: [:ex | 
			(ex receiver == aMagnitude and: [ex message selector == #isTimezone])
				ifTrue: [ex return: false]
				ifFalse: [ex pass]]! !

!NominalTime methodsFor: 'converting' stamp: ''!
asNonProxy
	"Answer the time zone to which the receiver indirectly refers by proxy.  If the receiver is not a proxy for a time zone other than itself, answer the receiver."

	^ChronosTimezone default! !

!NominalTime methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's class whose value is equivalent to that of the receiver's."

	^ChronosTimezone nominal! !

!NominalTime methodsFor: 'private' stamp: ''!
defaultNameIfNone: noneblock
	^'Nominal Time'! !

!NominalTime methodsFor: 'private-comparing' stamp: ''!
isEqualToTimezone: aTimezone 
	^true! !

!NominalTime methodsFor: 'testing' stamp: ''!
isInvariantToNominalTime
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to nominal time."

	^true! !

!NominalTime methodsFor: 'testing' stamp: ''!
isInvariantToUT
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to Universal Time."

	^false! !

!NominalTime methodsFor: 'testing' stamp: ''!
isProxyAndInvariantToUT
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to Universal Time, and whether the receiver operates as an indirect reference to some other time zone (if both are true, answer true, otherwise answer false.)"

	^false! !

!NominalTime methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processNominalTime: self! !

!ProxyTZ class methodsFor: 'accessing' stamp: ''!
registrationKey
	"Anser the canonical key that uniquely identifies the receiver's canonical instance."

	^self subclassResponsibility! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
abbreviation
	"Answer the abbreviation for the timezone represented by the receiver--according to the default locale if possible."

	^self asNonProxy abbreviation! !

!ProxyTZ methodsFor: 'queries' stamp: ''!
annualPolicyForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in local time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct annual policy, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UTC for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day in local time (without any need to consider standard versus daylight saving time.)"

	^self asNonProxy 
		annualPolicyForLocalYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!ProxyTZ methodsFor: 'queries' stamp: ''!
annualPolicyForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in Universal Time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct annual policy, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UT for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day as UT (without any need to consider standard versus daylight saving time.)"

	^self asNonProxy 
		annualPolicyForUTYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!ProxyTZ methodsFor: 'converting' stamp: ''!
asNonProxy
	"Answer the time zone to which the receiver indirectly refers by proxy.  If the receiver is not a proxy for a time zone other than itself, answer the receiver."

	^self subclassResponsibility! !

!ProxyTZ methodsFor: 'initialize-release' stamp: ''!
beDefault
	"Set the time zone indirectly referenced by the receiver as the default time zone. If the time zone indirectly referenced by the receiver is the system time zone, cause the default time zone to virtually shadow the system time zone, so that whenever the system time zone is set to a different value, the default time zone is also set to the same new value."

	self asNonProxy beDefault! !

!ProxyTZ methodsFor: 'initialize-release' stamp: ''!
beSystem
	"Set the time zone indirectly referenced by the receiver as the system time zone. This operation may or may not affect the host Smalltalk environment and/or the host operating system. See the class of the current ChronosSystemFacade singleton to determine the behavior in the current environment and platform."

	self asNonProxy beSystem! !

!ProxyTZ methodsFor: 'queries' stamp: ''!
binding
	"Answer the bound timezone referenced by the receiver.  If there is none, answer nil."

	| delegate |
	delegate := self asNonProxy.
	^delegate isBound ifTrue: [delegate binding]! !

!ProxyTZ methodsFor: 'queries' stamp: ''!
bindingForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in the local time defined by the receiver.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in local (`wall clock`) time as defined by the receiver."

	^self asNonProxy bindingForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!ProxyTZ methodsFor: 'queries' stamp: ''!
bindingForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in Universal Time.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in Universal Time."

	^self asNonProxy bindingForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
commonAbbreviation
	"Answer the common abbreviation for the timezone represented by the receiver."

	^self asNonProxy commonAbbreviation! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
defaultAnnualPolicy
	"Answer the AnnuallyRecurringTZPolicy that specifies the time zone rules that are in effect during the current year."

	^self asNonProxy defaultAnnualPolicy! !

!ProxyTZ methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	self beImmutable! !

!ProxyTZ methodsFor: 'testing' stamp: ''!
isBound
	"Answer whether the receiver is a bound time zone. A bound time zone is one that defines a single offset/abbreviation tuple, and that conforms to the `BOUND TIMEZONE API` (as defined in the class comment of ChronosTimezone.)"

	^false! !

!ProxyTZ methodsFor: 'testing' stamp: ''!
isProxy
	"Answer whether the receiver operates as an indirect reference to some other time zone."

	^true! !

!ProxyTZ methodsFor: 'testing' stamp: ''!
isProxyAndInvariantToUT
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to Universal Time, and whether the receiver operates as an indirect reference to some other time zone (if both are true, answer true, otherwise answer false.)"

	^true! !

!ProxyTZ methodsFor: 'testing' stamp: ''!
isProxyOrStatic
	"Answer whether the receiver is either a proxy time zone or a static time zone."

	^true! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
key
	"Answer the key that identifies the receiver."

	^self class registrationKey! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
name
	^self nameIfNone: [self key]! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
nameIfNone: noneBlock
	^ChronosLocale default properNameAtSemanticKey: self key ifAbsent: [self defaultNameIfNone: noneBlock]! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
namespaceKey
	^#proxy! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
offsetFromUT
	^self asNonProxy offsetFromUT! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
offsetSecondsFromUT
	^self asNonProxy offsetSecondsFromUT! !

!ProxyTZ methodsFor: 'printing' stamp: ''!
printOn: stream

	stream nextPutAll: self name.! !

!ProxyTZ methodsFor: 'printing' stamp: ''!
printPolicyOn: stream 
	self asNonProxy printPolicyOn: stream! !

!ProxyTZ methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processProxyTimezone: self! !

!ProxyTZ methodsFor: 'testing' stamp: ''!
specifiesName
	^true! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
stdTimeOffsetFromUT
	^self asNonProxy stdTimeOffsetFromUT! !

!ProxyTZ methodsFor: 'accessing' stamp: ''!
stdTimeOffsetSecondsFromUT
	^self asNonProxy stdTimeOffsetSecondsFromUT! !

ChronosTimezone subclass: #VariableOffsetTimezone
	instanceVariableNames: 'namespaceKey key policy'
	classVariableNames: 'Registry'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!VariableOffsetTimezone commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

VariableOffsetTimezone

	Concept:

		A VariableOffsetTimezone iimplements "unbound, dynamic" time zones.  A "bound" Chronos time zone is one whose single, specific offset-abbreviation tuple is or can be "bound to" (properly associated with) a specific point-in-time.  An "unbound" Chronos time zone is one that does NOT specify a single, specific offset and abbreviation that can be "bound to" (properly associated with) a specific point-in-time. A "static" Chronos time zone is one whose offset-abbreviation tuple is not subject to retroactive changes--for a static time zone, the binding of a point-in-time value to the offset-abbreviation tuple of its time zone is permanent for all time. A "dynamic" Chronos time zone is one whose offset-abbreviation tuple (or tuples) is subject to retroactive changes--for a dynamic time zone, the binding of a point-in-time value to the offset-abbreviation tuple currently specified by its time zone is not necessarily permanent.

		Although it may not in fact do so, a VariableOffsetTimezone is intended to represent the full diachronic history of the timezone rules for a particular location, such as New York, New York {Timezone at: 'America/New_York'}, Davos, Switzerland {Timezone at: 'Europe/Zurich'} or Ulaan Bator, Mongolia {Timezone at: 'Asia/Ulaanbaatar'}.  A VariableOffsetTimezone will normally have at least two offsets from Universal Time, and at least two abbreviations.  Most will have more.  So you can't just ask a VariableOffsetTimezone for its offset from Universal Time--it almost certainly has more than one (and even if it did have only one, the fact that its ruleset is subject to retroactive change would still require that it be not treated as equivalent to either a "bound" or a "static" timezone.) 

		See the class comment of ChronosTimezone for more in depth conceptual information about time zones, and for more information about the general characteristics and API of all Chronos time zones.

	Usage:

		A VariableOffsetTimezone conforms to and directly reimplements the Chronos "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.) 

		## KEYS; IDENTITY; LOOKUP

			Usually, VariableOffsetTimezones are uniquely identified by well-known, globally-defined keys and their rulesets are persistently stored in an external repository. However, it is also possible to create ad-hoc/transient instances of VariableOffsetTimezone whose keys are not globally well-known and/or whose rulesets are not persistently stored externally. However, since it is not possible to authoritatively determine whether the key of a VariableOffsetTimezone is in fact a globally well-known value, Chronos simply assumes that the key of any VariableOffsetTimezone stored in the peristent, external time zone repository is globally well known [for Chronos as delivered by the author, this assumption is valid--but it is possible for clients of Chronos to define and add their own time zone ruleset definitions, identified by keys of their choice,  to the Chronos time zones repository--although how to do this is currently not documented, and parhaps won't ever be unless it's requested.]  

			The key of a VariableOffsetTimezone is a Symbol.  As delivered by the author, all persistently-stored, globally-well-known VariableOffsetTimezones (and their keys) are as defined by the Olson Timezone Database (the same one used by UNIX.) The Olson time zone keys usually (but not always) have the form <continent>/<city> or <ocean>/<city>, such as 'Europe/London', 'Asia/Calcutta' or 'Pacific/Auckland'. However, as previously mentioned, clients of Chronos are allowed to define their own variable-offset time zones having any desired key--which do not have to be globally well known, and do not have to be persistently stored in the Chronos time-zones repository. 

			Note: The canonical key of the timezone whose proper name is Universal Time is #Universal.  However, a variety of aliases are supported: #'Universal Time', #UT, #UTC, #GMT, #Z and #Zulu. Although some of the same keys are defined (and in some cases, used without any definition) in the Olson Time Zone databse, Chronos ignores and does not use the Olson definition of Unversal Time.  The ChronosTimezone that implements Universal Time is the canonical instance of the class UniversalTime--it's not a VariableOffsetTimezone (although that could be done, it's neither necessary nor desirable--using atom bombs to swat flys should be avoided whenever possible.)

			In some circumstances, ad-hoc/transient VariableOffsetTimezones may be created by the current ChronosSystemFacade to represent/model/emulate the base system's local time zone.  The key of such a VariableOffsetTimezone created by the ChronosSystemFacade will be the Symbol #system.  The key #system may not even be unique within an image, let alone globally. For the precise behavior in the current Smalltalk environment and system platform, see ChronosSystemFacade and its subclass that implements the current ChronosSystemFacade singleton--the details may well vary by environment/platform.

			To retrieve a VariableOffsetTimezone by its key, use either the class message #at: or #at:ifAbsent:, with the time zone key as the first argument--the key may be either a Symbol or a String (e.g., {VariableOffsetTimezone at: 'Europe/Berlin'}.)

			To retrieve the keys of all the time zones resident in Chronos' repository of persistently-stored time zones, inspect the result of evaluating 'ChronosTimezone allRegisteredKeys' (if there are none, then the Chronos Time Zone Repository is missing, and should be obtained from the Chronos web site and installed according to the instructions (http://www.chronos-st.org/).)

			To see the current time in all the time zones resident in Chronos' repository of persistently-stored time zones, (showing the key, current offset, and current abbreviation for each time zone,) inspect the result of evaluating 'Timepoint nowInAllTimeZones' (if there are no entries, then the Chronos Time Zone Repository is missing, and should be obtained from the Chronos web site and installed according to the instructions (http://www.chronos-st.org/).)

		## USEFUL 'DO ITS' FOR MANUALLY SETTING THE SYSTEM/DEFAULT TIMEZONE

			Also see the "Usage:" section of the class comment of ChronosTimezone for an explanation of the terms 'system timezone' and 'default timezone.'

																						POSIX Rule Literal
			(Timezone at: #'America/Puerto_Rico') beSystem					"AST4"
			(Timezone at: #'America/New_York') beSystem					"EST5EDT4"
			(Timezone at: #'America/Indiana/Indianapolis') beSystem		"EST4"
			(Timezone at: #'America/Indiana/Knox') beSystem				"EST4"	
			(Timezone at: #'America/Indiana/Marengo') beSystem			"EST4"
			(Timezone at: #'America/Indiana/Vevay') beSystem				"EST4"
			(Timezone at: #'America/Chicago') beSystem						"CST6CDT5"
			(Timezone at: #'America/Boise') beSystem							"MST7MDT6"
			(Timezone at: #'America/Denver') beSystem						"MST7MDT6"
			(Timezone at: #'America/Phoenix') beSystem						"MST7"
			(Timezone at: #'America/Los_Angeles') beSystem				"PST8PDT7"
			(Timezone at: #'America/Anchorage') beSystem					"AKST9AKDT8"
			(Timezone at: #'America/Juneau') beSystem						"AKST9AKDT8"
			(Timezone at: #'America/Nome') beSystem							"AKST9AKDT8"
			(Timezone at: #'America/Adak') beSystem							"HAST10HADT9"
			(Timezone at: #'Pacific/Honolulu') beSystem						"HAST10"

			Timezone system beDefault	"Ensures that 'Timezone system == Timezone default' will still be true even after the system time zone is changed."
			
		## RETRIEVING TIMEZONE OFFSETS FROM UT (UNIVERSAL TIME)

			In order to retrieve the offset and/or abbreviation that is correct for the territorial domain of an instance of VariableOffsetTimezone at a particular point-in-time one must use the unbound ChronosTimezone API to resolve a "bound" ChronosTimezone with the correct offset and abbreviation for a given point-in-time, and retrieve the offset and/or abbreviation from the "bound" timezone so obtained. The bound time zone that results will be an instance of StandardTime if "standard time" is in effect at the point-in-time specified in the search parameters, but an instance of NonStandardTime otherwise.

			The search parameters needed to resolve a bound timezone are the year, day-of-year and seconds-since-start-of-day. They can be specified either as UT values or as local time ("wall clock") values.  The message signatures for resolving a bound timezone are as follows:

				#bindingForLocalYear:dayOfYear:secondsSinceStartOfDayFunction:		"Uses local-time search parameters"
				#bindingForUTYear:dayOfYear:secondsSinceStartOfDayFunction:		"Uses Universal Time search parameters"

			The final parameter value (following "secondsSinceStartOfDayFunction:") is a one-argument block.  If the seconds-since-start-of-day value is needed to find the correct bound timezone, this block will be invoked (as a 'call-back') with an argument whose value is the offset from UT in seconds for a particular bound timezone (representing a particular set of zone properties in effect during a particular period of time.)  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary (the answered seconds-since-start-of-day should be in Universal Time if the message #bindingForUTYear:dayOfYear:secondsSinceStartOfDayFunction: was sent, but in local ("wall clock") time if the message #bindingForLocalYear:dayOfYear:secondsSinceStartOfDayFunction: was sent.)  The reason for the callback block is that, during some years, a timezone may have more than one 'standard time' offset from UT, and because the offset transition rules for the same timezone for the same year can be specified as UT values for the first transition, local "wall clock" time for the second transition, but as local standard time for the third transition (yes, all that stuff actually happens--timezones are NOT simple!!)

			Instances of both StandardTime and NonStandardTime are "bound, dynamic" time zones (in the Chronos ontology of time zones.) Both will respond to the message #asUnbound by answering the "unbound, dynamic" time zone instance that defines the complete diachronic ruleset of the time-zone identified by their time zone key. A VariableOffsetTimezone instance (or any "unbound" Chronos time zone object) responds to the message #asUnbound with itself.

			Note: Most of the same information is presented near the end of the "Usage:" section of the class comment of ChronosTimezone--including eample "do its" that illustrate actual usage.

	Motivation:

		Real-world timezones are never invariant.  They always change over time: they change their abbreviations, their standard-time offsets from Universal Time, their DST offset deltas from standard time, and of course the dates and times when they transition to and or from DST. They can change any of these attributes any number of times during the year.  This is NOT theoretical--it's real, it happens, and a library and/or application that is serious about time has to deal with it.  UNIX does--and has been doing so for decades.

		Timezone rules and attributes are a political matter.  Legislatures, bureaucrats or other officials can and do set and change the timezone rules in their jurisdictions whenever they so please.  Perhaps a war prompts Congress to decree that the United States will transition to Daylight Saving Time and stay there until the war ends (World Wars I and II, for example.)  Perhaps the good people of Phoenix strongly prefer to use standard time all year round--except in 1967, when a change to Federal law forced them to observe DST for that year, until their State Legislature could pass the necessary law to get rid of the unpopular DST.  Welcome to the real world of timezones.

		If you only care about one point-in-time value (and don't have to deal with times in the future where the time zone rules might change before the future point-in-time you've designated transitions from future to past,) then a single offset from Universal Time is sufficient.  But if you want to compute new points-in-time using date/time arithmetic, then you have to deal with the fact that the offset of such computed points-in-time is undecidable in the absence of an unambiguous specification of which timezone ruleset should be used to determine the Universal Time offset of the computed timepoint.  Unambigously specifying the complete timezone ruleset in effect for a particular region, diachronically for all time, is what a VariableOffsetTimezone does (or at least enables.)

	Implementation:

		See TimeZonePolicy for information regarding the actual mechanisms by which a VariableOffsetTimezone implements and represents diachronic time zone rulesets.

		## INSTANCE REGISTRATION IN THE CACHE

			VariableOffsetTimezone maintains a cache of its instances. An instance will be registered in the cache when sent the message #register, provided the following conditions are satisfied: 1) the instance's key is not nil, 2) the instance's key is not the value #system, and 3) the instance has a non-nil TimeZonePolicy. Although it is not required that all instances be in the cache, all instances that are made immutable will be sent the message #register.  Instances deserialized from the external time-zones repository are always made immutable.  The cache is supposed to be a WeakDictionary, but what it actually is depends upon the current ChronosSystemFacade (see the implementation of the method #newWeakDictionary that is either implemented or inherited by the class of the current ChronosSystemFacade singleton.)

		Instance Variables

			key			<Symbol>	The key that identifies the time zone represented by the instance. If and only if it's the key of an Olson time zone (or it it's otherwise a universally well-known key,) it must be universally unique. Unless it's the special value #system, it must be unique within an image (or within an OS process, if the Smalltalk environment is not image based.)
			policy 		<TimeZonePolicy>	The TimeZonePolicy that specifies the ruleset of the time zone represented by the instance.  The ruleset of a time zone specifies for all time values, from the infinite past to the infinite future, the (possibly varying) time zone offsets and abbreviations that apply to points-in-time within the territorial domain of the time zone. Note, however, that the "policy" (time zone ruleset) can be changed retroactively--and this is rather likely to happen for times in the future (but can also happen to times in the past.)

		Class Variables

			Registry 	<WeakDictionary> Cache of VariableOffsetTimezones that have been instantiated in the image. Instances are usually (but not always) registerd in this cache.  

!

!VariableOffsetTimezone class methodsFor: 'validation' stamp: ''!
assertValidityOfTimezoneKey: aTimeZoneKey 
	"Assert that <aTimeZoneKey> is the key of a time zone persistently stored in the Chronos time-zones repository (to which this execution environment is attached.) If it is, do nothing. If it is not, raise an Exception."

	((#(#default #system) includes: aTimeZoneKey) or: [self registry includesKey: aTimeZoneKey])
		ifFalse: [TimeZonePolicyFactory assertValidityOfTimezoneKey: aTimeZoneKey]! !

!VariableOffsetTimezone class methodsFor: 'accessing' stamp: ''!
at: aTimeZoneKey 
	"Answer the VariableOffsetTimezone whose key is <aChronosTimeZoneKey>.  If there is no VariableOffsetTimezone with the specified key, signal an exception."

	"{(VariableOffsetTimezone at: #Universal) now}"
	"{(VariableOffsetTimezone at: #'America/New_York') now}"
	"{(VariableOffsetTimezone at: #'America/Detroit') now}"
	"{(VariableOffsetTimezone at: #alwaysDefault) now}"
	"{(VariableOffsetTimezone at: #alwaysSystem) now}"
	"{VariableOffsetTimezone at: #NOSUCHKEY}"

	^self at: aTimeZoneKey ifAbsent: [self signalInaccessibleTimeZonePolicyAt: aTimeZoneKey]! !

!VariableOffsetTimezone class methodsFor: 'accessing' stamp: ''!
at: aTimeZoneKey ifAbsent: ifAbsentBlock 
	"Answer the VariableOffsetTimezone whose key is <aChronosTimeZoneKey>.  If there is no VariableOffsetTimezone with the specified key, answer the result of evaluating <absentAction>."

	"{VariableOffsetTimezone at: #Universal ifAbsent: [#NoSuchTimeZone]}"
	"{VariableOffsetTimezone at: #system ifAbsent: [#NoSuchTimeZone]}"
	"{VariableOffsetTimezone at: #default ifAbsent: [#NoSuchTimeZone]}"
	"{VariableOffsetTimezone at: #alwaysSystem ifAbsent: [#NoSuchTimeZone]}"
	"{VariableOffsetTimezone at: #alwaysDefault ifAbsent: [#NoSuchTimeZone]}"
	"{VariableOffsetTimezone at: #nominal ifAbsent: [#NoSuchTimeZone]}"
	"{VariableOffsetTimezone at: #NOSUCHKEY ifAbsent: [#NoSuchTimeZone]}"

	| tzKey tz |
	tzKey := aTimeZoneKey asSymbol.
	tzKey == #system ifTrue: [^self system].
	tzKey == #default ifTrue: [^self default].
	tz := self registry at: tzKey ifAbsent: [0].
	^(tz == nil or: [tz = 0])
		ifTrue: 
			[[(self new)
				setNamespaceKey: #canonicalRepository key: tzKey;
				beImmutable] 
					on: Error
					do: [:ex | ex return: ifAbsentBlock value]]
		ifFalse: [tz]! !

!VariableOffsetTimezone class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	| keyOrSpec |
	keyOrSpec := literalArray at: 2.
	^keyOrSpec isString 
		ifTrue: [self at: keyOrSpec]
		ifFalse: 
			[(self new)
				initializeFromLiteralArray: literalArray;
				beImmutable]! !

!VariableOffsetTimezone class methodsFor: 'class initialization' stamp: ''!
initialize
	"VariableOffsetTimezone initialize."

	Registry := nil! !

!VariableOffsetTimezone class methodsFor: 'private' stamp: ''!
initializeRegistry
	"VariableOffsetTimezone initializeRegistry"

	Registry := EnvironmentFacade current newWeakDictionary.! !

!VariableOffsetTimezone class methodsFor: 'class initialization' stamp: ''!
invalidate
	"VariableOffsetTimezone invalidate."

	Registry == nil 
		ifFalse: 
			[Registry values do: [:each | each == nil ifFalse: [each invalidatePolicy]]].
	self invalidateTimezonePolicies.
	self setRegistry.! !

!VariableOffsetTimezone class methodsFor: 'class initialization' stamp: ''!
invalidateTimezonePolicies
	"Update the TimeZonePolicies of all non-transient instances of the receiver from the persistent specifications of their rulesets stored in the external Chronos time-zones repository."

	"VariableOffsetTimezone invalidateTimezonePolicies"

	self invalidateOffsetFlyweights.
	self invalidateBoundDynamicFlyweights.
	self allInstancesDo: [:each | each invalidatePolicy].! !

!VariableOffsetTimezone class methodsFor: 'instance creation' stamp: ''!
key: aKey name: aStringOrSymbol initialOffset: offset1FromUT withAbbreviation: abbreviation1 until: annualTransitionDate1 at: timeOfDay1 relativity: relativity1 thenOffset: offset2FromUT withAbbreviation: abbreviation2 until: annualTransitionDate2 at: timeOfDay2 relativity: relativity2 
	"Answer a new VariableOffsetTimezone with one inter-year ruleset consisting of two intra-year offset/abbreviation transitions that repeat annually. The answered instance's single inter-year ruleset with two intra-year annual transitions will apply every year, from the infinite past to the infinite future. The answered instance will have the specfied <key> and <name> (Symbols or Strings; the keys #alwaysSystem, #alwaysDefault and #nominal are not allowed.)  The name may nil, in which case the answered instance's name will be its key.

	From the beginning of the year until the first offset/abbreviation transition, the answered instance's offset from UT will be <offset1FromUT> (a Duration) and its abbreviation will be <abbreviation1> (a Symbol.)  The first transtion will occur on <annualTransitionDate1> (an AnnualDate) at <timeOfDay1> (a TimeOfDay).  If <relativity1> == #nominal, then the specified date and time of the first transition reflect local `wall clock` time as defined by the answered instance.   If <relativity1> == #standard, then the specified date and time of the first transition reflect local `standard time` as defined by the answered instance (i.e., without DST.)  If <relativity1> == #universal, then the specified date and time reflect the Universal Time when the first transition occurs.

	From the first offset/abbreviation transition until the second offset/abbreviation transition,  the answered instance's offset from UT will be <offset2FromUT> (a Duration) and its abbreviation will be <abbreviation2> (a Symbol.)  The second transtion will occur on <annualTransitionDate2> (an AnnualDate) at <timeOfDay2> (a TimeOfDay).  If <relativity2> == #nominal, then the specified date and time of the second transition reflect local `wall clock` time as defined by the answered instance.   If <relativity2> == #standard, then the specified date and time of the second transition reflect local `standard time`  as defined by the answered instance (i.e., without DST.)  If <relativity2> == #universal, then the specified date and time reflect the Universal Time when the second transition occurs.

	After the second offset/abbreviation transition and until the end of the year,  the answered instance's offset from UT will again be <offset1FromUT> (a Duration) and its abbreviation will again be <abbreviation2> (a Symbol.) 

	HOWEVER, the parameters may be supplied in inverted order: If <annualTransitionDate1> occurs later in the year than <annualTransitionDate2>, then the role of <offset1FromUT> is swapped with that of <offset2FromUT>, the role of <abbreviation1> is swapped with that of <abbreviation2>, the role of <annualTransitionDate1> is swapped with that of <annualTransitionDate2>, the role of <timeOfDay1> is swapped with that of <timeOfDay2> and the role of <relativity1> is swapped with that of <relativity2>.

	NOTE: Although it is of course possible to create a VariableOffsetTimezone with more than one inter-year ruleset, that is best done using factory objects, such as those implemented by TimeZonePolicySequenceFactory, TimeZonePolicyElementFactory and AnnuallyRecurringTZPolicyFactory (and its subclasses.) One may also `open-code` a TimeZonePolicy object graph directly, as is done in the implementation of this method, but that is not recommended in complex cases."

	"{(VariableOffsetTimezone
		key: #myOwnPrivateTimeZone name: #NorthernHemispereInvertedOrder
		initialOffset: (Duration hours: -7) withAbbreviation: #WDT 
			until: (WeekOfMonthDayOfWeek month: 11 week: 0 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #nominal
		thenOffset: (Duration hours: -8)  withAbbreviation: #WST  
			until: (WeekOfMonthDayOfWeek month: 3 week: 1 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #standard) 
				nowToTheSecond printStringUsing: #verbose}"

	"{(VariableOffsetTimezone
		key: #someoneElsesPrivateTimeZone name: #SouthernHemisphereNormalOrder
		initialOffset: (Duration hours: 10) withAbbreviation: #WADT 
			until: (WeekOfMonthDayOfWeek month: 4 week: 0 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #universal
		thenOffset: (Duration hours: 9)  withAbbreviation: #WAST  
			until: (WeekOfMonthDayOfWeek month: 9 week: 1 dayOfWeek: Sunday) at: (TimeOfDay hour: 2 minute: 0 second: 0) relativity: #universal)
				nowToTheSecond literalArrayEncoding decodeAsLiteralArray printStringUsing: #verbose}"

	| instance policy minOffset annualPolicy |
	instance := self new.
	policy := TimeZonePolicy newFor: instance.
	policy setDefaultName: aStringOrSymbol.
	instance 
		setNamespaceKey: #nonGlobal key: aKey
		policy: policy.
	minOffset := offset1FromUT min: offset2FromUT.
	annualPolicy := 
		(UntilAnnualDateTimeZoneTransition 
			for: policy
			offsetSeconds: offset1FromUT asSeconds
			stdTimeOffsetSeconds: minOffset asSeconds
			commonAbbreviation: abbreviation1
			annualDate: annualTransitionDate1
			transitionSecondsSinceStartOfDay: timeOfDay1 secondsSinceStartOfDay
			relativity: relativity1) 
				asListSortedInCanonicalOrderByTransitionTimeAdding: 
					(UntilAnnualDateTimeZoneTransition 
						for: policy
						offsetSeconds: offset2FromUT asSeconds
						stdTimeOffsetSeconds: minOffset asSeconds
						commonAbbreviation: abbreviation2
						annualDate: annualTransitionDate2
						transitionSecondsSinceStartOfDay: timeOfDay2 secondsSinceStartOfDay
						relativity: relativity2).
	annualPolicy := 
		annualPolicy 
			asListSortedInCanonicalOrderByTransitionTimeAdding: 
				(UntilEndOfYearTimeZoneTransition 
					for: policy
					offsetSeconds: annualPolicy offsetSecondsFromUT
					stdTimeOffsetSeconds: minOffset asSeconds
					commonAbbreviation: annualPolicy commonAbbreviation).
	policy 
		setEffectiveYear: nil;
		setAnnualPolicy: annualPolicy.
	^instance beImmutable! !

!VariableOffsetTimezone class methodsFor: 'private' stamp: ''!
registry
	"VariableOffsetTimezone registry"

	Registry == nil ifTrue: [self setRegistry].
	^Registry! !

!VariableOffsetTimezone class methodsFor: 'private' stamp: ''!
setRegistry
	"VariableOffsetTimezone setRegistry"

	Registry == nil ifTrue: [self initializeRegistry].
	Registry
		at: NominalTime registrationKey put: ChronosTimezone nominal;
		at: AlwaysSystemTZ registrationKey put: ChronosTimezone alwaysSystem;
		at: AlwaysDefaultTZ registrationKey put: ChronosTimezone alwaysDefault;
		at: #'Universal Time' put: ChronosTimezone universal; 	"Formally-correct identifying key of the international standard reference zero-offset timezone"
		at: #Universal put: ChronosTimezone universal; 			"An alias for 'Universal Time' used by the Olson Timezone Database."
		at: #UT put: ChronosTimezone universal;					"Formally-correct abbreviation for the Universal Time timzone"
		at: #Z put: ChronosTimezone universal;						"ISO 8601 abbreviation for the Universal Time timzone"
		at: #z put: ChronosTimezone universal;						"Alternate ISO 8601 abbreviation for the Universal Time timzone"
		at: #Zulu put: ChronosTimezone universal;					"Military standard identifier for the Universal Time timzone"
		at: #GMT put: ChronosTimezone universal; 				"Technically wrong since 1928, but it's still widely used as a synonym for UT.
																				Note, however, that GMT is also the abbreviation for a variety of timezones in the
																				vicinity of the Prime Meridian (e.g., Britain, West Africa) whose offset from UTC is 0 seconds 
																				in the winter, but +3600 seconds in the summer."
		at: #UTC put: ChronosTimezone universal					"UTC is quite commonly misused as the abbreviation of the Universal Time timezone (including by the official specification of the ANSI-Smalltalk Standard,) and also therefore (for consistency with ANSI Smalltalk) by the Chronos Date/Time library"! !

!VariableOffsetTimezone class methodsFor: 'private' stamp: ''!
signalInaccessibleTimeZonePolicyAt: aTimeZoneKey 
	^self 
		signalError: 'The resource that defines the ruleset for the ' , self name 
				, ' identified by ' , aTimeZoneKey printString 
				, ' is not accessible.'! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
aliasingKeys
	^self policy aliasingKeys! !

!VariableOffsetTimezone methodsFor: 'queries' stamp: ''!
annualPolicyForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in local time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct annual policy, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UTC for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day in local time (without any need to consider standard versus daylight saving time.)"

	^self policy
		searchBackwardForAnnualPolicyAtLocalYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!VariableOffsetTimezone methodsFor: 'queries' stamp: ''!
annualPolicyForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in Universal Time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct annual policy, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UT for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day as UT (without any need to consider standard versus daylight saving time.)"

	^self policy 
		searchBackwardForAnnualPolicyAtUTYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
beUniversal
	self assertMutability.
	self setNamespaceKey: #canonicalRepository key: ChronosTimezone universal key policy: nil.! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
bindPolicy
	policy := self resolvePolicy.
	policy == nil ifTrue: [^self].
	policy := policy asImmutable! !

!VariableOffsetTimezone methodsFor: 'queries' stamp: ''!
bindingForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in the local time defined by the receiver.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in local (`wall clock`) time as defined by the receiver."

	^(self 
		annualPolicyForLocalYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction) binding! !

!VariableOffsetTimezone methodsFor: 'queries' stamp: ''!
bindingForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in Universal Time.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in Universal Time."

	^(self 
		annualPolicyForUTYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction) binding! !

!VariableOffsetTimezone methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's class whose value is equivalent to that of the receiver's."

	^self class registry at: key
		ifAbsent: 
			[self
				invalidatePolicy;
				register]! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
canonicalKey
	^self policy registrationKey! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	policy == nil
		ifTrue: [self bindPolicy]
		ifFalse: [policy := policy asImmutable].
	self register! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
defaultAnnualPolicy
	"Answer the AnnuallyRecurringTZPolicy that specifies the time zone rules that are in effect during the current year."

	^(self policy effectiveRuleInYear: AnsiStandardCalendarClock thisYear ifNone: [self policy ]) annualPolicy! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
defaultName
	^self defaultNameIfNone: [self key]! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
defaultNameIfNone: noneBlock 
	^self policy specifiesDefaultName 
		ifTrue: [self policy defaultName]
		ifFalse: [noneBlock value]! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream nextPut: self namespaceKey! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
geographicCoordinates
	^self policy geographicCoordinates! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	namespaceKey := #nonGlobal.
	key := #system.! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	| keyOrFactory nsKey policyFactory |
	keyOrFactory := literalArray at: 2.
	nsKey := literalArray at: 3.
	keyOrFactory isSymbol 
		ifTrue: [self setNamespaceKey: nsKey key: keyOrFactory]
		ifFalse: 
			[policyFactory := keyOrFactory decodeAsLiteralArray.
			self setNamespaceKey: nsKey key: policyFactory key.
			policy := policyFactory asPolicyFor: self]! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
invalidateNamespaceKey
	namespaceKey == nil 
		ifTrue: 
			[(key ~~ #system 
				and: [TimeZonePolicyFactory timezoneKeyIsGloballyDefined: key]) 
					ifTrue: [namespaceKey := #canonicalRepository]
					ifFalse: [namespaceKey := #nonGlobal]]! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
invalidatePolicy
	self keyIsGlobal 
		ifTrue: 
			[policy release.
			policy := nil]! !

!VariableOffsetTimezone methodsFor: 'testing' stamp: ''!
isBound
	"Answer whether the receiver is a bound time zone. A bound time zone is one that defines a single offset/abbreviation tuple, and that conforms to the `BOUND TIMEZONE API` (as defined in the class comment of ChronosTimezone.)"

	^false! !

!VariableOffsetTimezone methodsFor: 'private-comparing' stamp: ''!
isEqualToTimezone: aTimezone 
	^(self keyIsGlobal 
		and: [aTimezone keyIsGlobal])
		ifTrue: [key == aTimezone key]
		ifFalse: [self == aTimezone]! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
key
	"Answer the key that identifies the receiver."

	^key! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
keyIsAlias
	^self key ~~ self policy registrationKey! !

!VariableOffsetTimezone methodsFor: 'testing' stamp: ''!
keyIsGlobal
	"Answer whether the receiver's identifying key is a globally well-known value."

	^key notNil and: [self namespaceKey ~~ #nonGlobal]! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
literalArrayEncodingOfKey
	^self keyIsGlobal 
		ifTrue: [self key]
		ifFalse: [self policy asPolicyFactory literalArrayEncoding]! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
name
	^self nameIfNone: [self key]! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
nameIfNone: noneBlock 
	| defaultName |
	defaultName := key == #system ifTrue: [self defaultNameIfNone: []].
	^defaultName == nil 
		ifTrue: 
			[ChronosLocale default properNameAtSemanticKey: self key
				ifAbsent: [self defaultNameIfNone: noneBlock]]
		ifFalse: [defaultName]! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
namespaceKey
	namespaceKey == nil ifTrue: [self invalidateNamespaceKey].
	^namespaceKey! !

!VariableOffsetTimezone methodsFor: 'accessing' stamp: ''!
policy
	"Answer the TimeZonePolicy that specifies the ruleset of the time zone represented by the instance.  The ruleset of a time zone specifies for all time values, from the infinite past to the infinite future, the (possibly varying) time zone offsets and abbreviations that apply to points-in-time within the territorial domain of the time zone. Note, however, that the `policy` (time zone ruleset) can be changed retroactively--and this is rather likely to happen for times in the future (but can also happen to times in the past.)"

	policy == nil ifTrue: [self bindPolicy].
	^policy! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
policyClass
	^TimeZonePolicy! !

!VariableOffsetTimezone methodsFor: 'printing' stamp: ''!
printPolicyOn: stream 
	stream 
		cr; tab;
		nextPutAll: 'policy=';
		cr; tab; tab.
	self policy printOn: stream! !

!VariableOffsetTimezone methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processVariableOffsetTimezone: self! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 10:39'!
register
	| old |
	old := self class registry at: key ifAbsentPut: [self].
	old == self 
		ifFalse: 
			["The only obvious reason it should ever be necessary to register one VariableOffsetTimezone in place of another is because their classes are different (and so have different behavior.)  However, the invariant that there is only one VariableOffsetTimezone instance with a given key must be maintained."
			self class registry at: key put: self.
			(DateAndTimeFactory) invalidateTimezones]! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
release
	super release.
	Registry == nil ifFalse: [Registry removeKey: self key ifAbsent: []].
	self invalidatePolicy! !

!VariableOffsetTimezone methodsFor: 'private' stamp: ''!
resolvePolicy
	self keyIsGlobal ifFalse: [^policy].
	^self policyClass 
		for: self
		ifNone: 
			[policy == nil 
				ifTrue: [self class signalInaccessibleTimeZonePolicyAt: key]
				ifFalse: [policy]]! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
setNamespaceKey: aTZNamespaceKey
	self assertMutability.
	namespaceKey := aTZNamespaceKey == nil ifFalse: [aTZNamespaceKey asSymbol].! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
setNamespaceKey: aTZNamespaceKey key: aTimeZoneKey 
	| tzKey |
	self setNamespaceKey: aTZNamespaceKey.
	tzKey := aTimeZoneKey asSymbol.
	(#(#alwaysSystem #alwaysDefault #nominal) includes: tzKey) 
		ifTrue: [self signalError: 'The key ', tzKey printString, ' is not legal for a ', self class name, '.'].
	key := tzKey! !

!VariableOffsetTimezone methodsFor: 'initialize-release' stamp: ''!
setNamespaceKey: aTZNamespaceKey key: aKey policy: aPolicy
	self setNamespaceKey: aTZNamespaceKey key: aKey.
	policy := aPolicy.! !

!VariableOffsetTimezone methodsFor: 'testing' stamp: ''!
specifiesAbbreviation
	^self specifiesCommonAbbreviation or: [(ChronosLocale default abbreviationAtSemanticKey: self key ifAbsent: [nil]) ~~ nil]! !

!VariableOffsetTimezone methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation

	^self policy specifiesCommonAbbreviation! !

!VariableOffsetTimezone methodsFor: 'testing' stamp: ''!
specifiesDefaultName
	^self policy specifiesDefaultName! !

!VariableOffsetTimezone methodsFor: 'testing' stamp: ''!
specifiesGeographicCoordinates
	^self policy specifiesGeographicCoordinates! !

!VariableOffsetTimezone methodsFor: 'testing' stamp: ''!
specifiesName
	^self specifiesDefaultName or: [(ChronosLocale default properNameAtSemanticKey: self key ifAbsent: [nil]) ~~ nil]! !

ChronosObject subclass: #GeographicCoordinateSpec
	instanceVariableNames: 'degreesOfLattitude degreesOfLongitude'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!GeographicCoordinateSpec class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!GeographicCoordinateSpec class methodsFor: 'instance creation' stamp: ''!
degreesOfLattitude: lattitude longitude: longitude 
	^(self new)
		setDegreesOfLattitude: lattitude;
		setDegreesOfLongitude: longitude;
		beImmutable! !

!GeographicCoordinateSpec class methodsFor: 'instance creation' stamp: ''!
lattitudeDegrees: latDegrees minutes: latMinutes seconds: latSeconds longitudeDegrees: lonDegrees minutes: lonMinutes seconds: lonSeconds 
	^(self new)
		setLattitudeDegrees: latDegrees
			minutes: latMinutes
			seconds: latSeconds;
		setLongitudeDegrees: lonDegrees
			minutes: lonMinutes
			seconds: lonSeconds;
		beImmutable! !

!GeographicCoordinateSpec class methodsFor: 'instance creation' stamp: ''!
readFrom: stream 
	"Create an instance based on the contents of stream."

	"Expects IS0 6709 format:
		{GeographicCoordinateSpec readFromString: '+340308-1181434'}"

	| ch latPolarity latDegrees latMinutes latSeconds lonPolarity lonDegrees lonMinutes lonSeconds |
	ChronosFunction skipSeparators: stream.
	((latPolarity := #($- $+) indexOf: stream next ifAbsent: [0]) > 0)
		ifFalse: [^self signalError: 'Lattitude must begin with either + or -'].
	latPolarity := #(-1 1) at: latPolarity.
	latDegrees := 
		ChronosFunction 
			nextUnsignedIntegerFrom: stream
			minDigits: 2
			maxDigits: 2
			acceptancePredicate: [:int :digitCount | true]
			handleRejection: 
					[:value :digitCount :rejectionReason | 
					^self signalError: 'Degress of lattitude must have exactly and only two digits, and must be <= 90'].
	latMinutes := 
		ChronosFunction 
			nextUnsignedIntegerFrom: stream
			minDigits: 2
			maxDigits: 2
			acceptancePredicate: [:int :digitCount | int <= 90]
			handleRejection: 
					[:value :digitCount :rejectionReason | 
					^self signalError: 'Minutes of lattitude must have exactly and only two digits, and must be < 60'].
	ch := stream peek.
	((lonPolarity := #($- $+) indexOf: ch ifAbsent: [0]) > 0)
		ifTrue: 
			[stream next.
			latSeconds := 0]
		ifFalse: 
			[latSeconds := 
				ChronosFunction 
					nextUnsignedIntegerFrom: stream
					minDigits: 2
					maxDigits: 2
					acceptancePredicate: [:int :digitCount | int < 60]
					handleRejection: 
							[:value :digitCount :rejectionReason | 
							^self signalError: 'Seconds of lattitude must have either two digits or none at all, and if present must be < 60'].
			((lonPolarity := #($- $+) indexOf: stream next ifAbsent: [0]) > 0)
				ifFalse: [^self signalError: 'Longitude must begin with either + or -']].
	lonPolarity := #(-1 1) at: lonPolarity.
	lonDegrees := 
		ChronosFunction 
			nextUnsignedIntegerFrom: stream
			minDigits: 3
			maxDigits: 3
			acceptancePredicate: [:int :digitCount | int <= 180]
			handleRejection: 
					[:value :digitCount :rejectionReason | 
					^self signalError: 'Degress of longitude must have exactly and only three digits, and must be <= 180'].
	lonMinutes := 
		ChronosFunction 
			nextUnsignedIntegerFrom: stream
			minDigits: 2
			maxDigits: 2
			acceptancePredicate: [:int :digitCount | int < 60]
			handleRejection: 
					[:value :digitCount :rejectionReason | 
					^self signalError: 'Minutes of longitude must have exactly and only two digits, and must be < 60'].
	lonSeconds := 
		ChronosFunction 
			nextUnsignedIntegerFrom: stream
			minDigits: 0
			maxDigits: 2
			acceptancePredicate: [:int :digitCount | digitCount ~= 1 and: [int < 60]]
			handleRejection: 
					[:value :digitCount :rejectionReason | 
					^self signalError: 'Seconds of lattitude must have either two digits or none at all, and if present must be < 60'].
	^self 
		lattitudeDegrees: latDegrees * latPolarity
		minutes: latMinutes * latPolarity
		seconds: latSeconds * latPolarity
		longitudeDegrees: lonDegrees * lonPolarity
		minutes: lonMinutes * lonPolarity
		seconds: lonSeconds * lonPolarity! !

!GeographicCoordinateSpec methodsFor: 'accessing' stamp: ''!
degreesOfLattitude
	^degreesOfLattitude rounded! !

!GeographicCoordinateSpec methodsFor: 'accessing' stamp: ''!
degreesOfLongitude
	^degreesOfLongitude rounded! !

!GeographicCoordinateSpec methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream
		nextPut: degreesOfLattitude;
		nextPut: degreesOfLongitude! !

!GeographicCoordinateSpec methodsFor: 'accessing' stamp: ''!
fractionalDegreesOfLattitude
	^degreesOfLattitude! !

!GeographicCoordinateSpec methodsFor: 'accessing' stamp: ''!
fractionalDegreesOfLongitude
	^degreesOfLongitude! !

!GeographicCoordinateSpec methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver."

	self assertMutability.
	degreesOfLattitude := 0.
	degreesOfLongitude := 0.! !

!GeographicCoordinateSpec methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self 
		setDegreesOfLattitude: (literalArray at: 2);
		setDegreesOfLongitude: (literalArray at: 3)! !

!GeographicCoordinateSpec methodsFor: 'accessing' stamp: ''!
minutesOfLattitude
	^(degreesOfLattitude * 60) rounded rem: 60! !

!GeographicCoordinateSpec methodsFor: 'accessing' stamp: ''!
minutesOfLongitude
	^(degreesOfLongitude * 60) rounded rem: 60! !

!GeographicCoordinateSpec methodsFor: 'printing' stamp: ''!
printOn: stream
	"Per ISO 6709"

	stream nextPut: (degreesOfLattitude positive ifTrue: [$+] ifFalse: [$-]).
	ChronosFunction 
		print: self degreesOfLattitude abs paddedWith: $0 to: 2 on: stream; 
		print: self minutesOfLattitude abs paddedWith: $0 to: 2 on: stream; 
		print: self secondsOfLattitude abs paddedWith: $0 to: 2 on: stream.
	stream nextPut: (degreesOfLongitude positive ifTrue: [$+] ifFalse: [$-]).
	ChronosFunction 
		print: self degreesOfLongitude abs paddedWith: $0 to: 3 on: stream; 
		print: self minutesOfLongitude abs paddedWith: $0 to: 2 on: stream; 
		print: self secondsOfLongitude abs paddedWith: $0 to: 2 on: stream.! !

!GeographicCoordinateSpec methodsFor: 'accessing' stamp: ''!
secondsOfLattitude
	^(degreesOfLattitude * 3600) rounded rem: 60! !

!GeographicCoordinateSpec methodsFor: 'accessing' stamp: ''!
secondsOfLongitude
	^(degreesOfLongitude * 3600) rounded rem: 60! !

!GeographicCoordinateSpec methodsFor: 'initialize-release' stamp: ''!
setDegreesOfLattitude: degrees
	self assertMutability.
	degreesOfLattitude := degrees! !

!GeographicCoordinateSpec methodsFor: 'initialize-release' stamp: ''!
setDegreesOfLongitude: degrees
	self assertMutability.
	degreesOfLongitude := degrees! !

!GeographicCoordinateSpec methodsFor: 'initialize-release' stamp: ''!
setLattitudeDegrees: degrees minutes: minutes seconds: seconds
	self setDegreesOfLattitude: degrees + (minutes / 60) + (seconds / 3600)! !

!GeographicCoordinateSpec methodsFor: 'initialize-release' stamp: ''!
setLongitudeDegrees: degrees minutes: minutes seconds: seconds
	self setDegreesOfLongitude: degrees + (minutes / 60) + (seconds / 3600)! !

ChronosObject subclass: #LeapSecond
	instanceVariableNames: 'prev next secondsDelta preNetLeapSeconds postNetLeapSeconds daysSinceEpoch secondsSinceStartOfDay calendricalSecondsSinceEpoch firstScientificSecondSinceEpoch lastScientificSecondSinceEpoch isRelativeToUT'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timescales'!

!LeapSecond commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

Instance Variables:
	daysSinceEpoch	<ArithmeticValue>	description of daysSinceEpoch
	isRelativeToUT	<Boolean>	description of isRelativeToUT
	postNetLeapSeconds	<SmallInteger>	description of postNetLeapSeconds
	preNetLeapSeconds	<ArithmeticValue>	description of preNetLeapSeconds
	secondsDelta	<SmallInteger>	description of secondsDelta
	secondsSinceStartOfDay	<SmallInteger>	description of secondsSinceStartOfDay
	ut1SecondsSinceEpoch	<ArithmeticValue>	description of ut1SecondsSinceEpoch
	utcSecondsSinceEpoch	<SmallInteger>	description of utcSecondsSinceEpoch

	Subclassing:


!

!LeapSecond class methodsFor: 'instance creation' stamp: ''!
withSecondsDelta: secondsDelta preNetLeapSeconds: preNetLeapSeconds daysSinceEpoch: daysSinceEpoch secondsSinceStartOfDay: secondsSinceStartOfDay isRelativeToUT: isRelativeToUT 
	| ls |
	ls := self new.
	isRelativeToUT ifTrue: [ls beRelativeToUT] ifFalse: [ls beRelativeToLocalTime].
	^ls
		setSecondsDelta: secondsDelta
		preNetLeapSeconds: preNetLeapSeconds
		daysSinceEpoch: daysSinceEpoch
		secondsSinceStartOfDay: secondsSinceStartOfDay! !

!LeapSecond methodsFor: 'private' stamp: ''!
basicNext: aLeapSecond
	"Allowed even if not mutable."

	next := aLeapSecond! !

!LeapSecond methodsFor: 'private' stamp: ''!
basicPrev: aLeapSecond
	self assertMutability.
	prev := aLeapSecond! !

!LeapSecond methodsFor: 'initialize-release' stamp: ''!
beImmutable
	"Make the receiver immutable.  Idempotent.  Must answer the receiver."

	self isMutable 
		ifTrue: 
			[super beImmutable.
			next == nil ifFalse: [next beImmutable].
			prev == nil ifFalse: [prev beImmutable]]! !

!LeapSecond methodsFor: 'initialize-release' stamp: ''!
beRelativeToLocalTime
	self assertMutability.
	isRelativeToUT := false! !

!LeapSecond methodsFor: 'initialize-release' stamp: ''!
beRelativeToUT
	self assertMutability.
	isRelativeToUT := true! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
calendricalSecondsSinceEpoch
	^calendricalSecondsSinceEpoch! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
dateAndTimeSpec
	^DateAndTimeSpec daysSinceEpoch: daysSinceEpoch seconds: secondsSinceStartOfDay! !

!LeapSecond methodsFor: 'queries' stamp: ''!
daysSinceDaySinceEpoch: daySinceEpoch 
	^daysSinceEpoch - daySinceEpoch! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
daysSinceEpoch
	^daysSinceEpoch! !

!LeapSecond methodsFor: 'queries' stamp: ''!
daysUntilDaySinceEpoch: daySinceEpoch 
	^daySinceEpoch - daysSinceEpoch! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
firstScientificSecondSinceEpoch
	^firstScientificSecondSinceEpoch! !

!LeapSecond methodsFor: 'queries' stamp: ''!
inEffectAtCalendricalSecondSinceEpoch: secondSinceEpoch 
	^secondSinceEpoch >= calendricalSecondsSinceEpoch
		ifTrue: 
			[next == nil 
				ifTrue: [self]
				ifFalse: 
					[secondSinceEpoch < next calendricalSecondsSinceEpoch 
						ifTrue: [self]
						ifFalse: [next inEffectAtCalendricalSecondSinceEpoch: secondSinceEpoch]]]
		ifFalse: 
			[prev == nil 
				ifFalse: [prev inEffectAtCalendricalSecondSinceEpoch: secondSinceEpoch]]! !

!LeapSecond methodsFor: 'queries' stamp: ''!
inEffectAtDaySinceEpoch: daySinceEpoch 
	^daySinceEpoch >= daysSinceEpoch
		ifTrue: 
			[next == nil 
				ifTrue: [self]
				ifFalse: 
					[daySinceEpoch < next daysSinceEpoch 
						ifTrue: [self]
						ifFalse: [next inEffectAtDaySinceEpoch: daySinceEpoch]]]
		ifFalse: 
			[prev == nil 
				ifFalse: [prev inEffectAtDaySinceEpoch: daySinceEpoch]]! !

!LeapSecond methodsFor: 'queries' stamp: ''!
inEffectAtScientificSecondSinceEpoch: secondSinceEpoch 
	^secondSinceEpoch >= firstScientificSecondSinceEpoch
		ifTrue: 
			[next == nil 
				ifTrue: [self]
				ifFalse: 
					[secondSinceEpoch < next firstScientificSecondSinceEpoch 
						ifTrue: [self]
						ifFalse: [next inEffectAtScientificSecondSinceEpoch: secondSinceEpoch]]]
		ifFalse: 
			[prev == nil 
				ifFalse: [prev inEffectAtScientificSecondSinceEpoch: secondSinceEpoch]]! !

!LeapSecond methodsFor: 'initialize-release' stamp: ''!
initialize
	self assertMutability.
	prev := nil.
	next := nil.
	secondsDelta := 0.
	preNetLeapSeconds := 0.
	postNetLeapSeconds := 0.
	daysSinceEpoch := 0. 
	secondsSinceStartOfDay := 0. 
	calendricalSecondsSinceEpoch := 0.
	firstScientificSecondSinceEpoch := 0.
	lastScientificSecondSinceEpoch := 0.
	isRelativeToUT := true.! !

!LeapSecond methodsFor: 'queries' stamp: ''!
intervalIncludesScientificSecondSinceEpoch: secondSinceEpoch 
	^secondsDelta > 1
		ifTrue: 
			[secondSinceEpoch 
				between: firstScientificSecondSinceEpoch
				and: lastScientificSecondSinceEpoch]
		ifFalse: [secondSinceEpoch = firstScientificSecondSinceEpoch]! !

!LeapSecond methodsFor: 'testing' stamp: ''!
isRelativeToLocalTime
	^isRelativeToUT not! !

!LeapSecond methodsFor: 'testing' stamp: ''!
isRelativeToUT
	^isRelativeToUT! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
lastScientificSecondSinceEpoch
	^lastScientificSecondSinceEpoch! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
next
	^next! !

!LeapSecond methodsFor: 'initialize-release' stamp: ''!
next: aLeapSecond 
	aLeapSecond == next 
		ifFalse: 
			[next == nil ifFalse: [next prev: nil].
			self basicNext: aLeapSecond.
			aLeapSecond == nil ifFalse: [aLeapSecond prev: self]]! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
postNetLeapSeconds
	^postNetLeapSeconds! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
preNetLeapSeconds
	^preNetLeapSeconds! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
prev
	^prev! !

!LeapSecond methodsFor: 'initialize-release' stamp: ''!
prev: aLeapSecond 
	aLeapSecond == prev 
		ifFalse: 
			[prev == nil ifFalse: [prev next: nil].
			self basicPrev: aLeapSecond.
			aLeapSecond == nil ifFalse: [aLeapSecond next: self]]! !

!LeapSecond methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	stream
		nextPut: $(;
		print: self dateAndTimeSpec;
		nextPutAll: ' | delta seconds=';
		print: secondsDelta;
		nextPutAll: ' | pre net leap seconds=';
		print: preNetLeapSeconds;
		nextPutAll: ' | post net leap seconds=';
		print: postNetLeapSeconds;
		nextPut: $)! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
secondsDelta
	^secondsDelta! !

!LeapSecond methodsFor: 'queries' stamp: ''!
secondsSinceCalendricalSecondSinceEpoch: secondSinceEpoch 
	^calendricalSecondsSinceEpoch - secondSinceEpoch! !

!LeapSecond methodsFor: 'queries' stamp: ''!
secondsSinceScientificSecondSinceEpoch: secondSinceEpoch 
	^secondsDelta > 1
		ifTrue: 
			[| diff |
			diff := firstScientificSecondSinceEpoch - secondSinceEpoch.
			diff <= 0
				ifTrue: 
					[diff := lastScientificSecondSinceEpoch - secondSinceEpoch.
					diff >= 0
						ifTrue: [0]
						ifFalse: [diff]]
				ifFalse: [diff]]
		ifFalse: [firstScientificSecondSinceEpoch - secondSinceEpoch]! !

!LeapSecond methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	^secondsSinceStartOfDay! !

!LeapSecond methodsFor: 'queries' stamp: ''!
secondsUntilCalendricalSecondSinceEpoch: secondSinceEpoch 
	^secondSinceEpoch - calendricalSecondsSinceEpoch! !

!LeapSecond methodsFor: 'queries' stamp: ''!
secondsUntilScientificSecondSinceEpoch: secondSinceEpoch 
	^secondsDelta > 1
		ifTrue: 
			[| diff |
			diff :=  secondSinceEpoch - firstScientificSecondSinceEpoch.
			diff >= 0
				ifTrue: 
					[diff :=  secondSinceEpoch - lastScientificSecondSinceEpoch.
					diff <= 0
						ifTrue: [0]
						ifFalse: [diff]]
				ifFalse: [diff]]
		ifFalse: [secondSinceEpoch - firstScientificSecondSinceEpoch]! !

!LeapSecond methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
setSecondsDelta: leapSeconds preNetLeapSeconds: preNetLeapSecs daysSinceEpoch: days secondsSinceStartOfDay: timeOfDayAsSeconds
	self assertMutability.

	secondsDelta := leapSeconds.
	preNetLeapSeconds := preNetLeapSecs.
	postNetLeapSeconds := preNetLeapSeconds + secondsDelta.
	daysSinceEpoch := days.
	secondsSinceStartOfDay := timeOfDayAsSeconds.
	calendricalSecondsSinceEpoch := (daysSinceEpoch * SecondsPerDay) + secondsSinceStartOfDay.
	firstScientificSecondSinceEpoch := calendricalSecondsSinceEpoch + preNetLeapSeconds.
	lastScientificSecondSinceEpoch := firstScientificSecondSinceEpoch + secondsDelta - 1! !

ChronosObject subclass: #MonthlyCalendarSpec
	instanceVariableNames: 'key nameKey daysPerMonth occurrenceType leapDayOrdinals'
	classVariableNames: 'EveryYearIntercalary LeapIntercalary Standard'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!MonthlyCalendarSpec commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

MonthlyCalendarSpec

	Concept:

		A MonthlyCalendarSpec represents/specifies the properties of a particular month as it occurs within a particular type of year (e.g., a standard year, a leap year) of a particular calendrical system (e.g., the Gregorian, Hebrew, or Persian calendar.)  It does NOT represent/specify an actual occurrence of a month in any specific year. In other words, an instance of MonthlyCalendarSpec would specify/represent (for example) the properties of the month of February as it occurs in any leap year of the Gregorian Calendar, but would not specify/represent any specific occurrence of February in a specific Gregorian year.

		MonthlyCalendarSpecs are used by instances of Calendar (which see) as factory objects in order to create and initialize instances of YearlyCalendar (which also see.)

	Implementation:

		Instance Variables

			key 								<Symbol>
				The key that semantically identifies the month represented by the instance.
			nameKey 							<Symbol | nil>
				The key that semantically identifies the name of the month represented by the instance (because what is semantically the "same month" may go by different names in different years--for example, "Adar" and "Adar Sheni" in the Hebrew Calendar.)  If the <nameKey> is nil, then the instance's "name key" is identical to its <key>.
			daysPerMonth 						<Integer>
				The number of days in the month represented by the instance.
			occurrenceType 					<Integer>
				Integer enumeration code, with the following encoding:
					0 = standard month that occurs every year ("standard month,") 
					1 = short month that occurs every year ("intercalary month,") and 
					2 = leap month that does not occur every year ("leap month.")
			leapDayOrdinals 					<Collection of Integer>
				Collection of the day-of-month ordinals of the days of the month represented by the instance that are leaps days (days that are inserted into the month in some years but not in others--note that a leap day does NOT have to be the last day of a month.)

!

!MonthlyCalendarSpec class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!MonthlyCalendarSpec class methodsFor: 'class initialization' stamp: ''!
initialize
	EveryYearIntercalary := 1.
	LeapIntercalary := 2.
	Standard := 0.! !

!MonthlyCalendarSpec class methodsFor: 'instance creation' stamp: ''!
newIntercalaryWithKey: anIdentifyingSymbol daysPerMonth: daysInMonth occursEveryYear: isNonLeap leapDayOrdinals: leapDays
	"Answer a new instance of the receiver that represents an intercalary month with the following properties:
		a) The key that semantically identifies the month (the 'month key') is <anIdentifyingSymbol>;
		b) The key that idenfities the month's name is also <anIdentifyingSymbol>;
		c) There are <daysInMonth> days in the month;
		e) If <isNonLeap>, then the month occurs every year, otherwise it does not (it's a 'leap month');
		d) The day-of-month ordinals of the month's leap days are contained in the Collection <leapDays> (which may be empty)"

	^self basicNew
		setKey: anIdentifyingSymbol;
		setDaysPerMonth: daysInMonth;
		setOccurrenceType: (isNonLeap ifTrue: [EveryYearIntercalary] ifFalse: [LeapIntercalary]);
		setLeapDayOrdinals: leapDays;
		beImmutable! !

!MonthlyCalendarSpec class methodsFor: 'instance creation' stamp: ''!
newIntercalaryWithKey: anIdentifyingSymbol nameKey: nameKey daysPerMonth: daysInMonth occursEveryYear: isNonLeap leapDayOrdinals: leapDays
	"Answer a new instance of the receiver that represents an intercalary month with the following properties:
		a) The key that semantically identifies the month (the 'month key') is <anIdentifyingSymbol>;
		b) The key that idenfities the month's name is <nameKey>;
		c) There are <daysInMonth> days in the month;
		e) If <isNonLeap>, then the month occurs every year, otherwise it does not (it's a 'leap month');
		d) The day-of-month ordinals of the month's leap days are contained in the Collection <leapDays> (which may be empty)"

	^self basicNew
		setKey: anIdentifyingSymbol;
		setNameKey: nameKey;
		setDaysPerMonth: daysInMonth;
		setOccurrenceType: (isNonLeap ifTrue: [EveryYearIntercalary] ifFalse: [LeapIntercalary]);
		setLeapDayOrdinals: leapDays;
		beImmutable! !

!MonthlyCalendarSpec class methodsFor: 'instance creation' stamp: ''!
newWithKey: anIdentifyingSymbol daysPerMonth: daysInMonth leapDayOrdinals: leapDays
	"Answer a new instance of the receiver that represents a non-leap/non-intercalary month with the following properties:
		a) The key that semantically identifies the month (the 'month key') is <anIdentifyingSymbol>;
		b) The key that idenfities the month's name is also <anIdentifyingSymbol>;
		c) There are <daysInMonth> days in the month;
		d) The day-of-month ordinals of the month's leap days are contained in the Collection <leapDays> (which may be empty)"

	^self basicNew
		setKey: anIdentifyingSymbol;
		setDaysPerMonth: daysInMonth;
		setOccurrenceType: Standard;
		setLeapDayOrdinals: leapDays;
		beImmutable! !

!MonthlyCalendarSpec class methodsFor: 'instance creation' stamp: ''!
newWithKey: anIdentifyingSymbol nameKey: nameKey daysPerMonth: daysInMonth leapDayOrdinals: leapDays
	"Answer a new instance of the receiver that represents a non-leap/non-intercalary month with the following properties:
		a) The key that semantically identifies the month (the 'month key') is <anIdentifyingSymbol>;
		b) The key that idenfities the month's name is <nameKey>;
		c) There are <daysInMonth> days in the month;
		d) The day-of-month ordinals of the month's leap days are contained in the Collection <leapDays> (which may be empty)"

	^self basicNew
		setKey: anIdentifyingSymbol;
		setNameKey: nameKey;
		setDaysPerMonth: daysInMonth;
		setOccurrenceType: Standard;
		setLeapDayOrdinals: leapDays;
		beImmutable! !

!MonthlyCalendarSpec methodsFor: 'enumerating' stamp: ''!
dayOfMonthOrdinalsDo: block1
	"For each day of the receiver's month, evaluate <block1> with the day-of-month ordinal (in ascending sequence) of the day as the argument."

	1 to: daysPerMonth do: [:index | block1 value: index]! !

!MonthlyCalendarSpec methodsFor: 'accessing' stamp: ''!
daysPerMonth
	"Answer the number of days in the month whose properties are specified by the receiver."

	^daysPerMonth! !

!MonthlyCalendarSpec methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut:key;
		nextPut: nameKey;
		nextPut: daysPerMonth;
		nextPut: occurrenceType;
		nextPut: leapDayOrdinals! !

!MonthlyCalendarSpec methodsFor: 'testing' stamp: ''!
hasLeapDayAt: dayOfMonthOrdinal
	"Answer whether the day of the receiver's month with the given <dayOfMonthOrdinal> is a leap day."

	^leapDayOrdinals includes: dayOfMonthOrdinal! !

!MonthlyCalendarSpec methodsFor: 'testing' stamp: ''!
hasLeapDays
	"Answer whether there are any leap days in the receiver's month."

	^leapDayOrdinals size > 0! !

!MonthlyCalendarSpec methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	self assertMutability.
	daysPerMonth := 0.
	occurrenceType := Standard.
	leapDayOrdinals := #()! !

!MonthlyCalendarSpec methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self 
		setKey: (literalArray at: 2);
		setNameKey: (literalArray at: 3);
		setDaysPerMonth: (literalArray at: 4) asNumber;
		setOccurrenceType: (literalArray at: 5) asNumber;
		setLeapDayOrdinals: (literalArray at: 6)! !

!MonthlyCalendarSpec methodsFor: 'testing' stamp: ''!
isIntercalaryMonth
	"Answer whether the receiver's month is an intercalary month. An intercalary month is one that either a) does not occur every year, and/or b) does not have nearly the same number of days as the majority of months in the year."

	^occurrenceType ~= Standard! !

!MonthlyCalendarSpec methodsFor: 'testing' stamp: ''!
isLeapMonth
	"Answer true if the month represented by the receiver does not occur in every type of year."

	^occurrenceType = LeapIntercalary! !

!MonthlyCalendarSpec methodsFor: 'testing' stamp: ''!
isStandardMonth
	"Answer whether the receiver's month is a 'normal' month. A normal month is one that a) occurs every year, and b) has about the same number of days as the majority of months in the year."

	^occurrenceType = Standard! !

!MonthlyCalendarSpec methodsFor: 'accessing' stamp: ''!
leapDayOrdinals
	^leapDayOrdinals! !

!MonthlyCalendarSpec methodsFor: 'enumerating' stamp: ''!
leapDayOrdinalsDo: block1
	"For each leap day in the receiver's month, evaluate <block1> with the day-of-month ordinal (in ascending sequence) of the day as the argument."

	leapDayOrdinals do: block1! !

!MonthlyCalendarSpec methodsFor: 'accessing' stamp: ''!
monthKey
	"Answer the semantic key that identifies the receiver's month."

	^key == nil ifTrue: [#'no-month-specified'] ifFalse: [key]! !

!MonthlyCalendarSpec methodsFor: 'accessing' stamp: ''!
monthName
	"Answer the name of the receiver's month according to the current default ChronosLocale."

	^ChronosLocale default properNameAtSemanticKey: self nameKey! !

!MonthlyCalendarSpec methodsFor: 'accessing' stamp: ''!
nameKey
	^nameKey == nil ifTrue: [self monthKey] ifFalse: [nameKey]! !

!MonthlyCalendarSpec methodsFor: 'testing' stamp: ''!
occursEveryYear
	"Answer whether the month represented by the receiver occurs in each and every type of year of the receiver's calendrical system."

	^occurrenceType ~= LeapIntercalary! !

!MonthlyCalendarSpec methodsFor: 'printing' stamp: ''!
printOn: stream
	stream 
		nextPut: ${;
		nextPutAll: self class name;
		nextPutAll: ' monthKey=';
		print: self monthKey;
		tab;
		nextPutAll: ' name=';
		nextPutAll: self monthName;
		crtab;
		nextPutAll: 'daysPerMonth=';
		print: self daysPerMonth;
		tab;
		nextPutAll: ' leapDayOrdinals=';
		print: self leapDayOrdinals;
		nextPut: $}! !

!MonthlyCalendarSpec methodsFor: 'initialize-release' stamp: ''!
setDaysPerMonth: daysInMonth
	self assertMutability.
	daysPerMonth := daysInMonth.! !

!MonthlyCalendarSpec methodsFor: 'initialize-release' stamp: ''!
setKey: anIdentifyingSymbol
	self assertMutability.
	key := anIdentifyingSymbol == nil ifFalse: [anIdentifyingSymbol asSymbol].! !

!MonthlyCalendarSpec methodsFor: 'initialize-release' stamp: ''!
setKey: anIdentifyingSymbol daysPerMonth: daysInMonth occurrenceType: occType leapDayOrdinals: leapDays

	key := anIdentifyingSymbol.
	daysPerMonth := daysInMonth.
	occurrenceType := occType.
	leapDayOrdinals := leapDays == nil ifTrue: [#()] ifFalse: [leapDays].! !

!MonthlyCalendarSpec methodsFor: 'initialize-release' stamp: ''!
setLeapDayOrdinals: leapDays
	self assertMutability.
	leapDayOrdinals := leapDays == nil ifTrue: [#()] ifFalse: [leapDays].! !

!MonthlyCalendarSpec methodsFor: 'initialize-release' stamp: ''!
setNameKey: anIdentifyingSymbol
	self assertMutability.
	nameKey := anIdentifyingSymbol == nil ifFalse: [anIdentifyingSymbol asSymbol].! !

!MonthlyCalendarSpec methodsFor: 'initialize-release' stamp: ''!
setOccurrenceType: occType
	self assertMutability.
	occurrenceType := occType! !

ChronosObject subclass: #SemanticDateObservanceRule
	instanceVariableNames: 'yearBase yearPeriod expirationYear dayOfWeekPolicy dayOfMonthConstraints'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Semantic Dates'!

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
dayOfWeekPolicy: nilOrAnArrayOf7Integers
	^self new
		setDayOfWeekPolicy: nilOrAnArrayOf7Integers;
		beImmutable! !

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
dayOfWeekPolicy: nilOrAnArrayOf7Integers dayOfMonthConstraints: aDictionaryOfWellKnownSymbols
	^self new
		setDayOfWeekPolicy: nilOrAnArrayOf7Integers;
		setDayOfMonthContraints: aDictionaryOfWellKnownSymbols;
		beImmutable! !

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
expirationYear: expirationYear
	^self new
		setExpirationYear: expirationYear;
		beImmutable! !

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
yearBase: base period: period
	^self new
		setYearBase: base;
		setYearPeriod: period;
		beImmutable! !

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
yearBase: base period: period dayOfWeekPolicy: nilOrAnArrayOf7Integers
	^self new
		setYearBase: base;
		setYearPeriod: period;
		setDayOfWeekPolicy: nilOrAnArrayOf7Integers;
		beImmutable! !

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
yearBase: base period: period dayOfWeekPolicy: nilOrAnArrayOf7Integers dayOfMonthConstraints: aDictionaryOfWellKnownSymbols
	^self new
		setYearBase: base;
		setYearPeriod: period;
		setDayOfWeekPolicy: nilOrAnArrayOf7Integers;
		setDayOfMonthContraints: aDictionaryOfWellKnownSymbols;
		beImmutable! !

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
yearBase: base period: period expirationYear: expirationYear
	^self new
		setYearBase: base;
		setYearPeriod: period;
		setExpirationYear: expirationYear;
		beImmutable! !

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
yearBase: base period: period expirationYear: expirationYear dayOfWeekPolicy: nilOrAnArrayOf7Integers
	^self new
		setYearBase: base;
		setYearPeriod: period;
		setExpirationYear: expirationYear;
		setDayOfWeekPolicy: nilOrAnArrayOf7Integers;
		beImmutable! !

!SemanticDateObservanceRule class methodsFor: 'instance creation' stamp: ''!
yearBase: base period: period expirationYear: expirationYear dayOfWeekPolicy: nilOrAnArrayOf7Integers dayOfMonthConstraints: aDictionaryOfWellKnownSymbols
	^self new
		setYearBase: base;
		setYearPeriod: period;
		setExpirationYear: expirationYear;
		setDayOfWeekPolicy: nilOrAnArrayOf7Integers;
		setDayOfMonthContraints: aDictionaryOfWellKnownSymbols;
		beImmutable! !

!SemanticDateObservanceRule methodsFor: 'accessing' stamp: ''!
dayOfMonthConstraints
	^dayOfMonthConstraints copy! !

!SemanticDateObservanceRule methodsFor: 'private' stamp: ''!
dayOfMonthObservanceConstraintOn: aDate 
	^dayOfMonthConstraints == nil 
		ifFalse: 
			[dayOfMonthConstraints isSymbol 
				ifTrue: [aDate isLastDayOfMonth ifTrue: [dayOfMonthConstraints]]
				ifFalse: [dayOfMonthConstraints at: aDate dayOfMonth ifAbsent: []]]! !

!SemanticDateObservanceRule methodsFor: 'accessing' stamp: ''!
dayOfWeekPolicy
	^dayOfWeekPolicy copy! !

!SemanticDateObservanceRule methodsFor: 'queries' stamp: ''!
doesEventNominallyOccurInYear: aYear
	"(SemanticDateObservanceRule yearBase: 0 period: 4) doesEventNominallyOccurInYear: 2003"
	"(SemanticDateObservanceRule yearBase: 0 period: 4) doesEventNominallyOccurInYear: 2004"
	"(SemanticDateObservanceRule yearBase: 0 period: 4) doesEventNominallyOccurInYear: 2005"
	"(SemanticDateObservanceRule yearBase: 1 period: 4) doesEventNominallyOccurInYear: 2003"
	"(SemanticDateObservanceRule yearBase: 1 period: 4) doesEventNominallyOccurInYear: 2004"
	"(SemanticDateObservanceRule yearBase: 1 period: 4) doesEventNominallyOccurInYear: 2005"

	expirationYear == nil 
		ifFalse: [aYear >= expirationYear ifTrue: [^false]].
	^yearPeriod = 0
		ifTrue: [true]
		ifFalse: [aYear - yearBase \\ yearPeriod = 0]! !

!SemanticDateObservanceRule methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream
		nextPut: yearBase;
		nextPut: yearPeriod;
		nextPut: expirationYear;
		nextPut: dayOfWeekPolicy;
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: dayOfMonthConstraints)! !

!SemanticDateObservanceRule methodsFor: 'queries' stamp: ''!
eventObservanceTypeNominallyOccuringOn: nominalAnnualDate for: aDate 
	"If <aDate> = <nominalAnnualDate inYear: aDate year>, answer #nominal.
	Otherwise, if <aDate> = the date that the observance rule represented by the receiver specifies for <nominalAnnualDate inYear: aDate year>, answer #observed.
	Otherwise, if <aDate> = a date for which the observance rule represented by the receiver forbids observance of the receiver's event, answer #notObserved.
	Otherwise, answer #none."

	| policy observanceConstraint |
	(self doesEventNominallyOccurInYear: aDate year) ifFalse: [^#none].
	observanceConstraint := self dayOfMonthObservanceConstraintOn: aDate.
	observanceConstraint == #notObserved ifTrue: [^#notObserved].
	dayOfWeekPolicy == nil 
		ifTrue: [policy := 0]
		ifFalse: 
			[policy := dayOfWeekPolicy at: aDate ansiDayOfWeekOrdinal.
			policy == #notObserved ifTrue: [^#notObserved]].
	nominalAnnualDate = aDate ifTrue: [^#nominal].
	^policy = 0 
		ifTrue: [#none]
		ifFalse: 
			[observanceConstraint == #observedOnlyIfNominal
				ifTrue: [#none]
				ifFalse: 
					[nominalAnnualDate = (aDate addingDays: policy) 
						ifTrue: [#observed]
						ifFalse: [#none]]]! !

!SemanticDateObservanceRule methodsFor: 'accessing' stamp: ''!
expirationYear
	^expirationYear! !

!SemanticDateObservanceRule methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	yearBase := 0.
	yearPeriod := 0.
	expirationYear := nil.
	dayOfWeekPolicy := nil.
	dayOfMonthConstraints := nil! !

!SemanticDateObservanceRule methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self
		setYearBase: (literalArray at: 2);
		setYearPeriod: (literalArray at: 3);
		setExpirationYear: (literalArray at: 4);
		setDayOfWeekPolicy: (literalArray at: 5);
		setDayOfMonthConstraints: (ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 6))! !

!SemanticDateObservanceRule methodsFor: 'queries' stamp: ''!
observanceDateAndTypeOf: nominalAnnualDate inYear: aYear into: block2 ifNone: ifNoneBlock 
	| nominalDate policy observanceConstraint |
	(self doesEventNominallyOccurInYear: aYear) ifFalse: [^ifNoneBlock value].
	nominalDate := nominalAnnualDate inYear: aYear.
	dayOfWeekPolicy == nil 
		ifFalse: 
			[| nominalDayOfWeek |
			nominalDayOfWeek := nominalDate ansiDayOfWeekOrdinal.
			policy := dayOfWeekPolicy at: nominalDayOfWeek.
			policy == #notObserved ifTrue: [^ifNoneBlock value].
			1 to: 7
				do: 
					[:dayOfWeek | 
					| diff |
					diff := nominalDayOfWeek - dayOfWeek.
					diff = 0 
						ifFalse: 
							[policy := dayOfWeekPolicy at: dayOfWeek.
							policy == #notObserved 
								ifFalse: 
									[diff = policy 
										ifTrue: 
											[| observedDate |
											observedDate := nominalDate subtractingDays: policy.
											^observedDate year = aYear 
												ifTrue: 
													[observanceConstraint := self dayOfMonthObservanceConstraintOn: observedDate.
													observanceConstraint == nil
														ifTrue: [block2 value: observedDate value: #observed]
														ifFalse: [ifNoneBlock value]]
												ifFalse: [ifNoneBlock value]]]]]].
	observanceConstraint := self dayOfMonthObservanceConstraintOn: nominalDate.
	^observanceConstraint == #notObserved 
		ifTrue: [ifNoneBlock value]
		ifFalse: [block2 value: nominalDate value: #nominal]! !

!SemanticDateObservanceRule methodsFor: 'private' stamp: ''!
postCopy
	"PRECONDTION: The receiver has just been instantiated as a #shallowCopy of another object.  
	POSTCONDITION: In response to this message, the receiver is required to make itself satisfy the following conditions and constraints: 1) It must be mutable,  2) It must compare (#=) as equal to the object from which it was shallowCopied, and 3) It must satisfy the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the object from which it was shallowCopied must not be changed, and b) whenever the object from which the receiver was shallowCopied mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the receiver must not be changed.  An associative reference is one where the semantics of the reference depend in any way on the object identity (#==) of the referenced object.  An attributive reference is one where any referenced object with the same value can transparently be substituted for any other such value-equivalent object without causing any error."

	"Subclasses may need to subimplement this message in order to satisfy the required semantics.  All subimplementers should send #postCopy to super."

	super postCopy.
	dayOfWeekPolicy := dayOfWeekPolicy copy.
	dayOfMonthConstraints := dayOfMonthConstraints copy! !

!SemanticDateObservanceRule methodsFor: 'initialize-release' stamp: ''!
setDayOfMonthContraints: aDictionaryOfSymbols
	self assertMutability.
	dayOfMonthConstraints := aDictionaryOfSymbols! !

!SemanticDateObservanceRule methodsFor: 'initialize-release' stamp: ''!
setDayOfWeekPolicy: anArrayOfIntegersIndexedByANSIDayOfWeekOrdinals 
	self assertMutability.
	dayOfWeekPolicy := anArrayOfIntegersIndexedByANSIDayOfWeekOrdinals.! !

!SemanticDateObservanceRule methodsFor: 'initialize-release' stamp: ''!
setExpirationYear: anInteger 
	self assertMutability.
	expirationYear := anInteger! !

!SemanticDateObservanceRule methodsFor: 'initialize-release' stamp: ''!
setYearBase: anInteger
	self assertMutability.
	yearBase := anInteger! !

!SemanticDateObservanceRule methodsFor: 'initialize-release' stamp: ''!
setYearPeriod: anInteger 
	self assertMutability.
	yearPeriod := anInteger == nil ifTrue: [0] ifFalse: [anInteger]! !

!SemanticDateObservanceRule methodsFor: 'accessing' stamp: ''!
yearBase
	^yearBase! !

!SemanticDateObservanceRule methodsFor: 'accessing' stamp: ''!
yearPeriod
	^yearPeriod! !

ChronosObject subclass: #ChronosPrintable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ChronosPrintable commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosPrintable

	Concept:

		ChronosPrintable is an abstract class that establishes a framework for instances (of a concrete subclass) to delegate to a ChronosPrintPolicy (which see) the responsibility for printing themselves on a Stream.  See the individual method comments for more information.

		ChronosPrintable also provides/implements Immutable behvavior/protocol and ChronosObject behavior/protocol (by inheritance.)

	Subclassing:

		Concrete subclasses must subimplement the instance method #printOn:using:




!

ChronosPrintable subclass: #ChronosPrintableDecorator
	instanceVariableNames: 'delegate defaultPolicy'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

ResourcePathContext subclass: #ChronosResourceRepositoryContext
	instanceVariableNames: 'version timestamp resourcePathPrefix timeZoneResourceBroker tzLocalizationPolicyResourceBroker'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-System'!

!ChronosResourceRepositoryContext class methodsFor: 'accessing' stamp: ''!
default
	^ChronosSystemFacade resourceRepositoryContext! !

!ChronosResourceRepositoryContext methodsFor: 'private' stamp: ''!
findValidResourcePathPrefix: block1
	^ChronosSystemFacade current findValidResourcePathPrefix: block1! !

!ChronosResourceRepositoryContext methodsFor: 'error signalling/handling' stamp: ''!
handleNonExistenceOfResourcePathReferencedBy: semanticKey 
	| rp |
	rp := self resourcePathTo: semanticKey
				ifNone: [^super handleNonExistenceOfResourcePathReferencedBy: semanticKey].
	self invalidateResourcePaths 
		ifTrue: 
			[rp := self resourcePathTo: semanticKey ifNone: [].
			rp exists ifTrue: [^true]].
	^super handleNonExistenceOfResourcePathReferencedBy: semanticKey! !

!ChronosResourceRepositoryContext methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	resourcePathPrefix := nil. 	"Relative to current working directory by default."
	self
		setDefaultHostnames;
		setCanonicalPathnameSuffixes;
		setPathDescriptions.! !

!ChronosResourceRepositoryContext methodsFor: 'installation' stamp: 'PaulDeBruicker 3/9/2011 10:39'!
install
	| success |
	self invalidateResourcePaths.
	ChronosSystemFacade current reportResourcePathnameMappings.
	self setTimeZoneResourceBroker.
	self setTzLocalizationPolicyResourceBroker.
	TimeZonePolicyFactory initialize.
	ChronosTimezone invalidate.
	LeapSecondSchedule invalidateUTC.
	success := 
		self invalidateWindowsToOlsonTZKeyMappings 
			and: [self invalidateTimeZoneKeys 
				and: [self invalidateTimeZoneAliases
					and: [self invalidateCountryCodeToCountryNameMappings]]].
	success 
		ifTrue: 
			[[(DateAndTimeFactory) invalidateTimezones] 
				on: Error
				do: 
					[:ex | 
					ChronosSystemFacade current reportTimeZoneInvalidationFailure: ex.
					ex return]].
	EnvironmentFacade current performGarbageCollection.
	^success! !

!ChronosResourceRepositoryContext methodsFor: 'installation' stamp: ''!
invalidateCountryCodeToCountryNameMappings
	"The memory-resident map of country-code to country-name mappings may be stale. Reload it from the canonical persistent data source. Answer true if successful, false otherwise."

	"{ChronosSystemFacade current resourceRepositoryContext invalidateCountryCodeToCountryNameMappings}"

	| rp stream |
	rp := self 
			resourcePathTo: #OlsonZoneInfoSourcesDirectory
			ifNone: [self signal: Error message: 'The system has no reference to the directory containing the mappings to country names from country codes.'].
	rp exists 
		ifFalse: 	
			[self invalidateResourcePaths.
			rp := self resourcePathTo: #OlsonZoneInfoSourcesDirectory ifNone: [rp]].
	rp exists 
		ifFalse: 
			[(self handleNonExistenceOfResourcePathReferencedBy: #OlsonZoneInfoSourcesDirectory) ifFalse: [^false].
			rp := self resourcePathTo: #OlsonZoneInfoSourcesDirectory ifNone: [rp]].
	rp := rp appending: 'iso3166.tab'.
	rp exists 
		ifFalse: 
			[self reportInaccessibleResource: rp.
			^false].

	stream := rp readStream.
	[TimeZoneLocalizationPolicy parseCountryCodeToNameMappingsFrom: stream] 
			ensure: [stream close].
	^true! !

!ChronosResourceRepositoryContext methodsFor: 'installation' stamp: ''!
invalidateResourcePaths
	"The resource paths may be invalid.  Reinitialize them."

	"{ChronosSystemFacade current resourceRepositoryContext invalidateResourcePaths}"

	| oldResourcePathPrefix |
	self resourcePathsExist ifTrue: [^true].
	oldResourcePathPrefix := resourcePathPrefix.
	^(self findValidResourcePathPrefix: 
			[:resourcePathPrefixString | 
			self resourcePathPrefix: resourcePathPrefixString]) 
		ifTrue: [true]
		ifFalse: 
			[resourcePathPrefix := oldResourcePathPrefix.
			false]! !

!ChronosResourceRepositoryContext methodsFor: 'installation' stamp: ''!
invalidateTimeZoneAliases
	"The memory-resident cache of timezone aliases may be stale. Reload it from the canonical persistent data source. Answer true if successful, false otherwise."

	"{ChronosSystemFacade current resourceRepositoryContext invalidateTimeZoneAliases}"

	| rp stream |
	rp := self 
				resourcePathTo: #TZRepository
				ifNone: [self signal: Error message: 'The system has no reference to the directory containing the timezone rule definitions.'].
	rp exists 
		ifFalse: 	
			[self invalidateResourcePaths.
			rp := self resourcePathTo: #TZRepository ifNone: [rp]].
	rp exists 
		ifFalse: 
			[(self handleNonExistenceOfResourcePathReferencedBy: #TZRepository) ifFalse: [^false].
			rp := self resourcePathTo: #TZRepository ifNone: [rp]].
	rp := rp appending: 'aliases'.
	rp exists 
		ifFalse: 
			[self reportInaccessibleResource: rp.
			^false].

	[stream := rp readStream.
	[ChronosFunction skipSeparators: stream.
	stream atEnd] whileFalse: 
				[| canonicalKey line aliases |
				canonicalKey := TimeZonePolicyFactory registrationKeyFrom: stream.
				line := ChronosFunction nextLineFrom: stream.
				aliases := ChronosFunction componentsFromString: line separator: $ .
				aliases do: 
						[:aliasingKeyString | 
						TimeZonePolicyFactory alias: canonicalKey as: aliasingKeyString asSymbol]]] 
			ensure: [stream close].
	^true! !

!ChronosResourceRepositoryContext methodsFor: 'installation' stamp: ''!
invalidateTimeZoneKeys
	"The memory-resident cache of timezone keys may be stale. Reload it from the canonical persistent data source. Answer true if successful, false otherwise."

	"{ChronosSystemFacade current resourceRepositoryContext invalidateTimeZoneKeys}"

	| rp stream |
	rp := self 
				resourcePathTo: #TZRepository
				ifNone: [self signal: Error message: 'The system has no reference to the directory containing the timezone rule definitions.'].
	rp exists 
		ifFalse: 	
			[self invalidateResourcePaths.
			rp := self resourcePathTo: #TZRepository ifNone: [rp]].
	rp exists 
		ifFalse: 
			[(self handleNonExistenceOfResourcePathReferencedBy: #TZRepository) ifFalse: [^false].
			rp := self resourcePathTo: #TZRepository ifNone: [rp]].
	rp := rp appending: 'index'.
	rp exists 
		ifFalse: 
			[self reportInaccessibleResource: rp.
			^false].

	[stream := rp readStream.
	
	[ChronosFunction skipSeparators: stream.
	stream atEnd] whileFalse: 
				[| key |
				key := (ChronosFunction nextLineFrom: stream) asSymbol.
				TimeZonePolicyFactory define: key]] 
			ensure: [stream close].
	^true! !

!ChronosResourceRepositoryContext methodsFor: 'installation' stamp: ''!
invalidateVersionAndTimestamp
	"{ChronosSystemFacade current resourceRepositoryContext invalidateVersionAndTimestamp}"

	| rp stream |
	rp := ResourcePath context: self components: (Array with: self timeZoneResourcesDirectoryName).
	rp := rp appending: 'version'.
	^[stream := rp readStream.
	[(ChronosFunction nextLineFrom: stream) = self versionTextHeading ifFalse: [stream close. ^false].
	ChronosFunction skipSeparators: stream.
	(stream upTo: $:) = 'version' ifFalse: [stream close. ^false].
	ChronosFunction skipSeparators: stream.
	version := ChronosFunction nextFrom: stream until: [:ch | ch isSeparator].
	ChronosFunction skipToNextLineOf: stream.
	ChronosFunction skipSeparators: stream.
	(stream upTo: $:) = 'timestamp' ifFalse: [stream close. ^false].
	ChronosFunction skipSeparators: stream.
	timestamp := DateAndTimeFactory readFrom: stream.
	true] ensure: [stream close]] on: Error do: [:ex | ex return: false]! !

!ChronosResourceRepositoryContext methodsFor: 'installation' stamp: ''!
invalidateWindowsToOlsonTZKeyMappings
	"The memory-resident map of Windows to Olson timezone keys may be stale. Reload it from the canonical persistent data source. Answer true if successful, false otherwise."

	"{ChronosSystemFacade current resourceRepositoryContext invalidateWindowsToOlsonTZKeyMappings}"

	| rp stream |
	rp := self 
			resourcePathTo: #TZForeignKeyMappings
			ifNone: [self signal: Error message: 'The system has no reference to the directory containing the mappings to Olson timezone keys from foreign timezone keys.'].
	rp exists 
		ifFalse: 	
			[self invalidateResourcePaths.
			rp := self resourcePathTo: #TZForeignKeyMappings ifNone: [rp]].
	rp exists 
		ifFalse: 
			[(self handleNonExistenceOfResourcePathReferencedBy: #TZForeignKeyMappings) ifFalse: [^false].
			rp := self resourcePathTo: #TZForeignKeyMappings ifNone: [rp]].
	rp := rp appending: 'windows'.
	rp exists 
		ifFalse: 
			[self reportInaccessibleResource: rp.
			^false].

	stream := rp readStream.
	[TimeZonePolicyFactory parseWindowsToOlsonTZKeyMappingsFrom: stream] 
			ensure: [stream close].
	^true! !

!ChronosResourceRepositoryContext methodsFor: 'canonical path suffixes' stamp: ''!
leapSecondSchedulesDirectoryName
	^'leap-seconds'! !

!ChronosResourceRepositoryContext methodsFor: 'services/utilities' stamp: ''!
logVersionAndTimestamp
	"ChronosResourceRepositoryContext default logVersionAndTimestamp"

	| rp stream |
	rp := ResourcePath context: self components: (Array with: self timeZoneResourcesDirectoryName).
	rp := rp appending: 'version'.
	stream := rp newWriteStream.
	[stream 
		nextPutAll: self versionTextHeading; cr; cr;
		nextPutAll: 'version: ';  nextPutAll: self version; cr;
		nextPutAll: 'timestamp: '; print: self timestamp] 
			ensure: [stream close].! !

!ChronosResourceRepositoryContext methodsFor: 'canonical path suffixes' stamp: ''!
olsonZoneinfoSourcesDirectoryName
	^'Olson-zoneinfo-sources'! !

!ChronosResourceRepositoryContext methodsFor: 'services/utilities' stamp: ''!
persistCanonicalTimeZoneKeys
	"Store the memory-resident cache of canonical timezone keys into the canonical persistent data store for storing timezone information."

	| rp stream |
	rp := self
				resourcePathTo: #TZRepository
				ifNone: [self signalError: 'The system has no reference to the directory containing the timezone rule definitions.'].
	rp := rp appending: 'index'.
	
	[stream := rp newWriteStream.
	TimeZonePolicyFactory writeCanonicalKeysOn: stream] ensure: [stream close]! !

!ChronosResourceRepositoryContext methodsFor: 'services/utilities' stamp: ''!
persistTimeZoneAliases
	"Store the memory-resident cache of timezone aliases into the canonical persistent data store for storing timezone aliases."

	| rp stream |
	rp := self resourcePathTo: #TZRepository ifNone: [self signal: Error message: 'The system has no reference to the directory containing the timezone rule definitions.'].
	rp := rp appending: 'aliases'.
	[stream := rp newWriteStream.
	TimeZonePolicyFactory writeAliasesOn: stream] 
			ensure: [stream close].! !

!ChronosResourceRepositoryContext methodsFor: 'error signalling/handling' stamp: ''!
reportInaccessibleResource: resourcePath 
	self reportToConsole: resourcePath printString 
				, ' persistent/remote resource is not accessible.'! !

!ChronosResourceRepositoryContext methodsFor: 'accessing' stamp: ''!
resourcePathPrefix
	^resourcePathPrefix! !

!ChronosResourceRepositoryContext methodsFor: 'accessing' stamp: ''!
resourcePathPrefix: prefixString 
	| newResourcePathPrefix rp |
	newResourcePathPrefix := (ChronosFunction isNilOrEmpty: prefixString) ifFalse: [prefixString].
	resourcePathPrefix = newResourcePathPrefix ifTrue: [^self resourcePathsExist].
	rp := newResourcePathPrefix == nil 
			ifTrue: [ResourcePath currentDirectory] 
			ifFalse: 
				[[ResourcePath fromString: newResourcePathPrefix] 
					on: Error 
					do: [:ex | ChronosSystemFacade current 
									reportException: ex 
									message: 'Unable to change the resource path prefix to the value specified due to the following error: '. ^false]].
	self setToDefaultConfiguration.
	rp setNonDefaultSpecifiedAttributesAsDefaultsInContext: self.
	^self resourcePathsExist 
		ifTrue: 
			[resourcePathPrefix := newResourcePathPrefix.
			true]
		ifFalse: 
			[self setToDefaultConfiguration.
			resourcePathPrefix == nil 
				ifFalse: 
					[rp := ResourcePath fromString: resourcePathPrefix.
					rp setNonDefaultSpecifiedAttributesAsDefaultsInContext: self].
			false]! !

!ChronosResourceRepositoryContext methodsFor: 'queries' stamp: ''!
resourcePathsExist
	"ChronosResourceRepositoryContext default resourcePathsExist"
	^self invalidateVersionAndTimestamp or: [super resourcePathsExist]! !

!ChronosResourceRepositoryContext methodsFor: 'installation' stamp: ''!
retrieveLeapSecondSchedule: key ifNone: ifNoneBlock
	| rp stream lss |
	rp := self resourcePathTo: #LeapSecondScheduleRepository
				ifNone: [^ifNoneBlock value].
	rp := rp appending: key.
	rp := rp appendingExtension: 'lss'.
	rp exists ifFalse: [^ifNoneBlock value].
	stream := rp readStream.
	[lss := LeapSecondSchedule decodeFrom: stream] ensure: [stream close].
	^lss! !

!ChronosResourceRepositoryContext methodsFor: 'private' stamp: ''!
setCanonicalPathnameSuffixes
	"Set the path suffixes of the Chronos resources (e.g., timezone rulesets, timezone localization policies, etc.) to their standard values."

	"{ChronosSystemFacade current resourcePathContext setCanonicalPathnameSuffixes}"

	self 
		resourcePathTo: #LeapSecondScheduleRepository
			put: (ResourcePath 
					context: self
					components: (Array with: self timeZoneResourcesDirectoryName with: self leapSecondSchedulesDirectoryName));
		resourcePathTo: #TZRepository
			put: (ResourcePath 
					context: self
					components: (Array with: self timeZoneResourcesDirectoryName with: self timezoneRulesetDirectoryName));
		resourcePathTo: #TZLocalizationPolicyRepository
			put: (ResourcePath 
					context: self
					components: (Array with: self timeZoneResourcesDirectoryName with: self timezoneLocalizationPolicyDirectoryName));
		resourcePathTo: #TZForeignKeyMappings
			put: (ResourcePath 
					context: self
					components: (Array with: self timeZoneResourcesDirectoryName with: self timezoneForeignKeyDirectoryName));
		resourcePathTo: #OlsonZoneInfoSourcesDirectory
			put: (ResourcePath 
					context: self
					components: (Array with: self timeZoneResourcesDirectoryName with: self olsonZoneinfoSourcesDirectoryName)).! !

!ChronosResourceRepositoryContext methodsFor: 'private' stamp: ''!
setDefaultHostnames
	self
		defaultHostnameAt: #http put: #'date-time-zone.com';	
		defaultHostnameAt: #https put: #'date-time-zone.com'! !

!ChronosResourceRepositoryContext methodsFor: 'private' stamp: ''!
setPathDescriptions
	self 
		pathDescriptionAt: #LeapSecondScheduleRepository put: 'The directory containing leap second schedules.';
		pathDescriptionAt: #TZRepository put: 'The directory containing timezone ruleset definitions';
		pathDescriptionAt: #TZLocalizationPolicyRepository put: 'The directory containing timezone localization policy definitions';
		pathDescriptionAt: #TZForeignKeyMappings put: 'The directory containing mappings from non-Olson timezone keys (e.g., Windows) to Olson timezone keys';
		pathDescriptionAt: #OlsonZoneInfoSourcesDirectory put: 'The directory containing the source Olson timezone rulesets from which Chronos compiles its timezone rulesets'! !

!ChronosResourceRepositoryContext methodsFor: 'private' stamp: ''!
setTimeZoneResourceBroker
	timeZoneResourceBroker := ResourceBroker new.
	timeZoneResourceBroker
		context: self;
		factory: TimeZonePolicyFactory;
		baseDirectoryKey: #TZRepository;
		elementExtension: self timezoneExtension! !

!ChronosResourceRepositoryContext methodsFor: 'private' stamp: ''!
setToDefaultConfiguration
	self initializeDefaults.
	self setDefaultHostnames.! !

!ChronosResourceRepositoryContext methodsFor: 'private' stamp: ''!
setTzLocalizationPolicyResourceBroker
	tzLocalizationPolicyResourceBroker := ResourceBroker new.
	tzLocalizationPolicyResourceBroker
		context: self;
		factory: TimeZoneLocalizationPolicy;
		baseDirectoryKey: #TZLocalizationPolicyRepository;
		elementExtension: self tzLocalizationPolicyExtension! !

!ChronosResourceRepositoryContext methodsFor: 'services/utilities' stamp: ''!
storeLeapSecondSchedule: lss
	| rp stream |
	rp := self resourcePathTo: #LeapSecondScheduleRepository ifNone: [].
	rp makeDirectory.
	rp := rp appending: lss registrationKey.
	rp := rp appendingExtension: 'lss'.
	stream := rp newWriteStream.
	[lss encodeOn: stream] ensure: [stream close].! !

!ChronosResourceRepositoryContext methodsFor: 'accessing' stamp: ''!
timeZoneResourceBroker
	timeZoneResourceBroker == nil ifTrue: [self setTimeZoneResourceBroker].
	^timeZoneResourceBroker! !

!ChronosResourceRepositoryContext methodsFor: 'canonical path suffixes' stamp: ''!
timeZoneResourcesDirectoryName
	^'time-zones'! !

!ChronosResourceRepositoryContext methodsFor: 'accessing' stamp: ''!
timestamp
	^timestamp == nil ifTrue: [DateAndTimeFactory utNow] ifFalse: [timestamp]! !

!ChronosResourceRepositoryContext methodsFor: 'canonical path suffixes' stamp: ''!
timezoneExtension
	^'tzn'! !

!ChronosResourceRepositoryContext methodsFor: 'canonical path suffixes' stamp: ''!
timezoneForeignKeyDirectoryName
	^'foreign-keys'! !

!ChronosResourceRepositoryContext methodsFor: 'canonical path suffixes' stamp: ''!
timezoneLocalizationPolicyDirectoryName
	^'localization-policies'! !

!ChronosResourceRepositoryContext methodsFor: 'canonical path suffixes' stamp: ''!
timezoneRulesetDirectoryName
	^'rulesets'! !

!ChronosResourceRepositoryContext methodsFor: 'canonical path suffixes' stamp: ''!
tzLocalizationPolicyExtension
	^'tzl'! !

!ChronosResourceRepositoryContext methodsFor: 'accessing' stamp: ''!
tzLocalizationPolicyResourceBroker
	tzLocalizationPolicyResourceBroker == nil ifTrue: [self setTzLocalizationPolicyResourceBroker].
	^tzLocalizationPolicyResourceBroker! !

!ChronosResourceRepositoryContext methodsFor: 'accessing' stamp: ''!
version
	^version == nil ifTrue: ['unknown'] ifFalse: [version]! !

!ChronosResourceRepositoryContext methodsFor: 'accessing' stamp: ''!
version: aVersionString
	"ChronosResourceRepositoryContext default version: 'Olson/2006b'"

	aVersionString = version
		ifFalse:
			[version := aVersionString.
			timestamp := DateAndTimeFactory utNow].! !

!ChronosResourceRepositoryContext methodsFor: 'accessing' stamp: ''!
versionTextHeading
	^'## Chronos Time Zone Repository ##'! !

PassportObject subclass: #ChronosSystemFacade
	instanceVariableNames: 'showReports resourceRepositoryContext systemTimeZone systemTimeZoneBindingStrategy systemLanguageCode systemCountryCode'
	classVariableNames: 'Current'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-System'!

!ChronosSystemFacade commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosSystemFacade

	Concept:

		The Chronos date/time library uses an instance of a concrete subclass of the abstract class ChronosSystemFacade as a facade for invoking functions whose implementation is beyond the scope of the Chronos date/time library itself, and where the API (or perhaps the language syntax) for performing such functions is generally different accross implementations of Smalltalk. A ChronosSystemFacade is also used to provide a facade for invoking functions that may need to be implemented differently when Chronos is used by (or in) a particular user base, organization, use case, application, locale, legal jurisdiction or operating system.

	Usage:

		Singleton (<ChronosSystemFacade current>)

			There is no need for more than one instance of the ChronosSystemFacade (in fact, multiple instances might be problematical.)  Consequently, ChronosSystemFacade implements the singleton design pattern.  The current active instance (the singleton) is accessed by evaluating 'ChronosSystemFacade current.'

		Instantiation  

			A new instance of a ChronosSystemFacade is created by sending the message #new to its class. However, since ChronosSystemFacade is an abstract class, and since each subclass is specific to a particular environment (Smaltalk implementation and/or client/application use case,) the  substantive issue that must be resolved is which class in the hierarchy of ChronosSystemFacade should be instantiated.  The same issue must be resolved in the case of ChronosSystemEnvironment and ChronosSystemClock.  

			The solution strategy is as follows: a) ChronosEnvironment and one concrete subclass thereof, specific to a particular platform, are packaged into a separate module ("package")--a different module for each platform, so that only the concrete subclass(es) of ChronosEnvironment needed by a particular platform will be installed when loading Chronos into an image; b)  ChronosSystemEnvrionment and ChronosSystemClock, and one platform-specific subclass of each, along with several other "system" classes,  are packaged into a separate module ("package")--a different module for each platform, so that only the concrete subclassses of ChronosSystemFacade and ChronosSystemClock needed by a particular platform will be installed when loading Chronos into an image; c)  The platform-specific subclass(es) of ChronosEnviromnent must subimplement the class method #systemFacadeClass, so that the method answers the concrete subclass of ChronosSystemFacade that should be instantiated as the ChronosSystemFacade singleton; and d) the concrete subclass of ChronosSystemFacade for a particular platform must subimplement the method #newSystemClock so that it answers a new instance of the concrete subclass of ChronosSystemClock that should be instantiated for use on the same platform for which that ChronosSystemFacade subclass is intended.  Consequently, the portable way to instantiate an instance of ChronosSystemFacade that is correct for the current platform is to ask the ChronosEnvironment class for the correct subclass of ChronosSystemFacade (by evaluating  'ChronosEnvironment systemFacadeClass',) and then sending #new to the result.

		Initialization

			When Chronos is first installed in an image, or when the Chronos codebase is loaded by a non-image-based Smalltalk runtime, or when a Chronos-enabled image is restared after a snapshot, the ChronosSystemFacade is responsible for (among other things) a) determining the local timezone used by the host system, b) determining the ISO 939 country-code and ISO 3166 language-code of the host system's locale, and c) determining the physical resource pathnames that should be used for each logical resource pathname required by Chronos (e.g., the path to the base directory where the timezone ruleset files reside.)   In order to fulfill those responsibilities, the ChronosSystemFacade must be informed whenever Chronos is initially installed and/or whenever a Chronos-enabled image is restarted after a snapshot.

			When Chronos is first installed, a singleton instance of the correct subclass of ChronosSystemFacade must be instantiated, and then this instance must be sent the message #installInitially. Doing so is the responsibility of ChronosEnvironment (see the method ChronosEnvironment>>installSystemFacade.)

			When an image is restarted after a snapshot, the message #install must be sent to the ChronosSystemFacade singleton.  Arranging for that to happen is the responsibility of the method ChronosSystemFacade>>registerForStartupNotification--which should be invoked by the implementation of ChronosSystemFacade>>installInitially (unless the host Smtalltalk implementation is not image-based.)

			However, if either a) the global #ChronosInstallationFlag is defined with the value false, or b) the environment variable CHRONOS_INSTALLATION is defined with the value 'NO', then the ChronosSystemFacade singleton will short-circuit almost all of its normal installation actions and procedures.  Avoiding the installation process may be necessary when a) doing development work on the Chronos codebase, or b) porting Chronos to a different Smalltalk system, or to a different version of the same Smalltalk environment. See the instance method #shouldSkipInstallation for more details.

		ChronosSystemClock Instantiation

			Since the code required to implement and encapsulate a clock device is necessarily quite system dependent (with respect to Smalltalk implementations, operating systems and perhaps even the available/desired clock hardware,) there must be a different ChronosSystemClock class for each implementation platform.  Instantiation of the appropriate ChronosSystemClock subclass is the responsibility of the ChronosSystemFacade singleton, which, in response to the message #newSystemClock, must instantiate and answer an instance of the subclass of ChronosSystemClock that is correct/appropriate for the current platform.

		Current Time--Network Time Service

			For situations where there is no local clock, or where it is desired to obtain the current time using the network time service as defined by RFC-868, the ChronosSystemFacade singleton responds to the message #rfc868SecondsSince1900 by answering the number of seconds since 1900-01-01T00:00:00 UT [Gregorian] (obtaining the answer from a network time server, in accordance with the protocol defined by RFC-868.) The implementation of this method is obviously highly non-portable among the various Smalltalk platforms (partly because the ANSI Smalltalk standard does not address networking.) It should be noted that the Chronos codebase only invokes the #rfc868SecondsSince1900 method in cases where the system clock singleton is actually an instance of ChronosSystemClock itself, instead of an instance of a subclass of ChronosSystemClock encapsulating access to some clock service other than that defined by RFC-868  (if the method ChronosSystemFacade>>newSystemClock has not been subimplemented to answer an instance of a subclass of ChronosSystemClock, then the default implementation in ChronosSystemFacade itself answers an instance ChronosSystemClock, and not an instance of a subclass.) Consequently, in the normal case, the Chronos codebase would not actually ever send the message #rfc868SecondsSince1900 to the ChronosSystemFacade singleton.

		WeakDictionary Instantiation

			Since there is no standard for WeakDictionaries, Chronos delegates instantiation of Dictionaries that weakly reference their elements (values) to the ChronosSystemFacade.  The ChronosSystemFacade singleton is responsible for providing a new, empty "Weak Dictionary" in response to the message #newWeakDictionary.  If porting Chronos to a Smalltalk implementation that does not support weak references, then a simple Dictionary (or its equivalent) may be used instead (most appropriately as an initial "first cut" at a port.)  However, answering a non-weak, conventional Dictionary in response to #newWeakDictionary will result in substantially suboptimal memory usage--especially in an image-based Smalltalk implementation.  The scope of the problem can be investigated by looking at all senders of #newWeakDictionary. Recommendation in such a case: Either implement weak references and WeakDictionaries, or implement/use an LRU cache instead.

		Delay Instantiation

			To instantiate a Delay whose delay interval is the time inverval represented by a Duration, send the message #newDelayFromDuration: to the ChronosSystemFacade singleton with a Duration as the arguement. Note: ScientificDuration (which implements the ANSI-Smalltalk protocol <Duration>) provides the method #asDelay, which is implemented as '^ChronosSystemFacade current newDelayFromDuration: self'.

		User Interaction

			When the ChronosSystemFacade is not able to resolve the host system's local timezone, it attempts to notify the user of the failure.  To do so, it sends the message #userNotify: to itself with an explanatory message as the argument.  The code required to actually present such a notification to a user is highly non-portable (and even if such code could be portable, it is highly likely that the 'look and feel' of the notification widetry would fail to thematically conform to the standard conventions of an application that uses Chronos, given such issues as colors, fonts, layout, terminology, language, visual metaphors, etc.)  And some applications are necessarily headless, and cannot have a conversational/interactive UI. Therefore, the implementation of #userNotify: is the responsibility of whoever ports Chronos to a platform (and/or of an application using Chronos that has its own specific requirements for such notifications.)

		Exceptions

			The Chronos codebase assumes that the ANSI-standard ExceptionFactory globals are available.  If that is not the case, they must be defined (perhaps as facades over functionality native to the platform.)

			Some applications may need Chronos to raise exceptions differently than the default implementation. Consequently, the ChronosSystemFacade implements the instance method #signal:message:, and Chronos always raises Exceptions by sending the message #signal:message: the current ChronosSystemFacade singleton. The first argument is an object that plays the role of an ANSI-Smalltalk <ExceptionFactory>.  The second argument is a String containing the message to be associated with the raised exception.  Applications can easily subimplement #signal:message: to suit their needs.

		Localization: System-Timezone; System-Locale Keys

			System Timezone: 

				Send #systemTimeZone to the ChronosSystemFacade singleton to get the ChronosTimezone that implements  time zone rules that match those of the host system's local time zone as closely as possible. See the comment (below) for the instance variable <systemTimeZone> for more information.

				Send #systemTimeZone: to the singleton to set the Chronos "system timezone" to be a ChronosTimezone instance (depending on the particular implementation of the ChronosSystemFacade that receives this message, this may or may not have any effect on the host system's local timezone, although ideally, it should (and may in fact have that result.)) Currently, the VisualWorks implementation changes the reference Core.TimeZone to one that matches the Chronos time zone as closely as possible, but does not attempt to change the operating system's time zone.)

			System Locale Language Code: 

				Send #systemLanguageCode to the singleton to get the ISO 639 code for the language of the system's locale.

			System Locale Country Code: 

				Send #systemCountryCode to the singleton to get the ISO 3166 code for the country of the system's locale.

			System Locale Key: 

				Send #systemLocaleKey to the singleton to get the key of the ChronosLocale that represents the system's locale.

		ChronosLocale Instantiation

			For localization/internationalization, Chronos uses instances of ChronosLocale (because the ANSI Smalltalk standard defines no standard API--a major gap.)  However, Chronos is a date/time library, and is not intended as a library for localization/internationalization.  Consequently, constructing instances of ChronosLocale properly initialized/configured for a particular locale is the responsibility of the ChronosSystemFacade singleton. In response to the message #findOrCreateChronosLocaleAt:, the ChronosSystemFacade singleton ideally should construct and answer an instance of ChronosLocale that will provide behavior that is appropriate for the locale identified by the locale-key provided as the argument.  See ChronosLocale, and the method comment of #findOrCreateChronosLocaleAt:, for more information.

			Chronos provides a "hard-coded" ChronosLocale for the United States (#en_US), which can be retrieved by evaluating 'ChronosLocale unitedStates.'. The default implementation of #findOrCreateChronosLocaleAt: provided by ChronosSystemFacade itself alwyays answers <ChronosLocale unitedStates>. The VisualWorks-specific ChronosSystemFacade (VWSystemFacade) creates, configures and then answers an instance of ConfigurableChronosLocale based on the information obtained from a VisualWorks Locale object.  

			Those porting Chronos to other Smalltalk platforms should attempt to leverage whatever Locale functionality may be provided by the host Smalltalk implementation.  If the ChronosLocale implementation provided by whomever ported Chronos to the flavor of Smalltalk being used is not adequate, then it may be necessary to implement a repository of ChronosLocale reference data and subimplement ChronosSystemFacade>>#findOrCreateChronosLocaleAt: so that it gets Locale information from the repository.  Locale information may also be available from the host operating system.

		Storing/Retrieving Chronos Reference Data
		
			ChronosSystemFacade delegates the responsibility for accessing reference data (i.e., "resources") to one or more concrete subclasses of ResourcePathFacade (which see.)  ResourcePathFacade instances are only directly used by instances of ResourcePath (also which see.)

			 The ChronosSystemFacade singleton is only responsible for knowing the name of the concrete subclass of ResourcePathFacade that is appropriate for use on the host platform by the client application, and for instantiating instances thereof as required. The ChronosSystemFacade singleton maintains a default instance of a ResourcePathFacade in an instance variable, and returns it in response to the message #resourcePathFacade.  However, there is no reason that instances of more than one concrete subclass of ResourcePathFacade could not simultaneously be in use in the same execution environment (image)--perhaps because some resources reside in local disk files while others reside in a remote reference data server and are accessed by means of (say) HTTP transport.

		Logical to Physical File Mapping

			The Chronos library does not use or depend on absolute pathnames to external resources, for three reasons: 1) Absolute pathnames are highly non-portable among different filesystems (and/or external namespace systems,)  2) Even if absolute pathnames could be specified in a portable way, the existence of the specified paths could not and should not be standardized accross platforms (e.g, there is no reason for Windows to have a c:\usr\local directory, nor for Unix to have a /Windows/system32 directory,) nor should all machines (even those running the same OS) be required to have the same directory structure, and 3) There is no way to guarantee the uniqueness of absolute pathnames (naming collisions cannot be prevented.)  These are the same issues that have motivated the existence and wide-spread usage of relative pathames in many other contexts.

			In most filesystems, a relative pathname is interpreted as a suffix of the absolute pathname of the "current directory."  A more general system would enable pathnames to be interpreted as suffixes relative to any set of absolute reference pathnames, where each absolute reference pathname is identified by some well-known key or identifier.  The ChronosSystemFacade is responsible for providing precisely such a set of well-known absolute reference pathnames, which may be used as prefixes to relative pathnames. This service enables the Chronos library to operate portably and transparently on any platform, without knowing or caring about the absolute pathnames needed to access Chronos reference data.  It also makes it possible for applications using Chronos to store the Chronos reference data at whatever location may be most appropriate for their individual situations (e.g., single user/single image, single user/multiple images/same machine, multiple users/multiple images/multiple machines.)
	
			The Chronos codebase will send the message #resourcePathTo:ifNone: to the ChronosSystemFacade singleton in order to get the absolute pathname currently bound to a particular well-known "semantic key." The "semantic key" idientifies an absolute pathname according to its intended role, function, purpose or usage.

			The well-known pathnames and associated semantic keys used by the Chronos codebase:
		
				Semantic Key							Role/function/purpose/usage of associated absolute pathname

				#TZRepository							The directory that contains the Chronos TimeZone specification files, and the zone alias file 
															(these files are generated by the Chronos TimeZone Compiler.)
				#TZLocalizationPolicyRepository		The directory that contains the Chronos TimeZoneLocalizationPolicy definition files
															(the default versions of these files are generated by the Chronos TimeZone Compiler.)
				#TZForeignKeyMappings				The directory that contains files that associate foreign timezone keys with those used by Chronos.
				#OlsonZoneInfoSourcesDirectory	The directory/folder containing the source files (text files using Unix line-end convertions) 
															that comprise the Olson Timezone Database (used only by the Chronos TimeZone Compiler.) 
															On UNIX systems, it may be desirable to make this directory be a symbolic link to the directory 
															where that system keeps its own zoneinfo source files, so as to ensure that the system's binary 
															timezone files and Chronos's time zone ruleset files are both derived from the same version of 
															the Olson TZ Database.
				#LeapSecondScheduleRepository	The directory/folder containing the schedule of leap seonds associated with particular 
															timescales, such as UTC.

		Accessing Chronos Resources in a Chronos Resource Repository

			Persistent/remote Chronos Respositories are accessed and updated using instances of ChronosResourceRepository (which is a concrete class.) A ChronosResourceRepository is a Dictionary-like object that uses a) one instance of (a concrete subclass of) ResourceReference per element, and b) one instance of (a concrete subclass of) ResourceBroker per instance of ChronosResourceRepository to store resources into and retrieve them from a persistent/remote resource repository. A ResourceReference is an Association-like object that knows how to collaborate with the ResourceBroker that instantiated it.  A ResourceBroker is both a factory for ResourceReference instances and an implementer of read/write operations to a particular physical repository using a particular transport or access protocol (the default implementation uses ResourcePaths, but other implementations are quite possible.) The combination of the multiple levels of abstraction provided by a) a ChronosResourceRepository, b) a ResourceReference, c) a ResourceBroker, d) ResourcePaths, e) one or more ResourcePathFacades and finally a ChronosSystemFacade should be able to handle just about any host platform, any Smalltalk environment and any Use Case. Resources absolutely do not have to reside in local disk files!!
		
			It is the responsibility of the ChronosSystemFacade singleton to instantiate instances of (concrete subclasses of) ResourceBroker that bind a ChronosResourceRepository to a remote/persistent repository at a particular physical location (which might be a local file directory, a remote JNDI Context, a remote LDAP directory, or a remote Smalltalk image, Web Server or Application Server acting as a reference data server.)  

			Currently, the ChronosSystemFacade singleton must instantiate and provide one instance of ResourceBroker that knows how to access the repository of time zone rule sets and another instance that knows how to access the repository of time zone localization policies.  The ChronosSystemFacade singleton must answer the ResourceBroker for time zone rule sets in response to the message #timeZoneResourceBroker, and must answer the ResourceBroker for time zone localization policies in response to the message #tzLocalizationPolicyResourceBroker.

		Other Chronos Reference Data

			In addition to TimeZonePolicyFactories and TimeZoneLocalizationPolicies, Chronos also needs to store/retrieve the following auxilliary reference data:
	
				TimeZone Key List
	
					Due to the fact that on image startup it is not a valid assumption that the set of time zones in the time zone rule set repository is the same as when the image was snapshoted, Chronos maintains a separate list (as a "file" in the time zone repository) of the keys of all timezones.  When it is sent the message #invalidateTimeZoneKeys, the ChronosSystemFacade singleton is responsbile for updating Chronos set of timezone keys maintained by the ChronosResourceRepository of time zone rule sets from the external "file" of zone keys. By default, #invalidateTimeZoneKeys is sent a) when Chronos is first installed, and b) when the image is restarted after a snapshot.

				TimeZone Key Alias Registry	
					
					To enable both "backwards" and "sideways" compatibility, Chronos maintains a separate registry (as a class variable of TimeZonePolicyFactory) of "alternate keys" (aliases) for some time zones.  When it is sent the message #invalidateTimeZoneAliases, the ChronosSystemFacade singleton is responsbile for refreshing the registry of time zone aliases from the persistent reference data. By default, #invalidateTimeZoneAliases is sent a) when Chronos is first installed, and b) when the image is restarted after a snapshot.

					When the Chronos TimeZone Compiler processes the Olson timezone source data, it stores any time zone aliases defined therein in the alias registry maintained by TimeZonePolicyFactory class.  Upon completion of its task of compiling the Olson timezone data into Chronos format, it sends the message #persistTimeZoneAliases to the ChronosSystemFacade singleton.  In response, the ChronosSystemFacade singleton is responsible for persistently storing the registry of timezone aliases.

				Leap Second Schedules

					When sent the message retrieveLeapSecondScheduleifNone:, the ChronosSystemFacade singleton is responsible for for instantiating and answering a LeapSecondSchedule for the timescale identified by the first argument (a Symbol.) The default implementation provided by ChronosSystemFacade gets the necessary leap second schedule information from a file whose name is <timeScaleKey>.lss.

	Motivation:

		By concentrating all system-specific code in the class hierarchies of ResourcePathFacade, ChronosSystemFacade, ChronosSystemClock and ChronosEnvironment, and by defining a standard API for the invocation of non-portable services, ResourcePathFacade enhances the portability of the codebase of the Chronos date/time library, both with respect to different implementations/versions of Smalltalk and also with respect to the varying needs and preferences of applications (or code libraries) that use Chronos.

		Ideally, porting Chronos to a new Smalltalk implementation (or in some cases, to a new version of a Smalltalk implementation) should require nothing more than writing a new subclass of a) ChronosEnvironment, b) ChronosSystemFacade, c) ResourcePathFacade and d) ChronosSystemClock. In reality, it will probably also be necessary to add (or reuse) inter-system compatibility methods in some classes of the host Smalltalk system's base library. Examples thereof might include methods such as #readStream and #writeStream in SequenceableCollection (or its equivalent(s)), and perhaps one or more utility methods in Stream. Finally, although the ANSI standard requires the existence of a class for scaled decimals, it very unfortunately does not specify the name of the class, nor the protocol for a scaled decimal factory.  Chronos assumes that the global that references the factory object for scaled decimal values is named ScaledDecimal, and that it conforms to the instance creation protocol defined by the VisualWorks FixedPoint class. If the native Smalltalk environment does not use the global name ScaledDecimal to reference the factory object for scaled decimal values, then the method ChronosEnvironemnt>>nativeScaledDecimalClass must be subimplemented by the subclass of ChronosEnvironment that will be used in that environment.  If the scaled decimal factory object's instance creation protocol does not conform to that of the VisualWorks FixedPoint class, then VW compatibility methods must be added.

		Modification of the Chronos codebase for the purpose of making Chronos work correctly on the Smalltalk platform to which it is being ported (other than as herein described,) is strongly not recommended. Instead, please notify the author of Chronos of the porting problem {send and e-mail to porting (at) chronos-st (dot) org} so that a general solution to the problem can be designed and incorporated into the mainline Chronos codebase. 

		See also: ChronosEnvironment, ChronosSystemClock

	Implementation:

		Instance Variables

		systemTimeZone	<ChronosTimezone>	
			The Chronos 'system timezone.' The system timezone is intended to a) define the mapping between local time and Universal Time at the location of the host sytem, and b) model, emulate and represent the time zone ruleset used by the host system to report local time to users. Note that there may be a conflict between the first and second goals, since some systems do not have a very sophisticated or accurate implementation of time zone rulesets (e.g., Windows.)
			
			There are three different cases where the value of <systemTimeZone> might be changed:

			1. When Chronos is first being installed in an image (or when a non-image-based Smalltalk runtime initially loads the Chronos codebase.) In this scenario, <systemTimeZone> will (if possible) be set to a ChronosTimezone according either to the #setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem strategy or to the #setSystemTimeZoneToAnalogOfNativeSystemTimeZone strategy (as defined below).  If the current ChronosSystemClock keeps and reports time as Universal Time, then the #setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem strategy will be used.  Otherwise, if the current ChronosSystemClock keeps and reports time as local time, then the #setSystemTimeZoneToAnalogOfNativeSystemTimeZone strategy will be used (see the comment for the instance variable <systemTimeZoneBindingStrategy> for the definition of these two strategies.)

			2. When an image where Chronos was previously installed is restarted after a snapshot. In this situatation, <systemTimeZone> will be set according to whichever <systemTimeZoneBindingStrategy> is currently in effect. 
	
			3. Whenever application code sends the message #beSystem to a ChronosTimezone. When this happens, the value of <systemTimeZone> will be set to that ChronosTimezone.

		systemTimeZoneBindingStrategy <Symbol>	
			Controls the strategy that will be used to resolve the ChronosTimezone that will become the <systemTimeZone> whenever the image starts after a snapshot (or whenever the Chronos Date/Time library is installed.) The strategy can be changed by sending 'control' messages to the instance, such as #onStartupDoNotSetSystemTimeZoneUnlessBaseSystemTimeZoneIsAnOlsonTimeZone, #onStartupSetSystemTimeZoneToAnalogOfNativeSystemTimeZone or #onStartupSetSystemTimeZoneToMostCongruentOlsonTimeZone. The initial default value immediately after Chronos installation is determined by sending the message #defaultSystemTimeZoneBindingStrategy to the instance (see the method for it's specific behavior.)
		
			The valid values of <systemTimeZoneBindingStrategy>, and the semantics of those values, are as follows:

				#setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone
					Strategy: If it's possible to determine that the host system is using an Olson timezone to define its local time, and if it's also possible to determine the Olson key of that timezone (to the desired degreee of certainty and precision,) then set the <systemTimeZone> to a Chronos VariableOffsetTimezone with the same key. Othwerwise do not change the <systemTimeZone>. [This strategy is preferred when a) the ChronosSystemClock keeps time relative to Universal Time, and not relative to local time, and b) when Chronos clients rarely (if ever) need to change the system timezone once it is correctly set]
		
				#setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem
					Strategy: Determine the key of the Olson timezone that is the most congruent to the host system's timezone, and set the <systemTimeZone> to the ChronosTimezone with that key. However, if it is not possible to obtain enough information about the host system's timezone to determine the Olson timezone key of the Olson timezone that would be reasonably congruent to the host system's timezone, then do not change the <systemTimeZone>.  [This strategy is preferred whenever a) the ChronosSystemClock keeps time relative to Universal Time, and not relative to local time, and b) a Chronos client/user is likely to be changing the host system's local timezone with any regularity (e.g., because of laptop/notebook users who travel)]

				#setSystemTimeZoneToAnalogOfNativeSystemTimeZone
					Strategy: Construct a ChronosTimezone that emulates the behavior of the host system's timezone as closely as possible (i.e., one that serves as a reasonably close--and hopefully perfect--analog of the host system's timezone,) and set the ChronosTimezone so constructed as the <systemTimeZone>. However, if it's not possible to get sufficient information about the host system's timezone to construct a ChronosTimezone that will serve as a reasonable analog, then do not change the <systemTimeZone>. Note that the best "analog" of an Olson timezone that serves as the local timezone of the host system would of course be a ChronosTimezone whose key is the same as that of the host system's Olson timezone. Note also that if an absolute perfect emulation is required, then care must be taken to ensure that both Chronos and the host system will always be using the same version of the Olson Timezone Databse. [This strategy is preferred whenever a) the ChronosSystemClock keeps time relative to local time, or b) whenever a Chronos client interacts with the host system in such a manner that matching Chronos local time to host system local time takes priority over timezone functionality that is maximally congruent to "real world" behavior]

		systemLanguageCode	<Symbol>	
			The ISO 639 code for the language of the current locale. The value may be set whenever the image is restarted after a snapshot (or whenever a non-image-based Smalltalk runtime initially loads the Chronos codebase.)

		systemCountryCode		<Symbol>	
			The ISO 3166 code for the country of the current locale. The value may be set whenever the image is restarted after a snapshot (or whenever a non-image-based Smalltalk runtime initially loads the Chronos codebase.)

		resourcePathPrefix		<String | nil>
			The common prefix of the pathnames of all Chronos resources to be used by default (e.g., timeone rulesets, timezone localization policies, etc.) The paths in the <resourcePathMap> are initialized with this value as their common path prefix. The value may be nil, which will result in the all the Chronos resource paths being relative to the current working directory.

		resourcePathMap 		<Dictionary: Symbol -> ResourcePath>
			Each key represents the semantics (purpose, logical function, role) of some file, directory or external resource. Each value is an instance of ResourcePath (which see) that specifies the pathname of some file, directory or external resource.  The specified pathname may be either absolute or relative.  The paths are all initialized with <resoucePathPrefix> as their common prefix.

			The entries may simply be hardcoded--in which case <resourcePathMap> only needs to be (re)initialized whenever the hardcoded pathnames are changed, or when Chronos is first installed in an image (or when the runtime of a non-image-based Smalltalk loads the Chronos codebase.)

			Alternatively, the <resourcePathMap> may be (re)initialized from some external data source, such as a configuration file, a data base or a remotely-hosted reference data service. In this case, the <resourcePathMap> should be (re)initialized whenever the image is restarted after a snapshot,  (or whenever the runtime of a non-image-based Smalltalk loads the Chronos  codebase.)
	
			The <resourcePathMap> may also be a proxy for a remotely-hosted Dictionary--in which case initialization of the entries is the responsibility of the remote process or image. 

		resourcePathFacade 				<ResourcePathFacade> -- see discussion above under the heading 'Storing/Retrieving Chronos Reference Data'

		timeZoneAccessor 					<ResourceAccessor> -- see discussion above under the heading 'Accessing Chronos Resources in a Chronos Resource Repository'

		tzLocalizationPolicyAccessor 	<ResourceAccessor> -- see discussion above under the heading 'Accessing Chronos Resources in a Chronos Resource Repository'

		showReports			<Boolan>
			Controls whether or not, after the ChronosSystemFacade singleton has been installed and/or reinitialized after an image startup, that a) the systemTimeZoneKey, b) the systemLanguageCode, c) the systemCountryCode, and d) the current mappings form external resource semantic keys to absolute pathnames will be reported to the "System Transcript" (or its equivalent, such as "stdout" in the case of a command-line based system)

	Subclassing:

		ChronosSystemFacade is an abstract class.  A concrete subclass appropriate for use on a particular platform, in a particular system environment, for use by a particular client application, must be provided.  Although there are many instance methods that may need to be subimplemented in order to provide functionality optimal for a particular situation, there is fortunately a much shorter list of instance methods that MUST be subimplemented in order to provide a fully operational ChronosSystemFacade singleton (all of which have method comments documenting the behavior for which the method is responsible):

			Method Selector															Subimplmentation Requirement

			#constructResourcePathFromNativeResourceID:								Mandatory--must have substantive implementation
			#resourceExists:																	Mandatory--must have substantive implementation
			#resourceIsDirectory:																Mandatory--must have substantive implementation
			#makeDirectory:																	Mandatory--must have substantive implementation
			#newExternalReadStream:type:													Mandatory--must have substantive implementation
			#newExternalWriteStream:mode:check:type: 									Mandatory--must have substantive implementation
			#registerForStartupNotification													Mandatory--must have substantive implementation
			#renameResource:to:																Mandatory--must have substantive implementation
			#unregisterForStartupNotification												Mandatory--must have substantive implementation
			#withResourcePathsOfResourcesInDirectory:do:								Mandatory--must have substantive implementation
			#chronosDateAndTimeFromNativeCalendricalCoordinate:calendarClock:	Mandatory--unless the Chronos class is also the native one.
			#chronosDateFromNativeCalendricalCoordinate:calendarClock: 			Mandatory--unless the Chronos class is also the native one.
			#nativeCalendricalCoordinateFromChronosDate:								Mandatory--unless the Chronos class is also the native one.
			#nativeCalendricalCoordinateFromChronosDateAndTime:					Mandatory--unless the Chronos class is also the native one.
			#chronosTimezoneFromNativeTimeZone:										Mandatory--unless the Chronos class is also the native one.
			#nativeTimeZoneFromChronosTimeZone:										Mandatory--unless the Chronos class is also the native one.
			#chronosTimeOfDayFromNativeTimeOfDay:									Mandatory--unless the Chronos class is also the native one.
			#nativeTimeOfDayFromChronosTimeOfDay:									Mandatory--unless the Chronos class is also the native one.

		Additionaly, the following instance methods may require subimplementation in some cases:

			Method Selector																		Subimplmentation Requirement

			#installPrerequisites																Optional--subimplment to install non-Chronos modules, packages, extensions, plugins (etc.)
			#valueOfEnvironmentVariableAt:													Optional--on UNIX, there may be no other way to resolve the local timezone from the host OS.
			#resolveSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone			Optional--if UNIX is important, consider enhancing or subimplementing.
			#windowsTimeZoneAttributes														Optional--must return nil if not hosted on a system that uses Windows timezone rulesets.
			#setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem	Optional--subimplementing one or more of the other methods may suffice.
			#setSystemTimeZoneToAnalogOfNativeSystemTimeZone					Optional--subimplementing one or more of the other methods may suffice.
			#setBaseSystemTimeZoneFromChronosSystemTimeZone					Optional--but substantive implementation is recommended.								
			#handleNonExistenceOfResourcePathReferencedBy:						Optional--but substantive implementation is recommended.
			#defaultSystemTimezoneBindingStrategy										Optional--change or subimplement to get desired behavior.
			#copyResource:to:																	Optional--can be no-op (present solely for API completeness.)
			#deleteResource:																	Optional--can be no-op (present solely for API completeness.)
			#moveResource:to:																	Optional--can be no-op (present solely for API completeness.)
			#rfc868SecondsSince1900														Optional--Unless the canonical ChronosSystemClock singleton will be using it.
			#sizeOfResource:																	Optional--can be no-op (present solely for API completeness.)
			#byDefaultShouldShowReportsOnStartup										Optional--must return true or false; the base implementation returns false.

			

			

!

!ChronosSystemFacade class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Chronos'! !

!ChronosSystemFacade class methodsFor: 'private' stamp: ''!
basicRelease
	"Ensure that all instances of the receiver get released."

	"ChronosSystemFacade basicRelease"

	self allInstancesDo: [:each | each unregisterForStartupNotification]! !

!ChronosSystemFacade class methodsFor: 'accessing' stamp: ''!
current
	"ChronosSystemFacade current"

	Current == nil 
		ifTrue: [Current := ChronosEnvironment systemFacadeClass new].
	^Current! !

!ChronosSystemFacade class methodsFor: 'class initialization' stamp: ''!
initialize
	"ChronosSystemFacade initialize"

	self release! !

!ChronosSystemFacade class methodsFor: 'class initialization' stamp: ''!
release
	"The message #release must be sent to ChronosSystemFacade whenever Chronos is about to be removed from the system (image.)  It is the responsibility of subimplementors to ensure that this message is sent at the appropriate time."

	"ChronosSystemFacade release"

	Current == nil ifFalse: [Current release].
	Current := nil.
	self allSubclassesDo: [:subclass | subclass basicRelease]! !

!ChronosSystemFacade class methodsFor: 'accessing' stamp: ''!
resourceRepositoryContext
	^self current resourceRepositoryContext! !

!ChronosSystemFacade methodsFor: 'private' stamp: ''!
baseSystemLocaleKey
	"This implementation assumes that it is easier to compute the baseSystemLocaleKey from the languageCode and countryCode.  If it would be easier to simply retrieve the base system's locale key directly, instead of computing it, then this method should be subimplemented."

	^self 
		baseSytemLocaleKeyFromLanguageCode: self systemLanguageCode
		countryCode: self systemCountryCode! !

!ChronosSystemFacade methodsFor: 'private' stamp: ''!
baseSytemLocaleKeyFromChronosLocaleKey: chronosLocaleKey 
	^ChronosLocale 
		fromLocaleKey: chronosLocaleKey
		setLanuageCodeAndCountryCodeInto: 
			[:languageCode :countryCode | 
			self 
				baseSytemLocaleKeyFromLanguageCode: languageCode
				countryCode: countryCode]! !

!ChronosSystemFacade methodsFor: 'private' stamp: ''!
baseSytemLocaleKeyFromLanguageCode: languageCode countryCode: countryCode
	^ChronosLocale "Since Chronos uses the international standard encoding, we assume that the base system does as well. If not, subimplement."
		localeKeyFromLanguageCode: languageCode
		countryCode: countryCode! !

!ChronosSystemFacade methodsFor: 'private' stamp: ''!
basicInstall
	"Invalidate any information stored in the receiver that needs to be synchronized with external sources, such as configuration files, environment variables, registry settings, etc. Answer true if totally successful, false otherwise."

	ChronosSystemClock invalidateCurrent.
	^self setChronosDefaultLanguageAndCountryCodesFromBaseSystem 
		ifTrue: [self resourceRepositoryContext install]
		ifFalse: [false]! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
byDefaultShouldShowReportsOnStartup
	"Answer the default value of the flag whose value determines whether or not, when the receiver is reinstalled during the restart of a snapshotted image, it should report its (possibly changed) status (e.g..systemTimeZoneKey, systemLanguageCode, etc.) to the 'System Transcript' (or some analog thereof.)"

	^false! !

!ChronosSystemFacade methodsFor: 'value conversion' stamp: ''!
chronosDateAndTimeFromNativeCalendricalCoordinate: aNativeCalendricalCoordinate calendarClock: calendarClock 
	"Answer a Chronos DateAndTime that semantically corresponds as closely as possible to <aNativeTimestampOrDate>."

	^aNativeCalendricalCoordinate! !

!ChronosSystemFacade methodsFor: 'value conversion' stamp: ''!
chronosDateFromNativeCalendricalCoordinate: aNativeCalendricalCoordinate calendarClock: calendarClock 
	"Answer a Chronos date value that semantically corresponds as closely as possible to <aNativeTimestampOrDate>."

	^aNativeCalendricalCoordinate! !

!ChronosSystemFacade methodsFor: 'value conversion' stamp: ''!
chronosTimeOfDayFromNativeTimeOfDay: aNativeTimeOfDay
	"Answer a Chronos TimeOfDay that semantically corresponds as closely as possible to <aNativeTimeOfDay>."

	^aNativeTimeOfDay! !

!ChronosSystemFacade methodsFor: 'value conversion' stamp: ''!
chronosTimezoneFromNativeTimeZone: aNativeTimeZone 
	"Answer a ChronosTimezone that semantically corresponds as closely as possible to <aNativeTimeZone>."

	^self subclassResponsibility! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
defaultSystemTimeZoneBindingStrategy
	"Answer the strategy that Chronos should use by default whenever Chronos attempts resolve the Chronos system timezone based on the local timezone of the host system and/or Smalltalk execution environment. See class comment for a full explanation of the options.  This default can be overridden by sending control messages to the receiver."

	^ChronosSystemClock current isRelativeToLocalTime
		ifTrue: [#setSystemTimeZoneToAnalogOfNativeSystemTimeZone]
		ifFalse: [#setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone]

	"Options: 
		#setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem
		#setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone 
		#setSystemTimeZoneToAnalogOfNativeSystemTimeZone"! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
evaluateTZEnvironmentVariableValue: tz ifOlsonTZKey: olsonTZKeyAction ifTZRuleLiteral: tzRuleLiteralAction otherwise: unknownContentAction 
	"Parse the value of <tz>, whose value should be a String conforming to the POSIX specification for the value of the TZ environment variable. However, if <tz> is nil or is the empty String, then just answer nil.

	If the parse determines that <tz> contains a value that identifies the key of an Olson timezone known to Chronos, then evaluate <olsonTZKeyAction> (a 1-arg block) with said timezone Olson key, then answer the result.

	If the parse determines that <tz> contains a POSIX timezone rule literal, parse the abbreviations for standard time and DST from the POSIX rule literal, and then evaluate <tzRuleLiteralAction> (a 2-arg block) with the standard-time and DST abbreviations parsed from the rule literal as the first and second arguments (respectively.) If <tzRuleLiteralAction> is nil, then answer nil, otherwise answer the resul of the evaluation.

	If the parse determines that <tz> contains neither an Olson timezone key known to Chronos, nor a valid POSIX timezone rule literal, then answer the result of evaluatiing <unknownContentAction> (a zero-arg block.)"

	"The well-known keys used by Chronos to identify the attributes of a POSIX timezone rule literal, and the value that should be associated with each key:
		
		Key									Semantics and Smalltalk type of associated value that should be computed by this method (as values in a Dictionary)

		#StdAbbreviation					->	<Symbol> whose value is timezone's abbreviation during STANDARD TIME.
		#StdOffsetSecondsFromUT		->	<Integer> number of seconds that should be ADDED to the Universal time-of-day to derive local time-of-day during STANDARD TIME.
			-- The following entries should not be present if the timezone does not observe DST: 
		#NonStdAbbreviation				->	<Symbol> whose value is the timezone's abbreviation during NON-STANDARD TIME.
		#NonStdOffsetSecondsFromUT	->	<Integer> number of seconds that should be ADDED to the Universal time-of-day to derive local time-of-day during NON-STANDARD TIME.
			-- The following entries may or may not be present:
		#StdDate								->	<AnnualDate> on which the timezone transitions to `standard` time--or not present if there is no transition to standard time.
		#StdTimeOfDay						-> 	<TimeOfDay> at which the timezone transitions to `standard` time (always local 'wall-clock' time)--or not present if there is no transition to standard time.
		#NonStdDate						->	<AnnualDate> on which the timezone transitions to `daylight-saving/summer` time.
		#NonStdTimeOfDay				-> <TimeOfDay> at which the timezone transitions to `daylight-saving/summer` time (always local 'wall-clock' time.)."



	"{ChronosSystemFacade current
		evaluateTZEnvironmentVariableValue: ':/usr/share/zoneinfo/America/Detroit' 
		ifOlsonTZKey: [:tzKey | (Timezone at: tzKey) now printStringUsing: #verbose] 
		ifTZRuleLiteral: 
			[:tzAttributes | tzAttributes] 
		otherwise: [#invalidValueOfTZEnvVar]}"

	"{ChronosSystemFacade current
		evaluateTZEnvironmentVariableValue: '<CST>5<CDT>' 
		ifOlsonTZKey: [:tzKey | (Timezone at: tzKey) now printStringUsing: #verbose] 
		ifTZRuleLiteral: [:tzAttributes | tzAttributes] 
		otherwise: [#invalidValueOfTZEnvVar]}"

	"{ChronosSystemFacade current
		evaluateTZEnvironmentVariableValue: '<CST>5<CDT>4' 
		ifOlsonTZKey: [:tzKey | (Timezone at: tzKey) now printStringUsing: #verbose] 
		ifTZRuleLiteral: [:tzAttributes | tzAttributes] 
		otherwise: [#invalidValueOfTZEnvVar]}"

	"{ChronosSystemFacade current
		evaluateTZEnvironmentVariableValue: 'MST7MDT' 
		ifOlsonTZKey: [:tzKey | (Timezone at: tzKey) now printStringUsing: #verbose] 
		ifTZRuleLiteral: [:tzAttributes | tzAttributes] 
		otherwise: [#invalidValueOfTZEnvVar]}"

	"The abbreviation BOT uniquely maps to to 'America/La_Paz':
	{ChronosSystemFacade current
		evaluateTZEnvironmentVariableValue: 'BOT' 
		ifOlsonTZKey: [:tzKey | (Timezone at: tzKey) now printStringUsing: #verbose] 
		ifTZRuleLiteral: [:tzAttributes | tzAttributes] 
		otherwise: [#invalidValueOfTZEnvVar]}"

	"{ChronosSystemFacade current
		evaluateTZEnvironmentVariableValue: 'IST-5:30ISST-6:30,M3.5.0,M10.1.0/3:00' 
		ifOlsonTZKey: [:tzKey | (Timezone at: tzKey) now printStringUsing: #verbose] 
		ifTZRuleLiteral: [:tzAttributes | tzAttributes] 
		otherwise: [#invalidValueOfTZEnvVar]}"

	| tzStream resolveOlsonTZKey tzKey tzAttributes parseAbbreviation parsePolarity parseOffsetOrTime parseDate stdAbbreviation stdPolarity stdOffset dstAbbreviation dstPolarity dstOffset toNonStdDate toNonStdTimeOfDay toStdDate toStdTimeOfDay |
	(tz == nil or: [tz size = 0]) ifTrue: [^nil].
	tzStream := tz readStream.
	ChronosFunction skipSeparators: tzStream.
	resolveOlsonTZKey :=
		[tzStream peek = $/ "If it starts with the POSIX file separator, then it's an absolute pathname of a zoneinfo binary file. It is ASSUMED that this is never done on Windows."
			ifTrue: 
				["We have an absolute pathname referring to a zoneinfo file in some non-standard location. So we have to ATTEMPT to derive the key from the filename (life can be so unfair...)  The operation will succeed PROVIDED the suffix of the pathname matches that of an Olson timezone key."
				TimeZonePolicyFactory allRegisteredKeys do: [:key | 
					('*' , key match: tz) 
						ifTrue: [^olsonTZKeyAction value: key]]]
			ifFalse: 
				[| returnToPosition |
				"Check whether it's an Olson TZ key known to Chronos."
				returnToPosition := tzStream position.
				tzKey := (ChronosFunction nextFrom: tzStream until: [:ch | ch isSeparator]) asSymbol.
				(TimeZonePolicyFactory timezoneKeyIsGloballyDefined: tzKey) 
					ifTrue: [^olsonTZKeyAction value: tzKey]
					ifFalse: [tzStream position: returnToPosition]]].
	(tzStream peekFor: $:) 
		ifTrue: 
			["It's either an Olson key known to Chronos, or else it's an unknown value."
			resolveOlsonTZKey value. "If an Olson key is recognized, the olsonTZKeyAction.will be evaluated with the key as its argument, and the method will return to the sender."
			^unknownContentAction value].

	resolveOlsonTZKey value. "Check for an Olson key not prefixed by a colon (':'). If an Olson key is recognized, the olsonTZKeyAction.will be evaluated with the key as its argument, and the method will return to the sender."

	"We have an ISO POSIX-1 literal rule specification."

	parseAbbreviation :=
		[tzStream atEnd
			ifFalse: 
				[(tzStream peekFor: $<)
					ifTrue: 
						[| abbreviation | 
						abbreviation := ChronosFunction nextFrom: tzStream until: [:ch | ch = $>].
						tzStream next.
						abbreviation]
					ifFalse: [ChronosFunction nextFrom: tzStream while: [:ch | ch isLetter]]]].
	parsePolarity := 
		["The POSIX polarity is inverted from standard practice (POSIX uses `seconds west of UT.`)"
		tzStream atEnd
			ifTrue: [-1]
			ifFalse:
				[(#($+ $-) includes: tzStream peek)
					ifTrue: [tzStream next = $+ ifTrue: [-1] ifFalse: [1]]
					ifFalse: [-1]]].
	parseOffsetOrTime :=
		[tzStream atEnd
			ifFalse: 
				[| hours minutes seconds |
				hours := ChronosFunction nextFrom: tzStream while: [:ch | ch isDigit].
				hours := hours size = 0 ifTrue: [0] ifFalse: [hours asNumber].
				minutes := 0.
				seconds := 0.
				(tzStream peekFor: $:)
					ifTrue: 
						[minutes := ChronosFunction nextFrom: tzStream while: [:ch | ch isDigit].
						minutes := minutes size = 0 ifTrue: [0] ifFalse: [minutes asNumber].
						(tzStream peekFor: $:)
							ifTrue: 
								[seconds := ChronosFunction nextFrom: tzStream while: [:ch | ch isDigit].
								seconds := seconds size = 0 ifTrue: [0] ifFalse: [seconds asNumber]]].
				(hours * SecondsPerHour) + (minutes * SecondsPerMinute) + seconds]].

	parseDate :=
		[tzStream atEnd
			ifFalse: 
				[(tzStream peekFor: $M)
					ifTrue:
						["It's a week-of-month/day-of-week specification."
						| month weekOfMonth dayOfWeek |
						month := ChronosFunction nextFrom: tzStream while: [:ch | ch isDigit].
						month := month size = 0 ifTrue: [^unknownContentAction value] ifFalse: [month asNumber].
						(tzStream peekFor: $.) ifFalse: [^unknownContentAction value].
						weekOfMonth := ChronosFunction nextFrom: tzStream while: [:ch | ch isDigit].
						weekOfMonth := weekOfMonth size = 0 ifTrue: [^unknownContentAction value] ifFalse: [weekOfMonth asNumber].
						(tzStream peekFor: $.) ifFalse: [^unknownContentAction value].
						dayOfWeek := ChronosFunction nextFrom: tzStream while: [:ch | ch isDigit].
						dayOfWeek := dayOfWeek size = 0 ifTrue: [^unknownContentAction value] ifFalse: [dayOfWeek asNumber + 1].
						WeekOfMonthDayOfWeekFactory
							month: month
							week: (weekOfMonth >= 5 ifTrue: [5 - weekOfMonth] ifFalse: [weekOfMonth])
							dayOfWeek: dayOfWeek]
					ifFalse: 
						["It's an ordinal date (wrongly called a 'Julian Date' by IT tradition (especially in the mainframe world.)"
						| yearlyCalendar dayOfYear calendarDay  |
						(tzStream peekFor: $J)
							ifTrue: 
								["Non leap-year day-of-year ordinal (1..365)"
								yearlyCalendar := Gregorian yearlyCalendarForYearTypeCode: 1.
								dayOfYear := ChronosFunction nextFrom: tzStream while: [:ch | ch isDigit].
								dayOfYear := dayOfYear size = 0 ifTrue: [^unknownContentAction value] ifFalse: [dayOfYear asNumber]]
							ifFalse: 
								["Leap year day-of-year cardinal (0..365)"
								yearlyCalendar := Gregorian yearlyCalendarForYearTypeCode: 2.
								dayOfYear := ChronosFunction nextFrom: tzStream while: [:ch | ch isDigit].
								dayOfYear := dayOfYear size = 0 ifTrue: [^unknownContentAction value] ifFalse: [dayOfYear asNumber + 1]].
						dayOfYear = 0 ifTrue: [dayOfYear := 1]. "Just in case..."
						calendarDay := yearlyCalendar dayAt: dayOfYear.
						DayOfMonthFactory month: calendarDay month day: calendarDay dayOfMonth]]].

	stdAbbreviation := parseAbbreviation value.
	tzKey  := TimeZoneLocalizationPolicy unique 
					defaultTimeZoneKeyWithCommonAbbreviation: stdAbbreviation 
					dstPreferred: false "true/false doesn't matter in this case" 
					ifAbsent: []. 
	tzKey == nil 
		ifFalse: 
			["If the abbreviation has a unique mapping to an Olson time zone key, then we have a winner!!"
			^olsonTZKeyAction value: tzKey].
	tzStream atEnd
		ifTrue: 
			[^tzRuleLiteralAction == nil 
				ifTrue: [nil] 
				ifFalse: ["Not legal" unknownContentAction value]].
	stdPolarity := parsePolarity value.
	stdOffset := parseOffsetOrTime value.
	stdOffset == nil
		ifTrue: 
			[^tzRuleLiteralAction == nil 
				ifTrue: [nil] 
				ifFalse: ["Not legal" unknownContentAction value]].
	stdOffset := stdOffset * stdPolarity.
	tzAttributes := Dictionary new.
	tzAttributes at: #StdAbbreviation put: stdAbbreviation.
	tzAttributes at: #StdOffsetSecondsFromUT put: stdOffset.
	dstAbbreviation := parseAbbreviation value.
	dstAbbreviation == nil
		ifTrue: 
			[tzRuleLiteralAction == nil 
				ifTrue: ["So we're not interested in any POSIX rule literal that may or may not be present." ^nil]]
		ifFalse:
			[tzKey  := TimeZoneLocalizationPolicy unique 
							defaultTimeZoneKeyWithCommonAbbreviation: dstAbbreviation 
							dstPreferred: true
							ifAbsent: []. 
			tzKey == nil 
				ifFalse: 
					["If the abbreviation has a unique mapping to an Olson time zone key, then we have a winner!!"
					^olsonTZKeyAction value: tzKey].
			tzRuleLiteralAction == nil 
				ifTrue: ["So we're not interested in any POSIX rule literal that may or may not be present." ^nil].
			dstPolarity := parsePolarity value.
			dstOffset := parseOffsetOrTime value.
			dstOffset := dstOffset == nil
							ifTrue: [stdOffset + SecondsPerHour]
							ifFalse: [dstOffset * dstPolarity].
			tzAttributes at: #NonStdAbbreviation put: dstAbbreviation.
			tzAttributes at: #NonStdOffsetSecondsFromUT put: dstOffset.
			ChronosFunction skipSeparators: tzStream.
			((tzStream peekFor: $,) or: [(tzStream peekFor: $;)])
				ifTrue:
					[ChronosFunction skipSeparators: tzStream.
					toNonStdDate := parseDate value.
					(tzStream peekFor: $/)
						ifTrue: [toNonStdTimeOfDay := parseOffsetOrTime value]
						ifFalse: [toNonStdTimeOfDay := 7200 "2am is the default"].
					(tzStream peekFor: $,) ifFalse: [^unknownContentAction value].
					toStdDate := parseDate value.
					(tzStream peekFor: $/)
						ifTrue: [toStdTimeOfDay := parseOffsetOrTime value]
						ifFalse: [toStdTimeOfDay := 7200 "2am is the default"].
					tzAttributes at: #NonStdDate put: toNonStdDate.
					tzAttributes at: #NonStdTimeOfDay put: (TimeOfDayFactory secondsSinceStartOfDay: toNonStdTimeOfDay).
					tzAttributes at: #StdDate put: toStdDate.
					tzAttributes at: #StdTimeOfDay put: (TimeOfDayFactory secondsSinceStartOfDay: toStdTimeOfDay)]].
	^tzRuleLiteralAction value: tzAttributes! !

!ChronosSystemFacade methodsFor: 'instance creation' stamp: ''!
findOrCreateChronosLocaleAt: isoStandardLocaleKey
	"Answer a ChronosLocale initialized to provide locale behavior that is correct for the language and country indicated by <isoStandardLocaleKey>.  
	If the information necessary to provide/construct the ChronosLocale as requested is not available, answer a ChronosLocale whose behavior will match that of the one requested as closely as possible.  In the worst case, just answer a ChronosLocale configured with whatever locale information is readily available and most appropriate.


	The <isoStandardLocaleKey> is a Symbol, whose content is structured as an ISO-639 language code, contingently followed by an underscore character and ISO-3166 country code. The country code is mandatory in cases where the language code is not sufficient to fully specify the appropriate behavior of a locale (e.g., US vs. British notational conventions.) Using the country code is recommended.

	Some common locale keys:

		United States: 	#en_US		Note: Not everyone lives in the United States, and notational conventions in the US sometimes differ considerably from international norms.
		Great Britain:	#en_GB 		Note: 'UK' is not the ISO country code for Great Britain/The United Kingdom
		Spain:				#es_ES		Note: Notational conventions may differ in Spanish-speaking countries outside of Spain
		France: 			#fr_FR		Note: Notational conventions may differ in French-speaking countries outside of France
		Germany:		#de_DE
		Italy:				#it_IT
		Japan:			#ja_JP

	There are three suggested approaches to subimplement this method, for those interested in actually dealing with locales in a serious manner:

		1) Create a ConfigurableChronosLocale, initialize it from whatever data source is preferred (perhaps user-managed flat files, or non-Chronos Locale objects,) and answer the newly created/initialized ConfigurableChronosLocale;
		2) Define a class (perhaps named 'ChronosLocaleAdapterForWindows' or 'ChronosLocaleAdapterForSTX') whose public API is that of a ChronosLocale, but which acts as an adapter or facade (see the canonical 'Gang of Four' Design Patterns book.) The 'ChronosLocaleAdapter' (or whatever name is chosen) would delegate service requests made using the API of a ChronosLocale to native locale objects or library calls, using whatever API they require (such objects and/or services might be provided by the native Smalltalk execution environment, by the host operating system, by proprietary classes or utility libraries, or by some combination thereof).  The implementation of this method would then be to create an instance of such a locale adapter configured to provide locale behavior appropriate for the requested locale;
		3) Combine approach 1 with appoach 2, using a locale adapter to initialize an instance of ConfigurableChronosLocale (which may or may not be preferrable to approach 2 by itself, depending on a variety of factors.)"

	^ChronosLocale unitedStates 
	"This is the abstract superclass--so the most appropriate implementation in this context is simply to answer some readily-available default locale.
	Subimplementors are strongly encouraged to provide richer behavior--hopefully aided by services available in the native Smalltalk execution environment and/or host operating system."! !

!ChronosSystemFacade methodsFor: 'resource repository' stamp: ''!
findValidResourcePathPrefix: block1
	"Summary: Evaluate <block1> for potential prefixes of the base resource path to the Chronos resource directories, in order of precedence. 

	Detailed spec: 
		
		For each potential base path prefix that specifies an existing resource directory, evaluate <block1> with the pathname String of the directory.  If the evaluation of <block1> results in the value true, answer true and do not evaluate any further potential base path prefixes.  If the evaluation of <block1> results in the value false, then proceed to evaluate the next potential base path prefix (in precedence order).  If there are no further potential base path prefixes, then answer false."

	"{ChronosSystemFacade current findValidResourcePathPrefix: [:resourcePathPrefixString | Transcript cr; show: resourcePathPrefixString. false]}"

	| pathString rp |
	pathString := EnvironmentFacade current valueOfEnvironmentVariableAt: 'CHRONOS_PATH'.
	(ChronosFunction isNilOrEmpty: pathString) ifFalse:
		[rp := ResourcePath fromString: pathString.
		rp exists ifTrue: [(block1 value: pathString) ifTrue: [^true]]].
	rp := ResourcePath currentDirectory.
	(block1 value: rp printString) ifTrue: [^true].
	^false! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
firstInstallationSystemTimeZoneBindingStrategy
	"Answer the strategy that Chronos should use, when it is being installed for the very first time, to resolve the Chronos system timezone based on the local timezone of the host system and/or Smalltalk execution environment. See class comment for a full explanation of the options."

	^ChronosSystemClock current isRelativeToLocalTime 
		ifTrue: [#setSystemTimeZoneToAnalogOfNativeSystemTimeZone]
		ifFalse: [#setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem]

	"Options: 
		#setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem
		#setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone 
		#setSystemTimeZoneToAnalogOfNativeSystemTimeZone"! !

!ChronosSystemFacade methodsFor: 'private' stamp: ''!
fromBaseSystemLocaleKey: baseSystemLocaleKey setLanguageCodeAndCountryCodeInto: block2
	baseSystemLocaleKey == nil ifTrue: [^block2 value: #en value: #US].
	^ChronosLocale
		fromLocaleKey: baseSystemLocaleKey "Since Chronos uses the ISO standard encoding, we assume that the base system does the same. If not, subimplement."
		setLanuageCodeAndCountryCodeInto: block2! !

!ChronosSystemFacade methodsFor: 'initialize-release' stamp: ''!
initialize
	systemTimeZone := nil.					"Set to nil so we will know it hasn't been set yet."
	systemLanguageCode := #en.			"English by default"
	systemCountryCode := #US.				"Unites States by default"
	showReports := true.
	self setResourceRepositoryContext.
	self onStartupSetSystemTimeZoneToMostCongruentOlsonTimeZone.! !

!ChronosSystemFacade methodsFor: 'installation' stamp: ''!
instalIInitially
	"This method MUST be invoked immediately after the Chronos codebase has been fully loaded into an image (after which, the image must be persisted)--or it must be invoked whenever a non-image-based Smalltalk runtime system first loads the Chronos codebase. It may not be advisable to invoke it at other times."

	"{ChronosSystemFacade current instalIInitially}"

	self shouldSkipInstallation ifTrue: [^self reportInstallationSkipped].
	showReports := true.
	self installPrerequisites.
	self registerForStartupNotification.
	systemTimeZone := nil.
	self basicInstall 
		ifTrue: 
			[systemTimeZoneBindingStrategy := self firstInstallationSystemTimeZoneBindingStrategy.
			self setChronosSystemTimeZoneFromBaseSystem.
			systemTimeZoneBindingStrategy := self defaultSystemTimeZoneBindingStrategy.
			showReports := self byDefaultShouldShowReportsOnStartup]! !

!ChronosSystemFacade methodsFor: 'installation' stamp: ''!
install
	"Invalidate any information stored in the receiver that needs to be synchronized with external sources, such as configuration files, environment variables, registry settings, etc."

	"This method MUST be invoked whenever a Smalltalk image starts running (i.e., whenever the image is restarted after a snapshot.)  In the case of Smalltalk implementations that don't use images, the method #installInitially should be called instead of #install (each time the Chronos codebase is loaded.)"

	"{ChronosSystemFacade current install}"

	(systemTimeZone == nil or: [systemTimeZone key == nil]) ifTrue: [^self instalIInitially].
	self shouldSkipInstallation ifTrue: [^self reportInstallationSkipped].
	self basicInstall ifTrue: [self setChronosSystemTimeZoneFromBaseSystem]! !

!ChronosSystemFacade methodsFor: 'installation' stamp: ''!
installPrerequisites
	"Ensure that any non-Chronos modules, packages, parcels (or whatever) that may be required for proper Chronos operation are installed."

	"By default, do nothing.  Subimplement with whatever code may be necessay or advisable--if any."! !

!ChronosSystemFacade methodsFor: 'value conversion' stamp: ''!
nativeCalendricalCoordinateFromChronosDate: aChronosDate
	"Answer the native 'Date' analog (or 'Timestamp' analog, if no Date analog is available) that semantically corresponds as closely as possible to <aChronosDate>"

	^aChronosDate! !

!ChronosSystemFacade methodsFor: 'value conversion' stamp: ''!
nativeCalendricalCoordinateFromChronosDateAndTime: aChronosDateAndTime 
	"Answer the native 'Timestamp' analog (or 'Date' analog, if no Timestamp analog is available) that semantically corresponds as closely as possible to <aChronosDateAndTime>"

	^aChronosDateAndTime! !

!ChronosSystemFacade methodsFor: 'value conversion' stamp: ''!
nativeTimeOfDayFromChronosTimeOfDay: aChronosTimeOfDay
	"Answer the native 'TimeOfDay' analog that semantically corresponds as closely as possible to <aChronosTimeOfDay>"

	"{ChronosSystemFacade current  nativeTimeOfDayFromChronosTimeOfDay: Gregorian clock timeOfDayNow}"

	^aChronosTimeOfDay! !

!ChronosSystemFacade methodsFor: 'value conversion' stamp: ''!
nativeTimeZoneFromChronosTimeZone: aChronosTimezone
	"Answer the native time zoneanalog that semantically corresponds as closely as possible to <aChronosTimezone>. If there is no such value, or if Chronos is the native date/time library of the host environment, answer <aChronosTimezone>."

	^aChronosTimezone! !

!ChronosSystemFacade methodsFor: 'instance creation' stamp: ''!
newDelayFromDuration: aDuration
	^Delay forMilliseconds: aDuration asMilliseconds! !

!ChronosSystemFacade methodsFor: 'instance creation' stamp: ''!
newSystemClock
	^ChronosSystemClock new! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
olsonTimeZoneKeyFromWindowsTimeZoneKey
	"Answer the Olson timezone key for the Olson timezone that is the most congruent to the current Windows timezone.  If not running on Windows, or if it is not possible to access the Windows registry in order to discover the current Windows timezone, then answer nil."

	"{ChronosSystemFacade current olsonTimeZoneKeyFromWindowsTimeZoneKey}"

	| windowsTZAttributes windowsTzName |
	windowsTZAttributes:= self windowsTimeZoneAttributes.
	windowsTZAttributes == nil ifTrue: [^nil].
	windowsTzName := windowsTZAttributes at: #StandardName.
	^TimeZonePolicyFactory timeZoneKeyFromWindowsTZName: windowsTzName
		ifAbsent: 
			[windowsTzName == nil 
				ifFalse: 
					[self reportUnknownWindowsTimeZoneName: windowsTzName.
					nil]]! !

!ChronosSystemFacade methodsFor: 'control' stamp: ''!
onStartupDoNotSetSystemTimeZoneUnlessBaseSystemTimeZoneIsAnOlsonTimeZone

	"{ChronosSystemFacade current onStartupDoNotSetSystemTimeZoneUnlessBaseSystemTimeZoneIsAnOlsonTimeZone} 	
		^-- Best when system timezone is unlikely to ever change once set correctly"
	"{ChronosSystemFacade current onStartupSetSystemTimeZoneToAnalogOfNativeSystemTimeZone}
		^-- Best when system clock keeps local time"
	"{ChronosSystemFacade current onStartupSetSystemTimeZoneToMostCongruentOlsonTimeZone}
		^-- Best when users change time zones frequently"

	systemTimeZoneBindingStrategy := #setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone! !

!ChronosSystemFacade methodsFor: 'control' stamp: ''!
onStartupSetSystemTimeZoneToAnalogOfNativeSystemTimeZone

	"{ChronosSystemFacade current onStartupDoNotSetSystemTimeZoneUnlessBaseSystemTimeZoneIsAnOlsonTimeZone} 	
		^-- Best when system timezone is unlikely to ever change once set correctly"
	"{ChronosSystemFacade current onStartupSetSystemTimeZoneToAnalogOfNativeSystemTimeZone}
		^-- Best when system clock keeps local time"
	"{ChronosSystemFacade current onStartupSetSystemTimeZoneToMostCongruentOlsonTimeZone}
		^-- Best when users change time zones frequently"

	systemTimeZoneBindingStrategy := #setSystemTimeZoneToAnalogOfNativeSystemTimeZone! !

!ChronosSystemFacade methodsFor: 'control' stamp: ''!
onStartupSetSystemTimeZoneToMostCongruentOlsonTimeZone

	"{ChronosSystemFacade current onStartupDoNotSetSystemTimeZoneUnlessBaseSystemTimeZoneIsAnOlsonTimeZone} 	
		^-- Best when system timezone is unlikely to ever change once set correctly"
	"{ChronosSystemFacade current onStartupSetSystemTimeZoneToAnalogOfNativeSystemTimeZone}
		^-- Best when system clock keeps local time"
	"{ChronosSystemFacade current onStartupSetSystemTimeZoneToMostCongruentOlsonTimeZone}
		^-- Best when users change time zones frequently"

	systemTimeZoneBindingStrategy := #setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem! !

!ChronosSystemFacade methodsFor: 'control' stamp: ''!
onStartupShowReports: flag
	showReports := flag == true! !

!ChronosSystemFacade methodsFor: 'installation' stamp: ''!
registerForStartupNotification
	"Make it so that whenever the Smalltalk image is restarted after a snapshot, the receiver will be sent the message #install.

	NOTE: This method is intended for use by image-based Smalltalk implementations.  It may or may not have any utility in the case of non-image-based Smalltalk systems."

	"ChronosSystemFacade current registerForStartupNotification"

	self unregisterForStartupNotification.
	EnvironmentFacade subscribe: self forImageRestartNotificationSending: #install! !

!ChronosSystemFacade methodsFor: 'initialize-release' stamp: ''!
release
	self unregisterForStartupNotification! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportCommencementOfInitialChronosInstallation
	showReports
		ifTrue: [self reportToConsole: 'Installing the Chronos Date/Time Library...' newLineCount: 2].! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportException: exception message: message
	self
		reportToConsole: message;
		reportToConsole: exception description newLineCount: 1 tabCount: 1! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportFailureToSetDefaultLanguageAndCountryCodesFromBaseSystem: exception
	self
		reportToConsole: 'The attempt to set the default language and country codes from the host system failed with the following exception: ';
		reportToConsole: exception description newLineCount: 1 tabCount: 1! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportInaccessibleResource: resourcePath

	self
		reportToConsole: resourcePath printString, ' persistent/remote resource is not accessible.'! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportInitialChronosInstallationAsSuccessful
	"ChronosSystemFacade current reportInitialChronosInstallationAsSuccessful"

	[self
		reportToConsole: 'Installation completed ', AnsiStandardCalendarClock now printString;
		newLineToConsole] 
			on: Error
			do: [:ex | self reportException: ex message: 'The following error occured during installation: ']! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportInstallationSkipped
	self
		reportToConsole: 'Chronos installation was not performed because the installation flag was set to NO/false.  The installation flag is the value either of the global variable ChronosInstallationFlag or else of the environment variable CHRONOS_INSTALLATION.  To perform the installation operations required in order for Chronos to be functional, first set the installation flag to YES/true, and then evaluate "ChronosSystemFacade current installInitially." (Note: It may also be necessary to restart Smalltalk before it will be aware that the value of an environment variable has been changed.)'! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportResourcePathnameMappings
	showReports 
		ifTrue: 
			[self 
				reportToConsole: 'Logical to physical pathname bindings for persistent/remote datasources:'.
			self resourceRepositoryContext resourcePathsDo: 
					[:key :value | 
					self 
						reportToConsole: key , '->' , value printString
						newLineCount: 1
						tabCount: 1]]! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportSystemLanguageAndCountryCode
	showReports 
		ifTrue: 
			[self
				reportToConsole: 'System Language Code set to ', systemLanguageCode printString;
				reportToConsole: 'System Country Code set to ', systemCountryCode printString]! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportSystemTimeZoneIdentity
	showReports 
		ifTrue: 
			[self
				reportToConsole: 'System Timezone set to ', self systemTimeZone identityString]! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportTimeZoneInvalidationFailure: exception
	self
		reportToConsole: 'The attempt to invalidate all currently-resident time zones failed with the following exception: ';
		reportToConsole: exception description newLineCount: 1 tabCount: 1! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportUnknownWindowsTimeZoneName: windowsTzName 
	showReports 
		ifTrue: 
			[self reportToConsole: 'Unkown Windows System Timezone Name: ' 
						, windowsTzName printString]! !

!ChronosSystemFacade methodsFor: 'private-reporting' stamp: ''!
reportUnkownTZEnvironmentVariableValue: tzEnvVarValue 
	self reportToConsole: 'Unknown value of TZ environment variable: ' 
				, tzEnvVarValue printString! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
resolveSystemTimeZoneFromTZEnvironmentVariableValue
	"If the TZ environment variable explicitly specifies the key of an Olson timezone known to Chronos, answer the ChronosTimezone with that key.  Otherwise, determine which of the following cases apply, and perform the operation as specified for that case:

	Case 1--#setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone is the current <systemTimeZoneBindingStrategy>:

		Answer nil.

	Case 2--#setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem is the current <systemTimeZoneBindingStrategy>:

		If the default TimeZoneLocalizationPolicy defines a to-Olson-timezone-key mapping from the standard-time offset specified by the POSIX rule literal contained in the TZ Environment Variable, or if the default TimeZoneLocalizationPolicy defines a to-Olson-timezone-key mapping from any timezone abbreviation specified by the POSIX rule literal contained in the TZ Environment Variable, then answer the ChronosTimezone that implements the Olson timezone mapped by the default TimeZoneLocalizationPolicy from either the POSIX rule's standard-time offset or else any of its abbreviations.  If no such to-Olson-timezone-key mapping is defined by the default TimeZoneLocalizationPolicy, then answer nil.
	
	Case 3--#setSystemTimeZoneToAnalogOfNativeSystemTimeZone is the current <systemTimeZoneBindingStrategy>:
		
		If the POSIX timezone rule literal in the TZ Environment Variable contains sufficient information to fully define the timezone rules (i.e., it specifies the abbreviation and offset for standard time, and if DST is observed, the abbreviation and offset for DST, as well as the dates and times-of-day when the transtion to and from DST occurs,) then construct a ChronosTimezone that emulates the timezone rules as specified.  However, if the rule literal is not syntactically valid, then answer nil. And if the rule literal does not specify sufficient information to construct ChronosTimezone analog, then answer a ChronosTimezone as specified for Case 2 (above.)"

	"{ChronosSystemFacade current resolveSystemTimeZoneFromTZEnvironmentVariableValue}"

	| tzEnvVarValue resolveOlsonTZ |
	tzEnvVarValue := self resolveValueOfTZEnvironmentVariable.
	resolveOlsonTZ := 
		[:tzAttributes |
		| stdOffset stdAbbreviation dstAbbreviation tzKey |
		stdOffset := tzAttributes at: #StdOffsetSecondsFromUT.
		dstAbbreviation := tzAttributes at: #NonStdAbbreviation ifAbsent: [].
		tzKey := 
			TimeZoneLocalizationPolicy default 
			defaultTimeZoneKeyForStandardTimeOffsetSecondsFromUT: stdOffset
			dstPreferred: dstAbbreviation notNil
			ifAbsent: [].
		tzKey == nil
			ifTrue:
				[stdAbbreviation := tzAttributes at: #StdAbbreviation ifAbsent: [].
				tzKey := TimeZoneLocalizationPolicy default 
								defaultTimeZoneKeyWithCommonAbbreviation: 
									(dstAbbreviation == nil 
										ifTrue: [stdAbbreviation]
										ifFalse: [dstAbbreviation])
								dstPreferred: dstAbbreviation notNil
								ifAbsent: [self reportUnkownTZEnvironmentVariableValue: tzEnvVarValue. nil]].
		tzKey == nil
			ifFalse: [VariableOffsetTimezone at: tzKey ifAbsent: []]].
	^self 
		evaluateTZEnvironmentVariableValue: tzEnvVarValue
		ifOlsonTZKey: [:tzKey | VariableOffsetTimezone at: tzKey]
		ifTZRuleLiteral: 
			(systemTimeZoneBindingStrategy == #setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone
				ifFalse: 
					[[:tzAttributes | 
					systemTimeZoneBindingStrategy == #setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem
						ifTrue: [resolveOlsonTZ value: tzAttributes]
						ifFalse: 
							["systemTimeZoneBindingStrategy == #setSystemTimeZoneToAnalogOfNativeSystemTimeZone"
							| stdOffset stdAbbreviation dstAbbreviation |
							stdAbbreviation := tzAttributes at: #StdAbbreviation.
							stdOffset := tzAttributes at: #StdOffsetSecondsFromUT.
							dstAbbreviation := tzAttributes at: #NonStdAbbreviation ifAbsent: [].
							dstAbbreviation == nil
								ifTrue: 
									[BasicTimezone 
										offset: (DurationFactory seconds: stdOffset) 
										name: tzEnvVarValue 
										commonAbbreviation: stdAbbreviation]
								ifFalse: 
									[| toDstDate toDstTime toStdDate toStdTime dstOffset stdOffsetDuration dstOffsetDuration |
									toDstDate := tzAttributes at: #NonStdDate ifAbsent: [^resolveOlsonTZ value: tzAttributes].
									toDstTime := tzAttributes at: #NonStdTimeOfDay.
									toStdDate := tzAttributes at: #StdDate.
									toStdTime := tzAttributes at: #StdTimeOfDay.
									dstOffset := tzAttributes at: #NonStdOffsetSecondsFromUT.
									stdOffsetDuration := DurationFactory seconds: stdOffset.
									dstOffsetDuration := DurationFactory seconds: dstOffset.
									VariableOffsetTimezone
										key: #system name: #POSIXTime
										initialOffset: stdOffsetDuration withAbbreviation: stdAbbreviation
											until: toDstDate at: toDstTime relativity: #nominal
										thenOffset: dstOffsetDuration withAbbreviation: dstAbbreviation
											until: toStdDate at: toStdTime relativity: #nominal]]]])
		otherwise: [self reportUnkownTZEnvironmentVariableValue: tzEnvVarValue. nil]! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
resolveSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone
	"If possible, determine whether the host system is using an Olson timezone to define its local time, and also whether the Olson key of that timezone can be discovered (to the desired degreee of certainty and precision.) If so, answer the Olson timezone key so determined. Othwerwise answer nil."

	"{ChronosSystemFacade current resolveSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone}"

	"Even on systems that use Olson timezones, there are usually only two ways to discover which Olson timezone key identifies the user's local time: 1) from the value of the TZ environment variable, or 2) from the contents of the file /etc/localtime.  It used to be that UNIX systems only used the value of the TZ environment variable for this purpose.  Unfortunately, they were forced to adopt a now widely-used alternative mechanism for specifying the local timezone: the /etc/localtime file. Although the TZ environment variable still functions, it only does so for individual users--the UNIX kernel does not and cannot make use of it.

	The reason that UNIX systems stopped using the TZ environment variable to define local time on a system-wide basis is because of Windows--or more specifically, because it became so common to dual-boot both UNIX and Windows on the same machine. UNIX traditionally expects the system clock to be set to Universal Time.  Windows expects the system clock to be set to local time.  

	UNIX, of course, is the one who had to adapt in order to resolve the conflicting system clock paradigms. So the UNIX kernel was changed so that it could handle a system clock set either to UT or to local time.  As a consequence of this change to the UNIX kernel, it was necessary for the kernel to have direct access to the `compiled` binary version of the Olson timezone description of the local timezone.  And unfortunately, the binary Olson timezone files (which Chronos does not use) do not contain any information which would make it easy to determine the Olson key of the timezone whose ruleset they contain.  So now it is quite common for the contents of the `totally-lacking-any-identification-internally` /etc/localtime binary timezone ruleset file to be the only specification available regarding a UNIX system's definition of local time.

	There is, however, one common practice that may make it possible to discover the Olson timezone key of the Olson timezone whose ruleset (but not identity) is specified by the contents of the /etc/localtime file: More often than not, /etc/localtime a symbolic link to one of the binary Olson timezone files in the /usr/share/zoneinfo directory (or in some directory whose pathname should be similar.)  If that's the case, then it should be possible for an application with the necessary permissions (and the ability to make UNIX system calls) to discover the target pathname of the /etc/localtime symbolic link, and then to find the suffix of the pathname that corresponds to the key of the Olson timezone whose specification resides in that file.  

	This implemention of the method makes no attempt to resolve an Olson timezone key from the pathname of the /usr/share/zoneinfo/<zonefile> pointed to by the /etc/localtime symbolic link; but subimplementers are encouraged to do so, should the need arise.  

	Another possible strategy (also not implemented here) that might be attempted would be to examine the information that is available in the /etc/localtime binary file, and use that to find the most likely corresponding Olson timezone key (an Olson binary timezone file contains every offset and abbreviation ever used for the timezone, and every point-in-time--as a number of seconds since 1970-01-01T00:00:00 UT--at which any of those values changed.) Yet another strategy would be to reverse-compile the binary timezone file into a (probably very long) sequence of Chronos TimeZonePolicySpecs--from which a TimeZonePolicy could be constructed (see TimeZonePolicy, TimeZoneOffsetPolicy, TimeZonePolicySpec, TimeZoneOffsetPolicySpec and their subclasses.)"

	^self resolveSystemTimeZoneFromTZEnvironmentVariableValue! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
resolveValueOfTZEnvironmentVariable
	"Answer the value of the TZ environment variable. If the host system does not support environment variables answer nil."

	^EnvironmentFacade current valueOfEnvironmentVariableAt: 'TZ'! !

!ChronosSystemFacade methodsFor: 'resource repository' stamp: ''!
resourcePathPrefix
	^self resourceRepositoryContext resourcePathPrefix! !

!ChronosSystemFacade methodsFor: 'control' stamp: ''!
resourcePathPrefix: prefixString 
	^self resourceRepositoryContext resourcePathPrefix: prefixString! !

!ChronosSystemFacade methodsFor: 'resource repository' stamp: ''!
resourceRepositoryContext
	resourceRepositoryContext == nil ifTrue: [self setResourceRepositoryContext].
	^resourceRepositoryContext! !

!ChronosSystemFacade methodsFor: 'queries' stamp: ''!
rfc868SecondsSince1900
	"Answer the number of seconds since 1900-01-01T00:00:00 UTC [Gregorian], using the network time service defined by RFC-868.  Purpose: To enable retrieving the current time in situations where a) there is no local clock available, or b) there is reason to believe the local clock may not be correctly set, or may not keep time with sufficient accuracy. Note: Asking for and receiving back the current time over the internet would typically require on the order of 200 milliseconds--so obtaining the current time over the internet should only be done infrequently (once per minute at most.)  Applications with extreme current-time accuracy requirements should configure the host platform to use a local NTP time server that uses the NTP standard to keep the local clock accurate to within nanosecond tolerances (the NTP standard is NOT the same as the one defined in RFC-868.)"

	"{DateAndTimeFactory 
		utSecondsSinceEpoch: 
			((Calendar gregorian secondsSinceEpochUpToYear: 1900) 
			+ ChronosSystemFacade current rfc868SecondsSince1900)
		timeZone: Timezone default}"

	^self subclassResponsibility

	"To implement:

		1. Establish a datagram socket connection to a network time server on port 37 (e.g. 't2.timegps.net', or Google for 'network time server'.)
		2. Send a datagram packet to the time server, with any byte sequence as the data payload.
		3. Receive a 4-byte response containing the number of seconds since 1900-01-01T00:00:00 (as an unsigned big-endian value.)"! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
setBaseSystemTimeZoneFromChronosSystemTimeZone
	"Set the base system's timezone (that defines its local time) to one which is as congruent as possible to the receiver's <systemTimeZone>.  This operation MUST NOT affect how time is reported by Chronos. If the Smalltalk execution environment has its own support for timezones (apart from either Chronos or the operating system,) then this operation should affect how the current Smalltalk execution environment reports time using its native date-time facilities.  Ideally, this operation should also affect the reporting of time by the host operating system (at least for the current user, but probably not for all users.) 

	NOTE: Some systems keep time in UT, and report local time by converting from UT according to the specifications of the current timezone.  Other systems keep time in local terms, and convert to UT when needful according to the specifications of the current timezone.  In the former case, this operation optimally should change the local time-of-day natively reported by the Smalltalk execution environment.  In the latter case, it should change the UT time-of-day natively reported by the Smalltalk execution environment."

	^self subclassResponsibility! !

!ChronosSystemFacade methodsFor: 'services/utilities' stamp: ''!
setChronosDefaultLanguageAndCountryCodesFromBaseSystem
	"This method MUST be invoked whenever the Smalltalk execution environment starts running (typically, whenever the 'image' is restarted after a snapshot, although not all ST implementations use 'images.') Answer true if successful, false otherwise."

	^[self 
		fromBaseSystemLocaleKey: self baseSystemLocaleKey
		setLanguageCodeAndCountryCodeInto: 
			[:language :country | self setSystemLanguageCode: language countryCode: country].
	true] 
			on: Error
			do: 
				[:ex | 
				self reportFailureToSetDefaultLanguageAndCountryCodesFromBaseSystem: ex.
				ex return: false]! !

!ChronosSystemFacade methodsFor: 'services/utilities' stamp: ''!
setChronosSystemTimeZoneFromBaseSystem
	"Set the receiver's <systemTimeZone> to that of the host system, according to the current system time zone binding strategy (see class comment for details.) Answer true if the <systemTimezone> was successfully set (even if to the same value as before,) false otherwise."

	"{ChronosSystemFacade current setChronosSystemTimeZoneFromBaseSystem}"

	"{ChronosSystemFacade current onStartupDoNotSetSystemTimeZoneUnlessBaseSystemTimeZoneIsAnOlsonTimeZone} 	
		^-- Best when system timezone is unlikely to ever change once set correctly"
	"{ChronosSystemFacade current onStartupSetSystemTimeZoneToAnalogOfNativeSystemTimeZone}
		^-- Best when system clock keeps local time"
	"{ChronosSystemFacade current onStartupSetSystemTimeZoneToMostCongruentOlsonTimeZone}
		^-- Best when users change time zones frequently"

	"This method MUST be invoked whenever the Smalltalk execution environment starts running (typically, whenever the 'image' is restarted after a snapshot, although not all ST implementations use 'images.')"

	| success |
	success := self perform: systemTimeZoneBindingStrategy.
	success 
		ifFalse: 
			[self showReportsWhile: [self reportSystemTimeZoneIdentity].
			systemTimeZoneBindingStrategy == #setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone
				ifFalse: [self userNotify: self systemTimeZoneNotResolvableMessage]].
	^success! !

!ChronosSystemFacade methodsFor: 'private' stamp: ''!
setResourceRepositoryContext
	"ChronosSystemFacade current setResourceRepositoryContext"

	resourceRepositoryContext := ChronosResourceRepositoryContext new.! !

!ChronosSystemFacade methodsFor: 'private' stamp: ''!
setSystemLanguageCode: languageCode countryCode: countryCode
	"Whether or not this method has any effect outside of Chronos is not specified.  Subimplementers may choose either approach."

	systemLanguageCode := languageCode.
	systemCountryCode := countryCode.
	ChronosLocale invalidateSystemLocale.
	self reportSystemLanguageAndCountryCode.! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
setSystemTimeZone: aChronosTimezone 
	"Set the <systemTimeZone> and notify ChronosTimezone of the change."

	^systemTimeZone = aChronosTimezone
		ifTrue: [false]
		ifFalse: 
			[systemTimeZone := aChronosTimezone.
			ChronosTimezone invalidateSystemTimezone.
			self showReportsWhile: [self reportSystemTimeZoneIdentity].
			true].! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone
	"If it's possible to determine that the host system is using an Olson timezone to define its local time, and if it's also possible to determine the Olson key of that timezone (to the desired degreee of certainty and precision,) then set the receiver's <systemTimeZone> to a Chronos VariableOffsetTimezone with the same key and answer true. Othwerwise do nothing and answer false"

	"{ChronosSystemFacade current setSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone}"

	| tz |
	tz := self resolveSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone.
	^tz == nil
		ifTrue: [false]
		ifFalse: 
			[self setSystemTimeZone: tz. 
			true]! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
setSystemTimeZoneToAnalogOfNativeSystemTimeZone
	"If it's possible to determine that the host system is using an Olson timezone to define its local time, and if it's also possible to determine the Olson key of that timezone (to the desired degreee of certainty and precision,) then set the receiver's <systemTimeZone> to a Chronos VariableOffsetTimezone with the same key and answer true.

	Otherwise, construct a ChronosTimezone that emulates the behavior of the host system's timezone as closely as possible (i.e., serves a reasonably close analog of the host system's timezone,) set the ChronosTimezone so constructed as the <systemTimeZone> and answer true. However, if it's not possible to get sufficient information about the host system's timezone to construct a ChronosTimezone that will serve as a reasonable analog, then do nothing and answer false."

	"{ChronosSystemFacade current setSystemTimeZoneToAnalogOfNativeSystemTimeZone}"

	| tz |
	tz := self resolveSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone.
	^tz == nil
		ifTrue: [self setSystemTimeZoneToAnalogOfWindowsTimeZone]
		ifFalse: 
			[self setSystemTimeZone: tz. 
			true]! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
setSystemTimeZoneToAnalogOfWindowsTimeZone
	"Construct a ChronosTimezone that emulates the behavior of the current user's Windows timezone as closely as possible (i.e., so that it serves a reasonably close analog of the Windows time zone,) and set the ChronosTimezone so constructed as the <systemTimeZone>, and answer true.  But if not running on Windows, or if it's not possible for some reason to access the Windows Registry and get the parameters of the current user's Windows timezone, do nothing and answer false."

	"{ChronosSystemFacade current setSystemTimeZoneToAnalogOfWindowsTimeZone}"

	"The well-known keys used by Chronos to identify the attributes of a Windows timezone ruleset specification, and the value that should be associated with each key:
		
		Key									Semantics and Smalltalk type of associated value that should be returned by this method (as values in a Dictionary)

		#BaseOffsetSecondsFromUT	->	<Integer> base number of seconds that should be ADDED to the Universal time-of-day to derive local time-of-day during STANDARD TIME.
		#StandardName					->	<String> whose value is Window's canonical name for the timezone.
		#StandardBias					->	<Integer> number of seconds that should be ADDED to the <BaseOffsetSecondsFromUT> during standard time (usually zero).
			-- The following entries should not be present if the timezone does not observe DST: 
		#StandardDate					->	<AnnualDate> on which the timezone transitions to `standard` time--or not present if there is no transition to standard time.
		#StandardTimeOfDay			-> <TimeOfDay> at which the timezone transitions to `standard` time (always local 'wall-clock' time)--or not present if there is no transition to standard time.
		#DaylightName					->	<String> whose value is Window's name for the timezone when DST is in effect.
		#DaylightBias					->	<Integer> number of seconds that should be ADDED to the <BaseOffsetSecondsFromUT> during 'daylight-saving/summer' time.
		#DaylightDate					->	<AnnualDate> on which the timezone transitions to `daylight-saving/summer` time.
		#DaylightTimeOfDay				-> <TimeOfDay> at which the timezone transitions to `daylight-saving/summer` time (always local 'wall-clock' time.).

	The standard time offset from UT will be computed as <BaseOffsetSecondsFromUT> + <StandardBias>; the DST offset from UT will be computed as <BaseOffsetSecondsFromUT> + <DaylightBias>."

	| windowsTzAttributes baseOffsetSecondsFromUT dstBias windowsStdTimeName olsonKey name stdAbbrev dstAbbrev |
	windowsTzAttributes := self windowsTimeZoneAttributes.
	windowsTzAttributes == nil ifTrue: [^false].
	windowsStdTimeName := windowsTzAttributes at: #StandardName.
	olsonKey := TimeZonePolicyFactory timeZoneKeyFromWindowsTZName: windowsStdTimeName ifAbsent: [].
	name := nil.
	olsonKey == nil 
		ifFalse: 
			[name := TimeZonePolicyFactory windowsTimeZoneNameFromTZKey: olsonKey ifAbsent: [].
			name == nil 
				ifFalse: 
					[| tzpf |
					tzpf := TimeZonePolicyFactory at: olsonKey ifAbsent: [].
					tzpf == nil
						ifTrue: 
							[stdAbbrev := windowsStdTimeName.
							dstAbbrev := windowsTzAttributes at: #DaylightName ifAbsent: [#DST]]
						ifFalse:
							[tzpf defaultAnnualTransitionPolicy annuallyRecurringTransitionsDo: 
								[:i :transition | 
									transition isStandardTime 
										ifTrue: [stdAbbrev := transition commonAbbreviation]
										ifFalse: [dstAbbrev := transition commonAbbreviation]]]]].
	name == nil
		ifTrue:
			[name := windowsStdTimeName.
			stdAbbrev := windowsStdTimeName.
			dstAbbrev := windowsTzAttributes at: #DaylightName ifAbsent: [#DST]].
	baseOffsetSecondsFromUT := windowsTzAttributes at: #BaseOffsetSecondsFromUT.
	dstBias := windowsTzAttributes at: #DaylightBias ifAbsent: [].
	dstBias == nil 
		ifTrue: 
			[self setSystemTimeZone: 
				(ChronosTimezone 
				offset: (DurationFactory seconds: baseOffsetSecondsFromUT + (windowsTzAttributes at: #StandardBias))
				name: name
				commonAbbreviation: stdAbbrev)]
		ifFalse: 
			[self setSystemTimeZone: 
				(ChronosTimezone 
					key: #system name: name
					initialOffset: (DurationFactory seconds: baseOffsetSecondsFromUT + (windowsTzAttributes at: #StandardBias)) withAbbreviation: stdAbbrev
						until: (windowsTzAttributes at: #DaylightDate) at: (windowsTzAttributes at: #DaylightTimeOfDay) relativity: #nominal
					thenOffset: (DurationFactory seconds: baseOffsetSecondsFromUT + (windowsTzAttributes at: #DaylightBias)) withAbbreviation: dstAbbrev
						until: (windowsTzAttributes at: #StandardDate) at: (windowsTzAttributes at: #StandardTimeOfDay) relativity: #nominal)].
	^true! !

!ChronosSystemFacade methodsFor: 'private-system timezone' stamp: ''!
setSystemTimeZoneToOlsonTimeZoneMostCongruentToNativeSystem
	"Determine the key of the Olson timezone that is the most congruent to the host system's timezone, set the <systemTimeZone> to the ChronosTimezone with that key, and answer true. However, if it is not possible to obtain enough information about the host system's timezone to determine the Olson timezone key of the Olson timezone that would be reasonably congruent to the host system's timezone, then do nothing and answer false."

	| tz timeZoneKey |
	tz := self resolveSystemTimeZoneOnlyFromNativeSystemOlsonTimeZone.
	^tz == nil 
		ifTrue: 
			[timeZoneKey := self olsonTimeZoneKeyFromWindowsTimeZoneKey.
			timeZoneKey == nil 
				ifTrue: [false]
				ifFalse: 
					[self setSystemTimeZone: (VariableOffsetTimezone at: timeZoneKey ifAbsent: [^false]).
					true]]
		ifFalse: 
			[self setSystemTimeZone: tz.
			true]! !

!ChronosSystemFacade methodsFor: 'private-testing' stamp: ''!
shouldSkipInstallation
	"Answer whether the receiver's installation operation should be totally skipped (applies to either #installInitially or #install.)"

	"{ChronosSystemFacade current shouldSkipInstallation}"
	"{ChronosEnvironment canonical globalNamespace at: #ChronosInstallationFlag put: false}"
	"{ChronosEnvironment canonical globalNamespace removeKey: #ChronosInstallationFlag ifAbsent: []}"

	self class == ChronosSystemFacade ifTrue: [^true].
	^ChronosEnvironment shouldSkipInstallation or: [(EnvironmentFacade current valueOfEnvironmentVariableAt: 'CHRONOS_INSTALLATION') asUppercase = 'NO']! !

!ChronosSystemFacade methodsFor: 'control' stamp: ''!
showReportsWhile: block0
	| originalState |
	originalState := showReports.
	showReports := true.
	block0 ensure: [showReports := originalState].! !

!ChronosSystemFacade methodsFor: 'queries' stamp: ''!
systemCountryCode
	^systemCountryCode! !

!ChronosSystemFacade methodsFor: 'queries' stamp: ''!
systemLanguageCode
	^systemLanguageCode! !

!ChronosSystemFacade methodsFor: 'queries' stamp: ''!
systemLocaleKey
	^ChronosLocale 
		localeKeyFromLanguageCode: self systemLanguageCode
		countryCode: self systemCountryCode! !

!ChronosSystemFacade methodsFor: 'queries' stamp: ''!
systemTimeZone
	^systemTimeZone == nil 
		ifTrue: [ChronosTimezone universal]
		ifFalse: [systemTimeZone]! !

!ChronosSystemFacade methodsFor: 'services/utilities' stamp: ''!
systemTimeZone: aChronosTimezone
	"Set the system's Timezone to one which is as congruent as possible to the one identified by <aTimeZoneKey> in the Olson TZ database.  At a minimum, this operation MUST affect how time is reported by Chronos. If the Smalltalk execution environment has its own support for Time Zones (apart from Chronos,) then this operation MUST affect how the current Smalltalk execution environment reports local time using its native date-time facilities.  IDEALLY, this operation should also affect the reporting of local time by the host operating system--but that is not strictly required (extra credit will be duly recorded...).

	See the method comment of 'ChronosSystemFacade>>resolveBaseSystemTimeZoneKey:' for more information, advice and discussion of the issues involved."


	^systemTimeZone = aChronosTimezone
		ifTrue: [false]
		ifFalse:
			[| changed |
			changed := self setSystemTimeZone:  aChronosTimezone.
			changed ifTrue: [self setBaseSystemTimeZoneFromChronosSystemTimeZone].
			changed]! !

!ChronosSystemFacade methodsFor: 'queries' stamp: ''!
systemTimeZoneBindingStrategy
	"Options: #resolveMostCongruentOlsonTimeZone | #onlyResolveOlsonTimeZoneToOlsonTimeZone | #setSystemTimeZoneToAnalogOfNativeSystemTimeZone"

	^systemTimeZoneBindingStrategy! !

!ChronosSystemFacade methodsFor: 'private-user notification text' stamp: ''!
systemTimeZoneNotResolvableMessage
	"Text of the user notification message to be presented to the user when Chronos has not been able to set the Chronos system timezone based on the host system's local time."

	"The notification text below is aimed at programmers; change or subimplement it in order to make the text appropriate to the actual user base."

		^'Chronos is unable to determine the host system timezone.', (String with: Character cr), 
		'If <', self systemTimeZone name, '> (the current Chronos system timezone)', (String with: Character cr), 
		'does not coincide with the host system''s local time, it will be necessary to set the Chronos', (String with: Character cr), 
		'system timezone manually (see the class comment of ChronosTimezone for instructions.)'! !

!ChronosSystemFacade methodsFor: 'queries' stamp: ''!
timeServerHostName
	^'time.nist.gov'! !

!ChronosSystemFacade methodsFor: 'installation' stamp: ''!
unregisterForStartupNotification
	"Make it so that whenever the Smalltalk image is restarted after a snapshot, the receiver will NOT be sent the message #install (nor otherwise notified.)

	NOTE: This method is intended for use by image-based Smalltalk implementations.  It may or may not have any utility in the case of non-image-based Smalltalk systems."

	"ChronosSystemFacade current unregisterForStartupNotification"

	EnvironmentFacade cancelImageRestartNotificationSubscriptionFor: self! !

!ChronosSystemFacade methodsFor: 'services/utilities' stamp: ''!
userNotify: aMessage 
	"Notify the user of an event by displaying or logging the text of <aMessage>"

	self reportToConsole: aMessage! !

!ChronosSystemFacade methodsFor: 'private-queries' stamp: ''!
windowsTimeZoneAttributes
	"If on Windows, answer the attributes (as a Dictionary with well-known keys) of the current user's Windows timezone ruleset as specified in the Windows Registry.  Answer nil if not on Windows, or if this operation is not currently supported."

	"{ChronosSystemFacade current windowsTimeZoneAttributes}"

	"The well-known keys used by Chronos to identify the attributes of a Windows timezone ruleset specification, and the value that should be associated with each key:
		
		Key									Semantics and Smalltalk type of associated value that should be returned by this method (as values in a Dictionary)

		#BaseOffsetSecondsFromUT	->	<Integer> base number of seconds that should be ADDED to the Universal time-of-day to derive local time-of-day during STANDARD TIME.
		#StandardName					->	<String> whose value is Window's canonical name for the timezone.
		#StandardBias					->	<Integer> number of seconds that should be ADDED to the <BaseOffsetSecondsFromUT> during standard time (usually zero).
			-- The following entries should not be present if the timezone does not observe DST: 
		#StandardDate					->	<AnnualDate> on which the timezone transitions to `standard` time--or not present if there is no transition to standard time.
		#StandardTimeOfDay			-> 	<TimeOfDay> at which the timezone transitions to `standard` time (always local 'wall-clock' time)--or not present if there is no transition to standard time.
		#DaylightName					->	<String> whose value is Window's name for the timezone when DST is in effect.
		#DaylightBias					->	<Integer> number of seconds that should be ADDED to the <BaseOffsetSecondsFromUT> during 'daylight-saving/summer' time.
		#DaylightDate					->	<AnnualDate> on which the timezone transitions to `daylight-saving/summer` time.
		#DaylightTimeOfDay				-> <TimeOfDay> at which the timezone transitions to `daylight-saving/summer` time (always local 'wall-clock' time.).

	The standard time offset from UT will be computed as <BaseOffsetSecondsFromUT> + <StandardBias>; the DST offset from UT will be computed as <BaseOffsetSecondsFromUT> + <DaylightBias>.

	Windows timezone attributes are natively represented in a 'struct' defined as follows (a 'WCHAR' is defined as 'unsigned short'):

		struct _TIME_ZONE_INFORMATION {
			LONG Bias;									// Number of minutes to ADD to local standard time to derive universal time (inverse polarity of standard practice.)
			WCHAR StandardName[32];				// Windows canonical timezone name--used as lookup key.
			SYSTEMTIME StandardDate;				// Annual date and time of transition to Standard Time--see below.
			LONG StandardBias;						// Number of minutes to ADD to <Bias> during Standard Time.
			WCHAR DaylightName[32];				// Windows name of timezone during Daylight-Saving/Summer Time.
			SYSTEMTIME DaylightDate;				// Annual date and time of transition to Daylight-Saving/Summer Time--see below.
			LONG DaylightBias;						// Number of minutes to ADD to <Bias> during Daylight-Saving/Summer Time.
		}

	The SYSTEMTIME struct type is defined as follows (a 'WORD' is defined as 'unsigned short'):

		typedef struct SYSTEMTIME { 
			WORD wYear;
			WORD wMonth;
			WORD wDayOfWeek;
			WORD wDay;
			WORD wHour;
			WORD wMinute;
			WORD wSecond;
			WORD wMilliseconds;
		}

	In a Windows timezone ruleset (as opposed to its usage elsewhere,) the members (fields, slots) of a SYSTEMTIME value have the following function/semantics:

		Member/Field/Slot Name			Function/Role/Semantics
		
		wYear									Not used
		wMonth								Ordinal of the month in which a transition to/from DST occurs (1=January, 12=December); 
													if the value is zero, then the struct represents a 'not a date' value, which means no transition.
		wDayOfWeek						Cardinal number of the day of the week on which a transition to/from DST occurs (0=Sunday; 7=Saturday.)
		wDay									Ordinal of the week of the month in which a transition to/from DST occurs; 
													1 means the first week, 4 means the fouth week, 
													but 5 means the last week of the month.
		wHour									Cardinal number of the hour of the day when a transition to/from DST occurs (0-23.)
		wMinute								Cardinal number of the minute of the hour of the day when a transition to/from DST occurs (0-59.)
		wSecond								Cardinal number of the second of the minute of the hour of the day when a transition to/from DST occurs (0-59.)
		wMilliseconds						Not used.
"

	^nil "By default, we assume either that we're not running Windows, or that this function is not implementable by the host Smalltalk system."! !

ChronosObject subclass: #ChronosTimezone
	instanceVariableNames: ''
	classVariableNames: 'AlwaysDefault AlwaysSystem BindingRegistry Default Nominal OffsetRegistry System Universal'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!ChronosTimezone commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosTimezone [Aliased by the global Timezone]

	Concept:

		ChronosTimezone is an abstract class; an instance of one of its concrete subclasses represents/implements a particular timezone. A timezone defines the civil/legal time-of-day for a particular locality (some legal jurisdiction, from as small as a city to as large as a nation-state.) Local time-of-day in a timezone is defined as some number of seconds of offset (positive or negative) from the local time-of-day in the international standard reference timezone.  For a timezone whose offset from the international reference timezone is negative 5 hours, the local time in that timezone would be 6 am when the local time of day in the international reference timezone is 11 am.  For more information on the origin and conceptual evolution of timezones, see the HISTORY section below.

		Universal Time (abbreviated UT) has been the official name of the international standard zero-offset reference timezone since 1928.   This reference timezone was originally called Greenwich Mean Time (abbreviated GMT.)  Common usage is to use either GMT or UTC as the name of the international zero-offset reference timezone, in spite of the fact that neither is the formally correct name (the name GMT has been superceded by UT, and UTC is technically the abbreviation of a timescale, not a timezone.)  

		Other than in comments such as this one, Chronos does not use the term "GMT." With but one exception, Chronos always uses either "Universal Time" or "UT" to refer to the international reference zero-offset timezone. Other than the name of the message #asUTC (whose name and semantics are mandated by the ANSI-Smalltalk Standard,) Chronos uses "UTC" solely as the abbreviation of the timescale "Coordinated Universal Time." The UTC timescale defines a second as an SI (metric system) second (which defines the temporal extent of one second in terms of the vibrational frequency of a particular type of atom under specific conditions,) and requires that a leap second occasionally be added to or removed from the number of seconds in a day in order to keep the UTC time-of-day to within 0.9 seconds of the UT1 time-of-day (in UT1, each day is a mean solar day of exactly 86400 seconds.) For more information on this subject, see the section on TIMESCALES presented below.

		Chronos supports both "simple" timezones whose UT-offset is some invariant number of seconds, and also "complex" timezones whose UT-offset varies over time.  Variable-offset timezones may not only use different UT-offsets within a year, but may also use different rules in different years to determine the moments of transition to or from Daylight Saving Time.  See the "INVARIANT-OFFSETS AND VARIABLE-OFFSETS FROM UNIVERSAL TIME" section immediately below for more details.

		Timezones are far from as simple as you probably imagine.  However, those who don't require sub-second time accuracy, and who don't care about points-in-time that occur all that far in the future or the past, may need to know nothing more than a) how to catalog all available pre-defined ChronosTimezones, b) how to instantiate a point-in-time value whose local time will be defined by a particular ChronosTimezone, and c) how to set the default ChronosTimezone to whatever the local timezone happens to be.  That information is provided in the "Usage:" section (far) below.  Everyone else is strongly encouraged to read the entire "Concept:" section of this class comment.

		## INVARIANT-OFFSETS AND VARIABLE-OFFSETS FROM UNIVERSAL TIME

			Chronos supports both "simple" timezones whose offset from UT never varies (from the infinite past into the infinite future) and also "real world" timezones whose offsets from UT may vary over time (diachronic offset rules.)  The simple, invariant-offset timezones are implemented by BasicTimezone.  The "real world," variable-offset timezones are implemented by VariableOffsetTimezone (both of which see.)

			BasicTimezone provides an invariant offset from UT (no DST rules,) an invariant name (optional) and an invariant abbreviation (optional.)  It is provided for two reasons: 1) simplicity/performance, and 2) compatibility with the way the ANSI-Smalltalk Standard defines the timezone behavior of instances of DateAndTime. The ANSI Standard makes the (generally false) assumption that a timezone can be specified as a Duration.  Although using an invariant Duration (offset) to define a timezone can work quite well under certain conditions, it is a very poor model of the way timezones usually work in practice.

			Generally, people don't conceptualize a timezone as a fixed offset from universal time.  They conceptualize a timezone as the local time at a particular location.  When you have an appointment to meet someone for some purpose at 1pm, the meaning of "1pm" is defined by the a) the location of the meeting, and 2) the legal definition of the time of day at that location at that moment in time.  Both the location and the moment in time are required in order to determine the offset from UT that will be in effect at a given location at a given time. For example, consider the following questions: If there is an event scheduled to occur (or that did occur) at "1pm" in Lihue, Hawaii (on the island of Kauai,) what is the offset from UT? What would be the date and time 100 hours later? 

			Even though Daylight Saving Time is not observed in Hawaii, the answer nevertheless depends on the date--and perhaps even on the time-of-day.  Before 1947-06-08T02:00:00 HST, the offset from UT would be -10:30 (hours:mintues,) on or after that moment it would be -10:00.  So an event that occurred at 1947-06-07T13:00:00 HST would correspond to 1947-06-07T23:30:00 Universal Time--and 100 hours later would be 1947-06-11T17:30:00 HST (1947-06-12T03:30:00 UT)--5:30pm local time, 3:30am UT.

			Consider also this: Hawaii could decide to start observing Daylight Saving Time at some point in the future--or the US Congress could decide that for them.  Consequently, it is not at all a guaranteed fact that the local time in Hawaii of some point-in-time in the future will have an offset from UT of -10 hours. So using "-10 hours" as the invariant offset of points-in-time for events in Hawaii will not only be wrong for moments prior to 1947-06-08T02:00:00 HST, it may also be wrong for moments in the future.  

			The preceding examples demonstrate why Chronos supports not only timezones whose offsets from UT may vary "intra-year" (which is typical of the way Daylight Saving Time works,) it also supports timezones whose "standard time" offset, abbreviation or DST transition rules may vary from one year to the next.  By specifying Hawaii's local timezone as "'Pacific/Honolulu'" instead of as "Duration hours: -10", not only will one get the correct UT-offset in effect now, one will also get the correct offsets in effect prior to June 1947, as well as whatever the correct offset may be in the future.

			See VariableOffsetTimezone for more details.

		## HISTORY {information that may be helpful for those who aren't already rather knowledgeable about timezones and how the time-of-day is determined)}

			"Standard Time"

				Before the introduction of timezones, every municipality set its clock by the local position of the sun (usually "mean solar time" in the case of cultures that were using relatively accurate mechanical clocks, or else "apparent solar time" otherwise. Local solar time (whether mean or apparent) served well until the introduction of the train, when it became possible to travel fast enough to require almost constant re-setting of clocks. Timezones were invented to solve this problem by setting all clocks in a region to the same time--which was originally called "standard time" (although modernly, "standard time" means something slightly different.) 

				"Standard time" (in its original meaning) divides the world into a number of "time zones", each one covering, in theory at least, 15 degrees (one hour of solar time.) All clocks within each of these zones are (theoretically) set to the same time as the others, but so as to differ by one hour from those in the neighbouring zones. The local time at the Royal Greenwich Observatory in Greenwich, England was chosen as the international reference timezone at the 1884 International Meridian Conference, leading to the now almost-universal practice of defining local (civil/legal, but perhaps not religious) time-of-day as some number of seconds of offset from that of the Universal Time (UT) timezone. Greenwich, England was chosen because by 1884 two-thirds of all charts and maps already used it as their prime meridian.

				In actual practice, the amount of offset from the international reference timezone that defines local time in a region is a political matter. The offset in actual use is far from being a simple function of the local longitude. And some timezones have (or have had) fractional-hour offsets, instead of the integer-hour ideal.

				The first time zone in the world was established by British railways on December 1, 1847Greenwich Mean Time (GMT) being hand carried on chronometers. About August 23, 1852, time signals were first transmitted by telegraph from the Royal Greenwich Observatory. Even though 98% of Great Britain's public clocks were using GMT by 1855, it was not made Britain's legal time until August 2, 1880.

				On November 2, 1868 New Zealand officially adopted a standard time to be observed nationally, and was perhaps the first country to do so. It was based on the longitude 172 30' East of Greenwich, that is 11 hours 30 minutes ahead of Greenwich Mean Time. This standard was known as New Zealand Mean Time. 

				In the United States and Canada, standard time zones were introduced on November 18, 1883, by American and Canadian railroads. Newspapers referred to that day as "the Day of Two Noons." There was no legislative enactment or ruling: the railroads simply adopted a five zone system and assumed the public would follow. The American Railway Association, an organization of railroad managers, had noticed growing scientific interest in standardizing time. The ARA devised their own system, which had irregular zone boundaries which followed then-existing boundaries of different (railroad) lines, partly in order to head off government action which might have been inconvenient to their operations. Most people simply accepted the new time, but a number of cities and counties refused to accept "railroad time", which, after all, had not been made law. In, for example, the expiration of a contract--what does "midnight" mean? In one Iowa Supreme Court case, the owner of a saloon argued that he operated by local (sun) time, not "railroad time," and so he had not violated laws about closing time. Standard time remained a local matter until 1918, when it was made US Federal law as part of the introduction of daylight saving time (to save fuel for World War 1.)

			"Daylight Saving Time" (also known as "Summer Time")

				Daylight Saving Time is the practice of temporarily adjusting a timezone's offset to a different value--usually by adding 1 hour to the offset, and usually only during local summer (note that summer in the Southern Hemisphere happens during winter in the Northern Hemisphere.) The effect is that local time advances by one hour while Daylight Saving Time is in effect, so that what was local noon (for example) becomes 1 pm. Daylight Saving Time has been used in the United States and in many European countries since World War I. 

				During World War I, in an effort to conserve fuel needed to produce electric power, Germany and Austria initiated Daylight Saving Time as of 11 pm (local standard time) on the 30th of April, 1916, by advancing the hands of the local clocks by one hour. The following October, Daylight Saving Time was terminated, and the hour-hand of the local clocks was set back by one hour. This 1916 action was immediately followed by other countries in Europe, Belgium, Denmark, France, Italy, Luxembourg, Netherlands, Norway, Portugal, Sweden, and Turkey. Tasmania, and Manitoba.and Britian began "saving daylight" 3 weeks later, on 21 May 1916. In 1917, Australia, Newfoundland and Nova Scotia also began the practice. 

				Daylight Saving Time was not formally adopted in the United States until 1918. 'An Act to preserve daylight and provide standard time for the United States' was enacted on 19 March 1918. It both established standard time zones and set summer DST to begin on 31 March 1918. Daylight Saving Time was observed for seven months in 1918 and 1919. After the War ended, the law, however, proved so unpopular (mostly because people rose earlier and went to bed earlier than we do today) that the law was later repealed in 1919 over President Wilson's veto. It became a local option, and was continued in a few states (Massachusetts, Rhode Island) and some cities (New York, Philadelphia, Chicago, and others).

				During World War II, President Roosevelt instituted year-round Daylight Saving Time, called 'War Time' (e.g., "Eastern War Time" or "EWT,' "Pacific War Time" or "PWT.") "War Time" was in effect from 2 February 1942 to 14 August 1945, when its name was changed to "Peace Time" (but the offset wasn't changed back to "standard time" until 30 September 1945.).  

				From 1945 to 1966, there was no federal law about Daylight Saving Time. So states and localities were free to choose whether to observe Daylight Saving Time or not, and could choose when it began and ended. This, however, caused confusion--especially for the broadcasting industry, and for railways, airlines, and bus companies. Because of the different local customs and laws, radio and TV stations and the transportation companies had to publish new schedules every time a state or town began or ended Daylight Saving Time.

				Since the introduction of Daylight Saving Time, the term "standard time" has been redefined; it now refers to the local time defined by a time zone when Daylight Saving Time is not in effect (originally, it meant the canonical time to which all clocks in a time zone were set--a better term for that concept nowadays would be simply 'local time.')

		## TIMESCALES {important technical information for those interested in the precise meaning of certain terms, such as GMT, UT1, UTC, timezone and timescale--others may skip this section}

			To unambigously specify a well-defined moment in time in the terrestrial reference frame (especially with accuracy to the second or better,) a temporal coordinate must not only specify an extent of time since an epoch (the zero-point of the coordinate system used to designate a point-in-time value,) it must also specify both a timescale and a timezone.  

			A timescale specifies the moment that serves as the origin point for the coordinate system used to designate temporal coordinates (the timescale's epoch,)  and also specifies the size of the time units used to count or measure extents of time since (or until) the epoch (zero point) of the timescale.  It also defines the zero-point of the time-of-day clock.

			Timezones specify a number of seconds by which temporal coordinates (point-in-time values) are translated with respect to the epoch of their timescale, and so define translated timescales.  Timezones always maintain gauge-invariance--they only involve addition of a well-defined number of seconds (which may be negative,) never any gauge-changing multiplications or divisions which would change the size (gauge) of any time units.  Conversely, a timescale may define different gauges (time unit sizes) that apply during different intervals within the coordinate system defined by the timescale--in fact, the sizes of a timescale's time units may be defined by complex functions, so that they differ continuously (e.g., apparent solar time.).

			The timescale of a Chronos point-in-time value (a conceputal value) is defined partly by its Calendar (which see,) and partly by a Timescale instance (once that gets implemented, which it currently is not--and until it is, the only supported timescale is UT1.) The Calendar of a Chronos point-in-time value defines the size of its day, month and year time units (a Calendar's day is a mean solar day,) and also defines the epoch of its timescale to the nearest day. The Timescale of a Chronos point-in-time value (an object--once it is implemented, which it currently is not) defines the size of one second, the number of seconds in a day (which may or may not differ from day to day, depending on the Timescale,) and defines the reference coordinate system by means of which the time-of-day of a point-in-time value may be unambigously specified in the terrestrial reference frame.

			Universal Time (UT,) and any other timezone, can be used with any terrestrial timescale that uses Greenwhich Mean Time (directly or indirectly) to establish the zero-point of the time-of-day clock.  Were such not the case, it would be impossible for any country that didn't use the UTC timescale to define its timezones as offsets from Universal Time--and not all countries use the UTC timescale as the basis for their civil time-of-day, even though they all define their timezones as offsets from Universal Time. Universal Time is simply the timezone whose offset from the specific timescale of one's choice (UT0, UT1, UTC, etc) is an invariant 0.0 seconds.

			Unfortunately, the names of specific timezones and/or timescales ("GMT," "UT," "UTC,") tend to be used to refer either to a timezone, or to a timescale, which leads to much confusion and bogosity.  To help clarify matters, and also to establish the technically correct meanings (which are often different than colloquial usage,) the following history and explanation of timescales should prove helpful:

			In 1884, at the International Meridian Conference, GMT was officially adopted as the international reference timezone and timescale. At the time, no conscious distinction was made between a timezone and a timescale--because everyone at the conference was using mean solar time as the timescale of their timezones, viewed a timescale based on apparent solar time as a barbarous anachronism, had never heard of or imagined atomic clocks, and so saw no need to think about timezones and timescales separately.

			In 1928, the International Astronomical Union (IAU) changed the official name of the international zero-offset reference timezone from Greenwich Mean Time (GMT) to Universal Time (UT) for English speakers, Temps Universel (TU) for French speakers, and Welt Zeit (WZ) for German speakers.  However, the habit of using the name of the international reference timescale as a synonym for the international reference timezone (or vice versa) was very strongly entrenched--due to the fact that the initial definition of GMT meant both or either--and so GMT continued to be used as the name for both the timezone and the timescale--a habit that continues to this day. 

			In 1956, the timescales UT0 (mean solar,) UT1 (UT0 corrected for polar motion) and UT2 (UT1 corrected for predictable seasonal variations) were defined by the International Astronomical Union (IAU), with UT1 simply being a new name for the GMT timescale as it was defined in 1956 (GMT had originally used a less-rigourously-defined version of what is now called UT0.) In 1960, the Confrence Gnrale des Poids et Mesures (CGPM,  "General Conference of Weights and Measures") adopted the names and definitions of these timescales as international standards. Here we finally see recognition of the need to think (and speak) about timescales separately from timezones. The fact that atomic clocks had been in operation since 1949 may have had something to do with this.

			Also in 1956, the International Committee for Weights and Measures, under the authority given it by the Tenth General Conference on Weights and Measures in 1954, defined the second in terms of the period of revolution of the Earth around the Sun for a particular epoch, because by then it had become recognized that the Earth's rotation on its own axis was not sufficiently uniform as a standard of time. The Earth's motion was described in Newcomb's Tables of the Sun, which provides a formula for the motion of the Sun at the epoch 1900 based on astronomical observations made during the eighteenth and nineteenth centuries (also known as the "Equation of Time.") The second thus defined is the fraction 1/31,556,925.9747 of the tropical year for 1900 January 0 at 12 hours ephemeris time. This definition was ratified by the Eleventh General Conference on Weights and Measures in 1960. Reference to the year 1900 does not mean that this is the epoch of a mean solar day of 86,400 seconds. Rather, it is the epoch of the tropical year of 31,556,925.9747 seconds of ephemeris time. Ephemeris Time (ET) was defined as the measure of time that brings the observed positions of the celestial bodies into accord with the Newtonian dynamical theory of motion. Consequently, for the first time, the second became (by official definition) an extent of time of invariant size. However, seconds with invariant size and days containing an invariant 86400 seconds are not at all consistent with keeping time according to the sun--because the Earth's rotational speed is not a constant.  But this problem was not addressed in 1956. [Measuring time is so simple!! Why is this lengthy class comment necessary?!!]

			In 1959, the first atomic time scale was constructed by the USNO and was extrapolated back to 1956. It was named A.1. It was set equal to the UT2 point-in-time of the USNO as of 1958-01-01. In 1961 the BIH constructed a time scale named AM using radio broadcasts based on three atomic clocks. This was renamed A3, more clocks were added from 1967 through 1969, new statistical algorithms were employed, and the name became TA. This series of time scales has been extrapolated back into 1955 using broadcast time signals based on the original cesium clock at NPL. In 1971 the BIH atomic time scale became TAI (Temps Atomique International.) By the mid 1970s it was evident that the scale unit of TAI was not equal to the SI second at sea level. On 1977-01-01 the frequency of TAI was reduced by one part in 1012, and the frequency of TAI has been steered since that time. Starting 1977-01-01 the un-steered combination of atomic clocks which had formerly been TAI has been known by the new name EAL. By 1995 it was evident that blackbody radiation was affecting the frequency of cesium clocks, and that the true SI second should be measured at 0 Kelvin. Over the interval from 1995 to 1998 the length of the TAI second was decreased by about 2 parts in 1014 until it corresponded as closely as possible to cesium atoms at absolute zero. [Measuring time is so simple!! Why is this lengthy class comment necessary?!!]

			In 1965, the Bureau International de l'Heure (BIH) developed a UT-like time scale from its atomic time scale, A3, and called it "UTC."  In 1967, at the IAU's 13th General Assembly, the Commissions on Ephemerides and Time Scales approved the name "Coordinated Universal Time" (UTC) for this new timescale.

			In 1967 the Thirteenth General Conference on Weights and Measures defined the second of atomic time in the International System of Units (SI) as the duration of 9,192,631,770 periods of the radiation corresponding to the transition between the two hyperfine levels of the ground state of the caesium-133 atom. The ground state is defined at zero magnetic field. The definition of the second was later refined at the 1997 meeting of the BIPM to append the statement "This definition refers to a caesium atom at rest at a temperature of 0 K." The second thus defined is equivalent to the ephemeris second, although its (now invariant) size became even more precisely and universally defined (measurement of the Earth's motion were no longer necessary.) But the conflict between the number of invariantly-sized seconds in a day and the definition of the day as invariantly 86400 seconds was not addressed in 1967.

			In 1971 the Confrence Gnrale des Poids et Mesures (General Conference of Weights and Measures) officially recognized the Atomic Time Scale and endorsed the BIH (now BIPM) time scale as the International Atomic Time Scale, TAI. Since the first of January 1972, most countries in the world have distributed the Atomic Time Scale. TAI is generated from data from hundreds of atomic clocks kept by laboratories around the world. Timing centers from many countries regularly contribute data to BIPM. The Consultative Committee on Radiocommunications of the International Telecommunications Union developed a scale for broadcast time signals based on TAI.  This new scale was named Coordinated Universal Time (UTC). It was defined by saying that at the beginning of 1 January 1972, UTC would be exactly 10 seconds behind TAI--but the points-in-time at which any of these 10 leap seconds should be inserted have never been specified. 

			In 1975 the Confrence Gnrale des Poids et Mesures endorsed UTC and recommended that civil clock time be based on it. Today, the UTC timescale is the official basis for civil time in most (but not all) nations of the world. 

			In order for UTC to match the Earth's rotation, some compensation for the irregularities in that rotation must be made, because there are not an invariant 86400 SI (atomic clock) seconds in a solar day.  Without corrections, the sun at noon would gradually drift from being overhead.  Prior to 1972, broadcast time services had kept in step with the Earth's rotation by subtly varying the frequency they broadcast.   For UTC, the frequency was to be held constant. Corrections are made only by adding or subtracting a whole number of seconds, to prevent UTC from differing by more than 0.7 (initially,) but now 0.9, seconds from TAI. The Bureau Internationale des Heures announces when a leap second is to be added or subtracted from UTC.  Since the Earth's rotation is slowing, it is usually necessary to add a second. The change is usually made at the last moment of June or December, but may also be made at the end of March or September. Unless the definition of either the SI second or of the UTC timescale is changed, leap seconds will eventually have to be added with ever greater frequency--at the end of any month, then at the end of any day (by about the year 52,000 Gregorian,) and in the far distant future more than one per day.

			As currently specified, the UTC timescale defines the day as having either 86399, 86400 or 864001 SI seconds, and is equivalent to UT1 ("GMT") to within a tolerance of +/- 0.9 SI seconds.  Which days have which number of SI seconds is decided by the International Earth Rotation and Reference Systems Service, who publish advance notice whenever their astronomical observations and calculations show that it is necessary to add or remove a leap second. In a very real sense,  with respect to the number of seconds in a day, this makes the UTC timescale an observational one.  In contrast, UT1 (mean solar time) is observational with respect to the temporal extent of days and seconds, but not with respect to the number of seconds in a day.

	Usage:

		## TIMEZONE KEYS

			In most cases, ChronosTimezones are uniquely identified by a well-known globally-defined key. The key of a ChronosTimezone whose offset is an invariant number of seconds from UT is simply the number of (possibly fractional) seconds in its offset (unless it's the time zone for Universal Time--see below.)   They key of a ChronosTimezone whose offset varies over time is a Symbol.  And the keys of a few other `special` time zones are also Symbols, as will be explained below. As delivered by the author, all persistently-stored, globally-well-known variable-offset time zones (and their keys) are as defined by the Olson Timezone Database (the same one used by UNIX.) The Olson time zone keys usually (but not always) have the form <continent>/<city> or <ocean>/<city>, such as 'Europe/London', 'Asia/Calcutta' or 'Pacific/Auckland'. However, clients of Chronos are allowed to define their own variable-offset time zones having any desired key--which do not have to be globally well known, and do not have to be persistently stored in the Chronos time-zones repository. 
		
			The time zone key #system is used by Chronos whenever it constructs a variable-offset timezone as an analog or emulation of the base system's local timezone. The key #system may not even be unique within an image, let alone globally.  Variable-offset time zones created by Chronos to emulate or model the local time zone of the host system are not persistently stored in Chronos' external time-zones repository.

			The canonical key of the timezone whose proper name is Universal Time is #'Universal Time'.  However, a variety of aliases are supported: #Universal, #UT, #UTC, #GMT, #Z and #Zulu. 

			To retrieve the keys of all the time zones resident in Chronos' repository of pre-defined time zones, inspect the result of evaluating 'ChronosTimezone allRegisteredKeys' (if there are none, then the Chronos time-zones repository is missing.)

			To see the current time in all the time zones resident in Chronos' repository of pre-defined time zones, (showing the key, current offset, and current abbreviation for each time zone,) inspect the result of evaluating 'Timepoint nowInAllTimeZones' (if there are no entries, then the Chronos time-zones repository is missing.)

		## TIMEZONE LOOKUP/RETRIEVAL BY (CANONICAL CHRONOS) KEY

			To retrieve a ChronosTimezone with a given Chronos timezone key, evaluate 'ChronosTimezone at: <key>', where <key> is either the number of seconds of offset from UT (a Number) or is one of the Symbols contained in the Set returned as a result of evaluating 'ChronosTimezone allRegisteredKeys.'  In place of the Symbol, one may instead use the equivalent String value.  

			The class message ChronosTimezone class>>referencedBy: can be used to convert the value passed as its argument into a ChronosTimezone in cases where the value might be a) a String, b) a Symbol, c) a Number, d) a Duration instance or e) a ChronosTimezone instance {"ChronosTimezone referencedBy: 0". "ChronosTimezone referencedBy: 'Europe/London'"}.

			The Universal timezone can be accessed by sending either #universal or #ut as messages to ChronosTimezone {Timezone universal}.

			Examples:

				Timezone universal.								"Timezone for Universal Time. 'ChronosTimezone ut' can also be used."
				Timezone referencedBy: Duration zero.			"Equivalent to 'ChronosTimezone universal'--but not identical"
				Timezone at: -25200.								"-7 hours--never any DST."
				Timezone at: 19800.								"+5.5 hours--never any DST."
				Timezone at: 0.9d.								"+0.9 seconds--never any DST."
				Timezone at: 'America/Vancouver'.				"Pacific Time with DST rules as observed (past, present, future) in Western Canada"
				Timezone at: #'America/Tijuana'.					"Pacific Time with DST rules as observed (past, present, future) in North Western Mexico"
				Timezone at: 'America/Los_Angeles'.				"Pacific Time with DST rules as observed (past, present, future) in the Western US"
				Timezone at: #'America/Phoenix'.					"US Mountain Time in Arizona--No DST since 1969"
				Timezone at: 'America/Denver'.					"US Mountain Time"
				Timezone at: #'America/Chicago'.					"US Central Time"
				Timezone at: 'America/Indiana/Indianapolis'.		"US Eastern Time in most of Indiana--No DST since 1971"
				Timezone at: #'America/New_York'.				"US Eastern Time with DST rules as observed in much of the US East Coast"

		## VARIABLE-OFFSET TIMEZONE LOOKUP/RETRIEVAL BY ABBREVIATION OR OFFSET

			The familiar timezone abbreviations are not unique on a world-wide basis.  However, a ChronosLocale provides a TimeZoneLocalizationPolicy that maps timezone abbreviations and offsets to a Chronos timezone, as is appropriate to a particular locale (e.g., the TimeZoneLocalizationPolicy provided by <ChronosLocale at: 'en_US'> maps the timezone abbreviation 'EST' to 'America/New_York', whereas the TimeZoneLocalizationPolicy provided by <ChronosLocale at: 'en_AU'> maps 'EST' to a timezone in Eastern Australia.) 

			A TimeZoneLocalizationPolicy will generally map a timezone offset or abbreviation to a timezone whose standard time offset from UTC is probably correct, and whose DST offset is probably correct, but whose rules for transitioning to and/or from DST may be wrong (perhaps currently, perhaps in the past, perhaps in the future).  A pertinent example: the DST transition rules for 'America/New_York' and 'America/Detroit' have not always been the same, even though both have the abbreviation "EST" and have the same standard time and DST offsets.  When using a TimeZoneLocalizationPolicy to map an abbreviation or an offset to a well-defined timezone, one can (in fact, must) specify a boolean preference for either a timezone that does, or does not, observe daylight saving time (also known as "summer time" in many parts of the world):

			TimeZoneLocalizationPolicy unitedStates 
				defaultTimeZoneKeyForStandardTimeOffsetSecondsFromUT: (Duration hours: -5) asSeconds
				dstPreferred: false
				ifAbsent: [].

			(Timezone atAbbreviation: #AST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #AST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #EST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #EST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #EST inLocale: (ChronosLocale at: 'en_AU') dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #EST inLocale: (ChronosLocale at: 'en_AU') dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #CST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #MST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #MST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #PST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #PST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name
			(Timezone atAbbreviation: #AKST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name 
			(Timezone atAbbreviation: #HAST inLocale: ChronosLocale unitedStates dstPreferred: true ifAbsent: []) name
			(Timezone atAbbreviation: #HAST inLocale: ChronosLocale unitedStates dstPreferred: false ifAbsent: []) name

			See ChronosLocale and TimezoneLocalizationPolicy for more information.

		## LOCAL TIME: THE DEFAULT TIMEZONE & THE SYSTEM TIMEZONE

			Chronos supports two separate definitions of "local time." There is local time according to the host operating system, and local time as defined by clients of Chronos. Although it would normally be the case that a Chronos client would want to have the same local time as the operating system on which it runs, there are situations where that is not so.  For example, a stock-trading application might need to define it's local time to be 'America/New_York', even though the user's computer resides in 'Australia/Perth'.  Or perhaps an application hosted on a web server in 'Asia/Calcutta' wants to let each logged-in user define his or her own local time to be any timezone defined in Chronos' timezone repository. To support such use cases, Chronos defines a system timezone and a default timezone.

			In order for Chronos to permit its view of "local time" to differ from that of the host system, it is absolutely necessary for Chronos to nevertheless know which timezone the host system is using to define local time. The reason is simply because the system clock on some systems keeps and reports time relative to the system's local timezone; and when that is the case, it is necessary to know the system timezone in order to know the meaning of times reported by the system clock.  Also, should one's Smalltalk environment need to interoperate or collaborate with the host system, or with some foreign component or application hosted on the same system, it may be necessary to either provide dates and/or times encoded as local time as defined by the host system, or to accept and correctly interpret such values (believe it or not, using UT-relative time values as the standard for data interchange is far from a universal practice.) 

			The default timezone is the one that is used by default whenever no timezone is explicitly specified. It serves as the 'implementation-defined local time' as required by the ANSI-Smalltalk Standard.  The default timezone is the one that will be used when the ANSI-Standard message #asLocal is sent to a DateAndTime value, or when the current DateAndTime is retrieved by evaluating 'DateAndTime now'.

			The default timezone is accessible by sending the message #default to ChronosTimezone {ChronosTimezone default}. A ChronosTimezone will be set as the current default timezone when sent the message #beDefault {(ChronosTimezone at: 'America/New_York') beDefault}. Setting the default timezone has no affect at all on which timezone is the system timezone.

			The system timezone is intended to be as congruent as possible to whatever timezone the host operating system uses to define local time. The statement says "intended" because it may not be possible to discover which timezone the host system is using to define local time, and also because the actual binding between Chronos and the host system is the responsibility of whoever ports Chronos to a particular platform. The statement says "as congruent as possible" because it may not be possible for Chronos to provide a timezone implemented so that it behaves in all respects identically to the timezone implementation used by the host system:  The ChronosSystemFacade provides an API by which a Chronos client can choose the strategy that will be used to synchronize Chronos' system timezone with the timezone used by the base/host system.  [For more information on the different system-timezone-binding strategies see ChronosSystemFacade.  The default behavior is as follows: If and only if the TZ environment variable of the current user specifies a valid Olson timezone key, the Chronos system timezone is set to the Olson timezone with that key whenever the image is restarted after a snopshot.]

			The system timezone is accessible by sending the message #system to ChronosTimezone {ChronosTimezone system}.  A ChronosTimezone will be set as the current system timezone when sent the message #beSystem {(ChronosTimezone at: 'America/Chicago') beSystem}.  Setting the Chronos system timezone in this manner may or may not change which timezone the host system uses to define local time, and it may or may not change which timezone is the Chronos default timezone.  

			When no timezone has been explicitly set as the default, Chronos makes the system timezone serve as the virtual default timezone--which means that <Timezone default> will evaluate to <Timezone system>, and that changing which timezone is the system timezone automatically changes which timezone is the default.  This is the situation immediately after Chronos has been installed.  However, once any timezone (other than the current system timezone) has been explicity set as the default, changing the system timezone will not affect which timezone serves as Chronos' default timezone.  To resynchronize the default and system timezones, so that changing the system timezone also changes the default, set the system timezone to be the default: <Timezone system beDefault>.

			The effect on the host operating system of changing the Chronos system timezone is a function of the implementation of the ChronosSystemFacade [As currently implemented for VisualWorks, there is no effect on the host operating system when the Chronos system timezone is changed from within Chronos, although the native VW default TimeZone will be redefined.]  Chronos clients are encouraged to change the implementation of ChronosSystemFacade  so that it meets their specific needs (subclassing is the recommended approach.).

		## ACCESSING THE CURRENT DATE/TIME IN A SPECIFIC TIMEZONE

			There are a variety of messages that can be sent to any ChronosTimezone to retrieve the current date and/or time (such that the local time of the retrieved points-in-time will be as defined by the referenced timezone):

												Message Signature		
			Type-of-return-value		Gregorain Calendar					Specified Calendar		
			
			TimeOfDay				#timeOfDayNow						#timeOfDayNowAs:		
			TimeOfDay				#timeOfDayNowToTheSecond		#timeOfDayNowToTheSecondAs:		
			YearMonthDay			#dateToday							#dateTodayAs:			
			DateAndTime 			#today								#todayAs:							
			DateAndTime			#now								#nowAs:					
			DateAndTime			#nowToTheSecond					#nowToTheSecondAs:	
			
			Examples (with explanations of semantics):

				Expression												Semantics

				Timezone default timeOfDayNow.							"Current time-of-day in the default timezone"
				Timezone system timeOfDayNowToTheSecond. 			"Current time-of-day (to the second) in the system timezone"
				Timezone universal dateToday.							"Current date in the Universal timezone"
				(Timezone at: 'Asia/Calcutta') today.						"DateAndTime in India as of the initial moment of today's date"
				(Timezone at: 'Australia/Sydney') now.						"DateAndTime at this moment in Sydney, Australia"
				Timezone default nowAs: #Hebrew.						"(Local) DateAndTime at this moment according to the Hebrew Calendar"
				Timezone default nowToTheSecondAs: #Ethiopic.			"(Local) DateAndTime at this moment (to the second) according to the Ethiopic Calendar" 
					(The Ethiopic Calendar's time-of-day clock starts at 6am)

			Timepoint class and CalendarClock both provide a similar API for retrieving the current date and/or time.

		## INSTANTIATION OF DATE/TIME VALUES WHOSE LOCAL TIME IS DEFINED BY A SPECIFIC TIMEZONE

			The ANSI-Smalltalk standard defines a few DateAndTime creation messages where the final message argument is a Duration whose value specifies the timezone that will define local time for the DateAndTime instance created as a result of sending the message--these ANSI-required multi-keyword messages all have the keyword "offset:" as the final message keyword.  

			Chronos provides a variety of DateAndTime (and date and time-of-day) factory methods that accept a "timeZone:" argument, the value of which can be any of a) a ChronosTimezone instance, b) a Duration instance, or c) the key of any Chronos timezone (a Symbol, a String or a Number.)  

			Examples (see the class methods of Timepoint and its superclasses for the complete factory-method API):

				Timepoint 	utYear: 1969 month: 7 day: 20 hour: 10 minute: 17 second: 40 timeZone: #'America/Chicago'.
				Timepoint 	   year: 1969 month: 7 day: 20 hour:   5 minute: 17 second: 40 offset: (Duration hours: -5).  
				Timepoint 	   year: 1969 month: 7 day: 20 hour:   5 minute: 17 second: 40 timeZone: 'America/Chicago'.
				Timepoint 	   year: 1969 month: 7 day: 20 seconds: 19060 nanoseconds: 677411800 timeZone: (ChronosTimezone at: #'America/Chicago'). 
				Timepoint daysSinceEpoch:  718997.220601852d timeZone: (Duration seconds: -18000).
				Timepoint julianDay: 2440422.720601852d timeZone: -18000.

			Note that the first example specifies the time using the Universal Time date and time (the specified time is the official point-in-time when Apollo 11 landed on the Moon,) even though the Timepoint created uses US Central Time as its local time.
				
		## PROXY TIMEZONES {"always default", "always system" and "nominal time"}
	
			A "proxy" timezone is one that serves as an indirect reference to some other timezone.  Chronos defines three standard "proxy" timezones: <Timezone alwaysSystem>, <Timezone alwaysDefault> and <Timezone nominal>. Proxy timezones are useful for cases where it is desirable that the local time of a point-in-time value dynamically change to reflect whatever timezone is currently set as the local timezone.  

			The precise semantics of the three standard proxy timezones are defined as follows:

				<Timezone alwaysDefault>	
					Dynamically refers by proxy to whatever Timezone is currently set as <Timezone default>. A Timepoint with this timezone always represents the same time UT, but its local time is dynamically determined by whatever Timezone is set as the current default timezone--in other words, its UT time is invariant, but its local time varies dynamically as a function of any change to whichever timezone == Timezone default. The key of the "always default" time zone is #alwaysDefault.

				<Timezone alwaysSystem>	
					Dynamically refers by proxy to whatever Timezone is currently set as <Timezone system>. A Timepoint with this timezone always represents the same time UT, but its local time is dynamically determined by whatever Timezone is set as the current system timezone--in other words, its UT time is invariant, but its local time varies dynamically as a function of any change to whichever timezone == Timezone system. The key of the "always system" time zone is #alwaysSystem.

				<Timezone nominal>		
					Refers to no timezone at all (or to any timezone)--used as the "timezone" of Timepoints that will/should be invariant to nominal time.  A point-in-time that is invariant to nominal time represents the same LOCAL time in any and all timezones, and so compares as equal to any other point-in-time whose local (or nominal) time matches the time it nominally designates. Timepoints with any other timezone are invariant to UT, which means that their value relative to other UT-invariant Timepoints is determined by the UT point-in-time they represent, and not by their local time (UT-invariance is the semantics required of points-in-time that conform to the ANSI-Smalltalk <DateAndTime> protocol.) However, for compatibility with UT-invariant Timepoints, Timepoints whose timezone is <Timezone nominal> also behave to some extent as though their timezone were <Timezone default>. So, nominal-time invariant Timepoints always represent THE SAME LOCAL TIME in any and all time zones--in other words, their LOCAL TIME ("nominal time") is INVARIANT, but the UT time they represent varies as a function of the value of 'Timezone default.'    The key of the `nominal time` time zone is #nominal.

		## RETRIEVING TIMEZONE OFFSETS FROM UT (UNIVERSAL TIME) (and also other related information) 

			[Definition: A timezone's offset from UT is the value that is added to the UT point-in-time in order to derive the local point-in-time in that timezone, and is also the value that is subtracted from the local point-in-time in order to derive the UT point-in-time. It is also common to refer to a time zone offset as a number of "hours east," "minutes east" or "seconds east" of UT, and to refer to its additive inverse as a number of "hours west," "minutes west" or "seconds west" of UT. POSIX time-zone rule literals are specified using "hours:minutes:seconds" **west** (not east) of UT--so the POSIX rule literal "EST5" means 'timezone whose standard-time abbreviation is EST and whose standard-time offset (west from/behind) UT is 5 hours (which corresponds to an offset that is -5 hours east (or ahead) of UT.)']

			The API for retrieving the offset of a ChronosTimezone varies depending on whether the ChronosTimezone instance is "bound" or "unbound" (the same is true of a timezone's abbreviation, but not of its key or name.) A "bound" Chronos time zone is one whose single, specific offset-abbreviation tuple is or can be "bound to" (properly associated with) a specific point-in-time.  An "unbound" Chronos time zone is one that does NOT specify a single, specific offset and abbreviation that can be "bound to" (properly associated with) a specific point-in-time. 

			Chronos time zones are also classified as either "static" or "dynamic." A "static" Chronos time zone is one whose offset-abbreviation tuple is not subject to retroactive changes--for a static time zone, the binding of a point-in-time value to the offset-abbreviation tuple of its time zone is permanent for all time. A "dynamic" Chronos time zone is one whose offset-abbreviation tuple (or tuples) is subject to retroactive changes--for a dynamic time zone, the binding of a point-in-time value to the offset-abbreviation tuple currently specified by its time zone is not necessarily permanent. 

		 	The following table presents the ontology of Chronos time zone types, and the names of the core classes that provide concrete implementations of each of the 3 types:

											Static					Dynamic

						Bound				UniversalTime			StandardTime
											BasicTimezone			NonStandardTime
								

						Unbound			<non-sensical>			VariableOffsetTimezone

			When sent the message #isBound, a "bound" ChronosTimezone will answer true, and an "unbound" ChronosTimezone will answer false. When sent the message #isStatic, a static Chronos time zone will answer true, and a dynamic Chronos time zone will answer false.

			BasicTimezone instances are "bound, static" timezones, because they have exactly one offset and one abbreviation for all time, from the infinite past to the infinite future--and the binding to the offset/abbreviation tuple is not subject to future revision, it's "static" or "constant." Instances of VariableOffsetTimezone are  "unbound, dynamic" time zones, because their offset and abbreviation can vary over time (even if their present offset and/or abbreviation have always been the same from the infinite past, either or both the offset and the abbreviation are still subject to change in the future--and even the past/current offsets and abbreviations are subject to being changed dynamically.) 

			++ BOUND TIMEZONE API ++
	
				Message							Semantics

				#offsetFromUT						Answers a Duration representing the timezone's offset. 
				#offsetSecondsFromUT				Answers the integer number of seconds of the timezone's 
														offset (ignores any subsecond fraction.)
				#stdTimeOffsetFromUT				Answers a Duration representing the timezone's offset from 
														UT for "standard time" (when DST is not in effect.) 
				#stdTimeOffsetSecondsFromUT		Answers the integer number of seconds of the timezone's 
														offset from UT for "standard time" (when DST is not in effect; 
														ignores any subsecond fraction.)
				#offsetDelta							Answers a Duration representing the difference between the 
														timezone's effective offset and its "standard time" offset.
				#offsetDeltaSeconds					Answers the integer number of seconds of the difference 
														between the timezone's effective offset and its "standard time" 
														offset (ignores any subsecond fraction.)
				#commonAbbreviation				Answers the timezone's commonly-used abbreviation.

				Note: Bound timezones also respond correctly to the API for unbound timezones; the reverse is NOT true.

			++ UNBOUND TIMEZONE  API ++ 

				In order to retrieve the offset and/or abbreviation that is correct for the location of an unbound ChronosTimezone (i.e., an instance of VariableOffsetTimezone) at a particular point-in-time one must use the unbound ChronosTimezone API to resolve a "bound" ChronosTimezone with the correct offset and abbreviation, and retrieve the offset and/or abbreviation from the "bound" timezone so obtained.

				The search parameters needed to resolve a bound timezone are the year, day-of-year and seconds-since-start-of-day. They can be specified either as UT values or as local time ("wall clock") values.  The message signatures for resolving a bound timezone are as follows:

					#bindingForLocalYear:dayOfYear:secondsSinceStartOfDayFunction:		"Uses local-time search parameters"
					#bindingForUTYear:dayOfYear:secondsSinceStartOfDayFunction:		"Uses Universal Time search parameters"

				The final parameter value (following "secondsSinceStartOfDayFunction:") is a one-argument block.  If the seconds-since-start-of-day value is needed to find the bound timezone, this block will be invoked (as a 'call-back') with an argument whose value is the offset from UT in seconds for a particular bound timezone (representing a particular set of zone properties in effect during a particular period of time.)  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary (the answered seconds-since-start-of-day should be in Universal Time if the message #bindingForUTYear:dayOfYear:secondsSinceStartOfDayFunction: was sent, but in local ("wall clock") time if the message #bindingForLocalYear:dayOfYear:secondsSinceStartOfDayFunction: was sent.)  The reason for the callback block is that, during some years, a timezone may have more than one 'standard time' offset from UT, and because the offset transition rules for the same timezone for the same year can be specified as UT values for the first transition, local "wall clock" time for the second transition, but as local standard time for the third transition (yes, all that stuff actually happens--timezones are NOT simple!!)

				See VariableOffsetTimezone for more detailed information.

				Examples: 

					((Timezone at: 'America/Los_Angeles')
						bindingForLocalYear: 1968
						dayOfYear: 119 "Sunday, April 28"
						secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | 7199 "1:59:59 am local time"]) offsetFromUT

					((Timezone at: 'America/Los_Angeles')
						bindingForLocalYear: 1968
						dayOfYear: 119 "Sunday, April 28"
						secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | 7200 "2:00:00 am local time"]) offsetFromUT

					((Timezone at: 'Europe/London')
						bindingForLocalYear: 2005
						dayOfYear: 86 "Sunday, March 27"
						secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | 3599 "12:59:59 am local time"]) offsetFromUT

					((Timezone at: 'Europe/London')
						bindingForLocalYear: 2005
						dayOfYear: 86 "Sunday, March 27"
						secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | 3600 "1:00:00 am local time"]) offsetFromUT

					And finally, to contrast and compare Chronos with the functionality and performance of the VW Timestamp and TimeZone--which, to be fair, were introduced long before most languages supported any equivalent functionality (although the Standard C Library provided both more and less functionality):
					
					[| now |
					now := Timepoint nominalNow.
					1000000 timesRepeat:
						[(Timezone system
							bindingForLocalYear: now year
							dayOfYear: now dayOfYear
							secondsSinceStartOfDayFunction: [:offsetSecondsFromUT | now secondsSinceStartOfDay]) 
										offsetSecondsFromUT + now secondsSinceEpoch]] durationToRun.

					[| now | "Will only run in VisualWorks"
					now := Timestamp now.
					1000000 timesRepeat:
						[TimeZone default convertLocalSecondsToGMT: now asSeconds]] durationToRun.
						"Design/implementation from the late 1980's--which, although ancient, is not old enough to have made it into the Squeak branch of ST80."

					[| now |
					now := Timepoint now.
					1000000 timesRepeat:
						[now utSecondsSinceEpoch]] durationToRun.

	Implementation:

		Instance Variables

			name				<StringOrSymbol | nil> 	The name of the timezone represented by instance--value may be nil.

		Class Variables

			AlwaysDefault	<AlwaysDefaultTZ> 		Canonical instance of AlwaysDefaultTZ (which see.)
			AlwaysSystem	<AlwaysSystemTZ> 	Canonical instance of AlwaysSystemTZ (which see.)
			BindingRegistry	<IdentityDictionary> 	Cache of instances of either StandardTime or NonStandardTime that are created when instances of VariableOffsetTimezone are deserialized by means of TimeZonePolicySpecs.  The cache is used to ensure that instances of VariableOffsetTimezone that are being deserialized from the time zone repository use only a single instance of StandardTime (or NonStandardTime) with the same offset and abbreviation (this is done solely to minimize memory usage--it is not an invariant required for correct operation.) The cache is cleared once the deserialization process is complete.
			Default			<ChronosTimezone | nil>	
				Specifies the current default timezone that establishes what Chronos considers to be local time--if nil, then the default timezone (that establishes local time in the context of Chronos) is the current system timezone.
			Nominal			<NominalTime> 			Canonical instance of NominalTime (which see.)
			OffsetRegistry	<WeakDictionary; offsetSecondsFromUT->(Duration seconds: offsetSecondsFromUT)>			
				Cache of Durations that serve as offsets-from-UT--the purpose is to ensure that instances of VariableOffsetTimezone that are being deserialized from the time zone repository use only a single Duration instance throughout their object graphs for a given number of offset-seconds-from-UT (this is done solely to minimize memory usage--it is not an invariant required for correct operation.) The cache is cleared once the deserialization process is complete.
			System			<ChronosTimezone>		
				Specifies the current system timezone--intended to correspond to whatever timezone defines/establishes local time in the context of the host system. Should always be the same object as the value of the <systemTimeZone> instance variable of 'ChronosSystemFacade current.'
			Universal			<UniversalTime> 	Canonical instance of UniversalTime (which see.)

	Subclassing:

		Concrete subclasses must subimplement the following instance methods:

			#defaultOffsetPolicy
			#isBound
			#key
			#processBy:


!

CalendarDuration subclass: #CivilDuration
	instanceVariableNames: 'hours minutes seconds nanosecondsSinceSecond'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!CivilDuration commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CivilDuration

	Concept:

		A CivilDuration is a "temporal extent" or "duration of time" specified in terms of both calendrical periods--years, months and days--and also in terms of hours, minutes and seconds (including fractions of a second.) A CivilDuration differs both in its semantics and interface from an ANSI-Smalltalk Duration in important ways. Semantically, a CivilDuration represents "civil," "legal," business" or "calendrical" time, as opposed to "scientific," "metric system" or "atomic" time (which is implemented by ScientificDuration.)  

		Also see CivilDuration's superclass CalendarDuration, which provides the implementation of the "years, months, days" portion of a CivilDuration's behavior.

		Conceptually and mathematically, a CivilDuration represents a duration vector with seven elements: years, months, days, hours, minutes, seconds and nanoseconds. The number of years, months and days are each independent of each other, and (unlike seconds and nanoseconds, for example) cannot be deterministically/universally translated from one to the other.  In contrast, nanoseconds and seconds are interconvertible by a factor of 1,000,000,000, seconds and minutes are interconvertible by a factor of 60, minutes and hours are interconvertible by a factor of 60, and hours and days are interconvertible by a factor of 24.  Although CivilDuration itself converts between seconds and minutes, seconds and hours and seconds and days using invariant conversion factors, other Chronos objects may use either different conversion factors, and/or may convert seconds into minutes, hours and days using occasional 'leap seconds' (and in the future, perhaps also leap minutes or leap hours.)

		CivilDuration semantics defines the duration of days, hours, minutes and seconds based on their civil, legal or business semantics, by which 'one day' means whatever number of seconds are required to go from a particular civil time-of-day on day 0 to the same civil time-of-day on day 1, 'one hour' is the temporal extent between T23:00:00 and T24:00:00 (regardless of any leap seconds or leap minutes,) 'one minute' is the temporal extent between T23:59:00 and T24:00:00 (regardless of any leap seconds,) and 'one second' is the temporal extent between T23:59:59 and T24:00:00 (also regardless of any leap seconds.)  Due to such things as leap seconds such "civil" or "calendar" time extents may have more or less than the regular number of SI (metric system) seconds (as measured by an atomic clock.) There may be more or less than 24 metric system ("scientific") hours in a day, due to Daylight Saving Time transitions (Daylight Saving Time is known as "Summer Time" in most places outside North America,)

		For more in depth conceptual discussion, see the class comments of CalendarDuration and Durational (the superclasses.)

	Usage:

		Instances of CivilDuration can be used as arithmetic operands with each other, and with instances of TemporalCoordinate (whose concrete subclasses include Timepoint, YearMonthDay and TimeOfDay--all of which see.) TemporalCoordinates can compute the temporal extent between any two instances, providing the result as a Durational instance. A Timeperiod specifies the temporal extent of the temporal inteveral it represents using a Durational instance. 

	Implementation:

		Conceptually, a CivilDuration represents a temporal extent as a vector whose elements represent a number of 1) years, 2) months, 3) days, 4) hours, 5) minutes and 6) seconds (including fractions of a second.) Physically, it uses a different instance variable for each element of the vector--except for the "seconds" element, where it uses two instance variables--one for the integer number of seconds, and one for the integer number of nanoseconds. Two instance variables are used for this purpose: 'seconds' and 'nanosecondsSinceSecond.' 

		Although the number of seconds/nanoseconds specified collectively by the instance variables 'seconds' and 'nanosecondsSinceSecond' are independent of the number of years, months, days, hours and minutes represented by an instance, when an instance is in canonical form, the absolute value of the "nanoseconds" element in its duration vector must not be greater than or equal to 1,000,000,000, and the "seconds" element of its duration vector must not be greater than or equal to the number of seconds in a mean solar minute (i.e., must be less than 60.) Similarly, the number of minutes must be less than 60 and the number of hours must be less than 24. Therefore, when an instance canonicalizes itself, if any such vector element has a value greater than is canonical (or less,) the overflow (or underflow) is propagated upward, which may result in adding to or subtracting from the number of days (or hours, or minutes, etc.)

		Instance Variables

			hours 		<Integer>
				The number of hours in the duration vector that represents the instance's temporal extent. When the instance is in canonical form, the value of <hours> must be positive or zero if the value of <days> is positive, and must be negative or zero if the value of <days> is negative--and the absolute value of <hours> must be less than the number of hours in a day (HoursPerDay = 24)
			minutes		<Integer> 
				The number of minutes in the duration vector that represents the instance's temporal extent. When the instance is in canonical form, the value of <minutes> must be positive or zero if the value of <hours> is positive, and must be negative or zero if the value of <hours> is negative--and the absolute value of <minutes> must be less than the number of minutes in an hour (MinutesPerHour = 60)
			seconds 					<Integer>
				The integer part of the "seconds" element of the instance's duration vector. When the instance is in canonical form, the value of <seconds> must be positive or zero if the value of <minutes> is positive, and must be negative or zero if the value of <minutes> is negative--and the absolute value of <seconds> must be less than the number of seconds in a minute (SecondsPerMinute = 60)
			nanosecondsSinceSecond	<Integer>
				Represents, as an integer number of nanoseconds, the fractional part of the "seconds" element of the instance's duration vector. When the instance is in canonical form, the value of <nanosecondsSinceSecond> must be positive or zero if the value of <seconds> is positive, and must be negative or zero if the value of <seconds> is negative--and the absolute value of <nanosecondsSinceSecond> must be less than the number of nanoseconds in a second (NanosecondsPerSecond = 1,000,000,000.)

		!

Durational subclass: #ComparableDuration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

AnnualDate subclass: #ComputedAnnualDate
	instanceVariableNames: 'daysOffset'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

ComputedAnnualDate class
	instanceVariableNames: 'canonical'!

!ComputedAnnualDate commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

ComputedAnnualDate class
	instanceVariableNames: 'canonical'!

MonthsPerYearInvariantCalendar subclass: #CopticCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!CopticCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

CopticCalendar

	Concept:

		CopticCalendar implements the Coptic Calendar.  The Copts are a Christian culture ethnically descended from the Pharonic Egyptians.  Their calendar is derived from the ancient Egyptian solar calendar, but unlike that calendar, uses leap years to more accurately reflect the length of the solar year.
		
		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Coptic Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Coptic Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Coptic Calendar, 0001-01-01 [Coptic], corresponds to 0284-08-29 [Gregorian and Julian].  Coptic days begin at sunset. The Julian Date of the Coptic epoch is 1,825,029.25 (6 pm,) so the actual initial moment of the Coptic epoch corresponds to 0284-08-28T18:00:00 [Gregorian and Julian]. 

			The Coptic epoch date is the first day of the year in the ancient Egyptian Calendar in which Diocletian ascended to the office of Emperor of Rome. This year marks the beginning of what is generally known as the Diocletian Era, although Copts call it the Era of Martyrs in memory of the many Christians tortured to death by Emperor Diocletian. This year was widely used as the epoch year in Europe (along with the leap year rule and month structure of the Imperial Julian Calendar) until around the Ninth Century, when almost all Christians began to use the modern "Anno Domini" era--with the obvious exception of the Copts.

			The Coptic era is called "Anno Martyrum" (AM)--which is Latin for "In the Year of the Martyrs."

		Time-of-Day Clock

			Although Coptic days begin at sunset, Copts label the hours of the day beginning at midnight.  So the zero-point of the the time-of-day clock is midnight, although the initial moment of the day is 6 pm. 

			{CopticCalendar clock today}
			{CopticCalendar clock now}

		Year Numbering Policy

			The Coptic Calendar uses "zeroless ordinal" year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year -1.

		Leap Year Rule

			A year is a leap year if dividing the year ordinal by 4 leaves a remainder of 3.

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Thoout					30/30
			2: Paope					30/30
			3: Athor						30/30
			4: Koiak					30/30
			5: Tobe						30/30
			6: Meshir					30/30
			7: Paremotep				30/30
			8: Parmoute					30/30
			9: Pashons					30/30
			10: Paone					30/30
			11: Epep					30/30
			12: Mesore					30/30
			13: Epagomene				5/6

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)



!

MonthOfYear subclass: #DayOfMonth
	instanceVariableNames: 'dayOfMonthOrdinal'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!DayOfMonth commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

CalendricalAnnualDate subclass: #DayOfYear
	instanceVariableNames: 'dayOfYearOrdinal'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!DayOfYear commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

ChronosPrintable subclass: #Durational
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!Durational commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

Durational

	Concept:

		Durational is an abstract class. An instance of a concrete subclass of Durational represents a duration of time. A duration of time differs from a "date" or "point-in-time" value in the same way that a "distance" value differs from a "position" value. A "position" value specifies an absolute location by specifying the distance between the location and some absolute reference point (.e.g, "93 million miles from the Sun.")  Similarly, a "point-in-time" value specifies an absolute point in time by specifying the duration since (or until) a particular point-in-time and some absolute reference time (e.g., "5765 years since the creation of the world.") A durational value specifies/designates a temporal extent ("how long,") without specifying when the temporal extent begins or ends.

		Chronos implemements two different types of durational ("temporal extent") values: "scientific" durations and "calendar" durations. Scientific durations are implemented by the concrete subclass ScientificDuration. Calendar durations are implemented by the concrete subclasses CalendarDuration and CivilDuration. The semantics of a ScientificDuration and of a CalendarDuration/CivilDuration differ as follows: A ScientificDuration conceptually represents a scalar value--a number of seconds (optionally including fractions of a second.) A CalendarDuration or CivilDuration conceptually represents a vector, where the elements of the vector represent years, months, days, hours, minutes and seconds (optionally including fractions of a second.) The days specified by a CalendarDuration or CivilDuration represent a number of calendar days, based on the civil (business) definition of a day.  The days of a ScientificDuration always represent 86400 seconds uniformly and invariantly. The days of a CalendarDuration or CivilDuration may have more or less than 86400 seconds, due to timezone offset changes and/or leap seconds.

		See ScientificDuration, CalendarDuration and CivilDuration for more information.

	Usage:

		Instances of Durational can be used as arithmetic operands with each other, and with instances of TemporalCoordinate (whose concrete subclasses include Timepoint, YearMonthDay and TimeOfDay--all of which see.) TemporalCoordinates can compute the temporal extent between any two instances, providing the result as a Durational instance. A Timeperiod specifies the temporal extent of the temporal inteveral it represents using a Durational instance. A ChronosTimezone uses a ScientificDuration to represent its offset from UTC.

		Key methods of Durational, CalendarDuration, CivilDuration and ScientificDuration have "do its" in their comments that provide usage examples.

		Many of the methods of Durational and ScientificDuration implement message signatures as specified and required by the ANSI-Smalltalk Standard.  As is true throughout the Chronos codebase, many of the others are implemented by analogy to those required by ANSI Smalltalk (i.e., in the same style and/or spirit--both in terms of naming conventions and semantics.)

		As is the case with most Chronos classes, Durational instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		Note that the instance creation messages (class messages) #days: and #seconds: (and many of the variations thereof) will correctly handle either integer or non-integer numeric arguments.

	Motivation:

		Firstly, the ANSI-Smalltalk Standard requires that durational values be supported as a type distinct from that of point-in-time values.

		Secondly, although in some contexts/situations it is both necessary and proper to represent a duration of time using a "raw" numeric value, it is usually superior to encapsulate a durational value in an object that knows the semantics and behavior of the represented temporal extent.  This avoids the possibility that raw numeric values will be misinterpreted as a number of seconds when they actually represent a number of days, hours or tenths of a microsecond.  Even better, it enables such values to collaborate with other objects with greater semantic precision, and in ways that can be made much more specific to the functional intent of the value.  It is much easier to define and understand the meaning of adding a durational value to a point-in-time value, than it would be to define or understand the meaning of adding a raw number (a number of what?).

		Thirdly, although point-in-time values represent a count of some number of years, months, days, hours, minutes and seconds (possibly including fractions of a second,) they are unsuitable for use as durational values for the following reasons:

			1. Although one can interpret point-in-time values as though they also represented a temporal extent defined by the duration of time form the epoch of their calendar up to the point-in-time they designate, doing so causes such values to have two distinct (and sometimes irreconcilable) meanings. For example, if points-in-time and durations are all considered one and the same semantically, then what is the meaning of subtracting one such value from another?  Should the result of subtracting <a> from <b> be the duration of time between the points-in-time <a> and <b>, or the point-in-time that results from subtracting the durational value of <b> from the point-in-time value of <a>?  The two cases are not at all equivalent, thanks to the non-uniform and context-dependent way that the rules of most calendrical systems count seconds into days, days into months, and days/months into years.

			2. Does a point-in-time value represent the number of seconds since its epoch, or the number of years, months, days and seconds?  In other words, is it a "scientific" duration, or a "calendar" duration? If one adds the number of seconds since the calendar epoch represented by the point-in-time <alpha> to the point-in-time <beta>, it is unlikely that the number of years, months, days and seconds by which the result <gamma> will differ from <beta> will be the same as the number of years, months, days and seconds since the epoch represented by <alpha>. Conversely, if one adds the number of years, months, days and seconds represented by the point-in-time <alpha> to the point-in-time <beta>, it is unlikely that the number of seconds by which the result <gamma> will differ from <beta> will be the same as the number of seconds since the epoch represented by <alpha>. Such contradictions and semantic undecidability are inherent to interpreting point-in-time values as simultaneously moments in time and also durations of time (temporal extents.)

			3. Points-in-time are bound to a particular calendar, and so cannot represent temporal extents independently of any particular calendrical system.

			4. Because calendrical/civil time/business semantics are not appropriate for all durational values, there must be at least one type of duration that does not count minutes, hours or days separately/independently of seconds, nor count years/months at all. But point-in-time values must do every one of those things.

		Durational defines and implements, to the extent possible, the behavior and state that is common to both ScientificDurations, CalendarDurations and CivilDurations.

	Implementation:

		Instance Variables

			NONE

	Subclassing:

		Concrete subclasses must subimplement the following instance methods:

			#addedToCalendricalCoordinate:
			#addedToDuration:
			#asCalendarSeconds
			#calendarDays
			#calendarDaysAreZero
			#calendarPeriodsAreZero
			#days
			#isZero
			#resolutionQuantum
			#setDays:
			#subsecondsAreZero
			#subtractedFromCalendricalCoordinate:
			#subtractedFromDuration:

		Concrete subclasses must subimplment the following class methods:

			#zero

!

CalendarDay subclass: #DynamicCalendarDay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!DynamicCalendarDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

DynamicCalendarDay

	Concept:

		A DynamicCalendarDay is a CalendarDay (which see) that is specialized for collaboration with a DynamicMonthlyCalendar (also which see.)

	Usage:

		As is the case with most Chronos classes, DynamicCalendarDay instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Motivation:

		DynamicCalendarDay, in collaboration with DynamicMonthlyCalendar and DynamicYearlyCalendar, avoids the utilization of too much memory in the case of calendrical systems that have too many different year types to reasonably use the flyweight pattern for representing the month structure of each type of year.

	Implementation:
!

MonthlyCalendar subclass: #DynamicMonthlyCalendar
	instanceVariableNames: 'daysPerMonth'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!DynamicMonthlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

DynamicMonthlyCalendar

	Concept:

		A DynamicMonthlyCalendar is a MonthlyCalendar (which see) that generates a new instance of DynamicCalendarDay every time one is needed.  DynamicMonthlyCalendar must be used in collaboration with DynamicYearlyCalendar and DynamicCalendarDay.

	Usage:

		As is the case with most Chronos classes, DynamicMonthlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Motivation:

		DynamicMonthlyCalendar, in collaboration with DynamicCalendarDay and DynamicYearlyCalendar, avoids the utilization of too much memory in the case of calendrical systems that have too many different year types to reasonably use the flyweight pattern for representing the month structure of each type of year.

	Implementation:

		Instance Variables

			daysPerMonth	<Integer> The number of days in the month represented by the instance.
!

YearlyCalendar subclass: #DynamicYearlyCalendar
	instanceVariableNames: 'monthSpecs daysUpToMonthSinceStartOfYear'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!DynamicYearlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

DynamicYearlyCalendar

	Concept:

		A DynamicYearlyCalendar is a YearlyCalendar (which see) that generates a new DynamicMontlyCalendar instance or a new DynamicCalendarDay instance every time it needs one or the other.

	Usage:

		As is the case with most Chronos classes, DynamicYearlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Motivation:

		DynamicYearlyCalendar, in collaboration with DynamicCalendarDay and DynamicMonthlyCalendar, avoids the utilization of too much memory in the case of calendrical systems that have too many different year types to reasonably use the flyweight pattern for representing the month structure of each type of year.

	Implementation:

		Instance Variables

			monthSpecs 						<Array of MonthlyCalendarSpec>
				The MonthlyCalendarSpec at the <M>th index in the array specifies the properties of the <M>th month of the year represented by the instance.
			daysUpToMonthSinceStartOfYear 	<Array of Integer>
				The integer value at the <M>th index in the array specifies the number of days from the first day of the year up to (but not including) the first day of the <M>th month of the year represented by the instance.
!

CopticCalendar subclass: #EthiopicCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!EthiopicCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

EthiopicCalendar

	Concept:

		EthiopicCalendar implements the Ethiopic Calendar.  The Ethiopic Calendar  is the principal calendar used in Ethiopia. The Ethiopic Calendar is derived from the ancient Egyptian solar calendar, but unlike that calendar, uses leap years to more accurately reflect the length of the solar year. It has the same leap year rule, month structure and New Year's Day as the Coptic Calendar, but has a different epoch year. Culturally, the usage of the Ethiopian Calendar in Ethiopia is strongly motivated by Ethiopia's main religions, the Coptic Church and the Ethiopian Orthodox Tewahido Church.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Ethiopic Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Ethiopic Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Ethiopic Calendar, 0001-01-01 [Ethiopic], corresponds to 0008-08-27 [Gregorian] and to 0008-08-29 [Julian].  Ethiopic days begin at sunrise. The Julian Date of the Ethiopic epoch is 1,724,220.75 (6 am,) so the actual initial moment of the Ethiopic epoch corresponds to 0008-08-27T06:00:00 [Gregorian] and to 0008-08-29T06:00:00 [Julian]. 
	
			The Ethiopic epoch date is the first day of the year in the ancient Egyptian Calendar after which Christ was born by the reckoning of the Ethiopian Orthodox Christian Church.

			Years on or after the epoch of the Ethiopic Calendar are said to be in the era "Zemene Haddis" (ZH)--which is Ethiopian for "Incarnation Era"  Alternatively, this era is also called "Amete Mihret" (AM)--which is Ethiopian for "years of mercy".  Chronos does not use "AM" in connection with the Ethiopic Calendar in order to avoid confusion with both "Anno Mundi" and "Anno Martyrum."  Years before the epoch are said to be in the era "Zemene Bluy" (ZB)--which is the Ethiopian equivalent of "Before Christ."

		Time-of-Day Clock

			Sunrise (6 am) is both the zero-point of the time-of-day clock and also the initial moment of the day. 

			{EthiopicCalendar clock today asGregorian}
			{EthiopicCalendar clock now}

		Year Numbering Policy

			The Ethiopic Calendar uses "zeroless ordinal" year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year -1.

		Leap Year Rule

			A year is a leap year if dividing the year ordinal by 4 leaves a remainder of 3.

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Maskaram				30/30
			2: Teqemt					30/30
			3: Khedar					30/30
			4: Takhsas					30/30
			5: Ter						30/30
			6: Yakatit					30/30
			7: Magabit					30/30
			8: Miyazya					30/30
			9: Genbot					30/30
			10: Sane					30/30
			11: Hamle					30/30
			12: Nahase					30/30
			13: Paguemen				5/6

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)


!

ChronosObject subclass: #GeographicCoordinateSpec
	instanceVariableNames: 'degreesOfLattitude degreesOfLongitude'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

RomanicCalendar subclass: #GregorianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!GregorianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

GregorianCalendar

	Concept:

		GregorianCalendar implements the Gregorian Calendar. The Gregorian Calendar is the official, civil calendar of most (but not all) nations of the world.  It uses the same month structure and epoch year as the Julian Calendar, but uses a leap year rule that (compared to the Julian Calendar) more accurately keeps the mean length of the Gregorian calendar year the same as the mean length of the solar year. 

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Gregorian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Gregorian Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		The Gregorian Calendar became the official, civil calendar of most of the Catholic countries of Europe (replacing the Julian Calendar) by the decree of Pope Gregory on October 15, 1582 AD [Gregorian], which corresponds to October 5, 1582 AD [Julian]. The British Empire switched from the Julian Calendar to the Gregorian Calendar on 14 September 1752 AD [Gregorian], which corresponds to 3 September 1752 AD [Julian]. Other European countries switched at other times. Some European countries did not switch from the Julian to the Gregorian Calendar until the early 20th Century.

		Epoch Date

			The epoch date of the Gregorian Calendar is, of course, 1 January 1 AD [Gregorian], which corresponds to 3 January 1 AD [Julian]. The Gregorian epoch date was set two days after the Julian (Dionysian) epoch date solely so that the date of the Vernal Equinox in the Gregorian Calendar (going forward from 1582) would be on or about 21 March, the same date on or about which the Vernal Equinox would have occurred when the official Church formula for computing the date of Easter was formally adopted at the Council of Nicaea in 325 AD.  [Note: Fixing the date of Easter was the sole motivation behind the Catholic Church's decision to adopt the Gregorian Calendar].

			 The Julian Date of the epoch of the Gregorian Calendar is 1,721,425.50 (midnight.) 

			Year 1 of the Gregorian Calendar is the first year of the Anno Domini era ("Anno Domini" is Latin for "In the year of the Lord.") Years prior to the year 1 Anno Domini are referred to as being in the era "Before Christ" (BC)--which is in English instead of Latin simply because the era was so named (originally) by the Venerable Bede, in his 'Ecclesiastical History of the English Nation,' which was published (in Old English) in the Eighth Century AD. 

			For information about a) the epoch year shared by both the Gregorian and Julian Calendars, and b) the Anno Domini Era (which begins in that year,) see the class comment of JulianCalendar.

		Time-of-Day Clock

			Modernly, midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  However, such has not always been the case for all users of the Gregorian Calendar.

			{GregorianCalendar clock today}
			{GregorianCalendar clock now}

		Year Numbering Policy

			The Gregian Calendar uses ordinal year numbering (as required by the ANSI Smalltalk standard.)  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			A year is a leap year if its ordinal is evenly divisible by 400, or else if its ordinal is evenly divisible by 4 but not by 100.  Consequently, the year 2000 is a leap year (evenly divisible by 400,) the year 1900 is not a leap year (evenly divisible by 100, but not by 400,) the year 2008 is a leap year (evenly divisible by 4, but not by 100,) and the year 2010 is not a leap year (divisible neither by 4 nor by 400.)

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: January					31/31
			2: February					28/29
			3: March					31/31
			4: April						30/30
			5: May						31/31
			6: June						30/30
			7: July						31/31
			8: August					31/31
			9: September				30/30
			10: October					31/31
			11: November				30/30
			12: December				31/31

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name.

	Usage:

		In the case of class APIs where some messages provide for specifying a Calendar, but other variations of semantically "the same" message omit any "calendar:" parameter, the Gregorian Calendar is the implied (default) Calendar that will be used.  The reaons for this behavior are that 1) the Gregorian Calendar is the de facto international standard calendar--many people never use any other calendar, and are at best only vaguely aware that other calendars even exist, and 2) in some cases, the message-variants that omit the "calendar:" parameter are required by the ANSI-Smalltalk standard to function as though the Gregorian Calendar were the implied parameter (e.g., the DateAndTimeFactory protocol defined by the ANSI-Smalltalk standard.)

		The Chronos namespace (shared pool) defines the global variable Gregorian, which aliases the canonical instance of GregorianCalendar.  "GregorianCalendar canonical" and "Gregorian" should be the same object.
!

ComputedAnnualDate subclass: #GregorianEaster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!GregorianEaster commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

RegularCalendar subclass: #HebrewCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!HebrewCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

HebrewCalendar

	Concept:

		HebrewCalendar implements the Hebrew Calendar, which was and is the calendar of the Jewish people, and of the Jewish religion.  The Hebrew Calendar is, by far, the most complex arithmetical calendar ever devised.  Modernly, it is used more for religious than secular purposes, although it is one of the two official, civil calendars of the State of Israel--the other, of course, is the Gregorian Calendar. The Hebrew Calendar was given its current form (as an arithmetical, rule-based calendrical system) in the mid Fourth Century AD.  Originally, it was an observational calendar.  Consequently, using the current Hebrew Calendar (as herein implemented) for dates before the year 4120 [Hebrew] (the mid-Fourth Century AD) would be anachronistic (although it's useful as an approximation/estimate.)

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Hebrew Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The modern Hebrew Calendar is an arithmetical, luni-solar calendar. A luni-solar calendar is one that, although it attempts to match the (average) length of its years to that of mean solar years over some sufficiently long period of time, also attempts to align the day on which one month transitions to the next with the moment that the moon transitions from one phase to the next, so that each month begins within a day or so of the moment that the moon exits from or enters into a particular phase. In the case of arithmetical luni-solar calendars, the result is usually that New Year's day oscillates back and forth with a period of about 1 month around some "fixed point" with respect to the mean solar year. Also, the solar year "fixed point" itself is likely to shift through the solar year over sufficiently long periods of time.

		The Hebrew Calendar seeks to transition from one month to the next as a function of each New Moon. 
	
		Epoch Date

			The epoch date of the Hebrew Calendar, 0001-01-01 [Hebrew], corresponds to -3760-09-07 [Gregorian] (astronomical year numbering) and to -3761-10-07 [Julian] (traditional year numbering.)  Hebrew days begin at sunset. The Julian Date of the Hebrew epoch is 347,997.25 (6 pm,) so the actual initial moment of the Hebrew epoch corresponds to -3760-09-06T18:00:00 [Gregorian] and to -3761-10-06T18:00:00 [Julian]. 

			Jewish tradition considers the Hebrew Calendar epoch to be the date of the creation of the world, which is why the name of the Hebrew era is "Anno Mundi" (AM)--Latin for "In the Year of the World."

		Time-of-Day Clock

			Although Hebrew days begin at sunset, modernly the Jewish people label the hours of the day beginning at midnight.  So the zero-point of the time-of-day clock is midnight, although the initial moment of the day is 6 pm. 

			{HebrewCalendar clock today}
			{HebrewCalendar clock now}

		Year Numbering Policy

			The Hebrew Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Year Type Rules

			There are six different year types (which means six different month structures [see below], and six different numbers of days per year.)  The six year types result from a two-dimensional matrix, with one dimension representing a binary distinction between a standard year and a leap year, and the other dimension representing a trinary distinction between "regular," "deficient" and "complete" years:

												Year Type Matrix 
									Deficient		Regular		Complete
				Standard Year	  353[1]		  354[2]		  355[3]
				Leap Year		  383[4]		  384[5]		  385[6]
					(table cells show: days-per-year[Chronos year-type code])

			The Hebrew Calendar uses the 19-year metonic cycle to determine which years are leap years. Years 3, 6, 8, 11, 14, 17 and 19 of the cycle are leap years, the remaining years are standard years. Whether or not a Hebrew year is a leap year can be computed by the following predicate function:

				isLeapYear(hebrewYear) = (((7 * hebrewYear) + 1)  mod 19) < 7

			Now comes the really complicated part: how to determine whether a Hebrew year is "regular," "deficient" or "complete" (which we will refer to here as the "completeness" of the year, for lack of a better term, since the term "type" already refers to the combination of leap-year-status and "completeness.") 

			One does not first determine the completeness and leap-year-status of a year in order to determine its type (and hence the number of days in the year.) Instead, one must first determine the number of days in the year, after which the type of the year (and hence its completeness) become evident.  In other words, one first determines that a year has (for example) 353 days, from which it obviously follows that the year's Chronos year-type is 1, and that it is therefore a standard, deficient year.

			The number of days in a year is a function of when its first day occurs, and when the first day of the succeeding year occurs.  The approximate first day of a year is determined by the computed occurrence of the mean new moon (earth-lunar conjunction) that is associated with the beginning of the month of Tishri (the first month of the civil year.) The date so computed is subject to possible adjustment by a set of special rules called the Dehiyyah ("delays," "postponements.") First we will explain the formula for computing the occurence of the New Moon (Molad) of Tishri, then we will explain the application of the Dehiyyah rules for the purpose of precisely determining the beginning of a year, and then we will explain how to compute the length of a year.

			Computing the New Moon (Molad) of Tishri

				The Hebrew day was traditionally divided into 24 hours, and each hour was traditionally divided into 1080 parts (halaqim,) which means a day consists of 25,920 parts.  The duration of a part is 3 and a third seconds. The rule for computing the new moon of Tishri is expressed in terms of parts (halaqim.)

				The epochal new moon of Tishri (which occurred on 0001-01-01 Anno Mundi--year 1, month 1 day 1 of the Hebrew Calendar) is deemed by calendrical rule to have occurred at 11:11:20 pm on the epoch date of the Hebrew calendar--which is very late Sunday evening according to Julian/Gregorian reckoning, but is the 5th hour of Monday according to Hebrew reckoning (Hebrew days start at sunset, Julian/Gregorian days start at midnight.) A duration of 5 hours, 11 minutes and 20 seconds (since the start of the day at 6 pm) equates to 18,680 seconds, which is equivalent to 5 hours and 204 parts (halaqim,) or to 5,604 parts (exactly.) Because the epochal Molad of Tishri occurred on the second day of the week (Monday,) after 5 hours and 204 parts since the start of the day, it is called Molad Beharad--the appellation "Beharad" (BHRD--written Hebrew omits all vowels) being derived from the numerology of the Hebrew alphabet, where the letter Beth has the value 2 (second day of the week,) the letter Heh has the value 5 (fifth hour of the day), the letter Resh has the value 200 (parts since the hour,) and the letter Daleth has the value 4 (additional parts since the hour.) Molad Beharad is the base or pivotal occurrence of the new moon upon which all Hebrew calendrical calculations depend.

				The length of a mean lunar period (the average duration between new moons) is deemed (by the rules of the Hebrew Calendar) to be 29 days, 12 hours and 793 parts--which equates to 29 days, 12 hours, 17 minutes and 37 and 1/3 seconds, or to 2549857.333... seconds (using the UT1 timescale.) Since there are 25,920 parts in a day, and since 12 hours + 793 parts is 13,753 parts, the mean lunar period also equates to 29 + (13753/25920) days.

				To compute the duration of time since the Hebrew epoch of the Molad of Tishri for a given year, one simply computes the number of months since the Hebrew epoch up to that year, then multiplies that number of months by the Hebrew Calendar's canonical value for the mean lunar period--which is 29 + (13753/25920) mean solar days, as given above, and adds the result to the moment of occurrence of the Molad Beharad (the epochal new moon of Tishri.)

				The formula for computing the number of months since the Hebrew epoch upto the start of a given (Hebrew) year is expressed by the following function (derived from the 19-year metonic leap-year cycle used by the Hebrew Calendar):

					monthsSinceEpochUpToYear(hebrewYear) =  ((235 * hebrewYear) - 234) div 19

				So the number of (UT1) seconds since the Hebrew epoch of the Molad of Tishri for a given Hebrew year is computed by the following function:

						secondsSinceEpochOfMoladOfTishri(hebrewYear) = 
							(((235 * hebrewYear) - 234) // 19) 	"Number of months since the Hebrew epoch up to the given year"
							* ((29 + (13753/25920)) * 86400)		"times the duration in seconds of the lunar period (one Hebrew month)"
							+ 18680								"plus the number of seconds from the initial moment of the epoch up to the Molad Beharad"

						{Timepoint nominalSecondsSinceEpoch: (((235 * 5765) - 234) // 19) * (29 + (13753/25920)) * 86400 + 18680 calendar: #Hebrew}

			The Dehiyyah: Computing Rosh ha Shannah (New Year's Day) from the Molad of Tishri

				Given the Molad of Tishri for a given Hebrew year, it is necessary to apply the "postponement rules" (the Dehiyyah) to determine the actual date of the Hebrew New Year's Day ("Rosh ha Shannah.") There are four postponement rules, all of which must be satisfied by the actual first day of Tishri, with the effect that the first day of Tishri can be delayed by more than one day from the day on which the Molad of Tishri occurs:

				1. 'Dehiyyah Molad Zaqen' requires that the first day of Tishri (Rosh ha Shannah; New Year's Day) be delayed by one day whenever the candidate day occurs on or after the 18th hour of the Hebrew day (that's on or after 12 noon modern clock time.) 
				2. 'Dehiyyah Lo ADU Rosh' requires that the first day of Tishri be postponed to the following day whenever the candidate day occurs on a Sunday, Wednesday or Friday.  Rules 1 and 2 often both apply, resulting in a 2-day postponement of Rosh ha Shannah.
				3. 'Dehiyyah GaTaRaD' requires that Tishri 1 be postponed to Thursday whenever the candidate day for a 12-month year occurs on Tuesday at 9 hours and 204 parts or later. The effect is to disallow a year from having 356 days. This rule applies roughly once every 30 years.
				4. 'Dehiyyah BeTU'TeKaPoT' requires that Tishri 1 be postponed to Tuesday whenever the candidate day following a 13-month year is on Monday at 15 hours and 589 parts or later. The effect is to disallow a year from having 382 days.  This rule applies roughly once every 186 years.)

			Computing the Length of a Year

				To compute the length of a given <year>, one must compute the number of days since the Hebrew epoch up to the first day of <year>+ 1 and also up to the first day of <year>, and subtract the second value from the first.  There is no other way. 

				And so now you know part of the reason the Hebrew Calendar is so complex.  The other part of the reason is because of its month structure, which is explained below.

		Month Structure

																				D A Y S        P E R		M O N T H
				Month			Civil 		Religious			  		Standard Year					  	Leap Year
								Ordinal	Ordinal			Deficient Regular Complete		Deficient Regular Complete
	
				Tishri				1			7				30			30			30					30			30		30 
				Marheshvan		2			8				29			29			30					29			29		30
				Kislev				3			9				29			30			30					29			30		30
				Teveth				4			10				29			29			29					29			29		29
				Shevat			5			11				30			30			30					30			30		30
				[Adar Rishon		nil/6		nil/12			0			0			0					30			30		30]: Leap Month
				Adar (Sheni)		6/7			12/13			29			29			29					29			29 		29
				Nisan 				7/8			1				30			30			30					30			30		30
				Iyyar				8/9			2				29			29			29					29			29		29
				Sivan				9/10		3				30			30			30					30			30		30
				Tammuz			10/11		4				29			29			29					29			29		29
				Av					11/12		5				30			30			30					30			30		30
				Elul				12/13		6				29			29			29					29			29		29

				Days/year									353		354		355				383		384	385
				Chronos Year Type							  1		  	2		 	 3				 	4		 	 5		  6

			Months have either 29 or 30 days. Most months always have the same number of days every year, either 29 or 30.  The two exceptions are the months of Marheshvan (civil ordinal = 2) and Kislev (civil ordinal = 3.) In a "regular" year (which has 354 days in a standard year, but 384 days in a leap year,) the month of Marheshvan has 29 days and the month of Kislev has 30 days. In a "deficient" year (which has 353 days in a standard year, but 383 days in a leap year,) Marheshvan and Kislev both have 29 days.  In a "complete" year (which has 355 days in a standard year, but 385 day in a leap year,) Marheshvan and Kislev both have 30 days.

			In non-leap years, there are 12 months in a year.  However, in leap years, a 13th leap month is inserted (as month 6) after the fifth month (Shevat) and before the non-leap-year sixth month (Adar,) with the consequence that the month ordinals of the months following the inserted leap month are incremented by one in leap years. The name of the leap month is Adar Rishon ('First Adar.')  In leap years, the month of Adar is referred to as Adar Sheni ('Second Adar,') in order to disambiguate it from Adar Rishon.  The reason that Adar Sheni (instead of Adar Rishon) is considered to be the "same month" as non-leap-year Adar is because the holiday of Purim occurs on Adar 14 in non-leap years, but on Adar Sheni 14 in leap years--and those born in Adar in a non-leap year generally observe their (Jewish) birthday in Adar Sheni in a leap year.

			The semantic month-key of a month is the same as the month's (English) name, except for the months of Adar Rishon and Adar Sheni.  The month-key of Adar Rishon is #AdarL, and the month-key of Adar Sheni is #Adar (the same as that of Adar, since it is semantically the same month.)

			Tishri is the first month of the year.  Elul is the last.  However, the Jewish religion labels the months with a numerical designator such that the month of Nisan (which by mathematical definition is the 7th month of the year in a non-leap year) has the numerical label 1, to indicate that it is the first month of the year for religious purposes--in spite of the fact that New Year's Day (the day whose initial moment marks the transition from one year to the next) is nevertheless the first day of the month of Tishri (whose religious numerical designator is 7.) 

			However, Chronos requires that, for all calendars universally, the ordinal number of the month that contains the first day of the year must be 1 (in other words, the month ordinal must literally be an ordinal number that counts months since the start of the year, and so must be a number greater by one than the cardinal number of months since the month that begins a year.)  Consequently, the Chronos month ordinal for the month of Tishri in the Hebrew Calendar is 1, not 7.

			The Calendar API provides the messages #monthOrdinalFromNumericMonthDesignator:forYearTypeCode: and #numericMonthDesignatorFromMonthOrdinal:forYearTypeCode: for the purpose of translation to/from canonical month ordinals and culturally-correct "numerical month designators." Sending the message #month to a point-in-time object (a DateSpec, YearMonthDay, DateAndTimeSpec or DateAndTime/Timepoint,) provides the mathematically-correct month ordinal of the date (as required by the ANSI-Smalltalk standard.) Sending the message #numericMonthDesignator to a point-in-time object (a DateSpec, YearMonthDay, DateAndTimeSpec or DateAndTime/Timepoint,) provides the culturally-correct month number.  Be sure to use these messages appropriately when capturing dates from, or presenting dates to, the users of an application (a ChronosPrintPolicy can be used to print dates using month ordinals, numeric month designators, month names or month abbreviations.) Applications must provide their own date capture and/or date parsing mechanisms. 
!

AbstractJulianCalendar subclass: #ImperialJulianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!ImperialJulianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ImperialJulianCalendar 	

	Concept:

		ImperialJulianCalendar implements the original Julian Calendar as used in Imperial Rome.  

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Julian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Imperial Julian Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		See the class comment of AbstractJulianCalendar for information about the Julian Calendar common to all its variations. For more information about the Modern Julian Calendar used by historians (and by some religions,) see the class JulianCalendar.

		Epoch Date

			The pre-Imperial, Imperial and post-Imperial Romans counted time from various reference points that changed frequently. However, there was one "epoch year" that was canonically (albeit infrequently) used to unify all their various time counts: the year of the founding of the city of Rome. That era that was called "Ab Urbe Condita," Latin for "From the Founding of the City."  So the epoch date of the Imperial Julian Calendar is 1 January 1 Ab Urbe Condita (AUC,) which corresponds to 1 January 753 BC [Julian].

			 The Julian Date of the epoch of the Imperial Julian Calendar is 1,446,389.50 (midnight.) 

		Time-of-Day Clock

			For this implementation, midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  However, such has not always been the case for all users of the Imperial Julian Calendar.

			{ImperialJulianCalendar clock today}
			{ImperialJulianCalendar clock now}

		Year Numbering Policy

			The Imperial Julian Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			De jure, a year is a leap year if dividing its year ordinal by 4 results in a remainder of 1. The de facto situation is more complicated.

			The Roman priesthood in charge of the Roman calendar (the pontiffs) were mathematically challenged, and so failed to correctly follow the de jure rules for leap years specified by Caesar. The pontiffs mistakenly failed to insert a leap day in 45 BC (709 A.U.C.,) inserting it in 44 BC (710 AUC) instead. Then, from 44 BC to 8 BC (710 A.U.C. to 746 A.U.C.), they inserted a leap day every three years, instead of every 4 (Caesar's decree making his calendar the official civil calendar of the Roman Empire required a leap year every 4 years.) When the error was discovered, Emperor Augustus (Caesar's nephew) was obliged to omit the insertion of leap days between 7 BC and 3 AD (746 A.U.C. to 756 A.U.C.) In 4 AD (757 A.U.C.,) after the extra leap day intercalations had been corrected, itercalation of the leap day was resumed. 

			Which years were actually observed as leap years by the Roman pontiffs has long been a subject of some controversy. The years used by Chronos are based on a recently-published ancient document, as discussed in the following reference [http://www.nationmaster.com/encyclopedia/Julian-calendar]: 

			"In 1999, an Egyptian papyrus was published which gives an ephemeris table for 24 BC with both Roman and Egyptian dates. From this it can be shown that the most likely sequence was in fact 44, 41, 38, 35, 32, 29, 26, 23, 20, 17, 14, 11, 8 BC, AD 4, 8, 12 etc., very close to that proposed by Matzat. This sequence shows that the standard Julian leap year sequence began in AD 4, the twelfth year of the Augustan reform. Also, under this sequence the actual Roman year coincided with the proleptic Julian year between 32 and 26 BC. This suggests that one aim of the realignment portion of the Augustan reform was to ensure that key dates of his career, notably the fall of Alexandria on 1 August 30 BC, were unaffected by his correction. 

			Roman dates before 32 BC were typically a day or two before the day with the same Julian date, so 1 January in the Roman calendar of the first year of the Julian reform actually fell on 31 December 46 BC (Julian date). A curious effect of this is that Caesar's assassination on the Ides (15th day) of March in 44 BC fell on 14 March 44 BC in the Julian calendar."

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: January					31/31
			2: February					28/29
			3: March					31/31
			4: April						30/30
			5: May						31/31
			6: June						30/30
			7: July						31/31
			8: August					31/31
			9: September				30/30
			10: October					31/31
			11: November				30/30
			12: December				31/31
			
			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name.

		Motivation:

			Since no one has used the Roman Imperial Julian Calendar, nor its Clerical variation, for over a thousand years, the only "use case" for this ancient calendar is the interpretation of dates in ancient documents and inscriptions. Consequently, Chronos provides the class ImperialJulianCalendar that fully implements the "de facto" Imperial Julian Calendar, using the "Ab Urbe Condita" era, and duplicating the leap-year schedule used by the Roman pontiffs.  It makes sense to combine the "Ab Urbe Condita" epoch with the "de facto" leap year rules of the Roman pontiffs, because both actually go together historically (one might actually encounter such dates in an ancient document or inscription.)  Such is not the case for dates using the "Anno Domini" era and the "Julian" calendar.







!

MonthsPerYearInvariantCalendar subclass: #IndianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!IndianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

IndianCalendar

	Concept:

		IndianCalendar implements the Indian Civil Calendar, which is the official, civil calendar of India. A bewildering variety of calendars have been and continue to be used in the Indian subcontinent. In 1957 the Indian government's Calendar Reform Committee adopted the National Calendar of India for civil purposes and, in addition, defined guidelines to standardise computation of the religious calendar, which is based on astronomical observations. The civil calendar is used throughout India today for administrative purposes, but a variety of religious calendars remain in use.  Most Indians use the Gregorian Calendar for business purposes, and one of the variations of the religous calendar for the purposes of observing religious holidays, festivals and ceremonies.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Indian Civil Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Indian (Civil) Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Indian Civil Calendar, 0001-01-01 [Indian Civil], corresponds to 0079-03-22 [Gregorian] and to 0079-03-24 [Julian].  The Julian Date of the epoch of the Indian Civil Calendar is 1,749,994.50 (midnight.) 
	
			The epoch date of the Indian Civil Calendar is the vernal equinox of the first year of the Saka Era, marking the ascension to the throne of King Salivahana.

			The name of the era of the Indian Civil Calendar is "Anno Sakidae" (AS)--which is Latin for "In the Year of the Saka."

		Time-of-Day Clock

			Midnight is both the zero-point of the time-of-day clock and also the initial moment of the day. 

			{IndianCalendar clock today}
			{IndianCalendar clock now}

		Year Numbering Policy

			The Indian Civil Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			A year is a leap year if the number that results from adding 78 to the year ordinal is either a) evenly divisible by 400, or b) evenly divisible by 4 but not by 100.  

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Caitra					30/31
			2: Vaisakha					31/31
			3: Jyaistha					31/31
			4: Asadha					31/31
			5: Sravana					31/31
			6: Bhadra					31/31
			7: Asvina					30/30
			8: Kartika					30/30
			9: Agrahayana				30/30
			10: Pausa					30/30
			11: Magha					30/30
			12: Phalguna				30/30

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)

!

ComparableDuration subclass: #InfiniteDuration
	instanceVariableNames: 'extent'
	classVariableNames: 'Backward Forward Negative Positive'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

TemporalInterval subclass: #InfiniteTimepoint
	instanceVariableNames: 'isNegative'
	classVariableNames: 'Future Past'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

Calendar subclass: #IrregularCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Irregular'!

!IrregularCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

IrregularCalendar

	Concept:

		IrregularCalendar is an abstract Calendar class whose subclasses implement "irregular" calendars.  An irregular calendar is one that does not have a reasonably small number of year types, and/or where the computation of the year type involves relatively complex math (typically astronomical calculations using real numbers.)  A year type defines a specific number of months in the year and a specific number of days in each month.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of AstronomicalCalendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		An irregular calendar is one where there is a rather large number of "year types," where a "year type" a) defines a particular way of organizing the days of a year into months and days-of-the-month, and b) defines a deterministic mapping between day-of-year ordinals and month/day-of-month designations.

		Typically, astronomical calendars are IrregularCalendars--but that's not always the case.

		IrregularCalendar is not yet implemented.
!

MonthsPerYearInvariantCalendar subclass: #IslamicFatimidCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!IslamicFatimidCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

IslamicFatimidCalendar

	Concept:

		IslamicFatimidCalendar implements the Islamic Fatimid Calendar.  The Islamic Fatimid Calendar (also called the Tabular Islamic Calendar) is an arithmetical variation of the Astronomical Islamic Calendar (the one most Muslims use for religious purposes.) It has the same year numbers and months, but the months are determined by arithmetic rules rather than by observation or astronomical calculations. It was developed by early Muslim astronomers of the second Hijra century (the eighth century AD) to provide a predictable time base for calculating the positions of the moon, sun, and planets. Historians use it to convert an Islamic date into a Western calendar date when no other information (like the day of the week) is available. Some Muslims (e.g, the Daudi Bohras, the Isma'ilis) also use the arithmetical calendar for regligous purposes [reference: http://archive.mumineen.org/publications/oup/bohras.html].  All Muslims commonly use it to estimate future (and sometimes past) dates.

		Many authoritative reference works claim that almost all Muslims use an observation-based calendar. While that used to be true, it is no longer the case--at least not for legal/civil purposes. A substantial percentage of Muslims now use astronomical calculations to determine when each month will be deemed to have started and ended for civil/legal matters. Such is the case in Saudi Arabia and most of the Gulf countries. Although few Muslims currently use an astronomical version of the Islamic calendar for religious purposes, such use is beginning to be discussed and considered. [References: http://www.jas.org.jo/sau.html; http://www.phys.uu.nl/~vgent/islam/mecca/ummalqura.htm; http://www.amperspective.com/html/the_hijra_calender_2005.html; http://www.abc.net.au/science/news/space/SpaceRepublish_1352797.htm]

		Chronos may provide an implementation of the official Saudi astronomical Islamic Calendar in the future. If so, the calendar registration key will be #'Islamic-Saudi'.  The registration key #'Islamic-Astronomical' is reserved until there is some astronomical Islamic calendar which is widely accepted as the standard or canonical Islamic Calendar (which the Saudi version may become, but it's too soon to accord it such status at present.)

		For now, however, Chronos only provides the Fatimid (arithmetical) Islamic Calendar, for the following reasons: 1) Chronos will never support any purely observational calendars, 2) Chronos does not yet support any astronomical calendars, and 3) there is as yet no widely-accepted, standard/canonical astronomical Islamic calendar (although this may be in the process of changing.)

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Islamic Fatimid Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Islamic Fatimid Calendar is an arithmetical, lunar calendar. A lunar calendar is one that attempts to align the day on which one month transitions to the next with the moment that the moon transitions from one phase to the next, so that each month begins within a day or so of the moment that the moon exits from or enters into a particular phase. A lunar calendar makes no attempt to match the length of its years to the length of the solar year.

		The Islamic Calendar transitions from one month to the next as a function of each New Moon. 

		Epoch Date

			The epoch date of the Islamic Fatimid Calendar, 0001-01-01 [Islamic-Fatimid], corresponds to 0622-07-19 [Gregorian] and to 0622-07-16 [Julian].  Islamic days begin at sunset. The Julian Date of the Islamic epoch is 1,948,439.25 (6 pm,) so the actual initial moment of the Islamic epoch corresponds to 0622-07-18T18:00:00 [Gregorian] and to 0622-07-15T18:00:00 [Julian]. 

			The epoch date of the Islamic Calendar marks the generally accepted date of the "hijra" of Mohammed to Medina ("hijra" means "flight from danger.")  There are some who prefer a different date in the same year for this event, but the Islamic Calendar uses the generally-accepted date as its epoch.

			The Islamic era is called "Anno Hegirae" (AH,) which is Latin for "In the Year of the Hijra."

		Time-of-Day Clock

			Although Islamic days begin at sunset, Muslims modernly label the hours of the day beginning at midnight.  So the zero-point of the the time-of-day clock is midnight, although the initial moment of the day is 6 pm.

			{IslamicFatimidCalendar clock today}
			{IslamicFatimidCalendar clock now}

		Year Numbering Policy

			The Islamic Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule
	
			A year is a leap year if the following function evaluates to true: isIslamicLeapYear(calendarYear) => ((calendarYear * 11) + 14) \\ 30 < 11.

		Month Structure


			Month					Days In Month
								Standard Year/Leap Year					
			1: Muharram				30/30
			2: Safar						29/29
			3: Rabi1					30/30
			4: Rabi2					29/29
			5: Jumada1					30/30
			6: Jumada2					29/29
			7: Rajab					30/30
			8: Shaban					29/29
			9: Ramadan					30/30
			10: Shawwal				29/29
			11: Dhu al-Qa'ada			30/30
			12: Dhu al-Hijja				29/30

			Days In Year				354/355

			The semantic month-key of a month is the same as the month's (English) name (as given here.)

			
!

AbstractJulianCalendar subclass: #JulianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!JulianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

JulianCalendar

	Concept:

		JulianCalendar implements the Modern Julian Calendar, as modernly used to designate dates prior to the adoption of the Gregorian Calendar (which happened at different times in different legal jurisdictions.)  

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Julian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Julian Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		See the class comment of AbstractJulianCalendar for information about the Julian Calendar common to all its variations.

		Epoch Date

			The epoch date of the Modern Julian Calendar as used by historians is 1 January 1 AD (1 January 754 AUC,) which is the first day of the year according to the civil calendar in use in Rome of the year in which or after which (no one knows for sure) that the Catholic Church reckoned that Christ was born. This year is the beginning of the Anno Domini era ("Anno Domini" is Latin for "In the year of the Lord.") Years prior to the year 1 Anno Domini are referred to as being in the era "Before Christ" (BC)--which is in English instead of Latin simply because the era was so named (originally) by the Venerable Bede, in his 'Ecclesiastical History of the English Nation,' which was published (in Old English) in the Eighth Century AD. 

			 The Julian Date of the epoch of the Modern Julian Calendar is 1,721,423.50 (midnight.) 

			The idea of using the year of Christ's birth as the epoch year of the Julian Calendar was first proposed by the Monk Dionysius Exiguus in 525 AD.  At the time, a variety of epoch years were in common use, with the year when Diocletian ascended to the office of Emperor of Rome being the most widely used. Although the Imperial and post-Imperial Romans counted time from various reference points that changed frequently, there was one "epoch date" that was canonically (albeit infrequently) used to unify all their various time counts: the date of the founding of the city of Rome (an era that was called "Ab Urbe Condita," Latin for "From the Founding of the City.") Dionysius explicity specified the year that would be the year 1 of the Anno Domini Era as the year 754 A.U.C. ("Ab Urbe Condita.")  

			There is much contention as to the actual year of Christ's birth, although it is almost certain that Christ was not in fact born in either 753 or 754 AUC (1 BC or 1 AD.)  However, it may be that Dionysius chose 754 AUC as the epoch year for mathematical reasons, and not because he believed that Christ was actually born in either 1 BC or 1 AD.
  
			Dionysius Exiguus' proposal to use the time of Christ's birth as the basis for the epoch of the Julian Calendar was not immediately adopted. In fact, it would be several centuries before the Christian/Anno Domini Era came to be the commonly used basis for counting years. But by that time, other changes in calendrical practices had taken place.

			New Year's Day as decreed by Julius Caesar was January 1.  But in medieval Europe, because the celebrations accompanying the new year were considered pagan and unchristian, the Council of Tours in 755 AD abolished January 1 as the beginning of the year. Over time, the result was that New Year's Day (the day on and after which the year ordinal would be incremented by one in date designations) came to be observed on any of December 25, March 1, March 25, the Feast of the Annunciation, or even Easter--and which of those days would have been deemed New Year's Day would depend, of course, on time and place. 

			The epoch date of the Modern Julian Calendar is 1 January 754 AUC. This epoch date is used by historians in order to establish a unified, canonical "Julian Calendar" for modern use when representing ancient and medieval dates. Note, however, that this epoch date makes the Modern Julian Calendar anachronistic (proleptic,) because its New Year's Day was last widely used officially (in connection with the Julian Calendar) in the Eighth Century, and its epoch year didn't become canonical until the Ninth Century. The Modern Julian Calendar as used by historians, with New Year's Day on January 1 and with 754 AUC as the epoch year, was never the official civil calendar of the Western World.

		Time-of-Day Clock

			Modernly, midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  However, such has not always been the case for all users of the Julian Calendar.

			{JulianCalendar clock today}
			{JulianCalendar clock now}

		Year Numbering Policy

			The Julian Calendar uses "zeroless ordinal" year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year -1.

		Leap Year Rule

			A year is a leap year if its ordinal is evenly divisible by 4.

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: January					31/31
			2: February					28/29
			3: March					31/31
			4: April						30/30
			5: May						31/31
			6: June						30/30
			7: July						31/31
			8: August					31/31
			9: September				30/30
			10: October					31/31
			11: November				30/30
			12: December				31/31

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name.

	Usage:

		The Chronos namespace (shared pool) defines the global variable Julian, which aliases the canonical instance of JulianCalendar.  "JulianCalendar canonical" and "Julian" should be the same object.

	!

ComputedAnnualDate subclass: #JulianEaster
	instanceVariableNames: ''
	classVariableNames: 'PaschalMoonTable'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!JulianEaster commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

ChronosObject subclass: #LeapSecond
	instanceVariableNames: 'prev next secondsDelta preNetLeapSeconds postNetLeapSeconds daysSinceEpoch secondsSinceStartOfDay calendricalSecondsSinceEpoch firstScientificSecondSinceEpoch lastScientificSecondSinceEpoch isRelativeToUT'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timescales'!

!LeapSecond commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

Instance Variables:
	daysSinceEpoch	<ArithmeticValue>	description of daysSinceEpoch
	isRelativeToUT	<Boolean>	description of isRelativeToUT
	postNetLeapSeconds	<SmallInteger>	description of postNetLeapSeconds
	preNetLeapSeconds	<ArithmeticValue>	description of preNetLeapSeconds
	secondsDelta	<SmallInteger>	description of secondsDelta
	secondsSinceStartOfDay	<SmallInteger>	description of secondsSinceStartOfDay
	ut1SecondsSinceEpoch	<ArithmeticValue>	description of ut1SecondsSinceEpoch
	utcSecondsSinceEpoch	<SmallInteger>	description of utcSecondsSinceEpoch

	Subclassing:


!

CalendarClock subclass: #LocalTimeCalendarClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!LocalTimeCalendarClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

LocalTimeCalendarClock

	Concept:
		
		A LocalTimeCalendarClock is CalendarClock (which see) specialized for encapsulating a ChronosSystemClock that reports time relative to the current default timezone.
!

CalendricalAnnualDate subclass: #MonthOfYear
	instanceVariableNames: 'monthKey monthOrdinal minDayOfYearOrdinal maxDayOfYearOrdinal'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!MonthOfYear commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

CalendarYearPart subclass: #MonthlyCalendar
	instanceVariableNames: 'key nameKey isIntercalary leapDayOrdinals daysUpToMonthSinceStartOfYear'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!MonthlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

MonthlyCalendar

	Concept:

		MonthlyCalendar is an abstract class; an instance of one of its concrete subclasses represents/specifies the properties of a particular month as it occurs within a particular type of year (e.g., a standard year, a leap year) of a particular calendrical system (e.g., the Gregorian, Hebrew, or Persian calendar.)  It does NOT represent/specify an actual occurrence of a month in any specific year. In other words, a MonthlyCalendar would specify/represent (for example) the properties of the month of February as it occurs in any leap year of the Gregorian Calendar, but would not specify/represent any specific occurrence of February in a specific Gregorian year.

		Specifically, a MonthlyCalendar specifies the YearlyCalendar that encapsulates it (and hence also the Calendar that implements the calendrical system for which it represents the properties/characteristics of a particular month in a particular type of year); the month ordinal of the month it represents; the "month key" that semantically identifies the month (because "the same" month may have a different ordinal in different year types); the "name key" that semantically identifies the name of the month (because the "same month" may have a different name in different year types, and also because the "same month" probably has a different name in different languages and/or cultures); whether or not the month is an intercalary or leap month; what the month's leap days are (if any); the number of days from the beginning of the year up to the first day of the month; and the properties of each day of the month (by means of an encapsulated instance of CalendarDay--one for each day of the month.)

		The two concrete subclasses of MonthlyCalendar are StaticMonthlyCalendar and DynamicMonthlyCalendar. A StaticMonthlyCalendar is preinitialized to encapsulate a flyweight instance of StaticCalendarDay for each day in the month it represents.  In contrast, a DynamicMonthlyCalendar generates a new instance of DynamicCalendarDay every time one is needed. StaticMonthlyCalendar must be used in collaboration with StaticYearlyCalendar and StaticCalendarDay. DynamicMonthlyCalendar must be used in collaboration with DynamicYearlyCalendar and DynamicCalendarDay.

	Usage:

		As is the case with most Chronos classes, MonthlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			key 								<Symbol>
				The key that semantically identifies the month represented by the instance.
			nameKey 							<Symbol | nil>
				The key that semantically identifies the name of the month represented by the instance (because what is semantically the "same month" may go by different names in different years--for example, "Adar" and "Adar Sheni" in the Hebrew Calendar.)  If the <nameKey> is nil, then the instance's "name key" is identical to its <key>.
			isIntercalary 						<Boolean>
				Flag that signals whether or not the month represented by the instance is an intercalary month. An intercalary month is one that either a) does not occur every year (it's a "leap month,") and/or b) does not have nearly the same number of days as the majority of months in the year.
			leapDayOrdinals 					<Collection of Integer>
				Collection of the day-of-month ordinals of the days of the month represented by the instance that are leaps days (days that are inserted into the month in some years but not in others--note that a leap day does NOT have to be the last day of a month.)
			daysUpToMonthSinceStartOfYear	<Integer>
				The number of days from the first day of the instance's year up to (but not including) the first day of the month represented by the instance.

	Subclassing:

		Concrete subclasses must subimplement the following instance methods (see the comment of each method for the required semantics):

			#basicDayAt:
			#calendarDayClass
			#dayAt:
			#daysPerMonth
			#setDaysPerMonth:
!

ChronosObject subclass: #MonthlyCalendarSpec
	instanceVariableNames: 'key nameKey daysPerMonth occurrenceType leapDayOrdinals'
	classVariableNames: 'EveryYearIntercalary LeapIntercalary Standard'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!MonthlyCalendarSpec commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

MonthlyCalendarSpec

	Concept:

		A MonthlyCalendarSpec represents/specifies the properties of a particular month as it occurs within a particular type of year (e.g., a standard year, a leap year) of a particular calendrical system (e.g., the Gregorian, Hebrew, or Persian calendar.)  It does NOT represent/specify an actual occurrence of a month in any specific year. In other words, an instance of MonthlyCalendarSpec would specify/represent (for example) the properties of the month of February as it occurs in any leap year of the Gregorian Calendar, but would not specify/represent any specific occurrence of February in a specific Gregorian year.

		MonthlyCalendarSpecs are used by instances of Calendar (which see) as factory objects in order to create and initialize instances of YearlyCalendar (which also see.)

	Implementation:

		Instance Variables

			key 								<Symbol>
				The key that semantically identifies the month represented by the instance.
			nameKey 							<Symbol | nil>
				The key that semantically identifies the name of the month represented by the instance (because what is semantically the "same month" may go by different names in different years--for example, "Adar" and "Adar Sheni" in the Hebrew Calendar.)  If the <nameKey> is nil, then the instance's "name key" is identical to its <key>.
			daysPerMonth 						<Integer>
				The number of days in the month represented by the instance.
			occurrenceType 					<Integer>
				Integer enumeration code, with the following encoding:
					0 = standard month that occurs every year ("standard month,") 
					1 = short month that occurs every year ("intercalary month,") and 
					2 = leap month that does not occur every year ("leap month.")
			leapDayOrdinals 					<Collection of Integer>
				Collection of the day-of-month ordinals of the days of the month represented by the instance that are leaps days (days that are inserted into the month in some years but not in others--note that a leap day does NOT have to be the last day of a month.)

!

RegularCalendar subclass: #MonthsPerYearInvariantCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!MonthsPerYearInvariantCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

MonthsPerYearInvariantCalendar	

	Concept:

		MonthsPerYearInvariantCalendar is an abstract Calendar class whose subclasses implement arithmetical calendars that have the same number of months in any and all years (most calendrical systems have this property.)  

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of ArithmetiicalCalendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

	Subclassing:

		The following class methods must be subimplemented by any concrete subclass (see the method comment for the method semantics):

			newMonthlyCalendarSpecsForStandardYear
			newMonthlyCalendarSpecsForLeapYear!

ProxyTZ subclass: #NominalTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!NominalTime commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

NominalTime

	Concept:

		The canonical instance of NominalTime is accessible by sending the class message #nominal to ChronosTimezone ("Timezone nominal.")
				
		An instance of NominalTime implements nominal time. A point-in-time value bound to a NominalTime instance has "nominal-time-invariant" semantics. A point-in-time value with nominal-time-invariant semantics invariantly represents the same local (nominal) time in any time zone, and is therefore said to be "invariant to nominal time." In a sense, <Timezone nominal> refers to no timezone at all --or to any timezone of your choice.

		A point-in-time that is invariant to nominal time represents the same LOCAL time in any and all timezones, and so compares as equal to any other point-in-time whose local (or nominal) time matches the time it nominally designates. Timepoints with any other timezone are invariant to UT, which means that their value relative to other UT-invariant Timepoints is determined by the UT point-in-time they represent, and not by their local time (UT-invariance is the semantics required of points-in-time that conform to the ANSI-Smalltalk <DateAndTime> protocol.) However, for compatibility with UT-invariant Timepoints, Timepoints whose timezone is <Timezone nominal> also behave to some extent as though their timezone were <Timezone default>. So, nominal-time invariant Timepoints always represent THE SAME LOCAL TIME in any and all time zones--in other words, their LOCAL TIME ("nominal time") is INVARIANT, but the UT time they represent varies as a function of the value of 'Timezone default.' 

		Instances of the ST-80 "Date" and "Time" classes, and also instances of the VisualWorks "Timestamp" class, have "nominal-time-invariant" semantics.  Instances of Chronos' DateSpec, DateAndTimeSpec, YearMonthDay and TimeOfDay classes are also invariant to nominal time.

	Usage:

		A NominalTime conforms to the Chronos "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		The key of the "nominal time" time zone is #nominal.

	Motivation:

		The minor motivation for implementing nominal time invariance is for compatibility with date and time values provided by other date/time libraries that also have nominal-time-invariant behavior (an ST80 Date or Time, or a VisualWorks Timestamp, for example.)

		The major motivation for implementing nominal time invariance is so that point-in-time values with nominal-time-invariance can be instantiated that specify the point-in-time of an event that occurs at the same local time in all time zones (or in some set of time zones.) Examples would be the initial moment of New Year's Day, the time that a regularly-scheduled television show begins, a schedule of the first and last momements of a company's regular shift at all locations nationally for the next year, or the moment of insertion of a "rolling" leap second.

		One should take care to use point-in-time values whose time-invariance semantics are correct for the situation at hand.  Getting this wrong is a significant source of bogosity in computer code that deals with time. 

		Consider the following examples:

			1. "Misusing Universal Time Invariance: Christmas Day does NOT include Christmas Day for all time zones (if only you had a dollar for every bug analogous to this one...)"

				| christmasDay |
				christmasDay := 
					Timeperiod 
						startingAt: (Timepoint year: 2005 month: 12 day: 25 hour: 0 minute: 0 second: 0 offset: (Duration hours: -5) " <-- The arrow points to the problem") 
						duration: (Duration days: 1).
				Array
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 21 minute: 0 second: 0 offset: (Duration hours: -8))))
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 12 minute: 0 second: 0 offset: (Duration hours: 0))))
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 0 minute: 0 second: 0 offset: (Duration hours: 10))))

			2. "Correctly Using Nominal-Time-Invariance: Christmas Day DOES include Christmas Day for all time zones (I don't have any dollars for you, but I do have a simple fix for the problem demonstrated above)"

				| christmasDay |
				christmasDay := 
					Timeperiod 
						startingAt: (Timepoint year: 2005 month: 12 day: 25 hour: 0 minute: 0 second: 0 timeZone: Timezone nominal " <-- The arrow points to the solution") 
						duration: (Duration days: 1).
				Array
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 21 minute: 0 second: 0 offset: (Duration hours: -12))))
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 0 minute: 0 second: 0 offset: (Duration hours: 0))))
					with: (christmasDay includes: ((Timepoint year: 2005 month: 12 day: 25  hour: 21 minute: 0 second: 0 offset: (Duration hours: 12))))

				

!

StandardTime subclass: #NonStandardTime
	instanceVariableNames: 'stdTimeOffsetFromUT'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!NonStandardTime commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

NonStandardTime	

	Concept:

		NonStandardTime implements "bound, dynamic" time zones, as described in the superclass BoundTimezone.  A NonStandardTime represents the (offset, abbreviation) tuple that defines local "daylight saving time" (also called "summer time" in much of the world, and generically referred to as "non-standard time" by Chronos) during some range (or ranges) ot point-in-time values within the territorial domain of a time zone.  For example, the NonStandardTime instance whose key is #'America/Phoenix', whose offset from UT is -6 hours, and whose abbreviation is #MDT functions as the "bound, dynamic" time-zone for all point-in-time values in Arizona from 1967-04-02T03:00:00 MDT up until 1967-10-29T01:00:00 MST (Arizona has occasionally observed DST for brief perionds.)

	Usage:

		A NonStandardTime conforms to both the Chronos "BOUND TIMEZONE API" and "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		See StandardTime, BasicTimezone, BoundTimezone, ChronosTimezone and VariableOffsetTimezone for more informaiton.

	Implementation:

		Instance Variables

			stdTimeOffsetFromUT	<ScientificDuration> 	The offset from UT that would be in effect during "standard time" in the territorial domain of the time zone whose non-standard time properties are represented by the instance..!

MonthsPerYearInvariantCalendar subclass: #PersianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!PersianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

PersianCalendar

	Concept:

		PersianCalendar implements the arithmetical version of the Persian Calendar.  There is also an astronomical version of the Persian Calendar, which some authorities claim is the one actually used in Iran, although other authorities claim otherwise.  Chronos does not currently provide implementations of any astronomical calendars. The astronomical version of the Persian Calendar will (eventually) be implemented by class named AstronomicalPersianCalendar, whose registration key will be #'Persian-Astronomical'.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Persian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Persian Calendar (as implemented here) is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.  

		Epoch Date

			The epoch date of the Persian Calendar, 0001-01-01 [Persian], corresponds to 0622-03-22 [Gregorian] and to 0622-03-19 [Julian].  The Julian Date of the epoch of the Persian Calendar is 1,948,320.50 (midnight.) 

			The epoch date of the Persian Calendar is the vernal equinox of the year in which the "hijra" of Mohammed to Medina occurred ("hijra" means "flight from danger.") 

			The era of the Persian Calendar is called "Anno Persico" or "Anno Persarum" (AP)--which is Latin for "In the Year of Persia/the Persians."

		Time-of-Day Clock

			Modernly, midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  However, such has not always been the case for all users of the Persian Calendar.

			{PersianCalendar clock today}
			{PersianCalendar clock now}

		Year Numbering Policy

			The Persian Calendar uses "zeroless ordinal" year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year -1.

		Leap Year Rule

			According to Birashk [A. Birashk, "A Comparative Calendar of the Iranian, Muslim Lunar, and Christian Eras for Three Thousand Years," Mazda Publishers (in association with Bibliotheca Persica,) Costa Mesa, CA, 1993], the arithmetical form of the Persian Calendar uses the following rather complicated leap year rules:

			There is a master cycle of 2820 years, during which 683 years are leap years. Each standard year contains 365 days, and each leap year contains 366 days, so the master 2820-year cycle contains 1,029,983 days [(2820 * 365) + 683 = 1,029,983].  Based on the current mean length of the tropical year and solar day, there are 1,029,983.00118 days in 2820 tropical years.  So, were it not for the fact that a) the length of the tropical year and the length of a mean solar day is slowly changing, and b) the length of the tropical year (which is defined by the duration between winter solstices) is not the same as the length of the spring equinoctial year (which is defined by the duration between vernal equinoxes,) it would be fair to say that the Persian arithmetical calendar deviates from the length of a year by only 101.952 minutes in 2820 years.  But for those (and other) caveats, the Persian arithmetical calendar would slip from perfect alignment with the tropical year by only one day every 39,829.68 years--which is astounding accuracy, in spite of the caveats. 

			Within each 2820-year cycle, there are 22 subcycles--the first 21 each contain 128 years, and the 22nd (final) subcycle contains 132 years [2820 = 21 * 128 + 132].

			Each 128-year subcycle contains one 29-year sub-subcycle (the first,) followed by three 33-year sub-subcycles [128 = 29 + (3 * 33)].

			Each 132-year subcycle contains one 29-year sub-subcycle (the first,) followed by two 33-year sub-subcycles, followed by one 37-year sub-subcycle [132 = 29 + (2 * 33) + 37].

			A year in a sub-subcycle (whether it contains 29, 33 or 37 years) is a leap year if the ordinal index of the year within the cycle satisfies the following two predicate tests: 1) it's greater than 1, and 2) the remainder after dividing it by 4 is 1 (so the first year in sub-subcyle is never a leap year; the first leap year is the fifth year in the sub-subcycle.) Thus, a 29-year sub-subcycle has 7 leap years, a 33-year sub-subcycle has 8 leap years, and a 37-year sub-subcycle has 9 leap years (Note: the last year of a sub-subcycle is always a leap year, since 29, 33 and 37 all result in a remainder of 1 when divided by 4) [21 * (7 + (3 * 8)) + (7 + (2 * 8) + 9) = 683].

			The base year of the 2820 cycle of years is NOT the Persian year zero or 1, however.  The base year of the 2820-year cycle of years is the Persian year 475 (which starts on 21 March 1096 [Gregorian] or 15 March 1096 [Julian].)  However, to facilitate the use of modular arithmetic, the Chronos implementation uses Persian year 474 as the zeroeth year of the 2820-year cycle.

			Algorithm of Predicate Function that answers true if a <persianYear> is a leap year (input arg=<persianYear>):

				1. If <persianYear> >= 1 then
					set <cardinalYear> to <persianYear> - 1;
				   else
					set <cardinalYear> to <persianYear>;
				   end
				2. Set <dividend> to <cardinalYear> - 473.
				3. Set <year> to (dividend mod 2820) + 474.
				4. Return (((<year> + 38) * 682) mod 2816) < 682

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Farvardin					31/31
			2: Ordibehesht				31/31
			3: Xordad					31/31
			4: Tir						31/31
			5: Mordad					31/31
			6: Shahrivar					31/31
			7: Mehr						30/30
			8: Aban						30/30
			9: Azar						30/30
			10: Dey						30/30
			11: Bahman					30/30
			12: Esfand					29/30

			Days In Year				365/366

			The semantic month-key of a month is the same as the month's (English) name (as given here.)

			
	!

ChronosTimezone subclass: #ProxyTZ
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!ProxyTZ commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ProxyTZ

	Concept:

		ProxyTZ is an abstract class that provides inheritable behavior appropriate for implementing "proxy" time zones. A "proxy" timezone is one that serves as an indirect reference to some other timezone. Proxy timezones are useful for cases where it is desirable that the local time of a point-in-time value dynamically change to reflect whatever timezone is currently set as the local timezone.  

		Chronos defines three standard "proxy" timezones: <Timezone alwaysSystem>, <Timezone alwaysDefault> and <Timezone nominal>.

		For further information, see AlwaysDefaultTZ, AlwaysSystemTZ, NominalTime and ChronosTimezone.

	Usage:

		A ProxyTZ conforms to both the Chronos "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

	Subclassing:

		Concrete subclasses must sumplimplement the instance method #delegate
!

Immutable subclass: #RangeConstraint
	instanceVariableNames: 'semanticKey rangeViolationHandler minValidValue maxValidValue'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!RangeConstraint commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

RangeConstraint

	Concept:

		A RangeConstraint is an Immutable (which see) that implements the concept of a range constraint to be imposed on a numeric values.

	Usage:

		A RangeConstraint instance has a #minValidValue and a #maxValidValue.  There are instance creation methods which permit an instance to be created with any specified minimum and maximum valid values. The instance messages #minValidValue and a #maxValidValue can be sent to an instance to determine the instance's valid value range. In the case of #minValidValue, nil is interpreted as negative infinity. In the case of #maxValidValue, nil is interpreted as positive infinity.

		Optionally, an instance can be instantiated with a #semanticKey.  The #semanticKey is used to identify the semantic role, function, purpose or usage of the instance. For example, a RangeConstraint instance  might be instantiated by evaluating 'RangeConstraint semanticKey: #GregorianMonthOrdinals minValidValue: 1 maxValidValue: 12.'  Sending the message #semanticKey to the instance would return the Symbol #GregorianMonthOrdinals. If the Symbol #GregorianMonthOrdinals is a well-known key, it would serve to identify the semantics (meaning, purpose, function) of the instance as a range constraint for valid ordinals of months in a Gregorian date.

		To test whether a number is within the valid range defined by an instance, send the message #isValid: to the instance, with the number to be tested as the argument. 

		To assert that a number is within the valid range defined by an instance, send the message #assertValid: to the instance, with the number to be tested as the argument. If the number is in fact within the valid range defined by the instance, nothing will happen.  However, if the assertion is false, the instance's rangeViolationHandler will be invoked (for details, see the comment for the rangeViolationHandler instance variable.)  The default rangeViolationHanlder raises an Exception.  Some of the instance creation messages permit an instance to be created with a rangeViolationHanlder provided as an argument.   

	Implementation:

		Instance Variables

		semanticKey 			<Symbol>				Identifies the semantic role, function, purpose, usage of the instance.
		rangeViolationHandler 	[:value :min :max | ...]	Block-3 that is invoked when the instance is presented with a value
														asserted to be valid, but the value is not in the valid range defined by
														the instance--the first argument is the out-of-range value, the second 
														is the minimum valid value, and the third argument is the maximum valid value.
		minValidValue 			<Number>				The minimum valid value of the range constraint that the instance enforces.	 A value of nil is treated as negative infinitiy.	
		maxValidValue 			<Number>				The maximum valid value of the range constraint that the instance enforces. A value of nil is treated as positive infinitiy.			

	!

!RangeConstraint class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Chronos'! !

!RangeConstraint class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey maxValidValue: max
	^self new
		setSemanticKey: semanticKey;
		setMaxValidValue: max;
		beImmutable! !

!RangeConstraint class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey minValidValue: min
	^self new
		setSemanticKey: semanticKey;
		setMinValidValue: min;
		beImmutable! !

!RangeConstraint class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey minValidValue: min maxValidValue: max
	^self new
		setSemanticKey: semanticKey;
		setMinValidValue: min;
		setMaxValidValue: max;
		beImmutable! !

!RangeConstraint class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey minValidValue: min maxValidValue: max rangeViolationHandler: block3
	^self new
		setSemanticKey: semanticKey;
		setMinValidValue: min;
		setMaxValidValue: max;
		setRangeViolationHandler: block3;
		beImmutable! !

!RangeConstraint class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey minValidValue: min maxValidValue: max rangeViolationHandler: block3 zeroInvalidException:  anExceptionFactory zeroInvalidMessage: aString
	^self new
		setSemanticKey: semanticKey;
		setMinValidValue: min;
		setMaxValidValue: max;
		setRangeViolationHandler: block3;
		setZeroInvalidException:  anExceptionFactory;
		setZeroInvalidMessage: aString;
		beImmutable! !

!RangeConstraint class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey zeroInvalidException:  aString
	^self new
		setSemanticKey: semanticKey;
		setZeroInvalidException:  aString;
		beImmutable! !

!RangeConstraint class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey zeroInvalidException:  anExceptionFactory zeroInvalidMessage: aString
	^self new
		setSemanticKey: semanticKey;
		setZeroInvalidException:  anExceptionFactory;
		setZeroInvalidMessage: aString;
		beImmutable! !

!RangeConstraint class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey zeroInvalidMessage: aString
	^self new
		setSemanticKey: semanticKey;
		setZeroInvalidMessage: aString;
		beImmutable! !

!RangeConstraint methodsFor: 'API-validation' stamp: ''!
assertValid: aValue
 	(aValue == nil or: [aValue < minValidValue or: [aValue > maxValidValue]])
		ifTrue: [self handleRangeViolation: aValue]! !

!RangeConstraint methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	rangeViolationHandler == nil
		ifTrue: [self setRangeViolationHandler: self defaultRangeViolationHandler].! !

!RangeConstraint methodsFor: 'private' stamp: ''!
defaultRangeViolationHandler
	^[:value :min :max | 
		value == nil ifTrue: [^self signalError: 'The value ', value printString, ' for the ', semanticKey printString, ' attribute is not valid.'].
		min == nil
			ifTrue: [self signalError: (self stringForValue: value), ' exceeds the maximum valid value of the ', semanticKey printString, ' attribute (max=', (self stringForValue: max), ')']
			ifFalse:
				[max == nil
					ifTrue: [self signalError: (self stringForValue: value), ' is less than the minimum valid value of the ', semanticKey printString, ' attribute (min=', (self stringForValue: min), ')']
					ifFalse: 
						[value < min
							ifTrue:[self signalError: (self stringForValue: value), ' is less than the minimum valid value of the ', semanticKey printString, ' attribute (min=', (self stringForValue: min), ')']
							ifFalse: [self signalError: (self stringForValue: value), ' exceeds the maximum valid value of the ', semanticKey printString, ' attribute (max=', (self stringForValue: max), ')']]]]! !

!RangeConstraint methodsFor: 'private' stamp: ''!
handleRangeViolation: value
	^self rangeViolationHandler value: value value: self minValidValue value: self maxValidValue! !

!RangeConstraint methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	minValidValue := 0.
	maxValidValue := 0.
	self setRangeViolationHandler: self defaultRangeViolationHandler.! !

!RangeConstraint methodsFor: 'testing' stamp: ''!
isNegativeValid
	^minValidValue < 0! !

!RangeConstraint methodsFor: 'testing' stamp: ''!
isPositveValid
	^maxValidValue > 0! !

!RangeConstraint methodsFor: 'API-validation' stamp: ''!
isValid: aValue
	^aValue ~~ nil and: [aValue >= minValidValue and: [aValue <= maxValidValue]]! !

!RangeConstraint methodsFor: 'testing' stamp: ''!
isZeroValid
	^minValidValue <= 0 and: [maxValidValue >= 0]! !

!RangeConstraint methodsFor: 'accessing' stamp: ''!
maxValidValue
	^maxValidValue! !

!RangeConstraint methodsFor: 'accessing' stamp: ''!
minValidValue
	^minValidValue! !

!RangeConstraint methodsFor: 'accessing' stamp: ''!
rangeViolationHandler
	^rangeViolationHandler! !

!RangeConstraint methodsFor: 'accessing' stamp: ''!
semanticKey
	^semanticKey! !

!RangeConstraint methodsFor: 'initialize-release' stamp: ''!
setMaxValidValue: aMagnitude
	self assertMutability.
	maxValidValue := aMagnitude! !

!RangeConstraint methodsFor: 'initialize-release' stamp: ''!
setMinValidValue: aMagnitude
	self assertMutability.
	minValidValue := aMagnitude! !

!RangeConstraint methodsFor: 'initialize-release' stamp: ''!
setRangeViolationHandler: block3
	self assertMutability.
	rangeViolationHandler := block3! !

!RangeConstraint methodsFor: 'initialize-release' stamp: ''!
setSemanticKey: aKey
	self assertMutability.
	semanticKey := aKey! !

!RangeConstraint methodsFor: 'private' stamp: ''!
signalZeroInvalid
	^self signal: self zeroInvalidException message: self zeroInvalidMessage! !

!RangeConstraint methodsFor: 'private' stamp: ''!
stringForValue: aValue
	^aValue == nil
		ifTrue:['undefined value']
		ifFalse: [aValue printString]! !

RangeConstraint subclass: #ZeroSensitiveRangeConstraint
	instanceVariableNames: 'zeroInvalidException zeroInvalidMessage'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ZeroSensitiveRangeConstraint commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ZeroSensitiveRangeConstraint

	Concept:

		ZeroSensitiveRangeConstraint is an abstract subclass of RangeConstraint. An instance of a concrete subclass of ZeroSensitiveRangeConstraint is a RangeConstraint (which see) that not only defines a numeric range constraint, but may additionally prohibit the value zero--even when zero falls inside the valid range.

	Usage:

		In addition to the behavior defined by RangeConstraint, a ZeroSensitiveRangeConstraint will raise an Exception when it is presented with a value asserted to be valid, but the value is zero AND zero is not a member of the set of valid values represented by the instance.  ZeroSensitiveRangeConstraint provides protocol for instantiating an instance with a) an Exception to be raised, and b) a message to be associated with that Exception, whenever an invalid zero-value is asserted to be valid.  Protocol is also provided for accessing the Exception and message.

		To test whether a given value satisfies an instance's zero constraint, send the message #satisfiesZeroConstraint: to the instance, with the value to be tested as the argument.  If the set of valid values represented by the instance includes zero, sending #satisfiesZeroConstraint: will result in true being returned, regardless of the value of the argument.  However, if the set of valid values represented by the instance does NOT include zero, sending #satisfiesZeroConstraint: will result in true being returned only if the argument is not zero (if the argument is zero in such a case, the value false will be returned.)

	Implementation:
		
		Whether zero is or is not a member of the set of valid values represented by the receiver is controlled by the implmentation of the method #satisfiesZeroConstraint:, which must answer true if zero is a valid value, but false if the argument is zero and zero is NOT a valid value.  The implementation provided by ZeroSensitiveRangeConstraint itself always answer true.

		Instance Variables

			zeroInvalidException 	<Exception>	Exception that is signalled (raised) when the instance is presented with a value
													asserted to be valid, but the value is zero AND zero is not a member of the set of
													valid values defined by the instance.
			zeroInvalidMessage 		<String>		Message that will be associated with the <zeroInvalidException> when it is signalled.

	Subclassing:

		Subclasses whose set of valid values does NOT contain zero should subimplement the method #satisfiesZeroConstraint: so that it returns false when invoked with an argument whose value is zero.
!

ZeroSensitiveRangeConstraint subclass: #NumberingPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!NumberingPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

NumberingPolicy

	Concept:

		NumberingPolicy is an abstract subclass of ZeroSensitiveRangeConstraint. In addition to the functionality of a ZeroSensitiveRangeConstraint, an instance of a concrete subclass of NumberingPolicy provides an API by means of which cardinal numbers, ordinal numbers, or zeroless-ordinal numbers may be correctly interpreted and manipulated (a zeroless-ordinal number is one where the integer one less than postive one is negative one, and the integer one greater than negative one is positive one--in other words, an integer number field where zero does not exist.)

		A subclass of NumberingPolicy intended to deal with zeroless-ordinal numbers (for example, year numbers in calendrical systems that don't have a year zero,) could be used to ensure that the correct result is obtained when integer values are added to and/or subtracted from a zeroless-ordinal value. For example, to subtract N years from a year in the Julian Calendar, one would use an instance of a zeroless-ordinal NumberingPolicy to a) convert the Julian year to a cardinal number, b) subtract N from the year cardinal, and then c) convert the year cardinal back into a zeroless-ordinal number.  If the starting year is the Julian year 3 AD, and we want to subtract 5 years from it, then the correct final answer would be the year 3 BC.  The math works as follows: a) Since positive Julian years are ordinal numbers, converting the year 3 into a cardinal number results in the value 2; b) Subtracting 5 from 2 results in the cardinal number -3; c) Since negative Julian years (or any other negative zeroless-ordinal numbers) happen to be cardinal numbers, converting the cardinal -3 into a zeroless-ordinal results in the year number -3.

	Usage:

		NumberingPolicy protocol consists of the following messages that can be sent to a NumberingPolicy instance:
	
			Message Selector					Semantics

			canonicalFromCardinal:				Answers the conversion of the cardinal number argument into the type of 
												number represented by the receiver (i.e., cardinal, ordinal, zeroless-ordinal)	
	
			canonicalFromOrdinal:				Answers the conversion of the ordinal number argument into the type of 
												number represented by the receiver (i.e., cardinal, ordinal, zeroless-ordinal)	

			canonicalFromZerolessOrdinal:		Answers the conversion of the zeroless-ordinal number argument into the 
												type of number represented by the receiver (i.e., cardinal, ordinal, zeroless-ordinal)

			cardinalFromCanonical:				Answers the conversion of the argument (assumed to be whatever type of 
												number is represented by the receiver (i.e., cardinal, ordinal, zeroless-ordinal)) 
												into a cardinal number

			ordinalFromCanonical:				Answers the conversion of the argument (assumed to be whatever type of 
												number is represented by the receiver (i.e., cardinal, ordinal, zeroless-ordinal)) 
												into an ordinal number

			zerolessOrdinalFromCanonical:		Answers the conversion of the argument (assumed to be whatever type of 
												number is represented by the receiver (i.e., cardinal, ordinal, zeroless-ordinal)) 
												into a zeroless-ordinal number

		Conding Example:

			| julianYearNumberingPolicy year |
			julianYearNumberingPolicy := Calendar julian yearNumberingPolicy. 	"Get the yearNumberingPolicy of the Julian Calendar"
			year:= julianYearNumberingPolicy cardinalFromCanonical: 3.			"Convert the Julian year 3 AD into the cardinal number 2"
 			year := year - 5.														"Subtract 5 from the year cardinal (2), assiging the result (-3) to year"
			julianYearNumberingPolicy canonicalFromCardinal: year				"Convert the year cardinal number resulting from the previous step into a zeroless-ordinal Julian year number."

	Motivation:

		NumberingPolicies greatly enhance the ability to correctly deal with the different conventions for numbering years used by various calendrical systems.

	Subclassing:

		Subclasses that implement cardinal numbering (CardinalNumberingPolicy,) ordinal numbering (OrdinalNumberingPolicy,) and zeroless-ordinal numbering (ZerolessOrdinalNumberingPolicy) are provided.
!

NumberingPolicy subclass: #CardinalNumberingPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!CardinalNumberingPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	CardinalNumberingPolicy: Please refer to the class comment of my superclass, NumberingPolicy
!

!CardinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromCardinal: cardinal
	^cardinal! !

!CardinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromOrdinal: ordinal
	^ordinal - 1! !

!CardinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromZerolessOrdinal: zerolessOrdinal
	^zerolessOrdinal > 0 
		ifTrue: [zerolessOrdinal - 1]
		ifFalse: [zerolessOrdinal < 0 ifTrue: [zerolessOrdinal] ifFalse: [self signalZeroInvalid]]! !

!CardinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
cardinalFromCanonical: canonical
	^canonical! !

!CardinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
ordinalFromCanonical: canonical
	^canonical + 1! !

!CardinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
zerolessOrdinalFromCanonical: canonical
	^canonical > 0
		ifTrue: [canonical + 1]
		ifFalse: [canonical]! !

!NumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromCardinal: cardinal
	^self subclassResponsibility! !

!NumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromOrdinal: ordinal
	^self subclassResponsibility! !

!NumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromZerolessOrdinal: zerolessOrdinal
	^self subclassResponsibility! !

!NumberingPolicy methodsFor: 'API-conversion' stamp: ''!
cardinalFromCanonical: canonical
	^self subclassResponsibility! !

!NumberingPolicy methodsFor: 'API-conversion' stamp: ''!
ordinalFromCanonical: canonical
	^self subclassResponsibility! !

!NumberingPolicy methodsFor: 'API-conversion' stamp: ''!
zerolessOrdinalFromCanonical: canonical
	^self subclassResponsibility! !

NumberingPolicy subclass: #OrdinalNumberingPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!OrdinalNumberingPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	OrdinalNumberingPolicy: Please refer to the class comment of my superclass, NumberingPolicy
!

!OrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromCardinal: cardinal
	^cardinal + 1! !

!OrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromOrdinal: ordinal
	^ordinal! !

!OrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromZerolessOrdinal: zerolessOrdinal
	^zerolessOrdinal > 0 
		ifTrue: [zerolessOrdinal]
		ifFalse: [zerolessOrdinal < 0 ifTrue: [zerolessOrdinal + 1] ifFalse: [self signalZeroInvalid]]! !

!OrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
cardinalFromCanonical: canonical
	^canonical - 1! !

!OrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
ordinalFromCanonical: canonical
	^canonical! !

!OrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
zerolessOrdinalFromCanonical: canonical
	^canonical > 0
		ifTrue: [canonical]
		ifFalse: [canonical - 1]! !

NumberingPolicy subclass: #ZerolessOrdinalNumberingPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ZerolessOrdinalNumberingPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	ZerolessOrdinalNumberingPolicy: Please refer to the class comment of my superclass, NumberingPolicy
!

!ZerolessOrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromCardinal: cardinal
	^cardinal >= 0
		ifTrue: [cardinal + 1]
		ifFalse: [cardinal]! !

!ZerolessOrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromOrdinal: ordinal
	^ordinal > 0
		ifTrue: [ordinal]
		ifFalse: [ordinal - 1]! !

!ZerolessOrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
canonicalFromZerolessOrdinal: zerolessOrdinal
	^zerolessOrdinal! !

!ZerolessOrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
cardinalFromCanonical: canonical
	^canonical > 0
		ifTrue: [canonical - 1]
		ifFalse: [canonical < 0 ifTrue: [canonical] ifFalse: [self signalZeroInvalid]]! !

!ZerolessOrdinalNumberingPolicy methodsFor: 'testing' stamp: ''!
isZeroValid
	^false! !

!ZerolessOrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
ordinalFromCanonical: canonical
	^canonical > 0
		ifTrue: [canonical]
		ifFalse: [canonical < 0 ifTrue: [canonical + 1] ifFalse: [self signalZeroInvalid]]! !

!ZerolessOrdinalNumberingPolicy methodsFor: 'API-validation' stamp: ''!
satisfiesZeroConstraint: aValue
	^aValue == nil
		ifTrue: [false]
		ifFalse: [aValue ~= 0]! !

!ZerolessOrdinalNumberingPolicy methodsFor: 'API-conversion' stamp: ''!
zerolessOrdinalFromCanonical: canonical
	^canonical! !

!ZeroSensitiveRangeConstraint methodsFor: 'API-validation' stamp: ''!
assertValid: aValue
	(self satisfiesZeroConstraint: aValue)
		ifFalse: [self signalZeroInvalid].
 	super assertValid: aValue! !

!ZeroSensitiveRangeConstraint methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	super canonicalize.
	zeroInvalidException == nil
		ifTrue: [self setZeroInvalidException: Error].
	zeroInvalidMessage == nil
		ifTrue: [self setZeroInvalidMessage: 'The value zero is not valid in a zeroless ordinal numbering system.'].! !

!ZeroSensitiveRangeConstraint methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	self setZeroInvalidException: Error.
	self setZeroInvalidMessage: 'The value zero is not valid in a zeroless ordinal numbering system.'! !

!ZeroSensitiveRangeConstraint methodsFor: 'API-validation' stamp: ''!
isValid: aValue
	^(self satisfiesZeroConstraint: aValue) and: [super isValid: aValue]! !

!ZeroSensitiveRangeConstraint methodsFor: 'API-validation' stamp: ''!
satisfiesZeroConstraint: aValue
	^true! !

!ZeroSensitiveRangeConstraint methodsFor: 'initialize-release' stamp: ''!
setZeroInvalidException: anExceptionFactory
	self assertMutability.
	zeroInvalidException := anExceptionFactory! !

!ZeroSensitiveRangeConstraint methodsFor: 'initialize-release' stamp: ''!
setZeroInvalidMessage: aString
	self assertMutability.
	zeroInvalidMessage := aString! !

!ZeroSensitiveRangeConstraint methodsFor: 'accessing' stamp: ''!
zeroInvalidException
	^zeroInvalidException! !

!ZeroSensitiveRangeConstraint methodsFor: 'accessing' stamp: ''!
zeroInvalidMessage
	^zeroInvalidMessage! !

Calendar subclass: #RegularCalendar
	instanceVariableNames: 'yearlyCalendars'
	classVariableNames: 'StandardYearTypeCode'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

RegularCalendar class
	instanceVariableNames: 'monthlyCalendarSpecs'!

!RegularCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ArithmeticalCalendar

	Concept:

		RegularCalendar is an abstract Calendar class whose subclasses implement "regular" calendars.  A regular calendar is one that has a reasonably small number of year types.  A year type defines a specific number of months in the year and a specific number of days in each month.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of ArithmeticalCalendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		A regular calendar is one where there is a finite and relatively small number of "year types," where a "year type" a) defines a particular way of organizing the days of a year into months/days-of-the-month, and b) defines a deterministic mapping between day-of-year ordinals and month/day-of-month designations.
	 
		Typically, arithmetical calendars are RegularCalendars--although, at least theoretically, that does not have to be the case.

		The Gregorian Calendar (the de facto international standard civil calendar) is a regular calendar, as are the Julian, Bahai, Coptic, Ethiopic, Fatimid (Arithmetical Islamic,) Hebrew, Indian (Civil,)  and Persian calendars. Most regular calendars have only two year types: a "standard" year and a "leap" year.  The Hebrew Calendar, however, has six different year types: three with 352, 353 and 354 days per year respectively (all three of which have 12 months per year,) and three with 382, 383 and 384 days per year respectively (all three of which have 13 months per year.)

	Implementation:

		Instance Variables

			yearlyCalendars 											<Array of YearlyCalendar>
				Every year of an ArithmeticalCalendar is a year of a particular type.  Each year type differs from other year types by reason of some difference in one or more of the following: a) the number of months in the year, b) the number of days in one or more of the months, c) the semantic key of one or more of the months, d) the name key of one or more of the months, e) the numerical month designator of one or more of the months, f) the day-of-month ordinals of one or more months that are considered to be leap days, g) the mapping between day-of-year ordinals and month/day-of-month designations, or h) the number of days in the year. There are only a small, finite number of different year types defined by any ArithmeticalCalendar.  For each such year type, there is an integer code that is used to identify the corresponding year type.  The integer year type code corresponds to the index in the Array of YearlyCalendars (referenced by <yearlyCalendars>) of the instance of YearlyCalendar that specifies the month structure for a year of the type identified by that integer code.  See the class comment of YearlyCalendar for more information.

			doMonthOrdinalsAlwaysCorrespondToTheSameMonthKey		<boolean> 
				True if the association between month ordinals and month keys is invariant for all year types--otherwise false.  Generally true for all calendrical systems that have the same number of months in all year types.  A month key is a well-known key that semantically (culturally) identifies the "same month," even in cases where its month ordinal differs in different year types (this happens in the Hebrew Calendar, among others.)  The value of this variable is computed from the information in <yearlyCalendars>, and set during initialization of the instance.

		Class Instance Variables

			monthlyCalendarSpecs										<Array of Array of MonthlyCalendarSpec>
				There must be one Array of MonthlyCalendarSpecs in the outer Array (the one referenced by <monthlyCalendarSpecs>) for each 'year type' of the calendrical system implemented by instances of (concrete subclasses of) ArithmeticalCalendar.  There must be a MonthlyCalendarSpec in the inner Array for each month for each year type.  The index in the outer Array of each inner Array of MonthlyCalendarSpecs is the integer code of the year type whose month structure is specified by the inner Array with that index. The index of each MonthlyCalendarSpec in its containing Array becomes the month ordinal of the month specified by that MonthlyCalendarSpec. The value of <monthlyCalendarSpecs> is used to generate the value of the instance variable <yearlyCalendars> when an instance of (a concrete subclass of) ArithmeticalCalendar is instantiated/initialized. See the class comment of MonthlyCalendarSpec for more information.

				So: "monthlyCalendarSpecs at: 2" evaluates to an Array of MonthlyCalendarSpecs that specifies the month structure for the year type identified by the integer code 2; "(monthlyCalendarSpecs at: 1) at: 7" evaluates to a MonthlyCalendarSpec that specifies the properties of the seventh month of a year whose integer year type code is 1.

	Subclassing:

		The class method #setMonthlyCalendarSpecs must be subimplemented.  See the method comment for more information.
!

RegularCalendar class
	instanceVariableNames: 'monthlyCalendarSpecs'!

MonthsPerYearInvariantCalendar subclass: #RomanicCalendar
	instanceVariableNames: 'secondsFromEpochUpToGregorianStart'
	classVariableNames: 'LeapYearTypeCode'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!RomanicCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

RomanicCalendar

	Concept:

		RomanicCalendar is an abstract class whose concrete subclasses implement calendrical systems that use the same month structure as the Julian and Gregorian calendars--which ultimately derives from ancient, Imperial Rome. It also provides for specifying the canonical moment of transition to the offical, civil usage of the Gregorian Calendar (which is currently the de-facto civil calendar for most nations of the world.)

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Julian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: January					31/31
			2: February					28/29
			3: March					31/31
			4: April						30/30
			5: May						31/31
			6: June						30/30
			7: July						31/31
			8: August					31/31
			9: September				30/30
			10: October					31/31
			11: November				30/30
			12: December				31/31
			
			Days In Year				365/366

	Implementation: 

		Insance Variables

			secondsFromEpochUpToGregorianStart	<Integer>
				The number of seconds from the instance's epoch up to the canonical moment of official/legal transition to the Gregorian Calendar. The value of this variable is computed and set during initialization of the instance.

	Subclassing:

		The instance method #computeSecondsFromEpochUpToGregorianStart must be subimplemented by any concrete subclass.  See the method comment for the method semantics.
	!

ComparableDuration subclass: #ScientificDuration
	instanceVariableNames: 'seconds nanosecondsSinceSecond'
	classVariableNames: 'Zero'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!ScientificDuration commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ScientificDuration [Aliased by the global Duration, unless that conflicts with a native global of the host Smalltalk environment]

	Concept:

		ScientificDuration implements the protocol <Duration> (and ScientificDuration class implements the protocol <DurationFactory>) as defined and specified by the ANSI-Smalltalk Standard. As required by the Standard, the global Duration is defined as an alias for ScientficDuration (unless there is already a global by that name defined in the standard environment of the host Smalltalk system in which this copy of the Chronos Date/Time library happens to be installed.)

		A ScientificDuration (or an ANSI-Smalltalk Duration) is a "temporal extent" or "duration of time" that represents a scalar number of seconds (including fractions of a second.) It is one of the two different types of Durational (the superclass) provided by Chronos. The other type of Durational provided by Chronos is implemented by the classes CalendarDuration and CivilDuration (which see.)

		For more in depth conceptual discussion, see the class comment of Durational (the superclass.)

	Usage:

		Instances of ScientificDuration can be used as arithmetic operands with each other, and with instances of TemporalCoordinate (whose concrete subclasses include Timepoint, YearMonthDay and TimeOfDay--all of which see.) TemporalCoordinates can compute the temporal extent between any two instances, providing the result as a Durational instance. A Timeperiod specifies the temporal extent of the temporal inteveral it represents using a Durational instance. A ChronosTimezone uses a ScientificDuration to represent its offset from Universal Time.

		Key methods of Durational, CalendarDuration, CivilDuration and ScientificDuration have "do its" in their comments that provide usage examples.

		Many of the methods of Durational and ScientificDuration implement message signatures as specified and required by the ANSI-Smalltalk Standard.  As is true throughout the Chronos codebase, many of the others are implemented as an analogy to those required by ANSI Smalltalk (i.e., in the same style and/or spirit--both in terms of naming conventions and semantics.)

		As is the case with most Chronos classes, instances of ScientificDuration will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		Note that the instance creation messages (class messages) #days: and #seconds: (and many of the variations thereof) will correctly handle either integer or non-integer numeric arguments.

	Motivation:

		The ANSI-Smalltalk standard requires that durational values be supported as a type distinct from that of point-in-time values.

		Secondly, although in some contexts/situations it is both necessary and proper to represent a duration of time using a "raw" numeric value, it is usually superior to encapsulate a durational value in an object that knows the semantics and behavior of the represented temporal extent.  This avoids the possibility that raw numeric values will be misinterpreted as a number of seconds when they actually represent a number of days, hours or tenths of a microsecond.  Even better, it enables such values to collaborate with other objects with greater semantic precision, and in ways that can be made much more specific to the functional intent of the value.  It is much easier to define and understand the meaning of adding a durational value to a point-in-time value, than it would be to define or understand the meaning of adding a raw number (a number of what?).

		Thirdly, because calendrical/civil time/business semantics are not appropriate for all durational values, there must be a type of duration that does not count days separately/independently of seconds, nor count years/months at all. Scientific and technical use cases require temporal extents that have a well-defined physical meaning, and that function as scalar values in a monotonic, uniform and gauge-invariant manner.  ScientificDuration is implemented to meet such needs.

	Implementation:

		The implementation represents a temporal extent as a count of seconds and nanoseconds, converting seconds to nanoseconds and nanoseconds to seconds as necessary.  The reason for this architecture is to hopefully minimize the usage of LargeIntegers, and also because an integer number of seconds is so commonly and generally needed, that it makes sense to store the durational information as a number of integer seconds. The instance variables (and many of the methods) used for this purpose are inherited from Durational (which see.)

		Instance Variables

			seconds 					<Integer>
				The integer part of the "seconds" element of the instance's duration vector. 

			nanosecondsSinceSecond	<Integer>
				Represents, as an integer number of nanoseconds, the fractional part of the "seconds" element of the instance's duration vector. When the instance is in canonical form, the value of <nanosecondsSinceSecond> must be positive or zero if the value of <seconds> is positive, and must be negative or zero if the value of <seconds> is negative--and the absolute value of <nanosecondsSinceSecond> must be less than the number of nanoseconds in a second (NanosecondsPerSecond = 1,000,000,000.)


		Class Variables

			Zero		<ScientificDuration>
				A constant ScientificDuration that represents a temporal extent of zero.  Accessed by sending the message #zero to the class (as specified and required by the ANSI-Smalltalk Standard.)  The global ZeroDuration (defined in the namespace ChronosDurationConstants) serves as an alias of 'ScientificDuration zero'.




!

ChronosObject subclass: #SemanticDateObservanceRule
	instanceVariableNames: 'yearBase yearPeriod expirationYear dayOfWeekPolicy dayOfMonthConstraints'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Semantic Dates'!

MonthsPerYearInvariantCalendar subclass: #SolarianCalendar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!SolarianCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

SolarianCalendar

	Concept:

		SolarianCalendar implements the Solarian Calendar.  The SolarianCalendar is an invention of the author of Chronos.  It was designed to ensure that, as far as possible, the solstices and equinoxes should occur on either the first of a month, or else on the last day of the previous month.  The formal, official specification of the Solarian calendrical system has not yet been finalized.

		For any and all discussion of what a 'Calendar' is conceptually, how an instance of a Calendar can and/or should be used, the general implementation requirements for subclasses of Calendar, or the architectural requirements and responsibilities of Calendar instances with respect to the rest of the Chronos Date/Time Library, please refer to the documentation of class Calendar.  The remainder of this text discusses the specific nature of the Solarian Calendar itself (and its implementation by this class,) and assumes that the reader has already become familiar with all the concepts and terminology documented in class Calendar.

		The Solarian Calendar is an arithmetical, solar calendar. A solar calendar is one that attempts to match the (average) length of its years to that of mean solar years.

		Epoch Date

			The epoch date of the Solarian Calendar, 0001-01-01 [Solarian], corresponds to 4236-12-23 [Gregorian] (astronomical year numbering) and to -4236-01-26 [Julian] (traditional year numbering.)  The Julian Date of the epoch of the Solarian Calendar is 174,249.50 (midnight.) 

			The epoch date of the Solarian Calendar is the Winter Solstice of the year in which the ancient Egyptian Calendar was founded, which corresponds to 4236 BC. This is the earliest recorded year in history.

			The name of the Solarian Calendar's era is "Solarian Year" (SY)--which is in English, obviously.

		Time-of-Day Clock

			Midnight is both the zero-point of the time-of-day clock and also the initial moment of the day.  

			{SolarianCalendar clock today}
			{SolarianCalendar clock now}

		Year Numbering Policy

			The Solarian Calendar uses ordinal year numbering.  This means that the epoch year is an ordinal number whose value is 1, and the year that immediately precedes the year 1 is the year 0.

		Leap Year Rule

			There is a master cycle of 2820 years, during which 683 years are leap years. Each standard year contains 365 days, and each leap year contains 366 days, so the master 2820-year cycle contains 1,029,983 days [(2820 * 365) + 683 = 1,029,983].  Based on the current mean length of the tropical year and solar day, there are 1,029,983.00118 days in 2820 tropical years.  So, were it not for the fact that a) the length of the tropical year and the length of a mean solar day is slowly changing, and b) the length of the tropical year (which is defined by the duration between winter solstices) is not the same as the length of the spring equinoctial year (which is defined by the duration between vernal equinoxes,) it would be fair to say that the Solarian calendar deviates from the length of a year by only 101.952 minutes in 2820 years.  But for those (and other) caveats, the Solarian calendar would slip from perfect alignment with the tropical year by only one day every 39,829.68 years--which is astounding accuracy, in spite of the caveats. 

			Within each 2820-year cycle, there are 22 subcycles--the first 21 each contain 128 years, and the 22nd (final) subcycle contains 132 years [2820 = 21 * 128 + 132].

			Each 128-year subcycle contains one 29-year sub-subcycle (the first,) followed by three 33-year sub-subcycles [128 = 29 + (3 * 33)].

			Each 132-year subcycle contains one 29-year sub-subcycle (the first,) followed by two 33-year sub-subcycles, followed by one 37-year sub-subcycle [132 = 29 + (2 * 33) + 37].

			A year in a sub-subcycle (whether it contains 29, 33 or 37 years) is a leap year if the ordinal index of the year within the cycle satisfies the following two predicate tests: 1) it's greater than 1, and 2) the remainder after dividing it by 4 is 1 (so the first year in sub-subcyle is never a leap year; the first leap year is the fifth year in the sub-subcycle.) Thus, a 29-year sub-subcycle has 7 leap years, a 33-year sub-subcycle has 8 leap years, and a 37-year sub-subcycle has 9 leap years (Note: the last year of a sub-subcycle is always a leap year, since 29, 33 and 37 all result in a remainder of 1 when divided by 4) [21 * (7 + (3 * 8)) + (7 + (2 * 8) + 9) = 683].

		Month Structure

			Month					Days In Month
								Standard Year/Leap Year					
			1: Month1					28/28
			2: Month2					30/31
			3: Month3					31/31
			4: Month4					31/31
			5: Month5					31/31
			6: Month6					31/31
			7: Month7					31/31
			8: Month8					31/31
			9: Month9					31/31
			10: Month10				31/31
			11: Month11				31/31
			12: Month12				28/28

			Days In Year				365/366

			The names of the months are acutually unspecified.  It is the responsiblity of each culture/language group to devise or evolve month names that are appropriate to their language and culture. The semantic month-key of a month is the English word #Month followed by one or more digits that identify the month ordinal.


			
	
!

BasicTimezone subclass: #StandardTime
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!StandardTime commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

StandardTime

	Concept:

		StandardTime implements "bound, dynamic" time zones, as described in the superclass BoundTimezone.  A StandardTime represents the (offset, abbreviation) tuple that defines local "standard time" during some range (or ranges) ot point-in-time values within the territorial domain of a time zone.  For example, the StandardTime instance whose key is #'Pacific/Honolulu', whose offset from UT is -10 hours, and whose abbreviation is #HST functions as the "bound, dynamic" time-zone for all point-in-time values in Hawaii from 1947-06-08T02:00:00 HST up until the time that his comment was written (2005,) and for for some presently-unknown span of time into the future (i.e., until either the State of Hawaii decides to change one or both of those values yet again--or perhaps to begin observing Daylight Saving Time.)

	Usage:

		A StandardTime conforms to both the Chronos "BOUND TIMEZONE API" and "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.)  Support for the Chronos "UNBOUND TIMEZONE API" is inherited from the superclass ChronosTimezone.

		==>> Note that `bound, dynamic` time zones (such as instances of StandardTime or NonStandardTime) are not allowed to have offsets from UT that have fractional seconds. <==

		See either the individual method comments, or the superclasses BasicTimezone, BoundTimezonie or ChronosTimezone, or the collaborating class VaraibleOffsetTimezone, for any further information.

	Implementation:

		Instance Variables

			key			<Symbol>	The key that identifies the time zone represented by the instance. If and only if it's the key of an Olson time zone (or it it's otherwise a universally well-known key,) it must be universally unique. Unless it's the special value #system, it must be unique within an image (or within an OS process, if the Smalltalk environment is not image based.)


	!

CalendarDay subclass: #StaticCalendarDay
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!StaticCalendarDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

StaticCalendarDay

	Concept:

		A StaticCalendarDay is a CalendarDay (which see) that is specialized for collaboration with a StaticMonthlyCalendar (also which see.)

	Usage:

		As is the case with most Chronos classes, StaticCalendarDay instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:
!

MonthlyCalendar subclass: #StaticMonthlyCalendar
	instanceVariableNames: 'prevInYear nextInYear days'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!StaticMonthlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

StaticMonthlyCalendar

	Concept:

		A StaticMonthlyCalendar is a MonthlyCalendar (which see) that is preinitialized to encapsulate a flyweight instance of StaticCalendarDay for each day in the month it represents.  StaticMonthlyCalendar must be used in collaboration with StaticYearlyCalendar and StaticCalendarDay.

	Usage:

		As is the case with most Chronos classes, StaticMonthlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			prevInYear 	<StaticMonthlyCalendar | nil>
				The StaticMonthlyCalendar that represents the month of the instance's year type that immediately precedes the month represented by the instance (if any).
			nextInYear 	<StaticMonthlyCalendar | nil>
				The StaticMonthlyCalendar that represents the month of the instance's year type that immediately follows the month represented by the instance (if any).
			days 		<Array of StaticCalendarDay>
				The StaticCalendarDay at the <D>th index in the array specifies the properties of the <D>th day of the month represented by the instance.
!

YearlyCalendar subclass: #StaticYearlyCalendar
	instanceVariableNames: 'months days'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Regular'!

!StaticYearlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

StaticYearlyCalendar

	Concept:

		A StaticYearlyCalendar is a YearlyCalendar (which see) that is preinitialized to encapsulate a flyweight instance of StaticMonthlyCalendar for each month in the type of year it represents, and to encapsulate a flyweight StaticCalendarDay for each day of the type of year it represents.  

	Usage:

		As is the case with most Chronos classes, StaticYearlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			months <Array of StaticMonthlyCalendar>
				The StaticMonthlyCalendar at the <M>th index in the array specifies the properties of the <M>th month of the year represented by the instance.
			days 	<Array of StaticCalendarDay>
				The StaticCalendarDay at the <D>th index in the array specifies the properties of the <D>th day of the year represented by the instance.
!

TemporalInterval subclass: #TemporalCoordinate
	instanceVariableNames: ''
	classVariableNames: 'HoursSinceStartOfDayRangeConstraint MinutesSinceHourRangeConstraint NanosecondsSinceSecondRangeConstraint SecondsSinceMinuteRangeConstraint SecondsSinceStartOfDayRangeConstraint'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!TemporalCoordinate commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

ChronosPrintable subclass: #TemporalInterval
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!TemporalInterval commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

TemporalInterval

	Concept:

		TemporalInterval is an abstract class. An instance of a concrete subclass of TemporalInterval represesents a temporal interval--specifically, a left-closed, right-open interval of time.  A temporal interval is a temporal extent that starts at a particular point-in-time. A left-closed, right-open interval is one that includes its left endpoint (its starting point,) but does not include its right endpoint (its ending point, or limit value.) The left endpoint of a TemporalInterval is the initial moment contained by the interval. The right endpoint/limit value is that point-in-time computed by adding the TemporalInterval's temporal extent to its starting point-in-time. Since a TemporalInterval represents an interval that includes its starting point-in-time, but does not include its ending point, a TemporalInterval representing the interval that started at the most recent local midnight, and whose temporal extent is one calendrical/civil day, asymptotically spans up to but does not include the next day's midnight.

		A TemporalInterval also represents a value associated with or related to a particular Calendar (which see.) TemporalInterval provides protocol for accessing the Calendar to which a TemporalInterval is associated, and for accessing properties of the associated Calendar (e.g, does the associated Calendar have an invariant number of months per year?)

		TemporalInterval also provides/implements "Magnitude" behavior/protocol (comparison operators,) Immutable behvavior/protocol and ChronosObject behavior/protocol.

		A TemporalInterval has the attributes #resolutionQuantum and #duration. The #resolutionQuantum of a TemporalInterval is the minimum non-zero interval of time by which one instance of a concrete subclass of Calendrical can differ from that of another instance of the same class. The #duration of a TemporalInterval is the interval of time spanned by the instance. Although the #resolutionQuantum and the #duration will often be the same, there are cases where they differ (see, for example, Timeperiod). The #resolutionQuantum and the #duration attributes are both represented by instances of Durational (e.g., a ScientificDuration or a CalendarDuration.)

	Usage:

		The starting point of a TemporalInterval can be accessed by sending the message #start to a Timeperiod instance.

		The temporal extent of a TemporalInterval is represented by an instance of Durational (which see,) and can be accessed by sending the message #duration to a TemporalInterval instance. The temporal extent may be negative--in which case the TemporalInterval's endpoint (limit value) is temporally prior to its starting point.  Also, the temporal extent may be either a simple scalar number of seconds, or a vector specifying some number of years, months, days, hours, minutes and seconds. 

		The end-point or "limit value" of a TemporalInterval is computed by adding its temporal extent (duration) to its starting point.  It can be accessed by sending the message #limit to an instance.  The end-point/limit is not included by the TemporalInterval.

		The granularity of a TemporalInterval is defined to be the quantum of resolution of its starting point-in-time (accessible by sending the message #granularity to a Timeperiod instance.)  The quantum of resolution of a date value is one calendar day.  The quantum of resolution of a DateAndTime value is the same as that of a Duration value--currently implemented to be one nanosecond. 

		In the case of a TemporalInterval with a positive duration, its "closed extent" is (conceptually) the temporal extent (duration) of the **fully-closed** interval that contains every point-in-time that is greater than or equal to the TemporalInterval's earliest point-in-time, and less than its latest point-in-time. In the case of a TemporalInterval with a negative duration, its "closed extent" is (conceptually) the temporal extent (duration) of the **fully-closed** interval that contains every point-in-time that is less than or equal to the TemporalInterval's latest point-in-time, and greater than its earliest point-in-time. Physically, its "closed extent" is defined to be the temporal extent (duration) computed by subtracting the TemporalInterval's granularity from its temporal exent (i.e., "aTimeperiod duration - aTimeperiod granularity.") It can be accessed by sending the message #closedExtent to a TemporalInterval instance.

		The first element of a Timeperiod is its starting point-in-time. It can be accessed by sending the message #first to a Timeperiod instance (to provide a small degree of polymorphism with SequenceableCollections/Intervals.)  The last element of a Timeperiod is the point-in-time computed by adding the Timeperiod's closed extent to its starting point-in-time ("aTimeperiod start + aTimeperiod closedExtent." The last element of a Timeperiod can be accessed by sending the message #last to an instance. 
		
		The quantum of resolution of the last element may or may not be the same as that of the first element, depending upon the nature of the Durational value that represents the TemporalInterval's closed extent (if it's either a non-zero ScientificDuration, or a CalendarDuration where the "seconds" element of its duration vector is non-zero, then the TemporalInterval's last element will have a 1-nanosecond quantum of resolution.)  For example, "(Timeperiod dayStartingAt: Timepoint today) last" evaluates to the final nanosecond of the current day, but "(Timeperiod quarterStartingAt: YearMonthDay today) last" evaluates to the last date of the quarter that started on today's date. The last day of the quarter, since it's a date value, conceptually includes all the points-in-time of that date, because the quantum of resolution of a Chronos date value is 1 calendar day, and a Chronos point-in-time value implicitly represents a left-closed, right-open interval, whose starting point (left endpoint) is the moment nominally designated by the value, and whose (open) temporal extent is the value's quantum of resolution.

		TemporalInterval introduces the API message #compareTo:, which is used to compute the relative ordering between two values (less than, equal to or greater than.)  See the method comment of #compareTo: for specific details.
	
	Implementation:

		Unlike class Magnitude, Calendrical implements all the other comparison methods using #compareTo:.

	Subclassing:

		Subclasses that store an instance of Calendar must subimplment the #invalidateCalendar method.

		Concrete subclasses must subimplement the following instance methods:
		
			#compareTo:
			#initializeFromLiteralArray:		(also see the class method #basicDecodeFromLiteralArray:)
			#literalArrayEncoding
		
!

TemporalCoordinate subclass: #TimeOfDay
	instanceVariableNames: 'hour minute second nanosecondsSinceSecond'
	classVariableNames: 'StartOfDay'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!TimeOfDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

CalendricalCoordinate subclass: #Timeperiod
	instanceVariableNames: 'start duration'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!Timeperiod commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

Timeperiod

	Concept:

		A Timeperiod is a TemporalInterval (which see) whose duration may be specified to be any durational value.

	Usage:

		The starting point of a Timeperiod may be any TemporalCoordinate (which see,) and can be accessed by sending the message #start to a Timeperiod instance. The Calendar associated with a Timeperiod is the same as the Calendar of its starting point.

		A Timeperiod can be used for the following purposes:

			1. To determine whether a point-in-time occurs during a particular temporal interval (e.g., "Timeperiod today includes: Gregorian clock now.")
			2. To determine whether one temporal interval intersects, contains or is adjacent to another (e.g., "Timeperiod today isAdjacentTo: YearMonthDay today tomorrow asTimeperiod.") 
			3. To compute the union or intersection of two temporal intervals (e.g., "Timeperiod currentYear * (Timeperiod yearStartingAt: YearMonthDay today).").
			4. To compute the temporal interval that results from adding/subtracting a temporal extent to/from a temporal interval's starting point-in-time--preserving the interval's exent (e.g., "(Timeperiod dayStartingAt: Gregorian clock now) + (CalendarDuration months: 6)").
			5. To compute and/or enumerate over a sequence of smaller temporal intervals contained by a larger temporal interval (e.g., "(Timeperiod yearStartingAt: YearMonthDay today) quartersDo: [:eachQuarter | Transcript cr; show: eachQuarter printString].")
			6. To compute and/or enumerate over a succession of temporal intervals, each starting at the endpoint of its predecessor, and having the same temporal extent (e.g., "(Timeperiod from: TimeOfDay now duration: HourDuration) next: 24.")

		See the individual method comments for more details.

	Implementation:

		Instance Variables

			start 		<TemporalCoordinate>
				The starting point-in-time ("left endpoint") of the temporal interval represented by the instance--this moment is included in the interval.
			duration 	<Durational>
				The temporal extent of the temporal interval represented by the instance.  The point-in-time computed by adding the <duration> to the <start> is the "right endpoint" or "limit" of the instance's temporal interval--and is NOT included in the interval (although all points-in-time asymptotically approaching the limit value "from the left" (from the <start> value) are included.) The <duration> may be either a scalar number of seconds (as implemented by ScientificDuration) or a vector specifying some number of years, months, days and seconds (as implemented by CalendarDuration.) The <duration> may be either positive or negative.

!

YearMonthDay subclass: #Timepoint
	instanceVariableNames: 'daysSinceEpoch secondsSinceStartOfDay nanosecondsSinceSecond timeZone'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

Timepoint class
	instanceVariableNames: 'universalTZ nominalTZ utcTZ'!

!Timepoint commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

Timepoint [Aliased by the global DateAndTime, unless that conflicts with a native global of the host Smalltalk environment]

	Concept:

		## NOMINAL TIME INVARIANCE vs. UNIVERSAL TIME INVARIANCE {this section is strongly recommended for all Chronos users}
		
		## UNIVERSAL TIME (UTC,) COORDINATED UNIVERSAL TIME (UTC) and LEAP SECONDS {if you don't care about timescales and/or leap seconds, you may skip this section}

			The formal name of the standard international reference zero-offset timezone is Universal Time (UT, although it is colloquially referred to as GMT more often than not--even by techies.) The formal name of the standard international reference timescale is Coordinated Universal Time (UTC.) However, UT and UTC are technically not the same thing at all: UT is a timezone; UTC is a timescale.  

			Universal Time, and any other timezone, can be used with any terrestrial timescale that uses Greenwhich Mean Time (directly or indirectly) to establish the zero-point of the time-of-day clock.  Were such not the case, it would be impossible for any country that didn't use the UTC timescale to define its timezones as offsets from Universal Time--and not all countries use the UTC timescale as the basis for their civil time-of-day, even though they all define their timezones as offsets from Universal Time. Universal Time is simply the timezone whose offset from the specific timescale of one's choice (UT0, UT1, UTC, etc) is an invariant 0.0 seconds.

			UTC is also quite commonly used as a synonum for UT, even though the former is technically a timescale and the latter is technically a timezone. In addition to the use of GMT as a synonym for UT, this can create no small amount of confusion and/or bogosity.  For example, many date/time libraries use the term UTC to mean the timezone UT.  They cannot possibly be literally referring to the UTC timescale, since they do not support leap seconds.  The same is true of international standards such as POSIX and the ANSI Smalltalk Standard.

			For example, the ANSI-Smalltalk standard says the following with respect to the behavior of the <DateAndTime> protocol:

				"This protocol describes the behavior that is common to date time objects. Date time objects represent individual points in Coordinated Universal Time (UTC) as represented in an implementation defined local time. The exact properties of local times are unspecified. Local times may differ in their offset from UTC. A given local time may have different offsets from UTC at different points in time. All dates and times in the UTC local time are in the Gregorian calendar. Date times prior to the adoption of the Gregorian calendar are given in the retrospective astronomical Gregorian calendar. The year 1 B.C. is astronomical Gregorian year 0. The year 2 B.C. is astronomical Gregorian year-1. The year 1 A.D. is astronomical Gregorian year 1. The offset of the UTC local time is zero."

			Given the precisely-specified requirements, the lack of any mention of leap seconds stands out. The X3J20 committee's specification does bother to define UTC as the timezone whose local time offset is zero. But why say that much, while saying nothing about leap seconds? 

			If the X3J20 committe intended "Coordinated Universal Time (UTC) " to be a reference to UTC as a timescale, including its use of leap seconds, then why did they take such care in the specification of the semantics of <DateAndTime> values, without any explicit requirement to handle leap seconds?  To be consistent with the level of detail on other matters, had the committee intended to require the proper handling of leap seconds, they should have a) said so explicity, b) specified the moment of insertion of the 10 "floating" leap seconds from 1955 to 1972 whose moments of insertion are not specified anywhere by any international standard, and c) specified how leap seconds in the future, and before 1955, should be dealt with (Ignore them? Estimate them? Provide for dynamic leap second notification? Leave such questions as implementation defined--which they usually **explicitly** do for other issues?).

			Consider also the ANSI-Smalltalk Standard's documentation of the message DateAndTime>>second, which says the following: "Answer a <number> greater than or equal to 0 and strictly less than 60 representing the second of the minute of the local time of the receiver."  This statement actually forbids leap seconds, since a leap second would have the cardinal value 60, which is not legal (the cardinal number of seconds must be "strictly less than 60.")

			Finally, there is the fact that earlier draft versions of the Standard did explicitly require the correct handling of leap seconds.  The statements in the X3J20 specification that required leap second handling were deliberately removed from the later (and final) versions of the standard, because the members of the X3J20 committee decided that mandatory support for leap seconds would be too great a burden (that information comes from public statements made by members of the X3J20 committee, including a written statement by Douglas Surber, who was the principal author of the section of the standard that deals with date and time protocols.)  So, although the ANSI Smalltalk standard states that <DateAndTime> values are coordinate points in UTC, it is beyond reasonable doubt that "UTC" is being (incorrectly) used in this case as a synonym for Universal Time, without reference to a specific timescale.  Such (mis)usage of the term "UTC" is quite common, even in contexts where one might rightly expect a high level of rigour and precision in the use of technical terms.

			Similarly, the VisualWorks documentation says the following with respect to the operation of the VisualWorks system clock primitive (which returns the number of clock ticks since 1901-01-01T00:00:00+00:00 as a count of microseconds):  "With the arrival of the object engine's microsecond clock, which provides the time in UTC (GMT) for all platforms, all users must now set the TimeZone."  However, it is easy to prove either that the implementation is broken, or that the author of this statement meant the timezone UT, not the timescale UTC. Without even considering the actual behavior of the VW system clock, the parenthetical "GMT" in this statement strongly suggests the latter interpretation.

			To the best of the author's knowledge, the "vanilla" version (as delivered in the default image) of all date/time libraries that claim to be compliant with the ANSI-Smalltalk Standard do not handle leap seconds, and use the UT1 timescale.  However, David T. Lewis has implemented an optional module for Squeak (available from SqueakMap) that enhances Brent Pinkney's ANSI-compliant Chronology Date/Time library (currently the native date/time library of Squeak) so that it supports leap seconds.

			The fact is, few computer operating systems natively support leap seconds.  Windows does not.  MacOS and MacOS-X do not.  POSIX-compliant systems are forbidden from doing so. The fact that POSIX systems emit timestamp strings that use "UTC" to indicate the UT timezone just adds to the general confusion.  POSIX is far from the only offender in this regard (e.g, Java.).  It would be easier to list the systems that do use the term UTC correctly--or that actually correctly implement leap seconds.

			The bottom line is this: any system which expects sub-second timing precision needs to be very carefully designed, taking into account all of the sources of delay and error. In more plain language, what the *&%#$!! are you thinking if you expect to use the system clock in your computer for precision timing? Few computer clocks are accurate to anywhere near one second every year--and that's the level of accuracy needed before the distinction between UT1 and UTC begins to have any relevance whatsoever.  Nevertheless, some use cases actually do require that degree of accuracy, and some applications have to correctly handle very precise UTC timestamps--perhaps generated by special (and expensive) clocks other than those installed on the motherboard of a laptop or desktop personal computer, or else generated by local clocks that are disciplined by means of the Network Time Protocol (which periodically synchronizes local clocks with atomic clocks over a network, and measures and corrects for the inaccuracies of the local clocks, greatly enhancing the effective accuracy of the local clocks.) For this reason, full support for leap seconds is planned for a future release of the Chronos Date/Time library.

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

Timepoint class
	instanceVariableNames: 'universalTZ nominalTZ utcTZ'!

CalendarClock subclass: #UTCalendarClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!UTCalendarClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UTCalendarClock

	Concept:

		A UTCalendarClock is CalendarClock (which see) specialized for encapsulating a ChronosSystemClock that reports time relative to the UT timezone.

!

BoundTimezone subclass: #UniversalTime
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!UniversalTime commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UniversalTime

	Concept:

		UniversalTime implements the international reference zero-offset time zone whose formal name is Universal Time, and whose formally-correct abbreviation is UT.  However, this time zone is quite commonly referred to by a variety of other names and abbreviations--some of which are more widely used than the formally-correct ones.  Such names/abbreviations include Greenwich Mean Time (which is technically a timescale, not a time zone,) GMT (which is the abbreviation for Greenwich Mean Time,) Coordinated Universal Time (which is also technically a timescale, not a time zone,) UTC (which is the abbreviation for Coordinated Universal Time,) Zulu and Z (and there are others, especially in languages other than English.) [Briefly: A time zone is an offset or translation from a timescale or from some other time zone; a timescale defines an absolute temporal coordinate system by specifying an epoch (the zero-point of the timescale) and the temporal extent (size, duration) of the units used to measure the passage of time relative to the epoch. What those who use 'UTC' as the abbreviation of a timezone ought to (metaphorically) mean by such usage (although they typically don't) is 'the international reference timezone whose offset from the UTC timescale is zero.' The moral of the story is to be aware that "UTC" is quite often (incorrectly) used to mean 'the international reference timezone whose offset from the Greenwich Mean Time timescale is zero')--and, although the difference between the incorrect and correct meaning of UTC is never more than 0.9 seconds, that may be quite a large discrepancy in some technical/scientific contexts.]

		An instance of UniversalTime is a Chronos "bound, static" time zone, as specified and explained by the comment of the superclass BoundTimezone..

		See the class comments of BoundTimezone, ChronosTimezone and Timescale (once it's implemented, which it currently is not) for more information.

	Usage:

		The canonical instance of UniversalTime can be accessed by sending the (class) messages #universal or #ut to ChronosTimezone (e.g., 'ChronosTimezone universal',) or by using any of the following timezone keys to look up a time zone by its key: #Universal, #'Universal Time', #UT, #UTC, #GMT, #Zulu or #Z (e.g., 'ChronosTimezone at: #GMT.') The canonical key of the Universal time zone is #Universal.

!

ChronosTimezone subclass: #VariableOffsetTimezone
	instanceVariableNames: 'namespaceKey key policy'
	classVariableNames: 'Registry'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!VariableOffsetTimezone commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

VariableOffsetTimezone

	Concept:

		A VariableOffsetTimezone iimplements "unbound, dynamic" time zones.  A "bound" Chronos time zone is one whose single, specific offset-abbreviation tuple is or can be "bound to" (properly associated with) a specific point-in-time.  An "unbound" Chronos time zone is one that does NOT specify a single, specific offset and abbreviation that can be "bound to" (properly associated with) a specific point-in-time. A "static" Chronos time zone is one whose offset-abbreviation tuple is not subject to retroactive changes--for a static time zone, the binding of a point-in-time value to the offset-abbreviation tuple of its time zone is permanent for all time. A "dynamic" Chronos time zone is one whose offset-abbreviation tuple (or tuples) is subject to retroactive changes--for a dynamic time zone, the binding of a point-in-time value to the offset-abbreviation tuple currently specified by its time zone is not necessarily permanent.

		Although it may not in fact do so, a VariableOffsetTimezone is intended to represent the full diachronic history of the timezone rules for a particular location, such as New York, New York {Timezone at: 'America/New_York'}, Davos, Switzerland {Timezone at: 'Europe/Zurich'} or Ulaan Bator, Mongolia {Timezone at: 'Asia/Ulaanbaatar'}.  A VariableOffsetTimezone will normally have at least two offsets from Universal Time, and at least two abbreviations.  Most will have more.  So you can't just ask a VariableOffsetTimezone for its offset from Universal Time--it almost certainly has more than one (and even if it did have only one, the fact that its ruleset is subject to retroactive change would still require that it be not treated as equivalent to either a "bound" or a "static" timezone.) 

		See the class comment of ChronosTimezone for more in depth conceptual information about time zones, and for more information about the general characteristics and API of all Chronos time zones.

	Usage:

		A VariableOffsetTimezone conforms to and directly reimplements the Chronos "UNBOUND TIMEZONE API" as specified and explained in the "Usage:" section of the class comment of ChronosTimezone (about 10% from the bottom of the extensive and long class comment.) 

		## KEYS; IDENTITY; LOOKUP

			Usually, VariableOffsetTimezones are uniquely identified by well-known, globally-defined keys and their rulesets are persistently stored in an external repository. However, it is also possible to create ad-hoc/transient instances of VariableOffsetTimezone whose keys are not globally well-known and/or whose rulesets are not persistently stored externally. However, since it is not possible to authoritatively determine whether the key of a VariableOffsetTimezone is in fact a globally well-known value, Chronos simply assumes that the key of any VariableOffsetTimezone stored in the peristent, external time zone repository is globally well known [for Chronos as delivered by the author, this assumption is valid--but it is possible for clients of Chronos to define and add their own time zone ruleset definitions, identified by keys of their choice,  to the Chronos time zones repository--although how to do this is currently not documented, and parhaps won't ever be unless it's requested.]  

			The key of a VariableOffsetTimezone is a Symbol.  As delivered by the author, all persistently-stored, globally-well-known VariableOffsetTimezones (and their keys) are as defined by the Olson Timezone Database (the same one used by UNIX.) The Olson time zone keys usually (but not always) have the form <continent>/<city> or <ocean>/<city>, such as 'Europe/London', 'Asia/Calcutta' or 'Pacific/Auckland'. However, as previously mentioned, clients of Chronos are allowed to define their own variable-offset time zones having any desired key--which do not have to be globally well known, and do not have to be persistently stored in the Chronos time-zones repository. 

			Note: The canonical key of the timezone whose proper name is Universal Time is #Universal.  However, a variety of aliases are supported: #'Universal Time', #UT, #UTC, #GMT, #Z and #Zulu. Although some of the same keys are defined (and in some cases, used without any definition) in the Olson Time Zone databse, Chronos ignores and does not use the Olson definition of Unversal Time.  The ChronosTimezone that implements Universal Time is the canonical instance of the class UniversalTime--it's not a VariableOffsetTimezone (although that could be done, it's neither necessary nor desirable--using atom bombs to swat flys should be avoided whenever possible.)

			In some circumstances, ad-hoc/transient VariableOffsetTimezones may be created by the current ChronosSystemFacade to represent/model/emulate the base system's local time zone.  The key of such a VariableOffsetTimezone created by the ChronosSystemFacade will be the Symbol #system.  The key #system may not even be unique within an image, let alone globally. For the precise behavior in the current Smalltalk environment and system platform, see ChronosSystemFacade and its subclass that implements the current ChronosSystemFacade singleton--the details may well vary by environment/platform.

			To retrieve a VariableOffsetTimezone by its key, use either the class message #at: or #at:ifAbsent:, with the time zone key as the first argument--the key may be either a Symbol or a String (e.g., {VariableOffsetTimezone at: 'Europe/Berlin'}.)

			To retrieve the keys of all the time zones resident in Chronos' repository of persistently-stored time zones, inspect the result of evaluating 'ChronosTimezone allRegisteredKeys' (if there are none, then the Chronos Time Zone Repository is missing, and should be obtained from the Chronos web site and installed according to the instructions (http://www.chronos-st.org/).)

			To see the current time in all the time zones resident in Chronos' repository of persistently-stored time zones, (showing the key, current offset, and current abbreviation for each time zone,) inspect the result of evaluating 'Timepoint nowInAllTimeZones' (if there are no entries, then the Chronos Time Zone Repository is missing, and should be obtained from the Chronos web site and installed according to the instructions (http://www.chronos-st.org/).)

		## USEFUL 'DO ITS' FOR MANUALLY SETTING THE SYSTEM/DEFAULT TIMEZONE

			Also see the "Usage:" section of the class comment of ChronosTimezone for an explanation of the terms 'system timezone' and 'default timezone.'

																						POSIX Rule Literal
			(Timezone at: #'America/Puerto_Rico') beSystem					"AST4"
			(Timezone at: #'America/New_York') beSystem					"EST5EDT4"
			(Timezone at: #'America/Indiana/Indianapolis') beSystem		"EST4"
			(Timezone at: #'America/Indiana/Knox') beSystem				"EST4"	
			(Timezone at: #'America/Indiana/Marengo') beSystem			"EST4"
			(Timezone at: #'America/Indiana/Vevay') beSystem				"EST4"
			(Timezone at: #'America/Chicago') beSystem						"CST6CDT5"
			(Timezone at: #'America/Boise') beSystem							"MST7MDT6"
			(Timezone at: #'America/Denver') beSystem						"MST7MDT6"
			(Timezone at: #'America/Phoenix') beSystem						"MST7"
			(Timezone at: #'America/Los_Angeles') beSystem				"PST8PDT7"
			(Timezone at: #'America/Anchorage') beSystem					"AKST9AKDT8"
			(Timezone at: #'America/Juneau') beSystem						"AKST9AKDT8"
			(Timezone at: #'America/Nome') beSystem							"AKST9AKDT8"
			(Timezone at: #'America/Adak') beSystem							"HAST10HADT9"
			(Timezone at: #'Pacific/Honolulu') beSystem						"HAST10"

			Timezone system beDefault	"Ensures that 'Timezone system == Timezone default' will still be true even after the system time zone is changed."
			
		## RETRIEVING TIMEZONE OFFSETS FROM UT (UNIVERSAL TIME)

			In order to retrieve the offset and/or abbreviation that is correct for the territorial domain of an instance of VariableOffsetTimezone at a particular point-in-time one must use the unbound ChronosTimezone API to resolve a "bound" ChronosTimezone with the correct offset and abbreviation for a given point-in-time, and retrieve the offset and/or abbreviation from the "bound" timezone so obtained. The bound time zone that results will be an instance of StandardTime if "standard time" is in effect at the point-in-time specified in the search parameters, but an instance of NonStandardTime otherwise.

			The search parameters needed to resolve a bound timezone are the year, day-of-year and seconds-since-start-of-day. They can be specified either as UT values or as local time ("wall clock") values.  The message signatures for resolving a bound timezone are as follows:

				#bindingForLocalYear:dayOfYear:secondsSinceStartOfDayFunction:		"Uses local-time search parameters"
				#bindingForUTYear:dayOfYear:secondsSinceStartOfDayFunction:		"Uses Universal Time search parameters"

			The final parameter value (following "secondsSinceStartOfDayFunction:") is a one-argument block.  If the seconds-since-start-of-day value is needed to find the correct bound timezone, this block will be invoked (as a 'call-back') with an argument whose value is the offset from UT in seconds for a particular bound timezone (representing a particular set of zone properties in effect during a particular period of time.)  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary (the answered seconds-since-start-of-day should be in Universal Time if the message #bindingForUTYear:dayOfYear:secondsSinceStartOfDayFunction: was sent, but in local ("wall clock") time if the message #bindingForLocalYear:dayOfYear:secondsSinceStartOfDayFunction: was sent.)  The reason for the callback block is that, during some years, a timezone may have more than one 'standard time' offset from UT, and because the offset transition rules for the same timezone for the same year can be specified as UT values for the first transition, local "wall clock" time for the second transition, but as local standard time for the third transition (yes, all that stuff actually happens--timezones are NOT simple!!)

			Instances of both StandardTime and NonStandardTime are "bound, dynamic" time zones (in the Chronos ontology of time zones.) Both will respond to the message #asUnbound by answering the "unbound, dynamic" time zone instance that defines the complete diachronic ruleset of the time-zone identified by their time zone key. A VariableOffsetTimezone instance (or any "unbound" Chronos time zone object) responds to the message #asUnbound with itself.

			Note: Most of the same information is presented near the end of the "Usage:" section of the class comment of ChronosTimezone--including eample "do its" that illustrate actual usage.

	Motivation:

		Real-world timezones are never invariant.  They always change over time: they change their abbreviations, their standard-time offsets from Universal Time, their DST offset deltas from standard time, and of course the dates and times when they transition to and or from DST. They can change any of these attributes any number of times during the year.  This is NOT theoretical--it's real, it happens, and a library and/or application that is serious about time has to deal with it.  UNIX does--and has been doing so for decades.

		Timezone rules and attributes are a political matter.  Legislatures, bureaucrats or other officials can and do set and change the timezone rules in their jurisdictions whenever they so please.  Perhaps a war prompts Congress to decree that the United States will transition to Daylight Saving Time and stay there until the war ends (World Wars I and II, for example.)  Perhaps the good people of Phoenix strongly prefer to use standard time all year round--except in 1967, when a change to Federal law forced them to observe DST for that year, until their State Legislature could pass the necessary law to get rid of the unpopular DST.  Welcome to the real world of timezones.

		If you only care about one point-in-time value (and don't have to deal with times in the future where the time zone rules might change before the future point-in-time you've designated transitions from future to past,) then a single offset from Universal Time is sufficient.  But if you want to compute new points-in-time using date/time arithmetic, then you have to deal with the fact that the offset of such computed points-in-time is undecidable in the absence of an unambiguous specification of which timezone ruleset should be used to determine the Universal Time offset of the computed timepoint.  Unambigously specifying the complete timezone ruleset in effect for a particular region, diachronically for all time, is what a VariableOffsetTimezone does (or at least enables.)

	Implementation:

		See TimeZonePolicy for information regarding the actual mechanisms by which a VariableOffsetTimezone implements and represents diachronic time zone rulesets.

		## INSTANCE REGISTRATION IN THE CACHE

			VariableOffsetTimezone maintains a cache of its instances. An instance will be registered in the cache when sent the message #register, provided the following conditions are satisfied: 1) the instance's key is not nil, 2) the instance's key is not the value #system, and 3) the instance has a non-nil TimeZonePolicy. Although it is not required that all instances be in the cache, all instances that are made immutable will be sent the message #register.  Instances deserialized from the external time-zones repository are always made immutable.  The cache is supposed to be a WeakDictionary, but what it actually is depends upon the current ChronosSystemFacade (see the implementation of the method #newWeakDictionary that is either implemented or inherited by the class of the current ChronosSystemFacade singleton.)

		Instance Variables

			key			<Symbol>	The key that identifies the time zone represented by the instance. If and only if it's the key of an Olson time zone (or it it's otherwise a universally well-known key,) it must be universally unique. Unless it's the special value #system, it must be unique within an image (or within an OS process, if the Smalltalk environment is not image based.)
			policy 		<TimeZonePolicy>	The TimeZonePolicy that specifies the ruleset of the time zone represented by the instance.  The ruleset of a time zone specifies for all time values, from the infinite past to the infinite future, the (possibly varying) time zone offsets and abbreviations that apply to points-in-time within the territorial domain of the time zone. Note, however, that the "policy" (time zone ruleset) can be changed retroactively--and this is rather likely to happen for times in the future (but can also happen to times in the past.)

		Class Variables

			Registry 	<WeakDictionary> Cache of VariableOffsetTimezones that have been instantiated in the image. Instances are usually (but not always) registerd in this cache.  

!

MonthOfYear subclass: #WeekOfMonthDayOfWeek
	instanceVariableNames: 'dayOfWeekOrdinal minDayOfMonthCardinal maxDayOfMonthCardinal daysOffset'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Annual Dates'!

!WeekOfMonthDayOfWeek commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

AbstractDate subclass: #YearMonthDay
	instanceVariableNames: 'year calendarDay'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!YearMonthDay commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

CalendarPeriod subclass: #YearlyCalendar
	instanceVariableNames: 'calendar typeCode intercalaryMonthCount leapMonthOrdinals leapDayOrdinals daysPerYear daysPerStandardYear hasNoLeapDays'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Calendars-Foundation'!

!YearlyCalendar commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

YearlyCalendar

	Concept:

		YearlyCalendar is an abstract class; an instance of one of its concrete subclasses represents/specifies the properties of a calendar year (of a particular type) of a particular calendrical system (e.g., the Gregorian, Hebrew, or Persian calendar.)  It does NOT represent/specify an actual occurrence of a specific year. In other words, a YearlyCalendar would specify/represent (for example) the properties of any leap year of the Gregorian Calendar, but would not specify/represent any specific Gregorian year.

		Specifically, a YearlyCalendar specifies the calendrical system for which it represents a type of year; the Chronos 'year type code' of the type of year it specifies; the number of months per year; the number of leap and intercalary months in the year; which months of the year are leap or intercalary months; the number of days per year; the number of leap days in the year; which days of the year are leap days; and the number of days in each month.  A YearlyCalendar encapsulates, and provides access to, instances of MonthlyCalendar and CalendarDay that specify the properties of each month and day of the type of year specified by the instance.

		Most calendrical systems have more than one type of year.  Instances of Calendar use a different instance of YearlyCalendar to represent/specify the properties/characteristics of each type of year that occurs in the calendrical system implemented by the Calendar instance.  

		StaticYearlyCalendar and DynamicYearlyCalendar are the two concrete subclasses of YearlyCalendar.  If there is a relatively small number of different year types that can occur in a calendrical system, a Calendar that implements that calendrical system instantiates a single instance of StaticYearlyCalendar for each such year type. Since there is usually only one instance of Calendar per calendrical system, StaticYearlyCalendars (and also StaticMonthlyCalendars and StaticCalendarDays) usually conform to the flyweight constraint (there's only one instance in the image per year type.)  However, if there is a relatively large (or infinite) number of distinct year types in a calendrical system, then a Calendar that implements that calendrical system instead may use instances of DynamicYearlyCalendar, DynamicMonthlyCalendar and DynamicCalendarDay, which will not conform to the flyweight constraint (so as to avoid using up excessive amounts of memory.)

		A StaticYearlyCalendar is preinitialized to encapsulate a flyweight instance of StaticMonthlyCalendar for each month in the type of year it represents, and to encapsulate a flyweight StaticCalendarDay for each day of the type of year it represents.  Similarly, a StaticMonthlyCalendar is preinitialized to encapsulate a flyweight instance of StaticCalendarDay for each day in the month it represents.  In contrast, a DynamicYearlyCalendar generates a new DynamicMontlyCalendar instance or a new DynamicCalendarDay instance every time it needs one or the other.  And a DynamicMonthlyCalendar generates a new instance of DynamicCalendarDay every time one is needed.

	Usage:

		As is the case with most Chronos classes, YearlyCalendar instances will normally be immutable, although mutable instances can also be instantiated (see the superclass Immutable for more information.)

		For specific usage information, see the method comments.

	Implementation:

		Instance Variables

			calendar 				<Calendar>
				The Calendar object that implements the calendrical system for which the instance specifies the properties of a year of a particular type.
			typeCode 				<Object>
				The object that uniquely identifies the type of the year whose properties are specified by the instance (usually, but not necessarily, this is an integer code.)
			intercalaryMonthCount 	<Integer>
				The number of intercalary months in a year of the type whose properties are specified by the instance (an intercalary month is one whose purpose is to contain any days that need to be added to the year--in addition to those that are contained by normal months--so that the total number of days in all the months of the year, and the total number of days in the year, will be the same. Intercalary months that occur every year usually have a number of days in the month that substantially differs from the number of days in a "standard" month.)
			leapMonthOrdinals 		<Array of Integer>
				Contains the month ordinal of each month that is a leap month in the type of year whose properties are specified by the instance.  A leap month is any month that doesn't occur in every type of year.  All leap months are also intercalary months, although not all intercalary months are leap months.
			leapDayOrdinals  		<Array of Integer>
				Contains the day-of-year ordinal of each day of the type of year whose properties are specified by the instance that is a leap day.  A leap day is any day of any month that doesn't occur in every type of year--including all the days of any leap month.
			daysPerYear 			<Integer>
				The number of days in a year of the type whose properties are specified by the instance.
			daysPerStandardYear 	<Integer>
				The number of days in a "standard" year for the calendrical system of the instance (as specified by the value of the 'calendar' instance variable.) A "standard year" is the type of year with the fewest leap days.
			hasNoLeapDays 		<Boolean>
				Flag that indicates whether there are any leap days in the type of year whose properties are specified by the instance.

	Subclassing:

		Concrete subclasses must subimplement the following instance methods (see the comment of each method for the required semantics):

			#basicDayAt:
			#basicMonthAt:dayAt:
			#dayAt:
			#dayAt:monthDayDo:
			#daysInMonthAt:
			#daysInMonthWithKey:ifAbsent:
			#daysUpToMonth:
			#daysUpToMonthWithKey:ifAbsent:
			#monthAt:
			#monthlyCalendarClass
			#monthOrdinalForMonthWithKey:ifAbsent:
			#monthsPerYear
			#setMonthsInYear:
!

RangeConstraint subclass: #ZeroSensitiveRangeConstraint
	instanceVariableNames: 'zeroInvalidException zeroInvalidMessage'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ZeroSensitiveRangeConstraint commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ZeroSensitiveRangeConstraint

	Concept:

		ZeroSensitiveRangeConstraint is an abstract subclass of RangeConstraint. An instance of a concrete subclass of ZeroSensitiveRangeConstraint is a RangeConstraint (which see) that not only defines a numeric range constraint, but may additionally prohibit the value zero--even when zero falls inside the valid range.

	Usage:

		In addition to the behavior defined by RangeConstraint, a ZeroSensitiveRangeConstraint will raise an Exception when it is presented with a value asserted to be valid, but the value is zero AND zero is not a member of the set of valid values represented by the instance.  ZeroSensitiveRangeConstraint provides protocol for instantiating an instance with a) an Exception to be raised, and b) a message to be associated with that Exception, whenever an invalid zero-value is asserted to be valid.  Protocol is also provided for accessing the Exception and message.

		To test whether a given value satisfies an instance's zero constraint, send the message #satisfiesZeroConstraint: to the instance, with the value to be tested as the argument.  If the set of valid values represented by the instance includes zero, sending #satisfiesZeroConstraint: will result in true being returned, regardless of the value of the argument.  However, if the set of valid values represented by the instance does NOT include zero, sending #satisfiesZeroConstraint: will result in true being returned only if the argument is not zero (if the argument is zero in such a case, the value false will be returned.)

	Implementation:
		
		Whether zero is or is not a member of the set of valid values represented by the receiver is controlled by the implmentation of the method #satisfiesZeroConstraint:, which must answer true if zero is a valid value, but false if the argument is zero and zero is NOT a valid value.  The implementation provided by ZeroSensitiveRangeConstraint itself always answer true.

		Instance Variables

			zeroInvalidException 	<Exception>	Exception that is signalled (raised) when the instance is presented with a value
													asserted to be valid, but the value is zero AND zero is not a member of the set of
													valid values defined by the instance.
			zeroInvalidMessage 		<String>		Message that will be associated with the <zeroInvalidException> when it is signalled.

	Subclassing:

		Subclasses whose set of valid values does NOT contain zero should subimplement the method #satisfiesZeroConstraint: so that it returns false when invoked with an argument whose value is zero.
!

NumberingPolicy subclass: #ZerolessOrdinalNumberingPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!ZerolessOrdinalNumberingPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	ZerolessOrdinalNumberingPolicy: Please refer to the class comment of my superclass, NumberingPolicy
!

Magnitude subclass: #DateSpec
	instanceVariableNames: 'year calendarDay'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!DateSpec commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

DateSpec subclass: #DateAndTimeSpec
	instanceVariableNames: 'hour minute second nanosecondsSinceSecond'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-DateTimeInterval'!

!DateAndTimeSpec commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
daysSinceEpoch: days seconds: seconds
	^self basicNew
		setDaysSinceEpoch: days calendar: AnsiStandardCalendar;
		setNanosecondsSinceSecond: 0;
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
daysSinceEpoch: days seconds: seconds calendar: calendar
	^self basicNew
		setDaysSinceEpoch: days calendar: (Calendar referencedBy: calendar)	;
		setNanosecondsSinceSecond: 0;
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
daysSinceEpoch: days seconds: seconds nanoseconds: n
	^self basicNew
		setDaysSinceEpoch: days calendar: AnsiStandardCalendar;
		setNanosecondsSinceSecond: n;
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
daysSinceEpoch: days seconds: seconds nanoseconds: n calendar: calendar
	^self basicNew
		setDaysSinceEpoch: days calendar: (Calendar referencedBy: calendar)	;
		setNanosecondsSinceSecond: n;
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
julianDay: julianDay seconds: seconds
	^(self new)
		setJulianDay: julianDay calendar: AnsiStandardCalendar;
		setSecondsSinceStartOfDay: seconds.! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
julianDay: julianDay seconds: seconds calendar: calendar
	^(self new)
		setJulianDay: julianDay calendar: (Calendar referencedBy: calendar);
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
julianDay: julianDay seconds: seconds nanoseconds: nanoseconds
	^(self new)
		setJulianDay: julianDay calendar: AnsiStandardCalendar;
		setNanosecondsSinceSecond: nanoseconds;
		setSecondsSinceStartOfDay: seconds.! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
julianDay: julianDay seconds: seconds nanoseconds: nanoseconds calendar: calendar 
	^(self new)
		setJulianDay: julianDay calendar: (Calendar referencedBy: calendar);
		setNanosecondsSinceSecond: nanoseconds;
		setSecondsSinceStartOfDay: seconds.! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
new
	^self basicNew initialize! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
secondsSinceEpoch: s 
	^self new
		setSecondsSinceEpoch: s calendar: AnsiStandardCalendar! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
secondsSinceEpoch: s calendar: calendar
	^self new
		setSecondsSinceEpoch: s calendar: (Calendar referencedBy: calendar)! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
secondsSinceEpoch: s nanoseconds: n 
	^self basicNew
		setSecondsSinceEpoch: s calendar: AnsiStandardCalendar;
		setNanosecondsSinceSecond: n! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
secondsSinceEpoch: s nanoseconds: n calendar: calendar
	^self basicNew
		setNanosecondsSinceSecond: n;
		setSecondsSinceEpoch: s calendar: (Calendar referencedBy: calendar)! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y calendarDay: cd seconds: seconds
	"{DateAndTimeSpec 
		year: 1941 
		calendarDay: (Gregorian calendarDayFromMonth: 12 day: 7 inYear: 1941) 
		seconds: 28500.5d}"

	^self new
		setYear: y calendarDay: cd;
		setSecondsSinceStartOfDay: seconds.! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y calendarDay: cd seconds: seconds nanoseconds: nanosecondsSinceSecond 
	"{DateAndTimeSpec 
		year: 1941 
		calendarDay: (Gregorian calendarDayFromMonth: 12 day: 7 inYear: 1941) 
		seconds: 28500
		nanoseconds: 0}"

	^self new
		setYear: y calendarDay: cd;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y day: d seconds: secondsSinceStartOfDay 
	"{DateAndTimeSpec 
		year: 1941 
		day:  341
		seconds:  28500.5d}"

	^self new
		setYear: y dayOfYearOrdinal: d calendar: AnsiStandardCalendar;
		setSecondsSinceStartOfDay: secondsSinceStartOfDay! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y day: d seconds: secondsSinceStartOfDay calendar: calendar 
	"{DateAndTimeSpec 
		year: 1941 
		day:  341
		seconds:  28500.5d
		calendar: Calendar gregorian}"

	^self new
		setYear: y dayOfYearOrdinal: d calendar: (Calendar referencedBy: calendar);
		setSecondsSinceStartOfDay: secondsSinceStartOfDay! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y day: d seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond 
	"{DateAndTimeSpec 
		year: 1941 
		day:  341
		seconds:  (7 * 3600) + (55 * 60)
		nanoseconds: 0}"

	^self basicNew
		setYear: y dayOfYearOrdinal: d calendar: AnsiStandardCalendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setSecondsSinceStartOfDay: secondsSinceStartOfDay! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y day: d seconds: secondsSinceStartOfDay nanoseconds: nanosecondsSinceSecond calendar: calendar 
	"{DateAndTimeSpec 
		year: 1941 
		day:  341
		seconds:  (7 * 3600) + (55 * 60)
		nanoseconds: 0
		calendar: Calendar gregorian}"

	^self basicNew
	setYear: y dayOfYearOrdinal: d calendar: (Calendar referencedBy: calendar);
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setSecondsSinceStartOfDay: secondsSinceStartOfDay! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second 

	"{DateAndTimeSpec 
		year: 1941 
		month: 12
		day: 7
		hour: 7
		minute: 55
		second: 0.5d}"

	^self new
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth calendar: AnsiStandardCalendar;
		setHour: hour minute: minute second: second! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second calendar: calendar
	"{DateAndTimeSpec 
		year: 1941 
		month: 12
		day: 7
		hour: 7
		minute: 55
		second: 0.5d
		calendar: Calendar gregorian}"

	^self new
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth calendar: (Calendar referencedBy: calendar);
		setHour: hour minute: minute second: second! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond 
	"{DateAndTimeSpec 
		year: 1941 
		month: 12
		day: 7
		hour: 7
		minute: 55
		second: 0
		nanosecond: 0}"

	^self basicNew
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth calendar: AnsiStandardCalendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: year month: month day: dayOfMonth hour: hour minute: minute second: second nanosecond: nanosecondsSinceSecond calendar: calendar
	"{DateAndTimeSpec 
		year: 1941 
		month: 12
		day: 7
		hour: 7
		minute: 55
		second: 0
		nanosecond: 0
		calendar: Calendar gregorian}"

	^self basicNew
		setYear: year monthOrdinal: month dayOfMonthOrdinal: dayOfMonth calendar: (Calendar referencedBy: calendar);
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setHour: hour minute: minute second: second! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y month: m day: d seconds: seconds 
	"{DateAndTimeSpec 
		year: 1941 
		month: 12
		day: 7
		seconds: 28500.5d}"

	^self new
		setYear: y monthOrdinal: m dayOfMonthOrdinal: d calendar: AnsiStandardCalendar;
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y month: m day: d  seconds: seconds calendar: calendar 
	"{DateAndTimeSpec 
		year: 1941 
		month: 12
		day: 7
		seconds: 28500.5d
		calendar: Calendar gregorian}"

	^self new
		setYear: y monthOrdinal: m dayOfMonthOrdinal: d calendar: (Calendar referencedBy: calendar);
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y month: m day: d seconds: seconds nanoseconds: nanosecondsSinceSecond 
	"{DateAndTimeSpec 
		year: 1941 
		month: 12
		day: 7
		seconds: (7 * 3600) + (55 * 60) 
		nanoseconds: 0}"

	^self basicNew
		setYear: y monthOrdinal: m dayOfMonthOrdinal: d calendar: AnsiStandardCalendar;
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setSecondsSinceStartOfDay: seconds.! !

!DateAndTimeSpec class methodsFor: 'instance creation' stamp: ''!
year: y month: m day: d  seconds: seconds nanoseconds: nanosecondsSinceSecond calendar: calendar 
	"{DateAndTimeSpec 
		year: 1941 
		month: 12
		day: 7
		seconds: (7 * 3600) + (55 * 60) 
		nanoseconds: 0
		calendar: Calendar gregorian}"

	^self basicNew
		setYear: y monthOrdinal: m dayOfMonthOrdinal: d calendar: (Calendar referencedBy: calendar);
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		setSecondsSinceStartOfDay: seconds! !

!DateAndTimeSpec methodsFor: 'converting' stamp: ''!
<< aChronosTimezone 
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but convert the date and time-of-day as though the receiver represented a date and time in the current default time zone (i.e,. preserve date and time-of-day in Universal Time as though the receiver represented a date and time in the current default time zone.)
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is the same as that of the receiver (i.e,, preserve local date and local time-of-day, don't preserve date or time-of-day in Universal Time.)"

	^self asNominalDateAndTime << aChronosTimezone! !

!DateAndTimeSpec methodsFor: 'converting' stamp: ''!
>> aChronosTimezone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."

	^self asDateAndTimeIn: aChronosTimezone! !

!DateAndTimeSpec methodsFor: 'converting' stamp: ''!
as: otherCalendar 
	"Answer the result of converting the receiver into a calendrical coordinate whose Calendar is <otherCalendar>, but which represents the same absolute temporal value (e.g., the same day in history)."

	"{(DateAndTimeSpec 
		year: 1941 
		month: 12 
		day: 7 
		secondsSinceStartOfDay: (7 * 3600) + (55 * 60) 
		nanosecond: 0 calendar: Calendar gregorian) as: Julian}"

	| newCalendar |
	newCalendar := Calendar referencedBy: otherCalendar.
	self calendar == newCalendar ifTrue: [^self copy].
	^(self copy)
		setSecondsSinceEpoch: 
			(newCalendar 
				secondsSinceEpochFromForeignSecondsSinceEpoch: self secondsSinceEpoch
				convertingFrom: self calendar)
		calendar: newCalendar! !

!DateAndTimeSpec methodsFor: 'converting' stamp: ''!
asCalendricalCoordinate
	"Answer the conversion of the receiver into its equivalent value implemented as a CalendricalCoordinate.  If the receiver is already a CalendricalCoordinate, answer the receiver."

	^self asNominalDateAndTime! !

!DateAndTimeSpec methodsFor: 'converting' stamp: ''!
asNative
	"Answer the native system's 'Timestamp' analog (or 'Date' analog, if no Timestamp analog is available) that semantically corresponds as closely as possible to the receiver."

	"{(DateAndTimeSpec year: 1941 month: 12 day: 7 calendar: Calendar gregorian) asNative}"

	^self calendar clock nativeCalendricalCoordinateFromChronosDateAndTime: self! !

!DateAndTimeSpec methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToDateAndTime: self] 
			on: MessageNotUnderstood 
			do: [:ex | 
				((ex receiver == aCalendrical) and: [#compareToDateAndTime: == ex message selector])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!DateAndTimeSpec methodsFor: 'private-comparing' stamp: ''!
compareToDate: aDate
	^(aDate compareToDateAndTime: self) negated! !

!DateAndTimeSpec methodsFor: 'converting' stamp: ''!
dateAndTimeSpec
	^self! !

!DateAndTimeSpec methodsFor: 'converting' stamp: ''!
dateSpec
	^DateSpec 
		year: self year
		calendarDay: self calendarDay! !

!DateAndTimeSpec methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self calendarRegistrationKey;
		nextPut: self daysSinceEpoch;
		nextPut: self hour;
		nextPut: self minute;
		nextPut: self second;
		nextPut: self nanosecondsSinceSecond.! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
hour
	^hour! !

!DateAndTimeSpec methodsFor: 'accessing-multivalued' stamp: ''!
hourMinuteSecondDo: block3 
	^block3
		value: hour
		value: minute
		value: second! !

!DateAndTimeSpec methodsFor: 'accessing-multivalued' stamp: ''!
hourMinuteSecondDo: block3 hour24Format: hour24
	^block3
		value: (hour24 ifTrue: [hour] ifFalse: [self hour12])
		value: minute
		value: second! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
hoursSinceMidnight
	^self timeOfDayClockStartsAtMidnight
		ifTrue: [hour]
		ifFalse: [self secondsSinceMidnight // SecondsPerHour]! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
hoursSinceStartOfDay 
	^self timeOfDayClockStartsAtStartOfDay
		ifTrue: [hour]
		ifFalse: [self secondsSinceStartOfDay // SecondsPerHour]! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
initialize
	hour := 0.
	minute := 0.
	second := 0.	
	nanosecondsSinceSecond := 0.! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self 
		setHour: (literalArray at: 4) asNumber minute: (literalArray at: 5) asNumber second: (literalArray at: 6) asNumber;
		setNanosecondsSinceSecond: (literalArray at: 7) asNumber! !

!DateAndTimeSpec methodsFor: 'testing' stamp: ''!
isAtStartOfDay
	^nanosecondsSinceSecond = 0 
		and: [second = 0 and: [minute = 0 and: [hour = 0]]]! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
julianDay
	"Answers the Julian Day Number of the Julian Day in which the the point-in-time represented by the receiver occurs. However, if the receiver's interval spans across the transition from one Julian Day to the next, then the Julian Day Number of the first Julian Day that starts at Noon within the interval of time represented by the receiver is answered."

	^self calendar julianDayFromSecondsSinceEpoch: self secondsSinceEpoch! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
minute
	^minute! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
minutesSinceMidnight
	^self timeOfDayClockStartsAtMidnight
		ifTrue: [hour * MinutesPerHour + minute]
		ifFalse: [self secondsSinceMidnight // SecondsPerMinute]! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
minutesSinceStartOfDay 
	^self timeOfDayClockStartsAtStartOfDay
		ifTrue: [hour * MinutesPerHour + minute]
		ifFalse: [self secondsSinceStartOfDay // SecondsPerMinute]! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
minutesSinceStartOfTimeOfDayClock
	^hour * MinutesPerHour + minute! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond	
	^nanosecondsSinceSecond! !

!DateAndTimeSpec methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."
	"If <aChronosPrintPolicy> == ChronosPrintPolicy default (or ChronosPrintPolicy ansiStandard or ChronosPrintPolicy iso8601,) then the receiver's printString will be formatted as required by both the ANSI-Smalltalk and the ISO 8601 Standards--except that no timezone information will be included, since the receiver is not bound to any timezone."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printDateAndTime: self on: stream! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
second
	^second! !

!DateAndTimeSpec methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay
	^(hour * SecondsPerHour) + (minute * SecondsPerMinute) + second! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
setDaysSinceEpoch: daysSinceEpoch calendar: calendar 
	super setDaysSinceEpoch: daysSinceEpoch calendar: calendar.
	daysSinceEpoch isInteger 
		ifFalse: 
			[self setSecondsSinceStartOfDay: (daysSinceEpoch - daysSinceEpoch truncated) * self secondsInDay].! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
setFractionalSecondsSinceEpoch: seconds calendar: calendar
	| iSeconds subseconds |
	iSeconds := seconds truncated.
	subseconds := seconds - iSeconds.
	self 
		setNanosecondsSinceSecond: subseconds * NanosecondsPerSecond;
		setSecondsSinceEpoch: iSeconds calendar: calendar! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
setHour: h minute: m second: s 
	hour := h.
	minute := m.
	second := s! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
setJulianDay: julianDay calendar: calendar
	self setSecondsSinceEpoch: (calendar secondsSinceEpochFromJulianDay: julianDay) calendar: calendar! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
setNanosecondsSinceSecond: nanosseconds
	nanosecondsSinceSecond := nanosseconds truncated! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
setSecondsSinceEpoch: seconds calendar: calendar
	| secondsDiv128 secondsMod128 |
	seconds isInteger ifFalse: [^self setFractionalSecondsSinceEpoch: seconds calendar: calendar].
	secondsDiv128 := seconds bitShift: -7. "Bit shifting is faster than LargeInteger math."
	secondsMod128 := seconds bitAnd: 127.
	self setDaysSinceEpoch: secondsDiv128 // 675 calendar: calendar. "128 * 675 = 86400"	
	self setSecondsSinceStartOfDay: (secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7)). "seconds \\ 128 + (seconds // 128 \\ 675 * 128)"! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
setSecondsSinceMidnight: secondsSinceMidnight 
	| seconds |
	secondsSinceMidnight isInteger 
		ifTrue: [seconds := secondsSinceMidnight]
		ifFalse: 
			[seconds := secondsSinceMidnight truncated.
			self setNanosecondsSinceSecond: (secondsSinceMidnight - seconds) * NanosecondsPerSecond].
	self setTimeOfDayFromSeconds: 
		(self timeOfDayClockStartsAtMidnight 
			ifTrue: [seconds]
			ifFalse: [self calendar secondsSinceStartOfDayFromSecondsSinceMidnight: seconds])! !

!DateAndTimeSpec methodsFor: 'initialize-release' stamp: ''!
setSecondsSinceStartOfDay: secondsSinceStartOfDay 
	| seconds |
	secondsSinceStartOfDay isInteger 
		ifTrue: [seconds := secondsSinceStartOfDay]
		ifFalse: 
			[seconds := secondsSinceStartOfDay truncated.
			self
				setNanosecondsSinceSecond: (secondsSinceStartOfDay - seconds) * NanosecondsPerSecond].
		self setTimeOfDayFromSeconds: 
			(self timeOfDayClockStartsAtStartOfDay 
				ifTrue: [seconds]
				ifFalse: [self calendar secondsSinceMidnightFromSecondsSinceStartOfDay: seconds])! !

!DateAndTimeSpec methodsFor: 'private' stamp: ''!
setTimeOfDayFromSeconds: secondsSinceStartOfTimeOfDayClock
	| seconds |
	seconds := 
		(secondsSinceStartOfTimeOfDayClock abs <= self secondsInDay 
			ifTrue: 
				[secondsSinceStartOfTimeOfDayClock positive ifTrue: [secondsSinceStartOfTimeOfDayClock] ifFalse: [self secondsInDay + secondsSinceStartOfTimeOfDayClock]]
			ifFalse: [secondsSinceStartOfTimeOfDayClock \\ self secondsInDay]).
	hour := seconds // SecondsPerHour.
	seconds := seconds \\ SecondsPerHour.
	minute := seconds // SecondsPerMinute.
	second := seconds \\ SecondsPerMinute.
	(hour == 24 and: [minute ==  0 and: [second == 0]])
		ifTrue:
			[hour := 23.
			minute := 59.
			second := 60]! !

!DateSpec class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray

	^self new
		initializeFromLiteralArray: literalArray! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
daysSinceEpoch: daysSinceEpoch 
	^(self new)
		setDaysSinceEpoch: daysSinceEpoch calendar: AnsiStandardCalendar! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
daysSinceEpoch: daysSinceEpoch calendar: calendar 
	^(self new)
		setDaysSinceEpoch: daysSinceEpoch calendar: (Calendar referencedBy: calendar)! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
decodeFromLiteralArray: literalArray

	| class |
	class := ChronosObject resolveClassFromLiteralArray: literalArray.
	^class basicDecodeFromLiteralArray: literalArray! !

!DateSpec class methodsFor: 'class initialization' stamp: ''!
invalidateCalendarBindings
	"DateSpec invalidateCalendarBindings"

	self allInstancesDo: [:calendrical | calendrical invalidateCalendar].
	self subclasses do: [:class | class invalidateCalendarBindings]! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
julianDay: julianDay
	"DateSpec julianDay: YearMonthDay today julianDay"

	^self new setJulianDay: julianDay calendar: AnsiStandardCalendar! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
julianDay: julianDay calendar: calendar 
	"DateSpec julianDay: YearMonthDay today julianDay calendar: #Hebrew"

	^self new setJulianDay: julianDay calendar: (Calendar referencedBy: calendar)! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
year: y calendarDay: cd
	^self new
		setYear: y calendarDay: cd! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
year: y day: d 
	^self new
		setYear: y dayOfYearOrdinal: d calendar: AnsiStandardCalendar! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
year: y day: d calendar: calendar 
	^self new
		setYear: y dayOfYearOrdinal: d calendar: (Calendar referencedBy: calendar)! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
year: y month: m day: d 
	^self new
		setYear: y monthOrdinal: m dayOfMonthOrdinal: d calendar: AnsiStandardCalendar! !

!DateSpec class methodsFor: 'instance creation' stamp: ''!
year: y month: m day: d calendar: calendar 
	^self new
		setYear: y monthOrdinal: m dayOfMonthOrdinal: d calendar: (Calendar referencedBy: calendar)! !

!DateSpec methodsFor: 'printing' stamp: ''!
% aChronosPrintPolicyOrSpec
	^self printStringUsing: aChronosPrintPolicyOrSpec! !

!DateSpec methodsFor: 'converting' stamp: ''!
/ aTemporalCoordinateOrADurational

	^aTemporalCoordinateOrADurational asTimeperiodStartingAt: self asCalendricalCoordinate! !

!DateSpec methodsFor: 'comparing' stamp: ''!
< aMagnitude 
	"Answer whether the receiver is less than the argument."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison negative]! !

!DateSpec methodsFor: 'converting' stamp: ''!
<< aChronosTimezone 
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but convert the date and time-of-day as though the receiver represented a date and time in the current default time zone (i.e,. preserve date and time-of-day in Universal Time as though the receiver represented a date and time in the current default time zone.)
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is the same as that of the receiver (i.e,, preserve local date and local time-of-day, don't preserve date or time-of-day in Universal Time.)"

	"YearMonthDay today asSpec << 10 hours"
	"YearMonthDay today asSpec << #nominal"
	"YearMonthDay today asSpec << 'Australia/Adelaide'"
	"YearMonthDay today asSpec << #default"
	"YearMonthDay today asSpec << #system"

	| timeZone dateAndTime |
	timeZone := ChronosTimezone referencedBy: aChronosTimezone.
	timeZone isInvariantToNominalTime ifTrue: [^self].
	timeZone isDefault 
		ifTrue: [dateAndTime := self asDateAndTime]
		ifFalse: 
			[dateAndTime := self asMutableDateAndTime.
			dateAndTime
				deproxifyTimeZone;
				convertToTimeZone: timeZone;
				beImmutable].
	^self duration asTimeperiodStartingAt: dateAndTime! !

!DateSpec methodsFor: 'comparing' stamp: ''!
= aMagnitude 
	"Answer whether the receiver is equal to the argument."

	self == aMagnitude ifTrue: [^true].
	^(self compareTo: aMagnitude) = 0! !

!DateSpec methodsFor: 'comparing' stamp: ''!
> aMagnitude 
	"Answer whether the receiver is greater than the argument."

	| comparison |
	comparison := self compareTo: aMagnitude.
	^comparison == nil
		ifTrue: [self signalError: 'Cannot compare a ', aMagnitude class printString, ' to a ', self class printString]
		ifFalse: [comparison positive]! !

!DateSpec methodsFor: 'converting' stamp: ''!
>> aChronosTimezone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."

	"YearMonthDay today asSpec >> 10 hours"
	"YearMonthDay today asSpec >> #nominal"
	"YearMonthDay today asSpec >> 'Australia/Adelaide'"
	"YearMonthDay today asSpec >> #default"
	"YearMonthDay today asSpec >> #system"
	"{YearMonthDay today asSpec >> 'America/Phoenix'}"
	"{YearMonthDay today asSpec >> 'Asia/Calcutta'}"

	| timeZone |
	timeZone := ChronosTimezone referencedBy: aChronosTimezone.
	timeZone isInvariantToNominalTime ifTrue: [^self].
	^self duration asTimeperiodStartingAt: (self asDateAndTimeIn: timeZone)! !

!DateSpec methodsFor: 'converting' stamp: ''!
@ timeOfDay 
	"(DateSpec year: 1999 month: 12 day: 31) @ (TimeOfDay hour: 23 minute: 59 second: 59)"

	^(DateAndTimeFactory basicNew)
		setCalendar: self calendar;
		basicSetTimeZone: self timeZone;
		basicSetYear: year calendarDay: calendarDay;
		setTimeOfDay: timeOfDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!DateSpec methodsFor: 'converting' stamp: ''!
\ calendar

	^self as: calendar! !

!DateSpec methodsFor: 'arithmetic' stamp: ''!
addingDays: dayDelta setYearAndCalendarDayInto: block2OrYearMonthDaySpec 
	^calendarDay 
		startingWithYear: year
		addingDays: dayDelta
		setYearAndCalendarDayInto: block2OrYearMonthDaySpec! !

!DateSpec methodsFor: 'accessing' stamp: ''!
ansiDayOfWeekOrdinal
	^self calendar ansiDayOfWeekOrdinalFromDaysSinceEpoch: self daysSinceEpoch! !

!DateSpec methodsFor: 'converting' stamp: ''!
as: otherCalendar 
	"Answer the result of converting the receiver into a calendrical coordinate whose Calendar is <otherCalendar>, but which represents the same absolute temporal value (e.g., the same day in history)."

	"{(DateSpec year: 1941 month: 12 day: 7 calendar: Calendar gregorian) as: Julian}"

	| newCalendar |
	newCalendar := Calendar referencedBy: otherCalendar.
	self calendar == newCalendar ifTrue: [^self copy].
	^(self copy)
		setDaysSinceEpoch: 
			(newCalendar 
				daysSinceEpochFromForeignDaysSinceEpoch: self daysSinceEpoch
				convertingFrom: self calendar)
		calendar: newCalendar! !

!DateSpec methodsFor: 'converting' stamp: ''!
asAll: anCollectionOfCalendars
	"NOTE: If <anCollectionOfCalendars> is a Set, the result will be a Set with only one member, because Calendrical instances compare as equal to all others that represent the same moment in time."

	^anCollectionOfCalendars asArray collect: [:aCalendar | self as: aCalendar]! !

!DateSpec methodsFor: 'converting' stamp: ''!
asBoundToStaticTimeZone
	"YearMonthDay today asBoundToStaticTimeZone"

	^self asDateAndTime asBoundToStaticTimeZone! !

!DateSpec methodsFor: 'converting' stamp: ''!
asBoundToTimeZone
	^self asDateAndTime! !

!DateSpec methodsFor: 'converting' stamp: ''!
asCalendricalCoordinate
	"Answer the conversion of the receiver into its equivalent value implemented as a CalendricalCoordinate.  If the receiver is already a CalendricalCoordinate, answer the receiver."

	^self asDate! !

!DateSpec methodsFor: 'converting' stamp: ''!
asDate
	"Answer the conversion of the receiver into a date-valued CalendricalCoordinate that represents the same date as does the receiver.  If the receiver is already a date-valued CalendricalCoordinate, answer the receiver.  A date-valued CalendricalCoordinate is one that specifies a date without specifying a particular time-of-day nor a particular timezone (i.e., it has nominal time semantics, and its quantum of resolution is 1 calendar day.)"

	^DateFactory basicNew
		setCalendar: self calendar;
		basicSetYear: self year calendarDay: self calendarDay;
		beImmutable! !

!DateSpec methodsFor: 'converting' stamp: ''!
asDateAndTime
	"Answer the conversion of the receiver into a DateAndTime value that represents the same point-in-time as does the receiver.  If the receiver is already a DateAndTime value, answer the receiver.  A DateAndTime value is a CalendricalCoordinate that specifies a point-in-time, with a quantum of resolution no larger than one second, with behavior/semantics that is invariant to UT, and that conforms to the ANSI-Smalltalk <DateAndTime> protocol. See the class comment of Timepoint for further clarification."

	^self >> ChronosTimezone default! !

!DateSpec methodsFor: 'converting' stamp: ''!
asDateAndTimeIn: aChronosTimezone

	"{YearMonthDay today asSpec asDateAndTimeIn: 'Asia/Calcutta'}"
	"{Timepoint now asSpec asDateAndTimeIn: 'Asia/Calcutta'}"
	"{Timepoint now asSpec asDateAndTimeIn: ChronosTimezone nominal}"

	^DateAndTimeFactory basicNew
		setCalendar: self calendar;
		setTimeZone: aChronosTimezone;
		setNanosecondsSinceSecond: self nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: self secondsSinceStartOfDay;
		basicSetYear: self year calendarDay: self calendarDay;
		canonicalizeFromLocalTime;
		beImmutable! !

!DateSpec methodsFor: 'converting' stamp: ''!
asGregorian
	^self as: Gregorian! !

!DateSpec methodsFor: 'converting' stamp: ''!
asInvariantToNominalTime
	"Answer a value equivalent to that of the receiver in all respects, except that its semantics/behavior is invariant to nominal time.  If the receiver is already nominal-time invariant, answer the receiver. See the class comment of Timepoint for further clarification."

	^self! !

!DateSpec methodsFor: 'converting' stamp: ''!
asInvariantToUT
	"Answer a value equivalent to that of the receiver in all respects, except that it has UT-invariant behavior/semantics.  If the receiver is already invariant-to-UT, answer the receiver. See the class comment of Timepoint for further clarification."

	^self >> ChronosTimezone default! !

!DateSpec methodsFor: 'converting' stamp: ''!
asJulian
	^self as: Julian! !

!DateSpec methodsFor: 'converting' stamp: ''!
asLocal
	^self >> ChronosTimezone default! !

!DateSpec methodsFor: 'private' stamp: ''!
asMutableDateAndTime
	^(DateAndTimeFactory basicNew)
		basicSetCalendar: self calendar;
		basicSetYear: year calendarDay: calendarDay;
		canonicalize! !

!DateSpec methodsFor: 'converting' stamp: ''!
asNative
	"Answer the native system's 'Date' analog (or 'Timestamp' analog, if no Date analog is available) that semantically corresponds as closely as possible to the receiver."

	"{(DateSpec year: 1941 month: 12 day: 7 calendar: Calendar gregorian) asNative}"

	^self calendar clock nativeCalendricalCoordinateFromChronosDate: self! !

!DateSpec methodsFor: 'converting' stamp: ''!
asNominalDateAndTime
	"Answer the conversion of the receiver into a nominal-time-invariant DateAndTime value that represents the same local point-in-time as does the receiver.  If the receiver is already a nominal-time-invariant DateAndTime value, answer the receiver.  A nominal-time-invariant DateAndTime value is a CalendricalCoordinate that nominally specifies a point-in-time without reference to any particular timezone, and has a quantum of resolution no larger than one second. A nominal-time-invariant DateAndTime value conforms to the ANSI-Smalltalk <DateAndTime> protocol EXCEPT that its behavior/semantics is invariant to nominal time, as opposed to being UT invariant. See the class comment of Timepoint for further clarification."

	^self >> ChronosTimezone nominal! !

!DateSpec methodsFor: 'converting' stamp: ''!
asSpec
	^self! !

!DateSpec methodsFor: 'converting' stamp: ''!
asTemporalCoordinate
	"Answer the conversion of the receiver into its equivalent value implemented as a TemporalCoordinate.  If the receiver is already a TemporalCoordinate, answer the receiver."

	^self asCalendricalCoordinate! !

!DateSpec methodsFor: 'converting' stamp: ''!
asUT
	^self >> ChronosTimezone ut! !

!DateSpec methodsFor: 'converting' stamp: ''!
asUTC
	"Specified and required by the ANSI-Smalltalk Standard."

	^self asUT! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondSince: aTemporal
	^aTemporal basicNanosecondsSinceSecondUntilNominal: self! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondSinceNominal: aTemporal
	^self nanosecondsSinceSecond - aTemporal nanosecondsSinceSecond! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondSinceUT: aTemporal
	^self nanosecondsSinceSecond - aTemporal nanosecondsSinceSecond! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondUntil: aTemporal 
	^aTemporal basicNanosecondsSinceSecondSinceNominal: self! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondUntilNominal: aTemporal 
	^aTemporal nanosecondsSinceSecond - self nanosecondsSinceSecond! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicNanosecondsSinceSecondUntilUT: aTemporal 
	^aTemporal nanosecondsSinceSecond - self nanosecondsSinceSecond! !

!DateSpec methodsFor: 'printing' stamp: ''!
basicPrintOn: stream
	super printOn: stream! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSince: aTemporal
	^aTemporal basicSecondsSinceEpochUntilNominal: self! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochSinceNominal: aDateAndTimeInvariantToNominalTime
	^self calendar == aDateAndTimeInvariantToNominalTime calendar
		ifTrue: [self secondsSinceEpoch - aDateAndTimeInvariantToNominalTime secondsSinceEpoch]
		ifFalse: [self secondsSinceUnificationEpoch - aDateAndTimeInvariantToNominalTime secondsSinceUnificationEpoch]! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochSinceUT: aDateAndTimeInvariantToUT
	^self calendar == aDateAndTimeInvariantToUT calendar 
		ifTrue: [self secondsSinceEpoch - aDateAndTimeInvariantToUT secondsSinceEpoch]
		ifFalse: [self secondsSinceUnificationEpoch - aDateAndTimeInvariantToUT secondsSinceUnificationEpoch]! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochUntilNominal: aDateAndTimeInvariantToNominalTime
	^self calendar == aDateAndTimeInvariantToNominalTime calendar 
		ifTrue: [aDateAndTimeInvariantToNominalTime secondsSinceEpoch - self secondsSinceEpoch]
		ifFalse: [aDateAndTimeInvariantToNominalTime secondsSinceUnificationEpoch - self secondsSinceUnificationEpoch]! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsSinceEpochUntilUT: aDateAndTimeInvariantToUT
	^self calendar == aDateAndTimeInvariantToUT calendar 
		ifTrue: [aDateAndTimeInvariantToUT secondsSinceEpoch - self secondsSinceEpoch]
		ifFalse: [aDateAndTimeInvariantToUT secondsSinceUnificationEpoch - self secondsSinceUnificationEpoch]! !

!DateSpec methodsFor: 'private-arithmetic' stamp: ''!
basicSecondsUntil: aTemporal
	^aTemporal basicSecondsSinceEpochSinceNominal: self! !

!DateSpec methodsFor: 'accessing' stamp: ''!
calendar
	^calendarDay calendar! !

!DateSpec methodsFor: 'accessing' stamp: ''!
calendarDay
	^calendarDay! !

!DateSpec methodsFor: 'accessing' stamp: ''!
calendarRegistrationKey
	^self calendar registrationKey! !

!DateSpec methodsFor: 'accessing' stamp: ''!
clock
	^self calendar clock! !

!DateSpec methodsFor: 'accessing' stamp: ''!
closedExtent
	"Answer the `closed extent` of the receiver. Conceptually, the closed extent of a Timeperiod is the temporal extent (duration) of the **fully-closed** temporal interval that contains every representable point-in-time contained by the Timeperiod. Physically, it is defined to be the temporal extent (duration) computed by subtracting the Timeperiod's granularity from its temporal exent (i.e., {aTimeperiod duration - aTimeperiod granularity}.) See the comment of the receiver's #granularity method (and also the class comment.)"

	"{Timeperiod currentWeek closedExtent}"
	"{Timeperiod currentHour closedExtent}"

	^self duration - self granularity! !

!DateSpec methodsFor: 'comparing' stamp: ''!
compareTo: aCalendrical
	"Compare the value of the receiver to that of <aCalendrical>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aCalendrical> are the same.)"

	self == aCalendrical ifTrue: [^0].
	^[aCalendrical compareToDate: self] 
			on: MessageNotUnderstood 
			do: [:ex | 
				((ex receiver == aCalendrical) and: [#compareToDate: == ex message selector])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToAnnualDate: anAnnualDate
	^(anAnnualDate compareToDate: self) negated! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToCalendricalCoordinate: aCalendricalCoordinate

	^self compareToTemporalCoordinate: aCalendricalCoordinate! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToDate: aDate
	^self calendar == aDate calendar
		ifTrue: [aDate daysSinceEpoch - self daysSinceEpoch]
		ifFalse: [aDate daysSinceUnificationEpoch - self daysSinceUnificationEpoch]! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToDateAndTime: aDateAndTime

	^self compareToTemporalCoordinate: aDateAndTime! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToDayOfMonth: aDayOfMonth
	^(aDayOfMonth compareToDate: self) negated! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToDayOfYear: aDayOfYear
	^(aDayOfYear compareToDate: self) negated! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToTemporalCoordinate: aTemporalCoordinate
	| diff |
	diff := aTemporalCoordinate basicSecondsSince: self.
	diff = 0 ifFalse: [^diff].
	^aTemporalCoordinate nanosecondsSinceSecond - self nanosecondsSinceSecond! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToTimeperiod: aTimeperiod 
	^(aTimeperiod compareToTemporalCoordinate: self) negated! !

!DateSpec methodsFor: 'private-comparing' stamp: ''!
compareToWeekOfMonthDayOfWeek: aWeekOfMonthDayOfWeek
	^(aWeekOfMonthDayOfWeek compareToDate: self) negated! !

!DateSpec methodsFor: 'converting' stamp: ''!
dateAndTimeSpec
	^DateAndTimeSpec 
		year: self year
		calendarDay: self calendarDay
		seconds: self secondsSinceStartOfDay
		nanoseconds: self nanosecondsSinceSecond! !

!DateSpec methodsFor: 'converting' stamp: ''!
dateSpec
	^self! !

!DateSpec methodsFor: 'accessing' stamp: ''!
dayOfMonth
	^calendarDay dayOfMonth! !

!DateSpec methodsFor: 'accessing' stamp: ''!
dayOfMonthOrdinal
	^calendarDay dayOfMonthOrdinal! !

!DateSpec methodsFor: 'accessing' stamp: ''!
dayOfWeek
	^self calendar dayOfWeekOrdinalFromDaysSinceEpoch: self daysSinceEpoch! !

!DateSpec methodsFor: 'accessing' stamp: ''!
dayOfWeekAbbreviation
	^ChronosLocale default abbreviationAtSemanticKey: self dayOfWeekKey! !

!DateSpec methodsFor: 'accessing' stamp: ''!
dayOfWeekKey
	^ANSIDayOfWeekKeys at: self ansiDayOfWeekOrdinal! !

!DateSpec methodsFor: 'accessing' stamp: ''!
dayOfWeekName
	^ChronosLocale default properNameAtSemanticKey: self dayOfWeekKey! !

!DateSpec methodsFor: 'accessing' stamp: ''!
dayOfYear
	^calendarDay dayOfYearOrdinal! !

!DateSpec methodsFor: 'accessing' stamp: ''!
dayOfYearOrdinal
	^calendarDay dayOfYearOrdinal! !

!DateSpec methodsFor: 'accessing' stamp: ''!
daysSinceEpoch
	^(self calendar daysSinceEpochUpToYear: self year) + self daysSinceStartOfYear! !

!DateSpec methodsFor: 'accessing' stamp: ''!
daysSinceEpochUpToYear
	^self calendar daysSinceEpochUpToYear: year! !

!DateSpec methodsFor: 'accessing' stamp: ''!
daysSinceStartOfANSIWeek
	^self calendar daysSinceStartOfANSIWeekFromDaysSinceEpoch: self daysSinceEpoch! !

!DateSpec methodsFor: 'accessing' stamp: ''!
daysSinceStartOfISOWeek
	^self calendar daysSinceStartOfISOWeekFromDaysSinceEpoch: self daysSinceEpoch! !

!DateSpec methodsFor: 'accessing' stamp: ''!
daysSinceStartOfMonth
	"Answer the number of days since the first day of the receiver's month up to (but not including) the day represented by the receiver. The answer is the CARDINAL number of the day of the month represented by the receiver."

	^calendarDay daysSinceStartOfMonth! !

!DateSpec methodsFor: 'accessing' stamp: ''!
daysSinceStartOfYear
	"Answer the number of days since the first day of the receiver's year up to (but not including) the day represented by the receiver. The answer is the CARDINAL number of the day of the year represented by the receiver."

	^calendarDay daysSinceStartOfYear! !

!DateSpec methodsFor: 'accessing' stamp: ''!
daysSinceUnificationEpoch
	^self daysSinceEpoch + self calendar unificationDayNumberOfEpoch! !

!DateSpec methodsFor: 'accessing' stamp: ''!
defaultLocale
	^ChronosLocale default! !

!DateSpec methodsFor: 'accessing' stamp: ''!
defaultPrintPolicy
	^ChronosPrintPolicy ansiStandard! !

!DateSpec methodsFor: 'accessing' stamp: ''!
duration
	"Answer a Duration whose value represents the receiver's temporal extent."

	^self resolutionQuantum! !

!DateSpec methodsFor: 'accessing' stamp: ''!
earliest
	"Compare the first and last element of the receiver (see the class comment,) and answer whichever one temporally precedes the other. If neither one precedes the other, answer either the receiver's first or last element."

	^self first min: self last! !

!DateSpec methodsFor: 'accessing' stamp: ''!
earliestAndLatestDo: block2
	"Evaluate <block2> with 'self earliest' as the first argument and with 'self latest' as the second argument."

	| first last |
	first := self first.
	last := self last.
	^last >= first 
		ifTrue: [block2 value: first value: last]
		ifFalse: [block2 value: last value: first]! !

!DateSpec methodsFor: 'accessing' stamp: ''!
eitherYearMonthDayDo: block3a orYearMonthkeyDayDo: block3b
	"If the receiver's month ordinal is unambigously specified, evaluate <block3a> with the receiver's year, its month ordinal and its day-of-month ordinal as the arguments. Otherwise, evaluate <block3b> with the receiver's year,  the semantic key that identifies the receiver's month and its day-of-month ordinal as the arguments."

	^self yearMonthDayDo: block3a! !

!DateSpec methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self calendarRegistrationKey;
		nextPut: self daysSinceEpoch! !

!DateSpec methodsFor: 'accessing' stamp: ''!
eraName
	^self calendar eraNameForYear: self year! !

!DateSpec methodsFor: 'accessing' stamp: ''!
first
	"Answer the first element of the receiver, which is defined to be its starting point-in-time."

	^self start! !

!DateSpec methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthAbbreviationIfResolvable: resolvable ifNot: notResolvable 
	"Evaluate <resolvable> with the abbreviation of the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^self calendarDay forLocale: aChronosLocale monthAbbreviationIfResolvable: resolvable ifNot: notResolvable! !

!DateSpec methodsFor: 'queries' stamp: ''!
forLocale: aChronosLocale monthNameIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the name of the receiver's month (as specified by <aChronosLocale>) as the sole argument. However, if the nameKkey of the receiver's month is not unambigously resolvable, then evaluate <notResolvable>. Answer the result of the evaluated block."

	^self calendarDay forLocale: aChronosLocale monthNameIfResolvable: resolvable ifNot: notResolvable! !

!DateSpec methodsFor: 'accessing' stamp: ''!
globalNameOfClass
	"Answer the fully-qualified (usable anywhere) name of the receiver's class."
 
	^EnvironmentFacade current fullyQualifiedNameOfClass: self class! !

!DateSpec methodsFor: 'accessing' stamp: ''!
granularity
	"Answer the receiver's granularity, which is defined to be the quantum of resolution of its starting point-in-time (the quantum of resolution of any Chronos point-in-time value is accessible by sending it the message #resolutionQuantum.)  The quantum of resolution of a date value is one calendar day.  The quantum of resolution of a DateAndTime value is the same as that of a Duration value--currently implemented to be one nanosecond. The granularity of Timeperiod contributes to the definition of its closed extent (see the comment of the #closedExtent method, and also the class comment.)"

	^self start resolutionQuantum! !

!DateSpec methodsFor: 'comparing' stamp: ''!
hash
	^(year + calendarDay hash) hash! !

!DateSpec methodsFor: 'accessing' stamp: ''!
hour
	^self secondsSinceStartOfTimeOfDayClock // SecondsPerHour! !

!DateSpec methodsFor: 'accessing' stamp: ''!
hour12
	| hour |
	hour := self hoursSinceMidnight \\ 12.
	^hour = 0
		ifTrue: [12]
		ifFalse: [hour]! !

!DateSpec methodsFor: 'accessing-multivalued' stamp: ''!
hour12MinuteSecondDo: block3 
	^self hourMinuteSecondDo: block3 hour24Format: false! !

!DateSpec methodsFor: 'accessing' stamp: ''!
hour24
	^self hoursSinceMidnight! !

!DateSpec methodsFor: 'accessing-multivalued' stamp: ''!
hour24MinuteSecondDo: block3 
	^self hourMinuteSecondDo: block3 hour24Format: true! !

!DateSpec methodsFor: 'accessing-multivalued' stamp: ''!
hourMinuteSecondDo: block3 
	^self hourMinuteSecondDo: block3 hour24Format: true! !

!DateSpec methodsFor: 'accessing-multivalued' stamp: ''!
hourMinuteSecondDo: block3 hour24Format: hour24
	^ChronosFunction 
		fromSeconds: 
			(hour24 
				ifTrue: [self secondsSinceStartOfTimeOfDayClock]
				ifFalse: [self secondsSinceMidnight])
		hourMinuteSecondDo:  block3! !

!DateSpec methodsFor: 'accessing' stamp: ''!
hoursSinceMidnight
	^self secondsSinceMidnight // SecondsPerHour! !

!DateSpec methodsFor: 'accessing' stamp: ''!
hoursSinceStartOfDay 
	^self secondsSinceStartOfDay // SecondsPerHour! !

!DateSpec methodsFor: 'converting' stamp: ''!
in: aChronosTimezone
	"If <aChronosTimezone> is (or refers to) the Nominal Time Invariant timezone, then: Answer the result of converting the receiver into a nominal-time-invariant moment in time nominally equal to the local time represented by the receiver.
	Otherwise, If the receiver is invariant to nominal time, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, and whose local time is nominally equal to the moment in time nominally represented by the receiver.
	Otherwise, if <aChronosTimezone> is (or refers to) a timezone that is invariant to UT, then: Answer the result of converting the receiver into a moment in time whose timezone is <aChronosTimezone>, but which represents the same absolute temporal value (e.g., the same date-and-time UT)."

	"{DateAndTimeFactory now in: 'Asia/Calcutta'}"
	"{DateAndTimeFactory nominalNow in: 'Asia/Calcutta'}"
	"{DateAndTimeFactory now in: ChronosTimezone nominal}"

	^self >> aChronosTimezone! !

!DateSpec methodsFor: 'converting' stamp: ''!
inAll: aCollectionOfTimeZones
	"NOTE: If <aCollectionOfTimeZones> is a Set, the result will be a Set with only one member, because all DateAndTime instances compare as equal to all others that represent the same moment in time."

	^aCollectionOfTimeZones  collect: [:tz | self  in: tz]! !

!DateSpec methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self 
		setDaysSinceEpoch: (literalArray at: 3) asNumber
		calendar: (Calendar referencedBy: (literalArray at: 2) asSymbol)! !

!DateSpec methodsFor: 'initialize-release' stamp: ''!
invalidateCalendar
	calendarDay := calendarDay == nil ifFalse: [calendarDay canonical]! !

!DateSpec methodsFor: 'testing' stamp: ''!
isAtStartOfDay
	^true! !

!DateSpec methodsFor: 'testing' stamp: ''!
isAtStartOfMonth
	^self isFirstDayOfMonth and: [self isAtStartOfDay]! !

!DateSpec methodsFor: 'testing' stamp: ''!
isAtStartOfYear
	^self isFirstDayOfYear and: [self isAtStartOfDay]! !

!DateSpec methodsFor: 'testing' stamp: ''!
isBoundToTimeZone
	^false! !

!DateSpec methodsFor: 'testing' stamp: ''!
isDayDuration
	"Answer whether the receiver's temporal extent is one day."

	^self duration isDayDuration! !

!DateSpec methodsFor: 'testing' stamp: ''!
isFirstDayOfMonth
	^calendarDay isFirstDayOfMonth! !

!DateSpec methodsFor: 'testing' stamp: ''!
isFirstDayOfYear
	^calendarDay isFirstDayOfYear! !

!DateSpec methodsFor: 'testing' stamp: ''!
isGregorian
	^self calendar isGregorian! !

!DateSpec methodsFor: 'testing' stamp: ''!
isInvariantToNominalTime
	"Answer true if the receiver always represents an invariant nominal local time ('3 pm local time') in whatever Timezone to which it may be bound. Otherwise, answer false."

	^true! !

!DateSpec methodsFor: 'testing' stamp: ''!
isInvariantToUT
	"Answer true if the receiver always represents an invariant nominal UT time ('3 pm UT') in whatever Timezone to which it may be bound. Otherwise, answer false."
	^self isInvariantToNominalTime not! !

!DateSpec methodsFor: 'testing' stamp: ''!
isLastDayOfMonth
	^calendarDay isLastDayOfMonth! !

!DateSpec methodsFor: 'testing' stamp: ''!
isLastDayOfYear
	^calendarDay isLastDayOfYear! !

!DateSpec methodsFor: 'testing' stamp: ''!
isLeapYear
	^calendarDay yearHasLeapDays! !

!DateSpec methodsFor: 'accessing' stamp: ''!
isMonthDuration
	"Answer whether the receiver's temporal extent is one month."

	^self duration isMonthDuration! !

!DateSpec methodsFor: 'testing' stamp: ''!
isNanosecondDuration
	"Answer whether the receiver's temporal extent is one nanosecond."

	^self duration isNanosecondDuration! !

!DateSpec methodsFor: 'accessing' stamp: ''!
isYearDuration
	"Answer whether the receiver's temporal extent is one year."

	^self duration isYearDuration! !

!DateSpec methodsFor: 'accessing' stamp: ''!
isoDayOfWeekOrdinal
	^self calendar isoDayOfWeekOrdinalFromDaysSinceEpoch: self daysSinceEpoch! !

!DateSpec methodsFor: 'accessing' stamp: ''!
julianDay
	"Answers the Julian Day Number of the Julian Day in which the the point-in-time represented by the receiver occurs. However, if the receiver's interval spans across the transition from one Julian Day to the next, then the Julian Day Number of the first Julian Day that starts at Noon within the interval of time represented by the receiver is answered."

	^self calendar julianDayFromDaysSinceEpoch: self daysSinceEpoch! !

!DateSpec methodsFor: 'accessing' stamp: ''!
julianDayNumber
	"Answers the Julian Day Number of the Julian Day that starts at Noon on the date represented by the receiver."

	^self calendar julianDayFromDaysSinceEpoch: self daysSinceEpoch! !

!DateSpec methodsFor: 'accessing' stamp: ''!
last
	"Answer the last element of the receiver, which is defined to be the point-in-time computed by adding the receiver's closed extent to its starting point-in-time ({self start + self closedExtent.} Also see the class comment."


	"{(Timeperiod 
		startingAt: (YearMonthDay year: 1901 day: 1)
		duration: (CalendarDuration years: 100)) last}"

	^self start + self closedExtent! !

!DateSpec methodsFor: 'accessing' stamp: ''!
latest
	"Compare the first and last element of the receiver (see the class comment,) and answer whichever one temporally follows the other. If neither one temporally follows the other, answer either the receiver's first or last element."

	^self first max: self last! !

!DateSpec methodsFor: 'accessing' stamp: ''!
limit
	"Answer the end-point or `limit value` of the receiver, which is defined to be the point-in-time computed by adding the temporal extent (duration) of a Timeperiod to its starting point. The end-point/limit is not included in the Timeperiod's temporal interval (although the points-in-time that asymptotically approach the limit from its starting point-in-time are all included in a Timeperiod's temporal interval.)"

	^self start + self duration! !

!DateSpec methodsFor: 'printing' stamp: ''!
localePrintString
	^self printStringUsing: self defaultLocale temporalPrintPolicy! !

!DateSpec methodsFor: 'printing' stamp: ''!
longPrintString
	^self printStringUsing: (self defaultLocale temporalPrintPolicy 
				apply: #(#showDayOfWeekName 
						#useMonthName 
						#showTimeOfDay 
						#showTimeZoneOffset 
						#timeZoneSeparator: $  
						#timeZoneElementSeparator: nil 
						#showNamesOfDurationElements 
						#showNamesOfCalendarDurationElements))! !

!DateSpec methodsFor: 'accessing' stamp: ''!
microsecondsSinceEpoch

	^self secondsSinceEpoch * MicrosecondsPerSecond + self microsecondsSinceSecond! !

!DateSpec methodsFor: 'accessing' stamp: ''!
microsecondsSinceSecond
	^(self nanosecondsSinceSecond bitShift: -3) // 125! !

!DateSpec methodsFor: 'accessing' stamp: ''!
microsecondsSinceStartOfDay
	^self nanosecondsSinceStartOfDay // NanosecondsPerMicrosecond! !

!DateSpec methodsFor: 'testing' stamp: ''!
midnightIsStartOfDay
	"Answer true if the receiver's calendrical system starts each day at local midnight."

	^self calendar midnightIsStartOfDay! !

!DateSpec methodsFor: 'accessing' stamp: ''!
millisecond
	^(self nanosecondsSinceSecond bitShift: -6) // 15625! !

!DateSpec methodsFor: 'accessing' stamp: ''!
millisecondsSinceEpoch

	^self secondsSinceEpoch * MillisecondsPerSecond + self millisecond! !

!DateSpec methodsFor: 'accessing' stamp: ''!
millisecondsSinceStartOfDay
	^self nanosecondsSinceStartOfDay // NanosecondsPerMillisecond! !

!DateSpec methodsFor: 'accessing' stamp: ''!
minute
	^self minutesSinceStartOfTimeOfDayClock \\ MinutesPerHour! !

!DateSpec methodsFor: 'accessing' stamp: ''!
minutesSinceMidnight
	^self secondsSinceMidnight // SecondsPerMinute! !

!DateSpec methodsFor: 'accessing' stamp: ''!
minutesSinceStartOfDay 
	^self secondsSinceStartOfDay // SecondsPerMinute! !

!DateSpec methodsFor: 'accessing' stamp: ''!
minutesSinceStartOfTimeOfDayClock
	^self secondsSinceStartOfTimeOfDayClock // SecondsPerMinute! !

!DateSpec methodsFor: 'accessing' stamp: ''!
month
	^calendarDay month! !

!DateSpec methodsFor: 'accessing' stamp: ''!
monthAbbreviation
	^self 
		forLocale: ChronosLocale default
		monthAbbreviationIfResolvable: [:name | name]
		ifNot: [self calendarDay monthAbbreviation]! !

!DateSpec methodsFor: 'accessing' stamp: ''!
monthKey
	^calendarDay monthKey! !

!DateSpec methodsFor: 'queries' stamp: ''!
monthKeyIfResolvable: resolvable ifNot: notResolvable
	"Evaluate <resolvable> with the key that semantically identifies the receiver's month as the sole argument. However, if the month's semantic key is not unambiguously resolvable, answer the result of evaluationg <notResolvable>. Answer the result of the evaluated block."

	^resolvable value: self monthKey! !

!DateSpec methodsFor: 'accessing' stamp: ''!
monthName
	^self 
		forLocale: ChronosLocale default
		monthNameIfResolvable: [:name | name]
		ifNot: [self calendarDay monthName]! !

!DateSpec methodsFor: 'accessing' stamp: ''!
monthOrdinal
	^calendarDay monthOrdinal! !

!DateSpec methodsFor: 'accessing' stamp: ''!
monthsSinceEpoch
	^(self calendar monthsSinceEpochUpToYear: self year) 
		+ self monthsSinceStartOfYear! !

!DateSpec methodsFor: 'accessing' stamp: ''!
monthsSinceStartOfYear
	^calendarDay monthsSinceStartOfYear! !

!DateSpec methodsFor: 'accessing' stamp: ''!
nanosecondsSinceEpoch
	^self secondsSinceEpoch * NanosecondsPerSecond + self nanosecondsSinceSecond! !

!DateSpec methodsFor: 'accessing' stamp: ''!
nanosecondsSinceMidnight
	^self secondsSinceMidnight * NanosecondsPerSecond + self nanosecondsSinceSecond! !

!DateSpec methodsFor: 'accessing' stamp: ''!
nanosecondsSinceSecond	
	^0! !

!DateSpec methodsFor: 'accessing' stamp: ''!
nanosecondsSinceStartOfDay
	^self secondsSinceStartOfDay * NanosecondsPerSecond + self nanosecondsSinceSecond! !

!DateSpec methodsFor: 'accessing' stamp: ''!
nanosecondsSinceUnificationEpoch
	^self secondsSinceUnificationEpoch * NanosecondsPerSecond + self nanosecondsSinceSecond! !

!DateSpec methodsFor: 'accessing' stamp: ''!
numericMonthDesignator
	"Answer the culturally-correct numerical label for the receiver's month (usually, this is the ordinal number of the month in the sequence of months since the month that begins a year, but such is not the case in all cultures.)"

	^self calendar numericMonthDesignatorFromMonthOrdinal: self monthOrdinal
		forYearTypeCode: self yearTypeCode! !

!DateSpec methodsFor: 'printing' stamp: ''!
printOn: stream
	self printOn: stream using: self defaultPrintPolicy! !

!DateSpec methodsFor: 'printing' stamp: ''!
printOn: stream using: aChronosPrintPolicy
	"Delegate the responsibility for printing the receiver on <stream> to <aChronosPrintPolicy>."
	"If <aChronosPrintPolicy> == ChronosPrintPolicy default (or ChronosPrintPolicy ansiStandard or ChronosPrintPolicy iso8601,) then the receiver's printString will be formatted as required by the ISO 8601 Standard."

	(ChronosPrintPolicy referencedBy: aChronosPrintPolicy) printDate: self on: stream! !

!DateSpec methodsFor: 'printing' stamp: ''!
printStringForLocale: aLocale
	"Answer the printString of the receiver as generated by the temporal print policy of the ChronosLocale specified by <aLocale>."

	^self printStringUsing: (ChronosLocale referencedBy: aLocale) temporalPrintPolicy! !

!DateSpec methodsFor: 'printing' stamp: ''!
printStringUsing: aPrintPolicy
	| stream |
	stream := (String new: 30) writeStream.
	self printOn: stream using: aPrintPolicy.
	^stream contents! !

!DateSpec methodsFor: 'accessing' stamp: ''!
relativity
	^#nominal! !

!DateSpec methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the receiver's quantum of temporal resolution--the resolution of its ability to represent time.  The quantum of temporal resolution is the minimum non-zero temporal extent by which two instances of the receiver's class can differ in value."

	^calendarDay resolutionQuantum! !

!DateSpec methodsFor: 'accessing' stamp: ''!
second
	^self secondsSinceStartOfTimeOfDayClock \\ SecondsPerMinute! !

!DateSpec methodsFor: 'queries' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsInDay
	^SecondsPerDay! !

!DateSpec methodsFor: 'arithmetic' stamp: ''!
secondsSince: aTemporal
	| seconds |
	seconds := self basicSecondsSince: aTemporal.
	^(self basicNanosecondsSinceSecondSince: aTemporal) >= 0 
		ifTrue: [seconds]
		ifFalse: [seconds - 1]! !

!DateSpec methodsFor: 'accessing' stamp: ''!
secondsSinceEpoch
	^(self daysSinceEpoch * 675 bitShift: 7) + self secondsSinceStartOfDay
	"86400 = 128 * 675"! !

!DateSpec methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsSinceMidnight
	^self midnightIsStartOfDay 
		ifTrue: [self secondsSinceStartOfDay]
		ifFalse: 
			[(self calendar 
				secondsSinceMidnightFromSecondsSinceStartOfDay: self secondsSinceStartOfDay) 
					\\ SecondsPerDay]! !

!DateSpec methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfDay	
	^0! !

!DateSpec methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
secondsSinceStartOfMonth
	^self daysSinceStartOfMonth * SecondsPerDay + self secondsSinceStartOfDay! !

!DateSpec methodsFor: 'accessing' stamp: ''!
secondsSinceStartOfTimeOfDayClock
	^self timeOfDayClockStartsAtStartOfDay 
		ifTrue: [self secondsSinceStartOfDay]
		ifFalse: [self secondsSinceMidnight]! !

!DateSpec methodsFor: 'accessing' stamp: ''!
secondsSinceUnificationEpoch
	^self calendar secondsSinceUnificationEpochFromSecondsSinceEpoch: self secondsSinceEpoch! !

!DateSpec methodsFor: 'arithmetic' stamp: ''!
secondsUntil: aTemporal
	| seconds |
	seconds := self basicSecondsUntil: aTemporal.
	^(self basicNanosecondsSinceSecondUntil: aTemporal ) >= 0 
		ifTrue: [seconds]
		ifFalse: [seconds - 1]! !

!DateSpec methodsFor: 'initialize-release' stamp: ''!
setDaysSinceEpoch: daysSinceEpoch calendar: calendar
	calendar
		forDaysSinceEpoch: daysSinceEpoch truncated
		setYearAndCalendarDayInto: self! !

!DateSpec methodsFor: 'initialize-release' stamp: ''!
setJulianDay: julianDay calendar: calendar
	self setDaysSinceEpoch: (calendar daysSinceEpochFromJulianDay: julianDay) calendar: calendar! !

!DateSpec methodsFor: 'initialize-release' stamp: ''!
setYear: y calendarDay: cd
	year := y.
	calendarDay := cd.! !

!DateSpec methodsFor: 'initialize-release' stamp: ''!
setYear: y dayOfYearOrdinal: dayOfYearOrdinal calendar: calendar 
	self 
		setYear: y
		calendarDay: ((calendar yearlyCalendarFor: y) basicDayAt: dayOfYearOrdinal)! !

!DateSpec methodsFor: 'initialize-release' stamp: ''!
setYear: y monthOrdinal: m dayOfMonthOrdinal: d calendar: calendar
	self setYear: y calendarDay: ((calendar yearlyCalendarFor: y) basicMonthAt: m dayAt: d).! !

!DateSpec methodsFor: 'printing' stamp: ''!
shortPrintString
	"Timepoint now shortPrintString"

	^self printStringUsing: (self defaultLocale temporalPrintPolicy 
				apply: #(#hideDayOfWeek 
						#useMonthAbbreviation 
						#showTimeOfDay 
						#hideSubsecondFraction 
						#showTimeZoneOffset 
						#timeZoneSeparator: $  
						#timeZoneElementSeparator: nil 
						#hideNamesOfDurationElements 
						#durationDayHourSeparator: ' T ' 
						#durationElementSeparator: $: 
						#durationPadChar: $0 
						#hideNamesOfCalendarDurationElements 
						#showZeroValuedDurationElements 
						#hideZeroValuedCalendarDurationElements))! !

!DateSpec methodsFor: 'accessing' stamp: ''!
start
	^self! !

!DateSpec methodsFor: 'accessing' stamp: ''!
timeOfDay
	^self hourMinuteSecondDo: 
			[:h :m :s | 
			TimeOfDayFactory 
				hour: h
				minute: m
				second: s
				nanosecond: self nanosecondsSinceSecond]! !

!DateSpec methodsFor: 'testing' stamp: ''!
timeOfDayClockStartsAtMidnight
	"Answer true if the zero-point of the time-of-day clock coincides with midnight"

	^self calendar timeOfDayClockStartsAtMidnight! !

!DateSpec methodsFor: 'testing' stamp: ''!
timeOfDayClockStartsAtStartOfDay
	"Answer true if the zero-point of the time-of-day clock canonically used by the principal users of the receiver's calendrical system coincides with the start-of-day moment.  Note that some cultures represent time-of-day as a count of time since midnight, in spite of the fact that, in their calendrical system, midnight is not the moment at which one day transitions to the next day."

	^self calendar timeOfDayClockStartsAtStartOfDay! !

!DateSpec methodsFor: 'accessing' stamp: ''!
timeOfDaySinceMidnight
	^self timeOfDayClockStartsAtMidnight 
		ifTrue: [self timeOfDay]
		ifFalse: 
			[ChronosFunction 
				fromSeconds: self secondsSinceMidnight
				hourMinuteSecondDo: 
					[:h :m :s | 
					TimeOfDayFactory 
						hour: h
						minute: m
						second: s
						nanosecond: self nanosecondsSinceSecond]]! !

!DateSpec methodsFor: 'accessing' stamp: ''!
timeZone
	^ChronosTimezone nominal! !

!DateSpec methodsFor: 'initialize-release' stamp: ''!
value: y value: cd
	year := y.
	calendarDay := cd.! !

!DateSpec methodsFor: 'accessing' stamp: ''!
weekOfMonthOrdinal
	"Answer the ordinal number of the week of the month in which the day represented by the receiver occurs.  The first seven days of the month are the first week of the month."

	^self weeksSinceStartOfMonth + 1! !

!DateSpec methodsFor: 'accessing' stamp: ''!
weekOfYearOrdinal
	"NOT ISO 8601"

	^self weeksSinceStartOfYear + 1! !

!DateSpec methodsFor: 'accessing' stamp: ''!
weeksSinceStartOfMonth
	"Answer the CARDINAL number of the week of the month in which the day represented by the receiver occurs.  The first seven days of the month are in the week whose CARDINAL number is zero."

	^self daysSinceStartOfMonth // DaysPerWeek! !

!DateSpec methodsFor: 'accessing' stamp: ''!
weeksSinceStartOfYear
	"NOT ISO 8601"

	^self daysSinceStartOfYear // DaysPerWeek! !

!DateSpec methodsFor: 'accessing' stamp: ''!
year
	^year! !

!DateSpec methodsFor: 'accessing-multivalued' stamp: ''!
yearAndCalendarDayDo: block2 
	^block2 value: year value: calendarDay! !

!DateSpec methodsFor: 'accessing' stamp: ''!
yearAndDayOfYearOrdinalAndYearTypeCodeDo: block3
	^block3 
		value: year
		value: self dayOfYearOrdinal
		value: self yearTypeCode! !

!DateSpec methodsFor: 'accessing' stamp: ''!
yearAndDaysSinceStartOfYearAndYearTypeCodeDo: block3
	^block3 
		value: year
		value: self daysSinceStartOfYear
		value: self yearTypeCode! !

!DateSpec methodsFor: 'accessing' stamp: ''!
yearCardinal
	^self calendar yearNumberingPolicy cardinalFromCanonical: self year! !

!DateSpec methodsFor: 'accessing-multivalued' stamp: ''!
yearMonthDayDo: block3
	"Evaluate <block3> with the calendar year number, month ordinal and day-of-month ordinal of the day represented by the receiver as the first, second and third arguments (respectively.) If the receiver is not bound to a particular year, use nil as the value of the year."

	^block3 
		value: year
		value: self month
		value: self dayOfMonth! !

!DateSpec methodsFor: 'accessing' stamp: ''!
yearOrdinal
	^self calendar yearNumberingPolicy ordinalFromCanonical: self year! !

!DateSpec methodsFor: 'accessing' stamp: ''!
yearTypeCode
	^calendarDay yearTypeCode! !

!DateSpec methodsFor: 'accessing' stamp: ''!
yearsSinceEpoch
	^self yearCardinal! !

ExternalResource subclass: #TimeZoneLocalizationPolicy
	instanceVariableNames: 'zoneMap defaultTimeZoneKeysByStandardTimeOffsetFromUT defaultTimeZoneKeysByCommonAbbreviation'
	classVariableNames: 'CountryNames Default Root Unique'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Localization'!

!TimeZoneLocalizationPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!TimeZoneLocalizationPolicy class methodsFor: 'instance creation' stamp: ''!
decodeDefaultMappingsFrom: stream into: policy
	| atEnd |
	ChronosFunction skipSeparators: stream.
	atEnd := stream atEnd.
	[atEnd] whileFalse:
		[| key dstPreferred dstNotPreferred |
		key := stream upTo: $ .
		ChronosFunction skipSeparators: stream.
		dstPreferred :=  (stream upTo: $ ) asSymbol.
		ChronosFunction skipSeparators: stream.
		dstNotPreferred := ChronosFunction nextLineFrom: stream.
		dstNotPreferred last = $!! 
			ifTrue: 
				[atEnd := true.
				dstNotPreferred := dstNotPreferred copyFrom: 1 to: dstNotPreferred size - 1].
		key first isLetter
			ifTrue: [policy bindCommonTzAbbreviation: key asSymbol withDSTPreferredTo: dstPreferred withDSTNotPreferredTo: dstNotPreferred]
			ifFalse: [policy bindStandardTimeOffsetFromUT: key asNumber withDSTPreferredTo: dstPreferred withDSTNotPreferredTo: dstNotPreferred].
		atEnd := atEnd 
						or: 
							[ChronosFunction skipSeparators: stream.
							stream atEnd]].! !

!TimeZoneLocalizationPolicy class methodsFor: 'instance creation' stamp: ''!
decodeFrom: stream
	| registrationKey policy |
	registrationKey := self registrationKeyFrom: stream.
	policy := self new.
	policy setKey: registrationKey.
	self decodeDefaultMappingsFrom: stream into: policy.
	self decodeZoneMapFrom: stream into: policy.
	^policy beImmutable! !

!TimeZoneLocalizationPolicy class methodsFor: 'instance creation' stamp: ''!
decodeZoneMapFrom: stream into: policy 
	| tzKey abbreviation offsetSecondsFromUT stdTimeOffsetSecondsFromUT |
	[ChronosFunction skipSeparators: stream.
	stream atEnd or: [stream peekFor: $!!]] 
			whileFalse: 
				[tzKey := (stream upTo: $:) asSymbol.
				ChronosFunction skipSeparators: stream.
				[stream peekFor: $@] whileTrue: 
						[abbreviation := (ChronosFunction nextFrom: stream until: [:ch | ch isSeparator]) asSymbol.
						[ChronosFunction skipSeparators: stream.
						stream peekFor: $|] 
								whileTrue: 
									[| ch polarity |
									ChronosFunction skipSeparators: stream.
									ch := stream peek.
									polarity := #($- $+) indexOf: ch ifAbsent: [0].
									polarity = 0
										ifTrue: [polarity := 1]
										ifFalse: 
											[stream next.
											polarity := #(-1 1) at: polarity].
									offsetSecondsFromUT := 
										(ChronosFunction 
											nextUnsignedIntegerFrom: stream
											minDigits: 1
											maxDigits: 5
											acceptancePredicate: [:int :digitCount | true]
											handleRejection: [:value :digitCount :rejectionReason | self signalError: rejectionReason]) * polarity.
									ChronosFunction skipSeparators: stream.
									ch := stream peek.
									polarity := #($- $+) indexOf: ch ifAbsent: [0].
									polarity = 0
										ifTrue: [polarity := 1]
										ifFalse: 
											[stream next.
											polarity := #(-1 1) at: polarity].
									stdTimeOffsetSecondsFromUT := 
										(ChronosFunction 
											nextUnsignedIntegerFrom: stream
											minDigits: 1
											maxDigits: 5
											acceptancePredicate: [:int :digitCount | true]
											handleRejection: [:value :digitCount :rejectionReason | self signalError: rejectionReason]) * polarity.
									policy 
										addZoneWithKey: tzKey
										abbreviation: abbreviation
										offsetSecondsFromUT: offsetSecondsFromUT
										stdTimeOffsetSecondsFromUT: stdTimeOffsetSecondsFromUT]]]! !

!TimeZoneLocalizationPolicy class methodsFor: 'accessing' stamp: ''!
default
	^Default == nil 
		ifTrue: 
			[| defaultCountryCode |
			defaultCountryCode := ChronosLocale default countryCode.
			self 
				at: defaultCountryCode
				ifAbsent: 
					[defaultCountryCode == #US 
						ifTrue: [self root]
						ifFalse: [self at: #US ifAbsent: [self root]]]]
		ifFalse: [Default]! !

!TimeZoneLocalizationPolicy class methodsFor: 'country names' stamp: ''!
defaultCountryNameAt: countryCode ifAbsent: block0
	^CountryNames at: countryCode ifAbsent: block0! !

!TimeZoneLocalizationPolicy class methodsFor: 'private' stamp: ''!
defineAllUniqueAbbreviationsIn: policy

		"All completely unique abbreviations, as generated by the following code:
		{TimeZonePolicySequenceFactory keysByAbbreviation keysAndValuesDo: [:key :value | 
			value size = 1
				ifTrue:
					[| tzKey |
					tzKey := value asArray first.
					Transcript
						cr; tab; tab;
						show: 'bindCommonTzAbbreviation: ';
						show: '''';
						show: key;
						show: '''';
						show: ' withDSTPreferredTo: #';
						show: '''';
						show: tzKey;
						show: '''';
						show: ' withDSTNotPreferredTo: #';
						show: '''';
						show: tzKey;
						show: '''';
						show: ';']]}"
	policy
		bindCommonTzAbbreviation: 'CXT' withDSTPreferredTo: #'Indian/Christmas' withDSTNotPreferredTo: #'Indian/Christmas';
		bindCommonTzAbbreviation: 'LKT' withDSTPreferredTo: #'Asia/Colombo' withDSTNotPreferredTo: #'Asia/Colombo';
		bindCommonTzAbbreviation: 'GYT' withDSTPreferredTo: #'America/Guyana' withDSTNotPreferredTo: #'America/Guyana';
		bindCommonTzAbbreviation: 'GALT' withDSTPreferredTo: #'Pacific/Galapagos' withDSTNotPreferredTo: #'Pacific/Galapagos';
		bindCommonTzAbbreviation: 'GFT' withDSTPreferredTo: #'America/Cayenne' withDSTNotPreferredTo: #'America/Cayenne';
		bindCommonTzAbbreviation: 'FKT' withDSTPreferredTo: #'Atlantic/Stanley' withDSTNotPreferredTo: #'Atlantic/Stanley';
		bindCommonTzAbbreviation: 'HOVT' withDSTPreferredTo: #'Asia/Hovd' withDSTNotPreferredTo: #'Asia/Hovd';
		bindCommonTzAbbreviation: 'GMT+2' withDSTPreferredTo: #'Etc/GMT+2' withDSTNotPreferredTo: #'Etc/GMT+2';
		bindCommonTzAbbreviation: 'SBT' withDSTPreferredTo: #'Pacific/Guadalcanal' withDSTNotPreferredTo: #'Pacific/Guadalcanal';
		bindCommonTzAbbreviation: 'GMT-3' withDSTPreferredTo: #'Etc/GMT-3' withDSTNotPreferredTo: #'Etc/GMT-3';
		bindCommonTzAbbreviation: 'GMT-8' withDSTPreferredTo: #'Etc/GMT-8' withDSTNotPreferredTo: #'Etc/GMT-8';
		bindCommonTzAbbreviation: 'VUT' withDSTPreferredTo: #'Pacific/Efate' withDSTNotPreferredTo: #'Pacific/Efate';
		bindCommonTzAbbreviation: 'GMT+5' withDSTPreferredTo: #'Etc/GMT+5' withDSTNotPreferredTo: #'Etc/GMT+5';
		bindCommonTzAbbreviation: 'MAWT' withDSTPreferredTo: #'Antarctica/Mawson' withDSTNotPreferredTo: #'Antarctica/Mawson';
		bindCommonTzAbbreviation: 'MEST' withDSTPreferredTo: #'MET' withDSTNotPreferredTo: #'MET';
		bindCommonTzAbbreviation: 'GMT-13' withDSTPreferredTo: #'Etc/GMT-13' withDSTNotPreferredTo: #'Etc/GMT-13';
		bindCommonTzAbbreviation: 'QYZT' withDSTPreferredTo: #'Asia/Qyzylorda' withDSTNotPreferredTo: #'Asia/Qyzylorda';
		bindCommonTzAbbreviation: 'GMT+8' withDSTPreferredTo: #'Etc/GMT+8' withDSTNotPreferredTo: #'Etc/GMT+8';
		bindCommonTzAbbreviation: 'PYT' withDSTPreferredTo: #'America/Asuncion' withDSTNotPreferredTo: #'America/Asuncion';
		bindCommonTzAbbreviation: 'AZT' withDSTPreferredTo: #'Asia/Baku' withDSTNotPreferredTo: #'Asia/Baku';
		bindCommonTzAbbreviation: 'SAKT' withDSTPreferredTo: #'Asia/Sakhalin' withDSTNotPreferredTo: #'Asia/Sakhalin';
		bindCommonTzAbbreviation: 'ECT' withDSTPreferredTo: #'America/Guayaquil' withDSTNotPreferredTo: #'America/Guayaquil';
		bindCommonTzAbbreviation: 'PETT' withDSTPreferredTo: #'Asia/Kamchatka' withDSTNotPreferredTo: #'Asia/Kamchatka';
		bindCommonTzAbbreviation: 'GMT+12' withDSTPreferredTo: #'Etc/GMT+12' withDSTNotPreferredTo: #'Etc/GMT+12';
		bindCommonTzAbbreviation: 'FKST' withDSTPreferredTo: #'Atlantic/Stanley' withDSTNotPreferredTo: #'Atlantic/Stanley';
		bindCommonTzAbbreviation: 'GMT+9' withDSTPreferredTo: #'Etc/GMT+9' withDSTNotPreferredTo: #'Etc/GMT+9';
		bindCommonTzAbbreviation: 'WAKT' withDSTPreferredTo: #'Pacific/Wake' withDSTNotPreferredTo: #'Pacific/Wake';
		bindCommonTzAbbreviation: 'GET' withDSTPreferredTo: #'Asia/Tbilisi' withDSTNotPreferredTo: #'Asia/Tbilisi';
		bindCommonTzAbbreviation: 'ORAT' withDSTPreferredTo: #'Asia/Oral' withDSTNotPreferredTo: #'Asia/Oral';
		bindCommonTzAbbreviation: 'KOST' withDSTPreferredTo: #'Pacific/Kosrae' withDSTNotPreferredTo: #'Pacific/Kosrae';
		bindCommonTzAbbreviation: 'IRKT' withDSTPreferredTo: #'Asia/Irkutsk' withDSTNotPreferredTo: #'Asia/Irkutsk';
		bindCommonTzAbbreviation: 'CHOST' withDSTPreferredTo: #'Asia/Choibalsan' withDSTNotPreferredTo: #'Asia/Choibalsan';
		bindCommonTzAbbreviation: 'SAKST' withDSTPreferredTo: #'Asia/Sakhalin' withDSTNotPreferredTo: #'Asia/Sakhalin';
		bindCommonTzAbbreviation: 'VOST' withDSTPreferredTo: #'Antarctica/Vostok' withDSTNotPreferredTo: #'Antarctica/Vostok';
		bindCommonTzAbbreviation: 'GMT+10' withDSTPreferredTo: #'Etc/GMT+10' withDSTNotPreferredTo: #'Etc/GMT+10';
		bindCommonTzAbbreviation: 'GMT-10' withDSTPreferredTo: #'Etc/GMT-10' withDSTNotPreferredTo: #'Etc/GMT-10';
		bindCommonTzAbbreviation: 'FJT' withDSTPreferredTo: #'Pacific/Fiji' withDSTNotPreferredTo: #'Pacific/Fiji';
		bindCommonTzAbbreviation: 'MAGST' withDSTPreferredTo: #'Asia/Magadan' withDSTNotPreferredTo: #'Asia/Magadan';
		bindCommonTzAbbreviation: 'NPT' withDSTPreferredTo: #'Asia/Katmandu' withDSTNotPreferredTo: #'Asia/Katmandu';
		bindCommonTzAbbreviation: 'MMT' withDSTPreferredTo: #'Asia/Rangoon' withDSTNotPreferredTo: #'Asia/Rangoon';
		bindCommonTzAbbreviation: 'PGT' withDSTPreferredTo: #'Pacific/Port_Moresby' withDSTNotPreferredTo: #'Pacific/Port_Moresby';
		bindCommonTzAbbreviation: 'TJT' withDSTPreferredTo: #'Asia/Dushanbe' withDSTNotPreferredTo: #'Asia/Dushanbe';
		bindCommonTzAbbreviation: 'WGT' withDSTPreferredTo: #'America/Godthab' withDSTNotPreferredTo: #'America/Godthab';
		bindCommonTzAbbreviation: 'MET' withDSTPreferredTo: #'MET' withDSTNotPreferredTo: #'MET';
		bindCommonTzAbbreviation: 'OMST' withDSTPreferredTo: #'Asia/Omsk' withDSTNotPreferredTo: #'Asia/Omsk';
		bindCommonTzAbbreviation: 'WGST' withDSTPreferredTo: #'America/Godthab' withDSTNotPreferredTo: #'America/Godthab';
		bindCommonTzAbbreviation: 'YAKST' withDSTPreferredTo: #'Asia/Yakutsk' withDSTNotPreferredTo: #'Asia/Yakutsk';
		bindCommonTzAbbreviation: 'VLAT' withDSTPreferredTo: #'Asia/Vladivostok' withDSTNotPreferredTo: #'Asia/Vladivostok';
		bindCommonTzAbbreviation: 'PWT' withDSTPreferredTo: #'Pacific/Palau' withDSTNotPreferredTo: #'Pacific/Palau';
		bindCommonTzAbbreviation: 'GMT-4' withDSTPreferredTo: #'Etc/GMT-4' withDSTNotPreferredTo: #'Etc/GMT-4';
		bindCommonTzAbbreviation: 'WAST' withDSTPreferredTo: #'Africa/Windhoek' withDSTNotPreferredTo: #'Africa/Windhoek';
		bindCommonTzAbbreviation: 'NOVT' withDSTPreferredTo: #'Asia/Novosibirsk' withDSTNotPreferredTo: #'Asia/Novosibirsk';
		bindCommonTzAbbreviation: 'GMT+3' withDSTPreferredTo: #'Etc/GMT+3' withDSTNotPreferredTo: #'Etc/GMT+3';
		bindCommonTzAbbreviation: 'DAVT' withDSTPreferredTo: #'Antarctica/Davis' withDSTNotPreferredTo: #'Antarctica/Davis';
		bindCommonTzAbbreviation: 'PHT' withDSTPreferredTo: #'Asia/Manila' withDSTNotPreferredTo: #'Asia/Manila';
		bindCommonTzAbbreviation: 'ALMT' withDSTPreferredTo: #'Asia/Almaty' withDSTNotPreferredTo: #'Asia/Almaty';
		bindCommonTzAbbreviation: 'EIT' withDSTPreferredTo: #'Asia/Jayapura' withDSTNotPreferredTo: #'Asia/Jayapura';
		bindCommonTzAbbreviation: 'TKT' withDSTPreferredTo: #'Pacific/Fakaofo' withDSTNotPreferredTo: #'Pacific/Fakaofo';
		bindCommonTzAbbreviation: 'GILT' withDSTPreferredTo: #'Pacific/Tarawa' withDSTNotPreferredTo: #'Pacific/Tarawa';
		bindCommonTzAbbreviation: 'PHOT' withDSTPreferredTo: #'Pacific/Enderbury' withDSTNotPreferredTo: #'Pacific/Enderbury';
		bindCommonTzAbbreviation: 'MVT' withDSTPreferredTo: #'Indian/Maldives' withDSTNotPreferredTo: #'Indian/Maldives';
		bindCommonTzAbbreviation: 'GMT+11' withDSTPreferredTo: #'Etc/GMT+11' withDSTNotPreferredTo: #'Etc/GMT+11';
		bindCommonTzAbbreviation: 'NFT' withDSTPreferredTo: #'Pacific/Norfolk' withDSTNotPreferredTo: #'Pacific/Norfolk';
		bindCommonTzAbbreviation: 'GMT-7' withDSTPreferredTo: #'Etc/GMT-7' withDSTNotPreferredTo: #'Etc/GMT-7';
		bindCommonTzAbbreviation: 'GMT+1' withDSTPreferredTo: #'Etc/GMT+1' withDSTNotPreferredTo: #'Etc/GMT+1';
		bindCommonTzAbbreviation: 'GMT+4' withDSTPreferredTo: #'Etc/GMT+4' withDSTNotPreferredTo: #'Etc/GMT+4';
		bindCommonTzAbbreviation: 'LINT' withDSTPreferredTo: #'Pacific/Kiritimati' withDSTNotPreferredTo: #'Pacific/Kiritimati';
		bindCommonTzAbbreviation: 'CHOT' withDSTPreferredTo: #'Asia/Choibalsan' withDSTNotPreferredTo: #'Asia/Choibalsan';
		bindCommonTzAbbreviation: 'KRAT' withDSTPreferredTo: #'Asia/Krasnoyarsk' withDSTNotPreferredTo: #'Asia/Krasnoyarsk';
		bindCommonTzAbbreviation: 'HOVST' withDSTPreferredTo: #'Asia/Hovd' withDSTNotPreferredTo: #'Asia/Hovd';
		bindCommonTzAbbreviation: 'KGT' withDSTPreferredTo: #'Asia/Bishkek' withDSTNotPreferredTo: #'Asia/Bishkek';
		bindCommonTzAbbreviation: 'CKT' withDSTPreferredTo: #'Pacific/Rarotonga' withDSTNotPreferredTo: #'Pacific/Rarotonga';
		bindCommonTzAbbreviation: 'EGT' withDSTPreferredTo: #'America/Scoresbysund' withDSTNotPreferredTo: #'America/Scoresbysund';
		bindCommonTzAbbreviation: 'GMT-12' withDSTPreferredTo: #'Etc/GMT-12' withDSTNotPreferredTo: #'Etc/GMT-12';
		bindCommonTzAbbreviation: 'TRUT' withDSTPreferredTo: #'Pacific/Truk' withDSTNotPreferredTo: #'Pacific/Truk';
		bindCommonTzAbbreviation: 'UYT' withDSTPreferredTo: #'America/Montevideo' withDSTNotPreferredTo: #'America/Montevideo';
		bindCommonTzAbbreviation: 'GMT-6' withDSTPreferredTo: #'Etc/GMT-6' withDSTNotPreferredTo: #'Etc/GMT-6';
		bindCommonTzAbbreviation: 'BOT' withDSTPreferredTo: #'America/La_Paz' withDSTNotPreferredTo: #'America/La_Paz';
		bindCommonTzAbbreviation: 'RET' withDSTPreferredTo: #'Indian/Reunion' withDSTNotPreferredTo: #'Indian/Reunion';
		bindCommonTzAbbreviation: 'TFT' withDSTPreferredTo: #'Indian/Kerguelen' withDSTNotPreferredTo: #'Indian/Kerguelen';
		bindCommonTzAbbreviation: 'KGST' withDSTPreferredTo: #'Asia/Bishkek' withDSTNotPreferredTo: #'Asia/Bishkek';
		bindCommonTzAbbreviation: 'GMT-11' withDSTPreferredTo: #'Etc/GMT-11' withDSTNotPreferredTo: #'Etc/GMT-11';
		bindCommonTzAbbreviation: 'ANAT' withDSTPreferredTo: #'Asia/Anadyr' withDSTNotPreferredTo: #'Asia/Anadyr';
		bindCommonTzAbbreviation: 'TOT' withDSTPreferredTo: #'Pacific/Tongatapu' withDSTNotPreferredTo: #'Pacific/Tongatapu';
		bindCommonTzAbbreviation: 'PET' withDSTPreferredTo: #'America/Lima' withDSTNotPreferredTo: #'America/Lima';
		bindCommonTzAbbreviation: 'SAMT' withDSTPreferredTo: #'Europe/Samara' withDSTNotPreferredTo: #'Europe/Samara';
		bindCommonTzAbbreviation: 'MART' withDSTPreferredTo: #'Pacific/Marquesas' withDSTNotPreferredTo: #'Pacific/Marquesas';
		bindCommonTzAbbreviation: 'YEKT' withDSTPreferredTo: #'Asia/Yekaterinburg' withDSTNotPreferredTo: #'Asia/Yekaterinburg';
		bindCommonTzAbbreviation: 'GMT+7' withDSTPreferredTo: #'Etc/GMT+7' withDSTNotPreferredTo: #'Etc/GMT+7';
		bindCommonTzAbbreviation: 'YAKT' withDSTPreferredTo: #'Asia/Yakutsk' withDSTNotPreferredTo: #'Asia/Yakutsk';
		bindCommonTzAbbreviation: 'ROTT' withDSTPreferredTo: #'Antarctica/Rothera' withDSTNotPreferredTo: #'Antarctica/Rothera';
		bindCommonTzAbbreviation: 'PMST' withDSTPreferredTo: #'America/Miquelon' withDSTNotPreferredTo: #'America/Miquelon';
		bindCommonTzAbbreviation: 'PETST' withDSTPreferredTo: #'Asia/Kamchatka' withDSTNotPreferredTo: #'Asia/Kamchatka';
		bindCommonTzAbbreviation: 'CVT' withDSTPreferredTo: #'Atlantic/Cape_Verde' withDSTNotPreferredTo: #'Atlantic/Cape_Verde';
		bindCommonTzAbbreviation: 'MUT' withDSTPreferredTo: #'Indian/Mauritius' withDSTNotPreferredTo: #'Indian/Mauritius';
		bindCommonTzAbbreviation: 'COT' withDSTPreferredTo: #'America/Bogota' withDSTNotPreferredTo: #'America/Bogota';
		bindCommonTzAbbreviation: 'ANAST' withDSTPreferredTo: #'Asia/Anadyr' withDSTNotPreferredTo: #'Asia/Anadyr';
		bindCommonTzAbbreviation: 'GMT-5' withDSTPreferredTo: #'Etc/GMT-5' withDSTNotPreferredTo: #'Etc/GMT-5';
		bindCommonTzAbbreviation: 'SYOT' withDSTPreferredTo: #'Antarctica/Syowa' withDSTNotPreferredTo: #'Antarctica/Syowa';
		bindCommonTzAbbreviation: 'VET' withDSTPreferredTo: #'America/Caracas' withDSTNotPreferredTo: #'America/Caracas';
		bindCommonTzAbbreviation: 'PMDT' withDSTPreferredTo: #'America/Miquelon' withDSTNotPreferredTo: #'America/Miquelon';
		bindCommonTzAbbreviation: 'KRAST' withDSTPreferredTo: #'Asia/Krasnoyarsk' withDSTNotPreferredTo: #'Asia/Krasnoyarsk';
		bindCommonTzAbbreviation: 'SRT' withDSTPreferredTo: #'America/Paramaribo' withDSTNotPreferredTo: #'America/Paramaribo';
		bindCommonTzAbbreviation: 'AZST' withDSTPreferredTo: #'Asia/Baku' withDSTNotPreferredTo: #'Asia/Baku';
		bindCommonTzAbbreviation: 'PYST' withDSTPreferredTo: #'America/Asuncion' withDSTNotPreferredTo: #'America/Asuncion';
		bindCommonTzAbbreviation: 'WFT' withDSTPreferredTo: #'Pacific/Wallis' withDSTNotPreferredTo: #'Pacific/Wallis';
		bindCommonTzAbbreviation: 'GMT-14' withDSTPreferredTo: #'Etc/GMT-14' withDSTNotPreferredTo: #'Etc/GMT-14';
		bindCommonTzAbbreviation: 'MAGT' withDSTPreferredTo: #'Asia/Magadan' withDSTNotPreferredTo: #'Asia/Magadan';
		bindCommonTzAbbreviation: 'CCT' withDSTPreferredTo: #'Indian/Cocos' withDSTNotPreferredTo: #'Indian/Cocos';
		bindCommonTzAbbreviation: 'YAPT' withDSTPreferredTo: #'Pacific/Yap' withDSTNotPreferredTo: #'Pacific/Yap';
		bindCommonTzAbbreviation: 'EGST' withDSTPreferredTo: #'America/Scoresbysund' withDSTNotPreferredTo: #'America/Scoresbysund';
		bindCommonTzAbbreviation: 'IRKST' withDSTPreferredTo: #'Asia/Irkutsk' withDSTNotPreferredTo: #'Asia/Irkutsk';
		bindCommonTzAbbreviation: 'NRT' withDSTPreferredTo: #'Pacific/Nauru' withDSTNotPreferredTo: #'Pacific/Nauru';
		bindCommonTzAbbreviation: 'GMT-2' withDSTPreferredTo: #'Etc/GMT-2' withDSTNotPreferredTo: #'Etc/GMT-2';
		bindCommonTzAbbreviation: 'DDUT' withDSTPreferredTo: #'Antarctica/DumontDUrville' withDSTNotPreferredTo: #'Antarctica/DumontDUrville';
		bindCommonTzAbbreviation: 'VLAST' withDSTPreferredTo: #'Asia/Vladivostok' withDSTNotPreferredTo: #'Asia/Vladivostok';
		bindCommonTzAbbreviation: 'GMT+6' withDSTPreferredTo: #'Etc/GMT+6' withDSTNotPreferredTo: #'Etc/GMT+6';
		bindCommonTzAbbreviation: 'AZOST' withDSTPreferredTo: #'Atlantic/Azores' withDSTNotPreferredTo: #'Atlantic/Azores';
		bindCommonTzAbbreviation: 'YEKST' withDSTPreferredTo: #'Asia/Yekaterinburg' withDSTNotPreferredTo: #'Asia/Yekaterinburg';
		bindCommonTzAbbreviation: 'BNT' withDSTPreferredTo: #'Asia/Brunei' withDSTNotPreferredTo: #'Asia/Brunei';
		bindCommonTzAbbreviation: 'NUT' withDSTPreferredTo: #'Pacific/Niue' withDSTNotPreferredTo: #'Pacific/Niue';
		bindCommonTzAbbreviation: 'AFT' withDSTPreferredTo: #'Asia/Kabul' withDSTNotPreferredTo: #'Asia/Kabul';
		bindCommonTzAbbreviation: 'PONT' withDSTPreferredTo: #'Pacific/Ponape' withDSTNotPreferredTo: #'Pacific/Ponape';
		bindCommonTzAbbreviation: 'OMSST' withDSTPreferredTo: #'Asia/Omsk' withDSTNotPreferredTo: #'Asia/Omsk';
		bindCommonTzAbbreviation: 'PKT' withDSTPreferredTo: #'Asia/Karachi' withDSTNotPreferredTo: #'Asia/Karachi';
		bindCommonTzAbbreviation: 'TAHT' withDSTPreferredTo: #'Pacific/Tahiti' withDSTNotPreferredTo: #'Pacific/Tahiti';
		bindCommonTzAbbreviation: 'SAMST' withDSTPreferredTo: #'Europe/Samara' withDSTNotPreferredTo: #'Europe/Samara';
		bindCommonTzAbbreviation: 'TPT' withDSTPreferredTo: #'Asia/Dili' withDSTNotPreferredTo: #'Asia/Dili';
		bindCommonTzAbbreviation: 'IOT' withDSTPreferredTo: #'Indian/Chagos' withDSTNotPreferredTo: #'Indian/Chagos';
		bindCommonTzAbbreviation: 'SCT' withDSTPreferredTo: #'Indian/Mahe' withDSTNotPreferredTo: #'Indian/Mahe';
		bindCommonTzAbbreviation: 'TVT' withDSTPreferredTo: #'Pacific/Funafuti' withDSTNotPreferredTo: #'Pacific/Funafuti';
		bindCommonTzAbbreviation: 'NOVST' withDSTPreferredTo: #'Asia/Novosibirsk' withDSTNotPreferredTo: #'Asia/Novosibirsk';
		bindCommonTzAbbreviation: 'NCT' withDSTPreferredTo: #'Pacific/Noumea' withDSTNotPreferredTo: #'Pacific/Noumea';
		bindCommonTzAbbreviation: 'GEST' withDSTPreferredTo: #'Asia/Tbilisi' withDSTNotPreferredTo: #'Asia/Tbilisi';
		bindCommonTzAbbreviation: 'GMT-1' withDSTPreferredTo: #'Etc/GMT-1' withDSTNotPreferredTo: #'Etc/GMT-1';
		bindCommonTzAbbreviation: 'AZOT' withDSTPreferredTo: #'Atlantic/Azores' withDSTNotPreferredTo: #'Atlantic/Azores';
		bindCommonTzAbbreviation: 'GMT-9' withDSTPreferredTo: #'Etc/GMT-9' withDSTNotPreferredTo: #'Etc/GMT-9'! !

!TimeZoneLocalizationPolicy class methodsFor: 'class initialization' stamp: ''!
initialize
	"TimeZoneLocalizationPolicy initialize."

	self basicInitializeAll.
	Default := nil.
	Root := nil.
	Unique := nil.
	CountryNames := Dictionary new! !

!TimeZoneLocalizationPolicy class methodsFor: 'country names' stamp: ''!
keysAndDefaultCountryNamesDo: block2
	CountryNames keysAndValuesDo: block2! !

!TimeZoneLocalizationPolicy class methodsFor: 'private' stamp: ''!
newRoot

	| policy |
	policy := self new.
	policy
		setKey: #Root;

		bindStandardTimeOffsetFromUT: -11 * SecondsPerHour withDSTPreferredTo: #'Pacific/Apia' withDSTNotPreferredTo: #'Pacific/Apia';
		bindStandardTimeOffsetFromUT: -10 * SecondsPerHour withDSTPreferredTo: #'America/Atka' withDSTNotPreferredTo: #'Pacific/Tahiti';
		bindStandardTimeOffsetFromUT: ((-9 * SecondsPerHour) + (-30 * SecondsPerMinute)) withDSTPreferredTo: #'Pacific/Marquesas' withDSTNotPreferredTo: #'Pacific/Marquesas';
		bindStandardTimeOffsetFromUT: -9 * SecondsPerHour withDSTPreferredTo: #'America/Yakutat' withDSTNotPreferredTo: #'Pacific/Gambier';
		bindStandardTimeOffsetFromUT: -8 * SecondsPerHour withDSTPreferredTo: #'America/Vancouver' withDSTNotPreferredTo: #'Pacific/Pitcairn';
		bindStandardTimeOffsetFromUT: -7 * SecondsPerHour withDSTPreferredTo: #'America/Edmonton' withDSTNotPreferredTo: #'America/Dawson_Creek';
		bindStandardTimeOffsetFromUT: -6 * SecondsPerHour withDSTPreferredTo: #'America/Mexico_City' withDSTNotPreferredTo: #'America/Regina';
		bindStandardTimeOffsetFromUT: -5 * SecondsPerHour withDSTPreferredTo: #'America/Toronto' withDSTNotPreferredTo: #'America/Bogota';
		bindStandardTimeOffsetFromUT: -4 * SecondsPerHour withDSTPreferredTo: #'America/Santiago' withDSTNotPreferredTo: #'America/Caracas';
		bindStandardTimeOffsetFromUT: -3 * SecondsPerHour withDSTPreferredTo: #'America/Sao_Paulo' withDSTNotPreferredTo: #'America/Argentina/Buenos_Aires';
		bindStandardTimeOffsetFromUT: -2 * SecondsPerHour withDSTPreferredTo: #'America/Noronha' withDSTNotPreferredTo: #'America/Noronha';
		bindStandardTimeOffsetFromUT: -1 * SecondsPerHour withDSTPreferredTo: #'Atlantic/Cape_Verde' withDSTNotPreferredTo: #'Atlantic/Cape_Verde';
		bindStandardTimeOffsetFromUT: 0 * SecondsPerHour withDSTPreferredTo: #'Europe/London' withDSTNotPreferredTo: #Universal;
		bindStandardTimeOffsetFromUT: 1 * SecondsPerHour withDSTPreferredTo: #'Europe/Berlin' withDSTNotPreferredTo: #'Africa/Lagos';
		bindStandardTimeOffsetFromUT: 2 * SecondsPerHour withDSTPreferredTo: #'Europe/Istanbul' withDSTNotPreferredTo: #'Africa/Johannesburg';
		bindStandardTimeOffsetFromUT: 3 * SecondsPerHour withDSTPreferredTo: #'Europe/Moscow' withDSTNotPreferredTo: #'Africa/Addis_Ababa';
		bindStandardTimeOffsetFromUT: 4 * SecondsPerHour withDSTPreferredTo: #'Asia/Baku' withDSTNotPreferredTo: #'Asia/Dubai';
		bindStandardTimeOffsetFromUT: ((4 * SecondsPerHour) + (30 * SecondsPerMinute)) withDSTPreferredTo: #'Asia/Kabul' withDSTNotPreferredTo: #'Asia/Kabul';
		bindStandardTimeOffsetFromUT: 5 * SecondsPerHour withDSTPreferredTo: #'Asia/Bishkek' withDSTNotPreferredTo: #'Asia/Karachi';
		bindStandardTimeOffsetFromUT: ((5 * SecondsPerHour) + (30 * SecondsPerMinute)) withDSTPreferredTo: #'Asia/Calcutta' withDSTNotPreferredTo: #'Asia/Calcutta';
		bindStandardTimeOffsetFromUT: ((5 * SecondsPerHour) + (45 * SecondsPerMinute)) withDSTPreferredTo: #'Asia/Katmandu' withDSTNotPreferredTo: #'Asia/Katmandu';
		bindStandardTimeOffsetFromUT: 6 * SecondsPerHour withDSTPreferredTo: #'Asia/Novosibirsk' withDSTNotPreferredTo: #'Asia/Colombo';
		bindStandardTimeOffsetFromUT: ((6 * SecondsPerHour) + (30 * SecondsPerMinute)) withDSTPreferredTo: #'Asia/Rangoon' withDSTNotPreferredTo: #'Asia/Rangoon';
		bindStandardTimeOffsetFromUT: 7 * SecondsPerHour withDSTPreferredTo: #'Asia/Hovd' withDSTNotPreferredTo: #'Asia/Bangkok';
		bindStandardTimeOffsetFromUT: 8 * SecondsPerHour withDSTPreferredTo: #'Asia/Irkutsk' withDSTNotPreferredTo: #'Asia/Hong_Kong';
		bindStandardTimeOffsetFromUT: 9 * SecondsPerHour withDSTPreferredTo: #'Asia/Yakutsk' withDSTNotPreferredTo: #'Asia/Tokyo';
		bindStandardTimeOffsetFromUT: ((9 * SecondsPerHour) + (30 * SecondsPerMinute)) withDSTPreferredTo: #'Australia/Adelaide' withDSTNotPreferredTo: #'Australia/Darwin';
		bindStandardTimeOffsetFromUT: 10 * SecondsPerHour withDSTPreferredTo: #'Australia/Sydney' withDSTNotPreferredTo: #'Australia/Queensland';
		bindStandardTimeOffsetFromUT: ((10 * SecondsPerHour) + (30 * SecondsPerMinute)) withDSTPreferredTo: #'Australia/Lord_Howe' withDSTNotPreferredTo: #'Australia/Lord_Howe';
		bindStandardTimeOffsetFromUT: 11 * SecondsPerHour withDSTPreferredTo: #'Pacific/Guadalcanal' withDSTNotPreferredTo: #'Pacific/Guadalcanal';
		bindStandardTimeOffsetFromUT: 12 * SecondsPerHour withDSTPreferredTo: #'Pacific/Auckland' withDSTNotPreferredTo: #'Pacific/Fiji';
		bindStandardTimeOffsetFromUT: ((12 * SecondsPerHour) + (30 * SecondsPerMinute)) withDSTPreferredTo: #'Pacific/Chatham' withDSTNotPreferredTo: #'Pacific/Chatham';
		bindStandardTimeOffsetFromUT: 13 * SecondsPerHour withDSTPreferredTo: #'Pacific/Tongatapu' withDSTNotPreferredTo: #'Pacific/Tongatapu';
		bindStandardTimeOffsetFromUT: 14 * SecondsPerHour withDSTPreferredTo: #'Pacific/Kiritimati' withDSTNotPreferredTo: #'Pacific/Kiritimati';

		bindCommonTzAbbreviation: #SST withDSTPreferredTo: #'Pacific/Apia' withDSTNotPreferredTo: #'Pacific/Apia';
		bindCommonTzAbbreviation: #HAST withDSTPreferredTo: #'America/Atka' withDSTNotPreferredTo: #'Pacific/Honolulu';
		bindCommonTzAbbreviation: #HADT withDSTPreferredTo: #'America/Atka' withDSTNotPreferredTo: #'America/Atka';
		bindCommonTzAbbreviation: #MART withDSTPreferredTo: #'Pacific/Marquesas' withDSTNotPreferredTo: #'Pacific/Marquesas';
		bindCommonTzAbbreviation: #AKST withDSTPreferredTo: #'America/Yakutat' withDSTNotPreferredTo: #'America/Anchorage';
		bindCommonTzAbbreviation: #AKDT withDSTPreferredTo: #'America/Yakutat' withDSTNotPreferredTo: #'America/Yakutat';
		bindCommonTzAbbreviation: #PST withDSTPreferredTo: #'America/Vancouver' withDSTNotPreferredTo: #'Pacific/Pitcairn';
		bindCommonTzAbbreviation: #PDT withDSTPreferredTo: #'America/Vancouver' withDSTNotPreferredTo: #'America/Vancouver';
		bindCommonTzAbbreviation: #MST withDSTPreferredTo: #'America/Edmonton' withDSTNotPreferredTo: #'America/Dawson_Creek';
		bindCommonTzAbbreviation: #MDT withDSTPreferredTo: #'America/Edmonton' withDSTNotPreferredTo: #'America/Edmonton';
		bindCommonTzAbbreviation: #CST withDSTPreferredTo: #'America/Mexico_City' withDSTNotPreferredTo: #'America/Regina';
		bindCommonTzAbbreviation: #CDT withDSTPreferredTo: #'America/Mexico_City' withDSTNotPreferredTo: #'America/Mexico_City';
		bindCommonTzAbbreviation: #EST withDSTPreferredTo: #'America/Toronto' withDSTNotPreferredTo: #'America/Indiana/Indianapolis';
		bindCommonTzAbbreviation: #EDT withDSTPreferredTo: #'America/Toronto' withDSTNotPreferredTo: #'America/Toronto';
		bindCommonTzAbbreviation: #VET withDSTPreferredTo: #'America/Caracas' withDSTNotPreferredTo: #'America/Caracas';
		bindCommonTzAbbreviation: #CLT withDSTPreferredTo: #'America/Santiago' withDSTNotPreferredTo: #'America/Santiago';
		bindCommonTzAbbreviation: #CLST withDSTPreferredTo: #'America/Santiago' withDSTNotPreferredTo: #'America/Santiago';
		bindCommonTzAbbreviation: #ART withDSTPreferredTo: #'America/Argentina/Buenos_Aires' withDSTNotPreferredTo: #'America/Argentina/Buenos_Aires';
		bindCommonTzAbbreviation: #BRT withDSTPreferredTo: #'America/Sao_Paulo' withDSTNotPreferredTo: #'America/Sao_Paulo';
		bindCommonTzAbbreviation: #FNT withDSTPreferredTo: #'America/Noronha' withDSTNotPreferredTo: #'America/Noronha';
		bindCommonTzAbbreviation: #GMT withDSTPreferredTo: #'Europe/London' withDSTNotPreferredTo: #Universal;
		bindCommonTzAbbreviation: #WAT withDSTPreferredTo: #'Africa/Lagos' withDSTNotPreferredTo: #'Africa/Lagos';
		bindCommonTzAbbreviation: #CET withDSTPreferredTo: #'Europe/Berlin' withDSTNotPreferredTo: #'Europe/Berlin';
		bindCommonTzAbbreviation: #CEST withDSTPreferredTo: #'Europe/Berlin' withDSTNotPreferredTo: #'Europe/Berlin';
		bindCommonTzAbbreviation: #SAST withDSTPreferredTo: #'Africa/Johannesburg' withDSTNotPreferredTo: #'Africa/Johannesburg';
		bindCommonTzAbbreviation: #EET withDSTPreferredTo: #'Europe/Istanbul' withDSTNotPreferredTo: #'Europe/Istanbul';
		bindCommonTzAbbreviation: #EEST withDSTPreferredTo: #'Europe/Istanbul' withDSTNotPreferredTo: #'Europe/Istanbul';
		bindCommonTzAbbreviation: #EAT withDSTPreferredTo: #'Africa/Addis_Ababa' withDSTNotPreferredTo: #'Africa/Addis_Ababa';
		bindCommonTzAbbreviation: #GST withDSTPreferredTo: #'Asia/Dubai' withDSTNotPreferredTo: #'Asia/Dubai';
		bindCommonTzAbbreviation: #AZT withDSTPreferredTo: #'Asia/Baku' withDSTNotPreferredTo: #'Asia/Baku';
		bindCommonTzAbbreviation: #AZST withDSTPreferredTo: #'Asia/Baku' withDSTNotPreferredTo: #'Asia/Baku';
		bindCommonTzAbbreviation: #AFT withDSTPreferredTo: #'Asia/Kabul' withDSTNotPreferredTo: #'Asia/Kabul';
		bindCommonTzAbbreviation: #PKT withDSTPreferredTo: #'Asia/Karachi' withDSTNotPreferredTo: #'Asia/Karachi';
		bindCommonTzAbbreviation: #KGT withDSTPreferredTo: #'Asia/Bishkek' withDSTNotPreferredTo: #'Asia/Bishkek';
		bindCommonTzAbbreviation: #KGST withDSTPreferredTo: #'Asia/Bishkek' withDSTNotPreferredTo: #'Asia/Bishkek';
		bindCommonTzAbbreviation: #IST withDSTPreferredTo: #'Asia/Calcutta' withDSTNotPreferredTo: #'Asia/Calcutta';
		bindCommonTzAbbreviation: #NPT withDSTPreferredTo: #'Asia/Katmandu' withDSTNotPreferredTo: #'Asia/Katmandu';
		bindCommonTzAbbreviation: #NOVT withDSTPreferredTo: #'Asia/Novosibirsk' withDSTNotPreferredTo: #'Asia/Novosibirsk';
		bindCommonTzAbbreviation: #NOVST withDSTPreferredTo: #'Asia/Novosibirsk' withDSTNotPreferredTo: #'Asia/Novosibirsk';
		bindCommonTzAbbreviation: #LKT withDSTPreferredTo: #'Asia/Colombo' withDSTNotPreferredTo: #'Asia/Colombo';
		bindCommonTzAbbreviation: #ICT withDSTPreferredTo: #'Asia/Bangkok' withDSTNotPreferredTo: #'Asia/Bangkok';
		bindCommonTzAbbreviation: #HKT withDSTPreferredTo: #'Asia/Hong_Kong' withDSTNotPreferredTo: #'Asia/Hong_Kong';
		bindCommonTzAbbreviation: #NZST withDSTPreferredTo: #'Pacific/Auckland' withDSTNotPreferredTo: #'Pacific/Auckland';
		bindCommonTzAbbreviation: #NZDT withDSTPreferredTo: #'Pacific/Auckland' withDSTNotPreferredTo: #'Pacific/Auckland'.

	self defineAllUniqueAbbreviationsIn: policy.
	^policy! !

!TimeZoneLocalizationPolicy class methodsFor: 'private' stamp: ''!
newUnique

	| policy |
	policy := self new.
	policy setKey: #Unique.
	self defineAllUniqueAbbreviationsIn: policy.
	^policy! !

!TimeZoneLocalizationPolicy class methodsFor: 'country names' stamp: ''!
parseCountryCodeToNameMappingsFrom: stream 
	"{ChronosSystemFacade current resourceRepositoryContext invalidateCountryCodeToCountryNameMappings}"

	CountryNames := Dictionary new.
	[ChronosFunction skipSeparators: stream.
	stream atEnd] whileFalse: 
		[| code countryName |
		(stream atEnd or: [stream peek = $#]) 
			ifTrue: [ChronosFunction skipToNextLineOf: stream]
			ifFalse: 
				[code := ChronosFunction nextFrom: stream until: [:ch | ch isSeparator].
				ChronosFunction skipSeparators: stream.
				countryName := ChronosFunction nextLineFrom: stream.
				CountryNames at: code asSymbol put: countryName]].! !

!TimeZoneLocalizationPolicy class methodsFor: 'private' stamp: ''!
resourceBroker
	^ChronosSystemFacade resourceRepositoryContext tzLocalizationPolicyResourceBroker! !

!TimeZoneLocalizationPolicy class methodsFor: 'accessing' stamp: ''!
root
	"TimeZoneLocalizationPolicy root"

	Root == nil 
		ifTrue: 
			[Root := self newRoot.
			Root forceRegistration].
	^Root! !

!TimeZoneLocalizationPolicy class methodsFor: 'accessing' stamp: ''!
unique
	"TimeZoneLocalizationPolicy unique"

	Unique == nil 
		ifTrue: 
			[Unique := self newUnique.
			Unique forceRegistration].
	^Unique! !

!TimeZoneLocalizationPolicy class methodsFor: 'accessing' stamp: ''!
unitedStates
	"TimeZoneLocalizationPolicy unitedStates"

	^self at: #US! !

!TimeZoneLocalizationPolicy methodsFor: 'queries' stamp: ''!
abbreviationToTimeZoneKeyMap: dstPreferred
	| map |
	map := Dictionary new.
	dstPreferred
		ifTrue: [defaultTimeZoneKeysByCommonAbbreviation keysAndValuesDo: [:key :array | map at: key put: array first]]
		ifFalse: [defaultTimeZoneKeysByCommonAbbreviation keysAndValuesDo: [:key :array | map at: key put: array last]].
	^map! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
addZoneWithKey: tzKey abbreviation: abbreviation offsetSecondsFromUT: offsetSecondsFromUT stdTimeOffsetSecondsFromUT: stdTimeOffsetSecondsFromUT 
	| offsetArray abbreviationMap offsetArraySet |
	self assertMutability.
	offsetArray := Array with: offsetSecondsFromUT with: stdTimeOffsetSecondsFromUT.
	abbreviationMap := zoneMap at: tzKey ifAbsentPut: [Dictionary new].
	offsetArraySet := (abbreviationMap at: abbreviation ifAbsent: [Set new]) asSet.
	offsetArraySet add: offsetArray.
	abbreviationMap at: abbreviation put: offsetArraySet asArray! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
beDefault
	self == ChronosLocale default timeZoneLocalizationPolicy
		ifTrue: [Default := nil]
		ifFalse: [Default := self]! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
bindCommonTzAbbreviation: commonTzAbbreviation withDSTPreferredTo: dstObservingTimeZoneKeyIfAvailable withDSTNotPreferredTo: dstNonObservingTimeZoneKeyIfAvailable 
	self assertMutability.
	defaultTimeZoneKeysByCommonAbbreviation at: commonTzAbbreviation asSymbol
		put: (Array with: dstObservingTimeZoneKeyIfAvailable asSymbol
				with: dstNonObservingTimeZoneKeyIfAvailable asSymbol)! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
bindStandardTimeOffsetFromUT: offsetSecondsFromUT withDSTPreferredTo: dstObservingTimeZoneKeyIfAvailable withDSTNotPreferredTo: dstNonObservingTimeZoneKeyIfAvailable 
	self assertMutability.
	defaultTimeZoneKeysByStandardTimeOffsetFromUT 
		at: offsetSecondsFromUT asInteger
		put: (Array with: dstObservingTimeZoneKeyIfAvailable asSymbol
				with: dstNonObservingTimeZoneKeyIfAvailable asSymbol)! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
computeDefaultMappings
	| offsetMap stdTimeAbbreviationMap dstAbbreviationMap |
	(ChronosFunction isNilOrEmpty: zoneMap) ifTrue: [^nil].
	offsetMap := Dictionary new.
	stdTimeAbbreviationMap := IdentityDictionary new.
	dstAbbreviationMap := IdentityDictionary new.
	zoneMap 
		keysAndValuesDo: 
			[:tzKey :abbreviationMap | 
			abbreviationMap keysAndValuesDo: 
				[:commonAbbreviation :offsetArrayArray | 
				| offsetSeconds stdTimeOffsetSeconds |
				offsetArrayArray do: 
					[:offsetArray | 
					offsetSeconds := offsetArray at: 1.
					stdTimeOffsetSeconds := offsetArray at: 2.
					(offsetMap at: stdTimeOffsetSeconds ifAbsentPut: [Set new]) add: tzKey.
					(stdTimeOffsetSeconds = offsetSeconds 
						ifTrue: [stdTimeAbbreviationMap]
						ifFalse: [dstAbbreviationMap]) at: tzKey
							put: commonAbbreviation]]].
	self initializeDefaultMappings.
	offsetMap keysAndValuesDo: [:stdTimeOffsetSeconds :zoneKeys | 
		| zoneKeyStream dstPreferred dstNotPreferred selectionMask |
		zoneKeyStream := zoneKeys asArray readStream.
		selectionMask := 3.
		[zoneKeyStream atEnd or: [selectionMask = 0]] 
			whileFalse: 
				[| zoneKey stdTimeAbbreviation dstAbbreviation |
				zoneKey := zoneKeyStream next.
				stdTimeAbbreviation := stdTimeAbbreviationMap at: zoneKey ifAbsent: [].
				dstAbbreviation := dstAbbreviationMap at: zoneKey ifAbsent: [].
				dstAbbreviation == nil
					ifTrue: 
						[dstNotPreferred := Array with: zoneKey with: stdTimeAbbreviation.
						selectionMask := selectionMask bitXor: 2]
					ifFalse: 
						[stdTimeAbbreviation == nil
							ifTrue: [dstNotPreferred :=  Array with: zoneKey with: dstAbbreviation]
							ifFalse: 
								[dstPreferred := Array with: zoneKey with: stdTimeAbbreviation with: dstAbbreviation.
								selectionMask := selectionMask bitXor: 1]]].
		dstNotPreferred == nil ifTrue: [dstNotPreferred :=  dstPreferred].
		dstPreferred == nil ifTrue: [dstPreferred := dstNotPreferred].
		self 
			bindStandardTimeOffsetFromUT: stdTimeOffsetSeconds
			withDSTPreferredTo: dstPreferred first
			withDSTNotPreferredTo: dstNotPreferred first.
		self 
			bindCommonTzAbbreviation: (dstPreferred at: 2)
			withDSTPreferredTo: dstPreferred first
			withDSTNotPreferredTo: dstNotPreferred first.
		dstPreferred size > 2
			ifTrue: 
				[self 
					bindCommonTzAbbreviation: (dstPreferred at: 3)
					withDSTPreferredTo: dstPreferred first
					withDSTNotPreferredTo: dstPreferred first]]! !

!TimeZoneLocalizationPolicy methodsFor: 'accessing' stamp: ''!
defaultCountryName
	"TimeZoneLocalizationPolicy unitedStates defaultCountryName"
	"(TimeZoneLocalizationPolicy at: #RU) defaultCountryName"
	"(TimeZoneLocalizationPolicy at: #FR) defaultCountryName"

	^self class defaultCountryNameAt: self key ifAbsent: [self key]! !

!TimeZoneLocalizationPolicy methodsFor: 'queries' stamp: ''!
defaultTimeZoneKeyForStandardTimeOffsetSecondsFromUT: offsetSecondsFromUT dstPreferred: dstPreferred ifAbsent: ifAbsent 
	| array default |
	array := defaultTimeZoneKeysByStandardTimeOffsetFromUT 
				at: offsetSecondsFromUT
				ifAbsent: 
					[^self isRoot 
						ifTrue: [ifAbsent value]
						ifFalse: 
							[default := self class default.
							(self == default ifTrue: [self class root ] ifFalse: [default])
								defaultTimeZoneKeyForStandardTimeOffsetSecondsFromUT: offsetSecondsFromUT
								dstPreferred: dstPreferred
								ifAbsent: ifAbsent]].
	^dstPreferred ifTrue: [array at: 1] ifFalse: [array at: 2]! !

!TimeZoneLocalizationPolicy methodsFor: 'queries' stamp: ''!
defaultTimeZoneKeyWithCommonAbbreviation: commonTzAbbreviation dstPreferred: dstPreferred ifAbsent: ifAbsent 
	| array default |
	array := defaultTimeZoneKeysByCommonAbbreviation 
				at: commonTzAbbreviation asSymbol
				ifAbsent: 
					[^self isRoot 
						ifTrue: [ifAbsent value]
						ifFalse: 
							[default := self class default.
							(self registrationKey == default registrationKey ifTrue: [self class root ] ifFalse: [default])
								defaultTimeZoneKeyWithCommonAbbreviation: commonTzAbbreviation
								dstPreferred: dstPreferred
								ifAbsent: ifAbsent]].
	^dstPreferred ifTrue: [array at: 1] ifFalse: [array at: 2]! !

!TimeZoneLocalizationPolicy methodsFor: 'testing' stamp: ''!
definesDefaultMappings
	^((ChronosFunction isNilOrEmpty: defaultTimeZoneKeysByCommonAbbreviation) 
		or: [ChronosFunction isNilOrEmpty: defaultTimeZoneKeysByStandardTimeOffsetFromUT]) not! !

!TimeZoneLocalizationPolicy methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: defaultTimeZoneKeysByStandardTimeOffsetFromUT);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: defaultTimeZoneKeysByCommonAbbreviation).
	zoneMap keysAndValuesDo: 
			[:tzKey :abbreviationMap | 
			stream nextPut: 
				(Array 
					with: tzKey
					with: (ChronosFunction encodeDictionaryAsLiteralArray: abbreviationMap))]! !

!TimeZoneLocalizationPolicy methodsFor: 'printing' stamp: ''!
encodeDefaultMappingsOn: stream
	defaultTimeZoneKeysByStandardTimeOffsetFromUT keysAndValuesDo: 
		[:offsetSeconds :array |
			stream 
				cr; tab;
				print: offsetSeconds;
				space;
				nextPutAll: array first;
				space;
				nextPutAll: array last].
	defaultTimeZoneKeysByCommonAbbreviation keysAndValuesDo: 
		[:abbreviation :array |
			stream 
				cr; tab;
				nextPutAll: abbreviation;
				space;
				nextPutAll: array first;
				space;
				nextPutAll: array last].
	stream nextPut: $!!.! !

!TimeZoneLocalizationPolicy methodsFor: 'printing' stamp: ''!
encodeOn: stream
	| position |
	stream cr.
	position := stream position.
	stream
		nextPutAll: registrationKey;
		nextPut: $:.
	self encodeDefaultMappingsOn: stream.
	self encodeZoneMapOn: stream.
	^position! !

!TimeZoneLocalizationPolicy methodsFor: 'printing' stamp: ''!
encodeZoneMapOn: stream
	stream cr.
	(ChronosFunction isNilOrEmpty: zoneMap) ifTrue: [^nil].
	zoneMap 
		keysAndValuesDo: 
			[:tzKey :abbreviationMap | 
			stream cr; nextPutAll: tzKey; nextPut: $:.
			abbreviationMap keysAndValuesDo: 
				[:commonAbbreviation :offsetArrayArray | 
				stream cr; tab: 1; nextPut: $@; nextPutAll: commonAbbreviation.
				offsetArrayArray do: [:offsetArray | stream tab; nextPut: $|; print: offsetArray first; space; print: offsetArray last]]].
	stream nextPut: $!!.! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	self initializeZoneMap.
	self initializeDefaultMappings.! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
initializeDefaultMappings

	self assertMutability.
	defaultTimeZoneKeysByCommonAbbreviation := IdentityDictionary new.
	defaultTimeZoneKeysByStandardTimeOffsetFromUT := Dictionary new.! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	| array |
	super initializeFromLiteralArray: literalArray.
	defaultTimeZoneKeysByStandardTimeOffsetFromUT := ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 3).
	defaultTimeZoneKeysByCommonAbbreviation := ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 4).
	zoneMap := IdentityDictionary new.
	5 to: literalArray size
		do: 
			[:index | 
			array := literalArray at: index.
			zoneMap at: (array at: 1) asSymbol
				put: (ChronosFunction decodeDictionaryFromLiteralArray: (array at: 2))]! !

!TimeZoneLocalizationPolicy methodsFor: 'initialize-release' stamp: ''!
initializeZoneMap

	self assertMutability.
	zoneMap := IdentityDictionary new.! !

!TimeZoneLocalizationPolicy methodsFor: 'testing' stamp: ''!
isRoot
	^self == Root! !

!TimeZoneLocalizationPolicy methodsFor: 'private' stamp: ''!
postCopy
	"PRECONDTION: The receiver has just been instantiated as a #shallowCopy of another object.  
	POSTCONDITION: In response to this message, the receiver is required to make itself satisfy the following conditions and constraints: 1) It must be mutable,  2) It must compare (#=) as equal to the object from which it was shallowCopied, and 3) It must satisfy the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the object from which it was shallowCopied must not be changed, and b) whenever the object from which the receiver was shallowCopied mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the receiver must not be changed.  An associative reference is one where the semantics of the reference depend in any way on the object identity (#==) of the referenced object.  An attributive reference is one where any referenced object with the same value can transparently be substituted for any other such value-equivalent object without causing any error."

	"Subclasses may need to subimplement this message in order to satisfy the required semantics.  All subimplementers should send #postCopy to super."

	super postCopy.
	defaultTimeZoneKeysByCommonAbbreviation := defaultTimeZoneKeysByCommonAbbreviation copy.
	defaultTimeZoneKeysByStandardTimeOffsetFromUT := defaultTimeZoneKeysByStandardTimeOffsetFromUT copy.! !

!TimeZoneLocalizationPolicy methodsFor: 'queries' stamp: ''!
standardTimeOffsetSecondsToTimeZoneKeyMap: dstPreferred
	| map |
	map := Dictionary new.
	dstPreferred
		ifTrue: [defaultTimeZoneKeysByStandardTimeOffsetFromUT keysAndValuesDo: [:key :array | map at: key put: array first]]
		ifFalse: [defaultTimeZoneKeysByStandardTimeOffsetFromUT keysAndValuesDo: [:key :array | map at: key put: array last]].
	^map! !

!TimeZoneLocalizationPolicy methodsFor: 'queries' stamp: ''!
zoneBindingsAt: olsonKey ifAbsent: ifAbsent 
	"TimeZoneLocalizationPolicy unitedStates zoneBindingsAt: #'America/Los_Angeles' ifAbsent: []"

	| map bindings |
	map := zoneMap at: olsonKey ifAbsent: [^ifAbsent value].
	bindings := (Array new: 2) writeStream.
	map keysAndValuesDo: 
			[:abbreviation :value | 
				value do: 
					[:offsetArray | 
					bindings nextPut: 
						(ChronosTimezone 
							newBindingForKey: olsonKey
							offsetSecondsFromUT: offsetArray first
							stdTimeOffsetSecondsFromUT: offsetArray last
							commonAbbreviation: abbreviation)]].
	^bindings contents! !

!TimeZoneLocalizationPolicy methodsFor: 'queries' stamp: ''!
zoneKeys
	^zoneMap keys! !

!TimeZoneLocalizationPolicy methodsFor: 'enumerating' stamp: ''!
zonesDo: block1 
	"{| zones |
	zones := SortedCollection sortBlock: [:a :b | a offsetFromUT < b offsetFromUT].
	(TimeZoneLocalizationPolicy at: #RU) zonesDo: [:zone | zones add: zone].
	zones do: [:zone | Transcript cr; show: zone printString]}"

	"{| zones |
	zones := SortedCollection sortBlock: [:a :b | a offsetFromUT < b offsetFromUT].
	(TimeZoneLocalizationPolicy at: #CA) zonesDo: [:zone | zones add: zone].
	zones do: [:zone | Transcript cr; show: zone printString]}"

	"{| zones |
	zones := SortedCollection sortBlock: [:a :b | a offsetFromUT < b offsetFromUT].
	(TimeZoneLocalizationPolicy at: #AU) zonesDo: [:zone | zones add: zone].
	zones do: [:zone | Transcript cr; show: zone printString]}"

	"{| zones |
	zones := SortedCollection sortBlock: [:a :b | a offsetFromUT < b offsetFromUT].
	(TimeZoneLocalizationPolicy at: #US) zonesDo: [:zone | zones add: zone].
	zones do: [:zone | Transcript cr; show: zone printString]}"

	(ChronosFunction isNilOrEmpty: zoneMap) ifTrue: [^nil].
	zoneMap keysAndValuesDo: 
			[:tzKey :abbreviationMap | 
			abbreviationMap keysAndValuesDo: 
					[:abbreviation :offsetArrayArray | 
					offsetArrayArray do: 
							[:offsetArray | 
							block1 value: 
								(ChronosTimezone 
									newBindingForKey: tzKey
									offsetSecondsFromUT: offsetArray first
									stdTimeOffsetSecondsFromUT: offsetArray last
									commonAbbreviation: abbreviation)]]]! !

ExternalResource subclass: #TimeZonePolicyFactory
	instanceVariableNames: 'defaultName geographicCoordinates annualTransitionPolicies'
	classVariableNames: 'OlsonToWindowsTZNameMap WindowsToOlsonTZKeyMap'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-PolicyFactories-Diachronic'!

!TimeZonePolicyFactory commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

TimeZonePolicyFactory

	Concept:

		A TimeZonePolicyFactory serves as a factory for creating a TimeZonePolicy instance.  Although it represents the same information as a TimeZonePolicy--the full diachronic ruleset of a time zone--its purpose and behavior are different. A TimeZonePolicy's behavior is targeted at resolving the offset/abbreviation tuple (in the form of a "bound, dynamic" time zone instance) that applies within the territorial domain of a time zone at a particular point-in-time.  A TimeZonePolicyFactory's behavior is targeted at correctly instantiating a TimeZonePolicy using the minimum possible amount of memory, and also at providing an API for the construction and editing of a time zone's full diachronic ruleset that is considerably easier to understand and use than is the case for a TimeZonePolicy.

		When Chronos time zones are retrieved from the Chronos time zone repository, they are deserialized as TimeZonePolicySequenceFactories, which are then used to construct the equivalent TimeZonePolicy.  Unlike TimeZonePolicies, TimeZonePolicySequenceFactories were designed to make serialization/deserialization easy and efficient.

	Implementation:

		Instance Variables

			annualTransitionPolicies	<Array of TimeZoneAnnualTransitionPolicyFactory>  
				Each TimeZoneAnnualTransitionPolicyFactory in the <annualTransitionPolicies> array represents the ruleset of a time zone that is in effect for some number of years (each one specifies its effective year.)  The ordering does not matter, since canonicalization of the order happens as a free side effect of constructing a TimeZonePolicy rule chain--although it is of course easier to understand if the array is kept in sorted order (which the Chronos Time Zone Compiler does for precisely this reason.)
!

!TimeZonePolicyFactory class methodsFor: 'validation' stamp: ''!
assertValidityOfTimezoneKey: aTimeZoneKey
	"Assert that <aTimeZoneKey> is the key of a time zone persistently stored in the Chronos time-zones repository (to which this execution environment is attached.) If it is, do nothing. If it is not, raise an Exception."

	(self timezoneKeyIsGloballyDefined: aTimeZoneKey) ifFalse: [self signalInvalidTimezoneKey: aTimeZoneKey]! !

!TimeZonePolicyFactory class methodsFor: 'private' stamp: ''!
computeOlsonToWindowsTZNameMap
	"TimeZonePolicyFactory computeOlsonToWindowsTZNameMap"

	| sortedListMap map ammendedMappings |
	ammendedMappings := Dictionary new.
	ammendedMappings
		at: 'GMT' put: 'London Time';
		at: 'Romance' put: 'Paris Time';
		at: 'GTB' put: 'Greek Time'.
	sortedListMap := Dictionary new.
	WindowsToOlsonTZKeyMap keysAndValuesDo: 
			[:windowsName :olsonKey | 
			(sortedListMap at: olsonKey asSymbol
				ifAbsentPut: [SortedCollection sortBlock: [:a :b | a size < b size]]) 
					add: windowsName].
	map := Dictionary new.
	sortedListMap keysAndValuesDo: 
			[:olsonKey :windowsNamesSortedBySize | 
			| index shortestGoodWindowsName |
			shortestGoodWindowsName := 
				ammendedMappings 
					at: windowsNamesSortedBySize first
					ifAbsent: 
						[index := 1.
						[shortestGoodWindowsName := windowsNamesSortedBySize at: index.
						index := index + 1.
						index > windowsNamesSortedBySize size 
							or: [shortestGoodWindowsName size > 3]] 
								whileFalse.
						('*Time*' match: shortestGoodWindowsName) 
							ifTrue: [shortestGoodWindowsName]
							ifFalse: [shortestGoodWindowsName , ' Time']].
			map at: olsonKey put: shortestGoodWindowsName].
	^map! !

!TimeZonePolicyFactory class methodsFor: 'repository management' stamp: ''!
createTZRepositoryFrom: aCollectionOfTimeZonePolicyFactories 
	self basicInitialize.
	aCollectionOfTimeZonePolicyFactories do: [:factory | factory forceRegistration].
	ChronosTimezone invalidate! !

!TimeZonePolicyFactory class methodsFor: 'instance creation' stamp: ''!
decodeFrom: stream 
	"{TimeZonePolicyFactory 
		decodeFrom: 
			'Pacific/Auckland:
				1990 true Until-Annual-Date-Transition:NZDT:46800:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|3|15|1|0) Until-Annual-Date-Transition:NZST:43200:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|10|1|1|0) Until-End-Of-Year:NZDT:46800:43200
				1989 true Until-Annual-Date-Transition:NZDT:46800:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|3|1|1|0) Until-Day-Of-Year-Transition:NZST:43200:43200:standard:7200:281 Until-End-Of-Year:NZDT:46800:43200
				1976 true Until-Annual-Date-Transition:NZDT:46800:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|3|1|1|0) Until-Annual-Date-Transition:NZST:43200:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|10|-6|1|0) Until-End-Of-Year:NZDT:46800:43200
				1975 true Until-Day-Of-Year-Transition:NZDT:46800:43200:standard:7200:54 Until-Annual-Date-Transition:NZST:43200:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|10|-6|1|0) Until-End-Of-Year:NZDT:46800:43200
				1974 true Until-Day-Of-Year-Transition:NZST:43200:43200:standard:7200:307 Until-End-Of-Year:NZDT:46800:43200
				1947 true Until-End-Of-Year:NZST:43200:43200
				1946 false Until-Day-Of-Year-Transition:NZST:45000:43200:nominal:0:1 Until-End-Of-Year:NZST:43200:43200
				1941 true Until-End-Of-Year:NZST:43200:41400
				1934 true Until-Annual-Date-Transition:NZST:43200:41400:nominal:7200:(WeekOfMonthDayOfWeek|Gregorian|4|-6|1|0) Until-Annual-Date-Transition:NZMT:41400:41400:nominal:7200:(WeekOfMonthDayOfWeek|Gregorian|9|-6|1|0) Until-End-Of-Year:NZST:43200:41400
				1929 true Until-Annual-Date-Transition:NZST:43200:41400:nominal:7200:(WeekOfMonthDayOfWeek|Gregorian|3|15|1|0) Until-Annual-Date-Transition:NZMT:41400:41400:nominal:7200:(WeekOfMonthDayOfWeek|Gregorian|10|8|1|0) Until-End-Of-Year:NZST:43200:41400
				1928 true Until-Day-Of-Year-Transition:NZST:45000:41400:nominal:7200:64 Until-Annual-Date-Transition:NZMT:41400:41400:nominal:7200:(WeekOfMonthDayOfWeek|Gregorian|10|8|1|0) Until-End-Of-Year:NZST:43200:41400
				1927 true Until-Day-Of-Year-Transition:NZT:41400:41400:nominal:7200:310 Until-End-Of-Year:NZST:45000:41400
				1869 true Until-End-Of-Year:NZT:41400:41400
				1868 true Until-Day-Of-Year-Transition:LMT:41944:41944:nominal:0:307 Until-End-Of-Year:NZT:41400:41400
				nil true Until-End-Of-Year:LMT:41944:41944!!

geographicCoordinates: -365200+1744600
defaultName: New Zealand Time!!' readStream}"

	| zoneKey elementStream timeZonePolicyElements attributes key value defaultName geographicCoordinates |
	zoneKey := self registrationKeyFrom: stream.
	ChronosFunction skipSeparators: stream.
	timeZonePolicyElements := OrderedCollection new.
	elementStream := (stream upTo: $!!) readStream.
	[elementStream atEnd]
		whileFalse: 
			[timeZonePolicyElements add: (TimeZoneAnnualTransitionPolicyFactory decodeFrom: elementStream key: zoneKey).
			ChronosFunction skipSeparators: elementStream].
	ChronosFunction skipSeparators: stream.
	stream atEnd
		ifTrue: [defaultName := geographicCoordinates := nil]
		ifFalse: 
			[elementStream := (stream upTo: $!!) readStream.
			attributes := IdentityDictionary new.
			[elementStream atEnd]
				whileFalse: 
					[key := (elementStream upTo: $:) asSymbol.
					ChronosFunction skipSeparators: elementStream.
					value := ChronosFunction nextLineFrom: elementStream.
					attributes at: key put: value.
					ChronosFunction skipSeparators: elementStream].
			defaultName := attributes at: #defaultName ifAbsent: [].
			geographicCoordinates := attributes at: #geographicCoordinates ifAbsent: [].
			geographicCoordinates == nil ifFalse: [geographicCoordinates := GeographicCoordinateSpec readFromString: geographicCoordinates]].
	^self 
		key: zoneKey 
		defaultName: defaultName 
		geographicCoordinates: geographicCoordinates
		annualTransitionPolicyArray: timeZonePolicyElements asArray! !

!TimeZonePolicyFactory class methodsFor: 'accessing' stamp: ''!
default
	^self at: #Universal! !

!TimeZonePolicyFactory class methodsFor: 'class initialization' stamp: ''!
initialize
	self basicInitializeAll.
	WindowsToOlsonTZKeyMap := Dictionary new.
	OlsonToWindowsTZNameMap := nil.! !

!TimeZonePolicyFactory class methodsFor: 'instance creation' stamp: ''!
key: registrationKey defaultName: aString geographicCoordinates: aGeographicCoordinatesSpec annualTransitionPolicyArray: anArrayOfAnnualTransitionPolicies
	^self new
		setKey: registrationKey;
		setDefaultName: aString;
		setGeographicCoordinates: aGeographicCoordinatesSpec;
		setAnnualTransitionPolicies: anArrayOfAnnualTransitionPolicies;
		beImmutable! !

!TimeZonePolicyFactory class methodsFor: 'accessing' stamp: ''!
keysByAbbreviation
	"Answer a Dictionary that maps time zone abbreviations to Sets of the all the time zone keys of time zones that currently use that abbreviation (according to the information in the current Chronos Time Zone Repository.)"

	"TimeZonePolicyFactory keysByAbbreviation"

	| map set |
	map := IdentityDictionary new.
	self allRegisteredKeys do: 
			[:tzKey | 
			| annualPolicyFactory |
			annualPolicyFactory := (TimeZonePolicyFactory at: tzKey asSymbol ifAbsent: []) defaultAnnualTransitionPolicy.
			annualPolicyFactory annuallyRecurringTransitionsDo: 
				[:index :annuallyPolicyElement | 
					set := map at: annuallyPolicyElement commonAbbreviation ifAbsentPut: [Set new].
					set add: tzKey]].
	^map! !

!TimeZonePolicyFactory class methodsFor: 'instance creation' stamp: ''!
newKey: registrationKey defaultName: aString geographicCoordinates: aGeographicCoordinatesSpec annualTransitionPolicyArray: anArrayOfAnnualTransitionPolicies
	^self new
		setKey: registrationKey;
		setDefaultName: aString;
		setGeographicCoordinates: aGeographicCoordinatesSpec;
		setAnnualTransitionPolicies: anArrayOfAnnualTransitionPolicies;
		markNonSymmetricEffectiveYearTransitions;
		beImmutable! !

!TimeZonePolicyFactory class methodsFor: 'private' stamp: ''!
olsonToWindowsTZNameMap
	OlsonToWindowsTZNameMap == nil ifTrue: [OlsonToWindowsTZNameMap := self computeOlsonToWindowsTZNameMap].
	^OlsonToWindowsTZNameMap! !

!TimeZonePolicyFactory class methodsFor: 'foreign keys' stamp: ''!
parseWindowsToOlsonTZKeyMappingsFrom: stream 
	"{ChronosSystemFacade current resourceRepositoryContext invalidateWindowsToOlsonTZKeyMappings}"

	WindowsToOlsonTZKeyMap := Dictionary new.
	OlsonToWindowsTZNameMap  := nil.	
	[ChronosFunction skipSeparators: stream.
	stream atEnd] whileFalse: 
		[| line keys |
		line := ChronosFunction nextLineFrom: stream.
		keys := ChronosFunction componentsFromString: line separator: $|.
		WindowsToOlsonTZKeyMap at: keys first put: keys last asSymbol].! !

!TimeZonePolicyFactory class methodsFor: 'repository management' stamp: ''!
persistAliases
	"TimeZonePolicyFactory persistAliases"

	ChronosSystemFacade resourceRepositoryContext persistTimeZoneAliases! !

!TimeZonePolicyFactory class methodsFor: 'private' stamp: ''!
resourceBroker
	^ChronosSystemFacade resourceRepositoryContext timeZoneResourceBroker! !

!TimeZonePolicyFactory class methodsFor: 'validation' stamp: ''!
signalInvalidTimezoneKey: aTimeZoneKey
	self signalError: 'Unrecognized Timezone identifier: ', aTimeZoneKey printString! !

!TimeZonePolicyFactory class methodsFor: 'foreign keys' stamp: ''!
timeZoneKeyFromWindowsTZName: windowsTZName ifAbsent: block0
	^WindowsToOlsonTZKeyMap at: windowsTZName ifAbsent: block0! !

!TimeZonePolicyFactory class methodsFor: 'validation' stamp: ''!
timezoneKeyIsGloballyDefined: aTimeZoneKey
	^self registry includesKey: aTimeZoneKey! !

!TimeZonePolicyFactory class methodsFor: 'foreign keys' stamp: ''!
windowsTimeZoneNameFromTZKey: olsonKey ifAbsent: block0
	"TimeZonePolicyFactory windowsTimeZoneNameFromTZKey: #'America/Chicago' ifAbsent: []"

	^self olsonToWindowsTZNameMap at: olsonKey asSymbol ifAbsent: block0! !

!TimeZonePolicyFactory methodsFor: 'accessing' stamp: ''!
annualTransitionPolicies	
	^annualTransitionPolicies! !

!TimeZonePolicyFactory methodsFor: 'accessing' stamp: ''!
annualTransitionPoliciesCount
	^annualTransitionPolicies size! !

!TimeZonePolicyFactory methodsFor: 'enumerating' stamp: ''!
annualTransitionPoliciesDo: block2
	| index | 
	index := 0.
	annualTransitionPolicies do: [:each | block2 value: (index := index + 1) value: each]! !

!TimeZonePolicyFactory methodsFor: 'queries' stamp: ''!
annualTransitionPolicyEffectiveInYear: year ifNone: ifNone
	annualTransitionPolicies do: [:annualTransitionPolicy | (annualTransitionPolicy effectiveYearIsLessThanOrEqualTo: year) ifTrue: [^annualTransitionPolicy]].
	^ifNone value! !

!TimeZonePolicyFactory methodsFor: 'converting' stamp: ''!
asPolicyFor: anUnboundDynamicTimeZone 
	| timeZonePolicy |
	timeZonePolicy := nil.
	annualTransitionPolicies do: 
			[:annualTransitionPolicy | 
			| tzPolicy |
			tzPolicy := annualTransitionPolicy asPolicyFor: anUnboundDynamicTimeZone.
			tzPolicy 
				setRegistrationKey: self registrationKey;
				setDefaultName: self defaultName;
				setGeographicCoordinates: self geographicCoordinates.
			timeZonePolicy == nil 
				ifTrue: [timeZonePolicy := tzPolicy]
				ifFalse: [timeZonePolicy := timeZonePolicy asListSortedInCanonicalOrderByTransitionTimeAdding: tzPolicy]].
	ChronosTimezone invalidateBoundDynamicFlyweights.
	^timeZonePolicy beImmutable! !

!TimeZonePolicyFactory methodsFor: 'queries' stamp: ''!
defaultAnnualTransitionPolicy
	annualTransitionPolicies do: [:annualTransitionPolicy | annualTransitionPolicy hasEverBeenInEffect ifTrue: [^annualTransitionPolicy]].
	^annualTransitionPolicies last! !

!TimeZonePolicyFactory methodsFor: 'accessing' stamp: ''!
defaultName
	^defaultName! !

!TimeZonePolicyFactory methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: defaultName;
		nextPut: geographicCoordinates literalArrayEncoding;
		nextPut: annualTransitionPolicies literalArrayEncoding! !

!TimeZonePolicyFactory methodsFor: 'printing' stamp: ''!
encodeOn: stream 
	| position bangSwitch |
	stream cr.
	position := stream position.
	stream
		nextPutAll: registrationKey;
		nextPut: $:.
	annualTransitionPolicies do: 
			[:each | 
			stream cr; tab.
			each encodeOn: stream].
	stream nextPut: $!!; cr.
	bangSwitch := false.
	geographicCoordinates == nil
		ifFalse: 
			[stream cr; nextPutAll: 'geographicCoordinates: '; print: geographicCoordinates.
			bangSwitch := true].
	defaultName == nil
		ifFalse: [stream cr; nextPutAll: 'defaultName: '; nextPutAll: defaultName.
			bangSwitch := true].
	bangSwitch ifTrue: [stream nextPut: $!!].
	^position! !

!TimeZonePolicyFactory methodsFor: 'enumerating' stamp: ''!
everyAnnualTransitionPolicyEverInEffectSinceYear: year do: block1 
	| prev |
	prev := nil.
	annualTransitionPolicies reverseDo: 
			[:annualTransitionPolicy | 
			(annualTransitionPolicy effectiveYearIsGreaterThanOrEqualTo: year) 
				ifTrue: 
					[(prev == nil or: [year = annualTransitionPolicy effectiveYear]) 
						ifFalse: [block1 value: prev].
					block1 value: annualTransitionPolicy.
					prev := nil]
				ifFalse: [prev := annualTransitionPolicy]].
	prev == nil 
		ifFalse: 
			[block1 value: prev]! !

!TimeZonePolicyFactory methodsFor: 'accessing' stamp: ''!
geographicCoordinates
	^geographicCoordinates! !

!TimeZonePolicyFactory methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	annualTransitionPolicies := Array new! !

!TimeZonePolicyFactory methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray .
	self 
		setDefaultName: (literalArray at: 3);
		setGeographicCoordinates: (literalArray at: 4) decodeAsLiteralArray;
		setAnnualTransitionPolicies: 
			((literalArray at: 5) collect: [:annualTransitionPolicyArrayLiteral | annualTransitionPolicyArrayLiteral decodeAsLiteralArray])! !

!TimeZonePolicyFactory methodsFor: 'initialize-release' stamp: ''!
markNonSymmetricEffectiveYearTransitions
	| policy0 policy1 |
	self assertMutability.
	policy1 := nil.
	1 to: annualTransitionPolicies size
		do: 
			[:index | 
			policy0 := annualTransitionPolicies at: index.
			policy1 == nil 
				ifFalse: [policy1 setSymmetryBasedOnTransitionFrom: policy0].
			policy1 := policy0]! !

!TimeZonePolicyFactory methodsFor: 'printing' stamp: ''!
printOn: stream
	stream
		nextPut: ${;
		nextPutAll: self class name.
	registrationKey == nil 
		ifFalse: 
			[stream
				cr; tab;
				nextPutAll: 'key=';
				print: registrationKey].
	self specifiesDefaultName
		ifTrue: 
			[stream
				nextPutAll: ' | ';
				nextPutAll: ' defaultName='; nextPutAll: self defaultName].
	self specifiesGeographicCoordinates 
		ifTrue: [stream cr; tab; nextPutAll: 'geographicCoordinates='; print: self geographicCoordinates].
	stream
		nextPutAll: '} annualTransitionPolicies=';
		print: annualTransitionPolicies;
		nextPut: $}! !

!TimeZonePolicyFactory methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processTimezonePolicyFactory: self.! !

!TimeZonePolicyFactory methodsFor: 'accessing' stamp: ''!
semanticKey	
	"Answer a value that identifies the conceptual type of the receiver."

	^#TimeZoneRuleSet! !

!TimeZonePolicyFactory methodsFor: 'initialize-release' stamp: ''!
setAnnualTransitionPolicies: anArrayOfAnnualTransitionPolicies
	self assertMutability.
	annualTransitionPolicies := anArrayOfAnnualTransitionPolicies! !

!TimeZonePolicyFactory methodsFor: 'initialize-release' stamp: ''!
setDefaultName: aString
	self assertMutability.
	defaultName := aString! !

!TimeZonePolicyFactory methodsFor: 'initialize-release' stamp: ''!
setGeographicCoordinates: aGeographicCoordinatesSpect
	self assertMutability.
	geographicCoordinates := aGeographicCoordinatesSpect! !

!TimeZonePolicyFactory methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation
	^annualTransitionPolicies contains: [:each | each specifiesCommonAbbreviation]! !

!TimeZonePolicyFactory methodsFor: 'testing' stamp: ''!
specifiesDefaultName
	^defaultName ~~ nil! !

!TimeZonePolicyFactory methodsFor: 'testing' stamp: ''!
specifiesGeographicCoordinates
	^geographicCoordinates ~~ nil! !

PassportMagnitude subclass: #AnnuallyRecurringTZPolicyFactory
	instanceVariableNames: 'offsetSecondsFromUT stdTimeOffsetSecondsFromUT commonAbbreviation'
	classVariableNames: 'ClassByTypeKeyRegistry'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-PolicyFactories-Annual'!

!AnnuallyRecurringTZPolicyFactory commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

AnnuallyRecurringTZPolicyFactory

	Concept:

		AnnuallyRecurringTZPolicyFactory is an abstract class. An instance of a concrete subclass of AnnuallyRecurringTZPolicyFactory specifies the offset and abbreviation that apply within the territorial domain of a time zone during some annually-recurring portion of a calendar year. 

		However, the purpose of an AnnuallyRecurringTZPolicyFactory is not to actually itself provide time-zone behavior, but rather to serve as a factory for creating an AnnuallyRecurringTZPolicy instance.  Although it represents essentially the same information as an AnnuallyRecurringTZPolicy, its purpose and behavior are different. An AnnuallyRecurringTZPolicy's behavior is targeted at resolving the offset/abbreviation tuple (in the form of a "bound, dynamic" time zone instance) that applies within the territorial domain of a time zone at a particular point-in-time.  An AnnuallyRecurringTZPolicyFactory's behavior is targeted at correctly instantiating an AnnuallyRecurringTZPolicy using the minimum possible amount of memory, and also at providing an API for the construction and editing of a time zone's ruleset that is considerably easier to understand and use than is the case for an AnnuallyRecurringTZPolicy.

		A list of AnnuallyRecurringTZPolicyFactoriess is used by instances of TimeZonePolicyElementFactory to specify the offset and abbreviation that apply within the territorial domain of a time zone during soem sequence of calendar years--in other words, to specify the intra-year time zone rules, including the offset/abbreviation transitions that annually recur each year (if any.)

	Implementation:

		Instance Variables

			offsetSecondsFromUT				<Integer> 	The number of seconds offset from Universal Time that defines "local time" (within the territorial domain of the time zone whose ruleset is (partially) specified by the instance) during any periods of time that the time zone rule specified by the instance is in effect.
			stdTimeOffsetSecondsFromUT	<Integer>	The number of seconds offset from Universal Time that defines "local time" (within the territorial domain of the time zone whose ruleset is (partially) specified by the instance) during any periods of time that "standard time" is in effect (e.g., whenever DST is not being observed.)
			commonAbbreviation 				<Symbol>	The commonly-used abbreviation for the timezone whose ruleset is (partially) specified by the instance during any periods of time that the time zone rule specified by the instance is in effect.

	Subclassing:

		Concrete subclasses must subimplement the instance methods:

	 		#asPolicyFor:
			#typeKey
			
!

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Chronos'! !

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 

	^self isConcrete 
		ifTrue: 
			[(self new)
				initializeFromLiteralArray: literalArray;
				beImmutable]
		ifFalse: [super decodeFromLiteralArray: literalArray]! !

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'private' stamp: ''!
classByTypeKeyRegistry
	"AnnuallyRecurringTZPolicyFactory classByTypeKeyRegistry" 

	ClassByTypeKeyRegistry == nil 
		ifTrue: [self initializeClassByTypeKeyRegistry].
	^ClassByTypeKeyRegistry! !

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'instance creation' stamp: ''!
decodeFrom: stream
	"{AnnuallyRecurringTZPolicyFactory 
		decodeFrom: 
			'Until-Annual-Date-Transition:NZDT:46800:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|3|15|1|0)' readStream}"

	^self decodeFromLiteralArray: (ChronosFunction componentsFromStream: stream separator: $:)! !

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'class initialization' stamp: ''!
initialize
	"AnnuallyRecurringTZPolicyFactory initialize."

	ClassByTypeKeyRegistry := nil! !

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'private' stamp: ''!
initializeClassByTypeKeyRegistry
	| map |
	map := IdentityDictionary new.
	map 
		at: #'Until-End-Of-Year'										put: (Pathname components: #(UntilEndOfYearTimeZoneTransitionFactory));
		at: #'Until-Annual-Date-Transition'							put: (Pathname components: #(UntilAnnualDateTimeZoneTransitionFactory));
		at: #'Until-Day-Of-Year-Transition'							put: (Pathname components: #(UntilAnnualDayOfYearTimeZoneTransitionFactory));
		at: #TimeZoneInvariantOffsetPolicyAtomSpec				put: (Pathname components: #(UntilEndOfYearTimeZoneTransitionFactory));
		at: #TimeZoneAnnualTransitionOffsetPolicyAtomSpec	put: (Pathname components: #(UntilAnnualDateTimeZoneTransitionFactory));
		at: #TimeZoneSingleTransitionOffsetPolicyAtomSpec		put: (Pathname components: #(UntilAnnualDayOfYearTimeZoneTransitionFactory)).

	ClassByTypeKeyRegistry := map

	"#'Until-End-Of-Year' 										-> UntilEndOfYearAnnualTZPolicyFactory
	#'Until-Annual-Date-Transition' 							-> UntilAnnualDateTZPolicyFactory
	#'Until-Day-Of-Year-Transition' 							-> UntilAnnualDayOfYearTZPolicyFactory
	#TimeZoneInvariantOffsetPolicyAtomSpec				-> UntilEndOfYearAnnualTZPolicyFactory
	#'TimeZoneAnnualTransitionOffsetPolicyAtomSpec	-> UntilAnnualDateTZPolicyFactory
	#TimeZoneSingleTransitionOffsetPolicyAtomSpec		-> UntilAnnualDayOfYearTZPolicyFactory"! !

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'testing' stamp: ''!
isConcrete
	^false! !

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'instance creation' stamp: ''!
referencedBy: aTimeZoneOffsetPolicyAtomSpecOrTimeZoneOffsetPolicyAtomSpecLiteralString
	"Anser the value referenced by <aChronosObjectOrChronosObjectLiteralString>. If the value is a key, answer the value bound to the key. If the value is a literal representation of a value encoded as a String, answer the result of decoding the value encoded by the String.  Otherwise, answer aChronosObjectOrChronosObjectLiteralString itself."

	"{TimeZoneOffsetPolicyAtomSpec 
		referencedBy: 
			'TimeZoneAnnualTransitionOffsetPolicyAtomSpec:NZDT:46800:43200:standard:7200:/WeekOfMonthDayOfWeek/Gregorian/March/15/1/0'}"

	^aTimeZoneOffsetPolicyAtomSpecOrTimeZoneOffsetPolicyAtomSpecLiteralString isString 
			ifTrue: 
				[self decodeFromLiteralArray: 
					(ChronosFunction 
						componentsFromString: aTimeZoneOffsetPolicyAtomSpecOrTimeZoneOffsetPolicyAtomSpecLiteralString
						separator: $:)]
			ifFalse: [aTimeZoneOffsetPolicyAtomSpecOrTimeZoneOffsetPolicyAtomSpecLiteralString].! !

!AnnuallyRecurringTZPolicyFactory class methodsFor: 'private' stamp: ''!
resolveClassFromLiteralArray: literalArray 
	| typeKey |
	typeKey := literalArray first asSymbol.
	^(self classByTypeKeyRegistry at: typeKey
		ifAbsent: [^super resolveClassFromLiteralArray: literalArray]) valueIn: (EnvironmentFacade current namespaceOfClass: self)! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'converting' stamp: ''!
asPolicyFor: anInterYearTimeZonePolicy 
	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
commonAbbreviation
	^commonAbbreviation! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'comparing' stamp: ''!
compareTo: anAnnualTZPolicyElement
	"Compare the value of the receiver to that of <aTimeZoneOffsetPolicyAtomSpec>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <aTimeZoneOffsetPolicyAtomSpec> are the same.)"

	self == anAnnualTZPolicyElement ifTrue: [^0].
	^[anAnnualTZPolicyElement compareToAnnualTZPolicyElement: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == anAnnualTZPolicyElement and: [ex message selector == #compareToAnnualTZPolicyElement:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'private-comparing' stamp: ''!
compareToAnnualTZPolicyElement: otherAnnualTZPolicyElement

	| diff |
	self == otherAnnualTZPolicyElement ifTrue: [^0].
	diff := otherAnnualTZPolicyElement offsetSecondsFromUT - offsetSecondsFromUT.
	diff = 0 ifFalse: [^diff].
	otherAnnualTZPolicyElement commonAbbreviation > commonAbbreviation ifTrue: [^1].
	^otherAnnualTZPolicyElement commonAbbreviation < commonAbbreviation
		ifTrue: [-1] ifFalse: [0]! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	stream 
		nextPut: self globalNameOfClass;
		nextPut: self commonAbbreviation;
		nextPut: self stdTimeOffsetSecondsFromUT;
		nextPut: self offsetSecondsFromUT! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'printing' stamp: ''!
encodeOn: stream
	stream
		nextPutAll: self typeKey;
		nextPut: $:;
		nextPutAll: commonAbbreviation;
		nextPut: $:;
		print: offsetSecondsFromUT;
		nextPut: $:;
		print: stdTimeOffsetSecondsFromUT.! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'testing' stamp: ''!
hasName
	^false! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'comparing' stamp: ''!
hash
	^(offsetSecondsFromUT + commonAbbreviation hash) hash! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	offsetSecondsFromUT := 0.
	stdTimeOffsetSecondsFromUT := 0.
	commonAbbreviation := #Unspecified! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self 
		setOffsetSeconds: (literalArray at: 3) asNumber
		stdTimeOffsetSeconds: (literalArray at: 4) asNumber
		commonAbbreviation: (literalArray at: 2)! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'testing' stamp: ''!
isStandardTime
	^offsetSecondsFromUT = stdTimeOffsetSecondsFromUT! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
name
	^commonAbbreviation! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
offsetDeltaSeconds
	"Answer the number of seconds to be added to the receiver's standard-time offset from UT in order to compute the receiver's offset from UT when Daylight Saving Time (Summer Time) is in effect."

	^self offsetSecondsFromUT - self stdTimeOffsetSecondsFromUT! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
offsetFromUT
	^DurationFactory seconds: self offsetSecondsFromUT! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
offsetSecondsFromUT
	^offsetSecondsFromUT! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'printing' stamp: ''!
printOn: stream
	stream
		cr; tab; tab; nextPut: ${;
		nextPutAll: self typeKey;
		nextPut: $};
		cr; tab; tab; tab; nextPutAll: 'commonAbbreviation=';
		nextPutAll: commonAbbreviation;
		nextPutAll: ' offsetSecondsFromUT=';
		print: offsetSecondsFromUT;
		nextPutAll: ' stdTimeOffsetSecondsFromUT=';
		print: stdTimeOffsetSecondsFromUT! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
semanticKey	
	"Answer a value that identifies the conceptual type of the receiver."

	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'initialize-release' stamp: ''!
setOffsetSeconds: secondsFromUTC stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol
	self assertMutability.
	offsetSecondsFromUT := secondsFromUTC.
	stdTimeOffsetSecondsFromUT := stdTimeSecondsFromUTC.
	commonAbbreviation := aSymbol asSymbol! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation
	^commonAbbreviation ~~ nil! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'testing' stamp: ''!
specifiesIntraYearTransition
	^false! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'testing' stamp: ''!
specifiesSingleTransition
	^false! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
stdTimeOffsetFromUT
	^DurationFactory seconds: self stdTimeOffsetSecondsFromUT! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
stdTimeOffsetSecondsFromUT
	^stdTimeOffsetSecondsFromUT! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'queries' stamp: ''!
transitionDateAndTimeInYear: year
	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnFirstDayOfYear: year
	^false! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnLastDayOfYear: year
	^false! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'accessing' stamp: ''!
typeKey
	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicyFactory methodsFor: 'converting' stamp: ''!
withTransitionDayOfYear: dayOfYearOrdinal transitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol 
	^UntilAnnualDayOfYearTimeZoneTransitionFactory
		offsetSeconds: offsetSecondsFromUT
		stdTimeOffsetSeconds: stdTimeOffsetSecondsFromUT
		commonAbbreviation: commonAbbreviation
		transitionDayOfYear: dayOfYearOrdinal
		transitionSecondsSinceStartOfDay: transitionSeconds
		relativity: aRelativitySymbol! !

AnnuallyRecurringTZPolicyFactory subclass: #IntraYearTimeZoneTransitionFactory
	instanceVariableNames: 'relativity transitionSecondsSinceStartOfDay'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-PolicyFactories-Annual'!

!IntraYearTimeZoneTransitionFactory commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

IntraYearTimeZoneTransitionFactory

	Concept:

		An IntraYearTimeZoneTransitionFactory is an abstract subclass of AnnuallyRecurringTZPolicyFactory.  An instance of a concrete subclass of IntraYearTimeZoneTransitionFactory functions as any but the last/final ruleform in the sequence of ruleforms that specifies the offset/abbreviation tuples that apply within the territorial domain of a time zone during every moment of a calendar year. The ruleform represented by an IntraYearTimeZoneTransitionFactory instance expires at some annually-recurring intra-year date and time (any of local time, local "standard time," or Universal Time may be used  to designate the moment of expiry of the predecessor ruleform and transition to the successor ruleform.) 

		However, the purpose of an IntraYearTimeZoneTransitionFactory is not to actually itself provide time-zone behavior, but rather to serve as a factory for creating an IntraYearTimeZoneTransition instance.  Although it represents essentially the same information as an IntraYearTimeZoneTransition, its purpose and behavior are different. 

		See the superclass AnnuallyRecurringTZPolicyFactory for more information.

	Motivation:

		Chronos represents offset/abbreviation transitions using annually-recurring dates, instead of following in the path of UNIX and using an exhaustive list of every transition specified as occurring at some absolute number of seconds since an epoch, for two independent reasons:

			1. To minimize memory usage--enough said.
			2. To make the representation of the moments of transition be independent of any particular timesale--in other words, to make them neutral with respect to leap seconds--a property which the source Olson time zone rules have, but the zic-generated binary time zone files do not..

	Implementation:

		Instance Variables  {Also see superclass}

			relativity								<Symbol>	If relativity == #nominal, then the instance's moment of expiry/transition-to-successor is designated in local ("wall clock") time; if relativity == #standard,  then the instance's moment of expiry/transition-to-successor is designated in local "standard time" (without DST;) if relativity == #universal, then the instance's moment of expiry/transition-to-successor is designated in Universal Time.
			transitionSecondsSinceStartOfDay 	<Integer>	The time of day, expressed as a number of seconds since the start of the day (0..86399,) when the ruleform represented by the instance expires and the transition to its successor (the <nextLink>) takes place. Specification/representation of the annually-recurring intra-year date on which the instance's ruleform expires is the responsibility of concrete subclasses.
!

!IntraYearTimeZoneTransitionFactory methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self relativity; 
		nextPut: self transitionSecondsSinceStartOfDay! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'printing' stamp: ''!
encodeOn: stream
	super encodeOn: stream.
	stream
		nextPut: $:;
		nextPutAll: relativity;
		nextPut: $:;
		print: transitionSecondsSinceStartOfDay.! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	relativity := #nominal.
	transitionSecondsSinceStartOfDay := 0! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self 
		setTransitionSecondsSinceStartOfDay: (literalArray at: 6) asNumber
		relativity: (literalArray at: 5)! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'testing' stamp: ''!
isSpecifiedAsLocalTime
	^relativity == #nominal! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'testing' stamp: ''!
isSpecifiedAsStandardTime
	^relativity == #standard! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'testing' stamp: ''!
isSpecifiedAsUT
	^relativity == #universal! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
maxDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^self subclassResponsibility! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
minDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^self subclassResponsibility! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'printing' stamp: ''!
printTimeOfDayOn: stream
	stream
		nextPutAll: ' transitionSecondsSinceStartOfDay=';
		print: transitionSecondsSinceStartOfDay;
		nextPutAll: ' relativity=';
		print: relativity! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
relativity
	^relativity! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'initialize-release' stamp: ''!
setTransitionSecondsSinceStartOfDay: seconds relativity: aRelativitySymbol
	self assertMutability.
	transitionSecondsSinceStartOfDay := seconds.
	relativity := aRelativitySymbol asSymbol.! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'testing' stamp: ''!
specifiesIntraYearTransition
	^true! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionDayOfWeekInYear: year
	^self subclassResponsibility! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursAfter: aDateAndTimeSpec
	^self subclassResponsibility! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnOrAfter: aDateAndTimeSpec
	^self subclassResponsibility! !

!IntraYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
transitionSecondsSinceStartOfDay
	^transitionSecondsSinceStartOfDay! !

IntraYearTimeZoneTransitionFactory subclass: #UntilAnnualDateTimeZoneTransitionFactory
	instanceVariableNames: 'annualDate'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-PolicyFactories-Annual'!

!UntilAnnualDateTimeZoneTransitionFactory commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UntilAnnualDateTimeZoneTransitionFactory

	Concept:

		An UntilAnnualDateTimeZoneTransitionFactory is an IntraYearTimeZoneTransitionFactory that specifies its annually-recurring intra-year date of expiry and transition to a successor AnnuallyRecurringTZPolicyFactory using an instance of AnnualDate.

		See the superclass IntraYearTimeZoneTransitionFactory for more information.

	Implementation:

		Instance Variables  {Also see superclass}

			annualDate	<AnnualDate> The annually-recurring intra-year date when the ruleform represented by the instance expires and the transition to its successor takes place. Specification/representation of the time-of-day of expiry/transition is implemented by the superclass.
!

!UntilAnnualDateTimeZoneTransitionFactory class methodsFor: 'testing' stamp: ''!
isConcrete
	^true! !

!UntilAnnualDateTimeZoneTransitionFactory class methodsFor: 'instance creation' stamp: ''!
offsetSeconds: secondsFromUTC stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol annualDate: anAnnualDate transitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol
	^self new
		setOffsetSeconds: secondsFromUTC stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol;
		setTransitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol;
		setAnnualDate: anAnnualDate;
		beImmutable! !

!UntilAnnualDateTimeZoneTransitionFactory class methodsFor: 'instance creation' stamp: ''!
offsetSeconds: secondsFromUTC stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol annualDateKey: annualDateRegistrationKey transitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol
	^self new
		setOffsetSeconds: secondsFromUTC  stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol;
		setTransitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol;
		setAnnualDateKey: annualDateRegistrationKey;
		beImmutable! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
annualDate
	^annualDate! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
annualDateKey
	^annualDate selfDescribingKey! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'converting' stamp: ''!
asPolicyFor: anInterYearTimeZonePolicy 
	^UntilAnnualDateTimeZoneTransition 
		for: anInterYearTimeZonePolicy
		offsetSeconds: offsetSecondsFromUT
		stdTimeOffsetSeconds: stdTimeOffsetSecondsFromUT
		commonAbbreviation: self commonAbbreviation
		annualDate: self annualDate
		transitionSecondsSinceStartOfDay: transitionSecondsSinceStartOfDay
		relativity: relativity! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream nextPut: self annualDateKey! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'printing' stamp: ''!
encodeOn: stream
	super encodeOn: stream.
	stream 
		nextPut: $:;
		nextPutAll: self annualDateKey.! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self setAnnualDateKey: (literalArray at: 7)! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
maxDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^(annualDate maxDayOfYearOrdinalForYearOfType: yearTypeCode) - 1! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
minDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^(annualDate minDayOfYearOrdinalForYearOfType: yearTypeCode) - 1! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	stream
		nextPutAll: ' annualDate=';
		print: annualDate.
	self printTimeOfDayOn: stream.! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	^aTimezoneProcessor processUntilAnnualDateTimeZoneTransition: self! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
semanticKey	
	"Answer a value that identifies the conceptual type of the receiver."

	^#UntilAnnualDateTimeZoneTransition! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'initialize-release' stamp: ''!
setAnnualDate: anAnnualDate
	self assertMutability.
	annualDate := anAnnualDate! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'initialize-release' stamp: ''!
setAnnualDateKey: anAnnualDateSelfDescribingKey
	self setAnnualDate: (CalendricalAnnualDate at: anAnnualDateSelfDescribingKey)! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionDateAndTimeInYear: year 
	^self isSpecifiedAsLocalTime 
		ifTrue: 
			[self annualDate asDateAndTimeInYear: year timeZone: self offsetFromUT]
		ifFalse: 
			[self isSpecifiedAsStandardTime 
				ifTrue: 
					[self annualDate asDateAndTimeInYear: year
						timeZone: self stdTimeOffsetFromUT asTimezone]
				ifFalse: 
					[self annualDate asDateAndTimeInUTYear: year timeZone: self offsetFromUT]]! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionDayOfWeekInYear: year
	^annualDate ansiDayOfWeekOrdinalInYear: year! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursAfter: aDateAndTimeSpec
	| diff |
	aDateAndTimeSpec == nil ifTrue: [^false].
	diff := aDateAndTimeSpec compareTo: self annualDate.
	diff > 0 ifTrue: [^false].
	diff < 0 ifTrue: [^true].
	^aDateAndTimeSpec secondsSinceStartOfDay < transitionSecondsSinceStartOfDay! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnFirstDayOfYear: year
	^annualDate minDayOfYearOrdinal = 1! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnLastDayOfYear: year
	^annualDate maxDayOfYearOrdinal = (Gregorian daysInYear: year)! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnOrAfter: aDateAndTimeSpec
	| diff |
	aDateAndTimeSpec == nil ifTrue: [^false].
	diff := aDateAndTimeSpec compareTo: self annualDate.
	diff > 0 ifTrue: [^false].
	diff < 0 ifTrue: [^true].
	^aDateAndTimeSpec secondsSinceStartOfDay <= transitionSecondsSinceStartOfDay! !

!UntilAnnualDateTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
typeKey
	^#'Until-Annual-Date-Transition'! !

IntraYearTimeZoneTransitionFactory subclass: #UntilAnnualDayOfYearTimeZoneTransitionFactory
	instanceVariableNames: 'transitionDayOfYear'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-PolicyFactories-Annual'!

!UntilAnnualDayOfYearTimeZoneTransitionFactory commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UntilAnnualDayOfYearTimeZoneTransitionFactory

	Concept:

		An UntilAnnualDayOfYearTimeZoneTransitionFactory is an IntraYearTimeZoneTransitionFactory that specifies its annually-recurring intra-year date of expiry and transition to a successor AnnuallyRecurringTZPolicyFactory using a day-of-year ordinal (first day of the year = 1.)

		See the superclass IntraYearTimeZoneTransitionFactory for more information.

	Motivation:

		UntilAnnualDayOfYearTimeZoneTransitionFactory is intended to be used for offset/abbreviation transitions that happen only once, and aren't actually annually recurring events (although it is perfectly possible and valid to use one to specify an annually-recurring transition that happens on the same day of the year every year.) However, the Chronos Time Zone Compiler uses UntilAnnualDayOfYearTimeZoneTransitionFactories solely for "one time" transitions.  

		Another possible reason to use UntilAnnualDayOfYearTimeZoneTransitionFactories would be in order to represent the contents of the binary time zone files used by UNIX (which are generted by the `zic` utility on UNIX that compiles Olson time zone rule specifications from their "source code" form into binary files used by the Standard C library on UNIX.)  The `zic` utility ('zic' = "zone information compiler") compiles time zone rules into a sequence of one-time offset/abbreviation transitions, where each transition is specified to occur at a particular time_t value (i.e., a specified number of seconds since 1970-01-01T00:00:00 UT; note that time_t values technically do not qualify as "UTC," because POSIX forbids UNIX from using leap seconds.) [Reference: http://www.gsp.com/cgi-bin/man.cgi?section=5&topic=tzfile]

	Implementation:

		Instance Variables  {Also see superclass}

			transitionDayOfYear	<Integer> The annually-recurring intra-year date, expressed as a day-of-year ordinal (first day = 1) when the ruleform represented by the instance expires and the transition to its successor takes place. Specification/representation of the time-of-day of expiry/transition is implemented by the superclass.
!

!UntilAnnualDayOfYearTimeZoneTransitionFactory class methodsFor: 'testing' stamp: ''!
isConcrete
	^true! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory class methodsFor: 'instance creation' stamp: ''!
offsetSeconds: secondsFromUTC stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol transitionDayOfYear: dayOfYearOrdinal transitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol 
	^(self new)
		setOffsetSeconds: secondsFromUTC  stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol;
		setTransitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol;
		setTransitionDayOfYear: dayOfYearOrdinal;
		beImmutable! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'converting' stamp: ''!
asPolicyFor: anInterYearTimeZonePolicy 
	^UntilAnnualDayOfYearTimeZoneTransition 
		for: anInterYearTimeZonePolicy
		offsetSeconds: offsetSecondsFromUT
		stdTimeOffsetSeconds: stdTimeOffsetSecondsFromUT
		commonAbbreviation: self commonAbbreviation
		transitionDayOfYear: transitionDayOfYear
		transitionSecondsSinceStartOfDay: transitionSecondsSinceStartOfDay
		relativity: relativity! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream nextPut: self transitionDayOfYear! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'printing' stamp: ''!
encodeOn: stream
	super encodeOn: stream.
	stream 
		nextPut: $:;
		print: transitionDayOfYear.! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self setTransitionDayOfYear: (literalArray at: 7) asNumber! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
maxDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^transitionDayOfYear - 1! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
minDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^transitionDayOfYear - 1! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	stream
		nextPutAll: ' transitionDayOfYear=';
		print: transitionDayOfYear.
	self printTimeOfDayOn: stream.! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	^aTimezoneProcessor processUntilAnnualDayOfYearTimeZoneTransition: self! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
semanticKey	
	"Answer a value that identifies the conceptual type of the receiver."

	^#UntilAnnualDayOfYearTimeZoneTransition! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'initialize-release' stamp: ''!
setTransitionDayOfYear: dayOfYearOrdinal
	self assertMutability.
	transitionDayOfYear := dayOfYearOrdinal.! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'testing' stamp: ''!
specifiesSingleTransition
	^true! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionDateAndTimeInYear: year 
	^self isSpecifiedAsLocalTime 
		ifTrue: 
			[DateAndTimeFactory 
				year: year
				day: transitionDayOfYear
				seconds: transitionSecondsSinceStartOfDay
				nanoseconds: 0
				timeZone: self offsetFromUT asTimezone]
		ifFalse: 
			[self isSpecifiedAsStandardTime 
				ifTrue: 
					[DateAndTimeFactory 
						year: year
						day: transitionDayOfYear
						seconds: transitionSecondsSinceStartOfDay
						nanoseconds: 0
						timeZone: self stdTimeOffsetFromUT asTimezone]
				ifFalse: 
					[DateAndTimeFactory 
						utYear: year
						day: transitionDayOfYear
						seconds: transitionSecondsSinceStartOfDay
						nanoseconds: 0
						timeZone: self offsetFromUT asTimezone]]! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionDayOfWeekInYear: year
	^(DateFactory year: year day: transitionDayOfYear) dayOfWeek! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
transitionDayOfYear
	^transitionDayOfYear! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursAfter: aDateAndTimeSpec
	| diff |
	aDateAndTimeSpec == nil ifTrue: [^false].
	diff := transitionDayOfYear - aDateAndTimeSpec dayOfYearOrdinal.
	diff > 0 ifTrue: [^true].
	diff < 0 ifTrue: [^false].
	^transitionSecondsSinceStartOfDay > aDateAndTimeSpec secondsSinceStartOfDay! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnFirstDayOfYear: year
	^transitionDayOfYear = 1! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnLastDayOfYear: year
	^transitionDayOfYear = (Gregorian daysInYear: year)! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionOccursOnOrAfter: aDateAndTimeSpec
	| diff |
	aDateAndTimeSpec == nil ifTrue: [^false].
	diff := transitionDayOfYear - aDateAndTimeSpec dayOfYearOrdinal.
	diff > 0 ifTrue: [^true].
	diff < 0 ifTrue: [^false].
	^transitionSecondsSinceStartOfDay >= aDateAndTimeSpec secondsSinceStartOfDay! !

!UntilAnnualDayOfYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
typeKey
	^#'Until-Day-Of-Year-Transition'! !

AnnuallyRecurringTZPolicyFactory subclass: #UntilEndOfYearTimeZoneTransitionFactory
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-PolicyFactories-Annual'!

!UntilEndOfYearTimeZoneTransitionFactory commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UntilEndOfYearTimeZoneTransitionFactory

	Concept:

		An UntilEndOfYearTimeZoneTransitionFactory is an AnnuallyRecurringTZPolicyFactory that functions as the last/final ruleform in the sequence of ruleforms that specifies the offset/abbreviation tuples that apply within the territorial domain of a time zone during every moment of a calendar year. The ruleform represented by an UntilEndOfYearTimeZoneTransitionFactory instance expires at the end of every year, and is succeded by the first rule in its sequence (which may be itself, if it's the only rule in the sequence.) 

		However, the purpose of an UntilEndOfYearTimeZoneTransitionFactory is not to actually itself provide time-zone behavior, but rather to serve as a factory for creating a UntilEndOfYearTimeZoneTransition instance.  Although it represents essentially the same information as an UntilEndOfYearTimeZoneTransition, its purpose and behavior are different. 

		See the superclass AnnuallyRecurringTZPolicyFactory for more information.


	!

!UntilEndOfYearTimeZoneTransitionFactory class methodsFor: 'testing' stamp: ''!
isConcrete
	^true! !

!UntilEndOfYearTimeZoneTransitionFactory class methodsFor: 'instance creation' stamp: ''!
offsetSeconds: secondsFromUTC stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol
	^self new
		setOffsetSeconds: secondsFromUTC  stdTimeOffsetSeconds: stdTimeSecondsFromUTC commonAbbreviation: aSymbol;
		beImmutable! !

!UntilEndOfYearTimeZoneTransitionFactory methodsFor: 'converting' stamp: ''!
asPolicyFor: anInterYearTimeZonePolicy 
	^UntilEndOfYearTimeZoneTransition 
		for: anInterYearTimeZonePolicy
		offsetSeconds: offsetSecondsFromUT
		stdTimeOffsetSeconds: stdTimeOffsetSecondsFromUT
		commonAbbreviation: commonAbbreviation! !

!UntilEndOfYearTimeZoneTransitionFactory methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	^aTimezoneProcessor processUntilEndOfYearTimeZoneTransition: self! !

!UntilEndOfYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
semanticKey	
	"Answer a value that identifies the conceptual type of the receiver."

	^#UntilEndOfYearTimeZoneTransition! !

!UntilEndOfYearTimeZoneTransitionFactory methodsFor: 'queries' stamp: ''!
transitionDateAndTimeInYear: year 
	^DateAndTimeFactory 
		year: year
		month: 12
		day: 31
		timeZone: self offsetFromUT asTimezone! !

!UntilEndOfYearTimeZoneTransitionFactory methodsFor: 'accessing' stamp: ''!
typeKey
	^#'Until-End-Of-Year'! !

PassportMagnitude subclass: #TemporalRule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!TemporalRule commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

TemporalRule

	Concept:

		TemporalRule is an abtract class. An instance of a concrete subclass of TemporalRule represents a rule that may change over time, so that it is necessary to specify a moment in time in order to identify the version of the rule then in effect.  

		Each TemporalRule instance represents a ruleform in effect for a particular period of time, and is also the head of a linked-list of TemporalRules representing either the successor or the predecessor sequence of versions of a rule. The linked list of TemporalRules, also called the "rule chain,"  provides a diachronic view of the historical versions of a rule.  It is the responsibility of subclasses to determine whether the "rule chain" (the linked list) starts with the most recent version of the rule or with the earliest version of the rule. It is also the responsibility of subclasses to implement the ruleform itself (specify the semantics/parameters of the rules,) and to define the temporal parameters necessary to determine when transitions occur from one version of a rule to another.

	Usage:

		See the individual method comments.

	Subclassing:

		Concrete subclasses must subimplement the following instance methods:

			#setRigthLink:
			#compareTo:
			#hash

		Subclasses will probably want to subimplement many (or all) of the following instance methods:

			#hasRightwardLink
			#isAlwaysInEffect
			#rightLink
			#rightLinkIfNone:
			#sortOperator
			#withRightLinkDo:
!

TemporalRule subclass: #AnnuallyRecurringTZPolicy
	instanceVariableNames: 'interYearPolicy boundTZ leftLink'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-Policies-Annual'!

!AnnuallyRecurringTZPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

AnnuallyRecurringTZPolicy

	Concept/Usage::

		AnnuallyRecurringTZPolicy is an abstract class. An instance of a concrete subclass of AnnuallyRecurringTZPolicy represents a ruleform that specifies, for all moments in time since the ruleform takes effect up until the moment it expires, the abbreviation and offset from UT that apply to all points-in-time within the territorial domain of a time zone. Each AnnuallyRecurringTZPolicy instance specifies/represents a single abbreviation and offset from UT that apply during the period of time its ruleform is in effect.  The purpose of an AnnuallyRecurringTZPolicy is to enable the binding of a point-in-time value to a particular time zone abbreviation and offset from UT (in the form of a "bound, dynamic" time zone instance.) 

		An AnnuallyRecurringTZPolicy is an element in a chain (linked list) of AnnuallyRecurringTZPolicy instances (with the linked-list behavior implemented in part by inheritance from its superclass TemporalRule,) such that the "rule chain" (linked list of AnnuallyRecurringTZPolicy instances) as a whole specifies the offset/abbreviation tuples that apply within the territorial domain of a time zone during every moment of the year. The first AnnuallyRecurringTZPolicy instance in the rule chain represents a ruleform that takes effect at the first moment of each year (local time.) Any successor elements in the rule chain represent ruleforms that take effect at some annually-recurring intra-year date and time (any of local time, local "standard time," or Universal Time may be used  to designate the moment of expiry of the predecessor ruleform and transition to the successor ruleform.) An AnnuallyRecurringTZPolicy's ruleform expires either at the end of each year, or else at whatever annually-recurring intra-year date and time it specifies.  When an AnnuallyRecurringTZPolicy's ruleform expires, it is superceded by either the next rule in the chain, or else (if it's the last rule in the rule chain) by the first rule in the chain.  

		The last ruleform in a rule chain must be represented by an instance of UntilEndOfYearTimeZoneTransition.  The other ruleforms in a rule chain may be instances of either UntilAnnualDateTimeZoneTransition or UntilAnnualDayOfYearTimeZoneTransition.

	Implementation:

		Insance Variables

			interYearPolicy	<TimeZonePolicy> The inter-year TimeZonePolicy of the receiver that connects the receiver to the full diachronic ruleset of the instance's time zone.
			boundTZ		<StandardTime | NonStandardTime> The "bound, dynamic" ChronosTimezone that specifies the abbreviation and offset from UT that apply within the territorial domain of that time zone while the time zone ruleform represented by the instance is in effect.
			leftLink 			<AnnuallyRecurringTZPolicy | nil>	The AnnuallyRecurringTZPolicy that was in effect before the instance's offset/abbreviation tuple came into effect.

	Subclassing:

		Concrete subclasses must subimplement the following methods:

			#asAnnuallyRecurringTZPolicyFactory
			#printTranstionRuleOn:
!

!AnnuallyRecurringTZPolicy class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self shouldNotImplement! !

!AnnuallyRecurringTZPolicy class methodsFor: 'instance creation' stamp: ''!
for: anInterYearTimeZonePolicy offsetSeconds: offsetSeconds stdTimeOffsetSeconds: stdTimeOffsetSeconds commonAbbreviation: abbreviation 
	^self new 
		setInterYearPolicy: anInterYearTimeZonePolicy
		offsetSeconds: offsetSeconds
		stdTimeOffsetSeconds: stdTimeOffsetSeconds
		commonAbbreviation: abbreviation! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
abbreviation
	"Answer the abbreviation for the timezone represented by the receiver--according to the default locale if possible."

	^boundTZ abbreviation! !

!AnnuallyRecurringTZPolicy methodsFor: 'converting' stamp: ''!
asAnnuallyRecurringTZPolicyFactory
	"Answer the AnnuallyRecurringTZPolicyFactory that would serve as a factory to recreate an instance of the receiver's class with the same value as the receiver."

	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicy methodsFor: 'converting' stamp: ''!
asAnnuallyRecurringTZPolicyFactoryArray
	"Answer an Array of the AnnuallyRecurringTZPolicyFactories that would serve as a factory to recreate an instance of the receiver's class with the same value as the list of AnnuallyRecurringTZPolicies represented by the receiver."

	| atomStream |
	atomStream := Array new writeStream.
	self withSelfAndAllRightwardLinksDo: [:offsetPolicy | atomStream nextPut: offsetPolicy asAnnuallyRecurringTZPolicyFactory].
	^atomStream contents! !

!AnnuallyRecurringTZPolicy methodsFor: 'converting' stamp: ''!
asChronosValue
	"Answer the translation of the receiver into an object that is an instance of whichever class in the Chronos Date/Time Library would be most appropriate for the instantiation of an object equal and/or analogous to the receiver ."

	^self! !

!AnnuallyRecurringTZPolicy methodsFor: 'converting' stamp: ''!
asNonProxy
	"Answer the time zone to which the receiver indirectly refers by proxy.  If the receiver is not a proxy for a time zone other than itself, answer the receiver."

	^self! !

!AnnuallyRecurringTZPolicy methodsFor: 'converting' stamp: ''!
asTimezone
	"Answer the conversion of the receiver into a time zone it either references or describes. If the receiver is itself a time zone, answer the receiver."

	^self root! !

!AnnuallyRecurringTZPolicy methodsFor: 'converting' stamp: ''!
asUnbound
	"Answer the unbound time zone that specifies the full diachronic ruleset of the time zone represented by the receiver."

	^interYearPolicy! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
binding
	^boundTZ! !

!AnnuallyRecurringTZPolicy methodsFor: 'queries' stamp: ''!
bindingForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in the local time defined by the receiver.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in local (`wall clock`) time as defined by the receiver."

	^interYearPolicy
		bindingForLocalYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!AnnuallyRecurringTZPolicy methodsFor: 'queries' stamp: ''!
bindingForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in Universal Time.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in Universal Time."

	^interYearPolicy
		bindingForUTYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!AnnuallyRecurringTZPolicy methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's root time zone."

	^self root canonical! !

!AnnuallyRecurringTZPolicy methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromLocal: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time in the local time defined by the receiver, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use Universal Time coordinates instead of local time coordinates.)"

	^boundTZ canonicalizeFromLocal: aDateAndTime! !

!AnnuallyRecurringTZPolicy methodsFor: 'collaboration-dateAndTime' stamp: ''!
canonicalizeFromUT: aDateAndTime
	"Library Private: Collaborate by double-dispatch with <aDateAndTime>, whose internal state currently designates a point-in-time using Universal Time coordinates, so that its internal state will canonically represent its designated point-in-time (the internal state of <aDateAndTime> may need to be partially or completely changed to use coordinates in the local time defined by the receiver instead of using Universal Time coordinates.)"

	^boundTZ canonicalizeFromUT: aDateAndTime! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
commonAbbreviation
	^boundTZ commonAbbreviation! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
defaultAnnualPolicy
	"Answer the AnnuallyRecurringTZPolicy that specifies the time zone rules that are in effect during the current year."

	^interYearPolicy defaultAnnualPolicy! !

!AnnuallyRecurringTZPolicy methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	self shouldNotImplement! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
hasLeftwardLink
	"Answer whether there is anonther rule after the receiver in the receiver's leftward rule chain."

	^leftLink notNil! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
hasName
	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
hasSubsecondOffset
	"Answer whether the receiver has fractional seconds of offset."

	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self shouldNotImplement! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
interYearPolicy
	^interYearPolicy! !

!AnnuallyRecurringTZPolicy methodsFor: 'queries' stamp: ''!
intraYearPolicyForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in local time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).  Assume the receiver's policy is in effect during the specified year.

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct timezone binding, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UTC for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day in local time (without any need to consider standard versus daylight saving time.)"

	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicy methodsFor: 'queries' stamp: ''!
intraYearPolicyForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in Universal Time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).  Assume the receiver's policy is in effect during the specified year.

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct timezone binding, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UT for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day as UT (without any need to consider standard versus daylight saving time.)"

	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isBound
	"Answer whether the receiver is a bound time zone. A bound time zone is one that defines a single offset/abbreviation tuple, and that conforms to the `BOUND TIMEZONE API` (as defined in the class comment of ChronosTimezone.)"

	^true! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isInvariantToNominalTime
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to nominal time."

	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isInvariantToUT
	^true! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isProxy
	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isProxyAndInvariantToUT
	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isProxyOrStatic
	"Answer whether the receiver is either a proxy time zone or a static time zone."

	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isStandardTime
	"Answer whether or not the offset from UT specified by the receiver defines the `standard time` of the time zone represented by the receiver (as opposed to `daylight saving time`, `summer time`, `war time`, 'three-year-long-year-round energy-saving-during-a-crisis time', etc)."

	^boundTZ isStandardTime! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isStatic
	"Answer whether or not the timezone policy (key, offset, name and abbreviation) of the timezone represented by the receiver is invariant, constant and never subject to change or revision.  If the receiver's timezone policy is dynamically redefinable, answer false."

	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isTimezone
	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
isUniversalTime
	"Anwser whether the receiver has all the properties and behaviors of the international reference zero-offset time zone."

	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
key
	"Answer the key that identifies the receiver."

	^interYearPolicy key! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
leftLink
	^leftLink! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
leftLinkIfNone: block0
	"Answer the next rule `to the left` in the receiver's rule chain, if there is one.  If there is not, answer the result of evaluating <block0>."

	^leftLink == nil
		ifTrue: [block0 value]
		ifFalse: [leftLink]! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
name
	^boundTZ name! !

!AnnuallyRecurringTZPolicy methodsFor: 'collaboration-dateAndTime' stamp: ''!
netSecondsAfterAddingOffsetFromUTToSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond 
	"Answer the net number of integer seconds (truncated towards zero) that result from adding the receiver's offset from UT to the specified number of <seconds> and <nanosecondsSinceSecond>."

	^boundTZ 
		netSecondsAfterAddingOffsetFromUTToSeconds: seconds
		nanosecondsSinceSecond: nanosecondsSinceSecond! !

!AnnuallyRecurringTZPolicy methodsFor: 'collaboration-dateAndTime' stamp: ''!
netSecondsAfterSubtractingOffsetFromUTFromSeconds: seconds nanosecondsSinceSecond: nanosecondsSinceSecond
	"Answer the net number of integer seconds (truncated towards zero) that result from subtracting the receiver's offset from UT from the specified number of <seconds> and <nanosecondsSinceSecond>."

	^boundTZ
		netSecondsAfterSubtractingOffsetFromUTFromSeconds: seconds 
		nanosecondsSinceSecond: nanosecondsSinceSecond! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
offsetDeltaSeconds
	^boundTZ offsetDeltaSeconds! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
offsetFromUT
	^boundTZ offsetFromUT! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
offsetIsZero
	"Anwser whether the receiver's offset from UT is zero."

	^boundTZ offsetIsZero! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
offsetSecondsFromUT
	^boundTZ offsetSecondsFromUT! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
policy
	"Answer the TimeZonePolicy that specifies the ruleset of the time zone represented by the instance.  The ruleset of a time zone specifies for all time values, from the infinite past to the infinite future, the (possibly varying) time zone offsets and abbreviations that apply to points-in-time within the territorial domain of the time zone. Note, however, that the `policy` (time zone ruleset) can be changed retroactively--and this is rather likely to happen for times in the future (but can also happen to times in the past.)"

	^interYearPolicy! !

!AnnuallyRecurringTZPolicy methodsFor: 'printing' stamp: ''!
printOn: stream
	stream
		nextPut: ${;
		nextPutAll: self class name;
		nextPutAll: ' commonAbbreviation=';
		nextPutAll: self commonAbbreviation;
		nextPutAll: ' offsetSecondsFromUT=';
		print: self offsetSecondsFromUT;
		nextPutAll: ' until='.
	self printTranstionRuleOn: stream.
	self printSuccessorOn: stream.
	stream nextPut: $}! !

!AnnuallyRecurringTZPolicy methodsFor: 'printing' stamp: ''!
printSuccessorOn: stream
	"By default, do nothing."! !

!AnnuallyRecurringTZPolicy methodsFor: 'printing' stamp: ''!
printTranstionRuleOn: stream
	^self subclassResponsibility! !

!AnnuallyRecurringTZPolicy methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	self asAnnuallyRecurringTZPolicyFactoryArray do: [:each | each processBy: aTimezoneProcessor]! !

!AnnuallyRecurringTZPolicy methodsFor: 'initialize-release' stamp: ''!
release
	super release.
	boundTZ release.! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
root

	^interYearPolicy root! !

!AnnuallyRecurringTZPolicy methodsFor: 'initialize-release' stamp: ''!
setBoundTZ: aBoundTimezone 
	self assertMutability.
	boundTZ := aBoundTimezone! !

!AnnuallyRecurringTZPolicy methodsFor: 'initialize-release' stamp: ''!
setInterYearPolicy: anInterYearTimeZonePolicy
	self assertMutability.
	interYearPolicy := anInterYearTimeZonePolicy.! !

!AnnuallyRecurringTZPolicy methodsFor: 'initialize-release' stamp: ''!
setInterYearPolicy: anInterYearTimeZonePolicy offsetSeconds: offsetSeconds stdTimeOffsetSeconds: stdTimeOffsetSeconds commonAbbreviation: abbreviation 
	self setInterYearPolicy: anInterYearTimeZonePolicy.
	self setBoundTZ: 
		(ChronosTimezone
			bindingForKey: self key
			offsetSecondsFromUT: offsetSeconds
			stdTimeOffsetSecondsFromUT: stdTimeOffsetSeconds
			commonAbbreviation: abbreviation)! !

!AnnuallyRecurringTZPolicy methodsFor: 'initialize-release' stamp: ''!
setLeftLink: aTimeZonePolicy
	"Set <aTimeZonePolicy> as the leftward link in the receiver's chain of TimeZonePolicies."

	self assertMutability.
	leftLink := aTimeZonePolicy.! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
sortOperator
	"Answer the comparison operator (as a message selector Symbol) to be used to sort the receiver's rule chain in canonical order."

	^#<! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation
	^boundTZ specifiesCommonAbbreviation or: [leftLink notNil and: [leftLink specifiesCommonAbbreviation]]! !

!AnnuallyRecurringTZPolicy methodsFor: 'testing' stamp: ''!
specifiesIntraYearTransition
	^false! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
stdTimeOffsetFromUT
	^boundTZ stdTimeOffsetFromUT! !

!AnnuallyRecurringTZPolicy methodsFor: 'accessing' stamp: ''!
stdTimeOffsetSecondsFromUT
	^boundTZ stdTimeOffsetSecondsFromUT! !

!AnnuallyRecurringTZPolicy methodsFor: 'queries' stamp: ''!
transitionDateAndTimeInYear: year
	^self subclassResponsibility! !

AnnuallyRecurringTZPolicy subclass: #IntraYearTimeZoneTransition
	instanceVariableNames: 'rightLink relativity transitionSecondsSinceStartOfDay'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-Policies-Annual'!

!IntraYearTimeZoneTransition commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

IntraYearTimeZoneTransition

	Concept:

		An IntraYearTimeZoneTransition is an abstract subclass of AnnuallyRecurringTZPolicy.  An instance of a concrete subclass of IntraYearTimeZoneTransition functions as any but the last/final ruleform in the rule chain that specifies the offset/abbreviation tuples that apply within the territorial domain of a time zone during every moment of the year. The ruleform represented by a IntraYearTimeZoneTransition instance expires at some annually-recurring intra-year date and time (any of local time, local "standard time," or Universal Time may be used  to designate the moment of expiry of the predecessor ruleform and transition to the successor ruleform.) 

		See the superclass AnnuallyRecurringTZPolicy for more information.

	Motivation:

		Chronos represents offset/abbreviation transitions using annually-recurring dates, instead of following in the path of UNIX and using an exhaustive list of every transition specified as occurring at some absolute number of seconds since an epoch, for two independent reasons:

			1. To minimize memory usage--enough said.
			2. To make the representation of the moments of transition be independent of any particular timesale--in other words, to make them neutral with respect to leap seconds--a property which the source Olson time zone rules have, but the zic-generated binary time zone files do not..

	Implementation:

		Instance Variables  {Also see superclass}

			rightLink 							<AnnuallyRecurringTZPolicy>	The AnnuallyRecurringTZPolicy that takes effect when the instance expires.
			relativity 							<Symbol>	If relativity == #nominal, then the instance's moment of expiry/transition-to-successor is designated in local ("wall clock") time; if relativity == #standard,  then the instance's moment of expiry/transition-to-successor is designated in local "standard time" (without DST;) if relativity == #universal, then the instance's moment of expiry/transition-to-successor is designated in Universal Time.
			transitionSecondsSinceStartOfDay 	<Integer>	The time of day, expressed as a number of seconds since the start of the day (0..86399,) when the ruleform represented by the instance expires and the transition to its successor (the <nextLink>) takes place. Specification/representation of the annually-recurring intra-year date on which the instance's ruleform expires is the responsibility of concrete subclasses.

	Subclassing:

		Concrete subclasses must subimplement the following instance methods:

			#maxDaysFromStartOfYearUntilTransition
			#minDaysFromStartOfYearUntilTransition
			#transitionDayOfWeekInYear:
			#transitionOccursOnOrAfterYear:dayOfYear:relativity:secondsSinceStartOfDayFunction: !

!IntraYearTimeZoneTransition methodsFor: 'private-comparing' stamp: ''!
compareToUntilEndOfYearAnnualTZPolicy: anUntilEndOfYearAnnualTZPolicy
	^1! !

!IntraYearTimeZoneTransition methodsFor: 'testing' stamp: ''!
hasRightwardLink
	"Answer whether there is anonther rule after the receiver in the receiver's rightward rule chain."

	^rightLink notNil! !

!IntraYearTimeZoneTransition methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	relativity := #nominal.
	transitionSecondsSinceStartOfDay := 0! !

!IntraYearTimeZoneTransition methodsFor: 'queries' stamp: ''!
intraYearPolicyForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in local time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).  Assume the receiver's policy is in effect during the specified year.

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct timezone binding, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UTC for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day in local time (without any need to consider standard versus daylight saving time.)"

	^(self 
		transitionOccursOnOrAfterYear: year
		dayOfYear: dayOfYear
		relativity: #nominal
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction) 
			ifTrue: 
				[rightLink 
					intraYearPolicyForLocalYear: year
					dayOfYear: dayOfYear
					secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction]
			ifFalse: [self]! !

!IntraYearTimeZoneTransition methodsFor: 'queries' stamp: ''!
intraYearPolicyForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in Universal Time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).  Assume the receiver's policy is in effect during the specified year.

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct timezone binding, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UT for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day as UT (without any need to consider standard versus daylight saving time.)"

	^(self 
		transitionOccursOnOrAfterYear: year
		dayOfYear: dayOfYear
		relativity: #universal
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction) 
			ifTrue: 
				[rightLink 
					intraYearPolicyForUTYear: year
					dayOfYear: dayOfYear
					secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction]
			ifFalse: [self]! !

!IntraYearTimeZoneTransition methodsFor: 'testing' stamp: ''!
isAlwaysInEffect
	"Answer whether thre rule represented by the receiver is always in effect."

	^self isAtom and: [interYearPolicy isAlwaysInEffect]! !

!IntraYearTimeZoneTransition methodsFor: 'testing' stamp: ''!
isSpecifiedAsLocalTime
	^relativity == #nomimal! !

!IntraYearTimeZoneTransition methodsFor: 'testing' stamp: ''!
isSpecifiedAsStandardTime
	^relativity == #standard! !

!IntraYearTimeZoneTransition methodsFor: 'testing' stamp: ''!
isSpecifiedAsUT
	^relativity == #universal! !

!IntraYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
maxDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^self subclassResponsibility! !

!IntraYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
minDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^self subclassResponsibility! !

!IntraYearTimeZoneTransition methodsFor: 'printing' stamp: ''!
printSuccessorOn: stream
	rightLink == nil 
		ifFalse: 
			[stream
				cr; tab; tab; tab; tab;
				nextPutAll: 'then '; print: rightLink].! !

!IntraYearTimeZoneTransition methodsFor: 'printing' stamp: ''!
printTransitionTimeOfDayOn: stream
	stream nextPutAll: ' @ '.
	self transitionTimeOfDay printOn: stream.
	stream
		nextPutAll: ' (';
		nextPutAll: relativity;
		nextPut: $)! !

!IntraYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
relativity
	^relativity! !

!IntraYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
rightLink
	"Answer the next rule `to the right` in the receiver's rule chain, if there is one.  If there is not, answer nil."

	^rightLink! !

!IntraYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
rightLinkIfNone: block0
	"Answer the next rule `to the right` in the receiver's rule chain, if there is one.  If there is not, answer the result of evaluating <block0>."

	^rightLink == nil
		ifTrue: [block0 value]
		ifFalse: [rightLink]! !

!IntraYearTimeZoneTransition methodsFor: 'initialize-release' stamp: ''!
setRightLink: anAnnuallyRecurringTZPolicy
	"Set <anAnnuallyRecurringTZPolicy> as the next rule `to the right` in the receiver's chain of  AnnuallyRecurringTZPolicies."

	self assertMutability.
	rightLink := anAnnuallyRecurringTZPolicy.
	super setRightLink: anAnnuallyRecurringTZPolicy.! !

!IntraYearTimeZoneTransition methodsFor: 'initialize-release' stamp: ''!
setTransitionSecondsSinceStartOfDay: seconds relativity: aRelativitySymbol
	self assertMutability.
	transitionSecondsSinceStartOfDay := seconds.
	relativity := aRelativitySymbol asSymbol.! !

!IntraYearTimeZoneTransition methodsFor: 'testing' stamp: ''!
specifiesIntraYearTransition
	^true! !

!IntraYearTimeZoneTransition methodsFor: 'queries' stamp: ''!
transitionDayOfWeekInYear: year
	^self subclassResponsibility! !

!IntraYearTimeZoneTransition methodsFor: 'private' stamp: ''!
transitionOccursOnOrAfterYear: year dayOfYear: dayOfYearOrdinal relativity: parameterRelativity secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
	^self subclassResponsibility! !

!IntraYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
transitionSecondsSinceStartOfDay
	^transitionSecondsSinceStartOfDay! !

!IntraYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
transitionTimeOfDay
	^TimeOfDayFactory secondsSinceStartOfDay: transitionSecondsSinceStartOfDay! !

!IntraYearTimeZoneTransition methodsFor: 'enumerating' stamp: ''!
withRightLinkDo: block1
	"Evaluatue <block1> with the next rightward link in the receiver's rule chain as the argument.  If there is no such link, do nothing."

	^rightLink == nil ifFalse: [block1 value: rightLink]! !

IntraYearTimeZoneTransition subclass: #UntilAnnualDateTimeZoneTransition
	instanceVariableNames: 'annualDate'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-Policies-Annual'!

!UntilAnnualDateTimeZoneTransition commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UntilAnnualDateTimeZoneTransition

	Concept:

		An UntilAnnualDateTimeZoneTransition is an IntraYearTimeZoneTransition that specifies its annually-recurring intra-year date of expiry and transition to a successor AnnuallyRecurringTZPolicy using an instance of AnnualDate.

		See the superclass IntraYearTimeZoneTransition for more information.

	Implementation:

		Instance Variables  {Also see superclass}
	
			annualDate	<AnnualDate> The annually-recurring intra-year date when the ruleform represented by the instance expires and the transition to its successor (the inherited <nextLink>) takes place. Specification/representation of the time-of-day of expiry/transition is implemented by the superclass.

!

!UntilAnnualDateTimeZoneTransition class methodsFor: 'instance creation' stamp: ''!
for: anInterYearTimeZonePolicy offsetSeconds: offsetSeconds stdTimeOffsetSeconds: stdTimeOffsetSeconds commonAbbreviation: abbreviation annualDate: annualDate transitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol
	^(self new)
		setInterYearPolicy: anInterYearTimeZonePolicy offsetSeconds: offsetSeconds stdTimeOffsetSeconds: stdTimeOffsetSeconds commonAbbreviation: abbreviation;
		setTransitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol;
		setAnnualDate: annualDate! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'accessing' stamp: ''!
annualDate
	^annualDate! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'accessing' stamp: ''!
annualDateKey
	^self annualDate selfDescribingKey! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'converting' stamp: ''!
asAnnuallyRecurringTZPolicyFactory
	"Answer the AnnuallyRecurringTZPolicyFactory that would serve as a factory to recreate an instance of the receiver's class with the same value as the receiver."

	^UntilAnnualDateTimeZoneTransitionFactory 
		offsetSeconds: self offsetSecondsFromUT
		stdTimeOffsetSeconds: self stdTimeOffsetSecondsFromUT
		commonAbbreviation: self commonAbbreviation
		annualDate: self annualDate
		transitionSecondsSinceStartOfDay: self transitionSecondsSinceStartOfDay
		relativity: self relativity! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'comparing' stamp: ''!
compareTo: anUntilAnnualDateTZPolicy
	"Answer a strictly positive integer if the receiver's transition time is greater than that of the argument; answer 0 if equal; and answer a negative integer if less."

	self == anUntilAnnualDateTZPolicy ifTrue: [^0].
	^[anUntilAnnualDateTZPolicy compareToUntilAnnualDateTZPolicy: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == anUntilAnnualDateTZPolicy and: [ex message selector == #compareToUntilAnnualDateTZPolicy:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'private-comparing' stamp: ''!
compareToUntilAnnualDateTZPolicy: anUntilAnnualDateTZPolicy
	| diff |
	diff := anUntilAnnualDateTZPolicy annualDate compareTo: annualDate.
	diff == nil ifTrue: [^nil].
	diff = 0 ifFalse: [^diff].
	^anUntilAnnualDateTZPolicy transitionSecondsSinceStartOfDay - transitionSecondsSinceStartOfDay! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'private-comparing' stamp: ''!
compareToUntilAnnualDayOfYearTZPolicy: anUntilAnnualDayOfYearTZPolicy
	| diff |
	diff := anUntilAnnualDayOfYearTZPolicy transitionDayOfYear - annualDate minDayOfYearOrdinal.
	diff = 0 ifFalse: [^diff].
	^anUntilAnnualDayOfYearTZPolicy transitionSecondsSinceStartOfDay - transitionSecondsSinceStartOfDay! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'accessing' stamp: ''!
maxDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^(annualDate maxDayOfYearOrdinalForYearOfType: yearTypeCode) - 1! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'accessing' stamp: ''!
maxTransitionDayOfYear
	^annualDate maxDayOfYearOrdinal! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'accessing' stamp: ''!
minDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^(annualDate minDayOfYearOrdinalForYearOfType: yearTypeCode) - 1! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'accessing' stamp: ''!
minTransitionDayOfYear
	^annualDate minDayOfYearOrdinal! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'printing' stamp: ''!
printTranstionRuleOn: stream
	stream 
		print: annualDate.
	self printTransitionTimeOfDayOn: stream! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'initialize-release' stamp: ''!
setAnnualDate: anAnnualDate
	self assertMutability.
	annualDate := anAnnualDate! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'queries' stamp: ''!
transitionDateAndTimeInYear: year 
	^self isSpecifiedAsLocalTime 
		ifTrue: 
			[self annualDate asDateAndTimeInYear: year timeZone: self offsetFromUT]
		ifFalse: 
			[self isSpecifiedAsStandardTime 
				ifTrue: 
					[self annualDate asDateAndTimeInYear: year
						timeZone: self stdTimeOffsetFromUT asTimezone]
				ifFalse: 
					[self annualDate asDateAndTimeInUTYear: year timeZone: self offsetFromUT]]! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'queries' stamp: ''!
transitionDayOfWeekInYear: year
	^annualDate ansiDayOfWeekOrdinalInYear: year! !

!UntilAnnualDateTimeZoneTransition methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
transitionOccursOnOrAfterYear: year dayOfYear: dayOfYearOrdinal relativity: parameterRelativity secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 

	| offsetSecondsFromUT transitionDay transitionSeconds dayDelta deltaSeconds secondsSinceStartOfDay |
	relativity == parameterRelativity 
		ifTrue: 
			[dayOfYearOrdinal < annualDate minDayOfYearOrdinal ifTrue: [^false].
			dayOfYearOrdinal > annualDate maxDayOfYearOrdinal ifTrue: [^true].
			transitionDay := annualDate dayOfYearOrdinalInYear: year.
			dayOfYearOrdinal < transitionDay ifTrue: [^false].
			dayOfYearOrdinal > transitionDay ifTrue: [^true].
			offsetSecondsFromUT := boundTZ offsetSecondsFromUT.
			transitionSeconds := transitionSecondsSinceStartOfDay.
			secondsSinceStartOfDay := secondsSinceStartOfDayFunction value: offsetSecondsFromUT.
			secondsSinceStartOfDay < 0
				ifTrue: [secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]
				ifFalse: 
					[secondsSinceStartOfDay > SecondsPerDay 
						ifTrue: [secondsSinceStartOfDay := SecondsPerDay - secondsSinceStartOfDay]]]
		ifFalse: 
			[dayDelta := dayOfYearOrdinal - annualDate minDayOfYearOrdinal.
			dayDelta < -1 ifTrue: [^false].
			dayDelta := dayOfYearOrdinal - annualDate maxDayOfYearOrdinal.
			dayDelta > 1 ifTrue: [^true].
			offsetSecondsFromUT := boundTZ offsetSecondsFromUT.
			relativity == #nominal
				ifTrue: 
					["parameterRelativity == #universal"
					deltaSeconds := offsetSecondsFromUT negated]
				ifFalse: 
					[relativity == #standard
						ifTrue: 
							[parameterRelativity == #nominal
								ifTrue: 
									["parameterRelativity == #nominal"
									deltaSeconds := boundTZ offsetDeltaSeconds]
								ifFalse:
									["parameterRelativity == #universal"
									deltaSeconds := boundTZ stdTimeOffsetSecondsFromUT negated]]
						ifFalse: 
							["parameterRelativity == #nominal"
							deltaSeconds := offsetSecondsFromUT]].
			transitionSeconds := transitionSecondsSinceStartOfDay + deltaSeconds.
			transitionDay := annualDate dayOfYearOrdinalInYear: year.
			"Assumption: No REGISTERED Timezone (with a well-known key in the Olson TZ database) will have an offsetSecondsFromUT greater than SecondsPerDay."
			transitionSeconds < 0 
				ifTrue: 
					[transitionDay := transitionDay - 1.
					transitionSeconds := transitionSeconds + SecondsPerDay]
				ifFalse: 
					[transitionSeconds >= SecondsPerDay 
						ifTrue: 
							[transitionDay := transitionDay + 1.
							transitionSeconds := transitionSeconds - SecondsPerDay]].
			dayOfYearOrdinal < transitionDay ifTrue: [^false].
			dayOfYearOrdinal > transitionDay ifTrue: [^true].
			secondsSinceStartOfDay := secondsSinceStartOfDayFunction value: offsetSecondsFromUT].
	^secondsSinceStartOfDay >= transitionSeconds! !

IntraYearTimeZoneTransition subclass: #UntilAnnualDayOfYearTimeZoneTransition
	instanceVariableNames: 'transitionDayOfYear'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-Policies-Annual'!

!UntilAnnualDayOfYearTimeZoneTransition commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UntilAnnualDayOfYearTZPolicy

	Concept:

		An UntilAnnualDayOfYearTZPolicy is an IntraYearTimeZoneTransition that specifies its annually-recurring intra-year date of expiry and transition to a successor AnnuallyRecurringTZPolicy using a day-of-year ordinal (first day of the year = 1.)

		See the superclass IntraYearTimeZoneTransition for more information.

	Motivation:

		UntilAnnualDayOfYearTZPolicy is intended to be used for offset/abbreviation transitions that happen only once, and aren't actually annually recurring events (although it is perfectly possible and valid to use one to specify an annually-recurring transition that happens on the same day of the year every year.) However, the Chronos Time Zone Compiler uses UntilAnnualDayOfYearTZPolicyFactories (which construct instances of UntilAnnualDayOfYearTZPolicy) solely for "one time" transitions.  

		Another possible reason to use UntilAnnualDayOfYearTZPolicies/UntilAnnualDayOfYearTZPolicyFactories would be in order to represent the contents of the binary time zone files used by UNIX (which are generted by the `zic` utility on UNIX that compiles Olson time zone rule specifications from their "source code" form into binary files used by the Standard C library on UNIX.)  The `zic` utility ('zic' = "zone information compiler") compiles time zone rules into a sequence of one-time offset/abbreviation transitions, where each transition is specified to occur at a particular time_t value (i.e., a specified number of seconds since 1970-01-01T00:00:00 UT; note that time_t values technically do not qualify as "UTC," because POSIX forbids UNIX from using leap seconds.) [Reference: http://www.gsp.com/cgi-bin/man.cgi?section=5&topic=tzfile]

	Implementation:

		Instance Variables  {Also see superclass}

			transitionDayOfYear	<Integer> The annually-recurring intra-year date, expressed as a day-of-year ordinal (first day = 1) when the ruleform represented by the instance expires and the transition to its successor (the inherited <nextLink>) takes place. Specification/representation of the time-of-day of expiry/transition is implemented by the superclass.
!

!UntilAnnualDayOfYearTimeZoneTransition class methodsFor: 'instance creation' stamp: ''!
for: anInterYearTimeZonePolicy offsetSeconds: offsetSeconds stdTimeOffsetSeconds: stdTimeOffsetSeconds commonAbbreviation: abbreviation transitionDayOfYear: dayOfYearOrdinal transitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol
	^(self new)
		setInterYearPolicy: anInterYearTimeZonePolicy offsetSeconds: offsetSeconds stdTimeOffsetSeconds: stdTimeOffsetSeconds commonAbbreviation: abbreviation;
		setTransitionSecondsSinceStartOfDay: transitionSeconds relativity: aRelativitySymbol;
		setTransitionDayOfYear: dayOfYearOrdinal! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'converting' stamp: ''!
asAnnuallyRecurringTZPolicyFactory
	"Answer the AnnuallyRecurringTZPolicyFactory that would serve as a factory to recreate an instance of the receiver's class with the same value as the receiver."

	^UntilAnnualDayOfYearTimeZoneTransitionFactory 
		offsetSeconds: self offsetSecondsFromUT
		stdTimeOffsetSeconds: self stdTimeOffsetSecondsFromUT
		commonAbbreviation: self commonAbbreviation
		transitionDayOfYear: self transitionDayOfYear
		transitionSecondsSinceStartOfDay: self transitionSecondsSinceStartOfDay
		relativity: self relativity! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'comparing' stamp: ''!
compareTo: anUntilAnnualDayOfYearTZPolicy
	"Answer a strictly positive integer if the receiver's transition time is greater than that of the argument; answer 0 if equal; and answer a negative integer if less."

	self == anUntilAnnualDayOfYearTZPolicy ifTrue: [^0].
	^[anUntilAnnualDayOfYearTZPolicy compareToUntilAnnualDayOfYearTZPolicy: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == anUntilAnnualDayOfYearTZPolicy and: [ex message selector == #compareToUntilAnnualDayOfYearTZPolicy:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'private-comparing' stamp: ''!
compareToUntilAnnualDateTZPolicy: anUntilAnnualDateTZPolicy
	| diff |
	diff := anUntilAnnualDateTZPolicy annualDate minDayOfYearOrdinal - transitionDayOfYear.
	diff = 0 ifFalse: [^diff].
	^anUntilAnnualDateTZPolicy transitionSecondsSinceStartOfDay - transitionSecondsSinceStartOfDay! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'private-comparing' stamp: ''!
compareToUntilAnnualDayOfYearTZPolicy: anUntilAnnualDayOfYearTZPolicy
	| diff |
	diff := anUntilAnnualDayOfYearTZPolicy transitionDayOfYear - transitionDayOfYear.
	diff = 0 ifFalse: [^diff].
	^anUntilAnnualDayOfYearTZPolicy transitionSecondsSinceStartOfDay - transitionSecondsSinceStartOfDay! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	transitionDayOfYear := 1! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
maxDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^transitionDayOfYear - 1! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
minDaysFromStartOfYearUntilTransitionForYearOfType: yearTypeCode
	^transitionDayOfYear - 1! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'printing' stamp: ''!
printTranstionRuleOn: stream
	stream 
		nextPutAll: 'dayOfYear=';
		print: transitionDayOfYear.
	self printTransitionTimeOfDayOn: stream! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'initialize-release' stamp: ''!
setTransitionDayOfYear: aDayOfYearOrdinal
	self assertMutability.
	transitionDayOfYear := aDayOfYearOrdinal! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'queries' stamp: ''!
transitionDateAndTimeInYear: year 
	^self isSpecifiedAsLocalTime 
		ifTrue: 
			[DateAndTimeFactory 
				year: year
				day: transitionDayOfYear
				seconds: transitionSecondsSinceStartOfDay
				nanoseconds: 0
				timeZone: self offsetFromUT asTimezone]
		ifFalse: 
			[self isSpecifiedAsStandardTime 
				ifTrue: 
					[DateAndTimeFactory 
						year: year
						day: transitionDayOfYear
						seconds: transitionSecondsSinceStartOfDay
						nanoseconds: 0
						timeZone: self stdTimeOffsetFromUT asTimezone]
				ifFalse: 
					[DateAndTimeFactory 
						utYear: year
						day: transitionDayOfYear
						seconds: transitionSecondsSinceStartOfDay
						nanoseconds: 0
						timeZone: self offsetFromUT asTimezone]]! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'queries' stamp: ''!
transitionDayOfWeekInYear: year
	^(DateFactory year: year day: transitionDayOfYear) dayOfWeek! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'accessing' stamp: ''!
transitionDayOfYear
	^transitionDayOfYear! !

!UntilAnnualDayOfYearTimeZoneTransition methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
transitionOccursOnOrAfterYear: year dayOfYear: dayOfYearOrdinal relativity: parameterRelativity secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction

	| offsetSecondsFromUT deltaSeconds transitionSeconds dayDelta secondsSinceStartOfDay |
	relativity == parameterRelativity 
		ifTrue: 
			[dayOfYearOrdinal > transitionDayOfYear ifTrue: [^true].
			dayOfYearOrdinal < transitionDayOfYear ifTrue: [^false].
			offsetSecondsFromUT := boundTZ offsetSecondsFromUT.
			transitionSeconds := transitionSecondsSinceStartOfDay.
			secondsSinceStartOfDay := secondsSinceStartOfDayFunction value: offsetSecondsFromUT.
			secondsSinceStartOfDay < 0
				ifTrue: [secondsSinceStartOfDay := SecondsPerDay + secondsSinceStartOfDay]
				ifFalse: 
					[secondsSinceStartOfDay > SecondsPerDay 
						ifTrue: [secondsSinceStartOfDay := SecondsPerDay - secondsSinceStartOfDay]]]
		ifFalse: 
			[dayDelta := dayOfYearOrdinal - transitionDayOfYear.
			dayDelta < -1 ifTrue: [^false].
			dayDelta > 1 ifTrue: [^true].
			offsetSecondsFromUT := boundTZ offsetSecondsFromUT.
			relativity == #nominal
				ifTrue: 
					["parameterRelativity == #universal"
					deltaSeconds := offsetSecondsFromUT negated]
				ifFalse: 
					[relativity == #standard
						ifTrue: 
							[parameterRelativity == #nominal
								ifTrue: 
									["parameterRelativity == #nominal"
									deltaSeconds := boundTZ offsetDeltaSeconds]
								ifFalse:
									["parameterRelativity == #universal"
									deltaSeconds := boundTZ stdTimeOffsetSecondsFromUT negated]]
						ifFalse: 
							["parameterRelativity == #nominal"
							deltaSeconds := offsetSecondsFromUT]].
			transitionSeconds := transitionSecondsSinceStartOfDay + deltaSeconds.
			"Assumption: No REGISTERED Timezone (with a well-known key in the Olson TZ database) will have an offsetSecondsFromUT greater than SecondsPerDay."
			transitionSeconds < 0 
				ifTrue: 
					[dayDelta := dayDelta + 1.
					transitionSeconds := transitionSeconds + SecondsPerDay]
				ifFalse: 
					[transitionSeconds >= SecondsPerDay 
						ifTrue: 
							[dayDelta := dayDelta - 1.
							transitionSeconds := transitionSeconds - SecondsPerDay]].
			dayDelta < 0 ifTrue: [^false].
			dayDelta > 0 ifTrue: [^true].
			secondsSinceStartOfDay := secondsSinceStartOfDayFunction value: offsetSecondsFromUT].
	^secondsSinceStartOfDay >= transitionSeconds! !

AnnuallyRecurringTZPolicy subclass: #UntilEndOfYearTimeZoneTransition
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-Policies-Annual'!

!UntilEndOfYearTimeZoneTransition commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

UntilEndOfYearTimeZoneTransition

	Concept:

		An UntilEndOfYearTimeZoneTransition is an AnnuallyRecurringTZPolicy that functions as the last/final ruleform in the rule chain that specifies the offset/abbreviation tuples that apply within the territorial domain of a time zone during every moment of the year. The ruleform represented by an UntilEndOfYearTimeZoneTransition instance expires at the end of every year, and is succeded by the first rule in its rule chain (which may be itself, if it's the only rule in the chain.) 

		See the superclass AnnuallyRecurringTZPolicy for more information.

!

!UntilEndOfYearTimeZoneTransition methodsFor: 'converting' stamp: ''!
asAnnuallyRecurringTZPolicyFactory
	"Answer the AnnuallyRecurringTZPolicyFactory that would serve as a factory to recreate an instance of the receiver's class with the same value as the receiver."

	^UntilEndOfYearTimeZoneTransitionFactory 
		offsetSeconds: self offsetSecondsFromUT
		stdTimeOffsetSeconds: self stdTimeOffsetSecondsFromUT
		commonAbbreviation: self commonAbbreviation! !

!UntilEndOfYearTimeZoneTransition methodsFor: 'comparing' stamp: ''!
compareTo: anUntilEndOfYearAnnualTZPolicy
	"Answer a strictly positive integer if the receiver's transition time is greater than that of the argument; answer 0 if equal; and answer a negative integer if less."

	self == anUntilEndOfYearAnnualTZPolicy ifTrue: [^0].
	^[anUntilEndOfYearAnnualTZPolicy compareToUntilEndOfYearAnnualTZPolicy: self]
		on: MessageNotUnderstood
		do: [:ex |
				(ex receiver == anUntilEndOfYearAnnualTZPolicy and: [ex message selector == #compareToUntilEndOfYearAnnualTZPolicy:])
					ifTrue: [ex return]
					ifFalse: [ex pass]]! !

!UntilEndOfYearTimeZoneTransition methodsFor: 'private-comparing' stamp: ''!
compareToUntilAnnualDateTZPolicy: anUntilAnnualDateTZPolicy
	^-1! !

!UntilEndOfYearTimeZoneTransition methodsFor: 'private-comparing' stamp: ''!
compareToUntilAnnualDayOfYearTZPolicy: anUntilAnnualDayOfYearTZPolicy
	^-1! !

!UntilEndOfYearTimeZoneTransition methodsFor: 'private-comparing' stamp: ''!
compareToUntilEndOfYearAnnualTZPolicy: anUntilEndOfYearAnnualTZPolicy
	^anUntilEndOfYearAnnualTZPolicy binding compareTo: boundTZ! !

!UntilEndOfYearTimeZoneTransition methodsFor: 'queries' stamp: ''!
intraYearPolicyForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in local time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).  Assume the receiver's policy is in effect during the specified year.

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct timezone binding, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UTC for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day in local time (without any need to consider standard versus daylight saving time.)"

	^self! !

!UntilEndOfYearTimeZoneTransition methodsFor: 'queries' stamp: ''!
intraYearPolicyForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in Universal Time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).  Assume the receiver's policy is in effect during the specified year.

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct timezone binding, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UT for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day as UT (without any need to consider standard versus daylight saving time.)"

	^self! !

!UntilEndOfYearTimeZoneTransition methodsFor: 'printing' stamp: ''!
printTranstionRuleOn: stream
	stream nextPutAll: 'end-of-year'.! !

!UntilEndOfYearTimeZoneTransition methodsFor: 'queries' stamp: ''!
transitionDateAndTimeInYear: year 
	^DateAndTimeFactory 
		year: year
		month: 12
		day: 31
		timeZone: self offsetFromUT asTimezone! !

TemporalRule subclass: #EffectiveYearTemporalRule
	instanceVariableNames: 'rightLink effectiveYear'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Foundation'!

!EffectiveYearTemporalRule commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

EffectiveYearTemporalRule

	Concept:

		EffectiveYearTemporalRule is an abstract subclass of TemporalRule.  An instance of a concrete subclass of EffectiveYearTemporalRule serves as a TemporalRule (which see) where transitions from one version of the rule to another may happen at the start of any year.

	Usage:

		See the individual method comments.

	Implementation:
		
		EffectiveYearTemporalRule implements the rule chain so that the first link in the chain is the most recent rule, and a rule's nextLink refers to its predecessor rule. Subclasses may invert the semantics.

		Instance Variables
		
			rightLink			<EffectiveYearTemporalRule>	
									The next EffectiveYearTemporalRule in the instance's rightward "rule chain" 
									(the rigthward linked list of versions of the "same" rule in effect during different, 
									non-overlapping periods of time.) EffectiveYearTemporalRule interprets
									the <rightLink> as a reference to a predecessor rule that was previously
									in effect. A subclass may define the <rightLink> to be either the 
									predecessor or the successor rule (a decision that must apply to all
									instances of the same class.)
			effectiveYear	<Integer> 						
									The version of the rule represented by the instance came into effect
									at the start of the year <effectiveYear>.

	Subclassing:

		In order to invert the temporal ordering of the "rule chain," subclasses may want to subimplement the instance methods #sortOperator and #compareEffectiveYearTo:. Subclasses are responsibile for defining and implementing the semantics of the ruleforms.!

EffectiveYearTemporalRule subclass: #AbstractSemanticAnnualDateRule
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Semantic Dates'!

!AbstractSemanticAnnualDateRule methodsFor: 'comparing' stamp: ''!
= otherTemporalRule 
	"Answer whether the receiver is equal to the argument."

	self == otherTemporalRule ifTrue: [^true].
	^self comparisonClassIdentifier 
		= otherTemporalRule comparisonClassIdentifier and: 
				[(self compareTo: otherTemporalRule) = 0 and: [key == otherTemporalRule key]]! !

!AbstractSemanticAnnualDateRule methodsFor: 'accessing' stamp: ''!
calendar
	^self subclassResponsibility! !

!AbstractSemanticAnnualDateRule methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream nextPut: key! !

!AbstractSemanticAnnualDateRule methodsFor: 'comparing' stamp: ''!
hash
	^key hash! !

!AbstractSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self setKey: (literalArray at: 4).
	super initializeFromLiteralArray: literalArray.! !

!AbstractSemanticAnnualDateRule methodsFor: 'testing' stamp: ''!
isDerived
	^false! !

!AbstractSemanticAnnualDateRule methodsFor: 'accessing' stamp: ''!
key
	^key! !

!AbstractSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
nominalDateInYear: aYear
	^self subclassResponsibility! !

!AbstractSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
nominallyOccursOn: aDate 
	^self subclassResponsibility! !

!AbstractSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
observanceDateAndTypeInYear: aYear into: block2 ifNone: ifNoneBlock
	^self subclassResponsibility! !

!AbstractSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
observanceTypeFor: aDate 
	^self subclassResponsibility! !

!AbstractSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
occursInYear: aYear
	^self subclassResponsibility! !

!AbstractSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
occursOn: aDate 
	^self subclassResponsibility! !

!AbstractSemanticAnnualDateRule methodsFor: 'printing' stamp: ''!
printOn: aStream
        "Append to the argument aStream a sequence of characters
        that describes the receiver."

	super printOn: aStream.
	aStream
		nextPut: $(;
		print: key;
		nextPut: $)! !

!AbstractSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
setKey: aSymbol
	self assertMutability.
	key := aSymbol! !

!AbstractSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
setRightLink: aSemnaticAnnualDateRule
	"Set <aSemnaticAnnualDateRule> as the next rule `to the right` in the receiver's chain of  SemnaticAnnualDateRules."

	aSemnaticAnnualDateRule == nil 
		ifFalse: 
			[key == aSemnaticAnnualDateRule key 
				ifFalse: [self signalError: 'All the rules in a SemanticAnnualDateRule rule chain must have the same key']].
	super setRightLink: aSemnaticAnnualDateRule! !

AbstractSemanticAnnualDateRule subclass: #DerivedSemanticAnnualDateRule
	instanceVariableNames: 'baseRule derivationIsNominal dateTransformer'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Semantic Dates'!

!DerivedSemanticAnnualDateRule class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey effectiveYear: effectiveYear dayAfterNominalDayOf: aBaseRule 
	^self 
		semanticKey: semanticKey
		effectiveYear: effectiveYear
		derivedFromNominalDateOf: aBaseRule
		dateTransformer: (SimpleDateTransformer delta: 1 days)! !

!DerivedSemanticAnnualDateRule class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey effectiveYear: effectiveYear dayAfterObservedDayOf: aBaseRule 
	^self 
		semanticKey: semanticKey
		effectiveYear: effectiveYear
		derivedFromObservedDateOf: aBaseRule
		dateTransformer: (SimpleDateTransformer delta: 1 days)! !

!DerivedSemanticAnnualDateRule class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey effectiveYear: effectiveYear dayBeforeNominalDayOf: aBaseRule 
	^(self new)
		setKey: semanticKey;
		setEffectiveYear: effectiveYear;
		setBaseRule: aBaseRule! !

!DerivedSemanticAnnualDateRule class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey effectiveYear: effectiveYear dayBeforeObservedDateOf: aBaseRule 
	^(self basicNew)
		setKey: semanticKey;
		setEffectiveYear: effectiveYear;
		setBaseRule: aBaseRule;
		setDerivationAsFromObservedDateOfBaseRule! !

!DerivedSemanticAnnualDateRule class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey effectiveYear: effectiveYear derivedFromNominalDateOf: aBaseRule dateTransformer: aDateTransformer
	^(self basicNew)
		setKey: semanticKey;
		setEffectiveYear: effectiveYear;
		setBaseRule: aBaseRule;
		setDateTransformer: aDateTransformer;
		setDerivationAsFromNominalDateOfBaseRule! !

!DerivedSemanticAnnualDateRule class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey effectiveYear: effectiveYear derivedFromObservedDateOf: aBaseRule dateTransformer: aDateTransformer
	^(self basicNew)
		setKey: semanticKey;
		setEffectiveYear: effectiveYear;
		setBaseRule: aBaseRule;
		setDateTransformer: aDateTransformer;
		setDerivationAsFromObservedDateOfBaseRule! !

!DerivedSemanticAnnualDateRule methodsFor: 'accessing' stamp: ''!
baseRule
	^baseRule! !

!DerivedSemanticAnnualDateRule methodsFor: 'accessing' stamp: ''!
calendar
	^baseRule calendar! !

!DerivedSemanticAnnualDateRule methodsFor: 'accessing' stamp: ''!
dateTransformer
	^dateTransformer! !

!DerivedSemanticAnnualDateRule methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream 
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream
		nextPut: baseRule literalArrayEncoding;
		nextPut: (derivationIsNominal ifTrue: [#setDerivationAsFromNominalDateOfBaseRule] ifFalse: [#setDerivationAsFromObservedDateOfBaseRule]);
		nextPut: self dateTransformer literalArrayEncoding! !

!DerivedSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	self setDerivationAsFromNominalDateOfBaseRule.
	self setDateTransformer: (SimpleDateTransformer delta: (CalendarDuration days: -1))! !

!DerivedSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	| selector |
	super initializeFromLiteralArray: literalArray.
	selector := (literalArray at: 6) asSymbol.
	self perform: selector.
	self 
		setBaseRule: (literalArray at: 5) decodeAsLiteralArray;
		setDateTransformer: (literalArray at: 7) decodeAsLiteralArray! !

!DerivedSemanticAnnualDateRule methodsFor: 'testing' stamp: ''!
isDerivationFromNominalDateOfBaseRule
	^derivationIsNominal! !

!DerivedSemanticAnnualDateRule methodsFor: 'testing' stamp: ''!
isDerived
	^true! !

!DerivedSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
nominalDateInYear: aYear
	^dateTransformer applyTo: (baseRule nominalDateInYear: aYear)! !

!DerivedSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
nominallyOccursOn: aDate 
	^baseRule nominallyOccursOn: (dateTransformer inverseApplyTo: aDate)! !

!DerivedSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
observanceDateAndTypeInYear: aYear into: block2 ifNone: ifNoneBlock 
	^derivationIsNominal 
		ifTrue: [block2 value: (self nominalDateInYear: aYear) value: #nominal]
		ifFalse: 
			[baseRule 
				observanceDateAndTypeInYear: aYear
				into: 
					[:baseObservedDate :observanceType | 
					| observedDate |
					observedDate := dateTransformer applyTo: baseObservedDate.
					observedDate year = aYear 
						ifTrue: [block2 value: observedDate value: observanceType]
						ifFalse: [ifNoneBlock value]]
				ifNone: [ifNoneBlock value]]! !

!DerivedSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
observanceTypeFor: aDate 
	^derivationIsNominal 
		ifTrue: 
			[| observanceType |
			observanceType := baseRule observanceTypeFor: (dateTransformer inverseApplyTo: aDate).
			observanceType == #observed ifTrue:[#none] ifFalse: [observanceType]]
		ifFalse: [baseRule observanceTypeFor: (dateTransformer inverseApplyTo: aDate)]! !

!DerivedSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
occursInYear: aYear
	^baseRule occursInYear: aYear! !

!DerivedSemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
occursOn: aDate 
	^derivationIsNominal
		ifTrue: [baseRule nominallyOccursOn: (dateTransformer inverseApplyTo: aDate)]
		ifFalse: [baseRule occursOn: (dateTransformer inverseApplyTo: aDate)]! !

!DerivedSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
setBaseRule: aSemanticAnnualDateRule
	"Set the receiver's base SemanticAnnualDateRule."

	self assertMutability.
	baseRule := aSemanticAnnualDateRule! !

!DerivedSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
setDateTransformer: aDateTransformer

	self assertMutability.
	dateTransformer := aDateTransformer! !

!DerivedSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
setDerivationAsFromNominalDateOfBaseRule
	self assertMutability.
	derivationIsNominal := true.! !

!DerivedSemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
setDerivationAsFromObservedDateOfBaseRule
	self assertMutability.
	derivationIsNominal := false.! !

AbstractSemanticAnnualDateRule subclass: #SemanticAnnualDateRule
	instanceVariableNames: 'observanceRule nominalAnnualDate'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Semantic Dates'!

!SemanticAnnualDateRule commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!SemanticAnnualDateRule class methodsFor: 'instance creation' stamp: ''!
semanticKey: semanticKey effectiveYear: effectiveYear nominalAnnualDate: annualDate observanceRule: observanceRule
	^self new
		setKey: semanticKey;
		setEffectiveYear: effectiveYear;
		setNominalAnnualDate: annualDate;
		setObservanceRule: observanceRule! !

!SemanticAnnualDateRule methodsFor: 'accessing' stamp: ''!
calendar
	^nominalAnnualDate calendar! !

!SemanticAnnualDateRule methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: observanceRule literalArrayEncoding;
		nextPut: nominalAnnualDate literalArrayEncoding! !

!SemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self 
		setObservanceRule: (literalArray at: 5) decodeAsLiteralArray;
		setNominalAnnualDate: (literalArray at: 7) decodeAsLiteralArray.
	super initializeFromLiteralArray: literalArray.! !

!SemanticAnnualDateRule methodsFor: 'accessing' stamp: ''!
nominalAnnualDate
	^nominalAnnualDate! !

!SemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
nominalDateInYear: aYear
	^nominalAnnualDate inYear: aYear! !

!SemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
nominallyOccursOn: aDate 
	^nominalAnnualDate = aDate! !

!SemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
observanceDateAndTypeInYear: aYear into: block2 ifNone: ifNoneBlock
	^observanceRule == nil
		ifTrue: [block2 value: (self nominalDateInYear: aYear) value: #nominal]
		ifFalse: [observanceRule observanceDateAndTypeOf: nominalAnnualDate inYear: aYear into: block2 ifNone: ifNoneBlock]! !

!SemanticAnnualDateRule methodsFor: 'accessing' stamp: ''!
observanceRule
	^observanceRule! !

!SemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
observanceTypeFor: aDate 
	^observanceRule == nil
		ifTrue: [(self nominallyOccursOn: aDate) ifTrue: [#nominal] ifFalse: [#none]]
		ifFalse: [observanceRule eventObservanceTypeNominallyOccuringOn: nominalAnnualDate for: aDate]! !

!SemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
occursInYear: aYear
	"Answer whether the semantic date represented by the receiver nominally occurs in <aYear>."

	^observanceRule == nil or: [observanceRule doesEventNominallyOccurInYear: aYear]! !

!SemanticAnnualDateRule methodsFor: 'queries' stamp: ''!
occursOn: aDate 
	^observanceRule == nil
		ifTrue: [self nominallyOccursOn: aDate]
		ifFalse: [#(nominal observed) includes: (observanceRule eventObservanceTypeNominallyOccuringOn: nominalAnnualDate for: aDate)]! !

!SemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
setNominalAnnualDate: anAnnualDate
	self assertMutability.
	nominalAnnualDate := anAnnualDate! !

!SemanticAnnualDateRule methodsFor: 'initialize-release' stamp: ''!
setObservanceRule: anObservanceRule 
	self assertMutability.
	observanceRule := anObservanceRule.! !

!EffectiveYearTemporalRule methodsFor: 'comparing' stamp: ''!
compareEffectiveYearTo: aYear
	"Answer a strictly positive integer if the receiver's effectiveYear is greater than the argument; answer 0 if equal; and answer a negative integer if less."

	effectiveYear = aYear ifTrue: [^0].
	^effectiveYear == nil 
		ifTrue: [-1]
		ifFalse: 
			[aYear == nil 
				ifTrue: [1]
				ifFalse: [effectiveYear - aYear]]! !

!EffectiveYearTemporalRule methodsFor: 'comparing' stamp: ''!
compareTo: aTemporalRule
	"Answer a strictly positive integer if the receiver's transition time is greater than that of the argument; answer 0 if equal; and answer a negative integer if less."

	^self compareEffectiveYearTo: aTemporalRule effectiveYear! !

!EffectiveYearTemporalRule methodsFor: 'queries' stamp: ''!
effectiveRuleInYear: aYear ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective in <aYear>.  If none, answer the result of evaluating <ifNone>."

	^(self compareEffectiveYearTo: aYear) > 0 
		ifTrue: 
			[(self rightLinkIfNone: [^ifNone value]) 
				searchRightwardForEffectiveRuleInYear: aYear
				ifNone: ifNone]
		ifFalse: 
			[(self leftLinkIfNone: [^self]) 
				searchLeftwardForEffectiveRuleInYear: aYear
				ifNone: [self]]! !

!EffectiveYearTemporalRule methodsFor: 'accessing' stamp: ''!
effectiveYear
	"Answer the year in which the rule represented by the receiver comes into in effect."

	^effectiveYear! !

!EffectiveYearTemporalRule methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: rightLink literalArrayEncoding;
		nextPut: effectiveYear! !

!EffectiveYearTemporalRule methodsFor: 'testing' stamp: ''!
hasRightwardLink
	"Answer whether there is anonther rule after the receiver in the receiver's rightward rule chain."

	^rightLink notNil! !

!EffectiveYearTemporalRule methodsFor: 'comparing' stamp: ''!
hash
	^effectiveYear hash! !

!EffectiveYearTemporalRule methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	self 
		setRightLink: (literalArray at: 2) decodeAsLiteralArray	;
		setEffectiveYear: (literalArray at: 3)! !

!EffectiveYearTemporalRule methodsFor: 'testing' stamp: ''!
isAlwaysInEffect
	"Answer whether thre rule represented by the receiver is always in effect."

	^self isAtom and: [effectiveYear == nil]! !

!EffectiveYearTemporalRule methodsFor: 'accessing' stamp: ''!
rightLink
	"Answer the next rule `to the right` in the receiver's rule chain, if there is one.  If there is not, answer nil."

	^rightLink! !

!EffectiveYearTemporalRule methodsFor: 'accessing' stamp: ''!
rightLinkIfNone: block0
	"Answer the next rule `to the right` in the receiver's rule chain, if there is one.  If there is not, answer the result of evaluating <block0>."

	^rightLink == nil
		ifTrue: [block0 value]
		ifFalse: [rightLink]! !

!EffectiveYearTemporalRule methodsFor: 'queries' stamp: ''!
searchLeftwardForEffectiveRuleInYear: aYear ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective in <aYear>--but searching only leftward.  If none, answer the result of evaluating <ifNone>."

	| diff |
	diff := self compareEffectiveYearTo: aYear.
	^diff > 0 
		ifTrue: [ifNone value]
		ifFalse: 
			[diff = 0 ifTrue: [^self].
			(self leftLinkIfNone: [^self]) 
				searchLeftwardForEffectiveRuleInYear: aYear
				ifNone: [self]]! !

!EffectiveYearTemporalRule methodsFor: 'queries' stamp: ''!
searchRightwardForEffectiveRuleInYear: aYear ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective in <aYear>--but searching only rightward.  If none, answer the result of evaluating <ifNone>."

	^(self compareEffectiveYearTo: aYear) <= 0 
		ifTrue: [self]
		ifFalse: 
			[(self rightLinkIfNone: [^ifNone value]) 
				searchRightwardForEffectiveRuleInYear: aYear
				ifNone: ifNone]! !

!EffectiveYearTemporalRule methodsFor: 'initialize-release' stamp: ''!
setEffectiveYear: aYear
	self assertMutability.
	effectiveYear := aYear! !

!EffectiveYearTemporalRule methodsFor: 'initialize-release' stamp: ''!
setRightLink: aTemporalRule
	"Set <aTemporalRule> as the next rule `to the right` in the receiver's chain of  TemporalRules."

	self assertMutability.
	rightLink := aTemporalRule.
	super setRightLink: aTemporalRule.! !

!EffectiveYearTemporalRule methodsFor: 'enumerating' stamp: ''!
withRightLinkDo: block1
	"Evaluatue <block1> with the next rightward link in the receiver's rule chain as the argument.  If there is no such link, do nothing."

	^rightLink == nil ifFalse: [block1 value: rightLink]! !

EffectiveYearTemporalRule subclass: #TimeZonePolicy
	instanceVariableNames: 'effectiveYearCalendar effectiveYearRelativity registrationKey defaultName geographicCoordinates leftLink annualPolicy rootTZ'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-Policies-Diachronic'!

!TimeZonePolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

TimeZonePolicy

	Concept:

		A TimeZonePolicy represents the full diachronic ruleset of a time zone, from the inifinite past up until the moment it is superceded by a more recent ruleform. It's purpose is to enable the binding of a point-in-time value to a particular time zone abbreviation and offset from UT (in the form of a "bound, dynamic" time zone instance.) 

		A TimeZonePolicy uses the behavior inherited from EffectiveYearTemporalRule to implement a `rule chain` of ruleforms, where each ruleform in the chain defines a time zone's abbreviation and offset from UT for each moment in time since the start of the effective year of the ruleform until it is superceded by a succcessor ruleform.  The predecessor link in the chain of ruleforms specifies the time zone rules that were in effect prior to the rules specified by the successor.  Each ruleform in the chain of ruleforms specifies only its effective year, it does not specify the year it is superceded by a successor ruleform.

		The ruleform specified by a TimeZonePolicy instance may specify that a time zone has a single abbrevation and a single offset from UT, without any variation, throughout the period of time during which it is in effect, or else it may specify that the abbreviation and/or the offset from UT transition to new values during its effective period.  Transitions to new offset and/or abbreviation values are specified to occur as of an annually recurring date and time (e.g., every year on April 15 at noon local time, every year on the last Sunday in November at 1 am Universal Time.)

		In rare cases, it is necessary to use the subclass AsymmetricTimeZonePolicy instead of using TimeZonePolicy.  Such is required whenever a time zone transitions to a new offset and/or abbreviation on either the first or the last day of the year.

	Usage:

		To create a new instance that represents a single ruleform (a "rule chain" with only one element/ruleform), send the class message #effectiveYear:annualPolicy: to TimeZonePolicy.  See the method comment for details. See the documentation in the superclasses TemporalRule and EffectiveYearTemporalRule for information about constructing a chain of ruleforms from individual elements. Hint: See the inherited instance method #asListSortedInCanonicalOrderByTransitionTimeAdding:.

		To create a new "rule chain" that represents a full diachronic time zone ruleset, deserialized from the time zone ruleset specification persistently stored in the external Chronos time-zones repository, send the class message #for:ifNone: to TimeZonePolicy.  See the method comment for details.  

		For a variety of reasons, it is highly recommended that the Chronos TimeZonePolicy factory objects be used to create TimeZonePolicy rule chains.  The Chronos TimeZonePolicy factory objects are instances of TimeZonePolicySequenceFactory, TimeZonePolicyElementFactory and the concrete subclasses of AnnuallyRecurringTZPolicyFactory. See TimeZonePolicySequenceFactory for more information.

	Implementation:

		Instances of TimeZonePolicy themselves directly implement the rule chain. Each instance specifies the effective year of the ruleform it represents.  All other  properties and behaviors of the ruleforms themselves are specified and provided by instances of (concrete subclasses of) AnnuallyRecurringTZPolicy.

		Instance Variables {Also see superclass}

			leftLink 			<TimeZonePolicy | nil>	The TimeZonePolicy whose annual policy will be in effect after the instance's <annualPolicy> expires.
			annualPolicy	<AnnuallyRecurringTZPolicy> 
				The <annualPolicy> specifies the annually-recurring intra-year rules of the instance's ruleform. The <annualPolicy> defines, for each moment in time since the start of the effective year of the instance, until the instance is superceded by a later ruleform, the abbreviation and offset from UT of the time zone whose ruleset is (partially or fully) represented by the instance. The <effectiveYear> instance variable inherited by a TimeZonePolicy specifies the first year its ruleform is in effect, and consequently the first year its predecessor ruleform is no longer in effect. The <effectiveYear> is specified in the local ("wall clock") time defined by the time zone whose ruleset is represented by the instance.  The ruleform specified by the instance goes into effect as of the initial moment of its <effectiveYear> (and expires as of the last moment--local time--of the year prior to the <effectiveYear> of its successor in the rule chain, if any.)

!

TimeZonePolicy subclass: #AsymmetricTimeZonePolicy
	instanceVariableNames: 'utEffectiveYear utEffectiveDayOfYear utEffectiveSecondsSinceStartOfDay'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-Policies-Diachronic'!

!AsymmetricTimeZonePolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

AsymmetricTimeZonePolicy

	Concept:

		An AsymmetricTimeZonePolicy is a TimeZonePolicy specialized for handling the rare cases where a time zone transitions to a new offset and/or abbreviation on either the first or the last day of the year.  A correctly-initialized AsymmetricTimeZonePolicy can be used in place of any instance of TimeZonePolicy regardless of the transitions it specifies, but that is only necessary when the ruleform to be represnted by a TimeZonePolicy (referring to the type, not to the class in this case) specifies an offset/abbreviation transition on the first day of the year, or when the predecessor ruleform specifies an offset/abbreviation transition on the last day of the year--and even then, it's only necessary when the "transition" actually results in a different offset-abbreviation tuple (there are cases in the Olson rules where such "no-op" transitions are specified.)

		The Chronos TimeZonePolicy factory objects (see the comment in the superclass) automatically create an instance AsymmetricTimeZonePolicy whenever necessary--which is one reason that it is strongly recommended that the factory objects should be used to create TimeZonePolicy rule chains .

	Implementation:

		Instance Variables

			utEffectiveYear 							<Integer>	The instance's <effectiveYear> (see superclasses) in Universal Time.
			utEffectiveDayOfYear 					<Integer>	The oridinal (first = 1) day of year (in Universal Time) the instance's ruleform takes effect.
			utEffectiveSecondsSinceStartOfDay		<Integer> 	The seconds-since-start-day (0..86400, in Universal Time) at which the instance's ruleform takes effect.

!

!AsymmetricTimeZonePolicy methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	| ymd |
	super canonicalize.
	utEffectiveSecondsSinceStartOfDay := (Gregorian secondsSinceEpochUpToYear: self effectiveYear) - annualPolicy offsetSecondsFromUT.
	utEffectiveDayOfYear := utEffectiveSecondsSinceStartOfDay // SecondsPerDay.
	utEffectiveSecondsSinceStartOfDay :=  utEffectiveSecondsSinceStartOfDay \\ SecondsPerDay.
	ymd := Gregorian dateSpecFromDaysSinceEpoch: utEffectiveDayOfYear.
	utEffectiveDayOfYear := ymd dayOfYearOrdinal.
	utEffectiveYear := ymd year.! !

!AsymmetricTimeZonePolicy methodsFor: 'comparing' stamp: ''!
compareUTEffectiveTimeToYear: aYear dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
	"Answer a strictly positive integer if the receiver's effectiveYear is greater than the argument; answer 0 if equal; and answer a negative integer if less."

	| diff |
	diff := utEffectiveYear - aYear.
	diff = 0 ifFalse: [^diff].
	diff := utEffectiveDayOfYear - dayOfYear.
	diff = 0 ifFalse: [^diff].
	^utEffectiveSecondsSinceStartOfDay - (secondsSinceStartOfDayFunction value: annualPolicy offsetSecondsFromUT)! !

!AsymmetricTimeZonePolicy methodsFor: 'accessing' stamp: ''!
defaultName
	^defaultName! !

!AsymmetricTimeZonePolicy methodsFor: 'queries' stamp: ''!
effectiveRuleInUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective as of the specified (in Universal Time) <year>, <dayOfYear> and seconds-since-start-day (where the seconds-since-start-day is computed by sending the message #value: to <secondsSinceStartOfDayFunction>). The <secondsSinceStartOfDayFunction> will, if the value it computes is needed, be invoked with a single argument that represents the number of seconds of offset from UT that should be used to convert local time to UT. If no rule is found that satisfies the search criteria, answer the result of evaluating <ifNone>."

	^(self compareUTEffectiveTimeToYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction) > 0 
		ifTrue: 
			[(self rightLinkIfNone: [^ifNone value]) 
				searchBackwardForEffectiveRuleInUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
				ifNone: ifNone]
		ifFalse: 
			[(self leftLinkIfNone: [^self]) 
				searchForwardForEffectiveRuleInUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
				ifNone: [self]]! !

!AsymmetricTimeZonePolicy methodsFor: 'testing' stamp: ''!
isSymmetric
	"Aswer true if the receiver is an instance of AsymmetricTimeZonePolicy, false otherwise.  See the class comment of AsymmetricTimeZonePolicy for an explanation of the difference."

	^false! !

!AsymmetricTimeZonePolicy methodsFor: 'queries' stamp: ''!
searchBackwardForEffectiveRuleInUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective as of the specified (in Universal Time) <year>, <dayOfYear> and seconds-since-start-day (where the seconds-since-start-day is computed by sending the message #value: to <secondsSinceStartOfDayFunction>).  Assume that the receiver's <annualPolicy> is currently in effect (don't check whether or not it may have expired.)

	The <secondsSinceStartOfDayFunction> will, if the value it computes is needed, be invoked with a single argument that represents the number of seconds of offset from UT that should be used to convert local time to UT. If no rule is found that satisfies the search criteria, answer the result of evaluating <ifNone>."

	^(self compareUTEffectiveTimeToYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction) <= 0 
		ifTrue: [self]
		ifFalse: 
			[(self rightLinkIfNone: [^ifNone value]) 
				searchBackwardForEffectiveRuleInUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
				ifNone: ifNone]! !

!AsymmetricTimeZonePolicy methodsFor: 'queries' stamp: ''!
searchForwardForEffectiveRuleInUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective as of the specified (in Universal Time) <year>, <dayOfYear> and seconds-since-start-day (where the seconds-since-start-day is computed by sending the message #value: to <secondsSinceStartOfDayFunction>).  Assume that the receiver's <annualPolicy> has always been in effect since the infinite past (don't check for previous annual time zone policies.)

	The <secondsSinceStartOfDayFunction> will, if the value it computes is needed, be invoked with a single argument that represents the number of seconds of offset from UT that should be used to convert local time to UT. If no rule is found that satisfies the search criteria, answer the result of evaluating <ifNone>."

	| diff |
	diff := self compareUTEffectiveTimeToYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction.
	^diff > 0 
		ifTrue: [ifNone value]
		ifFalse: 
			[diff = 0 ifTrue: [^self].
			(self leftLinkIfNone: [^self]) 
				searchForwardForEffectiveRuleInUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
				ifNone: [self]]! !

!AsymmetricTimeZonePolicy methodsFor: 'accessing' stamp: ''!
utEffectiveDayOfYear
	^utEffectiveDayOfYear! !

!AsymmetricTimeZonePolicy methodsFor: 'accessing' stamp: ''!
utEffectiveSecondsSinceStartOfDay
	^utEffectiveSecondsSinceStartOfDay! !

!AsymmetricTimeZonePolicy methodsFor: 'accessing' stamp: ''!
utEffectiveYear
	^utEffectiveYear! !

!TimeZonePolicy class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self shouldNotImplement! !

!TimeZonePolicy class methodsFor: 'instance creation' stamp: ''!
for: anUnboundDynamicTimeZone ifNone: ifNoneBlock
	"Create and answer a new TimeZonePolicy that encapsulates a fully-populated `rule chain` representing the full diachronic time zone ruleset for the `unbound, dynamic` time zone <anUnboundDynamicTimeZone>, deserialized from the time zone ruleset specification persistently stored in the external Chronos time-zones repository. If there is no such ruleset defined in the Chropnos time-zones repository, answer the result of evaluating the 0-argument block <ifNoneBlock>."

	^(TimeZonePolicyFactory at: anUnboundDynamicTimeZone key ifAbsent: [^ifNoneBlock value]) 
		asPolicyFor: anUnboundDynamicTimeZone! !

!TimeZonePolicy class methodsFor: 'instance creation' stamp: ''!
newFor: unboundDynamicTimeZone 
	"Create and answer a new TimeZonePolicy, representing a single ruleform (a `rule chain` with only one element,) with the specified  <unboundDynamicTimeZone> as the instance's root timezone."

	^self new setRootTZ: unboundDynamicTimeZone! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
aliasingKeys
	^TimeZonePolicyFactory aliasingKeysOf: self registrationKey! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
annualPolicy
	"Answer the receiver's AnnuallyRecurringTZPolicy."

	^annualPolicy! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
annualPolicyForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in local time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct annual policy, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UTC for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day in local time (without any need to consider standard versus daylight saving time.)"

	^(self effectiveRuleInYear: year ifNone: [self]) 
		annualPolicy 
			intraYearPolicyForLocalYear: year
			dayOfYear: dayOfYear
			secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
annualPolicyForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in Universal Time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT).

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct annual policy, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UT for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day as UT (without any need to consider standard versus daylight saving time.)"

	^(self effectiveRuleInUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction ifNone: [self]) 
		annualPolicy
			intraYearPolicyForUTYear: year
			dayOfYear: dayOfYear
			secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!TimeZonePolicy methodsFor: 'converting' stamp: ''!
asAnnualTransitionPolicyFactory
	"Answer the TimeZoneAnnualTransitionPolicyFactory that would serve as a factory to recreate a single instance of the receiver's class with the same value as the receiver (ignoring any predecessors.)"

	| factory |
	factory := 
		(TimeZoneAnnualTransitionPolicyFactory new)
			setEffectiveYear: self effectiveYear;
			setEffectiveYearCalendarKey: self effectiveYearCalendarKey;
			setEffectiveYearRelativity: effectiveYearRelativity;
			setAnnuallyRecurringTransitions: self annualPolicy asAnnuallyRecurringTZPolicyFactoryArray.
	self isSymmetric ifFalse: [factory setAsNonSymmetric].
	^factory! !

!TimeZonePolicy methodsFor: 'converting' stamp: ''!
asChronosValue
	"Answer the translation of the receiver into an object that is an instance of whichever class in the Chronos Date/Time Library would be most appropriate for the instantiation of an object equal and/or analogous to the receiver ."

	^self! !

!TimeZonePolicy methodsFor: 'converting' stamp: ''!
asNonProxy
	"Answer the time zone to which the receiver indirectly refers by proxy.  If the receiver is not a proxy for a time zone other than itself, answer the receiver."

	^self! !

!TimeZonePolicy methodsFor: 'converting' stamp: ''!
asPolicyFactory
	"Answer the TimeZonePolicyFactory that would serve as a factory to recreate an instance of the receiver's class with the same value as the receiver."

	| elementFactoryStream |
	elementFactoryStream := Array new writeStream.
	self withSelfAndAllRightwardLinksDo: [:policy | elementFactoryStream nextPut: policy asAnnualTransitionPolicyFactory].
	^TimeZonePolicyFactory 
		key: self key
		defaultName: self defaultName
 		geographicCoordinates: self geographicCoordinates
		annualTransitionPolicyArray: elementFactoryStream contents! !

!TimeZonePolicy methodsFor: 'converting' stamp: ''!
asTimezone
	"Answer the conversion of the receiver into a time zone it either references or describes. If the receiver is itself a time zone, answer the receiver."

	^rootTZ! !

!TimeZonePolicy methodsFor: 'converting' stamp: ''!
asUnbound
	"Answer the unbound time zone that specifies the full diachronic ruleset of the time zone represented by the receiver."

	^self! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
bindingForLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in the local time defined by the receiver.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in local (`wall clock`) time as defined by the receiver."

	^(self
		annualPolicyForLocalYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction) binding! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
bindingForUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"Answer the bound time zone whose offset/abbreviation tuple is correct for the specified <year> and <dayOfYear> ordinal (both in Universal Time.)  If the seconds-since-start-of-day value is needed to resolve the bound timezone, the <secondsSinceStartOfDayFunction> block will be invoked with a single argument whose value is an offset from UT in seconds.  When invoked, the block must answer the number of seconds since start-of-day, using the <offsetSecondsFromUT> passed in as the argument to the block to convert to/from UT if necessary. The answered seconds-since-start-of-day should be in Universal Time."

	^(self
		annualPolicyForUTYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction) binding! !

!TimeZonePolicy methodsFor: 'converting' stamp: ''!
canonical
	"Answer the canonical instance of the receiver's root time zone."

	^self root canonical! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	super canonicalize.
	annualPolicy beImmutable! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
defaultAnnualPolicy
	"Answer the AnnuallyRecurringTZPolicy that specifies the time zone rules that are in effect during the current year."

	^rootTZ defaultAnnualPolicy! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
defaultName
	^defaultName! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
effectiveRuleInUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective as of the specified (in Universal Time) <year>, <dayOfYear> and seconds-since-start-day (where the seconds-since-start-day is computed by sending the message #value: to <secondsSinceStartOfDayFunction>). The <secondsSinceStartOfDayFunction> will, if the value it computes is needed, be invoked with a single argument that represents the number of seconds of offset from UT that should be used to convert local time to UT. If no rule is found that satisfies the search criteria, answer the result of evaluating <ifNone>."

	^(self compareEffectiveYearTo: year) > 0 
		ifTrue: 
			[(self rightLinkIfNone: [^ifNone value]) 
				searchBackwardForEffectiveRuleInUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
				ifNone: ifNone]
		ifFalse: 
			[(self leftLinkIfNone: [^self]) 
				searchForwardForEffectiveRuleInUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
				ifNone: [self]]! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
effectiveYearCalendar
	^effectiveYearCalendar == nil ifTrue: [Gregorian] ifFalse: [effectiveYearCalendar]! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
effectiveYearCalendarKey
	^self effectiveYearCalendar registrationKey! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
effectiveYearRelativity
	^effectiveYearRelativity! !

!TimeZonePolicy methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	self shouldNotImplement! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
geographicCoordinates
	^geographicCoordinates! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
hasLeftwardLink
	"Answer whether there is anonther rule after the receiver in the receiver's leftward rule chain."

	^leftLink notNil! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	effectiveYearCalendar := Gregorian.
	effectiveYearRelativity := #nominal.! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self 
		setAnnualPolicy: (literalArray at: 4) decodeAsLiteralArray! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
interYearPolicy
	^self! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isBound
	"Answer whether the receiver is a bound time zone. A bound time zone is one that defines a single offset/abbreviation tuple, and that conforms to the `BOUND TIMEZONE API` (as defined in the class comment of ChronosTimezone.)"

	^false! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isInvariantToNominalTime
	"Answer whether a Timepoint whose time zone is the receiver will exhibit invariance to nominal time."

	^false! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isInvariantToUT
	^true! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isProxy
	^false! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isProxyAndInvariantToUT
	^false! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isProxyOrStatic
	"Answer whether the receiver is either a proxy time zone or a static time zone."

	^false! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isStatic
	"Answer whether or not the timezone policy (key, offset, name and abbreviation) of the timezone represented by the receiver is invariant, constant and never subject to change or revision.  If the receiver's timezone policy is dynamically redefinable, answer false."

	^false! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isSymmetric
	"Aswer true if the receiver is an instance of AsymmetricTimeZonePolicy, false otherwise.  See the class comment of AsymmetricTimeZonePolicy for an explanation of the difference."

	^true! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isTimezone
	^false! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
isUniversalTime
	"Anwser whether the receiver has all the properties and behaviors of the international reference zero-offset time zone."

	^false! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
key
	^rootTZ key! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
leftLink
	^leftLink! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
leftLinkIfNone: block0
	"Answer the next rule `to the left` in the receiver's rule chain, if there is one.  If there is not, answer the result of evaluating <block0>."

	^leftLink == nil
		ifTrue: [block0 value]
		ifFalse: [leftLink]! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
name
	^rootTZ name! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
nameIfNone: noneBlock
	^rootTZ nameIfNone: noneBlock! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
policy
	"Answer the TimeZonePolicy that specifies the ruleset of the time zone represented by the instance.  The ruleset of a time zone specifies for all time values, from the infinite past to the infinite future, the (possibly varying) time zone offsets and abbreviations that apply to points-in-time within the territorial domain of the time zone. Note, however, that the `policy` (time zone ruleset) can be changed retroactively--and this is rather likely to happen for times in the future (but can also happen to times in the past.)"

	^rootTZ policy! !

!TimeZonePolicy methodsFor: 'printing' stamp: ''!
printOn: stream
	stream
		nextPut: ${;
		nextPutAll: self class name.
	self specifiesDefaultName
		ifTrue: [stream cr; tab; tab; tab; nextPutAll: 'defaultName='; nextPutAll: self defaultName].
	stream
		cr; tab; tab; tab; nextPutAll: 'effectiveYear=';
		print: effectiveYear.
	self specifiesGeographicCoordinates 
		ifTrue: [stream tab; nextPutAll: ' geographicCoordinates='; print: self geographicCoordinates].
	stream
		cr; tab; tab; tab; nextPutAll: 'annual policy=';
		cr; tab; tab; tab; tab; print: annualPolicy.
	rightLink == nil 
		ifFalse: 
			[stream
				cr; tab; tab;
				print: rightLink].
	stream nextPut: $}! !

!TimeZonePolicy methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	^self asPolicyFactory processBy: aTimezoneProcessor! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
registrationKey
	^registrationKey! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
release
	super release.
	annualPolicy release.! !

!TimeZonePolicy methodsFor: 'accessing' stamp: ''!
root

	^rootTZ! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
searchBackwardForAnnualPolicyAtLocalYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in local time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT). Assume that the receiver's <annualPolicy> is currently in effect (don't check whether or not it may have expired.)

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct timezone binding, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UTC for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day in local time (without any need to consider standard versus daylight saving time.)"

	^(self searchRightwardForEffectiveRuleInYear: year ifNone: [self]) 
		annualPolicy 
			intraYearPolicyForLocalYear: year
			dayOfYear: dayOfYear
			secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
searchBackwardForAnnualPolicyAtUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction 
	"On the date specified in Universal Time, answer the annually-recurring time zone policy then in effect (i.e, the one whose bound time zone answers the correct value for the specified date in response to the message #offsetFromUT). Assume that the receiver's <annualPolicy> is currently in effect (don't check whether or not it may have expired.)

	If it is necessary for the receiver to also know the time-of-day in order to determine the correct timezone binding, the receiver will invoke the secondsSinceStartOfDayFunction (a BlockClosure) in order to resolve the seconds-since-start-day to be used in determining the timezone binding. If required, the secondsSinceStartOfDayFunction callback will be invoked with a single argument, which will be the offset seconds from UT for local standard time--if necessary, the sender should use this value to compute the answered seconds-since-start-day as UT (without any need to consider standard versus daylight saving time.)"

	^(self 
		searchBackwardForEffectiveRuleInUTYear: year
		dayOfYear: dayOfYear
		secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
		ifNone: [self]) 
			annualPolicy 
				intraYearPolicyForUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
searchBackwardForEffectiveRuleInUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective as of the specified (in Universal Time) <year>, <dayOfYear> and seconds-since-start-day (where the seconds-since-start-day is computed by sending the message #value: to <secondsSinceStartOfDayFunction>).  Assume that the receiver's <annualPolicy> is currently in effect (don't check whether or not it may have expired.)

	The <secondsSinceStartOfDayFunction> will, if the value it computes is needed, be invoked with a single argument that represents the number of seconds of offset from UT that should be used to convert local time to UT. If no rule is found that satisfies the search criteria, answer the result of evaluating <ifNone>."

	^(self compareEffectiveYearTo: year) <= 0 
		ifTrue: [self]
		ifFalse: 
			[(self rightLinkIfNone: [^ifNone value]) 
				searchBackwardForEffectiveRuleInUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
				ifNone: ifNone]! !

!TimeZonePolicy methodsFor: 'queries' stamp: ''!
searchForwardForEffectiveRuleInUTYear: year dayOfYear: dayOfYear secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction ifNone: ifNone 
	"Answer the rule in the receiver's rule chain effective as of the specified (in Universal Time) <year>, <dayOfYear> and seconds-since-start-day (where the seconds-since-start-day is computed by sending the message #value: to <secondsSinceStartOfDayFunction>).  Assume that the receiver's <annualPolicy> has always been in effect since the infinite past (don't check for previous annual time zone policies.)

	The <secondsSinceStartOfDayFunction> will, if the value it computes is needed, be invoked with a single argument that represents the number of seconds of offset from UT that should be used to convert local time to UT. If no rule is found that satisfies the search criteria, answer the result of evaluating <ifNone>."

	| diff |
	diff := self compareEffectiveYearTo: year.
	^diff > 0 
		ifTrue: [ifNone value]
		ifFalse: 
			[diff = 0 ifTrue: [^self].
			(self leftLinkIfNone: [^self]) 
				searchForwardForEffectiveRuleInUTYear: year
				dayOfYear: dayOfYear
				secondsSinceStartOfDayFunction: secondsSinceStartOfDayFunction
				ifNone: [self]]! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
setAnnualPolicy: anAnnualPolicy
	"Set the receiver's AnnuallyRecurringTZPolicy. CONSTRAINT: The <rootTZ> of the 'bound, dynamic' time zone associated with <anAnnualPolicy> must be the same Chronos `unbound, dynamic` time zone for which the receiver will serve as a TimeZonePolicy. Fail if the receiver is not mutable."

	self assertMutability.
	annualPolicy := anAnnualPolicy! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
setDefaultName: aString
	self assertMutability.
	defaultName := aString! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
setEffectiveYearCalendar: aCalendarRef
	self assertMutability.
	effectiveYearCalendar := Calendar referencedBy: aCalendarRef! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
setEffectiveYearRelativity: aSymbol
	self assertMutability.
	effectiveYearRelativity := aSymbol! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
setGeographicCoordinates: aGeographicCoordinatesSpect
	self assertMutability.
	geographicCoordinates := aGeographicCoordinatesSpect! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
setLeftLink: aTimeZonePolicy
	"Set <aTimeZonePolicy> as the leftward link in the receiver's chain of TimeZonePolicies."

	self assertMutability.
	leftLink := aTimeZonePolicy.! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
setRegistrationKey: aSymbol
	self assertMutability.
	registrationKey := aSymbol! !

!TimeZonePolicy methodsFor: 'initialize-release' stamp: ''!
setRootTZ: anUnboundDynamicTimeZone
	"Set <anUnboundDynamicTimeZone> as the receiver's root time zone."

	self assertMutability.
	rootTZ := anUnboundDynamicTimeZone.! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation
	^annualPolicy specifiesCommonAbbreviation or: [rightLink notNil and: [rightLink specifiesCommonAbbreviation]]! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
specifiesDefaultName
	^defaultName ~~ nil! !

!TimeZonePolicy methodsFor: 'testing' stamp: ''!
specifiesGeographicCoordinates
	^geographicCoordinates ~~ nil! !

!TimeZonePolicy methodsFor: 'enumerating' stamp: ''!
withLeftLinkDo: block1
	"Evaluatue <block1> with the next leftward link in the receiver's rule chain as the argument.  If there is no such link, do nothing."

	^leftLink == nil ifFalse: [block1 value: leftLink]! !

!TemporalRule class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Chronos'! !

!TemporalRule class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!TemporalRule methodsFor: 'comparing' stamp: ''!
= otherTemporalRule 
	"Answer whether the receiver is equal to the argument."

	self == otherTemporalRule ifTrue: [^true].
	^self comparisonClassIdentifier 
		= otherTemporalRule comparisonClassIdentifier and: 
				[(self compareTo: otherTemporalRule) = 0]! !

!TemporalRule methodsFor: 'private' stamp: ''!
addRight: aTemporalRule
	"Answer the result of adding <aTemporalRule> to the rightward side of the receiver's rule chain at the canonical position. If the receiver is immutable, use a mutable copy of the receiver as the head of the chain, and a mutable copy of each link in the chain upto the point of insertion.  Fail if the canonical position of <aTemporalRule> is to the left of the receiver."

	^self asMutable basicAddRight: aTemporalRule! !

!TemporalRule methodsFor: 'converting' stamp: ''!
asAtom
	"Answer the receiver as a rule chain containing only the receiver itself. If the receiver is immutable, answer a mutable copy of the receiver whose rightLink and leftLink are both nil."

	^self isAtom 
		ifTrue: [self]
		ifFalse: 
			[(self asMutable)
				setRightLink: nil;
				setLeftLink: nil]! !

!TemporalRule methodsFor: 'concatenation' stamp: ''!
asListSortedInCanonicalOrderByTransitionTimeAdding: aTemporalRule
	"Answer a rule chain sorted in canonical order that includes a) all the rules in the receiver's rule chain, and b) <aTemporalRule>. If the receiver is immutable, the answered rule chain will contain mutable copies of the rules in the receiver's rule chain."

	| concatenation |
	concatenation := self.
	aTemporalRule withSelfAndAllRightwardLinksDo: 
			[:each | 
			| atom |
			atom := each asAtom.
			concatenation := 
				(concatenation perform: self sortOperator with: atom)
					ifTrue: [concatenation addRight: atom]
					ifFalse: 
						[concatenation = atom 
							ifTrue: [atom addRight: concatenation rightLink]
							ifFalse: [atom addRight: concatenation]]].
	^concatenation! !

!TemporalRule methodsFor: 'private' stamp: ''!
basicAddRight: aTemporalRule 
	"Add <aTemporalRule> as one of the rules in the receiver's rightward rule chain."

	aTemporalRule == self 
		ifTrue: 
			[self 
				signalError: 'The rightward link of a TemporallRule cannot be itself.'].
	aTemporalRule == nil 
		ifTrue: [self setRightLink: nil]
		ifFalse: 
			[| rightLink |
			rightLink := self rightLinkIfNone: [^self setRightLink: aTemporalRule].
			rightLink == aTemporalRule 
				ifFalse: 
					[self setRightLink: 
						(rightLink asListSortedInCanonicalOrderByTransitionTimeAdding: aTemporalRule)]]! !

!TemporalRule methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	self isMutable 
		ifTrue: [self withRightLinkDo: [:rightLink | rightLink beImmutable]].! !

!TemporalRule methodsFor: 'accessing' stamp: ''!
depth
	"Answer the number of rules in the receiver's rule chain, counting from the receiver to the end of the chain."

	^(self rightLinkIfNone: [^1]) depth + 1! !

!TemporalRule methodsFor: 'testing' stamp: ''!
hasLeftwardLink
	"Answer whether there is anonther rule after the receiver in the receiver's leftward rule chain."

	^false! !

!TemporalRule methodsFor: 'testing' stamp: ''!
hasRightwardLink
	"Answer whether there is anonther rule after the receiver in the receiver's rightward rule chain."

	^false! !

!TemporalRule methodsFor: 'testing' stamp: ''!
isAlwaysInEffect
	"Answer whether thre rule represented by the receiver is always in effect."

	^self isAtom! !

!TemporalRule methodsFor: 'testing' stamp: ''!
isAtom
	^(self hasRightwardLink or: [self hasLeftwardLink]) not! !

!TemporalRule methodsFor: 'accessing' stamp: ''!
leftLink
	"Answer the next rule `to the left` in the receiver's rule chain, if there is one.  If there is not, answer nil."

	^nil! !

!TemporalRule methodsFor: 'accessing' stamp: ''!
leftLinkIfNone: block0
	"Answer the next rule `to the left` in the receiver's rule chain, if there is one.  If there is not, answer the result of evaluating <block0>."

	^block0 value! !

!TemporalRule methodsFor: 'accessing' stamp: ''!
rightLink
	"Answer the next rule `to the right` in the receiver's rule chain, if there is one.  If there is not, answer nil."

	^nil! !

!TemporalRule methodsFor: 'accessing' stamp: ''!
rightLinkIfNone: block0
	"Answer the next rule `to the right` in the receiver's rule chain, if there is one.  If there is not, answer the result of evaluating <block0>."

	^block0 value! !

!TemporalRule methodsFor: 'initialize-release' stamp: ''!
setLeftLink: aTemporalRule
	"Set <aTemporalRule> as the next rule `to the left` in the receiver's chain of  TemporalRules."

	"By defrault, do nothing."! !

!TemporalRule methodsFor: 'initialize-release' stamp: ''!
setRightLink: aTemporalRule
	"Set <aTemporalRule> as the next rule `to the right` in the receiver's chain of  TemporalRules."

	aTemporalRule == nil 
		ifFalse: [aTemporalRule setLeftLink: self].! !

!TemporalRule methodsFor: 'accessing' stamp: ''!
sortOperator
	"Answer the comparison operator (as a message selector Symbol) to be used to sort the receiver's rule chain in canonical order."

	^#>! !

!TemporalRule methodsFor: 'enumerating' stamp: ''!
withLeftLinkDo: block1
	"Evaluatue <block1> with the next leftward link in the receiver's rule chain as the argument.  If there is no such link, do nothing."

	"By default, do nothing"! !

!TemporalRule methodsFor: 'enumerating' stamp: ''!
withRightLinkDo: block1
	"Evaluatue <block1> with the next rightward link in the receiver's rule chain as the argument.  If there is no such link, do nothing."

	"By default, do nothing"! !

!TemporalRule methodsFor: 'enumerating' stamp: ''!
withSelfAndAllLeftwardLinksDo: block1
	"Evaluatue <block1> with the receiver as the argument, then evaluate <block1> with all the subsequent links in the receiver's leftward rule chain (if any.)"

	block1 value: self.
	self withLeftLinkDo: [:leftLink | leftLink withSelfAndAllLeftwardLinksDo: block1]! !

!TemporalRule methodsFor: 'enumerating' stamp: ''!
withSelfAndAllRightwardLinksDo: block1
	"Evaluatue <block1> with the receiver as the argument, then evaluate <block1> with all the subsequent links in the receiver's rightward rule chain (if any.)"

	block1 value: self.
	self withRightLinkDo: [:rightLink | rightLink withSelfAndAllRightwardLinksDo: block1]! !

PassportMagnitude subclass: #TimeZoneAnnualTransitionPolicyFactory
	instanceVariableNames: 'key effectiveYear effectiveYearCalendarKey effectiveYearRelativity isSymmetric annuallyRecurringTransitions'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-TimeZones-PolicyFactories-Diachronic'!

!TimeZoneAnnualTransitionPolicyFactory commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

TimeZoneAnnualTransitionPolicyFactory

	Concept:

		A TimeZoneAnnualTransitionPolicyFactory defines, for each moment in time during a calendar year, the offset/abbreviation tuple that is in effect within the territorial domain of a time zone. A TimeZoneAnnualTransitionPolicyFactory's rules may also specify annually-recurring dates and times within a year when there is a transition to a different offset/abbreviation tuple. A TimeZoneAnnualTransitionPolicyFactory's rules do not specify any particular year when such transitions occur--they occur every year, from the effective year of the ruleset until the ruleset expires and is superceded by a later rule.  

		However, the purpose of a TimeZoneAnnualTransitionPolicyFactory is not to actually itself provide time-zone behavior, but rather to a) serve as a factory object for correctly instantiating a TimeZonePolicy using the minimum possible amount of memory, and b) to provide an API for the construction and editing of a time zone's ruleset that is considerably easier to understand and use than is the case for a TimeZonePolicy. 

		So, allthough a TimeZoneAnnualTransitionPolicyFactory represents essentially the same information as a TimeZonePolicy (with a few differences, as will be explained in the "Motivation:" section below,) its purpose and behavior are different: A TimeZonePolicy is used to represent the full diachronic ruleset of a Chronos time zone (from the infinte past to the infinite future,) whereas a TimeZoneAnnualTransitionPolicyFactory is used as a factory for creating instances of TimeZonePolicy. 

		A TimeZoneAnnualTransitionPolicyFactory encapsulates a list of AnnuallyRecurringTZPolicyFactory instances, each of which represents the time zone rules in effect for some number of years (these change from time to time--see TimeZonePolicy, TimeZonePolicySequenceFactory and VariableOffsetTimezone for more information.)

	Motivation:

		The key differences between the representational architectures of TimeZonePolicySequenceFactory/TimeZoneAnnualTransitionPolicyFactory/AnnuallyRecurringTZPolicyFactory and TimeZonePolicy/AnnuallyRecurringTZPolicy that motivate the existence of factory objects for the creation of TimeZonePolicies and AnnuallyRecurringTZPolicies are the following:

			1. TimeZonePolicies and AnnuallyRecurringTZPolicies are elements in a linked list; TimeZonePolicySequenceFactories, TimeZonePolicyElementFactories and AnnuallyRecurringTZPolicyFactories are not. Consequently, TimeZonePolicy and AnnuallyRecurringTZPolicy instances not only represent themselves as list elements, they also represent their list (for which the serve as the head element) as a whole.  TimeZonePolicySequenceFactories, TimeZonePolicyElementFactories and AnnuallyRecurringTZPolicyFactories do not have such dual semantics, and so are less confusing, and also easier to incrementally modify. 

			2. The effective year of an inter-year ruleset (one that is in effect for some number of years) is stored in TimeZonePolicyElementFactories, but not in the otherwise-analogous AnnuallyRecurringTZPolicies they create.  Conversely, the effective year is stored in TimeZonePolicy instances, but not in the otherwise-analogous TimeZonePolicySequenceFactories that serve as factories for their creation.  So when translating between the  policy factory objects and the non-factory policy objects, the responsibility for specifying the effective year of the ruleset is not handled by the analogous objects. The reason for this difference is soley a necessary side effect of the other differences between the two class hierarchies.

			3. AnnuallyRecurringTZPolicies contain "bound, dynamic" time zone instances (e.g., instances of StandardTime and/or NonStandardTime)--which in turn contain a reference to the "unbound, dynamic" timezone that defines both their identity and their full diachronic ruleset (e.g., an instance of VariableOffsetTimezone).  Instances of AnnuallyRecurringTZPolicy (and hence also instances of TimeZonePolicy) cannot be in canonical form--nor be fully functional--unless they have a reference to their "root" timezone. Consequently, TimeZonePolicies and AnnuallyRecurringTZPolicies form cyclic graphs, and require the existence of the entire object graph of an "unbound, dynamic" timezone in order be in canonical form and fully functional. 

			In contrast, AnnuallyRecurringTZPolicyFactories specify their offsets and abbreviations using internal instance variables that contain just an integer and a Symbol, and so do not form a cyclic graph, do not require any reference to a "root" object, and so do not require the existence of the entire object graph that defines the full diachronic ruleset of a timezone.

			4. The use of factory/memento objects makes it easier to minimize the unnecessary creation of objects with duplicate values during the construction of TimeZonePolicies (specifically: StandardTime and NonStandardTime instances, Duration instances and AnnualDate instances.)

	Implementation:

		Instance Variables

			effectiveYear						<Integer>		The year the instance's ruleset takes effect.
			isSymmetric							<Boolean>	Flag that indicates whether or not the instance should instantiate a TimeZonePolicy or an AsymmetricTimeZonePolicy (see the class comment of AsymmetricTimeZonePolicy for more information.)
			annuallyRecurringTransitions 	<Array of AnnuallyRecurringTZPolicyFactory>
				Each AnnuallyRecurringTZPolicyFactory in the <annuallyRecurringTransitions> array specifies the abbreviation and offset from UT that apply during some part of the year within the territorial domain of the time zone whose intra-year ruleset is specified by the instance. See AnnuallyRecurringTZPolicyFactory for more information.!

!TimeZoneAnnualTransitionPolicyFactory class methodsFor: 'accessing' stamp: ''!
appOrLibraryName
	^'Chronos'! !

!TimeZoneAnnualTransitionPolicyFactory class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!TimeZoneAnnualTransitionPolicyFactory class methodsFor: 'instance creation' stamp: ''!
decodeFrom: stream key: tzKey
	"{TimeZoneAnnualTransitionPolicyFactory 
		decodeFrom: 
			'1990 true Until-Annual-Date-Transition:NZDT:46800:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|3|15|1|0) Until-Annual-Date-Transition:NZST:43200:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|10|1|1|0) Until-End-Of-Year:NZDT:46800:43200' readStream key: #'Pacific/Auckland'}"
	"{TimeZoneAnnualTransitionPolicyFactory 
		decodeFrom: 
			'Julian 1990 true Until-Annual-Date-Transition:NZDT:46800:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|3|15|1|0) Until-Annual-Date-Transition:NZST:43200:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|10|1|1|0) Until-End-Of-Year:NZDT:46800:43200' readStream key: #'Pacific/Auckland'}"
	"{TimeZoneAnnualTransitionPolicyFactory 
		decodeFrom: 
			'nil true Until-Annual-Date-Transition:NZDT:46800:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|3|15|1|0) Until-Annual-Date-Transition:NZST:43200:43200:standard:7200:(WeekOfMonthDayOfWeek|Gregorian|10|1|1|0) Until-End-Of-Year:NZDT:46800:43200' readStream key: #'Pacific/Auckland'}"

	| calendar effectiveYear polarity yearRelativity isSymmetric encodedAnnuallyRecurringTransitions policy |
	ChronosFunction skipSeparators: stream.
	stream peek isLetter
		ifTrue: 
			[calendar := ChronosFunction nextFrom: stream until: [:ch | ch isSeparator].
			calendar = 'nil' 
				ifTrue: 
					[calendar := #Gregorian.
					effectiveYear := #negativeInfinity]
				ifFalse: [calendar := calendar asSymbol]]
		ifFalse: [calendar := #Gregorian].
	effectiveYear = #negativeInfinity
		ifTrue: 
			[effectiveYear := nil.
			yearRelativity := #nominal]
		ifFalse:
			[| c index |
			(c := stream peek) isDigit
				ifTrue: [polarity := 1]
				ifFalse: 
					[index := #($- $+) indexOf: c ifAbsent: [0].
					index > 0
						ifTrue: 
							[polarity := #(1 -1) at: index.
							stream next]
						ifFalse: [polarity := 1]].
			effectiveYear = #negativeInfinity
				ifTrue: [effectiveYear := nil]
				ifFalse: 
					[effectiveYear := 
						ChronosFunction 
							nextUnsignedIntegerFrom: stream 
							minDigits: 1 
							maxDigits: 10 
							acceptancePredicate: [:int :digitCount | true] 
							handleRejection: [:value :digitCount :rejectionReason | 
								self signalError: (digitCount < 1 ifTrue: ['Invalid effective year-- must be a number'] ifFalse: ['Invalid effective year--too many digits'])].
					index := #($u $s $n) indexOf: stream peek ifAbsent: [0].
					yearRelativity := index > 0
											ifTrue: 
													[stream next.
													#(universal standard nominal) at: index]
											ifFalse: [#nominal]]].
	ChronosFunction skipSeparators: stream.
	isSymmetric := (ChronosFunction nextFrom: stream until: [:ch | ch isSeparator]) = 'true'.
	encodedAnnuallyRecurringTransitions := 
		ChronosFunction 
			componentsFromStream: (ChronosFunction nextLineFrom: stream) readStream
			separator: $ .
	policy := self new
		setKey: tzKey;
		setEffectiveYear: (effectiveYear == nil ifFalse: [effectiveYear * polarity]);
		setEffectiveYearCalendarKey: calendar;
		setEffectiveYearRelativity: yearRelativity;
		setAnnuallyRecurringTransitions: (encodedAnnuallyRecurringTransitions collect: [:each | AnnuallyRecurringTZPolicyFactory decodeFrom: each readStream]).
	isSymmetric ifFalse: [policy setAsNonSymmetric].
	^policy beImmutable! !

!TimeZoneAnnualTransitionPolicyFactory class methodsFor: 'instance creation' stamp: ''!
key: aKey effectiveYear: aYear annuallyRecurringTransitions: anArrayOfAnnuallyRecurringTransitions
	^self new
		setKey: aKey;
		setEffectiveYear: aYear;
		setAnnuallyRecurringTransitions: anArrayOfAnnuallyRecurringTransitions;
		beImmutable! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'comparing' stamp: ''!
= otherMagnitude
	^self == otherMagnitude! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
annuallyRecurringTransitions
	^annuallyRecurringTransitions! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
annuallyRecurringTransitionsCount
	^annuallyRecurringTransitions size! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'enumerating' stamp: ''!
annuallyRecurringTransitionsDo: block2
	| index | 
	index := 0.
	annuallyRecurringTransitions do: [:each | block2 value: (index := index + 1) value: each]! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'converting' stamp: ''!
asPolicyFor: anUnboundDynamicTimeZone 
	| interYearPolicy annualPolicyChain |
	interYearPolicy := self timeZonePolicyClass  newFor: anUnboundDynamicTimeZone.
	annualPolicyChain := nil.
	annuallyRecurringTransitions do: 
			[:annualPolicyElement | 
			| annualPolicy |
			annualPolicy := annualPolicyElement asPolicyFor: interYearPolicy.
			annualPolicyChain == nil 
				ifTrue: [annualPolicyChain := annualPolicy]
				ifFalse: [annualPolicyChain := annualPolicyChain asListSortedInCanonicalOrderByTransitionTimeAdding: annualPolicy]].
	^interYearPolicy
		setEffectiveYear: effectiveYear;
		setEffectiveYearCalendar: self effectiveYearCalendar;
		setEffectiveYearRelativity: effectiveYearRelativity;
		setAnnualPolicy: annualPolicyChain! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'comparing' stamp: ''!
compareTo: otherMagnitude
	"Compare the value of the receiver to that of <otherMagnitude>.  If the receiver's value is larger, answer a positive numerical value. If the receiver's value is smaller, answer a negative numerical value.  Otherwise, answer zero (when the value of the receiver and <otherMagnitude> are the same.)"

	| otherEffectiveYear |
	self == otherMagnitude ifTrue: [^0].
	effectiveYear = (otherEffectiveYear := otherMagnitude effectiveYear) ifTrue: [^0].
	effectiveYear == nil ifTrue: [^-1].
	otherEffectiveYear == nil ifTrue: [^1].
	^effectiveYear - otherEffectiveYear! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
effectiveYear
	^effectiveYear! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
effectiveYear: aYear
	^self copy
		setEffectiveYear: aYear;
		beImmutable! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
effectiveYearCalendar
	^Calendar at: effectiveYearCalendarKey! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
effectiveYearCalendarKey
	^effectiveYearCalendarKey = nil ifTrue: [#Gregorian] ifFalse: [effectiveYearCalendarKey]! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'queries' stamp: ''!
effectiveYearIsGreaterThanOrEqualTo: aYear
	^effectiveYear == nil 
		ifTrue: [aYear == nil]
		ifFalse: 
			[aYear == nil 
				ifTrue: [true]
				ifFalse: [aYear <= effectiveYear]]! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'queries' stamp: ''!
effectiveYearIsLessThanOrEqualTo: aYear
	^effectiveYear == nil 
		ifTrue: [true]
		ifFalse: 
			[aYear == nil 
				ifTrue: [false]
				ifFalse: [aYear >= effectiveYear]]! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
effectiveYearRelativity
	^effectiveYearRelativity! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
effectiveYearTimeZone
	^effectiveYearRelativity == #universal 
		ifTrue: [ChronosTimezone universal]
		ifFalse: [ChronosTimezone at: self key]! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self effectiveYear;
		nextPut: self isSymmetric;
		nextPut: (annuallyRecurringTransitions collect: [:element | element literalArrayEncoding])! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'printing' stamp: ''!
encodeOn: stream 
	stream 
		print: effectiveYear;
		space;
		print: self isSymmetric.
	annuallyRecurringTransitions do: 
			[:each | 
			stream space.
			each encodeOn: stream].! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'testing' stamp: ''!
hasEffectiveYear
	^effectiveYear notNil! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'testing' stamp: ''!
hasEverBeenInEffect
	^self effectiveYearIsLessThanOrEqualTo: 
		(self effectiveYearTimeZone dateTodayAs: effectiveYearCalendarKey) year! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'comparing' stamp: ''!
hash
	^self identityHash! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	effectiveYearCalendarKey := #Gregorian.
	effectiveYearRelativity := #nominal.
	annuallyRecurringTransitions := Array new.
	isSymmetric := true.! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	| yearLiteral |
	yearLiteral := literalArray at: 2.
	self setEffectiveYear: (yearLiteral == nil ifFalse: [yearLiteral asNumber]).
	(literalArray at: 3) ifFalse: [self setAsNonSymmetric].
	self setAnnuallyRecurringTransitions: ((literalArray at: 4) collect: [:elementLiteral | elementLiteral decodeAsLiteralArray])! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'testing' stamp: ''!
isNotYetInEffect
	^self hasEverBeenInEffect not! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'testing' stamp: ''!
isSymmetric
	"Answer true the receiver should create instances of TimeZonePolicy, and false if the receiver should create instances of AsymmetricTimeZonePolicy. See the class comment of AsymmetricTimeZonePolicy for an explanation of the difference."

	^isSymmetric! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'queries' stamp: ''!
isSymmetricTransitionTo: nextTZOffsetPolicySpec 
	| element0 element1 |
	element0 := annuallyRecurringTransitions last.
	element1 := nextTZOffsetPolicySpec annuallyRecurringTransitions first.
	^element0 = element1 
		ifTrue: 
			[| onLastDayOfYear |
			annuallyRecurringTransitions size > 1 
				ifTrue: 
					[element0 := annuallyRecurringTransitions at: annuallyRecurringTransitions size - 1.
					onLastDayOfYear := element0 transitionOccursOnLastDayOfYear: nextTZOffsetPolicySpec effectiveYear - 1]
				ifFalse: [onLastDayOfYear := false].
			(onLastDayOfYear or: [element1 transitionOccursOnFirstDayOfYear: nextTZOffsetPolicySpec effectiveYear]) not]
		ifFalse: [false]! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
key
	^key! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'printing' stamp: ''!
printOn: stream
	stream
		cr; tab;
		nextPut: ${;
		nextPutAll: self class name;
		nextPut: $};
		cr; tab; tab; nextPutAll: 'effectiveYear=';
		print: self effectiveYear;
		tab; nextPutAll: ' isSymmetric=';
		print: self isSymmetric;
		cr; tab; tab; nextPutAll: 'annuallyRecurringTransitions=';
		print: annuallyRecurringTransitions! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'processing' stamp: ''!
processBy: aTimezoneProcessor
	"Visitor pattern; see TimezoneProcessor"

	aTimezoneProcessor processTimezoneAnnualTransitionPolicyFactory: self.! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
registrationKey
	^key! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'accessing' stamp: ''!
semanticKey	
	"Answer a value that identifies the conceptual type of the receiver."

	^self hasEffectiveYear
		ifTrue: [#SinceEffectiveYearTimeZoneAnnualTransitionPolicy]
		ifFalse:[#SinceForeverTimeZoneAnnualTransitionPolicy]! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
setAnnuallyRecurringTransitions: anArrayOfAnnuallyRecurringTransitions
	self assertMutability.
	annuallyRecurringTransitions := anArrayOfAnnuallyRecurringTransitions! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
setAsNonSymmetric
	self assertMutability.
	isSymmetric := false! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
setEffectiveYear: aYear
	self assertMutability.
	effectiveYear := aYear! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
setEffectiveYearCalendarKey: aSymbol
	self assertMutability.
	effectiveYearCalendarKey := aSymbol! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
setEffectiveYearRelativity: aSymbol
	self assertMutability.
	effectiveYearRelativity := aSymbol! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
setKey: aKey
	self assertMutability.
	key := aKey == nil ifFalse: [aKey asSymbol].! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'initialize-release' stamp: ''!
setSymmetryBasedOnTransitionFrom: prevTZOffsetPolicySpec
	isSymmetric := prevTZOffsetPolicySpec isSymmetricTransitionTo: self.! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'testing' stamp: ''!
specifiesCommonAbbreviation
	^annuallyRecurringTransitions contains: [:each | each specifiesCommonAbbreviation]! !

!TimeZoneAnnualTransitionPolicyFactory methodsFor: 'private' stamp: ''!
timeZonePolicyClass
	^self isSymmetric
		ifTrue: [TimeZonePolicy]
		ifFalse: [AsymmetricTimeZonePolicy]! !

ReversibleTransformer subclass: #SimpleDateTransformer
	instanceVariableNames: 'calendarDelta'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Duration'!

!SimpleDateTransformer commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})
!

!SimpleDateTransformer class methodsFor: 'instance creation' stamp: ''!
delta: aCalendarDuration 
	^(self basicNew)
		setCalendarDelta: aCalendarDuration;
		beImmutable! !

!SimpleDateTransformer methodsFor: 'transformation' stamp: ''!
applyTo: aDate
	^aDate + calendarDelta! !

!SimpleDateTransformer methodsFor: 'accessing' stamp: ''!
calendarDelta
	^calendarDelta! !

!SimpleDateTransformer methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	calendarDelta := CalendarDurationFactory zero! !

!SimpleDateTransformer methodsFor: 'transformation' stamp: ''!
inverseApplyTo: aDate
	^aDate - calendarDelta! !

!SimpleDateTransformer methodsFor: 'initialize-release' stamp: ''!
setCalendarDelta: aCalendarDuration
	self assertMutability.
	calendarDelta := aCalendarDuration == nil ifTrue: [CalendarDurationFactory zero] ifFalse: [aCalendarDuration asCalendarDuration]! !

Registratable subclass: #ChronosLocale
	instanceVariableNames: 'languageCode countryCode timeZoneLocalizationPolicy temporalPrintPolicy'
	classVariableNames: 'Default English EnglishAbbreviationsBySemanticKey EnglishNotationalPolicies EnglishPluralNounsBySemanticKey EnglishProperNamesBySemanticKey EnglishSemanticCharacters EnglishSingularNounsBySemanticKey Root RootNotationalPolicies RootSemanticCharacters System US USEnglishNotationalPolicies USEnglishSemanticCharacters'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Localization'!

!ChronosLocale commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!ChronosLocale class methodsFor: 'accessing' stamp: ''!
default
	"ChronosLocale default"

	Default == nil ifTrue: [^self system].
	^Default! !

!ChronosLocale class methodsFor: 'accessing' stamp: ''!
english
	"ChronosLocale english"

	English == nil 
		ifTrue: 
			[English := self at: #en ifAbsent: [self newEnglishLocale forceRegistration]].
	^English! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
englishAbbreviations
	EnglishAbbreviationsBySemanticKey == nil ifTrue: [self initializeEnglishAbbreviationsBySemanticKey].
	^EnglishAbbreviationsBySemanticKey! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
englishNotationalPolicies
	EnglishNotationalPolicies == nil ifTrue: [self initializeEnglishNotationalPolicies].
	^EnglishNotationalPolicies! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
englishPluralNouns
	EnglishPluralNounsBySemanticKey == nil ifTrue: [self initializeEnglishPluralNounsBySemanticKey].
	^EnglishPluralNounsBySemanticKey! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
englishProperNames
	EnglishProperNamesBySemanticKey == nil ifTrue: [self initializeEnglishProperNamesBySemanticKey].
	^EnglishProperNamesBySemanticKey! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
englishSemanticCharacters
	EnglishSemanticCharacters == nil ifTrue: [self initializeEnglishSemanticCharacters].
	^EnglishSemanticCharacters! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
englishSingularNouns
	EnglishSingularNounsBySemanticKey == nil ifTrue: [self initializeEnglishSingularNounsBySemanticKey].
	^EnglishSingularNounsBySemanticKey! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
findOrCreateLocaleAt: localeKey
	localeKey == #'root_ROOT' ifTrue: [^ChronosLocale root].
	localeKey == #C ifTrue: [^ChronosLocale english].
	localeKey == #en ifTrue: [^ChronosLocale english].
	localeKey == #'en_US' ifTrue: [^ChronosLocale unitedStates].
	^(ChronosSystemFacade current findOrCreateChronosLocaleAt: localeKey) forceRegistration! !

!ChronosLocale class methodsFor: 'utility' stamp: ''!
fromLocaleKey: chronosLocaleKey setLanuageCodeAndCountryCodeInto: block2
	| key underscoreIndex languageCode countryCode countryCodeTerminatorIndex |
	key := chronosLocaleKey asString.
	underscoreIndex := key indexOf: $_.
	underscoreIndex = 0 
		ifTrue: [^block2 value: key asSymbol value: nil]
		ifFalse: [languageCode := (key copyFrom: 1 to: underscoreIndex - 1) asSymbol].
	countryCodeTerminatorIndex := underscoreIndex + 1.
	[countryCodeTerminatorIndex <= key size and: [(key at: countryCodeTerminatorIndex) isLetter]] 
		whileTrue: [countryCodeTerminatorIndex := countryCodeTerminatorIndex + 1].
	countryCode := (key copyFrom: underscoreIndex + 1 to: countryCodeTerminatorIndex - 1) asSymbol.
	^block2
		value: languageCode
		value: countryCode! !

!ChronosLocale class methodsFor: 'accessing' stamp: ''!
handleUnregistered: localeKey
	^self findOrCreateLocaleAt: localeKey! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initialize
	"ChronosLocale initialize" 

	self basicInitializeAll.	
	Root := nil.
	English := nil.
	US := nil.
	System := nil.
	Default := nil.! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeDefaultLocaleInformation
	"ChronosLocale initializeDefaultLocaleInformation"

	self initializeRootSemanticCharacters.
	self initializeRootNotationalPolicies.

	self initializeEnglishSemanticCharacters.
	self initializeEnglishNotationalPolicies.
	self initializeEnglishProperNamesBySemanticKey.
	self initializeEnglishAbbreviationsBySemanticKey.
	self initializeEnglishSingularNounsBySemanticKey.
	self initializeEnglishPluralNounsBySemanticKey.

	self initializeUSEnglishSemanticCharacters.
	self initializeUSEnglishNotationalPolicies.! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeEnglishAbbreviationsBySemanticKey
	"ChronosLocale initializeEnglishAbbreviationsBySemanticKey"

	EnglishAbbreviationsBySemanticKey := Dictionary new.
	EnglishAbbreviationsBySemanticKey
		at: #January put: #Jan;
		at: #February put: #Feb;
		at: #March put: #Mar;
		at: #April put: #Apr;
		at: #May put: #May;
		at: #June put: #Jun;
		at: #July put: #Jul;
		at: #August put: #Aug;
		at: #September put: #Sep;
		at: #October put: #Oct;
		at: #November put: #Nov;
		at: #December put: #Dec;
		at: #Monday put: #Mon;
		at: #Tuesday put: #Tue;
		at: #Wednesday put: #Wed;
		at: #Thursday put: #Thu;
		at: #Friday put: #Fri;
		at: #Saturday put: #Sat;
		at: #Sunday put: #Sun;
		at: #'ante-meridian' put: #am;
		at: #'post-meridian' put: #pm.! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeEnglishNotationalPolicies
	"ChronosLocale initializeEnglishNotationalPolicies"

	"Policy key								Valid policy values (one from the set)

	#dateAndTimeOrder					-- #(#useDateBeforeTimeOrder #useTimeBeforeDateOrder)
	#datePolicy								-- #(#useYearMonthDayOrder #useYearDayMonthOrder #useMonthDayYearOrder #useDayMonthYearOrder #useOrdinalDate
												#useISOWeekOfYearDayOfWeek #showDateAsJulianDay #showDateAsGregorianDay #showDateAsDaysSinceEpoch)
	#monthPolicy							-- #(#useNumericMonthDesignator #useMonthOrdinal #useMonthName #useMonthAbbreviation)
	#yearPolicy								-- #(#useFullDigitYears #useTwoDigitYears #hideYears)
	#dayOfWeekPolicy						-- #(#hideDayOfWeek #showDayOfWeekName #showDayOfWeekAbbreviation)
	#eraPolicy								-- #(#hideEraName #showEraName)

	#timeOfDayPolicy						-- #(#hideTimeOfDay #showTimeOfDay)
	#hourPolicy								-- #(#use12HourFormat #user24Hour4Format)
	#timeOfDaySubsecondPolicy			-- #(#hideSubsecondFraction #showSubsecondFraction)
	#timeZonePolicy						-- #(#hideTimeZone #showTimeZoneAbbreviation #showTimeZoneName #showTimeZoneOffset #showTimeZoneVerbosely)

	#durationElementNamePolicy			-- #(#hideNamesOfDurationElements #showNamesOfDurationElements)
	#calendarDurationElementNamePolicy	-- #(#hideNamesOfCalendarDurationElements #showNamesOfCalendarDurationElements)
	#durationElementZeroValuePolicy		-- #(#hideZeroValuedDurationElements #showZeroValuedDurationElements)
	#durationElementZeroValuePolicy		-- #(#hideZeroValuedCalendarDurationElements #showZeroValuedCalendarDurationElements)"

	EnglishNotationalPolicies := Dictionary new.
	EnglishNotationalPolicies
		at: #dateAndTimeOrder put: #useDateBeforeTimeOrder;
		at: #datePolicy put: #useDayMonthYearOrder;
		at: #monthPolicy put: #useMonthName;		
		at: #yearPolicy put: #useFullDigitYears;
		at: #dayOfWeekPolicy put: #hideDayOfWeek;
		at: #eraPolicy put: #hideEraName;
		at: #timeOfDayPolicy put: #showTimeOfDay;
		at: #hourPolicy put: #use12HourFormat;
		at: #timeOfDaySubsecondPolicy put: #hideSubsecondFraction;
		at: #timeZonePolicy put: #showTimeZoneAbbreviation;
		at: #durationElementNamePolicy put: #showNamesOfDurationElements;		
		at: #calendarDurationElementNamePolicy put: #showNamesOfCalendarDurationElements;		
		at: #durationElementZeroValuePolicy put: #hideZeroValuedDurationElements;
		at: #calendarDurationElementZeroValuePolicy put: #hideZeroValuedCalendarDurationElements! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeEnglishPluralNounsBySemanticKey
	"ChronosLocale initializeEnglishPluralNounsBySemanticKey"

	EnglishPluralNounsBySemanticKey := Dictionary new.
	EnglishPluralNounsBySemanticKey 
		at: #year put: #'years';
		at: #month put: #'months';
		at: #week put: #'weeks';
		at: #weekOfYear put: #'weeks of year';
		at: #weekOfMonth put: #'weeks of month';
		at: #day put: #'days';
		at: #dayOfYear put: #'days of year';
		at: #dayOfMonth put: #'days of month';
		at: #dayOfWeek put: #'days of week';
		at: #hour put: #'hours';
		at: #minute put: #'minutes';
		at: #second put: #'seconds';
		at: #millisecond put: #'milliseconds';
		at: #microsecond put: #'microseconds';
		at: #nanosecond put: '#nanoseconds';
		at: #tick put: #'ticks'. "clock ticks"! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeEnglishProperNamesBySemanticKey
	"ChronosLocale initializeEnglishProperNamesBySemanticKey"

	EnglishProperNamesBySemanticKey := Dictionary new.
	EnglishProperNamesBySemanticKey
		at: #system put: 'System';
		at: #default put: 'Default';
		at: #Universal put: 'Universal Time';
		at: #nominal put: 'Nominal Time';
		at: #alwaysSystem put: 'Dynamic Local Time (System)';
		at: #alwaysDefault put: 'Dynamic Local Time (User)';
		at: #January put: #January;
		at: #February put: #February;
		at: #March put: #March;
		at: #April put: #April;
		at: #May put: #May;
		at: #June put: #June;
		at: #July put: #July;
		at: #August put: #August;
		at: #September put: #September;
		at: #October put: #October;
		at: #November put: #November;
		at: #December put: #December;
		at: #Month1 put: #'FirstMonth';
		at: #Month2 put: #'SecondMonth';
		at: #Month3 put: #'ThirdMonth';
		at: #Month4 put: #'FourthMonth';
		at: #Month5 put: #'FifthMonth';
		at: #Month6 put: #'SixthMonth';
		at: #Month7 put: #'SeventhMonth';
		at: #Month8 put: #'EighthMonth';
		at: #Month9 put: #'NinthMonth';
		at: #Month10 put: #'TenthMonth';
		at: #Month11 put: #'EleventhMonth';
		at: #Month12 put: #'TwelfthMonth';
		at: #Monday put: #Monday;
		at: #Tuesday put: #Tuesday;
		at: #Wednesday put: #Wednesday;
		at: #Thursday put: #Thursday;
		at: #Friday put: #Friday;
		at: #Saturday put: #Saturday;
		at: #Sunday put: #Sunday;
		at: #'ante-meridian' put: #am;
		at: #'post-meridian' put: #pm;
		at: #Bahai put: #Bahai;
		at: #'Bahai-era-postEpoch' put: #BE; "Bahai Era"
		at: #'Bahai-era-preEpoch' put: #BE;
		at: #Chinese put: #Chinese;
		at: #'Chinese-era-postEpoch' put: #AS; "Anno Sinae (Year of the Chinese)"
		at: #'Chinese-era-preEpoch' put: #AS;
		at: #Coptic put: #Coptic;
		at: #'Coptic-era-postEpoch' put: #AM;	"Anno Martyrum (Year of the Martyrs)"
		at: #'Coptic-era-preEpoch' put: #AM;
		at: #Ethiopic put: #Ethiopic;
		at: #'Ethiopic-era-postEpoch' put: #ZH; "Zemene Haddis" "Alternatively: 'Amete Mihret'--not used here to avoid confusion with both the Coptic and Hebrew era abbreviations"
		at: #'Ethiopic-era-preEpoch' put: #ZB; "Zemene Bluy"
		at: #Greogian put: #Greogian;
		at: #Hebrew put: #Hebrew;
		at: #'Hebrew-era-postEpoch' put: #AM;	"Anno Mundi (Year of the World)"
		at: #'Hebrew-era-preEpoch' put: #AM;
		at: #'ImperialJulian-era-postEpoch' put: #AUC;	"Ab Urbe Condita (From the Founding of the City)"
		at: #'ImperialJulian-era-preEpoch' put: #AUC;
		at: #Indian put: #'Indian Civil';
		at: #'Indian-era-postEpoch' put: #AS;	"Anno Sakidae (Saka Era)"
		at: #'Indian-era-preEpoch' put: #AS;
		at: #'Islamic-Fatimid' put: #'Islamic (Fatimid)';
		at: #'Islamic-Fatimid-era-postEpoch' put: #AH;	"Anno Hegirae (Year of the Hijra)"
		at: #'Islamic-Fatimid-era-preEpoch' put: #AH;
		at: #Julian put: #Julian;
		at: #'Julian-Imperial' put: #'Julian (Imperial)';
		at: #Persian put: #Persian;
		at: #'Persian-era-postEpoch' put: #AP;	"Anno Persico (Persian Year)"
		at: #'Persian-era-preEpoch' put: #AP;
		at: #Solarian put: #Solarian;
		at: #'Solarian-era-postEpoch' put: #SY;	"Solarian Year"
		at: #'Solarian-era-preEpoch' put: #SY;
		at: #'Christian-era-postEpoch' put: #AD;	"Anno Domini (Year of the Lord)"
		at: #'Christian-era-preEpoch' put: #BC	"Before Christ (not in Latin, because the term was coined in English by the Venerable Bede)"

	"Note on the Era Names used for the Julian and Gregorian Calendars:

	For the Gregorian and Julian calendars, we use the formally and historically correct 'AD' and 'BC' era designators, instead of the revisionist 'CE' and 'BCE' designators.  

	The reasons for this choice:

		1) The majority of the general world population continues to prefer the usage of 'AD'/'BC'--and many are not even familiar with the 'CE'/'BCE' designations.
		2) The specification of the Gregorian calendar rightfully resides with its inventor: The Roman Catholic Church.  No changes to the specification of the Gregorian calendar have been authorized by the Pope since the introduction of the calendar.  Therefore, 'AD' and 'BC' are still formally correct--and 'CE'/'BCE' are not.
		3) The principle of reciprocity requires that each culture respect the standard conventions and usages of all other cultures, provided this does not involve the violation of rights.  Since Jews (for example) have no right to not be offended by whatever name Christians choose to use for the eras of their calendar (just as Christians, Hindus, Muslims and atheists have no right to not be offended by the implications of the phrase 'anno mundi,') Christians have the right to name the eras of their calendar whatever they wish, and other cultures are required by the principle of reciprocity to respect it.  Just because the names of certain cities in Thailand can be easily taken as vulgar words/phrases in English does not give English speakers the right to dictate to Thais what they call their cities.  By the same principle, no one has the right to dictate to Christians what they call their calendar eras--and any attempt to do so is both ill-mannered and offensive.

		It must also be mentioned that the stated reason by Jews for their unwillingness to use the designation 'anno domini'--namely, that they do not believe that Jesus is their 'lord'--is inconsistent and hypocritical.  No one disputes their disbelief, nor their right to disbelieve (certainly not I--I'm an atheist.)  However, Jews also do not believe that Yahshuah is 'ha Mashiahh' (that is, that Jesus is 'the Christ', both 'Mashiahh' and 'Christ' mean 'Annointed One,' a term with special significance in both the Hebrew and Christian scriptures.)  Consequently, to be logically consistent, Jews should also be unwilling to use the label 'Christian' in reference to the (self-proclaimed) disciples of Jesus, or to use the term 'Christ' to refer to the central figure of the Christian religion, since they emphatically do not believe this person to have been the Annointed One, nor that those called Christians are in fact the disciples of 'the real' Annointed One (who is yet to come, according to Jewish belief.)  Therefore, failure by Jews to avoid all reference to the term 'Christ,'   in all its forms (including 'Christian Era,') is thus blatantly and inarguably hypocritical, and renders their objections to 'anno domini' doubly offensive.

		Of course, Christians also have no right to force others to use their calendar (or to follow their naming conventions.)  Consequently, each individual is free to use whatever calendar and/or era names he/she thinks best. Nevertheless, as a general purpose tool, Chronos best serves all users by following common/standard usage."! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeEnglishSemanticCharacters
	"ChronosLocale initializeEnglishSemanticCharacters"

	EnglishSemanticCharacters := Dictionary new.
	EnglishSemanticCharacters
		at: #decimalPoint put: $.;
		at: #thousandsSeparator put: $,;
		at: #yearMonthSeparator put: $ ; "covers either year/month or month/year"
		at: #monthDayOfMonthSeparator put: $ ; "covers either month/dayOfMonth or dayOfMonth/month"
		at: #dayOfMonthYearSeparator put: $ ; "covers either dayOfMonth/year or year/dayOfMonth"
		at: #yearPad put: nil; "pad character for year--nil means don't pad"
		at: #monthPad put: nil; "pad character for month--nil means don't pad"
		at: #dayOfMonthPad put: nil; "pad character for dayOfMonth--nil means don't pad" 
		"Note: dayOfYear is always zero-padded; DaysSinceEpoch and Julian Day Numbers are never padded."
		at: #dateAndTimeSeparator put: '  ';
		at: #timeOfDayPrefix put: nil; "A prefix to be always prepended in front of a time-of-day. Nil means no prefix at all."
		at: #hourMinuteSecondSeparator put: $:;
		at: #timeZoneSeparator put: $ ;
		at: #timeZoneElementSeparator put: nil;
		at: #hourPad put: nil; "pad character for hour (nil means don't pad)--minute and second fields always zero-padded"
		at: #durationElementSeparator put: $ ;
		at: #calendarDurationElementSeparator put: $ ;
		at: #durationPad put: nil; "pad character for all scientific (ANSI) durations (nil means don't pad)"
		at: #calendarDurationPad put: nil; "pad character for calendar (ISO) durations (nil means don't pad)"
		at: #durationDayHourSeparator put: $ ;
		at: #calendarDurationDayHourSeparator put: $ .
		

		"Note: Any separator 'character' may be a String instead."! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeEnglishSingularNounsBySemanticKey
	"ChronosLocale initializeEnglishSingularNounsBySemanticKey"

	EnglishSingularNounsBySemanticKey := Dictionary new.
	EnglishSingularNounsBySemanticKey 
		at: #year put: #year;
		at: #month put: #month;
		at: #week put: #week;
		at: #weekOfYear put: #'week of year';
		at: #weekOfMonth put: #'week of month';
		at: #day put: #day;
		at: #dayOfYear put: #'day of year';
		at: #dayOfMonth put: #'day of month';
		at: #dayOfWeek put: #'day of week';
		at: #hour put: #'hour';
		at: #minute put: #'minute';
		at: #second put: #'second';
		at: #millisecond put: #'millisecond';
		at: #microsecond put: #'microsecond';
		at: #nanosecond put: #'nanosecond';
		at: #tick put: #'tick'."clock tick"! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeRootNotationalPolicies
	"Set values that best reflect international standards/conventions, and avoid names in any particular language."

	"{ChronosLocale initializeRootNotationalPolicies}"

	"Policy key								Valid policy values (one from the set)

	#dateAndTimeOrder					-- #(#useDateBeforeTimeOrder #useTimeBeforeDateOrder)
	#datePolicy								-- #(#useYearMonthDayOrder #useYearDayMonthOrder #useMonthDayYearOrder #useDayMonthYearOrder #useOrdinalDate
												#useISOWeekOfYearDayOfWeek #showDateAsJulianDay #showDateAsGregorianDay #showDateAsDaysSinceEpoch)
	#monthPolicy							-- #(#useNumericMonthDesignator #useMonthOrdinal #useMonthName #useMonthAbbreviation)
	#yearPolicy								-- #(#useFullDigitYears #useTwoDigitYears #hideYears)
	#dayOfWeekPolicy						-- #(#hideDayOfWeek #showDayOfWeekName #showDayOfWeekAbbreviation)
	#eraPolicy								-- #(#hideEraName #showEraName)

	#timeOfDayPolicy						-- #(#hideTimeOfDay #showTimeOfDay)
	#hourPolicy								-- #(#use12HourFormat #user24Hour4Format)
	#timeOfDaySubsecondPolicy			-- #(#hideSubsecondFraction #showSubsecondFraction)
	#timeZonePolicy						-- #(#hideTimeZone #showTimeZoneAbbreviation #showTimeZoneName #showTimeZoneOffset #showTimeZoneVerbosely)

	#durationElementNamePolicy			-- #(#hideNamesOfDurationElements #showNamesOfDurationElements)
	#calendarDurationElementNamePolicy	-- #(#hideNamesOfCalendarDurationElements #showNamesOfCalendarDurationElements)
	#durationElementZeroValuePolicy		-- #(#hideZeroValuedDurationElements #showZeroValuedDurationElements)
	#durationElementZeroValuePolicy		-- #(#hideZeroValuedCalendarDurationElements #showZeroValuedCalendarDurationElements)"

	RootNotationalPolicies := Dictionary new.
	RootNotationalPolicies
		at: #dateAndTimeOrder put: #useDateBeforeTimeOrder;
		at: #datePolicy put: #useYearMonthDayOrder;
		at: #monthPolicy put: #useNumericMonthDesignator;		
		at: #yearPolicy put: #useFullDigitYears;
		at: #dayOfWeekPolicy put: #hideDayOfWeek;
		at: #eraPolicy put: #hideEraName;
		at: #timeOfDayPolicy put: #showTimeOfDay;
		at: #hourPolicy put: #use12HourFormat;
		at: #timeOfDaySubsecondPolicy put: #hideSubsecondFraction;
		at: #timeZonePolicy put: #showTimeZoneAbbreviation;
		at: #durationElementNamePolicy put: #hideNamesOfDurationElements;		
		at: #calendarDurationElementNamePolicy put: #hideNamesOfCalendarDurationElements;		
		at: #durationElementZeroValuePolicy put: #showZeroValuedDurationElements;
		at: #calendarDurationElementZeroValuePolicy put: #hideZeroValuedCalendarDurationElements! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeRootSemanticCharacters
	"Set values that best reflect international standards and conventions."

	"{ChronosLocale initializeRootSemanticCharacters}"

	RootSemanticCharacters := Dictionary new.
	RootSemanticCharacters
		at: #currencySymbol put: (EnvironmentFacade current euroCurrencyCharIfNone: [$$]);
		at: #decimalPoint put: $,;
		at: #thousandsSeparator put: $.;
		at: #yearMonthSeparator put: $-; "covers either year/month or month/year"
		at: #monthDayOfMonthSeparator put: $-; "covers either month/dayOfMonth or dayOfMonth/month"
		at: #dayOfMonthYearSeparator put: $-; "covers either dayOfMonth/year or year/dayOfMonth"
		at: #yearPad put: $0; "pad character for year--nil means don't pad"
		at: #monthPad put: $0; "pad character for month--nil means don't pad"
		at: #dayOfMonthPad put: $0; "pad character for dayOfMonth--nil means don't pad" 
		"Note: dayOfYear is always zero-padded; DaysSinceEpoch and Julian Day Numbers are never padded."
		at: #dateAndTimeSeparator put: '  '; "Two spaces"
		at: #timeOfDayPrefix put: nil; "A prefix to be always prepended in front of a time-of-day. Nil means no prefix at all."
		at: #hourMinuteSecondSeparator put: $:;
		at: #hourPad put: $0; "pad character for hour (nil means don't pad)--minute and second fields always zero-padded"
		at: #timeZoneSeparator put: $ ;
		at: #timeZoneElementSeparator put: nil;
		at: #durationElementSeparator put: $:;
		at: #calendarDurationElementSeparator put: nil;
		at: #durationPad put: $0; "pad character for all scientific (ANSI) durations (nil means don't pad)"
		at: #calendarDurationPad put: nil; "pad character for calendar (ISO) durations (nil means don't pad)"
		at: #durationDayHourSeparator put: $T;
		at: #calendarDurationDayHourSeparator put: $T.
		
		"Note: Any separator 'character' may be a String instead."! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeUSEnglishNotationalPolicies
	"ChronosLocale initializeUSEnglishNotationalPolicies"

	"Policy key								Valid policy values (one from the set)

	#dateAndTimeOrder					-- #(#useDateBeforeTimeOrder #useTimeBeforeDateOrder)
	#datePolicy								-- #(#useYearMonthDayOrder #useYearDayMonthOrder #useMonthDayYearOrder #useDayMonthYearOrder #useOrdinalDate
												#useISOWeekOfYearDayOfWeek #showDateAsJulianDay #showDateAsGregorianDay #showDateAsDaysSinceEpoch)
	#monthPolicy							-- #(#useNumericMonthDesignator #useMonthOrdinal #useMonthName #useMonthAbbreviation)
	#yearPolicy								-- #(#useFullDigitYears #useTwoDigitYears #hideYears)
	#dayOfWeekPolicy						-- #(#hideDayOfWeek #showDayOfWeekName #showDayOfWeekAbbreviation)
	#eraPolicy								-- #(#hideEraName #showEraName)

	#timeOfDayPolicy						-- #(#hideTimeOfDay #showTimeOfDay)
	#hourPolicy								-- #(#use12HourFormat #user24Hour4Format)
	#timeOfDaySubsecondPolicy			-- #(#hideSubsecondFraction #showSubsecondFraction)
	#timeZonePolicy						-- #(#hideTimeZone #showTimeZoneAbbreviation #showTimeZoneName #showTimeZoneOffset #showTimeZoneVerbosely)

	#durationElementNamePolicy			-- #(#hideNamesOfDurationElements #showNamesOfDurationElements)
	#calendarDurationElementNamePolicy	-- #(#hideNamesOfCalendarDurationElements #showNamesOfCalendarDurationElements)
	#durationElementZeroValuePolicy		-- #(#hideZeroValuedDurationElements #showZeroValuedDurationElements)
	#durationElementZeroValuePolicy		-- #(#hideZeroValuedCalendarDurationElements #showZeroValuedCalendarDurationElements)"

	USEnglishNotationalPolicies := Dictionary new.
	USEnglishNotationalPolicies
		at: #dateAndTimeOrder put: #useDateBeforeTimeOrder;
		at: #datePolicy put: #useMonthDayYearOrder;
		at: #monthPolicy put: #useMonthName;		
		at: #yearPolicy put: #useFullDigitYears;
		at: #dayOfWeekPolicy put: #hideDayOfWeek;
		at: #eraPolicy put: #hideEraName;
		at: #timeOfDayPolicy put: #showTimeOfDay;
		at: #hourPolicy put: #use12HourFormat;
		at: #timeOfDaySubsecondPolicy put: #hideSubsecondFraction;
		at: #timeZonePolicy put: #showTimeZoneAbbreviation;
		at: #durationElementNamePolicy put: #showNamesOfDurationElements;		
		at: #calendarDurationElementNamePolicy put: #showNamesOfCalendarDurationElements;		
		at: #durationElementZeroValuePolicy put: #hideZeroValuedDurationElements;
		at: #calendarDurationElementZeroValuePolicy put: #hideZeroValuedCalendarDurationElements! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
initializeUSEnglishSemanticCharacters
	"ChronosLocale initializeUSEnglishSemanticCharacters"

	USEnglishSemanticCharacters := Dictionary new.
	USEnglishSemanticCharacters
		at: #decimalPoint put: $.;
		at: #thousandsSeparator put: $,;
		at: #currencySymbol put: $$;
		at: #yearMonthSeparator put: $/; "covers either year/month or month/year"
		at: #monthDayOfMonthSeparator put: $ ; "covers either month/dayOfMonth or dayOfMonth/month"
		at: #dayOfMonthYearSeparator put: ', '; "covers either dayOfMonth/year or year/dayOfMonth"
		at: #yearPad put: nil; "pad character for year--nil means don't pad"
		at: #monthPad put: nil; "pad character for month--nil means don't pad"
		at: #dayOfMonthPad put: nil; "pad character for dayOfMonth--nil means don't pad" 
		"Note: dayOfYear is always zero-padded; DaysSinceEpoch and Julian Day Numbers are never padded."
		at: #dateAndTimeSeparator put: '  ';
		at: #timeOfDayPrefix put: nil; "A prefix to be always prepended in front of a time-of-day. Nil means no prefix at all."
		at: #hourMinuteSecondSeparator put: $:;
		at: #hourPad put: nil; "pad character for hour (nil means don't pad)--minute and second fields always zero-padded"
		at: #timeZoneSeparator put: $ ;
		at: #timeZoneElementSeparator put: nil;
		at: #durationElementSeparator put: $ ;
		at: #calendarDurationElementSeparator put: $ ;
		at: #durationPad put: nil; "pad character for all scientific (ANSI) durations (nil means don't pad)"
		at: #calendarDurationPad put: nil; "pad character for calendar (ISO) durations (nil means don't pad)"
		at: #durationDayHourSeparator put: $ ;
		at: #calendarDurationDayHourSeparator put: $ .
		

		"Note: Any separator 'character' may be a String instead."! !

!ChronosLocale class methodsFor: 'class initialization' stamp: ''!
invalidateSystemLocale
	"ChronosLocale invalidateSystemLocale"

	System := self findOrCreateLocaleAt: ChronosSystemFacade current systemLocaleKey.! !

!ChronosLocale class methodsFor: 'utility' stamp: ''!
localeKeyFromLanguageCode: language countryCode: countryCode 
	| stream languageCode |
	languageCode := language == nil ifTrue: [^#root] ifFalse: [language].
	stream := (String new: 15) writeStream.
	stream nextPutAll: languageCode.
	countryCode == nil 
		ifFalse: 
			[stream
				nextPut: $_;
				nextPutAll: countryCode].
	^stream contents asSymbol! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
newEnglishLocale
	^ConfigurableChronosLocale new
		setDelegate: self root;
		setKey: #en;
		setStandardCalendarRegistrationKey: GregorianCalendar registrationKey;
		setCharacters: self englishSemanticCharacters;
		setNotationalPolicies: self englishNotationalPolicies;
		setProperNames: self englishProperNames;
		setAbbreviations: self englishAbbreviations;
		setSingularNouns: self englishSingularNouns pluralNouns: self englishPluralNouns! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
newRootLocale
	^ConfigurableChronosLocale new
		setKey: #'root_ROOT';
		setStandardCalendarRegistrationKey: GregorianCalendar registrationKey;
		setCharacters: self rootSemanticCharacters;
		setNotationalPolicies: self rootNotationalPolicies;
		setProperNames: self englishProperNames;
		setAbbreviations: self englishAbbreviations;
		setSingularNouns: self englishSingularNouns pluralNouns: self englishPluralNouns! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
newUSLocale
	^ConfigurableChronosLocale new
		setDelegate: self english;
		setKey: #'en_US';
		setStandardCalendarRegistrationKey: GregorianCalendar registrationKey;
		setCharacters: self usEnglishSemanticCharacters;
		setNotationalPolicies: self usEnglishNotationalPolicies;
		setProperNames: self englishProperNames;
		setAbbreviations: self englishAbbreviations;
		setSingularNouns: self englishSingularNouns pluralNouns: self englishPluralNouns! !

!ChronosLocale class methodsFor: 'accessing' stamp: ''!
root
	"ChronosLocale root"

	Root == nil 
		ifTrue: [Root := self at: #'root_ROOT' ifAbsent: [self newRootLocale forceRegistration]].
	^Root! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
rootNotationalPolicies
	RootNotationalPolicies == nil ifTrue: [self initializeRootNotationalPolicies].
	^RootNotationalPolicies! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
rootSemanticCharacters
	RootSemanticCharacters == nil ifTrue: [self initializeRootSemanticCharacters].
	^RootSemanticCharacters! !

!ChronosLocale class methodsFor: 'accessing' stamp: ''!
system
	"ChronosLocale system"

	System == nil ifTrue: [self invalidateSystemLocale].
	^System! !

!ChronosLocale class methodsFor: 'accessing' stamp: ''!
unitedStates
	"ChronosLocale unitedStates"

	US == nil 
		ifTrue: [US := self at: #'en_US' ifAbsent: [self newUSLocale forceRegistration]].
	^US! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
usEnglishNotationalPolicies
	USEnglishNotationalPolicies == nil ifTrue: [self initializeUSEnglishNotationalPolicies].
	^USEnglishNotationalPolicies! !

!ChronosLocale class methodsFor: 'private' stamp: ''!
usEnglishSemanticCharacters
	USEnglishSemanticCharacters == nil ifTrue: [self initializeUSEnglishSemanticCharacters].
	^USEnglishSemanticCharacters! !

!ChronosLocale methodsFor: 'API-Abbreviations' stamp: ''!
abbreviationAtSemanticKey: semanticKey 
	^self 
		abbreviationAtSemanticKey: semanticKey
		ifAbsent: [self properNameAtSemanticKey: semanticKey]! !

!ChronosLocale methodsFor: 'API-Abbreviations' stamp: ''!
abbreviationAtSemanticKey: semanticKey ifAbsent: ifAbsent
	^self class englishAbbreviations at: semanticKey ifAbsent: ifAbsent! !

!ChronosLocale methodsFor: 'initialize-release' stamp: ''!
beDefault
	"(ChronosLocale at: #de_DE) beDefault"
	"(ChronosLocale at: #en_AU) beDefault"
	"(ChronosLocale at: #en_UK) beDefault"
	"(ChronosLocale at: #en_US) beDefault"
	"(ChronosLocale at: #es_ES) beDefault"
	"(ChronosLocale at: #fr_CA) beDefault"
	"(ChronosLocale at: #fr_FR) beDefault"

	self == System 
		ifTrue: [Default := nil]
		ifFalse: [Default := self]! !

!ChronosLocale methodsFor: 'private' stamp: ''!
bindToTemporalPrintPolicy
	temporalPrintPolicy := self temporalPrintPolicy.
	temporalPrintPolicy canConformToLocale 
		ifTrue: 
			[temporalPrintPolicy := temporalPrintPolicy asMutable.
			temporalPrintPolicy confomToLocale: self].
	temporalPrintPolicy beImmutable! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
calendarDurationDayHourSeparator
	^self characterAtSemanticKey: #calendarDurationDayHourSeparator! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
calendarDurationElementNamePolicy
	^self notationalPolicyAt: #calendarDurationElementNamePolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
calendarDurationElementSeparator
	^self characterAtSemanticKey: #calendarDurationElementSeparator! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
calendarDurationElementZeroValuePolicy
	^self notationalPolicyAt: #calendarDurationElementZeroValuePolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
calendarDurationPadChar
	^self characterAtSemanticKey: #calendarDurationPad! !

!ChronosLocale methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	self canonicalizeIdentity.
	self canonicalizeState.! !

!ChronosLocale methodsFor: 'initialize-release' stamp: ''!
canonicalizeIdentity
	registrationKey == nil ifTrue: [self setKeyFromLanguageAndCountryCodes].
	(languageCode == nil or: [countryCode == nil]) 
		ifTrue: [self setLanguageAndCountryCodeFromKey].! !

!ChronosLocale methodsFor: 'initialize-release' stamp: ''!
canonicalizeState
	self bindToTemporalPrintPolicy.! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
characterAtSemanticKey: semanticKey
	^self characterAtSemanticKey: semanticKey ifAbsent: [self signalError: 'No character mapped to ', semanticKey printString]! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
characterAtSemanticKey: semanticKey ifAbsent: ifAbsent
	^self class rootSemanticCharacters at: semanticKey ifAbsent: ifAbsent! !

!ChronosLocale methodsFor: 'accessing' stamp: ''!
countryCode
	^countryCode! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
currencySymbol
	^self characterAtSemanticKey: #currencySymbol! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
dateAndTimeOrder
	^self notationalPolicyAt: #dateAndTimeOrder ifAbsent: [#useDateBeforeTimeOrder]! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
dateAndTimeSeparator
	^self characterAtSemanticKey: #dateAndTimeSeparator! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
datePolicy
	^self notationalPolicyAt: #datePolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
dayOfMonthPadChar
	^self characterAtSemanticKey: #dayOfMonthPad! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
dayOfMonthYearSeparator
	^self characterAtSemanticKey: #dayOfMonthYearSeparator! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
dayOfWeekPolicy
	^self notationalPolicyAt: #dayOfWeekPolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
decimalPointChar
	^self characterAtSemanticKey: #decimalPoint! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
durationDayHourSeparator
	^self characterAtSemanticKey: #durationDayHourSeparator! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
durationElementNamePolicy
	^self notationalPolicyAt: #durationElementNamePolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
durationElementSeparator
	^self characterAtSemanticKey: #durationElementSeparator! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
durationElementZeroValuePolicy
	^self notationalPolicyAt: #durationElementZeroValuePolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
durationPadChar
	^self characterAtSemanticKey: #durationPad! !

!ChronosLocale methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: self languageCode;
		nextPut: self countryCode

	"For ChronosLocale itself (as opposed to any subclasses,) the <timeZoneLocalizationPolicy> <temporalPrintPolicy> are not stored because they should be rebound upon decoding based on the language and country codes."! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
eraPolicy
	^self notationalPolicyAt: #eraPolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
hourMinuteSecondSeparator
	^self characterAtSemanticKey: #hourMinuteSecondSeparator! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
hourPadChar
	^self characterAtSemanticKey: #hourPad! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
hourPolicy
	^self notationalPolicyAt: #hourPolicy! !

!ChronosLocale methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self setLanguageCode: (literalArray at: 3) countryCode: (literalArray at: 4).

	"For ChronosLocale itself (as opposed to any subclasses,) the <timeZoneLocalizationPolicy> <temporalPrintPolicy> are not stored because they should be rebound upon decoding based on the language and country codes."! !

!ChronosLocale methodsFor: 'testing' stamp: ''!
isDefault
	^self == Default! !

!ChronosLocale methodsFor: 'testing' stamp: ''!
isRoot
	^registrationKey == #'root_ROOT'! !

!ChronosLocale methodsFor: 'testing' stamp: ''!
isSystem
	^self == System! !

!ChronosLocale methodsFor: 'testing' stamp: ''!
isUnitedStates
	^self == US! !

!ChronosLocale methodsFor: 'accessing' stamp: ''!
languageCode
	^languageCode! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
monthDayOfMonthSeparator
	^self characterAtSemanticKey: #monthDayOfMonthSeparator! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
monthPadChar
	^self characterAtSemanticKey: #monthPad! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
monthPolicy
	^self notationalPolicyAt: #monthPolicy! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
notationalPolicyAt: policyKey
	^self notationalPolicyAt: policyKey ifAbsent: [self signalError:  'No notational policy mapped to ', policyKey printString]! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
notationalPolicyAt: policyKey ifAbsent: ifAbsent
	^self class rootNotationalPolicies at: policyKey ifAbsent: ifAbsent! !

!ChronosLocale methodsFor: 'API-Nouns' stamp: ''!
pluralNounAtSemanticKey: semanticKey
	^self pluralNounAtSemanticKey: semanticKey ifAbsent: [self properNameAtSemanticKey: semanticKey]! !

!ChronosLocale methodsFor: 'API-Nouns' stamp: ''!
pluralNounAtSemanticKey: semanticKey ifAbsent: ifAbsent
	^self class englishPluralNouns at: semanticKey ifAbsent: ifAbsent! !

!ChronosLocale methodsFor: 'API-Proper Names' stamp: ''!
properNameAtSemanticKey: semanticKey
	^self properNameAtSemanticKey: semanticKey ifAbsent: [semanticKey]! !

!ChronosLocale methodsFor: 'API-Proper Names' stamp: ''!
properNameAtSemanticKey: semanticKey ifAbsent: ifAbsent
	^self class englishProperNames at: semanticKey ifAbsent: ifAbsent! !

!ChronosLocale methodsFor: 'accessing' stamp: ''!
semanticDatePolicy
	^SemanticDatePolicy 
		at: self semanticDatePolicyKey
		ifAbsent: [SemanticDatePolicy default]! !

!ChronosLocale methodsFor: 'accessing' stamp: ''!
semanticDatePolicyKey
	^self registrationKey! !

!ChronosLocale methodsFor: 'private' stamp: ''!
setKeyFromLanguageAndCountryCodes
	registrationKey := 
		self class 
			localeKeyFromLanguageCode: languageCode
			countryCode: countryCode! !

!ChronosLocale methodsFor: 'private' stamp: ''!
setLanguageAndCountryCodeFromKey
	registrationKey == nil ifTrue: [^self].
	self class
		fromLocaleKey: registrationKey 
		setLanuageCodeAndCountryCodeInto: 
			[:lCode :cCode | 
				languageCode := lCode.
				countryCode := cCode]! !

!ChronosLocale methodsFor: 'initialize-release' stamp: ''!
setLanguageCode: langCode countryCode: country
	self assertMutability.
	languageCode := langCode == nil ifFalse: [langCode asSymbol].
	countryCode := country == nil ifFalse: [country asSymbol].! !

!ChronosLocale methodsFor: 'API-Nouns' stamp: ''!
singularNounAtSemanticKey: semanticKey
	^self singularNounAtSemanticKey: semanticKey ifAbsent: [self properNameAtSemanticKey: semanticKey]! !

!ChronosLocale methodsFor: 'API-Nouns' stamp: ''!
singularNounAtSemanticKey: semanticKey ifAbsent: ifAbsent
	^self class englishSingularNouns at: semanticKey ifAbsent: ifAbsent! !

!ChronosLocale methodsFor: 'accessing' stamp: ''!
standardCalendarRegistrationKey
	^Calendar ansiStandard registrationKey! !

!ChronosLocale methodsFor: 'accessing' stamp: ''!
temporalPrintPolicy
	^temporalPrintPolicy == nil 
		ifTrue: 
			[(self delegateIfNone: [^ChronosPrintPolicy newConfigurable]) 
				temporalPrintPolicy]
		ifFalse: [temporalPrintPolicy]! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
thousandsSeparator
	^self characterAtSemanticKey: #thousandsSeparator! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
timeOfDayPolicy
	^self notationalPolicyAt: #timeOfDayPolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
timeOfDayPrefix
	^self characterAtSemanticKey: #timeOfDayPrefix ifAbsent: []! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
timeOfDaySubsecondPolicy
	^self notationalPolicyAt: #timeOfDaySubsecondPolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
timeZoneElementSeparator
	^self characterAtSemanticKey: #timeZoneElementSeparator! !

!ChronosLocale methodsFor: 'accessing' stamp: ''!
timeZoneLocalizationPolicy
	^timeZoneLocalizationPolicy == nil 
		ifTrue: 
			[TimeZoneLocalizationPolicy 
				at: self countryCode
				ifAbsent: [TimeZoneLocalizationPolicy default]]
		ifFalse: [timeZoneLocalizationPolicy]! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
timeZonePolicy
	^self notationalPolicyAt: #timeZonePolicy! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
timeZoneSeparator
	^self characterAtSemanticKey: #timeZoneSeparator! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
yearMonthSeparator
	^self characterAtSemanticKey: #yearMonthSeparator! !

!ChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
yearPadChar
	^self characterAtSemanticKey: #yearPad! !

!ChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
yearPolicy
	^self notationalPolicyAt: #yearPolicy! !

ChronosLocale subclass: #ConfigurableChronosLocale
	instanceVariableNames: 'delegate standardCalendarRegistrationKey semanticDatePolicyKey notationalPolicies characters properNames abbreviations singularNouns pluralNouns'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Localization'!

!ConfigurableChronosLocale commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!ConfigurableChronosLocale class methodsFor: 'private' stamp: ''!
newRegistry
	^self superclass registry! !

!ConfigurableChronosLocale methodsFor: 'API-Abbreviations' stamp: ''!
abbreviationAtSemanticKey: semanticKey ifAbsent: ifAbsent 
	^abbreviations == nil 
		ifTrue: 
			[(self delegateIfNone: [^ifAbsent value]) 
				abbreviationAtSemanticKey: semanticKey
				ifAbsent: ifAbsent]
		ifFalse: 
			[abbreviations 
				at: semanticKey
				ifAbsent: 
					[(self delegateIfNone: [^ifAbsent value]) 
						abbreviationAtSemanticKey: semanticKey
						ifAbsent: ifAbsent]]! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
canonicalizeState
	delegate == nil 
		ifTrue: 
			[self isRoot ifFalse: [self setDelegate: Root]].
	super canonicalizeState.
	semanticDatePolicyKey == nil ifTrue: [self setSemanticDatePolicyKey: self registrationKey]! !

!ConfigurableChronosLocale methodsFor: 'API-Characters/Punctuation' stamp: ''!
characterAtSemanticKey: semanticKey ifAbsent: ifAbsent 
	^characters == nil 
		ifTrue: 
			[(self delegateIfNone: [^ifAbsent value]) 
				characterAtSemanticKey: semanticKey
				ifAbsent: ifAbsent]
		ifFalse: 
			[characters 
				at: semanticKey
				ifAbsent: 
					[(self delegateIfNone: [^ifAbsent value]) 
						characterAtSemanticKey: semanticKey
						ifAbsent: ifAbsent]]! !

!ConfigurableChronosLocale methodsFor: 'accessing' stamp: ''!
delegateIfNone: ifNone 
	^delegate == nil 
		ifTrue: 
			[self isRoot 
				ifTrue: [ifNone value]
				ifFalse: 
					[self isDefault 
						ifTrue: [ChronosLocale system]
						ifFalse: 
							[self isSystem 
								ifTrue: [ChronosLocale root]
								ifFalse: [ChronosLocale default]]]]
		ifFalse: [delegate]! !

!ConfigurableChronosLocale methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: timeZoneLocalizationPolicy registrationKey;
		nextPut: self temporalPrintPolicy registrationKey;
		nextPut: (delegate == nil ifFalse: [delegate registrationKey]);
		nextPut: standardCalendarRegistrationKey;
		nextPut: semanticDatePolicyKey;
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: notationalPolicies);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: characters);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: properNames);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: abbreviations);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: singularNouns);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: pluralNouns)! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	temporalPrintPolicy := ChronosPrintPolicy referencedBy: (literalArray at: 6) decodeAsLiteralArray.
	self 
		setTimeZoneLocalizationPolicy: (literalArray at: 5) decodeAsLiteralArray;
		setDelegate:  (literalArray at: 7);
		setStandardCalendarRegistrationKey: (literalArray at: 8);
		setSemanticDatePolicyKey: (literalArray at: 9);
		setNotationalPolicies: (ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 10));
		setCharacters: (ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 11));
		setProperNames: (ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 12));
		setAbbreviations: (ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 13));
		setSingularNouns: (ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 14)) pluralNouns: (ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 15))! !

!ConfigurableChronosLocale methodsFor: 'API-Notational Policies' stamp: ''!
notationalPolicyAt: policyKey ifAbsent: ifAbsent
	^notationalPolicies == nil 
		ifTrue: 
			[(self delegateIfNone: [^ifAbsent value]) 
				notationalPolicyAt: policyKey
				ifAbsent: ifAbsent]
		ifFalse: 
			[notationalPolicies 
				at: policyKey
				ifAbsent: 
					[(self delegateIfNone: [^ifAbsent value]) 
						notationalPolicyAt: policyKey
						ifAbsent: ifAbsent]]! !

!ConfigurableChronosLocale methodsFor: 'API-Nouns' stamp: ''!
pluralNounAtSemanticKey: semanticKey ifAbsent: ifAbsent 
	^pluralNouns == nil 
		ifTrue: 
			[(self delegateIfNone: [^ifAbsent value]) 
				pluralNounAtSemanticKey: semanticKey
				ifAbsent: ifAbsent]
		ifFalse: 
			[pluralNouns 
				at: semanticKey
				ifAbsent: 
					[(self delegateIfNone: [^ifAbsent value]) 
						pluralNounAtSemanticKey: semanticKey
						ifAbsent: ifAbsent]]! !

!ConfigurableChronosLocale methodsFor: 'private' stamp: ''!
postCopy
	"PRECONDTION: The receiver has just been instantiated as a #shallowCopy of another object.  
	POSTCONDITION: In response to this message, the receiver is required to make itself satisfy the following conditions and constraints: 1) It must be mutable,  2) It must compare (#=) as equal to the object from which it was shallowCopied, and 3) It must satisfy the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the object from which it was shallowCopied must not be changed, and b) whenever the object from which the receiver was shallowCopied mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the receiver must not be changed.  An associative reference is one where the semantics of the reference depend in any way on the object identity (#==) of the referenced object.  An attributive reference is one where any referenced object with the same value can transparently be substituted for any other such value-equivalent object without causing any error."

	"Subclasses may need to subimplement this message in order to satisfy the required semantics.  All subimplementers should send #postCopy to super."

	super postCopy.
	notationalPolicies := notationalPolicies copy.
	characters := characters copy.
	properNames := properNames copy.
	abbreviations := abbreviations copy.
	singularNouns := singularNouns copy.
	pluralNouns := pluralNouns copy.! !

!ConfigurableChronosLocale methodsFor: 'API-Proper Names' stamp: ''!
properNameAtSemanticKey: semanticKey ifAbsent: ifAbsent 
	^properNames == nil 
		ifTrue: 
			[(self delegateIfNone: [^ifAbsent value]) 
				properNameAtSemanticKey: semanticKey
				ifAbsent: ifAbsent]
		ifFalse: 
			[properNames 
				at: semanticKey
				ifAbsent: 
					[(self delegateIfNone: [^ifAbsent value]) 
						properNameAtSemanticKey: semanticKey
						ifAbsent: ifAbsent]]! !

!ConfigurableChronosLocale methodsFor: 'accessing' stamp: ''!
semanticDatePolicyKey
	^semanticDatePolicyKey == nil 
		ifTrue: [(self delegateIfNone: [^self registrationKey]) semanticDatePolicyKey]
		ifFalse: [semanticDatePolicyKey]! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setAbbreviations: aDictionary
	self assertMutability.
	abbreviations := aDictionary! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setCharacters: aDictionary
	self assertMutability.
	characters := aDictionary! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setDelegate: aChronosLocaleOrReference 
	self assertMutability.
	delegate := aChronosLocaleOrReference == nil 
				ifFalse: [ChronosLocale referencedBy: aChronosLocaleOrReference]! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setNotationalPolicies: aDictionary
	self assertMutability.
	notationalPolicies := aDictionary! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setProperNames: aDictionary
	self assertMutability.
	properNames := aDictionary! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setSemanticDatePolicyKey: aSymbol
	self assertMutability.
	semanticDatePolicyKey  := aSymbol == nil ifFalse: [aSymbol asSymbol]! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setSingularNouns: singularDictionary pluralNouns: pluralDictionary
	self assertMutability.
	singularNouns := singularDictionary.
	pluralNouns := pluralDictionary! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setStandardCalendarRegistrationKey: aSymbol
	self assertMutability.
	standardCalendarRegistrationKey := aSymbol == nil ifFalse: [aSymbol asSymbol]! !

!ConfigurableChronosLocale methodsFor: 'initialize-release' stamp: ''!
setTimeZoneLocalizationPolicy: aTimeZoneLocalizationPolicy
	self assertMutability.
	timeZoneLocalizationPolicy := TimeZoneLocalizationPolicy referencedBy: aTimeZoneLocalizationPolicy.! !

!ConfigurableChronosLocale methodsFor: 'API-Nouns' stamp: ''!
singularNounAtSemanticKey: semanticKey ifAbsent: ifAbsent 
	^singularNouns == nil 
		ifTrue: 
			[(self delegateIfNone: [^ifAbsent value]) 
				singularNounAtSemanticKey: semanticKey
				ifAbsent: ifAbsent]
		ifFalse: 
			[singularNouns 
				at: semanticKey
				ifAbsent: 
					[(self delegateIfNone: [^ifAbsent value]) 
						singularNounAtSemanticKey: semanticKey
						ifAbsent: ifAbsent]]! !

!ConfigurableChronosLocale methodsFor: 'accessing' stamp: ''!
standardCalendarRegistrationKey
	^standardCalendarRegistrationKey == nil
		ifTrue: [(self delegateIfNone: [^super standardCalendarRegistrationKey]) standardCalendarRegistrationKey]
		ifFalse: [standardCalendarRegistrationKey]! !

Registratable subclass: #ChronosParser
	instanceVariableNames: 'calendar locale defaultTimeZone timeZoneSeparators twoDigitYearBackwardBias monthNameKeysByMonthName monthNameKeysByMonthAbbreviation minMonthNameSize maxMonthNameSize monthNumberInterpretationPolicy dayOfWeekKeysByName dayOfWeekKeysByAbbreviation minDayOfWeekNameSize maxDayOfWeekNameSize meridianNames meridianNameCharSet minMeridianNameSize maxMeridianNameSize'
	classVariableNames: 'ANSIStandard Default ISO8601 SpecRegistry'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Parsing'!

!ChronosParser class methodsFor: 'accessing' stamp: ''!
ansiStandard
	"ChronosParser ansiStandard nextDateAndTimeFrom: '1776-07-04' readStream"

	ANSIStandard == nil 
		ifTrue: 
			[ANSIStandard := 
				(self newConfigurable)
					setKey: #ansiStandard;
					setCalendar: Gregorian;
					setLocale: ChronosLocale english;
					forceRegistration].
	^ANSIStandard! !

!ChronosParser class methodsFor: 'accessing' stamp: ''!
at: key ifAbsent: notFound 

	| policy |
	key == #default  ifTrue: [^self default].
	key == #iso8601 ifTrue: [^self iso8601].
	key == #ansiStandard ifTrue: [^self ansiStandard].
	policy := self registry at: key ifAbsent: [0].
	^(policy == nil or: [policy = 0])
		ifTrue: 
			[(self applying: (self specificationAt: key ifAbsent: [^notFound value]))
				setKey: key; forceRegistration]
		ifFalse: [policy]! !

!ChronosParser class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	| key |
	key := literalArray at: 2.
	^ChronosParser
		at: key
		ifAbsent: 
			[(self new)
				initializeFromLiteralArray: literalArray;
				beImmutable]! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
calendar: aChronosCalendar
	^(self new)
		setCalendar: aChronosCalendar! !

!ChronosParser class methodsFor: 'accessing' stamp: ''!
default
	"ChronosParser default nextDateAndTimeFrom: '1776-07-04' readStream"

	Default == nil ifTrue: [self newConfigurable beDefault].
	^Default! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
defaultTimeZone: aChronosTimezone
	^(self new)
		setDefaultTimeZone: aChronosTimezone! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
defaultTimeZone: aChronosTimezone twoDigitYearBackwardBias: yearBias
	^(self new)
		setDefaultTimeZone: aChronosTimezone;
		setTwoDigitYearBackwardBias: yearBias.! !

!ChronosParser class methodsFor: 'accessing' stamp: ''!
dmy
	"ChronosParser dmy nextDateFrom: '4 July 1776' readStream"

	^self at: #dmy! !

!ChronosParser class methodsFor: 'class initialization' stamp: ''!
initialize
	"ChronosParser initialize"
 
	self basicInitializeAll.
	Default := nil.
	ANSIStandard := nil.
	ISO8601 := nil.
	self initializeSpecifications! !

!ChronosParser class methodsFor: 'class initialization' stamp: ''!
initializeSpecifications
	"ChronosParser initializeSpecifications"

	self setSpecRegistry.
	self 
		specificationAt: #ymd
		put: #(#expectYMD).

	self 
		specificationAt: #dmy
		put: #(#expectDMY).

	self 
		specificationAt: #mdy
		put: #(#expectMDY).

	self 
		specificationAt: #rfc2822
		put: #(#expectDayOfWeekName #expectDMY setCalendar: #Gregorian setLocale: #en).! !

!ChronosParser class methodsFor: 'accessing' stamp: ''!
iso8601
	"ChronosParser iso8601 nextDateAndTimeFrom: '1776-07-04' readStream"

	ISO8601 == nil 
		ifTrue: 
			[ISO8601 := 
				(self newConfigurable)
					setKey: #iso8601;
					setCalendar: Gregorian;
					setLocale: ChronosLocale english;
					forceRegistration].
	^ISO8601! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
locale: aChronosLocale
	"(ChronosParser locale: #fr_FR) canonicalize"

	^(self new)
		setLocale: aChronosLocale! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
locale: aChronosLocale calendar: aChronosCalendar
	^(self new)
		setLocale: aChronosLocale;
		setCalendar: aChronosCalendar! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
locale: aChronosLocale defaultTimeZone: aChronosTimezone
	^(self new)
		setLocale: aChronosLocale;
		setDefaultTimeZone: aChronosTimezone! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
locale: aChronosLocale defaultTimeZone: aChronosTimezone calendar: aChronosCalendar
	^(self new)
		setLocale: aChronosLocale;
		setDefaultTimeZone: aChronosTimezone;
		setCalendar: aChronosCalendar! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
locale: aChronosLocale defaultTimeZone: aChronosTimezone calendar: aChronosCalendar twoDigitYearBackwardBias: yearBias
	^(self new)
		setLocale: aChronosLocale;
		setDefaultTimeZone: aChronosTimezone;
		setCalendar: aChronosCalendar;
		setTwoDigitYearBackwardBias: yearBias.! !

!ChronosParser class methodsFor: 'accessing' stamp: ''!
mdy
	"ChronosParser mdy nextDateFrom: 'July 4, 1776' readStream"
	"ChronosParser mdy nextDateAndTimeFrom: 'July 4, 1776 at 3:30 pm' readStream"
	"ChronosParser mdy nextDateAndTimeFrom: '7/4/1776 @ 15:30 -0452 pm' readStream"
	"ChronosParser mdy nextDateAndTimeFrom: '07041776 1530-0452 pm' readStream"
	"ChronosParser mdy nextDateAndTimeFrom: '07041776 America/New_York' readStream"
	"ChronosParser mdy nextDateAndTimeFrom: '07041776 EST' readStream"
	"ChronosParser mdy nextDateAndTimeFrom: '07041776 -05:00' readStream"

	^self at: #mdy! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
newConfigurable
	^ConfigurableChronosParser new! !

!ChronosParser class methodsFor: 'accessing' stamp: ''!
referencedBy: aChronosParsOrChronosParsKeyOrChronosParserSpec 
	"Answer the value referenced by <aChronosParsOrChronosParsKeyOrChronosParserSpec>. If the value is a key, answer the value bound to the key. If the value is a sequenceable collection, answer the result of creating an instance of ChronosParse and then sending it the messages that are the elements of the sequenceable collection.  Otherwise, answer aChronosParsOrChronosParsKeyOrChronosParserSpec itself."

	^aChronosParsOrChronosParsKeyOrChronosParserSpec 
		isString 
			ifTrue: [super referencedBy: aChronosParsOrChronosParsKeyOrChronosParserSpec]
			ifFalse: 
				[aChronosParsOrChronosParsKeyOrChronosParserSpec 
					isSequenceable 
						ifTrue: 
							[(self applying: aChronosParsOrChronosParsKeyOrChronosParserSpec) beImmutable]
						ifFalse: 
							[super referencedBy: aChronosParsOrChronosParsKeyOrChronosParserSpec]]! !

!ChronosParser class methodsFor: 'accessing' stamp: ''!
rfc2822
	"ChronosParser rfc2822 nextDateAndTimeFrom: 'Thursday, 04 Jul 1776 12:00:00 -0500' readStream"
	"ChronosParser rfc2822 nextDateAndTimeFrom: '4 JUL 76 12:00:00 EDT' readStream"

	^self at: #rfc2822! !

!ChronosParser class methodsFor: 'private' stamp: ''!
setSpecRegistry
	SpecRegistry := IdentityDictionary new.! !

!ChronosParser class methodsFor: 'private' stamp: ''!
specRegistry
	SpecRegistry == nil ifTrue: [self setSpecRegistry].
	^SpecRegistry! !

!ChronosParser class methodsFor: 'specifications' stamp: ''!
specificationAt: key ifAbsent: ifAbsent
	^self specRegistry at: key ifAbsent: ifAbsent! !

!ChronosParser class methodsFor: 'specifications' stamp: ''!
specificationAt: key put: aPrintPolicySpec
	self specRegistry at: key put: aPrintPolicySpec! !

!ChronosParser class methodsFor: 'instance creation' stamp: ''!
twoDigitYearBackwardBias: yearBias
	^(self new)
		setTwoDigitYearBackwardBias: yearBias.! !

!ChronosParser class methodsFor: 'accessing' stamp: ''!
ymd
	"ChronosParser ymd nextDateFrom: '1776-07-04' readStream"

	^self at: #ymd! !

!ChronosParser methodsFor: 'private' stamp: ''!
basicNewDateAndTimeUsing: dateAndTimeFactory isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second timeZone: timeZone 
	^(dateAndTimeFactory 
		isoYear: (self canonicalYearFromYear: isoYear)
		week: isoWeekOrdinal
		dayOfWeek: isoDayOfWeekOrdinal
		hour: (hour == nil ifTrue: [0] ifFalse: [hour])
		minute: (minute == nil ifTrue: [0] ifFalse: [minute])
		second: (second == nil ifTrue: [0] ifFalse: [second])
		timeZone: timeZone) as: calendar! !

!ChronosParser methodsFor: 'private' stamp: ''!
basicNewDateAndTimeUsing: dateAndTimeFactory year: year day: day hour: hour minute: minute second: second timeZone: timeZone 
	^dateAndTimeFactory 
		year: year
		day: day
		hour: hour
		minute: minute
		second: second
		timeZone: timeZone
		calendar: calendar! !

!ChronosParser methodsFor: 'private' stamp: ''!
basicNewDateAndTimeUsing: dateAndTimeFactory year: year month: month day: day hour: hour minute: minute second: second timeZone: timeZone 
	^dateAndTimeFactory 
		year: year
		month: month
		day: day
		hour: hour
		minute: minute
		second: second
		timeZone: timeZone
		calendar: calendar! !

!ChronosParser methodsFor: 'private' stamp: ''!
basicNewDateUsing: dateFactory isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal
	^(dateFactory 
		isoYear: (self canonicalYearFromYear: isoYear)
		week: isoWeekOrdinal
		dayOfWeek: isoDayOfWeekOrdinal) as: calendar! !

!ChronosParser methodsFor: 'private' stamp: ''!
basicNewDateUsing: dateFactory year: year day: day
	^dateFactory 
		year: year
		day: day
		calendar: calendar! !

!ChronosParser methodsFor: 'private' stamp: ''!
basicNewDateUsing: dateFactory year: year month: month day: day
	^dateFactory 
		year: year
		month: month
		day: day
		calendar: calendar! !

!ChronosParser methodsFor: 'initialize-release' stamp: ''!
beDefault
	self beImmutable.
	Default := self! !

!ChronosParser methodsFor: 'private' stamp: ''!
bindDayOfWeekNamesAndAbbreviations

	dayOfWeekKeysByName := Dictionary new.
	dayOfWeekKeysByAbbreviation := Dictionary new.
	minDayOfWeekNameSize := 99999999.
	maxDayOfWeekNameSize := 0.	
	ANSIDayOfWeekKeys do: 
			[:dayOfWeekKey | 
			| name abbreviation |
			name := (locale properNameAtSemanticKey: dayOfWeekKey) asUppercase.
			abbreviation := (locale abbreviationAtSemanticKey: dayOfWeekKey) asUppercase.
			dayOfWeekKeysByName at: name put: dayOfWeekKey.
			dayOfWeekKeysByAbbreviation at: abbreviation put: dayOfWeekKey.
			minDayOfWeekNameSize := minDayOfWeekNameSize 
						min: (name size min: abbreviation size).
			maxDayOfWeekNameSize := maxDayOfWeekNameSize 
						max: (name size max: abbreviation size)]! !

!ChronosParser methodsFor: 'private' stamp: ''!
bindMeridianNames
	meridianNames := MeridianKeys collect: [:semanticKey | (self locale properNameAtSemanticKey: semanticKey) asUppercase asSymbol].
	meridianNameCharSet := Set new.
	minMeridianNameSize := 999.
	maxMeridianNameSize := 0.
	meridianNames do: [:name | 
		meridianNameCharSet addAll: name; addAll: name asLowercase.
		minMeridianNameSize := minMeridianNameSize min: name size.
		maxMeridianNameSize := maxMeridianNameSize max: name size].! !

!ChronosParser methodsFor: 'private' stamp: ''!
bindMonthNamesAndAbbreviations

	monthNameKeysByMonthName := Dictionary new.
	monthNameKeysByMonthAbbreviation := Dictionary new.
	minMonthNameSize := 99999999.
	maxMonthNameSize := 0.	
	calendar monthNameKeysDo: 
			[:monthNameKey | 
			| name abbreviation |
			name := (locale properNameAtSemanticKey: monthNameKey) asUppercase.
			abbreviation := (locale abbreviationAtSemanticKey: monthNameKey) asUppercase.
			monthNameKeysByMonthName at: name put: monthNameKey.
			monthNameKeysByMonthAbbreviation at: abbreviation put: monthNameKey.
			minMonthNameSize := minMonthNameSize 
						min: (name size min: abbreviation size).
			maxMonthNameSize := maxMonthNameSize 
						max: (name size max: abbreviation size)]! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
calendar
	^calendar! !

!ChronosParser methodsFor: 'API-utility' stamp: ''!
canonicalMonthFromMonth: month year: year 
	^month isInteger 
		ifTrue: [self canonicalMonthFromMonthNumber: month inYear: year]
		ifFalse: [self canonicalMonthFromMonthNameKey: month inYear: year]! !

!ChronosParser methodsFor: 'API-utility' stamp: ''!
canonicalMonthFromMonthNameKey: monthNameKey inYear: year 
	^calendar 
		monthOrdinalForMonthWithKey: (calendar monthKeyAtMonthNameKey: monthNameKey)
		inYear: year! !

!ChronosParser methodsFor: 'API-utility' stamp: ''!
canonicalMonthFromMonthNumber: monthNumber inYear: year 
	^self 
		perform: monthNumberInterpretationPolicy
		with: monthNumber
		with: year! !

!ChronosParser methodsFor: 'API-utility' stamp: ''!
canonicalMonthFromMonthOrdinal: monthOrdinal inYear: year
	^monthOrdinal! !

!ChronosParser methodsFor: 'API-utility' stamp: ''!
canonicalMonthFromNumericMonthDesignator: numericMonthDesignator inYear: year
	^calendar monthOrdinalFromNumericMonthDesignator: numericMonthDesignator inYear: year! !

!ChronosParser methodsFor: 'API-utility' stamp: ''!
canonicalYearFromYear: year 
	^twoDigitYearBackwardBias == nil 
		ifTrue: [calendar fullYearFromTwoDigitYear: year]
		ifFalse: 
			[calendar 
				fullYearFromTwoDigitYear: year
				backwardBias: twoDigitYearBackwardBias]! !

!ChronosParser methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	super canonicalize.
	timeZoneSeparators == nil ifTrue: [timeZoneSeparators := self constructTimeZoneSeparators].
	locale == nil ifTrue: [locale := ChronosLocale default].
	self bindMonthNamesAndAbbreviations.
	self bindDayOfWeekNamesAndAbbreviations.
	self bindMeridianNames! !

!ChronosParser methodsFor: 'private' stamp: ''!
constructTimeZoneSeparators
	^Array
		with: $-
		with: $+
		with: Character cr
		with: Character lf! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
defaultCalendarDurationFactory
	^CalendarDurationFactory! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
defaultCivilDurationFactory
	^CivilDurationFactory! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
defaultDateAndTimeFactory
	^DateAndTimeFactory! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
defaultDateFactory
	^DateFactory! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
defaultDurationFactory
	^DurationFactory! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
defaultTimeOfDayFactory
	^TimeOfDayFactory! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
defaultTimeZone
	^defaultTimeZone == nil 
		ifTrue: [ChronosTimezone default]
		ifFalse: [defaultTimeZone]! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
defaultTimeperiodFactory
	^TimeperiodFactory! !

!ChronosParser methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	"ChronosParser iso8601 literalArrayEncoding"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: calendar registrationKey;
		nextPut: locale literalArrayEncoding;
		nextPut: defaultTimeZone literalArrayEncoding;
		nextPut: twoDigitYearBackwardBias;
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: monthNameKeysByMonthName);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: monthNameKeysByMonthAbbreviation);
		nextPut: minMonthNameSize;
		nextPut: maxMonthNameSize;
		nextPut: monthNumberInterpretationPolicy;
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: dayOfWeekKeysByName);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: dayOfWeekKeysByAbbreviation);
		nextPut: minDayOfWeekNameSize;
		nextPut: maxDayOfWeekNameSize;
		nextPut: meridianNames;
		nextPut: meridianNameCharSet asArray;
		nextPut: minMeridianNameSize;
		nextPut: maxMeridianNameSize! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleDayOfWeek: dayOfWeeKey inconsistentWithThatOf: aDate 
	| actualDayOfWeekKey |
	actualDayOfWeekKey := aDate dayOfWeekKey.
	^self 
		signalError: 'The specified day of week, ' 
				, (self locale properNameAtSemanticKey: dayOfWeeKey) 
					, ', is not consistent wth that of the specified date, ' 
					, (aDate printStringForLocale: self locale),
					' (which occurs on a ', (self locale properNameAtSemanticKey: actualDayOfWeekKey), ')'! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidDayOfMonth: dayOfMonth digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid day-of-month: ', dayOfMonth printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidDays: days digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid days: ', days printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidHour: hour digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid hour: ', hour printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidIsoDayOfWeek: dayOfWeek digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid day-of-week: ', dayOfWeek printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidMinute: minute digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid minute: ', minute printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidMonth: month problemKey: problemKey
	^self signalError: 'Invalid month: ', month printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidMonths: months digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid months: ', months printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidSecond: second digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid second: ', second printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidYear: year digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid year: ', year printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleInvalidYears: years digitCount: digitCount problemKey: problemKey
	^self signalError: 'Invalid years: ', years printString, ' problem:', problemKey! !

!ChronosParser methodsFor: 'error handling' stamp: ''!
handleUnexpectedCharacter: char for: format
	^self signalError: 'Unexpected/inalid character: ', (String with: char), ' in ', format! !

!ChronosParser methodsFor: 'initialize-release' stamp: ''!
initialize 
	self assertMutability.
	timeZoneSeparators := self constructTimeZoneSeparators.
	calendar := AnsiStandardCalendar.
	locale := nil.
	defaultTimeZone := ChronosTimezone nominal.
	twoDigitYearBackwardBias := nil.
	self interpretMonthNumberAsOrdinal.! !

!ChronosParser methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	"ChronosParser iso8601 literalArrayEncoding decodeAsLiteralArray"

	super initializeFromLiteralArray: literalArray.
	self 
		setCalendar: (literalArray at: 3);
		setLocale: (literalArray at: 4) decodeAsLiteralArray;
		setDefaultTimeZone: (literalArray at: 5) decodeAsLiteralArray;
		setTwoDigitYearBackwardBias: (literalArray at: 6).
	monthNameKeysByMonthName := ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 7).
	monthNameKeysByMonthAbbreviation := ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 8).
	minMonthNameSize := literalArray at: 9.
	maxMonthNameSize := literalArray at: 10.
	monthNumberInterpretationPolicy := literalArray at: 11.
	dayOfWeekKeysByName := ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 12).
	dayOfWeekKeysByAbbreviation := ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 13).
	minDayOfWeekNameSize := literalArray at: 14.
	maxDayOfWeekNameSize := literalArray at: 15.
	meridianNames := literalArray at: 16.
	meridianNameCharSet := Set withAll: (literalArray at: 17) .
	minMeridianNameSize := literalArray at: 18.
	maxMeridianNameSize := literalArray at: 19.! !

!ChronosParser methodsFor: 'configuration-dates' stamp: ''!
interpretMonthNumberAsNumericDesignator
	self assertMutability.
	monthNumberInterpretationPolicy := #canonicalMonthFromNumericMonthDesignator:inYear:.! !

!ChronosParser methodsFor: 'configuration-dates' stamp: ''!
interpretMonthNumberAsOrdinal
	self assertMutability.
	monthNumberInterpretationPolicy := #canonicalMonthFromMonthOrdinal:inYear:.! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
locale
	^locale! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
maxMonthNameSize
	^maxMonthNameSize! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
minMonthNameSize
	^minMonthNameSize! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
monthAbbreviations
	^monthNameKeysByMonthAbbreviation keys! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
monthNameKeys
	^monthNameKeysByMonthName values! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
monthNames
	^monthNameKeysByMonthName keys! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newCalendarDurationUsing: calendarDurationFactory years: years months: months days: days 
	^calendarDurationFactory 
		years: years
		months: months
		days: days! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newCivilDurationUsing: civilDurationFactory years: years months: months days: days hours: hours minutes: minutes seconds: seconds 
	^(hours = 0 and: [minutes = 0 and: [seconds = 0]]) 
		ifTrue: 
			[self 
				newCalendarDurationUsing: civilDurationFactory calendarDurationFactory
				years: years
				months: months
				days: days]
		ifFalse: 
			[civilDurationFactory 
				years: years
				months: months
				days: days
				hours: hours
				minutes: minutes
				seconds: seconds]! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newDateAndTimeUsing: dateAndTimeFactory isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal hour: hour minute: minute second: second timeZone: timeZone 
	isoWeekOrdinal == nil 
		ifTrue: 
			[^self 
				newDateUsing: dateAndTimeFactory dateFactory
				year: isoYear
				day: nil
				timeZone: timeZone].
	^isoDayOfWeekOrdinal == nil 
		ifTrue: 
			[isoYear == nil
				ifTrue:
					[self 
						newTimeOfDayUsing: dateAndTimeFactory timeOfDayFactory
						hour: hour
						minute: minute
						second: second]
				ifFalse:
					[self 
						newDateUsing: dateAndTimeFactory dateFactory
						isoYear: isoYear
						week: isoWeekOrdinal
						dayOfWeek: isoDayOfWeekOrdinal
						timeZone: timeZone]]
		ifFalse: 
			[hour == nil 
				ifTrue: 
					[self 
						newDateUsing: dateAndTimeFactory dateFactory 
						isoYear: isoYear 
						week: isoWeekOrdinal
						dayOfWeek: isoDayOfWeekOrdinal 
						timeZone: timeZone]
				ifFalse: 
					[| canonicalYear |
					canonicalYear := self canonicalYearFromYear: isoYear.
					minute == nil
						ifTrue: 
							[self 
								newTimeperiodUsing: dateAndTimeFactory timeperiodFactory
								from: 
									(self 
										basicNewDateAndTimeUsing: dateAndTimeFactory 
										isoYear: canonicalYear
										week: isoWeekOrdinal
										dayOfWeek: isoDayOfWeekOrdinal
										hour: hour
										minute: 0
										second: 0
										timeZone: timeZone)
								duration: (dateAndTimeFactory civilDurationFactory hours: 1)]
						ifFalse:
							[second == nil
								ifTrue:
									[self 
										newTimeperiodUsing: dateAndTimeFactory timeperiodFactory
										from: 
											(self 
												basicNewDateAndTimeUsing: dateAndTimeFactory
												isoYear: canonicalYear
												week: isoWeekOrdinal
												dayOfWeek: isoDayOfWeekOrdinal
												hour: hour
												minute: minute
												second: 0
												timeZone: timeZone)
										duration: (dateAndTimeFactory civilDurationFactory minutes: 1)]
								ifFalse:
									[self 
										basicNewDateAndTimeUsing: dateAndTimeFactory 
										isoYear: canonicalYear
										week: isoWeekOrdinal
										dayOfWeek: isoDayOfWeekOrdinal
										hour: hour
										minute: minute
										second: second
										timeZone: timeZone]]]]! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newDateAndTimeUsing: dateAndTimeFactory year: year day: day hour: hour minute: minute second: second timeZone: timeZone 
	^day == nil 
		ifTrue: 
			[year == nil
				ifTrue:
					[self 
						newTimeOfDayUsing: dateAndTimeFactory timeOfDayFactory
						hour: hour
						minute: minute
						second: second]
				ifFalse:
					[self 
						newDateUsing: dateAndTimeFactory dateFactory
						year: year
						day: day
						timeZone: timeZone]]
		ifFalse: 
			[hour == nil 
				ifTrue: 
					[self 
						newDateUsing: dateAndTimeFactory dateFactory 
						year: year 
						day: day 
						timeZone: timeZone]
				ifFalse: 
					[| canonicalYear |
					canonicalYear := self canonicalYearFromYear: year.
					minute == nil
						ifTrue: 
							[self 
								newTimeperiodUsing: dateAndTimeFactory timeperiodFactory
								from: 
									(self 
										basicNewDateAndTimeUsing: dateAndTimeFactory 
										year: canonicalYear
										day: day
										hour: hour
										minute: 0
										second: 0
										timeZone: timeZone)
								duration: (dateAndTimeFactory civilDurationFactory hours: 1)]
						ifFalse:
							[second == nil
								ifTrue:
									[self 
										newTimeperiodUsing: dateAndTimeFactory timeperiodFactory
										from: 
											(self 
												basicNewDateAndTimeUsing: dateAndTimeFactory
												year: canonicalYear
												day: day
												hour: hour
												minute: minute
												second: 0
												timeZone: timeZone)
										duration: (dateAndTimeFactory civilDurationFactory minutes: 1)]
								ifFalse:
									[self 
										basicNewDateAndTimeUsing: dateAndTimeFactory 
										year: canonicalYear
										day: day
										hour: hour
										minute: minute
										second: second
										timeZone: timeZone]]]]! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newDateAndTimeUsing: dateAndTimeFactory year: year month: month day: day hour: hour minute: minute second: second timeZone: timeZone 
	^month == nil 
		ifTrue: 
			[self 
				newDateAndTimeUsing: dateAndTimeFactory 
				year: year 
				day: day 
				hour: hour 
				minute: minute 
				second: second 
				timeZone: timeZone]
		ifFalse: 
			[(month isSymbol or: [month >= 0]) 
				ifTrue: 
					[day == nil
						ifTrue:
							[self 
								newDateUsing: dateAndTimeFactory dateFactory
								year: year
								month: month
								day: day
								timeZone: timeZone]
						ifFalse:
							[hour == nil
								ifTrue:
									[self 
										newDateUsing: dateAndTimeFactory dateFactory
										year: year
										month: month
										day: day
										timeZone: timeZone]
								ifFalse:
									[| canonicalYear canonicalMonth |
									canonicalYear := self canonicalYearFromYear: year.
									canonicalMonth := self canonicalMonthFromMonth: month year: canonicalYear.
									minute == nil
										ifTrue:
											[self
												newTimeperiodUsing: dateAndTimeFactory timeperiodFactory
												from: 
													(self
														basicNewDateAndTimeUsing: dateAndTimeFactory
														year:  canonicalYear
														month: canonicalMonth
														day: day
														hour: hour
														minute: 0
														second: 0
														timeZone: timeZone)
												duration: (dateAndTimeFactory civilDurationFactory hours: 1)]
										ifFalse:
											[second == nil
												ifTrue:
													[self
														newTimeperiodUsing: dateAndTimeFactory timeperiodFactory
														from: 
															(self
																basicNewDateAndTimeUsing: dateAndTimeFactory
																year:  canonicalYear
																month: canonicalMonth
																day: day
																hour: hour
																minute: minute
																second: 0
																timeZone: timeZone)
														duration: (dateAndTimeFactory civilDurationFactory minutes: 1)]
												ifFalse:
													[self
														basicNewDateAndTimeUsing: dateAndTimeFactory 
														year: canonicalYear
														month: canonicalMonth
														day: day
														hour: hour
														minute: minute
														second: second
														timeZone: timeZone]]]]]
				ifFalse: 
					[self 
						newDateAndTimeUsing: dateAndTimeFactory
						isoYear: year
						week: month abs
						dayOfWeek: day
						hour: hour
						minute: minute
						second: second
						timeZone: timeZone]]! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newDateUsing: dateFactory isoYear: isoYear week: isoWeekOrdinal dayOfWeek: isoDayOfWeekOrdinal timeZone: timeZone 
	isoWeekOrdinal == nil 
		ifTrue: 
			[^self 
				newDateUsing: dateFactory
				year: isoYear
				day: nil
				timeZone: timeZone].
	^isoDayOfWeekOrdinal == nil
		ifTrue:
			[| canonicalYear |
			canonicalYear := self canonicalYearFromYear: isoYear.
			self 
				newTimeperiodUsing: dateFactory timeperiodFactory
				from: 
					(timeZone isInvariantToNominalTime 
						ifTrue:
							[self 
								basicNewDateUsing: dateFactory 
								isoYear: canonicalYear
								week: isoWeekOrdinal
								dayOfWeek: 1]
						ifFalse:
							[self 
								basicNewDateAndTimeUsing: dateFactory dateAndTimeFactory
								isoYear: canonicalYear
								week: isoWeekOrdinal
								dayOfWeek: 1
								hour: 0
								minute: 0
								second: 0
								timeZone: timeZone])
				duration: (dateFactory calendarDurationFactory weeks: 1)]
		ifFalse:
			[timeZone isInvariantToNominalTime 
				ifTrue: 
					[self basicNewDateUsing: dateFactory 
						isoYear: (self canonicalYearFromYear: isoYear)
						week: isoWeekOrdinal
						dayOfWeek: isoDayOfWeekOrdinal]
				ifFalse: 
					[self 
						newTimeperiodUsing: dateFactory timeperiodFactory
						from: 
							(self basicNewDateUsing: dateFactory 
								isoYear: (self canonicalYearFromYear: isoYear)
								week: isoWeekOrdinal
								dayOfWeek: isoDayOfWeekOrdinal)
						duration: (dateFactory calendarDurationFactory days: 1)]]! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newDateUsing: dateFactory year: year day: day timeZone: timeZone 
	| canonicalYear |
	canonicalYear := self canonicalYearFromYear: year.
	^day == nil
		ifTrue:
			[self 
				newTimeperiodUsing: dateFactory timeperiodFactory
				from: 
					(timeZone isInvariantToNominalTime
						ifTrue:
							[self
								basicNewDateUsing: dateFactory
								year: canonicalYear
								day: 1]
						ifFalse:
							[self
								basicNewDateAndTimeUsing: dateFactory dateAndTimeFactory
								year: canonicalYear
								day: 1
								hour: 0
								minute: 0
								second: 0
								timeZone: timeZone])
				duration: (dateFactory calendarDurationFactory years: 1)]
		ifFalse:
			[timeZone isInvariantToNominalTime
				ifTrue: 
					[self 
						basicNewDateUsing: dateFactory 
						year: canonicalYear
						day: day]
				ifFalse: 
					[self 
						newTimeperiodUsing: dateFactory timeperiodFactory
						from: 
							(self
								basicNewDateAndTimeUsing: dateFactory dateAndTimeFactory
								year: canonicalYear
								day: day
								hour: 0
								minute: 0
								second: 0
								timeZone: timeZone)
						duration: (dateFactory calendarDurationFactory days: 1)]]! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newDateUsing: dateFactory year: year month: month day: day timeZone: timeZone 
	month == nil 
		ifTrue: 
			[^self 
				newDateUsing: dateFactory
				year: year
				day: day
				timeZone: timeZone].
	^(month isSymbol or: [month >= 0]) 
		ifTrue: 
			[| canonicalYear canonicalMonth |
			canonicalYear := self canonicalYearFromYear: year.
			canonicalMonth := self canonicalMonthFromMonth: month year: canonicalYear.
			day == nil
				ifTrue:
					[self 
						newTimeperiodUsing: dateFactory timeperiodFactory
						from: 
							(timeZone isInvariantToNominalTime
								ifTrue:
									[self
										basicNewDateUsing: dateFactory
										year: canonicalYear
										month: canonicalMonth
										day: 1]
								ifFalse:
									[self
										basicNewDateAndTimeUsing: dateFactory dateAndTimeFactory
										year: canonicalYear
										month: canonicalMonth
										day: 1
										hour: 0
										minute: 0
										second: 0
										timeZone: timeZone])
						duration: (dateFactory calendarDurationFactory months: 1)]
				ifFalse:
					[timeZone isInvariantToNominalTime
						ifTrue: 
							[self 
								basicNewDateUsing: dateFactory 
								year: canonicalYear
								month: canonicalMonth
								day: day]
						ifFalse: 
							[self 
								newTimeperiodUsing: dateFactory timeperiodFactory
								from: 
									(self
										basicNewDateAndTimeUsing: dateFactory dateAndTimeFactory
										year: canonicalYear
										month: canonicalMonth
										day: day
										hour: 0
										minute: 0
										second: 0
										timeZone: timeZone)
								duration: (dateFactory calendarDurationFactory days: 1)]]]
		ifFalse: 
			[self 
				newDateUsing: dateFactory
				isoYear: year
				week: month abs
				dayOfWeek: day
				timeZone: timeZone]! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newDurationUsing: durationFactory days: days hours: hours minutes: minutes seconds: seconds 
	^durationFactory 
		days: days
		hours: hours
		minutes: minutes
		seconds: seconds! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newTimeOfDayUsing: timeOfDayFactory hour: hour minute: minute second: second 
	^minute == nil 
		ifTrue: 
			[self
				newTimeperiodUsing: timeOfDayFactory timeperiodFactory 
				from: 
					(timeOfDayFactory 
						hour: hour
						minute: 0
						second: 0) 
				duration: (timeOfDayFactory civilDurationFactory hours: 1)]
		ifFalse: 
			[second == nil 
				ifTrue: 
					[self
						newTimeperiodUsing: timeOfDayFactory timeperiodFactory 
						from: 
							(timeOfDayFactory 
								hour: hour
								minute: minute
								second: 0) 
						duration: (timeOfDayFactory civilDurationFactory minutes: 1)]
				ifFalse: 
					[timeOfDayFactory 
						hour: hour
						minute: minute
						second: second]]! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newTimeperiodUsing: timePeriodFactory from: startingPoint duration: duration 
	^timePeriodFactory from: startingPoint duration: duration! !

!ChronosParser methodsFor: 'API-date/time/duration/period instantiation' stamp: ''!
newTimeperiodUsing: timePeriodFactory from: startingPoint to: limitMoment 
	^timePeriodFactory from: startingPoint to: limitMoment! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextCalendarDurationFrom: stream 
	"ChronosParser default nextCalendarDurationFrom: 'P48Y8M27D' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'P48Y8M27DT18H16M55.062077S' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'PT18H16M55.062077S' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'P48Y8M' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'P48Y' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'P18M' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'P180D' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'P2006-12-31' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'P2006-12-31T12:05:19.4224562' readStream"
	"ChronosParser default nextCalendarDurationFrom: 'PT12:05:19.4224562' readStream"

	^self nextCalendarDurationFrom: stream usingFactory: self defaultCivilDurationFactory! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextCalendarDurationFrom: stream usingFactory: calendarDurationFactory 
	^self subclassResponsibility! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextCivilDurationFrom: stream 
	"ChronosParser default nextCivilDurationFrom: 'P48Y8M27D' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P48Y8M27DT18H16M55.062077S' readStream"
	"ChronosParser default nextCivilDurationFrom: 'PT18H16M55.062077S' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P18H16M55.062077S' readStream"
	"ChronosParser default nextCivilDurationFrom: 'PT18H16M' readStream"
	"ChronosParser default nextCivilDurationFrom: 'PT18H' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P18.5H' readStream"
	"ChronosParser default nextCivilDurationFrom: 'PT16.5M' readStream"
	"ChronosParser default nextCivilDurationFrom: 'PT55.062077S' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P18H' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P55.062077S' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P48Y8M' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P48Y' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P18M' readStream"
	"ChronosParser default nextCivilDurationFrom: 'PT18M' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P180D' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P2006-12-31' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P2006-12-31T12:05:19.4224562' readStream"
	"ChronosParser default nextCivilDurationFrom: 'PT12:05:19.4224562' readStream"
	"ChronosParser default nextCivilDurationFrom: 'P12:05:19.4224562' readStream"

	^self nextCivilDurationFrom: stream usingFactory: self defaultCivilDurationFactory! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextCivilDurationFrom: stream usingFactory: civilDurationFactory 
	^self subclassResponsibility! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDateAndTimeFrom: stream 
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004-Feb-29' readStream"
	"ChronosParser ansiStandard nextDateAndTimeFrom: '2004-Feb-29' readStream"
	"ChronosParser default nextDateAndTimeFrom: '2004-Feb-29' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004-02-29' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '20040229' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004-060' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004060' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004-W09-7' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004W097' readStream"

	^self 
		nextDateAndTimeFrom: stream
		usingFactory: self defaultDateAndTimeFactory! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDateAndTimeFrom: stream usingFactory: dateAndTimeFactory 
	^self subclassResponsibility! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDateFrom: stream 
	"ChronosParser default nextDateFrom: '2004-Feb-29' readStream"
	"ChronosParser iso8601 nextDateFrom: '20040229' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004-060' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004060' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004-W09-7' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004W097' readStream"

	^self nextDateFrom: stream usingFactory: self defaultDateFactory! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDateFrom: stream usingFactory: dateFactory 
	^self subclassResponsibility! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDurationFrom: stream 
	"ChronosParser default nextDurationFrom: '1:23:59:59' readStream"
	"ChronosParser default nextDurationFrom: '00:00:00:00.000000001' readStream"
	"ChronosParser default nextDurationFrom: '-00:00:00:00.000000001' readStream"
	"ChronosParser default nextDurationFrom: '-365:23:59:59' readStream"
	"ChronosParser default nextDurationFrom: '1:23:59:60' readStream" "invalid"

	^self nextDurationFrom: stream usingFactory: self defaultDurationFactory! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDurationFrom: stream usingFactory: durationFactory 
	^self subclassResponsibility! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDurationalFrom: stream 
	ChronosFunction skipSeparators: stream.
	^stream peek = $P
		ifTrue: [self nextCivilDurationFrom: stream]
		ifFalse: [self nextDurationFrom: stream]! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextTimeOfDayFrom: stream 
	"ChronosParser default nextTimeOfDayFrom: '23:59:60' readStream"
	"ChronosParser default nextTimeOfDayFrom: 'T00:00:00.000000001' readStream"
	"ChronosParser default nextTimeOfDayFrom: '23:59:61' readStream"

	^self nextTimeOfDayFrom: stream usingFactory: self defaultTimeOfDayFactory! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextTimeOfDayFrom: stream usingFactory: timeOfDayFactory 
	^self subclassResponsibility! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextTimeperiodFrom: stream 
	"{ChronosParser default nextTimeperiodFrom: '2007-07-01/P1Y6M15D' readStream}
	{ChronosParser default nextTimeperiodFrom: '2002-03-01/2003-05-11' readStream}
	{ChronosParser default nextTimeperiodFrom: '2002-03-01T13:00:00Z/2003-05-11T15:30:00Z' readStream}
	{ChronosParser default nextTimeperiodFrom: '2002-03-01/P1Y2M10DT2H30M' readStream}
	{ChronosParser default nextTimeperiodFrom: '2002-03-01T13:00:00Z/P1Y2M10DT2H30M' readStream}
	{ChronosParser default nextTimeperiodFrom: 'P1Y2M10DT2H30M/2003-05-11' readStream}
	{ChronosParser default nextTimeperiodFrom: 'P1Y2M10DT2H30M/2003-05-11T15:30:00Z' readStream}
	{ChronosParser default nextTimeperiodFrom: '2002-03-01/182:12:30:30.5' readStream}"

	^self nextTimeperiodFrom: stream usingFactory: self defaultTimeperiodFactory! !

!ChronosParser methodsFor: 'API-parsing' stamp: ''!
nextTimeperiodFrom: stream usingFactory: timeperiodFactory 
	^self subclassResponsibility! !

!ChronosParser methodsFor: 'parsing-utility' stamp: ''!
parseOptionalTokenFrom: stream prefixPredicate: prefixPredicate tokenPredicate: tokenPredicate minChars: minChars maxChars: maxChars acceptancePredicate: acceptancePredicate 
	"{| stream token |
	stream := '   Wednesday, ' readStream .
	token := ChronosParser default 
				parseOptionalTokenFrom: stream
				prefixPredicate: [:ch | ch isSeparator] 
				tokenPredicate: [:ch :count | ch isAlphabetic] 
				minChars: 1 
				maxChars: 80 
				acceptancePredicate: [:dayOfWeekName | ANSIDayOfWeekKeys includes: dayOfWeekName asSymbol].
	Array with: token with: stream upToEnd}"

	"{| stream token |
	stream := '   March 17' readStream .
	token := ChronosParser default 
				parseOptionalTokenFrom: stream
				prefixPredicate: [:ch | ch isSeparator] 
				tokenPredicate: [:ch :count | ch isAlphabetic] 
				minChars: 1 
				maxChars: 80 
				acceptancePredicate: [:dayOfWeekName | ANSIDayOfWeekKeys includes: dayOfWeekName asSymbol].
	Array with: token with: stream upToEnd}"

	| startPosition token count |
	startPosition := stream position.
	ChronosFunction skipOver: stream while: prefixPredicate.
	stream atEnd 
		ifTrue: 
			[stream skip: startPosition - stream position.
			^false->nil].
	count := 0.
	token := ChronosFunction 
				nextFrom: stream
				while: 
					[:ch | 
					count := count + 1.
					tokenPredicate value: ch value: count]
				minChars: minChars
				maxChars: maxChars
				onUnexpectedEOD: 
					[:prefix :ch :position | 
					stream skip: startPosition - stream position.
					^false -> prefix].
	^(acceptancePredicate value: token) 
		ifTrue: [true -> token]
		ifFalse: 
			[stream skip: startPosition - stream position.
			false -> token]! !

!ChronosParser methodsFor: 'initialize-release' stamp: ''!
setCalendar: aCalendar 
	self assertMutability.
	calendar := Calendar referencedBy: aCalendar! !

!ChronosParser methodsFor: 'initialize-release' stamp: ''!
setDefaultTimeZone: timeZone 
	self assertMutability.
	defaultTimeZone := timeZone == nil ifFalse: [ChronosTimezone referencedBy: timeZone]! !

!ChronosParser methodsFor: 'initialize-release' stamp: ''!
setLocale: aLocale 
	self assertMutability.
	locale := ChronosLocale referencedBy: aLocale! !

!ChronosParser methodsFor: 'initialize-release' stamp: ''!
setTwoDigitYearBackwardBias: anInteger 
	self assertMutability.
	twoDigitYearBackwardBias := anInteger! !

!ChronosParser methodsFor: 'API-utility' stamp: ''!
timeZoneWithNameOrAbbreviation: timeZoneNameOrAbbreviation ifNone: ifNoneBlock 
	(ChronosFunction isNilOrEmpty: timeZoneNameOrAbbreviation) 
		ifTrue: [^ifNoneBlock value].
	timeZoneNameOrAbbreviation = 'T' ifTrue: [^ifNoneBlock value].
	^ChronosTimezone at: timeZoneNameOrAbbreviation
		ifAbsent: 
			[timeZoneNameOrAbbreviation size < 3 
				ifTrue: [ifNoneBlock value]
				ifFalse: 
					[ChronosTimezone 
						atAbbreviation: timeZoneNameOrAbbreviation
						inLocale: self locale
						dstPreferred: true
						ifAbsent: [ifNoneBlock value]]]! !

!ChronosParser methodsFor: 'accessing' stamp: ''!
twoDigitYearBackwardBias
	^twoDigitYearBackwardBias! !

ChronosParser subclass: #ConfigurableChronosParser
	instanceVariableNames: 'expectDayOfWeekName dateSyntax dateAndTimeSyntax'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Parsing'!

!ConfigurableChronosParser class methodsFor: 'private' stamp: ''!
newRegistry
	^self superclass registry! !

!ConfigurableChronosParser methodsFor: 'configuration-dates' stamp: ''!
doNotExpectDayOfWeekName
	self assertMutability.
	expectDayOfWeekName := false! !

!ConfigurableChronosParser methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	"ChronosParser iso8601 literalArrayEncoding"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: expectDayOfWeekName;
		nextPut: dateSyntax;
		nextPut: dateAndTimeSyntax! !

!ConfigurableChronosParser methodsFor: 'configuration-dates' stamp: ''!
expectDMY
	self assertMutability.
	dateSyntax := #parseDayMonthYearFrom:into:! !

!ConfigurableChronosParser methodsFor: 'configuration-dateAndTime' stamp: ''!
expectDateThenTime
	self assertMutability.
	dateAndTimeSyntax := #parseDateThenTimeFrom:into:! !

!ConfigurableChronosParser methodsFor: 'configuration-dates' stamp: ''!
expectDayOfWeekName
	self assertMutability.
	expectDayOfWeekName := true! !

!ConfigurableChronosParser methodsFor: 'configuration-dates' stamp: ''!
expectMDY
	self assertMutability.
	dateSyntax := #parseMonthDayYearFrom:into:! !

!ConfigurableChronosParser methodsFor: 'configuration-dateAndTime' stamp: ''!
expectTimeThenDate
	self assertMutability.
	dateAndTimeSyntax := #parseTimeThenDateFrom:into:! !

!ConfigurableChronosParser methodsFor: 'configuration-dates' stamp: ''!
expectYDM
	self assertMutability.
	dateSyntax := #parseYearDayMonthFrom:into:! !

!ConfigurableChronosParser methodsFor: 'configuration-dates' stamp: ''!
expectYMD
	self assertMutability.
	dateSyntax := #parseYearMonthDayFrom:into:! !

!ConfigurableChronosParser methodsFor: 'initialize-release' stamp: ''!
initialize
	super initialize.
	self expectYMD.
	self expectDateThenTime.
	self doNotExpectDayOfWeekName.! !

!ConfigurableChronosParser methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	"ChronosParser iso8601 literalArrayEncoding decodeAsLiteralArray"

	super initializeFromLiteralArray: literalArray.
	expectDayOfWeekName := literalArray at: 20.
	dateSyntax := literalArray at: 21.
	dateAndTimeSyntax := literalArray at: 22.! !

!ConfigurableChronosParser methodsFor: 'API-parsing' stamp: ''!
nextCalendarDurationFrom: stream usingFactory: calendarDurationFactory 
	^self parseCalendarDurationFrom: stream
		into: 
			[:years :months :days | 
			self 
				newCalendarDurationUsing: calendarDurationFactory
				years: years
				months: months
				days: days]! !

!ConfigurableChronosParser methodsFor: 'API-parsing' stamp: ''!
nextCivilDurationFrom: stream usingFactory: civilDurationFactory 
	^self parseCivilDurationFrom: stream
		into:  
			[:years :months :days :hours :minutes :seconds | 
			self 
				newCivilDurationUsing: civilDurationFactory
				years: years
				months: months
				days: days
				hours: hours 
				minutes: minutes
				seconds: seconds]! !

!ConfigurableChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDateAndTimeFrom: stream usingFactory: dateAndTimeFactory 
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004-Feb-29' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004-02-29T13:30' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004-060T13:30' readStream"
	"ChronosParser ansiStandard nextDateAndTimeFrom: '2004-Feb-29 -0500' readStream"
	"ChronosParser default nextDateAndTimeFrom: '2004-Feb-29' readStream"
	"(ChronosParser applying: #(expectDayOfWeekName expectMDY setLocale: #'en_US')) beImmutable 
		nextDateAndTimeFrom: 'Sunday, Feb 29 2004 5:30 pm PST' readStream"
	"(ChronosParser applying: #(expectDayOfWeekName expectMDY setLocale: #'en_US')) beImmutable 
		nextDateAndTimeFrom: 'Wed, Feb 29 2004' readStream"
	"(ChronosParser applying: #(expectDayOfWeekName expectMDY setLocale: #'en_US')) beImmutable 
		nextDateAndTimeFrom: 'Wednesday, Feb 29 2006 5:30 pm PST' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '20040229' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004060' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004-W09-7' readStream"
	"ChronosParser iso8601 nextDateAndTimeFrom: '2004W097' readStream"

	| dateAndTime dayOfWeeKey argArray |
	dayOfWeeKey := expectDayOfWeekName ifTrue: [self parseDayOfWeekKeyFrom: stream ifNone: []].
	argArray := Array new: 7.
	self parseDateAndTimeFrom: stream into: argArray.
	dateAndTime := 
		self 
			newDateAndTimeUsing: dateAndTimeFactory
			year: (argArray at: 1)
			month: (argArray at: 2)
			day: (argArray at: 3)
			hour: (argArray at: 5)
			minute: (argArray at: 6)
			second: (argArray at: 7)
			timeZone: (argArray at: 4).
	dayOfWeeKey == nil 
		ifFalse: 
			[dateAndTime dayOfWeekKey = dayOfWeeKey 
				ifFalse: [self handleDayOfWeek: dayOfWeeKey inconsistentWithThatOf: dateAndTime]].
	^dateAndTime! !

!ConfigurableChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDateFrom: stream usingFactory: dateFactory 
	"ChronosParser default nextDateFrom: '2004-Feb-29' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004-02-29' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004-02-29-08:00' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004-02-29 -0800' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004-02-29 EST' readStream"
	"ChronosParser iso8601 nextDateFrom: '20040229' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004-060' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004-W09-7' readStream"
	"ChronosParser iso8601 nextDateFrom: '2004W097' readStream"
	"(ChronosParser applying: #(expectDayOfWeekName expectMDY)) beImmutable nextDateFrom: 'Sunday, Feb 29 2004' readStream"
	"(ChronosParser applying: #(expectDayOfWeekName expectMDY)) beImmutable nextDateFrom: 'Wed, Feb 29 2004' readStream"

	| dayOfWeeKey argArray date |
	dayOfWeeKey := expectDayOfWeekName ifTrue: [self parseDayOfWeekKeyFrom: stream ifNone: []].
	argArray := Array new: 4.
	self 
		parseDateFrom: stream
		into: argArray.
	date := 
		self 
			newDateUsing: dateFactory
			year: (argArray at: 1)
			month: (argArray at: 2)
			day: (argArray at: 3)
			timeZone: (argArray at: 4).
	dayOfWeeKey == nil 
		ifFalse: 
			[date dayOfWeekKey = dayOfWeeKey 
				ifFalse: [self handleDayOfWeek: dayOfWeeKey inconsistentWithThatOf: date]].
	^date! !

!ConfigurableChronosParser methodsFor: 'API-parsing' stamp: ''!
nextDurationFrom: stream usingFactory: durationFactory 
	^self parseDurationFrom: stream
		into: 
			[:days :hours :minutes :seconds | 
			self 
				newDurationUsing: durationFactory
				days: days
				hours: hours
				minutes: minutes
				seconds: seconds]! !

!ConfigurableChronosParser methodsFor: 'API-parsing' stamp: ''!
nextTimeOfDayFrom: stream usingFactory: timeOfDayFactory 
	"ChronosParser default nextTimeOfDayFrom: '23:59:60' readStream"
	"ChronosParser default nextTimeOfDayFrom: 'T00:00:00.000000001' readStream"
	"ChronosParser default nextTimeOfDayFrom: '23:59:61' readStream"

	^self parseTimeOfDayFrom: stream
		into: 
			[:hour :minute :second | 
			self 
				newTimeOfDayUsing: timeOfDayFactory
				hour: hour
				minute: minute
				second: second]! !

!ConfigurableChronosParser methodsFor: 'API-parsing' stamp: ''!
nextTimeperiodFrom: stream usingFactory: timeperiodFactory 
	^self 
		parseTimeperiodFrom: stream
		startAndDurationInto: 
			[:start :duration | 
			self 
				newTimeperiodUsing: timeperiodFactory
				from: start
				duration: duration]
		startAndEndInto: 
			[:start :end | 
			self 
				newTimeperiodUsing: timeperiodFactory
				from: start
				to: end]! !

!ConfigurableChronosParser methodsFor: 'parsing-durations' stamp: ''!
parseCalendarDurationFrom: stream into: block3 
	^self 
		parseCalendarDurationFrom: stream
		into: block3
		handleUnexpected: 
			[:ymdArray :value :ch | 
				self 
					handleUnexpectedCharacter: ch
					for: 'CalendarDuration/CivilDuration']! !

!ConfigurableChronosParser methodsFor: 'private' stamp: ''!
parseCalendarDurationFrom: stream into: block3 handleUnexpected: unexpectedAction
	| evaluator minIndex action years months days polarity |
	ChronosFunction skipSeparators: stream.
	stream atEnd ifTrue: [^nil].	
	years := 0.
	months := 0.
	days := 0.
	polarity := 1.
	action := Array new: 4.
	action 
		at: 1 put: [:value | minIndex := 2. years := value];
		at: 2 put: [:value | minIndex := 3. months := value];
		at: 3 put: [:value | minIndex := 4. days := value * 7];
		at: 4 put: [:value | minIndex := nil. days := value].
	minIndex := 1.
	evaluator := 
		[:value | 
			| discriminant index | 
			stream atEnd ifTrue: [self handleUnexpectedCharacter: nil for: 'CalendarDuration/CivilDuration'].
			discriminant := stream next.
			(minIndex = 1 and: [discriminant = $-])
				ifTrue: 
					[years := value.
					action := nil. "Now we know the alternative 'combined' syntax is being used, so the element values cannot be negative, and the semantics of each element are determined by position, not by a discriminating tag that follows each element."
					evaluator := 
						[:value2 | 
							months := value2.
							(stream peekFor: $-) ifFalse: [self handleUnexpectedCharacter: stream peek for: 'CalendarDuration/CivilDuration'].
							evaluator := [:value3 | days := value3. minIndex := nil]]]
				ifFalse:
					[index := 
						#($Y $M $W $D) 
							indexOf: discriminant 
							ifAbsent: 
								[^unexpectedAction value: (Array with: years with: months with: days) value: value * polarity value: discriminant].
					index < minIndex ifTrue: [self handleUnexpectedCharacter: discriminant for: 'CalendarDuration/CivilDuration'].
					(action at: index) value: value]].
	(stream peekFor: $P) ifFalse: [self handleUnexpectedCharacter: stream peek for: 'CalendarDuration/CivilDuration'].
	[stream atEnd or: [(stream peekFor: $T) or: [minIndex == nil]]]
		whileFalse:
			[| value |
			action == nil 
				ifFalse: "Initially, we assume the alternative 'combined' syntax is not being used, so the element values might be negative."
					[(stream peekFor: $-)
						ifTrue: [polarity := -1]
						ifFalse: [polarity := 1]].
			value := UtilityFunction 
						nextScaledDecimalFrom: stream 
 						minDigits: 1 maxDigits: nil
						maxValue: nil 
						handleRejection: [:vvv :digitCount :rejectionReason | 
							self signalError: 'Invalid civil duration element: ', vvv printString, ' problem:', rejectionReason].
			evaluator value: value * polarity].
	^block3 value: years value: months value: days! !

!ConfigurableChronosParser methodsFor: 'parsing-durations' stamp: ''!
parseCivilDurationFrom: stream into: block6 
	^self 
		parseCalendarDurationFrom: stream
		into: [:years :months :days | 
				self 
					parseCivilDurationFrom: stream
					years: years
					months: months
					days: days
					value: nil
					discriminant: nil
					into: block6]
		handleUnexpected: 
			[:ymdArray :value :discriminant | 
				self 
					parseCivilDurationFrom: stream
					years: (ymdArray at: 1)
					months: (ymdArray at: 2)
					days: (ymdArray at: 3)
					value: value
					discriminant: discriminant
					into: block6]! !

!ConfigurableChronosParser methodsFor: 'private' stamp: ''!
parseCivilDurationFrom: stream years: years months: months days: days value: value discriminant: discriminant into: block6
	| evaluator combinedSyntax minIndex action hours minutes seconds polarity args |
	hours := 0.
	minutes := 0.
	seconds := 0.
	polarity := 1.
	action := Array new: 3.
	action 
		at: 1 put: [:v | minIndex := 2. hours := v];
		at: 2 put: [:v | minIndex := 3. minutes := v ];
		at: 3 put: [:v | minIndex := nil. seconds := v].
	minIndex := 1.
	combinedSyntax :=
		[:v | hours := v.
			action := nil. "Now we know the alternative 'combined' syntax is being used, so the element values cannot be negative, and the semantics of each element are determined by position, not by a discriminating tag that follows each element."
			evaluator := 
				[:value2 | 
					minutes := value2.
					(stream peekFor: $:) ifFalse: [self handleUnexpectedCharacter: stream peek for: 'CivilDuration'].
					evaluator := [:value3 | seconds := value3. minIndex := nil]]].
	evaluator := 
		[:v | 
			| tag index | 
			stream atEnd ifTrue: [self handleUnexpectedCharacter: nil for: 'CivilDuration'].
			tag := stream next.
			(minIndex = 1 and: [tag = $:])
				ifTrue: [combinedSyntax value: v]
				ifFalse:
					[index := 
						#($H $M $S) 
							indexOf: tag 
							ifAbsent: [self handleUnexpectedCharacter: tag for: 'CivilDuration'].
					index < minIndex ifTrue: [self handleUnexpectedCharacter: tag for: 'CivilDuration'].
					(action at: index) value: v]].
	value == nil 
		ifFalse: 
			[| index |
			index := 
				#($H $M $S $:) 
					indexOf: discriminant 
					ifAbsent: [self handleUnexpectedCharacter: discriminant for: 'CivilDuration'].
			index <= 3 
				ifTrue: [(action at: index) value: value]
				ifFalse: [combinedSyntax value: value]].
	[stream atEnd or: [minIndex == nil]]
		whileFalse:
			[| v |
			action == nil 
				ifFalse: "Initially, we assume the alternative 'combined' syntax is not being used, so the element values might be negative."
					[(stream peekFor: $-)
						ifTrue: [polarity := -1]
						ifFalse: [polarity := 1]].
			v := UtilityFunction 
					nextScaledDecimalFrom: stream 
 					minDigits: 1 maxDigits: nil
					maxValue: nil 
					handleRejection: [:vvv :digitCount :rejectionReason | 
						minIndex > 1
							ifFalse: [self signalError: 'Invalid civil duration element: ', vvv printString, ' problem:', rejectionReason]].
			v == nil
				ifTrue: [minIndex := nil]
				ifFalse: [evaluator value: v * polarity]].
	args := Array new: 6.
	args 
		at: 1 put: years;
		at: 2 put: months;
		at: 3 put: days;
		at: 4 put: hours;
		at: 5 put: minutes;
		at: 6 put: seconds.
	^block6 valueWithArguments: args! !

!ConfigurableChronosParser methodsFor: 'parsing-dateAndTime' stamp: ''!
parseDateAndTimeFrom: stream into: ymdTzhmsArray 
	^self 
		perform: dateAndTimeSyntax
		with: stream
		with: ymdTzhmsArray! !

!ConfigurableChronosParser methodsFor: 'parsing-dates' stamp: ''!
parseDateFrom: stream into: ymdTzArray
	ymdTzArray at: 4 put: ChronosTimezone nominal.
	self 
		perform: dateSyntax
		with: stream
		with: ymdTzArray.
	stream atEnd ifTrue: [^ymdTzArray].
	stream peek = $/ ifTrue: [^ymdTzArray].
	ymdTzArray at: 4 put: (self parseTimeZoneFrom: stream ifNone: [^ymdTzArray]).
	^ymdTzArray! !

!ConfigurableChronosParser methodsFor: 'parsing-dateAndTime' stamp: ''!
parseDateThenTimeFrom: stream into: ymdTzhmsArray 
	"ChronosParser default 
		parseDateThenTimeFrom: Timepoint now printString readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseDateThenTimeFrom: '1970-01-01T00:00:00 UTC' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseDateThenTimeFrom: '1970-01-01T00:00:00Z' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseDateThenTimeFrom: '2006-02-12T18:15:33.333+05:30' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseDateThenTimeFrom: '2006-02-12T18:15:33.333 EST' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseDateThenTimeFrom: '2004-02-29 was a leap day...' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseDateThenTimeFrom: '2004-02-29-0700' readStream
		into: (Array new: 7)"

	| count resetPosition endOfData tz |
	self parseDateFrom: stream into: ymdTzhmsArray.
	stream atEnd ifTrue: [^ymdTzhmsArray].
	stream peek = $/ ifTrue: [^ymdTzhmsArray].
	tz := ymdTzhmsArray at: 4.
	tz isInvariantToNominalTime ifFalse: [^ymdTzhmsArray].
	count := 0.
	resetPosition := stream position.
	endOfData := false.
	ChronosFunction 
		skipOver: stream 
		until: [:ch | 
				ch isLetter ifTrue: [count := count + 1]. 
				endOfData := count > 2. 
				endOfData or: [ch isDigit or: [timeZoneSeparators includes: ch]]].
	endOfData ifTrue: [stream skip: resetPosition - stream position].
	ChronosFunction skipSeparators: stream.
	stream atEnd ifTrue: [^ymdTzhmsArray].
	(stream peek isDigit)
		ifTrue:  [self parseTimeOfDayFrom: stream into: [:hour :minute :second | ymdTzhmsArray at: 5 put: hour; at: 6 put: minute; at: 7 put: second]].
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric or: [timeZoneSeparators includes: ch]].
	stream atEnd ifTrue: [^ymdTzhmsArray].
	ymdTzhmsArray
		at: 4
		put: (self parseTimeZoneFrom: stream ifNone: [self defaultTimeZone]).
	^ymdTzhmsArray! !

!ConfigurableChronosParser methodsFor: 'parsing-dates' stamp: ''!
parseDayMonthYearFrom: stream into: ymdTzArray 
	"ChronosParser default parseDayMonthYearFrom: '29 February 2008' readStream into: (Array new: 4)"
	"ChronosParser default parseDayMonthYearFrom: '1.2.96' readStream into: (Array new: 4)"
	"ChronosParser default parseDayMonthYearFrom: '29021987' readStream into: (Array new: 4)"
	"ChronosParser default parseDayMonthYearFrom: '1987-02-29' readStream into: (Array new: 4)"
	"ChronosParser default parseDayMonthYearFrom: 'Aug 6, 1945' readStream into: (Array new: 4)"

	| year monthSpec day |
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	stream atEnd ifTrue: [^nil].	
	day := self 
				parseDayOfMonthFrom: stream
				maxDigits: 8
				handleRejection: 
					[:value :digitCount :rejectionReason | 
					digitCount = 4 ifTrue: [^self parseYearMonthDayFrom: stream into: ymdTzArray ].
					rejectionReason == #notAnInteger 
						ifTrue: [^self parseMonthDayYearFrom: stream into: ymdTzArray]
						ifFalse: [self handleInvalidDayOfMonth: value digitCount: digitCount problemKey: rejectionReason]].
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	monthSpec := self parseMonthFrom: stream maxDigits: 2 handleRejection: [:month :count :problem | self handleInvalidMonth: month problemKey: problem].
	ChronosFunction skipOver: stream until: [:ch | ch isDigit].
	year := self 
				parseYearFrom: stream
				handleRejection: [:value :digitCount :rejectionReason | self handleInvalidYear: value digitCount: digitCount problemKey: rejectionReason].
	ymdTzArray 
		at: 1 put: year;
		at: 2 put: monthSpec;
		at: 3 put: day.
	^ymdTzArray! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseDayOfMonthFrom: stream maxDigits: maxDigits handleRejection: handleRejection
	"ChronosParser default parseDayOfMonthFrom: '31' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseDayOfMonthFrom: '5' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseDayOfMonthFrom: '0' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseDayOfMonthFrom: '32' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseDayOfMonthFrom: '1997' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseDayOfMonthFrom: '31121997' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseDayOfMonthFrom: 'x7' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"

	^ChronosFunction 
		nextUnsignedIntegerFrom: stream
		minDigits: 1 
		maxDigits: maxDigits
		acceptancePredicate: 
			[:int :digitCount | 
				digitCount < 3]
		handleRejection: 
			[:value :digitCount :rejectionReason | 
				((#(#streamAtEnd notAnInteger) includes: rejectionReason) or: [digitCount <= maxDigits and: [digitCount = 4]])
					ifTrue: [handleRejection value: value value: digitCount value: rejectionReason]
					ifFalse:
						[stream skip: 2.
						value // (10 raisedToInteger: digitCount - 2)]]! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseDayOfWeekKeyFrom: stream ifNone: noneBlock 
	"ChronosParser default 
		parseDayOfWeekKeyFrom: ' Monday, May' readStream ifNone: []"
	"ChronosParser default 
		parseDayOfWeekKeyFrom: ' May 30, 1932' readStream ifNone: []"

	| dowResult dayOfWeekKey |
	stream atEnd ifTrue: [^noneBlock value].
	dowResult := 
		self 
			parseOptionalTokenFrom: stream
			prefixPredicate: [:ch | ch isSeparator]
			tokenPredicate: 
				[:ch :count | ch isLetter]
			minChars: minDayOfWeekNameSize
			maxChars: maxDayOfWeekNameSize
			acceptancePredicate: 
				[:name | | canonicalNameForm |
				canonicalNameForm := name asUppercase.
				(dayOfWeekKey := dayOfWeekKeysByAbbreviation at: canonicalNameForm
					ifAbsent: [dayOfWeekKeysByName at: canonicalNameForm ifAbsent: []]) notNil].
	^dowResult key 
		ifTrue: [dayOfWeekKey]
		ifFalse: [noneBlock value]! !

!ConfigurableChronosParser methodsFor: 'parsing-durations' stamp: ''!
parseDurationFrom: stream into: block4 
	| days hours minutes seconds polarity duration |
	ChronosFunction skipOver: stream
		until: [:ch | ch isAlphaNumeric or: [#($- $+) includes: ch]].
	stream atEnd ifTrue: [^nil].	
	polarity := (stream peekFor: $-) ifTrue: [-1] ifFalse: [1].
	days := UtilityFunction 
				nextScaledDecimalFrom: stream 
				minDigits: 1 maxDigits: nil
				maxValue: nil 
				handleRejection: [:value :digitCount :rejectionReason | 
					self 
						handleInvalidDays: value
						digitCount: digitCount
						problemKey: rejectionReason].
	(stream peekFor: $:) ifFalse: [self handleUnexpectedCharacter: stream peek for: 'Duration'].
	hours := UtilityFunction 
					nextScaledDecimalFrom: stream 
					minDigits: 2 maxDigits: 2
					maxValue: 23 
					handleRejection: [:value :digitCount :rejectionReason | 
						self 
							handleInvalidHour: value
							digitCount: digitCount
							problemKey: rejectionReason].
	(stream peekFor: $:) ifFalse: [self handleUnexpectedCharacter: stream peek for: 'Duration'].
	minutes := UtilityFunction 
					nextScaledDecimalFrom: stream 
					minDigits: 2 maxDigits: 2
					maxValue: 59 
					handleRejection: [:value :digitCount :rejectionReason | 
						self 
							handleInvalidMinute: value
							digitCount: digitCount
							problemKey: rejectionReason].
	(stream peekFor: $:) ifFalse: [self handleUnexpectedCharacter: stream peek for: 'Duration'].
	seconds := UtilityFunction 
					nextScaledDecimalFrom: stream 
					minDigits: 2 maxDigits: 2
					maxValue: 59 
					handleRejection: [:value :digitCount :rejectionReason | 
						self 
							handleInvalidSecond: value
							digitCount: digitCount
							problemKey: rejectionReason].
	duration := block4 valueWithArguments: (Array with: days with: hours with: minutes with: seconds).
	^polarity > 0 ifTrue: [duration] ifFalse: [duration negated]! !

!ConfigurableChronosParser methodsFor: 'parsing-timeOfDay-elements' stamp: ''!
parseHourOfDayFrom: stream handleRejection: handleRejection
	"ChronosParser new parseHourOfDayFrom: '23' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser new parseHourOfDayFrom: '5' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser new parseHourOfDayFrom: '0' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser new parseHourOfDayFrom: '32' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser new parseHourOfDayFrom: 'x7' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"

	^ChronosFunction 
		nextUnsignedIntegerFrom: stream
		minDigits: 1
		maxDigits: 2
		acceptancePredicate: [:int :digitCount | true]
		handleRejection: handleRejection! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseIsoDayOfWeekFrom: stream handleRejection: handleRejection
	"ChronosParser new parseIsoDayOfWeekFrom: '1' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"
	"ChronosParser new parseIsoDayOfWeekFrom: '5' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"
	"ChronosParser new parseIsoDayOfWeekFrom: '7' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"
	"ChronosParser new parseIsoDayOfWeekFrom: '53' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"
	"ChronosParser new parseIsoDayOfWeekFrom: 'x7' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"

	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	^ChronosFunction 
		nextUnsignedIntegerFrom: stream
		minDigits: 1
		maxDigits: 2
		acceptancePredicate: [:int :digitCount | digitCount < 2]
		handleRejection: handleRejection! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseIsoWeekOfYearFrom: stream handleRejection: handleRejection 
	"ChronosParser new parseIsoWeekOfYearFrom: '23' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"
	"ChronosParser new parseIsoWeekOfYearFrom: '5' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"
	"ChronosParser new parseIsoWeekOfYearFrom: '0' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"
	"ChronosParser new parseIsoWeekOfYearFrom: '532' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"
	"ChronosParser new parseIsoWeekOfYearFrom: 'x7' readStream handleRejection: [:value :digitCount :problem | problem->(Array with: value with: digitCount)]"

	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	^(stream peekFor: $W) 
		ifTrue: 
			[ChronosFunction 
				nextUnsignedIntegerFrom: stream
				minDigits: 2
				maxDigits: 2
				acceptancePredicate: [:int :digitCount | true]
				handleRejection: handleRejection]
		ifFalse: [handleRejection value: nil value: 0 value: #syntaxInvalid ]! !

!ConfigurableChronosParser methodsFor: 'parsing-timeOfDay-elements' stamp: ''!
parseMeridianKeyFrom: stream ifNone: noneBlock 
	"| stream result |
	stream := ' pm-0800' readStream.
	result := ChronosParser default 
				parseMeridianKeyFrom: stream ifNone: [#notAMeridianName].
	Array with: result with: stream upToEnd"
	"ChronosParser default 
		parseMeridianKeyFrom: ' AM PST' readStream ifNone: [#notAMeridianName]"
	"| stream result |
	stream := ' EST' readStream.
	result := ChronosParser default 
				parseMeridianKeyFrom: stream ifNone: [#notAMeridianName].
	Array with: result with: stream upToEnd"
	"ChronosParser default 
		parseMeridianKeyFrom: ' America/Chicago' readStream ifNone: [#notAMeridianName]"

	| meridianResult meridianIndex endedByNonAlpha |
	stream atEnd ifTrue: [^noneBlock value].
	endedByNonAlpha := true.
	meridianResult := 
		self 
			parseOptionalTokenFrom: stream
			prefixPredicate: [:ch | ch isSeparator]
			tokenPredicate: 
				[:ch :count | count <= maxMeridianNameSize ifTrue: [meridianNameCharSet includes: ch] ifFalse: [endedByNonAlpha := ch isLetter not. false]]
			minChars: minMeridianNameSize
			maxChars: maxMeridianNameSize + 1
			acceptancePredicate: 
				[:name | | canonicalNameForm |
				endedByNonAlpha
					ifTrue:
						[canonicalNameForm := name asUppercase asSymbol.
						meridianIndex := meridianNames indexOf: canonicalNameForm ifAbsent: [0].
						meridianIndex > 0]
					ifFalse: [false]].
	^meridianResult key 
		ifTrue: [MeridianKeys at: meridianIndex]
		ifFalse: [noneBlock value]! !

!ConfigurableChronosParser methodsFor: 'parsing-timeOfDay-elements' stamp: ''!
parseMinuteOfHourFrom: stream handleRejection: handleRejection
	"ChronosParser new parseMinuteOfHourFrom: '59' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser new parseMinuteOfHourFrom: '05' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser new parseMinuteOfHourFrom: '0' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser new parseMinuteOfHourFrom: '60' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser new parseMinuteOfHourFrom: 'x7' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"

	^ChronosFunction 
		nextUnsignedIntegerFrom: stream
		minDigits: 2
		maxDigits: 2
		acceptancePredicate: [:int :digitCount | true]
		handleRejection: handleRejection! !

!ConfigurableChronosParser methodsFor: 'parsing-dates' stamp: ''!
parseMonthDayYearFrom: stream into: ymdTzArray
	"ChronosParser default parseMonthDayYearFrom: '2/29/2008' readStream into: (Array new: 4)"
	"ChronosParser default parseMonthDayYearFrom: '02291987' readStream into: (Array new: 4)"
	"ChronosParser default parseDayMonthYearFrom: '1987-02-29' readStream into: (Array new: 4)"
	"ChronosParser default parseMonthDayYearFrom: 'Feb2996' readStream into: (Array new: 4)"
	"ChronosParser default parseMonthDayYearFrom: 'Aug 6, 1945' readStream into: (Array new: 4)"
	"ChronosParser default parseMonthDayYearFrom: '6 Aug 1945' readStream into: (Array new: 4)"

	| year monthSpec day |
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	stream atEnd ifTrue: [^nil].	
	monthSpec := 
		self 
			parseMonthFrom: stream 
			maxDigits: 8 
			handleRejection: [:month :count :problem | count = 4 ifTrue: [^self parseYearMonthDayFrom: stream into: ymdTzArray] ifFalse: [self handleInvalidMonth: month problemKey: problem]].
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	day := self 
			parseDayOfMonthFrom: stream
			maxDigits: 2
			handleRejection: 
				[:value :digitCount :rejectionReason | 
				digitCount > 0 
					ifTrue:  [self handleInvalidDayOfMonth: value digitCount: digitCount problemKey: rejectionReason]
					ifFalse: 
						[rejectionReason == #notAnInteger 
							ifTrue: 
								[monthSpec isInteger
									ifTrue: 
										[| dayOfMonth | 
										dayOfMonth := monthSpec.
										monthSpec := self parseMonthFrom: stream maxDigits: 2 handleRejection: [:month :count :problem | self handleInvalidMonth: month problem: problem].
										dayOfMonth]
									ifFalse: [self handleInvalidDayOfMonth: value digitCount: digitCount problemKey: rejectionReason]]
							ifFalse:  [self handleInvalidDayOfMonth: value digitCount: digitCount problemKey: rejectionReason]]].
	ChronosFunction skipOver: stream until: [:ch | ch isDigit].
	year := self 
				parseYearFrom: stream 
				handleRejection: [:value :digitCount :rejectionReason | self handleInvalidYear: value digitCount: digitCount problemKey: rejectionReason].
	ymdTzArray 
		at: 1 put: year;
		at: 2 put: monthSpec;
		at: 3 put: day.
	^ymdTzArray! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseMonthFrom: stream maxDigits: maxDigits handleRejection: handleRejection
	"ChronosParser rfc2822 parseMonthFrom: '12' readStream maxDigits: 2 handleRejection: [:month :count :problem | month->problem]"
	"ChronosParser rfc2822 parseMonthFrom: 'Aug' readStream maxDigits: 2 handleRejection: [:month :count :problem | month->problem]"
	"ChronosParser rfc2822 parseMonthFrom: '5' readStream maxDigits: 2 handleRejection: [:month :problem | month->problem]"
	"ChronosParser rfc2822 parseMonthFrom: 'January' readStream maxDigits: 2 handleRejection: [:month :count :problem | month->problem]"
	"ChronosParser rfc2822 parseMonthFrom: '0' readStream maxDigits: 2 handleRejection: [:month :count :problem | month->problem]"
	"ChronosParser rfc2822 parseMonthFrom: '24' readStream maxDigits: 2 handleRejection: [:month :count :problem | month->problem]"
	"ChronosParser rfc2822 parseMonthFrom: '1224' readStream maxDigits: 2 handleRejection: [:month :count :problem | month->problem]"
	"ChronosParser rfc2822 parseMonthFrom: 'x7' readStream maxDigits: 2 handleRejection: [:month :count :problem | month->problem]"

	| monthNumber |
	monthNumber :=
		self 
			parseMonthNumberFrom: stream
			maxDigits: maxDigits 
			handleRejection:
				[:value :digitCount :rejectionReason | 
				^rejectionReason == #notAnInteger
					ifTrue: 
						[(self 
							parseMonthNameKeyByNameOrAbbreviationFrom: stream 
							handleRejection: handleRejection)]
					ifFalse: 
						[(digitCount <= maxDigits)
							ifTrue: 
								[digitCount > 4
									ifTrue: 
										[stream skip: 2.
										value // (10 raisedTo: digitCount - 2)]
									ifFalse: [handleRejection value: value value: digitCount value: rejectionReason]]
							ifFalse: [handleRejection value: value value: digitCount value: rejectionReason]]].
	^monthNumber! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseMonthNameKeyByNameOrAbbreviationFrom: stream handleRejection: handleRejection
	"ChronosParser rfc2822 parseMonthNameKeyByNameOrAbbreviationFrom: 'Aug' readStream 
		handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser rfc2822 parseMonthNameKeyByNameOrAbbreviationFrom: 'September' readStream 
		handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser rfc2822 parseMonthNameKeyByNameOrAbbreviationFrom: 'Ju' readStream 
		handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser rfc2822 parseMonthNameKeyByNameOrAbbreviationFrom: 'abcdefjhijkl' readStream 
		handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser rfc2822 parseMonthNameKeyByNameOrAbbreviationFrom: '12' readStream 
		handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"

	| nameOrAbbreviation canonicalNameForm|
	nameOrAbbreviation := 
		self 
			parseMonthNameOrAbbreviationFrom: stream
			unexpectedEODAction: [:prefix :ch :count | ^handleRejection value: prefix value: count value: #unknownMonthName].
	canonicalNameForm := nameOrAbbreviation asUppercase.
	^monthNameKeysByMonthAbbreviation 
		at: canonicalNameForm
		ifAbsent: [monthNameKeysByMonthName at: canonicalNameForm ifAbsent: [handleRejection value: nameOrAbbreviation value: nameOrAbbreviation size value: #unknownMonthName]]! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseMonthNameOrAbbreviationFrom: stream unexpectedEODAction: unexpectedEODAction 
	"ChronosParser rfc2822 parseMonthNameOrAbbreviationFrom: 'Aug 12' readStream unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser rfc2822 parseMonthNameOrAbbreviationFrom: 'September 15' readStream unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser rfc2822 parseMonthNameOrAbbreviationFrom: 'Adar Rishon ' readStream unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser rfc2822 parseMonthNameOrAbbreviationFrom: 'Ju ' readStream unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser rfc2822 parseMonthNameOrAbbreviationFrom: 'abcdefjhijkl ' readStream unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser rfc2822 parseMonthNameOrAbbreviationFrom: '12 ' readStream unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"

	| name component appendSpace |
	appendSpace := false.
	name :=  (String new: 9) writeStream.
	[component := 
			ChronosFunction 
				nextFrom: stream
				while: [:ch | ch isLetter]
				minChars: minMonthNameSize
				maxChars: maxMonthNameSize
				onUnexpectedEOD: 
					[:prefix :ch :position | 
						^name position > 0 
							ifTrue: [name contents] 
							ifFalse: [unexpectedEODAction value: prefix value: ch value: position]].
	appendSpace ifTrue: [name space].
	name nextPutAll: component.
	stream atEnd ifTrue: [false] ifFalse: [stream peek isSeparator]] 
			whileTrue: 
				[appendSpace := true.
				ChronosFunction skipSeparators: stream].
	^name contents! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseMonthNumberFrom: stream maxDigits: maxDigits handleRejection: handleRejection
	"ChronosParser default parseMonthNumberFrom: '12' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseMonthNumberFrom: '5' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseMonthNumberFrom: '0' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseMonthNumberFrom: '24' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseMonthNumberFrom: 'x7' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"

	^ChronosFunction 
		nextUnsignedIntegerFrom: stream
		minDigits: 1 
		maxDigits: maxDigits
		acceptancePredicate: 
			[:int :digitCount | 
			digitCount < 3]
		handleRejection: handleRejection! !

!ConfigurableChronosParser methodsFor: 'private' stamp: ''!
parseScaledDecimalFrom: stream minDigits: minDigits maxDigits: maxDigits maxValue: maxValue handleRejection: handleRejection
	"ConfigurableChronosParser new parseScaledDecimalFrom: '59' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: '60' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: '05' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: '0' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: '00.123' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: '01.999999999' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: '60.999999999' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: '00.x' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: '61' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ConfigurableChronosParser new parseScaledDecimalFrom: 'x7' readStream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"

	| second |
	second := 
		ChronosFunction 
			nextUnsignedIntegerFrom: stream
			minDigits: minDigits
			maxDigits: maxDigits
			acceptancePredicate: [:int :digitCount | maxValue == nil or: [int <= maxValue]]
			handleRejection: [:value :count :rejectionReason | ^handleRejection value: value value: count value: rejectionReason].
	((stream peekFor: $.) or: [stream peekFor: $,]) 
		ifTrue: 
			[| subSeconds |
			subSeconds := 
				ChronosFunction 
					nextFrom: stream
					while: [:ch | ch isDigit]
					minChars: 0
					maxChars: 99999999
					onUnexpectedEOD: [:prefix :ch :position | ^handleRejection value: prefix value: 0 value: #notAnInteger].
			subSeconds size > 0 
				ifTrue: 
					[| scale denominator |
					scale := subSeconds size.
					denominator := 10 raisedToInteger: scale.
					second := (ScaledDecimal  numerator: second * denominator + (Integer readFrom: subSeconds readStream) denominator: denominator scale: scale)]].
	^second! !

!ConfigurableChronosParser methodsFor: 'parsing-timeOfDay-elements' stamp: ''!
parseSecondOfMinuteFrom: stream handleRejection: handleRejection
	^UtilityFunction nextScaledDecimalFrom: stream minDigits: 2 maxDigits: 2 maxValue: 60 handleRejection: handleRejection! !

!ConfigurableChronosParser methodsFor: 'parsing-timeOfDay' stamp: ''!
parseTimeOfDayFrom: stream into: block3 
	"ChronosParser default parseTimeOfDayFrom: '23:59:60 CST' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"
	"ChronosParser default parseTimeOfDayFrom: '235960-06:00' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"
	"ChronosParser default parseTimeOfDayFrom: '23:59+0530' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"
	"ChronosParser default parseTimeOfDayFrom: '11:59 am' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"
	"ChronosParser default parseTimeOfDayFrom: '11:59 PM' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"
	"ChronosParser default parseTimeOfDayFrom: '11:59pm-0400' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"
	"ChronosParser default parseTimeOfDayFrom: '23:59 AM' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]" "Code assumes there is no meridian name if hour > 12"
	"ChronosParser default parseTimeOfDayFrom: '23:59 PM' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]" "Code assumes there is no meridian name if hour > 12"
	"ChronosParser default parseTimeOfDayFrom: '12:59 am' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]" 
	"ChronosParser default parseTimeOfDayFrom: '24:00' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]" 
	"ChronosParser default parseTimeOfDayFrom: '23h59 Europe/Paris' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"
	"ChronosParser default parseTimeOfDayFrom: '23:7x' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"
	"ChronosParser default parseTimeOfDayFrom: '23:59:0 ' readStream into: [:hour :minute :second | Array with: hour with: minute with: second]"

	| hour minute second count meridianKey |
	ChronosFunction skipOver: stream
		until: [:ch | ch isAlphaNumeric or: [#($- $+) includes: ch]].
	stream atEnd ifTrue: [^nil].	
	(#($T $t) includes: stream peek) ifTrue: [stream next].
	hour := self parseHourOfDayFrom: stream
				handleRejection: 
					[:value :digitCount :rejectionReason | 
					self 
						handleInvalidHour: value
						digitCount: digitCount
						problemKey: rejectionReason].
	count := 0.
	ChronosFunction skipOver: stream
		while: 
			[:ch | 
			count := count + 1.
			count < 2 and: [#($: $h $H $.) includes: ch]].
	minute := self parseMinuteOfHourFrom: stream
				handleRejection: 
					[:value :digitCount :rejectionReason | 
					digitCount = 0 
						ifFalse: 
							[self 
								handleInvalidMinute: value
								digitCount: digitCount
								problemKey: rejectionReason]].
	count := 0.
	ChronosFunction skipOver: stream
		while: 
			[:ch | 
			count := count + 1.
			count < 2 and: [#($: $m $M $.) includes: ch]].
	second := self parseSecondOfMinuteFrom: stream
				handleRejection: 
					[:value :digitCount :rejectionReason | 
					digitCount = 0 
						ifFalse: 
							[self 
								handleInvalidSecond: value
								digitCount: digitCount
								problemKey: rejectionReason]].
	hour <= 12 
		ifTrue: [meridianKey := self parseMeridianKeyFrom: stream ifNone: []].
	^block3 
		value: (meridianKey == #'post-meridian' 
				ifTrue: [hour < 12 ifTrue: [hour + 12] ifFalse: [hour]]
				ifFalse: 
					[meridianKey == #'ante-meridian' 
						ifTrue: [hour < 12 ifTrue: [hour] ifFalse: [0]]
						ifFalse: [hour]])
		value: minute
		value: second! !

!ConfigurableChronosParser methodsFor: 'parsing-dateAndTime' stamp: ''!
parseTimeThenDateFrom: stream into: ymdTzhmsArray
	"ChronosParser default 
		parseTimeThenDateFrom: (Timepoint now % #(useTimeBeforeDateOrder dateAndTimeSeparator: ' @ ')) readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseTimeThenDateFrom: '00:00:00 1970-01-01 UTC' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseTimeThenDateFrom: 'T00:00:00 1970-01-01Z' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseTimeThenDateFrom: '18:15:33.333 2006-02-12+05:30' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseTimeThenDateFrom: '18:15:33.333//2006-02-12 EST' readStream
		into: (Array new: 7)"

	"ChronosParser default 
		parseTimeThenDateFrom: '10:00 2004-02-29 scheduled arrival' readStream
		into: (Array new: 7)"

	| endOfData |
	self parseTimeOfDayFrom: stream into:  [:hour :minute :second |  ymdTzhmsArray at: 5 put: hour; at: 6 put: minute; at: 7 put: second].
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	endOfData := stream atEnd.
	endOfData ifFalse: [self  parseDateFrom: stream into: ymdTzhmsArray].
	^ymdTzhmsArray! !

!ConfigurableChronosParser methodsFor: 'parsing-time zone' stamp: ''!
parseTimeZoneFrom: stream ifNone: noneBlock
	"ChronosParser default 
		parseTimeZoneFrom: '+05:30' readStream ifNone: []"
	"ChronosParser default 
		parseTimeZoneFrom: 'Australia/Adelaide' readStream ifNone: []"
	"ChronosParser default 
		parseTimeZoneFrom: '-08:00' readStream ifNone: []"
	"ChronosParser default 
		parseTimeZoneFrom: 'PST' readStream ifNone: []"
	"ChronosParser default 
		parseTimeZoneFrom: 'EDT' readStream ifNone: []"
	"ChronosParser default 
		parseTimeZoneFrom: '+01' readStream ifNone: []"
	"ChronosParser default 
		parseTimeZoneFrom: '+10:45:30.5' readStream ifNone: []"
	"ChronosParser default 
		parseTimeZoneFrom: '+0300' readStream ifNone: []"
	"ChronosParser default 
		parseTimeZoneFrom: ' am Don''t be late!!' readStream ifNone: []"

	| offset zoneResult zone |
	ChronosFunction skipSeparators: stream.
	stream atEnd ifTrue: [^noneBlock value].
	offset := 
		self 
			parseTimeZoneOffsetFrom: stream
			unexpectedEODAction: 
				[:prefix :ch :position | 
					(ChronosFunction isNilOrEmpty: prefix) 
						ifFalse: [^noneBlock value]].
	offset == nil ifFalse: [^offset asTimezone].
	zoneResult := 
		self 
			parseOptionalTokenFrom: stream
			prefixPredicate: [:ch | ch isSeparator] 
			tokenPredicate: [:ch :count | count <= 3 ifTrue: [ch isLetter] ifFalse: [(#($/ $_) includes: ch) or: [ch isLetter]]] 
			minChars: 1 
			maxChars: 80 
			acceptancePredicate: [:name | (zone := self timeZoneWithNameOrAbbreviation: name ifNone: []) notNil].
	^zoneResult key
		ifTrue: [zone]
		ifFalse: [noneBlock value]! !

!ConfigurableChronosParser methodsFor: 'parsing-time zone' stamp: ''!
parseTimeZoneOffsetFrom: stream unexpectedEODAction: unexpectedEODAction 
	"ChronosParser default 
		parseTimeZoneOffsetFrom: '+05:30' readStream 
		unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser default 
		parseTimeZoneOffsetFrom: '-08:00' readStream 
		unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser default 
		parseTimeZoneOffsetFrom: '+01' readStream 
		unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser default 
		parseTimeZoneOffsetFrom: '+10:45:30.5' readStream 
		unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"
	"ChronosParser default 
		parseTimeZoneOffsetFrom: '+0300' readStream 
		unexpectedEODAction: [:prefix :ch :position | prefix->(Array with: ch with: position)]"

	| polarity hours minutes seconds |
	(#($- $+) includes: (polarity := stream peek)) 
		ifFalse: [^unexpectedEODAction value: nil value: polarity value: stream position].
	stream next.
	polarity := polarity = $+ ifTrue: [1] ifFalse: [-1].
	hours := self parseHourOfDayFrom: stream handleRejection: [:value :digitCount :rejectionReason | self handleInvalidHour: value digitCount: digitCount problemKey: rejectionReason].
	stream peekFor: $:.
	minutes := 
		self parseMinuteOfHourFrom: stream 
			handleRejection: [:value :digitCount :rejectionReason | 
						digitCount = 0 ifTrue: [0] ifFalse: [self handleInvalidMinute: value digitCount: digitCount problemKey: rejectionReason]].
	stream peekFor: $:.
	seconds := 
		self parseSecondOfMinuteFrom: stream
			handleRejection: [:value :digitCount :rejectionReason | 
						digitCount = 0 ifTrue: [0] ifFalse: [self handleInvalidSecond: value digitCount: digitCount problemKey: rejectionReason]].
	^self 
		newDurationUsing: self defaultDurationFactory 
		days: 0
		hours: hours * polarity
		minutes: minutes * polarity
		seconds: seconds * polarity! !

!ConfigurableChronosParser methodsFor: 'parsing-timeperiods' stamp: ''!
parseTimeperiodFrom: stream startAndDurationInto: startWithDuration startAndEndInto: startToEnd
	| start duration end |
	ChronosFunction skipSeparators: stream.
	stream atEnd ifTrue: [^nil].
	^stream peek = $P
		ifTrue: 
			[duration := self nextCivilDurationFrom: stream.
			(stream peekFor: $/) ifFalse: [self handleUnexpectedCharacter: stream peek for: 'Timeperiod separator'].
			end := self nextDateAndTimeFrom: stream.	
			startWithDuration value: end - duration value: duration]
		ifFalse: 
			[start := self nextDateAndTimeFrom: stream.
			(stream peekFor: $/) ifFalse: [self handleUnexpectedCharacter: stream peek for: 'Timeperiod separator'].
			(stream peek = $P)
				ifTrue: [startWithDuration value: start value: (self nextCivilDurationFrom: stream)]
				ifFalse: 
					[| mark |
					mark := stream position.
					ChronosFunction skipOver: stream while: [:ch | ch isDigit].
					stream peek = $: "Check for ANSI-Smalltalk Duration syntax"
						ifTrue:
							["It's probably an ANSI-Smalltalk Duration"
							stream skip: mark - stream position.
							startWithDuration value: start value: (self nextDurationFrom: stream)]
						ifFalse: 
							["It's NOT an ANSI-Smalltalk Duration, so it must be a DateAndTime"
							stream skip: mark - stream position.
							startToEnd value: start value: (self nextDateAndTimeFrom: stream)]]].! !

!ConfigurableChronosParser methodsFor: 'parsing-dates' stamp: ''!
parseYearDayMonthFrom: stream into: ymdTzArray 
	"ChronosParser default parseYearDayMonthFrom: '2008, 29 February' readStream into: (Array new: 4)"
	"ChronosParser default parseYearDayMonthFrom: '19872902' readStream into: (Array new: 4)"
	"ChronosParser default parseYearDayMonthFrom: '19870229' readStream into: (Array new: 4)"
	"ChronosParser default parseYearDayMonthFrom: '96-2902' readStream into: (Array new: 4)"
	"ChronosParser default parseYearDayMonthFrom: 'Aug 6, 1945' readStream into: (Array new: 4) "
	"ChronosParser default parseYearDayMonthFrom: '1945 Aug 6' readStream into: (Array new: 4)"

	| year monthSpec day month |
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	stream atEnd ifTrue: [^nil].	
	year := self 
				parseYearFrom: stream 
				handleRejection: 
					[:value :digitCount :rejectionReason |
					rejectionReason == #notAnInteger 
						ifTrue: [^self parseMonthDayYearFrom: stream into: ymdTzArray]
						ifFalse: [self handleInvalidYear: value digitCount: digitCount problemKey: rejectionReason]].
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	day := self 
			parseDayOfMonthFrom: stream
			maxDigits: 2
			handleRejection: 
				[:value :digitCount :rejectionReason | 
				rejectionReason == #notAnInteger 
					ifTrue: 
						[monthSpec := self parseMonthFrom: stream maxDigits: 2 handleRejection: [:m :count :problem | self handleInvalidMonth: m problemKey: problem].
						ChronosFunction skipOver: stream until: [:ch2 | ch2 isDigit].
						self 
							parseDayOfMonthFrom: stream
							maxDigits: 2
							handleRejection: [:value2 :digitCounts :rejectionReasons | self handleInvalidDayOfMonth: value digitCount: digitCount problemKey: rejectionReason]]
					ifFalse:  [self handleInvalidDayOfMonth: value digitCount: digitCount problemKey: rejectionReason]].
	monthSpec == nil
		ifTrue: 
			[ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
			monthSpec := 
				self 
					parseMonthFrom: stream 
					maxDigits: 4 
					handleRejection: [:m :count :problem | 
						(problem == #notAccepted and: [year between: 1 and: calendar maxDaysPerMonth])
							ifTrue: 
								[month := year.
								year := m.
								month > calendar maxMonthsPerYear
									ifTrue: 	
										[| swap |
										swap := month. 
										month := day.
										day := swap]. 
								monthSpec := month]
							ifFalse: [self handleInvalidMonth: m problemKey: problem]]].
	month := monthSpec.
	month isInteger
		ifTrue: 
			[(month > calendar maxMonthsPerYear)
				ifTrue: 
					[month <= calendar maxDaysPerMonth
						ifTrue: 
							[monthSpec := day.
							day := month]]].
	ymdTzArray 
		at: 1 put: year;
		at: 2 put: monthSpec;
		at: 3 put: day.
	^ymdTzArray! !

!ConfigurableChronosParser methodsFor: 'parsing-dates-elements' stamp: ''!
parseYearFrom: stream handleRejection: handleRejection 
	"ChronosParser default parseYearFrom: '2006' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"
	"ChronosParser default parseYearFrom: '-86' readStream handleRejection: [:value :digitCount :rejectionReason | rejectionReason -> (Array with: value with: digitCount)]"

	| isNegative year |
	ChronosFunction skipSeparators: stream.
	isNegative := stream peekFor: $-.
	year := ChronosFunction 
				nextUnsignedIntegerFrom: stream
				minDigits: 1
				maxDigits: 4
				acceptancePredicate: [:int :digitCount | true]
				handleRejection: [:value :digitCount :rejectionReason | ^handleRejection value: value value: digitCount value: rejectionReason].
	^isNegative ifTrue: [year negated] ifFalse: [year]! !

!ConfigurableChronosParser methodsFor: 'parsing-dates' stamp: ''!
parseYearMonthDayFrom: stream into: ymdTzArray
	"ChronosParser default parseYearMonthDayFrom: '2008-02-29' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: '19870229' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: '2/14/1987' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: '2/12/1987' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: '96Feb29' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: 'Aug 6, 1945' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: '1945-218' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: '1945218' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: '1945W32-1' readStream into: (Array new: 4)"
	"ChronosParser default parseYearMonthDayFrom: '1945W321' readStream into: (Array new: 4)"

	| year monthSpec day isIsoYearWeekDayOfWeek isoWeekOfYear |
	ChronosFunction skipOver: stream until: [:ch | ch isAlphaNumeric].
	stream atEnd ifTrue: [^nil].	
	year := self 
				parseYearFrom: stream 
				handleRejection: 
					[:value :digitCount :rejectionReason |
					rejectionReason == #notAnInteger 
						ifTrue: [^self parseMonthDayYearFrom: stream into: ymdTzArray] 
						ifFalse: [self handleInvalidYear: value digitCount: digitCount problemKey: rejectionReason]].
	isIsoYearWeekDayOfWeek := true.
	isoWeekOfYear := self parseIsoWeekOfYearFrom: stream handleRejection: [:value :digitCount :problem | isIsoYearWeekDayOfWeek := false].
	isIsoYearWeekDayOfWeek
		ifTrue: 
			[monthSpec := isoWeekOfYear negated.
			day := 
				self 
					parseIsoDayOfWeekFrom: stream 
					handleRejection: [:value :digitCount :problem | self handleInvalidIsoDayOfWeek: value digitCount: digitCount problemKey: problem]]
		ifFalse:
			[monthSpec := 
				self 
					parseMonthFrom: stream 
					maxDigits: 4 
					handleRejection: 
						[:month :count :problem | 
							month isInteger
								ifTrue: 
									[count = 3
										ifTrue: 
											[day := month.
											stream skip: 3.
											nil]
										ifFalse: 
											[stream skip: 4.
											day := month \\ 100.
											month // 100]]
								ifFalse: [problem == #streamAtEnd ifFalse: [self handleInvalidMonth: month problemKey: problem]]].
			day == nil
				ifTrue: 
					[ChronosFunction skipOver: stream until: [:ch | ch isDigit].
					day := 
						self 
							parseDayOfMonthFrom: stream
							maxDigits: 4
							handleRejection: 
								[:value :digitCount :rejectionReason | 
								| dayOfMonth | 
								digitCount > 0 
									ifTrue:  
										[(year between: 1 and: calendar maxDaysPerMonth)
											ifTrue: 
												[| month |
												month := monthSpec.
												month isInteger 
													ifTrue: 
														[year > calendar maxMonthsPerYear
															ifTrue: [dayOfMonth := year]
															ifFalse: 
																[month > calendar maxMonthsPerYear
																	ifTrue: 
																		[dayOfMonth := month.
																		monthSpec := year]
																	ifFalse: [dayOfMonth := year]]]
													ifFalse: [dayOfMonth := year].
												stream skip: digitCount.
												year := value.
												dayOfMonth]
											ifFalse: [self handleInvalidDayOfMonth: value digitCount: digitCount problemKey: rejectionReason]]
									ifFalse: 
										[(rejectionReason == #notAnInteger and: [monthSpec value isInteger])
											ifTrue: 
												[dayOfMonth := monthSpec value.
												monthSpec := 
													self 
														parseMonthFrom: stream 
														maxDigits: 2 
														handleRejection: [:month :count :problem | self handleInvalidMonth: month problemKey: problem].		
												dayOfMonth]
											"ifFalse:  [self handleInvalidDayOfMonth: value digitCount: digitCount problemKey: rejectionReason]"]]]].
	ymdTzArray 
		at: 1 put: year;
		at: 2 put: monthSpec;
		at: 3 put: day.
	^ymdTzArray! !

Registratable subclass: #ChronosPrintPolicy
	instanceVariableNames: ''
	classVariableNames: 'ANSIStandard ISO8601 SpecRegistry'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Printing'!

!ChronosPrintPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
ansiStandard
	"ChronosPrintPolicy ansiStandard now"

	ANSIStandard == nil 
		ifTrue: 
			[| ansiStandard |
			ansiStandard := self newANSIStandard.
			ansiStandard  
				setKey: #ansiStandard;
				forceRegistration.
			ANSIStandard := ansiStandard].
	^ANSIStandard! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
at: key ifAbsent: notFound 
	"ChronosPrintPolicy at: #default"
	"ChronosPrintPolicy at: #ansiStandard"
	"ChronosPrintPolicy at: #iso8601"
	"ChronosPrintPolicy at: #rfc2822"

	| policy |
	(key == #default or: [key == #ansiStandard]) ifTrue: [^self ansiStandard].
	key == #iso8601 ifTrue: [^self iso8601].
	policy := self registry at: key ifAbsent: [0].
	^(policy == nil or: [policy = 0])
		ifTrue: 
			[(self applying: (self specificationAt: key ifAbsent: [^notFound value]))
				setKey: key; forceRegistration]
		ifFalse: [policy]! !

!ChronosPrintPolicy class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	| key |
	key := literalArray at: 2.
	^ChronosPrintPolicy 
		at: key
		ifAbsent: 
			[(self new)
				initializeFromLiteralArray: literalArray;
				beImmutable]! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
default
	^self ansiStandard! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
dmyOnly
	"ChronosPrintPolicy dmyOnly now"

	^self at: #dmyOnly! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
forLocaleAt: localeKey do: block1
	^ChronosLocale at: localeKey do: [:locale | block1 value: locale temporalPrintPolicy]! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
germanLong
	"ChronosPrintPolicy germanLong now"
	"{ChronosPrintPolicy forLocaleAt: #'de_DE' do: [:printPolicy | (printPolicy apply: (self specificationAt: #germanLong ifAbsent: [])) nowIn: 'Europe/Berlin']}"

	^self at: #germanLong! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
germanShort
	"ChronosPrintPolicy germanShort now"
	"{ChronosPrintPolicy forLocaleAt: #'de_DE' do: [:printPolicy | (printPolicy apply: (self specificationAt: #germanShort ifAbsent: [])) nowIn: 'Europe/Berlin']}"

	^self at: #germanShort! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
handleUnregistered: aKey
	^self signalError: 'Unrecognized printPolicy key: ', aKey printString! !

!ChronosPrintPolicy class methodsFor: 'class initialization' stamp: ''!
initialize
	"ChronosPrintPolicy initialize"
 
	self basicInitializeAll.	
	ANSIStandard := nil.
	ISO8601 := nil.
	self initializeSpecifications! !

!ChronosPrintPolicy class methodsFor: 'class initialization' stamp: ''!
initializeSpecifications
	"ChronosPrintPolicy initializeSpecifications"

	| rfc2822Spec |
	self setSpecRegistry.
	self 
		specificationAt: #dmyOnly 
		put: #(hideTimeOfDay
				hideTimeZone
				useMonthAbbreviation
				useDayMonthYearOrder 
				hideDayOfWeek 
				hideEraName 
				hideStandardCalendarName 
				dateSeparator: $ 
				datePadChar: nil).
	self 
		specificationAt: #mdyOnly 
		put: #(hideTimeOfDay
				hideTimeZone
				useMonthAbbreviation
				useMonthDayYearOrder 
				hideDayOfWeek 
				hideEraName 
				hideStandardCalendarName 
				dateSeparator: $ ).
	self 
		specificationAt: #ymdOnly 
		put: #(hideTimeOfDay
				hideTimeZone
				useNumericMonthDesignator
				useYearMonthDayOrder 
				hideDayOfWeek 
				hideEraName 
				hideStandardCalendarName 
				dateSeparator: $-).
	rfc2822Spec := 
				#(confomToLocale: #en
				padChar: $0
				showDayOfWeekAbbreviation 
				useDayMonthYearOrder 
				useMonthAbbreviation 
				yearMonthSeparator:monthDayOfMonthSeparator:dayOfMonthYearSeparator: $ $  ', '
				hideEraName 
				showTimeOfDay
				dateAndTimeSeparator: $ 
				use24HourFormat
				timeOfDayPrefix: nil
				hideSubsecondFraction
				showTimeZoneOffset
				timeZoneSeparator: $ 
				timeZoneElementSeparator: nil
				hideNamesOfDurationElements
				showNamesOfCalendarDurationElements
				durationElementSeparator: $:
				calendarDurationElementSeparator: $ 
				durationDayHourSeparator: $T 
				calendarDurationDayHourSeparator: $ 
				durationPadChar: $0
				calendarDurationPadChar: nil).
	self 
		specificationAt: #rfc2822 
		put: rfc2822Spec.
	self 
		specificationAt: #rfc822 
		put: (rfc2822Spec copyWith: #useTwoDigitYears).
	self 
		specificationAt: #rfc2822v 
		put: (rfc2822Spec copyWith: #showTimeZoneVerbosely).
	self
		specificationAt: #isoWeekOfYearDayOfWeek
		put: #(useISOWeekOfYearDayOfWeek).
	self 
		specificationAt: #usLong
		put: #(confomToLocale: #'en_US'
				showDayOfWeekName 
				useMonthDayYearOrder 
				useMonthName 
				yearMonthSeparator:monthDayOfMonthSeparator:dayOfMonthYearSeparator: $ $  ', '
				padChar: nil 
				dateAndTimeSeparator: '  ' 
				timeOfDayPrefix: nil
				showTimeOfDay
				use12HourFormat
				hideSubsecondFraction
				timeZoneSeparator: $ 
				timeZoneElementSeparator: nil
				showTimeZoneAbbreviation
				showNamesOfDurationElements
				showNamesOfCalendarDurationElements
				durationElementSeparator: $ 
				calendarDurationElementSeparator: $ 
				durationDayHourSeparator: $ 
				calendarDurationDayHourSeparator: $ 
				durationPadChar: nil
				calendarDurationPadChar: nil).
	self 
		specificationAt: #usShort
		put: #(confomToLocale: #'en_US'
				useMonthOrdinal
				useMonthDayYearOrder 
				yearMonthSeparator:monthDayOfMonthSeparator:dayOfMonthYearSeparator: $/ $/ $/
				padChar: nil 
				dateAndTimeSeparator: $ 
				timeOfDayPrefix: nil
				showTimeOfDay
				use12HourFormat
				hideTimeOfDaySecond
				timeZoneSeparator: $ 
				timeZoneElementSeparator: nil
				showTimeZoneAbbreviation
				showNamesOfCalendarDurationElements
				calendarDurationElementSeparator: $ 
				durationDayHourSeparator: $T 
				calendarDurationDayHourSeparator: $ 
				calendarDurationPadChar: nil).
	self
		specificationAt: #germanShort
		put: #(useMonthOrdinal
				useDayMonthYearOrder 
				yearMonthSeparator:monthDayOfMonthSeparator:dayOfMonthYearSeparator: '. ' '. ' '. '
				padChar: nil 
				useMonthAbbreviation
				dateAndTimeSeparator: $  
				timeOfDayPrefix: nil
				showTimeOfDay
				hourMinuteSecondSeparator: $.
				use24HourFormat
				hideSubsecondFraction
				timeZoneSeparator: $ 
				timeZoneElementSeparator: nil
				showTimeZoneAbbreviation
				durationDayHourSeparator: $T 
				calendarDurationDayHourSeparator: $T).
	self
		specificationAt: #germanLong
		put: #(showDayOfWeekName 
				useMonthOrdinal
				useDayMonthYearOrder 
				yearMonthSeparator:monthDayOfMonthSeparator:dayOfMonthYearSeparator: $  '. ' '. '
				padChar: nil 
				useMonthName
				dateAndTimeSeparator: $  
				timeOfDayPrefix: nil
				showTimeOfDay
				hourMinuteSecondSeparator: $.
				use24HourFormat
				hideSubsecondFraction
				timeZoneSeparator: $ 
				timeZoneElementSeparator: nil
				showTimeZoneAbbreviation
				durationDayHourSeparator: $T 
				calendarDurationDayHourSeparator: $T).
	self
		specificationAt: #universal
		put: #(useNumericMonthDesignator 
				showEraNameAfterDate 
				dateAndTimeSeparator: ' @ ' 
				timeOfDayPrefix: nil
				use12HourFormat 
				hourPadChar: nil 
				hideSubsecondFraction
				timeZoneSeparator: $ 
				timeZoneElementSeparator: nil 
				showStandardCalendarName).
	self 
		specificationAt: #verbose 
		put: #(showDayOfWeekName 
				useDayMonthYearOrder 
				useMonthName 
				yearMonthSeparator:monthDayOfMonthSeparator:dayOfMonthYearSeparator: $  $  $ 
				showEraNameAfterDate 
				padChar: nil
				dateAndTimeSeparator: ' @ ' 
				timeOfDayPrefix: nil
				showTimeOfDay
				use12HourFormat
				showTimeOfDaySecondWithFraction
				timeZoneSeparator: $ 
				timeZoneElementSeparator: nil
				showTimeZoneVerbosely
				showNamesOfDurationElements
				showNamesOfCalendarDurationElements
				durationElementSeparator: $ 
				calendarDurationElementSeparator: $ 
				durationDayHourSeparator: $ 
				calendarDurationDayHourSeparator: $ 
				durationPadChar: nil
				calendarDurationPadChar: nil).
	self 
		specificationAt: #vwTimestamp
		put: #(confomToLocale: #'en_US'
				showTimeOfDay
				showTimeOfDaySecondWithFraction
				hideTimeZone 
				useMonthName 
				useMonthDayYearOrder 
				hideDayOfWeek
				hideEraName 
				hideStandardCalendarName 
				datePadChar: nil 
				yearMonthSeparator:monthDayOfMonthSeparator:dayOfMonthYearSeparator: $ $  ', '
				timeOfDayPrefix: $  
				dateAndTimeSeparator: nil
				use24HourFormat
				hourPadChar: nil
				subSecondTimeMinPrecision: 3
				dateAndTimeMaxPrecision: 3
				subSecondDurationMaxPrecision: 6).! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
iso8601
	"ChronosPrintPolicy iso8601 now"

	ISO8601 == nil 
		ifTrue: 
			[| iso8601 |
			iso8601 := self newISO8601.
			iso8601 
				setKey: #iso8601;
				forceRegistration.
			ISO8601 := iso8601].
	^ISO8601! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
isoWeekOfYearDayOfWeek
	"ChronosPrintPolicy isoWeekOfYearDayOfWeek now"

	^self at: #isoWeekOfYearDayOfWeek! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
mdyOnly
	"ChronosPrintPolicy mdyOnly now"

	^self at: #mdyOnly! !

!ChronosPrintPolicy class methodsFor: 'instance creation' stamp: ''!
new
	^self newConfigurable! !

!ChronosPrintPolicy class methodsFor: 'instance creation' stamp: ''!
newANSIStandard
	"PRINT IT: {ChronosPrintPolicy newANSIStandard}"

	^ChronosPrintPolicy basicNew! !

!ChronosPrintPolicy class methodsFor: 'instance creation' stamp: ''!
newConfigurable
	^ConfigurableChronosPrintPolicy basicNew initialize! !

!ChronosPrintPolicy class methodsFor: 'instance creation' stamp: ''!
newISO8601
	"PRINT IT: {ChronosPrintPolicy newISO8601}"

	^ISO8601PrintPolicy new! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
referencedBy: aChronosPrintPolicyOrChronosPrintPolicyKeyOrChronosPrintPolicySpec 
	"Answer the value referenced by <aChronosPrintPolicyOrChronosPrintPolicyKeyOrChronosPrintPolicySpec>. If the value is a key, answer the value bound to the key. If the value is a sequenceable collection, answer the result of creating an instance of ChronosConfigurablePrintPolicy and then sending it the messages that are the elements of the sequenceable collection.  Otherwise, answer aChronosPrintPolicyOrChronosPrintPolicyKeyOrChronosPrintPolicySpec itself."

	"(ChronosPrintPolicy referencedBy: ChronosPrintPolicy iso8601) now"
	"(ChronosPrintPolicy referencedBy: #rfc2822) now"
	"(ChronosPrintPolicy referencedBy: 
		#(useNumericMonthDesignator 
		showEraName 
		dateAndTimeSeparator: ' @ ' 
		use12HourFormat 
		hourPadChar: nil 
		hideSubsecondFraction
		timeZoneSeparator: $ 
		timeZoneElementSeparator: nil 
		showStandardCalendarName)) now"

	^aChronosPrintPolicyOrChronosPrintPolicyKeyOrChronosPrintPolicySpec 
		isString 
			ifTrue: 
				[super 
					referencedBy: aChronosPrintPolicyOrChronosPrintPolicyKeyOrChronosPrintPolicySpec]
			ifFalse: 
				[aChronosPrintPolicyOrChronosPrintPolicyKeyOrChronosPrintPolicySpec 
					isSequenceable 
						ifTrue: 
							[(self 
								applying: aChronosPrintPolicyOrChronosPrintPolicyKeyOrChronosPrintPolicySpec) beImmutable]
						ifFalse: 
							[super 
								referencedBy: aChronosPrintPolicyOrChronosPrintPolicyKeyOrChronosPrintPolicySpec]]! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
rfc2822
	"ChronosPrintPolicy rfc2822 now"

	^self at: #rfc2822! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
rfc2822v
	"ChronosPrintPolicy rfc2822v now"

	^self at: #rfc2822v! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
rfc822
	"ChronosPrintPolicy rfc822 now"

	^self at: #rfc822! !

!ChronosPrintPolicy class methodsFor: 'private' stamp: ''!
setSpecRegistry
	SpecRegistry := IdentityDictionary new.! !

!ChronosPrintPolicy class methodsFor: 'private' stamp: ''!
specRegistry
	SpecRegistry == nil ifTrue: [self setSpecRegistry].
	^SpecRegistry! !

!ChronosPrintPolicy class methodsFor: 'specifications' stamp: ''!
specificationAt: key ifAbsent: ifAbsent
	^self specRegistry at: key ifAbsent: ifAbsent! !

!ChronosPrintPolicy class methodsFor: 'specifications' stamp: ''!
specificationAt: key put: aPrintPolicySpec
	self specRegistry at: key put: aPrintPolicySpec! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
universal
	"ChronosPrintPolicy universal now"

	^self at: #universal! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
usLong
	"ChronosPrintPolicy usLong now"

	^self at: #usLong! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
usShort
	"ChronosPrintPolicy usShort now"

	^self at: #usShort! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
verbose
	"ChronosPrintPolicy verbose now"

	^self at: #verbose! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
vwTimestamp
	"{ChronosPrintPolicy vwTimestamp now}"
	"{Timestamp now printString}"

	^self at: #vwTimestamp! !

!ChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
ymdOnly
	"ChronosPrintPolicy ymdOnly now"

	^self at: #ymdOnly! !

!ChronosPrintPolicy methodsFor: 'name lookup' stamp: ''!
abbreviationAtSemanticKey: semanticKey
	^self effectiveLocale abbreviationAtSemanticKey: semanticKey! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
calendarDurationDayHourSeparator
	^$T! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
calendarDurationElementSeparator
	^nil! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
calendarDurationPadChar
	^nil! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
canConformToLocale
	^false! !

!ChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
dateAndTimeMaxPrecision
	^#all! !

!ChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
dateAndTimeOrder 
	^#useDateBeforeTimeOrder! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
dateAndTimeSeparator
	^nil! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
dateToday
	"ChronosPrintPolicy usShort dateToday"

	^DateFactory today printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
dateTodayAs: calendar
	"ChronosPrintPolicy universal dateTodayAs: #'Julian-Imperial'"

	^(DateFactory todayAs: calendar) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
dateTodayIn: aTimezone
	"ChronosPrintPolicy usLong dateTodayIn: 'Pacific/Auckland'"
	"ChronosPrintPolicy isoWeekOfYearDayOfWeek dateTodayIn: 'Pacific/Honolulu'"

	^(DateFactory todayIn: aTimezone) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
dateTodayIn: aTimezone as: aCalendar
	"ChronosPrintPolicy verbose dateTodayIn: 'Pacific/Auckland' as: #'Julian-Imperial'"

	^(DateFactory todayIn: aTimezone as: aCalendar) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
dayOfMonthPadChar
	^$0! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
dayYearSeparator
	^$-! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
decimalPointChar
	^$. "Per ANSI Smalltalk Standard"! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
dontPrintYear: year on: stream 
	" Do nothing!!"! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationDayHourSeparator
	^$:! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationElementSeparator
	^$:! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationPadChar
	^$0! !

!ChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
effectiveLocale
	^ChronosLocale english! !

!ChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
eraPolicy
	^nil "Don't show the era name"! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
hidesDayOfWeek
	^true! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
hidesTimeZone
	^false! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
hourMinuteSecondSeparator
	^$:! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
hourPadChar
	^$0! !

!ChronosPrintPolicy methodsFor: 'name lookup' stamp: ''!
monthAbbreviationFrom: aDate
	^aDate
		forLocale: self effectiveLocale
		monthAbbreviationIfResolvable: [:name | name]
		ifNot: [(self singularNounAtSemanticKey: #month), aDate monthOrdinal printString]! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
monthDaySeparator
	^$-! !

!ChronosPrintPolicy methodsFor: 'name lookup' stamp: ''!
monthNameFrom: aDate
	^aDate
		forLocale: self effectiveLocale
		monthNameIfResolvable: [:name | name]
		ifNot: [(self singularNounAtSemanticKey: #month), aDate monthOrdinal printString]! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
monthPadChar
	^$0! !

!ChronosPrintPolicy methodsFor: 'name lookup' stamp: ''!
nameAbbreviationOfDayOfWeekAt: dayOfWeekKey
	^self effectiveLocale abbreviationAtSemanticKey: dayOfWeekKey! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
nominalNow
	"ChronosPrintPolicy usShort nominalNow"

	^DateAndTimeFactory nominalNow printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
nominalNowAs: calendar
	"ChronosPrintPolicy rfc2822 nominalNowAs: #Hebrew"

	^(DateAndTimeFactory nominalNowAs: calendar) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
now
	"ChronosPrintPolicy universal now"
	"ChronosPrintPolicy rfc2822 now"
	"ChronosPrintPolicy verbose now"
	"ChronosPrintPolicy usLong now"
	"ChronosPrintPolicy usShort now"
	"ChronosPrintPolicy iso8601 now"
	"(ChronosPrintPolicy applying: 
		#(showEraNameBeforeDate)) now" 
	"{(ChronosPrintPolicy applying: 
		#(useTimeBeforeDateOrder 
		useMonthDayYearOrder
		useMonthName
		dateSeparator: $ 
		timeOfDayPrefix: '
                The current local time: ' 
		dateAndTimeSeparator: '.
                Today''s date: '
		hideSubsecondFraction
		timeZoneSeparator: '.
                Time zone offset: '
		timeZoneElementSeparator: $h)) now}"

	^DateAndTimeFactory now printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
nowAs: calendar
	"ChronosPrintPolicy rfc2822 nowAs: #Ethiopic"
	"ChronosPrintPolicy universal nowAs: #Ethiopic"
	"ChronosPrintPolicy verbose nowAs: #Ethiopic"

	^(DateAndTimeFactory nowAs: calendar) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
nowIn: aTimezone
	"ChronosPrintPolicy universal nowIn: 'Europe/Moscow'"
	"ChronosPrintPolicy rfc2822 nowIn: 'Europe/Moscow'"
	"ChronosPrintPolicy usLong nowIn: 'Europe/Moscow'"

	^(DateAndTimeFactory nowIn: aTimezone) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
nowIn: aTimezone as: aCalendar
	"ChronosPrintPolicy verbose nowIn: 'Asia/Tehran' as: #Persian"

	^(DateAndTimeFactory nowIn: aTimezone as: aCalendar) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
nowToTheSecond
	"ChronosPrintPolicy universal nowToTheSecond"
	"ChronosPrintPolicy rfc2822 nowToTheSecond"
	"ChronosPrintPolicy verbose nowToTheSecond"
	"ChronosPrintPolicy usLong nowToTheSecond"
	"ChronosPrintPolicy usShort nowToTheSecond"
	"ChronosPrintPolicy iso8601 nowToTheSecond"

	^DateAndTimeFactory nowToTheSecond printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'name lookup' stamp: ''!
pluralNounAtSemanticKey: semanticKey
	^self effectiveLocale pluralNounAtSemanticKey: semanticKey! !

!ChronosPrintPolicy methodsFor: 'printing-polymorphic' stamp: ''!
print: aTemporal on: stream
	aTemporal printOn: stream using: self! !

!ChronosPrintPolicy methodsFor: 'printing-names' stamp: ''!
printAbbreviationAt: semanticKey on: stream
	stream
		nextPutAll: (self abbreviationAtSemanticKey: semanticKey)! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printAbbreviationOfTimeZoneFrom: aTimepoint on: stream 
	self 
		printAbbreviationOfTimeZoneFrom: aTimepoint
		prefix: $ 
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printAbbreviationOfTimeZoneFrom: aTimepoint prefix: prefix on: stream 
	self printSeparator: prefix on: stream.
	stream nextPutAll: aTimepoint timeZoneAbbreviation! !

!ChronosPrintPolicy methodsFor: 'printing-annual dates' stamp: ''!
printAnnualDate: anAnnualDate on: stream 
	(self shouldShowCalendarNameOf: anAnnualDate) 
		ifTrue: 
			[stream space.
			self printCalendarNameFrom: anAnnualDate on: stream].
	anAnnualDate class printOn: stream! !

!ChronosPrintPolicy methodsFor: 'printing-calendarPeriods' stamp: ''!
printCalendarDay: aCalendarDay on: stream
	self printMonthDayFrom: aCalendarDay on: stream.! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printCalendarElementsFrom: aDate maxPrecision: maxPrecision on: stream 
	self printYearMonthDayFrom: aDate maxPrecision: maxPrecision on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printCalendarElementsFrom: aDate on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printCalendarNameFrom: aDate on: stream
	stream 
		nextPut: $[;
		nextPutAll: (self properNameAtSemanticKey: aDate  calendarRegistrationKey);
		nextPut: $]! !

!ChronosPrintPolicy methodsFor: 'printing-durations' stamp: ''!
printCivilDuration: aCalendarDuration on: stream 
	self 
		printCivilDuration: aCalendarDuration
		separator: self calendarDurationElementSeparator
		dayHourSeparator: self calendarDurationDayHourSeparator
		padWith: self calendarDurationPadChar
		appendElementNames: self showsNamesOfCalendarDurationElements
		suppressZeroValuedElements: self suppressesZeroValuedCalendarDurationElements
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-durations' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
printCivilDuration: aCalendarDuration separator: separator dayHourSeparator: dayHourSeparator padWith: padChar appendElementNames: showNamesOfDurationElements suppressZeroValuedElements: suppressZeroValuedDurationElements on: stream 
	| years months days seconds nanosecondsSinceSecond secondsAndNanosecondsAreZero monthsAndDaysAreZero hasPrefix |
	hasPrefix := false.
	showNamesOfDurationElements ifFalse: [stream nextPut: $P].
	years := aCalendarDuration years.
	months := aCalendarDuration months.
	days := aCalendarDuration days.
	seconds := aCalendarDuration secondsSinceStartOfDay.
	nanosecondsSinceSecond := aCalendarDuration nanosecondsSinceSecond.
	secondsAndNanosecondsAreZero := seconds = 0 and: [nanosecondsSinceSecond = 0].
	monthsAndDaysAreZero := days = 0 and: [months = 0].
	(suppressZeroValuedDurationElements and: 
			[secondsAndNanosecondsAreZero and: [monthsAndDaysAreZero and: [years = 0]]]) 
		ifTrue: [self printZeroDurationPadWith: padChar appendElementNames: showNamesOfDurationElements on: stream]
		ifFalse: 
			[(self 
				printValue: years elementNameKey: (showNamesOfDurationElements ifTrue: [#year])
				isPrefixed: false separator: nil
				padWith: padChar to: 4
				suppressIfZero: suppressZeroValuedDurationElements
				on: stream) 
					ifTrue: 
						[hasPrefix := true.
						showNamesOfDurationElements 
							ifFalse: [suppressZeroValuedDurationElements ifTrue: [stream nextPut: $Y]]].
			(suppressZeroValuedDurationElements 
				and: [secondsAndNanosecondsAreZero and: [monthsAndDaysAreZero]]) 
					ifFalse: 
						[(self 
							printValue: months elementNameKey: (showNamesOfDurationElements ifTrue: [#month])
							isPrefixed: hasPrefix separator: separator
							padWith: padChar to: 2
							suppressIfZero: suppressZeroValuedDurationElements
							on: stream) 
								ifTrue: 
									[hasPrefix := true.
									showNamesOfDurationElements 
										ifFalse: [suppressZeroValuedDurationElements ifTrue: [stream nextPut: $M]]].
						(suppressZeroValuedDurationElements 
							and: [secondsAndNanosecondsAreZero and: [days = 0]]) 
								ifFalse: 
									[self 
										printDurationElementsFromSeconds: days * SecondsPerDay + seconds
										nanoseconds: nanosecondsSinceSecond
										isPrefixed: hasPrefix
										dayHourSeparator: dayHourSeparator
										hmsSeparator: separator
										padWith: padChar
										appendElementNames: showNamesOfDurationElements
										suppressZeroValuedElements: suppressZeroValuedDurationElements
										on: stream]]].! !

!ChronosPrintPolicy methodsFor: 'printing-dates/timepoints' stamp: ''!
printDate: aDate maxPrecision: maxPrecision showCalendar: showCalendar on: stream 
	self 
		printDate: aDate
		showDayOfWeek: self showsDayOfWeek
		maxPrecision: maxPrecision
		eraPolicy: self eraPolicy
		showCalendar: showCalendar
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates/timepoints' stamp: ''!
printDate: aDate on: stream 
	self 
		printDate: aDate
		maxPrecision: self dateAndTimeMaxPrecision
		showCalendar: (self shouldShowCalendarNameOf: aDate) 
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates/timepoints' stamp: ''!
printDate: aDate showDayOfWeek: showDayOfWeek maxPrecision: maxPrecision eraPolicy: eraPolicy showCalendar: showCalendar on: stream 
	showDayOfWeek 
		ifTrue: 
			[self printDayOfWeekFrom: aDate on: stream.
			stream nextPutAll: ', '].
	eraPolicy == #showEraNameBeforeDate
		ifTrue: 
			[self printEraNameFrom: aDate on: stream.
			stream space].
	self printCalendarElementsFrom: aDate maxPrecision: maxPrecision on: stream.
	eraPolicy == #showEraNameAfterDate
		ifTrue: 
			[stream space.
			self printEraNameFrom: aDate on: stream].
	showCalendar
		ifTrue: 
			[stream space.
			self printCalendarNameFrom: aDate on: stream]! !

!ChronosPrintPolicy methodsFor: 'printing-dates/timepoints' stamp: ''!
printDateAndTime: aDateAndTime maxPrecision: maxPrecision dateAndTimeSeparator: dateAndTimeSeparator showTimeZone: showTimeZone on: stream 
	self dateAndTimeOrder == #useDateBeforeTimeOrder 
		ifTrue: 
			[aDateAndTime isCalendricalCoordinate 
				ifTrue: 
					[self 
						printDate: aDateAndTime
						maxPrecision: maxPrecision
						showCalendar: false
						on: stream].
			(maxPrecision isInteger 
				or: [(#(#all #minute #hour #day #month #year) indexOf: maxPrecision) < 4]) 
					ifTrue: 
						[self printSeparator: dateAndTimeSeparator on: stream.
						self 
							printTimeOfDay: aDateAndTime
							maxPrecision: maxPrecision
							on: stream]]
		ifFalse: 
			[(maxPrecision isInteger 
				or: [(#(#all #minute #hour #day #month #year) indexOf: maxPrecision) < 4]) 
					ifTrue: 
						[self 
							printTimeOfDay: aDateAndTime
							maxPrecision: maxPrecision
							on: stream.
						self printSeparator: dateAndTimeSeparator on: stream].
			aDateAndTime isCalendricalCoordinate 
				ifTrue: 
					[self 
						printDate: aDateAndTime
						maxPrecision: maxPrecision
						showCalendar: false
						on: stream]].
	showTimeZone ifTrue: [self printTimeZoneFrom: aDateAndTime on: stream].
	(self shouldShowCalendarNameOf: aDateAndTime) 
		ifTrue: 
			[stream space.
			self printCalendarNameFrom: aDateAndTime on: stream]! !

!ChronosPrintPolicy methodsFor: 'printing-dates/timepoints' stamp: ''!
printDateAndTime: aDateAndTime on: stream 
	self 
		printDateAndTime: aDateAndTime
		maxPrecision: self dateAndTimeMaxPrecision 
		dateAndTimeSeparator: self dateAndTimeSeparator
		showTimeZone: (self showsTimeZone and: [aDateAndTime isInvariantToUT])
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printDayMonthYearFrom: aDate maxPrecision: maxPrecision  dayMonthSeparator: monthDaySep monthYearSeparator: yearMonthSep on: stream 
	| mp |
	mp := 
		maxPrecision isInteger
			ifTrue: [maxPrecision negated]
			ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
	(mp < 6) 
			ifTrue: 
				[(mp < 5) 
						ifTrue: 
							[self printDayOfMonthFrom: aDate on: stream.
							self printSeparator: monthDaySep on: stream].
				self printMonthAbbreviationFrom: aDate on: stream.
				self printSeparator: yearMonthSep on: stream].
	self printYear: aDate year on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printDayMonthYearFrom: aDate maxPrecision: maxPrecision on: stream 
	self 
		printDayMonthYearFrom: aDate
		maxPrecision: maxPrecision
		dayMonthSeparator: self monthDaySeparator
		monthYearSeparator: self yearMonthSeparator
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-annual dates' stamp: ''!
printDayOfMonth: aDayOfMonth on: stream 
	self printMonthDayFrom: aDayOfMonth on: stream.
	(self shouldShowCalendarNameOf: aDayOfMonth) 
		ifTrue: 
			[stream space.
			self printCalendarNameFrom: aDayOfMonth on: stream].! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printDayOfMonthFrom: aDate on: stream 
	ChronosFunction 
		print: aDate dayOfMonth
		paddedWith: self dayOfMonthPadChar
		to: 2
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printDayOfWeekFrom: aDate on: stream 
	self printProperNameAt: aDate dayOfWeekKey on: stream.! !

!ChronosPrintPolicy methodsFor: 'printing-annual dates' stamp: ''!
printDayOfYear: aDayOfYear on: stream 
	stream nextPutAll: 'YYYY'.
	self printSeparator: $- on: stream.
	self printDayOfYearFrom: aDayOfYear on: stream.
	(self shouldShowCalendarNameOf: aDayOfYear) 
		ifTrue: 
			[stream space.
			self printCalendarNameFrom: aDayOfYear on: stream].! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printDayOfYearFrom: aDate on: stream 
	ChronosFunction 
		print: aDate dayOfYear
		paddedWith: $0
		to: 3
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printDaysSinceEpochFrom: aDate maxPrecision: maxPrecision on: stream
	stream nextPutAll: 'D.S.E. '.
	aDate daysSinceEpoch printOn: stream.! !

!ChronosPrintPolicy methodsFor: 'printing-durations' stamp: ''!
printDuration: aDuration on: stream
	aDuration positive ifFalse: [stream nextPut: $-].
	self 
		printDurationElementsFromSeconds: aDuration asSeconds abs
		nanoseconds: aDuration nanosecondsSinceSecond abs
		isPrefixed: false
		dayHourSeparator: self durationDayHourSeparator
		hmsSeparator: self durationElementSeparator
		padWith: self durationPadChar
		appendElementNames: self showsNamesOfDurationElements
		suppressZeroValuedElements: self suppressesZeroValuedDurationElements
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-durations' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
printDurationElementsFromSeconds: seconds nanoseconds: nanoseconds isPrefixed: isPrefixed dayHourSeparator: daysAndHoursSep hmsSeparator: hourMinuteSecondSeparator padWith: durationPadChar appendElementNames: showNamesOfDurationElements suppressZeroValuedElements: suppressZeroValuedDurationElements on: stream 
	| secondsSinceMinute days subDays hours subHours minutes hasPrefix secondsPrinted |
	(seconds = 0 and: [nanoseconds = 0]) 
		ifTrue: [self printZeroDurationPadWith: durationPadChar appendElementNames: showNamesOfDurationElements on: stream]
		ifFalse: 
			[days := seconds quo: SecondsPerDay.
			subDays := seconds rem: SecondsPerDay.
			hours := subDays quo: (SecondsPerHour).
			subHours := subDays rem: (SecondsPerHour).
			minutes := subHours quo: (SecondsPerMinute).
			secondsSinceMinute := subHours rem: (SecondsPerMinute).
			hasPrefix := isPrefixed.
			secondsPrinted := false.
			(self 
				printValue: days elementNameKey: (showNamesOfDurationElements ifTrue: [#day])
				isPrefixed: isPrefixed separator: hourMinuteSecondSeparator
				padWith: durationPadChar to: (suppressZeroValuedDurationElements ifTrue: [1] ifFalse: [2])
				suppressIfZero: suppressZeroValuedDurationElements
				on: stream) 
					ifTrue: 
						[hasPrefix := true.
						showNamesOfDurationElements 
							ifFalse: [suppressZeroValuedDurationElements ifTrue: [stream nextPut: $D]]].
			(suppressZeroValuedDurationElements 
				and: [subDays = 0 and: [nanoseconds = 0]]) 
					ifFalse: 
						[(self 
							printValue: hours elementNameKey: (showNamesOfDurationElements ifTrue: [#hour])
							isPrefixed: hasPrefix separator: daysAndHoursSep
							padWith: durationPadChar to: 2
							suppressIfZero: suppressZeroValuedDurationElements
							on: stream) 
								ifTrue: 
									[hasPrefix := true.
									showNamesOfDurationElements 
										ifFalse: [suppressZeroValuedDurationElements ifTrue: [stream nextPut: $H]]]
								ifFalse: 
									[suppressZeroValuedDurationElements 
										ifTrue: [minutes = 0 
													ifFalse: 
														["The ISO8601 standard label 'M' is ambiguous (month or minute,) so we have to use the <daysAndHoursSep> in this case to disambiguate."
														self printSeparator: daysAndHoursSep on: stream]]].
						(suppressZeroValuedDurationElements 
							and: [subHours = 0 and: [nanoseconds = 0]]) 
								ifFalse: 
									[(self 
										printValue: minutes elementNameKey: (showNamesOfDurationElements ifTrue: [#minute])
										isPrefixed: hasPrefix separator: hourMinuteSecondSeparator
										padWith: durationPadChar to: 2
										suppressIfZero: suppressZeroValuedDurationElements
										on: stream) 
											ifTrue: 
												[hasPrefix := true.
												showNamesOfDurationElements 
													ifFalse: [suppressZeroValuedDurationElements ifTrue: [stream nextPut: $M]]].
									(suppressZeroValuedDurationElements 
										and: [secondsSinceMinute = 0 and: [nanoseconds = 0]]) 
											ifFalse: 
												[secondsPrinted := false.
												(self 
													printValue: secondsSinceMinute elementNameKey: nil
													isPrefixed: hasPrefix separator: hourMinuteSecondSeparator
													padWith: durationPadChar to: 2
													suppressIfZero: suppressZeroValuedDurationElements
													on: stream) ifTrue: [secondsPrinted := true].
												(hasPrefix and: [secondsPrinted not]) ifTrue: [self printSeparator: hourMinuteSecondSeparator on: stream].
												self 
													printNanosecondsSinceSecond: nanoseconds
													asSubsecondFractionOn: stream
													minPrecision: 0
													maxPrecision: self subSecondDurationMaxPrecision
													prependingZero: secondsPrinted not.
												showNamesOfDurationElements 
													ifTrue: 
														[stream space.
														self 
															printTemporalUnitName: #second
															value: ((seconds abs = 1 and: [nanoseconds = 0]) ifTrue: [1] ifFalse: [2])
															on: stream]
													ifFalse: 
														[suppressZeroValuedDurationElements 
															ifTrue: [stream nextPut: $S]]]]]]! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printEraNameFrom: aDate on: stream
	stream 
		nextPutAll: aDate eraName! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printFullYear: year on: stream 
	ChronosFunction 
		print: year
		paddedWith: self yearPadChar
		to: 4
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printGregorianDayFrom: aDate maxPrecision: maxPrecision on: stream
	stream nextPutAll: 'G.D. '.
	aDate asGregorian daysSinceEpoch printOn: stream.! !

!ChronosPrintPolicy methodsFor: 'printing-time of day-elements' stamp: ''!
printHour12: h24 on: stream
	self printHour12: h24 padWith: $  on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time of day-elements' stamp: ''!
printHour12: h24 padWith: pad on: stream
	| hour |
	hour := h24 rem: 12.
	ChronosFunction  print: (hour = 0 ifTrue: [12] ifFalse: [hour]) paddedWith: pad to: 2 on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time of day-elements' stamp: ''!
printHour24: h24 on: stream
	ChronosFunction  print: h24 paddedWith: self hourPadChar to: 2 on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time of day-elements' stamp: ''!
printHour: h24 on: stream
	self uses24HourClock
		ifTrue: [self printHour24: h24 on: stream]
		ifFalse: [self printHour12: h24 on: stream]! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printISOWeekOfYearDayOfWeekFrom: aDate maxPrecision: maxPrecision on: stream 
	| mp |
	mp := 
		maxPrecision isInteger 
			ifTrue: [maxPrecision negated]
			ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
	aDate isoYearWeekDayOfWeekDo: 
			[:year :week :dayOfWeek | 
			year == nil 
				ifFalse: 
					[self printYear: year on: stream.
					mp < 6 ifTrue: [self printSeparator: $- on: stream]].
			mp < 6 
				ifTrue: 
					[stream nextPut: $W.
					ChronosFunction 
						print: week
						paddedWith: $0
						to: 2
						on: stream.
					mp < 5
						ifTrue:
							[self printSeparator: $- on: stream.
							stream print: dayOfWeek]]]! !

!ChronosPrintPolicy methodsFor: 'printing-durations' stamp: ''!
printInfiniteDuration: anInfiniteDuration on: stream
	stream
		nextPut: (anInfiniteDuration positive ifTrue: [$+] ifFalse: [$-]);
		nextPutAll: 'infiniteDuration'! !

!ChronosPrintPolicy methodsFor: 'printing-dates/timepoints' stamp: ''!
printInfiniteTimepoint: anInfiniteTimepoint on: stream
	stream
		nextPut: (anInfiniteTimepoint isInfinitePast ifTrue: [$-] ifFalse: [$+]);
		nextPutAll: 'infiniteTimepoint'! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printJulianDayFrom: aDate maxPrecision: maxPrecision on: stream
	stream nextPutAll: 'J.D. '.
	aDate julianDay printOn: stream.! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printKeyOfTimeZoneFrom: aTimepoint on: stream 
	self 
		printKeyOfTimeZoneFrom: aTimepoint
		prefix: $ 
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printKeyOfTimeZoneFrom: aTimepoint prefix: prefix on: stream 
	self printSeparator: prefix on: stream.
	aTimepoint timeZone printKeyOn: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthAbbreviationFrom: date on: stream 
	stream nextPutAll: (self monthAbbreviationFrom: date)! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthDayFrom: aDate monthDaySeparator: monthDaySep on: stream 
	aDate isMonthKeyResolvable
		ifTrue: [self printMonthAbbreviationFrom: aDate on: stream]
		ifFalse: [self printMonthOrdinalFrom: aDate on: stream].	
	self printSeparator: monthDaySep on: stream.
	self printDayOfMonthFrom: aDate on: stream.! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthDayFrom: aDate on: stream 
	self 
		printMonthDayFrom: aDate
		monthDaySeparator: self monthDaySeparator
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthDayYearFrom: aDate maxPrecision: maxPrecision monthDaySeparator: monthDaySep dayYearSeparator: dayYearSep on: stream 
	| mp |
	mp := 
		maxPrecision isInteger 
			ifTrue: [maxPrecision negated]
			ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
	(mp < 6)
		ifTrue:
			[self printMonthFrom: aDate on: stream.
			self printSeparator: monthDaySep on: stream.
			(mp < 5)
				ifTrue:
					[self printDayOfMonthFrom: aDate on: stream.
					self printSeparator: dayYearSep on: stream]].
	self printYear: aDate year on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthDayYearFrom: aDate maxPrecision: maxPrecision on: stream 
	self 
		printMonthDayYearFrom: aDate
		maxPrecision: maxPrecision
		monthDaySeparator: self monthDaySeparator
		dayYearSeparator: self dayYearSeparator
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthFrom: date on: stream 
	self printMonthOrdinalFrom: date on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthNameFrom: date on: stream 
	stream nextPutAll: (self monthNameFrom: date)! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthOrdinalFrom: date on: stream 
	ChronosFunction  
		print: date month
		paddedWith: self monthPadChar
		to: 2
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-calendarPeriods' stamp: ''!
printMonthlyCalendar: aMonthlyCalendar on: stream
	aMonthlyCalendar basicPrintOn: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printNameOfTimeZoneFrom: aTimepoint on: stream 
	self 
		printNameOfTimeZoneFrom: aTimepoint
		prefix: $ 
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printNameOfTimeZoneFrom: aTimepoint prefix: prefix on: stream 
	self printSeparator: prefix on: stream.
	stream nextPutAll: aTimepoint timeZoneName! !

!ChronosPrintPolicy methodsFor: 'printing-time of day-elements' stamp: ''!
printNanosecondsSinceSecond: nanosecondsSinceSecond asSubsecondFractionOn: stream minPrecision: minPrecision maxPrecision: maxPrecision prependingZero: shouldPrependZero
	ChronosFunction
		print: nanosecondsSinceSecond 
		asPostDecimalOn: stream 
		decimalPoint: self decimalPointChar 
		scale: 9
		minPrecision: minPrecision
		maxPrecision: maxPrecision
		prependingZero: shouldPrependZero! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printNumericMonthDesignatorFrom: date on: stream 
	ChronosFunction  
		print: date numericMonthDesignator
		paddedWith: self monthPadChar
		to: 2
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printOffsetOfTimeZoneFrom: aTimepoint on: stream 
	self printTimeZoneOffset: aTimepoint offset on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printOrdinalDateFrom: aDate maxPrecision: maxPrecision on: stream 
	| mp |
	mp := 
		maxPrecision isInteger 
			ifTrue: [maxPrecision negated]
			ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
	self printYear: aDate year on: stream.
	(mp < 5)
		ifTrue: 
			[self printSeparator: $- on: stream.
			self printDayOfYearFrom: aDate on: stream]! !

!ChronosPrintPolicy methodsFor: 'printing-names' stamp: ''!
printProperNameAt: semanticKey on: stream
	stream
		nextPutAll: (self properNameAtSemanticKey: semanticKey)! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printSemanticKeyFrom: aDate on: stream 
	self printProperNameAt: (aDate semanticKeyIfNone: [^self]) on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-utility' stamp: ''!
printSeparator: separator on: stream
	separator isSequenceable
		ifTrue: [stream nextPutAll: separator]
		ifFalse: [separator == nil ifFalse: [stream nextPut: separator]].! !

!ChronosPrintPolicy methodsFor: 'printing-time of day' stamp: ''!
printSubsecondFractionFrom: aTimeOfDay on: stream prependingZero: shouldPrependZero
	| maxPrecision |
	maxPrecision := self dateAndTimeMaxPrecision.
	self 
		printNanosecondsSinceSecond: aTimeOfDay nanosecondsSinceSecond 
		asSubsecondFractionOn: stream 
		minPrecision: self subSecondTimeMinPrecision
		maxPrecision: ((maxPrecision isInteger or: [maxPrecision == #all]) ifTrue: [maxPrecision] ifFalse: [0])
		prependingZero: shouldPrependZero! !

!ChronosPrintPolicy methodsFor: 'printing-utility' stamp: ''!
printTemporalUnitName: nameKey value: value on: stream
	stream nextPutAll: 
		((value = 1)
			ifTrue: [self singularNounAtSemanticKey: nameKey]
			ifFalse: [self pluralNounAtSemanticKey: nameKey]).! !

!ChronosPrintPolicy methodsFor: 'printing-time of day-elements' stamp: ''!
printTimeElement: aTimeElement on: stream

	ChronosFunction  print: aTimeElement paddedWith: $0 to: 2 on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time of day' stamp: ''!
printTimeOfDay: aTimeOfDay maxPrecision: maxPrecision on: stream 
	self 
		printTimeOfDay: aTimeOfDay
		prefix: self timeOfDayPrefix
		maxPrecision: maxPrecision
		hour24Format: self uses24HourClock
		separator: self hourMinuteSecondSeparator
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time of day' stamp: ''!
printTimeOfDay: aTimeOfDay on: stream 
	self 
		printTimeOfDay: aTimeOfDay
		maxPrecision: self dateAndTimeMaxPrecision
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time of day' stamp: ''!
printTimeOfDay: aTimeOfDay prefix: prefix maxPrecision: maxPrecision hour24Format: hour24 separator: hourMinuteSecondSeparator on: stream 
	self printSeparator: prefix on: stream.
	aTimeOfDay 
		hourMinuteSecondDo: 
			[:hour :minute :second | 
			| mp |
			hour24 
				ifTrue: [self printHour24: hour on: stream]
				ifFalse: [self printHour12: hour on: stream].
			mp := 
				maxPrecision isInteger
					ifTrue: [maxPrecision negated]
					ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
			(mp < 3)
				ifTrue: 
					[self printSeparator: hourMinuteSecondSeparator on: stream.
					self printTimeElement: minute on: stream.
					(mp < 2)
						ifTrue:
							[self printSeparator: hourMinuteSecondSeparator on: stream.
							self printTimeElement: second on: stream.
							self 
								printSubsecondFractionFrom: aTimeOfDay
								on: stream
								prependingZero: false]].
			hour24 
				ifFalse: 
					[stream space.
					self printProperNameAt: (MeridianKeys at: hour // 12 + 1) on: stream]]
		hour24Format: hour24! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printTimeZoneFrom: aTimepoint on: stream 
	self printOffsetOfTimeZoneFrom: aTimepoint on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printTimeZoneOffset: offsetFromUTC on: stream 
	self 
		printTimeZoneOffset: offsetFromUTC
		prefix: self timeZoneSeparator
		elementSeparator: self timeZoneElementSeparator
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: 'PaulDeBruicker 3/9/2011 10:38'!
printTimeZoneOffset: offsetFromUTC prefix: prefix elementSeparator: elementSeparator on: stream 
	| seconds secondsSinceMinute hours minutes |
	offsetFromUTC isZero 
		ifTrue: 
			[^self 
				printTimeZoneZeroOffsetWithPrefix: prefix
				elementSeparator: elementSeparator
				on: stream].
	self printSeparator: prefix on: stream.
	offsetFromUTC positive 
		ifTrue: [stream nextPut: $+]
		ifFalse: [stream nextPut: $-].
	seconds := offsetFromUTC asSeconds.
	secondsSinceMinute := seconds abs.
	hours := secondsSinceMinute // (SecondsPerHour).
	secondsSinceMinute := secondsSinceMinute \\ (SecondsPerHour).
	minutes := secondsSinceMinute // (SecondsPerMinute).
	secondsSinceMinute := secondsSinceMinute \\ (SecondsPerMinute).
	ChronosFunction  
		print: hours
		paddedWith: $0
		to: 2
		on: stream.
	self printSeparator: elementSeparator on: stream.
	ChronosFunction
		print: minutes
		paddedWith: $0
		to: 2
		on: stream.
	(secondsSinceMinute = 0 and: [offsetFromUTC subsecondsAreZero]) 
		ifFalse: 
			[self printSeparator: elementSeparator on: stream.
			ChronosFunction 
				print: secondsSinceMinute
				paddedWith: $0
				to: 2
				on: stream.
			self 
				printNanosecondsSinceSecond: offsetFromUTC nanosecondsSinceSecond 
				asSubsecondFractionOn: stream
				minPrecision: 0
				maxPrecision: #all
				prependingZero: false]! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printTimeZoneVerboselyFrom: aTimepoint on: stream 
	| timeZone |
	self printOffsetOfTimeZoneFrom: aTimepoint on: stream.
	timeZone := aTimepoint timeZone.
	(timeZone isDynamic or: [timeZone specifiesAbbreviation or: [timeZone specifiesName]])
		ifTrue: 
			[| prefix |
			stream nextPutAll: ' ('.
			timeZone specifiesAbbreviation
				ifTrue: 
					[self printAbbreviationOfTimeZoneFrom: aTimepoint prefix: nil on: stream.
					stream nextPutAll: ':'.
					prefix := $ ]
				ifFalse: [prefix := nil].
			timeZone isDynamic
				ifTrue: 
					[self printKeyOfTimeZoneFrom: aTimepoint prefix: prefix on: stream.
					prefix := ' | '].
			timeZone specifiesName
				ifTrue: 
					[self printNameOfTimeZoneFrom: aTimepoint prefix: prefix on: stream].
			stream nextPut: $)].! !

!ChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printTimeZoneZeroOffsetWithPrefix: prefix elementSeparator: elementSeparator on: stream 
	self printSeparator: prefix on: stream.
	stream nextPut: $+.
	ChronosFunction  
		print: 0
		paddedWith: $0
		to: 2
		on: stream.
	self printSeparator: elementSeparator on: stream.
	ChronosFunction  
		print: 0
		paddedWith: $0
		to: 2
		on: stream.! !

!ChronosPrintPolicy methodsFor: 'printing-timeperiods' stamp: ''!
printTimeperiod: aTimeperiod on: stream 
	"ISO8601 format--since ANSI doesn't specify a format for timeperiods (intervals.)"

	| start duration timeperiodDefaultPrinter |
	start := aTimeperiod start.
	duration := aTimeperiod duration.
	timeperiodDefaultPrinter := 
		[start printOn: stream using: self class iso8601.
		stream nextPut: $/.
		duration printOn: stream using: self class ansiStandard].
	duration isMinimumResolutionQuantum 
		ifTrue: [start printOn: stream using: self]
		ifFalse: 
			[(start subsecondsAreZero and: [duration subsecondsAreZero]) 
				ifTrue: 
					[| dateAndTimePrinter seconds minutes hours days months years |
					dateAndTimePrinter :=
						[:maxPrecision | 
							self 
								printDateAndTime: start
								maxPrecision: maxPrecision
								dateAndTimeSeparator: self dateAndTimeSeparator
								showTimeZone: (self showsTimeZone and: [start isInvariantToUT])
								on: stream].
					seconds := duration seconds.
					minutes := duration minutes.
					hours := duration hours.
					days := duration days.
					months := duration months.
					years := duration years.
					(seconds = 1 and: [minutes = 0 and: [hours = 0 and: [days = 0 and: [months = 0 and: [years = 0]]]]])
						ifTrue: [dateAndTimePrinter value: 0]
						ifFalse: 
							[| timeOfDay |
							timeOfDay := start timeOfDaySinceStartOfDay.
							(seconds = 0 and: [timeOfDay second = 0]) 
								ifTrue: 
									[(minutes = 1 and: [hours = 0 and: [days = 0 and: [months = 0 and: [years = 0]]]])
										ifTrue: [dateAndTimePrinter value: #minute]
										ifFalse: 
											[(minutes = 0 and: [timeOfDay minute = 0]) 
												ifTrue: 
													[(hours = 1 and: [days = 0 and: [months = 0 and: [years = 0]]])
														ifTrue: [dateAndTimePrinter value: #hour]
														ifFalse: 
															[(hours = 0 and: [timeOfDay hour = 0]) 
																ifTrue: 
																	[| datePrinter |
																	datePrinter := 
																		[:maxPrecision | 
																			self  printDate: start maxPrecision: maxPrecision showCalendar: false on: stream.
																			(self showsTimeZone and: [start isInvariantToUT]) 
																				ifTrue: [self printTimeZoneFrom: start on: stream].
																			(self shouldShowCalendarNameOf: start) 
																				ifTrue: 
																					[stream space.
																					self printCalendarNameFrom: start on: stream]].
																	(days = 1 and: [months = 0 and: [years = 0]]) 
																		ifTrue: [datePrinter value: #day]
																		ifFalse: 
																			[(days = 0 and: [start isFirstDayOfMonth]) 
																				ifTrue: 
																					[(months = 1 and: [years = 0]) 
																						ifTrue: [datePrinter value: #month]
																						ifFalse: 
																							[(months = 0 and: [start isFirstDayOfYear]) 
																								ifTrue: 
																									[years := duration years.
																									years = 1 
																										ifTrue: [datePrinter value: #year]
																										ifFalse: [timeperiodDefaultPrinter value]]
																								ifFalse: [timeperiodDefaultPrinter value]]]
																				ifFalse: [timeperiodDefaultPrinter value]]]
																ifFalse: [timeperiodDefaultPrinter value]]]
												ifFalse: [timeperiodDefaultPrinter value]]]
								ifFalse: [timeperiodDefaultPrinter value]]]
				ifFalse: [timeperiodDefaultPrinter value]]! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printTwoDigitYear: year on: stream 
	ChronosFunction  
		print: (ChronosFunction twoDigitYearFromFullYear: year)
		paddedWith: self yearPadChar
		to: 2
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-utility' stamp: ''!
printValue: element elementNameKey: elementNameKey isPrefixed: isPrefixed separator: separator padWith: padChar to: minDigits suppressIfZero: suppressIfZero on: stream 
	"Answer true if the element was printed, false if it was suppressed."

	^(suppressIfZero and: [element = 0]) 
		ifTrue: [false]
		ifFalse: 
			[| int |
			isPrefixed ifTrue: [self printSeparator: separator on: stream].
			int := element truncated.
			ChronosFunction  
				print: int
				paddedWith: padChar
				to: minDigits
				on: stream.
			element isInteger
				ifFalse: 
					[ChronosFunction
						print: ((element - int) * NanosecondsPerSecond) truncated
						asPostDecimalOn: stream 
						decimalPoint: self decimalPointChar
						scale: 9 
						minPrecision: 0
						maxPrecision: 9
						prependingZero: false].
			elementNameKey == nil 
				ifFalse: 
					[stream space.
					self 
						printTemporalUnitName: elementNameKey
						value: element
						on: stream].
			true]! !

!ChronosPrintPolicy methodsFor: 'printing-annual dates' stamp: ''!
printWeekOfMonthDayOfWeek: aWeekOfMonthDayOfWeek on: stream 
	stream
		nextPut: ${;
		nextPutAll: (self singularNounAtSemanticKey: #month);
		nextPut: $=.
	aWeekOfMonthDayOfWeek isMonthKeyResolvable
		ifTrue: [self printMonthAbbreviationFrom: aWeekOfMonthDayOfWeek on: stream]
		ifFalse: [self printMonthOrdinalFrom: aWeekOfMonthDayOfWeek on: stream].	
	stream nextPutAll: ' | '.
	stream nextPutAll: (self pluralNounAtSemanticKey: #dayOfMonth).
	stream nextPut: $=.
	aWeekOfMonthDayOfWeek minDayOfMonthOrdinal printOn: stream.
	stream nextPutAll: '..'.
	aWeekOfMonthDayOfWeek maxDayOfMonthOrdinal printOn: stream.
	stream nextPutAll: ' | '.
	stream nextPutAll: (self singularNounAtSemanticKey: #dayOfWeek).
	stream nextPut: $=.
	self printDayOfWeekFrom: aWeekOfMonthDayOfWeek on: stream.
	(self shouldShowCalendarNameOf: aWeekOfMonthDayOfWeek) 
		ifTrue: 
			[stream space.
			self printCalendarNameFrom: aWeekOfMonthDayOfWeek on: stream].
	stream nextPut: $}.! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printYear: year on: stream 
	self printFullYear:year on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printYearDayMonthFrom: aDate maxPrecision: maxPrecision on: stream 
	self 
		printYearDayMonthFrom: aDate
		maxPrecision: maxPrecision
		yearDaySeparator: self dayYearSeparator
		dayMonthSeparator: self monthDaySeparator
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printYearDayMonthFrom: aDate maxPrecision: maxPrecision yearDaySeparator: dayYearSep dayMonthSeparator: monthDaySep on: stream 
	| mp |
	mp := 
		maxPrecision isInteger 
			ifTrue: [maxPrecision negated]
			ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
	self printYear: aDate year on: stream.
	(mp < 6)
		ifTrue:
			[self printSeparator: dayYearSep on: stream.
			(mp < 5)
				ifTrue:
					[self printDayOfMonthFrom: aDate on: stream.
					self printSeparator: monthDaySep on: stream].
			self printMonthAbbreviationFrom: aDate on: stream]! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printYearMonthDayFrom: aDate maxPrecision: maxPrecision on: stream 
	self 
		printYearMonthDayFrom: aDate
		maxPrecision: maxPrecision
		yearMonthSeparator: self yearMonthSeparator
		monthDaySeparator: self monthDaySeparator
		on: stream! !

!ChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printYearMonthDayFrom: aDate maxPrecision: maxPrecision yearMonthSeparator: yearMonthSep monthDaySeparator: monthDaySep on: stream 
	| mp |
	mp := 
		maxPrecision isInteger 
			ifTrue: [maxPrecision negated]
			ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
	self printYear: aDate year on: stream.
	(mp < 6)
		ifTrue:
			[self printSeparator: yearMonthSep on: stream.
			self printMonthFrom: aDate on: stream.
			(mp < 5)
				ifTrue:
					[self printSeparator: monthDaySep on: stream.
					self printDayOfMonthFrom: aDate on: stream]]! !

!ChronosPrintPolicy methodsFor: 'printing-calendarPeriods' stamp: ''!
printYearlyCalendar: aYearlyCalendar on: stream
	aYearlyCalendar basicPrintOn: stream! !

!ChronosPrintPolicy methodsFor: 'printing-durations' stamp: ''!
printZeroDurationPadWith: padChar appendElementNames: showNamesOfDurationElements on: stream 
	ChronosFunction  print: 0 paddedWith: padChar to: 2 on: stream.
	stream nextPut: $:.
	ChronosFunction  print: 0 paddedWith: padChar to: 2 on: stream.
	stream nextPut: $:.
	ChronosFunction  print: 0 paddedWith: padChar to: 2 on: stream.
	stream nextPut: $:.
	ChronosFunction  print: 0 paddedWith: padChar to: 2 on: stream.! !

!ChronosPrintPolicy methodsFor: 'name lookup' stamp: ''!
properNameAtSemanticKey: semanticKey
	^self effectiveLocale properNameAtSemanticKey: semanticKey! !

!ChronosPrintPolicy methodsFor: 'private' stamp: ''!
shouldShowCalendarNameOf: aCalendrical
	^aCalendrical calendarRegistrationKey ~~ self standardCalendarRegistrationKey! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsDayOfWeek
	^self hidesDayOfWeek not! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsNameOfEra
	^false! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsNamesOfCalendarDurationElements
	^false! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsNamesOfDurationElements
	^false! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsTimeOfDay
	| maxPrecision |
	maxPrecision := self dateAndTimeMaxPrecision.
	^maxPrecision isInteger 
		ifTrue: [true]
		ifFalse: [(#(#all #minute #hour #day #month #year) indexOf: maxPrecision)  < 4]! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsTimeZone
	^self hidesTimeZone not! !

!ChronosPrintPolicy methodsFor: 'name lookup' stamp: ''!
singularNounAtSemanticKey: semanticKey
	^self effectiveLocale singularNounAtSemanticKey: semanticKey! !

!ChronosPrintPolicy methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/9/2011 10:48'!
standardCalendarRegistrationKey
	"Answer the registration key of the receiver's standard calendar (which is the calendar whose name may optionally be hidden when printing a calendrical value.)"

	^(AnsiStandardCalendar) registrationKey! !

!ChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
subSecondDurationMaxPrecision
	^#all! !

!ChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
subSecondTimeMinPrecision
	^0! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
suppressesZeroValuedCalendarDurationElements
	^true! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
suppressesZeroValuedDurationElements
	^false! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
timeOfDayPrefix
	^$T! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
timeZoneElementSeparator
	^$:! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
timeZoneSeparator
	^nil! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
today
	"ChronosPrintPolicy usLong today"

	^DateAndTimeFactory today printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
todayAs: calendar
	"ChronosPrintPolicy universal todayAs: #Coptic"

	^(DateAndTimeFactory todayAs: calendar) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
todayIn: aTimezone
	"ChronosPrintPolicy universal todayIn: 'Europe/Moscow'"

	^(DateAndTimeFactory todayIn: aTimezone) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'utility/examples' stamp: ''!
todayIn: aTimezone as: aCalendar
	"ChronosPrintPolicy universal todayIn: 'Asia/Tehran' as: #Persian"

	^(DateAndTimeFactory todayIn: aTimezone as: aCalendar) printStringUsing: self! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
uses12HourClock
	^self uses24HourClock not! !

!ChronosPrintPolicy methodsFor: 'testing' stamp: ''!
uses24HourClock
	^true! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
yearMonthSeparator
	^$-! !

!ChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
yearPadChar
	^$0! !

ChronosPrintPolicy subclass: #ConfigurableChronosPrintPolicy
	instanceVariableNames: 'effectiveLocaleKey dayOfWeekPolicy dateAndTimeOrder datePolicy yearPolicy monthPolicy yearMonthSep monthDaySep dayYearSep yearPadChar monthPadChar dayOfMonthPadChar eraPolicy standardCalendarRegistrationKey showTimeOfDay hour24 dateAndTimeSeparator timeOfDayPrefix hourMinuteSecondSeparator hourPadChar decimalPointChar subSecondTimeMinPrecision dateAndTimeMaxPrecision timeZonePrintPolicy timeZoneSeparator timeZoneElementSeparator showNamesOfDurationElements showNamesOfCalendarDurationElements suppressZeroValuedDurationElements suppressZeroValuedCalendarDurationElements durationElementSep calendarDurationElementSep durationDayHourSep calendarDurationDayHourSep durationPadChar calendarDurationPadChar subSecondDurationMaxPrecision'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Printing'!

!ConfigurableChronosPrintPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!ConfigurableChronosPrintPolicy class methodsFor: 'private' stamp: ''!
basicDecodeFromLiteralArray: literalArray 
	"Construct an object from the values containted in <literalArray>, which is an array that specifies the class and attributes of an object. The first element of <literalArray> must be the name of the class that should be responsible for constructing the object from the remaining components of <literalArray>. It is required that the receiver of #basicDecodeFromLiteralArray: be the class named by the first element of <literalArray>."

	^self new
		initializeFromLiteralArray: literalArray;
		beImmutable! !

!ConfigurableChronosPrintPolicy class methodsFor: 'accessing' stamp: ''!
default
	^ChronosLocale default temporalPrintPolicy! !

!ConfigurableChronosPrintPolicy class methodsFor: 'private' stamp: ''!
newRegistry
	^self superclass registry! !

!ConfigurableChronosPrintPolicy methodsFor: 'initialize-release' stamp: ''!
beANSIStandard
	self assertMutability.
	self standardCalendarRegistrationKey: GregorianCalendar registrationKey.
	self hideDayOfWeek. 
	self useDateBeforeTimeOrder.
	self useFullDigitYears.
	self useMonthOrdinal.
	self useYearMonthDayOrder.
	self dateSeparator: $-.
	self padChar: $0.
	self hideEraName.
	self dateAndTimeSeparator: nil.
	self timeOfDayPrefix: $T.
	self showTimeOfDay.
	self use24HourFormat.
	self hourMinuteSecondSeparator: $:.
	self decimalPointChar: $..
	self subSecondTimeMinPrecision: 0.
	self dateAndTimeMaxPrecision: #all.
	self showTimeZoneOffset.
	self timeZoneSeparator: nil.
	self timeZoneElementSeparator: $:.
	self durationDayHourSeparator: $:.
	self calendarDurationDayHourSeparator: $T.
	self durationElementSeparator: $:.
	self calendarDurationElementSeparator: nil.
	self durationPadChar: $0.
	self calendarDurationPadChar: nil.
	self hideNamesOfDurationElements.
	self hideNamesOfCalendarDurationElements.
	self showZeroValuedDurationElements.
	self hideZeroValuedCalendarDurationElements.
	self subSecondDurationMaxPrecision: #all.! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
calendarDurationDayHourSeparator
	^calendarDurationDayHourSep! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
calendarDurationDayHourSeparator: aCharOrCharArray
	self assertMutability.
	calendarDurationDayHourSep := aCharOrCharArray! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
calendarDurationElementSeparator
	^calendarDurationElementSep! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
calendarDurationElementSeparator: aCharOrCharArray
	self assertMutability.
	calendarDurationElementSep := aCharOrCharArray! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
calendarDurationPadChar
	^calendarDurationPadChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
calendarDurationPadChar: pad
	self assertMutability.
	calendarDurationPadChar := pad! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
canConformToLocale
	^true! !

!ConfigurableChronosPrintPolicy methodsFor: 'initialize-release' stamp: ''!
confomToLocale: aChronosLocale 
	self assertMutability.
	aChronosLocale == nil 
		ifTrue: [effectiveLocaleKey := nil]
		ifFalse: 
			[| locale |
			locale := ChronosLocale referencedBy: aChronosLocale.
			registrationKey := locale registrationKey.
			effectiveLocaleKey := locale registrationKey.
			standardCalendarRegistrationKey := locale standardCalendarRegistrationKey.
			self setPunctuationFromLocale: locale.
			self setNotationalPoliciesFromLocale: locale.
			self registerButIfPresent: [:collision | ]]! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
dateAndTimeMaxPrecision
	^dateAndTimeMaxPrecision! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
dateAndTimeMaxPrecision: anIntOrSymbol 
	"ConfigurableChronosPrintPolicy newConfigurable dateAndTimeMaxPrecision: #foo"
 
	self assertMutability.
	anIntOrSymbol isInteger 
		ifTrue: [dateAndTimeMaxPrecision := anIntOrSymbol max: 0]
		ifFalse: 
			[| newSymbol |
			newSymbol := anIntOrSymbol asSymbol.
			(#(all minute hour day month year) includes: newSymbol) ifFalse: [self signalError: 'dateAndTimeMaxPrecision must be either A) an integer => 0 or B) one of the following Symbols: #all #minute #hour #day #month #year'].
			dateAndTimeMaxPrecision := newSymbol]! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
dateAndTimeOrder
	^dateAndTimeOrder == nil ifTrue: [#useDateBeforeTimeOrder] ifFalse: [dateAndTimeOrder]! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
dateAndTimeSeparator
	^dateAndTimeSeparator! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
dateAndTimeSeparator: aCharOrString
	self assertMutability.
	dateAndTimeSeparator := aCharOrString! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
datePadChar: pad
	self yearPadChar: pad monthPadChar: pad dayOfMonthPadChar: pad! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
dateSeparator: aChar
	self yearMonthSeparator: aChar monthDayOfMonthSeparator: aChar dayOfMonthYearSeparator: aChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
dayOfMonthPadChar
	^dayOfMonthPadChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
dayYearSeparator
	^dayYearSep! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
decimalPointChar
	^decimalPointChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
decimalPointChar: aChar
	self assertMutability.
	decimalPointChar := aChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationDayHourSeparator
	^durationDayHourSep! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
durationDayHourSeparator: aCharOrCharArray
	self assertMutability.
	durationDayHourSep := aCharOrCharArray! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationElementSeparator
	^durationElementSep! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
durationElementSeparator: aCharOrCharArray
	self assertMutability.
	durationElementSep := aCharOrCharArray! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationPadChar
	^durationPadChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
durationPadChar: pad
	self assertMutability.
	durationPadChar := pad! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
effectiveLocale
	^effectiveLocaleKey == nil 
		ifTrue: [ChronosLocale default]
		ifFalse: 
			[ChronosLocale at: effectiveLocaleKey ifAbsent: [ChronosLocale default]]! !

!ConfigurableChronosPrintPolicy methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: effectiveLocaleKey;
		nextPut: dayOfWeekPolicy;
		nextPut: dateAndTimeOrder;
		nextPut: datePolicy;
		nextPut: yearPolicy;
		nextPut: monthPolicy;
		nextPut: yearMonthSep;
		nextPut: monthDaySep;
		nextPut: dayYearSep;
		nextPut: yearPadChar;
		nextPut: monthPadChar;
		nextPut: dayOfMonthPadChar;
		nextPut: eraPolicy;
		nextPut: standardCalendarRegistrationKey;
		nextPut: hour24;
		nextPut: dateAndTimeSeparator;
		nextPut: timeOfDayPrefix;
		nextPut: hourMinuteSecondSeparator;
		nextPut: hourPadChar;
		nextPut: decimalPointChar;
		nextPut: subSecondTimeMinPrecision;
		nextPut: dateAndTimeMaxPrecision;
		nextPut: timeZonePrintPolicy;
		nextPut: timeZoneSeparator;
		nextPut: timeZoneElementSeparator;
		nextPut: showNamesOfDurationElements;
		nextPut: showNamesOfCalendarDurationElements;
		nextPut: suppressZeroValuedDurationElements;
		nextPut: suppressZeroValuedCalendarDurationElements;
		nextPut: durationElementSep;
		nextPut: calendarDurationElementSep;
		nextPut: durationDayHourSep;
		nextPut: calendarDurationDayHourSep;
		nextPut: durationPadChar;
		nextPut: calendarDurationPadChar;
		nextPut: subSecondDurationMaxPrecision! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
eraPolicy
	^eraPolicy! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
hideDayOfDate
	self assertMutability.
	dateAndTimeMaxPrecision := 
		dateAndTimeMaxPrecision isInteger 
			ifTrue: [#month]
			ifFalse: 
				[| index |
				index := #(#all #minute #hour #day #month #year) indexOf: dateAndTimeMaxPrecision.
				index >= 5 ifTrue: [dateAndTimeMaxPrecision] ifFalse: [#month]]! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-day of week' stamp: ''!
hideDayOfWeek
	self assertMutability.
	dayOfWeekPolicy := nil! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
hideEraName
	self assertMutability.
	eraPolicy := nil! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
hideMonthOfDate
	self assertMutability.
	dateAndTimeMaxPrecision := #year! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
hideNamesOfCalendarDurationElements
	self assertMutability.
	showNamesOfCalendarDurationElements := false! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
hideNamesOfDurationElements
	self assertMutability.
	showNamesOfDurationElements := false! !

!ConfigurableChronosPrintPolicy methodsFor: 'deprecated' stamp: ''!
hideSeconds
	self hideTimeOfDaySecond! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
hideStandardCalendarName
	self standardCalendarRegistrationKey: self effectiveLocale standardCalendarRegistrationKey! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
hideSubsecondFraction
	self assertMutability.
	dateAndTimeMaxPrecision := 0! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
hideTimeOfDay
	self hideTimeOfDayHour! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
hideTimeOfDayHour
	self assertMutability.
	dateAndTimeMaxPrecision := 
		dateAndTimeMaxPrecision isInteger 
			ifTrue: [#day]
			ifFalse: 
				[| index |
				index := #(#all #minute #hour #day #month #year) indexOf: dateAndTimeMaxPrecision.
				index >= 4 ifTrue: [dateAndTimeMaxPrecision] ifFalse: [#day]]! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
hideTimeOfDayMinute
	self assertMutability.
	dateAndTimeMaxPrecision := 
		dateAndTimeMaxPrecision isInteger 
			ifTrue: [#hour]
			ifFalse: 
				[| index |
				index := #(#all #minute #hour #day #month #year) indexOf: dateAndTimeMaxPrecision.
				index >= 3 ifTrue: [dateAndTimeMaxPrecision] ifFalse: [#hour]]! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
hideTimeOfDaySecond
	self assertMutability.
	dateAndTimeMaxPrecision := 
		dateAndTimeMaxPrecision isInteger 
			ifTrue: [#minute]
			ifFalse: 
				[dateAndTimeMaxPrecision == #all 
					ifTrue: [#minute]
					ifFalse: [dateAndTimeMaxPrecision]]! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
hideTimeZone
	self assertMutability.
	timeZonePrintPolicy := nil! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-year format' stamp: ''!
hideYears
	self assertMutability.
	yearPolicy := #dontPrintYear:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
hideZeroValuedCalendarDurationElements
	self assertMutability.
	suppressZeroValuedCalendarDurationElements := true! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
hideZeroValuedDurationElements
	self assertMutability.
	suppressZeroValuedDurationElements := true! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
hidesDayOfWeek
	^dayOfWeekPolicy == nil! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
hidesTimeZone
	^timeZonePrintPolicy == nil! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
hourMinuteSecondSeparator
	^hourMinuteSecondSeparator! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
hourMinuteSecondSeparator: aCharacterArrayOrCharacter 
	self assertMutability.
	hourMinuteSecondSeparator := aCharacterArrayOrCharacter! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
hourPadChar
	^hourPadChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
hourPadChar: pad
	self assertMutability.
	hourPadChar := pad! !

!ConfigurableChronosPrintPolicy methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."

	super initialize.
	self beANSIStandard.! !

!ConfigurableChronosPrintPolicy methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	effectiveLocaleKey := (literalArray at: 3).
	dayOfWeekPolicy := (literalArray at: 4).
	dateAndTimeOrder := (literalArray at: 5).
	datePolicy := (literalArray at: 6).
	yearPolicy := (literalArray at: 7).
	monthPolicy := (literalArray at: 8).
	yearMonthSep := (literalArray at: 9).
	monthDaySep := (literalArray at: 10).
	dayYearSep := (literalArray at: 11).
	yearPadChar := (literalArray at: 12).
	monthPadChar := (literalArray at: 13).
	dayOfMonthPadChar := (literalArray at: 14).
	eraPolicy := (literalArray at: 15).
	standardCalendarRegistrationKey := (literalArray at: 16).
	hour24 := (literalArray at: 17).
	dateAndTimeSeparator := (literalArray at: 18).
	timeOfDayPrefix := (literalArray at: 19).
	hourMinuteSecondSeparator := (literalArray at: 20).
	hourPadChar := (literalArray at: 21).
	decimalPointChar := (literalArray at: 22).
	subSecondTimeMinPrecision := (literalArray at: 23).
	dateAndTimeMaxPrecision := (literalArray at: 24).
	timeZonePrintPolicy := (literalArray at: 25).
	timeZoneSeparator := (literalArray at: 26).
	timeZoneElementSeparator := (literalArray at: 27).
	showNamesOfDurationElements := (literalArray at: 28).
	showNamesOfCalendarDurationElements := (literalArray at: 29).
	suppressZeroValuedDurationElements := (literalArray at: 30).
	suppressZeroValuedCalendarDurationElements := (literalArray at: 31).
	durationElementSep := (literalArray at: 32).
	calendarDurationElementSep := (literalArray at: 33).
	durationDayHourSep := (literalArray at: 34).
	calendarDurationDayHourSep := (literalArray at: 35).
	durationPadChar := (literalArray at: 36).
	calendarDurationPadChar := (literalArray at: 37).
	subSecondDurationMaxPrecision := (literalArray at: 38).! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
monthDaySeparator
	^monthDaySep! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
monthPadChar
	^monthPadChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
padChar: pad
	self hourPadChar: pad.
	self datePadChar: pad! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printAbbreviationOfTimeZoneFrom: aTimepoint on: stream 
	self 
		printAbbreviationOfTimeZoneFrom: aTimepoint
		prefix: timeZoneSeparator
		on: stream! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printCalendarElementsFrom: aDate maxPrecision: maxPrecision on: stream 
	self perform: datePolicy with: aDate with: maxPrecision with: stream.! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printDayMonthYearFrom: aDate maxPrecision: maxPrecision  dayMonthSeparator: mdSep monthYearSeparator: ymSep on: stream 
	| mp |
	mp := 
		maxPrecision isInteger
			ifTrue: [maxPrecision negated]
			ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
	(mp < 6)
		ifTrue:
			[(mp < 5)
				ifTrue:
					[self printDayOfMonthFrom: aDate on: stream.
					self printSeparator: mdSep on: stream].
			self printMonthFrom: aDate on: stream.
			self printSeparator: ymSep on: stream].
	self printYear: aDate year on: stream! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printDayOfWeekFrom: aDate on: stream 
	dayOfWeekPolicy == nil 
		ifTrue: [super printDayOfWeekFrom: aDate on: stream]
		ifFalse: 
			[self 
				perform: dayOfWeekPolicy
				with: aDate dayOfWeekKey
				with: stream]! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-time of day-elements' stamp: ''!
printHour12: h24 on: stream
	self printHour12: h24 padWith: hourPadChar on: stream! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printKeyOfTimeZoneFrom: aTimepoint on: stream 
	self 
		printKeyOfTimeZoneFrom: aTimepoint
		prefix: timeZoneSeparator
		on: stream! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printMonthFrom: date on: stream 
	self perform: monthPolicy with: date with: stream! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printNameOfTimeZoneFrom: aTimepoint on: stream 
	self 
		printNameOfTimeZoneFrom: aTimepoint
		prefix: timeZoneSeparator
		on: stream! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printTimeZoneFrom: aTimepoint on: stream 
	timeZonePrintPolicy == nil 
		ifTrue: [super printTimeZoneFrom: aTimepoint on: stream]
		ifFalse: 
			[self 
				perform: timeZonePrintPolicy
				with: aTimepoint
				with: stream]! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printYear: year on: stream 
	self perform: yearPolicy with: year with: stream! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-dates-elements' stamp: ''!
printYearDayMonthFrom: aDate maxPrecision: maxPrecision yearDaySeparator: dySep dayMonthSeparator: mdSep on: stream 
	| mp |
	mp := 
		maxPrecision isInteger 
			ifTrue: [maxPrecision negated]
			ifFalse: [#(#all #minute #hour #day #month #year) indexOf: maxPrecision].
	self printYear: aDate year on: stream.
	(mp < 6)
		ifTrue:
			[self printSeparator: dySep on: stream.
			(mp < 5)
				ifTrue:
					[self printDayOfMonthFrom: aDate on: stream.
					self printSeparator: mdSep on: stream].
			self printMonthFrom: aDate on: stream]! !

!ConfigurableChronosPrintPolicy methodsFor: 'printing-durations' stamp: ''!
printZeroDurationPadWith: padChar appendElementNames: showNames on: stream 
	showNames 
		ifTrue: 
			[ChronosFunction 
				print: 0
				paddedWith: padChar
				to: 2
				on: stream.
			stream space.
			self 
				printTemporalUnitName: #second
				value: 0
				on: stream]
		ifFalse: 
			[super 
				printZeroDurationPadWith: padChar
				appendElementNames: showNames
				on: stream]! !

!ConfigurableChronosPrintPolicy methodsFor: 'initialize-release' stamp: ''!
setNotationalPoliciesFromLocale: aChronosLocale
	self assertMutability.
	self 
		perform: aChronosLocale dateAndTimeOrder;
		perform: aChronosLocale datePolicy;
		perform: aChronosLocale monthPolicy;
		perform: aChronosLocale yearPolicy;
		perform: aChronosLocale dayOfWeekPolicy;
		perform: aChronosLocale eraPolicy;
		perform: aChronosLocale timeOfDayPolicy;
		perform: aChronosLocale hourPolicy;
		perform: aChronosLocale timeOfDaySubsecondPolicy;
		perform: aChronosLocale timeZonePolicy;
		perform: aChronosLocale durationElementNamePolicy;
		perform: aChronosLocale durationElementZeroValuePolicy;
		perform: aChronosLocale calendarDurationElementNamePolicy;
		perform: aChronosLocale calendarDurationElementZeroValuePolicy! !

!ConfigurableChronosPrintPolicy methodsFor: 'initialize-release' stamp: ''!
setPunctuationFromLocale: aChronosLocale
	self assertMutability.
	decimalPointChar := aChronosLocale decimalPointChar.
	yearPadChar := aChronosLocale yearPadChar.
	monthPadChar := aChronosLocale monthPadChar.
	dayOfMonthPadChar := aChronosLocale dayOfMonthPadChar.
	yearMonthSep := aChronosLocale yearMonthSeparator.
	monthDaySep := aChronosLocale monthDayOfMonthSeparator.
	dayYearSep := aChronosLocale dayOfMonthYearSeparator.
	dateAndTimeSeparator := aChronosLocale dateAndTimeSeparator.
	timeOfDayPrefix := aChronosLocale timeOfDayPrefix.
	hourPadChar := aChronosLocale hourPadChar.
	hourMinuteSecondSeparator := aChronosLocale hourMinuteSecondSeparator.
	timeZoneSeparator := aChronosLocale timeZoneSeparator.
	timeZoneElementSeparator := aChronosLocale timeZoneElementSeparator.
	durationElementSep := aChronosLocale durationElementSeparator.
	calendarDurationElementSep := aChronosLocale calendarDurationElementSeparator.
	durationDayHourSep := aChronosLocale durationDayHourSeparator.
	calendarDurationDayHourSep := aChronosLocale calendarDurationDayHourSeparator.
	durationPadChar := aChronosLocale durationPadChar.
	calendarDurationPadChar := aChronosLocale calendarDurationPadChar.! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-form/content' stamp: ''!
showDateAsDaysSinceEpoch
	self assertMutability.
	datePolicy := #printDaysSinceEpochFrom:maxPrecision:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-form/content' stamp: ''!
showDateAsGregorianDay
	self assertMutability.
	datePolicy := #printGregorianDayFrom:maxPrecision:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-form/content' stamp: ''!
showDateAsJulianDay
	self assertMutability.
	datePolicy := #printJulianDayFrom:maxPrecision:on:.! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
showDateToTheDay
	self assertMutability.
	dateAndTimeMaxPrecision := #day! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
showDateToTheMonth
	self assertMutability.
	dateAndTimeMaxPrecision := #month! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
showDateToTheYear
	self assertMutability.
	dateAndTimeMaxPrecision := #year! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-day of week' stamp: ''!
showDayOfWeekAbbreviation
	self assertMutability.
	dayOfWeekPolicy := #printAbbreviationAt:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-day of week' stamp: ''!
showDayOfWeekName
	self assertMutability.
	dayOfWeekPolicy := #printProperNameAt:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
showEraName
	"Deprecated. Use #showEraNameAfterDate or #showEraNameBeforeDate"

	self showEraNameAfterDate! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
showEraNameAfterDate
	"NOTE: The formal convention for most calendars is to put the era designator AFTER the rest of the date--the Gregorian/Julian calendars (in English speaking countries, but not universally) being the major exceptions.  However, in actual modern English usage the 'AD' or 'BC' much more frequently follows the date.  And in the case of the revisionist 'CE' and 'BCE' era designations (which were invented and insisted upon by Jewish Talmudists originally,) putting the designation after the date is also the formally-correct placement.  Consequently, for calendar polymorphism/symmetry, for year-month-day order independence, to match actual modern usage, and for compatibility with international standards (such as ISO 8601,) it is recommended to put the era designation after the date, instead of using the formal English placement rule, which is no longer commonly observed, and would not be appropriate for 'CE'/'BCE,' for some year-month-day orderings, for many non-English speakers, nor for most other calendars."	

	self assertMutability.
	eraPolicy := #showEraNameAfterDate! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
showEraNameBeforeDate
	"NOTE: The formal convention for most calendars is to put the era designator AFTER the rest of the date--the Gregorian/Julian calendars (in English speaking countries, but not universally) being the major exceptions.  However, in actual modern English usage the 'AD' or 'BC' much more frequently follows the date.  And in the case of the revisionist 'CE' and 'BCE' era designations (which were invented and insisted upon by Jewish Talmudists originally,) putting the designation after the date is also the formally-correct placement.  Consequently, for calendar polymorphism/symmetry, for year-month-day order independence, to match actual modern usage, and for compatibility with international standards (such as ISO 8601,) it is recommended to put the era designation after the date, instead of using the formal English placement rule, which is no longer commonly observed, and would not be appropriate for 'CE'/'BCE,' for some year-month-day orderings, for many non-English speakers, nor for most other calendars."	

	self assertMutability.
	eraPolicy := #showEraNameBeforeDate! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
showNamesOfCalendarDurationElements
	self assertMutability.
	showNamesOfCalendarDurationElements := true! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
showNamesOfDurationElements
	self assertMutability.
	showNamesOfDurationElements := true! !

!ConfigurableChronosPrintPolicy methodsFor: 'deprecated' stamp: ''!
showSecondsWithFraction
	self showTimeOfDaySecondWithFraction! !

!ConfigurableChronosPrintPolicy methodsFor: 'deprecated' stamp: ''!
showSecondsWithoutFraction
	self showTimeOfDaySecondWithoutFraction! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
showStandardCalendarName
	self standardCalendarRegistrationKey: nil! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeOfDay
	(dateAndTimeMaxPrecision isInteger or: [dateAndTimeMaxPrecision == #all])
		ifFalse: [self dateAndTimeMaxPrecision: #all]! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeOfDaySecondWithFraction
	self assertMutability.
	dateAndTimeMaxPrecision := #all! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeOfDaySecondWithoutFraction
	self assertMutability.
	dateAndTimeMaxPrecision := 0! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeOfDayToTheHour
	self assertMutability.
	dateAndTimeMaxPrecision := #hour! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeOfDayToTheMinute
	self assertMutability.
	dateAndTimeMaxPrecision := #minute! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeZoneAbbreviation
	self assertMutability.
	timeZonePrintPolicy := #printAbbreviationOfTimeZoneFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeZoneKey
	self assertMutability.
	timeZonePrintPolicy := #printKeyOfTimeZoneFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeZoneName
	self assertMutability.
	timeZonePrintPolicy := #printNameOfTimeZoneFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeZoneOffset
	self assertMutability.
	timeZonePrintPolicy := #printOffsetOfTimeZoneFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
showTimeZoneVerbosely
	self assertMutability.
	timeZonePrintPolicy := #printTimeZoneVerboselyFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
showZeroValuedCalendarDurationElements
	self assertMutability.
	suppressZeroValuedCalendarDurationElements := false! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
showZeroValuedDurationElements
	self assertMutability.
	suppressZeroValuedDurationElements := false! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsNameOfEra
	^eraPolicy notNil! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsNamesOfCalendarDurationElements
	^showNamesOfCalendarDurationElements! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
showsNamesOfDurationElements
	^showNamesOfDurationElements! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
standardCalendarRegistrationKey
	"Answer the registration key of the receiver's standard calendar (which is the calendar whose name may optionally be hidden when printing a calendrical value.)"

	^standardCalendarRegistrationKey! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
standardCalendarRegistrationKey: aSymbol
	"Set the registration key of the receiver's standard calendar (which is the calendar whose name may optionally be hidden when printing a calendrical value.)  If set to nil, the receiver will always show the calendar name."

	self assertMutability.
	standardCalendarRegistrationKey := aSymbol! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
subSecondDurationMaxPrecision
	^subSecondDurationMaxPrecision! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-durations' stamp: ''!
subSecondDurationMaxPrecision: anIntOrTheSymbolAll 
	self assertMutability.
	subSecondDurationMaxPrecision := anIntOrTheSymbolAll isInteger 
				ifTrue: [anIntOrTheSymbolAll max: 0]
				ifFalse: [anIntOrTheSymbolAll asSymbol]! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
subSecondMaxPrecision: anInt
	self dateAndTimeMaxPrecision: anInt.
	self subSecondDurationMaxPrecision: anInt! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing' stamp: ''!
subSecondTimeMinPrecision
	^subSecondTimeMinPrecision! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
subSecondTimeMinPrecision: anInt
	self assertMutability.
	subSecondTimeMinPrecision := anInt max: 0! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
subSecondTimePrecision: anInt
	self subSecondTimeMinPrecision: anInt.
	self dateAndTimeMaxPrecision: anInt.! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
suppressesZeroValuedCalendarDurationElements
	^suppressZeroValuedCalendarDurationElements! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
suppressesZeroValuedDurationElements
	^suppressZeroValuedDurationElements! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
timeOfDayPrefix
	^timeOfDayPrefix! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
timeOfDayPrefix: aCharOrStringOrNil
	self assertMutability.
	timeOfDayPrefix := aCharOrStringOrNil! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
timeZoneElementSeparator
	^timeZoneElementSeparator! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
timeZoneElementSeparator: aCharOrString
	self assertMutability.
	timeZoneElementSeparator := aCharOrString! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
timeZoneSeparator
	^timeZoneSeparator! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
timeZoneSeparator: aCharOrStringOrNil
	self assertMutability.
	timeZoneSeparator := aCharOrStringOrNil! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
use12HourFormat
	self assertMutability.
	hour24 := false! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-time of day' stamp: ''!
use24HourFormat
	self assertMutability.
	hour24 := true! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
useDateBeforeTimeOrder
	self assertMutability.
	dateAndTimeOrder := #useDateBeforeTimeOrder! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-form/content' stamp: ''!
useDayMonthYearOrder
	self assertMutability.
	datePolicy := #printDayMonthYearFrom:maxPrecision:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-year format' stamp: ''!
useFullDigitYears
	self assertMutability.
	yearPolicy := #printFullYear:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-form/content' stamp: ''!
useISOWeekOfYearDayOfWeek
	self assertMutability.
	datePolicy := #printISOWeekOfYearDayOfWeekFrom:maxPrecision:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-month format' stamp: ''!
useMonthAbbreviation
	self assertMutability.
	monthPolicy := #printMonthAbbreviationFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-form/content' stamp: ''!
useMonthDayYearOrder
	self assertMutability.
	datePolicy := #printMonthDayYearFrom:maxPrecision:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-month format' stamp: ''!
useMonthName
	self assertMutability.
	monthPolicy := #printMonthNameFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-month format' stamp: ''!
useMonthOrdinal
	self assertMutability.
	monthPolicy := #printMonthOrdinalFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-month format' stamp: ''!
useNumericMonthDesignator
	self assertMutability.
	monthPolicy := #printNumericMonthDesignatorFrom:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-form/content' stamp: ''!
useOrdinalDate
	self assertMutability.
	datePolicy := #printOrdinalDateFrom:maxPrecision:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring' stamp: ''!
useTimeBeforeDateOrder
	self assertMutability.
	dateAndTimeOrder := #useTimeBeforeDateOrder! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-year format' stamp: ''!
useTwoDigitYears
	self assertMutability.
	yearPolicy := #printTwoDigitYear:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates-form/content' stamp: ''!
useYearMonthDayOrder
	self assertMutability.
	datePolicy := #printYearMonthDayFrom:maxPrecision:on:! !

!ConfigurableChronosPrintPolicy methodsFor: 'testing' stamp: ''!
uses24HourClock
	^hour24! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
yearMonthSeparator
	^yearMonthSep! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
yearMonthSeparator: ymSep monthDayOfMonthSeparator: mdSep dayOfMonthYearSeparator: dySep
	self assertMutability.
	yearMonthSep := ymSep.
	monthDaySep := mdSep.
	dayYearSep := dySep! !

!ConfigurableChronosPrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
yearPadChar
	^yearPadChar! !

!ConfigurableChronosPrintPolicy methodsFor: 'configuring-dates' stamp: ''!
yearPadChar: yChar monthPadChar: mChar dayOfMonthPadChar: dChar
	self assertMutability.
	yearPadChar := yChar.
	monthPadChar := mChar.
	dayOfMonthPadChar := dChar.! !

ChronosPrintPolicy subclass: #ISO8601PrintPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Printing'!

!ISO8601PrintPolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!ISO8601PrintPolicy class methodsFor: 'accessing' stamp: ''!
default
	^ChronosPrintPolicy iso8601! !

!ISO8601PrintPolicy class methodsFor: 'private' stamp: ''!
newRegistry
	^self superclass registry! !

!ISO8601PrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationDayHourSeparator
	^$T! !

!ISO8601PrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationElementSeparator
	^nil! !

!ISO8601PrintPolicy methodsFor: 'accessing--punctuation characters' stamp: ''!
durationPadChar
	^nil! !

!ISO8601PrintPolicy methodsFor: 'printing-durations' stamp: ''!
printDuration: aDuration on: stream
	stream nextPut: $P.
	self 
		printDurationElementsFromSeconds: aDuration asSeconds
		nanoseconds: aDuration nanosecondsSinceSecond
		isPrefixed: false
		dayHourSeparator: self durationDayHourSeparator
		hmsSeparator: self durationElementSeparator
		padWith: self durationPadChar
		appendElementNames: self showsNamesOfDurationElements
		suppressZeroValuedElements: self suppressesZeroValuedDurationElements
		on: stream! !

!ISO8601PrintPolicy methodsFor: 'printing-time zones' stamp: ''!
printTimeZoneZeroOffsetWithPrefix: prefix elementSeparator: elementSeparator on: stream 
	stream nextPut: $Z! !

!ISO8601PrintPolicy methodsFor: 'printing-durations' stamp: ''!
printZeroDurationPadWith: padChar appendElementNames: showNames on: stream 
	ChronosFunction  
		print: 0
		paddedWith: padChar
		to: 2
		on: stream.
	stream nextPut: $S! !

!ISO8601PrintPolicy methodsFor: 'testing' stamp: ''!
suppressesZeroValuedDurationElements
	^true! !

Registratable subclass: #LeapSecondSchedule
	instanceVariableNames: 'firstLeapSecond lastLeapSecond recentlyAccessedLeapSecond map daysSinceEpochOfFirstLeapSecond daysSinceEpochOfLastLeapSecond secondsSinceEpochOfFirstLeapSecond calendricalSecondsSinceEpochOfLastLeapSecond scientificSecondsSinceEpochOfLastLeapSecond'
	classVariableNames: 'UTC'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timescales'!

!LeapSecondSchedule commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

Instance Variables:
	daysSinceEpochOfFirstLeapSecond	<SmallInteger>	description of daysSinceEpochOfFirstLeapSecond
	daysSinceEpochOfLastLeapSecond	<SmallInteger>	description of daysSinceEpochOfLastLeapSecond
	map	<Dictionary>	description of map
	registrationKey	<ByteSymbol>	description of registrationKey
	secondsSinceEpochOfFirstLeapSecond	<SmallInteger>	description of secondsSinceEpochOfFirstLeapSecond
	sequence	<SequenceableCollection>	description of sequence
	ut1SecondsSinceEpochOfLastLeapSecond	<SmallInteger>	description of ut1SecondsSinceEpochOfLastLeapSecond
	utcSecondsSinceEpochOfLastLeapSecond	<SmallInteger>	description of utcSecondsSinceEpochOfLastLeapSecond

	Subclassing:

!

!LeapSecondSchedule class methodsFor: 'instance creation' stamp: ''!
decodeFrom: stream
	"LeapSecondSchedule
		decodeFrom:
			'utc:
				1:720073:86400:true
				1:720257:86400:true
				1:720622:86400:true
				1:720987:86400:true
				1:721352:86400:true
				1:721718:86400:true
				1:722083:86400:true
				1:722448:86400:true
				1:722813:86400:true
				1:723360:86400:true
				1:723725:86400:true
				1:724090:86400:true
				1:724821:86400:true
				1:725735:86400:true
				1:726466:86400:true
				1:726831:86400:true
				1:727378:86400:true
				1:727743:86400:true
				1:728108:86400:true
				1:728657:86400:true
				1:729204:86400:true
				1:729753:86400:true
				1:732310:86400:true' readStream"

	| key isRelativeToUT lss secondsDelta daysSinceEpoch secondsSinceStartOfDay |
	ChronosFunction skipSeparators: stream.
	key := (stream upTo: $:) asSymbol.
	lss := self new.
	lss setKey: key.
	[ChronosFunction skipSeparators: stream.
	stream atEnd] 
		whileFalse: 
			[secondsDelta := Integer readFrom: stream.
			(stream peekFor: $:) ifFalse: [self signalError: 'Invalid ', self typeKey, ' encoding format.'].
			daysSinceEpoch := Integer readFrom: stream.
			(stream peekFor: $:) ifFalse: [self signalError: 'Invalid ', self typeKey, ' encoding format.'].
			secondsSinceStartOfDay := Integer readFrom: stream.
			(stream peekFor: $:) ifFalse: [self signalError: 'Invalid ', self typeKey, ' encoding format.'].
			isRelativeToUT := Boolean readFrom: (ChronosFunction nextLineFrom: stream) readStream.
			lss addLeapSeconds: secondsDelta atDaysSinceEpoch: daysSinceEpoch secondsSinceStartOfDay: secondsSinceStartOfDay isRelativeToUT: isRelativeToUT].
	^lss beImmutable! !

!LeapSecondSchedule class methodsFor: 'accessing' stamp: ''!
default
	"Answer the default instance of the receiver"

	^self utc! !

!LeapSecondSchedule class methodsFor: 'class initialization' stamp: ''!
invalidateUTC
	"LeapSecondSchedule invalidateUTC"

	(ChronosSystemFacade resourceRepositoryContext retrieveLeapSecondSchedule: #utc ifNone: [self newDefaultUTC]) beUTC! !

!LeapSecondSchedule class methodsFor: 'private' stamp: ''!
newDefaultUTC
	^self 
		decodeFrom: 
			'utc:
				1:720073:86400:true
				1:720257:86400:true
				1:720622:86400:true
				1:720987:86400:true
				1:721352:86400:true
				1:721718:86400:true
				1:722083:86400:true
				1:722448:86400:true
				1:722813:86400:true
				1:723360:86400:true
				1:723725:86400:true
				1:724090:86400:true
				1:724821:86400:true
				1:725735:86400:true
				1:726466:86400:true
				1:726831:86400:true
				1:727378:86400:true
				1:727743:86400:true
				1:728108:86400:true
				1:728657:86400:true
				1:729204:86400:true
				1:729753:86400:true
				1:732310:86400:true' readStream! !

!LeapSecondSchedule class methodsFor: 'private' stamp: ''!
newRegistry
	^IdentityDictionary new! !

!LeapSecondSchedule class methodsFor: 'accessing' stamp: ''!
typeKey
	^self name! !

!LeapSecondSchedule class methodsFor: 'accessing' stamp: ''!
utc
	UTC == nil ifTrue: [self invalidateUTC].
	^UTC! !

!LeapSecondSchedule methodsFor: 'initialize-release' stamp: ''!
addLeapSeconds: secondsDelta at: dateAndTimeSpec isRelativeToUT: isRelativeToUT 
	self addLeapSeconds: secondsDelta atDaysSinceEpoch: dateAndTimeSpec daysSinceEpoch secondsSinceStartOfDay: dateAndTimeSpec secondsSinceStartOfDay isRelativeToUT: isRelativeToUT! !

!LeapSecondSchedule methodsFor: 'initialize-release' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
addLeapSeconds: secondsDelta atDaysSinceEpoch: daysSinceEpoch secondsSinceStartOfDay: secondsSinceStartOfDay isRelativeToUT: isRelativeToUT 
	| secondsSinceEpoch prevLs ls newLs preNetLeapSeconds |
	self assertMutability.
	secondsSinceEpoch := (daysSinceEpoch * SecondsPerDay) + secondsSinceStartOfDay.
	preNetLeapSeconds := 0.
	map := Dictionary new.
	prevLs := nil.
	lastLeapSecond := nil.
	ls := firstLeapSecond.
	[ls notNil and: [secondsSinceEpoch > ls calendricalSecondsSinceEpoch]] 
		whileTrue: 
			[self mapLeapSecond: ls.
			preNetLeapSeconds := preNetLeapSeconds + ls secondsDelta.
			prevLs := ls.
			ls := prevLs next].
	newLs := LeapSecond withSecondsDelta: secondsDelta preNetLeapSeconds: preNetLeapSeconds daysSinceEpoch: daysSinceEpoch secondsSinceStartOfDay: secondsSinceStartOfDay isRelativeToUT: isRelativeToUT.
	prevLs == nil
		ifTrue: [firstLeapSecond := newLs]
		ifFalse: [newLs prev: prevLs].
	self mapLeapSecond: newLs.
	prevLs := newLs.
	preNetLeapSeconds := preNetLeapSeconds + secondsDelta.
	[ls == nil] 
		whileFalse: 
			[newLs := LeapSecond withSecondsDelta: ls secondsDelta preNetLeapSeconds: preNetLeapSeconds daysSinceEpoch: ls daysSinceEpoch secondsSinceStartOfDay: ls secondsSinceStartOfDay isRelativeToUT: ls isRelativeToUT.
			newLs prev: prevLs.
			self mapLeapSecond: newLs.
			preNetLeapSeconds := preNetLeapSeconds + ls secondsDelta.
			prevLs := newLs.
			ls := ls next].
	recentlyAccessedLeapSecond := lastLeapSecond := prevLs.
	lastLeapSecond beImmutable.
	daysSinceEpochOfFirstLeapSecond := firstLeapSecond daysSinceEpoch.
	daysSinceEpochOfLastLeapSecond := lastLeapSecond daysSinceEpoch.
	secondsSinceEpochOfFirstLeapSecond := firstLeapSecond calendricalSecondsSinceEpoch.
	calendricalSecondsSinceEpochOfLastLeapSecond := lastLeapSecond calendricalSecondsSinceEpoch.
	scientificSecondsSinceEpochOfLastLeapSecond := lastLeapSecond firstScientificSecondSinceEpoch.! !

!LeapSecondSchedule methodsFor: 'initialize-release' stamp: ''!
beUTC
	registrationKey == nil 
		ifTrue: [registrationKey := #utc]
		ifFalse: 
			[registrationKey == #utc 
				ifFalse: 
					[self assertMutability.
					registrationKey := #utc]].
	self forceRegistration.
	UTC := self! !

!LeapSecondSchedule methodsFor: 'accessing' stamp: ''!
calendricalSecondsSinceEpochOfLastLeapSecond
	^calendricalSecondsSinceEpochOfLastLeapSecond! !

!LeapSecondSchedule methodsFor: 'accessing' stamp: ''!
daysSinceEpochOfFirstLeapSecond
	^daysSinceEpochOfFirstLeapSecond! !

!LeapSecondSchedule methodsFor: 'accessing' stamp: ''!
daysSinceEpochOfLastLeapSecond
	^daysSinceEpochOfLastLeapSecond! !

!LeapSecondSchedule methodsFor: 'printing' stamp: ''!
encodeOn: stream
	stream 
		nextPutAll: self registrationKey;
		nextPut: $:;
		cr.
	self leapSecondsDo: [:leapSecond | 
		stream 
			tab;
			print: leapSecond secondsDelta;
			nextPut: $:;
			print: leapSecond daysSinceEpoch;
			nextPut: $:;
			print: leapSecond secondsSinceStartOfDay;
			nextPut: $:;
			print: leapSecond isRelativeToUT;
			cr]! !

!LeapSecondSchedule methodsFor: 'accessing' stamp: ''!
firstScheduledLeapSecond
	^firstLeapSecond! !

!LeapSecondSchedule methodsFor: 'initialize-release' stamp: ''!
initialize
	self assertMutability.
	map := Dictionary new.
	daysSinceEpochOfFirstLeapSecond := 0.
	daysSinceEpochOfLastLeapSecond := 0.
	secondsSinceEpochOfFirstLeapSecond := 0.
	calendricalSecondsSinceEpochOfLastLeapSecond := 0.
	scientificSecondsSinceEpochOfLastLeapSecond := 0.! !

!LeapSecondSchedule methodsFor: 'initialize-release' stamp: ''!
invalidate
	^self hasKey 
		ifTrue: 
			[| replacement |
			replacement := ChronosSystemFacade resourceRepositoryContext retrieveLeapSecondSchedule: self key ifNone: [].
			replacement == nil 
				ifTrue: [self]
				ifFalse: 
					[replacement := replacement registerButIfPresent: [:collision | "ignore"].
					replacement key == #utc ifTrue: [UTC := replacement].
					replacement]]
		ifFalse: [self]! !

!LeapSecondSchedule methodsFor: 'accessing' stamp: ''!
lastScheduledLeapSecond
	^lastLeapSecond! !

!LeapSecondSchedule methodsFor: 'queries' stamp: ''!
leapSecondAtDaysSinceEpoch: daysSinceEpoch 
	| ls |
	ls := map at: daysSinceEpoch ifAbsent: [].
	^ls == nil ifFalse: [recentlyAccessedLeapSecond := ls]! !

!LeapSecondSchedule methodsFor: 'queries' stamp: ''!
leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: secondsSinceEpoch 
	"LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: Timepoint now utSecondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: (DateAndTimeSpec year: 1972 month: 6 day: 30 hour: 23 minute: 59 second: 59) secondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: (DateAndTimeSpec year: 1972 month: 6 day: 30 hour: 23 minute: 59 second: 60) secondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: (DateAndTimeSpec year: 1981 month: 6 day: 30 hour: 23 minute: 59 second: 59) secondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: (DateAndTimeSpec year: 1981 month: 7 day: 1 hour: 0 minute: 0 second: 0) secondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: (DateAndTimeSpec year: 2005 month: 12 day: 31 hour: 23 minute: 59 second: 59) secondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: (DateAndTimeSpec year: 2006 month: 1 day: 1 hour: 0 minute: 0 second: 0) secondsSinceEpoch"

	| ls |
	secondsSinceEpoch >= calendricalSecondsSinceEpochOfLastLeapSecond ifTrue: [^lastLeapSecond].
	secondsSinceEpoch < secondsSinceEpochOfFirstLeapSecond ifTrue: [^nil].

	ls := recentlyAccessedLeapSecond inEffectAtCalendricalSecondSinceEpoch: secondsSinceEpoch.
	ls == nil ifFalse: [recentlyAccessedLeapSecond := ls].
	^ls! !

!LeapSecondSchedule methodsFor: 'queries' stamp: ''!
leapSecondOnOrBeforeDaysSinceEpoch: daysSinceEpoch
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: Timepoint now utDaysSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: (DateSpec year: 1972 month: 6 day: 29) daysSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: (DateSpec year: 1972 month: 6 day: 30) daysSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: (DateSpec year: 1981 month: 6 day: 29) daysSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: (DateSpec year: 1981 month: 6 day: 30) daysSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: (DateSpec year: 1981 month: 7 day: 1) daysSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: (DateSpec year: 2005 month: 12 day: 30) daysSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: (DateSpec year: 2005 month: 12 day: 31) daysSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeDaysSinceEpoch: (DateSpec year: 2006 month: 1 day: 1) daysSinceEpoch"

	| ls |
	daysSinceEpoch >= daysSinceEpochOfLastLeapSecond ifTrue: [^lastLeapSecond].
	daysSinceEpoch < daysSinceEpochOfFirstLeapSecond ifTrue: [^nil].

	ls := recentlyAccessedLeapSecond inEffectAtDaySinceEpoch: daysSinceEpoch.
	ls == nil ifFalse: [recentlyAccessedLeapSecond := ls].
	^ls! !

!LeapSecondSchedule methodsFor: 'queries' stamp: ''!
leapSecondOnOrBeforeScientificSecondsSinceEpoch: secondsSinceEpoch 
	"LeapSecondSchedule utc leapSecondOnOrBeforeScientificSecondsSinceEpoch: Timepoint now utSecondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeScientificSecondsSinceEpoch: (DateAndTimeSpec year: 1972 month: 6 day: 30 hour: 23 minute: 59 second: 59) secondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeScientificSecondsSinceEpoch: (DateAndTimeSpec year: 1972 month: 6 day: 30 hour: 23 minute: 59 second: 60) secondsSinceEpoch"
	"LeapSecondSchedule utc leapSecondOnOrBeforeScientificSecondsSinceEpoch: (DateAndTimeSpec year: 1981 month: 6 day: 30 hour: 23 minute: 59 second: 59) secondsSinceEpoch + 9"
	"LeapSecondSchedule utc leapSecondOnOrBeforeScientificSecondsSinceEpoch: (DateAndTimeSpec year: 1981 month: 7 day: 1 hour: 0 minute: 0 second: 0) secondsSinceEpoch + 9"
	"LeapSecondSchedule utc leapSecondOnOrBeforeScientificSecondsSinceEpoch: (DateAndTimeSpec year: 2005 month: 12 day: 31 hour: 23 minute: 59 second: 59) secondsSinceEpoch + 22"
	"LeapSecondSchedule utc leapSecondOnOrBeforeScientificSecondsSinceEpoch: (DateAndTimeSpec year: 2005 month: 12 day: 31 hour: 23 minute: 59 second: 60) secondsSinceEpoch + 22"
	"LeapSecondSchedule utc leapSecondOnOrBeforeScientificSecondsSinceEpoch: (DateAndTimeSpec year: 2006 month: 1 day: 1 hour: 0 minute: 0 second: 0) secondsSinceEpoch + 22"

	| ls |
	secondsSinceEpoch >= scientificSecondsSinceEpochOfLastLeapSecond ifTrue: [^lastLeapSecond].
	secondsSinceEpoch < secondsSinceEpochOfFirstLeapSecond ifTrue: [^nil].

	ls := recentlyAccessedLeapSecond inEffectAtScientificSecondSinceEpoch: secondsSinceEpoch.
	ls == nil ifFalse: [recentlyAccessedLeapSecond := ls].
	^ls

	"ls := lastLeapSecond.
	[secondsSinceEpoch >= ls firstScientificSecondSinceEpoch ifTrue: [^ls].
	ls := ls prev.
	ls == nil] whileFalse.
	^nil"! !

!LeapSecondSchedule methodsFor: 'enumerating' stamp: ''!
leapSecondsDo: block1 
	| ls |
	ls := firstLeapSecond.
	[ls == nil] whileFalse: 
			[block1 value: ls.
			ls := ls next]! !

!LeapSecondSchedule methodsFor: 'private' stamp: ''!
mapLeapSecond: aLeapSecond
	self assertMutability.
	map at: aLeapSecond daysSinceEpoch - 1 put: aLeapSecond.
	map at: aLeapSecond daysSinceEpoch  put: aLeapSecond.
	map at: aLeapSecond daysSinceEpoch + 1 put: aLeapSecond.! !

!LeapSecondSchedule methodsFor: 'printing' stamp: ''!
printOn: stream
	stream nextPutAll: self globalNameOfClass.
	stream nextPut: $(.
	self encodeOn: stream.
	stream nextPut: $).! !

!LeapSecondSchedule methodsFor: 'accessing' stamp: ''!
scientificSecondsSinceEpochOfLastLeapSecond
	^scientificSecondsSinceEpochOfLastLeapSecond! !

!LeapSecondSchedule methodsFor: 'accessing' stamp: ''!
secondsSinceEpochOfFirstLeapSecond
	^secondsSinceEpochOfFirstLeapSecond! !

!LeapSecondSchedule methodsFor: 'persistence' stamp: ''!
storeInRepository
	ChronosSystemFacade resourceRepositoryContext storeLeapSecondSchedule: self! !

Registratable subclass: #SemanticDatePolicy
	instanceVariableNames: 'effectiveYearCalendar dayOfWeekSemanticKeys semanticAnnualDates semanticUniqueDates'
	classVariableNames: 'Default NYSEHolidays USDefault USFederalHolidaySemanticKeys'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Semantic Dates'!

!SemanticDatePolicy commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

!SemanticDatePolicy class methodsFor: 'accessing' stamp: ''!
default
	Default == nil ifTrue: [^self unitedStates].
	^Default! !

!SemanticDatePolicy class methodsFor: 'accessing' stamp: ''!
defaultDayOfWeekSemanticKeys
	^#(#(weekend) nil nil nil nil nil #(weekend)) "Indexed by ANSI day-of-week ordinals (Sunday=1, Saturday=7)"! !

!SemanticDatePolicy class methodsFor: 'class initialization' stamp: ''!
initialize
	"SemanticDatePolicy initialize." 

	self basicInitializeAll.	
	USDefault := nil.
	NYSEHolidays := nil.
	Default := nil.
	USFederalHolidaySemanticKeys := nil! !

!SemanticDatePolicy class methodsFor: 'private' stamp: ''!
newNYSEHolidays
	| sdp |
	sdp := SemanticDatePolicy new.
	sdp setDayOfWeekSemanticKeys: self defaultDayOfWeekSemanticKeys.
	self registerNYSEHolidaysIn: sdp.
	^sdp! !

!SemanticDatePolicy class methodsFor: 'private' stamp: ''!
newRegistry
	^IdentityDictionary new! !

!SemanticDatePolicy class methodsFor: 'private' stamp: ''!
newUSDefault
	| sdp |
	sdp := SemanticDatePolicy new.
	sdp setDayOfWeekSemanticKeys: self defaultDayOfWeekSemanticKeys.
	self registerDefaultUSAnnualSemanticDaysIn: sdp.
	^sdp! !

!SemanticDatePolicy class methodsFor: 'accessing' stamp: ''!
nyse
	"SemanticDatePolicy nyse"
	NYSEHolidays == nil 
		ifTrue: 
			[NYSEHolidays := self newNYSEHolidays.
			NYSEHolidays registerAs: #NYSE ifPresent: []].
	^NYSEHolidays! !

!SemanticDatePolicy class methodsFor: 'examples' stamp: ''!
nyseTradingDayCountFrom: minDate through: maxDate 
	"{[1000 timesRepeat: 
		[SemanticDatePolicy 
			nyseTradingDayCountFrom: (YearMonthDay year: 2000 month: January day: 14) 
			through: (YearMonthDay year: 2006 month: January day: 11)]] durationToRun}"

	"{[1000 timesRepeat: 
		[SemanticDatePolicy 
			nyseTradingDayCountFrom: (YearMonthDay year: 2005 month: December day: 9) 
			through: (YearMonthDay year: 2006 month: February day: 1)]] durationToRun}"

	"{[1000 timesRepeat: 
		[SemanticDatePolicy 
			nyseTradingDayCountFrom: (YearMonthDay year: 2003 month: March day: 12) 
			through: (YearMonthDay year: 2006 month: January day: 12)]] durationToRun}"

	"There are no trading days in the following interval, since 2005-12-31 is a Saturay, 2006-01-01 is both a Sunday and New Year's Day, and 2006-01-02 (a Monday) is the day on which New Year's Day is officially observed by the NYSE:
	{SemanticDatePolicy 
		nyseTradingDayCountFrom: (YearMonthDay year: 2005 month: December day: 31) 
		through: (YearMonthDay year: 2006 month: January day: 2)}"

	| closureCount |
	minDate > maxDate ifTrue: [^0].
	closureCount := 0.
	SemanticDatePolicy nyse 
		observedEventOccurenceDatesFrom: minDate
		through: maxDate
		do: 
			[:semanticKey :date :observanceType | 
			semanticKey == #weekend 
				ifTrue: 
					[(date year between: 1873 and: 1952) 
						ifTrue: [date dayOfWeek = Sunday ifTrue: [closureCount := closureCount + 1]]
						ifFalse: [closureCount := closureCount + 1]]
				ifFalse: [closureCount := closureCount + 1]].
	^(minDate daysUntil: maxDate) + 1  - closureCount! !

!SemanticDatePolicy class methodsFor: 'utilities/services' stamp: ''!
registerAnnuallyRecurringNYSEHolidaysIn: aSemanticDatePolicy
	| nonWeekendObservanceRule nonWeekendNonEndOfMonthObservanceRule semanticAnnualDate newYearsDay thanksgiving christmas |

	nonWeekendObservanceRule := SemanticDateObservanceRule dayOfWeekPolicy: #(0 -1 0 0 0 1 0).
	"If a Date is a Monday and the previous Sunday is a semantic day, then impute that Monday as virtually the same semantic day; if a Date is a Friday and the following Saturday is a semantic day, then impute that Friday as virtually the same semantic day; otherwise, don't impute any virtual semantic days."

	nonWeekendNonEndOfMonthObservanceRule := SemanticDateObservanceRule dayOfWeekPolicy: #(0 -1 0 0 0 1 0) dayOfMonthConstraints: #observedOnlyIfNominal.

	newYearsDay := 
		SemanticAnnualDateRule 
			semanticKey: #NewYearsDay 
			effectiveYear: 1792 
			nominalAnnualDate: AnnualDate gregorianNewYear 
			observanceRule: nonWeekendNonEndOfMonthObservanceRule.
	"The first day of the year is typically a holiday in most cultures--and that has been so for a very long time.  The effective year used here is the year that the Gregorian Calendar became the official calendar of the British Empire.  Before 1753, New Year's day would have been determined according to the Julian Calendar in the American Colonies."
	aSemanticDatePolicy addSemanticAnnualDateRule: newYearsDay. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #MartinLutherKingDay      "Honoring Dr. Martin Luther King--actual birthday January 15"
			effectiveYear: 1998
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: January week: 3 dayOfWeek: Monday)
			observanceRule: nil. "Martin Luther King Day always occurs on the same day of the week."
	"Established as a Federal legal holiday by Act of Congress in 1983 (signed into law by President Reagan in a Rose Garden ceremony in that year,) but was not observed until 1986-Jan-20."	
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #LincolnsBirthday 
			effectiveYear: 1896 "First formal observance by US Congress"
			nominalAnnualDate: (DayOfMonthFactory month: February day: 12)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1954 dayOfWeekPolicy: #(0 -1 0 0 0 1 0)).
	"Normal business day in most of the United States, although it has been (and still is) a legal holiday in some States."
	"A NYSE holiday from 1896 through 1953 (I have confirmed this by looking through a dataset I have containing daily bars of the open, close, high and low prices for the DJIA back to 1900.)"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #WashingtonsBirthday 
			effectiveYear: 1796 
			nominalAnnualDate: (DayOfMonthFactory month: February day: 22)
			observanceRule: nonWeekendObservanceRule. "Before 1968, the day of week was variable."
	"Washingtons Birthday was celebrated publicly for the first time in 1796, the last year of his presidency.  Washington's Birthday became a US Federal Holiday in 1885. 
	Note that Washington was born in 1732--at a time when the Julian Calendar was the official calendar in his home jurisdiction (in fact, throughought the American Colonies, which didn't switch to the Gregorian Calendar until 1752.)  The date of his birth in the Julian Calendar was {(DateFactory year: 1732 month: February day: 22 calendar: Calendar gregorian) asJulian localePrintString} = February 11, 1732 [Julian]."	
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #WashingtonsBirthday 
			effectiveYear: 1971 
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: February week: 3 dayOfWeek: Monday)
			observanceRule: nil. "Since 1971, President's Day always occurs on the same day of the week."
	"Set as the third Monday in February by Act of Congress in 1968 (effective 1971.)"	
	"As of 2004, Washington's Birthday is still the official name of this holiday, in spite of the fact that it usually doesn't actually fall on his birthday."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #GoodFriday 
			effectiveYear: 1792
			nominalAnnualDate: (GregorianEaster daysOffset: -2) 
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1898).
	"The NYSE has closed for Good Friday every year except in 1898, 1906 and 1907."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #GoodFriday 
			effectiveYear: 1899
			nominalAnnualDate: (GregorianEaster daysOffset: -2) 
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1906).
	"The NYSE has closed for Good Friday every year except in 1898, 1906 and 1907."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #GoodFriday 
			effectiveYear: 1908
			nominalAnnualDate: (GregorianEaster daysOffset: -2) 
			observanceRule: nil.
	"The NYSE has closed for Good Friday every year except in 1898, 1906 and 1907."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #MemorialDay 
			effectiveYear: 1873 
			nominalAnnualDate: (DayOfMonthFactory month: May day: 30)
			observanceRule: nonWeekendObservanceRule.
	"Established as a Federal legal holiday (affecting Federal employees only) by Act of Congress. In 1888, Congress added all persons in the District of Columbia to the affected group."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #MemorialDay 
			effectiveYear: 1971 
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: May week: WeekOfMonthDayOfWeekFactory lastWeekOfMonth dayOfWeek: Monday)
			observanceRule: nil. "Since 1971, Memorial Day always occurs on the same day of the week."
	"Date rule of Memorial Day changed by Act of Congress in 1968 (effective 1971.)"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #FlagDay 
			effectiveYear: 1916 "Established by Presidential Proclamation (Woodrow Wilson.)"
			nominalAnnualDate: (DayOfMonthFactory month: June day: 14)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1954 dayOfWeekPolicy: #(0 -1 0 0 0 1 0)).
	"A NYSE holiday through 1953 (I have confirmed this by looking through a dataset I have containing daily bars of the open, close, high and low prices for the DJIA back to 1900.)"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #IndependenceDay 
			effectiveYear: 1792 
			nominalAnnualDate: (DayOfMonthFactory month: July day: 4)
			observanceRule: nonWeekendObservanceRule.
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #LaborDay 
			effectiveYear: 1887 
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: September week: 1 dayOfWeek: Monday)
			observanceRule: nil. "Labor Day always occurs on the same day of the week."
	"First observed in New York State in 1882 (where the NYSE operates.) Established as a Federal legal holiday by Act of Congress in 1894."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ColumbusDay
			effectiveYear: 1909
			nominalAnnualDate: (DayOfMonthFactory month: October day: 12)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1954 dayOfWeekPolicy: #(0 -1 0 0 0 1 0)).
	"Made a legal holiday by New York State in 1909. Established as a Federal legal holiday by President Roosevelt."
	"A NYSE holiday through 1953 (I have confirmed this by looking through a dataset I have containing daily bars of the open, close, high and low prices for the DJIA back to 1900.)"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ElectionDay 
			effectiveYear: 1792 "Second US Presidential Election under the 1789 Constitution, but the first year of operation of NYSE."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: 1 dayOfWeek: Tuesday)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1969). 
			"Occurred every year through 1968. This trading holiday was discontinued as of 1984"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ElectionDay 
			effectiveYear: 1972 "Second US Presidential Election under the 1789 Constitution, but the first year of operation of NYSE."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: 1 dayOfWeek: Tuesday)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 4 expirationYear: 1984). 
			"From 1972 through 1980, only observed for Presidential elections. This trading holiday was discontinued as of 1984"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #VeteransDay "Formerly 'Armistice Day'--corresponds to 'Remembrance Day' in British Commonwealth countries (same date, congruent semantics.)"
			effectiveYear: 1918
			nominalAnnualDate: (DayOfMonthFactory month: November day: 11)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1919 dayOfWeekPolicy: #(0 -1 0 0 0 1 0)).
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #VeteransDay "Formerly 'Armistice Day'--corresponds to 'Remembrance Day' in British Commonwealth countries (same date, congruent semantics.)"
			effectiveYear: 1921
			nominalAnnualDate: (DayOfMonthFactory month: November day: 11)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1922 dayOfWeekPolicy: #(0 -1 0 0 0 1 0)).
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #VeteransDay "Formerly 'Armistice Day'--corresponds to 'Remembrance Day' in British Commonwealth countries (same date, congruent semantics.)"
			effectiveYear: 1934
			nominalAnnualDate: (DayOfMonthFactory month: November day: 11)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 0 expirationYear: 1954 dayOfWeekPolicy: #(0 -1 0 0 0 1 0)).
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	thanksgiving := 
		SemanticAnnualDateRule 
			semanticKey: #Thanksgiving 
			effectiveYear: 1863 "Lincoln's Thanksgiving Rule."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: WeekOfMonthDayOfWeekFactory lastWeekOfMonth dayOfWeek: Thursday)
			observanceRule: nil. "Thanksgiving always occurs on the same day of the week."
	"Before 1941, the status of Thanksgiving as a legal and/or 'traditional' holiday, and the date of its observance, varied widely within the United States. However, the most common date of observance before 1941 was the **last** Thursday in November (as opposed to the modern rule, which is the **fourth** Thursday.)"
	aSemanticDatePolicy addSemanticAnnualDateRule: thanksgiving.  

	thanksgiving := 
		SemanticAnnualDateRule 
			semanticKey: #Thanksgiving 
			effectiveYear: 1941 "Roosevelt's Thanksgiving Rule."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: 4 dayOfWeek: Thursday)
			observanceRule: nil. "Thanksgiving always occurs on the same day of the week."
	"Established as a Federal legal holiday by Act of Congress in 1941."
	aSemanticDatePolicy addSemanticAnnualDateRule: thanksgiving.  

	christmas := 
		SemanticAnnualDateRule 
			semanticKey: #Christmas 
			effectiveYear: 1792 
			nominalAnnualDate: (DayOfMonthFactory month: December day: 25) 
			observanceRule: nonWeekendObservanceRule.
	"Effective year based on the fact that the Gregorian Calendar became the official calendar of the British Empire in 1752."
	aSemanticDatePolicy addSemanticAnnualDateRule: christmas.! !

!SemanticDatePolicy class methodsFor: 'utilities/services' stamp: ''!
registerDefaultUSAnnualSemanticDaysIn: aSemanticDatePolicy
	"Add a set of well-known (standard, canonical in the context of Chronos) annual semantic dates commonly recognized in the United States to a <aSemanticDatePolicy>. Many of them, but by no means all of them, are United States Federal holidays (as of the time this was written or last updated.)  Holidays for the US Federal government may not be holidays for your employer, your bank, your school or your community (for example, you may not live in the United States, or your job may require that you work on days that are holidays for most other people.)  More importantly, semantic dates are not necessarily holidays to anyone at all.  A semantic date could be someone's birthday, wedding anniversary, tax filing day or annual medical checkup date--whatever dates have special semantic siginificance to someone in some use case (different use cases and/or 'users,' where 'users' might mean individuals, companies, stock exchanges or entire nations, should probably have their own instances of SemanticDatePolicy.) Consequently, whether or not the set of semantic days herein defined is 'complete' is not defined in the absolute sense.  A 'complete' set can only be defined in the context of a particular use case and user base.  

	This method's purpose is to provide a set of semantic dates for the United States all of which will be of some siginififcance to most residents of the the UnitedStates (purposely including a few that are not usually non-business days, to emphasize the point that semantic dates are not necessarily non-business days,) and also to provide an example of configuring a SemanticDatePolicy.  For identifying non-business days, the suggested approach is to define and use one or more Sets (for different years, different users, different stock exchanges, etc.) of the semantic keys of those semantic-dates that are non-business days for whatever individual(s), company(ies), organization(s), community(ies) or nation(s) that matter in your use case(s), and perhaps to also define your own SemanticDatePolicy(ies) that reflect the dates and rules needed in your use case(s)."

	| nonWeekendObservanceRule inaugurationDayObservanceRule semanticAnnualDate newYearsDay thanksgiving christmas |

	nonWeekendObservanceRule := SemanticDateObservanceRule dayOfWeekPolicy: #(0 -1 0 0 0 1 0).
	"If a Date is a Monday and the previous Sunday is a semantic day, then impute that Monday as virtually the same semantic day; if a Date is a Friday and the following Saturday is a semantic day, then impute that Friday as virtually the same semantic day; otherwise, don't impute any virtual semantic days."

	inaugurationDayObservanceRule := SemanticDateObservanceRule yearBase: 1 period: 4 dayOfWeekPolicy: #(0 -1 0 0 0 0 0). 
	"Shift observance to Monday if nominally occurs on Sunday"

	newYearsDay := 
		SemanticAnnualDateRule 
			semanticKey: #NewYearsDay 
			effectiveYear: -46 "Start of Julian Calendar."
			nominalAnnualDate: (AnnualDate newYearsDayInCalendar: Julian)
			observanceRule: nil.
	"The first day of the year is typically a holiday in most cultures--and that has been so for a very long time.  The effective year used here is the year that the Gregorian Calendar became the official calendar of the British Empire.  Before 1753, New Year's day would have been determined according to the Julian Calendar in the American Colonies."
	aSemanticDatePolicy addSemanticAnnualDateRule: newYearsDay. 

	semanticAnnualDate := 
		DerivedSemanticAnnualDateRule 
			semanticKey: #NewYearsEve
			effectiveYear: -46  "Start of Julian Calendar."
			derivedFromNominalDateOf: newYearsDay dateTransformer: (SimpleDateTransformer delta: (CalendarDurationFactory years: 1 months: 0 days: -1)).
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	newYearsDay := 
		SemanticAnnualDateRule 
			semanticKey: #NewYearsDay 
			effectiveYear: 1753 
			nominalAnnualDate: AnnualDate gregorianNewYear 
			observanceRule: nonWeekendObservanceRule.
	"The first day of the year is typically a holiday in most cultures--and that has been so for a very long time.  The effective year used here is the year that the Gregorian Calendar became the official calendar of the British Empire.  Before 1753, New Year's day would have been determined according to the Julian Calendar in the American Colonies."
	aSemanticDatePolicy addSemanticAnnualDateRule: newYearsDay. 

	semanticAnnualDate := 
		DerivedSemanticAnnualDateRule 
			semanticKey: #NewYearsEve
			effectiveYear: 1752 
			derivedFromNominalDateOf: newYearsDay dateTransformer: (SimpleDateTransformer delta: (CalendarDurationFactory years: 1 months: 0 days: -1)).
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #JacksonDay      "Celebrates the Battle of New Orleans in 1815 when the United States forces commanded by 
													Andrew Jackson defeated the British. This was the last battle of the War of 1812, and was 
													actually fought two weeks after the peace treaty was signed (the treaty of Ghent.) Also known 
													as Old Hickory's Day and Battle of New Orleans Day."
			effectiveYear: 1829					"Became a National Holiday after Jackson became President in 1828."
			nominalAnnualDate: (DayOfMonthFactory month: January day: 8)
			observanceRule: nil. "Ceased to be observed as holiday after the Civil War--and it was never shifted from the weekend to a weekday."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #InaugurationDay
			effectiveYear: 1789
			nominalAnnualDate: (DayOfMonthFactory month: March day: 4)
			observanceRule: inaugurationDayObservanceRule. "Shift observance to Monday if nominally occurs on Sunday"
	"US Federal Holiday."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #InaugurationDay
			effectiveYear: 1933 
			nominalAnnualDate: (DayOfMonthFactory month: January day: 20)
			observanceRule: inaugurationDayObservanceRule. "Shift observance to Monday if nominally occurs on Sunday"
	"US Federal Holiday--date changed by Consitutional Ammendment."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #MartinLutherKingDay      "Honoring Dr. Martin Luther King--actual birthday January 15"
			effectiveYear: 1986
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: January week: 3 dayOfWeek: Monday)
			observanceRule: nil. "Martin Luther King Day always occurs on the same day of the week."
	"Established as a Federal legal holiday by Act of Congress in 1983 (signed into law by President Reagan in a Rose Garden ceremony in that year,) but was not observed until 1986-Jan-20."	
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #GroundhogDay 
			effectiveYear: 1841 "Earliest attested observance."
			nominalAnnualDate: (DayOfMonthFactory month: February day: 2)
			observanceRule: nil.
	"Normal business day."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #LincolnsBirthday 
			effectiveYear: 1866 "First formal observance by US Congress"
			nominalAnnualDate: (DayOfMonthFactory month: February day: 12)
			observanceRule: nil.
	"Normal business day in most of the United States, although it has been a legal holiday in some States."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ValentinesDay 
			effectiveYear: 1753 "Gregorian Calendar conversion in English-speaking North America."
			nominalAnnualDate: (DayOfMonthFactory month: February day: 14)
			observanceRule: nil.
	"Normal business day."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #WashingtonsBirthday
			effectiveYear: 1796 
			nominalAnnualDate: (DayOfMonthFactory month: February day: 22)
			observanceRule: nonWeekendObservanceRule. "Before 1968, the day of week was variable."
	"Washingtons Birthday was celebrated publicly for the first time in 1796, the last year of his presidency.  Washington's Birthday became a US Federal Holiday in 1885. 
	Note that Washington was born in 1732--at a time when the Julian Calendar was the official calendar in his home jurisdiction (in fact, throughought the American Colonies, which didn't switch to the Gregorian Calendar until 1752.)  The date of his birth in the Julian Calendar was {(DateFactory year: 1732 month: February day: 22 calendar: Calendar gregorian) asJulian localePrintString} = February 11, 1732 [Julian]."	
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #WashingtonsBirthday 
			effectiveYear: 1971 
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: February week: 3 dayOfWeek: Monday)
			observanceRule: nil. "Since 1971, President's Day always occurs on the same day of the week."
	"Set as the third Monday in February by Act of Congress in 1968 (effective 1971.)"	
	"As of 2004, Washington's Birthday is still the official name of this holiday, in spite of the fact that it usually doesn't actually fall on his birthday."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #StPatricksDay 
			effectiveYear: 1753 "Gregorian Calendar conversion in English-speaking North America."
			nominalAnnualDate: (DayOfMonthFactory month: March day: 17)
			observanceRule: nil.
	"Normal business day."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #Easter 
			effectiveYear: 325
			nominalAnnualDate: JulianEaster canonical
			observanceRule: nil. 
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #Easter 
			effectiveYear: 1753
			nominalAnnualDate: GregorianEaster canonical
			observanceRule: nil. 
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #GoodFriday 
			effectiveYear: 1753
			nominalAnnualDate: (GregorianEaster daysOffset: -2) 
			observanceRule: nil. 
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #AprilFoolsDay 
			effectiveYear: 1753 "Gregorian Calendar conversion in English-speaking North America."
			nominalAnnualDate: (DayOfMonthFactory month: April day: 1)
			observanceRule: nil.
	"Normal business day (although one does need to adopt a skeptical attitude...)"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #EarthDay 
			effectiveYear: 1970 
			nominalAnnualDate: (DayOfMonthFactory month: April day: 22)
			observanceRule: nil.
	"Normal business day"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #AdministrativeAssistantsDay "Secretaries' Day" 
			effectiveYear: 1955 
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: April minDayOfMonth: 24 dayOfWeek: Saturday offset: -3)
				"Wednesday before last Saturday of April."
			observanceRule: nil.
	"Normal business day"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ArborDay
			effectiveYear: 1872
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: April minDayOfMonth: 24 dayOfWeek: Friday)
				"Last Friday of April--however, the date rule varies by locale, see http://www.arborday.org/ for more information."
			observanceRule: nil.
	"Normal business day"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #MothersDay
			effectiveYear: 1914 "By Presidential Proclamation, although it was widely celebrated in most of the US by 1911."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: May minDayOfMonth: 8 dayOfWeek: Sunday)
				"Second Sunday of May."
			observanceRule: nil.
	"Normal business day"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #MemorialDay 
			effectiveYear: 1887 
			nominalAnnualDate: (DayOfMonthFactory month: May day: 30)
			observanceRule: nonWeekendObservanceRule.
	"Established as a Federal legal holiday (affecting Federal employees only) by Act of Congress. In 1888, Congress added all persons in the District of Columbia to the affected group."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #MemorialDay 
			effectiveYear: 1971 
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: May week: WeekOfMonthDayOfWeekFactory lastWeekOfMonth dayOfWeek: Monday)
			observanceRule: nil. "Since 1971, Memorial Day always occurs on the same day of the week."
	"Date rule of Memorial Day changed by Act of Congress in 1968 (effective 1971.)"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #FlagDay 
			effectiveYear: 1916 "Established by Presidential Proclamation (Woodrow Wilson.)"
			nominalAnnualDate: (DayOfMonthFactory month: June day: 14)
			observanceRule: nil.
	"Normal business day."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #FathersDay
			effectiveYear: 1966 "By Presidential Proclamation, although it was widely celebrated in most of the US well before then."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: June minDayOfMonth: 15 dayOfWeek: Sunday)
				"Third Sunday of June."
			observanceRule: nil.
	"Normal business day"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #IndependenceDay 
			effectiveYear: 1781 
			nominalAnnualDate: (DayOfMonthFactory month: July day: 4)
			observanceRule: nonWeekendObservanceRule.
	"Recognized by Massachussets as a legal holiday in 1781. 
	In 1870, the U.S. Congress made July 4 an unpaid holiday for federal employees.
	Established as a Federal legal holiday (with pay) by Act of Congress in 1941."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ParentsDay
			effectiveYear: 1994 "By Resolution of Congress."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: July minDayOfMonth: 22 dayOfWeek: Sunday)
				"Fourth Sunday of July."
			observanceRule: nil.
	"Normal business day"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #LaborDay 
			effectiveYear: 1894 
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: September week: 1 dayOfWeek: Monday)
			observanceRule: nil. "Labor Day always occurs on the same day of the week."
	"Established as a Federal legal holiday by Act of Congress in 1894."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #GrandParentsDay
			effectiveYear: 1978 "By Presidential Proclamation."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: September minDayOfMonth: 1 dayOfWeek: Monday offset: 6)
				"Sunday after First Monday of September."
			observanceRule: nil.
	"Normal business day"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ColumbusDay
			effectiveYear: 1937
			nominalAnnualDate: (DayOfMonthFactory month: October day: 12)
			observanceRule: nonWeekendObservanceRule.
	"Established as a Federal legal holiday by President Roosevelt."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ColumbusDay
			effectiveYear: 1971
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: October week: 2 dayOfWeek: Monday)
			observanceRule: nil. "Columbus Day now always occurs on the same day of the week."
	"Established as a Federal legal holiday by Act of Congress."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #UnitedNationsDay
			effectiveYear: 1947 "By Resolution of the UN General Assembly."
			nominalAnnualDate: (DayOfMonthFactory month: October day: 24)
			observanceRule: nil.
	"Normal business day"
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #Halloween "Also known as 'All Hallows Eve,' 'Samhain,'  'All Hallowtide,' and 'The Feast of the Dead'"
			effectiveYear: 1
			nominalAnnualDate: (DayOfMonthFactory month: October day: 31 calendar: Julian)
			observanceRule: nil. "Although Halloween may occur on any day of the week, it is usually not imputed to a different day (because it's almost always a business day regardless of the day of the week.)"
	"Not a legal holiday, nor is it generally a non-business day.  The effective year is the epoch year of the Modern Julian Calendar."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #Halloween "Also known as 'All Hallows Eve,' 'Samhain,'  'All Hallowtide,' and 'The Feast of the Dead'"
			effectiveYear: 1752
			nominalAnnualDate: (DayOfMonthFactory month: October day: 31)
			observanceRule: nil. "Although Halloween may occur on any day of the week, it is usually not imputed to a different day (because it's almost always a business day regardless of the day of the week.)"
	"Not a legal holiday, nor is it generally a non-business day.  The effective date is that of the Gregorian Calendar."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #VeteransDay "Formerly 'Armistice Day'--corresponds to 'Remembrance Day' in British Commonwealth countries (same date, congruent semantics.)"
			effectiveYear: 1938
			nominalAnnualDate: (DayOfMonthFactory month: November day: 11)
			observanceRule: nonWeekendObservanceRule.
	"Established as a Federal legal holiday by Act of Congress."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	aSemanticDatePolicy at: #ElectionDay putUniqueDate: (DateSpec year: 1789 month: 1 day: 7). "First US Presidential Election under the 1789 Constitution."
	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #ElectionDay 
			effectiveYear: 1792 "Second US Presidential Election under the 1789 Constitution."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: 1 dayOfWeek: Tuesday)
			observanceRule: (SemanticDateObservanceRule yearBase: 0 period: 4). 
			"Election Day occurs in years evenly divisible by 4. However, it's not a non-business day, although there have been proposals to make it one."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	thanksgiving := 
		SemanticAnnualDateRule 
			semanticKey: #Thanksgiving 
			effectiveYear: 1863 "Lincoln's Thanksgiving Rule."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: WeekOfMonthDayOfWeekFactory lastWeekOfMonth dayOfWeek: Thursday)
			observanceRule: nil. "Thanksgiving always occurs on the same day of the week."
	"Before 1941, the status of Thanksgiving as a legal and/or 'traditional' holiday, and the date of its observance, varied widely within the United States. However, the most common date of observance before 1941 was the **last** Thursday in November (as opposed to the modern rule, which is the **fourth** Thursday.)"
	aSemanticDatePolicy addSemanticAnnualDateRule: thanksgiving.  

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #DayAfterThanksgiving 
			effectiveYear: 1863 "Lincoln's Thanksgiving Rule."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: WeekOfMonthDayOfWeekFactory lastWeekOfMonth dayOfWeek: Thursday offset: 1)
			observanceRule: nil. "The Day After Thanksgiving always occurs on the same day of the week."
	"Not a legal holiday--but often a non-business day. Effective year taken from that of Thanksgiving."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	thanksgiving := 
		SemanticAnnualDateRule 
			semanticKey: #Thanksgiving 
			effectiveYear: 1941 "Roosevelt's Thanksgiving Rule."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: 4 dayOfWeek: Thursday)
			observanceRule: nil. "Thanksgiving always occurs on the same day of the week."
	"Established as a Federal legal holiday by Act of Congress in 1941."
	aSemanticDatePolicy addSemanticAnnualDateRule: thanksgiving.  

	semanticAnnualDate := 
		SemanticAnnualDateRule 
			semanticKey: #DayAfterThanksgiving 
			effectiveYear: 1941 "Roosevelt's Thanksgiving Rule."
			nominalAnnualDate: (WeekOfMonthDayOfWeekFactory month: November week: 4 dayOfWeek: Thursday offset: 1)
			observanceRule: nil. "The Day After Thanksgiving always occurs on the same day of the week."
	"Not a legal holiday--but more often than not a non-business day in the modern era. Effective year taken from that of Thanksgiving."
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate. 

	christmas := 
		SemanticAnnualDateRule 
			semanticKey: #Christmas 
			effectiveYear: 340
			nominalAnnualDate: (DayOfMonthFactory month: December day: 25 calendar: Julian) 
			observanceRule: nil.
	"Effective year based on the fact that Christmas was first declared a legal holiday by Emperor Constantine's Declaration in 340 A.D. It's a reasonably safe assumption that Christmas was a non-business day in most parts of the western world since 340 A.D--although before 1752 in the British Empire (which at the time included what is now the United States,) it would have been celebrated on Dec 25 in the Julian Calendar, which would be a different day than Dec 25 in the Gregorian Calendar."
	aSemanticDatePolicy addSemanticAnnualDateRule: christmas.

	semanticAnnualDate := 
		DerivedSemanticAnnualDateRule 
			semanticKey: #ChristmasEve 
			effectiveYear: 340 
			dayBeforeNominalDayOf: christmas. 
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate.	

	christmas := 
		SemanticAnnualDateRule 
			semanticKey: #Christmas 
			effectiveYear: 1752 
			nominalAnnualDate: (DayOfMonthFactory month: December day: 25) 
			observanceRule: nonWeekendObservanceRule.
	"Effective year based on the fact that the Gregorian Calendar became the official calendar of the British Empire in 1752."
	aSemanticDatePolicy addSemanticAnnualDateRule: christmas.

	semanticAnnualDate := 
		DerivedSemanticAnnualDateRule 
			semanticKey: #ChristmasEve 
			effectiveYear: 1752 
			dayBeforeNominalDayOf: christmas. 
	aSemanticDatePolicy addSemanticAnnualDateRule: semanticAnnualDate.! !

!SemanticDatePolicy class methodsFor: 'utilities/services' stamp: ''!
registerNYSEHolidaysIn: aSemanticDatePolicy
	self registerAnnuallyRecurringNYSEHolidaysIn: aSemanticDatePolicy.
	self registerUniqueNYSEHolidaysIn: aSemanticDatePolicy! !

!SemanticDatePolicy class methodsFor: 'utilities/services' stamp: ''!
registerUniqueNYSEHolidaysIn: aSemanticDatePolicy
	aSemanticDatePolicy 
		at: #'DayOfMourning-GeraldFord' putUniqueDate: (DateSpec year: 2007 month: January day: 2);
		at: #'PresidentialFuneral-RonaldReagan' putUniqueDate: (DateSpec year: 2004 month: June day: 11);
		at: #WorldTradeCenterEvent putUniqueDate: (DateSpec year: 2001 month: September day: 14);		
		at: #WorldTradeCenterEvent putUniqueDate: (DateSpec year: 2001 month: September day: 13);
		at: #WorldTradeCenterEvent putUniqueDate: (DateSpec year: 2001 month: September day: 12);
		at: #WorldTradeCenterEvent putUniqueDate: (DateSpec year: 2001 month: September day: 11);
		at: #'PresidentialFuneral-RichardNixon' putUniqueDate: (DateSpec year: 1994 month: April day: 27);
		at: #'Weather-HurricaneGloria' putUniqueDate: (DateSpec year: 1985 month: September day: 27);
		at: #NewYorkCityBlackout putUniqueDate: (DateSpec year: 1977 month: July day: 14);
		at: #'PresidentialFuneral-LyndonJohnson' putUniqueDate: (DateSpec year: 1973 month: January day: 25);
		at: #'PresidentialFuneral-HarryTruman' putUniqueDate: (DateSpec year: 1972 month: December day: 28);
		at: #FirstLunarLanding putUniqueDate: (DateSpec year: 1969 month: July day: 21);
		at: #'PresidentialFuneral-DwightEisenhower' putUniqueDate: (DateSpec year: 1969 month: March day: 31);
		at: #'Weather-Snow' putUniqueDate: (DateSpec year: 1969 month: February day: 10).
	((DateFactory year: 1968 month: June day: 12) to: (DateFactory year: 1969 day: 1))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #PaperCrisis putUniqueDate: day start].
	aSemanticDatePolicy 
		at: #DayAfterIndependenceDay putUniqueDate: (DateSpec year: 1968 month: July day: 5);
		at: #'DayOfMourning-MartinLutherKing' putUniqueDate: (DateSpec year: 1968 month: April day: 9);
		at: #LincolnsBirthday putUniqueDate: (DateSpec year: 1968 month: February day: 12);
		at: #'PresidentialFuneral-JohnKennedy' putUniqueDate: (DateSpec year: 1963 month: November day: 25);
		at: #DayBeforeDecorationDay putUniqueDate: (DateSpec year: 1961 month: May day: 29);
		at: #DayAfterChrismas putUniqueDate: (DateSpec year: 1958 month: December day: 26);
		at: #ChristmasEve putUniqueDate: (DateSpec year: 1956 month: December day: 24);
		at: #ChristmasEve putUniqueDate: (DateSpec year: 1954 month: December day: 24).
	"From 1873 until 1952, there was a 2-hour trading session (10am to Noon) on Saturdays--except over the summer. But the exchange had no fixed rule for the start or end of the 'over-the-summer Saturday holdiay' period."
	((DateFactory year: 1952 month: May day: 31) to: (DateFactory year: 1952 month: September day: 28))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	((DateFactory year: 1951 month: June day: 2) to: (DateFactory year: 1951 month: September day: 30))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	aSemanticDatePolicy 
		at: #'Saturday-Before-ChristmasEve' putUniqueDate: (DateSpec year: 1950 month: December day: 12).
	((DateFactory year: 1950 month: June day: 3) to: (DateFactory year: 1950 month: October day: 1))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	aSemanticDatePolicy 
		at: #ChristmasEve putUniqueDate: (DateSpec year: 1949 month: December day: 24).
	((DateFactory year: 1949 month: May day: 28) to: (DateFactory year: 1949 month: September day: 25))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	aSemanticDatePolicy 
		at: #'Weather-SevereConditions' putUniqueDate: (DateSpec year: 1948 month: January day: 3).
	((DateFactory year: 1948 month: May day: 29) to: (DateFactory year: 1948 month: September day: 26))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	((DateFactory year: 1947 month: May day: 31) to: (DateFactory year: 1947 month: September day: 28))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	((DateFactory year: 1946 month: June day: 1) to: (DateFactory year: 1946 month: September day: 29))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	aSemanticDatePolicy 
		at: #RailroadStrike putUniqueDate: (DateSpec year: 1946 month: May day: 25);
		at: #'Saturday-After-WashingtonsBirthday' putUniqueDate: (DateSpec year: 1946 month: February day: 23);
		at: #ChristmasEve putUniqueDate: (DateSpec year: 1945 month: December day: 24);
		at: #NavyDay putUniqueDate: (DateSpec year: 1945 month: October day: 27);
		at: #'Saturday-After-ColumbusDay' putUniqueDate: (DateSpec year: 1945 month: October day: 13);
		at: #VictoryOverJapanDay putUniqueDate: (DateSpec year: 1945 month: August day: 16);
		at: #VictoryOverJapanDay putUniqueDate: (DateSpec year: 1945 month: August day: 15).
	((DateFactory year: 1945 month: July day: 7) to: (DateFactory year: 1945 month: September day: 2))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].	
	aSemanticDatePolicy 
		at: #'DayOfMourning-FranklinRoosevelt' putUniqueDate: (DateSpec year: 1945 month: April day: 14).
	((DateFactory year: 1944 month: August day: 19) to: (DateFactory year: 1944 month: September day: 3))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	aSemanticDatePolicy 
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1937 month: July day: 3);
		at: #'Saturday-Before-DecorationDay' putUniqueDate: (DateSpec year: 1937 month: May day: 29);
		at: #'Saturday-After-Christmas' putUniqueDate: (DateSpec year: 1936 month: December day: 26).
	((DateFactory year: 1933 month: July day: 29) to: (DateFactory year: 1933 month: September day: 4))
		every: DaysPerWeek
		daysDo: [:day | aSemanticDatePolicy at: #'Saturday-Summertime' putUniqueDate: day start].
	((DateFactory year: 1933 month: March day: 6) to: (DateFactory year: 1933 month: March day: 14)) 
		every: 1
		daysDo: [:day | | date | 
			"FDRs unfortunate attempt to cure the Great Depression.  History shows that the government decides to act at about the same time that the trend reverses back up on its own. The same phenomenon is visible in the behavior of the typical investor, who finaly capitulates and sells his positions at the bottom of the market. 'Buy when the blood is running in the streets.' -- Nathan Rothschild"
			date := day start.
			date dayOfWeek = Sunday
				ifFalse: [aSemanticDatePolicy at: #NationalBankingHoliday putUniqueDate: date]].
	aSemanticDatePolicy 
		at: #StateBankingHoliday putUniqueDate: (DateSpec year: 1933 month: March day: 4);
		at: #'PresidentialFuneral-CalvinCoolidge' putUniqueDate: (DateSpec year: 1933 month: January day: 7);
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1932 month: July day: 2);
		at: #'Saturday-After-Christmas' putUniqueDate: (DateSpec year: 1931 month: December day: 26);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1931 month: September day: 5);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1930 month: August day: 30);
		at: #'Saturday-After-IndependenceDay' putUniqueDate: (DateSpec year: 1930 month: July day: 5);
		at: #'Saturday-After-DecorationDay' putUniqueDate: (DateSpec year: 1930 month: May day: 31);
		at: #'Saturday-After-DecorationDay' putUniqueDate: (DateSpec year: 1930 month: May day: 31);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1930 month: April day: 19);
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1930 month: November day: 29);	"No computers back then. And of course, the market was crashing..."
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1929 month: November day: 30);	
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1929 month: November day: 23);	
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1929 month: November day: 16);	
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1929 month: November day: 9);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1929 month: November day: 2);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1929 month: November day: 1);		
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1929 month: August day: 31);		
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1929 month: March day: 30);		
		at: #'Saturday-After-WashingtonsBirthday' putUniqueDate: (DateSpec year: 1929 month: February day: 23);		
		at: #'Saturday-After-WashingtonsBirthday' putUniqueDate: (DateSpec year: 1929 month: February day: 23);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1929 month: February day: 9);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1928 month: November day: 24);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1928 month: May day: 26);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1928 month: May day: 19);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1928 month: May day: 12);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1928 month: May day: 5);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1928 month: April day: 21);		
		at: #ClericalBacklogRelief putUniqueDate: (DateSpec year: 1928 month: April day: 7);		
		at: #'Parade-CharlesLindbergh' putUniqueDate: (DateSpec year: 1927 month: June day: 13);		
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1926 month: September day: 4);		
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1926 month: July day: 3);		
		at: #'Saturday-Before-DecorationDay' putUniqueDate: (DateSpec year: 1926 month: May day: 29);		
		at: #'Saturday-After-Christmas' putUniqueDate: (DateSpec year: 1925 month: December day: 26);		
		at: #'Saturday-After-DecorationDay' putUniqueDate: (DateSpec year: 1924 month: May day: 31);		
		at: #'PresidentialFuneral-WarrenHarding' putUniqueDate: (DateSpec year: 1923 month: August day: 10);		
		at: #'PresidentialDeath-WarrenHarding' putUniqueDate: (DateSpec year: 1923 month: August day: 3);		
		at: #'Saturday-Before-Christmas' putUniqueDate: (DateSpec year: 1922 month: December day: 23);		
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1921 month: September day: 3);
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1921 month: July day: 2);		
		at: #'Saturday-Before-DecorationDay' putUniqueDate: (DateSpec year: 1921 month: May day: 28);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1920 month: September day: 4);
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1920 month: July day: 3);
		at: #RelocationOfBrokerageFirmOffices putUniqueDate: (DateSpec year: 1920 month: May day: 1);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1920 month: April day: 3);
		at: #ReturnOfGeneralJohnPershing putUniqueDate: (DateSpec year: 1919 month: September day: 10);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1919 month: August day: 30);
		at: #'Saturday-After-DecorationDay' putUniqueDate: (DateSpec year: 1919 month: May day: 31);
		at: #'Saturday-After-DecorationDay' putUniqueDate: (DateSpec year: 1919 month: May day: 31);
		at: #'Parade-77thDivision' putUniqueDate: (DateSpec year: 1919 month: May day: 6);
		at: #HomecomingOf27thDivision putUniqueDate: (DateSpec year: 1919 month: March day: 25);
		at: #DraftRegistrationDay putUniqueDate: (DateSpec year: 1918 month: September day: 12);
		at: #HeatlessDay putUniqueDate: (DateSpec year: 1918 month: February day: 11);	"Was it just too cold, was the heating system broken, or were they trying to conserve energy during wartime? Don't know, but it could have been due to any of the preceding reasons."
		at: #HeatlessDay putUniqueDate: (DateSpec year: 1918 month: February day: 4);
		at: #HeatlessDay putUniqueDate: (DateSpec year: 1918 month: January day: 28);
		at: #'Saturday-After-ColumbusDay' putUniqueDate: (DateSpec year: 1917 month: October day: 13);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1917 month: September day: 1);
		at: #'Weather-HeatDay' putUniqueDate: (DateSpec year: 1917 month: August day: 4);		"Too hot, one assumes.  No air conditioning back then."
		at: #DraftRegistrationDay putUniqueDate: (DateSpec year: 1917 month: June day: 5);
		at: #'Saturday-Before-NewYearsDay' putUniqueDate: (DateSpec year: 1916 month: December day: 30).
	((DateFactory year: 1914 month: July day: 31) to: (DateFactory year: 1914 month: December day: 13)) 
		every: 1
		daysDo: [:day | | date | 
			date := day start.
			date dayOfWeek = Sunday
				ifFalse: [aSemanticDatePolicy at: #WorldWar1 putUniqueDate: date]].
	aSemanticDatePolicy 
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1913 month: August day: 30);
		at: #'Saturday-After-IndependenceDay' putUniqueDate: (DateSpec year: 1913 month: July day: 5);		
		at: #'Saturday-After-DecorationDay' putUniqueDate: (DateSpec year: 1913 month: May day: 31);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1913 month: March day: 22);
		at: #'PresidentialFuneral-JamesSherman' putUniqueDate: (DateSpec year: 1912 month: November day: 2);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1912 month: August day: 31);
		at: #'Saturday-Before-Christmas' putUniqueDate: (DateSpec year: 1911 month: December day: 23);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1911 month: September day: 2);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1911 month: April day: 15);
		at: #'Saturday-Before-Christmas' putUniqueDate: (DateSpec year: 1910 month: December day: 24);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1910 month: September day: 3);
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1910 month: July day: 2);
		at: #'Saturday-Before-DecorationDay' putUniqueDate: (DateSpec year: 1910 month: May day: 28);
		at: #ReceptionDayOfHudsonFultonCelebration putUniqueDate: (DateSpec year: 1909 month: September day: 25);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1909 month: September day: 4);
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1909 month: July day: 3);
		at: #'Saturday-Before-DecorationDay' putUniqueDate: (DateSpec year: 1909 month: May day: 29);
		at: #'Saturday-Before-DecorationDay' putUniqueDate: (DateSpec year: 1909 month: May day: 29);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1909 month: April day: 10);
		at: #'Saturday-After-LincolnsBirthday' putUniqueDate: (DateSpec year: 1909 month: February day: 13);
		at: #'Saturday-After-LincolnsBirthday' putUniqueDate: (DateSpec year: 1909 month: February day: 13);
		at: #'Saturday-After-Christmas' putUniqueDate: (DateSpec year: 1908 month: December day: 26);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1908 month: September day: 5);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1908 month: September day: 5);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1908 month: April day: 18);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1907 month: August day: 31);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1907 month: March day: 30);
		at: #'Saturday-After-WashingtonsBirthday' putUniqueDate: (DateSpec year: 1907 month: February day: 23);		
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1905 month: April day: 22);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1905 month: April day: 22);
		at: #'Saturday-Before-Christmas' putUniqueDate: (DateSpec year: 1904 month: December day: 24);		
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1904 month: September day: 3);		
		at: #'Saturday-Before-IndepedenceDay' putUniqueDate: (DateSpec year: 1904 month: July day: 2);
		at: #'Saturday-Before-DecorationDay' putUniqueDate: (DateSpec year: 1904 month: May day: 28);
		at: #'Saturday-After-Christmas' putUniqueDate: (DateSpec year: 1903 month: December day: 26);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1903 month: September day: 5);
		at: #NewNYSEBuildingOpened putUniqueDate: (DateSpec year: 1903 month: April day: 22);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1903 month: April day: 11);
		at: #'Saturday-Before-WashingtonsBirthday' putUniqueDate: (DateSpec year: 1903 month: February day: 21);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1902 month: August day: 30);
		at: #CoronationOfKingEdwardVII putUniqueDate: (DateSpec year: 1902 month: August day: 9);
		at: #'Saturday-After-IndepedenceDay' putUniqueDate: (DateSpec year: 1902 month: July day: 5);
		at: #'Saturday-After-DecorationDay' putUniqueDate: (DateSpec year: 1902 month: May day: 31);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1902 month: March day: 29);
		at: #'PresidentialFuneral-WilliamMcKinley' putUniqueDate: (DateSpec year: 1901 month: September day: 19);
		at: #'PresidentialAssassination-WilliamMcKinley' putUniqueDate: (DateSpec year: 1901 month: September day: 14);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1901 month: August day: 31);
		at: #DayAfterIndepedenceDay putUniqueDate: (DateSpec year: 1901 month: July day: 5); "Interesting..."
		at: #'Saturday-After-IndepedenceDay' putUniqueDate: (DateSpec year: 1901 month: July day: 6);
		at: #EnlargementOfTemporaryQuartersInProduceExchange putUniqueDate: (DateSpec year: 1901 month: May day: 11); "See below"
		at: #MoveToTemporaryQuartersInProduceExchange putUniqueDate: (DateSpec year: 1901 month: April day: 27); "See above"
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1901 month: April day: 6);
		at: #FuneralOfQueenVictoria putUniqueDate: (DateSpec year: 1901 month: February day: 2);
		at: #ChristmasEve putUniqueDate: (DateSpec year: 1900 month: December day: 24);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1900 month: September day: 1);
		at: #'Saturday-After-GoodFriday' putUniqueDate: (DateSpec year: 1900 month: April day: 14);
		at: #'VicePresidentialFuneral-GarretHobart' putUniqueDate: (DateSpec year: 1899 month: November day: 25);
		at: #'AdmiralDeweyCelebration' putUniqueDate: (DateSpec year: 1899 month: September day: 30);
		at: #'AdmiralDeweyCelebration' putUniqueDate: (DateSpec year: 1899 month: September day: 29);
		at: #DayBeforeIndependenceDay putUniqueDate: (DateSpec year: 1899 month: July day: 3);
		at: #DayBeforeDecorationDay putUniqueDate: (DateSpec year: 1899 month: May day: 29);
		at: #'Saturday-Before-LincolnsBirthday' putUniqueDate: (DateSpec year: 1899 month: February day: 11);
		at: #'Saturday-Before-Christmas' putUniqueDate: (DateSpec year: 1898 month: December day: 24);
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1898 month: September day: 3);
		at: #WelcomeOfNavalCommanders putUniqueDate: (DateSpec year: 1898 month: August day: 20);
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1898 month: July day: 2);
		at: #CharterDay putUniqueDate: (DateSpec year: 1898 month: May day: 4);
		at: #'PresidentialBirthday-UlyssesGrant' putUniqueDate: (DateSpec year: 1897 month: April day: 27); "The cultural differences between then and now really begin to show here."
		at: #'PresidentialBirthday-UlyssesGrant' putUniqueDate: (DateSpec year: 1897 month: April day: 27); 
		at: #'Saturday-After-Christmas' putUniqueDate: (DateSpec year: 1896 month: December day: 26);
		at: #'Saturday-After-Christmas' putUniqueDate: (DateSpec year: 1896 month: December day: 26);
		at: #ColumbianCelebration putUniqueDate: (DateSpec year: 1893 month: April day: 27);
		at: #ColumbianCelebration putUniqueDate: (DateSpec year: 1893 month: April day: 27);
		at: #ColumbianCelebration putUniqueDate: (DateSpec year: 1892 month: October day: 22);
		at: #ColumbianCelebration putUniqueDate: (DateSpec year: 1892 month: October day: 21);
		at: #ColumbianCelebration putUniqueDate: (DateSpec year: 1892 month: October day: 12);
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1892 month: July day: 2);
		at: #'Saturday-After-Christmas' putUniqueDate: (DateSpec year: 1891 month: December day: 26);
		at: #'Saturday-After-IndependenceDay' putUniqueDate: (DateSpec year: 1890 month: July day: 5);
		at: #CentennialCelebrationOfWashingtonsInauguration putUniqueDate: (DateSpec year: 1889 month: May day: 1);
		at: #CentennialCelebrationOfWashingtonsInauguration putUniqueDate: (DateSpec year: 1889 month: April day: 30);
		at: #CentennialCelebrationOfWashingtonsInauguration putUniqueDate: (DateSpec year: 1889 month: April day: 29);
		at: #DayAfterThanksgiving putUniqueDate: (DateSpec year: 1888 month: November day: 30); "Note this differs from the modern rule for Thanksgiving."
		at: #'Saturday-Before-LaborDay' putUniqueDate: (DateSpec year: 1888 month: September day: 1); 
		at: #'Weather-Blizzard' putUniqueDate: (DateSpec year: 1888 month: March day: 13); 
		at: #'Saturday-Before-Christmas' putUniqueDate: (DateSpec year: 1887 month: December day: 24); 
		at: #'Saturday-Before-IndependenceDay' putUniqueDate: (DateSpec year: 1887 month: July day: 2); 
		at: #'PresidentialFuneral-UlyssesGrant' putUniqueDate: (DateSpec year: 1885 month: August day: 8).

	"Data before 1885 is not available."! !

!SemanticDatePolicy class methodsFor: 'accessing' stamp: ''!
unitedStates
	"SemanticDatePolicy unitedStates"

	USDefault == nil 
		ifTrue: 
			[USDefault := self newUSDefault.
			(self at: ChronosLocale unitedStates registrationKey ifAbsent: []) release.
			USDefault registerAs: ChronosLocale unitedStates registrationKey ifPresent: []].
	^USDefault! !

!SemanticDatePolicy class methodsFor: 'examples' stamp: ''!
usFederalBusinessDayCountFrom: minDate through: maxDate 
	"{[1000 timesRepeat: 
		[SemanticDatePolicy 
			usFederalBusinessDayCountFrom: (YearMonthDay year: 2001 month: January day: 20) 
			through: (YearMonthDay year: 2009 month: January day: 20)]] durationToRun}"

	"{[1000 timesRepeat: 
		[SemanticDatePolicy 
			usFederalBusinessDayCountFrom: (YearMonthDay year: 2006 month: December day: 31) 
			through: (YearMonthDay year: 2006 month: January day: 1)]] durationToRun}"

	| holidayCount |
	minDate > maxDate ifTrue: [^0].
	holidayCount := 0.
	SemanticDatePolicy unitedStates
		observedEventOccurenceDatesFrom: minDate
		through: maxDate
		do: 
			[:semanticKey :date :observanceType | 
			semanticKey == #weekend 
				ifTrue: [holidayCount := holidayCount + 1]
				ifFalse: [(SemanticDatePolicy usFederalHolidaySemanticKeys includes: semanticKey) ifTrue: [holidayCount := holidayCount + 1]]].
	^(minDate daysUntil: maxDate) + 1  - holidayCount! !

!SemanticDatePolicy class methodsFor: 'accessing' stamp: ''!
usFederalHolidaySemanticKeys
	"Well-known (standard, canonical in the context of Chronos) semantic keys of the semantic dates of United States Federal holidays (as of the time this was written or last updated.)  Although these are all holidays for the US Federal government, they may not be holidays for your employer, your bank, your school or your community (for example, you may not live in the United States, or you may work for a hospital that never closes.)"

	"SemanticDatePolicy usFederalHolidaySemanticKeys"

	USFederalHolidaySemanticKeys == nil 
		ifTrue: 
			[| set |
			set := Set new.
			set 
				addAll: #(#NewYearsDay #MartinLutherKingDay #InaugurationDay #WashingtonsBirthday #MemorialDay #IndependenceDay #LaborDay #ColumbusDay #VeteransDay #Thanksgiving #Christmas).
			USFederalHolidaySemanticKeys := set].
	^USFederalHolidaySemanticKeys! !

!SemanticDatePolicy methodsFor: 'initialize-release' stamp: ''!
addSemanticAnnualDateRule: aSemanticAnnualDateRule 
	"There can only be one SemanticAnnualDate with the same key and effectiveYear.  Subsequent registrations of the same key/effectiveYear override any previous registrations."

	| currentRule |
	self assertMutability.
	currentRule := 
		semanticAnnualDates 
				at: aSemanticAnnualDateRule key
				ifAbsent: 
					[^semanticAnnualDates at: aSemanticAnnualDateRule key
						put: aSemanticAnnualDateRule beImmutable].
	semanticAnnualDates 
		at: aSemanticAnnualDateRule key
		put: (currentRule asListSortedInCanonicalOrderByTransitionTimeAdding: aSemanticAnnualDateRule) beImmutable! !

!SemanticDatePolicy methodsFor: 'initialize-release' stamp: ''!
at: semanticKey putUniqueDate: uniqueDate
	| canonicalDate |
	self assertMutability.
	canonicalDate := uniqueDate asDate.
	(semanticUniqueDates at: canonicalDate daysSinceUnificationEpoch ifAbsentPut: [Set new]) add: semanticKey->canonicalDate! !

!SemanticDatePolicy methodsFor: 'initialize-release' stamp: ''!
beDefault
	Default := self! !

!SemanticDatePolicy methodsFor: 'initialize-release' stamp: ''!
canonicalize
	"The receiver is about to made immutable.  Therefore, ensure that any instance variables of the receiver whose values must not be changed once the receiver becomes immutable have been set to valid, canonical and/or default values.  This may be accomplished by either a) resetting the value of variables, or b) raising an exception. Fail if the receiver is not mutable."

	effectiveYearCalendar == nil 
		ifTrue: [effectiveYearCalendar := AnsiStandardCalendar]! !

!SemanticDatePolicy methodsFor: 'accessing' stamp: ''!
dayOfWeekSemanticKeys
	^dayOfWeekSemanticKeys copy! !

!SemanticDatePolicy methodsFor: 'accessing' stamp: ''!
effectiveYearCalendar
	^effectiveYearCalendar! !

!SemanticDatePolicy methodsFor: 'private' stamp: ''!
encodeAsLiteralArrayOn: stream
	"Write onto <stream>--in the canoncial order--the attribute values of the receiver that canonically occur in the receiver's `literalArrayEncoding.`  See the comment of the method #literalArrayEncoding for more information (which the receiver either implements or inherits.)"

	super encodeAsLiteralArrayOn: stream.
	stream 
		nextPut: effectiveYearCalendar registrationKey;
		nextPut: dayOfWeekSemanticKeys;
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: semanticAnnualDates);
		nextPut: (ChronosFunction encodeDictionaryAsLiteralArray: semanticUniqueDates)! !

!SemanticDatePolicy methodsFor: 'queries' stamp: ''!
forEachSemanticAnnualEventOccurringOn: aDate do: annualSemanticDateAction 
	| dateInCalendar duplicates  |
	dateInCalendar := aDate as: effectiveYearCalendar.
	duplicates := IdentitySet new.
	self semanticAnnualDateRulesEffectiveInYear: dateInCalendar year
		do: 
			[:rule | 
			(duplicates includes: rule key) 
				ifFalse: 
					[(rule occursOn: dateInCalendar) 
						ifTrue: [annualSemanticDateAction value: rule key value: aDate].
					duplicates add: rule key]].! !

!SemanticDatePolicy methodsFor: 'queries' stamp: ''!
forEachSemanticUniqueEventOccurringOn: aDate do: semanticUniqueDateAction 
	| mappingSet  |
	mappingSet := semanticUniqueDates at: aDate daysSinceUnificationEpoch ifAbsent: [^nil].
	mappingSet do: [:association | semanticUniqueDateAction value: association key value: association value].! !

!SemanticDatePolicy methodsFor: 'queries' stamp: ''!
forEachSemanticWeeklyEventOccurringOnTheDayOfWeekOf: aDate do: dayOfWeekSemanticAction 
	^dayOfWeekSemanticKeys == nil 
		ifFalse: 
			[| semanticKeySet |
			semanticKeySet := dayOfWeekSemanticKeys at: aDate ansiDayOfWeekOrdinal.
			semanticKeySet == nil ifFalse: [semanticKeySet do: [:semanticKey | dayOfWeekSemanticAction value: semanticKey value: aDate]]]! !

!SemanticDatePolicy methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize a newly created instance. This method must answer the receiver. Fail if the receiver is not mutable."
 
	super initialize.
	effectiveYearCalendar := AnsiStandardCalendar.
	dayOfWeekSemanticKeys := ChronosFunction ansiValueOfArrayLiteral: #(nil nil nil nil nil nil nil).
	semanticAnnualDates := IdentityDictionary new.
	semanticUniqueDates := Dictionary new.! !

!SemanticDatePolicy methodsFor: 'initialize-release' stamp: ''!
initializeFromLiteralArray: literalArray 
	"Initialize the receiver from the contents of <literalArray>, which must be an Array of the values that would canonically be used to portably represent and/or transport a value of the receiver's type, stored in canonical positions in the Array, and as would be produced when any object of the receiver's type is sent the message #literalArrayEncoding. Fail if the receiver is not mutable."

	super initializeFromLiteralArray: literalArray.
	self 	
		setEffectiveYearCalendar: (literalArray at: 3);
		setDayOfWeekSemanticKeys: (literalArray at: 4).
	semanticAnnualDates := ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 5).
	semanticUniqueDates := ChronosFunction decodeDictionaryFromLiteralArray: (literalArray at: 6)! !

!SemanticDatePolicy methodsFor: 'enumerating-nominal dates' stamp: ''!
nominalAnnualEventOccurenceDatesFrom: minDateOriginal through: maxDateOriginal do: block2 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy unitedStates 
		nominalAnnualEventOccurenceDatesFrom: (YearMonthDay year: 2006 month: 4 day: 1) 
		through: (YearMonthDay year: 2007 month: 9 day: 30) 
		do: [:semanticKey :date | list add: date->semanticKey].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab; show: assoc value]}"
 
	| minDate maxDate year maxYear |
	minDate := minDateOriginal as: effectiveYearCalendar.
	maxDate := maxDateOriginal as: effectiveYearCalendar.
	year := minDate year.
	maxYear := maxDate year.
	year = maxYear 
		ifTrue: 
			[self 
				nominalAnnualEventOccurenceDatesInYear: year
				do: 
					[:semanticKey :date | 
					(date >= minDate and: [date <= maxDate]) 
						ifTrue: [block2 value: semanticKey value: date]]]
		ifFalse: 
			[year > maxYear ifTrue: [^self].
			self 
				nominalAnnualEventOccurenceDatesInYear: year
				do: [:semanticKey :date | date >= minDate ifTrue: [block2 value: semanticKey value: date]].
			year + 1 to: maxYear - 1 do: 
				[:y | self nominalAnnualEventOccurenceDatesInYear: y do: block2].
			self 
				nominalAnnualEventOccurenceDatesInYear: maxYear
				do: [:semanticKey :date | date <= maxDate ifTrue: [block2 value: semanticKey value: date]]]! !

!SemanticDatePolicy methodsFor: 'enumerating-nominal dates' stamp: ''!
nominalAnnualEventOccurenceDatesInYear: year do: block2 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy default nominalAnnualEventOccurenceDatesInYear: 2005 do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"
 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy nyse nominalAnnualEventOccurenceDatesInYear: 2005 do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	self semanticAnnualDateRulesEffectiveInYear: year
		do: [:rule | (rule occursInYear: year) ifTrue: [block2 value: rule key value: (rule nominalDateInYear: year)]]! !

!SemanticDatePolicy methodsFor: 'enumerating-nominal dates' stamp: ''!
nominalEventOccurenceDatesFrom: minDateOriginal through: maxDateOriginal do: block2 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy default nominalEventOccurenceDatesInYear: 2005 do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy nyse nominalEventOccurenceDatesInYear: 2004 do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy nyse nominalEventOccurenceDatesInYear: 2006 do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	| minDate maxDate |
	minDate := minDateOriginal as: effectiveYearCalendar.
	maxDate := maxDateOriginal as: effectiveYearCalendar.
	self semanticDaysOfWeekFrom: minDate through: maxDate do: block2.
	self nominalAnnualEventOccurenceDatesFrom: minDate through: maxDate do: block2.
	self 
		semanticUniqueDatesFrom: minDate
		through: maxDate
		do: block2! !

!SemanticDatePolicy methodsFor: 'enumerating-nominal dates' stamp: ''!
nominalEventOccurenceDatesInYear: year do: block2 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy default nominalEventOccurenceDatesInYear: 2005 do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy nyse nominalEventOccurenceDatesInYear: 2004 do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy nyse nominalEventOccurenceDatesInYear: 2006 do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	self semanticDaysOfWeekInYear: year do: block2.
	self nominalAnnualEventOccurenceDatesInYear: year do: block2.
	self 
		semanticUniqueDatesFrom: (DateFactory year: year day: 1 calendar: effectiveYearCalendar)
		through: (DateFactory year: year day: (effectiveYearCalendar daysInYear: year) calendar: effectiveYearCalendar)
		do: block2! !

!SemanticDatePolicy methodsFor: 'enumerating-observed dates' stamp: ''!
observedAnnualEventOccurenceDatesFrom: minDateOriginal through: maxDateOriginal do: block3 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy unitedStates 
		observedAnnualEventOccurenceDatesFrom: (YearMonthDay year: 2006 month: 4 day: 1) 
		through: (YearMonthDay year: 2007 month: 9 day: 30) 
		do: [:semanticKey :date :observanceType | list add: date->(Array with: semanticKey with: observanceType)].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"
 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse 
		observedAnnualEventOccurenceDatesFrom: (YearMonthDay year: 1969 month: 4 day: 1) 
		through: (YearMonthDay year: 1973 month: 9 day: 30) 
		do: [:semanticKey :date :observanceType | list add: date->(Array with: semanticKey with: observanceType)].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"
 
	| minDate maxDate year maxYear |
	minDate := minDateOriginal as: effectiveYearCalendar.
	maxDate := maxDateOriginal as: effectiveYearCalendar.
	year := minDate year.
	maxYear := maxDate year.
	year = maxYear 
		ifTrue: 
			[self 
				observedAnnualEventOccurenceDatesInYear: year
				do: 
					[:semanticKey :date :observanceType | 
					(date >= minDate and: [date <= maxDate]) 
						ifTrue: [block3 value: semanticKey value: date value: observanceType]]]
		ifFalse: 
			[year > maxYear ifTrue: [^self].
			self 
				observedAnnualEventOccurenceDatesInYear: year
				do: [:semanticKey :date :observanceType | date >= minDate ifTrue: [block3 value: semanticKey value: date value: observanceType]].
			year + 1 to: maxYear - 1 do: 
				[:y | self observedAnnualEventOccurenceDatesInYear: y do: block3].
			self 
				observedAnnualEventOccurenceDatesInYear: maxYear
				do: [:semanticKey :date :observanceType | date <= maxDate ifTrue: [block3 value: semanticKey value: date value: observanceType]]]! !

!SemanticDatePolicy methodsFor: 'enumerating-observed dates' stamp: ''!
observedAnnualEventOccurenceDatesInYear: year do: block3 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy default observedAnnualEventOccurenceDatesInYear: 2004 do: 
		[:semanticKey :date :observanceType | list add: date->(Array with: semanticKey with: observanceType)].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse observedAnnualEventOccurenceDatesInYear: 2004 do: 
		[:semanticKey :date :observanceType | list add: date->(Array with: semanticKey with: observanceType)].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse observedAnnualEventOccurenceDatesInYear: 2006 do: 
		[:semanticKey :date :observanceType | list add: date->(Array with: semanticKey with: observanceType)].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ': '; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"

	self semanticAnnualDateRulesEffectiveInYear: year
		do: 
			[:rule | 
			(rule occursInYear: year) 
				ifTrue: 
					[rule 
						observanceDateAndTypeInYear: year
						into: [:date :observanceType | block3 value: rule key value: date value: observanceType]
						ifNone: []]]! !

!SemanticDatePolicy methodsFor: 'enumerating-observed dates' stamp: ''!
observedEventOccurenceDatesFrom: minDateOriginal through: maxDateOriginal do: block3 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse 
		observedEventOccurenceDatesFrom: (YearMonthDay year: 2000 month: 1 day: 14) 
		through: (YearMonthDay year: 2006 month: 1 day: 12) 
		do: [:semanticKey :date :observanceType | semanticKey == #weekend ifFalse: [list add: date->(Array with: semanticKey with: observanceType)]].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"
 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse 
		observedEventOccurenceDatesFrom: (YearMonthDay year: 1969 month: 4 day: 1) 
		through: (YearMonthDay year: 1973 month: 9 day: 30) 
		do: [:semanticKey :date :observanceType | semanticKey == #weekend ifFalse: [list add: date->(Array with: semanticKey with: observanceType)].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]]}"
 
	| minDate maxDate |
	minDate := minDateOriginal as: effectiveYearCalendar.
	maxDate := maxDateOriginal as: effectiveYearCalendar.
	self semanticDaysOfWeekFrom: minDate through: maxDate do: [:semanticKey :date | block3 value: semanticKey value: date value: #nominal].
	self observedAnnualEventOccurenceDatesFrom: minDate through: maxDate do: block3.
	self 
		semanticUniqueDatesFrom: minDate
		through: maxDate
		do: [:semanticKey :date | block3 value: semanticKey value: date value: #nominal]! !

!SemanticDatePolicy methodsFor: 'enumerating-observed dates' stamp: ''!
observedEventOccurenceDatesInYear: year do: block3 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy default observedEventOccurenceDatesInYear: 2004 do: 
		[:semanticKey :date :observanceType | semanticKey == #weekend ifFalse: [list add: date->(Array with: semanticKey with: observanceType)]].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse observedEventOccurenceDatesInYear: 2001 do: 
		[:semanticKey :date :observanceType | semanticKey == #weekend ifFalse: [list add: date->(Array with: semanticKey with: observanceType)]].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse observedEventOccurenceDatesInYear: 1969 do: 
		[:semanticKey :date :observanceType | semanticKey == #weekend ifFalse: [list add: date->(Array with: semanticKey with: observanceType)]].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse observedEventOccurenceDatesInYear: 1933 do: 
		[:semanticKey :date :observanceType | semanticKey == #weekend ifFalse: [list add: date->(Array with: semanticKey with: observanceType)]].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"

	"{| list |
	list := SortedCollection sortBlock: [:a :b | a key < b key].
	SemanticDatePolicy nyse observedEventOccurenceDatesInYear: 1914 do: 
		[:semanticKey :date :observanceType | semanticKey == #weekend ifFalse: [list add: date->(Array with: semanticKey with: observanceType)]].
	Transcript cr.
	list do: [:assoc | 
		Transcript cr; show: (assoc key printStringUsing: #rfc2822); show: ':'; tab. 
		assoc value do: [:key | 
			key == #nominal 
				ifFalse: 
					[key == #observed 
						ifTrue: 
							[Transcript show: ' ('; show: key; show: ')'] 
						ifFalse: [Transcript show: key]]]]}"

	self semanticDaysOfWeekInYear: year do: [:semanticKey :date | block3 value: semanticKey value: date value: #nominal].
	self observedAnnualEventOccurenceDatesInYear: year do: block3.
	self 
		semanticUniqueDatesFrom: (DateFactory year: year day: 1 calendar: effectiveYearCalendar)
		through: (DateFactory year: year day: (effectiveYearCalendar daysInYear: year) calendar: effectiveYearCalendar)
		do: [:semanticKey :date | block3 value: semanticKey value: date value: #nominal]! !

!SemanticDatePolicy methodsFor: 'private' stamp: ''!
postCopy
	"PRECONDTION: The receiver has just been instantiated as a #shallowCopy of another object.  
	POSTCONDITION: In response to this message, the receiver is required to make itself satisfy the following conditions and constraints: 1) It must be mutable,  2) It must compare (#=) as equal to the object from which it was shallowCopied, and 3) It must satisfy the following constraints: a) whenever the receiver mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the object from which it was shallowCopied must not be changed, and b) whenever the object from which the receiver was shallowCopied mutates the internal state of any object to which it refers as an attributive value (i.e., not as the target of an associative reference,) the state and behavior of the receiver must not be changed.  An associative reference is one where the semantics of the reference depend in any way on the object identity (#==) of the referenced object.  An attributive reference is one where any referenced object with the same value can transparently be substituted for any other such value-equivalent object without causing any error."

	"Subclasses may need to subimplement this message in order to satisfy the required semantics.  All subimplementers should send #postCopy to super."

	super postCopy.
	dayOfWeekSemanticKeys := dayOfWeekSemanticKeys copy.
	semanticAnnualDates := semanticAnnualDates copy.
	semanticUniqueDates := semanticUniqueDates copy.! !

!SemanticDatePolicy methodsFor: 'accessing' stamp: ''!
semanticAnnualDateRuleAt: semanticKey effectiveInYear: aYear ifNone: ifNone 
	"(SemanticDatePolicy unitedStates semanticAnnualDateRuleAt: #NewYearsEve effectiveInYear: 2005 ifNone: []) 
		observedDateInYear: 2005 ifNone: []"

	^(semanticAnnualDates at: semanticKey ifAbsent: [^ifNone value]) 
		effectiveRuleInYear: aYear
		ifNone: ifNone! !

!SemanticDatePolicy methodsFor: 'enumerating-rules' stamp: ''!
semanticAnnualDateRulesDo: block1 
	"Evaluate <block1 value: semanticAnnualDateRule> for all SemanticAnnualDateRules registered with the receiver. 
	Note: The sender should be prepared to handle more than one SemanticAnnualDateRule with the same semanticKey (but each with a different effectiveYear.)"

	semanticAnnualDates 
		do: [:rule | rule withSelfAndAllRightwardLinksDo: block1]! !

!SemanticDatePolicy methodsFor: 'enumerating-rules' stamp: ''!
semanticAnnualDateRulesEffectiveInYear: year detect: predicate ifNone: ifNone 
	semanticAnnualDates do: 
			[:rule | 
			| effectiveRule |
			effectiveRule := rule effectiveRuleInYear: year ifNone: [].
			effectiveRule == nil 
				ifFalse: [(predicate value: effectiveRule) ifTrue: [^effectiveRule]]].
	^ifNone value! !

!SemanticDatePolicy methodsFor: 'enumerating-rules' stamp: ''!
semanticAnnualDateRulesEffectiveInYear: year do: block1 
	"Evaluate <block1 value: semanticAnnualDate> (for each SemanticAnnualDateRule registered with the receiver) that was in effect in the given <year.>"

	semanticAnnualDates do: 
			[:rule | 
			| effectiveRule |
			effectiveRule := rule effectiveRuleInYear: year ifNone: [].
			effectiveRule == nil ifFalse: [block1 value: effectiveRule]]! !

!SemanticDatePolicy methodsFor: 'enumerating' stamp: ''!
semanticDaysOfWeekDo: block2 
	"SemanticDatePolicy unitedStates semanticDaysOfWeekDo: [:semanticKey :ansiDayOfWeekOrdinal | Transcript cr; show: semanticKey printString; show: ' | '; show: ansiDayOfWeekOrdinal printString]"

	1 to: dayOfWeekSemanticKeys size
		do: 
			[:dayOfWeek | 
			| semanticKeySet |
			semanticKeySet := dayOfWeekSemanticKeys at: dayOfWeek.
			semanticKeySet == nil ifFalse: [semanticKeySet do: [:semanticKey | block2 value: semanticKey value: dayOfWeek]]]! !

!SemanticDatePolicy methodsFor: 'enumerating' stamp: ''!
semanticDaysOfWeekFrom: minDateOriginal through: maxDateOriginal do: block2 
	"{Transcript cr.
	SemanticDatePolicy default 
		semanticDaysOfWeekFrom: YearMonthDay today 
		through: (YearMonthDay today addingMonths: 3) 
		do: [:semanticKey :date | Transcript cr; show: (date printStringUsing: #rfc2822)]}"

	| minDate maxDate |
	minDate := minDateOriginal as: effectiveYearCalendar.
	maxDate := maxDateOriginal as: effectiveYearCalendar.
	self semanticDaysOfWeekDo: 
			[:semanticKey :ansiDayOfWeekOrdinal | 
			| delta startDate endDate |
			delta := minDate ansiDayOfWeekOrdinal - ansiDayOfWeekOrdinal.
			delta > 0 ifTrue: [delta := delta - DaysPerWeek].
			startDate := minDate subtractingDays: delta.
			delta := ansiDayOfWeekOrdinal - maxDate ansiDayOfWeekOrdinal.
			delta > 0 ifTrue: [delta := delta - DaysPerWeek].
			endDate := maxDate addingDays: delta.
			startDate <= endDate 
				ifTrue: 
					[startDate 
						through: endDate
						every: 1
						weeksDo: [:date | block2 value: semanticKey value: date]]]! !

!SemanticDatePolicy methodsFor: 'enumerating' stamp: ''!
semanticDaysOfWeekInYear: year do: block2 
	self semanticDaysOfWeekDo: 
			[:semanticKey :ansiDayOfWeekOrdinal | 
			| startDate |
			startDate := 
				(WeekOfMonthDayOfWeekFactory 
					month: 1
					week: 1
					dayOfWeek: ansiDayOfWeekOrdinal
					calendar: effectiveYearCalendar) inYear: year.
			startDate 
				through: (DateFactory year: startDate year day: startDate daysInYear calendar: effectiveYearCalendar)
				every: 1 weeksDo: [:date | block2 value: semanticKey value: date]].! !

!SemanticDatePolicy methodsFor: 'enumerating' stamp: ''!
semanticKeysFor: aDate detect: predicate ifNone: ifNone
	"{SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 1985 month: January day: 21) detect: [:semanticKey | true] ifNone: [#normalDay]}"
	"{SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 2004 month: December day: 31) detect: [:semanticKey | true] ifNone: [#normalDay]}"
	"{SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 2005 month: January day: 1) detect: [:semanticKey | true] ifNone: [#normalDay]}"
	"{SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 2005 month: January day: 2) detect: [:semanticKey | true] ifNone: [#normalDay]}"
	"{SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 2005 month: December day: 26) detect: [:semanticKey | true] ifNone: [#normalDay]}"
	"{SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 2005 month: December day: 31) detect: [:semanticKey | true] ifNone: [#normalDay]}"
	"{SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 2006 month: January day: 1) detect: [:semanticKey | true] ifNone: [#normalDay]}"
	"{SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 2006 month: January day: 2) detect: [:semanticKey | true] ifNone: [#normalDay]}"

	self semanticKeysFor: aDate do: [:semanticKey | (predicate value: semanticKey) ifTrue: [^semanticKey]].
	^ifNone value! !

!SemanticDatePolicy methodsFor: 'enumerating' stamp: ''!
semanticKeysFor: aDate do: block1
	"{| set |
	set := Set new.
	SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 1985 month: January day: 20) do: [:semanticKey | set add: semanticKey].
	set}"
	"{| set |
	set := Set new.
	SemanticDatePolicy unitedStates semanticKeysFor: (DateFactory year: 2004 month: December day: 31) do: [:semanticKey | set add: semanticKey].
	set} Note: This example answers both NewYearsDay AND NewYearsEve, because the observance rule for NewYearsDay adjusts observance to Friday when the nominal date is a Saturday."

	self forEachSemanticAnnualEventOccurringOn: aDate do: [:semanticKey :date | block1 value: semanticKey].
	self forEachSemanticUniqueEventOccurringOn: aDate do: [:semanticKey :date | block1 value: semanticKey].
	self forEachSemanticWeeklyEventOccurringOnTheDayOfWeekOf: aDate do: [:semanticKey :date | block1 value: semanticKey].! !

!SemanticDatePolicy methodsFor: 'accessing' stamp: ''!
semanticUniqueDates
	^semanticUniqueDates! !

!SemanticDatePolicy methodsFor: 'enumerating' stamp: ''!
semanticUniqueDatesDo: block2
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy nyse semanticUniqueDatesDo:[:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	semanticUniqueDates do: [:set | set do: [:association | block2 value: association key value: association value]]! !

!SemanticDatePolicy methodsFor: 'enumerating' stamp: ''!
semanticUniqueDatesFrom: minDate through: maxDate do: block2 
	"{| list |
	list := SortedCollection sortBlock: [:a :b | a value < b value].
	SemanticDatePolicy nyse 
		semanticUniqueDatesFrom: (YearMonthDay year: 1969 month: July day: 1) through: (YearMonthDay year: 1977 month: October day: 15)
		do: [:semanticKey :date | list add: semanticKey->date].
	Transcript cr.
	list do: [:assoc | Transcript cr; show: (assoc value printStringUsing: #rfc2822); show: ':'; tab; show: assoc key]}"

	minDate daysSinceUnificationEpoch to: maxDate daysSinceUnificationEpoch
		do: 
			[:daysSinceUnificationEpoch | 
			| set |
			set := semanticUniqueDates at: daysSinceUnificationEpoch ifAbsent: [].
			set == nil 
				ifFalse: 
					[set do: [:association | block2 value: association key value: association value]]]! !

!SemanticDatePolicy methodsFor: 'initialize-release' stamp: ''!
setDayOfWeekSemanticKeys: anArrayOfSymbols
	self assertMutability.
	dayOfWeekSemanticKeys := ChronosFunction ansiValueOfArrayLiteral: anArrayOfSymbols.! !

!SemanticDatePolicy methodsFor: 'initialize-release' stamp: ''!
setEffectiveYearCalendar: aCalendar
	self assertMutability.
	effectiveYearCalendar := Calendar referencedBy: aCalendar.! !

Registratable subclass: #Timescale
	instanceVariableNames: 'secondsSinceJulianDayEpochUpToEpoch secondsSinceUnificationEpochUpToEpoch'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timescales'!

!Timescale commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})


	Concept:

	Usage:

	Motivation:

	Implementation:

	Subclassing:
!

Timescale subclass: #TerrestrialTimescale
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timescales'!

!TerrestrialTimescale commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

!

!TerrestrialTimescale class methodsFor: 'private' stamp: ''!
newRegistry
	^self superclass registry! !

!TerrestrialTimescale methodsFor: 'private' stamp: 'PaulDeBruicker 3/9/2011 11:27'!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the receiver's timescale."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	^1721425 * SecondsPerDay +  43200! !

!TerrestrialTimescale methodsFor: 'collaboration-dateAndTime' stamp: ''!
fromSecondsSinceEpoch: secondsSinceEpoch andNanosecondsSinceSecond: nanosecondsSinceSecond specifiedAsUT: isSpecifiedAsUT setDaysSinceEpochAndSecondsSinceStartOfDayAndNanosecondsSinceSecondInto: aTimepoint 
	| secondsDiv128 secondsMod128 |
	secondsDiv128 := secondsSinceEpoch bitShift: -7.	"Bit shifting is faster than LargeInteger math."
	secondsMod128 := secondsSinceEpoch bitAnd: 127.
	aTimepoint 
		setNanosecondsSinceSecond: nanosecondsSinceSecond;
		basicSetSecondsSinceStartOfDay: secondsMod128 + (secondsDiv128 \\ 675 bitShift: 7);	"secondsSinceEpoch \\ 128 + (seconds // 128 \\ 675 * 128)"
		basicSetDaysSinceEpoch: secondsDiv128 // 675.	"128 * 675 = 86400"
	isSpecifiedAsUT
		ifTrue: [aTimepoint canonicalizeFromUT]
		ifFalse: [aTimepoint canonicalizeFromLocalTime]! !

!TerrestrialTimescale methodsFor: 'interconversion' stamp: ''!
secondsSinceEpochFromDaysSinceEpoch: daysSinceEpoch
	^daysSinceEpoch * 675 bitShift: 7! !

TerrestrialTimescale subclass: #UT1Timescale
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timescales'!

!UT1Timescale commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

!

!UT1Timescale class methodsFor: 'private' stamp: ''!
newRegistry
	^self superclass registry! !

!UT1Timescale methodsFor: 'private' stamp: ''!
setSecondsSinceUnificationEpochUpToEpoch
	"Set the number of seconds since the initial moment of the unification timescale up to the initial moment of the receiver's timescale."

	self assertMutability.
	secondsSinceUnificationEpochUpToEpoch := 0! !

TerrestrialTimescale subclass: #UTCTimescale
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timescales'!

!UTCTimescale commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

!

!UTCTimescale class methodsFor: 'private' stamp: ''!
newRegistry
	^self superclass registry! !

!UTCTimescale methodsFor: 'collaboration-dateAndTime' stamp: ''!
fromSecondsSinceEpoch: secondsSinceEpoch andNanosecondsSinceSecond: nanosecondsSinceSecond specifiedAsUT: isSpecifiedAsUT setDaysSinceEpochAndSecondsSinceStartOfDayAndNanosecondsSinceSecondInto: aTimepoint 
	"| ts tp secondsSinceEpoch ls |
	secondsSinceEpoch := (DateAndTimeSpec year: 1980 month: 12 day: 31 hour: 23 minute: 59 second: 59) secondsSinceEpoch.
	ls := LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: secondsSinceEpoch.
	secondsSinceEpoch := secondsSinceEpoch + ls postNetLeapSeconds.
	ts := UTCTimescale new.
	tp := Timepoint basicNew.
	tp 
		basicSetCalendar: Gregorian;
		basicSetTimeZone: Timezone universal.
	ts 
		fromSecondsSinceEpoch: secondsSinceEpoch 
		andNanosecondsSinceSecond: 0 
		specifiedAsUT: true
		setDaysSinceEpochAndSecondsSinceStartOfDayAndNanosecondsSinceSecondInto: tp.
	tp beImmutable"

	"| ts tp secondsSinceEpoch utSecondsSinceEpoch ls |
	tp := Timepoint year: 1980 month: 12 day: 31 hour: 23 minute: 59 second: 59.
	secondsSinceEpoch := tp secondsSinceEpoch.
	utSecondsSinceEpoch := tp utSecondsSinceEpoch.
	ls := LeapSecondSchedule utc leapSecondOnOrBeforeCalendricalSecondsSinceEpoch: utSecondsSinceEpoch.
	secondsSinceEpoch := secondsSinceEpoch + ls postNetLeapSeconds.
	ts := UTCTimescale new.
	tp := Timepoint basicNew.
	tp 
		basicSetCalendar: Gregorian;
		basicSetTimeZone: Timezone default.
	ts 
		fromSecondsSinceEpoch: secondsSinceEpoch 
		andNanosecondsSinceSecond: 0 
		specifiedAsUT: false
		setDaysSinceEpochAndSecondsSinceStartOfDayAndNanosecondsSinceSecondInto: tp.
	tp beImmutable"

	| schedule leapSecond calendricalSecondsSinceEpoch insertLeapSecondsAtEndOfUTDay utSecondsSinceEpoch diff | 
	schedule := LeapSecondSchedule utc.
	leapSecond := schedule leapSecondOnOrBeforeScientificSecondsSinceEpoch: secondsSinceEpoch.
	calendricalSecondsSinceEpoch := 
		leapSecond == nil 
			ifTrue: [secondsSinceEpoch]
			ifFalse: [secondsSinceEpoch - leapSecond postNetLeapSeconds].
	super
			fromSecondsSinceEpoch: calendricalSecondsSinceEpoch
			andNanosecondsSinceSecond: nanosecondsSinceSecond
			specifiedAsUT: isSpecifiedAsUT
			setDaysSinceEpochAndSecondsSinceStartOfDayAndNanosecondsSinceSecondInto: aTimepoint.
	(isSpecifiedAsUT or: [aTimepoint localTimeIsUniversal])
		ifTrue:
			[leapSecond == nil
				ifTrue: [^self]
				ifFalse: 
					[insertLeapSecondsAtEndOfUTDay := leapSecond intervalIncludesScientificSecondSinceEpoch: secondsSinceEpoch.
					utSecondsSinceEpoch := secondsSinceEpoch]]
		ifFalse: 
			[leapSecond == nil
				ifTrue: 
					["Note: No time zone offset transitions occur within 24 hours of the first leap second on 1972-06-30T23:59:60."
					utSecondsSinceEpoch := aTimepoint timeZone
						netSecondsAfterSubtractingOffsetFromUTFromSeconds: secondsSinceEpoch
						nanosecondsSinceSecond: nanosecondsSinceSecond.
					diff := utSecondsSinceEpoch - schedule secondsSinceEpochOfFirstLeapSecond.
					diff < 0 ifTrue: [^self].
					insertLeapSecondsAtEndOfUTDay := leapSecond intervalIncludesScientificSecondSinceEpoch: utSecondsSinceEpoch.
					insertLeapSecondsAtEndOfUTDay ifFalse: [aTimepoint addSeconds: leapSecond postNetLeapSeconds negated]]
				ifFalse: 
					[| timeZone0  timeZone1 |
					timeZone0 := aTimepoint timeZone.
					[| ls |
					utSecondsSinceEpoch := 
						timeZone0
							netSecondsAfterSubtractingOffsetFromUTFromSeconds: secondsSinceEpoch
							nanosecondsSinceSecond: nanosecondsSinceSecond.
					ls := leapSecond inEffectAtScientificSecondSinceEpoch: utSecondsSinceEpoch.
					ls == leapSecond 
						ifTrue: [true]
						ifFalse: 
							[aTimepoint addSeconds: leapSecond postNetLeapSeconds - ls postNetLeapSeconds.
							leapSecond := ls.
							timeZone0 isStatic 
								or: 
									[timeZone1 := aTimepoint timeZone.
									timeZone0 == timeZone1]]] whileFalse: [timeZone0 := timeZone1].
					insertLeapSecondsAtEndOfUTDay := leapSecond intervalIncludesScientificSecondSinceEpoch: utSecondsSinceEpoch]].
	insertLeapSecondsAtEndOfUTDay 
		ifTrue: 
			[aTimepoint 
				basicSetSecondsSinceStartOfDay: 
					aTimepoint basicSecondsSinceStartOfDay 
						+ utSecondsSinceEpoch - leapSecond firstScientificSecondSinceEpoch + 1]! !

!UTCTimescale methodsFor: 'private' stamp: ''!
setSecondsSinceUnificationEpochUpToEpoch
	"Set the number of seconds since the initial moment of the unification timescale up to the initial moment of the receiver's timescale."

	self assertMutability.
	secondsSinceUnificationEpochUpToEpoch := 0! !

!Timescale class methodsFor: 'accessing' stamp: ''!
default 
	^self unification! !

!Timescale class methodsFor: 'private' stamp: ''!
newRegistry
	^IdentityDictionary new! !

!Timescale class methodsFor: 'accessing' stamp: ''!
unification 
	^UT1Timescale new! !

!Timescale methodsFor: 'private' stamp: ''!
computeSecondsSinceJulianDayEpochUpToEpoch
	"Compute and answer the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the receiver's timescale."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	"Example 'de novo' calculation for the Gregorian Calendar:

		 {| uDays uSeconds |
		uDays := Gregorian 
					daysSinceEpochUpToMonth: 11
					day: 24
					inYear: -4713.
		uSeconds := uDays * 86400.
		uSeconds negated - Gregorian secondsSinceStartOfDayAtStartOfJulianDay}"

	"Example 'de novo' calculation for the Hebrew Calendar:

		 {| uDays uSeconds |
		uDays := HebrewCalendar canonical
					daysSinceEpochUpToMonth: 4
					day: 20
					inYear: -952.
		uSeconds := uDays * 86400.
		uSeconds negated - HebrewCalendar canonical secondsSinceStartOfDayAtStartOfJulianDay}"


	self subclassResponsibility! !

!Timescale methodsFor: 'collaboration-dateAndTime' stamp: ''!
fromFractionalSecondsSinceEpoch: secondsSinceEpoch relativeToUT: isRelativeToUT setDaysSinceEpochAndSecondsSinceStartOfDayAndNanosecondsSinceSecondInto: aTimepoint 
	| integerSeconds |
	integerSeconds := secondsSinceEpoch truncated.
	self 
		fromSecondsSinceEpoch: integerSeconds
		andNanosecondsSinceSecond: (secondsSinceEpoch - integerSeconds) * NanosecondsPerSecond
		relativeToUT: isRelativeToUT
		setDaysSinceEpochAndSecondsSinceStartOfDayAndNanosecondsSinceSecondInto: aTimepoint! !

!Timescale methodsFor: 'collaboration-dateAndTime' stamp: ''!
fromSecondsSinceEpoch: secondsSinceEpoch andNanosecondsSinceSecond: nanosecondsSinceSecond specifiedAsUT: isSpecifiedAsUT setDaysSinceEpochAndSecondsSinceStartOfDayAndNanosecondsSinceSecondInto: aTimepoint 
	^self subclassResponsibility! !

!Timescale methodsFor: 'initialize-release' stamp: ''!
initialize
	"Initialize the receiver so that it becomes fully functional as a Calendar object that implements a particular calenrdical system. Fail if the receiver is not mutable."

	self initializeConversionFactors.! !

!Timescale methodsFor: 'private' stamp: ''!
initializeConversionFactors
	"Initialize the instance variables of the receiver that store values used to convert between timescales, or that otherwise serve to provide temporal reference points for interpreting point-in-time values in the receiver's timescale in a timescale-neutral manner."

	self secondsSinceJulianDayEpochUpToEpoch: self computeSecondsSinceJulianDayEpochUpToEpoch.
	self setSecondsSinceUnificationEpochUpToEpoch! !

!Timescale methodsFor: 'interconversion' stamp: ''!
secondsSinceEpochFromDaysSinceEpoch: daysSinceEpoch
	^self subclassResponsibility! !

!Timescale methodsFor: 'interconversion' stamp: ''!
secondsSinceEpochFromForeignSecondsSinceEpoch: foreignSecondsSinceEpoch convertingFrom: aForeignTimescale 
	^self 
		secondsSinceEpochFromSecondsSinceUnificationEpoch: 
			(aForeignTimescale 
				secondsSinceUnificationEpochFromSecondsSinceEpoch: foreignSecondsSinceEpoch)! !

!Timescale methodsFor: 'interconversion' stamp: ''!
secondsSinceEpochFromSecondsSinceUnificationEpoch: secondsSinceUnificationEpoch
	"Answer the number of seconds since the initial moment of the receiver's timescale, converted from <secondsSinceUnificationEpoch> seconds from the initial moment of the unification timescale."

	^secondsSinceUnificationEpoch - secondsSinceUnificationEpochUpToEpoch! !

!Timescale methodsFor: 'accessing' stamp: ''!
secondsSinceJulianDayEpochUpToEpoch
	"Answer the number of seconds since the initial moment (Noon) of Julian Day 0 (Monday, January 1, 4713 BC in the proleptic Julian calendar; or November 24, -4713 in the proleptic Gregorian calendar) up to the initial moment of the receiver's time scale."

	^secondsSinceJulianDayEpochUpToEpoch! !

!Timescale methodsFor: 'initialize-release' stamp: ''!
secondsSinceJulianDayEpochUpToEpoch: seconds
	"Set the number of seconds since the initial moment of Julian Day Number 0 up to the initial moment of the epoch day of the receiver's time scale."

	"Julian Day 0 starts at Noon Jan/1 4713 B.C. (zeroless ordinal year) in the Julian Calendar.
	Julian Day 0 starts at Noon Nov/24 -4713 (pure ordinal year) in the proleptic Gregorian Calendar."

	"Example 'de novo' calculation for the Gregorian Calendar:

		 {| uDays uSeconds |
		uDays := Gregorian 
					daysSinceEpochUpToMonth: 11
					day: 24
					inYear: -4713.
		uSeconds := uDays * 86400.
		uSeconds negated - Gregorian secondsSinceStartOfDayAtStartOfJulianDay}"

	"Example 'de novo' calculation for the Hebrew Calendar:

		 {| uDays uSeconds |
		uDays := HebrewCalendar canonical
					daysSinceEpochUpToMonth: 4
					day: 20
					inYear: -952.
		uSeconds := uDays * 86400.
		uSeconds negated - HebrewCalendar canonical secondsSinceStartOfDayAtStartOfJulianDay}"

	self assertMutability.
	secondsSinceJulianDayEpochUpToEpoch := seconds! !

!Timescale methodsFor: 'interconversion' stamp: ''!
secondsSinceUnificationEpochFromSecondsSinceEpoch: secondsSinceEpoch
	"Answer the number of seconds since the initial moment of the unification timescale, converted from <secondsSinceEpoch> seconds from the initial moment of the receiver's timescale."

	^secondsSinceEpoch + secondsSinceUnificationEpochUpToEpoch! !

!Timescale methodsFor: 'private' stamp: ''!
setSecondsSinceUnificationEpochUpToEpoch
	"Set the number of seconds since the initial moment of the unification timescale up to the initial moment of the receiver's timescale."

	self assertMutability.
	secondsSinceUnificationEpochUpToEpoch := secondsSinceJulianDayEpochUpToEpoch - Timescale unification secondsSinceJulianDayEpochUpToEpoch! !

Object subclass: #ChronosSystemClock
	instanceVariableNames: 'ticksPerSecond'
	classVariableNames: 'Current'
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-System'!

!ChronosSystemClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

ChronosSystemClock

	Concept:
	
		An instance of ChronosSystemClock serves as the encapsulation of a clock device, and provides a standard API for obtaining the following types of information:

			* The current time, expressed as the count of clock ticks between the current moment and the epoch of the clock (see below for the definition of the terms 'tick' and 'epoch');
			* The number of Metric System time units (seconds, milliseconds, microseconds, nanoseconds) represented by a particular number of clock ticks; 
			* The number of clock ticks represented by a particular number of Metric System time units; and 
			* Meta-information about the operating parameters and characteristics of the encapsulated clock device--specifically, clock resolution, clock precision, clock epoch date, and whether the clock reports time relative to UT or relative to local time (see below for a definition of the term 'UT'.)

		Terminology

			UT: Universal Time. UT is the international reference timezone.  UT provides the reference time-of-day relative to which local, civil time-of-day is defined all over the world (in terms of a number of seconds of offset from UT.) Originally, the start-of-day point of UT corresponded by definition to mean solar midnight in Greenwich, England.  Currently (since as early as 1956,) the precise definition of start-of-day according to UT depends upon which timescale one uses with it: UT0, UT1, UT2, UT1R, UT2R or UTC (and there are others.) Note that it is far more common than not to see either the abbreviation GMT or UTC used to refer to the timezone UT--and that such usage is technically incorrect (which tends to make it more difficult than it ought to be to tell which timescale is used or assumed, and hence to know whether or not leap seconds will be consumed and/or produced.) See the class comment of ChronosTimezone for more information.'

			Resolution: The resolution of a clock is defined by the smallest non-zero interval of time that can be notationally represented by the API for retrieving the current clock time.  

			Tick: One clock tick is the smallest non-zero interval of time that can be notationally represented by the API for retrieving the current clock time.  The difference between 'tick' and 'resolution' is that 'tick' is used when specifying a particular count or number of time intervals, whereas 'resolution' is used when specifying the notational limits of a particular clock API.

			Precision: The precision of a clock is the smallest non-zero interval of time that can pass between changes to the value of the clock's tick counter. So the resolution of a clock represents the limits on its time measurement due to its notational model, but its precision represents the limits of its time measurement performance in practice.  The resolution is frozen into the public API (a strategic issue); the precision is a function of the implementation of the clock's hardware, and of the software used to encapsulate it (a tactical issue.)

			Epoch: The epoch of a clock is the moment that serves as the zero-point for the clock's tick count.  The orignal "Blue Book" Smallalk-80 used 1901-01-01T00:00:00 UT as the epoch of its system clock, with a resolution of 1 second, and so reported the current time as the number of seconds since 12:00am, 1 January 1901 UT (the Blue Book refers to UT as GMT.)

	Usage:

		An instance of ChronosSystemClock is instantiated by sending the message #new to its class.

		The canonical instance of the ChronosSystemClock is accessible via a global named SystemClock, or by evaluating 'ChronosSystemClock current'.

		The following example demonstrates the usage of a UT-relative ChronosSystemClock instance to compute the current local time in seconds and nanoseconds:

			| ticksNow secondsSinceClockEpoch secondsSinceGregorianEpoch nanosecondsSinceSecond | 
	 		ticksNow := SystemClock ticksNowSinceSystemClockEpoch.
       		secondsSinceClockEpoch := SystemClock secondsFromTicks: ticksNow. 
	 		nanosecondsSinceSecond := SystemClock nanosecondsSinceSecondFromTicks: ticksNow.
        		secondsSinceGregorianEpoch := SystemClock secondsFromGregorianEpochUpToSystemClockEpoch + secondsSinceClockEpoch.
			DateAndTimeFactory utSecondsSinceEpoch: secondsSinceGregorianEpoch nanoseconds: nanosecondsSinceSecond timeZone: ChronosTimezone default

		The following example demonstrates the usage of a ChronosSystemClock instance to measure the time required to execute a block of code:

			DurationFactory nanoseconds: (SystemClock nanosecondsToRun: [1000 timesRepeat: [1000 factorial]])

	Motivation:

		By concentrating all system-specific code in the class hierarchies of ResourcePathFacade, ChronosSystemFacade, ChronosSystemClock and ChronosEnvironment, and by defining a standard API for the invocation of system clock functions, ChronosSystemClock enhances the portability of the codebase of the Chronos date/time library, both with respect to different implementations/versions of Smalltalk and also with respect to the varying needs and preferences of applications (or code libraries) that use Chronos.

		For example, a particular application or use case might require the use of a specialized device for reporting the current time, such as a network time server, a GPS satellite receiver, or an atomic clock directly connected to a computer. In such cases, a sublcass of ChronosSystemClock specifically implemented for accessing some such non-standard clock device can easily be substituted in place of the 'default' system clock class that relies on the host Smalltalk implementation's system clock functionality.

		Ideally, porting Chronos to a new Smalltalk implementation (or in some cases, to a new version of a Smalltalk implementation) should require nothing more than writing a new subclass of a) ChronosEnvironment, b) ChronosSystemFacade, c) ResourcePathFacade and d) ChronosSystemClock. In reality, it will probably also be necessary to add (or reuse) inter-system compatibility methods in some classes of the host Smalltalk system's base library. Examples thereof might include methods such as #readStream and #writeStream in SequenceableCollection (or its equivalent(s)), and perhaps one or more utility methods in Stream. Finally, although the ANSI standard requires the existence of a class for scaled decimals, it very unfortunately does not specify the name of the class, nor the protocol for a scaled decimal factory.  Chronos assumes that the global that references the factory object for scaled decimal values is named ScaledDecimal, and that it conforms to the instance creation protocol defined by the VisualWorks FixedPoint class. If the native Smalltalk environment does not use the global name ScaledDecimal to reference the factory object for scaled decimal values, then the method ChronosEnvironemnt>>nativeScaledDecimalClass must be subimplemented by the subclass of ChronosEnvironment that will be used in that environment.  If the scaled decimal factory object's instance creation protocol does not conform to that of the VisualWorks FixedPoint class, then VW compatibility methods must be added.

		Modification of the Chronos codebase for the purpose of making Chronos work correctly on the Smalltalk platform to which it is being ported (other than as herein described,) is strongly not recommended. Instead, please notify the author of Chronos of the porting problem {send and e-mail to porting (at) chronos-st (dot) org} so that a general solution to the problem can be designed and incorporated into the mainline Chronos codebase. 

		See also: ChronosEnvironment, ChronosSystemFacade, ResourcePathFacade

	Implementation:

		ChronosSystemClock itself is implemented to retrieve the current time using the Network Time Service, as defined by RFC-868, which provides the number of seconds since 1900-01-01T00:00:00 UT (so the resolution of the RFC-868 clock is 1 second, and the clock epoch is the first moment of the Gregorian year 1900.) The implementation of ChronosSystemClock>>ticksNowSinceSystemClockEpoch simply sends the message #rfc868SecondsSince1900 to the ChronosSystemFacade singleton (because the API for internet access is highly non-portable among the various Smalltalk implementations.) 

		Of course, the 1-second resolution provided by the RFC-868 Network Time Service may be insufficient, the 200-millisecond latency required to get the answer back may be unacceptable, and the risk that reliable high-speed internet access won't be available when needed may not be tolerable.  Consequently, most clients of Chronos will want to implement and/or use a subclass of ChronosSystemClock that encapsulates a local clock device with finer tick resolution. For VisualWorks, Chronos provides and uses the class VWSystemClock, which ecapsulates the VisualWorks VM system clock (which itself encapsulates the system clock of the host operating system.)

		Instance Variables
		
			ticksPerSecond		<Integer>	The number of clock ticks per second.

	Subclassing:

		Subclasses may need to subimplement some of the following instance methods (the semantics/responsibilities for each of these methods is fully described in the method comment):

			isRelativeToUT
			secondsFromGregorianEpochUpToSystemClockEpoch
			ticksNowSinceSystemClockEpoch
			tickResolutionName

		Additionally, the time-unit conversion methods may need to be subimplemented.  HOWEVER, note that the provided subclasses MillisecondSystemClock, MicrosecondSystemClock and NanosecondSystemClock already correctly subimplement the time-unit conversion methods for clock devices whose resolution is 1 millisecond, 1 microsecond or 1 nanosecond (respectively.) So if the clock to be encapsulated by a subclass of ChronosSystemClock has one of those three standard resolutions, then the subclass should inherit from the subclass of ChronosSystemClock whose implementation provides the appropriate time-unit conversion methods.  VWSystemClock, for example, inherits from MicrosecondSystemClock.
!

!ChronosSystemClock class methodsFor: 'accessing' stamp: ''!
current
	Current == nil ifTrue: [self invalidateCurrent].
	^Current! !

!ChronosSystemClock class methodsFor: 'class initialization' stamp: ''!
initialize
	"ChronosSystemClock initialize" 

	Current := nil.! !

!ChronosSystemClock class methodsFor: 'class initialization' stamp: ''!
invalidateCurrent
	"Ensure that the current ChronosSystemClock is the correct implementation for the current system environment.  Also ensure that the CalendarClock for all Calendars is the correct implementation for the current ChronosSystemClock."

	"ChronosSystemClock invalidateCurrent"

	Current := ChronosSystemFacade current newSystemClock.
	Calendar invalidateClock.
	ChronosEnvironment canonical defineSystemClockInGlobalNamespace! !

!ChronosSystemClock class methodsFor: 'queries' stamp: ''!
javaEpoch
	"ChronosSystemClock javaEpoch"

	^self unixEpoch! !

!ChronosSystemClock class methodsFor: 'queries' stamp: ''!
msWindowsNTEpoch
	"ChronosSystemClock msWindowsNTEpoch"

	^DateAndTimeFactory year: 1601 day: 1 timeZone: #UT! !

!ChronosSystemClock class methodsFor: 'instance creation' stamp: ''!
new
	^self basicNew initialize! !

!ChronosSystemClock class methodsFor: 'queries' stamp: ''!
st80Epoch
	"ChronosSystemClock st80Epoch"

	^DateAndTimeFactory year: 1901 day: 1 timeZone: #UT! !

!ChronosSystemClock class methodsFor: 'queries' stamp: ''!
unixEpoch
	^DateAndTimeFactory year: 1970 day: 1 timeZone: #UT! !

!ChronosSystemClock methodsFor: 'accessing' stamp: ''!
epoch
	^self isRelativeToUT 
		ifTrue: 
			[DateAndTimeFactory 
				utSecondsSinceEpoch: self secondsFromGregorianEpochUpToSystemClockEpoch
				timeZone: ChronosTimezone universal]
		ifFalse: 
			[DateAndTimeFactory 
				secondsSinceEpoch: self secondsFromGregorianEpochUpToSystemClockEpoch]! !

!ChronosSystemClock methodsFor: 'initialize-release' stamp: ''!
initialize
	ticksPerSecond := self ticksFromSeconds: 1! !

!ChronosSystemClock methodsFor: 'initialize-release' stamp: ''!
invalidateRelativity
	"Reset the receiver's UT/local relativity based on the current operating environment. If the new relativity differs from the old, inform dependents of the change using the aspect #relativity"

	"By default, do nothing"! !

!ChronosSystemClock methodsFor: 'testing' stamp: ''!
isRelativeToLocalTime
	"If the receiver reports ticks relative to UT, answer false.
	If the receiver reports ticks relative to local time, answer true."

	^self isRelativeToUT not! !

!ChronosSystemClock methodsFor: 'testing' stamp: ''!
isRelativeToUT
	"If the receiver reports ticks relative to UT, answer true.
	If the receiver reports ticks relative to local time, answer false."

	^true! !

!ChronosSystemClock methodsFor: 'testing' stamp: ''!
isRelativityDynamic
	"Answer true if the relativity of the receiver (whether it keeps/reports time relative to UT or to local time) may be different in different operating environments (e.g., pre VW7x, the VW system clock is relative to local time on Windows and MacOS Classic, but relative to UT on all other platforms.)"

	^false! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
microsecondsFromTicks: ticks
	^ChronosFunction times1000000: ticks! !

!ChronosSystemClock methodsFor: 'API-timing' stamp: ''!
microsecondsToRun: timedBlock
	^self microsecondsFromTicks: (self ticksToRun: timedBlock)! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
millisecondsFromTicks: ticks
	^ticks * MillisecondsPerSecond! !

!ChronosSystemClock methodsFor: 'API-timing' stamp: ''!
millisecondsToRun: timedBlock
	^self millisecondsFromTicks: (self ticksToRun: timedBlock)! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
nanosecondsFromTicks: ticks
	^ticks * NanosecondsPerSecond! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
nanosecondsSinceSecondFromTicks: ticks
	^0! !

!ChronosSystemClock methodsFor: 'API-timing' stamp: ''!
nanosecondsToRun: timedBlock
	^self nanosecondsFromTicks: (self ticksToRun: timedBlock)! !

!ChronosSystemClock methodsFor: 'calendar clock binding' stamp: ''!
newCalendarClock
	"Answer a new CalendarClock instance appropriate for use with the receiver.  The appropriate CalendarClock depends on the relativity of the time the receiver reports (e.g., relative to Universal Time, relative to local time, etc.)"

	^CalendarClock systemClock: self! !

!ChronosSystemClock methodsFor: 'calendar clock binding' stamp: ''!
newGregorianCalendarClock
	"Answer a new CalendarClock instance appropriate for use with the receiver and the Gregorian Calendar.  The appropriate CalendarClock instance depends on 1) whether the host Smalltalk environment's system clock reports time as a) time units (seconds, milliseconds, etc.) since an epoch or b) a Gregorian year-month-day-hour-minute-second designation; and 2) whether the host Smalltalk environment's system clock reports time c) relative to Universal Time or d) relative to local time."

	^self newCalendarClock! !

!ChronosSystemClock methodsFor: 'accessing' stamp: ''!
precision
	"Answer a Duration whose value indicates the precision of the receiver.  The precision of a clock is the average time interval between updates to the clock's tick count.  The 'tick size' of a clock is the minimum time interval that notationally can be represented by the clock's time counter (the clock's 'tick size' is also called the 'clock resolution.')"

	^DurationFactory nanoseconds: (self nanosecondsFromTicks: self tickPrecision)! !

!ChronosSystemClock methodsFor: 'printing' stamp: ''!
printOn: stream
	super printOn: stream.
	stream
		nextPut: $(;
		nextPutAll: 'tick resolution = ';
		nextPutAll: self tickResolutionName;
		nextPutAll: ' | ';
		nextPutAll: 'Clock Epoch = ';
		nextPutAll: (self epoch printStringUsing: ChronosPrintPolicy verbose).
	stream nextPut: $)! !

!ChronosSystemClock methodsFor: 'accessing' stamp: ''!
resolutionQuantum
	"Answer a Duration whose value indicates the resolution of the receiver.  The resolution of a clock is the minimum temporal extent that notationally can be represented by the clock's logical time counter (which is determined by the API for reading the value of the counter.)"

	^DurationFactory nanoseconds: (self nanosecondsFromTicks: 1)! !

!ChronosSystemClock methodsFor: 'calendar clock binding' stamp: ''!
secondsFromGregorianEpochUpToSystemClockEpoch
	"Answer the number of seconds from the Epoch date/time of the Proleptic Gregorian Calendar (i.e., January 1, 1 AD  00:00:00 Proleptic Gregorian) up to the Epoch date/time of the platform system clock encapsulated by the receiver (i.e., where clock ticks = 0).  For most Smalltallk implementations, the platform system clock is a software device provided by the virtual machine.  On most operating systems, the system clock's zero point will be 00:00:00 UT of the first day of some Gregorian year.  However, some platforms (e.g., Classic MacOS) use a zero point that is 00:00:00 (midnight) LOCAL TIME.  Do not adjust the encapsulated clock's tick count from UT to local time, nor from local time to UT.  If the encapsulated clock reports ticks relative to UT, then #secondsFromGregorianEpochUpToSystemClockEpoch should answer the number of seconds since midnight UT of the clock's epoch date, and the instance method #isRelativeToUT should answer true. However, if the encapsulated clock reports ticks relative to local time, then #secondsFromGregorianEpochUpToSystemClockEpoch should answer the number of seconds since midnight local time of the clock's epoch date, and the instance method #isRelativeToUT should answer false."

	"EXAMPLE 'How-To':

	Option 1: 'Let the Gregorian Calendar do it-slower but very clear, and since this value will usually only be needed once, speed should not be an issue'
		^(Calendar gregorian secondsSinceEpochUpToYear: 1901) {= 59958144000} 

	Option 2: 'Use the difference between Julian Days-fast but opaque'
		^(2415386 - 1721426) * SecondsPerDay {=59958144000}

	Option 3: 'Precompute the value somehow and just answer it--very fast but very opaque'
		^59958144000"

	"Many Smalltalk systems use 1901-01-01T00:00:00 UT (1 January 1901 AD, UT start-of-day) as the 'Epoch Date/Time' for the system clock (or perhaps 1901-01-01T00:00:00 local time, even though that's a rather bad practice.) The corresponding Julian Day is 2415386. (Julian Days start at noon; the convention is that the Julian Day Number of a date corresponds to that of the Julian Day that starts at Noon on that date.)

	The Julian Day numbers for a list of common system clock/calendar epoch dates are listed below:

		Gregorian Date		 +0.5d =	Julian Day	-0.5d =	Julian Calendar Date		Verification							Comment
		-4713-11-24T00:00:00 UT =>  		    0		<=	-4713-01-01T00:00:00 UT		{DateSpec julianDay: 0} 			Julian Day Zero
		0000-12-30T00:00:00 UT =>  	1721424		<=	0001-01-01T00:00:00 UT		{DateSpec julianDay: 1721424} 	Epoch of Julian Calendar
		0000-12-31T00:00:00 UT =>  	1721425		<=	0001-01-02T00:00:00 UT		{DateSpec julianDay: 1721425} 	Rata Die epoch (Reingold/Dershowitz)
		0001-01-01T00:00:00 UT =>  	1721426		<=	0001-01-03T00:00:00 UT		{DateSpec julianDay: 1721426} 	Epoch of Gregorian Calendar
		1582-10-15T00:00:00 UT =>  	2299161		<=	1582-10-05T00:00:00 UT		{DateSpec julianDay: 2299161}	Inception of Gregorian Calendar,
																										by Proclamation of Pope Gregory
																										(which was ignored by many 
																										non-Catholic countries, who all
																										switched at various later times)
		1601-01-01T00:00:00 UT =>  	2305814		<=	1600-12-22T00:00:00 UT		{DateSpec julianDay: 2305814}  System clock Epoch for both
																											Windows-32 & ANSI COBOL
		1858-11-17T00:00:00 UT =>  	2400001		<=	1858-11-05T00:00:00 UT		{DateSpec julianDay: 2400001}  Epoch of Modified Julian Day 
																																					(Midnight, not Noon)
																																					& System clock epoch of VMS
		1900-01-01T00:00:00 UT =>  	2415021		<=	1899-12-20T00:00:00 UT		{DateSpec julianDay: 2415021}  IBM Mainframe system clock Epoch
		1901-01-01T00:00:00 UT =>  	2415386		<=	1900-12-19T00:00:00 UT		{DateSpec julianDay: 2415386}  ST-80 VM clock Epoch
		1904-01-01T00:00:00 UT =>  	2416481		<=	1903-12-19T00:00:00 UT		{DateSpec julianDay: 2416481}  MacOS Classic clock epoch
		1970-01-01T00:00:00 UT =>  	2440588		<=	1969-12-19T00:00:00 UT		{DateSpec julianDay: 2440588}  UNIX/POSIX system clock Epoch
		1980-01-01T00:00:00 xxx =>  	2444240		<=	1979-12-19T00:00:00 xxx		{DateSpec julianDay: 2444240}	MS-DOS system clock Epoch 
																																					& Windows-16 (both in local time!!!!!!)
		1990-01-01T00:00:00 UT =>  	2447893		<=	1989-12-19T00:00:00 UT		{DateSpec julianDay: 2447893}
		2000-01-01T00:00:00 UT =>  	2451545		<=	1999-12-19T00:00:00 UT		{DateSpec julianDay: 2451545}
		2001-01-01T00:00:00 UT =>  	2451911		<=	2000-12-19T00:00:00 UT		{DateSpec julianDay: 2451911}

		Note that the actual Julian Date of the Modified Julian Day system is 2400000.5, since MJD 0.0 is midnight (start-of-day) 1858-11-17T00:00:00 UT."


	"The default implementation uses the network time service as defined by RFC-868, which provides the number of seconds since 1900-01-01T00:00:00 UT"

	"^Calendar gregorian secondsSinceEpochUpToYear: 1900" ^59926608000! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
secondsFromTicks: ticks
	^ticks! !

!ChronosSystemClock methodsFor: 'API-timing' stamp: ''!
secondsNowSinceSystemClockEpoch
	"Answer the number of seconds since the Epoch date/time of the platform system clock encapsulated by the receiver (i.e., where seconds = 0)) up to the current moment. Do not adjust for timezone offset, just answer the raw value provided by the platform system clock (for many Smalltallk implementations, the platform system clock is a software device provided by the virtual machine, and can be accessed via primtive message send.)"

	"The default implementation uses the network time service as defined by RFC-868, which provides the number of seconds since 1900-01-01T00:00:00 UTC"

	"{| clock |
	clock := ChronosSystemClock new.
	DateAndTimeFactory
		utSecondsSinceEpoch: (clock secondsFromGregorianEpochUpToSystemClockEpoch + clock secondsNowSinceSystemClockEpoch)
		timeZone: Timezone default}"

	^self secondsFromTicks: self ticksNowSinceSystemClockEpoch! !

!ChronosSystemClock methodsFor: 'accessing' stamp: ''!
tickPrecision 
        "Answer the mean of the number of clock ticks between subsequent updates of the clock's tick counter." 

        "{ChronosSystemClock current tickPrecision}" 

        | ticks tickDelta sum count | 
        sum := 0. 
        count := 0. 
        ticks := self ticksNowSinceSystemClockEpoch. 
        [count < 10] whileTrue: 
                        [tickDelta := self ticksNowSinceSystemClockEpoch - ticks. 
                        tickDelta > 0 
                                ifTrue: 
                                        [count := count + 1. 
                                        sum := sum + tickDelta. 
                                        ticks := self ticksNowSinceSystemClockEpoch]]. 
        ^(sum / 10) rounded! !

!ChronosSystemClock methodsFor: 'accessing' stamp: ''!
tickResolutionName
	"Answer a Symbol that identifies a time unit whose duration is that of the receiver's tick resolution."

	^#second! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromMicroseconds: microseconds 
	^microseconds // MicrosecondsPerSecond! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromMilliseconds: milliseconds
	^milliseconds // MillisecondsPerSecond! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromNanososeconds: nanoseconds 
	^nanoseconds // NanosecondsPerSecond! !

!ChronosSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromSeconds: seconds
	^seconds! !

!ChronosSystemClock methodsFor: 'API-timing' stamp: ''!
ticksNowSinceSystemClockEpoch
	"Answer the number of clock ticks since the Epoch date/time of the platform system clock encapsulated by the receiver (i.e., where clock ticks = 0)) up to the current moment. Do not adjust for timezone offset, just answer the raw value provided by the platform system clock (for many Smalltallk implementations, the platform system clock is a software device provided by the virtual machine, and can be accessed via primtive message send.)"

	"The default implementation uses the network time service as defined by RFC-868, which provides the number of seconds since 1900-01-01T00:00:00 UTC"

	"{| clock |
	clock := ChronosSystemClock new.
	DateAndTimeFactory
		utSecondsSinceEpoch: (clock secondsFromGregorianEpochUpToSystemClockEpoch + (clock secondsFromTicks: clock ticksNowSinceSystemClockEpoch))
		timeZone: Timezone default}"

	^ChronosSystemFacade current rfc868SecondsSince1900! !

!ChronosSystemClock methodsFor: 'accessing' stamp: ''!
ticksPerSecond
	^ticksPerSecond! !

!ChronosSystemClock methodsFor: 'API-timing' stamp: ''!
ticksToRun: timedBlock
	| initialTicks |
	initialTicks := self ticksNowSinceSystemClockEpoch.
	timedBlock value.
	^self ticksNowSinceSystemClockEpoch - initialTicks! !

ChronosSystemClock subclass: #MicrosecondSystemClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-System'!

!MicrosecondSystemClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

MicrosecondSystemClock

	Concept:

		MicrosecondSystemClock is an abstract subclass of ChronosSystemClock. It should be used as the superclass of any concrete ChronosSystemClock class that encapsulates a clock device whose resolution is one microsecond.  See the class comment of ChronosSystemClock for more information, including the defintion of the term 'resolution.' 

		!

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
microsecondsFromTicks: ticks
	^ticks! !

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
millisecondsFromTicks: ticks

	^ChronosFunction times1000: ticks! !

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
nanosecondsFromTicks: ticks
	^ticks * NanosecondsPerMicrosecond! !

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
nanosecondsSinceSecondFromTicks: ticks
	"MicrosecondSystemClock new nanosecondsSinceSecondFromTicks: 1200000"

	"{[1000000 timesRepeat: [33554431 \\ 1000000 * 125 bitShift: 3]] durationToRun 00:00:00:00.150378} Fastest"
	"{[1000000 timesRepeat: [((33554431 bitAnd: 63) + (((33554431 bitShift: -6) \\ 15625)  bitShift: 6) * 125) bitShift: 3]] durationToRun 00:00:00:00.156723} Next to fastest"
	"{[1000000 timesRepeat: [(33554431 bitAnd: 63) * 1000 + ((((33554431 bitShift: -6) \\ 15625)  * 125) bitShift: 9)]] durationToRun 00:00:00:00.361593} Next to slowest"
	"{[1000000 timesRepeat: [33554431 \\ 1000000 * 1000]] durationToRun 00:00:00:01.089217} Slowest"

	^ticks \\ ticksPerSecond * 125 bitShift: 3! !

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
secondsFromTicks: ticks

	^ticks // MicrosecondsPerSecond! !

!MicrosecondSystemClock methodsFor: 'accessing' stamp: ''!
tickResolutionName
	"Answer a Symbol that identifies a time unit whose duration is that of the receiver's tick resolution."

	^#microsecond! !

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromMicroseconds: microseconds 
	^microseconds! !

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromMilliseconds: milliseconds
	^milliseconds * MicrosecondsPerMillisecond! !

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromNanososeconds: nanoseconds 
	^nanoseconds * NanosecondsPerMicrosecond! !

!MicrosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromSeconds: seconds
	^ChronosFunction times1000000: seconds! !

!MicrosecondSystemClock methodsFor: 'API-timing' stamp: ''!
ticksNowSinceSystemClockEpoch
	"Answer the number of clock ticks since the Epoch date/time of the platform system clock encapsulated by the receiver (i.e., where clock ticks = 0)) up to the current moment. Do not adjust for timezone offset, just answer the raw value provided by the platform system clock (for many Smalltallk implementations, the platform system clock is a software device provided by the virtual machine, and can be accessed via primtive message send.)"

	"The default implementation uses the network time service as defined by RFC-868, which provides the number of seconds since 1900-01-01T00:00:00 UT"

	^self subclassResponsibility! !

ChronosSystemClock subclass: #MillisecondSystemClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-System'!

!MillisecondSystemClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

MillisecondSystemClock

	Concept:

		MillisecondSystemClock is an abstract subclass of ChronosSystemClock. It should be used as the superclass of any concrete ChronosSystemClock class that encapsulates a clock device whose resolution is one millisecond.  See the class comment of ChronosSystemClock for more information, including the defintion of the term 'resolution.' 
!

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
microsecondsFromTicks: ticks
	^ticks * MicrosecondsPerMillisecond! !

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
millisecondsFromTicks: ticks
	^ticks! !

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
nanosecondsFromTicks: ticks
	^ChronosFunction times1000000: ticks! !

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
nanosecondsSinceSecondFromTicks: ticks
	"MillisecondSystemClock new nanosecondsSinceSecondFromTicks: 1200"

	^ticks \\ ticksPerSecond * 1000000! !

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
secondsFromTicks: ticks

	^ChronosFunction times1000: ticks! !

!MillisecondSystemClock methodsFor: 'accessing' stamp: ''!
tickResolutionName
	"Answer a Symbol that identifies a time unit whose duration is that of the receiver's tick resolution."

	^#millisecond! !

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromMicroseconds: microseconds 
	^microseconds // MicrosecondsPerMillisecond! !

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromMilliseconds: milliseconds
	^milliseconds! !

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromNanososeconds: nanoseconds 
	^nanoseconds // NanosecondsPerMillisecond! !

!MillisecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromSeconds: seconds
	^seconds * MillisecondsPerSecond! !

!MillisecondSystemClock methodsFor: 'API-timing' stamp: ''!
ticksNowSinceSystemClockEpoch
	"Answer the number of clock ticks since the Epoch date/time of the platform system clock encapsulated by the receiver (i.e., where clock ticks = 0)) up to the current moment. Do not adjust for timezone offset, just answer the raw value provided by the platform system clock (for many Smalltallk implementations, the platform system clock is a software device provided by the virtual machine, and can be accessed via primtive message send.)"

	"The default implementation uses the network time service as defined by RFC-868, which provides the number of seconds since 1900-01-01T00:00:00 UTC"

	^self subclassResponsibility! !

ChronosSystemClock subclass: #NanosecondSystemClock
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-System'!

!NanosecondSystemClock commentStamp: '<historical>' prior: 0!
[Chronos] All code (classes and methods, and all associated documentation,) distributed as part of the Chronos Date/Time library are  Copyright 2005-2006 by Alan L. Lovejoy.  All Rights Reserved. Usage is controlled by the Chronos License (which is included in the distribution as the contents of the file {chronos-license.txt}, and is also available from the Chronos web site {http://www.chronos-st.org/License.html})

NanosecondSystemClock

	Concept:

		NanosecondSystemClock is an abstract subclass of ChronosSystemClock. It should be used as the superclass of any concrete ChronosSystemClock class that encapsulates a clock device whose resolution is one nanosecond.  See the class comment of ChronosSystemClock for more information, including the defintion of the term 'resolution.' 
!

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
microsecondsFromTicks: ticks
	^ChronosFunction times1000: ticks! !

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
millisecondsFromTicks: ticks
	^ticks // NanosecondsPerMillisecond! !

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
nanosecondsFromTicks: ticks
	^ticks! !

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
nanosecondsSinceSecondFromTicks: ticks
	^ticks \\ ticksPerSecond! !

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
secondsFromTicks: ticks
	^ChronosFunction divBy1000000000: ticks

	"{[1000000 timesRepeat: [(33554431 bitShift: -9) // 1953125]] durationToRun}
	{[1000000 timesRepeat: [33554431 // 1000000000]] durationToRun}
	{[1000000 timesRepeat: [33554431 // NanosecondsPerSecond]] durationToRun}
	{[1000000 timesRepeat: [(33554431 // 1953125) bitShift: -9]] durationToRun}"! !

!NanosecondSystemClock methodsFor: 'accessing' stamp: ''!
tickResolutionName
	"Answer a Symbol that identifies a time unit whose duration is that of the receiver's tick resolution."

	^#nanosecond! !

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromMicroseconds: microseconds
	^microseconds * NanosecondsPerMicrosecond! !

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromMilliseconds: milliseconds
	^milliseconds * NanosecondsPerMillisecond! !

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromNanososeconds: nanoseconds
	^nanoseconds! !

!NanosecondSystemClock methodsFor: 'API-conversion' stamp: ''!
ticksFromSeconds: seconds
	^seconds  * NanosecondsPerSecond

	"{[1000000 timesRepeat: [33554431  * NanosecondsPerSecond]] durationToRun}
	{[1000000 timesRepeat: [((33554431 bitShift: 9) * 1953125)]] durationToRun}
	{[1000000 timesRepeat: [((33554431 * 1953125) bitShift: 9)]] durationToRun}
	
	
	{33554431  * NanosecondsPerSecond}
	{((33554431 bitShift: 9) * 1953125)}
	{((33554431 * 1953125) bitShift: 9)}"! !

!NanosecondSystemClock methodsFor: 'API-timing' stamp: ''!
ticksNowSinceSystemClockEpoch
	"Answer the number of clock ticks since the Epoch date/time of the platform system clock encapsulated by the receiver (i.e., where clock ticks = 0)) up to the current moment. Do not adjust for timezone offset, just answer the raw value provided by the platform system clock (for many Smalltallk implementations, the platform system clock is a software device provided by the virtual machine, and can be accessed via primtive message send.)"

	"The default implementation uses the network time service as defined by RFC-868, which provides the number of seconds since 1900-01-01T00:00:00 UTC"

	^self subclassResponsibility! !

Object subclass: #TimezoneProcessor
	instanceVariableNames: 'depth defaultZoneName'
	classVariableNames: ''
	poolDictionaries: 'Chronos ChronosConstants Passport'
	category: 'Chronos-Timezones'!

!TimezoneProcessor class methodsFor: 'instance creation' stamp: ''!
new
	^self basicNew initialize! !

!TimezoneProcessor methodsFor: 'initialize-release' stamp: ''!
initialize
	depth := 0! !

!TimezoneProcessor methodsFor: 'API' stamp: ''!
process: aChronosTimezone
	"TimezoneProcessor new process: ChronosTimezone default"

	^(ChronosTimezone referencedBy: aChronosTimezone) processBy: self! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processAlwaysDefaultTZ: timezone
	^self processProxyTimezone: timezone! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processAlwaysSystemTZ: timezone
	^self processProxyTimezone: timezone! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processAnnualDate: annualDate
	"By default, do nothing"! !

!TimezoneProcessor methodsFor: 'processing-AnnuallyRecurringTZPolicyFactories' stamp: ''!
processAnnuallyRecurringTZPolicy: annuallyRecurringTZPolicy
	"By default, do nothing"! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processBasicTimezone: timezone
	^self processUnboundTimezone: timezone! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processBoundTimezone: timezone
	"By default, do nothing"! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processCalendricalAnnualDate: annualDate
	self processAnnualDate: annualDate! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processComputedAnnualDate: annualDate
	self processAnnualDate: annualDate! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processDayOfMonth: annualDate
	self processMonthOfYear: annualDate! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processDayOfYear: annualDate
	self processCalendricalAnnualDate: annualDate! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processGregorianEaster: annualDate
	self processComputedAnnualDate: annualDate! !

!TimezoneProcessor methodsFor: 'processing-AnnuallyRecurringTZPolicyFactories' stamp: ''!
processIntraYearTimeZoneTransition: annuallyRecurringTZPolicy
	^self processAnnuallyRecurringTZPolicy: annuallyRecurringTZPolicy! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processJulianEaster: annualDate
	self processComputedAnnualDate: annualDate! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processMonthOfYear: annualDate
	self processCalendricalAnnualDate: annualDate! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processNominalTime: timezone
	^self processProxyTimezone: timezone! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processNonStandardTime: timezone
	^self processStandardTime: timezone! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processProxyTimezone: timezone
	depth := depth + 1.
	timezone asNonProxy processBy: self.
	depth := depth - 1.! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processStandardTime: timezone
	^self processBasicTimezone: timezone! !

!TimezoneProcessor methodsFor: 'processing-TimeZonePolicyFactories' stamp: ''!
processTimezoneAnnualTransitionPolicyFactory: timeZonePolicy
	depth := depth + 1.
	timeZonePolicy annuallyRecurringTransitionsDo: [:index :each | each processBy: self].
	depth := depth - 1.! !

!TimezoneProcessor methodsFor: 'processing-TimeZonePolicyFactories' stamp: ''!
processTimezonePolicyFactory: timeZonePolicy
	depth := depth + 1.
	timeZonePolicy annualTransitionPoliciesDo: [:index :each | each processBy: self].
	depth := depth - 1.! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processUnboundTimezone: timezone
	defaultZoneName := timezone name! !

!TimezoneProcessor methodsFor: 'processing-AnnuallyRecurringTZPolicyFactories' stamp: ''!
processUntilAnnualDateTimeZoneTransition: annuallyRecurringTZPolicy
	^self processIntraYearTimeZoneTransition: annuallyRecurringTZPolicy! !

!TimezoneProcessor methodsFor: 'processing-AnnuallyRecurringTZPolicyFactories' stamp: ''!
processUntilAnnualDayOfYearTimeZoneTransition: annuallyRecurringTZPolicy
	^self processIntraYearTimeZoneTransition: annuallyRecurringTZPolicy! !

!TimezoneProcessor methodsFor: 'processing-AnnuallyRecurringTZPolicyFactories' stamp: ''!
processUntilEndOfYearTimeZoneTransition: annuallyRecurringTZPolicy
	^self processAnnuallyRecurringTZPolicy: annuallyRecurringTZPolicy! !

!TimezoneProcessor methodsFor: 'processing-Timezones' stamp: ''!
processVariableOffsetTimezone: timezone
	self processUnboundTimezone: timezone.
	depth := depth + 1.
	timezone policy processBy: self.
	depth := depth - 1.! !

!TimezoneProcessor methodsFor: 'processing-AnnualDates' stamp: ''!
processWeekOfMonthDayOfWeek: annualDate
	self processMonthOfYear: annualDate! !
TimeZonePolicyFactory initialize!
ChronosLocale initialize!
ChronosSystemFacade initialize!
TimeOfDay initialize!
Timepoint initialize!
ChronosPrintPolicy initialize!
TimeZoneLocalizationPolicy initialize!
InfiniteDuration initialize!
ChronosTimezone initialize!
MonthlyCalendarSpec initialize!
VariableOffsetTimezone initialize!
AnnuallyRecurringTZPolicyFactory initialize!
Chronos initialize!
ChronosConstants initialize!
SemanticDatePolicy initialize!
AnnualDate initialize!
ComputedAnnualDate initialize!
RegularCalendar initialize!
SolarianCalendar initialize!
HebrewCalendar initialize!
RomanicCalendar initialize!
ImperialJulianCalendar initialize!
CopticCalendar initialize!
EthiopicCalendar initialize!
GregorianCalendar initialize!
BahaiCalendar initialize!
PersianCalendar initialize!
IndianCalendar initialize!
IslamicFatimidCalendar initialize!
ChronosSystemClock initialize!
ChronosEnvironment initialize!
ChronosParser initialize!
JulianCalendar initialize!
